package fr.unedic.cali.asu.caa14.p01;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.asr.liquidation.outilsfonctionnels.AlimenterBaseEchanges;
import fr.unedic.cali.asu.caa14.p01.calcul.dom.DureeIndemnisation;
import fr.unedic.cali.asu.caa14.p01.calcul.dom.FormuleMontantRegimeGeneralASRARE;
import fr.unedic.cali.asu.caa14.p01.liquidation.outilsfonctionnels.AlimenterBaseEchangesAsrAre;
import fr.unedic.cali.asu.caa14.p01.liquidation.outilsfonctionnels.FabriqueObjectifExamen;
import fr.unedic.cali.asu.caa14.p01.liquidation.outilsfonctionnels.RecuperationFormuleMontant;
import fr.unedic.cali.asu.caa14.p01.liquidation.parcours.ParcoursDetecterContributionParticuliere;
import fr.unedic.cali.asu.caa14.p01.liquidation.parcours.ParcoursDeterminationOrdreObjectifs;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.ConstructionPra;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.OutilTraitementReliquat;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ParcoursValiderObjectif;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.CompetenceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.FaitGenerateurSpec;
import fr.unedic.cali.asu.dom.ObjectifExamen;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionCoordinationEuropeenne;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionQuantiteAffiliation;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.Examen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ObjectifExamenSpec;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.ContratTravail;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.dom.DureeIndemnisationAbstraite;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.ObjetAlertesNonBloquantes;
import fr.unedic.cali.dom.affectation.ContexteDemandeSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.dom.echange.Decision;
import fr.unedic.cali.migration.GrapheLiquidationSpec;
import fr.unedic.cali.occasionnel.outilsfonctionnels.CriteresExecutionPopulation;
import fr.unedic.cali.outilsfonctionnels.AppelCalculParLiquidation;
import fr.unedic.cali.parcours.DomLiquidationDemande;
import fr.unedic.cali.parcours.ResultatExecutionCalculSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Parcours;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;
import java.util.List;

public class ProduitDelegue
  extends fr.unedic.cali.asu.cge01.p04.ProduitDelegue
{
  public FormuleMontantSpec getFormuleMontant(String code)
  {
    return RecuperationFormuleMontant.getInstanceFormuleMontant(code);
  }
  
  public DureeIndemnisationAbstraite creerDureeCalcul(AttributionSpec attribution)
  {
    AttributionAssuranceSpec attributionAssurance = (AttributionAssuranceSpec)attribution;
    DureeIndemnisation dureeCalcul = new DureeIndemnisation(attributionAssurance.getDureeTheorique().getValeurEntiere());
    dureeCalcul.setCodeFormuleMontant(FormuleMontantRegimeGeneralASRARE.getCode());
    return dureeCalcul;
  }
  
  private ObjectifExamenSpec recupererObjectifCourantDepuisContexte(Contexte contexte)
  {
    ObjectifExamen objectifCourant = null;
    if ((contexte != null) && (contexte.getDonnees() != null)) {
      objectifCourant = DomLiquidationAssurance.getDemande(contexte).getObjectifCourant();
    }
    return (ObjectifExamenSpec)objectifCourant;
  }
  
  protected Resultat effectuerParcours(Parcours parcours, Contexte contexte)
    throws ApplicativeException
  {
    Resultat resultat = null;
    if (parcours != null) {
      resultat = parcours.effectuerParcours(contexte);
    }
    return resultat;
  }
  
  public void alimenterBaseEchangesProduit(DossierExamenSpec dossierExamen, Decision demandeEchange)
    throws CoucheLogiqueException
  {
    super.alimenterBaseEchangesProduit(dossierExamen, demandeEchange);
    AlimenterBaseEchangesAsrAre.getInstance().alimenterDonneesProduit(dossierExamen, demandeEchange);
    AlimenterBaseEchanges.alimentationSpecifiqueDuree(dossierExamen, demandeEchange);
  }
  
  public GrapheLiquidationSpec creerGraphe(int natureDecision, boolean classement)
  {
    return null;
  }
  
  public boolean estReexecutable(CriteresExecutionPopulation criteres)
  {
    return false;
  }
  
  public ArrayList getParametres()
  {
    return null;
  }
  
  public Resultat constituerNbHeuresTravaillees(Contexte contexte)
    throws ApplicativeException
  {
    return null;
  }
  
  public Object creerObjectifExamen(int sousType, List<ContexteDemandeSpec> contexteDemande)
  {
    return FabriqueObjectifExamen.creerObjectif(sousType, contexteDemande);
  }
  
  public Resultat detecterContributionParticuliere(Contexte contexte)
    throws ApplicativeException
  {
    ParcoursDetecterContributionParticuliere parcours = new ParcoursDetecterContributionParticuliere();
    return parcours.effectuerParcours(contexte);
  }
  
  public void determinerOrdreObjectifs(Contexte contexte)
    throws ApplicativeException
  {
    ParcoursDeterminationOrdreObjectifs parcours = new ParcoursDeterminationOrdreObjectifs();
    parcours.effectuerParcours(contexte);
  }
  
  public Periode determinerPraLaPlusLongue(DemandeSpec demandeCourante, ActiviteSalarie periodeFctCourante)
    throws CoucheLogiqueException
  {
    return ConstructionPra.determinerPraLaPlusLongue(demandeCourante, periodeFctCourante);
  }
  
  public Quantite determinerReliquatHorsMaintien(AttributionSpec attribution, Damj dateCalcul)
    throws ApplicativeException
  {
    ResultatExecutionCalculSpec resultat = AppelCalculParLiquidation.executerCalculDeterminationEtatDroit(attribution, dateCalcul, true, true);
    Quantite reliquatAre;
    Quantite reliquatAre;
    if (resultat.getReliquatDureeIndemnisation() == null) {
      reliquatAre = ((AttributionAssuranceSpec)attribution).getDureeIndemnisationEffective();
    } else {
      reliquatAre = resultat.getReliquatDureeIndemnisation();
    }
    return reliquatAre;
  }
  
  public boolean determinerRepriseInvalide(DemandeSpec demande)
  {
    return true;
  }
  
  public boolean estCompetenceAdministrativeRac(AttributionSpec attribution)
  {
    return ((Attribution)attribution).getCompetence().getCompetenceAdministrative() == 1;
  }
  
  public boolean estEntameDiffereStandard(DemandeSpec demande)
    throws ApplicativeException
  {
    boolean estConsommeDiffere = false;
    DossierExamen dossierExamen = (DossierExamen)((Demande)demande).getDossierExamen();
    if (dossierExamen != null)
    {
      ResultatExecutionCalculSpec resultatCalcul = AppelCalculParLiquidation.executerCalculDeterminationEtatDroit((Attribution)dossierExamen, null, true);
      
      estConsommeDiffere = resultatCalcul.isDiffereEntame();
    }
    return estConsommeDiffere;
  }
  
  public Damj getDateFaitGenerateur(AttributionSpec attribution)
  {
    Attribution attributionAsu = (Attribution)attribution;
    if (attributionAsu.getFaitGenerateur() != null) {
      return attributionAsu.getFaitGenerateur().getDateFaitGenerateur();
    }
    return null;
  }
  
  public Damj getDateObtentionAgePourMaintien(DemandeSpec demande)
  {
    return null;
  }
  
  public Damj getDateObtentionDesTrimestres(DemandeSpec demande)
  {
    return null;
  }
  
  public Damj getDateObtentionIndemnisation(DemandeSpec demande)
    throws ApplicativeException
  {
    return null;
  }
  
  public Damj getDateRuptureContratTravail(AttributionSpec attribution)
  {
    Attribution attributionProduit = (Attribution)attribution;
    Damj dateRuptureContratTravail = null;
    if ((attributionProduit != null) && (attributionProduit.getDossierAffecte() != null))
    {
      FaitGenerateurSpec cdtFaitGenerateur = attributionProduit.getConditionFaitGenerateur();
      if ((cdtFaitGenerateur != null) && (cdtFaitGenerateur.getPeriodeFaitGenerateur() != null))
      {
        ContratTravail contrat = cdtFaitGenerateur.getPeriodeFaitGenerateur().getContrat();
        if (contrat != null) {
          dateRuptureContratTravail = contrat.getDateRuptureContratTravail();
        }
      }
    }
    return dateRuptureContratTravail;
  }
  
  public Quantite getDureeInitiale(AttributionSpec attribution)
  {
    AttributionAssuranceSpec attributionAssurance = (AttributionAssuranceSpec)attribution;
    return attributionAssurance.getDureeInitiale();
  }
  
  public BigDecimal getSJR(AttributionSpec attribution)
  {
    return ((Attribution)attribution).getElementBaseIndemnisation().getSjr().getSalaire();
  }
  
  public void initialiserDossierExamen(DossierAffectationSpec dossierAffecte)
  {
    dossierAffecte.setDossierExamen(new Examen());
  }
  
  public void miseAJourDossierExamen(DossierExamenSpec dossier, AttributionSpec attribution)
  {
    ((DossierExamen)dossier).setAttributionPrecedente((AttributionAssuranceSpec)attribution);
  }
  
  public void sauvegardeElementsJustificatifs(DossierExamenSpec decision)
    throws CoucheLogiqueException
  {}
  
  public Resultat traiterReliquat(ResultatExecutionCalculSpec resultatExecutionCalcul, Damj dateEtude)
    throws ApplicativeException
  {
    return OutilTraitementReliquat.getInstance().traiterReliquat(resultatExecutionCalcul, dateEtude);
  }
  
  public boolean verifierCapasPreliminaires(Contexte contexte)
    throws ApplicativeException
  {
    return true;
  }
  
  public Resultat verifierCondition28JoursSuspension(Contexte contexte)
    throws ApplicativeException
  {
    return new Resultat(0);
  }
  
  public Resultat verifierConditionActivitePourMaintien(Contexte contexte)
    throws ApplicativeException
  {
    return new Resultat(0);
  }
  
  public Resultat verifierConditionAgePourMaintien(Contexte contexte)
    throws ApplicativeException
  {
    return null;
  }
  
  public Resultat verifierConditionAppartenancePourMaintien(Contexte contexte)
    throws ApplicativeException
  {
    return null;
  }
  
  public Resultat verifierConditionBeneficeAutreProduit(Contexte contexte)
    throws ApplicativeException
  {
    return new Resultat(0);
  }
  
  public Resultat verifierConditionCSRAccordCP(Contexte contexte)
    throws ApplicativeException
  {
    return new Resultat(0);
  }
  
  public Resultat verifierConditionCSRDateAttributionPendantSuspension(Contexte contexte)
    throws ApplicativeException
  {
    return new Resultat(0);
  }
  
  public Resultat verifierConditionChomageInvolontaire(Contexte contexte)
    throws ApplicativeException
  {
    return new Resultat(0);
  }
  
  public Resultat verifierConditionChomageTotal(Contexte contexte)
    throws ApplicativeException
  {
    return new Resultat(0);
  }
  
  public Resultat verifierConditionDecisionCPPourMaintien(Contexte contexte)
    throws ApplicativeException
  {
    return new Resultat(0);
  }
  
  public Resultat verifierConditionDureeIndemnisationPourMaintien(Contexte contexte)
    throws ApplicativeException
  {
    return new Resultat(0);
  }
  
  public Resultat verifierConditionNombreTrimestresPourMaintien(Contexte contexte)
    throws ApplicativeException
  {
    return null;
  }
  
  public Resultat verifierConditionQuantiteAffiliation(Contexte contexte)
    throws ApplicativeException
  {
    Resultat result = super.verifierConditionQuantiteAffiliation(contexte);
    
    DemandeSpec demandeEnCours = ((DomLiquidationDemande)contexte.getDonnees()).getDemandeSpec();
    if (((Demande)demandeEnCours).getContexteAffiliationValide() != null) {
      result.setEtat(0);
    }
    return result;
  }
  
  public void verifierValiditeObjectif(Contexte contexte)
    throws ApplicativeException
  {
    ParcoursValiderObjectif parcours = new ParcoursValiderObjectif();
    parcours.effectuerParcours(contexte);
  }
  
  public Resultat constituerDateLimiteIndemnisation(Contexte contexte)
    throws ApplicativeException
  {
    ObjectifExamenSpec objectifCourant = recupererObjectifCourantDepuisContexte(contexte);
    Parcours parcours = objectifCourant.creerParcoursDateLimiteIndemnisation();
    return effectuerParcours(parcours, contexte);
  }
  
  public Resultat verifierConditionAnciennete(Contexte contexte)
    throws ApplicativeException
  {
    return new Resultat(0);
  }
  
  public void verifierPropositionAttribution(DemandeSpec demande)
    throws CoucheLogiqueException
  {
    DossierExamen dossierExamen = (DossierExamen)demande.getDossierAffectation().getDossierExamen();
    ReglementApplicableSpec reglementApplicable = dossierExamen.getReglementApplicable();
    if (reglementApplicable != null) {
      if (reglementApplicable.getReglement().estNomReglementIdentique("A9B"))
      {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ALERTE_A11MB18");
      }
      else if (reglementApplicable.getReglement().estNomReglementIdentique("A9A"))
      {
        Collection listePeriodes = new ArrayList();
        
        ObjetAlertesNonBloquantes objetAlerteNonBloquante = new ObjetAlertesNonBloquantes(Damj.NUIT_DES_TEMPS, Damj.FIN_DES_TEMPS, 999);
        
        listePeriodes.add(objetAlerteNonBloquante);
        demande.getAlertesNonBloquantes().put("A11MNB12", listePeriodes);
      }
    }
    if (dossierExamen.getConstitutionQuantiteAffiliation() != null)
    {
      Periode periodePra = dossierExamen.getConstitutionQuantiteAffiliation().getPeriodePRA();
      if (periodePra != null) {
        OutilGestionCoordinationEuropeenne.getInstance().controlerCoordinationEuropeenneATord((Demande)demande, periodePra);
      }
    }
  }
}

/* Location:
 * Qualified Name:     ProduitDelegue
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */