package fr.unedic.cali.asu.caa14.p01.calcul.outilsfonctionnels;

import fr.unedic.cali.asu.caa14.p01.calcul.outilsfonctionnels.fabriques.FabriqueStrategieActiviteReduitePansConservee;
import fr.unedic.cali.asu.caa14.p01.calcul.outilsfonctionnels.strategies.StrategieActiviteReduitePansConserveeSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.calcul.dom.ConstituantsCalculActiviteReduiteSpec;
import fr.unedic.cali.calcul.dom.SyntheseARsurUT;
import fr.unedic.cali.calcul.dom.UniteTraitement;
import fr.unedic.cali.calcul.dom.periode.DsmTravail;
import fr.unedic.cali.calcul.dom.periode.PansSpec;
import fr.unedic.cali.calcul.dom.periode.PeriodePrime;
import fr.unedic.cali.calcul.dom.periode.PeriodeTravailJustifiee;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeCalcul;
import fr.unedic.cali.calcul.outilsfonctionnels.DeterminationActiviteConserveeReprise;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ResultatActiviteReduite;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodePANSConservee;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.SalaireJournalierSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;

public class TraitementActiviteReduite
  extends fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.TraitementActiviteReduite
{
  public static void traitementPeriodesDecalantes(AttributionSpec p_attribution, ChronologiePeriodes p_periodesDecalantes, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, UniteTraitement p_ut)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesDecalantesDeclarees = new ChronologiePeriodes();
    ChronologiePeriodes periodesDecalantesJustifiees = new ChronologiePeriodes();
    ChronologiePeriodes periodeNonDeclareeSanction = null;
    ObjetChronoPeriodeCalcul periodeTravailCalcul = null;
    
    boolean traitementActiviteReduite = preTraitementPeriodesDecalantes(p_attribution, p_periodesDecalantes, p_constituantsCalculActiviteReduite, p_ut, periodesDecalantesDeclarees, periodesDecalantesJustifiees, periodeNonDeclareeSanction, periodeTravailCalcul);
    if (traitementActiviteReduite)
    {
      if (periodesDecalantesJustifiees.getTaille() != 0)
      {
        ResultatActiviteReduite resultatActiviteReduite = appelleActiviteReduite(p_attribution, periodesDecalantesJustifiees, p_constituantsCalculActiviteReduite, p_ut, false);
        
        postTraitementPeriodesDecalantes(p_ut, resultatActiviteReduite, p_attribution);
      }
      if (periodesDecalantesDeclarees.getTaille() != 0)
      {
        ResultatActiviteReduite resultatActiviteReduite = appelleActiviteReduite(p_attribution, periodesDecalantesDeclarees, p_constituantsCalculActiviteReduite, p_ut, false);
        
        postTraitementPeriodesDecalantes(p_ut, resultatActiviteReduite, p_attribution);
        
        appliquerRegleSurUTPP(p_ut);
      }
    }
  }
  
  public static void traitementPeriodesGelantes(AttributionSpec p_attribution, ChronologiePeriodes p_periodesGelantes, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, UniteTraitement p_ut)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesGelantesDeclareees = new ChronologiePeriodes();
    ChronologiePeriodes periodesGelantesJustifiees = new ChronologiePeriodes();
    
    boolean traitementActiviteReduite = preTraitementPeriodesGelantes(p_attribution, p_ut, p_periodesGelantes, periodesGelantesDeclareees, periodesGelantesJustifiees);
    if (traitementActiviteReduite)
    {
      if (periodesGelantesJustifiees.getTaille() != 0)
      {
        ResultatActiviteReduite resultatActiviteReduite = appelleActiviteReduite(p_attribution, periodesGelantesJustifiees, p_constituantsCalculActiviteReduite, p_ut, false);
        
        postTraitementPeriodesGelantes(p_ut, resultatActiviteReduite);
      }
      if (periodesGelantesDeclareees.getTaille() != 0)
      {
        ResultatActiviteReduite resultatActiviteReduite = appelleActiviteReduite(p_attribution, periodesGelantesDeclareees, p_constituantsCalculActiviteReduite, p_ut, false);
        
        postTraitementPeriodesGelantes(p_ut, resultatActiviteReduite);
      }
    }
  }
  
  protected static boolean preTraitementPeriodesDecalantes(AttributionSpec p_attribution, ChronologiePeriodes p_periodesDecalantes, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, UniteTraitement p_ut, ChronologiePeriodes p_periodesDecalantesDeclareees, ChronologiePeriodes p_periodesDecalantesJustifiees, ChronologiePeriodes p_periodeNonDeclareeSanction, ObjetChronoPeriodeCalcul p_periodeTravailCalcul)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesDecalantesJustifiees = new ChronologiePeriodes();
    boolean traitementActiviteReduite = false;
    
    Chronologie chronoPeriodesConserveesLiq = ((Attribution)p_attribution).getListeActiviteConservee();
    
    p_periodesDecalantes.iterer();
    while (p_periodesDecalantes.encoreSuivant())
    {
      p_periodeTravailCalcul = (ObjetChronoPeriodeCalcul)p_periodesDecalantes.elementSuivant();
      if (((p_periodeTravailCalcul instanceof PeriodeTravailJustifiee)) || ((p_periodeTravailCalcul instanceof PeriodePrime)))
      {
        boolean periodeAIgnorer = DeterminationActiviteConserveeReprise.determinerTypeActivite(chronoPeriodesConserveesLiq, p_ut, p_periodeTravailCalcul, p_attribution);
        if (!periodeAIgnorer) {
          periodesDecalantesJustifiees.ajouter(p_periodeTravailCalcul);
        }
      }
    }
    boolean presencePansConservee = !periodesDecalantesJustifiees.copier(new FiltrePeriodePANSConservee()).estVide();
    switch (p_ut.getStatut())
    {
    case -1: 
    case 1: 
    case 2: 
    case 5: 
    case 7: 
      throw new CoucheLogiqueException("HG_PR_CALI_L_ACTIVITE_REDUITE_STATUT_UT_INATTENDU", "Erreur sur le statut de l'Unité de Traitement lors du traitement de l'activité réduite.", null);
    case 3: 
      if (periodesDecalantesJustifiees.getTaille() != 0)
      {
        p_periodesDecalantesJustifiees.ajouter(periodesDecalantesJustifiees);
        traitementActiviteReduite = true;
      }
      break;
    case 4: 
      BigDecimal gains = new BigDecimal("0");
      BigDecimal heures = new BigDecimal("0");
      BigDecimal totalNbJourTravail = new BigDecimal("0");
      p_periodesDecalantes.iterer();
      while (p_periodesDecalantes.encoreSuivant())
      {
        p_periodeTravailCalcul = (ObjetChronoPeriodeCalcul)p_periodesDecalantes.elementSuivant();
        if ((p_periodeTravailCalcul instanceof DsmTravail))
        {
          if (((DsmTravail)p_periodeTravailCalcul).getGain() != null) {
            gains = gains.add(((DsmTravail)p_periodeTravailCalcul).getGain());
          }
          if (((DsmTravail)p_periodeTravailCalcul).getNombreHeures() != null) {
            heures = heures.add(((DsmTravail)p_periodeTravailCalcul).getNombreHeures());
          }
          totalNbJourTravail = totalNbJourTravail.add(new BigDecimal(p_periodeTravailCalcul.getDuree()));
        }
      }
      SyntheseARsurUT syntheseARsurUT = p_ut.getSyntheseARsurUT();
      syntheseARsurUT.setTotalGainUtilisePourDecalage(new QuantiteEuro(gains));
      syntheseARsurUT.setTotalHeureUtilisePourDecalage(new QuantiteEuro(heures));
      syntheseARsurUT.setCumulJourDeTravailAR(new Quantite(totalNbJourTravail, p_ut.getUniteParDefautQuantites()));
      break;
    case 6: 
      break;
    case 0: 
    default: 
      throw new CoucheLogiqueException("HG_PR_CALI_L_ACTIVITE_REDUITE_STATUT_UT_INATTENDU", "Erreur sur le statut de l'Unité de Traitement lors du traitement de l'activité réduite.", null);
    }
    if (!((Attribution)p_attribution).getNomReglementApplicable().equalsIgnoreCase("A4"))
    {
      BigDecimal sjr = p_constituantsCalculActiviteReduite.getSjrProduit().getSalaire();
      BigDecimal sjc = p_constituantsCalculActiviteReduite.getSjcProduit().getSalaire();
      boolean apprenti = ((Attribution)p_attribution).isTopContratsRemuneresBaseSmic();
      if ((chronoPeriodesConserveesLiq != null) && (!chronoPeriodesConserveesLiq.estVide()))
      {
        BigDecimal cumulGainPansConservee = new BigDecimal("0");
        boolean estAMettreAJour = false;
        
        periodesDecalantesJustifiees.iterer();
        while (periodesDecalantesJustifiees.encoreSuivant())
        {
          ObjetChronoPeriodeCalcul periodeDecalanteCalcul = (ObjetChronoPeriodeCalcul)periodesDecalantesJustifiees.elementSuivant();
          if (((periodeDecalanteCalcul instanceof PansSpec)) && 
            (((PansSpec)periodeDecalanteCalcul).getTypeActivite() == 1)) {
            cumulGainPansConservee = cumulGainPansConservee.add(((PansSpec)periodeDecalanteCalcul).getGain());
          }
        }
        CritereStrategie critere = new CritereStrategie();
        critere.setDatePivot(p_ut.getDateDebut());
        FabriqueStrategieActiviteReduitePansConservee fabrique = new FabriqueStrategieActiviteReduitePansConservee();
        StrategieActiviteReduitePansConserveeSpec strategie = (StrategieActiviteReduitePansConserveeSpec)fabrique.getStrategie(critere);
        
        BigDecimal gainPansConserveeALaLiquidation = strategie.getGainPansConserveeALaLiquidation(p_attribution);
        
        BigDecimal gainPansConserveeAPrendreenComptePourNeutralisation = gainPansConserveeALaLiquidation;
        if (gainPansConserveeAPrendreenComptePourNeutralisation.compareTo(new BigDecimal(0)) == 0) {
          gainPansConserveeAPrendreenComptePourNeutralisation = cumulGainPansConservee;
        }
        chronoPeriodesConserveesLiq.iterer();
        while ((chronoPeriodesConserveesLiq.encoreSuivant()) && (!estAMettreAJour))
        {
          TravailSpec periodeConserveeLiq = (TravailSpec)chronoPeriodesConserveesLiq.elementSuivant();
          if ((((Attribution)p_attribution).getTermePrcActiviteConservee() != null) && (periodeConserveeLiq.getDateDebut().estAvant(((Attribution)p_attribution).getTermePrcActiviteConservee()))) {
            estAMettreAJour = true;
          }
        }
        if (estAMettreAJour) {
          p_ut.getSyntheseARsurUT().setSeuilRemunerationARAvecActConservee(new Quantite(ActiviteReduite.calculerSeuilMensuel(p_ut.getDateDebut(), sjr, sjc, apprenti, true, gainPansConserveeAPrendreenComptePourNeutralisation, presencePansConservee), p_ut.getUniteParDefautQuantites()));
        }
      }
      else
      {
        p_ut.getSyntheseARsurUT().setSeuilRemunerationAR(new Quantite(ActiviteReduite.calculerSeuilMensuel(p_ut.getDateDebut(), sjr, sjc, apprenti, false, new BigDecimal(0), presencePansConservee), p_ut.getUniteParDefautQuantites()));
      }
    }
    return traitementActiviteReduite;
  }
  
  protected static boolean preTraitementPeriodesGelantes(AttributionSpec p_attribution, UniteTraitement p_ut, ChronologiePeriodes p_periodesGelantes, ChronologiePeriodes p_periodesGelantesDeclareees, ChronologiePeriodes p_periodesGelantesJustifiees)
    throws CoucheLogiqueException
  {
    boolean traitementActiviteReduite = false;
    switch (p_ut.getStatut())
    {
    case -1: 
    case 1: 
    case 2: 
    case 5: 
    case 7: 
      throw new CoucheLogiqueException("HG_PR_CALI_L_ACTIVITE_REDUITE_STATUT_UT_INATTENDU", "Erreur sur le statut de l'Unité de Traitement lors du traitement de l'activité réduite.", null);
    case 3: 
      p_periodesGelantes.iterer();
      while (p_periodesGelantes.encoreSuivant())
      {
        ObjetChronoPeriodeCalcul periodeTravailCalcul = (ObjetChronoPeriodeCalcul)p_periodesGelantes.elementSuivant();
        if (((periodeTravailCalcul instanceof PeriodeTravailJustifiee)) || ((periodeTravailCalcul instanceof PeriodePrime)))
        {
          Chronologie chronoPeriodesConserveesLiq = ((Attribution)p_attribution).getListeActiviteConservee();
          
          boolean periodeAIgnorer = DeterminationActiviteConserveeReprise.determinerTypeActivite(chronoPeriodesConserveesLiq, p_ut, periodeTravailCalcul, p_attribution);
          if (!periodeAIgnorer) {
            p_periodesGelantesJustifiees.ajouter(periodeTravailCalcul);
          }
        }
      }
      if (p_periodesGelantesJustifiees.getTaille() != 0) {
        traitementActiviteReduite = true;
      }
      break;
    case 4: 
      p_ut.setNeutralisee(true);
      p_ut.setTypeNeutralisation(4);
      break;
    case 6: 
      p_ut.setNeutralisee(true);
      p_ut.setTypeNeutralisation(8);
      break;
    case 0: 
    default: 
      throw new CoucheLogiqueException("HG_PR_CALI_L_ACTIVITE_REDUITE_STATUT_UT_INATTENDU", "Erreur sur le statut de l'Unité de Traitement lors du traitement de l'activité réduite.", null);
    }
    return traitementActiviteReduite;
  }
}

/* Location:
 * Qualified Name:     TraitementActiviteReduite
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */