package fr.unedic.cali.asu.calcul.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.calcul.dom.pc.EtatAuDjiGammePC;
import fr.unedic.cali.calcul.dom.EtatAuDji;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;

public abstract class EtatAuDjiGammeGen
  extends EtatAuDji
  implements DomGenSpec
{
  private Quantite m_reliquatDureeIndemnisation = null;
  private Quantite m_reliquatDureeIndemnisationAvecMaintien = null;
  private Quantite m_reliquatDureeProlongation = null;
  private Quantite m_reliquatDureeFinancement;
  
  public EtatAuDjiGammeGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public EtatAuDjiGammeGen() {}
  
  protected DomPCSpec createPC()
  {
    return new EtatAuDjiGammePC();
  }
  
  protected Quantite rawGetReliquatDureeIndemnisation()
  {
    return ((EtatAuDjiGammePC)getPC()).getReliquatDureeIndemnisation();
  }
  
  public Quantite getReliquatDureeIndemnisation()
  {
    return ((EtatAuDjiGammePC)getPC()).getReliquatDureeIndemnisation();
  }
  
  public void setReliquatDureeIndemnisation(Quantite p_reliquatDureeIndemnisation)
  {
    if ((m_reliquatDureeIndemnisation == null) || (p_reliquatDureeIndemnisation == null))
    {
      m_reliquatDureeIndemnisation = p_reliquatDureeIndemnisation;
      ((EtatAuDjiGammePC)getPC()).setReliquatDureeIndemnisation(p_reliquatDureeIndemnisation);
    }
    else if ((m_reliquatDureeIndemnisation != null) && (p_reliquatDureeIndemnisation != null) && (!p_reliquatDureeIndemnisation.equals(m_reliquatDureeIndemnisation)))
    {
      m_reliquatDureeIndemnisation = p_reliquatDureeIndemnisation;
      ((EtatAuDjiGammePC)getPC()).setReliquatDureeIndemnisation(p_reliquatDureeIndemnisation);
    }
  }
  
  protected int rawGetCumulMoisActiviteReduite()
  {
    return ((EtatAuDjiGammePC)getPC()).getCumulMoisActiviteReduite();
  }
  
  public int getCumulMoisActiviteReduite()
  {
    return ((EtatAuDjiGammePC)getPC()).getCumulMoisActiviteReduite();
  }
  
  public void setCumulMoisActiviteReduite(int p_cumulMoisActiviteReduite)
  {
    ((EtatAuDjiGammePC)getPC()).setCumulMoisActiviteReduite(p_cumulMoisActiviteReduite);
  }
  
  protected int rawGetNbJourAREF()
  {
    return ((EtatAuDjiGammePC)getPC()).getNbJourAREF();
  }
  
  public int getNbJourAREF()
  {
    return ((EtatAuDjiGammePC)getPC()).getNbJourAREF();
  }
  
  public void setNbJourAREF(int p_nbJourAREF)
  {
    ((EtatAuDjiGammePC)getPC()).setNbJourAREF(p_nbJourAREF);
  }
  
  protected Quantite rawGetReliquatDureeIndemnisationAvecMaintien()
  {
    return ((EtatAuDjiGammePC)getPC()).getReliquatDureeIndemnisationAvecMaintien();
  }
  
  public Quantite getReliquatDureeIndemnisationAvecMaintien()
  {
    return ((EtatAuDjiGammePC)getPC()).getReliquatDureeIndemnisationAvecMaintien();
  }
  
  public void setReliquatDureeIndemnisationAvecMaintien(Quantite p_reliquatDureeIndemnisationAvecMaintien)
  {
    if ((m_reliquatDureeIndemnisationAvecMaintien == null) || (p_reliquatDureeIndemnisationAvecMaintien == null))
    {
      m_reliquatDureeIndemnisationAvecMaintien = p_reliquatDureeIndemnisationAvecMaintien;
      ((EtatAuDjiGammePC)getPC()).setReliquatDureeIndemnisationAvecMaintien(p_reliquatDureeIndemnisationAvecMaintien);
    }
    else if ((m_reliquatDureeIndemnisationAvecMaintien != null) && (p_reliquatDureeIndemnisationAvecMaintien != null) && (!p_reliquatDureeIndemnisationAvecMaintien.equals(m_reliquatDureeIndemnisationAvecMaintien)))
    {
      m_reliquatDureeIndemnisationAvecMaintien = p_reliquatDureeIndemnisationAvecMaintien;
      ((EtatAuDjiGammePC)getPC()).setReliquatDureeIndemnisationAvecMaintien(p_reliquatDureeIndemnisationAvecMaintien);
    }
  }
  
  protected Quantite rawGetReliquatDureeProlongation()
  {
    return ((EtatAuDjiGammePC)getPC()).getReliquatDureeProlongation();
  }
  
  public Quantite getReliquatDureeProlongation()
  {
    return ((EtatAuDjiGammePC)getPC()).getReliquatDureeProlongation();
  }
  
  public void setReliquatDureeProlongation(Quantite p_reliquatDureeProlongation)
  {
    if ((m_reliquatDureeProlongation == null) || (p_reliquatDureeProlongation == null))
    {
      m_reliquatDureeProlongation = p_reliquatDureeProlongation;
      ((EtatAuDjiGammePC)getPC()).setReliquatDureeProlongation(p_reliquatDureeProlongation);
    }
    else if ((m_reliquatDureeProlongation != null) && (p_reliquatDureeProlongation != null) && (!p_reliquatDureeProlongation.equals(m_reliquatDureeProlongation)))
    {
      m_reliquatDureeProlongation = p_reliquatDureeProlongation;
      ((EtatAuDjiGammePC)getPC()).setReliquatDureeProlongation(p_reliquatDureeProlongation);
    }
  }
  
  protected int rawGetNbMoisIndemniseAsu()
  {
    return ((EtatAuDjiGammePC)getPC()).getNbMoisIndemniseAsu();
  }
  
  public int getNbMoisIndemniseAsu()
  {
    return ((EtatAuDjiGammePC)getPC()).getNbMoisIndemniseAsu();
  }
  
  public void setNbMoisIndemniseAsu(int p_nbMoisIndemniseAsu)
  {
    ((EtatAuDjiGammePC)getPC()).setNbMoisIndemniseAsu(p_nbMoisIndemniseAsu);
  }
  
  protected boolean rawIsEstNbMoisIndemniseAsu()
  {
    return ((EtatAuDjiGammePC)getPC()).isEstNbMoisIndemniseAsu();
  }
  
  public boolean isEstNbMoisIndemniseAsu()
  {
    return ((EtatAuDjiGammePC)getPC()).isEstNbMoisIndemniseAsu();
  }
  
  public void setEstNbMoisIndemniseAsu(boolean p_estNbMoisIndemniseAsu)
  {
    ((EtatAuDjiGammePC)getPC()).setEstNbMoisIndemniseAsu(p_estNbMoisIndemniseAsu);
  }
  
  protected Quantite rawGetReliquatDureeFinancement()
  {
    return ((EtatAuDjiGammePC)getPC()).getReliquatDureeFinancement();
  }
  
  public Quantite getReliquatDureeFinancement()
  {
    return ((EtatAuDjiGammePC)getPC()).getReliquatDureeFinancement();
  }
  
  public void setReliquatDureeFinancement(Quantite p_reliquatDureeFinancement)
  {
    if ((m_reliquatDureeFinancement == null) || (p_reliquatDureeFinancement == null))
    {
      m_reliquatDureeFinancement = p_reliquatDureeFinancement;
      ((EtatAuDjiGammePC)getPC()).setReliquatDureeFinancement(p_reliquatDureeFinancement);
    }
    else if ((m_reliquatDureeFinancement != null) && (p_reliquatDureeFinancement != null) && (!p_reliquatDureeFinancement.equals(m_reliquatDureeFinancement)))
    {
      m_reliquatDureeFinancement = p_reliquatDureeFinancement;
      ((EtatAuDjiGammePC)getPC()).setReliquatDureeFinancement(p_reliquatDureeFinancement);
    }
  }
  
  protected int rawGetCumulJoursAR()
  {
    return ((EtatAuDjiGammePC)getPC()).getCumulJoursAR();
  }
  
  public int getCumulJoursAR()
  {
    return ((EtatAuDjiGammePC)getPC()).getCumulJoursAR();
  }
  
  public void setCumulJoursAR(int p_cumulJoursAR)
  {
    ((EtatAuDjiGammePC)getPC()).setCumulJoursAR(p_cumulJoursAR);
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     EtatAuDjiGammeGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */