package fr.unedic.cali.asu.calcul.outilsfonctionnels;

import fr.unedic.cali.asu.calcul.FacadeCalculGammeImpl;
import fr.unedic.cali.calcul.FacadeCalculProduitSpec;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.UniteTraitement;
import fr.unedic.cali.calcul.dom.periode.DsmTravail;
import fr.unedic.cali.calcul.dom.periode.Pans;
import fr.unedic.cali.calcul.dom.periode.PansNonInstallee;
import fr.unedic.cali.calcul.dom.periode.PeriodeAbsenceActualisationMaintienEuropeen;
import fr.unedic.cali.calcul.dom.periode.PeriodeTravail;
import fr.unedic.cali.calcul.outilsfonctionnels.DefinitionStatutUtTraitementActiviteReduiteAbstraite;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodeTravailCalculCES;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodeTravailCalculDeclaree;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodeTravailCalculHorsCES;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodeTravailCalculHorsETTSeul;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodeTravailCalculHorsPANS;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodeTravailCalculHorsPANSNonInstallee;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodeTravailCalculJustifiee;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodeTravailCalculPANS;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodeTravailCalculPANSNonInstallee;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.fabriques.FabriqueStrategieDeterminationPriseEnCompteGainsSurPANS;
import fr.unedic.cali.fabriques.FabriqueStrategieDeterminationStatutUTConversionHeure;
import fr.unedic.cali.fabriques.FabriqueStrategieDeterminationStatutUTGainHeureRenseigne;
import fr.unedic.cali.outilsfonctionnels.OutillagePEC;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieDeterminationPriseEnCompteGainSurPansSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieDeterminationStatutUTConversionHeureSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieDeterminationStatutUTGainHeureRenseigneSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.fabriques.FabriqueStrategieA8A10ConfrontationGainHeure;
import fr.unedic.cali.outilsfonctionnels.strategies.spec.StrategieA8A10ConfrontationGainHeureSpec;
import fr.unedic.cali.parametres.GestionnaireDateApplication;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;

public class DefinitionStatutUtTraitementActiviteReduite
  extends DefinitionStatutUtTraitementActiviteReduiteAbstraite
{
  public static int definirStatutUt(AttributionSpec attribution, ChronologiePeriodes periodesDecalantes, int nbPPA, boolean contientFormation, UniteTraitement ut, ArretProduitAvecRaison arretProduitAvecRaison, FacadeCalculProduitSpec facadeCalculProduit)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesDecalantesHorsETT = null;
    
    periodesDecalantesHorsETT = (ChronologiePeriodes)periodesDecalantes.copier(new FiltrePeriodeTravailCalculHorsETTSeul());
    int population;
    int population;
    if (ut.getPeriode().getDebut().estApresOuCoincideAvec(GestionnaireDateApplication.getInstance().recupererDateApplication("Determination de la population par le produit indemnise"))) {
      population = ((FacadeCalculGammeImpl)facadeCalculProduit).recupererPopulation();
    } else {
      population = attribution.getDemandeur().determinerPopulationIndividu(ut.getPeriode().getDebut());
    }
    int statutUt;
    switch (population)
    {
    case 0: 
      statutUt = definirStatutUtPourCasGeneral(periodesDecalantesHorsETT, ut.getPeriode(), attribution);
      break;
    case 1: 
      statutUt = definirStatutUtPourA8A10(periodesDecalantesHorsETT, ut.getPeriode(), attribution);
      break;
    default: 
      throw new CoucheLogiqueException("HG_PR_CALI_L_STATUT_UT_POPULATION_INATTENDUE", "Population de l'individu inattendue pour la définition du statut de l'UT", null);
    }
    if ((statutUt == 3) && (contientFormation) && (ut.isAbsenceRetourUL961()) && (facadeCalculProduit.neutralisationApplicableRetourUL961())) {
      if (VerificationEligibilitePaiementParAvance.verifierEligibilitePaiementParAvance(attribution, periodesDecalantesHorsETT, nbPPA, ut, arretProduitAvecRaison, facadeCalculProduit))
      {
        statutUt = 7;
      }
      else
      {
        statutUt = 4;
        ut.setEstAttenteJustifFormation(true);
      }
    }
    if (statutUt == 2)
    {
      if (VerificationEligibilitePaiementParAvance.verifierEligibilitePaiementParAvance(attribution, periodesDecalantesHorsETT, nbPPA, ut, arretProduitAvecRaison, facadeCalculProduit)) {
        statutUt = 5;
      } else {
        statutUt = 4;
      }
    }
    else if (statutUt == 10) {
      if (VerificationEligibilitePaiementParAvance.verifierEligibilitePaiementParAvance(attribution, periodesDecalantesHorsETT, nbPPA, ut, arretProduitAvecRaison, facadeCalculProduit)) {
        statutUt = 9;
      } else {
        statutUt = 4;
      }
    }
    return statutUt;
  }
  
  public static boolean contientDSMEnPresencePansSupraMensuel(ChronologiePeriodes periodesDecalantesHorsETT)
  {
    ChronologiePeriodes periodesDeclarees = (ChronologiePeriodes)periodesDecalantesHorsETT.copier(new FiltrePeriodeTravailCalculDeclaree());
    return !periodesDeclarees.estVide();
  }
  
  public static int definirStatutUtPourCasGeneral(ChronologiePeriodes periodesDecalantes, Periode periodeUt, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    if (periodeUt.getDebut().estApresOuCoincideAvec(GestionnaireDateApplication.getInstance().recupererDateApplication("Prise en compte des ANS mensuel et supra M"))) {
      return DeterminerStatutCasGeneral.definirStatutUtPourCasGeneralApresGestionPansMensuelEtSupra(periodesDecalantes, periodeUt, attribution);
    }
    return DeterminerStatutCasGeneral.definirStatutUtPourCasGeneralAvantGestionPansMensuelEtSupra(periodesDecalantes, periodeUt, attribution);
  }
  
  private static int definirStatutUtPourA8A10(ChronologiePeriodes periodesDecalantes, Periode periodeUt, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    int statut = 2;
    if (periodesDecalantes.estVide())
    {
      statut = 3;
    }
    else if (estActualiseMaintienEuropeen(periodesDecalantes, periodeUt, attribution))
    {
      BigDecimal totalGainsJustifiees = BigDecimal.ZERO;
      BigDecimal totalGainsDeclares = BigDecimal.ZERO;
      BigDecimal totalHeuresJustifiees = BigDecimal.ZERO;
      BigDecimal totalHeuresDeclarees = BigDecimal.ZERO;
      BigDecimal totalGainsDeclaresCES = BigDecimal.ZERO;
      BigDecimal totalHeuresDeclareesCES = BigDecimal.ZERO;
      boolean estDNJ = false;
      boolean unHorsCESOuDSMTravail = true;
      boolean unCESavecDSMTravail = false;
      boolean existePans = false;
      
      ChronologiePeriodes periodesDeclarees = null;
      ChronologiePeriodes periodesJustifiees = null;
      ChronologiePeriodes periodesCES = null;
      ChronologiePeriodes periodesPANS = null;
      ChronologiePeriodes periodesPANSNonInstallees = null;
      
      periodesDeclarees = (ChronologiePeriodes)periodesDecalantes.copier(new FiltrePeriodeTravailCalculDeclaree());
      
      periodesJustifiees = (ChronologiePeriodes)periodesDecalantes.copier(new FiltrePeriodeTravailCalculJustifiee()).copier(new FiltrePeriodeTravailCalculHorsCES());
      
      unHorsCESOuDSMTravail = (!periodesJustifiees.estVide()) || (!periodesDeclarees.estVide());
      
      periodesJustifiees = (ChronologiePeriodes)periodesJustifiees.copier(new FiltrePeriodeTravailCalculHorsPANS()).copier(new FiltrePeriodeTravailCalculHorsPANSNonInstallee());
      
      periodesCES = (ChronologiePeriodes)periodesDecalantes.copier(new FiltrePeriodeTravailCalculCES());
      
      periodesPANS = (ChronologiePeriodes)periodesDecalantes.copier(new FiltrePeriodeTravailCalculPANS());
      
      periodesPANSNonInstallees = (ChronologiePeriodes)periodesDecalantes.copier(new FiltrePeriodeTravailCalculPANSNonInstallee());
      
      unCESavecDSMTravail = (!periodesCES.estVide()) && (!periodesDeclarees.estVide());
      
      periodesCES.iterer();
      while (periodesCES.encoreSuivant())
      {
        PeriodeTravail periodeCES = (PeriodeTravail)periodesCES.elementSuivant();
        totalGainsDeclaresCES = totalGainsDeclaresCES.add(periodeCES.getGain());
        totalHeuresDeclareesCES = totalHeuresDeclareesCES.add(periodeCES.getNombreHeures());
      }
      periodesDeclarees.iterer();
      while (periodesDeclarees.encoreSuivant())
      {
        PeriodeTravail periodeDeclaree = (PeriodeTravail)periodesDeclarees.elementSuivant();
        totalGainsDeclares = totalGainsDeclares.add(periodeDeclaree.getGain());
        totalHeuresDeclarees = totalHeuresDeclarees.add(periodeDeclaree.getNombreHeures());
      }
      if ((unCESavecDSMTravail) && (totalGainsDeclares.compareTo(totalGainsDeclaresCES) < 0))
      {
        totalGainsDeclares = totalGainsDeclaresCES;
        totalHeuresDeclarees = totalHeuresDeclareesCES;
      }
      effectuerConversionHeureNonRenseigne(periodesJustifiees, periodeUt.getDebut(), attribution);
      
      periodesJustifiees.iterer();
      while (periodesJustifiees.encoreSuivant())
      {
        PeriodeTravail paec = (PeriodeTravail)periodesJustifiees.elementSuivant();
        totalGainsJustifiees = totalGainsJustifiees.add(paec.getGain());
        totalHeuresJustifiees = totalHeuresJustifiees.add(paec.getNombreHeures());
      }
      periodesPANS.iterer();
      while (periodesPANS.encoreSuivant())
      {
        Pans pansCalcul = (Pans)periodesPANS.elementSuivant();
        totalGainsJustifiees = totalGainsJustifiees.add(pansCalcul.getGain());
        if (pansCalcul.getNombreHeures() != null) {
          totalHeuresJustifiees = totalHeuresJustifiees.add(pansCalcul.getNombreHeures());
        }
        existePans = true;
      }
      periodesPANSNonInstallees.iterer();
      while (periodesPANSNonInstallees.encoreSuivant())
      {
        PansNonInstallee pans = (PansNonInstallee)periodesPANSNonInstallees.elementSuivant();
        totalGainsJustifiees = totalGainsJustifiees.add(pans.getGain());
        if (pans.getNombreHeures() != null) {
          totalHeuresJustifiees = totalHeuresJustifiees.add(pans.getNombreHeures());
        }
        existePans = true;
      }
      totalGainsJustifiees = totalGainsJustifiees.add(totalGainsDeclaresCES);
      totalHeuresJustifiees = totalHeuresJustifiees.add(totalHeuresDeclareesCES);
      
      periodesDeclarees.iterer();
      while (periodesDeclarees.encoreSuivant())
      {
        DsmTravail periodeDeclaree = (DsmTravail)periodesDeclarees.elementSuivant();
        if (!periodeDeclaree.isJustifiee()) {
          estDNJ = true;
        }
      }
      boolean catPat = false;
      if (estDNJ)
      {
        if (((determinerConfrontationGainHeure(totalGainsJustifiees, totalHeuresJustifiees, totalGainsDeclares, totalHeuresDeclarees, periodeUt.getDebut())) && (determinerPresenceGainHeureJustifiees(totalGainsJustifiees, totalHeuresJustifiees, existePans, periodeUt.getDebut(), catPat))) || (!unHorsCESOuDSMTravail)) {
          statut = 3;
        } else {
          statut = 2;
        }
      }
      else {
        statut = 3;
      }
    }
    else
    {
      statut = 4;
    }
    return statut;
  }
  
  protected static boolean estActualiseMaintienEuropeen(ChronologiePeriodes periodesDecalantes, Periode periodeUt, AttributionSpec attribution)
  {
    boolean retour = true;
    if (OutillagePEC.estPecAutreEtatMembreCoordination(OutillagePEC.getPeriodePECContenant(attribution.getDemandeur(), periodeUt.getDebut())))
    {
      periodesDecalantes.iterer();
      while (periodesDecalantes.encoreSuivant())
      {
        ObjetChronoPeriode periode = (ObjetChronoPeriode)periodesDecalantes.elementSuivant();
        if (((periode instanceof PeriodeAbsenceActualisationMaintienEuropeen)) && (periode.chevauche(periodeUt))) {
          retour = false;
        }
      }
    }
    return retour;
  }
  
  protected static boolean determinerPriseEnCompteGainsSurPANS(Damj datePivot)
    throws CoucheLogiqueException
  {
    boolean priseEnCompteGain = false;
    
    CritereStrategie critereStrategie = new CritereStrategie();
    critereStrategie.setDatePivot(datePivot);
    
    StrategieDeterminationPriseEnCompteGainSurPansSpec strategieDeterminationGainsPansSurUT = (StrategieDeterminationPriseEnCompteGainSurPansSpec)FabriqueStrategieDeterminationPriseEnCompteGainsSurPANS.getInstance().getStrategie(critereStrategie);
    
    priseEnCompteGain = strategieDeterminationGainsPansSurUT.priseEnCompteGainSurPANS();
    
    return priseEnCompteGain;
  }
  
  protected static boolean determinerPresenceGainHeureJustifiees(BigDecimal totalGainJustifiee, BigDecimal totalHeuresJustifiee, boolean existePANS, Damj datePivot, boolean catPat)
    throws CoucheLogiqueException
  {
    boolean presenceGainHeureJustifiee = false;
    
    CritereStrategie critereStrategie = new CritereStrategie();
    critereStrategie.setDatePivot(datePivot);
    StrategieDeterminationStatutUTGainHeureRenseigneSpec strategieDeterminationStatutUT = (StrategieDeterminationStatutUTGainHeureRenseigneSpec)FabriqueStrategieDeterminationStatutUTGainHeureRenseigne.getInstance().getStrategie(critereStrategie);
    
    presenceGainHeureJustifiee = strategieDeterminationStatutUT.presenceGainHeureRenseigne(totalGainJustifiee, totalHeuresJustifiee, existePANS, catPat);
    
    return presenceGainHeureJustifiee;
  }
  
  protected static boolean determinerConfrontationGainHeure(BigDecimal totalGainJustifiee, BigDecimal totalHeuresJustifiee, BigDecimal totalGainDeclares, BigDecimal totalHeuresDeclares, Damj datePivot)
    throws CoucheLogiqueException
  {
    CritereStrategie critereStrategie = new CritereStrategie();
    critereStrategie.setDatePivot(datePivot);
    StrategieA8A10ConfrontationGainHeureSpec strategie = (StrategieA8A10ConfrontationGainHeureSpec)FabriqueStrategieA8A10ConfrontationGainHeure.getInstance().getStrategie(critereStrategie);
    
    return strategie.estSuperieurA90Pourcent(totalHeuresJustifiee, totalGainJustifiee, totalHeuresDeclares, totalGainDeclares);
  }
  
  protected static void effectuerConversionHeureNonRenseigne(ChronologiePeriodes periodesJustifiees, Damj dateDebutUt, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    CritereStrategie critereStrategie = new CritereStrategie();
    critereStrategie.setDatePivot(dateDebutUt);
    StrategieDeterminationStatutUTConversionHeureSpec strategieDeterminationStatutUT = (StrategieDeterminationStatutUTConversionHeureSpec)FabriqueStrategieDeterminationStatutUTConversionHeure.getInstance().getStrategie(critereStrategie);
    
    strategieDeterminationStatutUT.conversionHeureBS(periodesJustifiees, dateDebutUt, attribution);
  }
  
  protected static boolean verifierPresenceGainHeureJustifiees(BigDecimal totalGainJustifiee, BigDecimal totalHeuresJustifiee, boolean existePANS, Damj datePivot, boolean estCategorieEmploiAnnexe1, boolean pansEnAttenteRegulationApresEcheance)
  {
    if (((totalGainJustifiee.compareTo(BigDecimal.ZERO) != 0) && (((totalHeuresJustifiee.compareTo(BigDecimal.ZERO) != 0) && (!pansEnAttenteRegulationApresEcheance)) || (estCategorieEmploiAnnexe1))) || (existePANS)) {
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     DefinitionStatutUtTraitementActiviteReduite
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */