package fr.unedic.cali.asu.cge01.avant.outilsfonctionnels;

import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeAEDV;
import fr.unedic.cali.asu.cge01.avant.FacadeAvantLigneImpl;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.Qualification;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.CarenceIccp;
import fr.unedic.cali.asu.produits.liquidation.dom.CarenceIslr;
import fr.unedic.cali.asu.produits.liquidation.dom.Differe;
import fr.unedic.cali.asu.produits.liquidation.dom.Poursuite;
import fr.unedic.cali.asu.produits.liquidation.dom.PreavisLegal;
import fr.unedic.cali.asu.produits.liquidation.dom.PreavisMesureConservatoireNonIndemnisable;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.CalendrierExecutionAvant;
import fr.unedic.cali.calcul.dom.ConsommationPeriodes;
import fr.unedic.cali.calcul.dom.DureeConsommableAvant;
import fr.unedic.cali.calcul.dom.EtatAuDernierJourAvant;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.UniteTraitementAvant;
import fr.unedic.cali.calcul.dom.periode.PeriodeActiviteEmploiCalcul;
import fr.unedic.cali.calcul.dom.periode.PeriodeConflitGAEC;
import fr.unedic.cali.calcul.dom.periode.PeriodeExclusionDefinitiveDDTE;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormationNonIndemniseeAbsenceHeure;
import fr.unedic.cali.calcul.dom.temps.ObjetChrono60AnsBlocageRetraite;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeArretCalcul;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeCalcul;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionSuivi;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodesPriseEnCompte;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodeTravailCalculPAEC;
import fr.unedic.cali.calcul.pbjc.dom.IndividuPbjcNcp;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.fabriques.FabriqueStrategieQuantiteAffiliationHeureAvecCachet;
import fr.unedic.cali.outilsfonctionnels.Anomalie;
import fr.unedic.cali.outilsfonctionnels.GestionAnomalies;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieQuantiteAffiliationHeureAvecCachetSpec;
import fr.unedic.cali.parametres.GestionnaireDateApplication;
import fr.unedic.cali.utilitaire.outils.OutilRecherche;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.Unite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.FiltreChevauchePeriode;
import fr.unedic.util.temps.FiltreDebutDansBornes;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import fr.unedic.util.temps.Temporel;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.ListIterator;

public class TraitementUtAvant
{
  public static int executerUtAvant(AttributionSpec attribution, CalendrierExecutionAvant calendrierAvant, Periode periodeUtAvant, ChronologiePeriodes chronologiePeriodes)
    throws CoucheLogiqueException
  {
    convertionCachets(chronologiePeriodes);
    
    UniteTraitementAvant utAvant = executerAttributionAvant(attribution, calendrierAvant, periodeUtAvant, chronologiePeriodes);
    return executerUtAvant(attribution, calendrierAvant, utAvant, attribution.getDemandeur());
  }
  
  public static void convertionCachets(ChronologiePeriodes periodes)
  {
    if ((periodes != null) && (!periodes.estVide()))
    {
      PeriodeActiviteEmploiCalcul periodeActivite = null;
      Chronologie chronoPeriodesPAEC = periodes.copier(new FiltrePeriodeTravailCalculPAEC());
      if ((chronoPeriodesPAEC != null) && (!chronoPeriodesPAEC.estVide()))
      {
        chronoPeriodesPAEC.iterer();
        while (chronoPeriodesPAEC.encoreSuivant())
        {
          periodeActivite = (PeriodeActiviteEmploiCalcul)chronoPeriodesPAEC.elementSuivant();
          if ((periodeActivite.getQuantiteAffiliationCachets() != null) && (periodeActivite.getCachets() != null))
          {
            periodeActivite.setNombreHeures(periodeActivite.getNombreHeuresDeCompletude());
            
            CritereStrategie strategieHeureCachets = new CritereStrategie();
            strategieHeureCachets.setDatePivot(periodeActivite.getDateDebut());
            StrategieQuantiteAffiliationHeureAvecCachetSpec strategieHeureAvecCachet = (StrategieQuantiteAffiliationHeureAvecCachetSpec)FabriqueStrategieQuantiteAffiliationHeureAvecCachet.getInstance().getStrategie(strategieHeureCachets);
            
            strategieHeureAvecCachet.determinerQuantiteAffiliationHeureAvecCachet(periodeActivite, periodeActivite.getQuantiteAffiliationCachets());
          }
        }
      }
    }
  }
  
  public static int executerUtAvant(AttributionSpec attribution, CalendrierExecutionAvant calendrierAvant, UniteTraitementAvant utAvant, IndividuSpec individu)
    throws CoucheLogiqueException
  {
    int etat = 0;
    
    DureeConsommableAvant dureeActive = utAvant.getDureeConsommableAvantActiveEnFinUt();
    if (dureeActive != null)
    {
      Periode p = utAvant.getConsommationPeriodes().getPeriodesParTypologie(dureeActive.getTypeDureeConsommable());
      if (p != null) {
        if (utAvant.isProduitATerminerApresUT()) {
          p.setFin(utAvant.getArretProduitAvecRaison().recupereLendemainDateArret().veille());
        } else {
          p.setFin(utAvant.getDateFin());
        }
      }
    }
    calendrierAvant.ajouterUniteTraitementAvant(utAvant);
    if ((calendrierAvant.getDebutPeriodePECEvenementReducteurs() == null) && (utAvant.getDebutPeriodePECEvenementReducteurs() != null)) {
      calendrierAvant.setDebutPeriodePECEvenementReducteurs(utAvant.getDebutPeriodePECEvenementReducteurs());
    }
    if (utAvant.isProduitATerminerApresUT())
    {
      calendrierAvant.setDernierJourAvant(utAvant.getArretProduitAvecRaison().recupereLendemainDateArret().veille());
      if ((etat == 0) && (utAvant.getArretProduitAvecRaison().isRaisonsContientRaison(4))) {
        etat = 1;
      }
      ChronologiePeriodes periodesInterruptivesDefinitives = new ChronologiePeriodes();
      periodesInterruptivesDefinitives.ajouter(utAvant.getArretProduitAvecRaison().getPeriodesInterruptivesDefinitives());
      if (!periodesInterruptivesDefinitives.estVide())
      {
        Damj datePeriodeInterruptives = null;
        
        ObjetChronoPeriode premiereChronoPeriode = null;
        
        periodesInterruptivesDefinitives.iterer();
        while (periodesInterruptivesDefinitives.encoreSuivant())
        {
          ObjetChronoPeriode objetChronoPeriode = (ObjetChronoPeriode)periodesInterruptivesDefinitives.elementSuivant();
          
          datePeriodeInterruptives = objetChronoPeriode.getDateDebut();
          if ((datePeriodeInterruptives.estContenueDans(new Periode(calendrierAvant.getDateDebut(), calendrierAvant.getDateFin().lendemain()))) && ((premiereChronoPeriode == null) || (objetChronoPeriode.getDateDebut().estAvant(premiereChronoPeriode.getDateDebut())))) {
            premiereChronoPeriode = objetChronoPeriode;
          }
        }
        if ((premiereChronoPeriode instanceof PeriodeExclusionDefinitiveDDTE))
        {
          etat = 9;
        }
        else if ((premiereChronoPeriode instanceof PeriodeConflitGAEC))
        {
          GestionAnomalies.ajouteAnomalie(new Anomalie("M02", calendrierAvant.getDateFin().lendemain(), ""), individu);
        }
        else if ((premiereChronoPeriode instanceof PeriodeFormationNonIndemniseeAbsenceHeure))
        {
          GestionAnomalies.ajouteAnomalie(new Anomalie("M06", calendrierAvant.getDateFin().lendemain(), ""), individu);
        }
        else if ((premiereChronoPeriode instanceof ObjetChrono60AnsBlocageRetraite))
        {
          ObjetChrono60AnsBlocageRetraite objetChrono60AnsBlocageRetraite = (ObjetChrono60AnsBlocageRetraite)premiereChronoPeriode;
          GestionAnomalies.ajouteAnomalie(new Anomalie("M11", Damj.max(objetChrono60AnsBlocageRetraite.getDateDebut(), attribution.getDateAttribution()), ""), individu);
        }
      }
      mettreAJourPeriodeApplicationDureeConsommableAvant(calendrierAvant);
      if (calendrierAvant.getDebutPeriodePECEvenementReducteurs() != null) {
        calendrierAvant.setEtatAuDernierJourAvant(new EtatAuDernierJourAvant(utAvant, etat, new Periode(calendrierAvant.getDebutPeriodePECEvenementReducteurs(), calendrierAvant.getDernierJourAvant())));
      } else {
        calendrierAvant.setEtatAuDernierJourAvant(new EtatAuDernierJourAvant(utAvant, etat, null));
      }
    }
    return etat;
  }
  
  public static UniteTraitementAvant executerAttributionAvant(AttributionSpec attribution, CalendrierExecutionAvant calendrierAvant, Periode periodeUtAvant, ChronologiePeriodes chronologiePeriodes)
    throws CoucheLogiqueException
  {
    Damj dateDepartAttribution = attribution.getDateAttribution();
    if ((attribution instanceof Poursuite)) {
      dateDepartAttribution = ((Poursuite)attribution).getPjp();
    }
    ChronologiePeriodes chronoPeriodesSurUt = new ChronologiePeriodes(new FiltreChevauchePeriode(new Periode(periodeUtAvant.getDebut(), periodeUtAvant.getFin().lendemain())));
    
    chronoPeriodesSurUt.ajouter(chronologiePeriodes);
    
    Qualification qualification = new Qualification();
    QualificationPeriodes periodesQualifie = qualification.qualificationPeriodesPourAvant(chronoPeriodesSurUt, attribution);
    
    forcerQualificationPeriodesCalcul(chronoPeriodesSurUt, periodesQualifie);
    
    ChronologiePeriodes periodesInterruptives = periodesQualifie.getPeriodesInterruptivesDefinitives();
    ChronologiePeriodes periodesNouvellesInterruptives = new ChronologiePeriodes();
    periodesInterruptives.iterer();
    while (periodesInterruptives.encoreSuivant())
    {
      ObjetChronoPeriodeCalcul periode = (ObjetChronoPeriodeCalcul)periodesInterruptives.elementSuivant();
      if (periode.getDateDebut().estApresOuCoincideAvec(dateDepartAttribution)) {
        periodesNouvellesInterruptives.ajouter(periode);
      }
    }
    periodesQualifie.setPeriodesInterruptivesDefinitives(periodesNouvellesInterruptives);
    return executerAttributionAvant(attribution, calendrierAvant, periodeUtAvant, periodesQualifie);
  }
  
  public static UniteTraitementAvant executerAttributionAvant(AttributionSpec attribution, CalendrierExecutionAvant calendrierAvant, Periode pperiodeUtAvant, QualificationPeriodes periodesQualifie)
    throws CoucheLogiqueException
  {
    UniteTraitementAvant utAvant = null;
    ChronologiePeriodes periodesAnalyses = null;
    PeriodesPriseEnCompte periodesPriseEnCompte = null;
    
    Periode periodeUtAvant = (Periode)pperiodeUtAvant.copie();
    
    utAvant = new UniteTraitementAvant(Unite.get("jour"), periodeUtAvant);
    
    utAvant.setQualificationPeriodes(periodesQualifie);
    
    utAvant.setConsommationPeriodes(new ConsommationPeriodes());
    
    periodesPriseEnCompte = new PeriodesPriseEnCompte(pperiodeUtAvant);
    if (calendrierAvant.getEtatExecutionAvant() == 1)
    {
      periodesPriseEnCompte.tronquePeriodesPriseEnCompteEnDebut(calendrierAvant.getPremierJourAvant());
      
      calendrierAvant.setEtatExecutionAvant(2);
    }
    initialiserDureesConsommablesAvant(calendrierAvant, utAvant, attribution);
    
    ArretProduitAvecRaison arretProduitAvecRaison = effectuerTraitementPeriodes(utAvant, periodesPriseEnCompte, attribution, calendrierAvant);
    
    DureeConsommableAvant dureeActive = utAvant.getDureeConsommableAvantActiveEnDebutUt();
    if ((dureeActive != null) && (dureeActive.getQuantiteInitial().getValeurEntiere() > 0))
    {
      Periode p = utAvant.getConsommationPeriodes().getPeriodesParTypologie(dureeActive.getTypeDureeConsommable());
      if (p == null)
      {
        p = new Periode(utAvant.getDateDebut());
        utAvant.getConsommationPeriodes().setPeriodesParTypologie(dureeActive.getTypeDureeConsommable(), p);
      }
    }
    periodesAnalyses = creerLesPeriodesAnalyses(utAvant, utAvant.getQualificationPeriodes(), periodesPriseEnCompte);
    
    TraitementPeriodesAnalyseAvant.traitementDesPeriodesAnalyses(attribution, utAvant, periodesAnalyses, utAvant.getQualificationPeriodes(), arretProduitAvecRaison);
    if (arretProduitAvecRaison.isProduitAArreter())
    {
      utAvant.setProduitATerminerApresUT(true);
      utAvant.setArretProduitAvecRaison(arretProduitAvecRaison);
      calendrierAvant.setEtatExecutionAvant(3);
    }
    return utAvant;
  }
  
  public static void initialiserDureesConsommablesAvant(CalendrierExecutionAvant calendrierAvant, UniteTraitementAvant putAvant, AttributionSpec attribution)
  {
    if (calendrierAvant.getChronologieUnitesTraitements() != null)
    {
      UniteTraitementAvant utAvant = null;
      Iterator listeUt = calendrierAvant.getChronologieUnitesTraitements().iterer();
      while (listeUt.hasNext()) {
        utAvant = (UniteTraitementAvant)listeUt.next();
      }
      if (utAvant != null)
      {
        if (utAvant.getDureePmcEnFinUT() != null)
        {
          DureeConsommableAvant dureePmc = (DureeConsommableAvant)utAvant.getDureePmcEnFinUT().copie();
          putAvant.setDureePmcEnDebutUT(dureePmc);
        }
        if (utAvant.getDureePreavisLegalEnFinUT() != null)
        {
          DureeConsommableAvant dureePreavisLegal = (DureeConsommableAvant)utAvant.getDureePreavisLegalEnFinUT().copie();
          putAvant.setDureePreavisLegalEnDebutUT(dureePreavisLegal);
        }
        if (utAvant.getDureeDiffereStandardEnFinUT() != null)
        {
          DureeConsommableAvant dureeDiffereStandard = (DureeConsommableAvant)utAvant.getDureeDiffereStandardEnFinUT().copie();
          putAvant.setDureeDiffereStandardEnDebutUT(dureeDiffereStandard);
        }
        if (utAvant.getDureeDiffereSpecifiqueEnFinUT() != null)
        {
          DureeConsommableAvant dureeDiffereSpecifique = (DureeConsommableAvant)utAvant.getDureeDiffereSpecifiqueEnFinUT().copie();
          putAvant.setDureeDiffereSpecifiqueEnDebutUT(dureeDiffereSpecifique);
        }
        if (utAvant.getDureeDelaiAttenteEnFinUT() != null)
        {
          DureeConsommableAvant dureeDelaiAttente = (DureeConsommableAvant)utAvant.getDureeDelaiAttenteEnFinUT().copie();
          putAvant.setDureeDelaiAttenteEnDebutUT(dureeDelaiAttente);
        }
        return;
      }
    }
    creerDureeIndemnisation(attribution, calendrierAvant, putAvant);
  }
  
  private static void creerDureeIndemnisation(AttributionSpec attribution, CalendrierExecutionAvant calendrierAvant, UniteTraitementAvant utAvant)
  {
    DureeConsommableAvant dureePmc = new DureeConsommableAvant(0, new QuantiteJour("0"));
    DureeConsommableAvant dureePreavisLegal = new DureeConsommableAvant(4, new QuantiteJour("0"));
    DureeConsommableAvant dureeDiffereStandard = new DureeConsommableAvant(1, new QuantiteJour("0"));
    DureeConsommableAvant dureeDiffereSpecifique = new DureeConsommableAvant(2, new QuantiteJour("0"));
    DureeConsommableAvant dureeDelaiAttente = new DureeConsommableAvant(3, new QuantiteJour("0"));
    
    Collection carences = FacadeAvantLigneImpl.getCarencesValides(((Attribution)attribution).getListeCarences(), attribution.getDateAttribution());
    if ((attribution instanceof Poursuite)) {
      carences = FacadeAvantLigneImpl.getCarencesValides(construireCarencesPoursuite(attribution), attribution.getDateAttribution());
    }
    PreavisMesureConservatoireNonIndemnisable pmc = FacadeAvantLigneImpl.getPmcAConsommer(carences);
    if (pmc != null) {
      dureePmc.setQuantiteInitial(pmc.getQuantiteInitial());
    }
    PreavisLegal preavisLegal = FacadeAvantLigneImpl.getPreavisLegalAConsommer(carences);
    if (preavisLegal != null) {
      dureePreavisLegal.setQuantiteInitial(preavisLegal.getQuantiteInitial());
    }
    CarenceIccp differeStandard = FacadeAvantLigneImpl.getDiffereStandardAConsommer(carences);
    if (differeStandard != null) {
      dureeDiffereStandard.setQuantiteInitial(differeStandard.getQuantiteInitial());
    }
    CarenceIslr differeIslr = FacadeAvantLigneImpl.getDiffereSpecifiqueAConsommer(carences);
    if (differeIslr != null) {
      dureeDiffereSpecifique.setQuantiteInitial(differeIslr.getQuantiteInitial());
    }
    Differe delaiAttente = FacadeAvantLigneImpl.getDelaiAttenteAConsommer(carences);
    if (delaiAttente != null) {
      dureeDelaiAttente.setQuantiteInitial(delaiAttente.getQuantiteInitial());
    }
    dureePmc.activer();
    if (dureePmc.getQuantiteInitial().getValeurEntiere() > 0)
    {
      Periode p = new Periode(calendrierAvant.getPremierJourAvant());
      utAvant.getConsommationPeriodes().setPeriodePmc(p);
    }
    utAvant.setDureePmcEnDebutUT(dureePmc);
    utAvant.setDureePreavisLegalEnDebutUT(dureePreavisLegal);
    utAvant.setDureeDiffereStandardEnDebutUT(dureeDiffereStandard);
    utAvant.setDureeDiffereSpecifiqueEnDebutUT(dureeDiffereSpecifique);
    utAvant.setDureeDelaiAttenteEnDebutUT(dureeDelaiAttente);
  }
  
  private static ChronologiePeriodes creerLesPeriodesAnalyses(UniteTraitementAvant utAvant, QualificationPeriodes qualificationPeriodes, PeriodesPriseEnCompte periodesPriseEnCompte)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesAnalyses = null;
    if (periodesAnalyses == null)
    {
      Iterator iterator = null;
      ChronologiePeriodes chronologie = null;
      ObjetChronoPeriode objetChronoPeriode = null;
      Periode periode = null;
      
      iterator = periodesPriseEnCompte.getPeriodesParTypologie(3).iterer();
      chronologie = new ChronologiePeriodes();
      while (iterator.hasNext())
      {
        objetChronoPeriode = (ObjetChronoPeriode)iterator.next();
        periode = new Periode(objetChronoPeriode.getDateDebut(), objetChronoPeriode.getDateFin());
        chronologie.ajouter((ChronologiePeriodes)qualificationPeriodes.getPeriodesSegmentantes().copier(new FiltreDebutDansBornes(periode)));
      }
      iterator = periodesPriseEnCompte.getPeriodesParTypologie(3).iterer();
      ChronologiePeriodes chronologiePeriodesAnalyses = new ChronologiePeriodes();
      while (iterator.hasNext())
      {
        objetChronoPeriode = (ObjetChronoPeriode)iterator.next();
        periode = new Periode(objetChronoPeriode.getDateDebut(), objetChronoPeriode.getDateFin());
        if (periode.getFin().estApresOuCoincideAvec(periode.getDebut())) {
          chronologiePeriodesAnalyses.ajouter(TraitementPeriodesAvant.traitementPeriodesSegmentantes(periode, utAvant, chronologie));
        }
      }
      periodesAnalyses = chronologiePeriodesAnalyses;
    }
    return periodesAnalyses;
  }
  
  private static ArretProduitAvecRaison effectuerTraitementPeriodes(UniteTraitementAvant utAvant, PeriodesPriseEnCompte periodesPriseEnCompte, AttributionSpec attribution, CalendrierExecutionAvant calendrierAvant)
    throws CoucheLogiqueException
  {
    QualificationPeriodes qualificationPeriodes = utAvant.getQualificationPeriodes();
    
    filtrerPeriodesPourUneTypologie(1, qualificationPeriodes, periodesPriseEnCompte);
    
    ArretProduitAvecRaison arretProduitAvecRaison = traitementPeriodesInterruptivesDefinitives(periodesPriseEnCompte, utAvant, attribution, calendrierAvant);
    
    return arretProduitAvecRaison;
  }
  
  private static void filtrerPeriodesPourUneTypologie(int periodeType, QualificationPeriodes qualificationPeriodes, PeriodesPriseEnCompte periodesPriseEnCompte)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes chronologie = new ChronologiePeriodes();
    
    Iterator it = periodesPriseEnCompte.getPeriodesParTypologie(periodeType).iterer();
    while (it.hasNext())
    {
      ObjetChronoPeriode objetChronoPeriode = (ObjetChronoPeriode)it.next();
      Periode periode = new Periode(objetChronoPeriode.getDateDebut(), objetChronoPeriode.getDateFin());
      ChronologiePeriodes chronoAAjouter = (ChronologiePeriodes)qualificationPeriodes.getPeriodesParTypologie(periodeType).copier(new FiltreChevauchePeriode(periode));
      
      Iterator itChronoAAjouter = chronoAAjouter.iterer();
      while (itChronoAAjouter.hasNext())
      {
        Temporel temporel = (Temporel)itChronoAAjouter.next();
        if (!chronologie.contientElement(temporel)) {
          chronologie.ajouter(temporel);
        }
      }
    }
    qualificationPeriodes.setPeriodesParTypologie(periodeType, chronologie);
  }
  
  static ArretProduitAvecRaison traitementPeriodesInterruptivesDefinitives(PeriodesPriseEnCompte periodesPriseEnCompte, UniteTraitementAvant utAvant, AttributionSpec attribution, CalendrierExecutionAvant calendrierAvant)
    throws CoucheLogiqueException
  {
    ObjetChronoPeriode objetChronoPeriode = null;
    ListIterator iterator = null;
    ArretProduitAvecRaison retour = new ArretProduitAvecRaison();
    Damj dateDebutPremierePeriodeTraitee = null;
    ChronologiePeriodes periodesInterruptivesDefinitives = utAvant.getQualificationPeriodes().getPeriodesInterruptivesDefinitives();
    
    iterator = periodesInterruptivesDefinitives.iterer();
    while (iterator.hasNext())
    {
      objetChronoPeriode = (ObjetChronoPeriode)iterator.next();
      if ((dateDebutPremierePeriodeTraitee == null) || (objetChronoPeriode.getDateDebut().equals(dateDebutPremierePeriodeTraitee)))
      {
        dateDebutPremierePeriodeTraitee = objetChronoPeriode.getDateDebut();
        
        retour.ajoutePeriodeInterruptiveDefinitive(objetChronoPeriode);
        
        periodesPriseEnCompte.tronquePeriodesPriseEnCompteEnFin(objetChronoPeriode.getDateDebut().veille());
      }
      if ((estUneAEDVApresDispositif(objetChronoPeriode, attribution)) && (objetChronoPeriode.getDateFin().estApresOuCoincideAvec(attribution.getDateAttribution())) && (!estUneAttributionAREM(attribution)))
      {
        if (!estDemandeApresAEDv(objetChronoPeriode.getDateDebut(), attribution))
        {
          gestionEnqueteDrv(attribution, objetChronoPeriode);
          if (attribution.getDemandeur().getIndividuPbjcNcp() == null) {
            attribution.getDemandeur().setIndividuPbjcNcp(new IndividuPbjcNcp());
          }
          attribution.getDemandeur().getIndividuPbjcNcp().setDateAtteinteMoisNonPaye(objetChronoPeriode.getDateDebut().veille());
        }
        calendrierAvant.setDateDrv(objetChronoPeriode.getDateDebut());
      }
    }
    return retour;
  }
  
  private static void gestionEnqueteDrv(AttributionSpec attribution, ObjetChronoPeriode objetChronoPeriode)
  {
    if (attribution.getRsod() != null)
    {
      int rangEnquete = GestionSuivi.determinerRangEnqueteDRV(attribution, objetChronoPeriode);
      
      GestionSuivi.enregistrerEnquetePbjcNcpSurAvant(attribution, objetChronoPeriode.getDateDebut(), 39, rangEnquete, true, null);
    }
  }
  
  protected static void forcerQualificationPeriodesCalcul(ChronologiePeriodes periodes, QualificationPeriodes qualificationPeriodes)
  {
    ObjetChronoPeriodeCalcul periode = null;
    ListIterator iterator = null;
    
    iterator = periodes.iterer();
    while (iterator.hasNext())
    {
      periode = (ObjetChronoPeriodeCalcul)iterator.next();
      if ((periode instanceof ObjetChronoPeriodeArretCalcul)) {
        qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
      }
    }
  }
  
  protected static void mettreAJourPeriodeApplicationDureeConsommableAvant(CalendrierExecutionAvant calendrierExecutionAvant)
  {
    Chronologie uts = calendrierExecutionAvant.getChronologieUnitesTraitements();
    UniteTraitementAvant derniereUtAvant = (UniteTraitementAvant)uts.dernierElement();
    DureeConsommableAvant duree = null;
    Periode periodeConsoPmc = getPeriode(calendrierExecutionAvant, 0);
    Periode periodeConsoPreavisLegal = getPeriode(calendrierExecutionAvant, 4);
    Periode periodeConsoDiffereStandard = getPeriode(calendrierExecutionAvant, 1);
    Periode periodeConsoDiffereSpecifique = getPeriode(calendrierExecutionAvant, 2);
    Periode periodeConsoDelaiAttente = getPeriode(calendrierExecutionAvant, 3);
    
    duree = derniereUtAvant.getDureePmcEnFinUT();
    if (duree != null) {
      duree.setPeriodeApplicationCarence(periodeConsoPmc);
    }
    duree = derniereUtAvant.getDureePreavisLegalEnFinUT();
    if (duree != null) {
      duree.setPeriodeApplicationCarence(periodeConsoPreavisLegal);
    }
    duree = derniereUtAvant.getDureeDiffereStandardEnFinUT();
    if (duree != null) {
      duree.setPeriodeApplicationCarence(periodeConsoDiffereStandard);
    }
    duree = derniereUtAvant.getDureeDiffereSpecifiqueEnFinUT();
    if (duree != null) {
      duree.setPeriodeApplicationCarence(periodeConsoDiffereSpecifique);
    }
    duree = derniereUtAvant.getDureeDelaiAttenteEnFinUT();
    if (duree != null) {
      duree.setPeriodeApplicationCarence(periodeConsoDelaiAttente);
    }
  }
  
  private static Periode getPeriode(CalendrierExecutionAvant calendrierExecutionAvant, int typeDureeConsommableAvant)
  {
    Chronologie uts = calendrierExecutionAvant.getChronologieUnitesTraitements();
    ConsommationPeriodes periodes = null;
    Periode periodeConsommationTotale = null;
    Periode periodeConsommationMensuelle = null;
    
    uts.iterer();
    while (uts.encoreSuivant())
    {
      UniteTraitementAvant utAvant = (UniteTraitementAvant)uts.elementSuivant();
      periodes = utAvant.getConsommationPeriodes();
      periodeConsommationMensuelle = periodes.getPeriodesParTypologie(typeDureeConsommableAvant);
      if (periodeConsommationMensuelle != null) {
        if (periodeConsommationTotale == null) {
          periodeConsommationTotale = (Periode)periodeConsommationMensuelle.copie();
        } else {
          periodeConsommationTotale.setFin(periodeConsommationMensuelle.getFin());
        }
      }
    }
    return periodeConsommationTotale;
  }
  
  private static Collection construireCarencesPoursuite(AttributionSpec attribution)
  {
    Collection toutesLesCarences = new ArrayList();
    Poursuite attrib = (Poursuite)attribution;
    if (attrib.getUniteTraitementAvant() != null)
    {
      if (attrib.getUniteTraitementAvant().getDureePmc() != null)
      {
        PreavisMesureConservatoireNonIndemnisable pmc = new PreavisMesureConservatoireNonIndemnisable();
        pmc.setReliquat(new QuantiteJour(attrib.getUniteTraitementAvant().getDureePmc().toString()));
        pmc.setPeriodeApplicationCarence(attrib.getUniteTraitementAvant().getPeriode());
        pmc.setDateFinPeriodeOrigine(attrib.getUniteTraitementAvant().getPeriode().getDebut());
        pmc.setQuantiteInitial(new QuantiteJour(attrib.getUniteTraitementAvant().getDureePmc().toString()));
        toutesLesCarences.add(pmc);
      }
      if (attrib.getUniteTraitementAvant().getDureeIccp() != null)
      {
        CarenceIccp carenceICCP = new CarenceIccp();
        carenceICCP.setReliquat(new QuantiteJour(attrib.getUniteTraitementAvant().getDureeIccp().toString()));
        carenceICCP.setPeriodeApplicationCarence(attrib.getUniteTraitementAvant().getPeriode());
        carenceICCP.setDateFinPeriodeOrigine(attrib.getUniteTraitementAvant().getPeriode().getDebut());
        carenceICCP.setQuantiteInitial(new QuantiteJour(attrib.getUniteTraitementAvant().getDureeIccp().toString()));
        toutesLesCarences.add(carenceICCP);
      }
      if (attrib.getUniteTraitementAvant().getDureeIslr() != null)
      {
        CarenceIslr carenceISLR = new CarenceIslr();
        carenceISLR.setReliquat(new QuantiteJour(attrib.getUniteTraitementAvant().getDureeIslr().toString()));
        carenceISLR.setPeriodeApplicationCarence(attrib.getUniteTraitementAvant().getPeriode());
        carenceISLR.setDateFinPeriodeOrigine(attrib.getUniteTraitementAvant().getPeriode().getDebut());
        carenceISLR.setQuantiteInitial(new QuantiteJour(attrib.getUniteTraitementAvant().getDureeIslr().toString()));
        toutesLesCarences.add(carenceISLR);
      }
      if (attrib.getUniteTraitementAvant().getDureeDelaiAttente() != null)
      {
        Differe delaiAttente = new Differe();
        delaiAttente.setReliquat(new QuantiteJour(attrib.getUniteTraitementAvant().getDureeDelaiAttente().toString()));
        delaiAttente.setPeriodeApplicationCarence(attrib.getUniteTraitementAvant().getPeriode());
        delaiAttente.setDateFinPeriodeOrigine(attrib.getUniteTraitementAvant().getPeriode().getDebut());
        delaiAttente.setQuantiteInitial(new QuantiteJour(attrib.getUniteTraitementAvant().getDureeDelaiAttente().toString()));
        toutesLesCarences.add(delaiAttente);
      }
    }
    return toutesLesCarences;
  }
  
  private static boolean estDemandeApresAEDv(Damj dateAeDV, AttributionSpec attribution)
  {
    return OutilRecherche.rechercherDemandeSuivante(attribution.getDemande().getChronologieDemandesAssuranceSansCourante(), dateAeDV.veille(), null) != null;
  }
  
  private static boolean estUneAttributionAREM(AttributionSpec attribution)
  {
    return (attribution.getProduitExecution().getNomUnique().equals("ASU_MAY17_02")) || (attribution.getProduitExecution().getNomUnique().equals("ASU_MAY17_03"));
  }
  
  private static boolean estUneAEDVApresDispositif(ObjetChronoPeriode objetChrono, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    return ((objetChrono instanceof ObjetChronoPeriodeAEDV)) && (objetChrono.getDateDebut().estApresOuCoincideAvec(GestionnaireDateApplication.getInstance().recupererDateApplication("Application du nouveau dispositif sur les DRV"))) && (!((AttributionAssuranceSpec)attribution).estMaintenue());
  }
}

/* Location:
 * Qualified Name:     TraitementUtAvant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */