package fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels;

import fr.unedic.cali.asu.calcul.dom.temps.ObjectChronoFinChomageSansRct;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeAEDV;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeAssDemandeExpresse;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeCarences;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeDebutPec;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeFinDureeMaintienDroit;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodePreavis;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeRejetDRV;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeRejetDVDemandeExpresse;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeRejetDVFilEau;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeRejetRevision;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeSuspensionIndemnisation;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.OutilPensionInvalidite;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.fabriques.FabriqueStrategieConvention2014;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.strategies.StrategieConventionARE14Spec;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.fabriques.FabriqueStrategiePeriodeAbsencePointageDelaiAttente;
import fr.unedic.cali.asu.may17.p02.liquidation.dom.AttributionAssuranceMayotte;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeDetection100TMaintien;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeDetectionAgeMaintien;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeMaintien;
import fr.unedic.cali.asu.outilsfonctionnels.DetectionChomageLegitime;
import fr.unedic.cali.asu.outilsfonctionnels.OutilDemande;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategiePeriodeAbsencePointageDelaiAttenteSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.ElementChomageSansRupture;
import fr.unedic.cali.autresdoms.cohab.dom.PeriodeSousPensionInvaliditeChainee;
import fr.unedic.cali.autresdoms.cohab.dom.spec.PeriodeSousPensionInvaliditeChaineeSpec;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.periode.DebutActionFormation;
import fr.unedic.cali.calcul.dom.periode.DsmAbsenceAuPointage;
import fr.unedic.cali.calcul.dom.periode.DsmMaladie;
import fr.unedic.cali.calcul.dom.periode.DsmTravail;
import fr.unedic.cali.calcul.dom.periode.FinActionFormation;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeFormationNonIndemnisee;
import fr.unedic.cali.calcul.dom.periode.FinPeriodePensionInvaliditeChainee;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeSanctionReductionMontant;
import fr.unedic.cali.calcul.dom.periode.ObjetPeriodeAEDV;
import fr.unedic.cali.calcul.dom.periode.PeriodeAbsenceActualisationMaintienEuropeen;
import fr.unedic.cali.calcul.dom.periode.PeriodeAbsenceAuPointage;
import fr.unedic.cali.calcul.dom.periode.PeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.periode.PeriodeBlocageIndemnisation;
import fr.unedic.cali.calcul.dom.periode.PeriodeChevauchementSanction;
import fr.unedic.cali.calcul.dom.periode.PeriodeClca;
import fr.unedic.cali.calcul.dom.periode.PeriodeClcaOuverte;
import fr.unedic.cali.calcul.dom.periode.PeriodeConflitGAEC;
import fr.unedic.cali.calcul.dom.periode.PeriodeDisponibilite;
import fr.unedic.cali.calcul.dom.periode.PeriodeEvenementBloquant;
import fr.unedic.cali.calcul.dom.periode.PeriodeEvenementPersonnel;
import fr.unedic.cali.calcul.dom.periode.PeriodeExclusionDefinitiveDDTE;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormationNonIndemnisee;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormationNonIndemniseeAbsenceHeure;
import fr.unedic.cali.calcul.dom.periode.PeriodeInassiduiteFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodeInterStageFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodePrime;
import fr.unedic.cali.calcul.dom.periode.PeriodeSanctionReductionMontant;
import fr.unedic.cali.calcul.dom.periode.PeriodeSuspensionDDTEAvecImputation;
import fr.unedic.cali.calcul.dom.periode.PeriodeSuspensionDDTESansImputation;
import fr.unedic.cali.calcul.dom.periode.PeriodeSuspensionTitreConservatoire;
import fr.unedic.cali.calcul.dom.periode.PeriodeTravailJustifiee;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnniversaire50Ans;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnniversaire55Ans;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnniversaire60Ans;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnomalieI04;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoBlocageM12;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoNonPeriodeHomogene;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeAttributionSecteurPublic;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeBlocagePerteActiviteConservee;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeCalcul;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeDemandeClassementSP;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeFinPec;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeHomogene;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeInterProduits;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeLendemainDja;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeLimiteIndemnisationPMVS;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeRetraite;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeSuspensionIslr;
import fr.unedic.cali.calcul.outilsfonctionnels.OutilGestionPoursuite;
import fr.unedic.cali.calcul.outilsfonctionnels.QualificationAbstraite;
import fr.unedic.cali.calcul.outilsfonctionnels.RecuperationAvantageVieillesseAvantPJI;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.RevisionSpec;
import fr.unedic.cali.dom.affectation.ProduitAbstrait;
import fr.unedic.cali.dom.affectation.ProduitForDelegueSpec;
import fr.unedic.cali.dom.affectation.ProduitForRfp04P01;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.parametres.GestionnaireDateApplication;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreAttributionSurDecisions;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreDecisionPourProduit;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreReexamenSurDemande;
import fr.unedic.cali.utilitaire.filtres.logiques.FiltreET;
import fr.unedic.cali.utilitaire.filtres.logiques.FiltreNegation;
import fr.unedic.cali.utilitaire.outils.OutilRecherche;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public class Qualification
  extends QualificationAbstraite
{
  static final int SOIXANTE_ANS = 60;
  static final BigDecimal QUARANTE = new BigDecimal("40.00");
  
  public QualificationPeriodes qualificationPeriodesPourAvant(ChronologiePeriodes chronologiePeriodes, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    QualificationPeriodes qualificationPeriodes = null;
    qualificationPeriodes = new QualificationPeriodes();
    
    FabriqueStrategieConvention2014 fab = new FabriqueStrategieConvention2014();
    CritereStrategie cs = new CritereStrategie();
    cs.setDatePivot(attribution.getDateAttribution());
    StrategieConventionARE14Spec strat = (StrategieConventionARE14Spec)fab.getStrategie(cs);
    
    return strat.qualificationPeriodesPourAvant(qualificationPeriodes, chronologiePeriodes, attribution);
  }
  
  protected boolean estTypeAPrendreEnCompte(ObjetChronoPeriode periode)
  {
    boolean retour = true;
    if (((periode instanceof ObjetChronoPeriodeCarences)) || ((periode instanceof ObjetChronoPeriodePreavis))) {
      retour = false;
    }
    return retour;
  }
  
  protected boolean qualifierUnePeriodeInterruptivesDefinitives(ObjetChronoPeriodeCalcul periode, QualificationPeriodes qualificationPeriodes, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    Damj dateAttrib = OutilGestionPoursuite.getInstance().recupererDateAttributionOuPjpSiPoursuite(attribution);
    if ((periode instanceof PeriodeDisponibilite))
    {
      if ((periode.getDateFin().estApresOuCoincideAvec(GestionnaireDateApplication.getInstance().recupererDateApplication("Périodes suspensives en cours"))) && (periode.getDateFin().estApres(attribution.getDateAttribution())) && (((PeriodeDisponibilite)periode).doitInterrompteARE()) && ((!((PeriodeDisponibilite)periode).estSuiteRenouvellement()) || (attribution.getDateAttribution().estAvantOuCoincideAvec(((PeriodeDisponibilite)periode).getDateDebutRenouvellement())))) {
        qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
      }
    }
    else if (((periode instanceof ObjetChronoPeriodeLimiteIndemnisationPMVS)) && (((ObjetChronoPeriodeLimiteIndemnisationPMVS)periode).getRsod().equals(attribution.getRsod())))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if (((periode instanceof PeriodeClcaOuverte)) && (periode.getDateDebut().estApres(attribution.getDateAttribution())))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if ((periode instanceof ObjetChronoPeriodeAssDemandeExpresse))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if ((periode instanceof ObjetChronoPeriodeRejetDVDemandeExpresse))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if ((periode instanceof ObjetChronoPeriodeRejetDRV))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if ((periode instanceof ObjetChronoPeriodeRejetDVFilEau))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if ((periode instanceof ObjetChronoPeriodeDemandeClassementSP))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if (((periode instanceof ObjetChronoPeriodeAttributionSecteurPublic)) && (!attribution.equals(((ObjetChronoPeriodeAttributionSecteurPublic)periode).getAttribution())) && (!OutilDemande.estUneDemandeFinDeDroitSurEpuissement(((ObjetChronoPeriodeAttributionSecteurPublic)periode).getAttribution(), new Periode(periode.getDateDebut().getDebutMois(), periode.getDateFin().getFinMois()))))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if (((periode instanceof ObjetChronoPeriodeInterProduits)) && (!attribution.equals(((ObjetChronoPeriodeInterProduits)periode).getAttribution())))
    {
      if ((((ObjetChronoPeriodeInterProduits)periode).getTypePeriode() == 1) && (((ObjetChronoPeriodeInterProduits)periode).getGamme().equals("ASU")) && (!OutilDemande.estUneDemandeFinDeDroitSurEpuissement(((ObjetChronoPeriodeInterProduits)periode).getAttribution(), new Periode(periode.getDateDebut().getDebutMois(), periode.getDateFin().getFinMois()))) && ((!(((ObjetChronoPeriodeInterProduits)periode).getAttribution() instanceof RevisionSpec)) || (!attribution.getDateAttribution().coincideAvec(((ObjetChronoPeriodeInterProduits)periode).getAttribution().getDateAttribution())))) {
        qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
      } else if (((ObjetChronoPeriodeInterProduits)periode).getNomProduit().equals("INR_RCE04_01")) {
        qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
      } else if ((((ObjetChronoPeriodeInterProduits)periode).getNomProduit().equals("RET_ACO01_01")) && (((ObjetChronoPeriodeInterProduits)periode).getTypePeriode() == 2)) {
        qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
      }
    }
    else if ((periode instanceof ObjetChronoPeriodeRetraite))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if (((periode instanceof PeriodeExclusionDefinitiveDDTE)) && (((PeriodeExclusionDefinitiveDDTE)periode).getRSOD().equals(attribution.getRsod())))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if ((periode instanceof fr.unedic.cali.calcul.dom.periode.ActionFormation))
    {
      qualificationPeriodes.ajouterPeriodesNonQualifiees(periode);
    }
    else if ((periode instanceof PeriodeConflitGAEC))
    {
      if (!attribution.estNeutralise())
      {
        if ((dateAttrib != null) && (dateAttrib.estApres(periode.getDateDebut()))) {
          if (dateAttrib.coincideAvec(dateAttrib.getFinMois()))
          {
            periode.setDateDebut(dateAttrib.lendemain());
            periode.setDateFin(dateAttrib.lendemain());
          }
          else
          {
            periode.setDateDebut(dateAttrib.getFinMois());
            periode.setDateFin(dateAttrib.getFinMois());
          }
        }
        qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
      }
    }
    else if ((periode instanceof PeriodeChevauchementSanction))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if ((periode instanceof PeriodeBlocageIndemnisation))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if ((periode instanceof PeriodeFormationNonIndemniseeAbsenceHeure))
    {
      if (!attribution.estNeutralise())
      {
        if ((dateAttrib != null) && (dateAttrib.estApres(periode.getDateDebut())) && (dateAttrib.estContenueDans(periode.getPeriode()))) {
          periode.setDateDebut(dateAttrib);
        }
        qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
      }
    }
    else if ((periode instanceof ObjetChronoPeriodeFinDureeMaintienDroit))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if ((periode instanceof ObjetChronoPeriodeFinPec))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if (((periode instanceof ObjectChronoFinChomageSansRct)) && (estUneDemandeDeContexteDeChomageEnCoursDeSuspension(attribution)) && (!estUnContexteDeRupturePendantSuspension(attribution)))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if (((periode instanceof ObjetChronoPeriodeBlocagePerteActiviteConservee)) && (((ObjetChronoPeriodeBlocagePerteActiviteConservee)periode).getRsod() != null) && (((ObjetChronoPeriodeBlocagePerteActiviteConservee)periode).getRsod().equals(attribution.getRsod())))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if ((periode instanceof ObjetChronoPeriodeRejetRevision))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if (((periode instanceof ObjetPeriodeAEDV)) && (!(attribution instanceof AttributionAssuranceMayotte)) && (periode.getDateDebut().estApresOuCoincideAvec(GestionnaireDateApplication.getInstance().recupererDateApplication("Application du nouveau dispositif sur les DRV"))) && (!((AttributionAssuranceSpec)attribution).estMaintenue()) && (attribution.estExecutable()) && (periode.getDateFin().estApresOuCoincideAvec(attribution.getDateAttribution())) && (!((AttributionAssuranceSpec)attribution).getListeActiviteConservee().contientElement(((ObjetPeriodeAEDV)periode).getActiviteSalarie())))
    {
      ObjetPeriodeAEDV aedv = (ObjetPeriodeAEDV)periode;
      if (DetectionChomageLegitime.getInstance().estAeDvRejetOuNonDecisionne(attribution.getDemandeur(), aedv.getActiviteSalarie())) {
        qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(new ObjetChronoPeriodeAEDV(periode.getDateFin().lendemain()));
      }
    }
    else
    {
      return false;
    }
    return true;
  }
  
  protected boolean qualifierUnePeriodeSuspensives(ObjetChronoPeriodeCalcul periode, QualificationPeriodes qualificationPeriodes, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    if ((periode instanceof PeriodeDisponibilite))
    {
      if ((((PeriodeDisponibilite)periode).doitSuspendreARE()) && (attribution.getDateAttribution().estAvantOuCoincideAvec(periode.getDateDebut()))) {
        qualificationPeriodes.ajouterPeriodesSuspensives(periode);
      }
    }
    else
    {
      if ((periode instanceof PeriodeClcaOuverte)) {
        return false;
      }
      if ((periode instanceof PeriodeClca))
      {
        if ((attribution != null) && (periode.getDateDebut().estApres(attribution.getDateAttribution()))) {
          qualificationPeriodes.ajouterPeriodesSuspensives(periode);
        }
      }
      else if (((periode instanceof PeriodeEvenementPersonnel)) || ((periode instanceof DsmMaladie)) || ((periode instanceof PeriodeInassiduiteFormation)) || ((periode instanceof DsmAbsenceAuPointage))) {
        qualificationPeriodes.ajouterPeriodesSuspensives(periode);
      } else if ((periode instanceof PeriodeFormationNonIndemnisee))
      {
        if ((((PeriodeFormationNonIndemnisee)periode).estRemuneree()) || (((PeriodeFormationNonIndemnisee)periode).getDureeTotale() == null) || (((PeriodeFormationNonIndemnisee)periode).getDureeTotale().getValeur().compareTo(QUARANTE) == 1)) {
          qualificationPeriodes.ajouterPeriodesSuspensives(periode);
        }
      }
      else if ((periode instanceof PeriodeSuspensionTitreConservatoire)) {
        qualificationPeriodes.ajouterPeriodesSuspensives(periode);
      } else if ((periode instanceof PeriodeSuspensionDDTEAvecImputation))
      {
        if (((((PeriodeSuspensionDDTEAvecImputation)periode).getCodeSanction().equals("SD")) || (((PeriodeSuspensionDDTEAvecImputation)periode).getCodeSanction().equals("SE"))) && (attribution.getRsod() != null) && (attribution.getRsod().equals(((PeriodeSuspensionDDTEAvecImputation)periode).getRSOD()))) {
          qualificationPeriodes.ajouterPeriodesSuspensives(periode);
        }
      }
      else if ((periode instanceof PeriodeSuspensionDDTESansImputation))
      {
        if (((((PeriodeSuspensionDDTESansImputation)periode).getCodeSanction().equals("SD")) || (((PeriodeSuspensionDDTESansImputation)periode).getCodeSanction().equals("SE"))) && (attribution.getRsod() != null) && (attribution.getRsod().equals(((PeriodeSuspensionDDTESansImputation)periode).getRSOD()))) {
          qualificationPeriodes.ajouterPeriodesSuspensives(periode);
        }
      }
      else if (((periode instanceof ObjetChronoPeriodeInterProduits)) && (!attribution.equals(((ObjetChronoPeriodeInterProduits)periode).getAttribution())))
      {
        if (((ObjetChronoPeriodeInterProduits)periode).getTypePeriode() == 7) {
          qualificationPeriodes.ajouterPeriodesSuspensives(periode);
        }
      }
      else if ((((periode instanceof ObjetChronoPeriodeCarences)) || ((periode instanceof ObjetChronoPeriodePreavis))) && (estUneDemandeDeContexteDeChomageEnCoursDeSuspension(attribution))) {
        qualificationPeriodes.ajouterPeriodesSuspensives(periode);
      } else if ((periode instanceof ObjetChronoPeriodeSuspensionIslr)) {
        qualificationPeriodes.ajouterPeriodesSuspensives(periode);
      } else {
        return false;
      }
    }
    return true;
  }
  
  protected boolean qualifierUnePeriodeSegmentante(ObjetChronoPeriodeCalcul periode, QualificationPeriodes qualificationPeriodes, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    Damj pjeNcp = OutilGestionPoursuite.getInstance().recupererPremierJourExecutableNcp(attribution);
    if ((periode instanceof PeriodeSousPensionInvaliditeChaineeSpec))
    {
      PeriodeSousPensionInvaliditeChainee sousPiChainee = (PeriodeSousPensionInvaliditeChainee)periode;
      if (OutilPensionInvalidite.estUneSousPensionDeductible((AttributionAssuranceSpec)attribution, sousPiChainee)) {
        qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
      }
    }
    else if ((periode instanceof FinPeriodePensionInvaliditeChainee))
    {
      FinPeriodePensionInvaliditeChainee finPiChainee = (FinPeriodePensionInvaliditeChainee)periode;
      PeriodeSousPensionInvaliditeChainee piChainee = (PeriodeSousPensionInvaliditeChainee)finPiChainee.getPeriodePensionGeneratrice();
      if (OutilPensionInvalidite.estUneSousPensionDeductible((AttributionAssuranceSpec)attribution, piChainee)) {
        qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
      }
    }
    else if ((periode instanceof fr.unedic.cali.calcul.dom.periode.PeriodeFormation))
    {
      if (((fr.unedic.cali.calcul.dom.periode.PeriodeFormation)periode).getActionFormation().estBasculeAutoriserEnContexteFormation())
      {
        ObjetChronoPeriodeCalcul periodeFormation = (ObjetChronoPeriodeCalcul)periode.copie();
        if ((periode.getDateDebut().estAvant(pjeNcp)) && (periode.getDateFin().estApres(pjeNcp))) {
          periodeFormation.setDateDebut(pjeNcp);
        }
        qualificationPeriodes.ajouterPeriodesSegmentantes(periodeFormation);
      }
    }
    else if ((periode instanceof ObjetChronoPeriodeLendemainDja))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof FinActionFormation))
    {
      IndividuSpec individu = attribution.getDemandeur();
      ObjetChronoPeriode periodeActivite = null;
      ChronologiePeriodes chronologiePeriodes = individu.getChronoPeriodePasseProfessionnelSansFiltrageDNJ();
      chronologiePeriodes.iterer();
      boolean estEncoreEnFormation = false;
      while ((chronologiePeriodes.encoreSuivant()) && (!estEncoreEnFormation))
      {
        periodeActivite = (ObjetChronoPeriode)chronologiePeriodes.elementSuivant();
        if (((periodeActivite instanceof fr.unedic.cali.autresdoms.ga.dom.ActionFormation)) && (!((fr.unedic.cali.autresdoms.ga.dom.ActionFormation)periodeActivite).estAnnulee()) && (((FinActionFormation)periode).getActionFormation().getIdentifiantActionFormation() != Integer.parseInt(((fr.unedic.cali.autresdoms.ga.dom.ActionFormation)periodeActivite).getIdentifiant())) && (periode.getDateFin().estContenueDans(new Periode(periodeActivite.getDateDebut(), periodeActivite.getDateFin()))) && (periode.getDateFin().lendemain().estContenueDans(new Periode(periodeActivite.getDateDebut(), periodeActivite.getDateFin())))) {
          estEncoreEnFormation = true;
        }
      }
      if (!estEncoreEnFormation) {
        qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
      }
    }
    else if ((periode instanceof DebutActionFormation))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if (((periode instanceof ObjetChronoAnniversaire50Ans)) || ((periode instanceof ObjetChronoAnniversaire55Ans)) || ((periode instanceof ObjetChronoAnniversaire60Ans)))
    {
      if ((periode.getDateDebut().estAvant(GestionnaireDateApplication.getInstance().recupererDateApplication("Application des segmentant à tort"))) || (RecuperationAvantageVieillesseAvantPJI.recupererPeriodeAvADate(attribution.getDemandeur(), periode.getDateDebut()) != null)) {
        qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
      }
    }
    else if ((periode instanceof PeriodeInterStageFormation))
    {
      IndividuSpec individu = attribution.getDemandeur();
      Collection listePeriodeAQualifier = new ArrayList();
      ObjetChronoPeriode periodeActivite = null;
      Periode periodeFormation = null;
      ChronologiePeriodes listePeriodesFormations = null;
      
      listePeriodeAQualifier.add(periode);
      
      ChronologiePeriodes chronologiePeriodes = individu.getChronoPeriodePasseProfessionnelSansFiltrageDNJ();
      chronologiePeriodes.iterer();
      while (chronologiePeriodes.encoreSuivant())
      {
        periodeActivite = (ObjetChronoPeriode)chronologiePeriodes.elementSuivant();
        if ((periodeActivite instanceof fr.unedic.cali.autresdoms.ga.dom.ActionFormation))
        {
          listePeriodesFormations = ((fr.unedic.cali.autresdoms.ga.dom.ActionFormation)periodeActivite).getListePeriodeFormation();
          listePeriodesFormations.iterer();
          while (listePeriodesFormations.encoreSuivant())
          {
            periodeFormation = ((fr.unedic.cali.autresdoms.ga.dom.PeriodeFormation)listePeriodesFormations.elementSuivant()).getPeriodeEffective();
            if (periodeFormation != null) {
              if (new Periode(periodeFormation.getDebut(), periodeFormation.getFin()).contient(periode.getPeriode()))
              {
                listePeriodeAQualifier.remove(periode);
              }
              else if (periode.getPeriode().contient(new Periode(periodeFormation.getDebut(), periodeFormation.getFin())))
              {
                listePeriodeAQualifier.remove(periode);
                PeriodeInterStageFormation periodePremierDecoupage = new PeriodeInterStageFormation();
                if (periode.getDateDebut().estAvant(periodeFormation.getDebut().veille()))
                {
                  periodePremierDecoupage.setDateDebut(periode.getDateDebut());
                  periodePremierDecoupage.setDateFin(periodeFormation.getDebut().veille());
                  listePeriodeAQualifier.add(periodePremierDecoupage);
                }
                PeriodeInterStageFormation periodeDeuxiemeDecoupage = new PeriodeInterStageFormation();
                if (periode.getDateFin().estApres(periodeFormation.getFin().lendemain()))
                {
                  periodeDeuxiemeDecoupage.setDateDebut(periodeFormation.getFin().lendemain());
                  periodeDeuxiemeDecoupage.setDateFin(periode.getDateFin());
                  listePeriodeAQualifier.add(periodeDeuxiemeDecoupage);
                }
              }
              else if (periode.getPeriode().contient(periodeFormation.getDebut()))
              {
                periode.setDateFin(periodeFormation.getDebut().veille());
              }
              else if (periode.getPeriode().contient(periodeFormation.getFin()))
              {
                periode.setDateDebut(periodeFormation.getFin().lendemain());
              }
            }
          }
        }
      }
      Iterator iterateur = listePeriodeAQualifier.iterator();
      while (iterateur.hasNext())
      {
        ObjetChronoPeriodeCalcul periodeAAjouter = (ObjetChronoPeriodeCalcul)iterateur.next();
        if (periodeAAjouter.getDuree() > 15) {
          qualificationPeriodes.ajouterPeriodesSegmentantes(periodeAAjouter);
        }
      }
    }
    else if ((periode instanceof DebutActionFormation))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof ObjetChronoPeriodeDetectionAgeMaintien))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof ObjetChronoPeriodeDetection100TMaintien))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof ObjetChronoPeriodeMaintien))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if (((periode instanceof ObjetChronoPeriodeInterProduits)) && (!attribution.equals(((ObjetChronoPeriodeInterProduits)periode).getAttribution())))
    {
      if ((((ObjetChronoPeriodeInterProduits)periode).getTypePeriode() == 2) && ((((ObjetChronoPeriodeInterProduits)periode).getNomProduit().equals("SOL_AER05_01")) || (((ObjetChronoPeriodeInterProduits)periode).getNomProduit().equals("SOL_AER05_02")) || (((ObjetChronoPeriodeInterProduits)periode).getNomProduit().equals("SOL_AER05_03")))) {
        qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
      } else if ((((ObjetChronoPeriodeInterProduits)periode).getTypePeriode() == 5) && ((((ObjetChronoPeriodeInterProduits)periode).getNomProduit().equals("SOL_AER05_01")) || (((ObjetChronoPeriodeInterProduits)periode).getNomProduit().equals("SOL_AER05_02")) || (((ObjetChronoPeriodeInterProduits)periode).getNomProduit().equals("SOL_AER05_03")))) {
        qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
      }
    }
    else if (((periode instanceof PeriodeSanctionReductionMontant)) || ((periode instanceof FinPeriodeSanctionReductionMontant)))
    {
      if (((periode instanceof PeriodeSanctionReductionMontant)) && (periode.getDateDebut().estAvant(pjeNcp)) && (periode.getDateFin().estApresOuCoincideAvec(pjeNcp))) {
        periode.setDateDebut(pjeNcp);
      }
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof PeriodeAvantageVieillesse))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof FinPeriodeAvantageVieillesse))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof PeriodeEvenementBloquant))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if (((periode instanceof ObjetChronoPeriodeHomogene)) || ((periode instanceof ObjetChronoNonPeriodeHomogene)))
    {
      if (periode.getDateDebut().estAvant(GestionnaireDateApplication.getInstance().recupererDateApplication("Application des segmentant à tort"))) {
        qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
      }
    }
    else if ((periode instanceof FinPeriodeFormationNonIndemnisee))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof PeriodeSuspensionDDTEAvecImputation))
    {
      if (((((PeriodeSuspensionDDTEAvecImputation)periode).getCodeSanction().equals("SD")) || (((PeriodeSuspensionDDTEAvecImputation)periode).getCodeSanction().equals("SE"))) && (attribution.getRsod() != null) && (attribution.getRsod().equals(((PeriodeSuspensionDDTEAvecImputation)periode).getRSOD()))) {
        qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
      }
    }
    else if ((periode instanceof ObjetChronoPeriodeDebutPec))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else
    {
      return false;
    }
    return true;
  }
  
  protected boolean qualifierUnePeriodeDecalante(ObjetChronoPeriodeCalcul periode, QualificationPeriodes qualificationPeriodes, AttributionSpec attribution)
  {
    if (((periode instanceof PeriodeTravailJustifiee)) || ((periode instanceof DsmTravail)) || ((periode instanceof PeriodePrime))) {
      qualificationPeriodes.ajouterPeriodesDecalantes(periode);
    } else if ((periode instanceof PeriodeAbsenceActualisationMaintienEuropeen)) {
      qualificationPeriodes.ajouterPeriodesDecalantes(periode);
    } else {
      return false;
    }
    return true;
  }
  
  protected boolean qualifierUnePeriodeGelante(ObjetChronoPeriodeCalcul periode, QualificationPeriodes qualificationPeriodes, AttributionSpec attribution)
  {
    Damj dateFaitGenerateur = ((Attribution)attribution).getDateFaitGenerateur();
    boolean retour = false;
    if (dateFaitGenerateur == null)
    {
      if (((periode instanceof PeriodeTravailJustifiee)) || ((periode instanceof DsmTravail)) || ((periode instanceof PeriodePrime))) {
        qualificationPeriodes.ajouterPeriodesGelantes(periode);
      } else if ((periode instanceof PeriodeAbsenceAuPointage)) {
        qualificationPeriodes.ajouterPeriodesGelantes(periode);
      } else {
        return false;
      }
      return true;
    }
    if (periode.getDateFin().estApres(dateFaitGenerateur)) {
      if (((periode instanceof PeriodeTravailJustifiee)) || ((periode instanceof DsmTravail)) || ((periode instanceof PeriodePrime)))
      {
        retour = true;
        qualificationPeriodes.ajouterPeriodesGelantes(periode);
      }
      else if ((periode instanceof PeriodeAbsenceAuPointage))
      {
        retour = true;
        qualificationPeriodes.ajouterPeriodesGelantes(periode);
      }
    }
    return retour;
  }
  
  protected boolean qualifierUnePeriodeInterruptives(ObjetChronoPeriodeCalcul periode, QualificationPeriodes qualificationPeriodes, AttributionSpec attribution)
  {
    if ((periode instanceof ObjetChronoPeriodeSuspensionIndemnisation)) {
      qualificationPeriodes.ajouterPeriodesInterruptives(periode);
    } else {
      return false;
    }
    return true;
  }
  
  public ChronologiePeriodes qualificationPeriodesSuspensivesPourAvant(ChronologiePeriodes chronologiePeriodes, Damj dateAttribution)
    throws CoucheLogiqueException
  {
    QualificationPeriodes qualificationPeriodes = new QualificationPeriodes();
    ObjetChronoPeriodeCalcul periode = null;
    
    Iterator iterator = chronologiePeriodes.iterer();
    while (iterator.hasNext())
    {
      periode = (ObjetChronoPeriodeCalcul)iterator.next();
      if ((((periode instanceof PeriodeClca)) || ((periode instanceof PeriodeSuspensionDDTEAvecImputation))) && (periode.getDateDebut().estApres(dateAttribution))) {
        qualifierUnePeriodeSuspensives(periode, qualificationPeriodes, null);
      } else if ((periode instanceof ObjetChronoPeriodeSuspensionIndemnisation)) {
        qualificationPeriodes.ajouterPeriodesInterruptives(periode);
      }
    }
    return qualificationPeriodes.getPeriodesSuspensives();
  }
  
  protected boolean qualifierUnePeriodeAlertante(ObjetChronoPeriodeCalcul periode, QualificationPeriodes qualificationPeriodes, AttributionSpec attribution)
  {
    if (((periode instanceof ObjetChronoBlocageM12)) || ((periode instanceof ObjetChronoAnomalieI04)))
    {
      qualificationPeriodes.ajouterPeriodesAlertantes(periode);
      return true;
    }
    return false;
  }
  
  protected boolean qualifierUnePeriodeSuspensivesPourAvant(ObjetChronoPeriodeCalcul periode, QualificationPeriodes qualificationPeriodes, AttributionSpec attrib)
    throws CoucheLogiqueException
  {
    if ((periode instanceof PeriodeDisponibilite))
    {
      if ((((PeriodeDisponibilite)periode).doitSuspendreARE()) && (attrib.getDateAttribution().estAvantOuCoincideAvec(periode.getDateDebut()))) {
        qualificationPeriodes.ajouterPeriodesSuspensives(periode);
      }
    }
    else if ((periode instanceof PeriodeAbsenceAuPointage))
    {
      CritereStrategie critereStrategie = new CritereStrategie();
      critereStrategie.setDatePivot(periode.getDateDebut());
      StrategiePeriodeAbsencePointageDelaiAttenteSpec strategie = (StrategiePeriodeAbsencePointageDelaiAttenteSpec)FabriqueStrategiePeriodeAbsencePointageDelaiAttente.getInstance().getStrategie(critereStrategie);
      if (strategie.estPeriodeAbsencePointageDelaiAttenteAPrendreEnCompte()) {
        qualificationPeriodes.ajouterPeriodesSuspensives(periode);
      } else {
        return false;
      }
    }
    else
    {
      if ((periode instanceof PeriodeClcaOuverte)) {
        return false;
      }
      if ((periode instanceof PeriodeClca))
      {
        if ((attrib != null) && (periode.getDateDebut().estApres(attrib.getDateAttribution()))) {
          qualificationPeriodes.ajouterPeriodesSuspensives(periode);
        }
      }
      else if (((periode instanceof PeriodeEvenementPersonnel)) || ((periode instanceof DsmMaladie)) || ((periode instanceof PeriodeInassiduiteFormation)) || ((periode instanceof DsmAbsenceAuPointage)))
      {
        qualificationPeriodes.ajouterPeriodesSuspensives(periode);
      }
      else if ((periode instanceof fr.unedic.cali.calcul.dom.periode.PeriodeFormation))
      {
        if (((fr.unedic.cali.calcul.dom.periode.PeriodeFormation)periode).getActionFormation().estBasculeAutoriserEnContexteFormation())
        {
          FiltreET filtreCali = new FiltreET();
          filtreCali.ajouterFiltre(new FiltreAttributionSurDecisions());
          filtreCali.ajouterFiltre(new FiltreDecisionPourProduit(34));
          filtreCali.ajouterFiltre(new FiltreNegation(new FiltreReexamenSurDemande()));
          Chronologie chronologie = OutilRecherche.rechercherDecisionsPrecedentes(attrib.getDemandeur().getChronoDemandesNonTriees(), Damj.FIN_DES_TEMPS, filtreCali);
          
          fr.unedic.cali.calcul.dom.periode.PeriodeFormation periodeFormation = (fr.unedic.cali.calcul.dom.periode.PeriodeFormation)periode;
          chronologie.iterer();
          while (chronologie.encoreSuivant())
          {
            AttributionSpec attribution = (AttributionSpec)chronologie.elementSuivant();
            ProduitAbstrait produitRFPE = ProduitForRfp04P01.getInstance();
            ProduitForDelegueSpec produitDelegueRFPE = (ProduitForDelegueSpec)produitRFPE.getProduitDelegue();
            
            String idActionFormation = produitDelegueRFPE.getIdActionFormation(attribution);
            if ((idActionFormation != null) && (Integer.parseInt(idActionFormation) == periodeFormation.getActionFormation().getIdentifiantActionFormation())) {
              qualificationPeriodes.ajouterPeriodesSuspensives(periode);
            }
          }
        }
      }
      else if (((periode instanceof PeriodeInterStageFormation)) && (periode.getDuree() <= 15))
      {
        FiltreET filtreCali = new FiltreET();
        filtreCali.ajouterFiltre(new FiltreAttributionSurDecisions());
        filtreCali.ajouterFiltre(new FiltreDecisionPourProduit(34));
        filtreCali.ajouterFiltre(new FiltreNegation(new FiltreReexamenSurDemande()));
        Chronologie chronologie = OutilRecherche.rechercherDecisionsPrecedentes(attrib.getDemandeur().getChronoDemandesNonTriees(), Damj.FIN_DES_TEMPS, filtreCali);
        
        PeriodeInterStageFormation periodeInterStageFormation = (PeriodeInterStageFormation)periode;
        chronologie.iterer();
        while (chronologie.encoreSuivant())
        {
          AttributionSpec attribution = (AttributionSpec)chronologie.elementSuivant();
          ProduitAbstrait produitRFPE = ProduitForRfp04P01.getInstance();
          ProduitForDelegueSpec produitDelegueRFPE = (ProduitForDelegueSpec)produitRFPE.getProduitDelegue();
          
          String idActionFormation = produitDelegueRFPE.getIdActionFormation(attribution);
          if ((idActionFormation != null) && (Integer.parseInt(idActionFormation) == periodeInterStageFormation.getActionFormation().getIdentifiantActionFormation())) {
            qualificationPeriodes.ajouterPeriodesSuspensives(periode);
          }
        }
      }
      else if ((periode instanceof ObjetChronoPeriodeSuspensionIslr))
      {
        qualificationPeriodes.ajouterPeriodesSuspensives(periode);
      }
      else
      {
        return false;
      }
    }
    return true;
  }
  
  protected boolean qualifierUnePeriodeSegmentantesPourAvant(ObjetChronoPeriodeCalcul periode, QualificationPeriodes qualificationPeriodes, AttributionSpec attribution)
  {
    if ((periode instanceof ObjetChronoPeriodeDebutPec)) {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    } else {
      return false;
    }
    return true;
  }
  
  private boolean estUnContexteDeRupturePendantSuspension(AttributionSpec attribution)
  {
    ElementChomageSansRupture elementChomageSansRupture = ((Attribution)attribution).getElementChomageSansRupture();
    if (elementChomageSansRupture != null) {
      return elementChomageSansRupture.estUnContexteDeRupturePendantSuspension();
    }
    return false;
  }
  
  private boolean estUneDemandeDeContexteDeChomageEnCoursDeSuspension(AttributionSpec attribution)
  {
    ElementChomageSansRupture elementChomageSansRupture = ((Attribution)attribution).getElementChomageSansRupture();
    if (elementChomageSansRupture != null) {
      return elementChomageSansRupture.estDemandeEnContexteDeChomageEnCoursDeSuspension();
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     Qualification
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */