package fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeDebutPec;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.OutilPensionInvalidite;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.Qualification;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.fabriques.FabriqueStrategiePeriodeAbsencePointageDelaiAttente;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeDetection100TMaintien;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeDetectionAgeMaintien;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeMaintien;
import fr.unedic.cali.asu.outilsfonctionnels.OutilAsp;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategiePeriodeAbsencePointageDelaiAttenteSpec;
import fr.unedic.cali.autresdoms.cohab.dom.PeriodeSousPensionInvaliditeChainee;
import fr.unedic.cali.autresdoms.cohab.dom.spec.PeriodeSousPensionInvaliditeChaineeSpec;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.periode.DebutActionFormation;
import fr.unedic.cali.calcul.dom.periode.FinActionFormation;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeFormationNonIndemnisee;
import fr.unedic.cali.calcul.dom.periode.FinPeriodePensionInvaliditeChainee;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeSanctionReductionMontant;
import fr.unedic.cali.calcul.dom.periode.PeriodeAbsenceAuPointage;
import fr.unedic.cali.calcul.dom.periode.PeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.periode.PeriodeEvenementBloquant;
import fr.unedic.cali.calcul.dom.periode.PeriodeInterStageFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodeSanctionReductionMontant;
import fr.unedic.cali.calcul.dom.periode.PeriodeSuspensionDDTEAvecImputation;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnniversaire50Ans;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnniversaire55Ans;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnniversaire60Ans;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoBlocageM12;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoNonPeriodeHomogene;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeCalcul;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeHomogene;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeInterProduits;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeLendemainDja;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public class StrategieConventionARE14Apres
  extends Qualification
  implements StrategieConventionARE14Spec
{
  public boolean estAvantConventionARE14()
  {
    return false;
  }
  
  public boolean estApresConventionARE14()
  {
    return true;
  }
  
  public Damj recupererDateFaitGenerateurDroitCsp(AttributionSpec attribution)
  {
    ActiviteSalarie activiteSalarie = OutilAsp.getInstance().recupererAeCspPourEntreeEnDispositifCSP(attribution.getDemandeur(), (AttributionAssuranceSpec)attribution);
    if (activiteSalarie != null) {
      return activiteSalarie.getDateFin();
    }
    return Damj.FIN_DES_TEMPS;
  }
  
  public QualificationPeriodes qualificationPeriodesPourAvant(QualificationPeriodes qualificationPeriodes, ChronologiePeriodes chronologiePeriodes, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    ObjetChronoPeriodeCalcul periode = null;
    Iterator iterator = null;
    
    iterator = chronologiePeriodes.iterer();
    while (iterator.hasNext())
    {
      periode = (ObjetChronoPeriodeCalcul)iterator.next();
      boolean resultat = qualifierUnePeriodeInterruptivesDefinitives(periode, qualificationPeriodes, attribution);
      resultat = (qualifierUnePeriodeInterruptives(periode, qualificationPeriodes, attribution)) || (resultat);
      resultat = (qualifierUnePeriodeSuspensives(periode, qualificationPeriodes, attribution)) || (resultat);
      
      resultat = (qualifierUnePeriodeSegmentantePourAvant(periode, qualificationPeriodes, attribution)) || (resultat);
      resultat = (qualifierUnePeriodeDecalante(periode, qualificationPeriodes, attribution)) || (resultat);
      resultat = (qualifierUnePeriodeAlertante(periode, qualificationPeriodes, attribution)) || (resultat);
      if ((!resultat) && (estTypeAPrendreEnCompte(periode))) {
        qualificationPeriodes.ajouterPeriodesNonQualifiees(periode);
      }
    }
    return qualificationPeriodes;
  }
  
  private boolean qualifierUnePeriodeSegmentantePourAvant(ObjetChronoPeriodeCalcul periode, QualificationPeriodes qualificationPeriodes, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    Damj pjeNcp = attribution.getDateAttribution();
    if ((periode instanceof PeriodeSousPensionInvaliditeChaineeSpec))
    {
      PeriodeSousPensionInvaliditeChainee sousPiChainee = (PeriodeSousPensionInvaliditeChainee)periode;
      if (OutilPensionInvalidite.estUneSousPensionDeductible((AttributionAssuranceSpec)attribution, sousPiChainee)) {
        qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
      }
    }
    else if ((periode instanceof FinPeriodePensionInvaliditeChainee))
    {
      FinPeriodePensionInvaliditeChainee finPiChainee = (FinPeriodePensionInvaliditeChainee)periode;
      PeriodeSousPensionInvaliditeChainee piChainee = (PeriodeSousPensionInvaliditeChainee)finPiChainee.getPeriodePensionGeneratrice();
      if (OutilPensionInvalidite.estUneSousPensionDeductible((AttributionAssuranceSpec)attribution, piChainee)) {
        qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
      }
    }
    else if ((periode instanceof fr.unedic.cali.calcul.dom.periode.PeriodeFormation))
    {
      if (((fr.unedic.cali.calcul.dom.periode.PeriodeFormation)periode).getActionFormation().estBasculeAutoriserEnContexteFormation())
      {
        ObjetChronoPeriodeCalcul periodeFormation = (ObjetChronoPeriodeCalcul)periode.copie();
        if ((periode.getDateDebut().estAvant(pjeNcp)) && (periode.getDateFin().estApres(pjeNcp))) {
          periodeFormation.setDateDebut(pjeNcp);
        }
        qualificationPeriodes.ajouterPeriodesSegmentantes(periodeFormation);
      }
    }
    else if ((periode instanceof ObjetChronoPeriodeLendemainDja))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof FinActionFormation))
    {
      IndividuSpec individu = attribution.getDemandeur();
      ObjetChronoPeriode periodeActivite = null;
      ChronologiePeriodes chronologiePeriodes = individu.getChronoPeriodePasseProfessionnelSansFiltrageDNJ();
      chronologiePeriodes.iterer();
      boolean estEncoreEnFormation = false;
      while ((chronologiePeriodes.encoreSuivant()) && (!estEncoreEnFormation))
      {
        periodeActivite = (ObjetChronoPeriode)chronologiePeriodes.elementSuivant();
        if (((periodeActivite instanceof fr.unedic.cali.autresdoms.ga.dom.ActionFormation)) && (!((fr.unedic.cali.autresdoms.ga.dom.ActionFormation)periodeActivite).estAnnulee()) && (((FinActionFormation)periode).getActionFormation().getIdentifiantActionFormation() != Integer.parseInt(((fr.unedic.cali.autresdoms.ga.dom.ActionFormation)periodeActivite).getIdentifiant())) && (periode.getDateFin().estContenueDans(new Periode(periodeActivite.getDateDebut(), periodeActivite.getDateFin()))) && (periode.getDateFin().lendemain().estContenueDans(new Periode(periodeActivite.getDateDebut(), periodeActivite.getDateFin())))) {
          estEncoreEnFormation = true;
        }
      }
      if (!estEncoreEnFormation) {
        qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
      }
    }
    else if ((periode instanceof DebutActionFormation))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if (((periode instanceof ObjetChronoAnniversaire50Ans)) || ((periode instanceof ObjetChronoAnniversaire55Ans)) || ((periode instanceof ObjetChronoAnniversaire60Ans)))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof PeriodeInterStageFormation))
    {
      IndividuSpec individu = attribution.getDemandeur();
      Collection listePeriodeAQualifier = new ArrayList();
      ObjetChronoPeriode periodeActivite = null;
      Periode periodeFormation = null;
      ChronologiePeriodes listePeriodesFormations = null;
      
      listePeriodeAQualifier.add(periode);
      
      ChronologiePeriodes chronologiePeriodes = individu.getChronoPeriodePasseProfessionnelSansFiltrageDNJ();
      chronologiePeriodes.iterer();
      while (chronologiePeriodes.encoreSuivant())
      {
        periodeActivite = (ObjetChronoPeriode)chronologiePeriodes.elementSuivant();
        if ((periodeActivite instanceof fr.unedic.cali.autresdoms.ga.dom.ActionFormation))
        {
          listePeriodesFormations = ((fr.unedic.cali.autresdoms.ga.dom.ActionFormation)periodeActivite).getListePeriodeFormation();
          listePeriodesFormations.iterer();
          while (listePeriodesFormations.encoreSuivant())
          {
            periodeFormation = ((fr.unedic.cali.autresdoms.ga.dom.PeriodeFormation)listePeriodesFormations.elementSuivant()).getPeriodeEffective();
            if (periodeFormation != null) {
              if (new Periode(periodeFormation.getDebut(), periodeFormation.getFin()).contient(periode.getPeriode()))
              {
                listePeriodeAQualifier.remove(periode);
              }
              else if (periode.getPeriode().contient(new Periode(periodeFormation.getDebut(), periodeFormation.getFin())))
              {
                listePeriodeAQualifier.remove(periode);
                PeriodeInterStageFormation periodePremierDecoupage = new PeriodeInterStageFormation();
                if (periode.getDateDebut().estAvant(periodeFormation.getDebut().veille()))
                {
                  periodePremierDecoupage.setDateDebut(periode.getDateDebut());
                  periodePremierDecoupage.setDateFin(periodeFormation.getDebut().veille());
                  listePeriodeAQualifier.add(periodePremierDecoupage);
                }
                PeriodeInterStageFormation periodeDeuxiemeDecoupage = new PeriodeInterStageFormation();
                if (periode.getDateFin().estApres(periodeFormation.getFin().lendemain()))
                {
                  periodeDeuxiemeDecoupage.setDateDebut(periodeFormation.getFin().lendemain());
                  periodeDeuxiemeDecoupage.setDateFin(periode.getDateFin());
                  listePeriodeAQualifier.add(periodeDeuxiemeDecoupage);
                }
              }
              else if (periode.getPeriode().contient(periodeFormation.getDebut()))
              {
                periode.setDateFin(periodeFormation.getDebut().veille());
              }
              else if (periode.getPeriode().contient(periodeFormation.getFin()))
              {
                periode.setDateDebut(periodeFormation.getFin().lendemain());
              }
            }
          }
        }
      }
      Iterator iterateur = listePeriodeAQualifier.iterator();
      while (iterateur.hasNext())
      {
        ObjetChronoPeriodeCalcul periodeAAjouter = (ObjetChronoPeriodeCalcul)iterateur.next();
        if (periodeAAjouter.getDuree() > 15) {
          qualificationPeriodes.ajouterPeriodesSegmentantes(periodeAAjouter);
        }
      }
    }
    else if ((periode instanceof DebutActionFormation))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof ObjetChronoPeriodeDetectionAgeMaintien))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof ObjetChronoPeriodeDetection100TMaintien))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof ObjetChronoPeriodeMaintien))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if (((periode instanceof ObjetChronoPeriodeInterProduits)) && (!attribution.equals(((ObjetChronoPeriodeInterProduits)periode).getAttribution())))
    {
      if ((((ObjetChronoPeriodeInterProduits)periode).getTypePeriode() == 2) && ((((ObjetChronoPeriodeInterProduits)periode).getNomProduit().equals("SOL_AER05_01")) || (((ObjetChronoPeriodeInterProduits)periode).getNomProduit().equals("SOL_AER05_02")) || (((ObjetChronoPeriodeInterProduits)periode).getNomProduit().equals("SOL_AER05_03")))) {
        qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
      } else if ((((ObjetChronoPeriodeInterProduits)periode).getTypePeriode() == 5) && ((((ObjetChronoPeriodeInterProduits)periode).getNomProduit().equals("SOL_AER05_01")) || (((ObjetChronoPeriodeInterProduits)periode).getNomProduit().equals("SOL_AER05_02")) || (((ObjetChronoPeriodeInterProduits)periode).getNomProduit().equals("SOL_AER05_03")))) {
        qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
      }
    }
    else if (((periode instanceof PeriodeSanctionReductionMontant)) || ((periode instanceof FinPeriodeSanctionReductionMontant)))
    {
      if (((periode instanceof PeriodeSanctionReductionMontant)) && (periode.getDateDebut().estAvant(pjeNcp)) && (periode.getDateFin().estApresOuCoincideAvec(pjeNcp))) {
        periode.setDateDebut(pjeNcp);
      }
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof PeriodeAvantageVieillesse))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof FinPeriodeAvantageVieillesse))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof PeriodeEvenementBloquant))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if (((periode instanceof ObjetChronoPeriodeHomogene)) || ((periode instanceof ObjetChronoNonPeriodeHomogene)))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof FinPeriodeFormationNonIndemnisee))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else if ((periode instanceof PeriodeSuspensionDDTEAvecImputation))
    {
      if (((((PeriodeSuspensionDDTEAvecImputation)periode).getCodeSanction().equals("SD")) || (((PeriodeSuspensionDDTEAvecImputation)periode).getCodeSanction().equals("SE"))) && (attribution.getRsod() != null) && (attribution.getRsod().equals(((PeriodeSuspensionDDTEAvecImputation)periode).getRSOD()))) {
        qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
      }
    }
    else if ((periode instanceof ObjetChronoPeriodeDebutPec))
    {
      qualificationPeriodes.ajouterPeriodesSegmentantes(periode);
    }
    else
    {
      return false;
    }
    return true;
  }
  
  protected boolean qualifierUnePeriodeSuspensives(ObjetChronoPeriodeCalcul periode, QualificationPeriodes qualificationPeriodes, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    if ((periode instanceof PeriodeAbsenceAuPointage))
    {
      CritereStrategie critereStrategie = new CritereStrategie();
      critereStrategie.setDatePivot(periode.getDateDebut());
      StrategiePeriodeAbsencePointageDelaiAttenteSpec strategie = (StrategiePeriodeAbsencePointageDelaiAttenteSpec)FabriqueStrategiePeriodeAbsencePointageDelaiAttente.getInstance().getStrategie(critereStrategie);
      if (strategie.estPeriodeAbsencePointageDelaiAttenteAPrendreEnCompte()) {
        qualificationPeriodes.ajouterPeriodesSuspensives(periode);
      } else {
        return false;
      }
    }
    else
    {
      return super.qualifierUnePeriodeSuspensives(periode, qualificationPeriodes, attribution);
    }
    return true;
  }
  
  protected boolean qualifierUnePeriodeAlertante(ObjetChronoPeriodeCalcul periode, QualificationPeriodes qualificationPeriodes, AttributionSpec attribution)
  {
    if ((periode instanceof ObjetChronoBlocageM12))
    {
      qualificationPeriodes.ajouterPeriodesAlertantes(periode);
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     StrategieConventionARE14Apres
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */