package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.affiliation;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.affiliation.dom.ParametresAffiliation;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.affiliation.spec.ComportementAffiliationSpec;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.affiliation.spec.TraitementAssimilationSpec;
import fr.unedic.cali.asu.dom.AffiliationAssimilee;
import fr.unedic.cali.autresdoms.ga.dom.PeriodeFormationAssimilable;
import fr.unedic.util.Convertisseur;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.Periode;
import fr.unedic.util.temps.Temporel;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;

public class OutilTraitementAssimilation
  implements TraitementAssimilationSpec
{
  public List<AffiliationAssimilee> traiterAffiliationAssimilable(Periode pra, Chronologie chronologiePeriodes, ComportementAffiliationSpec comportement, ParametresAffiliation parametresAffiliation)
  {
    List<AffiliationAssimilee> resultat = new ArrayList();
    
    List<AffiliationAssimilee> listAssimilationFormation = traiterAssimilationFormation(pra, chronologiePeriodes, comportement, parametresAffiliation);
    resultat.addAll(listAssimilationFormation);
    
    return resultat;
  }
  
  protected List<AffiliationAssimilee> traiterAssimilationFormation(Periode pra, Chronologie chronologiePeriodes, ComportementAffiliationSpec comportement, ParametresAffiliation parametresAffiliation)
  {
    List<AffiliationAssimilee> resultat = new ArrayList();
    if ((parametresAffiliation.isComptabiliserAssimilation()) && (chronologiePeriodes != null))
    {
      Iterator it = chronologiePeriodes.iterer();
      while (it.hasNext())
      {
        Temporel periodeCourante = (Temporel)it.next();
        if (periodeCourante.estType(PeriodeFormationAssimilable.class)) {
          traiterPeriodeAssimilable(pra, comportement, parametresAffiliation, periodeCourante, resultat);
        }
      }
    }
    return resultat;
  }
  
  private void traiterPeriodeAssimilable(Periode pra, ComportementAffiliationSpec comportement, ParametresAffiliation parametresAffiliation, Temporel periodeCourante, List<AffiliationAssimilee> resultat)
  {
    PeriodeFormationAssimilable formation = (PeriodeFormationAssimilable)periodeCourante;
    if (formation.getPeriode().chevauche(pra))
    {
      AffiliationAssimilee affiliationAssimilee = creerInstanceAffiliationAssimilee();
      
      Quantite quantiteARetenir = recupererQuantiteARetenir(comportement, parametresAffiliation, formation);
      
      affiliationAssimilee.setPeriodeAssimilation(formation.getPeriode());
      affiliationAssimilee.setNature(3);
      affiliationAssimilee.setIdPeriodeActivite(formation.getIdentifiant());
      affiliationAssimilee.setQuantiteAssimilation(quantiteARetenir);
      
      resultat.add(affiliationAssimilee);
    }
  }
  
  private Quantite recupererQuantiteARetenir(ComportementAffiliationSpec comportement, ParametresAffiliation parametresAffiliation, PeriodeFormationAssimilable formation)
  {
    Quantite quantiteARetenir = (Quantite)formation.getListeQuantitesAppartenance().get(parametresAffiliation.getUniteCalcul());
    if (quantiteARetenir == null)
    {
      Enumeration enumQuantite = formation.getListeQuantitesAppartenance().keys();
      while (enumQuantite.hasMoreElements())
      {
        Unite uniteCourante = (Unite)enumQuantite.nextElement();
        Quantite quantite = (Quantite)formation.getListeQuantitesAppartenance().get(uniteCourante);
        Quantite quantiteUniteCalcul = comportement.getConvertisseurUnite().convertir(quantite, parametresAffiliation.getUniteCalcul());
        if (quantiteARetenir == null) {
          quantiteARetenir = quantite;
        } else if (quantiteARetenir.compareTo(quantiteUniteCalcul) < 0) {
          quantiteARetenir = quantite;
        }
      }
    }
    return quantiteARetenir;
  }
  
  private AffiliationAssimilee creerInstanceAffiliationAssimilee()
  {
    return new AffiliationAssimilee();
  }
}

/* Location:
 * Qualified Name:     OutilTraitementAssimilation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */