package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieContexteRepriseSystematiqueSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.util.services.CoucheLogiqueException;
import java.util.ArrayList;
import java.util.List;

public class StrategieContexteRepriseSystematiqueApresARE14
  implements StrategieContexteRepriseSystematiqueSpec
{
  public boolean determinerContexteRepriseSystematique(Demande demande)
  {
    return true;
  }
  
  public List<Integer> determinerObjectifsExamenDv122Jour(Demande demande, int contexteExamen)
    throws CoucheLogiqueException
  {
    List<Integer> typesObjectifs = new ArrayList();
    switch (contexteExamen)
    {
    case 1: 
      typesObjectifs.add(Integer.valueOf(10));
      break;
    case 3: 
      if (demande.getDonneesTemporaires().isDroitOptionForce()) {
        typesObjectifs.add(Integer.valueOf(12));
      } else {
        typesObjectifs.addAll(determinerObjectifsExamenPourRepriseSystematique(demande));
      }
      break;
    case 2: 
      typesObjectifs.add(Integer.valueOf(12));
      break;
    case 4: 
      typesObjectifs.addAll(determinerObjectifsAntecedentSecteurPublic(demande));
      break;
    }
    return typesObjectifs;
  }
  
  public List<Integer> determinerObjectifsExamenDemandeExpresseAvecReliquatValide(Demande demande)
  {
    List<Integer> typesObjectifs = new ArrayList();
    if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(demande.getListContexteDemande(), "PREPOSTCSP")) {
      typesObjectifs.add(Integer.valueOf(48));
    } else {
      typesObjectifs.add(Integer.valueOf(15));
    }
    return typesObjectifs;
  }
  
  public List<Integer> determinerObjectifsFinAsp(Demande demande, int contexteExamen)
  {
    List<Integer> typesObjectifs = new ArrayList();
    if (contexteExamen == 3) {
      typesObjectifs.add(Integer.valueOf(15));
    } else if (contexteExamen == 1) {
      typesObjectifs.add(Integer.valueOf(10));
    } else {
      typesObjectifs.add(Integer.valueOf(12));
    }
    return typesObjectifs;
  }
  
  public List<Integer> determinerObjectifsExamenPourRepriseSystematique(Demande demande)
  {
    List<Integer> typesObjectifs = new ArrayList();
    if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(demande.getListContexteDemande(), "AREENTRCSP")) {
      typesObjectifs.add(Integer.valueOf(47));
    } else if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(demande.getListContexteDemande(), "PREPOSTCSP")) {
      typesObjectifs.add(Integer.valueOf(48));
    } else {
      ajouterObjectifReprise(demande, typesObjectifs, 15);
    }
    return typesObjectifs;
  }
  
  private void ajouterObjectifReprise(Demande demande, List<Integer> typesObjectifs, int typeReprise)
  {
    if ("S".equalsIgnoreCase(demande.getModeLiquidation())) {
      typesObjectifs.add(Integer.valueOf(34));
    } else {
      typesObjectifs.add(Integer.valueOf(typeReprise));
    }
  }
  
  public List<Integer> determinerObjectifsAntecedentSecteurPublic(Demande demande)
    throws CoucheLogiqueException
  {
    List<Integer> typesObjectifs = new ArrayList();
    if (demande.estDroitOptionReadmission()) {
      typesObjectifs.add(Integer.valueOf(12));
    } else if (OutilGestionContexteDemande.estContexteDemandeAssurancePresent(demande, "AREENTRCSP")) {
      typesObjectifs = determinerObjectifsExamenPourRepriseSystematique(demande);
    } else if (OutilGestionContexteDemande.estContexteDemandeAssurancePresent(demande, "ARESJASPDC")) {
      typesObjectifs.add(Integer.valueOf(12));
    } else {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ALERTE_A8MB12");
    }
    return typesObjectifs;
  }
}

/* Location:
 * Qualified Name:     StrategieContexteRepriseSystematiqueApresARE14
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */