package fr.unedic.cali.asu.cge01.p02.liquidation.dom;

import fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen.ConditionActiviteConserveeGen;
import fr.unedic.cali.dom.ConditionAttributionSpec;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import java.math.BigDecimal;

public class ConditionActiviteConservee
  extends ConditionActiviteConserveeGen
  implements ConditionAttributionSpec
{
  private static final long serialVersionUID = -1181116194110764786L;
  public static final int SITUATION_MEME_EMPLOYEUR = 1;
  public static final int SITUATION_DEPASSEMENT_PLAFOND_HEURE = 2;
  public static final int SITUATION_DEPASSEMENT_PLAFOND_REMUNERATION = 3;
  public static final int SITUATION_ACTIVITE_CONSERVEE_ET_CONDITION_REMPLIE = 4;
  
  public ConditionActiviteConservee() {}
  
  public ConditionActiviteConservee(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public ResultatElementDroit getResultatElementDroit()
  {
    if (super.getResultatElementDroit() == null) {
      super.setResultatElementDroit(new ResultatElementDroit());
    }
    return super.getResultatElementDroit();
  }
  
  public String toString()
  {
    StringBuffer sb = new StringBuffer();
    sb.append("ConditionActiviteConservee:");
    
    sb.append("\n\tEtat Condition Activite Conservee:");
    sb.append("\n\t" + getEtat());
    
    sb.append("\n\tSituation Condition Activite Conservee:");
    sb.append("\n\t" + getSituationConditionActiviteConservee());
    if (getNombreHeuresMensuelActiviteConservee().compareTo(new BigDecimal("0")) != 0)
    {
      sb.append("\n\tNombre heures mensuel Condition Activite Conservee:");
      sb.append("\n\t" + getNombreHeuresMensuelActiviteConservee());
    }
    if (getMontantMensuelActiviteConservee().compareTo(new BigDecimal("0")) != 0)
    {
      sb.append("\n\tMontant mensuel Condition Activite Conservee:");
      sb.append("\n\t" + getMontantMensuelActiviteConservee());
    }
    return sb.toString();
  }
  
  public void jdoPreDelete() {}
  
  public void marquerGraphePersistant() {}
  
  public boolean estSatisfait()
  {
    return getResultatElementDroit().estSatisfait();
  }
  
  public int getCodeMotifEchec()
  {
    return getResultatElementDroit().getCodeMotifEchec();
  }
  
  public void setCodeMotifEchec(int p_codeMotifEchec)
  {
    getResultatElementDroit().setCodeMotifEchec(p_codeMotifEchec);
  }
  
  public void setEtatSatisfait(boolean p_etatSatisfait)
  {
    getResultatElementDroit().setEtatSatisfait(p_etatSatisfait);
  }
  
  public ObjetMetierSpec copie()
  {
    ConditionActiviteConservee copie = new ConditionActiviteConservee();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ConditionActiviteConservee copie = (ConditionActiviteConservee)p_copie;
    copie.setCodeMotifEchec(getCodeMotifEchec());
    copie.setEtat(getEtat());
    copie.setSituationConditionActiviteConservee(getSituationConditionActiviteConservee());
    copie.setNombreHeuresMensuelActiviteConservee(getNombreHeuresMensuelActiviteConservee());
    copie.setMontantMensuelActiviteConservee(getMontantMensuelActiviteConservee());
    copie.setSeuilMontantMensuelActiviteConservee(getSeuilMontantMensuelActiviteConservee());
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public void jdoPostLoad() {}
  
  public void jdoPreClear() {}
  
  public void jdoPreStore() {}
  
  public void setEtat(int p_etat)
  {
    getResultatElementDroit().setEtat(p_etat);
  }
  
  public int getEtat()
  {
    return getResultatElementDroit().getEtat();
  }
  
  public BigDecimal getMontantMensuelActiviteConservee()
  {
    if (super.getMontantMensuelActiviteConservee() == null) {
      super.setMontantMensuelActiviteConservee(new BigDecimal("0"));
    }
    return super.getMontantMensuelActiviteConservee();
  }
  
  public BigDecimal getNombreHeuresMensuelActiviteConservee()
  {
    if (super.getNombreHeuresMensuelActiviteConservee() == null) {
      super.setNombreHeuresMensuelActiviteConservee(new BigDecimal("0"));
    }
    return super.getNombreHeuresMensuelActiviteConservee();
  }
  
  public BigDecimal getSeuilMontantMensuelActiviteConservee()
  {
    if (super.getSeuilMontantMensuelActiviteConservee() == null) {
      super.setSeuilMontantMensuelActiviteConservee(new BigDecimal("0"));
    }
    return super.getSeuilMontantMensuelActiviteConservee();
  }
}

/* Location:
 * Qualified Name:     ConditionActiviteConservee
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */