package fr.unedic.cali.asu.cge01.p02.liquidation.dom;

import fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen.PrcSjrGen;
import fr.unedic.cali.asu.cge01.p02.liquidation.outilsfonctionnels.ConstructionChronologie;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.util.OutillageChronologiePeriodes;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.FiltreChevauchePeriode;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;

public class PrcSjr
  extends PrcSjrGen
{
  private static final long serialVersionUID = 4404749202049979772L;
  
  /**
   * @deprecated
   */
  public PrcSjr() {}
  
  public PrcSjr(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public PrcSjr(Periode p_periode)
  {
    super(p_periode);
  }
  
  public PrcSjr(Periode p_periode, Chronologie p_chronoActiviteSalarie, Chronologie p_chronoPeriodesDeductibles)
  {
    super(p_periode);
    m_chronoActiviteSalarie = p_chronoActiviteSalarie;
    m_chronoPeriodesDeductibles = p_chronoPeriodesDeductibles;
  }
  
  public void jdoPreDelete()
  {
    super.jdoPreDelete();
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
  
  public ObjetMetierSpec copie()
  {
    PrcSjr copie = new PrcSjr();
    copieElements(copie);
    return copie;
  }
  
  protected JustificationSjr recupererJustificationSjr(Demande p_demande)
  {
    return ((DossierExamen)p_demande.getDossierExamen()).getConstitutionSjr().getJustificationSjr();
  }
  
  protected String donnerCodeAlerteNonBloquanteSurAbsenceSalaire()
  {
    return "A11MNB5";
  }
  
  protected void calculerNombreJourInappartenance(Demande p_demande)
  {
    Periode periodeReferenceCourante = new Periode(getDateDebut(), getDateFin());
    ChronologiePeriodes chronoPeriodesActivitesSpecifiqueInappartenance = (ChronologiePeriodes)ConstructionChronologie.determinerChronoActivitesPrcPourInappartenance(p_demande, periodeReferenceCourante);
    
    ChronologiePeriodes chronoPeriodesActivitesFusionnees = null;
    if ((chronoPeriodesActivitesSpecifiqueInappartenance != null) && (chronoPeriodesActivitesSpecifiqueInappartenance.contientChevauchementElements())) {
      chronoPeriodesActivitesFusionnees = chronoPeriodesActivitesSpecifiqueInappartenance.fusionnerChevauchementPeriodes();
    } else {
      chronoPeriodesActivitesFusionnees = chronoPeriodesActivitesSpecifiqueInappartenance;
    }
    ChronologiePeriodes chronoPeriodesInappartenance = OutillageChronologiePeriodes.donnerPeriodesComplementaires(chronoPeriodesActivitesFusionnees, periodeReferenceCourante);
    if ((chronoPeriodesInappartenance != null) && (chronoPeriodesInappartenance.getTaille() > 0))
    {
      super.setNombreJourInappartenance(inter(chronoPeriodesInappartenance));
      if (m_listeJustificationDiviseurPeriodesParticipantes != null)
      {
        JustificationDiviseurPeriodeParticipante justifDiviseurPeriodeParticipanteCourante = null;
        ObjetChronoPeriode objetChronoPeriodeInappartenanceCourant = null;
        Periode periodeInappartenanceCourante = null;
        ChronologiePeriodes chronoPeriodesChevauchantInappartenance = null;
        chronoPeriodesInappartenance.iterer();
        while (chronoPeriodesInappartenance.encoreSuivant())
        {
          objetChronoPeriodeInappartenanceCourant = (ObjetChronoPeriode)chronoPeriodesInappartenance.elementSuivant();
          periodeInappartenanceCourante = new Periode(objetChronoPeriodeInappartenanceCourant.getDateDebut(), objetChronoPeriodeInappartenanceCourant.getDateFin());
          
          justifDiviseurPeriodeParticipanteCourante = new JustificationDiviseurPeriodeParticipante(periodeInappartenanceCourante);
          justifDiviseurPeriodeParticipanteCourante.setNombreJoursInappartenance(periodeInappartenanceCourante.getDuree());
          
          chronoPeriodesChevauchantInappartenance = (ChronologiePeriodes)p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(new FiltreChevauchePeriode(periodeInappartenanceCourante));
          if (chronoPeriodesChevauchantInappartenance.estVide())
          {
            justifDiviseurPeriodeParticipanteCourante.setNature(10);
          }
          else
          {
            justifDiviseurPeriodeParticipanteCourante.renseignerNatureMultiplePeriode(chronoPeriodesChevauchantInappartenance);
            justifDiviseurPeriodeParticipanteCourante.completerNatureMultiplePeriodeInactivite(chronoPeriodesChevauchantInappartenance);
          }
          m_listeJustificationDiviseurPeriodesParticipantes.ajouter(justifDiviseurPeriodeParticipanteCourante);
        }
      }
    }
  }
}

/* Location:
 * Qualified Name:     PrcSjr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */