package fr.unedic.cali.asu.cge01.p02.liquidation.dom;

import fr.unedic.cali.asu.cge01.outilsfonctionnels.RevalorisationSalaire;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen.RepriseGen;
import fr.unedic.cali.asu.cge01.p02.liquidation.outilsfonctionnels.DeterminationSjrip;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.DecisionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.DossierExamenAssuranceSpec;
import fr.unedic.cali.asu.dom.ElementBaseActiviteReduite;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.JustificationAffiliationSpec;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.dom.Sjc;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.produits.liquidation.dom.JustificationAffiliation;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.dom.EvenementReferenceExamenSpec;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.MaintienEuropeen;
import fr.unedic.cali.dom.RepriseSpec;
import fr.unedic.cali.dom.SalaireJournalierSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.ProduitSecurisationProfessionnelleSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.dom.spec.ConventionGestionSpec;
import fr.unedic.cali.parcours.ResultatAvant;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;
import java.util.Collection;
import java.util.Iterator;

public class Reprise
  extends RepriseGen
  implements RepriseSpec
{
  private static final long serialVersionUID = -4503140086244100468L;
  public static final String CODE_FORMULE_MONTANT = "1";
  public static final String CODE_FORMULE_MONTANT_AREF = "2";
  
  public Reprise() {}
  
  public Reprise(DomPCSpec pc)
  {
    super(pc);
  }
  
  public Reprise(Damj dateEvenement, DossierExamenSpec dossierExamen)
  {
    super(dateEvenement);
    copie((DossierExamen)dossierExamen);
  }
  
  public Reprise(Damj dateEvenement)
  {
    super(dateEvenement);
  }
  
  public String getRsod()
  {
    String rsod = "0";
    if (getAttributionPrecedente() != null) {
      rsod = getAttributionPrecedente().getRsod();
    }
    return rsod;
  }
  
  public String getSituationParticuliere()
  {
    String situationParticuliere = "";
    if (getAttributionPrecedente() != null) {
      situationParticuliere = getAttributionPrecedente().getSituationParticuliere();
    }
    return situationParticuliere;
  }
  
  public String getRsrp()
  {
    return getReferenceExterne();
  }
  
  public ObjetMetierSpec copie()
  {
    Reprise copie = new Reprise();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec copieObjet)
  {
    Reprise copie = (Reprise)copieObjet;
    super.copieElements(copie);
  }
  
  public boolean isTopContratsRemuneresBaseSmic()
  {
    boolean estApprenti = false;
    if (getAttributionPrecedente() != null) {
      estApprenti = getAttributionPrecedente().isTopContratsRemuneresBaseSmic();
    }
    return estApprenti;
  }
  
  public JustificationAffiliationSpec getJustificationAffiliation()
  {
    if ((DossierExamenAssuranceSpec)((Demande)getDossierAffecte().getDemande()).getDossierAffectationAdmission().getDossierExamen() != null) {
      return ((DossierExamenAssuranceSpec)((Demande)getDossierAffecte().getDemande()).getDossierAffectationAdmission().getDossierExamen()).getJustificationAffiliation();
    }
    return new JustificationAffiliation();
  }
  
  public boolean estDroitSaisonnier()
  {
    if ((getNatureDecision() != 14) && (getConstitutionCaractereSaisonnier() != null))
    {
      int caractereSaisonnier = getConstitutionCaractereSaisonnier().getTypeCaractereSaisonnierRetenu();
      switch (caractereSaisonnier)
      {
      case 1: 
      case 2: 
        return true;
      }
      return false;
    }
    return false;
  }
  
  public ReglementApplicableSpec getConstitutionReglementApplicable()
  {
    ReglementApplicableSpec reglement = null;
    if (getAttributionPrecedente() != null) {
      reglement = getAttributionPrecedente().getReglementApplicable();
    }
    return reglement;
  }
  
  public ElementBaseIndemnisation getElementBaseIndemnisation()
  {
    if (getElementBaseIndemnisationPrive() == null)
    {
      ElementBaseIndemnisation ebiAttributionPrecedente = null;
      ebiAttributionPrecedente = getAttributionPrecedente().getElementBaseIndemnisation();
      
      setElementBaseIndemnisationPrive(new ElementBaseIndemnisation());
      ebiAttributionPrecedente.copieElements(getElementBaseIndemnisationPrive());
      if ((getDemande() != null) && (estDemandeEnContexteAreASP((Demande)getDemande()))) {
        getElementBaseIndemnisationPrive().setProduitAreActif(getProduit());
      } else if ((getProduit() instanceof ProduitSecurisationProfessionnelleSpec)) {
        getElementBaseIndemnisationPrive().setProduitAreActif(((ProduitSecurisationProfessionnelleSpec)getProduit()).recupererProduitAreActif(this));
      }
      Quantite dureePostPrime = getDureePostPrime();
      if ((dureePostPrime != null) && (dureePostPrime.getValeurEntiere() == 0)) {
        getElementBaseIndemnisationPrive().setEstDureePostPrimeEpuisee(true);
      }
    }
    return (ElementBaseIndemnisation)getElementBaseIndemnisationPrive().copie();
  }
  
  public ConstitutionSjr getConstitutionSjr()
  {
    ConstitutionSjr constitutionSjr = null;
    if (getAttributionPrecedente() != null)
    {
      ElementBaseIndemnisation ebiAttributionPrecedente = getElementBaseIndemnisation();
      
      constitutionSjr = new ConstitutionSjr();
      
      Reglement reglementApplicableCourant = ebiAttributionPrecedente.getReglementApplicableMontantRetenu().getReglement();
      
      Sjr sjrAServir = ebiAttributionPrecedente.getSjr();
      
      Sjrip sjrip = new Sjrip(sjrAServir.getDateDepart(), null, new QuantiteEuro(sjrAServir.getSalaire()));
      constitutionSjr.setSjrip(sjrip);
      
      int codeEmploiA2B = ebiAttributionPrecedente.getCodeEmploiA2B();
      constitutionSjr.setCodeEmploiA2b(codeEmploiA2B);
      if (sjrAServir != null)
      {
        Sjr sjr = null;
        if (reglementApplicableCourant.equals(getDossierAffecte().getProduit().getReglement("A2b"))) {
          sjr = new Sjr(sjrip.getSjrInitial().getValeur(), sjrip.getDateEffet(), sjrip.getContexteParticulierSjr());
        } else {
          sjr = DeterminationSjrip.revaloriserSjr(sjrip, getDateAttribution());
        }
        constitutionSjr.setSjrrp(sjr);
      }
    }
    return constitutionSjr;
  }
  
  public ConstitutionSjc getConstitutionSjc()
  {
    ConstitutionSjc constitutionSjc = null;
    if (getAttributionPrecedente() != null)
    {
      ElementBaseActiviteReduite ebacAttributionPrecedente = getElementBaseActiviteReduite();
      
      Sjc sjcAttributionPrecedente = ebacAttributionPrecedente.getSjc();
      if (sjcAttributionPrecedente != null)
      {
        Damj dateEffet = sjcAttributionPrecedente.getDateDepart();
        BigDecimal sjcInitial = sjcAttributionPrecedente.getSalaire();
        Sjcip sjcipCourant = new Sjcip(dateEffet, null, new QuantiteEuro(sjcInitial));
        Collection listeActivitesConservees = getElementBaseActiviteReduite().getListeSjrActiviteConservee();
        if (listeActivitesConservees != null)
        {
          Iterator itActiviteConservee = listeActivitesConservees.iterator();
          while (itActiviteConservee.hasNext()) {
            sjcipCourant.ajouterSjrActiviteConserve((SjrActiviteConservee)itActiviteConservee.next());
          }
        }
        Sjc sjcCourant = new Sjc(sjcipCourant.getSjcInitial().getValeur(), sjcipCourant.getDateEffet(), null);
        Sjc sjcrpCalcule = RevalorisationSalaire.revaloriserSjc(sjcCourant, getDateAttribution());
        constitutionSjc = new ConstitutionSjc();
        constitutionSjc.setSjcip(sjcipCourant);
        constitutionSjc.setSjcrp(sjcrpCalcule);
      }
    }
    return constitutionSjc;
  }
  
  public ConstitutionCoefficientSaisonnier getConstitutionCoefficientSaisonnier()
  {
    ConstitutionCoefficientSaisonnier constitutionCoefficient = null;
    if (getAttributionPrecedente() != null)
    {
      BigDecimal coefficient = getElementBaseIndemnisation().getCoefficientSaisonnier();
      if (coefficient != null)
      {
        constitutionCoefficient = new ConstitutionCoefficientSaisonnier();
        constitutionCoefficient.setCoefficientSaisonnierRetenu(coefficient);
      }
    }
    return constitutionCoefficient;
  }
  
  public ConstitutionCoefficientTempsPartiel getConstitutionCoefficientTempsPartiel()
  {
    ConstitutionCoefficientTempsPartiel constitutionCoefficient = null;
    if (getAttributionPrecedente() != null)
    {
      BigDecimal coefficient = getElementBaseIndemnisation().getCoefficientTempsPartiel();
      
      constitutionCoefficient = new ConstitutionCoefficientTempsPartiel();
      constitutionCoefficient.setCoefficientTempsPartielRetenu(coefficient);
    }
    return constitutionCoefficient;
  }
  
  public ConstitutionCaractereSaisonnier getConstitutionCaractereSaisonnier()
  {
    ConstitutionCaractereSaisonnier caractereSaisonnier = null;
    if (getAttributionPrecedente() != null)
    {
      caractereSaisonnier = new ConstitutionCaractereSaisonnier();
      ElementBaseIndemnisation elementBaseIndemnisation = getElementBaseIndemnisation();
      if ((elementBaseIndemnisation.getTypeCaractereSaisonnierRetenu() == 2) || (elementBaseIndemnisation.getTypeCaractereSaisonnierRetenu() == 1)) {
        caractereSaisonnier.setCaractereSaisonnierRetenu(true);
      }
      caractereSaisonnier.setTypeCaractereSaisonnierRetenu(elementBaseIndemnisation.getTypeCaractereSaisonnierRetenu());
      caractereSaisonnier.setActivite3Sur5(elementBaseIndemnisation.isConditionCaractereSaisonnierParRythme());
    }
    return caractereSaisonnier;
  }
  
  public int getCodeEmploiA2B()
  {
    int codeEmploiA2B = -1;
    if (getConstitutionSjr() != null) {
      codeEmploiA2B = getConstitutionSjr().getCodeEmploiA2b();
    }
    return codeEmploiA2B;
  }
  
  public ElementBaseActiviteReduite getElementBaseActiviteReduite()
  {
    return getAttributionPrecedente().getElementBaseActiviteReduite();
  }
  
  public AttributionSpec getAttributionMaitre()
  {
    if (getAttributionPrecedente() != null) {
      return getAttributionPrecedente().getAttributionMaitre();
    }
    return null;
  }
  
  public AttributionAssuranceSpec getAttributionOrigine()
  {
    if (getAttributionPrecedente() != null) {
      return getAttributionPrecedente().getAttributionOrigine();
    }
    return null;
  }
  
  public boolean isInvestigationFraude()
  {
    if (getAttributionPrecedente() == null) {
      return false;
    }
    return getAttributionPrecedente().isInvestigationFraude();
  }
  
  public ProduitAsuSpec getProduitMontantRetenu()
  {
    return getAttributionPrecedente().getProduitMontantRetenu();
  }
  
  public FormuleMontantSpec getFormuleMontant(String code)
  {
    Demande demandePrecedente = (Demande)getAttributionPrecedente().getDemande();
    if ((estDemandeEnContexteAreASP((Demande)getDemande())) || ((estDemandeEnContexteAreASP(demandePrecedente)) && (!estDemandeEnContexteAreASP((Demande)getDemande())))) {
      return super.getFormuleMontant(code);
    }
    return getAttributionPrecedente().getFormuleMontant(code);
  }
  
  private boolean estDemandeEnContexteAreASP(Demande demande)
  {
    return (OutilGestionContexteDemande.estContexteDemandeAssurancePresent(demande, "AREENTRCSP")) || (OutilGestionContexteDemande.estContexteDemandeAssurancePresent(demande, "ARECOURCSP"));
  }
  
  public Damj getDateFaitGenerateurDroit()
  {
    return getAttributionPrecedente().getDateFaitGenerateurDroit();
  }
  
  public MaintienEuropeen getMaintienEuropeen()
  {
    if ((getMaintienEuropenPrive() == null) && (getAttributionPrecedente() != null)) {
      if (getAttributionPrecedente().getMaintienEuropeen() == null) {
        setMaintienEuropeenPrive(MaintienEuropeen.getInstanceMaintienEuropeen(this));
      } else {
        setMaintienEuropeenPrive(getAttributionPrecedente().getMaintienEuropeen());
      }
    }
    return getMaintienEuropenPrive();
  }
  
  public boolean estMaintenue()
  {
    if (getOuvertureDroit().getNatureDecision() == 38) {
      return ((fr.unedic.cali.asu.dom.OdAssuranceSpec)getOuvertureDroit()).estMaintenue();
    }
    return super.estMaintenue();
  }
  
  public int getTypeMontantRetenu()
  {
    return getAttributionPrecedente().getTypeMontantRetenu();
  }
  
  public int getTypeCapitalRetenu()
  {
    return getAttributionPrecedente().getTypeMontantRetenu();
  }
  
  public fr.unedic.cali.dom.OdAssuranceSpec getOuvertureDroit()
  {
    fr.unedic.cali.dom.OdAssuranceSpec ouvertureDeDroit = null;
    AttributionAssuranceSpec attributionPrecedente = getAttributionPrecedente();
    if (attributionPrecedente == null) {
      attributionPrecedente = getDemandeAssurance().rechercherAttributionPrecedenteDuMemeType();
    }
    if (attributionPrecedente != null) {
      ouvertureDeDroit = attributionPrecedente.getOuvertureDroit();
    }
    return ouvertureDeDroit;
  }
  
  public fr.unedic.cali.asu.dom.OdAssuranceSpec getOuvertureDroitCapitalRetenu()
  {
    fr.unedic.cali.asu.dom.OdAssuranceSpec ouvertureDeDroit = null;
    AttributionAssuranceSpec attributionPrecedente = getAttributionPrecedente();
    if (attributionPrecedente == null) {
      attributionPrecedente = getDemandeAssurance().rechercherOuvertureDroitPrecedenteDuMemeType();
    }
    if (attributionPrecedente != null) {
      ouvertureDeDroit = attributionPrecedente.getOuvertureDroitCapitalRetenu();
    }
    return ouvertureDeDroit;
  }
  
  public boolean estDemandeSuiteFinDeDroit()
  {
    return (getAttributionPrecedente() != null) && (getAttributionPrecedente().estDemandeSuiteFinDeDroit());
  }
  
  public ConventionGestionSpec getConventionGestion()
  {
    if ("ASU_23".equals(getAttributionOrigine().getDemande().getEvenementReferenceExamen().getTypeExamen())) {
      return getAttributionOrigine().getConventionGestion();
    }
    return super.getConventionGestion();
  }
  
  public SalaireJournalierSpec getSalaireJournalierInitial()
  {
    if (getAttributionPrecedente() != null) {
      return getAttributionPrecedente().getSalaireJournalierInitial();
    }
    return null;
  }
  
  public SalaireJournalierSpec getSalaireJournalierConserve()
  {
    if (getAttributionPrecedente() != null) {
      return getAttributionPrecedente().getSalaireJournalierConserve();
    }
    return null;
  }
  
  public Boolean estAvecPrecompteCRC()
  {
    if (getAttributionPrecedente() != null) {
      return getAttributionPrecedente().estAvecPrecompteCRC();
    }
    return null;
  }
  
  public BigDecimal getCoefficientSaisonnier()
  {
    if (getAttributionPrecedente() != null) {
      return getAttributionPrecedente().getCoefficientSaisonnier();
    }
    return null;
  }
  
  public int getNatureCoefficientSaisonnier()
  {
    if (getAttributionPrecedente() != null) {
      return getAttributionPrecedente().getNatureCoefficientSaisonnier();
    }
    return -1;
  }
  
  public boolean a3ansActiviteEn5ans()
  {
    if (getAttributionPrecedente() != null) {
      return getAttributionPrecedente().a3ansActiviteEn5ans();
    }
    return false;
  }
  
  public BigDecimal getCoefficientTempsPartiel()
  {
    if (getAttributionPrecedente() != null) {
      return getAttributionPrecedente().getCoefficientTempsPartiel();
    }
    return null;
  }
  
  public boolean estSjrBaseSmic()
  {
    if (getAttributionPrecedente() != null) {
      return getAttributionPrecedente().estSjrBaseSmic();
    }
    return false;
  }
  
  public int getCategorieEmploiA2B()
  {
    if (getAttributionPrecedente() != null) {
      return getAttributionPrecedente().getCategorieEmploiA2B();
    }
    return 0;
  }
  
  public ReglementApplicableSpec getReglementApplicableMontantRetenu()
  {
    if (getAttributionPrecedente() != null) {
      return getAttributionPrecedente().getReglementApplicableMontantRetenu();
    }
    return null;
  }
  
  public ResultatAvant determinationEtatACT()
    throws CoucheLogiqueException
  {
    return null;
  }
  
  public Damj getDateDebutDelaiDecheance()
  {
    if (getAttributionPrecedente() != null) {
      return getAttributionPrecedente().getDateDebutDelaiDecheance();
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     Reprise
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */