package fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc.CompetencePC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public abstract class CompetenceGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_competencePC;
  private String m_libelleEmployeurCompetent;
  private String m_numeroConventionGestion;
  
  public CompetenceGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public CompetenceGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new CompetencePC();
  }
  
  public DomPCSpec getPC()
  {
    return m_competencePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_competencePC)
  {
    m_competencePC = p_competencePC;
  }
  
  protected int rawGetDureeActiviteSecteurPrive()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPrive();
  }
  
  public int getDureeActiviteSecteurPrive()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPrive();
  }
  
  public void setDureeActiviteSecteurPrive(int p_dureeActiviteSecteurPrive)
  {
    ((CompetencePC)getPC()).setDureeActiviteSecteurPrive(p_dureeActiviteSecteurPrive);
  }
  
  protected int rawGetDureeActiviteSecteurPriveCaCae()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPriveCaCae();
  }
  
  public int getDureeActiviteSecteurPriveCaCae()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPriveCaCae();
  }
  
  public void setDureeActiviteSecteurPriveCaCae(int p_dureeActiviteSecteurPriveCaCae)
  {
    ((CompetencePC)getPC()).setDureeActiviteSecteurPriveCaCae(p_dureeActiviteSecteurPriveCaCae);
  }
  
  protected int rawGetDureeActiviteSecteurPublicAffilie()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPublicAffilie();
  }
  
  public int getDureeActiviteSecteurPublicAffilie()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPublicAffilie();
  }
  
  public void setDureeActiviteSecteurPublicAffilie(int p_dureeActiviteSecteurPublicAffilie)
  {
    ((CompetencePC)getPC()).setDureeActiviteSecteurPublicAffilie(p_dureeActiviteSecteurPublicAffilie);
  }
  
  protected int rawGetDureeActiviteSecteurPublicAutoAssurance()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPublicAutoAssurance();
  }
  
  public int getDureeActiviteSecteurPublicAutoAssurance()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPublicAutoAssurance();
  }
  
  public void setDureeActiviteSecteurPublicAutoAssurance(int p_dureeActiviteSecteurPublicAutoAssurance)
  {
    ((CompetencePC)getPC()).setDureeActiviteSecteurPublicAutoAssurance(p_dureeActiviteSecteurPublicAutoAssurance);
  }
  
  protected int rawGetDureeActiviteSecteurPublicConventionGestion()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPublicConventionGestion();
  }
  
  public int getDureeActiviteSecteurPublicConventionGestion()
  {
    return ((CompetencePC)getPC()).getDureeActiviteSecteurPublicConventionGestion();
  }
  
  public void setDureeActiviteSecteurPublicConventionGestion(int p_dureeActiviteSecteurPublicConventionGestion)
  {
    ((CompetencePC)getPC()).setDureeActiviteSecteurPublicConventionGestion(p_dureeActiviteSecteurPublicConventionGestion);
  }
  
  protected int rawGetCompetenceAdministrative()
  {
    return ((CompetencePC)getPC()).getCompetenceAdministrative();
  }
  
  public int getCompetenceAdministrative()
  {
    return ((CompetencePC)getPC()).getCompetenceAdministrative();
  }
  
  public void setCompetenceAdministrative(int p_competenceAdministrative)
  {
    ((CompetencePC)getPC()).setCompetenceAdministrative(p_competenceAdministrative);
  }
  
  protected int rawGetCompetenceFinanciere()
  {
    return ((CompetencePC)getPC()).getCompetenceFinanciere();
  }
  
  public int getCompetenceFinanciere()
  {
    return ((CompetencePC)getPC()).getCompetenceFinanciere();
  }
  
  public void setCompetenceFinanciere(int p_competenceFinanciere)
  {
    ((CompetencePC)getPC()).setCompetenceFinanciere(p_competenceFinanciere);
  }
  
  protected String rawGetLibelleEmployeurCompetent()
  {
    return ((CompetencePC)getPC()).getLibelleEmployeurCompetent();
  }
  
  public String getLibelleEmployeurCompetent()
  {
    return ((CompetencePC)getPC()).getLibelleEmployeurCompetent();
  }
  
  public void setLibelleEmployeurCompetent(String p_libelleEmployeurCompetent)
  {
    if ((m_libelleEmployeurCompetent == null) || (p_libelleEmployeurCompetent == null))
    {
      m_libelleEmployeurCompetent = p_libelleEmployeurCompetent;
      ((CompetencePC)getPC()).setLibelleEmployeurCompetent(p_libelleEmployeurCompetent);
    }
    else if ((m_libelleEmployeurCompetent != null) && (p_libelleEmployeurCompetent != null) && (!p_libelleEmployeurCompetent.equals(m_libelleEmployeurCompetent)))
    {
      m_libelleEmployeurCompetent = p_libelleEmployeurCompetent;
      ((CompetencePC)getPC()).setLibelleEmployeurCompetent(p_libelleEmployeurCompetent);
    }
  }
  
  protected String rawGetNumeroConventionGestion()
  {
    return ((CompetencePC)getPC()).getNumeroConventionGestion();
  }
  
  public String getNumeroConventionGestion()
  {
    return ((CompetencePC)getPC()).getNumeroConventionGestion();
  }
  
  public void setNumeroConventionGestion(String p_numeroConventionGestion)
  {
    if ((m_numeroConventionGestion == null) || (p_numeroConventionGestion == null))
    {
      m_numeroConventionGestion = p_numeroConventionGestion;
      ((CompetencePC)getPC()).setNumeroConventionGestion(p_numeroConventionGestion);
    }
    else if ((m_numeroConventionGestion != null) && (p_numeroConventionGestion != null) && (!p_numeroConventionGestion.equals(m_numeroConventionGestion)))
    {
      m_numeroConventionGestion = p_numeroConventionGestion;
      ((CompetencePC)getPC()).setNumeroConventionGestion(p_numeroConventionGestion);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     CompetenceGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */