package fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc.ConditionActiviteConserveePC;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import java.math.BigDecimal;

public abstract class ConditionActiviteConserveeGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_conditionActiviteConserveePC;
  private ResultatElementDroit m_resultatElementDroit;
  private BigDecimal m_nombreHeuresMensuelActiviteConservee = new BigDecimal("0");
  private BigDecimal m_montantMensuelActiviteConservee = new BigDecimal("0");
  private BigDecimal m_seuilMontantMensuelActiviteConservee = new BigDecimal("0");
  
  public ConditionActiviteConserveeGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConditionActiviteConserveeGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ConditionActiviteConserveePC();
  }
  
  public DomPCSpec getPC()
  {
    return m_conditionActiviteConserveePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_conditionActiviteConserveePC)
  {
    m_conditionActiviteConserveePC = p_conditionActiviteConserveePC;
  }
  
  protected int rawGetSituationConditionActiviteConservee()
  {
    return ((ConditionActiviteConserveePC)getPC()).getSituationConditionActiviteConservee();
  }
  
  public int getSituationConditionActiviteConservee()
  {
    return ((ConditionActiviteConserveePC)getPC()).getSituationConditionActiviteConservee();
  }
  
  public void setSituationConditionActiviteConservee(int p_situationConditionActiviteConservee)
  {
    ((ConditionActiviteConserveePC)getPC()).setSituationConditionActiviteConservee(p_situationConditionActiviteConservee);
  }
  
  public ResultatElementDroit getResultatElementDroit()
  {
    if (m_resultatElementDroit == null)
    {
      DomPCSpec resultatElementDroitPC = ((ConditionActiviteConserveePC)getPC()).getResultatElementDroit();
      if (resultatElementDroitPC != null) {
        m_resultatElementDroit = ((ResultatElementDroit)resultatElementDroitPC.createOM());
      }
    }
    return m_resultatElementDroit;
  }
  
  public void setResultatElementDroit(ResultatElementDroit p_resultatElementDroit)
  {
    if (p_resultatElementDroit == null)
    {
      ((ConditionActiviteConserveePC)getPC()).setResultatElementDroit(null);
      m_resultatElementDroit = p_resultatElementDroit;
    }
    else if (!p_resultatElementDroit.equals(m_resultatElementDroit))
    {
      ((ConditionActiviteConserveePC)getPC()).setResultatElementDroit(p_resultatElementDroit.getPC());
      m_resultatElementDroit = p_resultatElementDroit;
    }
  }
  
  protected BigDecimal rawGetNombreHeuresMensuelActiviteConservee()
  {
    return ((ConditionActiviteConserveePC)getPC()).getNombreHeuresMensuelActiviteConservee();
  }
  
  public BigDecimal getNombreHeuresMensuelActiviteConservee()
  {
    return ((ConditionActiviteConserveePC)getPC()).getNombreHeuresMensuelActiviteConservee();
  }
  
  public void setNombreHeuresMensuelActiviteConservee(BigDecimal p_nombreHeuresMensuelActiviteConservee)
  {
    if ((m_nombreHeuresMensuelActiviteConservee == null) || (p_nombreHeuresMensuelActiviteConservee == null))
    {
      m_nombreHeuresMensuelActiviteConservee = p_nombreHeuresMensuelActiviteConservee;
      ((ConditionActiviteConserveePC)getPC()).setNombreHeuresMensuelActiviteConservee(p_nombreHeuresMensuelActiviteConservee);
    }
    else if ((m_nombreHeuresMensuelActiviteConservee != null) && (p_nombreHeuresMensuelActiviteConservee != null) && (!p_nombreHeuresMensuelActiviteConservee.equals(m_nombreHeuresMensuelActiviteConservee)))
    {
      m_nombreHeuresMensuelActiviteConservee = p_nombreHeuresMensuelActiviteConservee;
      ((ConditionActiviteConserveePC)getPC()).setNombreHeuresMensuelActiviteConservee(p_nombreHeuresMensuelActiviteConservee);
    }
  }
  
  protected BigDecimal rawGetMontantMensuelActiviteConservee()
  {
    return ((ConditionActiviteConserveePC)getPC()).getMontantMensuelActiviteConservee();
  }
  
  public BigDecimal getMontantMensuelActiviteConservee()
  {
    return ((ConditionActiviteConserveePC)getPC()).getMontantMensuelActiviteConservee();
  }
  
  public void setMontantMensuelActiviteConservee(BigDecimal p_montantMensuelActiviteConservee)
  {
    if ((m_montantMensuelActiviteConservee == null) || (p_montantMensuelActiviteConservee == null))
    {
      m_montantMensuelActiviteConservee = p_montantMensuelActiviteConservee;
      ((ConditionActiviteConserveePC)getPC()).setMontantMensuelActiviteConservee(p_montantMensuelActiviteConservee);
    }
    else if ((m_montantMensuelActiviteConservee != null) && (p_montantMensuelActiviteConservee != null) && (!p_montantMensuelActiviteConservee.equals(m_montantMensuelActiviteConservee)))
    {
      m_montantMensuelActiviteConservee = p_montantMensuelActiviteConservee;
      ((ConditionActiviteConserveePC)getPC()).setMontantMensuelActiviteConservee(p_montantMensuelActiviteConservee);
    }
  }
  
  protected BigDecimal rawGetSeuilMontantMensuelActiviteConservee()
  {
    return ((ConditionActiviteConserveePC)getPC()).getSeuilMontantMensuelActiviteConservee();
  }
  
  public BigDecimal getSeuilMontantMensuelActiviteConservee()
  {
    return ((ConditionActiviteConserveePC)getPC()).getSeuilMontantMensuelActiviteConservee();
  }
  
  public void setSeuilMontantMensuelActiviteConservee(BigDecimal p_seuilMontantMensuelActiviteConservee)
  {
    if ((m_seuilMontantMensuelActiviteConservee == null) || (p_seuilMontantMensuelActiviteConservee == null))
    {
      m_seuilMontantMensuelActiviteConservee = p_seuilMontantMensuelActiviteConservee;
      ((ConditionActiviteConserveePC)getPC()).setSeuilMontantMensuelActiviteConservee(p_seuilMontantMensuelActiviteConservee);
    }
    else if ((m_seuilMontantMensuelActiviteConservee != null) && (p_seuilMontantMensuelActiviteConservee != null) && (!p_seuilMontantMensuelActiviteConservee.equals(m_seuilMontantMensuelActiviteConservee)))
    {
      m_seuilMontantMensuelActiviteConservee = p_seuilMontantMensuelActiviteConservee;
      ((ConditionActiviteConserveePC)getPC()).setSeuilMontantMensuelActiviteConservee(p_seuilMontantMensuelActiviteConservee);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    Object resultatElementDroit = getResultatElementDroit();
    if ((resultatElementDroit != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(resultatElementDroit))) {
      DomManager.supprimer(getResultatElementDroit(), p_contexteSuppression);
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConditionActiviteConserveeGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */