package fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionAge;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionChomageInvolontaire;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionCumulPrestationFamiliale;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionMontantNonNul;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionRechercheEmploi;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionValiditeReliquat;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc.ConditionsAttributionReprisePC;
import fr.unedic.cali.dom.ConditionsAttributionAbstrait;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public abstract class ConditionsAttributionRepriseGen
  extends ConditionsAttributionAbstrait
  implements DomGenSpec
{
  protected transient DomPCSpec m_conditionsAttributionReprisePC;
  private ConditionRechercheEmploi m_conditionRechercheEmploi;
  private ConditionAge m_conditionAge;
  private ConditionChomageInvolontaire m_conditionChomageInvolontaire;
  private ConditionCumulPrestationFamiliale m_conditionCumulPrestationFamiliale;
  private ConditionMontantNonNul m_conditionMontantNonNul;
  private ConditionValiditeReliquat m_conditionValiditeReliquat;
  
  public ConditionsAttributionRepriseGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConditionsAttributionRepriseGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ConditionsAttributionReprisePC();
  }
  
  public DomPCSpec getPC()
  {
    return m_conditionsAttributionReprisePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_conditionsAttributionReprisePC)
  {
    m_conditionsAttributionReprisePC = p_conditionsAttributionReprisePC;
  }
  
  public ConditionRechercheEmploi getConditionRechercheEmploi()
  {
    if (m_conditionRechercheEmploi == null)
    {
      DomPCSpec conditionRechercheEmploiPC = ((ConditionsAttributionReprisePC)getPC()).getConditionRechercheEmploi();
      if (conditionRechercheEmploiPC != null) {
        m_conditionRechercheEmploi = ((ConditionRechercheEmploi)conditionRechercheEmploiPC.createOM());
      }
    }
    return m_conditionRechercheEmploi;
  }
  
  public void setConditionRechercheEmploi(ConditionRechercheEmploi p_conditionRechercheEmploi)
  {
    if (p_conditionRechercheEmploi == null)
    {
      ((ConditionsAttributionReprisePC)getPC()).setConditionRechercheEmploi(null);
      m_conditionRechercheEmploi = p_conditionRechercheEmploi;
    }
    else if (!p_conditionRechercheEmploi.equals(m_conditionRechercheEmploi))
    {
      ((ConditionsAttributionReprisePC)getPC()).setConditionRechercheEmploi(p_conditionRechercheEmploi.getPC());
      m_conditionRechercheEmploi = p_conditionRechercheEmploi;
    }
  }
  
  public ConditionAge getConditionAge()
  {
    if (m_conditionAge == null)
    {
      DomPCSpec conditionAgePC = ((ConditionsAttributionReprisePC)getPC()).getConditionAge();
      if (conditionAgePC != null) {
        m_conditionAge = ((ConditionAge)conditionAgePC.createOM());
      }
    }
    return m_conditionAge;
  }
  
  public void setConditionAge(ConditionAge p_conditionAge)
  {
    if (p_conditionAge == null)
    {
      ((ConditionsAttributionReprisePC)getPC()).setConditionAge(null);
      m_conditionAge = p_conditionAge;
    }
    else if (!p_conditionAge.equals(m_conditionAge))
    {
      ((ConditionsAttributionReprisePC)getPC()).setConditionAge(p_conditionAge.getPC());
      m_conditionAge = p_conditionAge;
    }
  }
  
  public ConditionChomageInvolontaire getConditionChomageInvolontaire()
  {
    if (m_conditionChomageInvolontaire == null)
    {
      DomPCSpec conditionChomageInvolontairePC = ((ConditionsAttributionReprisePC)getPC()).getConditionChomageInvolontaire();
      if (conditionChomageInvolontairePC != null) {
        m_conditionChomageInvolontaire = ((ConditionChomageInvolontaire)conditionChomageInvolontairePC.createOM());
      }
    }
    return m_conditionChomageInvolontaire;
  }
  
  public void setConditionChomageInvolontaire(ConditionChomageInvolontaire p_conditionChomageInvolontaire)
  {
    if (p_conditionChomageInvolontaire == null)
    {
      ((ConditionsAttributionReprisePC)getPC()).setConditionChomageInvolontaire(null);
      m_conditionChomageInvolontaire = p_conditionChomageInvolontaire;
    }
    else if (!p_conditionChomageInvolontaire.equals(m_conditionChomageInvolontaire))
    {
      ((ConditionsAttributionReprisePC)getPC()).setConditionChomageInvolontaire(p_conditionChomageInvolontaire.getPC());
      m_conditionChomageInvolontaire = p_conditionChomageInvolontaire;
    }
  }
  
  public ConditionCumulPrestationFamiliale getConditionCumulPrestationFamiliale()
  {
    if (m_conditionCumulPrestationFamiliale == null)
    {
      DomPCSpec conditionCumulPrestationFamilialePC = ((ConditionsAttributionReprisePC)getPC()).getConditionCumulPrestationFamiliale();
      if (conditionCumulPrestationFamilialePC != null) {
        m_conditionCumulPrestationFamiliale = ((ConditionCumulPrestationFamiliale)conditionCumulPrestationFamilialePC.createOM());
      }
    }
    return m_conditionCumulPrestationFamiliale;
  }
  
  public void setConditionCumulPrestationFamiliale(ConditionCumulPrestationFamiliale p_conditionCumulPrestationFamiliale)
  {
    if (p_conditionCumulPrestationFamiliale == null)
    {
      ((ConditionsAttributionReprisePC)getPC()).setConditionCumulPrestationFamiliale(null);
      m_conditionCumulPrestationFamiliale = p_conditionCumulPrestationFamiliale;
    }
    else if (!p_conditionCumulPrestationFamiliale.equals(m_conditionCumulPrestationFamiliale))
    {
      ((ConditionsAttributionReprisePC)getPC()).setConditionCumulPrestationFamiliale(p_conditionCumulPrestationFamiliale.getPC());
      m_conditionCumulPrestationFamiliale = p_conditionCumulPrestationFamiliale;
    }
  }
  
  public ConditionMontantNonNul getConditionMontantNonNul()
  {
    if (m_conditionMontantNonNul == null)
    {
      DomPCSpec conditionMontantNonNulPC = ((ConditionsAttributionReprisePC)getPC()).getConditionMontantNonNul();
      if (conditionMontantNonNulPC != null) {
        m_conditionMontantNonNul = ((ConditionMontantNonNul)conditionMontantNonNulPC.createOM());
      }
    }
    return m_conditionMontantNonNul;
  }
  
  public void setConditionMontantNonNul(ConditionMontantNonNul p_conditionMontantNonNul)
  {
    if (p_conditionMontantNonNul == null)
    {
      ((ConditionsAttributionReprisePC)getPC()).setConditionMontantNonNul(null);
      m_conditionMontantNonNul = p_conditionMontantNonNul;
    }
    else if (!p_conditionMontantNonNul.equals(m_conditionMontantNonNul))
    {
      ((ConditionsAttributionReprisePC)getPC()).setConditionMontantNonNul(p_conditionMontantNonNul.getPC());
      m_conditionMontantNonNul = p_conditionMontantNonNul;
    }
  }
  
  public ConditionValiditeReliquat getConditionValiditeReliquat()
  {
    if (m_conditionValiditeReliquat == null)
    {
      DomPCSpec conditionValiditeReliquatPC = ((ConditionsAttributionReprisePC)getPC()).getConditionValiditeReliquat();
      if (conditionValiditeReliquatPC != null) {
        m_conditionValiditeReliquat = ((ConditionValiditeReliquat)conditionValiditeReliquatPC.createOM());
      }
    }
    return m_conditionValiditeReliquat;
  }
  
  public void setConditionValiditeReliquat(ConditionValiditeReliquat p_conditionValiditeReliquat)
  {
    if (p_conditionValiditeReliquat == null)
    {
      ((ConditionsAttributionReprisePC)getPC()).setConditionValiditeReliquat(null);
      m_conditionValiditeReliquat = p_conditionValiditeReliquat;
    }
    else if (!p_conditionValiditeReliquat.equals(m_conditionValiditeReliquat))
    {
      ((ConditionsAttributionReprisePC)getPC()).setConditionValiditeReliquat(p_conditionValiditeReliquat.getPC());
      m_conditionValiditeReliquat = p_conditionValiditeReliquat;
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    Object conditionRechercheEmploi = getConditionRechercheEmploi();
    if ((conditionRechercheEmploi != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(conditionRechercheEmploi))) {
      DomManager.supprimer(getConditionRechercheEmploi(), p_contexteSuppression);
    }
    Object conditionAge = getConditionAge();
    if ((conditionAge != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(conditionAge))) {
      DomManager.supprimer(getConditionAge(), p_contexteSuppression);
    }
    Object conditionChomageInvolontaire = getConditionChomageInvolontaire();
    if ((conditionChomageInvolontaire != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(conditionChomageInvolontaire))) {
      DomManager.supprimer(getConditionChomageInvolontaire(), p_contexteSuppression);
    }
    Object conditionCumulPrestationFamiliale = getConditionCumulPrestationFamiliale();
    if ((conditionCumulPrestationFamiliale != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(conditionCumulPrestationFamiliale))) {
      DomManager.supprimer(getConditionCumulPrestationFamiliale(), p_contexteSuppression);
    }
    Object conditionMontantNonNul = getConditionMontantNonNul();
    if ((conditionMontantNonNul != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(conditionMontantNonNul))) {
      DomManager.supprimer(getConditionMontantNonNul(), p_contexteSuppression);
    }
    Object conditionValiditeReliquat = getConditionValiditeReliquat();
    if ((conditionValiditeReliquat != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(conditionValiditeReliquat))) {
      DomManager.supprimer(getConditionValiditeReliquat(), p_contexteSuppression);
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConditionsAttributionRepriseGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */