package fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc.ConstitutionMontantsBrutsPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import java.math.BigDecimal;

public abstract class ConstitutionMontantsBrutsGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionMontantsBrutsPC;
  private Quantite m_crc = null;
  private Quantite m_montantJournalierBrut;
  private Quantite m_capitalInitialBrut;
  private Quantite m_montantMini;
  private Quantite m_montantPlancher;
  private Quantite m_montantPlafond;
  private Quantite m_montantBase;
  private Quantite m_pensionInvaliditeADeduirePriseEnCompte;
  private Quantite m_montantBrutSansPensionInvaliditeADeduire;
  private Quantite m_montantJournalierAvantageVieillesse;
  private Quantite m_montantJournalierAvantageVieillesseDeduit;
  private BigDecimal m_sjrMontantMaxAsp;
  
  public ConstitutionMontantsBrutsGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConstitutionMontantsBrutsGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ConstitutionMontantsBrutsPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_constitutionMontantsBrutsPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionMontantsBrutsPC)
  {
    m_constitutionMontantsBrutsPC = p_constitutionMontantsBrutsPC;
  }
  
  protected Quantite rawGetCrc()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getCrc();
  }
  
  public Quantite getCrc()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getCrc();
  }
  
  public void setCrc(Quantite p_crc)
  {
    if ((m_crc == null) || (p_crc == null))
    {
      m_crc = p_crc;
      ((ConstitutionMontantsBrutsPC)getPC()).setCrc(p_crc);
    }
    else if ((m_crc != null) && (p_crc != null) && (!p_crc.equals(m_crc)))
    {
      m_crc = p_crc;
      ((ConstitutionMontantsBrutsPC)getPC()).setCrc(p_crc);
    }
  }
  
  protected Quantite rawGetMontantJournalierBrut()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getMontantJournalierBrut();
  }
  
  public Quantite getMontantJournalierBrut()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getMontantJournalierBrut();
  }
  
  public void setMontantJournalierBrut(Quantite p_montantJournalierBrut)
  {
    if ((m_montantJournalierBrut == null) || (p_montantJournalierBrut == null))
    {
      m_montantJournalierBrut = p_montantJournalierBrut;
      ((ConstitutionMontantsBrutsPC)getPC()).setMontantJournalierBrut(p_montantJournalierBrut);
    }
    else if ((m_montantJournalierBrut != null) && (p_montantJournalierBrut != null) && (!p_montantJournalierBrut.equals(m_montantJournalierBrut)))
    {
      m_montantJournalierBrut = p_montantJournalierBrut;
      ((ConstitutionMontantsBrutsPC)getPC()).setMontantJournalierBrut(p_montantJournalierBrut);
    }
  }
  
  protected Quantite rawGetCapitalInitialBrut()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getCapitalInitialBrut();
  }
  
  public Quantite getCapitalInitialBrut()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getCapitalInitialBrut();
  }
  
  public void setCapitalInitialBrut(Quantite p_capitalInitialBrut)
  {
    if ((m_capitalInitialBrut == null) || (p_capitalInitialBrut == null))
    {
      m_capitalInitialBrut = p_capitalInitialBrut;
      ((ConstitutionMontantsBrutsPC)getPC()).setCapitalInitialBrut(p_capitalInitialBrut);
    }
    else if ((m_capitalInitialBrut != null) && (p_capitalInitialBrut != null) && (!p_capitalInitialBrut.equals(m_capitalInitialBrut)))
    {
      m_capitalInitialBrut = p_capitalInitialBrut;
      ((ConstitutionMontantsBrutsPC)getPC()).setCapitalInitialBrut(p_capitalInitialBrut);
    }
  }
  
  protected Quantite rawGetMontantMini()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getMontantMini();
  }
  
  public Quantite getMontantMini()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getMontantMini();
  }
  
  public void setMontantMini(Quantite p_montantMini)
  {
    if ((m_montantMini == null) || (p_montantMini == null))
    {
      m_montantMini = p_montantMini;
      ((ConstitutionMontantsBrutsPC)getPC()).setMontantMini(p_montantMini);
    }
    else if ((m_montantMini != null) && (p_montantMini != null) && (!p_montantMini.equals(m_montantMini)))
    {
      m_montantMini = p_montantMini;
      ((ConstitutionMontantsBrutsPC)getPC()).setMontantMini(p_montantMini);
    }
  }
  
  protected Quantite rawGetMontantPlancher()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getMontantPlancher();
  }
  
  public Quantite getMontantPlancher()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getMontantPlancher();
  }
  
  public void setMontantPlancher(Quantite p_montantPlancher)
  {
    if ((m_montantPlancher == null) || (p_montantPlancher == null))
    {
      m_montantPlancher = p_montantPlancher;
      ((ConstitutionMontantsBrutsPC)getPC()).setMontantPlancher(p_montantPlancher);
    }
    else if ((m_montantPlancher != null) && (p_montantPlancher != null) && (!p_montantPlancher.equals(m_montantPlancher)))
    {
      m_montantPlancher = p_montantPlancher;
      ((ConstitutionMontantsBrutsPC)getPC()).setMontantPlancher(p_montantPlancher);
    }
  }
  
  protected Quantite rawGetMontantPlafond()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getMontantPlafond();
  }
  
  public Quantite getMontantPlafond()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getMontantPlafond();
  }
  
  public void setMontantPlafond(Quantite p_montantPlafond)
  {
    if ((m_montantPlafond == null) || (p_montantPlafond == null))
    {
      m_montantPlafond = p_montantPlafond;
      ((ConstitutionMontantsBrutsPC)getPC()).setMontantPlafond(p_montantPlafond);
    }
    else if ((m_montantPlafond != null) && (p_montantPlafond != null) && (!p_montantPlafond.equals(m_montantPlafond)))
    {
      m_montantPlafond = p_montantPlafond;
      ((ConstitutionMontantsBrutsPC)getPC()).setMontantPlafond(p_montantPlafond);
    }
  }
  
  protected Quantite rawGetMontantBase()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getMontantBase();
  }
  
  public Quantite getMontantBase()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getMontantBase();
  }
  
  public void setMontantBase(Quantite p_montantBase)
  {
    if ((m_montantBase == null) || (p_montantBase == null))
    {
      m_montantBase = p_montantBase;
      ((ConstitutionMontantsBrutsPC)getPC()).setMontantBase(p_montantBase);
    }
    else if ((m_montantBase != null) && (p_montantBase != null) && (!p_montantBase.equals(m_montantBase)))
    {
      m_montantBase = p_montantBase;
      ((ConstitutionMontantsBrutsPC)getPC()).setMontantBase(p_montantBase);
    }
  }
  
  protected Quantite rawGetPensionInvaliditeADeduirePriseEnCompte()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getPensionInvaliditeADeduirePriseEnCompte();
  }
  
  public Quantite getPensionInvaliditeADeduirePriseEnCompte()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getPensionInvaliditeADeduirePriseEnCompte();
  }
  
  public void setPensionInvaliditeADeduirePriseEnCompte(Quantite p_pensionInvaliditeADeduirePriseEnCompte)
  {
    if ((m_pensionInvaliditeADeduirePriseEnCompte == null) || (p_pensionInvaliditeADeduirePriseEnCompte == null))
    {
      m_pensionInvaliditeADeduirePriseEnCompte = p_pensionInvaliditeADeduirePriseEnCompte;
      ((ConstitutionMontantsBrutsPC)getPC()).setPensionInvaliditeADeduirePriseEnCompte(p_pensionInvaliditeADeduirePriseEnCompte);
    }
    else if ((m_pensionInvaliditeADeduirePriseEnCompte != null) && (p_pensionInvaliditeADeduirePriseEnCompte != null) && (!p_pensionInvaliditeADeduirePriseEnCompte.equals(m_pensionInvaliditeADeduirePriseEnCompte)))
    {
      m_pensionInvaliditeADeduirePriseEnCompte = p_pensionInvaliditeADeduirePriseEnCompte;
      ((ConstitutionMontantsBrutsPC)getPC()).setPensionInvaliditeADeduirePriseEnCompte(p_pensionInvaliditeADeduirePriseEnCompte);
    }
  }
  
  protected Quantite rawGetMontantBrutSansPensionInvaliditeADeduire()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getMontantBrutSansPensionInvaliditeADeduire();
  }
  
  public Quantite getMontantBrutSansPensionInvaliditeADeduire()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getMontantBrutSansPensionInvaliditeADeduire();
  }
  
  public void setMontantBrutSansPensionInvaliditeADeduire(Quantite p_montantBrutSansPensionInvaliditeADeduire)
  {
    if ((m_montantBrutSansPensionInvaliditeADeduire == null) || (p_montantBrutSansPensionInvaliditeADeduire == null))
    {
      m_montantBrutSansPensionInvaliditeADeduire = p_montantBrutSansPensionInvaliditeADeduire;
      ((ConstitutionMontantsBrutsPC)getPC()).setMontantBrutSansPensionInvaliditeADeduire(p_montantBrutSansPensionInvaliditeADeduire);
    }
    else if ((m_montantBrutSansPensionInvaliditeADeduire != null) && (p_montantBrutSansPensionInvaliditeADeduire != null) && (!p_montantBrutSansPensionInvaliditeADeduire.equals(m_montantBrutSansPensionInvaliditeADeduire)))
    {
      m_montantBrutSansPensionInvaliditeADeduire = p_montantBrutSansPensionInvaliditeADeduire;
      ((ConstitutionMontantsBrutsPC)getPC()).setMontantBrutSansPensionInvaliditeADeduire(p_montantBrutSansPensionInvaliditeADeduire);
    }
  }
  
  protected Quantite rawGetMontantJournalierAvantageVieillesse()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getMontantJournalierAvantageVieillesse();
  }
  
  public Quantite getMontantJournalierAvantageVieillesse()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getMontantJournalierAvantageVieillesse();
  }
  
  public void setMontantJournalierAvantageVieillesse(Quantite p_montantJournalierAvantageVieillesse)
  {
    if ((m_montantJournalierAvantageVieillesse == null) || (p_montantJournalierAvantageVieillesse == null))
    {
      m_montantJournalierAvantageVieillesse = p_montantJournalierAvantageVieillesse;
      ((ConstitutionMontantsBrutsPC)getPC()).setMontantJournalierAvantageVieillesse(p_montantJournalierAvantageVieillesse);
    }
    else if ((m_montantJournalierAvantageVieillesse != null) && (p_montantJournalierAvantageVieillesse != null) && (!p_montantJournalierAvantageVieillesse.equals(m_montantJournalierAvantageVieillesse)))
    {
      m_montantJournalierAvantageVieillesse = p_montantJournalierAvantageVieillesse;
      ((ConstitutionMontantsBrutsPC)getPC()).setMontantJournalierAvantageVieillesse(p_montantJournalierAvantageVieillesse);
    }
  }
  
  protected Quantite rawGetMontantJournalierAvantageVieillesseDeduit()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getMontantJournalierAvantageVieillesseDeduit();
  }
  
  public Quantite getMontantJournalierAvantageVieillesseDeduit()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getMontantJournalierAvantageVieillesseDeduit();
  }
  
  public void setMontantJournalierAvantageVieillesseDeduit(Quantite p_montantJournalierAvantageVieillesseDeduit)
  {
    if ((m_montantJournalierAvantageVieillesseDeduit == null) || (p_montantJournalierAvantageVieillesseDeduit == null))
    {
      m_montantJournalierAvantageVieillesseDeduit = p_montantJournalierAvantageVieillesseDeduit;
      ((ConstitutionMontantsBrutsPC)getPC()).setMontantJournalierAvantageVieillesseDeduit(p_montantJournalierAvantageVieillesseDeduit);
    }
    else if ((m_montantJournalierAvantageVieillesseDeduit != null) && (p_montantJournalierAvantageVieillesseDeduit != null) && (!p_montantJournalierAvantageVieillesseDeduit.equals(m_montantJournalierAvantageVieillesseDeduit)))
    {
      m_montantJournalierAvantageVieillesseDeduit = p_montantJournalierAvantageVieillesseDeduit;
      ((ConstitutionMontantsBrutsPC)getPC()).setMontantJournalierAvantageVieillesseDeduit(p_montantJournalierAvantageVieillesseDeduit);
    }
  }
  
  protected BigDecimal rawGetSjrMontantMaxAsp()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getSjrMontantMaxAsp();
  }
  
  public BigDecimal getSjrMontantMaxAsp()
  {
    return ((ConstitutionMontantsBrutsPC)getPC()).getSjrMontantMaxAsp();
  }
  
  public void setSjrMontantMaxAsp(BigDecimal p_sjrMontantMaxAsp)
  {
    if ((m_sjrMontantMaxAsp == null) || (p_sjrMontantMaxAsp == null))
    {
      m_sjrMontantMaxAsp = p_sjrMontantMaxAsp;
      ((ConstitutionMontantsBrutsPC)getPC()).setSjrMontantMaxAsp(p_sjrMontantMaxAsp);
    }
    else if ((m_sjrMontantMaxAsp != null) && (p_sjrMontantMaxAsp != null) && (!p_sjrMontantMaxAsp.equals(m_sjrMontantMaxAsp)))
    {
      m_sjrMontantMaxAsp = p_sjrMontantMaxAsp;
      ((ConstitutionMontantsBrutsPC)getPC()).setSjrMontantMaxAsp(p_sjrMontantMaxAsp);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConstitutionMontantsBrutsGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */