package fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc.ConstitutionQuantiteAffiliationPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.UniteAffiliation;
import fr.unedic.util.temps.Periode;

public abstract class ConstitutionQuantiteAffiliationGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionQuantiteAffiliationPC;
  private Quantite m_dureeInitiale = null;
  private Quantite m_quantiteAffiliationAcquise = new Quantite("0", UniteAffiliation.get("heure de travail"));
  private Quantite m_quantiteAssimilationAcquise = new Quantite("0", UniteAffiliation.get("heure de travail"));
  private String m_article3;
  private Periode m_periodePRA;
  
  public ConstitutionQuantiteAffiliationGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConstitutionQuantiteAffiliationGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ConstitutionQuantiteAffiliationPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_constitutionQuantiteAffiliationPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionQuantiteAffiliationPC)
  {
    m_constitutionQuantiteAffiliationPC = p_constitutionQuantiteAffiliationPC;
  }
  
  protected Quantite rawGetDureeInitiale()
  {
    return ((ConstitutionQuantiteAffiliationPC)getPC()).getDureeInitiale();
  }
  
  public Quantite getDureeInitiale()
  {
    return ((ConstitutionQuantiteAffiliationPC)getPC()).getDureeInitiale();
  }
  
  public void setDureeInitiale(Quantite p_dureeInitiale)
  {
    if ((m_dureeInitiale == null) || (p_dureeInitiale == null))
    {
      m_dureeInitiale = p_dureeInitiale;
      ((ConstitutionQuantiteAffiliationPC)getPC()).setDureeInitiale(p_dureeInitiale);
    }
    else if ((m_dureeInitiale != null) && (p_dureeInitiale != null) && (!p_dureeInitiale.equals(m_dureeInitiale)))
    {
      m_dureeInitiale = p_dureeInitiale;
      ((ConstitutionQuantiteAffiliationPC)getPC()).setDureeInitiale(p_dureeInitiale);
    }
  }
  
  protected Quantite rawGetQuantiteAffiliationAcquise()
  {
    return ((ConstitutionQuantiteAffiliationPC)getPC()).getQuantiteAffiliationAcquise();
  }
  
  public Quantite getQuantiteAffiliationAcquise()
  {
    return ((ConstitutionQuantiteAffiliationPC)getPC()).getQuantiteAffiliationAcquise();
  }
  
  public void setQuantiteAffiliationAcquise(Quantite p_quantiteAffiliationAcquise)
  {
    if ((m_quantiteAffiliationAcquise == null) || (p_quantiteAffiliationAcquise == null))
    {
      m_quantiteAffiliationAcquise = p_quantiteAffiliationAcquise;
      ((ConstitutionQuantiteAffiliationPC)getPC()).setQuantiteAffiliationAcquise(p_quantiteAffiliationAcquise);
    }
    else if ((m_quantiteAffiliationAcquise != null) && (p_quantiteAffiliationAcquise != null) && (!p_quantiteAffiliationAcquise.equals(m_quantiteAffiliationAcquise)))
    {
      m_quantiteAffiliationAcquise = p_quantiteAffiliationAcquise;
      ((ConstitutionQuantiteAffiliationPC)getPC()).setQuantiteAffiliationAcquise(p_quantiteAffiliationAcquise);
    }
  }
  
  protected Quantite rawGetQuantiteAssimilationAcquise()
  {
    return ((ConstitutionQuantiteAffiliationPC)getPC()).getQuantiteAssimilationAcquise();
  }
  
  public Quantite getQuantiteAssimilationAcquise()
  {
    return ((ConstitutionQuantiteAffiliationPC)getPC()).getQuantiteAssimilationAcquise();
  }
  
  public void setQuantiteAssimilationAcquise(Quantite p_quantiteAssimilationAcquise)
  {
    if ((m_quantiteAssimilationAcquise == null) || (p_quantiteAssimilationAcquise == null))
    {
      m_quantiteAssimilationAcquise = p_quantiteAssimilationAcquise;
      ((ConstitutionQuantiteAffiliationPC)getPC()).setQuantiteAssimilationAcquise(p_quantiteAssimilationAcquise);
    }
    else if ((m_quantiteAssimilationAcquise != null) && (p_quantiteAssimilationAcquise != null) && (!p_quantiteAssimilationAcquise.equals(m_quantiteAssimilationAcquise)))
    {
      m_quantiteAssimilationAcquise = p_quantiteAssimilationAcquise;
      ((ConstitutionQuantiteAffiliationPC)getPC()).setQuantiteAssimilationAcquise(p_quantiteAssimilationAcquise);
    }
  }
  
  protected String rawGetArticle3()
  {
    return ((ConstitutionQuantiteAffiliationPC)getPC()).getArticle3();
  }
  
  public String getArticle3()
  {
    return ((ConstitutionQuantiteAffiliationPC)getPC()).getArticle3();
  }
  
  public void setArticle3(String p_article3)
  {
    if ((m_article3 == null) || (p_article3 == null))
    {
      m_article3 = p_article3;
      ((ConstitutionQuantiteAffiliationPC)getPC()).setArticle3(p_article3);
    }
    else if ((m_article3 != null) && (p_article3 != null) && (!p_article3.equals(m_article3)))
    {
      m_article3 = p_article3;
      ((ConstitutionQuantiteAffiliationPC)getPC()).setArticle3(p_article3);
    }
  }
  
  protected Periode rawGetPeriodePRA()
  {
    return ((ConstitutionQuantiteAffiliationPC)getPC()).getPeriodePRA();
  }
  
  public Periode getPeriodePRA()
  {
    return ((ConstitutionQuantiteAffiliationPC)getPC()).getPeriodePRA();
  }
  
  public void setPeriodePRA(Periode p_periodePRA)
  {
    if ((m_periodePRA == null) || (p_periodePRA == null))
    {
      m_periodePRA = p_periodePRA;
      ((ConstitutionQuantiteAffiliationPC)getPC()).setPeriodePRA(p_periodePRA);
    }
    else if ((m_periodePRA != null) && (p_periodePRA != null) && (!p_periodePRA.equals(m_periodePRA)))
    {
      m_periodePRA = p_periodePRA;
      ((ConstitutionQuantiteAffiliationPC)getPC()).setPeriodePRA(p_periodePRA);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConstitutionQuantiteAffiliationGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */