package fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.PrcSjc;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc.SjrActiviteConserveePC;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.QuantiteEuro;

public abstract class SjrActiviteConserveeGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_sjrActiviteConserveePC;
  private PrcSjc m_prc = null;
  private QuantiteEuro m_sjrInitial = null;
  private String m_identifiantPeriodeActiviteConservee;
  
  public SjrActiviteConserveeGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public SjrActiviteConserveeGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new SjrActiviteConserveePC();
  }
  
  public DomPCSpec getPC()
  {
    return m_sjrActiviteConserveePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_sjrActiviteConserveePC)
  {
    m_sjrActiviteConserveePC = p_sjrActiviteConserveePC;
  }
  
  public PrcSjc getPrc()
  {
    if (m_prc == null)
    {
      DomPCSpec prcPC = ((SjrActiviteConserveePC)getPC()).getPrc();
      if (prcPC != null) {
        m_prc = ((PrcSjc)prcPC.createOM());
      }
    }
    return m_prc;
  }
  
  public void setPrc(PrcSjc p_prc)
  {
    if (p_prc == null)
    {
      ((SjrActiviteConserveePC)getPC()).setPrc(null);
      m_prc = p_prc;
    }
    else if (!p_prc.equals(m_prc))
    {
      ((SjrActiviteConserveePC)getPC()).setPrc(p_prc.getPC());
      m_prc = p_prc;
    }
  }
  
  protected QuantiteEuro rawGetSjrInitial()
  {
    return ((SjrActiviteConserveePC)getPC()).getSjrInitial();
  }
  
  public QuantiteEuro getSjrInitial()
  {
    return ((SjrActiviteConserveePC)getPC()).getSjrInitial();
  }
  
  public void setSjrInitial(QuantiteEuro p_sjrInitial)
  {
    if ((m_sjrInitial == null) || (p_sjrInitial == null))
    {
      m_sjrInitial = p_sjrInitial;
      ((SjrActiviteConserveePC)getPC()).setSjrInitial(p_sjrInitial);
    }
    else if ((m_sjrInitial != null) && (p_sjrInitial != null) && (!p_sjrInitial.equals(m_sjrInitial)))
    {
      m_sjrInitial = p_sjrInitial;
      ((SjrActiviteConserveePC)getPC()).setSjrInitial(p_sjrInitial);
    }
  }
  
  protected String rawGetIdentifiantPeriodeActiviteConservee()
  {
    return ((SjrActiviteConserveePC)getPC()).getIdentifiantPeriodeActiviteConservee();
  }
  
  public String getIdentifiantPeriodeActiviteConservee()
  {
    return ((SjrActiviteConserveePC)getPC()).getIdentifiantPeriodeActiviteConservee();
  }
  
  public void setIdentifiantPeriodeActiviteConservee(String p_identifiantPeriodeActiviteConservee)
  {
    if ((m_identifiantPeriodeActiviteConservee == null) || (p_identifiantPeriodeActiviteConservee == null))
    {
      m_identifiantPeriodeActiviteConservee = p_identifiantPeriodeActiviteConservee;
      ((SjrActiviteConserveePC)getPC()).setIdentifiantPeriodeActiviteConservee(p_identifiantPeriodeActiviteConservee);
    }
    else if ((m_identifiantPeriodeActiviteConservee != null) && (p_identifiantPeriodeActiviteConservee != null) && (!p_identifiantPeriodeActiviteConservee.equals(m_identifiantPeriodeActiviteConservee)))
    {
      m_identifiantPeriodeActiviteConservee = p_identifiantPeriodeActiviteConservee;
      ((SjrActiviteConserveePC)getPC()).setIdentifiantPeriodeActiviteConservee(p_identifiantPeriodeActiviteConservee);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    Object prc = getPrc();
    if ((prc != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(prc))) {
      DomManager.supprimer(getPrc(), p_contexteSuppression);
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     SjrActiviteConserveeGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */