package fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionCaractereSaisonnier;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.temps.Periode;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Collection;
import javax.jdo.JDOFatalInternalException;
import javax.jdo.JDOUnsupportedOptionException;
import javax.jdo.JDOUserException;
import javax.jdo.PersistenceManager;
import javax.jdo.spi.JDOImplHelper;
import javax.jdo.spi.JDOPermission;
import javax.jdo.spi.PersistenceCapable;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldConsumer;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldSupplier;
import javax.jdo.spi.StateManager;
import xcalia.lido.internal.sm.CommonStateManager;

public class ConstitutionCaractereSaisonnierPC
  implements DomPCSpec, PersistenceCapable
{
  private transient ConstitutionCaractereSaisonnier m_constitutionCaractereSaisonnierOM;
  protected boolean m_caractereSaisonnierRetenu;
  protected int m_typeCaractereSaisonnierRetenu;
  protected Periode m_periodeReferenceSaisonnier;
  protected Periode m_periodeRechercheActiviteSaisonniere;
  protected boolean m_activite3Sur5;
  protected Collection m_listePeriodesChomageSaisonnier;
  protected transient byte jdoFlags;
  protected transient StateManager jdoStateManager;
  private static int jdoInheritedFieldCount = 0;
  private static String[] jdoFieldNames = { "m_caractereSaisonnierRetenu", "m_typeCaractereSaisonnierRetenu", "m_periodeReferenceSaisonnier", "m_periodeRechercheActiviteSaisonniere", "m_activite3Sur5", "m_listePeriodesChomageSaisonnier" };
  private static Class[] jdoFieldTypes = { Boolean.TYPE, Integer.TYPE, Periode.class, Periode.class, Boolean.TYPE, Collection.class };
  private static byte[] jdoFieldFlags = { (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE) };
  private static Class jdoPersistenceCapableSuperclass = null;
  
  public ConstitutionCaractereSaisonnierPC()
  {
    jdoSetm_caractereSaisonnierRetenu(this, false);
    
    jdoSetm_periodeReferenceSaisonnier(this, null);
    jdoSetm_periodeRechercheActiviteSaisonniere(this, null);
    jdoSetm_activite3Sur5(this, false);
    
    jdoSetm_listePeriodesChomageSaisonnier(this, null);
  }
  
  public Object createOM()
  {
    if (m_constitutionCaractereSaisonnierOM == null) {
      m_constitutionCaractereSaisonnierOM = new ConstitutionCaractereSaisonnier(this);
    }
    return m_constitutionCaractereSaisonnierOM;
  }
  
  public boolean isCaractereSaisonnierRetenu()
  {
    return jdoGetm_caractereSaisonnierRetenu(this);
  }
  
  public final void setCaractereSaisonnierRetenu(boolean p_caractereSaisonnierRetenu)
  {
    jdoSetm_caractereSaisonnierRetenu(this, p_caractereSaisonnierRetenu);
  }
  
  public int getTypeCaractereSaisonnierRetenu()
  {
    return jdoGetm_typeCaractereSaisonnierRetenu(this);
  }
  
  public final void setTypeCaractereSaisonnierRetenu(int p_typeCaractereSaisonnierRetenu)
  {
    jdoSetm_typeCaractereSaisonnierRetenu(this, p_typeCaractereSaisonnierRetenu);
  }
  
  public Periode getPeriodeReferenceSaisonnier()
  {
    return jdoGetm_periodeReferenceSaisonnier(this);
  }
  
  public final void setPeriodeReferenceSaisonnier(Periode p_periodeReferenceSaisonnier)
  {
    jdoSetm_periodeReferenceSaisonnier(this, p_periodeReferenceSaisonnier);
  }
  
  public Periode getPeriodeRechercheActiviteSaisonniere()
  {
    return jdoGetm_periodeRechercheActiviteSaisonniere(this);
  }
  
  public final void setPeriodeRechercheActiviteSaisonniere(Periode p_periodeRechercheActiviteSaisonniere)
  {
    jdoSetm_periodeRechercheActiviteSaisonniere(this, p_periodeRechercheActiviteSaisonniere);
  }
  
  public boolean isActivite3Sur5()
  {
    return jdoGetm_activite3Sur5(this);
  }
  
  public final void setActivite3Sur5(boolean p_activite3Sur5)
  {
    jdoSetm_activite3Sur5(this, p_activite3Sur5);
  }
  
  public final Collection getCollectionPeriodeChomageSaisonnier()
  {
    if (jdoGetm_listePeriodesChomageSaisonnier(this) == null) {
      jdoSetm_listePeriodesChomageSaisonnier(this, new ArrayList());
    }
    return jdoGetm_listePeriodesChomageSaisonnier(this);
  }
  
  public final void ajouterPeriodeChomageSaisonnier(DomPCSpec p_periodesChomageSaisonnier)
    throws NullPointerException
  {
    if (p_periodesChomageSaisonnier == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodesChomageSaisonnier ne devrait pas être nul.", p_periodesChomageSaisonnier);
    }
    getCollectionPeriodeChomageSaisonnier().add(p_periodesChomageSaisonnier);
  }
  
  public final void supprimerPeriodeChomageSaisonnier(DomPCSpec p_periodesChomageSaisonnier)
    throws NullPointerException
  {
    if (p_periodesChomageSaisonnier == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodesChomageSaisonnier ne devrait pas être nul.", p_periodesChomageSaisonnier);
    }
    getCollectionPeriodeChomageSaisonnier().remove(p_periodesChomageSaisonnier);
  }
  
  static
  {
    JDOImplHelper.registerClass(ConstitutionCaractereSaisonnierPC.class, jdoFieldNames, jdoFieldTypes, jdoFieldFlags, jdoPersistenceCapableSuperclass, new ConstitutionCaractereSaisonnierPC());
  }
  
  protected static final boolean jdoGetm_caractereSaisonnierRetenu(ConstitutionCaractereSaisonnierPC pc)
  {
    if (jdoFlags <= 0) {
      return m_caractereSaisonnierRetenu;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 0)) {
        return m_caractereSaisonnierRetenu;
      }
      return sm.getBooleanField(pc, jdoInheritedFieldCount + 0, m_caractereSaisonnierRetenu);
    }
    return m_caractereSaisonnierRetenu;
  }
  
  protected static final int jdoGetm_typeCaractereSaisonnierRetenu(ConstitutionCaractereSaisonnierPC pc)
  {
    if (jdoFlags <= 0) {
      return m_typeCaractereSaisonnierRetenu;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 1)) {
        return m_typeCaractereSaisonnierRetenu;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 1, m_typeCaractereSaisonnierRetenu);
    }
    return m_typeCaractereSaisonnierRetenu;
  }
  
  protected static final Periode jdoGetm_periodeReferenceSaisonnier(ConstitutionCaractereSaisonnierPC pc)
  {
    if (jdoFlags <= 0) {
      return m_periodeReferenceSaisonnier;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 2)) {
        return m_periodeReferenceSaisonnier;
      }
      return (Periode)sm.getObjectField(pc, jdoInheritedFieldCount + 2, m_periodeReferenceSaisonnier);
    }
    return m_periodeReferenceSaisonnier;
  }
  
  protected static final Periode jdoGetm_periodeRechercheActiviteSaisonniere(ConstitutionCaractereSaisonnierPC pc)
  {
    if (jdoFlags <= 0) {
      return m_periodeRechercheActiviteSaisonniere;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 3)) {
        return m_periodeRechercheActiviteSaisonniere;
      }
      return (Periode)sm.getObjectField(pc, jdoInheritedFieldCount + 3, m_periodeRechercheActiviteSaisonniere);
    }
    return m_periodeRechercheActiviteSaisonniere;
  }
  
  protected static final boolean jdoGetm_activite3Sur5(ConstitutionCaractereSaisonnierPC pc)
  {
    if (jdoFlags <= 0) {
      return m_activite3Sur5;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 4)) {
        return m_activite3Sur5;
      }
      return sm.getBooleanField(pc, jdoInheritedFieldCount + 4, m_activite3Sur5);
    }
    return m_activite3Sur5;
  }
  
  protected static final Collection jdoGetm_listePeriodesChomageSaisonnier(ConstitutionCaractereSaisonnierPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 5)) {
        return m_listePeriodesChomageSaisonnier;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 5, m_listePeriodesChomageSaisonnier);
    }
    return m_listePeriodesChomageSaisonnier;
  }
  
  protected static final void jdoSetm_caractereSaisonnierRetenu(ConstitutionCaractereSaisonnierPC pc, boolean newValue)
  {
    if (jdoFlags == 0)
    {
      m_caractereSaisonnierRetenu = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setBooleanField(pc, jdoInheritedFieldCount + 0, m_caractereSaisonnierRetenu, newValue);
    } else {
      m_caractereSaisonnierRetenu = newValue;
    }
  }
  
  protected static final void jdoSetm_typeCaractereSaisonnierRetenu(ConstitutionCaractereSaisonnierPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_typeCaractereSaisonnierRetenu = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 1, m_typeCaractereSaisonnierRetenu, newValue);
    } else {
      m_typeCaractereSaisonnierRetenu = newValue;
    }
  }
  
  protected static final void jdoSetm_periodeReferenceSaisonnier(ConstitutionCaractereSaisonnierPC pc, Periode newValue)
  {
    if (jdoFlags == 0)
    {
      m_periodeReferenceSaisonnier = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 2, m_periodeReferenceSaisonnier, newValue);
    } else {
      m_periodeReferenceSaisonnier = newValue;
    }
  }
  
  protected static final void jdoSetm_periodeRechercheActiviteSaisonniere(ConstitutionCaractereSaisonnierPC pc, Periode newValue)
  {
    if (jdoFlags == 0)
    {
      m_periodeRechercheActiviteSaisonniere = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 3, m_periodeRechercheActiviteSaisonniere, newValue);
    } else {
      m_periodeRechercheActiviteSaisonniere = newValue;
    }
  }
  
  protected static final void jdoSetm_activite3Sur5(ConstitutionCaractereSaisonnierPC pc, boolean newValue)
  {
    if (jdoFlags == 0)
    {
      m_activite3Sur5 = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setBooleanField(pc, jdoInheritedFieldCount + 4, m_activite3Sur5, newValue);
    } else {
      m_activite3Sur5 = newValue;
    }
  }
  
  protected static final void jdoSetm_listePeriodesChomageSaisonnier(ConstitutionCaractereSaisonnierPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 5, m_listePeriodesChomageSaisonnier, newValue);
    } else {
      m_listePeriodesChomageSaisonnier = newValue;
    }
  }
  
  public void jdoProvideField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      jdoStateManager.providedBooleanField(this, fieldNumber, m_caractereSaisonnierRetenu);
      break;
    case 1: 
      jdoStateManager.providedIntField(this, fieldNumber, m_typeCaractereSaisonnierRetenu);
      break;
    case 2: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_periodeReferenceSaisonnier);
      break;
    case 3: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_periodeRechercheActiviteSaisonniere);
      break;
    case 4: 
      jdoStateManager.providedBooleanField(this, fieldNumber, m_activite3Sur5);
      break;
    case 5: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_listePeriodesChomageSaisonnier);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoReplaceField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      m_caractereSaisonnierRetenu = jdoStateManager.replacingBooleanField(this, fieldNumber);
      break;
    case 1: 
      m_typeCaractereSaisonnierRetenu = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 2: 
      m_periodeReferenceSaisonnier = ((Periode)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 3: 
      m_periodeRechercheActiviteSaisonniere = ((Periode)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 4: 
      m_activite3Sur5 = jdoStateManager.replacingBooleanField(this, fieldNumber);
      break;
    case 5: 
      m_listePeriodesChomageSaisonnier = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoProvideFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoProvideField(fieldNumber);
    }
  }
  
  public void jdoReplaceFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoReplaceField(fieldNumber);
    }
  }
  
  public synchronized void jdoReplaceStateManager(StateManager sm)
  {
    if (jdoStateManager != null)
    {
      jdoStateManager = jdoStateManager.replacingStateManager(this, sm);
    }
    else
    {
      SecurityManager securityManager = System.getSecurityManager();
      if (securityManager != null) {
        securityManager.checkPermission(JDOPermission.SET_STATE_MANAGER);
      }
      jdoStateManager = sm;
    }
  }
  
  public boolean jdoIsPersistent()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isPersistent(this);
    }
    return false;
  }
  
  public boolean jdoIsTransactional()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isTransactional(this);
    }
    return false;
  }
  
  public boolean jdoIsNew()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isNew(this);
    }
    return false;
  }
  
  public boolean jdoIsDirty()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDirty(this);
    }
    return false;
  }
  
  public boolean jdoIsDeleted()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDeleted(this);
    }
    return false;
  }
  
  public void jdoMakeDirty(String fieldName)
  {
    if (jdoStateManager != null) {
      jdoStateManager.makeDirty(this, fieldName);
    }
  }
  
  public void jdoReplaceFlags()
  {
    if (jdoStateManager != null)
    {
      jdoFlags = jdoStateManager.replacingFlags(this);
      return;
      jdoFlags = 0;
    }
  }
  
  public boolean jdoIsDetached()
  {
    if (jdoStateManager != null) {
      return ((CommonStateManager)jdoStateManager).isDetached();
    }
    return false;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm)
  {
    ConstitutionCaractereSaisonnierPC pc = new ConstitutionCaractereSaisonnierPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    return pc;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm, Object oid)
  {
    ConstitutionCaractereSaisonnierPC pc = new ConstitutionCaractereSaisonnierPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    pc.jdoCopyKeyFieldsFromObjectId(oid);
    return pc;
  }
  
  public static int jdoGetManagedFieldCount()
  {
    return jdoInheritedFieldCount + 6;
  }
  
  public void jdoCopyFields(Object pc, int[] fieldNumbers)
  {
    if (!(pc instanceof ConstitutionCaractereSaisonnierPC)) {
      throw new JDOFatalInternalException("Can't copy fields from a different class");
    }
    ConstitutionCaractereSaisonnierPC other = (ConstitutionCaractereSaisonnierPC)pc;
    if (jdoStateManager != jdoStateManager) {
      throw new JDOUserException("Source object should have the same StateManager");
    }
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int relativeField = fieldNumbers[i] - jdoInheritedFieldCount;
      switch (relativeField)
      {
      case 0: 
        m_caractereSaisonnierRetenu = m_caractereSaisonnierRetenu;
        break;
      case 1: 
        m_typeCaractereSaisonnierRetenu = m_typeCaractereSaisonnierRetenu;
        break;
      case 2: 
        m_periodeReferenceSaisonnier = m_periodeReferenceSaisonnier;
        break;
      case 3: 
        m_periodeRechercheActiviteSaisonniere = m_periodeRechercheActiviteSaisonniere;
        break;
      case 4: 
        m_activite3Sur5 = m_activite3Sur5;
        break;
      case 5: 
        m_listePeriodesChomageSaisonnier = m_listePeriodesChomageSaisonnier;
      }
    }
  }
  
  public void jdoCopyKeyFieldsToObjectId(Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public void jdoCopyKeyFieldsToObjectId(PersistenceCapable.ObjectIdFieldSupplier supplier, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  protected void jdoCopyKeyFieldsFromObjectId(Object object) {}
  
  public void jdoCopyKeyFieldsFromObjectId(PersistenceCapable.ObjectIdFieldConsumer consumer, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public Object jdoNewObjectIdInstance()
  {
    return null;
  }
  
  public Object jdoNewObjectIdInstance(Object str)
  {
    return null;
  }
  
  public Object jdoGetObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getObjectId(this);
    }
    return null;
  }
  
  public PersistenceManager jdoGetPersistenceManager()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getPersistenceManager(this);
    }
    return null;
  }
  
  private void jdoPreSerialize()
  {
    if (jdoStateManager != null) {
      jdoStateManager.preSerialize(this);
    }
  }
  
  private void writeObject(ObjectOutputStream out)
    throws IOException
  {
    jdoPreSerialize();
    out.defaultWriteObject();
  }
  
  public Object jdoGetTransactionalObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getTransactionalObjectId(this);
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     ConstitutionCaractereSaisonnierPC
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */