package fr.unedic.cali.asu.cge01.p02.liquidation.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionCaractereSaisonnier;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionCoefficientSaisonnier;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionCoefficientTempsPartiel;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionDateAttribution;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionDelais;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionDurees;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionMontantsBruts;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionPointDepartIndemnisation;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionProduitResultant;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionQuantiteAffiliation;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionSjc;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionSjr;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.DureeIndemnisation;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Od;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Prc;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Sjcip;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Sjrip;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.ConditionQuantiteAffiliationSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.DossierExamenAssuranceSpec;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.FaitGenerateurSpec;
import fr.unedic.cali.asu.dom.JustificationAffiliationSpec;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieDroitOptionApresARE14;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.ContratTravail;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.OdAssuranceSpec;
import fr.unedic.cali.dom.PoursuiteIndemnisationSpec;
import fr.unedic.cali.dom.RejetSpec;
import fr.unedic.cali.dom.RepriseSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P02;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.dom.pivot.DemandePivot;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.Unite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import org.apache.commons.lang.StringUtils;

public final class AlimentationBasePivot
{
  private static final int LONGUEUR_CODE_PAYS_ACTIVITE = 3;
  private static final int LONGUEUR_CODE_ACTIVITE_HORS_FRANCE = 2;
  private static final String STRING_VIDE = "";
  
  public static void alimenterDonneesProduit(DossierExamenSpec dossierExamen, DemandePivot demandePivot)
    throws ApplicativeException
  {
    Demande demandeAssurance = (Demande)dossierExamen.getDemande();
    
    fr.unedic.cali.dom.pivot.Decision decision = demandePivot.getDecision();
    
    fr.unedic.cali.dom.pivot.Attribution attribution = demandePivot.getAttribution();
    if (!(dossierExamen instanceof PoursuiteIndemnisationSpec)) {
      renseignerDecision(decision, demandeAssurance);
    }
    if (attribution != null)
    {
      renseignerAttribution(demandePivot.getAttribution(), demandeAssurance);
      renseignerAttributionCoordinationCee(demandePivot.getAttribution(), demandeAssurance);
    }
    fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.AlimentationBasePivot.getInstance().alimentationSpecificitesAspSurProduitCge(demandeAssurance, attribution, dossierExamen, decision);
    if (attribution != null) {
      fr.unedic.cali.asu.liquidation.outilsfonctionnels.AlimentationBasePivot.alimentationMontantAllocationJournaliereBrut(dossierExamen, attribution);
    }
  }
  
  private static void renseignerAttribution(fr.unedic.cali.dom.pivot.Attribution attribution, Demande demande)
    throws ApplicativeException, CoucheLogiqueException
  {
    renseignerDroitCourant(attribution, demande);
    
    renseignerDroitRetenu(attribution, demande);
  }
  
  private static void renseignerDroitCourant(fr.unedic.cali.dom.pivot.Attribution attribution, Demande demande)
    throws ApplicativeException, CoucheLogiqueException
  {
    fr.unedic.cali.asu.cge01.p02.liquidation.dom.Decision decision = (fr.unedic.cali.asu.cge01.p02.liquidation.dom.Decision)demande.getDossierExamen();
    if (decision.getConstitutionQuantiteAffiliation() != null) {
      attribution.setReferenceReglementaireAffiliationDroitCourant(decision.getConstitutionQuantiteAffiliation().getArticle3().toUpperCase());
    }
    if ((decision instanceof Od)) {
      attribution.setPlus100trimestres(determineAuMoins100Trimestres(demande));
    }
    attribution.setDateEffetAttribution(decision.getConstitutionDateAttribution().getDateAttribution());
    
    attribution.setPji(decision.getConstitutionPointDepartIndemnisation().getPji());
    if (decision.getConstitutionReglementApplicable() != null) {
      attribution.setReglementApplicableCourant(decision.getConstitutionReglementApplicable().getReglement().getNomReglement().toUpperCase());
    }
    if ((decision.getConstitutionMontantsBruts() != null) && (decision.getConstitutionMontantsBruts().getCapitalInitialBrut() != null)) {
      attribution.setCapitalOdCourante(decision.getConstitutionMontantsBruts().getCapitalInitialBrut().getValeur());
    }
    attribution.setTypeChomageSaisonnier(determineTypeChomageSaisonnier(decision));
    
    attribution.setCapitalDroitPrecedentSp(determineCapitalPrecedentSp(demande));
    if ((decision.getConstitutionDurees() != null) && (decision.getConstitutionDurees().getDureeIndemnisation().getDureeTheorique() != null)) {
      attribution.setDureeTheoriqueDroitCourant(decision.getConstitutionDurees().getDureeIndemnisation().getDureeTheorique().getValeurEntiere());
    }
    if (!demande.estEnReExamen()) {
      attribution.setDateTheoriqueFinDroit(fr.unedic.cali.asu.outilsfonctionnels.AlimentationBasePivot.determineDateTheoriqueFinDroit((AttributionAssuranceSpec)decision));
    }
    attribution.setDateFinDelaiDecheance(determineDateFinDelaiDecheance(attribution.getDateTheoriqueFinDroit()));
    if (decision.getConstitutionSjr() != null)
    {
      boolean sjrForce = false;
      BigDecimal zero = BigDecimal.ZERO;
      if ((demande.getDonneesTemporaires() != null) && (demande.getDonneesTemporaires().getTermePrc() != null)) {
        sjrForce = true;
      }
      Prc prcDroitCourant = decision.getConstitutionSjr().getSjrip().getPrc();
      if (prcDroitCourant != null)
      {
        attribution.setDateDebutPrcDroitCourant(prcDroitCourant.getDateDebut());
        
        attribution.setDateFinPrcDroitCourant(prcDroitCourant.getDateFin());
        
        attribution.setMontantSalaireReferenceSjrCourant(!sjrForce ? prcDroitCourant.getSrip() : zero);
      }
      attribution.setNbJoursDiviseurSjrCourant(!sjrForce ? determineDiviseurPrc(decision) : zero);
      
      attribution.setMontantSjrCourantNonPlafonne(!sjrForce ? decision.getConstitutionSjr().getSjrip().getSjrInitial().getValeur() : zero);
      
      attribution.setMontantSjrCourantCalculePlafonne(!sjrForce ? decision.getConstitutionSjr().getSjrip().getSjrip() : zero);
      
      attribution.setMontantSjrCourantPlafonne(decision.getConstitutionSjr().getSjrrp().getSalaire());
      
      attribution.setNbHeuresTravailleesA8A10SjrCourant(0);
    }
    if ((decision.getConstitutionSjc() != null) && (decision.getConstitutionSjc().getSjcip() != null))
    {
      attribution.setDateEffetSjc(decision.getConstitutionSjc().getSjcip().getDateEffet());
      
      attribution.setMontantSjc(decision.getConstitutionSjc().getSjcip().getSjcip());
    }
    attribution.setCoeffTempsPartielSjrCourant(determinerCoeffTempsPartielDroitRetenu(decision));
    
    attribution.setCoeffSaisonnierCalcSjrCourant(determineCoefficientSaisonnierCalcule(decision));
    if (decision.getConstitutionDelais() != null)
    {
      attribution.setNbJoursIccp(decision.getConstitutionDelais().getNbJoursCarenceICCP());
      
      attribution.setUniteDureeIccp("C");
      
      attribution.setDateDebutIccp(decision.getConstitutionDelais().getDebutCarenceICCP());
      
      attribution.setDateFinIccp(decision.getConstitutionDelais().getTermeCarenceICCP());
      if ((decision.getConstitutionReglementApplicable() != null) && (decision.getConstitutionReglementApplicable().getReglement().equals(ProduitAsuCge01P02.getInstance().getReglement("A4"))))
      {
        if (decision.getConstitutionDelais().getCumulMontantICCPA4Origine() != null) {
          attribution.setMontantCarenceIccp(decision.getConstitutionDelais().getCumulMontantICCPA4Origine().getValeurMontant());
        }
      }
      else if (decision.getConstitutionDelais().getMontantICCPOrigine() != null) {
        attribution.setMontantCarenceIccp(decision.getConstitutionDelais().getMontantICCPOrigine().getValeurMontant());
      }
      attribution.setNbJoursIslr(decision.getConstitutionDelais().getNbJoursCarenceISLR());
      
      attribution.setUniteDureeIslr("C");
      
      attribution.setDateDebutIslr(decision.getConstitutionDelais().getDebutCarenceISLR());
      
      attribution.setDateFinIslr(decision.getConstitutionDelais().getTermeCarenceISLR());
      
      attribution.setNbJoursDiffere(decision.getConstitutionDelais().getNbJoursCarenceDiffere());
      
      attribution.setUniteDureeDiffere("C");
      
      attribution.setDateDebutDiffere(decision.getConstitutionDelais().getDebutCarenceDiffere());
      
      attribution.setDateFinDiffere(decision.getConstitutionDelais().getTermeCarenceDiffere());
    }
    if (((decision instanceof fr.unedic.cali.asu.cge01.p02.liquidation.dom.Attribution)) && (((fr.unedic.cali.asu.cge01.p02.liquidation.dom.Attribution)decision).isRegimeFinancementParticulierCaCae())) {
      attribution.setRegimeParticulier("A");
    } else {
      attribution.setRegimeParticulier("");
    }
    if ((decision.getFaitGenerateur() != null) && (decision.getFaitGenerateur().getPeriodeFaitGenerateur() != null) && (decision.getFaitGenerateur().getPeriodeFaitGenerateur().isRegimeAlsaceMoselle())) {
      attribution.setComplementSs("A");
    }
    alimenterCodesStatutFNA(demande.getFaitGenerateur(), attribution);
    
    fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.AlimentationBasePivot.getInstance().alimenterCodeSousProduit(attribution, demande);
    
    fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.AlimentationBasePivot.getInstance().alimenterConventionGestion(attribution, demande);
    
    alimenterDonneesFNA(attribution, demande);
  }
  
  private static void alimenterCodesStatutFNA(FaitGenerateurSpec faitGenerateur, fr.unedic.cali.dom.pivot.Attribution attribution)
  {
    if ((faitGenerateur != null) && (faitGenerateur.getPeriodeFaitGenerateur() != null))
    {
      int pohf = faitGenerateur.getPeriodeFaitGenerateur().getContrat().getPohf();
      String pohfS = "";
      attribution.setCodePaysActivite(StringUtils.leftPad(Integer.toString(faitGenerateur.getPeriodeFaitGenerateur().getContrat().getPays()), 3, "0"));
      if (pohf != 0) {
        pohfS = StringUtils.leftPad(Integer.toString(pohf), 2, "0");
      }
      attribution.setCodeActiviteHorsFrance(pohfS);
    }
  }
  
  protected static void renseignerAttributionCoordinationCee(fr.unedic.cali.dom.pivot.Attribution attribution, Demande demande)
  {
    fr.unedic.cali.asu.cge01.p02.liquidation.dom.Attribution decision = (fr.unedic.cali.asu.cge01.p02.liquidation.dom.Attribution)demande.getDossierExamen();
    
    String codeSousProduitRetourne = decision.determinerCodeSousProduitPourSigma();
    
    attribution.setCodeSousProduitCourant(codeSousProduitRetourne);
    switch (decision.getNatureDecision())
    {
    case 10: 
    case 12: 
      attribution.setCodeSousProduitRetenu(codeSousProduitRetourne);
      break;
    case 3: 
    case 11: 
    case 26: 
      AttributionSpec attributionPrec = decision.getAttributionPrecedente();
      attribution.setCodeSousProduitRetenu(attributionPrec.determinerCodeSousProduitPourSigma());
      break;
    }
  }
  
  private static void renseignerDroitRetenu(fr.unedic.cali.dom.pivot.Attribution attribution, Demande demande)
    throws CoucheLogiqueException
  {
    fr.unedic.cali.asu.cge01.p02.liquidation.dom.Attribution decision = (fr.unedic.cali.asu.cge01.p02.liquidation.dom.Attribution)demande.getDossierExamen();
    
    BigDecimal zero = BigDecimal.ZERO;
    if (decision.getConstitutionQuantiteAffiliation() != null) {
      attribution.setReferenceReglementaireAffiliationDroitRetenu(decision.getConstitutionQuantiteAffiliation().getArticle3().toUpperCase());
    }
    if (decision.getConstitutionReglementApplicable() != null) {
      attribution.setReglementApplicableRetenu(decision.getConstitutionReglementApplicable().getReglement().getNomReglement().toUpperCase());
    }
    if ((decision.getElementBaseIndemnisation() != null) && (decision.getElementBaseIndemnisation().getCoefficientSaisonnier() != null)) {
      attribution.setCoeffSaisonnierForceSjrCourant(decision.getElementBaseIndemnisation().getCoefficientSaisonnier());
    }
    if (decision.getNatureDecision() == 11)
    {
      if ((decision.getConstitutionProduitResultant() != null) && (decision.getConstitutionProduitResultant().getConstitutionDurees() != null))
      {
        attribution.setFinPrcSjrRetenu(decision.getElementBaseIndemnisation().getSjr().getDateDepart());
        if (decision.getConstitutionProduitResultant().getConstitutionDurees().getDureeIndemnisation().getDureeTheorique() != null) {
          attribution.setDureeTheoriqueDroitRetenu(decision.getConstitutionProduitResultant().getConstitutionDurees().getDureeIndemnisation().getDureeTheorique().getValeurEntiere());
        }
        if (decision.getConstitutionProduitResultant().getCapitalDroitPrecedent() != null) {
          attribution.setCapitalOdPrecedente(decision.getConstitutionProduitResultant().getCapitalDroitPrecedent().getValeur());
        }
        attribution.setMontantSjrRetenuPlafonne(decision.getConstitutionProduitResultant().getSjrrpProduitPrecedent().getSalaire());
      }
    }
    else
    {
      if ((decision.getConstitutionProduitResultant() != null) && (decision.getConstitutionProduitResultant().getCapitalDroitPrecedent() != null)) {
        attribution.setCapitalOdPrecedente(decision.getConstitutionProduitResultant().getCapitalDroitPrecedent().getValeur());
      } else {
        attribution.setCapitalOdPrecedente(zero);
      }
      if ((decision.getConstitutionDurees() != null) && (decision.getConstitutionDurees().getDureeIndemnisation().getDureeTheorique() != null)) {
        attribution.setDureeTheoriqueDroitRetenu(decision.getConstitutionDurees().getDureeIndemnisation().getDureeTheorique().getValeurEntiere());
      }
      if (decision.getConstitutionSjr() != null)
      {
        Prc prcCourante = decision.getConstitutionSjr().getSjrip().getPrc();
        if (prcCourante != null) {
          attribution.setFinPrcSjrRetenu(decision.getConstitutionSjr().getSjrip().getPrc().getDateFin());
        }
        attribution.setMontantSjrRetenuPlafonne(decision.getConstitutionSjr().getSjrip().getSjrip());
      }
    }
  }
  
  private static void renseignerDecision(fr.unedic.cali.dom.pivot.Decision decision, Demande demande)
    throws CoucheLogiqueException
  {
    DossierExamen dossierExamen = (DossierExamen)demande.getDossierExamen();
    
    renseigneAffiliation(decision, dossierExamen);
    
    renseignerDonneesPmc(decision, dossierExamen);
  }
  
  private static BigDecimal determineCoefficientSaisonnierCalcule(DossierExamen dossier)
  {
    if ((dossier.getConstitutionCoefficientSaisonnier() != null) && (dossier.getConstitutionCoefficientSaisonnier().getCoefficientSaisonnierRetenu() != null)) {
      return dossier.getConstitutionCoefficientSaisonnier().getCoefficientSaisonnierRetenu();
    }
    return null;
  }
  
  private static BigDecimal determineCapitalPrecedentSp(Demande demande)
  {
    Quantite qte = demande.getDonneesTemporaires().getCapitalReliquatSecteurPublic();
    return qte != null ? qte.getValeur() : null;
  }
  
  private static BigDecimal determineDiviseurPrc(DossierExamen dossier)
  {
    BigDecimal div = null;
    if (dossier.getConstitutionSjr().getSjrip().getPrc() != null) {
      div = dossier.getConstitutionSjr().getSjrip().getPrc().getDiviseur();
    }
    return div;
  }
  
  private static Damj determineDateFinDelaiDecheance(Damj djiTheorique)
  {
    int troisAns = 3;
    Damj dateFin = null;
    DureeCalendaire delaiDecheance = new DureeCalendaire(3, 0, 0);
    if (djiTheorique != null) {
      dateFin = djiTheorique.deplacerVersAvant(delaiDecheance);
    }
    return dateFin;
  }
  
  private static BigDecimal determinerCoeffTempsPartielDroitRetenu(DossierExamen dossier)
  {
    BigDecimal coeffTempsPartiel = BigDecimal.ONE;
    
    BigDecimal coeff = null;
    ConstitutionCoefficientTempsPartiel coeffTP = dossier.getConstitutionCoefficientTempsPartiel();
    if ((coeffTP != null) && (coeffTP.getCoefficientTempsPartielRetenu() != null)) {
      coeff = coeffTP.getCoefficientTempsPartielRetenu();
    }
    if (coeff != null) {
      coeffTempsPartiel = coeff;
    }
    return coeffTempsPartiel;
  }
  
  private static void renseigneAffiliation(fr.unedic.cali.dom.pivot.Decision decision, DossierExamen dossier)
    throws CoucheLogiqueException
  {
    int valeurTotale1 = 0;
    int valeurTotale2 = 0;
    String nomUnite1 = "";
    String nomUnite2 = "";
    Quantite appartenance1 = null;
    Quantite appartenance2 = null;
    if (((dossier instanceof RejetSpec)) || ((dossier instanceof RepriseSpec)))
    {
      DossierAffectation dossierAffectationAdmission = ((Demande)dossier.getDossierAffecte().getDemande()).getDossierAffectationAdmission();
      if ((dossierAffectationAdmission != null) && (dossierAffectationAdmission.getDossierExamen() != null))
      {
        DossierExamenAssuranceSpec dossierExamenAdmission = (DossierExamenAssuranceSpec)dossierAffectationAdmission.getDossierExamen();
        ConditionQuantiteAffiliationSpec capa07 = dossierExamenAdmission.getConditionQuantiteAffiliation();
        FaitGenerateurSpec capa04 = dossierExamenAdmission.getFaitGenerateur();
        if ((capa07 != null) && (!capa07.estSatisfait()))
        {
          appartenance1 = capa07.getQuantiteAppartenance();
          appartenance2 = capa07.getQuantiteAppartenanceSecondaire();
          if (capa07.getJustificationAffiliation() != null)
          {
            Periode pra = capa07.getJustificationAffiliation().getPeriodeRechercheAffiliation();
            if (pra != null)
            {
              decision.setDateDebutPra(pra.getDebut());
              decision.setDateFinPra(pra.getFin());
            }
          }
        }
        else if ((capa04 != null) && (!capa04.estSatisfait()))
        {
          appartenance1 = capa04.getNombreJoursFaitGenerateur();
        }
        else
        {
          ValidationProduit vlp = dossierAffectationAdmission.getValidationProduit();
          if ((vlp != null) && (vlp.isEstProduitValide()))
          {
            appartenance1 = vlp.getQuantiteAcquise();
            appartenance2 = vlp.getQuantiteAcquiseSecondaire();
            
            Periode pra = vlp.getPeriodePra();
            if (pra != null)
            {
              decision.setDateDebutPra(pra.getDebut());
              decision.setDateFinPra(pra.getFin());
            }
          }
        }
      }
    }
    else
    {
      ConstitutionQuantiteAffiliation cepa09 = dossier.getConstitutionQuantiteAffiliation();
      if (cepa09 != null)
      {
        appartenance1 = cepa09.getQuantiteAcquise();
        appartenance2 = cepa09.getQuantiteAcquiseSecondaire();
        
        Periode pra = cepa09.getPeriodePRA();
        if (pra != null)
        {
          decision.setDateDebutPra(pra.getDebut());
          decision.setDateFinPra(pra.getFin());
        }
      }
    }
    if (appartenance1 != null)
    {
      valeurTotale1 = appartenance1.getValeur().intValue();
      nomUnite1 = appartenance1.getUnite().getNom();
    }
    if ((nomUnite1 != null) && (!nomUnite1.equals("")))
    {
      decision.setValeurQuantiteAffiliation(valeurTotale1);
      decision.setUniteAffiliation(fr.unedic.cali.outilsfonctionnels.AlimentationBasePivot.determineNomPourPivotUniteAffiliation(nomUnite1));
    }
    if (appartenance2 != null)
    {
      valeurTotale2 = appartenance2.getValeur().intValue();
      nomUnite2 = appartenance2.getUnite().getNom();
    }
    if ((nomUnite2 != null) && (!nomUnite2.equals("")))
    {
      decision.setValeurQuantiteAffiliation2(valeurTotale2);
      decision.setUniteAffiliation2(fr.unedic.cali.outilsfonctionnels.AlimentationBasePivot.determineNomPourPivotUniteAffiliation(nomUnite2));
    }
  }
  
  private static String determineAuMoins100Trimestres(Demande demande)
  {
    String val;
    String val;
    if ((demande.getDemandeur().getDateCentTrimestres() != null) && (demande.getDemandeur().getDateCentTrimestres().estAvantOuCoincideAvec(demande.getFaitGenerateur().getDateFaitGenerateur()))) {
      val = "O";
    } else {
      val = "N";
    }
    return val;
  }
  
  private static String determineTypeChomageSaisonnier(DossierExamen dossier)
  {
    int val = 0;
    if (dossier.getConstitutionCaractereSaisonnier() != null) {
      val = dossier.getConstitutionCaractereSaisonnier().getTypeCaractereSaisonnierRetenu();
    }
    String type;
    String type;
    if (val == 0) {
      type = "";
    } else {
      type = Integer.toString(val);
    }
    return type;
  }
  
  private static void renseignerDonneesPmc(fr.unedic.cali.dom.pivot.Decision decision, DossierExamen dossier)
    throws CoucheLogiqueException
  {
    if ((dossier.getConstitutionDelais() != null) && (dossier.getConstitutionDelais().getTermePMC() != null))
    {
      decision.setDateFinPmc(dossier.getConstitutionDelais().getTermePMC());
      if (dossier.getConstitutionDelais().getTypePmc() == 1) {
        decision.setTypePmc(0);
      } else if (dossier.getConstitutionDelais().getTypePmc() == 2) {
        decision.setTypePmc(1);
      }
    }
  }
  
  private static void alimenterDonneesFNA(fr.unedic.cali.dom.pivot.Attribution attribution, Demande demande)
  {
    attribution.setEstDroitOption(demande.estDroitOptionReadmission() ? "O" : "N");
    
    ActiviteSalarie fctRetenue = null;
    if (demande.getAttribution() != null)
    {
      OdAssuranceSpec ouvertureDroit = demande.getAttribution().getOuvertureDroit();
      
      ValidationProduit validationProduit = ((DossierAffectation)ouvertureDroit.getDossierAffecte()).getValidationProduit();
      if (validationProduit != null) {
        fctRetenue = validationProduit.getPeriodeValidationProduit();
      }
    }
    if ((fctRetenue != null) && (StrategieDroitOptionApresARE14.estApprenti(fctRetenue))) {
      attribution.setEstDroitApprenti("O");
    } else {
      attribution.setEstDroitApprenti("N");
    }
  }
}

/* Location:
 * Qualified Name:     AlimentationBasePivot
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */