package fr.unedic.cali.asu.cge01.p02.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.competence.DeterminationCompetenceCge;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Attribution;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Competence;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionQuantiteAffiliation;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.CompetenceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffecte;
import fr.unedic.cali.asu.dom.DossierExamenAssuranceSpec;
import fr.unedic.cali.asu.dom.FaitGenerateurSpec;
import fr.unedic.cali.asu.dom.ObjectifExamen;
import fr.unedic.cali.asu.dom.ResultatDeterminationCompetence;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.ContratTravail;
import fr.unedic.cali.autresdoms.ga.dom.Entreprise;
import fr.unedic.cali.autresdoms.ga.dom.Metier;
import fr.unedic.cali.autresdoms.ga.dom.PeriodeIntensite;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreActiviteContenuDansPra;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreContratPaysUnionEuropeenne;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeActiviteNonSalariee;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeActiviteSalarieHorsFrance;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeActiviteSalarieeE301;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeActiviteSalarieeSecteurPrive;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeActiviteSalarieeSecteurPriveCaCae;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeActiviteSalarieeSecteurPublicAffilie;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeActiviteSalarieeSecteurPublicAutoAssurance;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeActiviteSalarieeSecteurPublicConventionGestion;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeDsmTravail;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesAvecConflit;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesCertifiees;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesJustifiees;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesLiquidables;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesQualifiables;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesSansConflit;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesSurFiltresExclusifs;
import fr.unedic.util.Mathematiques;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.ComparateurTemporelsSurDateFin;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.FiltreChevauchePeriode;
import fr.unedic.util.temps.FiltreFinAvantOuCoincideAvecDate;
import fr.unedic.util.temps.FiltreMemeDateFin;
import fr.unedic.util.temps.FiltresTemporel;
import fr.unedic.util.temps.Periode;
import fr.unedic.util.temps.Temporel;
import java.math.BigDecimal;
import java.util.Enumeration;
import java.util.Hashtable;

public class DeterminationCompetence
  extends DeterminationCompetenceCge
{
  public static DeterminationCompetence getInstance()
  {
    return new DeterminationCompetence();
  }
  
  private static Hashtable tableEmployeursActivites = null;
  private static final BigDecimal MI_TEMPS = new BigDecimal("0.5");
  private static final int SP_RAC_SP_RAC = 1;
  private static final int SP_SP_SP_RAC = 2;
  private static final int SP_RAC_SP_SP = 3;
  private static final int SP_SP_SP_SP = 4;
  private static final int RAC_RAC_RAC_RAC = 5;
  private static final int SP_RAC_RAC_RAC = 6;
  private static final int SP_SP_RAC_RAC = 7;
  private static final int RAC_RAC_SP_RAC = 8;
  private static final int RAC_RAC_SP_SP = 9;
  
  public void determinerCompetenceAdministrative(Demande demande, ResultatDeterminationCompetence resultatDeterminationCompetence)
    throws CoucheLogiqueException
  {
    determinerCompetenceFinanciereProduitResultant(demande, resultatDeterminationCompetence);
    
    deduireCompetenceAdministrative(resultatDeterminationCompetence);
  }
  
  public void determinerCompetenceAdministrativeDroitCourant(Demande demandeCourante, ResultatDeterminationCompetence resultatDeterminationCompetence)
    throws CoucheLogiqueException
  {
    determinerCompetenceFinanciereProduitResultant(demandeCourante, resultatDeterminationCompetence);
    
    determinerEmployeurCompetent(demandeCourante, resultatDeterminationCompetence);
    
    deduireCompetenceAdministrative(resultatDeterminationCompetence);
  }
  
  private void determinerCompetenceFinanciereProduitResultant(Demande demande, ResultatDeterminationCompetence resultatDeterminationCompetence)
    throws CoucheLogiqueException
  {
    determinerChargeIndemnisationDroitExecutable(demande, resultatDeterminationCompetence);
    if (resultatDeterminationCompetence.getCompetenceFinanciere() == 2) {
      determinerEmployeurCompetentSecteurPublic(demande, resultatDeterminationCompetence);
    } else {
      determinerRegimeFinancementSecteurPrive(demande, resultatDeterminationCompetence);
    }
  }
  
  public void determinerEmployeurCompetent(Demande demande, ResultatDeterminationCompetence resultatDeterminationCompetence)
    throws CoucheLogiqueException
  {
    if (resultatDeterminationCompetence.getCompetenceFinanciere() == 2) {
      determinerEmployeurCompetentSecteurPublic(demande, resultatDeterminationCompetence);
    } else {
      determinerRegimeFinancementSecteurPrive(demande, resultatDeterminationCompetence);
    }
  }
  
  private static void deduireCompetenceAdministrative(ResultatDeterminationCompetence resultatDeterminationCompetence)
  {
    if (resultatDeterminationCompetence.getCompetenceFinanciere() == 1)
    {
      resultatDeterminationCompetence.setCompetenceAdministrative(1);
    }
    else
    {
      ChronologiePeriodes chronoPeriodesActiviteEmployeurCompetent = (ChronologiePeriodes)tableEmployeursActivites.get(resultatDeterminationCompetence.getIdentifiantEmployeurCompetent());
      ChronologiePeriodes chronoPeriodesActiviteSecteurPublicConventionGestion = (ChronologiePeriodes)chronoPeriodesActiviteEmployeurCompetent.copier(new FiltrePeriodeActiviteSalarieeSecteurPublicConventionGestion());
      if ((chronoPeriodesActiviteSecteurPublicConventionGestion != null) && (!chronoPeriodesActiviteSecteurPublicConventionGestion.estVide())) {
        resultatDeterminationCompetence.setCompetenceAdministrative(1);
      } else {
        resultatDeterminationCompetence.setCompetenceAdministrative(2);
      }
    }
  }
  
  private static void determinerCompetenceFinanciereEtAdministrative(Periode periodeRechercheAffiliation, ChronologiePeriodes chronoPasseProfessionnel, Damj dateExamen, ResultatDeterminationCompetence resultatDeterminationCompetence)
  {
    ChronologiePeriodes chronoPeriodesFiltrees = null;
    ChronologiePeriodes chronoPeriodesActiviteSecteurPrive = new ChronologiePeriodes();
    ChronologiePeriodes chronoPeriodesActiviteSecteurPublic = new ChronologiePeriodes();
    
    FiltresTemporel listeFiltres = new FiltresTemporel();
    
    listeFiltres.ajouterFiltre(new FiltrePeriodesLiquidables());
    listeFiltres.ajouterFiltre(new FiltrePeriodesSansConflit());
    
    listeFiltres.ajouterFiltre(new FiltreFinAvantOuCoincideAvecDate(dateExamen));
    
    listeFiltres.ajouterFiltre(new FiltreActiviteContenuDansPra(periodeRechercheAffiliation));
    
    listeFiltres.ajouterFiltre(new FiltrePeriodeActiviteSalarieeE301(false));
    
    listeFiltres.ajouterFiltre(new FiltrePeriodeActiviteSalarieHorsFrance(false));
    
    ChronologiePeriodes chronoActivitesParticipantes = (ChronologiePeriodes)chronoPasseProfessionnel.copier(listeFiltres);
    resultatDeterminationCompetence.setActiviteParticipantes(chronoActivitesParticipantes);
    
    FiltresTemporel filtreActivitesChampPrive = new FiltresTemporel();
    filtreActivitesChampPrive.ajouterFiltre(new FiltrePeriodeActiviteSalarieeSecteurPrive());
    filtreActivitesChampPrive.ajouterFiltre(new FiltreContratPaysUnionEuropeenne());
    chronoPeriodesFiltrees = (ChronologiePeriodes)chronoActivitesParticipantes.copier(filtreActivitesChampPrive);
    chronoPeriodesActiviteSecteurPrive.ajouter(chronoPeriodesFiltrees);
    resultatDeterminationCompetence.setDureeActiviteSecteurPrive(calculerDureeActivite(periodeRechercheAffiliation, chronoPeriodesFiltrees, resultatDeterminationCompetence, true));
    
    chronoPeriodesFiltrees = (ChronologiePeriodes)chronoActivitesParticipantes.copier(new FiltrePeriodeActiviteSalarieeSecteurPublicAffilie());
    
    chronoPeriodesActiviteSecteurPrive.ajouter(chronoPeriodesFiltrees);
    resultatDeterminationCompetence.setDureeActiviteSecteurPublicAffilie(calculerDureeActivite(periodeRechercheAffiliation, chronoPeriodesFiltrees, resultatDeterminationCompetence, true));
    
    chronoPeriodesFiltrees = (ChronologiePeriodes)chronoActivitesParticipantes.copier(new FiltrePeriodeActiviteSalarieeSecteurPublicAutoAssurance());
    
    chronoPeriodesActiviteSecteurPublic.ajouter(chronoPeriodesFiltrees);
    resultatDeterminationCompetence.setDureeActiviteSecteurPublicAutoAssurance(calculerDureeActivite(periodeRechercheAffiliation, chronoPeriodesFiltrees, resultatDeterminationCompetence, false));
    
    chronoPeriodesFiltrees = (ChronologiePeriodes)chronoActivitesParticipantes.copier(new FiltrePeriodeActiviteSalarieeSecteurPublicConventionGestion());
    
    chronoPeriodesActiviteSecteurPublic.ajouter(chronoPeriodesFiltrees);
    resultatDeterminationCompetence.setDureeActiviteSecteurPublicConventionGestion(calculerDureeActivite(periodeRechercheAffiliation, chronoPeriodesFiltrees, resultatDeterminationCompetence, false));
    
    chronoPeriodesFiltrees = (ChronologiePeriodes)chronoActivitesParticipantes.copier(new FiltrePeriodeActiviteSalarieeSecteurPriveCaCae());
    chronoPeriodesActiviteSecteurPrive.ajouter(chronoPeriodesFiltrees);
    resultatDeterminationCompetence.setDureeActiviteSecteurPriveCaCae(calculerDureeActivite(periodeRechercheAffiliation, chronoPeriodesFiltrees, resultatDeterminationCompetence, true));
    
    resultatDeterminationCompetence.setChronoPeriodesActiviteSecteurPriveRetenues(chronoPeriodesActiviteSecteurPrive);
    resultatDeterminationCompetence.setChronoPeriodesActiviteSecteurPublicRetenues(chronoPeriodesActiviteSecteurPublic);
  }
  
  public void determinerChargeIndemnisationDroitCourant(Demande demande, ResultatDeterminationCompetence resultatDeterminationCompetence)
    throws CoucheLogiqueException
  {
    Periode pra = ((DossierExamen)demande.getDossierExamen()).getConstitutionQuantiteAffiliation().getPeriodePRA();
    
    ChronologiePeriodes chronoPasseProfessionnel = demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation();
    
    determinerCompetenceFinanciereEtAdministrative(pra, chronoPasseProfessionnel, demande.getDateExamen(), resultatDeterminationCompetence);
    
    int dureeActiviteRelevantSecteurPrive = resultatDeterminationCompetence.getDureeActiviteSecteurPrive() + resultatDeterminationCompetence.getDureeActiviteSecteurPublicAffilie() + resultatDeterminationCompetence.getDureeActiviteSecteurPriveCaCae();
    
    int dureeActiviteRelevantSecteurPublic = resultatDeterminationCompetence.getDureeActiviteSecteurPublicAutoAssurance() + resultatDeterminationCompetence.getDureeActiviteSecteurPublicConventionGestion();
    if ((dureeActiviteRelevantSecteurPrive != 0) && (dureeActiviteRelevantSecteurPublic != 0)) {
      verifierOriginePAS((DossierAffecte)demande.getDossierAffectation(), chronoPasseProfessionnel);
    }
    if (dureeActiviteRelevantSecteurPrive > dureeActiviteRelevantSecteurPublic)
    {
      resultatDeterminationCompetence.setChargeIndemnisationDroitCourant(1);
    }
    else if (dureeActiviteRelevantSecteurPrive < dureeActiviteRelevantSecteurPublic)
    {
      resultatDeterminationCompetence.setChargeIndemnisationDroitCourant(2);
    }
    else
    {
      ActiviteSalarie dernierePeriodeActivite = ((DossierExamen)demande.getDossierExamen()).getFaitGenerateur().getPeriodeFaitGenerateur();
      int champApplicationDernierContrat = dernierePeriodeActivite.getMetier().getChampApplication();
      switch (champApplicationDernierContrat)
      {
      case 3: 
      case 4: 
        resultatDeterminationCompetence.setChargeIndemnisationDroitCourant(2);
        break;
      default: 
        resultatDeterminationCompetence.setChargeIndemnisationDroitCourant(1);
      }
    }
  }
  
  private static int calculerDureeActivite(Periode periodeRechercheAffiliation, ChronologiePeriodes chronoPeriodesActiviteFiltrees, ResultatDeterminationCompetence resultatDeterminationCompetence, boolean estActiviteSecteurPrive)
  {
    int dureeActiviteRetournee = 0;
    if ((chronoPeriodesActiviteFiltrees != null) && (!chronoPeriodesActiviteFiltrees.estVide()))
    {
      BigDecimal tempsPartiel = null;
      BigDecimal equivalentJoursTempsPlein = null;
      ActiviteSalarie periodeActiviteSalarieCourante = null;
      Chronologie chronoPeriodesIntensites = null;
      PeriodeIntensite periodeIntensiteCourante = null;
      int dureeIntensiteDansPra = 0;
      
      chronoPeriodesActiviteFiltrees.iterer();
      while (chronoPeriodesActiviteFiltrees.encoreSuivant())
      {
        periodeActiviteSalarieCourante = (ActiviteSalarie)chronoPeriodesActiviteFiltrees.elementSuivant();
        
        chronoPeriodesIntensites = periodeActiviteSalarieCourante.getListePeriodeIntensite();
        chronoPeriodesIntensites.iterer();
        if (chronoPeriodesIntensites.getTaille() == 0)
        {
          dureeIntensiteDansPra = periodeActiviteSalarieCourante.inter(periodeRechercheAffiliation);
          dureeActiviteRetournee += dureeIntensiteDansPra;
        }
        else
        {
          while (chronoPeriodesIntensites.encoreSuivant())
          {
            periodeIntensiteCourante = (PeriodeIntensite)chronoPeriodesIntensites.elementSuivant();
            
            dureeIntensiteDansPra = periodeIntensiteCourante.inter(periodeRechercheAffiliation);
            
            tempsPartiel = Mathematiques.diviseParDefaut(periodeIntensiteCourante.getHorairesSalarie(), periodeIntensiteCourante.getHorairesEntreprise());
            if (tempsPartiel.compareTo(MI_TEMPS) == -1)
            {
              equivalentJoursTempsPlein = new BigDecimal(dureeIntensiteDansPra).multiply(tempsPartiel);
              dureeIntensiteDansPra = Mathematiques.arrondiASup(equivalentJoursTempsPlein, 0).intValue();
              if (estActiviteSecteurPrive) {
                resultatDeterminationCompetence.setEstCoeffTPAppliqueRAC(true);
              } else {
                resultatDeterminationCompetence.setEstCoeffTPAppliqueSP(true);
              }
            }
            dureeActiviteRetournee += dureeIntensiteDansPra;
          }
        }
      }
    }
    return dureeActiviteRetournee;
  }
  
  public void determinerChargeIndemnisationDroitExecutable(Demande demande, ResultatDeterminationCompetence resultatDeterminationCompetence)
    throws CoucheLogiqueException
  {
    CompetenceSpec competenceDroitPrecedent = null;
    if (demande.estEnContexteDroitAnterieurSecteurPublicValide())
    {
      competenceDroitPrecedent = new Competence();
      competenceDroitPrecedent.setCompetenceFinanciere(2);
    }
    else
    {
      AttributionAssuranceSpec attributionPrecedente = demande.rechercherAttributionPrecedenteDuMemeType();
      if ((attributionPrecedente instanceof DossierExamen)) {
        competenceDroitPrecedent = attributionPrecedente.getCompetence();
      }
    }
    if ((competenceDroitPrecedent == null) || (competenceDroitPrecedent.getCompetenceFinanciere() == resultatDeterminationCompetence.getChargeIndemnisationDroitCourant()))
    {
      resultatDeterminationCompetence.setCompetenceFinanciere(resultatDeterminationCompetence.getChargeIndemnisationDroitCourant());
    }
    else
    {
      boolean readmissionDroitCourant = (demande.getObjectifCourant().getSousType() == 12) || (demande.getObjectifCourant().getSousType() == 44);
      
      Periode periodeRechercheAffiliation = ((DossierExamen)demande.getDossierExamen()).getConstitutionQuantiteAffiliation().getPeriodePRA();
      
      ChronologiePeriodes chronoPasseProfessionnel = demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation();
      
      determinerCompetenceFinanciereEtAdministrative(periodeRechercheAffiliation, chronoPasseProfessionnel, demande.getDateExamen(), resultatDeterminationCompetence);
      
      int dureeActiviteRelevantSecteurPrive = resultatDeterminationCompetence.getDureeActiviteSecteurPrive() + resultatDeterminationCompetence.getDureeActiviteSecteurPublicAffilie() + resultatDeterminationCompetence.getDureeActiviteSecteurPriveCaCae();
      
      int dureeActiviteRelevantSecteurPublic = resultatDeterminationCompetence.getDureeActiviteSecteurPublicAutoAssurance() + resultatDeterminationCompetence.getDureeActiviteSecteurPublicConventionGestion();
      if (competenceDroitPrecedent.getCompetenceFinanciere() == 2)
      {
        if (readmissionDroitCourant)
        {
          if ((dureeActiviteRelevantSecteurPrive != 0) && (dureeActiviteRelevantSecteurPublic != 0)) {
            verifierOriginePAS((DossierAffecte)demande.getDossierAffectation(), demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation());
          }
          resultatDeterminationCompetence.setCompetenceFinanciere(1);
        }
        else
        {
          fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ALERTE_SP");
        }
      }
      else
      {
        if ((dureeActiviteRelevantSecteurPrive != 0) && (dureeActiviteRelevantSecteurPublic != 0)) {
          verifierOriginePAS((DossierAffecte)demande.getDossierAffectation(), demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation());
        }
        if (readmissionDroitCourant) {
          resultatDeterminationCompetence.setCompetenceFinanciere(2);
        } else {
          resultatDeterminationCompetence.setCompetenceFinanciere(1);
        }
      }
    }
  }
  
  public void determinerEmployeurCompetentSecteurPublic(Demande demande, ResultatDeterminationCompetence resultatDeterminationCompetence)
    throws CoucheLogiqueException
  {
    Periode periodeRechercheAffiliation = ((DossierExamen)demande.getDossierExamen()).getConstitutionQuantiteAffiliation().getPeriodePRA();
    
    tableEmployeursActivites = new Hashtable();
    
    ChronologiePeriodes chronoPeriodesActiviteSecteurPublicRetenuesPra = resultatDeterminationCompetence.getChronoPeriodesActiviteSecteurPublicRetenues();
    chronoPeriodesActiviteSecteurPublicRetenuesPra.iterer();
    ActiviteSalarie activiteSalarieeCourante = null;
    String identifiantEmployeurCourant = null;
    ChronologiePeriodes chronoPeriodesActiviteParEmployeur = null;
    while (chronoPeriodesActiviteSecteurPublicRetenuesPra.encoreSuivant())
    {
      activiteSalarieeCourante = (ActiviteSalarie)chronoPeriodesActiviteSecteurPublicRetenuesPra.elementSuivant();
      
      identifiantEmployeurCourant = activiteSalarieeCourante.getEntreprise().getIdentifiantBNE();
      if (tableEmployeursActivites.containsKey(identifiantEmployeurCourant))
      {
        chronoPeriodesActiviteParEmployeur = (ChronologiePeriodes)tableEmployeursActivites.get(identifiantEmployeurCourant);
        chronoPeriodesActiviteParEmployeur.ajouter(activiteSalarieeCourante);
      }
      else
      {
        chronoPeriodesActiviteParEmployeur = new ChronologiePeriodes();
        chronoPeriodesActiviteParEmployeur.ajouter(activiteSalarieeCourante);
        tableEmployeursActivites.put(identifiantEmployeurCourant, chronoPeriodesActiviteParEmployeur);
      }
    }
    Hashtable tableEmployeursDureeActiviteDansPra = new Hashtable();
    for (Enumeration enumeration = tableEmployeursActivites.keys(); enumeration.hasMoreElements();)
    {
      identifiantEmployeurCourant = (String)enumeration.nextElement();
      chronoPeriodesActiviteParEmployeur = (ChronologiePeriodes)tableEmployeursActivites.get(identifiantEmployeurCourant);
      int dureeActiviteParEmployeur = calculerDureeActivite(periodeRechercheAffiliation, chronoPeriodesActiviteParEmployeur, resultatDeterminationCompetence, false);
      tableEmployeursDureeActiviteDansPra.put(identifiantEmployeurCourant, Integer.valueOf(dureeActiviteParEmployeur));
    }
    int dureeActiviteLaPlusGrande = 0;
    String identifiantEmployeurCompetent = null;
    for (Enumeration enumeration = tableEmployeursDureeActiviteDansPra.keys(); enumeration.hasMoreElements();)
    {
      identifiantEmployeurCourant = (String)enumeration.nextElement();
      int dureeActiviteParEmployeur = ((Integer)tableEmployeursDureeActiviteDansPra.get(identifiantEmployeurCourant)).intValue();
      if ((dureeActiviteLaPlusGrande == 0) || (dureeActiviteParEmployeur > dureeActiviteLaPlusGrande))
      {
        dureeActiviteLaPlusGrande = dureeActiviteParEmployeur;
        identifiantEmployeurCompetent = identifiantEmployeurCourant;
      }
      else if (dureeActiviteParEmployeur == dureeActiviteLaPlusGrande)
      {
        ChronologiePeriodes chronoPeriodesActiviteTrieesSurDateFin = new ChronologiePeriodes();
        chronoPeriodesActiviteTrieesSurDateFin.setComparateur(new ComparateurTemporelsSurDateFin());
        chronoPeriodesActiviteTrieesSurDateFin.ajouter((ChronologiePeriodes)tableEmployeursActivites.get(identifiantEmployeurCourant));
        chronoPeriodesActiviteTrieesSurDateFin.ajouter((ChronologiePeriodes)tableEmployeursActivites.get(identifiantEmployeurCompetent));
        
        activiteSalarieeCourante = (ActiviteSalarie)chronoPeriodesActiviteTrieesSurDateFin.dernierElement();
        if (activiteSalarieeCourante.getEntreprise().getIdentifiantBNE().equalsIgnoreCase(identifiantEmployeurCourant)) {
          identifiantEmployeurCompetent = identifiantEmployeurCourant;
        }
      }
    }
    resultatDeterminationCompetence.setIdentifiantEmployeurCompetent(identifiantEmployeurCompetent);
    
    chronoPeriodesActiviteParEmployeur = (ChronologiePeriodes)tableEmployeursActivites.get(identifiantEmployeurCompetent);
    activiteSalarieeCourante = (ActiviteSalarie)chronoPeriodesActiviteParEmployeur.premierElement();
    resultatDeterminationCompetence.setLibelleEmployeurCompetent(activiteSalarieeCourante.getEntreprise().getLibelleEntreprise());
    if ((activiteSalarieeCourante.getNumeroConventionGestion() != null) && (activiteSalarieeCourante.getContrat().getCodeAffectation() != null)) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ALERTE_A14MB6");
    }
    resultatDeterminationCompetence.setNumeroConventionGestion(activiteSalarieeCourante.getEntreprise().getNumeroConventionGestion());
  }
  
  public void determinerRegimeFinancementSecteurPrive(Demande demande, ResultatDeterminationCompetence resultatDeterminationCompetence)
    throws CoucheLogiqueException
  {
    ((Attribution)demande.getAttribution()).setRegimeFinancementParticulierCaCae(false);
    if (resultatDeterminationCompetence != null)
    {
      int dureeActiviteSecteurPrive = resultatDeterminationCompetence.getDureeActiviteSecteurPrive() + resultatDeterminationCompetence.getDureeActiviteSecteurPublicAffilie();
      
      int dureeActiviteSecteurPriveCaCae = resultatDeterminationCompetence.getDureeActiviteSecteurPriveCaCae();
      if (dureeActiviteSecteurPriveCaCae > dureeActiviteSecteurPrive)
      {
        ((Attribution)demande.getAttribution()).setRegimeFinancementParticulierCaCae(true);
      }
      else if (dureeActiviteSecteurPriveCaCae == dureeActiviteSecteurPrive)
      {
        Damj dateFaitGenerateur = ((DossierExamen)demande.getDossierExamen()).getFaitGenerateur().getDateFaitGenerateur();
        
        ChronologiePeriodes chronoPeriodesActiviteSecteurPriveRetenues = (ChronologiePeriodes)resultatDeterminationCompetence.getChronoPeriodesActiviteSecteurPriveRetenues().copier(new FiltreFinAvantOuCoincideAvecDate(dateFaitGenerateur));
        
        chronoPeriodesActiviteSecteurPriveRetenues.setComparateur(new ComparateurTemporelsSurDateFin());
        if (!chronoPeriodesActiviteSecteurPriveRetenues.estVide())
        {
          ActiviteSalarie derniereActiviteSecteurPrive = (ActiviteSalarie)chronoPeriodesActiviteSecteurPriveRetenues.premierElement();
          
          ChronologiePeriodes chronoActiviteMemeDateFin = (ChronologiePeriodes)chronoPeriodesActiviteSecteurPriveRetenues.copier(new FiltreMemeDateFin(derniereActiviteSecteurPrive.getDateFin()));
          if (chronoActiviteMemeDateFin.getTaille() > 1)
          {
            ChronologiePeriodes chronoActiviteMemeDateFinEtCaCae = (ChronologiePeriodes)chronoActiviteMemeDateFin.copier(new FiltrePeriodeActiviteSalarieeSecteurPriveCaCae());
            if ((chronoActiviteMemeDateFinEtCaCae != null) && (!chronoActiviteMemeDateFinEtCaCae.estVide())) {
              ((Attribution)demande.getAttribution()).setRegimeFinancementParticulierCaCae(true);
            }
          }
          else
          {
            int champApplicationDernierContrat = derniereActiviteSecteurPrive.getMetier().getChampApplication();
            if (champApplicationDernierContrat == 9) {
              ((Attribution)demande.getAttribution()).setRegimeFinancementParticulierCaCae(true);
            }
          }
        }
      }
    }
  }
  
  public void verifierOriginePAS(DossierAffecte dossierAffectation, Chronologie chronoPasseProfessionnel)
    throws CoucheLogiqueException
  {
    Periode praLaPlusLongue = ((ProduitAsuSpec)dossierAffectation.getProduit()).determinerPraLaPlusLongue(dossierAffectation.getDemande(), dossierAffectation.getValidationProduit().getPeriodeValidationProduit());
    
    FiltresTemporel listeFiltres = new FiltresTemporel();
    listeFiltres.ajouterFiltre(new FiltreChevauchePeriode(praLaPlusLongue));
    
    FiltrePeriodesSurFiltresExclusifs filtre = new FiltrePeriodesSurFiltresExclusifs();
    filtre.ajouterFiltre(new FiltrePeriodeDsmTravail());
    
    listeFiltres.ajouterFiltre(filtre);
    Chronologie chronoPeriodeDNJ = chronoPasseProfessionnel.copier(listeFiltres);
    if (!chronoPeriodeDNJ.estVide()) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ALERTE_A14MB1_DNJ", new Object[] { chronoPeriodeDNJ.dernierElement().getDateDebut(), chronoPeriodeDNJ.dernierElement().getDateFin() });
    }
    filtre = new FiltrePeriodesSurFiltresExclusifs();
    FiltresTemporel filtreCertifieeNonQualifiee = new FiltresTemporel();
    filtreCertifieeNonQualifiee.ajouterFiltre(new FiltrePeriodesCertifiees());
    filtreCertifieeNonQualifiee.ajouterFiltre(new FiltrePeriodesQualifiables(false));
    filtre.ajouterFiltre(filtreCertifieeNonQualifiee);
    
    listeFiltres.vider();
    listeFiltres.ajouterFiltre(new FiltreChevauchePeriode(praLaPlusLongue));
    listeFiltres.ajouterFiltre(filtre);
    
    listeFiltres.ajouterFiltre(new FiltrePeriodeActiviteNonSalariee(false));
    listeFiltres.ajouterFiltre(new FiltreFinAvantOuCoincideAvecDate(dossierAffectation.getDemande().getDateExamen()));
    
    Chronologie chronoPeriodeCNQ = chronoPasseProfessionnel.copier(listeFiltres);
    if (!chronoPeriodeCNQ.estVide()) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ALERTE_A14MB1_CNQ", new Object[] { chronoPeriodeCNQ.dernierElement().getDateDebut(), chronoPeriodeCNQ.dernierElement().getDateFin() });
    }
    filtre = new FiltrePeriodesSurFiltresExclusifs();
    FiltrePeriodesSurFiltresExclusifs filtreOu = new FiltrePeriodesSurFiltresExclusifs();
    FiltresTemporel filtreConflitJustifiee = new FiltresTemporel();
    filtreConflitJustifiee.ajouterFiltre(new FiltrePeriodesAvecConflit());
    filtreOu.ajouterFiltre(new FiltrePeriodesJustifiees());
    filtreOu.ajouterFiltre(new FiltrePeriodesCertifiees());
    filtreConflitJustifiee.ajouterFiltre(filtreOu);
    filtre.ajouterFiltre(filtreConflitJustifiee);
    
    listeFiltres.vider();
    listeFiltres.ajouterFiltre(new FiltreChevauchePeriode(praLaPlusLongue));
    listeFiltres.ajouterFiltre(filtre);
    Chronologie chronoPeriodeNDNJC = chronoPasseProfessionnel.copier(listeFiltres);
    if (!chronoPeriodeNDNJC.estVide()) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ALERTE_A14MB1_NDNJC", new Object[] { chronoPeriodeNDNJC.dernierElement().getDateDebut(), chronoPeriodeNDNJC.dernierElement().getDateFin() });
    }
  }
  
  public static void determinerCompetencesProduitResultant(Demande demandeCourante, BigDecimal capitalCourant, BigDecimal capitalPrecedent)
    throws CoucheLogiqueException
  {
    int combinaisonCompetence = 0;
    int codeCompAdmCourante = 0;
    int codeCompFinanceCourante = 0;
    int codeCompAdmPrecedente = 0;
    int codeCompFinancePrecedente = 0;
    DossierExamenAssuranceSpec dossierExamenPrecedent = null;
    String numeroConventionGestionDroitPrecedent = null;
    String employeurPrecedent = null;
    
    CompetenceSpec competencesCourantes = ((DossierExamenAssuranceSpec)demandeCourante.getDossierExamen()).getCompetence();
    codeCompAdmCourante = competencesCourantes.getCompetenceAdministrative();
    codeCompFinanceCourante = competencesCourantes.getCompetenceFinanciere();
    if (demandeCourante.estEnContexteDroitAnterieurSecteurPublicValide())
    {
      codeCompAdmPrecedente = 2;
      codeCompFinancePrecedente = 2;
    }
    else
    {
      dossierExamenPrecedent = (DossierExamenAssuranceSpec)demandeCourante.getAttribution().getAttributionPrecedente().getDossierAffecte().getDossierExamen();
      codeCompAdmPrecedente = dossierExamenPrecedent.getCompetence().getCompetenceAdministrative();
      codeCompFinancePrecedente = dossierExamenPrecedent.getCompetence().getCompetenceFinanciere();
      CompetenceSpec competencePrecedent = dossierExamenPrecedent.getCompetence();
      numeroConventionGestionDroitPrecedent = competencePrecedent.getNumeroConventionGestion();
      employeurPrecedent = competencePrecedent.getLibelleEmployeurCompetent();
    }
    combinaisonCompetence = determinationCombinaisonCompetenceAdmFinance(codeCompFinancePrecedente, codeCompAdmPrecedente, codeCompFinanceCourante, codeCompAdmCourante);
    
    determinationCompetences(employeurPrecedent, numeroConventionGestionDroitPrecedent, combinaisonCompetence, competencesCourantes, capitalCourant, capitalPrecedent);
  }
  
  private static void determinationCompetences(String employeurPrecedent, String numeroConventionGestionDroitPrecedent, int combinaisonCompetence, CompetenceSpec competencesCourantes, BigDecimal capitalCourant, BigDecimal capitalPrecedent)
    throws CoucheLogiqueException
  {
    switch (combinaisonCompetence)
    {
    case 9: 
      if (capitalPrecedent.compareTo(capitalCourant) > 0)
      {
        competencesCourantes.setCompetenceAdministrative(1);
        competencesCourantes.setCompetenceFinanciere(1);
        competencesCourantes.setLibelleEmployeurCompetent("");
      }
      break;
    case 5: 
      break;
    case 8: 
      if (capitalPrecedent.compareTo(capitalCourant) > 0)
      {
        competencesCourantes.setCompetenceAdministrative(1);
        competencesCourantes.setCompetenceFinanciere(1);
        competencesCourantes.setNumeroConventionGestion("");
        competencesCourantes.setLibelleEmployeurCompetent("");
      }
      break;
    case 1: 
      if (capitalPrecedent.compareTo(capitalCourant) > 0)
      {
        competencesCourantes.setNumeroConventionGestion(numeroConventionGestionDroitPrecedent);
        competencesCourantes.setLibelleEmployeurCompetent(employeurPrecedent);
      }
      break;
    case 3: 
      if (capitalPrecedent.compareTo(capitalCourant) > 0)
      {
        competencesCourantes.setCompetenceAdministrative(1);
        competencesCourantes.setCompetenceFinanciere(2);
        competencesCourantes.setNumeroConventionGestion(numeroConventionGestionDroitPrecedent);
        competencesCourantes.setLibelleEmployeurCompetent(employeurPrecedent);
      }
      break;
    case 6: 
      if (capitalPrecedent.compareTo(capitalCourant) > 0)
      {
        competencesCourantes.setCompetenceAdministrative(1);
        competencesCourantes.setCompetenceFinanciere(2);
        competencesCourantes.setNumeroConventionGestion(numeroConventionGestionDroitPrecedent);
        competencesCourantes.setLibelleEmployeurCompetent(employeurPrecedent);
      }
      break;
    case 7: 
      if (capitalPrecedent.compareTo(capitalCourant) > 0)
      {
        competencesCourantes.setCompetenceAdministrative(2);
        competencesCourantes.setCompetenceFinanciere(2);
      }
      break;
    case 2: 
      if (capitalPrecedent.compareTo(capitalCourant) > 0)
      {
        competencesCourantes.setCompetenceAdministrative(2);
        competencesCourantes.setCompetenceFinanciere(2);
        competencesCourantes.setNumeroConventionGestion("");
        competencesCourantes.setLibelleEmployeurCompetent("");
      }
      break;
    case 4: 
      break;
    }
  }
  
  private static int determinationCombinaisonCompetenceAdmFinance(int codeCompFinancePrecedente, int codeCompAdmPrecedente, int codeCompFinanceCourante, int codeCompAdmCourante)
  {
    int combinaisonCompetences = 0;
    if ((estCompRAC(codeCompFinancePrecedente)) && (estCompRAC(codeCompAdmPrecedente)) && (estCompSP(codeCompFinanceCourante)) && (estCompRAC(codeCompAdmCourante))) {
      combinaisonCompetences = 8;
    } else if ((estCompRAC(codeCompFinancePrecedente)) && (estCompRAC(codeCompAdmPrecedente)) && (estCompSP(codeCompFinanceCourante)) && (estCompSP(codeCompAdmCourante))) {
      combinaisonCompetences = 9;
    } else if ((estCompRAC(codeCompFinancePrecedente)) && (estCompRAC(codeCompAdmPrecedente)) && (estCompRAC(codeCompFinanceCourante)) && (estCompRAC(codeCompAdmCourante))) {
      combinaisonCompetences = 5;
    } else if ((estCompSP(codeCompFinancePrecedente)) && (estCompRAC(codeCompAdmPrecedente)) && (estCompSP(codeCompFinanceCourante)) && (estCompRAC(codeCompAdmCourante))) {
      combinaisonCompetences = 1;
    } else if ((estCompSP(codeCompFinancePrecedente)) && (estCompRAC(codeCompAdmPrecedente)) && (estCompSP(codeCompFinanceCourante)) && (estCompSP(codeCompAdmCourante))) {
      combinaisonCompetences = 3;
    } else if ((estCompSP(codeCompFinancePrecedente)) && (estCompRAC(codeCompAdmPrecedente)) && (estCompRAC(codeCompFinanceCourante)) && (estCompRAC(codeCompAdmCourante))) {
      combinaisonCompetences = 6;
    } else if ((estCompSP(codeCompFinancePrecedente)) && (estCompSP(codeCompAdmPrecedente)) && (estCompSP(codeCompFinanceCourante)) && (estCompRAC(codeCompAdmCourante))) {
      combinaisonCompetences = 2;
    } else if ((estCompSP(codeCompFinancePrecedente)) && (estCompSP(codeCompAdmPrecedente)) && (estCompSP(codeCompFinanceCourante)) && (estCompSP(codeCompAdmCourante))) {
      combinaisonCompetences = 4;
    } else if ((estCompSP(codeCompFinancePrecedente)) && (estCompSP(codeCompAdmPrecedente)) && (estCompRAC(codeCompFinanceCourante)) && (estCompRAC(codeCompAdmCourante))) {
      combinaisonCompetences = 7;
    }
    return combinaisonCompetences;
  }
  
  private static boolean estCompSP(int competence)
  {
    return competence == 2;
  }
  
  private static boolean estCompRAC(int competence)
  {
    return competence == 1;
  }
  
  public void determinerCompetenceFinanciere(Demande demande, ResultatDeterminationCompetence resultatDeterminationCompetence)
    throws CoucheLogiqueException
  {}
}

/* Location:
 * Qualified Name:     DeterminationCompetence
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */