package fr.unedic.cali.asu.cge01.p02.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Attribution;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionCaractereSaisonnier;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionCoefficientSaisonnier;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionCoefficientTempsPartiel;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionSjc;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionSjr;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Sjcip;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Sjrip;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.dom.Sjc;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.outilsfonctionnels.OutilAsp;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.produits.liquidation.dom.Competence;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.Competences;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P02;
import fr.unedic.cali.dom.affectation.ProduitSecurisationProfessionnelleSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.services.OutilFonctionnel;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public class RecuperationElementIndemnisation
  implements OutilFonctionnel
{
  public static ElementBaseIndemnisation recupererElementBaseIndemnisation(AttributionSpec attribution)
  {
    ElementBaseIndemnisation ebi = new ElementBaseIndemnisation();
    alimenterEBIavecAttribution(attribution, ebi);
    if ((OutilGestionContexteDemande.estContexteDemandeAssurancePresent((Demande)attribution.getDemande(), "ASPDC")) || (OutilGestionContexteDemande.estContexteDemandeAssurancePresent((Demande)attribution.getDemande(), "PAPDC")))
    {
      ElementBaseIndemnisation sousEbiAspSousJacent = new ElementBaseIndemnisation();
      fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.RecuperationElementIndemnisation.alimenterEBIavecAttributionEntreeAspSousJacent(attribution, sousEbiAspSousJacent);
      
      Collection<ElementBaseIndemnisation> listeSousEbiAdmissions = new ArrayList();
      alimenterListeEBIAvecODouNovationOuRevision(attribution, listeSousEbiAdmissions);
      
      Collection<ElementBaseIndemnisation> listeSousEbi = new ArrayList();
      listeSousEbi.add(sousEbiAspSousJacent);
      listeSousEbi.addAll(listeSousEbiAdmissions);
      ebi.setListeSousEBI(listeSousEbi);
    }
    return ebi;
  }
  
  private static void alimenterListeEBIAvecODouNovationOuRevision(AttributionSpec attribution, Collection<ElementBaseIndemnisation> listeSousEbi)
  {
    Attribution attributionCourante = (Attribution)attribution;
    
    Collection<DemandeAssuranceSpec> admissionsDurantDispositifCsp = OutilAsp.getInstance().recupererAdmissionsDurantDispositifCSP(attributionCourante);
    if (!admissionsDurantDispositifCsp.isEmpty())
    {
      Iterator<DemandeAssuranceSpec> iterDemande = admissionsDurantDispositifCsp.iterator();
      while (iterDemande.hasNext())
      {
        DemandeAssuranceSpec demande = (DemandeAssuranceSpec)iterDemande.next();
        ElementBaseIndemnisation ebi = new ElementBaseIndemnisation();
        alimenterEBIavecAttribution(demande.getAttribution(), ebi);
        
        ebi.setProduitMontantRetenu(demande.getAttribution().getProduitMontantRetenu());
        
        Competences competenceAttribution = creerConteneurCompetence(demande.getAttribution());
        ebi.setCompetence(competenceAttribution);
        
        ebi.setAvecPrecompteCRC(demande.getAttribution().estAvecPrecompteCRC());
        listeSousEbi.add(ebi);
      }
    }
  }
  
  private static void alimenterEBIavecAttribution(AttributionSpec attribution, ElementBaseIndemnisation ebi)
  {
    Attribution attributionCourante = (Attribution)attribution;
    
    ebi.setSjr(getSJR(attributionCourante));
    ebi.setSjc(getSJC(attributionCourante));
    
    ebi.setCoefficientSaisonnier(getCoefficientSaisonnier(attributionCourante));
    
    Quantite dureePostPrime = attributionCourante.getDureePostPrime();
    if ((dureePostPrime != null) && (dureePostPrime.getValeurEntiere() == 0)) {
      ebi.setEstDureePostPrimeEpuisee(true);
    }
    if (attributionCourante.getConstitutionCaractereSaisonnier() != null)
    {
      if (((Demande)attribution.getDemande()).getDonneesTemporaires().isCaractereSaisonnierForce())
      {
        if (((Demande)attribution.getDemande()).getDonneesTemporaires().getTypeCaractereSaisonnierForce() == 1) {
          ebi.setIsConditionCaractereSaisonnierParRythme(true);
        }
      }
      else {
        ebi.setIsConditionCaractereSaisonnierParRythme(attributionCourante.getConstitutionCaractereSaisonnier().getActivite3Sur5());
      }
      ebi.setTypeCaractereSaisonnierRetenu(attributionCourante.getConstitutionCaractereSaisonnier().getTypeCaractereSaisonnierRetenu());
    }
    else
    {
      ebi.setIsConditionCaractereSaisonnierParRythme(false);
      ebi.setTypeCaractereSaisonnierRetenu(-1);
    }
    ebi.setIsSjrBaseSurPourcentageSMIC(attributionCourante.isTopContratsRemuneresBaseSmic());
    
    ebi.setCoefficientTempsPartiel(getCoefficientTempsPartiel(attributionCourante));
    if (attributionCourante.getConstitutionSjr() != null) {
      ebi.setCodeEmploiA2B(attributionCourante.getConstitutionSjr().getCodeEmploiA2b());
    }
    ebi.setReglementApplicableMontantRetenu(attributionCourante.getReglementApplicable());
    if (((attribution.getDemande() != null) && (OutilGestionContexteDemande.estContexteDemandeAssurancePresent((Demande)attribution.getDemande(), "ARECOURCSP"))) || (OutilGestionContexteDemande.estContexteDemandeAssurancePresent((Demande)attribution.getDemande(), "AREENTRCSP"))) {
      ebi.setProduitAreActif(attribution.getProduit());
    } else if ((attribution.getProduit() instanceof ProduitSecurisationProfessionnelleSpec)) {
      ebi.setProduitAreActif(((ProduitSecurisationProfessionnelleSpec)attribution.getProduit()).recupererProduitAreActif(attribution));
    }
  }
  
  private static Sjc getSJC(Attribution p_attribution)
  {
    Sjc sjcTemporaire = null;
    if ((p_attribution.getConstitutionSjc() != null) && (p_attribution.getConstitutionSjc().getSjcip() != null)) {
      sjcTemporaire = new Sjc(p_attribution.getConstitutionSjc().getSjcip().getSjcInitial().getValeur(), p_attribution.getConstitutionSjc().getSjcip().getDateEffet(), null);
    } else {
      sjcTemporaire = new Sjc(new BigDecimal("0"), p_attribution.getConstitutionSjr().getSjrip().getDateEffet(), null);
    }
    return sjcTemporaire;
  }
  
  private static Sjr getSJR(Attribution p_attribution)
  {
    Sjr sjrTemporaire = null;
    if ((p_attribution.getConstitutionSjr() != null) && (p_attribution.getConstitutionSjr().getSjrip() != null)) {
      sjrTemporaire = new Sjr(p_attribution.getConstitutionSjr().getSjrip().getSjrInitial().getValeur(), p_attribution.getConstitutionSjr().getSjrip().getDateEffet(), null);
    }
    return sjrTemporaire;
  }
  
  private static BigDecimal getCoefficientTempsPartiel(Attribution p_attribution)
  {
    BigDecimal valeurCoefficientTempsPartiel = null;
    if ((p_attribution.getReglementApplicable() != null) && (p_attribution.getReglementApplicable().getReglement() != null) && (p_attribution.getReglementApplicable().getReglement().equals(ProduitAsuCge01P02.getInstance().getReglement("A4")))) {
      valeurCoefficientTempsPartiel = new BigDecimal("1");
    } else if (p_attribution.getConstitutionCoefficientTempsPartiel() != null) {
      valeurCoefficientTempsPartiel = p_attribution.getConstitutionCoefficientTempsPartiel().getCoefficientTempsPartielRetenu();
    }
    if (valeurCoefficientTempsPartiel == null) {
      valeurCoefficientTempsPartiel = new BigDecimal("1");
    }
    return valeurCoefficientTempsPartiel;
  }
  
  private static BigDecimal getCoefficientSaisonnier(Attribution p_attribution)
  {
    BigDecimal valeurCoefficientSaisonnier = null;
    if (p_attribution.getConstitutionCoefficientSaisonnier() != null) {
      valeurCoefficientSaisonnier = p_attribution.getConstitutionCoefficientSaisonnier().getCoefficientSaisonnierRetenu();
    }
    if (valeurCoefficientSaisonnier == null) {
      valeurCoefficientSaisonnier = new BigDecimal("1");
    }
    return valeurCoefficientSaisonnier;
  }
  
  public static ElementBaseIndemnisation recupererElementBaseIndemnisation(DonneesTemporaires p_donneesForcees)
  {
    return recupererElementBaseIndemnisation(p_donneesForcees, null);
  }
  
  public static ElementBaseIndemnisation recupererElementBaseIndemnisation(DonneesTemporaires p_donneesForcees, AttributionSpec p_attribution)
  {
    ElementBaseIndemnisation ebi = new ElementBaseIndemnisation();
    
    ebi.setSjr(new Sjr(p_donneesForcees.getSjrSP().getValeur(), p_donneesForcees.getTermePrcSp(), null));
    
    ebi.setCoefficientSaisonnier(p_donneesForcees.getCoefficientSaisonnierSp());
    
    ebi.setIsConditionCaractereSaisonnierParRythme(false);
    ebi.setTypeCaractereSaisonnierRetenu(p_donneesForcees.getTypeCaractereSaisonnierForce());
    
    ebi.setCoefficientTempsPartiel(p_donneesForcees.getCoefficientTempsPartielSp());
    
    ebi.setIsSjrBaseSurPourcentageSMIC(false);
    
    ebi.setReglementApplicableMontantRetenu(null);
    if (p_attribution != null)
    {
      Attribution attribution = (Attribution)p_attribution;
      ebi.setReglementApplicableMontantRetenu(attribution.getReglementApplicable());
    }
    return ebi;
  }
  
  private static Competences creerConteneurCompetence(AttributionAssuranceSpec p_attribution)
  {
    Competences conteneurCompetences = new Competences();
    conteneurCompetences.setCompetenceAdministrative(p_attribution.getCompetenceAdministrative());
    conteneurCompetences.setCompetenceFinanciere(p_attribution.getCompetenceFinanciere());
    conteneurCompetences.setConventionGestion(p_attribution.getConventionGestion());
    if ((p_attribution.getCompetence() instanceof Competence)) {
      conteneurCompetences.setEstPCRCForce(((Competence)p_attribution.getCompetence()).isEstPCRCForce());
    }
    return conteneurCompetences;
  }
}

/* Location:
 * Qualified Name:     RecuperationElementIndemnisation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */