package fr.unedic.cali.asu.cge01.p03.antecedent;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.liquidation.dom.ConteneurConditionActiviteConservee;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Antecedent;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.CarenceIccp;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.CarenceIslr;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Competence;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConditionActiviteConservee;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConditionAge;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConditionFaitGenerateur;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionCaractereSaisonnier;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionCoefficientSaisonnier;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionCoefficientTempsPartiel;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDateAttribution;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDelais;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDurees;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionPointDepartIndemnisation;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionProduitResultant;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionSjc;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionSjr;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Differe;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DureeIndemnisation;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.EnsembleCarences;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Poursuite;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Prc;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.PrcSjr;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.PreavisMesureConservatoireNonIndemnisable;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Sjcip;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Sjrip;
import fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.DeterminationMontantBrut;
import fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.DeterminationSjrip;
import fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.RechercheConditionCumulActiviteConservee;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffecte;
import fr.unedic.cali.asu.dom.DossierExamenAssuranceSpec;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.dom.SaisieAntecedent;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionDateLimiteIndemnisation;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.DeterminationDateLimiteIndemnisation;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.ResultatDeterminationDateLimiteIndemnisation;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.EvenementReferenceExamenSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.Retraite;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.outilsfonctionnels.OutilRetraite;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.ObjetChronoPeriodeConcrete;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;

public class GrapheAntecedent
  extends fr.unedic.cali.asu.cge01.antecedent.GrapheAntecedent
{
  public static GrapheAntecedent getInstance()
  {
    return new GrapheAntecedent();
  }
  
  protected void initialiserDossierExamen(Demande demande)
    throws CoucheLogiqueException
  {
    if ((7 == demande.getSaisieAntecedent().getContexteDemande().intValue()) || (5 == demande.getSaisieAntecedent().getContexteDemande().intValue())) {
      demande.getDossierAffectation().setDossierExamen(new Poursuite());
    } else {
      demande.getDossierAffectation().setDossierExamen(new Antecedent());
    }
  }
  
  protected void alimenterConditionsAdmission(Demande demande)
    throws CoucheLogiqueException
  {
    SaisieAntecedent saisieAntecedent = demande.getSaisieAntecedent();
    fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen dossierExamen = (fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen)demande.getDossierExamen();
    
    alimenterConditionFaitGenerateur(dossierExamen, saisieAntecedent);
    
    alimenterConditionAge(dossierExamen);
  }
  
  protected void alimenterConditionFaitGenerateur(fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen dossierExamen, SaisieAntecedent saisieAntecedent)
  {
    IndividuSpec demandeur = dossierExamen.getDemande().getDemandeur();
    ConditionFaitGenerateur conditionFaitGenerateur = dossierExamen.createConditionFaitGenerateur();
    
    String identifiantFaitGenerateur = saisieAntecedent.getIdentifiantFaitGenerateur();
    ActiviteSalarie periodeFaitGenerateur = (ActiviteSalarie)demandeur.rechercherPeriodePasseProfessionnel(identifiantFaitGenerateur);
    
    conditionFaitGenerateur.setPeriodeFaitGenerateur(periodeFaitGenerateur);
    conditionFaitGenerateur.setAgeIndividuDateFG(demandeur.getAgeALaDate(periodeFaitGenerateur.getDateFin()));
    conditionFaitGenerateur.setEtatSatisfait(true);
  }
  
  protected void alimenterConditionAge(fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen dossierExamen)
    throws CoucheLogiqueException
  {
    IndividuSpec demandeur = dossierExamen.getDemande().getDemandeur();
    ConditionAge conditionAge = dossierExamen.createConditionAge();
    
    Damj dateEffetTheoriquePensionRetraite = OutilRetraite.getInstance().determinerRetraite(demandeur).getDate();
    conditionAge.setDateEffetPension(dateEffetTheoriquePensionRetraite);
  }
  
  protected void alimenterConstituantsAdmission(Demande demande)
    throws CoucheLogiqueException
  {
    SaisieAntecedent saisieAntecedent = demande.getSaisieAntecedent();
    fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen dossierExamen = (fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen)demande.getDossierExamen();
    
    alimenterConstitutionDateAttribution(dossierExamen, saisieAntecedent);
    
    alimenterConstitutionReglementApplicable(dossierExamen, saisieAntecedent);
    
    alimenterConstitutionSjr(dossierExamen, saisieAntecedent);
    
    alimenterConstitutionSjc(dossierExamen, saisieAntecedent);
    
    alimenterConstitutionCoefficientTempsPartiel(dossierExamen, saisieAntecedent);
    
    alimenterConstitutionCaractereSaisonnier(dossierExamen, saisieAntecedent);
    
    alimenterConstitutionCoefficientSaisonnier(dossierExamen, saisieAntecedent);
    
    alimenterConstitutionDurees(dossierExamen, saisieAntecedent);
    
    Competence competence = new Competence();
    dossierExamen.setCompetence(competence);
    alimenterCompetence((Demande)dossierExamen.getDemande(), competence, saisieAntecedent);
    if ((OutilGestionContexteDemande.estContexteDemandeAssurancePresent(demande, "ASPARE")) || (OutilGestionContexteDemande.estContexteDemandeAssurancePresent(demande, "ASPDC")))
    {
      Competence competenceSousJacente = new Competence();
      competenceSousJacente.setCompetenceAdministrative(1);
      competenceSousJacente.setCompetenceFinanciere(1);
      dossierExamen.setCompetenceSousJacente(competenceSousJacente);
    }
    alimenterConstitutionMontantBrut(dossierExamen, saisieAntecedent);
    
    alimenterConstitutionProduitResultant(dossierExamen, saisieAntecedent);
    
    alimenterConstitutionDelais(dossierExamen, saisieAntecedent);
    
    alimenterConstitutionPointDeDepart(dossierExamen, saisieAntecedent);
  }
  
  protected void alimenterConstitutionDateAttribution(fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen dossierExamen, SaisieAntecedent saisieAntecedent)
  {
    ConstitutionDateAttribution constitutionDateAttribution = dossierExamen.createConstitutionDateAttribution();
    
    Damj dateAttribution = saisieAntecedent.getDateAttribution();
    
    constitutionDateAttribution.setDateAttribution(dateAttribution);
  }
  
  protected void alimenterConstitutionReglementApplicable(fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen dossierExamen, SaisieAntecedent saisieAntecedent)
  {
    ReglementApplicableSpec constitutionReglementApplicable = dossierExamen.createConstitutionReglementApplicable();
    
    Reglement reglement = ((DossierAffecte)dossierExamen.getDossierAffecte()).getReglementPeriodeValidationProduit();
    
    constitutionReglementApplicable.setReglement(reglement);
  }
  
  protected void alimenterConstitutionSjr(fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen dossierExamen, SaisieAntecedent saisieAntecedent)
    throws CoucheLogiqueException
  {
    ConstitutionSjr constitutionSjr = dossierExamen.createConstitutionSjr();
    Sjrip sjrip = constitutionSjr.createSjrip();
    
    Integer codeEmploiA2b = saisieAntecedent.getCodeEmploiA2B();
    Damj termePRC = saisieAntecedent.getTermePRC();
    Damj debutPrc = saisieAntecedent.getDateDebutPRC();
    
    Quantite sjrPlafonne = saisieAntecedent.getSalaireJournalierReferencePlafonne();
    boolean topRemunerationBaseSMIC = saisieAntecedent.isSalaireReferenceSurBaseSMIC();
    if ((codeEmploiA2b != null) && (codeEmploiA2b.intValue() != 0))
    {
      termePRC = saisieAntecedent.getPeriodeFctRetenue().getDateFin();
      debutPrc = termePRC;
      Sjrip srip = DeterminationSjrip.determinerSjripPourA2B((Demande)dossierExamen.getDemande());
      sjrPlafonne = new QuantiteEuro(srip.getSjrip());
    }
    if (saisieAntecedent.getCodeEmploiA2B() != null) {
      constitutionSjr.setCodeEmploiA2b(codeEmploiA2b.intValue());
    }
    PrcSjr prcSjr = new PrcSjr(new Periode(debutPrc, termePRC));
    sjrip.setPrc(prcSjr);
    sjrip.setDateEvenement(termePRC);
    sjrip.setPlafondSjr(prcSjr.getPlafondSjr());
    sjrip.setSjrInitial(new QuantiteEuro(sjrPlafonne.getValeur()));
    constitutionSjr.getSjrip().getPrc().setTopContratsDeTypeParticulier(topRemunerationBaseSMIC);
    constitutionSjr.setSjrrp(new Sjr(sjrPlafonne.getValeur()));
    
    prcSjr.setDiviseur(null);
  }
  
  protected void alimenterConstitutionSjc(fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen dossierExamen, SaisieAntecedent saisieAntecedent)
    throws CoucheLogiqueException
  {
    Quantite sjcPlafonne = saisieAntecedent.getSalaireJournalierConservePlafonne();
    Damj termePRC = saisieAntecedent.getTermePRC();
    
    controleActivitesConservees(dossierExamen, sjcPlafonne);
    if (sjcPlafonne != null)
    {
      ConstitutionSjc constitutionSjc = dossierExamen.createConstitutionSjc();
      constitutionSjc.createSjcip();
      
      determinerListeActiviteConservees(dossierExamen, saisieAntecedent);
      
      constitutionSjc.getSjcip().setSjcInitial(new QuantiteEuro(sjcPlafonne.getValeur()));
      constitutionSjc.getSjcip().setDateEvenement(termePRC);
    }
  }
  
  private void determinerListeActiviteConservees(fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen dossierExamen, SaisieAntecedent saisieAntecedent)
    throws CoucheLogiqueException
  {
    ProduitAsuSpec produit = (ProduitAsuSpec)dossierExamen.getDossierAffecte().getProduit();
    
    Damj dateExamen = dossierExamen.getDemande().getDateExamen();
    
    Damj dateExamenRechercheActiviteConservees = saisieAntecedent.getDateAttribution();
    dossierExamen.getDemande().getEvenementReferenceExamen().setDateEvenement(dateExamenRechercheActiviteConservees);
    
    produit.recalculerActivitesConserveesPourDemandeMigree(dossierExamen.getDemande());
    
    dossierExamen.getDemande().getEvenementReferenceExamen().setDateEvenement(dateExamen);
  }
  
  protected void alimenterConstitutionCoefficientTempsPartiel(fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen dossierExamen, SaisieAntecedent saisieAntecedent)
  {
    ConstitutionCoefficientTempsPartiel constitutionCoefficientTempsPartiel = dossierExamen.getConstitutionElementsActifs().createConstitutionCoefficientTempsPartiel();
    
    BigDecimal coefficientTempsPartiel = saisieAntecedent.getCoefficientTempsPartiel();
    if (coefficientTempsPartiel == null) {
      coefficientTempsPartiel = new BigDecimal("1");
    }
    constitutionCoefficientTempsPartiel.setCoefficientTempsPartielRetenu(coefficientTempsPartiel);
  }
  
  protected void alimenterConstitutionCaractereSaisonnier(fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen dossierExamen, SaisieAntecedent p_saisieAntecedent)
  {
    ConstitutionCaractereSaisonnier constitutionCaractereSaisonnier = dossierExamen.createConstitutionCaractereSaisonnier();
    
    boolean activite3sur5 = p_saisieAntecedent.isA3ansActiviteEn5ans();
    Integer typeCaractereSaisonnier = p_saisieAntecedent.getTypeCaractereSaisonnier();
    
    boolean caractereSaisonnierRetenu = (typeCaractereSaisonnier != null) && ((2 == typeCaractereSaisonnier.intValue()) || (1 == typeCaractereSaisonnier.intValue()));
    
    constitutionCaractereSaisonnier.setActivite3Sur5(activite3sur5);
    constitutionCaractereSaisonnier.setCaractereSaisonnierRetenu(caractereSaisonnierRetenu);
    if (caractereSaisonnierRetenu) {
      constitutionCaractereSaisonnier.setTypeCaractereSaisonnierRetenu(typeCaractereSaisonnier.intValue());
    }
    constitutionCaractereSaisonnier.setPeriodeReferenceSaisonnier(null);
    constitutionCaractereSaisonnier.setPeriodeRechercheActiviteSaisonniere(null);
  }
  
  protected void alimenterConstitutionCoefficientSaisonnier(fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen p_dossierExamen, SaisieAntecedent p_saisieAntecedent)
  {
    ConstitutionCoefficientSaisonnier constitutionCoefficientSaisonnier = p_dossierExamen.createConstitutionCoefficientSaisonnier();
    
    BigDecimal coefficientSaisonnier = p_saisieAntecedent.getCoefficientSaisonnier();
    
    constitutionCoefficientSaisonnier.setCoefficientSaisonnierRetenu(coefficientSaisonnier);
    
    constitutionCoefficientSaisonnier.setJourActiviteDouzeDerniersMois(null);
  }
  
  protected void alimenterConstitutionDurees(fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen p_dossierExamen, SaisieAntecedent p_saisieAntecedent)
    throws CoucheLogiqueException
  {
    ConstitutionDurees constitutionDurees = p_dossierExamen.getConstitutionElementsActifs().createConstitutionDurees();
    DureeIndemnisation dureeIndemnisation = constitutionDurees.createDureeIndemnisation();
    
    Quantite dureeInitialeDroit = p_saisieAntecedent.getDureeInitialeDroit();
    if (dureeInitialeDroit == null) {
      dureeInitialeDroit = new QuantiteJour("0");
    }
    dureeIndemnisation.setDureeTheorique(dureeInitialeDroit);
    dureeIndemnisation.setDureeEffective(dureeInitialeDroit);
    
    dureeIndemnisation.setDureeImputation(null);
    dureeIndemnisation.setQuantiteTotalJourImputation(null);
    dureeIndemnisation.setQuantiteJourImputationForce(null);
  }
  
  protected void alimenterConstitutionMontantBrut(DossierExamenAssuranceSpec dossierExamen, SaisieAntecedent p_saisieAntecedent)
    throws CoucheLogiqueException
  {
    DeterminationMontantBrut.getInstance().determinerMontantsBruts((Demande)dossierExamen.getDemande());
  }
  
  protected void alimenterConstitutionDelais(fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen dossierExamen, SaisieAntecedent saisieAntecedent)
  {
    ConstitutionDelais constitutionDelais = dossierExamen.createConstitutionDelais();
    
    Integer reliquatICCP = saisieAntecedent.getReliquatJoursICCP();
    Integer reliquatISLR = saisieAntecedent.getReliquatJoursISLR();
    Integer reliquatDelaiAttente = saisieAntecedent.getReliquatJoursDelaiAttente();
    Damj dateFinPMC = saisieAntecedent.getDateFinPMC();
    Damj dateOrigine = saisieAntecedent.getDateDernierJourCalcule();
    ObjetChronoPeriodeConcrete periodeOrigine = new ObjetChronoPeriodeConcrete(dateOrigine, dateOrigine);
    Damj debutProchaineCarence = dateOrigine.lendemain();
    
    EnsembleCarences ensembleCarence = new EnsembleCarences();
    boolean ajouterEnsembleCarence = false;
    if (dateFinPMC != null)
    {
      PreavisMesureConservatoireNonIndemnisable pmc = new PreavisMesureConservatoireNonIndemnisable();
      
      Periode periodeApplicationPMC = new Periode(debutProchaineCarence, dateFinPMC);
      pmc.setPeriodeApplicationCarence(periodeApplicationPMC);
      
      pmc.setQuantiteInitialJour(periodeApplicationPMC.getDuree());
      
      pmc.setOrigine(periodeOrigine);
      
      debutProchaineCarence = periodeApplicationPMC.getFin().lendemain();
      
      ajouterEnsembleCarence = true;
      
      ensembleCarence.setCarencePmc(pmc);
    }
    if ((reliquatICCP != null) && (reliquatICCP.intValue() > 0))
    {
      CarenceIccp iccp = new CarenceIccp();
      
      iccp.setQuantiteInitialJour(reliquatICCP.intValue());
      
      Damj finProchainePeriode = debutProchaineCarence.deplacerVersAvant(new DureeCalendaire(0, 0, iccp.getQuantiteInitialJour())).veille();
      
      Periode periodeApplicationICCP = new Periode(debutProchaineCarence, finProchainePeriode);
      iccp.setPeriodeApplicationCarence(periodeApplicationICCP);
      
      iccp.setOrigine(periodeOrigine);
      
      debutProchaineCarence = periodeApplicationICCP.getFin().lendemain();
      
      ajouterEnsembleCarence = true;
      
      ensembleCarence.setCarenceIccp(iccp);
    }
    if ((reliquatISLR != null) && (reliquatISLR.intValue() > 0))
    {
      CarenceIslr islr = new CarenceIslr();
      
      islr.setQuantiteInitialJour(reliquatISLR.intValue());
      
      Damj finProchainePeriode = debutProchaineCarence.deplacerVersAvant(new DureeCalendaire(0, 0, islr.getQuantiteInitialJour())).veille();
      
      Periode periodeApplicationISLR = new Periode(debutProchaineCarence, finProchainePeriode);
      islr.setPeriodeApplicationCarence(periodeApplicationISLR);
      
      islr.setOrigine(periodeOrigine);
      
      debutProchaineCarence = periodeApplicationISLR.getFin().lendemain();
      
      ajouterEnsembleCarence = true;
      
      ensembleCarence.setCarenceIslr(islr);
    }
    if (ajouterEnsembleCarence) {
      constitutionDelais.ajouterEnsembleCarences(ensembleCarence);
    }
    if ((reliquatDelaiAttente != null) && (reliquatDelaiAttente.intValue() > 0))
    {
      Differe differe = new Differe();
      
      differe.setQuantiteInitialJour(reliquatDelaiAttente.intValue());
      
      Damj finProchainePeriode = debutProchaineCarence.deplacerVersAvant(new DureeCalendaire(0, 0, differe.getQuantiteInitialJour())).veille();
      
      Periode periodeApplicationDelaiAttente = new Periode(debutProchaineCarence, finProchainePeriode);
      differe.setPeriodeEffet(periodeApplicationDelaiAttente);
      
      constitutionDelais.ajouterDelaisReports(differe);
    }
  }
  
  protected void alimenterConstitutionPointDeDepart(fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen dossierExamen, SaisieAntecedent saisieAntecedent)
  {
    ConstitutionPointDepartIndemnisation constitutionPointDepartIndemnisation = dossierExamen.createConstitutionPointDepartIndemnisation();
    
    Damj pji = saisieAntecedent.getPremierJourIndemnisable();
    
    constitutionPointDepartIndemnisation.setPji(pji);
  }
  
  protected void alimenterConstitutionProduitResultant(fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen dossierExamen, SaisieAntecedent saisieAntecedent)
  {
    ConstitutionProduitResultant constitutionProduitResultant = dossierExamen.createConstitutionProduitResultant();
    if (!"0".equals(saisieAntecedent.getMontantReadmissionRetenu())) {
      constitutionProduitResultant.setMontantRetenu(2);
    } else {
      constitutionProduitResultant.setMontantRetenu(1);
    }
  }
  
  protected void alimenterConditionsAdmissionSupplementaire(Demande p_demande)
    throws CoucheLogiqueException
  {
    SaisieAntecedent saisieAntecedent = p_demande.getSaisieAntecedent();
    
    fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen dossierExamen = (fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen)p_demande.getDossierExamen();
    
    alimenterContionCumulActiviteConservee(dossierExamen, saisieAntecedent);
  }
  
  protected void alimenterContionCumulActiviteConservee(fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen pDossierExamen, SaisieAntecedent pSaisieAntecedent)
    throws CoucheLogiqueException
  {
    Quantite sjcPlafonne = pSaisieAntecedent.getSalaireJournalierConservePlafonne();
    if (sjcPlafonne != null)
    {
      DomLiquidationAssurance dom = new DomLiquidationAssurance();
      Contexte contexte = new Contexte();
      contexte.setDonnees(dom);
      
      Demande demandeOrigine = (Demande)pDossierExamen.getDemandeAssurance();
      Damj dateExamen = demandeOrigine.getDateExamen();
      Demande demandeCopiee = (Demande)demandeOrigine.copie();
      demandeCopiee.getEvenementReferenceExamen().setDateEvenement(pDossierExamen.getDateAttribution());
      dom.setDemande(demandeCopiee);
      try
      {
        fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen dossierExamen = (fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen)demandeCopiee.getDossierExamen();
        ConditionActiviteConservee conditionActiviteConserveeDemandeCopiee = dossierExamen.createConditionActiviteConservee();
        ConteneurConditionActiviteConservee conteneurConditionActiviteConservee = new ConteneurConditionActiviteConservee();
        BigDecimal plafondMensuelRemuneration = RechercheConditionCumulActiviteConservee.determinerPlafondMensuelRemuneration(demandeCopiee, demandeCopiee.getDateExamen());
        conteneurConditionActiviteConservee.setSeuilMontantMensuelActiviteConservee(plafondMensuelRemuneration);
        RechercheConditionCumulActiviteConservee.mapperConteneurVersConditionActiviteConservee(conteneurConditionActiviteConservee, conditionActiviteConserveeDemandeCopiee);
        pDossierExamen.createConditionActiviteConservee();
        conditionActiviteConserveeDemandeCopiee.setEtat(0);
        conditionActiviteConserveeDemandeCopiee.copieElements(pDossierExamen.getConditionActiviteConservee());
        demandeOrigine.getEvenementReferenceExamen().setDateEvenement(dateExamen);
      }
      catch (ApplicativeException ex)
      {
        throw new CoucheLogiqueException(ex.getCode(), ex);
      }
    }
  }
  
  protected void alimenterDateLimiteIndemnisation(Demande pDemande, fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen pDossierExamen, SaisieAntecedent pSaisieAntecedent)
    throws CoucheLogiqueException
  {
    if ((OutilGestionContexteDemande.estContexteDemandeAssurancePresent(pDemande, "ASPARE")) || (OutilGestionContexteDemande.estContexteDemandeAssurancePresent(pDemande, "ASPDC")))
    {
      ConstitutionDateLimiteIndemnisation dateLimiteIndemnisation = pDossierExamen.getConstitutionElementsActifs().createConstitutionDateLimiteIndemnisation();
      ResultatDeterminationDateLimiteIndemnisation resultat = DeterminationDateLimiteIndemnisation.determinerDateLimiteIndemnisation(pDemande);
      dateLimiteIndemnisation.setDateLimiteIndem(resultat.getDateLimiteIndemnisation());
    }
  }
}

/* Location:
 * Qualified Name:     GrapheAntecedent
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */