package fr.unedic.cali.asu.cge01.p03.calcul;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.antecedent.GestionAntecedentCalculAsuSpec;
import fr.unedic.cali.asu.calcul.FacadeCalculGammeImpl;
import fr.unedic.cali.asu.calcul.dom.ConstituantsCalculActiviteReduiteGamme;
import fr.unedic.cali.asu.calcul.dom.EtatAuDjiGamme;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeAEDV;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeAssDemandeExpresse;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeDebutPec;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeFinDureeMaintienDroit;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeRejetDRV;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeRejetDVFilEau;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.ActiviteReduite;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.DefinitionStatutUtTraitementActiviteReduite;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.OutilsMaintienEuropeenEessiASU;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.RecuperationPensionInvaliditeAvantDate;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.fabriques.FabriqueStrategieConvention2014;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.strategies.StrategieConventionARE14Spec;
import fr.unedic.cali.asu.cge01.outilsfonctionnels.RevalorisationSalaire;
import fr.unedic.cali.asu.cge01.p03.antecedent.GestionAntecedentCalcul;
import fr.unedic.cali.asu.cge01.p03.antecedent.GestionPoursuiteCalcul;
import fr.unedic.cali.asu.cge01.p03.calcul.dom.ConstituantsCalculActiviteReduiteProduit;
import fr.unedic.cali.asu.cge01.p03.calcul.dom.DureeIndemnisation;
import fr.unedic.cali.asu.cge01.p03.calcul.dom.FormuleMontantAREF;
import fr.unedic.cali.asu.cge01.p03.calcul.dom.FormuleMontantRegimeGeneral;
import fr.unedic.cali.asu.cge01.p03.calcul.outilsfonctionnels.Maintien;
import fr.unedic.cali.asu.cge01.p03.calcul.outilsfonctionnels.MajCi;
import fr.unedic.cali.asu.cge01.p03.calcul.outilsfonctionnels.PostTraitements;
import fr.unedic.cali.asu.cge01.p03.calcul.outilsfonctionnels.Qualification;
import fr.unedic.cali.asu.cge01.p03.calcul.outilsfonctionnels.TraitementActiviteReduite;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Attribution;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Poursuite;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisationAREF;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.dom.SalaireReference;
import fr.unedic.cali.asu.dom.Sjc;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.fabriques.FabriqueConventionTransitoireCalcul2014;
import fr.unedic.cali.asu.mnt.dom.DureeDetectionMaintien;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeDetection100TMaintien;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeDetectionAgeMaintien;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeMaintien;
import fr.unedic.cali.asu.outilsfonctionnels.OutilAsr;
import fr.unedic.cali.asu.outilsfonctionnels.OutilFinDroit;
import fr.unedic.cali.asu.outilsfonctionnels.RechercheDecisionsInterruptives;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieGenerationEnqueteCumulARSpec;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieGestionDRVSpec;
import fr.unedic.cali.asu.parametres.EvenementParametre;
import fr.unedic.cali.asu.parametres.ParametresIndemnisation;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.calcul.OutillageCalculADate;
import fr.unedic.cali.calcul.OutillagePeriodes;
import fr.unedic.cali.calcul.OutillageQuantites;
import fr.unedic.cali.calcul.RecuperationDonneesSecteurPublic;
import fr.unedic.cali.calcul.TraitementPeriodes;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculPeriodique;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculSpec;
import fr.unedic.cali.calcul.dom.ConstituantsCalculActiviteReduiteSpec;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.calcul.dom.EtatAuDji;
import fr.unedic.cali.calcul.dom.EvenementChangementParametre;
import fr.unedic.cali.calcul.dom.EvenementLendemainFinQuantiteDroit;
import fr.unedic.cali.calcul.dom.EvenementMaintien;
import fr.unedic.cali.calcul.dom.EvenementMaintienEuropeenDJI;
import fr.unedic.cali.calcul.dom.EvenementRejetDv;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.periode.FinActionFormation;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeFormationNonIndemnisee;
import fr.unedic.cali.calcul.dom.periode.FinPeriodePensionInvalidite;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeSanctionReductionMontant;
import fr.unedic.cali.calcul.dom.periode.PeriodeAbsenceAuPointage;
import fr.unedic.cali.calcul.dom.periode.PeriodeActiviteEmploiCalcul;
import fr.unedic.cali.calcul.dom.periode.PeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.periode.PeriodeExclusionDefinitiveDDTE;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormationNonIndemnisee;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormationNonIndemniseeAbsenceHeure;
import fr.unedic.cali.calcul.dom.periode.PeriodeInterStageFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodePensionInvalidite;
import fr.unedic.cali.calcul.dom.periode.PeriodeSanctionReductionMontant;
import fr.unedic.cali.calcul.dom.periode.PeriodeSuspensionDDTEAvecImputation;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeInterProduits;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeRetraite;
import fr.unedic.cali.calcul.outilsfonctionnels.DecoupageProratisation;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionForcage;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionSuivi;
import fr.unedic.cali.calcul.outilsfonctionnels.OutilGestionPoursuite;
import fr.unedic.cali.calcul.outilsfonctionnels.RecuperationAvantageVieillesseAvantPJI;
import fr.unedic.cali.calcul.outilsfonctionnels.RecuperationSanctionReduction;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ContexteUT;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ContexteUT.ElementContexteUT;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ElementBaseIndemnisationFacade;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodeAnalyse;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodeAnalyseSpec;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodesPriseEnCompte;
import fr.unedic.cali.calcul.pbjc.dom.IndividuPbjcNcp;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.ElementBaseIndemnisationSpec;
import fr.unedic.cali.dom.FormuleMontantAREFSpec;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.cali.dom.OdSpec;
import fr.unedic.cali.dom.QuantiteDroitSpec;
import fr.unedic.cali.dom.QuantiteIndemnisationSpec;
import fr.unedic.cali.dom.RepriseSpec;
import fr.unedic.cali.dom.RevisionSpec;
import fr.unedic.cali.dom.affectation.GammeSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P03;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.ProduitSolSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.outilsfonctionnels.Anomalie;
import fr.unedic.cali.outilsfonctionnels.GestionAnomalies;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.parametres.GestionnaireDateApplication;
import fr.unedic.cali.parcours.ResultatCalcul;
import fr.unedic.util.Mathematiques;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.Unite;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import fr.unedic.util.temps.Temporel;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

public class FacadeCalculProduitImpl
  extends FacadeCalculGammeImpl
{
  private static final int DIX = 10;
  private static final int DATE_ATTRIBUTION_MINIMALE_JOUR = 1;
  private static final int DATE_ATTRIBUTION_MINIMALE_MOIS = 7;
  private static final int DATE_ATTRIBUTION_MINIMALE_ANNEE = 2001;
  private static final Damj DATE_ATTRIBUTION_MINIMALE = new Damj(2001, 7, 1);
  private static final DureeCalendaire DUREE_6_MOIS = new DureeCalendaire(0, 6, 1);
  private static final String COEFFICIENT_IMPUTATION_FORMATION = "10";
  private static final int LIMITATION_IMPUTATION_FORMATION = 30;
  private static final int AGE_50_ANS = 50;
  
  public fr.unedic.cali.calcul.dom.UniteTraitement creerUT(Periode p_periodeUT, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return new fr.unedic.cali.asu.cge01.p03.calcul.dom.UniteTraitement(Unite.get("jour"), p_periodeUT);
  }
  
  public Quantite getQuantiteIndemnisableTheorique(Periode p_periode, AttributionSpec p_attribution, ConstituantsIndemnisation p_constituantsIndemnisation, ContexteUT p_contexteUt)
  {
    return new QuantiteJour(new BigDecimal(p_periode.getDuree()));
  }
  
  public Damj getDateFinQuantiteDroit(Periode p_periode, AttributionSpec p_attribution, QuantiteDroitSpec p_quantiteDroit, ChronologiePeriodes p_chronologieRemplissage, Quantite p_quantiteAImputer, Damj p_dateDebut)
  {
    return OutillageCalculADate.remplirTrousChronologieParIndemnisation(p_chronologieRemplissage, p_quantiteAImputer, p_periode);
  }
  
  public void initialiseElementBaseIndemnisationCourante(ConstituantsIndemnisation p_constituantsIndemnisation, AttributionSpec p_attribution, Periode p_periodeUT)
    throws CoucheLogiqueException
  {
    if (p_constituantsIndemnisation.getElementBaseIndemnisationCourant() == null)
    {
      Attribution attribution = (Attribution)p_attribution;
      ElementBaseIndemnisation elementBaseIndemnisationCourant = new ElementBaseIndemnisation();
      ElementBaseIndemnisation ebiAttrib = attribution.getElementBaseIndemnisation();
      elementBaseIndemnisationCourant.setProduitMontantRetenu(attribution.getProduitMontantRetenu());
      p_constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationCourant);
      
      Reglement reglementApplicable = ebiAttrib.getReglementApplicable();
      if (reglementApplicable != null) {
        elementBaseIndemnisationCourant.setReglementApplicable(reglementApplicable);
      }
      Quantite affiliationRequisePourPRA = ebiAttrib.getAffiliationRequisePourPRA();
      if (affiliationRequisePourPRA != null) {
        elementBaseIndemnisationCourant.setAffiliationRequisePourPRA(affiliationRequisePourPRA);
      }
      SalaireReference salaireReference = ebiAttrib.getSalaireReference();
      if (salaireReference != null) {
        elementBaseIndemnisationCourant.setSalaireReference(salaireReference);
      }
      BigDecimal nombreHeureTravaillesEtendu = ebiAttrib.getNombreHeureTravaillesEtendu();
      if (nombreHeureTravaillesEtendu != null) {
        elementBaseIndemnisationCourant.setNombreHeureTravaillesEtendu(nombreHeureTravaillesEtendu);
      }
      BigDecimal nombreHeuresTravailleesPlafonnees = ebiAttrib.getNombreHeuresTravailleesPlafonnees();
      if (nombreHeuresTravailleesPlafonnees != null) {
        elementBaseIndemnisationCourant.setNombreHeuresTravailleesPlafonnees(nombreHeuresTravailleesPlafonnees);
      }
      Periode prc = ebiAttrib.getPrc();
      if (prc != null) {
        elementBaseIndemnisationCourant.setPrc(prc);
      }
      elementBaseIndemnisationCourant.setNbJoursEmploiSurPrc(ebiAttrib.getNbJoursEmploiSurPrc());
      elementBaseIndemnisationCourant.setCoefficientHoraireJour(ebiAttrib.getCoefficientHoraireJour());
      
      BigDecimal coefficientSaisonnier = ebiAttrib.getCoefficientSaisonnier();
      if (coefficientSaisonnier != null) {
        elementBaseIndemnisationCourant.setCoefficientSaisonnier(coefficientSaisonnier);
      } else {
        elementBaseIndemnisationCourant.setCoefficientSaisonnier(new BigDecimal("1"));
      }
      BigDecimal coefficientTempsPartiel = ebiAttrib.getCoefficientTempsPartiel();
      if (coefficientTempsPartiel != null) {
        elementBaseIndemnisationCourant.setCoefficientTempsPartiel(coefficientTempsPartiel);
      } else {
        elementBaseIndemnisationCourant.setCoefficientTempsPartiel(new BigDecimal("1"));
      }
      elementBaseIndemnisationCourant.setSjr((Sjr)ebiAttrib.getSjr().copie());
      elementBaseIndemnisationCourant.setSjc((Sjc)attribution.getSJC().copie());
      elementBaseIndemnisationCourant.setCoefficientSanctionReduction(new BigDecimal("1.00"));
      elementBaseIndemnisationCourant.setMontantPensionInvaliditeADeduire(RecuperationPensionInvaliditeAvantDate.recuperationMontantPI(attribution.getDemandeur(), recupererPremierJourExecutableNcp(p_attribution).veille()));
      
      PeriodeAvantageVieillesse periodeAvCourante = RecuperationAvantageVieillesseAvantPJI.recupererPeriodeAvADate(attribution.getDemandeur(), recupererPremierJourExecutableNcp(p_attribution));
      
      BigDecimal montantAV = new BigDecimal(0);
      Damj dateRevalorisation = p_attribution.getDateAttribution();
      if (periodeAvCourante != null)
      {
        montantAV = periodeAvCourante.getQuantiteEuro().getValeur();
        
        elementBaseIndemnisationCourant.setDateEffetAV(attribution.getPji().veille());
        dateRevalorisation = Damj.max(p_attribution.getDateAttribution(), periodeAvCourante.getDateDebut());
      }
      elementBaseIndemnisationCourant.setDateMaintienEuropeen(OutilsMaintienEuropeenEessiASU.rechercherDateMaintienEuropeen(p_attribution, p_periodeUT, p_constituantsIndemnisation));
      
      Sjr sjrrp = RevalorisationSalaire.revaloriserSjr(elementBaseIndemnisationCourant, attribution.getProduitMontantRetenu(), dateRevalorisation);
      BigDecimal coeffAV = montantAV.divide(sjrrp.getSalaire(), 10, 4);
      elementBaseIndemnisationCourant.setCoefficientAvantageVieillesse(coeffAV);
      elementBaseIndemnisationCourant.setMontantAvantageVieillesse(coeffAV.multiply(sjrrp.getSalaire()));
      
      elementBaseIndemnisationCourant.setTypeCaractereSaisonnierRetenu(ebiAttrib.getTypeCaractereSaisonnierRetenu());
      
      elementBaseIndemnisationCourant.setIsConditionCaractereSaisonnierParRythme(ebiAttrib.isConditionCaractereSaisonnierParRythme());
      
      elementBaseIndemnisationCourant.setDureeInitialeMaintien(attribution.getDureeIndemnisationInitiale());
      elementBaseIndemnisationCourant.setCapitalRetenuCourant(attribution.isCapitalRetenuCourant());
      
      FormuleMontantSpec formuleMontant = null;
      ElementBaseIndemnisationAREF elementBaseIndemnisationAREF = null;
      
      QuantiteIndemnisationSpec duree = OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(p_constituantsIndemnisation.getCollectionQuantiteDroit());
      if (duree != null) {
        formuleMontant = p_attribution.getFormuleMontant(duree.getCodeFormuleMontant());
      } else {
        formuleMontant = p_attribution.getFormuleMontant(p_constituantsIndemnisation.getCodeFormuleMontant());
      }
      if ((formuleMontant instanceof FormuleMontantAREFSpec))
      {
        elementBaseIndemnisationAREF = new ElementBaseIndemnisationAREF(elementBaseIndemnisationCourant);
        p_constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationAREF);
      }
    }
  }
  
  public void initialisationQuantitesIndemnisation(ConstituantsIndemnisation p_constituantsIndemnisation, AttributionSpec p_attribution, Periode p_periodeUT)
    throws ApplicativeException
  {
    Iterator iterator = null;
    QuantiteDroitSpec duree = null;
    Collection collectionDurees = null;
    
    collectionDurees = p_constituantsIndemnisation.getCollectionQuantiteDroit();
    if (collectionDurees != null)
    {
      iterator = collectionDurees.iterator();
      while (iterator.hasNext())
      {
        duree = (QuantiteDroitSpec)iterator.next();
        if ((duree instanceof DureeIndemnisation))
        {
          duree.activer();
          initialiseElementBaseIndemnisationCourante(p_constituantsIndemnisation, p_attribution, p_periodeUT);
        }
      }
    }
  }
  
  public boolean epuisementQuantiteDroit(Damj p_dateEpuisementQuantite, AttributionSpec p_attribution, QuantiteDroitSpec p_quantiteDroitEpuisee, ConstituantsIndemnisation p_constituantsIndemnisation, fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
    throws ApplicativeException
  {
    boolean finDeProduit = false;
    if ((p_quantiteDroitEpuisee instanceof DureeDetectionMaintien))
    {
      if ((Maintien.getInstance().evaluerConditionAge(p_attribution, p_dateEpuisementQuantite)) && 
        (Maintien.getInstance().evaluerConditionReliquat(p_constituantsIndemnisation))) {
        Maintien.getInstance().effectuerDetection((AttributionAssuranceSpec)p_attribution, p_dateEpuisementQuantite.lendemain(), p_constituantsIndemnisation);
      }
    }
    else if ((p_quantiteDroitEpuisee instanceof QuantiteIndemnisationSpec))
    {
      Attribution attribution = (Attribution)p_attribution;
      if (!attribution.estMaintenue()) {
        finDeProduit = true;
      } else {
        p_constituantsIndemnisation.setCodeFormuleMontant(((QuantiteIndemnisationSpec)p_quantiteDroitEpuisee).getCodeFormuleMontant());
      }
    }
    return finDeProduit;
  }
  
  public ConstituantsIndemnisation creationConstituantsIndemnisation(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    ConstituantsIndemnisation constituantsIndemnisation = new ConstituantsIndemnisation();
    Collection collectionDurees = null;
    if ((p_attribution instanceof Poursuite)) {
      collectionDurees = new ArrayList(((Poursuite)p_attribution).getUniteTraitement().getConstituantsIndemnisationEnFinUT().getCollectionQuantiteDroit());
    } else {
      collectionDurees = new ArrayList(((Attribution)p_attribution).getListeDurees());
    }
    constituantsIndemnisation.setCollectionQuantiteDroit(collectionDurees);
    return constituantsIndemnisation;
  }
  
  public ConstituantsIndemnisation miseAJourConstituantsIndemnisation(fr.unedic.cali.calcul.dom.UniteTraitement ut, AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, Damj dateDeMiseAjour, Periode periode)
    throws CoucheLogiqueException
  {
    return MajCi.miseAJourConstituantsIndemnisation(attribution, constituantsIndemnisation, dateDeMiseAjour);
  }
  
  public ConstituantsCalculActiviteReduiteSpec miseAJourCumulAR(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, AttributionSpec p_attribution, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, ContexteUT p_contexteUT, ArretProduitAvecRaison p_arretProduitAvecRaison)
    throws CoucheLogiqueException
  {
    ConstituantsCalculActiviteReduiteProduit constituantsCalculActiviteReduite = (ConstituantsCalculActiviteReduiteProduit)p_constituantsCalculActiviteReduite;
    int cumulActiviteReduite = constituantsCalculActiviteReduite.getCumul();
    
    boolean existeAttributionPrecedenteAvecCumulAr = false;
    boolean existeAttributionAsrPrecedenteAvecCumulAr = false;
    boolean individuPossedeCesSurUt = false;
    boolean individuPossedeCaeSurUt = false;
    boolean individuPossedeCaeCuiSurUt = false;
    
    CritereStrategie critere = new CritereStrategie();
    critere.setDatePivot(p_ut.getDateDebut());
    FabriqueConventionTransitoireCalcul2014 fabrique = FabriqueConventionTransitoireCalcul2014.getInstance();
    StrategieGenerationEnqueteCumulARSpec strategie = (StrategieGenerationEnqueteCumulARSpec)fabrique.getStrategie(critere);
    
    FabriqueConventionTransitoireCalcul2014 fabriqueDRV = FabriqueConventionTransitoireCalcul2014.getInstance();
    StrategieGestionDRVSpec strategieGestionDRVARE14Apres = fabriqueDRV.getStrategieGestionDRV(critere);
    if ((strategieGestionDRVARE14Apres.mettreAjourCumulMoisNonIndemnise()) && (constituantsCalculActiviteReduite != null) && (!((AttributionAssuranceSpec)p_attribution).estMaintenue()) && (p_ut.getDateDebut().estAvant(GestionnaireDateApplication.getInstance().recupererDateApplication("Fin application de l'ancien dispositif DRV")))) {
      miseAjourNombreMoisNonIndemnise(p_attribution, p_ut, constituantsCalculActiviteReduite, p_contexteUT, p_arretProduitAvecRaison);
    }
    if ((((p_attribution instanceof RepriseSpec)) || ((p_attribution instanceof RevisionSpec))) && (p_attribution.getPji().estContenueDans(p_ut.getPeriode()))) {
      existeAttributionPrecedenteAvecCumulAr = existeAttributionPrecedenteAvecCumulAr(p_attribution, p_contexteUT);
    }
    if ((p_attribution instanceof AttributionSpec)) {
      existeAttributionAsrPrecedenteAvecCumulAr = existeAttributionAsrPrecedenteAvecCumulAr(p_attribution, p_contexteUT);
    }
    if (existeAttributionPrecedenteAvecCumulAr) {
      constituantsCalculActiviteReduite.setCumul(cumulActiviteReduite + 1);
    }
    Reglement reglementOdCourante = ((Attribution)p_attribution).getReglementApplicable().getReglement();
    if ((!existeAttributionPrecedenteAvecCumulAr) && (!existeAttributionAsrPrecedenteAvecCumulAr) && (!reglementOdCourante.equals(ProduitAsuCge01P03.getInstance().getReglement("A4"))))
    {
      Iterator iterateurPeriode = p_ut.getQualificationPeriodes().getPeriodesDecalantes().iterer();
      while (iterateurPeriode.hasNext())
      {
        ObjetChronoPeriode periodeActivite = (ObjetChronoPeriode)iterateurPeriode.next();
        if ((periodeActivite instanceof PeriodeActiviteEmploiCalcul))
        {
          if (7 == ((PeriodeActiviteEmploiCalcul)periodeActivite).getTypeContratParticulier()) {
            individuPossedeCesSurUt = true;
          }
          if (14 == ((PeriodeActiviteEmploiCalcul)periodeActivite).getTypeContratParticulier()) {
            individuPossedeCaeSurUt = true;
          }
          if (23 == ((PeriodeActiviteEmploiCalcul)periodeActivite).getTypeContratParticulier()) {
            individuPossedeCaeCuiSurUt = true;
          }
        }
      }
      boolean decalageSurPa = false;
      Iterator<PeriodeAnalyseSpec> ite = p_ut.getListePeriodesAnalyse().iterer();
      while (ite.hasNext())
      {
        PeriodeAnalyse pa = (PeriodeAnalyse)ite.next();
        if ((pa.getQuantiteDecalee() != null) && (pa.getQuantiteDecalee().getValeurEntiere() >= 0)) {
          decalageSurPa = true;
        }
      }
      if ((!individuPossedeCesSurUt) && (!individuPossedeCaeSurUt) && (!individuPossedeCaeCuiSurUt) && (!p_ut.isNeutralisee()) && (((p_ut.getCreditDecalage() != null) && (p_ut.getCreditDecalage().getValeur() != null) && (p_ut.getCreditDecalage().getValeur().intValue() >= 0)) || ((decalageSurPa) && (p_ut.getQuantiteIndemnisee() != null) && (p_ut.getQuantiteIndemnisee().getValeur() != null) && (p_ut.getQuantiteIndemnisee().getValeur().intValue() >= 1))))
      {
        cumulActiviteReduite++;
        constituantsCalculActiviteReduite.setCumul(cumulActiviteReduite);
        if ((p_ut.getStatut() != 5) && (cumulActiviteReduite == 13) && (p_attribution.getDemandeur().getAgeALaDate(p_ut.getDateDebut()).getAnnees() < 50) && (strategie != null) && (strategie.genererEnqueteCumulAR())) {
          GestionSuivi.enregistrerEnquetePbjcNcp(p_attribution, p_ut.getDateFin(), 11, 0, true, null, this, p_ut.getConstituantsIndemnisationEnFinUT());
        }
        if ((p_ut.getStatut() != 5) && (cumulActiviteReduite == 1)) {
          GestionSuivi.enregistrerEnquetePbjcNcp(p_attribution, Damj.max(p_ut.getDateDebut(), p_attribution.getPji()), 4, 0, true, null, this, p_ut.getConstituantsIndemnisationEnFinUT());
        }
      }
    }
    return constituantsCalculActiviteReduite;
  }
  
  public ConstituantsCalculActiviteReduiteSpec creationConstituantsCalculActiviteReduite(AttributionSpec p_attribution, ContexteUT p_contexteUT, ConstituantsIndemnisation p_constituantsIndemnisation)
    throws CoucheLogiqueException
  {
    int cumulAR = 0;
    int cumulMoisNi = 0;
    Attribution attribution = (Attribution)p_attribution;
    if ((attribution instanceof Poursuite))
    {
      cumulAR = ((Poursuite)attribution).getUniteTraitement().getConstituantsCalculActiviteReduiteEnFinUT().getCumul();
      cumulMoisNi = ((Poursuite)attribution).getUniteTraitement().getConstituantsCalculActiviteReduiteEnFinUT().getCumulMoisNonIndemnise();
    }
    else
    {
      AttributionSpec attributionPrecedente = null;
      boolean aTrouveAttributionNonRadieePendantAvant = false;
      if (((attribution instanceof RepriseSpec)) || ((attribution instanceof RevisionSpec)))
      {
        attributionPrecedente = attribution.getAttributionPrecedente();
        if ((attributionPrecedente != null) && (attributionPrecedente.getCalendrierExecutionCalcul() != null) && (attributionPrecedente.getCalendrierExecutionCalcul().getDernierJourIndemnisable().lendemain().coincideAvec(attribution.getDateAttribution())) && (!attribution.estDemandeDrv()))
        {
          EtatAuDjiGamme etatAuDji = (EtatAuDjiGamme)attributionPrecedente.getCalendrierExecutionCalcul().getEtatAuDJI();
          if (((etatAuDji.getCumulMoisnonIndemnise() < 3) && ((attribution instanceof RepriseSpec))) || ((attribution instanceof RevisionSpec))) {
            cumulMoisNi = etatAuDji.getCumulMoisnonIndemnise();
          }
        }
        AttributionSpec attributionPrecedenteAUtiliserPourCumulAR = attributionPrecedente;
        if ((attribution.getAttributionPrecedente().getTypeExamen().equals("ASU_17")) || (attribution.getAttributionPrecedente().getTypeExamen().equals("ASU_25"))) {
          attributionPrecedenteAUtiliserPourCumulAR = OutilFinDroit.rechercherAttributionCorrespondantePecedente(attributionPrecedente.getDemande());
        }
        while (!aTrouveAttributionNonRadieePendantAvant) {
          if ((attributionPrecedenteAUtiliserPourCumulAR != null) && (attributionPrecedenteAUtiliserPourCumulAR.getCalendrierExecutionCalcul() != null) && (attributionPrecedenteAUtiliserPourCumulAR.getCalendrierExecutionCalcul().getEtatAuDJI() != null))
          {
            aTrouveAttributionNonRadieePendantAvant = true;
            EtatAuDjiGamme etatAuDji = (EtatAuDjiGamme)attributionPrecedenteAUtiliserPourCumulAR.getCalendrierExecutionCalcul().getEtatAuDJI();
            cumulAR = etatAuDji.getCumulMoisActiviteReduite();
            
            boolean existeAttributionPrecedenteAvecCumulAr = existeAttributionPrecedenteAvecCumulAr(attribution, p_contexteUT);
            if (existeAttributionPrecedenteAvecCumulAr) {
              cumulAR--;
            }
          }
          else if (!(attributionPrecedenteAUtiliserPourCumulAR instanceof OdSpec))
          {
            attributionPrecedenteAUtiliserPourCumulAR = ((Attribution)attributionPrecedenteAUtiliserPourCumulAR).getAttributionPrecedente();
          }
          else
          {
            aTrouveAttributionNonRadieePendantAvant = true;
          }
        }
      }
      BigDecimal cumulMoisARMigre = ((AttributionAssuranceSpec)p_attribution).getCumulMoisActiviteReduite();
      if (cumulMoisARMigre != null) {
        cumulAR = cumulMoisARMigre.intValue();
      }
    }
    ConstituantsCalculActiviteReduiteProduit constituantsCalculActiviteReduiteProduit = new ConstituantsCalculActiviteReduiteProduit(cumulAR, attribution.getElementBaseIndemnisation().getSjr(), attribution.getSJC());
    constituantsCalculActiviteReduiteProduit.setCumulMoisNonIndemnise(cumulMoisNi);
    
    return constituantsCalculActiviteReduiteProduit;
  }
  
  public ConstituantsCalculActiviteReduiteSpec miseAjourConstituantsCalculActiviteReduite(AttributionSpec p_attribution, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, Damj p_dateDeMiseAjour, ConstituantsIndemnisation p_constituantIndemnisation)
    throws CoucheLogiqueException
  {
    Attribution attribution = (Attribution)p_attribution;
    ConstituantsCalculActiviteReduiteProduit constituantsCalculActiviteReduiteProduit = (ConstituantsCalculActiviteReduiteProduit)p_constituantsCalculActiviteReduite;
    
    constituantsCalculActiviteReduiteProduit.setSjr(RevalorisationSalaire.revaloriserSjr(attribution, p_dateDeMiseAjour));
    
    constituantsCalculActiviteReduiteProduit.setSjc(RevalorisationSalaire.revaloriserSjc(attribution.getSJC(), p_dateDeMiseAjour));
    return constituantsCalculActiviteReduiteProduit;
  }
  
  public QualificationPeriodes qualificationPeriodes(ChronologiePeriodes p_chronologiePeriodes, AttributionSpec p_attribution, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    return new Qualification().qualificationPeriodes(p_chronologiePeriodes, p_attribution);
  }
  
  public ChronologiePeriodes decoupageEtProratisationPeriodesActivites(PeriodesPriseEnCompte p_periodesPriseEnCompte, int p_typePeriodeDeReference, ChronologiePeriodes p_chronologieDePeriodesAProratiser, Periode p_periodeUT)
    throws CoucheLogiqueException
  {
    Periode periodeDeReference = null;
    Iterator iterator = null;
    ChronologiePeriodes chronologie = null;
    ObjetChronoPeriode objetChronoPeriode = null;
    iterator = p_periodesPriseEnCompte.getPeriodesParTypologie(p_typePeriodeDeReference).iterer();
    chronologie = new ChronologiePeriodes();
    while (iterator.hasNext())
    {
      objetChronoPeriode = (ObjetChronoPeriode)iterator.next();
      periodeDeReference = new Periode(objetChronoPeriode.getDateDebut(), objetChronoPeriode.getDateFin());
      chronologie.ajouter(DecoupageProratisation.decoupageEtProratisationPeriodesActivites(periodeDeReference, p_chronologieDePeriodesAProratiser));
    }
    return chronologie;
  }
  
  public ChronologiePeriodes recupererPeriodesProduit(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesIndividuelles = null;
    IndividuSpec individu = null;
    
    periodesIndividuelles = new ChronologiePeriodes();
    individu = p_attribution.getDemandeur();
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire50Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire55Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire60Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererPeriodeRetraite(individu));
    if (individu.getDernierJourAtteste() != null) {
      periodesIndividuelles.ajouter(OutillagePeriodes.genererLendemainDja(individu));
    }
    RecuperationDonneesSecteurPublic.recupererDemandeClassementSP(periodesIndividuelles, p_attribution);
    
    RecuperationDonneesSecteurPublic.rechercherAdmissionSecteurPublic(periodesIndividuelles, p_attribution);
    return periodesIndividuelles;
  }
  
  public ChronologiePeriodes recupererPeriodesLieesAuContexte(ContexteUT p_contexteUT, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes chronologiePeriodes = new ChronologiePeriodes();
    
    Collection collectionPeriode = p_contexteUT.getPeriodesInterProduitsSurUTDateDepartAttributionPourGamme(p_attribution, "ASU");
    List liste = p_contexteUT.getListeAttributions();
    if (liste != null)
    {
      Iterator iterator = liste.iterator();
      while (iterator.hasNext())
      {
        AttributionSpec attribution = (AttributionSpec)iterator.next();
        if (attribution.getGamme().getNomUnique().equals("SOL")) {
          if (((attribution.getProduit().getNomUnique().equals("SOL_AER05_01")) || (attribution.getProduit().getNomUnique().equals("SOL_AER05_02")) || (attribution.getProduit().getNomUnique().equals("SOL_AER05_03"))) && (attribution.getCalendrierExecutionCalcul() != null) && ((attribution.getCalendrierExecutionCalcul().getEtatAttribution() == 1) || (attribution.getCalendrierExecutionCalcul().getEtatAttribution() == 2)))
          {
            Damj djiTheoriqueAER = ((ProduitSolSpec)attribution.getProduit()).getDjiTheoriqueAER(attribution);
            chronologiePeriodes.ajouter(new ObjetChronoPeriodeInterProduits(djiTheoriqueAER.lendemain(), djiTheoriqueAER.lendemain(), 5, attribution));
          }
        }
      }
    }
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "SOL_AER05_01"));
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "SOL_AER05_02"));
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "SOL_AER05_03"));
    
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartAttributionPourProduit(p_attribution, "INR_RCE04_01"));
    
    chronologiePeriodes.ajouter(collectionPeriode);
    if (!((AttributionAssuranceSpec)p_attribution).estMaintenue())
    {
      chronologiePeriodes.ajouter(Maintien.getInstance().genererEvenementAgeDetection(p_attribution));
      if (Maintien.getInstance().estDate100TConnue((AttributionAssuranceSpec)p_attribution)) {
        chronologiePeriodes.ajouter(Maintien.getInstance().genererEvenement100TDetection(p_attribution));
      }
    }
    else if (((Attribution)p_attribution).getDemandeMaintien() != null)
    {
      chronologiePeriodes.ajouter(Maintien.getInstance().genererEvenementMaintien(p_attribution));
    }
    chronologiePeriodes.ajouter(RechercheDecisionsInterruptives.rechercher(p_attribution.getDemandeur(), OutilGestionPoursuite.getInstance().recupererPremierJourExecutableNcp(p_attribution), p_attribution));
    
    chronologiePeriodes.ajouter(p_contexteUT.getPeriodesInterProduitsPeriodesLieuSurUTPourGammeRBF(p_attribution));
    
    chronologiePeriodes.ajouter(p_contexteUT.getPeriodesInterProduitsSurUTIndemnisationRfpe(p_attribution));
    
    chronologiePeriodes.ajouter(OutilsMaintienEuropeenEessiASU.getListesPeriodesMaintienEuropeen(p_attribution));
    
    chronologiePeriodes.ajouter(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "RET_ACO01_01"));
    
    return chronologiePeriodes;
  }
  
  public void determinerStatutUT(AttributionSpec p_attribution, ChronologiePeriodes p_periodesDecalantes, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ArretProduitAvecRaison p_arretProduitAvecRaison, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    boolean absenceAuPointage = false;
    if (p_ut.getQualificationPeriodes().getPeriodesGelantes() != null)
    {
      ChronologiePeriodes periodesGelantes = p_ut.getQualificationPeriodes().getPeriodesGelantes();
      periodesGelantes.iterer();
      while (periodesGelantes.encoreSuivant()) {
        if ((periodesGelantes.elementSuivant() instanceof PeriodeAbsenceAuPointage))
        {
          p_ut.setStatut(6);
          absenceAuPointage = true;
        }
      }
    }
    if (!absenceAuPointage)
    {
      if (!GestionForcage.appliquerForcageStatut(p_attribution.getDemande(), p_ut)) {
        p_ut.setStatut(DefinitionStatutUtTraitementActiviteReduite.definirStatutUt(p_attribution, p_periodesDecalantes, ((ConstituantsCalculActiviteReduiteGamme)p_constituantsCalculActiviteReduite).getNbMoisEnPPA(), estEnFormation(p_ut), p_ut, p_arretProduitAvecRaison, this));
      }
      if (p_ut.getStatut() == 5)
      {
        int nbMoisEnPPA = ((ConstituantsCalculActiviteReduiteGamme)p_constituantsCalculActiviteReduite).getNbMoisEnPPA();
        ((ConstituantsCalculActiviteReduiteGamme)p_constituantsCalculActiviteReduite).setNbMoisEnPPA(nbMoisEnPPA + 1);
      }
    }
  }
  
  protected void traitementFDD(PeriodesPriseEnCompte periodesPriseEnCompte, Periode periodeUT, ContexteUT contexteUT, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    appliquerFiltreSurFDDSuiteEpuismentOuDateAnniverssaire(periodesPriseEnCompte, periodeUT, contexteUT, attribution);
  }
  
  public void traitementPeriodesGelantes(AttributionSpec p_attribution, ChronologiePeriodes p_periodesGelantes, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
    throws CoucheLogiqueException
  {
    TraitementActiviteReduite.traitementPeriodesGelantes(p_attribution, p_periodesGelantes, p_constituantsCalculActiviteReduite, p_ut);
  }
  
  public void traitementPeriodesDecalantes(AttributionSpec p_attribution, ChronologiePeriodes p_periodesDecalantes, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ConstituantsIndemnisation p_constituantsIndemnisation, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    TraitementActiviteReduite.traitementPeriodesDecalantes(p_attribution, p_periodesDecalantes, p_constituantsCalculActiviteReduite, p_ut);
  }
  
  public void traitementPeriodesSuspensives(AttributionSpec p_attribution, ChronologiePeriodes p_periodesSuspensives, PeriodeAnalyseSpec p_pa)
    throws CoucheLogiqueException
  {
    Quantite quantiteSuspensive = TraitementPeriodes.getQuantiteSuspensive(p_pa.getPeriode(), p_pa.getQuantiteIndemnisable(), p_periodesSuspensives);
    
    p_pa.setQuantiteNonIndemnisee(p_pa.getQuantiteNonIndemnisee().ajouter(quantiteSuspensive));
  }
  
  public void traitementPeriodeSegmentante(AttributionSpec p_attribution, ObjetChronoPeriode p_periode, ConstituantsIndemnisation p_constituantsIndemnisation, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, PeriodeAnalyseSpec p_pa, ArretProduitAvecRaison p_arretProduitAvecRaison, ChronologiePeriodes p_periodesAnalyses)
    throws ApplicativeException
  {
    if (OutilsMaintienEuropeenEessiASU.controlerContexteMaintienEuropeen(p_attribution.getDemandeur(), p_periode.getDateDebut())) {
      if ((p_periode instanceof PeriodeFormation))
      {
        if (((PeriodeFormation)p_periode).estEffective()) {
          passerEnIndemnisationAvecFormation(p_periode, p_constituantsIndemnisation);
        } else {
          passerEnIndemnisationSansFormation(p_constituantsIndemnisation);
        }
      }
      else if ((p_periode instanceof ObjetChronoPeriodeDetectionAgeMaintien))
      {
        if (!((AttributionAssuranceSpec)p_attribution).estMaintenue()) {
          if (Maintien.getInstance().controlerConditionsDetectionHorsAge((AttributionAssuranceSpec)p_attribution, p_constituantsIndemnisation, p_periode.getDateDebut(), p_ut)) {
            Maintien.getInstance().effectuerDetection((AttributionAssuranceSpec)p_attribution, p_periode.getDateDebut(), p_constituantsIndemnisation);
          }
        }
      }
      else if ((p_periode instanceof ObjetChronoPeriodeDetection100TMaintien))
      {
        if (!((AttributionAssuranceSpec)p_attribution).estMaintenue()) {
          if (Maintien.getInstance().controlerConditionsDetectionHors100T((AttributionAssuranceSpec)p_attribution, p_constituantsIndemnisation, p_periode.getDateDebut(), p_ut)) {
            Maintien.getInstance().effectuerDetection((AttributionAssuranceSpec)p_attribution, p_periode.getDateDebut(), p_constituantsIndemnisation);
          }
        }
      }
      else if ((p_periode instanceof ObjetChronoPeriodeMaintien))
      {
        if (((ObjetChronoPeriodeMaintien)p_periode).getDateMaintienHorsPEC() != null) {
          Maintien.getInstance().detecter((AttributionAssuranceSpec)p_attribution, ((ObjetChronoPeriodeMaintien)p_periode).getDateMaintienHorsPEC(), false, p_constituantsIndemnisation);
        } else {
          Maintien.getInstance().detecter((AttributionAssuranceSpec)p_attribution, p_periode.getDateDebut(), false, p_constituantsIndemnisation);
        }
        if (((AttributionAssuranceSpec)p_attribution).estMaintenue()) {
          if (((ObjetChronoPeriodeMaintien)p_periode).getDateMaintienHorsPEC() != null) {
            p_ut.ajouterEvenement(new EvenementMaintien(((ObjetChronoPeriodeMaintien)p_periode).getDateMaintienHorsPEC()));
          } else {
            p_ut.ajouterEvenement(new EvenementMaintien(p_periode.getDateDebut()));
          }
        }
      }
    }
    if (((p_periode instanceof PeriodeInterStageFormation)) || ((p_periode instanceof FinActionFormation)))
    {
      passerEnIndemnisationSansFormation(p_constituantsIndemnisation);
    }
    else if ((p_periode instanceof PeriodeSanctionReductionMontant))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
      if (((PeriodeSanctionReductionMontant)p_periode).getCodeSanction().equals("R1")) {
        elementBaseIndemnisation.setCoefficientSanctionReduction(new BigDecimal("0.80"));
      } else if (((PeriodeSanctionReductionMontant)p_periode).getCodeSanction().equals("R2")) {
        elementBaseIndemnisation.setCoefficientSanctionReduction(new BigDecimal("0.50"));
      }
    }
    else if (((p_periode instanceof FinPeriodeSanctionReductionMontant)) && (((p_pa != null) && (p_pa.getDateDebut().estContenueDans(((FinPeriodeSanctionReductionMontant)p_periode).getPeriode()))) || ((p_pa == null) && (p_periode.getDateDebut().estContenueDans(p_ut.getPeriode())))))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
      elementBaseIndemnisation.setCoefficientSanctionReduction(new BigDecimal("1.00"));
    }
    else if (((p_periode instanceof PeriodePensionInvalidite)) && (p_periode.getDateDebut().estApresOuCoincideAvec(p_attribution.getPji())))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
      elementBaseIndemnisation.setMontantPensionInvaliditeADeduire(elementBaseIndemnisation.getMontantPensionInvaliditeADeduire().add(((PeriodePensionInvalidite)p_periode).getQuantiteEuro().getValeur()));
    }
    else if (((p_periode instanceof PeriodeAvantageVieillesse)) && (p_periode.getDateDebut().estApresOuCoincideAvec(p_attribution.getPji())))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
      
      BigDecimal montantAv = null;
      if ((elementBaseIndemnisation.getDateEffetAV() == null) || (elementBaseIndemnisation.getDateEffetAV().estAvant(p_periode.getDateDebut())))
      {
        montantAv = ((PeriodeAvantageVieillesse)p_periode).getQuantiteEuro().getValeur();
        elementBaseIndemnisation.setDateEffetAV(p_periode.getDateDebut());
      }
      else if (elementBaseIndemnisation.getDateEffetAV().coincideAvec(p_periode.getDateDebut()))
      {
        montantAv = elementBaseIndemnisation.getMontantAvantageVieillesse().add(((PeriodeAvantageVieillesse)p_periode).getQuantiteEuro().getValeur());
      }
      if (montantAv != null)
      {
        elementBaseIndemnisation.setMontantAvantageVieillesse(montantAv);
        if ((elementBaseIndemnisation.getSjr() != null) && (elementBaseIndemnisation.getSjr().getSalaire() != null) && (!elementBaseIndemnisation.getSjr().getSalaire().equals(new BigDecimal("0.00"))))
        {
          BigDecimal coeffAV = montantAv.divide(elementBaseIndemnisation.getSjr().getSalaire(), 10, 4);
          elementBaseIndemnisation.setCoefficientAvantageVieillesse(coeffAV);
        }
      }
    }
    else if (((p_periode instanceof FinPeriodeAvantageVieillesse)) && (((p_pa != null) && (p_pa.getDateDebut().equals(p_periode.getDateDebut()))) || ((p_pa == null) && (p_periode.getDateDebut().estContenueDans(p_ut.getPeriode())))))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
      
      elementBaseIndemnisation.setCoefficientAvantageVieillesse(new BigDecimal("0"));
      elementBaseIndemnisation.setMontantAvantageVieillesse(new BigDecimal("0"));
    }
    else if (((p_periode instanceof FinPeriodePensionInvalidite)) && (((p_pa != null) && (p_pa.getDateDebut().equals(p_periode.getDateDebut()))) || ((p_pa == null) && (p_periode.getDateDebut().estContenueDans(p_ut.getPeriode())))))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
      elementBaseIndemnisation.setMontantPensionInvaliditeADeduire(elementBaseIndemnisation.getMontantPensionInvaliditeADeduire().subtract(((FinPeriodePensionInvalidite)p_periode).getQuantiteEuro().getValeur()));
    }
    else if (((p_periode instanceof FinPeriodeFormationNonIndemnisee)) && (((p_pa != null) && (p_pa.getDateDebut().equals(p_periode.getDateDebut()))) || ((p_pa == null) && (p_periode.getDateDebut().estContenueDans(p_ut.getPeriode())))))
    {
      if (((Attribution)p_attribution).getDureeInitiale().getValeurEntiere() > ((ProduitAsuSpec)p_attribution.getProduit()).getDureeMinimumPourImputationFormation()) {
        imputerQuantiteIndemnisationADate(p_ut, p_periode, p_pa, p_constituantsIndemnisation, p_arretProduitAvecRaison, p_attribution);
      }
    }
    else if (((p_periode instanceof PeriodeSuspensionDDTEAvecImputation)) && (p_pa != null) && (((PeriodeSuspensionDDTEAvecImputation)p_periode).getPeriodeInitiale().getDebut().coincideAvec(p_pa.getDateDebut())))
    {
      PeriodeSuspensionDDTEAvecImputation periode = (PeriodeSuspensionDDTEAvecImputation)p_periode.copie();
      
      Damj finPeriodesAnalyse = null;
      ObjetChronoPeriode periodesAnalyse = (ObjetChronoPeriode)p_periodesAnalyses.dernierElement();
      finPeriodesAnalyse = periodesAnalyse.getDateFin();
      if ((finPeriodesAnalyse != null) && (((PeriodeSuspensionDDTEAvecImputation)p_periode).getPeriodeInitiale().getFin().estApres(finPeriodesAnalyse))) {
        periode.setDateFin(finPeriodesAnalyse);
      }
      imputerQuantiteIndemnisationDuAuxSanctions(p_attribution, p_ut, periode, p_constituantsIndemnisation, p_arretProduitAvecRaison);
    }
    else if ((p_periode instanceof ObjetChronoPeriodeDebutPec))
    {
      OutilsMaintienEuropeenEessiASU.controlerEtEmettreEnqueteMaintienEuropeen(p_attribution, p_constituantsIndemnisation, p_periode.getDateDebut(), this, null, p_ut);
      passerEnIndemnisationSansFormation(p_constituantsIndemnisation);
    }
  }
  
  public FormuleMontantSpec getFormuleMontant(String p_code)
  {
    FormuleMontantSpec fm = null;
    if (FormuleMontantAREF.getCode().equals(p_code)) {
      fm = new FormuleMontantAREF();
    } else if (FormuleMontantRegimeGeneral.getCode().equals(p_code)) {
      fm = new FormuleMontantRegimeGeneral();
    }
    return fm;
  }
  
  private void passerEnIndemnisationSansFormation(ConstituantsIndemnisation p_constituantsIndemnisation)
  {
    DureeIndemnisation duree = (DureeIndemnisation)OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(p_constituantsIndemnisation.getCollectionQuantiteDroit());
    if (duree != null) {
      duree.setCodeFormuleMontant(FormuleMontantRegimeGeneral.getCode());
    } else {
      p_constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantRegimeGeneral.getCode());
    }
    ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant().copie();
    p_constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisation);
  }
  
  private void passerEnIndemnisationAvecFormation(ObjetChronoPeriode p_periode, ConstituantsIndemnisation p_constituantsIndemnisation)
  {
    DureeIndemnisation duree = (DureeIndemnisation)OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(p_constituantsIndemnisation.getCollectionQuantiteDroit());
    if (duree != null) {
      duree.setCodeFormuleMontant(FormuleMontantAREF.getCode());
    } else {
      p_constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantAREF.getCode());
    }
    ElementBaseIndemnisationAREF elementBaseIndemnisationAREF = new ElementBaseIndemnisationAREF((ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant());
    if ((p_periode instanceof PeriodeFormation)) {
      elementBaseIndemnisationAREF.setEffectif(((PeriodeFormation)p_periode).estEffective());
    }
    p_constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationAREF);
  }
  
  public boolean verifierConditionExecutionEtEventuelAbandon(AttributionSpec p_attribution, ContexteUT p_contexteUT, Periode p_periodeUT, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul)
    throws CoucheLogiqueException
  {
    if (((AttributionAssuranceSpec)p_attribution).estTopeeRenoncement())
    {
      p_calendrierExecutionCalcul.setEtatAttribution(6);
      return false;
    }
    if (!p_attribution.estPjiEffectif())
    {
      p_calendrierExecutionCalcul.setEtatAttribution(4);
      return false;
    }
    return true;
  }
  
  public boolean verifierImputationDuree(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ConstituantsIndemnisation p_constituantsIndemnisation)
    throws CoucheLogiqueException
  {
    return true;
  }
  
  public void controlerAttribution(AttributionSpec p_attribution)
    throws ContexteException
  {
    Attribution attribution = (Attribution)p_attribution;
    
    Damj dateARE = DATE_ATTRIBUTION_MINIMALE;
    if (attribution.getDateEffet().estAvant(dateARE)) {
      throw new ContexteException("HG_PR_CALI_L_ERR_CONTEXTE", "La date de l'Ouverture de Droit doit etre posterieure au 01/07/2001", null);
    }
  }
  
  public ResultatCalcul postTraitementResultatDetaille(AttributionSpec p_attribution, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul)
    throws CoucheLogiqueException
  {
    return PostTraitements.postTraitementResultatDetaille(p_attribution, (fr.unedic.cali.calcul.dom.CalendrierExecutionCalcul)p_calendrierExecutionCalcul);
  }
  
  public ResultatCalcul postTraitementResultatDetailleNotification(AttributionSpec p_attribution, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul)
    throws CoucheLogiqueException
  {
    return PostTraitements.postTraitementResultatDetailleNotification(p_attribution, (fr.unedic.cali.calcul.dom.CalendrierExecutionCalcul)p_calendrierExecutionCalcul);
  }
  
  public ResultatCalcul postTraitementResultatDeterminationEtatDroit(AttributionSpec p_attribution, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul, Damj p_dateEtatDroit)
    throws CoucheLogiqueException
  {
    return PostTraitements.postTraitementResultatDeterminationEtatDroit(p_attribution, (fr.unedic.cali.calcul.dom.CalendrierExecutionCalcul)p_calendrierExecutionCalcul, p_dateEtatDroit);
  }
  
  public AttributionSpec rechercherAttributionPrecedenteSurLUT(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return ((AttributionAssuranceSpec)p_attribution).getAttributionPrecedente();
  }
  
  public ElementBaseIndemnisationFacade mapperUTVersElementBaseIndemnisation(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, AttributionSpec p_attribution)
  {
    ElementBaseIndemnisationFacade elt = new ElementBaseIndemnisationFacade();
    ElementBaseIndemnisation eltBase = null;
    eltBase = (ElementBaseIndemnisation)p_ut.getConstituantsIndemnisationEnFinUT().getElementBaseIndemnisationCourant();
    
    elt.setCoefficientAvantageVieillesse(eltBase.getCoefficientAvantageVieillesse().toString());
    if (eltBase.getCoefficientSaisonnier() != null) {
      elt.setCoefficientSaisonnier(eltBase.getCoefficientSaisonnier().toString());
    }
    if (eltBase.getCoefficientTempsPartiel() != null) {
      elt.setCoefficientTempsPartiel(eltBase.getCoefficientTempsPartiel().toString());
    }
    if (eltBase.getMontantPensionInvaliditeADeduire() != null) {
      elt.setMontantPensionInvaliditeADeduire(eltBase.getMontantPensionInvaliditeADeduire().toString());
    }
    if (eltBase.getMontantAvantageVieillesse() != null) {
      elt.setMontantAvantageVieillesse(eltBase.getMontantAvantageVieillesse().toString());
    }
    if (eltBase.getSjc().getSalaire() != null) {
      elt.setSjc(eltBase.getSjc().getSalaire().toString());
    }
    if (eltBase.getSjr().getSalaire() != null) {
      elt.setSjr(eltBase.getSjr().getSalaire().toString());
    }
    if (eltBase.getTauxAvantageVieillesse() != null) {
      elt.setTauxAvantageVieillesse(elt.getTauxAvantageVieillesse());
    }
    return elt;
  }
  
  public CalendrierExecutionCalculSpec creerCalendrierExecutionCalcul(AttributionSpec p_attribution)
  {
    return new fr.unedic.cali.asu.cge01.p03.calcul.dom.CalendrierExecutionCalcul();
  }
  
  public Collection getEvtsChangementParametre(ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_date)
  {
    List evtsRetour = new ArrayList();
    EvenementParametre evtParam = ParametresIndemnisation.getParametresIndemnisation().getElementActif(p_date);
    Sjr sjr = ((ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant()).getSjr();
    if ((evtParam.isNouveauRevalorisationSjr()) && 
      (!sjr.getDateDepart().deplacerVersAvant(DUREE_6_MOIS).estApres(p_date)))
    {
      EvenementChangementParametre evt = new EvenementChangementParametre("REVALORISATION", evtParam.getDateEvenement());
      
      evtsRetour.add(evt);
    }
    return evtsRetour;
  }
  
  public MontantBaseSpec calculMontant(FormuleMontantSpec p_formuleMontant, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_dateCalcul)
    throws CoucheLogiqueException
  {
    return p_formuleMontant.calculer(p_constituantsIndemnisation, p_dateCalcul);
  }
  
  public void imputerQuantiteIndemnisationDuAuxSanctions(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, PeriodeSuspensionDDTEAvecImputation p_periodeSuspensionDDTEAvecImputation, ConstituantsIndemnisation p_constituantsIndemnisation, ArretProduitAvecRaison p_arretProduitAvecRaison)
    throws ApplicativeException
  {
    QuantiteIndemnisationSpec dureeIndemnisation = null;
    Quantite nouvelleDureeIndemnisation = null;
    Quantite ancienneDureeIndemnisation = null;
    EvenementLendemainFinQuantiteDroit evtLendemainFinQuantiteDroit = null;
    
    dureeIndemnisation = OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(p_constituantsIndemnisation.getCollectionQuantiteDroit());
    
    Quantite quantiteDecalage = new Quantite(new BigDecimal(p_ut.getDuree() < p_periodeSuspensionDDTEAvecImputation.getDuree() ? p_ut.getDuree() : p_periodeSuspensionDDTEAvecImputation.getDuree()), p_ut.getUniteParDefautQuantites());
    if (quantiteDecalage != null) {
      if (p_ut.getCreditDecalageSanctions() != null) {
        p_ut.setCreditDecalageSanctions(quantiteDecalage.ajouter(p_ut.getCreditDecalageSanctions()));
      } else {
        p_ut.setCreditDecalageSanctions(quantiteDecalage);
      }
    }
    if ((dureeIndemnisation != null) && (quantiteDecalage != null))
    {
      nouvelleDureeIndemnisation = dureeIndemnisation.getQuantiteCourante().soustraire(quantiteDecalage);
      ancienneDureeIndemnisation = dureeIndemnisation.getQuantiteCourante();
      
      dureeIndemnisation.setQuantiteCourante(nouvelleDureeIndemnisation.getValeurEntiere() < 0 ? new QuantiteJour(new BigDecimal("0")) : nouvelleDureeIndemnisation);
    }
    if ((dureeIndemnisation != null) && (dureeIndemnisation.getQuantiteCourante().getValeurEntiere() == 0))
    {
      if ((quantiteDecalage != null) && (ancienneDureeIndemnisation != null))
      {
        Damj dateDebutImputation = p_ut.getDateDebut();
        if (dateDebutImputation.estAvant(p_attribution.getPji())) {
          dateDebutImputation = p_attribution.getPji();
        }
        if (p_periodeSuspensionDDTEAvecImputation.getPeriodeInitiale().getDebut().estApres(dateDebutImputation)) {
          dateDebutImputation = p_periodeSuspensionDDTEAvecImputation.getPeriodeInitiale().getDebut();
        }
        evtLendemainFinQuantiteDroit = new EvenementLendemainFinQuantiteDroit(dateDebutImputation.deplacerVersAvant(new DureeCalendaire(0, 0, quantiteDecalage.min(ancienneDureeIndemnisation).getValeurEntiere())), dureeIndemnisation);
      }
      else
      {
        evtLendemainFinQuantiteDroit = new EvenementLendemainFinQuantiteDroit(p_ut.getDateFin().lendemain(), dureeIndemnisation);
      }
      evtLendemainFinQuantiteDroit.setEstCauseFinProduit(true);
      p_arretProduitAvecRaison.ajouteLendemainFinQuantiteDroitArretCalcul(evtLendemainFinQuantiteDroit);
    }
  }
  
  public void traiterPeriodeInterruptiveDefinitive(AttributionSpec attribution, fr.unedic.cali.calcul.dom.UniteTraitement ut, ObjetChronoPeriode objetChronoPeriode, ArretProduitAvecRaison arretProduitAvecRaison, CalendrierExecutionCalculPeriodique calendrier)
    throws CoucheLogiqueException
  {
    if ((objetChronoPeriode instanceof ObjetChronoPeriodeAssDemandeExpresse))
    {
      arretProduitAvecRaison.setProduitAEteindre(true);
    }
    else if ((objetChronoPeriode instanceof ObjetChronoPeriodeAEDV))
    {
      boolean contientDejaInterruptifAmemeDate = verifiePresenceIntAvantOuMemeJourHorsDV(ut, objetChronoPeriode);
      if (!contientDejaInterruptifAmemeDate)
      {
        int rangEnquete = GestionSuivi.determinerRangEnqueteDRV(attribution, objetChronoPeriode);
        
        GestionSuivi.enregistrerEnquetePbjcNcp(attribution, objetChronoPeriode.getDateDebut(), 39, rangEnquete, true, null, this, null);
        if (attribution.getDemandeur().getIndividuPbjcNcp() == null) {
          attribution.getDemandeur().setIndividuPbjcNcp(new IndividuPbjcNcp());
        }
        attribution.getDemandeur().getIndividuPbjcNcp().setDateAtteinteMoisNonPaye(objetChronoPeriode.getDateDebut().veille());
        calendrier.setDateDrv(objetChronoPeriode.getDateDebut());
        ut.ajouterEvenement(new EvenementRejetDv(objetChronoPeriode.getDateDebut()));
      }
    }
    else if ((objetChronoPeriode instanceof PeriodeExclusionDefinitiveDDTE))
    {
      arretProduitAvecRaison.setProduitAEteindre(true);
    }
    else if ((objetChronoPeriode instanceof PeriodeFormationNonIndemniseeAbsenceHeure))
    {
      GestionAnomalies.ajouteAnomalie(new Anomalie("M06", objetChronoPeriode.getDateDebut(), ""), attribution.getDemandeur());
    }
    else if ((objetChronoPeriode instanceof ObjetChronoPeriodeFinDureeMaintienDroit))
    {
      ut.ajouterEvenement(new EvenementMaintienEuropeenDJI(objetChronoPeriode.getDateDebut().veille()));
    }
    else if (((objetChronoPeriode instanceof ObjetChronoPeriodeRejetDRV)) && 
      (((ObjetChronoPeriodeRejetDRV)objetChronoPeriode).isEstRejetDV()))
    {
      ut.ajouterEvenement(new EvenementRejetDv(objetChronoPeriode.getDateDebut()));
    }
  }
  
  public void realiserDetectionFinDeProduitPourSuivi(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    Damj finDeProduit = null;
    ArretProduitAvecRaison arretProduitAvecRaison = null;
    arretProduitAvecRaison = p_ut.getArretProduitAvecRaison();
    if (arretProduitAvecRaison.isRaisonsContientRaison(1)) {
      if (!arretProduitAvecRaison.getLendemainFinQuantiteIndemnisationArretCalcul().isEmpty())
      {
        finDeProduit = ((Temporel)arretProduitAvecRaison.getLendemainFinQuantiteIndemnisationArretCalcul().iterator().next()).getDateDebut().veille();
        if ((!p_contexteUT.existeAERenFinASU(finDeProduit)) && (!arretProduitAvecRaison.contientTypePeriodeInterruptive(ObjetChronoPeriodeRetraite.class)))
        {
          GestionSuivi.enregistrerEnquetePbjcNcp(p_attribution, finDeProduit, 5, 0, true, null, this, p_ut.getConstituantsIndemnisationEnFinUT());
          
          CritereStrategie critere = new CritereStrategie();
          critere.setDatePivot(p_contexteUT.getPeriodeUT().getDebut());
          FabriqueStrategieConvention2014 fabriqueAre14 = FabriqueStrategieConvention2014.getInstance();
          StrategieConventionARE14Spec strategieARE14 = (StrategieConventionARE14Spec)fabriqueAre14.getStrategie(critere);
          if (strategieARE14.estApresConventionARE14()) {
            GestionSuivi.enregistrerEnquetePbjcNcp(p_attribution, finDeProduit, 38, 0, true, null, this, p_ut.getConstituantsIndemnisationEnFinUT());
          }
        }
      }
    }
  }
  
  private boolean estEnFormation(fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
  {
    ChronologiePeriodes periodesSegmentantes = p_ut.getQualificationPeriodes().getPeriodesSegmentantes();
    periodesSegmentantes.iterer();
    while (periodesSegmentantes.encoreSuivant()) {
      if ((periodesSegmentantes.elementSuivant() instanceof PeriodeFormation)) {
        return true;
      }
    }
    return false;
  }
  
  public ResultatCalcul postTraitementResultatMigrationCalcul(AttributionSpec p_attribution, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul)
    throws CoucheLogiqueException
  {
    return PostTraitements.postTraitementResultatMigrationCalcul(p_attribution, (fr.unedic.cali.calcul.dom.CalendrierExecutionCalcul)p_calendrierExecutionCalcul);
  }
  
  public EtatAuDji renseignerEtatAuDji(fr.unedic.cali.calcul.dom.UniteTraitement p_derniereUT, CalendrierExecutionCalculPeriodique p_calendrier, AttributionSpec p_attribution, EtatAuDji p_etatAuDji)
    throws CoucheLogiqueException
  {
    int reliquatCumulAR = 0;
    EtatAuDjiGamme etatAuDji = new EtatAuDjiGamme();
    Quantite reliquatDureeIndemnisation = null;
    etatAuDji.setMontant(p_etatAuDji.getMontant());
    reliquatCumulAR = ((ConstituantsCalculActiviteReduiteGamme)p_derniereUT.getConstituantsCalculActiviteReduiteEnFinUT()).getCumul();
    etatAuDji.setCumulMoisActiviteReduite(reliquatCumulAR);
    reliquatDureeIndemnisation = recupererReliquatDureeIndemnisation(p_derniereUT);
    if (reliquatDureeIndemnisation != null)
    {
      etatAuDji.setReliquatDureeIndemnisation(new Quantite(reliquatDureeIndemnisation.getValeur().setScale(0), reliquatDureeIndemnisation.getUnite()));
      
      etatAuDji.setReliquatDureeIndemnisationAvecMaintien(etatAuDji.getReliquatDureeIndemnisation());
    }
    if (((AttributionAssuranceSpec)p_attribution).estMaintenue())
    {
      Damj retraite = OutillagePeriodes.genererPeriodeRetraite(p_attribution.getDemandeur()).getDateEffet();
      int dureeMaintien = retraite.joursEntre(p_calendrier.getDernierJourIndemnisable());
      etatAuDji.setReliquatDureeIndemnisationAvecMaintien(new Quantite(new BigDecimal(Integer.toString(dureeMaintien)), DureeIndemnisation.UNITE_DEFAUT));
    }
    etatAuDji.setNbJourAREF(p_derniereUT.getNbJoursFormationEnFinDUT());
    etatAuDji.setNbMoisIndemniseAsu(p_derniereUT.getNbMoisIndemniseAsu());
    etatAuDji.setEstNbMoisIndemniseAsu(p_derniereUT.isEstNbMoisIndemniseAsu());
    etatAuDji.setCumulMoisnonIndemnise(p_derniereUT.getConstituantsCalculActiviteReduiteEnFinUT().getCumulMoisNonIndemnise());
    return etatAuDji;
  }
  
  private Quantite recupererReliquatDureeIndemnisation(fr.unedic.cali.calcul.dom.UniteTraitement p_derniereUT)
  {
    Quantite reliquatDureeIndemnisation = null;
    Collection collectionQuantiteDroit = p_derniereUT.getConstituantsIndemnisationEnFinUT().getCollectionQuantiteDroit();
    QuantiteIndemnisationSpec quantiteIndemnisation = null;
    if (collectionQuantiteDroit != null)
    {
      Iterator iterator = collectionQuantiteDroit.iterator();
      while (iterator.hasNext())
      {
        QuantiteDroitSpec quantiteDroit = (QuantiteDroitSpec)iterator.next();
        if ((quantiteDroit instanceof QuantiteIndemnisationSpec))
        {
          quantiteIndemnisation = (QuantiteIndemnisationSpec)quantiteDroit;
          if (quantiteDroit.getEtat() == 1) {
            break;
          }
        }
      }
    }
    if (quantiteIndemnisation != null)
    {
      if (quantiteIndemnisation.getEtat() == 1) {
        reliquatDureeIndemnisation = quantiteIndemnisation.getQuantiteCourante();
      } else if (quantiteIndemnisation.getEtat() == 2) {
        reliquatDureeIndemnisation = new QuantiteJour(BigDecimal.ZERO);
      }
    }
    else {
      reliquatDureeIndemnisation = new QuantiteJour(BigDecimal.ZERO);
    }
    return reliquatDureeIndemnisation;
  }
  
  public int initialiserCompteurFormation(AttributionSpec p_attribution)
  {
    int nbJourFormation = 0;
    Attribution attribution = (Attribution)p_attribution;
    if ((attribution instanceof Poursuite))
    {
      nbJourFormation = ((Poursuite)attribution).getUniteTraitement().getNbJoursFormationEnFinDUT();
    }
    else if ((attribution instanceof RepriseSpec))
    {
      AttributionSpec attributionPrecedente = attribution.getAttributionPrecedente();
      if ((attribution.getAttributionPrecedente() != null) && ((attribution.getAttributionPrecedente().getTypeExamen().equals("ASU_17")) || (attribution.getAttributionPrecedente().getTypeExamen().equals("ASU_25")))) {
        attributionPrecedente = OutilFinDroit.rechercherAttributionCorrespondantePecedente(attributionPrecedente.getDemande());
      }
      if ((attributionPrecedente != null) && (attributionPrecedente.getCalendrierExecutionCalcul() != null) && (attributionPrecedente.getCalendrierExecutionCalcul().getEtatAuDJI() != null))
      {
        EtatAuDjiGamme etatAuDji = (EtatAuDjiGamme)attributionPrecedente.getCalendrierExecutionCalcul().getEtatAuDJI();
        nbJourFormation = etatAuDji.getNbJourAREF();
      }
    }
    return nbJourFormation;
  }
  
  public Damj recupererDateFinDroitTheorique(CalendrierExecutionCalculSpec p_calendrierExecutionCalcul, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    Damj dateFinDroitTheorique = null;
    EtatAuDjiGamme etatAuDji = (EtatAuDjiGamme)p_calendrierExecutionCalcul.getEtatAuDJI();
    BigDecimal reliquatDureeIndemnisation = null;
    if (etatAuDji != null)
    {
      if ((etatAuDji.getReliquatDureeIndemnisation() != null) && (etatAuDji.getReliquatDureeIndemnisation().getValeur() != null))
      {
        reliquatDureeIndemnisation = etatAuDji.getReliquatDureeIndemnisation().getValeur();
        dateFinDroitTheorique = p_calendrierExecutionCalcul.getDernierJourIndemnisable().deplacerVersAvant(new DureeCalendaire(0, 0, reliquatDureeIndemnisation.intValue()));
      }
      else
      {
        dateFinDroitTheorique = p_calendrierExecutionCalcul.getDernierJourIndemnisable();
      }
    }
    else
    {
      Attribution attribution = (Attribution)p_attribution;
      dateFinDroitTheorique = p_attribution.getPji().deplacerVersAvant(new DureeCalendaire(0, 0, attribution.getDureeIndemnisationTheorique().getValeurEntiere() - 1));
    }
    return dateFinDroitTheorique;
  }
  
  public boolean estEnActiviteConservee(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
    throws CoucheLogiqueException
  {
    if (((Attribution)p_attribution).getListeActiviteConservee() != null)
    {
      Iterator ite = ((Attribution)p_attribution).getListeActiviteConservee().iterer();
      boolean aUneActiviteEncoreConserve = false;
      while (ite.hasNext())
      {
        TravailSpec activite = (TravailSpec)ite.next();
        if (activite.getDateFin().estApresOuCoincideAvec(p_ut.getDateDebut())) {
          aUneActiviteEncoreConserve = true;
        }
      }
      return (!((Attribution)p_attribution).getListeActiviteConservee().estVide()) && (aUneActiviteEncoreConserve);
    }
    return false;
  }
  
  public void miseAJourConstituantsIndemnisationADate(AttributionSpec p_attribution, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_date, ChronologiePeriodes p_chronologiePeriodesSanctions)
    throws CoucheLogiqueException
  {
    ElementBaseIndemnisation elementBaseIndemnisationCourant = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
    
    elementBaseIndemnisationCourant.setMontantPensionInvaliditeADeduire(RecuperationPensionInvaliditeAvantDate.recuperationMontantPI(p_attribution.getDemandeur(), p_date.veille()));
    
    elementBaseIndemnisationCourant.setCoefficientAvantageVieillesse(new BigDecimal(0));
    elementBaseIndemnisationCourant.setMontantAvantageVieillesse(new BigDecimal(0));
    
    PeriodeAvantageVieillesse periodeAvCourante = RecuperationAvantageVieillesseAvantPJI.recupererPeriodeAvADate(((Attribution)p_attribution).getDemandeur(), p_date.veille());
    if (periodeAvCourante != null)
    {
      Damj dateDepart = Damj.max(p_attribution.getDateAttribution(), periodeAvCourante.getDateDebut());
      
      Sjr sjrDepart = RevalorisationSalaire.revaloriserSjr(((AttributionAssuranceSpec)p_attribution).getElementBaseIndemnisation(), ((AttributionAssuranceSpec)p_attribution).getProduitMontantRetenu(), dateDepart);
      
      BigDecimal coeffAV = periodeAvCourante.getQuantiteEuro().getValeur().divide(sjrDepart.getSalaire(), 10, 4);
      elementBaseIndemnisationCourant.setCoefficientAvantageVieillesse(coeffAV);
      
      Sjr sjrCourant = RevalorisationSalaire.revaloriserSjr(((AttributionAssuranceSpec)p_attribution).getElementBaseIndemnisation(), ((AttributionAssuranceSpec)p_attribution).getProduitMontantRetenu(), p_date.veille());
      
      elementBaseIndemnisationCourant.setCoefficientAvantageVieillesse(coeffAV);
      elementBaseIndemnisationCourant.setMontantAvantageVieillesse(coeffAV.multiply(sjrCourant.getSalaire()));
      
      elementBaseIndemnisationCourant.setDateEffetAV(p_date.veille());
    }
    elementBaseIndemnisationCourant.setCoefficientSanctionReduction(RecuperationSanctionReduction.recuperationCoefficientSanctionReductionADate(p_chronologiePeriodesSanctions, p_date));
  }
  
  public void imputerAvant(ObjetChronoPeriode p_periode, ConstituantsIndemnisation p_constituantsIndemnisation, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    QuantiteIndemnisationSpec dureeIndemnisation = null;
    Quantite nouvelleDureeIndemnisation = null;
    BigDecimal dureeImputation = null;
    boolean calcul = false;
    dureeIndemnisation = OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(p_constituantsIndemnisation.getCollectionQuantiteDroit());
    if (((p_periode instanceof PeriodeSuspensionDDTEAvecImputation)) && ((((PeriodeSuspensionDDTEAvecImputation)p_periode).getCodeSanction().equals("SD")) || (((PeriodeSuspensionDDTEAvecImputation)p_periode).getCodeSanction().equals("SE"))))
    {
      dureeImputation = new BigDecimal(((PeriodeSuspensionDDTEAvecImputation)p_periode).getDureeImputation());
      calcul = true;
    }
    else if (((p_periode instanceof FinPeriodeFormationNonIndemnisee)) && (((Attribution)p_attribution).getDureeInitiale().getValeurEntiere() > ((ProduitAsuSpec)p_attribution.getProduit()).getDureeMinimumPourImputationFormation()))
    {
      FinPeriodeFormationNonIndemnisee periode = (FinPeriodeFormationNonIndemnisee)p_periode;
      Quantite dureeFormation = ((FinPeriodeFormationNonIndemnisee)p_periode).getPeriodeFormationNonIndemnisee().getDureeTotale();
      Damj dateLendemainFaitGenerateur = ((Demande)p_attribution.getDemande()).getDateFaitGenerateurOuDernierSinistre().lendemain();
      if ((((FinPeriodeFormationNonIndemnisee)p_periode).getDateDebutFormation().estAvant(p_attribution.getDateAttribution())) && (periode.getDateDebutFormation().estAvant(dateLendemainFaitGenerateur)))
      {
        BigDecimal prorata = Mathematiques.diviseASup(new BigDecimal(periode.getDateFinFormation().joursEntre(dateLendemainFaitGenerateur)), new BigDecimal(periode.getDateFinFormation().joursEntre(periode.getDateDebutFormation())), 2);
        
        dureeImputation = prorata.multiply(dureeFormation.getValeur());
      }
      else
      {
        dureeImputation = dureeFormation.getValeur();
      }
      dureeImputation = Mathematiques.diviseEntier(dureeImputation, new BigDecimal("10"));
      
      BigDecimal valeurMax = dureeIndemnisation.getQuantiteCourante().getValeurEntiere() - 30 < 0 ? new BigDecimal("0") : new BigDecimal(dureeIndemnisation.getQuantiteCourante().getValeurEntiere() - 30);
      
      dureeImputation = dureeImputation.compareTo(valeurMax) == 1 ? valeurMax : dureeImputation;
      calcul = true;
    }
    if ((calcul) && (dureeIndemnisation != null))
    {
      nouvelleDureeIndemnisation = dureeIndemnisation.getQuantiteCourante().soustraire(new Quantite(dureeImputation, DureeIndemnisation.UNITE_DEFAUT));
      
      dureeIndemnisation.setQuantiteCourante(nouvelleDureeIndemnisation.getValeurEntiere() < 0 ? new QuantiteJour(new BigDecimal("0")) : nouvelleDureeIndemnisation);
    }
  }
  
  private void imputerQuantiteIndemnisationADate(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ObjetChronoPeriode p_periode, PeriodeAnalyseSpec p_pa, ConstituantsIndemnisation p_constituantsIndemnisation, ArretProduitAvecRaison p_arretProduitAvecRaison, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    QuantiteIndemnisationSpec dureeIndemnisation = null;
    Quantite nouvelleDureeIndemnisation = null;
    Quantite quantiteAImputee = null;
    BigDecimal dureeImputation = null;
    EvenementLendemainFinQuantiteDroit evtLendemainFinQuantiteDroit = null;
    Damj dateLendemainFinQuantiteDroit = null;
    dureeIndemnisation = OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(p_constituantsIndemnisation.getCollectionQuantiteDroit());
    if ((p_periode instanceof FinPeriodeFormationNonIndemnisee))
    {
      FinPeriodeFormationNonIndemnisee periode = (FinPeriodeFormationNonIndemnisee)p_periode;
      Quantite dureeFormation = ((FinPeriodeFormationNonIndemnisee)p_periode).getPeriodeFormationNonIndemnisee().getDureeTotale();
      
      Damj dateLendemainFaitGenerateur = ((Demande)((AttributionAssuranceSpec)p_attribution).getAttributionMaitre().getDemande()).getDateFaitGenerateurOuDernierSinistre().lendemain();
      if ((((FinPeriodeFormationNonIndemnisee)p_periode).getDateDebutFormation().estAvant(p_attribution.getDateAttribution())) && (periode.getDateDebutFormation().estAvant(dateLendemainFaitGenerateur)))
      {
        BigDecimal prorata = Mathematiques.diviseASup(new BigDecimal(periode.getDateFinFormation().joursEntre(dateLendemainFaitGenerateur)), new BigDecimal(periode.getDateFinFormation().joursEntre(periode.getDateDebutFormation())), 2);
        
        dureeImputation = prorata.multiply(dureeFormation.getValeur());
      }
      else
      {
        dureeImputation = dureeFormation.getValeur();
      }
      dureeImputation = Mathematiques.diviseEntier(dureeImputation, new BigDecimal("10"));
      
      BigDecimal valeurMax = dureeIndemnisation.getQuantiteCourante().getValeurEntiere() - 30 < 0 ? new BigDecimal("0") : new BigDecimal(dureeIndemnisation.getQuantiteCourante().getValeurEntiere() - 30);
      
      dureeImputation = dureeImputation.compareTo(valeurMax) == 1 ? valeurMax : dureeImputation;
    }
    if (dureeIndemnisation != null)
    {
      nouvelleDureeIndemnisation = dureeIndemnisation.getQuantiteCourante().soustraire(new Quantite(dureeImputation, DureeIndemnisation.UNITE_DEFAUT));
      
      quantiteAImputee = nouvelleDureeIndemnisation.getValeurEntiere() < 0 ? dureeIndemnisation.getQuantiteCourante() : new Quantite(dureeImputation, DureeIndemnisation.UNITE_DEFAUT);
      
      dureeIndemnisation.setQuantiteCourante(nouvelleDureeIndemnisation.getValeurEntiere() < 0 ? new QuantiteJour(new BigDecimal("0")) : nouvelleDureeIndemnisation);
      if (p_pa != null)
      {
        p_pa.setQuantiteImputeeNonIndemnisee(quantiteAImputee);
        dateLendemainFinQuantiteDroit = p_pa.getDateDebut().lendemain();
      }
      else
      {
        p_ut.setQuantiteImputeeNonIndemnisee(p_ut.getQuantiteImputeeNonIndemnisee().ajouter(quantiteAImputee));
        dateLendemainFinQuantiteDroit = p_periode.getDateDebut().lendemain();
      }
      if (dureeIndemnisation.getQuantiteCourante().getValeurEntiere() == 0)
      {
        evtLendemainFinQuantiteDroit = new EvenementLendemainFinQuantiteDroit(dateLendemainFinQuantiteDroit, dureeIndemnisation);
        evtLendemainFinQuantiteDroit.setEstCauseFinProduit(true);
        p_arretProduitAvecRaison.ajouteLendemainFinQuantiteDroitArretCalcul(evtLendemainFinQuantiteDroit);
      }
    }
  }
  
  private boolean existeAttributionPrecedenteAvecCumulAr(AttributionSpec p_attribution, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    AttributionSpec attributionPrecedente = ((Attribution)p_attribution).getAttributionPrecedente();
    if ((attributionPrecedente != null) && (attributionPrecedente.estNeutralise()) && (attributionPrecedente.getCalendrierExecutionCalcul() != null) && (p_contexteUT.getPeriodeUT().contient(attributionPrecedente.getCalendrierExecutionCalcul().getDernierJourIndemnisable()))) {
      return true;
    }
    while ((attributionPrecedente != null) && (p_contexteUT.getListeOrdonneeCandidats().contains(attributionPrecedente)))
    {
      ContexteUT.ElementContexteUT elementContexteUT = p_contexteUT.getElementContexteUT(attributionPrecedente);
      if ((elementContexteUT.getQuantiteIndemnisee() != null) && (elementContexteUT.getQuantiteIndemnisee().getValeur() != null) && (elementContexteUT.getQuantiteIndemnisee().getValeur().intValue() >= 1) && (elementContexteUT.getCreditDecalageSurUT() != null)) {
        return true;
      }
      if (((attributionPrecedente instanceof RepriseSpec)) || ((attributionPrecedente instanceof RevisionSpec))) {
        attributionPrecedente = ((Attribution)attributionPrecedente).getAttributionPrecedente();
      } else {
        attributionPrecedente = null;
      }
    }
    return false;
  }
  
  public void traitementPeriodesAlertantes(AttributionSpec p_attribution, ObjetChronoPeriode p_periode, ConstituantsIndemnisation p_constituantsIndemnisation, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, PeriodeAnalyseSpec p_pa, ArretProduitAvecRaison p_arretProduitAvecRaison)
    throws CoucheLogiqueException
  {}
  
  public boolean neutralisationApplicableRetourUL961()
  {
    return true;
  }
  
  public int calculerCompteurNombreMoisIndemnisesSurUT(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, int p_nbMoisIndemniseEnDebutDUT)
  {
    int nbMoisIndemniseAsu = p_ut.getNbMoisIndemniseEnDebutDUT();
    
    Quantite quantiteIndemnise = p_ut.getQuantiteIndemnisee();
    if (quantiteIndemnise.getValeur().intValue() >= 1) {
      nbMoisIndemniseAsu += 1;
    }
    return nbMoisIndemniseAsu;
  }
  
  public int initialiserNombreMoisIndemnise(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    int nbMoisIndemniseAsu = 0;
    Attribution attribution = (Attribution)p_attribution;
    if ((attribution instanceof Poursuite))
    {
      nbMoisIndemniseAsu = ((Poursuite)attribution).getUniteTraitement().getNbMoisIndemniseAsu();
    }
    else if ((attribution instanceof RepriseSpec))
    {
      AttributionSpec attributionPrecedente = attribution.getAttributionPrecedente();
      if ((attributionPrecedente != null) && ((attributionPrecedente.getTypeExamen().equals("ASU_17")) || (attributionPrecedente.getTypeExamen().equals("ASU_19")) || (attributionPrecedente.getTypeExamen().equals("ASU_25")))) {
        attributionPrecedente = OutilFinDroit.rechercherAttributionCorrespondantePecedente(attributionPrecedente.getDemande());
      }
      if ((attributionPrecedente != null) && (attributionPrecedente.getCalendrierExecutionCalcul() != null) && (attributionPrecedente.getCalendrierExecutionCalcul().getEtatAuDJI() != null))
      {
        EtatAuDjiGamme etatAuDji = (EtatAuDjiGamme)attributionPrecedente.getCalendrierExecutionCalcul().getEtatAuDJI();
        if (etatAuDji.isEstNbMoisIndemniseAsu()) {
          nbMoisIndemniseAsu = etatAuDji.getNbMoisIndemniseAsu();
        }
        if ((attributionPrecedente.getCalendrierExecutionCalcul().getDernierJourIndemnisable() != null) && (p_ut.getPeriode().contient(attributionPrecedente.getCalendrierExecutionCalcul().getDernierJourIndemnisable()))) {
          if ((attributionPrecedente.estNeutralise()) || (!attributionPrecedente.estExecutable()))
          {
            nbMoisIndemniseAsu = Math.max(0, nbMoisIndemniseAsu--);
          }
          else
          {
            ContexteUT.ElementContexteUT elementContexteUT = p_contexteUT.getElementContexteUT(attributionPrecedente);
            if ((elementContexteUT.getQuantiteIndemnisee() != null) && (elementContexteUT.getQuantiteIndemnisee().getValeur() != null) && (elementContexteUT.getQuantiteIndemnisee().getValeur().intValue() > 0) && (p_ut.getQuantiteIndemnisee() != null) && (p_ut.getQuantiteIndemnisee().getValeur() != null) && (p_ut.getQuantiteIndemnisee().getValeur().intValue() > 0)) {
              nbMoisIndemniseAsu--;
            }
          }
        }
      }
    }
    return nbMoisIndemniseAsu;
  }
  
  public boolean recuperationAlimentationNombreMoisIndemnise(AttributionSpec p_attribution)
  {
    boolean estAlimenteNbMoisIndemniseAsu = false;
    Attribution attribution = (Attribution)p_attribution;
    if ((attribution instanceof Poursuite))
    {
      estAlimenteNbMoisIndemniseAsu = ((Poursuite)attribution).getUniteTraitement().getNbMoisIndemniseAsu() != 0;
    }
    else if ((attribution instanceof RepriseSpec))
    {
      AttributionSpec attributionPrecedente = attribution.getAttributionPrecedente();
      if ((attribution.getAttributionPrecedente() != null) && ((attribution.getAttributionPrecedente().getTypeExamen().equals("ASU_17")) || (attribution.getAttributionPrecedente().getTypeExamen().equals("ASU_25")))) {
        attributionPrecedente = OutilFinDroit.rechercherAttributionCorrespondantePecedente(attributionPrecedente.getDemande());
      }
      if ((attributionPrecedente != null) && (attributionPrecedente.getCalendrierExecutionCalcul() != null) && (attributionPrecedente.getCalendrierExecutionCalcul().getEtatAuDJI() != null))
      {
        EtatAuDjiGamme etatAuDji = (EtatAuDjiGamme)attributionPrecedente.getCalendrierExecutionCalcul().getEtatAuDJI();
        
        estAlimenteNbMoisIndemniseAsu = etatAuDji.isEstNbMoisIndemniseAsu();
      }
    }
    else if ((attribution instanceof OdSpec))
    {
      estAlimenteNbMoisIndemniseAsu = true;
    }
    else
    {
      estAlimenteNbMoisIndemniseAsu = false;
    }
    return estAlimenteNbMoisIndemniseAsu;
  }
  
  public void controleActiviteReduiteMaintienEuropeen(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ArretProduitAvecRaison p_arretProduitAvecRaison, ConstituantsIndemnisation p_constituantsIndemnisation)
    throws CoucheLogiqueException
  {
    OutilsMaintienEuropeenEessiASU.controleActiviteReduiteMaintienEuropeen(p_attribution, p_ut, p_arretProduitAvecRaison, p_constituantsIndemnisation);
  }
  
  public Damj getIdeMaintienEuropeenDuDroit(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return OutilsMaintienEuropeenEessiASU.getIdeMaintienEuropeenDuDroit(p_attribution);
  }
  
  public Damj getPjiMaintienEuropeenDuDroit(AttributionSpec p_attribution)
  {
    return OutilsMaintienEuropeenEessiASU.getPjiMaintienEuropeenDuDroit(p_attribution);
  }
  
  public Damj getDjiMaintienEuropeenDuDroit(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return OutilsMaintienEuropeenEessiASU.getDjiMaintienEuropeenDuDroit(p_attribution, this);
  }
  
  private boolean existeAttributionAsrPrecedenteAvecCumulAr(AttributionSpec p_attribution, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    Attribution attribution = (Attribution)p_attribution;
    AttributionSpec attributionPrecedente = attribution.getAttributionPrecedente();
    if ((attributionPrecedente != null) && (attribution.getAttributionPrecedente().getTypeExamen().equals("ASU_17")))
    {
      attributionPrecedente = OutilAsr.rechercherDernierDroitAsr(attributionPrecedente.getDemande());
      if ((attributionPrecedente != null) && (attributionPrecedente.estNeutralise()) && (attributionPrecedente.getCalendrierExecutionCalcul() != null) && (p_contexteUT.getPeriodeUT().contient(attributionPrecedente.getCalendrierExecutionCalcul().getDernierJourIndemnisable()))) {
        return true;
      }
    }
    return false;
  }
  
  public boolean enregistrerDroitPBJCNCP(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return true;
  }
  
  public boolean enregistrerEnquetePBJCNCP()
  {
    return true;
  }
  
  public void alimenterGrapheAntecedentCalcul(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    if ((p_attribution instanceof Poursuite)) {
      GestionPoursuiteCalcul.getInstance().alimenterGrapheCalcul(p_attribution);
    } else {
      GestionAntecedentCalcul.getInstance().alimenterGrapheCalcul(p_attribution);
    }
  }
  
  public Damj recupererPremierJourExecutableNcp(AttributionSpec p_attribution)
  {
    if ((p_attribution instanceof Poursuite)) {
      return ((Poursuite)p_attribution).getPjp();
    }
    return p_attribution.getPji();
  }
  
  public fr.unedic.cali.calcul.dom.EvenementFinQuantiteDroit creerEvenementFinQuantiteDroit(Damj p_dateEffet, QuantiteDroitSpec p_quantiteDroit)
  {
    return new fr.unedic.cali.asu.cge01.p03.calcul.dom.EvenementFinQuantiteDroit(p_dateEffet, p_quantiteDroit);
  }
  
  public fr.unedic.cali.calcul.dom.periode.DsmTravail convertirDsmTravailVersDsmTravailProduit(fr.unedic.cali.calcul.dom.periode.DsmTravail p_dsmTravail)
  {
    return new fr.unedic.cali.asu.cge01.p03.calcul.dom.periode.DsmTravail(p_dsmTravail);
  }
  
  public void postTraitementQualification(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, QualificationPeriodes p_qualificationPeriodes)
    throws CoucheLogiqueException
  {}
  
  public void traitementActiviteReduiteSurPa(PeriodeAnalyseSpec p_pa, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, AttributionSpec p_attribution, MontantBaseSpec p_montant, BigDecimal sjr)
    throws CoucheLogiqueException
  {
    Quantite creditDecalage = null;
    CritereStrategie critere = new CritereStrategie();
    critere.setDatePivot(p_pa.getDateDebut());
    StrategieConventionARE14Spec strategie = (StrategieConventionARE14Spec)FabriqueStrategieConvention2014.getInstance().getStrategie(critere);
    if (strategie.estApresConventionARE14())
    {
      Quantite quantiteSansSup = null;
      
      quantiteSansSup = p_pa.getQuantiteIndemnisable().soustraire(p_pa.getQuantiteNonIndemnisee());
      if (!p_ut.getChronoPeriodeDecalante().estVide()) {
        creditDecalage = ActiviteReduite.traitementActiviteReduiteSurPa(p_pa, p_ut.getChronoPeriodeDecalante(), p_attribution, p_montant, quantiteSansSup, p_ut, sjr);
      }
    }
  }
  
  public BigDecimal recupererPlafondGlobal(AttributionSpec p_attribution, Damj p_dateDebut, BigDecimal p_sjr)
  {
    return null;
  }
  
  private boolean verifiePresenceIntAvantOuMemeJourHorsDV(fr.unedic.cali.calcul.dom.UniteTraitement ut, ObjetChronoPeriode objetChronoPeriode)
  {
    boolean contientDejaInterruptifAmemeDate = false;
    ChronologiePeriodes periodesInterruptivesDefinitives = ut.getQualificationPeriodes().getPeriodesInterruptivesDefinitives();
    ObjetChronoPeriode objet = null;
    Iterator<ObjetChronoPeriode> ite = periodesInterruptivesDefinitives.iterer();
    while (ite.hasNext())
    {
      objet = (ObjetChronoPeriode)ite.next();
      if ((objet.getDateDebut().estAvantOuCoincideAvec(objetChronoPeriode.getDateDebut())) && (!(objet instanceof ObjetChronoPeriodeAEDV)) && (!(objet instanceof ObjetChronoPeriodeRejetDVFilEau))) {
        contientDejaInterruptifAmemeDate = true;
      }
    }
    return contientDejaInterruptifAmemeDate;
  }
}

/* Location:
 * Qualified Name:     FacadeCalculProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */