package fr.unedic.cali.asu.cge01.p03.liquidation.dom;

import fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen.ConstitutionElementsRevisionGen;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import java.util.ArrayList;
import java.util.List;

public class ConstitutionElementsRevision
  extends ConstitutionElementsRevisionGen
  implements ConstitutionElementsSpec
{
  public ConstitutionElementsRevision(DomPCSpec p_constitutionElementsRevisionPC)
  {
    super(p_constitutionElementsRevisionPC);
  }
  
  public ConstitutionElementsRevision() {}
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  protected List getListeElementsDroit()
  {
    List listeConstitutionDroit = new ArrayList();
    listeConstitutionDroit.add(getConstitutionSjr());
    listeConstitutionDroit.add(getConstitutionDelais());
    listeConstitutionDroit.add(getConstitutionDurees());
    listeConstitutionDroit.add(getConstitutionSjc());
    listeConstitutionDroit.add(getConstitutionMontantsBruts());
    listeConstitutionDroit.add(getConstitutionPointDepartIndemnisation());
    listeConstitutionDroit.add(getConstitutionCoefficientTempsPartiel());
    listeConstitutionDroit.add(getConstitutionDateAttribution());
    return listeConstitutionDroit;
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(super.getConstitutionSjr());
    DomManager.persisterEnProfondeur(super.getConstitutionDelais());
    DomManager.persisterEnProfondeur(super.getConstitutionDurees());
    DomManager.persisterEnProfondeur(super.getConstitutionSjc());
    DomManager.persisterEnProfondeur(super.getConstitutionDateAttribution());
    DomManager.persisterEnProfondeur(super.getConstitutionMontantsBruts());
    DomManager.persisterEnProfondeur(super.getConstitutionPointDepartIndemnisation());
    DomManager.persisterEnProfondeur(super.getConstitutionCoefficientTempsPartiel());
  }
  
  public ObjetMetierSpec copie()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller le méthode copieElements(ObjetMetierSpec).");
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ConstitutionElementsRevision copie = (ConstitutionElementsRevision)p_copie;
    if (getConstitutionDateAttribution() != null)
    {
      ConstitutionDateAttribution copieCepa = copie.createConstitutionDateAttribution();
      getConstitutionDateAttribution().copieElements(copieCepa);
    }
    if (getConstitutionDelais() != null)
    {
      ConstitutionDelais copieCepa = copie.createConstitutionDelais();
      getConstitutionDelais().copieElements(copieCepa);
    }
    if (getConstitutionMontantsBruts() != null)
    {
      ConstitutionMontantsBruts copieCepa = copie.createConstitutionMontantsBruts();
      getConstitutionMontantsBruts().copieElements(copieCepa);
    }
    if (getConstitutionSjc() != null)
    {
      ConstitutionSjc copieCepa = copie.createConstitutionSjc();
      getConstitutionSjc().copieElements(copieCepa);
    }
    if (getConstitutionSjr() != null)
    {
      ConstitutionSjr copieCepa = copie.createConstitutionSjr();
      getConstitutionSjr().copieElements(copieCepa);
    }
    if (getConstitutionPointDepartIndemnisation() != null)
    {
      ConstitutionPointDepartIndemnisation copieCepa = copie.createConstitutionPointDepartIndemnisation();
      getConstitutionPointDepartIndemnisation().copieElements(copieCepa);
    }
    if (getConstitutionCoefficientTempsPartiel() != null)
    {
      ConstitutionCoefficientTempsPartiel copieCepa = copie.createConstitutionCoefficientTempsPartiel();
      getConstitutionCoefficientTempsPartiel().copieElements(copieCepa);
    }
    if (getConstitutionDurees() != null)
    {
      ConstitutionDurees copieCepa = copie.createConstitutionDurees();
      getConstitutionDurees().copieElements(copieCepa);
    }
  }
  
  public void jdoPreClear() {}
  
  public void jdoPreDelete() {}
  
  public void jdoPostLoad() {}
  
  public void jdoPreStore() {}
  
  public ConstitutionCaractereSaisonnier createConstitutionCaractereSaisonnier()
  {
    return null;
  }
  
  public ConstitutionCoefficientSaisonnier createConstitutionCoefficientSaisonnier()
  {
    return null;
  }
  
  public ConstitutionReglementApplicable createConstitutionReglementApplicable()
  {
    return null;
  }
  
  public ConstitutionCaractereSaisonnier getConstitutionCaractereSaisonnier()
  {
    return null;
  }
  
  public ConstitutionCoefficientSaisonnier getConstitutionCoefficientSaisonnier()
  {
    return null;
  }
  
  public ConstitutionReglementApplicable getConstitutionReglementApplicable()
  {
    return null;
  }
  
  public ConstitutionProduitResultant getConstitutionProduitResultant()
  {
    return null;
  }
}

/* Location:
 * Qualified Name:     ConstitutionElementsRevision
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */