package fr.unedic.cali.asu.cge01.p03.liquidation.dom;

import fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen.ConstitutionMontantsBrutsGen;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.spec.ConstitutionElementsAbstraitPC;
import fr.unedic.cali.asu.dom.ConstitutionMontantsBrutsSpec;
import fr.unedic.cali.asu.dom.MontantAsuSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;

public class ConstitutionMontantsBruts
  extends ConstitutionMontantsBrutsGen
  implements ConstitutionMontantsBrutsSpec
{
  private transient Quantite m_montantBrutSansDeduction;
  private transient int m_flagParent;
  private transient MontantAsuSpec m_montantAAttribution;
  public static final int FLAG_CONSTITUTION_MONTANTS_BRUTS = 1;
  public static final int FLAG_CONSTITUTION_PRODUIT_RESULTANT = 2;
  
  private ConstitutionMontantsBruts() {}
  
  private ConstitutionMontantsBruts(int p_flagParent)
  {
    m_flagParent = p_flagParent;
  }
  
  public ConstitutionMontantsBruts(DomPCSpec p_constitutionElementsAdmissionPC, int p_flagParent)
  {
    super(p_constitutionElementsAdmissionPC);
    m_flagParent = p_flagParent;
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public int getFlagParent()
  {
    return m_flagParent;
  }
  
  public Quantite getMontantJournalierBrut()
  {
    if (m_flagParent == 1) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierBrutConstitutionMontantsBruts();
    }
    if (m_flagParent == 2) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierBrutConstitutionProduitResultant();
    }
    return null;
  }
  
  public void setMontantJournalierBrut(Quantite p_quantite)
  {
    if (m_flagParent == 1) {
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierBrutConstitutionMontantsBruts(p_quantite);
    }
    if (m_flagParent == 2) {
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierBrutConstitutionProduitResultant(p_quantite);
    }
  }
  
  public Quantite getCapitalInitialBrut()
  {
    if (m_flagParent == 1) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getCapitalInitialBrutConstitutionMontantsBruts();
    }
    if (m_flagParent == 2) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getCapitalInitialBrutConstitutionProduitResultant();
    }
    return null;
  }
  
  public void setCapitalInitialBrut(Quantite p_quantite)
  {
    if (m_flagParent == 1) {
      ((ConstitutionElementsAbstraitPC)getPC()).setCapitalInitialBrutConstitutionMontantsBruts(p_quantite);
    }
    if (m_flagParent == 2) {
      ((ConstitutionElementsAbstraitPC)getPC()).setCapitalInitialBrutConstitutionProduitResultant(p_quantite);
    }
  }
  
  public Quantite getMontantBase()
  {
    if (m_flagParent == 1) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getMontantBaseConstitutionMontantsBruts();
    }
    if (m_flagParent == 2) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getMontantBaseConstitutionProduitResultant();
    }
    return null;
  }
  
  public Quantite getMontantMini()
  {
    if (m_flagParent == 1) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getMontantMiniConstitutionMontantsBruts();
    }
    if (m_flagParent == 2) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getMontantMiniConstitutionProduitResultant();
    }
    return null;
  }
  
  public Quantite getMontantPlafond()
  {
    if (m_flagParent == 1) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getMontantPlafondConstitutionMontantsBruts();
    }
    if (m_flagParent == 2) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getMontantPlafondConstitutionProduitResultant();
    }
    return null;
  }
  
  public Quantite getMontantPlancher()
  {
    if (m_flagParent == 1) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getMontantPlancherConstitutionMontantsBruts();
    }
    if (m_flagParent == 2) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getMontantPlancherConstitutionProduitResultant();
    }
    return null;
  }
  
  public void setMontantBase(Quantite p_quantite)
  {
    if (m_flagParent == 1) {
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantBaseConstitutionMontantsBruts(p_quantite);
    }
    if (m_flagParent == 2) {
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantBaseConstitutionProduitResultant(p_quantite);
    }
  }
  
  public void setMontantMini(Quantite p_quantite)
  {
    if (m_flagParent == 1) {
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantMiniConstitutionMontantsBruts(p_quantite);
    }
    if (m_flagParent == 2) {
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantMiniConstitutionProduitResultant(p_quantite);
    }
  }
  
  public void setMontantPlafond(Quantite p_quantite)
  {
    if (m_flagParent == 1) {
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantPlafondConstitutionMontantsBruts(p_quantite);
    }
    if (m_flagParent == 2) {
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantPlafondConstitutionProduitResultant(p_quantite);
    }
  }
  
  public void setMontantPlancher(Quantite p_quantite)
  {
    if (m_flagParent == 1) {
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantPlancherConstitutionMontantsBruts(p_quantite);
    }
    if (m_flagParent == 2) {
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantPlancherConstitutionProduitResultant(p_quantite);
    }
  }
  
  public Quantite getPensionInvaliditeADeduirePriseEnCompte()
  {
    if (m_flagParent == 1) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getPensionInvaliditeADeduirePriseEnCompteConstitutionMontantsBruts();
    }
    if (m_flagParent == 2) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getPensionInvaliditeADeduirePriseEnCompteConstitutionProduitResultant();
    }
    return null;
  }
  
  public void setPensionInvaliditeADeduirePriseEnCompte(Quantite p_quantite)
  {
    if (m_flagParent == 1) {
      ((ConstitutionElementsAbstraitPC)getPC()).setPensionInvaliditeADeduirePriseEnCompteConstitutionMontantsBruts(p_quantite);
    }
    if (m_flagParent == 2) {
      ((ConstitutionElementsAbstraitPC)getPC()).setPensionInvaliditeADeduirePriseEnCompteConstitutionProduitResultant(p_quantite);
    }
  }
  
  public Quantite getMontantBrutSansPensionInvaliditeADeduire()
  {
    if (m_flagParent == 1) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getMontantBrutSansPensionInvaliditeADeduireConstitutionMontantsBruts();
    }
    if (m_flagParent == 2) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getMontantBrutSansPensionInvaliditeADeduireConstitutionProduitResultant();
    }
    return null;
  }
  
  public void setMontantBrutSansPensionInvaliditeADeduire(Quantite p_quantite)
  {
    if (m_flagParent == 1) {
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantBrutSansPensionInvaliditeADeduireConstitutionMontantsBruts(p_quantite);
    }
    if (m_flagParent == 2) {
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantBrutSansPensionInvaliditeADeduireConstitutionProduitResultant(p_quantite);
    }
  }
  
  public Quantite getMontantJournalierAvantageVieillesse()
  {
    if (m_flagParent == 1) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierAvantageVieillesseConstitutionMontantsBruts();
    }
    if (m_flagParent == 2) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierAvantageVieillesseConstitutionProduitResultant();
    }
    return null;
  }
  
  public void setMontantJournalierAvantageVieillesse(Quantite p_montantJournalierAvantageVieillesse)
  {
    if (m_flagParent == 1) {
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierAvantageVieillesseConstitutionMontantsBruts(p_montantJournalierAvantageVieillesse);
    }
    if (m_flagParent == 2) {
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierAvantageVieillesseConstitutionProduitResultant(p_montantJournalierAvantageVieillesse);
    }
  }
  
  public Quantite getMontantJournalierAvantageVieillesseDeduit()
  {
    if (m_flagParent == 1) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierAvantageVieillesseDeduitConstitutionMontantsBruts();
    }
    if (m_flagParent == 2) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getMontantJournalierAvantageVieillesseDeduitConstitutionProduitResultant();
    }
    return null;
  }
  
  public void setMontantJournalierAvantageVieillesseDeduit(Quantite p_montantJournalierAvantageVieillesseDeduit)
  {
    if (m_flagParent == 1) {
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierAvantageVieillesseDeduitConstitutionMontantsBruts(p_montantJournalierAvantageVieillesseDeduit);
    }
    if (m_flagParent == 2) {
      ((ConstitutionElementsAbstraitPC)getPC()).setMontantJournalierAvantageVieillesseDeduitConstitutionProduitResultant(p_montantJournalierAvantageVieillesseDeduit);
    }
  }
  
  public Quantite getMontantBrutSansDeduction()
  {
    return m_montantBrutSansDeduction;
  }
  
  public void setMontantBrutSansDeduction(Quantite p_quantite)
  {
    m_montantBrutSansDeduction = p_quantite;
  }
  
  public MontantAsuSpec getMontantAAttribution()
  {
    return m_montantAAttribution;
  }
  
  public void setMontantAAttribution(MontantAsuSpec p_montantAAttribution)
  {
    m_montantAAttribution = p_montantAAttribution;
  }
  
  public void marquerGraphePersistant() {}
  
  public ObjetMetierSpec copie()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller le méthode copieElements(ObjetMetierSpec).");
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ConstitutionMontantsBruts copie = (ConstitutionMontantsBruts)p_copie;
    
    copie.setCapitalInitialBrut(getCapitalInitialBrut());
    copie.setMontantBase(getMontantBase());
    copie.setMontantBrutSansPensionInvaliditeADeduire(getMontantBrutSansPensionInvaliditeADeduire());
    copie.setMontantJournalierBrut(getMontantJournalierBrut());
    copie.setMontantBrutSansDeduction(getMontantBrutSansDeduction());
    copie.setMontantMini(getMontantMini());
    copie.setMontantPlafond(getMontantPlafond());
    copie.setMontantPlancher(getMontantPlancher());
    copie.setPensionInvaliditeADeduirePriseEnCompte(getPensionInvaliditeADeduirePriseEnCompte());
    copie.setMontantJournalierAvantageVieillesse(getMontantJournalierAvantageVieillesse());
    copie.setMontantJournalierAvantageVieillesseDeduit(getMontantJournalierAvantageVieillesseDeduit());
    copie.setCrc(getCrc());
    copie.setMontantAAttribution(getMontantAAttribution());
  }
  
  public Quantite getCrc()
  {
    if (m_flagParent == 1) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getCrcConstitutionMontantsBruts();
    }
    if (m_flagParent == 2) {
      return ((ConstitutionElementsAbstraitPC)getPC()).getCrcConstitutionConstitutionProduitResultant();
    }
    return null;
  }
  
  public void setCrc(Quantite p_crc)
  {
    if (m_flagParent == 1) {
      ((ConstitutionElementsAbstraitPC)getPC()).setCrcConstitutionMontantsBruts(p_crc);
    }
    if (m_flagParent == 2) {
      ((ConstitutionElementsAbstraitPC)getPC()).setCrcConstitutionConstitutionProduitResultant(p_crc);
    }
  }
  
  public void jdoPreClear() {}
  
  public void jdoPreDelete() {}
  
  public void jdoPostLoad() {}
  
  public void jdoPreStore() {}
}

/* Location:
 * Qualified Name:     ConstitutionMontantsBruts
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */