package fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.spec.ConditionsAttributionAbstraitPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import java.math.BigDecimal;

public abstract class ConditionActiviteConserveeGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_conditionsAttributionAbstraitPC;
  private BigDecimal m_nombreHeuresMensuelActiviteConservee;
  private BigDecimal m_montantMensuelActiviteConservee;
  private BigDecimal m_seuilMontantMensuelActiviteConservee;
  
  public ConditionActiviteConserveeGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConditionActiviteConserveeGen() {}
  
  public DomPCSpec getPC()
  {
    return m_conditionsAttributionAbstraitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_conditionsAttributionAbstraitPC)
  {
    m_conditionsAttributionAbstraitPC = p_conditionsAttributionAbstraitPC;
  }
  
  protected int rawGetSituationConditionActiviteConservee()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getSituationConditionActiviteConservee();
  }
  
  public int getSituationConditionActiviteConservee()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getSituationConditionActiviteConservee();
  }
  
  public void setSituationConditionActiviteConservee(int p_situationConditionActiviteConservee)
  {
    ((ConditionsAttributionAbstraitPC)getPC()).setSituationConditionActiviteConservee(p_situationConditionActiviteConservee);
  }
  
  protected int rawGetCodeMotifEchec()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getCodeMotifEchecConditionActiviteConservee();
  }
  
  public int getCodeMotifEchec()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getCodeMotifEchecConditionActiviteConservee();
  }
  
  public void setCodeMotifEchec(int p_codeMotifEchec)
  {
    ((ConditionsAttributionAbstraitPC)getPC()).setCodeMotifEchecConditionActiviteConservee(p_codeMotifEchec);
  }
  
  protected int rawGetEtat()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getEtatConditionActiviteConservee();
  }
  
  public int getEtat()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getEtatConditionActiviteConservee();
  }
  
  public void setEtat(int p_etat)
  {
    ((ConditionsAttributionAbstraitPC)getPC()).setEtatConditionActiviteConservee(p_etat);
  }
  
  protected BigDecimal rawGetNombreHeuresMensuelActiviteConservee()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getNombreHeuresMensuelActiviteConserveeConditionActiviteConservee();
  }
  
  public BigDecimal getNombreHeuresMensuelActiviteConservee()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getNombreHeuresMensuelActiviteConserveeConditionActiviteConservee();
  }
  
  public void setNombreHeuresMensuelActiviteConservee(BigDecimal p_nombreHeuresMensuelActiviteConservee)
  {
    if ((m_nombreHeuresMensuelActiviteConservee == null) || (p_nombreHeuresMensuelActiviteConservee == null))
    {
      m_nombreHeuresMensuelActiviteConservee = p_nombreHeuresMensuelActiviteConservee;
      ((ConditionsAttributionAbstraitPC)getPC()).setNombreHeuresMensuelActiviteConserveeConditionActiviteConservee(p_nombreHeuresMensuelActiviteConservee);
    }
    else if ((m_nombreHeuresMensuelActiviteConservee != null) && (p_nombreHeuresMensuelActiviteConservee != null) && (!p_nombreHeuresMensuelActiviteConservee.equals(m_nombreHeuresMensuelActiviteConservee)))
    {
      m_nombreHeuresMensuelActiviteConservee = p_nombreHeuresMensuelActiviteConservee;
      ((ConditionsAttributionAbstraitPC)getPC()).setNombreHeuresMensuelActiviteConserveeConditionActiviteConservee(p_nombreHeuresMensuelActiviteConservee);
    }
  }
  
  protected BigDecimal rawGetMontantMensuelActiviteConservee()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getMontantMensuelActiviteConserveeConditionActiviteConservee();
  }
  
  public BigDecimal getMontantMensuelActiviteConservee()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getMontantMensuelActiviteConserveeConditionActiviteConservee();
  }
  
  public void setMontantMensuelActiviteConservee(BigDecimal p_montantMensuelActiviteConservee)
  {
    if ((m_montantMensuelActiviteConservee == null) || (p_montantMensuelActiviteConservee == null))
    {
      m_montantMensuelActiviteConservee = p_montantMensuelActiviteConservee;
      ((ConditionsAttributionAbstraitPC)getPC()).setMontantMensuelActiviteConserveeConditionActiviteConservee(p_montantMensuelActiviteConservee);
    }
    else if ((m_montantMensuelActiviteConservee != null) && (p_montantMensuelActiviteConservee != null) && (!p_montantMensuelActiviteConservee.equals(m_montantMensuelActiviteConservee)))
    {
      m_montantMensuelActiviteConservee = p_montantMensuelActiviteConservee;
      ((ConditionsAttributionAbstraitPC)getPC()).setMontantMensuelActiviteConserveeConditionActiviteConservee(p_montantMensuelActiviteConservee);
    }
  }
  
  protected BigDecimal rawGetSeuilMontantMensuelActiviteConservee()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getSeuilMontantMensuelActiviteConserveeConditionActiviteConservee();
  }
  
  public BigDecimal getSeuilMontantMensuelActiviteConservee()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getSeuilMontantMensuelActiviteConserveeConditionActiviteConservee();
  }
  
  public void setSeuilMontantMensuelActiviteConservee(BigDecimal p_seuilMontantMensuelActiviteConservee)
  {
    if ((m_seuilMontantMensuelActiviteConservee == null) || (p_seuilMontantMensuelActiviteConservee == null))
    {
      m_seuilMontantMensuelActiviteConservee = p_seuilMontantMensuelActiviteConservee;
      ((ConditionsAttributionAbstraitPC)getPC()).setSeuilMontantMensuelActiviteConserveeConditionActiviteConservee(p_seuilMontantMensuelActiviteConservee);
    }
    else if ((m_seuilMontantMensuelActiviteConservee != null) && (p_seuilMontantMensuelActiviteConservee != null) && (!p_seuilMontantMensuelActiviteConservee.equals(m_seuilMontantMensuelActiviteConservee)))
    {
      m_seuilMontantMensuelActiviteConservee = p_seuilMontantMensuelActiviteConservee;
      ((ConditionsAttributionAbstraitPC)getPC()).setSeuilMontantMensuelActiviteConserveeConditionActiviteConservee(p_seuilMontantMensuelActiviteConservee);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    setSituationConditionActiviteConservee(0);
    setCodeMotifEchec(0);
    setEtat(0);
    setNombreHeuresMensuelActiviteConservee(null);
    setMontantMensuelActiviteConservee(null);
    setSeuilMontantMensuelActiviteConservee(null);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConditionActiviteConserveeGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */