package fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.spec.ConditionsAttributionAbstraitPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public abstract class ConditionValiditeReliquatGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_conditionsAttributionAbstraitPC;
  private Damj m_dateDecheance;
  
  public ConditionValiditeReliquatGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConditionValiditeReliquatGen() {}
  
  public DomPCSpec getPC()
  {
    return m_conditionsAttributionAbstraitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_conditionsAttributionAbstraitPC)
  {
    m_conditionsAttributionAbstraitPC = p_conditionsAttributionAbstraitPC;
  }
  
  protected int rawGetEtat()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getEtatConditionValiditeReliquat();
  }
  
  public int getEtat()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getEtatConditionValiditeReliquat();
  }
  
  public void setEtat(int p_etat)
  {
    ((ConditionsAttributionAbstraitPC)getPC()).setEtatConditionValiditeReliquat(p_etat);
  }
  
  protected int rawGetCodeMotifEchec()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getCodeMotifEchecConditionValiditeReliquat();
  }
  
  public int getCodeMotifEchec()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getCodeMotifEchecConditionValiditeReliquat();
  }
  
  public void setCodeMotifEchec(int p_codeMotifEchec)
  {
    ((ConditionsAttributionAbstraitPC)getPC()).setCodeMotifEchecConditionValiditeReliquat(p_codeMotifEchec);
  }
  
  protected Damj rawGetDateDecheance()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getDateDecheanceConditionValiditeReliquat();
  }
  
  public Damj getDateDecheance()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getDateDecheanceConditionValiditeReliquat();
  }
  
  public void setDateDecheance(Damj p_dateDecheance)
  {
    if ((m_dateDecheance == null) || (p_dateDecheance == null))
    {
      m_dateDecheance = p_dateDecheance;
      ((ConditionsAttributionAbstraitPC)getPC()).setDateDecheanceConditionValiditeReliquat(p_dateDecheance);
    }
    else if ((m_dateDecheance != null) && (p_dateDecheance != null) && (!p_dateDecheance.equals(m_dateDecheance)))
    {
      m_dateDecheance = p_dateDecheance;
      ((ConditionsAttributionAbstraitPC)getPC()).setDateDecheanceConditionValiditeReliquat(p_dateDecheance);
    }
  }
  
  protected int rawGetMotifNonValidite()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getMotifNonValiditeConditionValiditeReliquat();
  }
  
  public int getMotifNonValidite()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getMotifNonValiditeConditionValiditeReliquat();
  }
  
  public void setMotifNonValidite(int p_motifNonValidite)
  {
    ((ConditionsAttributionAbstraitPC)getPC()).setMotifNonValiditeConditionValiditeReliquat(p_motifNonValidite);
  }
  
  protected int rawGetCauseExtinction()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getCauseExtinctionConditionValiditeReliquat();
  }
  
  public int getCauseExtinction()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getCauseExtinctionConditionValiditeReliquat();
  }
  
  public void setCauseExtinction(int p_causeExtinction)
  {
    ((ConditionsAttributionAbstraitPC)getPC()).setCauseExtinctionConditionValiditeReliquat(p_causeExtinction);
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    setEtat(0);
    setCodeMotifEchec(0);
    setDateDecheance(null);
    setMotifNonValidite(0);
    setCauseExtinction(0);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConditionValiditeReliquatGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */