package fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.spec.ConstitutionElementsAbstraitPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import java.math.BigDecimal;

public abstract class ConstitutionCoefficientSaisonnierGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionElementsAbstraitPC;
  private BigDecimal m_coefficientSaisonnierRetenu;
  private Quantite m_jourActiviteDouzeDerniersMois;
  
  public ConstitutionCoefficientSaisonnierGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConstitutionCoefficientSaisonnierGen() {}
  
  public DomPCSpec getPC()
  {
    return m_constitutionElementsAbstraitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionElementsAbstraitPC)
  {
    m_constitutionElementsAbstraitPC = p_constitutionElementsAbstraitPC;
  }
  
  protected BigDecimal rawGetCoefficientSaisonnierRetenu()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCoefficientSaisonnierRetenuConstitutionCoefficientSaissonier();
  }
  
  public BigDecimal getCoefficientSaisonnierRetenu()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCoefficientSaisonnierRetenuConstitutionCoefficientSaissonier();
  }
  
  public void setCoefficientSaisonnierRetenu(BigDecimal p_coefficientSaisonnierRetenu)
  {
    if ((m_coefficientSaisonnierRetenu == null) || (p_coefficientSaisonnierRetenu == null))
    {
      m_coefficientSaisonnierRetenu = p_coefficientSaisonnierRetenu;
      ((ConstitutionElementsAbstraitPC)getPC()).setCoefficientSaisonnierRetenuConstitutionCoefficientSaissonier(p_coefficientSaisonnierRetenu);
    }
    else if ((m_coefficientSaisonnierRetenu != null) && (p_coefficientSaisonnierRetenu != null) && (!p_coefficientSaisonnierRetenu.equals(m_coefficientSaisonnierRetenu)))
    {
      m_coefficientSaisonnierRetenu = p_coefficientSaisonnierRetenu;
      ((ConstitutionElementsAbstraitPC)getPC()).setCoefficientSaisonnierRetenuConstitutionCoefficientSaissonier(p_coefficientSaisonnierRetenu);
    }
  }
  
  protected Quantite rawGetJourActiviteDouzeDerniersMois()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getJourActiviteDouzeDerniersMoisConstitutionCoefficientSaissonier();
  }
  
  public Quantite getJourActiviteDouzeDerniersMois()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getJourActiviteDouzeDerniersMoisConstitutionCoefficientSaissonier();
  }
  
  public void setJourActiviteDouzeDerniersMois(Quantite p_jourActiviteDouzeDerniersMois)
  {
    if ((m_jourActiviteDouzeDerniersMois == null) || (p_jourActiviteDouzeDerniersMois == null))
    {
      m_jourActiviteDouzeDerniersMois = p_jourActiviteDouzeDerniersMois;
      ((ConstitutionElementsAbstraitPC)getPC()).setJourActiviteDouzeDerniersMoisConstitutionCoefficientSaissonier(p_jourActiviteDouzeDerniersMois);
    }
    else if ((m_jourActiviteDouzeDerniersMois != null) && (p_jourActiviteDouzeDerniersMois != null) && (!p_jourActiviteDouzeDerniersMois.equals(m_jourActiviteDouzeDerniersMois)))
    {
      m_jourActiviteDouzeDerniersMois = p_jourActiviteDouzeDerniersMois;
      ((ConstitutionElementsAbstraitPC)getPC()).setJourActiviteDouzeDerniersMoisConstitutionCoefficientSaissonier(p_jourActiviteDouzeDerniersMois);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    setCoefficientSaisonnierRetenu(null);
    setJourActiviteDouzeDerniersMois(null);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConstitutionCoefficientSaisonnierGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */