package fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionCoefficientTempsPartiel;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDateAttribution;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDelais;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDurees;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionElementsAbstrait;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionMontantsBruts;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionPointDepartIndemnisation;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionSjc;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionSjr;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.pc.ConstitutionElementsRevisionPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.services.ApplicativeRuntimeException;

public abstract class ConstitutionElementsRevisionGen
  extends ConstitutionElementsAbstrait
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionElementsRevisionPC;
  private transient ConstitutionSjr m_constitutionSjr = null;
  private transient ConstitutionDelais m_constitutionDelais = null;
  private transient ConstitutionDurees m_constitutionDurees = null;
  private transient ConstitutionSjc m_constitutionSjc = null;
  private transient ConstitutionDateAttribution m_constitutionDateAttribution = null;
  private transient ConstitutionMontantsBruts m_constitutionMontantsBruts = null;
  private transient ConstitutionPointDepartIndemnisation m_constitutionPointDepartIndemnisation = null;
  private transient ConstitutionCoefficientTempsPartiel m_constitutionCoefficientTempsPartiel = null;
  
  public ConstitutionElementsRevisionGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConstitutionElementsRevisionGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ConstitutionElementsRevisionPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_constitutionElementsRevisionPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionElementsRevisionPC)
  {
    m_constitutionElementsRevisionPC = p_constitutionElementsRevisionPC;
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    if (getConstitutionSjr() != null)
    {
      getConstitutionSjr().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionSjr = null;
    }
    if (getConstitutionDelais() != null)
    {
      getConstitutionDelais().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionDelais = null;
    }
    if (getConstitutionDurees() != null)
    {
      getConstitutionDurees().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionDurees = null;
    }
    if (getConstitutionSjc() != null)
    {
      getConstitutionSjc().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionSjc = null;
    }
    if (getConstitutionDateAttribution() != null)
    {
      getConstitutionDateAttribution().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionDateAttribution = null;
    }
    if (getConstitutionMontantsBruts() != null)
    {
      getConstitutionMontantsBruts().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionMontantsBruts = null;
    }
    if (getConstitutionPointDepartIndemnisation() != null)
    {
      getConstitutionPointDepartIndemnisation().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionPointDepartIndemnisation = null;
    }
    if (getConstitutionCoefficientTempsPartiel() != null)
    {
      getConstitutionCoefficientTempsPartiel().supprimerEnProfondeur(p_contexteSuppression);
      m_constitutionCoefficientTempsPartiel = null;
    }
  }
  
  public ConstitutionSjr getConstitutionSjr()
  {
    if ((((ConstitutionElementsRevisionPC)getPC()).isPresenceDonneesConstitutionSjr()) && (m_constitutionSjr == null)) {
      m_constitutionSjr = new ConstitutionSjr(getPC());
    }
    return m_constitutionSjr;
  }
  
  public ConstitutionSjr createConstitutionSjr()
  {
    ((ConstitutionElementsRevisionPC)getPC()).setPresenceDonneesConstitutionSjr(true);
    if (m_constitutionSjr == null) {
      m_constitutionSjr = new ConstitutionSjr(getPC());
    }
    try
    {
      m_constitutionSjr.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionSjr;
  }
  
  public void removeConstitutionSjr()
  {
    try
    {
      m_constitutionSjr.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsRevisionPC)getPC()).setPresenceDonneesConstitutionSjr(false);
  }
  
  public ConstitutionDelais getConstitutionDelais()
  {
    if ((((ConstitutionElementsRevisionPC)getPC()).isPresenceDonneesConstitutionDelais()) && (m_constitutionDelais == null)) {
      m_constitutionDelais = new ConstitutionDelais(getPC());
    }
    return m_constitutionDelais;
  }
  
  public ConstitutionDelais createConstitutionDelais()
  {
    ((ConstitutionElementsRevisionPC)getPC()).setPresenceDonneesConstitutionDelais(true);
    if (m_constitutionDelais == null) {
      m_constitutionDelais = new ConstitutionDelais(getPC());
    }
    try
    {
      m_constitutionDelais.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionDelais;
  }
  
  public void removeConstitutionDelais()
  {
    try
    {
      m_constitutionDelais.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsRevisionPC)getPC()).setPresenceDonneesConstitutionDelais(false);
  }
  
  public ConstitutionDurees getConstitutionDurees()
  {
    if ((((ConstitutionElementsRevisionPC)getPC()).isPresenceDonneesConstitutionDurees()) && (m_constitutionDurees == null)) {
      m_constitutionDurees = new ConstitutionDurees(getPC(), 0);
    }
    return m_constitutionDurees;
  }
  
  public ConstitutionDurees createConstitutionDurees()
  {
    ((ConstitutionElementsRevisionPC)getPC()).setPresenceDonneesConstitutionDurees(true);
    if (m_constitutionDurees == null) {
      m_constitutionDurees = new ConstitutionDurees(getPC(), 0);
    }
    try
    {
      m_constitutionDurees.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionDurees;
  }
  
  public void removeConstitutionDurees()
  {
    try
    {
      m_constitutionDurees.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsRevisionPC)getPC()).setPresenceDonneesConstitutionDurees(false);
  }
  
  public ConstitutionSjc getConstitutionSjc()
  {
    if ((((ConstitutionElementsRevisionPC)getPC()).isPresenceDonneesConstitutionSjc()) && (m_constitutionSjc == null)) {
      m_constitutionSjc = new ConstitutionSjc(getPC());
    }
    return m_constitutionSjc;
  }
  
  public ConstitutionSjc createConstitutionSjc()
  {
    ((ConstitutionElementsRevisionPC)getPC()).setPresenceDonneesConstitutionSjc(true);
    if (m_constitutionSjc == null) {
      m_constitutionSjc = new ConstitutionSjc(getPC());
    }
    try
    {
      m_constitutionSjc.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionSjc;
  }
  
  public void removeConstitutionSjc()
  {
    try
    {
      m_constitutionSjc.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsRevisionPC)getPC()).setPresenceDonneesConstitutionSjc(false);
  }
  
  public ConstitutionDateAttribution getConstitutionDateAttribution()
  {
    if ((((ConstitutionElementsRevisionPC)getPC()).isPresenceDonneesConstitutionDateAttribution()) && (m_constitutionDateAttribution == null)) {
      m_constitutionDateAttribution = new ConstitutionDateAttribution(getPC());
    }
    return m_constitutionDateAttribution;
  }
  
  public ConstitutionDateAttribution createConstitutionDateAttribution()
  {
    ((ConstitutionElementsRevisionPC)getPC()).setPresenceDonneesConstitutionDateAttribution(true);
    if (m_constitutionDateAttribution == null) {
      m_constitutionDateAttribution = new ConstitutionDateAttribution(getPC());
    }
    try
    {
      m_constitutionDateAttribution.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionDateAttribution;
  }
  
  public void removeConstitutionDateAttribution()
  {
    try
    {
      m_constitutionDateAttribution.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsRevisionPC)getPC()).setPresenceDonneesConstitutionDateAttribution(false);
  }
  
  public ConstitutionMontantsBruts getConstitutionMontantsBruts()
  {
    if ((((ConstitutionElementsRevisionPC)getPC()).isPresenceDonneesConstitutionMontantsBruts()) && (m_constitutionMontantsBruts == null)) {
      m_constitutionMontantsBruts = new ConstitutionMontantsBruts(getPC(), 1);
    }
    return m_constitutionMontantsBruts;
  }
  
  public ConstitutionMontantsBruts createConstitutionMontantsBruts()
  {
    ((ConstitutionElementsRevisionPC)getPC()).setPresenceDonneesConstitutionMontantsBruts(true);
    if (m_constitutionMontantsBruts == null) {
      m_constitutionMontantsBruts = new ConstitutionMontantsBruts(getPC(), 1);
    }
    try
    {
      m_constitutionMontantsBruts.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionMontantsBruts;
  }
  
  public void removeConstitutionMontantsBruts()
  {
    try
    {
      m_constitutionMontantsBruts.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsRevisionPC)getPC()).setPresenceDonneesConstitutionMontantsBruts(false);
  }
  
  public ConstitutionPointDepartIndemnisation getConstitutionPointDepartIndemnisation()
  {
    if ((((ConstitutionElementsRevisionPC)getPC()).isPresenceDonneesConstitutionPointDepartIndemnisation()) && (m_constitutionPointDepartIndemnisation == null)) {
      m_constitutionPointDepartIndemnisation = new ConstitutionPointDepartIndemnisation(getPC());
    }
    return m_constitutionPointDepartIndemnisation;
  }
  
  public ConstitutionPointDepartIndemnisation createConstitutionPointDepartIndemnisation()
  {
    ((ConstitutionElementsRevisionPC)getPC()).setPresenceDonneesConstitutionPointDepartIndemnisation(true);
    if (m_constitutionPointDepartIndemnisation == null) {
      m_constitutionPointDepartIndemnisation = new ConstitutionPointDepartIndemnisation(getPC());
    }
    try
    {
      m_constitutionPointDepartIndemnisation.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionPointDepartIndemnisation;
  }
  
  public void removeConstitutionPointDepartIndemnisation()
  {
    try
    {
      m_constitutionPointDepartIndemnisation.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsRevisionPC)getPC()).setPresenceDonneesConstitutionPointDepartIndemnisation(false);
  }
  
  public ConstitutionCoefficientTempsPartiel getConstitutionCoefficientTempsPartiel()
  {
    if ((((ConstitutionElementsRevisionPC)getPC()).isPresenceDonneesConstitutionCoefficientTempsPartiel()) && (m_constitutionCoefficientTempsPartiel == null)) {
      m_constitutionCoefficientTempsPartiel = new ConstitutionCoefficientTempsPartiel(getPC());
    }
    return m_constitutionCoefficientTempsPartiel;
  }
  
  public ConstitutionCoefficientTempsPartiel createConstitutionCoefficientTempsPartiel()
  {
    ((ConstitutionElementsRevisionPC)getPC()).setPresenceDonneesConstitutionCoefficientTempsPartiel(true);
    if (m_constitutionCoefficientTempsPartiel == null) {
      m_constitutionCoefficientTempsPartiel = new ConstitutionCoefficientTempsPartiel(getPC());
    }
    try
    {
      m_constitutionCoefficientTempsPartiel.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_constitutionCoefficientTempsPartiel;
  }
  
  public void removeConstitutionCoefficientTempsPartiel()
  {
    try
    {
      m_constitutionCoefficientTempsPartiel.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    ((ConstitutionElementsRevisionPC)getPC()).setPresenceDonneesConstitutionCoefficientTempsPartiel(false);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConstitutionElementsRevisionGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */