package fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.JustificationSjr;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Sjrip;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.spec.ConstitutionElementsAbstraitPC;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.services.ApplicativeRuntimeException;
import java.math.BigDecimal;

public abstract class ConstitutionSjrGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionElementsAbstraitPC;
  private Sjr m_sjrrp;
  private BigDecimal m_sommeMontantRevision;
  private transient Sjrip m_sjrip;
  private transient JustificationSjr m_justificationSjr;
  
  public ConstitutionSjrGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConstitutionSjrGen() {}
  
  public DomPCSpec getPC()
  {
    return m_constitutionElementsAbstraitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionElementsAbstraitPC)
  {
    m_constitutionElementsAbstraitPC = p_constitutionElementsAbstraitPC;
  }
  
  protected Sjr rawGetSjrrp()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getSjrrpConstitutionSjr();
  }
  
  public Sjr getSjrrp()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getSjrrpConstitutionSjr();
  }
  
  public void setSjrrp(Sjr p_sjrrp)
  {
    if ((m_sjrrp == null) || (p_sjrrp == null))
    {
      m_sjrrp = p_sjrrp;
      ((ConstitutionElementsAbstraitPC)getPC()).setSjrrpConstitutionSjr(p_sjrrp);
    }
    else if ((m_sjrrp != null) && (p_sjrrp != null) && (!p_sjrrp.equals(m_sjrrp)))
    {
      m_sjrrp = p_sjrrp;
      ((ConstitutionElementsAbstraitPC)getPC()).setSjrrpConstitutionSjr(p_sjrrp);
    }
  }
  
  protected int rawGetCodeEmploiA2b()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCodeEmploiA2b();
  }
  
  public int getCodeEmploiA2b()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getCodeEmploiA2b();
  }
  
  public void setCodeEmploiA2b(int p_codeEmploiA2b)
  {
    ((ConstitutionElementsAbstraitPC)getPC()).setCodeEmploiA2b(p_codeEmploiA2b);
  }
  
  protected BigDecimal rawGetSommeMontantRevision()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getSommeMontantRevisionConstitutionSjr();
  }
  
  public BigDecimal getSommeMontantRevision()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getSommeMontantRevisionConstitutionSjr();
  }
  
  public void setSommeMontantRevision(BigDecimal p_sommeMontantRevision)
  {
    if ((m_sommeMontantRevision == null) || (p_sommeMontantRevision == null))
    {
      m_sommeMontantRevision = p_sommeMontantRevision;
      ((ConstitutionElementsAbstraitPC)getPC()).setSommeMontantRevisionConstitutionSjr(p_sommeMontantRevision);
    }
    else if ((m_sommeMontantRevision != null) && (p_sommeMontantRevision != null) && (!p_sommeMontantRevision.equals(m_sommeMontantRevision)))
    {
      m_sommeMontantRevision = p_sommeMontantRevision;
      ((ConstitutionElementsAbstraitPC)getPC()).setSommeMontantRevisionConstitutionSjr(p_sommeMontantRevision);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    if (getSjrip() != null)
    {
      getSjrip().supprimerEnProfondeur(p_contexteSuppression);
      m_sjrip = null;
    }
    if (getJustificationSjr() != null)
    {
      getJustificationSjr().supprimerEnProfondeur(p_contexteSuppression);
      m_justificationSjr = null;
    }
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    if (getSjrip() != null)
    {
      getSjrip().initEnProfondeur();
      m_sjrip = null;
    }
    if (getJustificationSjr() != null)
    {
      getJustificationSjr().initEnProfondeur();
      m_justificationSjr = null;
    }
    setSjrrp(null);
    setCodeEmploiA2b(0);
    setSommeMontantRevision(null);
  }
  
  public Sjrip getSjrip()
  {
    if (m_sjrip == null) {
      m_sjrip = new Sjrip(getPC());
    }
    return m_sjrip;
  }
  
  public Sjrip createSjrip()
  {
    if (m_sjrip == null) {
      m_sjrip = new Sjrip(getPC());
    }
    try
    {
      m_sjrip.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_sjrip;
  }
  
  public void removeSjrip()
  {
    try
    {
      m_sjrip.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
  }
  
  public JustificationSjr getJustificationSjr()
  {
    if (m_justificationSjr == null) {
      m_justificationSjr = new JustificationSjr(getPC());
    }
    return m_justificationSjr;
  }
  
  public JustificationSjr createJustificationSjr()
  {
    if (m_justificationSjr == null) {
      m_justificationSjr = new JustificationSjr(getPC());
    }
    try
    {
      m_justificationSjr.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_justificationSjr;
  }
  
  public void removeJustificationSjr()
  {
    try
    {
      m_justificationSjr.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConstitutionSjrGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */