package fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.CarenceIccp;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.CarenceIslr;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.PreavisMesureConservatoireIndemnisable;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.PreavisMesureConservatoireNonIndemnisable;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.pc.EnsembleCarencesPC;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public abstract class EnsembleCarencesGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_ensembleCarencesPC;
  private PreavisMesureConservatoireNonIndemnisable m_carencePmc;
  private CarenceIccp m_carenceIccp;
  private CarenceIslr m_carenceIslr;
  private PreavisMesureConservatoireIndemnisable m_pmcIndemnisable;
  
  public EnsembleCarencesGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public EnsembleCarencesGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new EnsembleCarencesPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_ensembleCarencesPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_ensembleCarencesPC)
  {
    m_ensembleCarencesPC = p_ensembleCarencesPC;
  }
  
  public PreavisMesureConservatoireNonIndemnisable getCarencePmc()
  {
    if (m_carencePmc == null)
    {
      DomPCSpec carencePmcPC = ((EnsembleCarencesPC)getPC()).getCarencePmc();
      if (carencePmcPC != null) {
        m_carencePmc = ((PreavisMesureConservatoireNonIndemnisable)carencePmcPC.createOM());
      }
    }
    return m_carencePmc;
  }
  
  public void setCarencePmc(PreavisMesureConservatoireNonIndemnisable p_carencePmc)
  {
    if (p_carencePmc == null)
    {
      ((EnsembleCarencesPC)getPC()).setCarencePmc(null);
      m_carencePmc = p_carencePmc;
    }
    else if (!p_carencePmc.equals(m_carencePmc))
    {
      ((EnsembleCarencesPC)getPC()).setCarencePmc(p_carencePmc.getPC());
      m_carencePmc = p_carencePmc;
    }
  }
  
  public CarenceIccp getCarenceIccp()
  {
    if (m_carenceIccp == null)
    {
      DomPCSpec carenceIccpPC = ((EnsembleCarencesPC)getPC()).getCarenceIccp();
      if (carenceIccpPC != null) {
        m_carenceIccp = ((CarenceIccp)carenceIccpPC.createOM());
      }
    }
    return m_carenceIccp;
  }
  
  public void setCarenceIccp(CarenceIccp p_carenceIccp)
  {
    if (p_carenceIccp == null)
    {
      ((EnsembleCarencesPC)getPC()).setCarenceIccp(null);
      m_carenceIccp = p_carenceIccp;
    }
    else if (!p_carenceIccp.equals(m_carenceIccp))
    {
      ((EnsembleCarencesPC)getPC()).setCarenceIccp(p_carenceIccp.getPC());
      m_carenceIccp = p_carenceIccp;
    }
  }
  
  public CarenceIslr getCarenceIslr()
  {
    if (m_carenceIslr == null)
    {
      DomPCSpec carenceIslrPC = ((EnsembleCarencesPC)getPC()).getCarenceIslr();
      if (carenceIslrPC != null) {
        m_carenceIslr = ((CarenceIslr)carenceIslrPC.createOM());
      }
    }
    return m_carenceIslr;
  }
  
  public void setCarenceIslr(CarenceIslr p_carenceIslr)
  {
    if (p_carenceIslr == null)
    {
      ((EnsembleCarencesPC)getPC()).setCarenceIslr(null);
      m_carenceIslr = p_carenceIslr;
    }
    else if (!p_carenceIslr.equals(m_carenceIslr))
    {
      ((EnsembleCarencesPC)getPC()).setCarenceIslr(p_carenceIslr.getPC());
      m_carenceIslr = p_carenceIslr;
    }
  }
  
  public PreavisMesureConservatoireIndemnisable getPmcIndemnisable()
  {
    if (m_pmcIndemnisable == null)
    {
      DomPCSpec pmcIndemnisablePC = ((EnsembleCarencesPC)getPC()).getPmcIndemnisable();
      if (pmcIndemnisablePC != null) {
        m_pmcIndemnisable = ((PreavisMesureConservatoireIndemnisable)pmcIndemnisablePC.createOM());
      }
    }
    return m_pmcIndemnisable;
  }
  
  public void setPmcIndemnisable(PreavisMesureConservatoireIndemnisable p_pmcIndemnisable)
  {
    if (p_pmcIndemnisable == null)
    {
      ((EnsembleCarencesPC)getPC()).setPmcIndemnisable(null);
      m_pmcIndemnisable = p_pmcIndemnisable;
    }
    else if (!p_pmcIndemnisable.equals(m_pmcIndemnisable))
    {
      ((EnsembleCarencesPC)getPC()).setPmcIndemnisable(p_pmcIndemnisable.getPC());
      m_pmcIndemnisable = p_pmcIndemnisable;
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    Object carencePmc = getCarencePmc();
    if ((carencePmc != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(carencePmc))) {
      DomManager.supprimer(getCarencePmc(), p_contexteSuppression);
    }
    Object carenceIccp = getCarenceIccp();
    if ((carenceIccp != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(carenceIccp))) {
      DomManager.supprimer(getCarenceIccp(), p_contexteSuppression);
    }
    Object carenceIslr = getCarenceIslr();
    if ((carenceIslr != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(carenceIslr))) {
      DomManager.supprimer(getCarenceIslr(), p_contexteSuppression);
    }
    Object pmcIndemnisable = getPmcIndemnisable();
    if ((pmcIndemnisable != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(pmcIndemnisable))) {
      DomManager.supprimer(getPmcIndemnisable(), p_contexteSuppression);
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     EnsembleCarencesGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */