package fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.ConstructionPra;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Revision;
import fr.unedic.cali.asu.cge01.p03.liquidation.fabriques.FabriqueStrategieSjrJoursDeductibles;
import fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.strategies.StrategieSjrJoursDeductiblesSpec;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.FaitGenerateurSpec;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.asu.outilsfonctionnels.ConstructionChronologieCarences;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsActiviteConserve;
import fr.unedic.cali.asu.produits.liquidation.dom.Pra;
import fr.unedic.cali.autresdoms.cohab.dom.ObjetChronoPeriodePriseEnChargeSansFiltre;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.PeriodeChomageAtteste;
import fr.unedic.cali.dom.affectation.DecorReglementaire;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P03;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.dom.conteneurs.DonneesEntreeConstructionChronologie;
import fr.unedic.cali.outilsfonctionnels.ComparateurTemporelSurDateFinDecroissante;
import fr.unedic.cali.outilsfonctionnels.OutillagePEC;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreActiviteContenuDansPra;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreActiviteSalarie;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreActiviteSalarieAutreQueFormationCifCdd;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreActiviteSalarieeMotifDvNonLegitime;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreBulletinSalaire;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreFinActivite;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreMemeRegime;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeDsmTravail;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeFormationAssimilable;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeFormationImputableSurDuree;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeIndemnisationIjss;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeServiceNational;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesAttestees;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesLiquidables;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesQualifiables;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesSansConflit;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesSurFiltresExclusifs;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreRegimeDifferent;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.util.OutillageChronologiePeriodes;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.ComparateurTemporelsSurDateFin;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.FiltreChevauchePeriode;
import fr.unedic.util.temps.FiltreFinAvantOuCoincideAvecDate;
import fr.unedic.util.temps.FiltreFinDansBornes;
import fr.unedic.util.temps.FiltresTemporel;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.util.Comparator;

public class ConstructionChronologie
{
  private static Chronologie determinerChronoActiviteSalarieSpecDansPeriode(Periode p_periodeRecherche, Chronologie p_chronoActivitesDom)
  {
    FiltresTemporel filtres = new FiltresTemporel();
    filtres.ajouterFiltre(new FiltreActiviteSalarie());
    filtres.ajouterFiltre(new FiltrePeriodesLiquidables());
    filtres.ajouterFiltre(new FiltreFinDansBornes(p_periodeRecherche));
    
    Chronologie chronologieActivitesParticipantes = p_chronoActivitesDom.copier(filtres);
    
    chronologieActivitesParticipantes.setComparateur(new ComparateurTemporelsSurDateFin());
    
    return chronologieActivitesParticipantes;
  }
  
  public static Chronologie determinerChronoActivitesSalarieesConservees(Demande p_demande)
    throws CoucheLogiqueException
  {
    Chronologie chronoActivitesSalarieesRetenues = null;
    
    DonneesEntreeConstructionChronologie donneesEntree = fr.unedic.cali.asu.outilsfonctionnels.ConstructionChronologie.mapperDemandeDonneesEntreeConstructionChronologie(p_demande);
    Chronologie chronoActivitesConservees = fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.ConstructionChronologie.determinerChronoActivitesConservees(donneesEntree);
    
    chronoActivitesSalarieesRetenues = chronoActivitesConservees.copier(new FiltreActiviteSalarie());
    
    return chronoActivitesSalarieesRetenues;
  }
  
  public static Chronologie determinerChronoActivitesParticipantCarences(Periode p_periodeReference, Demande p_demande)
  {
    return ConstructionChronologieCarences.determinerChronoActivitesParticipantCarences(p_periodeReference, p_demande);
  }
  
  public static Chronologie determinerChronoActivitesParticipantPMC(Periode p_periodeReference, Demande p_demande, Chronologie p_chronoCarences)
  {
    Chronologie chronoActivitesRetenuesPMC = determinerChronoActivitesParticipantCarences(p_periodeReference, p_demande);
    
    p_chronoCarences.iterer();
    while (p_chronoCarences.encoreSuivant())
    {
      ActiviteSalarie periodeTraitee = (ActiviteSalarie)p_chronoCarences.elementSuivant();
      if (chronoActivitesRetenuesPMC.contientElement(periodeTraitee)) {
        chronoActivitesRetenuesPMC.supprimer(periodeTraitee);
      }
    }
    return chronoActivitesRetenuesPMC;
  }
  
  public static Chronologie determinerChronoActivitesPrtp(Demande p_demande, Periode p_prtp)
  {
    return determinerChronoActivitesPrc(p_demande, p_prtp);
  }
  
  public static Chronologie determinerChronoActivitesPrs(Demande p_demande, Periode p_prs)
  {
    Chronologie chronoActivitesRetenuesPrs = null;
    
    FiltresTemporel filtres = new FiltresTemporel();
    filtres.ajouterFiltre(new FiltreActiviteSalarie());
    filtres.ajouterFiltre(new FiltreChevauchePeriode(p_prs));
    
    filtres.ajouterFiltre(new FiltrePeriodesLiquidables());
    filtres.ajouterFiltre(new FiltrePeriodesQualifiables());
    filtres.ajouterFiltre(new FiltrePeriodesSansConflit());
    
    chronoActivitesRetenuesPrs = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(filtres);
    
    return chronoActivitesRetenuesPrs;
  }
  
  public static Chronologie determinerChronoActivitesPrc(Demande p_demande, Periode p_prc)
  {
    Chronologie chronoActivitesRetenuesPourPrc = null;
    DecorReglementaire decor = ((DossierAffectation)p_demande.getDossierAffectation()).getDecorReglementaire();
    
    FiltresTemporel filtres = new FiltresTemporel();
    filtres.ajouterFiltre(new FiltreActiviteSalarie());
    filtres.ajouterFiltre(new FiltreChevauchePeriode(p_prc));
    
    Damj dateReferenceExamen = p_demande.getDateExamen().veille();
    Damj dateFgOdPrecedente = p_demande.getDateFaitGenerateurOdPrecedente();
    if (dateFgOdPrecedente != null) {
      filtres.ajouterFiltre(new FiltreFinDansBornes(dateFgOdPrecedente.lendemain(), dateReferenceExamen));
    } else {
      filtres.ajouterFiltre(new FiltreFinAvantOuCoincideAvecDate(dateReferenceExamen));
    }
    filtres.ajouterFiltre(new FiltrePeriodesAttestees());
    filtres.ajouterFiltre(new FiltrePeriodesSansConflit());
    filtres.ajouterFiltre(new FiltrePeriodesLiquidables());
    
    chronoActivitesRetenuesPourPrc = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(filtres);
    
    FiltresTemporel filtresRegimeDifferentA2bEtA7 = new FiltresTemporel();
    filtresRegimeDifferentA2bEtA7.ajouterFiltre(new FiltreRegimeDifferent("A2b", decor));
    filtresRegimeDifferentA2bEtA7.ajouterFiltre(new FiltreRegimeDifferent("A7", decor));
    chronoActivitesRetenuesPourPrc = chronoActivitesRetenuesPourPrc.copier(filtresRegimeDifferentA2bEtA7);
    
    return chronoActivitesRetenuesPourPrc;
  }
  
  public static Chronologie determinerChronoActivitesPrcPourRevision(Demande p_demande, Periode p_prc)
  {
    Chronologie chronoActivitesRetenuesPourPrc = null;
    DecorReglementaire decor = ((DossierAffectation)p_demande.getDossierAffectation()).getDecorReglementaire();
    
    FiltresTemporel filtres = new FiltresTemporel();
    filtres.ajouterFiltre(new FiltreActiviteSalarie());
    filtres.ajouterFiltre(new FiltreChevauchePeriode(p_prc));
    
    Damj dateReferenceExamen = p_demande.getDateExamen().veille();
    filtres.ajouterFiltre(new FiltreFinDansBornes(p_prc.getDebut(), dateReferenceExamen));
    
    filtres.ajouterFiltre(new FiltrePeriodesAttestees());
    filtres.ajouterFiltre(new FiltrePeriodesSansConflit());
    filtres.ajouterFiltre(new FiltrePeriodesLiquidables());
    
    chronoActivitesRetenuesPourPrc = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(filtres);
    
    FiltresTemporel filtresRegimeDifferentA2bEtA7 = new FiltresTemporel();
    filtresRegimeDifferentA2bEtA7.ajouterFiltre(new FiltreRegimeDifferent("A2b", decor));
    filtresRegimeDifferentA2bEtA7.ajouterFiltre(new FiltreRegimeDifferent("A7", decor));
    chronoActivitesRetenuesPourPrc = chronoActivitesRetenuesPourPrc.copier(filtresRegimeDifferentA2bEtA7);
    
    return chronoActivitesRetenuesPourPrc;
  }
  
  public static Chronologie determinerChronoActivitesPrcPourInappartenance(Demande p_demande, Periode p_prc)
  {
    Chronologie chronoActivitesRetenuesPrcPourInappartenance = null;
    DecorReglementaire decor = ((DossierAffectation)p_demande.getDossierAffectation()).getDecorReglementaire();
    
    FiltresTemporel filtres = new FiltresTemporel();
    filtres.ajouterFiltre(new FiltreActiviteSalarie());
    filtres.ajouterFiltre(new FiltrePeriodesLiquidables());
    filtres.ajouterFiltre(new FiltreChevauchePeriode(p_prc));
    Damj dateFgOdCourante = null;
    Damj dateFgOdPrecedente = null;
    if (OutilsActiviteConserve.estUneDemandeDeRevision(p_demande))
    {
      AttributionAssuranceSpec dossierExamen = (AttributionAssuranceSpec)((Revision)p_demande.getDossierExamen()).getOuvertureDroit();
      Demande demandeOrigine = (Demande)dossierExamen.getDemande();
      dateFgOdCourante = p_demande.getDateDeclenchementExamen();
      dateFgOdPrecedente = demandeOrigine.getDateFaitGenerateurOdPrecedente();
    }
    else
    {
      dateFgOdCourante = p_demande.getFaitGenerateur().getDateFaitGenerateur();
      dateFgOdPrecedente = p_demande.getDateFaitGenerateurOdPrecedente();
    }
    if (dateFgOdPrecedente != null) {
      filtres.ajouterFiltre(new FiltreFinDansBornes(dateFgOdPrecedente.lendemain(), dateFgOdCourante));
    } else {
      filtres.ajouterFiltre(new FiltreFinAvantOuCoincideAvecDate(dateFgOdCourante));
    }
    chronoActivitesRetenuesPrcPourInappartenance = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(filtres);
    
    FiltresTemporel filtresRegimeDifferentA2bEtA7 = new FiltresTemporel();
    filtresRegimeDifferentA2bEtA7.ajouterFiltre(new FiltreRegimeDifferent("A2b", decor));
    filtresRegimeDifferentA2bEtA7.ajouterFiltre(new FiltreRegimeDifferent("A7", decor));
    chronoActivitesRetenuesPrcPourInappartenance = chronoActivitesRetenuesPrcPourInappartenance.copier(filtresRegimeDifferentA2bEtA7);
    
    FiltresTemporel filtresPeriodesDnj = new FiltresTemporel();
    filtresPeriodesDnj.ajouterFiltre(new FiltrePeriodeDsmTravail());
    filtresPeriodesDnj.ajouterFiltre(new FiltreChevauchePeriode(p_prc));
    if (dateFgOdPrecedente != null) {
      filtresPeriodesDnj.ajouterFiltre(new FiltreFinDansBornes(dateFgOdPrecedente.lendemain(), dateFgOdCourante));
    } else {
      filtresPeriodesDnj.ajouterFiltre(new FiltreFinAvantOuCoincideAvecDate(dateFgOdCourante));
    }
    Chronologie chronoPeriodesDnjRetenuesPrcPourInappartenance = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(filtresPeriodesDnj);
    
    chronoActivitesRetenuesPrcPourInappartenance.ajouter(chronoPeriodesDnjRetenuesPrcPourInappartenance);
    
    FiltresTemporel filtresPeriodesBs = new FiltresTemporel();
    filtresPeriodesBs.ajouterFiltre(new FiltreBulletinSalaire());
    filtresPeriodesBs.ajouterFiltre(new FiltreChevauchePeriode(p_prc));
    if (dateFgOdPrecedente != null) {
      filtresPeriodesBs.ajouterFiltre(new FiltreFinDansBornes(dateFgOdPrecedente.lendemain(), dateFgOdCourante));
    } else {
      filtresPeriodesBs.ajouterFiltre(new FiltreFinAvantOuCoincideAvecDate(dateFgOdCourante));
    }
    Chronologie chronoPeriodesBsRetenuesPrcPourInappartenance = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(filtresPeriodesBs);
    
    chronoActivitesRetenuesPrcPourInappartenance.ajouter(chronoPeriodesBsRetenuesPrcPourInappartenance);
    
    return chronoActivitesRetenuesPrcPourInappartenance;
  }
  
  public static Chronologie determinerChronoActivitesReglementApplicable(Periode p_periodeRechercheReglement, Chronologie p_chronoActivitesDom)
  {
    return determinerChronoActiviteSalarieSpecDansPeriode(p_periodeRechercheReglement, p_chronoActivitesDom);
  }
  
  public static Chronologie determinerChronoAssimilablePra(Periode p_pra, Chronologie p_chronoActivitesDom)
  {
    FiltresTemporel filtres = new FiltresTemporel();
    
    FiltreActiviteContenuDansPra filtreActiviteContenuDansPra = new FiltreActiviteContenuDansPra(p_pra);
    filtres.ajouterFiltre(filtreActiviteContenuDansPra);
    
    FiltreFinActivite filterFinActivite = new FiltreFinActivite();
    filtres.ajouterFiltre(filterFinActivite);
    
    FiltrePeriodeFormationAssimilable filtrePeriodeFormationAssimilable = new FiltrePeriodeFormationAssimilable();
    filtres.ajouterFiltre(filtrePeriodeFormationAssimilable);
    
    Chronologie chronologieActivitesAssimilableParticipanteCumul = p_chronoActivitesDom.copier(filtres);
    
    return chronologieActivitesAssimilableParticipanteCumul;
  }
  
  public static Chronologie determinerChronoFormationAImputer(Periode p_periodeRecherche, Chronologie p_chronoActivitesDom)
  {
    FiltresTemporel filtres = new FiltresTemporel();
    
    FiltreFinDansBornes filtreFinDansPeriode = new FiltreFinDansBornes(p_periodeRecherche);
    filtres.ajouterFiltre(filtreFinDansPeriode);
    
    FiltrePeriodeFormationImputableSurDuree filtrePeriodeFormationImputableSurDuree = new FiltrePeriodeFormationImputableSurDuree();
    filtres.ajouterFiltre(filtrePeriodeFormationImputableSurDuree);
    
    Chronologie chronologieActivitesParticipantes = p_chronoActivitesDom.copier(filtres);
    
    Comparator comparateursurDateFin = new ComparateurTemporelsSurDateFin();
    chronologieActivitesParticipantes.setComparateur(comparateursurDateFin);
    
    return chronologieActivitesParticipantes;
  }
  
  private static Chronologie determinerChronoActiviteSalarieMemeReglement(Chronologie p_chronoActivitesDom, String p_reglementPropose, Periode p_pra, Demande p_demande)
  {
    FiltresTemporel filtres = new FiltresTemporel();
    
    FiltreActiviteContenuDansPra filtreActiviteContenuDansPra = new FiltreActiviteContenuDansPra(p_pra);
    filtres.ajouterFiltre(filtreActiviteContenuDansPra);
    
    FiltreFinActivite filterFinActivite = new FiltreFinActivite();
    filtres.ajouterFiltre(filterFinActivite);
    
    FiltreActiviteSalarie filtreActiviteSalarie = new FiltreActiviteSalarie();
    filtres.ajouterFiltre(filtreActiviteSalarie);
    filtres.ajouterFiltre(new FiltrePeriodesLiquidables());
    
    DecorReglementaire decor = ((DossierAffectation)p_demande.getDossierAffectation()).getDecorReglementaire();
    FiltreMemeRegime filtreMemeRegime = new FiltreMemeRegime(p_reglementPropose, decor);
    filtres.ajouterFiltre(filtreMemeRegime);
    
    return p_chronoActivitesDom.copier(filtres);
  }
  
  private static Chronologie determinerChronoActiviteSalarieTousReglements(Chronologie p_chronoActivitesDom, Periode p_pra)
  {
    FiltresTemporel filtres = new FiltresTemporel();
    
    FiltreActiviteContenuDansPra filtreActiviteContenuDansPra = new FiltreActiviteContenuDansPra(p_pra);
    filtres.ajouterFiltre(filtreActiviteContenuDansPra);
    
    FiltreFinActivite filterFinActivite = new FiltreFinActivite();
    filtres.ajouterFiltre(filterFinActivite);
    
    FiltreActiviteSalarie filtreActiviteSalarie = new FiltreActiviteSalarie();
    filtres.ajouterFiltre(filtreActiviteSalarie);
    filtres.ajouterFiltre(new FiltrePeriodesLiquidables());
    
    Chronologie chronologieActivitesParticipanteCumul = p_chronoActivitesDom.copier(filtres);
    
    return chronologieActivitesParticipanteCumul;
  }
  
  public static Chronologie determinerChronoPeriodesDeductiblesPrc(Demande p_demande, Periode p_prc)
    throws CoucheLogiqueException
  {
    Chronologie chronoPeriodesDeductibles = new ChronologiePeriodes();
    Chronologie chronoPeriodesDeductiblesSansConflit = new ChronologiePeriodes();
    
    Reglement reglementApplicableCourant = ((DossierExamen)p_demande.getDossierExamen()).getReglementApplicable().getReglement();
    if ((reglementApplicableCourant.equals(ProduitAsuCge01P03.getInstance().getReglement("A3"))) || (reglementApplicableCourant.equals(ProduitAsuCge01P03.getInstance().getReglement("A4"))) || (reglementApplicableCourant.equals(ProduitAsuCge01P03.getInstance().getReglement("A5"))))
    {
      chronoPeriodesDeductibles.ajouter(determinerChronoPeriodesDeductiblesCommunes(p_demande, p_prc));
      
      chronoPeriodesDeductiblesSansConflit = chronoPeriodesDeductibles.copier(new FiltrePeriodesSansConflit());
    }
    return chronoPeriodesDeductiblesSansConflit;
  }
  
  public static Chronologie determinerChronoPeriodesDeductiblesCommunes(Demande p_demande, Periode p_prc)
    throws CoucheLogiqueException
  {
    Chronologie chronoPeriodesDeductibles = new ChronologiePeriodes();
    Chronologie chronoPeriodesFiltrees = null;
    FiltresTemporel filtres = null;
    DecorReglementaire decor = ((DossierAffectation)p_demande.getDossierAffectation()).getDecorReglementaire();
    
    filtres = new FiltresTemporel();
    filtres.ajouterFiltre(new FiltrePeriodeFormationAssimilable());
    filtres.ajouterFiltre(new FiltreChevauchePeriode(p_prc));
    chronoPeriodesFiltrees = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(filtres);
    if (!chronoPeriodesFiltrees.estVide()) {
      chronoPeriodesDeductibles.ajouter(chronoPeriodesFiltrees);
    }
    filtres = new FiltresTemporel();
    filtres.ajouterFiltre(new FiltrePeriodeServiceNational());
    filtres.ajouterFiltre(new FiltreChevauchePeriode(p_prc));
    chronoPeriodesFiltrees = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(filtres);
    if (!chronoPeriodesFiltrees.estVide()) {
      chronoPeriodesDeductibles.ajouter(chronoPeriodesFiltrees);
    }
    filtres = new FiltresTemporel();
    filtres.ajouterFiltre(new FiltrePeriodeIndemnisationIjss());
    filtres.ajouterFiltre(new FiltreChevauchePeriode(p_prc));
    chronoPeriodesFiltrees = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(filtres);
    if (!chronoPeriodesFiltrees.estVide()) {
      chronoPeriodesDeductibles.ajouter(chronoPeriodesFiltrees);
    }
    Chronologie chronoPeriodeChomageAtteste = determinerChronoPeriodeChomageAtteste(p_demande, p_prc);
    if (!chronoPeriodeChomageAtteste.estVide()) {
      chronoPeriodesDeductibles.ajouter(chronoPeriodeChomageAtteste);
    }
    FiltrePeriodesSurFiltresExclusifs listeFiltresExclusifs = new FiltrePeriodesSurFiltresExclusifs();
    listeFiltresExclusifs.ajouterFiltre(new FiltreMemeRegime("A2b", decor));
    listeFiltresExclusifs.ajouterFiltre(new FiltreMemeRegime("A7", decor));
    
    filtres = new FiltresTemporel();
    filtres.ajouterFiltre(new FiltreActiviteSalarie());
    filtres.ajouterFiltre(new FiltreChevauchePeriode(p_prc));
    filtres.ajouterFiltre(listeFiltresExclusifs);
    chronoPeriodesFiltrees = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(filtres);
    if (!chronoPeriodesFiltrees.estVide()) {
      chronoPeriodesDeductibles.ajouter(chronoPeriodesFiltrees);
    }
    return chronoPeriodesDeductibles;
  }
  
  public static Chronologie determinerChronoPeriodesDeductiblesSpecifiques(Demande p_demande, Periode p_prc)
  {
    Chronologie chronoPeriodesDeductibles = new ChronologiePeriodes();
    Chronologie chronoPeriodesConcerneesFiltreSpecifique = null;
    Chronologie chronoPeriodesFiltrees = null;
    FiltresTemporel filtres = null;
    DecorReglementaire decor = ((DossierAffectation)p_demande.getDossierAffectation()).getDecorReglementaire();
    
    Reglement reglementApplicableCourant = ((DossierExamen)p_demande.getDossierExamen()).getReglementApplicable().getReglement();
    if (reglementApplicableCourant.equals(ProduitAsuCge01P03.getInstance().getReglement("A3")))
    {
      chronoPeriodesConcerneesFiltreSpecifique = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation();
    }
    else
    {
      filtres = new FiltresTemporel();
      filtres.ajouterFiltre(new FiltreActiviteSalarie());
      filtres.ajouterFiltre(new FiltreChevauchePeriode(p_prc));
      filtres.ajouterFiltre(new FiltreMemeRegime("A3", decor));
      chronoPeriodesConcerneesFiltreSpecifique = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(filtres);
    }
    FiltrePeriodesSurFiltresExclusifs listeFiltresExclusifs = new FiltrePeriodesSurFiltresExclusifs();
    
    filtres = new FiltresTemporel();
    filtres.ajouterFiltre(listeFiltresExclusifs);
    filtres.ajouterFiltre(new FiltreChevauchePeriode(p_prc));
    chronoPeriodesFiltrees = chronoPeriodesConcerneesFiltreSpecifique.copier(filtres);
    if (!chronoPeriodesFiltrees.estVide()) {
      chronoPeriodesDeductibles.ajouter(chronoPeriodesFiltrees);
    }
    if (reglementApplicableCourant.equals(ProduitAsuCge01P03.getInstance().getReglement("A4")))
    {
      chronoPeriodesConcerneesFiltreSpecifique = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation();
    }
    else
    {
      filtres = new FiltresTemporel();
      filtres.ajouterFiltre(new FiltreActiviteSalarie());
      filtres.ajouterFiltre(new FiltreChevauchePeriode(p_prc));
      filtres.ajouterFiltre(new FiltreMemeRegime("A4", decor));
      chronoPeriodesConcerneesFiltreSpecifique = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(filtres);
    }
    filtres = new FiltresTemporel();
    
    filtres.ajouterFiltre(new FiltreChevauchePeriode(p_prc));
    chronoPeriodesFiltrees = chronoPeriodesConcerneesFiltreSpecifique.copier(filtres);
    if (!chronoPeriodesFiltrees.estVide()) {
      chronoPeriodesDeductibles.ajouter(chronoPeriodesFiltrees);
    }
    return chronoPeriodesDeductibles;
  }
  
  private static Chronologie determinerChronoPeriodeChomageAtteste(Demande p_demande, Periode p_prc)
    throws CoucheLogiqueException
  {
    Chronologie chronoPeriodeCaRetournee = new ChronologiePeriodes();
    ChronologiePeriodes chronoPeriodesNonDeductibles = new ChronologiePeriodes();
    
    CritereStrategie critereStrategie = new CritereStrategie();
    critereStrategie.setDatePivot(p_demande.getFaitGenerateur().getDateFaitGenerateur());
    StrategieSjrJoursDeductiblesSpec strategieSjrJoursDeductiblesCourante = (StrategieSjrJoursDeductiblesSpec)FabriqueStrategieSjrJoursDeductibles.getInstance().getStrategie(critereStrategie);
    
    ChronologiePeriodes chronoPeriodesTravailRetenues = strategieSjrJoursDeductiblesCourante.determinerChronoActivitesPourChomageAtteste(p_demande, p_prc);
    
    ChronologiePeriodes chronoPeriodesAbsencePointage = p_demande.getDemandeur().getChronoPeriodeEvtActualisation();
    
    chronoPeriodesNonDeductibles.ajouter(chronoPeriodesTravailRetenues);
    chronoPeriodesNonDeductibles.ajouter(chronoPeriodesAbsencePointage);
    
    Chronologie chronoPeriodesPecRetenues = OutillagePEC.getPeriodesPecDebutAvantDate(p_demande.getDemandeur(), p_demande.getDateExamen());
    chronoPeriodesPecRetenues = OutillagePEC.getPeriodesPecChevauchePeriode(chronoPeriodesPecRetenues, p_prc);
    if (!chronoPeriodesPecRetenues.estVide())
    {
      ChronologiePeriodes chronoPeriodeChomageAtteste = null;
      ObjetChronoPeriodePriseEnChargeSansFiltre objetChronoPecCourante = null;
      Periode periodeReference = null;
      
      chronoPeriodesPecRetenues.iterer();
      while (chronoPeriodesPecRetenues.encoreSuivant())
      {
        objetChronoPecCourante = (ObjetChronoPeriodePriseEnChargeSansFiltre)chronoPeriodesPecRetenues.elementSuivant();
        
        periodeReference = objetChronoPecCourante.periodeIntersection(p_prc);
        chronoPeriodeChomageAtteste = OutillageChronologiePeriodes.donnerPeriodesComplementaires(chronoPeriodesNonDeductibles, periodeReference);
        if (chronoPeriodeChomageAtteste != null)
        {
          chronoPeriodeChomageAtteste.iterer();
          ObjetChronoPeriode objetChronoPeriodeChomageAttesteCourant = null;
          while (chronoPeriodeChomageAtteste.encoreSuivant())
          {
            objetChronoPeriodeChomageAttesteCourant = (ObjetChronoPeriode)chronoPeriodeChomageAtteste.elementSuivant();
            
            chronoPeriodeCaRetournee.ajouter(new PeriodeChomageAtteste(objetChronoPeriodeChomageAttesteCourant.getDateDebut(), objetChronoPeriodeChomageAttesteCourant.getDateFin()));
          }
        }
      }
    }
    return chronoPeriodeCaRetournee;
  }
  
  public static Chronologie determinerChronoPraReglementPropose(Periode p_pra, String p_reglementPropose, Chronologie p_chronoActivitesDom, Demande p_demande)
  {
    return determinerChronoActiviteSalarieMemeReglement(p_chronoActivitesDom, p_reglementPropose, p_pra, p_demande);
  }
  
  public static Chronologie determinerChronoPraTousReglement(Periode p_pra, Chronologie p_chronoActivitesDom)
  {
    Chronologie chronoActiviteSalarie = determinerChronoActiviteSalarieTousReglements(p_chronoActivitesDom, p_pra);
    
    return chronoActiviteSalarie;
  }
  
  public static Chronologie determinerChronoActivitesDV(Demande p_demande)
    throws CoucheLogiqueException
  {
    Chronologie chronoActivitesDV = null;
    
    Damj dateFG = p_demande.getDateFaitGenerateurOuFinDernierContratTravailRompu();
    
    Damj dateDebutPraLaPlusLongue = null;
    ActiviteSalarie periodeValidationProduit = null;
    if ((((DossierAffectation)p_demande.getDossierAffectation()).getValidationProduit() != null) && (((DossierAffectation)p_demande.getDossierAffectation()).getValidationProduit().isEstProduitValide()))
    {
      periodeValidationProduit = ((DossierAffectation)p_demande.getDossierAffectation()).getValidationProduit().getPeriodeValidationProduit();
      
      Pra praLaPlusLongue = ConstructionPra.determinerPraLaPlusLongue(p_demande, periodeValidationProduit);
      
      dateDebutPraLaPlusLongue = praLaPlusLongue.getDebut();
    }
    else
    {
      dateDebutPraLaPlusLongue = Damj.NUIT_DES_TEMPS;
    }
    if (p_demande.getDateFaitGenerateurOdPrecedente() != null) {
      dateDebutPraLaPlusLongue = Damj.max(Damj.NUIT_DES_TEMPS, p_demande.getDateFaitGenerateurOdPrecedente());
    }
    FiltresTemporel filtres = new FiltresTemporel();
    filtres.ajouterFiltre(new FiltreActiviteSalarieAutreQueFormationCifCdd());
    filtres.ajouterFiltre(new FiltreActiviteSalarieeMotifDvNonLegitime());
    filtres.ajouterFiltre(new FiltreFinDansBornes(dateDebutPraLaPlusLongue, dateFG));
    
    filtres.ajouterFiltre(new FiltrePeriodesQualifiables());
    
    chronoActivitesDV = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(filtres);
    
    chronoActivitesDV.setComparateur(new ComparateurTemporelSurDateFinDecroissante());
    
    return chronoActivitesDV;
  }
}

/* Location:
 * Qualified Name:     ConstructionChronologie
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */