package fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.archi.util.trace.Log;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Differe;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Od;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsChomageSansRCT;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.util.services.OutilFonctionnel;
import fr.unedic.util.temps.CalculDelais;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.Periode;
import java.util.ArrayList;

public class DeterminationDiffere
  implements OutilFonctionnel
{
  public static ArrayList determinerDiffere(Demande p_demande)
    throws ApplicativeException
  {
    int douzeMois = 12;
    ArrayList listeDelaiReport = new ArrayList();
    boolean creationDiffere = false;
    if (Log.isTraceActive(DeterminationDiffere.class, Niveau.INFO)) {
      Log.ecritTrace(Niveau.INFO, DeterminationDiffere.class, "determinerDiffere", "Début de la détermination du délai report (Différé).");
    }
    Boolean forcageDelai = null;
    if (p_demande.getDonneesTemporaires() != null) {
      forcageDelai = p_demande.getDonneesTemporaires().isDelaiAttenteForce();
    }
    if ((forcageDelai != null) && (forcageDelai.booleanValue()))
    {
      listeDelaiReport.add(new Differe(7));
      return listeDelaiReport;
    }
    if ((forcageDelai != null) && (!forcageDelai.booleanValue())) {
      return listeDelaiReport;
    }
    Od odCourante = (Od)p_demande.getOdAcquise();
    AttributionSpec odPrecedente = null;
    AttributionSpec attribPrecedente = null;
    if (odCourante != null)
    {
      odPrecedente = p_demande.rechercherOuvertureDroitPrecedenteDuMemeType();
      attribPrecedente = p_demande.rechercherAttributionPrecedenteDuMemeType();
      if (odPrecedente != null)
      {
        if (attribPrecedente == null) {
          attribPrecedente = odPrecedente;
        }
        if (OutilsChomageSansRCT.estDemandeEnContexteDeChomageEnCoursDeSuspension((DemandeAssuranceSpec)odPrecedente.getDemande()))
        {
          creationDiffere = true;
        }
        else
        {
          Damj termePeriode = odCourante.getDateDebut();
          DureeCalendaire duree12Mois = new DureeCalendaire(0, 12, 0);
          Periode periode12MoisSurOdCourante = CalculDelais.determinerDelai(termePeriode, duree12Mois);
          periode12MoisSurOdCourante.setDebut(periode12MoisSurOdCourante.getDebut().lendemain());
          if ((periode12MoisSurOdCourante.estApres(odPrecedente.getDateEffet())) || (!estEntameDiffereOdPrecedente((DemandeAssuranceSpec)attribPrecedente.getDemande()))) {
            creationDiffere = true;
          }
        }
      }
      else
      {
        creationDiffere = true;
      }
      if (creationDiffere)
      {
        if (Log.isTraceActive(DeterminationDiffere.class, Niveau.DEBUG)) {
          Log.ecritTrace(Niveau.DEBUG, DeterminationDiffere.class, "determinerDiffere", "Création du Différé (7 jours).");
        }
        Differe differeJours = new Differe(7);
        
        listeDelaiReport.add(differeJours);
      }
    }
    else if (Log.isTraceActive(DeterminationDiffere.class, Niveau.DEBUG))
    {
      Log.ecritTrace(Niveau.DEBUG, DeterminationDiffere.class, "determinerDiffere", "Aucune Ouverture de Droits sur la demande courante: impossible de déterminer le délai report (Différé).");
    }
    return listeDelaiReport;
  }
  
  private static boolean estEntameDiffereOdPrecedente(DemandeAssuranceSpec p_odPrecedente)
    throws ApplicativeException
  {
    ProduitAsuSpec produit = (ProduitAsuSpec)p_odPrecedente.getDossierAffectation().getProduit();
    return produit.estEntameDiffereStandard(p_odPrecedente);
  }
}

/* Location:
 * Qualified Name:     DeterminationDiffere
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */