package fr.unedic.cali.asu.cge01.p03.migration.graphes;

import fr.unedic.cali.affectation.parametres.AccesDecorReglementaire;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.OutilDeterminationSjc;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.CarenceIccp;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.CarenceIslr;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConditionFaitGenerateur;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionCaractereSaisonnier;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionCoefficientSaisonnier;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionCoefficientTempsPartiel;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDateAttribution;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDelais;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDurees;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionMontantsBruts;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionPointDepartIndemnisation;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionQuantiteAffiliation;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionReglementApplicable;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionSjc;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionSjr;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Decision;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Differe;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DureeIndemnisation;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.EnsembleCarences;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Prc;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.PrcSjc;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.PrcSjr;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.PreavisMesureConservatoireNonIndemnisable;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Sjcip;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.SjrActiviteConservee;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.Sjrip;
import fr.unedic.cali.asu.cge01.p03.migration.controles.ControleDelaisReportPji;
import fr.unedic.cali.asu.cge01.p03.migration.recalcul.RecalculerCapitalDroitCourant;
import fr.unedic.cali.asu.cge01.p03.migration.recalcul.RecalculerMontantBrutDroitCourant;
import fr.unedic.cali.asu.cge01.p03.migration.recalcul.RecalculerPji;
import fr.unedic.cali.asu.dom.CompetenceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.DossierAffecte;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.asu.migration.graphes.GrapheAssurance;
import fr.unedic.cali.autresdoms.cohab.dom.CodesErreursMigration;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.spec.PeriodeGaecSpec;
import fr.unedic.cali.dom.ConteneurAccesDecorReglementaire;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.Erreur;
import fr.unedic.cali.dom.Individu;
import fr.unedic.cali.dom.affectation.Parametres;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P03;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.parcours.ContexteParcoursCali;
import fr.unedic.cohabitation.sigma.migration.dom.DecisionMigreeAsuV1;
import fr.unedic.cohabitation.sigma.migration.dom.DemandeMigreeAsuV1;
import fr.unedic.cohabitation.sigma.migration.dom.DemandeMigreeV1;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.Unite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public abstract class GrapheDecision
  extends GrapheAssurance
{
  private static final String INDEX_PERIODE_GAEC = "-0";
  public static final int NON_RESSORTISSANT_EUROPEEN = 2;
  
  protected Collection getListControle()
  {
    Collection listeControle = new ArrayList();
    
    listeControle.addAll(super.getListControle());
    listeControle.add(new ControleDelaisReportPji());
    
    return listeControle;
  }
  
  protected void alimenterDonnees(DemandeMigreeV1 demandeV1, DemandeSpec demande)
  {
    super.alimenterDonnees(demandeV1, demande);
    
    Decision decisionAsu = (Decision)demande.getDossierAffectation().getDossierExamen();
    
    DemandeMigreeAsuV1 demandeTemporaireSigma = (DemandeMigreeAsuV1)demandeV1;
    DecisionMigreeAsuV1 decisionTemporaireSigma = demandeTemporaireSigma.getDecision();
    
    alimenterValidationProduit(demandeTemporaireSigma, decisionAsu);
    
    alimenterDonneesSimples(decisionTemporaireSigma, decisionAsu);
    
    alimenterCompetences(decisionTemporaireSigma, decisionAsu);
    
    alimenterIdentifiant(decisionTemporaireSigma, decisionAsu);
    
    DossierExamen dossierExamen = (DossierExamen)demande.getDossierAffectation().getDossierExamen();
    
    alimenterCaps(decisionTemporaireSigma, dossierExamen);
    
    alimenterCeps(decisionTemporaireSigma, dossierExamen);
  }
  
  protected void alimenterDonneesForcage(DemandeMigreeV1 demandeV1, DemandeSpec demande)
  {
    super.alimenterDonneesForcage(demandeV1, demande);
    alimenterDonneesImposees(demandeV1, demande);
  }
  
  protected void alimenterDonneesImposees(DemandeMigreeV1 demandeV1, DemandeSpec demande)
  {
    DossierExamen dossierExamen = (DossierExamen)demande.getDossierAffectation().getDossierExamen();
    DecisionMigreeAsuV1 decisionAsu = ((DemandeMigreeAsuV1)demandeV1).getDecision();
    
    alimenterConstitutionDateAttribution(decisionAsu, dossierExamen);
    alimenterConstitutionDurees(decisionAsu, dossierExamen);
    alimenterConstitutionSjr(decisionAsu, dossierExamen);
    alimenterConstitutionSjc(decisionAsu, dossierExamen);
    alimenterConstitutionCoefficientSaisonnier(decisionAsu, dossierExamen);
    alimenterConstitutionCoefficientTempsPartiel(decisionAsu, dossierExamen);
    alimenterConstitutionCaractereSaisonnier(decisionAsu, dossierExamen);
    alimenterConstitutionDelaisReport(decisionAsu, dossierExamen);
  }
  
  protected Collection getListRecalcule()
  {
    Collection listeRecalcul = super.getListRecalcule();
    
    listeRecalcul.add(new RecalculerPji());
    listeRecalcul.add(new RecalculerMontantBrutDroitCourant());
    listeRecalcul.add(new RecalculerCapitalDroitCourant());
    
    return listeRecalcul;
  }
  
  protected DemandeSpec construireGraphe(DemandeMigreeV1 demandeV1)
  {
    DemandeSpec demande = super.construireGraphe(demandeV1);
    
    DemandeMigreeAsuV1 demandeTemporaireSigma = (DemandeMigreeAsuV1)demandeV1;
    
    Demande demandeAsu = (Demande)demande;
    
    demandeAsu.setDossierAffectation(creerDossierAffectation());
    
    int natureDecision = demandeTemporaireSigma.getDecision().getNatureDecision();
    
    demandeAsu.getDossierAffectation().setDossierExamen(creerDecision(natureDecision));
    
    DossierExamen dossierExamen = (DossierExamen)demandeAsu.getDossierAffectation().getDossierExamen();
    
    creerCaps(dossierExamen);
    
    creerCeps(dossierExamen);
    
    return demande;
  }
  
  public DemandeMigreeV1 lireDonnees(DemandeSpec demande)
  {
    DemandeMigreeAsuV1 demandeLue = (DemandeMigreeAsuV1)super.lireDonnees(demande);
    
    DecisionMigreeAsuV1 decisionLue = demandeLue.getDecision();
    
    Demande demandeAsu = (Demande)demande;
    Decision decision = (Decision)demandeAsu.getDossierAffectation().getDossierExamen();
    
    lireValidationProduit(decision, decisionLue);
    
    lireDecision(decision, decisionLue);
    
    lireDonneesSimples(decision, decisionLue);
    
    lireCompetences(decision, decisionLue);
    
    lireIdentifiant(decision, decisionLue);
    
    lireCaps(decision, decisionLue);
    
    lireCeps(decision, decisionLue);
    
    return demandeLue;
  }
  
  protected abstract DossierAffectation creerDossierAffectation();
  
  protected abstract Decision creerDecision(int paramInt);
  
  protected abstract void creerCaps(DossierExamen paramDossierExamen);
  
  protected abstract void creerCeps(DossierExamen paramDossierExamen);
  
  protected abstract void alimenterIdentifiant(DecisionMigreeAsuV1 paramDecisionMigreeAsuV1, Decision paramDecision);
  
  protected abstract void alimenterCaps(DecisionMigreeAsuV1 paramDecisionMigreeAsuV1, DossierExamen paramDossierExamen);
  
  protected abstract void alimenterCeps(DecisionMigreeAsuV1 paramDecisionMigreeAsuV1, DossierExamen paramDossierExamen);
  
  protected void alimenterValidationProduit(DemandeMigreeAsuV1 demandeTemporaireSource, Decision decision)
  {
    ValidationProduit validationProduit = ((DossierAffecte)decision.getDossierAffecte()).getValidationProduit();
    
    String idPeriodeValidation = demandeTemporaireSource.getDecision().getIdPeriodeValidation();
    if (idPeriodeValidation == null)
    {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_PERIO_VALID"));
    }
    else if (isPeriodeValidationProduitValide(idPeriodeValidation))
    {
      validationProduit.setIdentifiantPeriodeValidationProduit(idPeriodeValidation);
      
      ActiviteSalarie periodeValidation = validationProduit.getPeriodeValidationProduit();
      if (periodeValidation == null)
      {
        validationProduit.setIdentifiantPeriodeValidationProduit(idPeriodeValidation + "-0");
        
        periodeValidation = validationProduit.getPeriodeValidationProduit();
        if (periodeValidation == null) {
          getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_PERIO_VALID"));
        } else {
          validationProduit.setPeriodeValidationProduit(periodeValidation);
        }
      }
      else
      {
        validationProduit.setPeriodeValidationProduit(periodeValidation);
      }
      if ((periodeValidation != null) && (periodeValidation.getCollectionOrigineInformationPAS() != null) && (periodeValidation.getCollectionOrigineInformationPAS().contains(Integer.valueOf(10))))
      {
        Demande demandeAsu = (Demande)decision.getDemande();
        DonneesTemporaires donneesTemporaires = demandeAsu.getDonneesTemporaires();
        if (donneesTemporaires != null) {
          donneesTemporaires.setTypeCoordinationEuropeenne(2);
        }
      }
    }
    else
    {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_PER_INVALIDE"));
    }
    ProduitSpec produit = Parametres.getProduit(demandeTemporaireSource.getCodeProduit());
    validationProduit.setProduitValide(produit);
    if ((demandeTemporaireSource.getDecision().getReglementApplicable() != null) || (produit.getReglement(demandeTemporaireSource.getDecision().getReglementApplicable()) != null)) {
      validationProduit.setReglementApplicable(produit.getReglement(demandeTemporaireSource.getDecision().getReglementApplicable()));
    } else {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_RA"));
    }
    if (validationProduit.getPeriodeValidationProduit() != null)
    {
      ConteneurAccesDecorReglementaire conteneur = new ConteneurAccesDecorReglementaire();
      conteneur.setDateRecherche(validationProduit.getPeriodeValidationProduit().getDateFin());
      try
      {
        ((DossierAffectation)decision.getDossierAffecte()).setDecorReglementaire(AccesDecorReglementaire.getInstance().getDecor(conteneur));
      }
      catch (CoucheLogiqueException ex) {}
    }
  }
  
  private boolean isPeriodeValidationProduitValide(String idPeriodeValidation)
  {
    Individu individuCourant = ContexteParcoursCali.getIndividuCourant();
    
    PeriodeGaecSpec periode = individuCourant.rechercherPeriodePasseProfessionnel(idPeriodeValidation);
    if (periode == null) {
      periode = individuCourant.rechercherPeriodePasseProfessionnel(idPeriodeValidation + "-0");
    }
    return periode instanceof ActiviteSalarie;
  }
  
  protected void alimenterDonneesSimples(DecisionMigreeAsuV1 decisionTemporaireSource, Decision decisionInstallee)
  {
    Damj dateDerniereValidation = decisionTemporaireSource.getDateDerniereValidation();
    if (dateDerniereValidation == null)
    {
      getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_DATE_VALID"));
    }
    else
    {
      decisionInstallee.getDemande().setDateDerniereValidation(dateDerniereValidation);
      
      decisionInstallee.setValidee(true);
    }
  }
  
  protected void alimenterCompetences(DecisionMigreeAsuV1 decisionTemporaireSource, Decision decisionInstallee)
  {
    CompetenceSpec competence = decisionInstallee.getCompetence();
    if (decisionTemporaireSource.getCompetenceAdministrative() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_COMP_ADMIN"));
    } else {
      competence.setCompetenceAdministrative(decisionTemporaireSource.getCompetenceAdministrative().intValue());
    }
    if (decisionTemporaireSource.getCompetenceFinanciere() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_COMP_FIN"));
    } else {
      competence.setCompetenceFinanciere(decisionTemporaireSource.getCompetenceFinanciere().intValue());
    }
    if (decisionTemporaireSource.getNumeroConventionGestionEmployeur() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_NUM_G_EMPLOY"));
    } else {
      competence.setNumeroConventionGestion(decisionTemporaireSource.getNumeroConventionGestionEmployeur());
    }
    decisionInstallee.setCompetence(competence);
  }
  
  protected void alimenterConditionFaitGenerateur(DecisionMigreeAsuV1 decisionTemporaireSource, DossierExamen dossierExamen)
  {
    ConditionFaitGenerateur capaFg = (ConditionFaitGenerateur)dossierExamen.getFaitGenerateur();
    
    String idPeriodeFgd = decisionTemporaireSource.getIdPeriodeFgd();
    if (idPeriodeFgd == null)
    {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_ID_PERIO_FGD"));
    }
    else if (isPeriodeValidationProduitValide(idPeriodeFgd))
    {
      capaFg.setIdentifiantPeriodeFaitGenerateur(idPeriodeFgd);
      
      Individu individuCourant = ContexteParcoursCali.getIndividuCourant();
      
      ActiviteSalarie periodeFgd = (ActiviteSalarie)individuCourant.rechercherPeriodePasseProfessionnel(idPeriodeFgd);
      if (periodeFgd == null)
      {
        periodeFgd = (ActiviteSalarie)individuCourant.rechercherPeriodePasseProfessionnel(idPeriodeFgd + "-0");
        if (periodeFgd == null)
        {
          getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_PERIO_FGD"));
        }
        else
        {
          capaFg.setPeriodeFaitGenerateur(periodeFgd);
          
          ((DossierAffecte)dossierExamen.getDossierAffecte()).setSinistre(periodeFgd);
        }
      }
      else
      {
        capaFg.setPeriodeFaitGenerateur(periodeFgd);
        
        ((DossierAffecte)dossierExamen.getDossierAffecte()).setSinistre(periodeFgd);
      }
    }
    else
    {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_PER_FGD"));
    }
    capaFg.setEtatSatisfait(true);
  }
  
  protected void alimenterConditionFaitGenerateurFlagEstApprenti(DecisionMigreeAsuV1 decisionTemporaireSource, DossierExamen dossierExamen)
  {
    ConstitutionSjr constitutionSjr = dossierExamen.getConstitutionSjr();
    if (constitutionSjr != null)
    {
      Prc prcSjr = constitutionSjr.getSjrip().getPrc();
      
      prcSjr.setTopContratsDeTypeParticulier(decisionTemporaireSource.isEstApprenti());
    }
  }
  
  protected void alimenterConstitutionMontantsBruts(DecisionMigreeAsuV1 decisionTemporaireSource, DossierExamen dossierExamen)
  {
    ConstitutionMontantsBruts cepaMontantsBruts = dossierExamen.getConstitutionMontantsBruts();
    if (decisionTemporaireSource.getCapitalOdCourante() == null)
    {
      cepaMontantsBruts.setCapitalInitialBrut(new QuantiteEuro("0"));
      getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_CAPITAL_DC"));
    }
    else
    {
      cepaMontantsBruts.setCapitalInitialBrut(decisionTemporaireSource.getCapitalOdCourante());
    }
    if (decisionTemporaireSource.getMontantBrut() == null)
    {
      cepaMontantsBruts.setMontantJournalierBrut(new QuantiteEuro("0"));
      getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_MONTANT_BRUT"));
    }
    else
    {
      cepaMontantsBruts.setMontantJournalierBrut(decisionTemporaireSource.getMontantBrut());
    }
  }
  
  protected void alimenterConstitutionDurees(DecisionMigreeAsuV1 decisionTemporaireSource, DossierExamen dossierExamen)
  {
    ConstitutionDurees cepaDuree = dossierExamen.getConstitutionDurees();
    DureeIndemnisation dureeIndemnisation = cepaDuree.createDureeIndemnisation();
    if (decisionTemporaireSource.getDureeTheoriqueDroitCourant() != null) {
      dureeIndemnisation.setDureeTheorique(decisionTemporaireSource.getDureeTheoriqueDroitCourant());
    } else {
      getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_DUREE_THEOR"));
    }
    if (decisionTemporaireSource.getDureeEffectiveDroitCourant() != null) {
      dureeIndemnisation.setDureeEffective(decisionTemporaireSource.getDureeEffectiveDroitCourant());
    } else {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_DUREE_EFFECT"));
    }
  }
  
  protected void alimenterConstitutionSjr(DecisionMigreeAsuV1 decisionTemporaireSource, DossierExamen dossierExamen)
  {
    ConstitutionSjr cepaSjr = dossierExamen.getConstitutionSjr();
    if (decisionTemporaireSource.getMontantSjrInitialDroitCourant() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_MT_SJRI"));
    }
    if (decisionTemporaireSource.getMontantSjrrpDroitCourant() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_MT_SJRRP"));
    }
    if (decisionTemporaireSource.getDateDebutPrcSjrInitialDroitCourant() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_DEBUT_SJRI"));
    }
    if (decisionTemporaireSource.getDateFinPrcSjrInitialDroitCourant() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_FIN_SJRI"));
    }
    if (decisionTemporaireSource.getDiviseurSjrInitialCourant() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_DIV_SJRI"));
    }
    if ((decisionTemporaireSource.getMontantSjrInitialDroitCourant() != null) && (decisionTemporaireSource.getDateDebutPrcSjrInitialDroitCourant() != null) && (decisionTemporaireSource.getDateFinPrcSjrInitialDroitCourant() != null) && (decisionTemporaireSource.getMontantSjrrpDroitCourant() != null))
    {
      PrcSjr prcSjr = new PrcSjr(new Periode(decisionTemporaireSource.getDateDebutPrcSjrInitialDroitCourant(), decisionTemporaireSource.getDateFinPrcSjrInitialDroitCourant()));
      
      Sjrip sjrip = cepaSjr.createSjrip();
      
      sjrip.setSjrInitial(decisionTemporaireSource.getMontantSjrInitialDroitCourant());
      sjrip.setDateEvenement(decisionTemporaireSource.getDateFinPrcSjrInitialDroitCourant());
      sjrip.setPlafondSjr(prcSjr.getPlafondSjr());
      
      prcSjr.setDiviseur(decisionTemporaireSource.getDiviseurSjrInitialCourant());
      
      cepaSjr.setSjrrp(new Sjr(decisionTemporaireSource.getMontantSjrrpDroitCourant()));
      
      sjrip.setPrc(prcSjr);
      
      alimenterConditionFaitGenerateurFlagEstApprenti(decisionTemporaireSource, dossierExamen);
    }
  }
  
  protected void alimenterConstitutionSjc(DecisionMigreeAsuV1 decisionTemporaireSource, DossierExamen dossierExamen)
  {
    ConstitutionSjc cepaSjc = dossierExamen.getConstitutionSjc();
    if (decisionTemporaireSource.getMontantSjcInitialDroitCourant() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_MONTANT_SJCI"));
    }
    if (decisionTemporaireSource.getDateSjcInitialDroitCourant() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_DATE_SJCI"));
    }
    Sjcip sjcip = cepaSjc.createSjcip();
    if ((decisionTemporaireSource.getMontantSjcInitialDroitCourant() != null) && (decisionTemporaireSource.getDateSjcInitialDroitCourant() != null))
    {
      sjcip.setSjcInitial(decisionTemporaireSource.getMontantSjcInitialDroitCourant());
      sjcip.setDateEvenement(decisionTemporaireSource.getDateSjcInitialDroitCourant());
      if (dossierExamen.getConstitutionSjr().getSjrip() != null) {
        sjcip.setPlafond(dossierExamen.getConstitutionSjr().getSjrip().getPlafondSjr());
      }
    }
    else
    {
      sjcip.setSjcInitial(new QuantiteEuro("0"));
      if (dossierExamen.getConstitutionSjr().getSjrip() != null) {
        sjcip.setDateEvenement(dossierExamen.getConstitutionSjr().getSjrip().getDateEvenement());
      }
    }
    if (dossierExamen.getConstitutionSjr().getSjrip() != null) {
      sjcip.setPlafond(dossierExamen.getConstitutionSjr().getSjrip().getPlafondSjr());
    }
  }
  
  protected void alimenterListeActivitesConservees(DecisionMigreeAsuV1 decisionTemporaireSource, DossierExamen dossierExamen)
    throws CoucheLogiqueException
  {
    ConstitutionSjc cepaSjc = dossierExamen.getConstitutionSjc();
    Sjcip sjcip = cepaSjc.getSjcip();
    if ((sjcip.getSjcInitial() != null) && (sjcip.getSjcInitial().getValeur().compareTo(BigDecimal.ZERO) != 0))
    {
      Chronologie chronoActivitesConservees = getChronoActivitesConservees(dossierExamen);
      Prc prcSjr = getPrcSjr(dossierExamen);
      Periode periodePrcSjc = new Periode(prcSjr.getDateDebut(), prcSjr.getDateFin());
      
      Iterator it = chronoActivitesConservees.iterer();
      SjrActiviteConservee sjrActiviteConservee = null;
      ActiviteSalarie activiteSalarie = null;
      PrcSjc prcSjcCourante = null;
      if (chronoActivitesConservees.estVide()) {
        getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_PERIODES_SJC"));
      } else {
        while (it.hasNext())
        {
          activiteSalarie = (ActiviteSalarie)it.next();
          
          sjrActiviteConservee = new SjrActiviteConservee(new QuantiteEuro("0"));
          prcSjcCourante = new PrcSjc(periodePrcSjc, activiteSalarie, null);
          sjrActiviteConservee.setPrc(prcSjcCourante);
          sjrActiviteConservee.setPeriodeActiviteConservee(activiteSalarie);
          
          OutilDeterminationSjc.mettreAJourTypeActiviteConservee(sjrActiviteConservee);
          
          sjcip.ajouterSjrActiviteConservee(sjrActiviteConservee);
          
          getListeErreurs().add(new Erreur(2, "LIQ_ASU_PERIODES_SJC", "Période AC du " + activiteSalarie.getDateDebut() + " au " + activiteSalarie.getDateFin()));
        }
      }
    }
  }
  
  protected abstract Chronologie getChronoActivitesConservees(DossierExamen paramDossierExamen)
    throws CoucheLogiqueException;
  
  protected abstract Prc getPrcSjr(DossierExamen paramDossierExamen);
  
  protected void reinitialiserCarences(ConstitutionDelais cepaDelaisReport)
  {
    cepaDelaisReport.clearCollectionEnsembleCarences();
    
    cepaDelaisReport.setDebutCarenceDiffere(null);
    cepaDelaisReport.setTermeCarenceDiffere(null);
    cepaDelaisReport.setNbJoursCarenceDiffere(0);
    
    cepaDelaisReport.setDebutCarenceICCP(null);
    cepaDelaisReport.setTermeCarenceICCP(null);
    cepaDelaisReport.setNbJoursCarenceICCP(0);
    
    cepaDelaisReport.setDebutCarenceISLR(null);
    cepaDelaisReport.setTermeCarenceISLR(null);
    cepaDelaisReport.setNbJoursCarenceISLR(0);
    
    cepaDelaisReport.setDebutCarencePMC(null);
    cepaDelaisReport.setTermeCarencePMC(null);
    cepaDelaisReport.setNbJoursCarencePMC(0);
  }
  
  protected void alimenterConstitutionDelaisReport(DecisionMigreeAsuV1 decisionTemporaireSource, DossierExamen dossierExamen)
  {
    ConstitutionDelais cepaDelaisReport = dossierExamen.getConstitutionDelais();
    
    cepaDelaisReport.clearCollectionDelaisReports();
    
    reinitialiserCarences(cepaDelaisReport);
    if ((decisionTemporaireSource.getNbJoursDiffere() == -1) || (decisionTemporaireSource.getDebutDiffere() == null) || (decisionTemporaireSource.getFinDiffere() == null))
    {
      if (decisionTemporaireSource.getNbJoursDiffere() == -1) {
        getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_NB_JRS_DIFF"));
      }
      if (decisionTemporaireSource.getDebutDiffere() == null) {
        getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_DEBUT_DIFF"));
      }
      if (decisionTemporaireSource.getFinDiffere() == null) {
        getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_FIN_DIFFERE"));
      }
    }
    else
    {
      Differe differe = new Differe();
      cepaDelaisReport.ajouterDelaisReports(differe);
      differe.setQuantiteInitialJour(decisionTemporaireSource.getNbJoursDiffere());
      cepaDelaisReport.setNbJoursCarenceDiffere(decisionTemporaireSource.getNbJoursDiffere());
      differe.setPeriodeEffet(new Periode(decisionTemporaireSource.getDebutDiffere(), decisionTemporaireSource.getFinDiffere()));
      cepaDelaisReport.setDebutCarenceDiffere(decisionTemporaireSource.getDebutDiffere());
      cepaDelaisReport.setTermeCarenceDiffere(decisionTemporaireSource.getFinDiffere());
    }
    EnsembleCarences ensemblesCarences = new EnsembleCarences();
    cepaDelaisReport.ajouterEnsembleCarences(ensemblesCarences);
    if ((decisionTemporaireSource.getNbJoursCarenceICCP() == -1) || (decisionTemporaireSource.getDebutCarenceICCP() == null) || (decisionTemporaireSource.getFinCarenceICCP() == null))
    {
      if (decisionTemporaireSource.getNbJoursCarenceICCP() == -1) {
        getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_NB_JRS_ICCP"));
      }
      if (decisionTemporaireSource.getDebutCarenceICCP() == null) {
        getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_DEBUT_ICCP"));
      }
      if (decisionTemporaireSource.getFinCarenceICCP() == null) {
        getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_FIN_ICCP"));
      }
    }
    else
    {
      CarenceIccp carenceIccp = new CarenceIccp();
      ensemblesCarences.setCarenceIccp(carenceIccp);
      
      cepaDelaisReport.setNbJoursCarenceICCP(decisionTemporaireSource.getNbJoursCarenceICCP());
      carenceIccp.setQuantiteInitialJour(decisionTemporaireSource.getNbJoursCarenceICCP());
      
      carenceIccp.setPeriodeApplicationCarence(new Periode(decisionTemporaireSource.getDebutCarenceICCP(), decisionTemporaireSource.getFinCarenceICCP()));
      
      cepaDelaisReport.setDebutCarenceICCP(decisionTemporaireSource.getDebutCarenceICCP());
      cepaDelaisReport.setTermeCarenceICCP(decisionTemporaireSource.getFinCarenceICCP());
    }
    if ((decisionTemporaireSource.getNbJoursCarenceISLR() == -1) || (decisionTemporaireSource.getDebutCarenceISLR() == null) || (decisionTemporaireSource.getFinCarenceISLR() == null))
    {
      if (decisionTemporaireSource.getNbJoursCarenceISLR() == -1) {
        getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_NB_JRS_ISLR"));
      }
      if (decisionTemporaireSource.getDebutCarenceISLR() == null) {
        getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_DEBUT_ISLR"));
      }
      if (decisionTemporaireSource.getFinCarenceISLR() == null) {
        getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_FIN_ISLR"));
      }
    }
    else
    {
      CarenceIslr carenceIslr = new CarenceIslr();
      ensemblesCarences.setCarenceIslr(carenceIslr);
      
      cepaDelaisReport.setNbJoursCarenceISLR(decisionTemporaireSource.getNbJoursCarenceISLR());
      carenceIslr.setQuantiteInitialJour(decisionTemporaireSource.getNbJoursCarenceISLR());
      
      carenceIslr.setPeriodeApplicationCarence(new Periode(decisionTemporaireSource.getDebutCarenceISLR(), decisionTemporaireSource.getFinCarenceISLR()));
      
      cepaDelaisReport.setDebutCarenceISLR(decisionTemporaireSource.getDebutCarenceISLR());
      cepaDelaisReport.setTermeCarenceISLR(decisionTemporaireSource.getFinCarenceISLR());
    }
    if ((decisionTemporaireSource.getNbJoursCarencePMC() == -1) || (decisionTemporaireSource.getDebutCarencePMC() == null) || (decisionTemporaireSource.getFinCarencePMC() == null))
    {
      if (decisionTemporaireSource.getNbJoursCarencePMC() == -1) {
        getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_NB_JOURS_PMC"));
      }
      if (decisionTemporaireSource.getDebutCarencePMC() == null) {
        getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_DEBUT_PMC"));
      }
      if (decisionTemporaireSource.getFinCarencePMC() == null) {
        getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_FIN_PMC"));
      }
    }
    else
    {
      PreavisMesureConservatoireNonIndemnisable carencePmc = new PreavisMesureConservatoireNonIndemnisable();
      ensemblesCarences.setCarencePmc(carencePmc);
      
      cepaDelaisReport.setNbJoursCarencePMC(decisionTemporaireSource.getNbJoursCarencePMC());
      carencePmc.setQuantiteInitialJour(decisionTemporaireSource.getNbJoursCarencePMC());
      
      carencePmc.setPeriodeApplicationCarence(new Periode(decisionTemporaireSource.getDebutCarencePMC(), decisionTemporaireSource.getFinCarencePMC()));
      
      cepaDelaisReport.setDebutCarencePMC(decisionTemporaireSource.getDebutCarencePMC());
      cepaDelaisReport.setTermeCarencePMC(decisionTemporaireSource.getFinCarencePMC());
    }
  }
  
  protected void alimenterConstitutionQuantiteAffiliation(DecisionMigreeAsuV1 decisionTemporaireSource, DossierExamen dossierExamen)
  {
    ConstitutionQuantiteAffiliation cepaAffiliation = dossierExamen.getConstitutionQuantiteAffiliation();
    if (decisionTemporaireSource.getArticle3() != null) {
      cepaAffiliation.setArticle3(decisionTemporaireSource.getArticle3());
    } else {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_ARTICLE3"));
    }
    if (decisionTemporaireSource.getQteAffiliation1() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_QTE_AFFI_1"));
    }
    if (decisionTemporaireSource.getUniteAffiliation1() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_UNITE_AFFI_1"));
    }
    if ((decisionTemporaireSource.getQteAffiliation1() != null) && (decisionTemporaireSource.getUniteAffiliation1() != null))
    {
      Unite uniteAffiliation1 = null;
      try
      {
        uniteAffiliation1 = Unite.getParCode(decisionTemporaireSource.getUniteAffiliation1());
      }
      catch (NullPointerException e) {}
      if (uniteAffiliation1 == null)
      {
        getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_UNITE_AFFI_1", decisionTemporaireSource.getUniteAffiliation1()));
      }
      else
      {
        cepaAffiliation.setQuantiteAffiliationAcquise(new Quantite(decisionTemporaireSource.getQteAffiliation1(), uniteAffiliation1));
        cepaAffiliation.setQuantiteAssimilationAcquise(new Quantite("0", uniteAffiliation1));
      }
    }
    if (decisionTemporaireSource.getQteAffiliation2() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_QTE_AFFI_2"));
    }
    if (decisionTemporaireSource.getUniteAffiliation2() == null) {
      getListeErreurs().add(CodesErreursMigration.getErreur(2, "LIQ_ASU_UNITE_AFFI_2"));
    }
    if ((decisionTemporaireSource.getQteAffiliation2() != null) && (decisionTemporaireSource.getUniteAffiliation2() != null))
    {
      Unite uniteAffiliation2 = null;
      try
      {
        uniteAffiliation2 = Unite.getParCode(decisionTemporaireSource.getUniteAffiliation2());
      }
      catch (NullPointerException e) {}
      if (uniteAffiliation2 == null)
      {
        getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_UNITE_AFFI_2"));
      }
      else
      {
        cepaAffiliation.setQuantiteAffiliationAcquiseSecondaire(new Quantite(decisionTemporaireSource.getQteAffiliation2(), uniteAffiliation2));
        
        cepaAffiliation.setQuantiteAssimilationAcquiseSecondaire(new Quantite("0", uniteAffiliation2));
      }
    }
  }
  
  protected void alimenterConstitutionReglementApplicable(DecisionMigreeAsuV1 decisionTemporaireSource, DossierExamen dossierExamen)
  {
    ConstitutionReglementApplicable cepaReglementApplicable = (ConstitutionReglementApplicable)dossierExamen.getConstitutionReglementApplicable();
    if ((decisionTemporaireSource.getReglementApplicable() != null) || (ProduitAsuCge01P03.getInstance().contientReglement(decisionTemporaireSource.getReglementApplicable()))) {
      cepaReglementApplicable.setReglement(ProduitAsuCge01P03.getInstance().getReglement(decisionTemporaireSource.getReglementApplicable()));
    } else {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_RA"));
    }
  }
  
  protected void alimenterConstitutionDateAttribution(DecisionMigreeAsuV1 decisionTemporaireSource, DossierExamen dossierExamen)
  {
    ConstitutionDateAttribution cepaDateAttribution = dossierExamen.getConstitutionDateAttribution();
    if (decisionTemporaireSource.getDateAttribution() != null) {
      cepaDateAttribution.setDateAttribution(decisionTemporaireSource.getDateAttribution());
    } else {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_HG_DATE_ATTRIB"));
    }
  }
  
  protected void alimenterConstitutionPji(DecisionMigreeAsuV1 decisionTemporaireSource, DossierExamen dossierExamen)
  {
    ConstitutionPointDepartIndemnisation cepaPji = dossierExamen.getConstitutionPointDepartIndemnisation();
    if (decisionTemporaireSource.getPji() != null) {
      cepaPji.setPji(decisionTemporaireSource.getPji());
    } else {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_HG_PJI"));
    }
  }
  
  protected void alimenterConstitutionCaractereSaisonnier(DecisionMigreeAsuV1 decisionTemporaireSource, DossierExamen dossierExamen)
  {
    ConstitutionCaractereSaisonnier cepaCaractereSaisonnier = dossierExamen.getConstitutionCaractereSaisonnier();
    
    cepaCaractereSaisonnier.setTypeCaractereSaisonnierRetenu(decisionTemporaireSource.getTypeCaractereSaisonnier());
    switch (decisionTemporaireSource.getTypeCaractereSaisonnier())
    {
    case 0: 
      cepaCaractereSaisonnier.setCaractereSaisonnierRetenu(false);
      break;
    case 1: 
    case 2: 
      cepaCaractereSaisonnier.setCaractereSaisonnierRetenu(true);
      cepaCaractereSaisonnier.setActivite3Sur5(false);
      break;
    default: 
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_TYPE_CARAC_S"));
    }
    if ((decisionTemporaireSource.getDateDebutPrcSjrInitialDroitCourant() != null) && (decisionTemporaireSource.getDateFinPrcSjrInitialDroitCourant() != null))
    {
      Periode prs = new Periode(decisionTemporaireSource.getDateDebutPrcSjrInitialDroitCourant(), decisionTemporaireSource.getDateFinPrcSjrInitialDroitCourant());
      
      cepaCaractereSaisonnier.setPeriodeReferenceSaisonnier(prs);
    }
  }
  
  protected void alimenterConstitutionCoefficientSaisonnier(DecisionMigreeAsuV1 decisionTemporaireSource, DossierExamen dossierExamen)
  {
    ConstitutionCoefficientSaisonnier cepaCoefficientSaisonnier = dossierExamen.getConstitutionCoefficientSaisonnier();
    if (decisionTemporaireSource.getCoefCaractereSaisonnierDroitCourant() != null) {
      cepaCoefficientSaisonnier.setCoefficientSaisonnierRetenu(decisionTemporaireSource.getCoefCaractereSaisonnierDroitCourant());
    } else {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_COEF_SAIS"));
    }
  }
  
  protected void alimenterConstitutionCoefficientTempsPartiel(DecisionMigreeAsuV1 decisionTemporaireSource, DossierExamen dossierExamen)
  {
    ConstitutionCoefficientTempsPartiel cepaCoefficientTempsPartiel = dossierExamen.getConstitutionCoefficientTempsPartiel();
    if (decisionTemporaireSource.getCoefTempsPartielDroitCourant() != null) {
      cepaCoefficientTempsPartiel.setCoefficientTempsPartielRetenu(decisionTemporaireSource.getCoefTempsPartielDroitCourant());
    } else {
      getListeErreurs().add(CodesErreursMigration.getErreur(3, "LIQ_ASU_COEF_TPS_P"));
    }
  }
  
  protected abstract void lireIdentifiant(Decision paramDecision, DecisionMigreeAsuV1 paramDecisionMigreeAsuV1);
  
  protected abstract void lireCaps(Decision paramDecision, DecisionMigreeAsuV1 paramDecisionMigreeAsuV1);
  
  protected abstract void lireCeps(Decision paramDecision, DecisionMigreeAsuV1 paramDecisionMigreeAsuV1);
  
  protected void lireDecision(Decision decision, DecisionMigreeAsuV1 decisionLue)
  {
    decisionLue.setNatureDecision(new BigDecimal(decision.getNatureDecision()));
  }
  
  protected void lireValidationProduit(Decision decision, DecisionMigreeAsuV1 decisionLue)
  {
    ValidationProduit validationProduit = ((DossierAffecte)decision.getDossierAffecte()).getValidationProduit();
    
    decisionLue.setIdPeriodeValidation(validationProduit.getIdentifiantPeriodeValidationProduit());
    decisionLue.setDateValidationProduit(validationProduit.getDateFinPeriode());
    
    decisionLue.setReglementApplicable(validationProduit.getReglementApplicable().getNomReglement());
    decisionLue.getDemandeMigree().setCodeProduit(validationProduit.getProduitValide().getNomUnique());
  }
  
  protected void lireDonneesSimples(Decision decision, DecisionMigreeAsuV1 decisionLue)
  {
    decisionLue.setDateDerniereValidation(decision.getDemande().getDateDerniereValidation());
  }
  
  protected void lireCompetences(Decision decision, DecisionMigreeAsuV1 decisionLue)
  {
    decisionLue.setCompetenceAdministrative(new BigDecimal(decision.getCompetence().getCompetenceAdministrative()));
    decisionLue.setCompetenceFinanciere(new BigDecimal(decision.getCompetence().getCompetenceFinanciere()));
  }
  
  protected void lireConditionFaitGenerateur(Decision decision, DecisionMigreeAsuV1 decisionLue)
  {
    ConditionFaitGenerateur conditionFg = (ConditionFaitGenerateur)decision.getConditionFaitGenerateur();
    
    decisionLue.setIdPeriodeFgd(conditionFg.getIdentifiantPeriodeFaitGenerateur());
    decisionLue.setDateFgd(conditionFg.getDateFaitGenerateur());
  }
  
  protected void lireConstitutionCaractereSaisonnier(Decision decision, DecisionMigreeAsuV1 decisionLue)
  {
    decisionLue.setTypeCaractereSaisonnier(Integer.valueOf(decision.getConstitutionCaractereSaisonnier().getTypeCaractereSaisonnierRetenu()).toString());
  }
  
  protected void lireConstitutionCoefficientSaisonnier(Decision decision, DecisionMigreeAsuV1 decisionLue)
  {
    decisionLue.setCoefCaractereSaisonnierDroitCourant(decision.getConstitutionCoefficientSaisonnier().getCoefficientSaisonnierRetenu());
  }
  
  protected void lireConstitutionCoefficientTempsPartiel(Decision decision, DecisionMigreeAsuV1 decisionLue)
  {
    decisionLue.setCoefTempsPartielDroitCourant(decision.getConstitutionCoefficientTempsPartiel().getCoefficientTempsPartielRetenu());
  }
  
  protected void lireConstitutionDateAttribution(Decision decision, DecisionMigreeAsuV1 decisionLue)
  {
    decisionLue.setDateAttribution(decision.getConstitutionDateAttribution().getDateAttribution());
  }
  
  protected void lireConstitutionDelaisReport(Decision decision, DecisionMigreeAsuV1 decisionLue)
  {
    ConstitutionDelais cepaDelaisReport = decision.getConstitutionDelais();
    
    decisionLue.setDebutDiffere(cepaDelaisReport.getDebutCarenceDiffere());
    decisionLue.setFinDiffere(cepaDelaisReport.getTermeCarenceDiffere());
    decisionLue.setNbJoursDiffere(new BigDecimal(cepaDelaisReport.getNbJoursCarenceDiffere()));
    
    decisionLue.setDebutCarenceICCP(cepaDelaisReport.getDebutCarenceICCP());
    decisionLue.setFinCarenceICCP(cepaDelaisReport.getTermeCarenceICCP());
    decisionLue.setNbJoursCarenceICCP(new BigDecimal(cepaDelaisReport.getNbJoursCarenceICCP()));
    
    decisionLue.setDebutCarenceISLR(cepaDelaisReport.getDebutCarenceISLR());
    decisionLue.setFinCarenceISLR(cepaDelaisReport.getTermeCarenceISLR());
    decisionLue.setNbJoursCarenceISLR(new BigDecimal(cepaDelaisReport.getNbJoursCarenceISLR()));
    
    decisionLue.setDebutCarencePMC(cepaDelaisReport.getDebutCarencePMC());
    decisionLue.setFinCarencePMC(cepaDelaisReport.getTermeCarencePMC());
    decisionLue.setNbJoursCarencePMC(new BigDecimal(cepaDelaisReport.getNbJoursCarencePMC()));
  }
  
  protected void lireConstitutionDurees(Decision decision, DecisionMigreeAsuV1 decisionLue)
  {
    if (decision.getConstitutionDurees().getDureeIndemnisation().getDureeTheorique() != null) {
      decisionLue.setDureeTheoriqueDroitCourant(decision.getConstitutionDurees().getDureeIndemnisation().getDureeTheorique().getValeur());
    }
    if (decision.getConstitutionDurees().getDureeIndemnisation().getDureeEffective() != null) {
      decisionLue.setDureeEffectiveDroitCourant(decision.getConstitutionDurees().getDureeIndemnisation().getDureeEffective().getValeur());
    }
  }
  
  protected void lireConstitutionMontantsBruts(Decision decision, DecisionMigreeAsuV1 decisionLue)
  {
    decisionLue.setMontantBrut(decision.getConstitutionMontantsBruts().getMontantJournalierBrut().getValeur());
    decisionLue.setCapitalOdCourante(decision.getConstitutionMontantsBruts().getCapitalInitialBrut().getValeur());
  }
  
  protected void lireConstitutionPji(Decision decision, DecisionMigreeAsuV1 decisionLue)
  {
    decisionLue.setPji(decision.getConstitutionPointDepartIndemnisation().getPji());
  }
  
  protected void lireConstitutionQuantiteAffiliation(Decision decision, DecisionMigreeAsuV1 decisionLue)
  {
    decisionLue.setArticle3(decision.getConstitutionQuantiteAffiliation().getArticle3());
    decisionLue.setQteAffiliation1(decision.getConstitutionQuantiteAffiliation().getQuantiteAffiliationAcquise().getValeur());
    decisionLue.setUniteAffiliation1(decision.getConstitutionQuantiteAffiliation().getQuantiteAffiliationAcquise().getUnite().getCode());
  }
  
  protected void lireConstitutionReglementApplicable(Decision decision, DecisionMigreeAsuV1 decisionLue)
  {
    decisionLue.setReglementApplicable(decision.getConstitutionReglementApplicable().getReglement().getNomReglement());
  }
  
  protected void lireConstitutionSjc(Decision decision, DecisionMigreeAsuV1 decisionLue)
  {
    ConstitutionSjc cepaSjc = decision.getConstitutionSjc();
    if (cepaSjc != null)
    {
      decisionLue.setMontantSjcInitialDroitCourant(cepaSjc.getSjcip().getSjcInitial().getValeur());
      
      decisionLue.setDateSjcInitialDroitCourant(cepaSjc.getSjcip().getDateEvenement());
    }
  }
  
  protected void lireConstitutionSjr(Decision decision, DecisionMigreeAsuV1 decisionLue)
  {
    Sjrip sjrip = decision.getConstitutionSjr().getSjrip();
    Sjr sjrrp = decision.getConstitutionSjr().getSjrrp();
    
    decisionLue.setMontantSjrInitialDroitCourant(sjrip.getSjrInitial().getValeur());
    
    decisionLue.setMontantSjrrpDroitCourant(sjrrp.getSalaire());
    
    decisionLue.setDateDebutPrcSjrInitialDroitCourant(sjrip.getPrc().getDateDebut());
    
    decisionLue.setDateFinPrcSjrInitialDroitCourant(sjrip.getPrc().getDateFin());
    
    decisionLue.setDiviseurSjrInitialCourant(sjrip.getPrc().getDiviseur());
    if (sjrip.getPrc() != null) {
      decisionLue.setEstApprenti(sjrip.getPrc().isTopContratsDeTypeParticulier());
    }
  }
}

/* Location:
 * Qualified Name:     GrapheDecision
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */