package fr.unedic.cali.asu.cge01.p05.liquidation.dom;

import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionCaractereSaisonnier;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionCoefficientSaisonnier;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionCoefficientTempsPartiel;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDateAttributionFinDroit;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDelaisFinDeDroit;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeEffective;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeReglementaireFinAsr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionPointDeDepartFinDroit;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionProduitResultantFinDroit;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionQuantiteAffiliation;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionReglementApplicableFinAsr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionRevisionAutomatiqueFinAsr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationCompetencesProduitCourant;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationCompetencesProduitResultant;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionChomageInvolontaire;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionCumulActiviteConservee;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionFaitGenerateurFinDroit;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationConditionQuantiteAffiliationFinDroit;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ParcoursConstitutionSjc;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ParcoursConstitutionSjr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.VerifierConditionSurFinDispositifReclassement;
import fr.unedic.cali.asu.cge01.p05.liquidation.dom.gen.ObjectifExamenAdmissionFinAsrGen;
import fr.unedic.cali.asu.parcours.ParcoursObjectifAdmission;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionCapitalAvecDureeEffective;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionMontantsBruts;
import fr.unedic.cali.asu.produits.liquidation.parcours.DeterminationConditionAge;
import fr.unedic.cali.asu.produits.liquidation.parcours.DeterminationConditionDureeNonNulle;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.services.Parcours;

public class ObjectifExamenAdmissionFinAsr
  extends ObjectifExamenAdmissionFinAsrGen
{
  private static final long serialVersionUID = 1L;
  
  public ObjectifExamenAdmissionFinAsr(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public ObjectifExamenAdmissionFinAsr() {}
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
  
  public ObjetMetierSpec copie()
  {
    ObjectifExamenAdmission copie = new ObjectifExamenAdmission();
    copieElements(copie);
    return copie;
  }
  
  public Parcours creerParcoursCaractereSaisonnier()
  {
    return new ConstitutionCaractereSaisonnier();
  }
  
  public Parcours creerParcoursCoefficientSaisonnier()
  {
    return new ConstitutionCoefficientSaisonnier();
  }
  
  public Parcours creerParcoursCoefficientTempsPartiel()
  {
    return new ConstitutionCoefficientTempsPartiel();
  }
  
  public Parcours creerParcoursConditionChomageInvolontaire()
  {
    return new DeterminationConditionChomageInvolontaire();
  }
  
  public Parcours creerParcoursConditionFaitGenerateur()
  {
    return new DeterminationConditionFaitGenerateurFinDroit();
  }
  
  public Parcours creerParcoursConditionQuantiteAffiliation()
  {
    return new DeterminationConditionQuantiteAffiliationFinDroit();
  }
  
  public Parcours creerParcoursConditionDureeNonNulle()
  {
    return new DeterminationConditionDureeNonNulle();
  }
  
  public Parcours creerParcoursDateAttribution()
  {
    return new ConstitutionDateAttributionFinDroit();
  }
  
  public Parcours creerParcoursDelaisReports()
  {
    return new ConstitutionDelaisFinDeDroit();
  }
  
  public Parcours creerParcoursDeterminationCompetenceFinanceAdmDroitResultant()
  {
    return new DeterminationCompetencesProduitResultant();
  }
  
  public Parcours creerParcoursDeterminationCompetencesFinanceAdmDroitCourant()
  {
    return new DeterminationCompetencesProduitCourant();
  }
  
  public Parcours creerParcoursDureeEffective()
  {
    return new ConstitutionDureeEffective();
  }
  
  public Parcours creerParcoursDureesReglementaires()
  {
    return new ConstitutionDureeReglementaireFinAsr();
  }
  
  public Parcours creerParcoursMontantsBruts()
  {
    return new ConstitutionMontantsBruts();
  }
  
  public Parcours creerParcoursProduitResultant()
  {
    return new ConstitutionProduitResultantFinDroit();
  }
  
  public Parcours creerParcoursQuantiteAffiliation()
  {
    return new ConstitutionQuantiteAffiliation();
  }
  
  public Parcours creerParcoursSalaireJournalierConserve()
  {
    return new ParcoursConstitutionSjc();
  }
  
  public Parcours creerParcoursSalaireJournalierDeReference()
  {
    return new ParcoursConstitutionSjr();
  }
  
  public Parcours creerParcoursCapitalAvecDureeEffective()
  {
    return new ConstitutionCapitalAvecDureeEffective();
  }
  
  public Parcours creerParcoursConditionAge()
  {
    return new DeterminationConditionAge();
  }
  
  public Parcours creerParcoursConditionChomageTotal()
  {
    return null;
  }
  
  public Parcours creerParcoursConditionCumulAvantageVieillesse()
  {
    return super.creerParcoursConditionCumulAvantageVieillesse();
  }
  
  public Parcours creerParcoursConditionCumulActiviteConservee()
  {
    return new VerifierConditionSurFinDispositifReclassement(new DeterminationConditionCumulActiviteConservee());
  }
  
  public Parcours creerParcoursConditionCumulPrestationFamiliale()
  {
    return new VerifierConditionSurFinDispositifReclassement(super.creerParcoursConditionCumulPrestationFamiliale());
  }
  
  public Parcours creerParcoursConditionMontant()
  {
    return new VerifierConditionSurFinDispositifReclassement(super.creerParcoursConditionMontant());
  }
  
  public Parcours creerParcoursConditionRechercheEmploi()
  {
    return null;
  }
  
  public Parcours creerParcoursObjectif()
  {
    return new ParcoursObjectifAdmission();
  }
  
  public Parcours creerParcoursPointDeDepart()
  {
    return new ConstitutionPointDeDepartFinDroit();
  }
  
  public Parcours creerParcoursReglementApplicable()
  {
    return new ConstitutionReglementApplicableFinAsr();
  }
  
  public Parcours creerParcoursRevisionAutomatique()
  {
    return new ConstitutionRevisionAutomatiqueFinAsr();
  }
}

/* Location:
 * Qualified Name:     ObjectifExamenAdmissionFinAsr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */