package fr.unedic.cali.asu.cge01.parametres;

import fr.unedic.cali.asu.produits.liquidation.dom.Pra;
import fr.unedic.cali.asu.produits.liquidation.parametres.CleAccesPRA;
import fr.unedic.cali.parametres.GestionnaireDateApplication;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import fr.unedic.util.services.ApplicativeRuntimeException;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;
import java.util.Iterator;

public class ParametragePraOppositionDv
{
  private Collection<Pra> listePRA;
  private static ParametragePraOppositionDv instance;
  
  public static ParametragePraOppositionDv getInstance()
  {
    if (instance == null) {
      instance = new ParametragePraOppositionDv();
    }
    return instance;
  }
  
  public ParametragePraOppositionDv()
  {
    initInstance();
  }
  
  private void initInstance()
  {
    listePRA = new ArrayList();
    
    Pra pra = new Pra("RG");
    positionnerQuantiteAffiliationRequise(pra, 91, "jour d'affiliation");
    positionnerQuantiteAffiliationRequise(pra, 455, "heure de travail");
    ajouterPRASurCollection(pra);
    
    pra = new Pra("RGP");
    positionnerQuantiteAffiliationRequise(pra, 91, "jour d'affiliation");
    positionnerQuantiteAffiliationRequise(pra, 455, "heure de travail");
    ajouterPRASurCollection(pra);
    
    pra = new Pra("OP");
    positionnerQuantiteAffiliationRequise(pra, 91, "jour d'affiliation");
    positionnerQuantiteAffiliationRequise(pra, 455, "heure de travail");
    ajouterPRASurCollection(pra);
    
    pra = new Pra("A1");
    positionnerQuantiteAffiliationRequise(pra, 91, "jour d'affiliation");
    ajouterPRASurCollection(pra);
    
    pra = new Pra("A2a");
    positionnerQuantiteAffiliationRequise(pra, 91, "embarquement administratif");
    positionnerQuantiteAffiliationRequise(pra, 630, "heure de travail");
    ajouterPRASurCollection(pra);
    
    pra = new Pra("A2b");
    positionnerQuantiteAffiliationRequise(pra, 91, "embarquement administratif");
    ajouterPRASurCollection(pra);
    
    pra = new Pra("A3");
    positionnerQuantiteAffiliationRequise(pra, 130, "vacation");
    ajouterPRASurCollection(pra);
    try
    {
      Damj datePivot = GestionnaireDateApplication.getInstance().recupererDateApplication("Prise en compte des heures pour la pra d'opposition en A4");
      
      pra = new Pra("A4");
      positionnerQuantiteAffiliationRequise(pra, 91, "embarquement administratif");
      positionnerQuantiteAffiliationRequise(pra, 455, "heure de travail");
      pra.setPeriodeValidite(new Periode(Damj.NUIT_DES_TEMPS, datePivot.veille()));
      ajouterPRASurCollection(pra);
      
      pra = new Pra("A4");
      positionnerQuantiteAffiliationRequise(pra, 455, "heure de travail");
      positionnerQuantiteAffiliationRequise(pra, 91, "jour d'affiliation");
      pra.setPeriodeValidite(new Periode(datePivot, Damj.FIN_DES_TEMPS));
      ajouterPRASurCollection(pra);
    }
    catch (CoucheLogiqueException ex)
    {
      throw new ApplicativeRuntimeException(ex.getCode(), ex.getMessage(), ex);
    }
    pra = new Pra("A5");
    positionnerQuantiteAffiliationRequise(pra, 455, "heure de travail");
    ajouterPRASurCollection(pra);
    
    pra = new Pra("A9A");
    positionnerQuantiteAffiliationRequise(pra, 91, "jour d'affiliation");
    positionnerQuantiteAffiliationRequise(pra, 455, "heure de travail");
    ajouterPRASurCollection(pra);
  }
  
  public Pra getPram(CleAccesPRA cle)
  {
    Iterator<Pra> it = listePRA.iterator();
    while (it.hasNext())
    {
      Pra pra = (Pra)it.next();
      if (pra.estApplicable(cle)) {
        return (Pra)pra.copie();
      }
    }
    return null;
  }
  
  protected void ajouterPRASurCollection(Pra pra)
  {
    listePRA.add(pra);
  }
  
  protected void positionnerQuantiteAffiliationRequise(Pra pra, int pQuantite, String uniteAffiliation)
  {
    Unite unite = Unite.get(uniteAffiliation);
    Quantite quantite = new Quantite(pQuantite, unite);
    pra.getListeQuantitesAffiliationRequises().put(unite, quantite);
  }
}

/* Location:
 * Qualified Name:     ParametragePraOppositionDv
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */