package fr.unedic.cali.asu.cge01.revision.outilsfonctionnels;

import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.PensionInvaliditeChainee;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsRevisions;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.autresdoms.cohab.dom.spec.PeriodePensionInvaliditeChaineeSpec;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

public class DeterminationListePensionInvaliditeRevisionAre14
{
  public static Collection<PeriodePensionInvaliditeChaineeSpec> determinationListePisRevision(Demande p_demandeRevision)
  {
    List<List<PeriodePensionInvaliditeChaineeSpec>> ensemblePi = construireEnsemblePis((Attribution)p_demandeRevision.getAttribution());
    return determinationListePis(ensemblePi);
  }
  
  public static Collection<PeriodePensionInvaliditeChaineeSpec> determinationListePis(List<List<PeriodePensionInvaliditeChaineeSpec>> pEnsemblePis)
  {
    Collection<PeriodePensionInvaliditeChaineeSpec> listePiFinalePourMontantPi = new ArrayList();
    
    int indexPremiereDemandeSousJacence = 0;
    int uneDemandeSouJacente = 1;
    int decalageIndexNombreDeDemande = 1;
    if (!pEnsemblePis.isEmpty())
    {
      Collection<PeriodePensionInvaliditeChaineeSpec> listePiPremiereFct = (Collection)pEnsemblePis.get(indexPremiereDemandeSousJacence);
      int nombredemandeSousJacentes = pEnsemblePis.size();
      List<List<PeriodePensionInvaliditeChaineeSpec>> listePisDemandeSousJacentes = null;
      if (nombredemandeSousJacentes > uneDemandeSouJacente) {
        listePisDemandeSousJacentes = pEnsemblePis.subList(indexPremiereDemandeSousJacence + decalageIndexNombreDeDemande, nombredemandeSousJacentes);
      }
      Iterator<PeriodePensionInvaliditeChaineeSpec> iterateurListePiPremiereFct = listePiPremiereFct.iterator();
      while (iterateurListePiPremiereFct.hasNext())
      {
        PeriodePensionInvaliditeChaineeSpec piTempPremiereFct = (PeriodePensionInvaliditeChaineeSpec)iterateurListePiPremiereFct.next();
        PensionInvaliditeChainee piPourMontantPensionInvalidite = new PensionInvaliditeChainee();
        listePiFinalePourMontantPi.add(piPourMontantPensionInvalidite);
        piTempPremiereFct.copieElements(piPourMontantPensionInvalidite);
        if ((piPourMontantPensionInvalidite.getStatut() == 1) && (estPiExisteAvecCaractereCumulable(piTempPremiereFct, listePisDemandeSousJacentes))) {
          piPourMontantPensionInvalidite.setStatut(2);
        }
      }
    }
    return listePiFinalePourMontantPi;
  }
  
  public static List<List<PeriodePensionInvaliditeChaineeSpec>> construireEnsemblePis(Attribution pAttributionRevision)
  {
    Demande demandeRevision = (Demande)pAttributionRevision.getDemande();
    List<List<PeriodePensionInvaliditeChaineeSpec>> listePiDemandesSousJacentes = new ArrayList();
    List<DemandeAssuranceSpec> listeDemandeAssocie = OutilsRevisions.getListeDemandesAssocieesAdmission(demandeRevision);
    
    Iterator<DemandeAssuranceSpec> iterateur = listeDemandeAssocie.iterator();
    while (iterateur.hasNext())
    {
      DemandeAssuranceSpec demande = (DemandeAssuranceSpec)iterateur.next();
      AttributionAssuranceSpec attribution = (AttributionAssuranceSpec)demande.getDossierExamen();
      List<PeriodePensionInvaliditeChaineeSpec> listePi = new ArrayList();
      Iterator<PeriodePensionInvaliditeChaineeSpec> iter = attribution.getListePensionInvalidite().iterator();
      while (iter.hasNext())
      {
        PensionInvaliditeChainee element = (PensionInvaliditeChainee)iter.next();
        listePi.add((PensionInvaliditeChainee)element.copie());
      }
      listePiDemandesSousJacentes.add(listePi);
    }
    return listePiDemandesSousJacentes;
  }
  
  public static boolean estPiExisteAvecCaractereCumulable(PeriodePensionInvaliditeChaineeSpec pPiTempPremiereFct, List<List<PeriodePensionInvaliditeChaineeSpec>> pListePisDemandeSousJacentes)
  {
    boolean estPiExisteAvecCaractereCumulable = false;
    if (pListePisDemandeSousJacentes != null)
    {
      Iterator<List<PeriodePensionInvaliditeChaineeSpec>> iterateurListePisDemandeSousJacente = pListePisDemandeSousJacentes.iterator();
      while (iterateurListePisDemandeSousJacente.hasNext())
      {
        Collection<PeriodePensionInvaliditeChaineeSpec> collectionPi = (Collection)iterateurListePisDemandeSousJacente.next();
        if (collectionPi != null)
        {
          Iterator<PeriodePensionInvaliditeChaineeSpec> collectionPiTemp = collectionPi.iterator();
          while (collectionPiTemp.hasNext())
          {
            PeriodePensionInvaliditeChaineeSpec pi = (PeriodePensionInvaliditeChaineeSpec)collectionPiTemp.next();
            if ((pPiTempPremiereFct.compareTo(pi) == 0) && (2 == pi.getStatut())) {
              return true;
            }
          }
        }
      }
    }
    return estPiExisteAvecCaractereCumulable;
  }
}

/* Location:
 * Qualified Name:     DeterminationListePensionInvaliditeRevisionAre14
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */