package fr.unedic.cali.asu.csa06.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.csa06.liquidation.outilsfonctionnels.fabriques.FabriqueStrategieContexteRepriseSystematique;
import fr.unedic.cali.asu.csa06.liquidation.outilsfonctionnels.strategies.StrategieContexteRepriseSystematiqueSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.EreDemandeExpresse;
import fr.unedic.cali.asu.outilsfonctionnels.OutilDeterminationObjectifReprise;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.strategies.StrategieDroitOptionElargiApres;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.strategies.StrategieDroitOptionElargiAvant;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.strategies.spec.StrategieDroitOptionElargiSpec;
import fr.unedic.cali.fabriques.outilsfonctionnels.FabriqueStrategieGenerique;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.util.services.CoucheLogiqueException;
import java.util.ArrayList;
import java.util.List;

public class OutilDeterminationOrdreObjectifs
  extends fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.OutilDeterminationOrdreObjectifs
{
  public static fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.OutilDeterminationOrdreObjectifs getInstance()
  {
    return new OutilDeterminationOrdreObjectifs();
  }
  
  protected List determinerObjectifsAvecAntecedentValide(Demande demande, boolean estEnRepriseContextuelle, boolean estReliquatDroitMaintenu)
    throws CoucheLogiqueException
  {
    boolean droitOptionReadmissionForce = false;
    if (demande.getDonneesTemporaires() != null)
    {
      StrategieDroitOptionElargiSpec strategie = (StrategieDroitOptionElargiSpec)FabriqueStrategieGenerique.choisirStrategie(demande.getDateExamen(), "Application du droit d'option élargi.", new StrategieDroitOptionElargiAvant(), new StrategieDroitOptionElargiApres());
      
      droitOptionReadmissionForce = strategie.estDroitOptionForce(demande);
      demande.setDroitOptionReadmission((demande.estDroitOptionReadmission()) || (droitOptionReadmissionForce));
    }
    List<Integer> listeTypesObjectifs = new ArrayList();
    if (OutilDeterminationObjectifReprise.getInstance().determineDateExtinctionReliquatSurObjectifReprise(demande) != null)
    {
      listeTypesObjectifs.add(Integer.valueOf(12));
      listeTypesObjectifs.add(Integer.valueOf(determinerObjectifReprise(demande, 13)));
    }
    else if ((!demande.estDroitOptionReadmission()) && (!(demande.getEvenementReferenceExamen() instanceof EreDemandeExpresse)))
    {
      CritereStrategie critere = new CritereStrategie();
      critere.setDatePivot(demande.getDateExamen());
      StrategieContexteRepriseSystematiqueSpec strategie = (StrategieContexteRepriseSystematiqueSpec)FabriqueStrategieContexteRepriseSystematique.getInstance().getStrategie(critere);
      listeTypesObjectifs = strategie.determinerObjectifsExamenPourRepriseSystematique(demande);
    }
    else if ((demande.getEvenementReferenceExamen() instanceof EreDemandeExpresse))
    {
      listeTypesObjectifs.addAll(determinerObjectifDemandeExpresseAvecReliquatValide(demande));
    }
    else
    {
      listeTypesObjectifs.add(Integer.valueOf(12));
    }
    return listeTypesObjectifs;
  }
  
  public static int determinerObjectifRepriseAvecGestionContexteNovation(Demande demande)
  {
    int objectifRetour;
    int objectifRetour;
    if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(demande.getListContexteDemande(), "AREENTRCSP"))
    {
      objectifRetour = 47;
    }
    else
    {
      int objectifRetour;
      if (OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(demande.getListContexteDemande(), "PREPOSTCSP")) {
        objectifRetour = 48;
      } else {
        objectifRetour = determinerObjectifReprise(demande, 13);
      }
    }
    return objectifRetour;
  }
  
  public static int determinerObjectifReprise(Demande demande, int typeReprise)
  {
    int objectifRetour;
    int objectifRetour;
    if ("S".equalsIgnoreCase(demande.getModeLiquidation())) {
      objectifRetour = 34;
    } else {
      objectifRetour = typeReprise;
    }
    return objectifRetour;
  }
}

/* Location:
 * Qualified Name:     OutilDeterminationOrdreObjectifs
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */