package fr.unedic.cali.asu.csa06.p02;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.csa06.p02.liquidation.dom.FabriqueObjectifExamen;
import fr.unedic.cali.asu.csa06.p02.liquidation.outilsfonctionnels.AlimenterBaseEchanges;
import fr.unedic.cali.asu.csa06.p02.liquidation.outilsfonctionnels.ConstructionPra;
import fr.unedic.cali.asu.csa06.p02.liquidation.outilsfonctionnels.RechercheValiditeProduit;
import fr.unedic.cali.asu.csa06.p02.liquidation.outilsfonctionnels.RecuperationFormuleMontant;
import fr.unedic.cali.asu.csa06.p02.liquidation.outilsfonctionnels.strategies.StrategieConditionChomageInvolontaireAre14Avant;
import fr.unedic.cali.asu.csa06.p02.liquidation.parcours.ParcoursDeterminationOrdreObjectifs;
import fr.unedic.cali.asu.csa06.p02.parametres.FabriqueParametres;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.affectation.ContexteDemandeSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuCsa06P02;
import fr.unedic.cali.dom.affectation.ValidationProduitSpec;
import fr.unedic.cali.dom.echange.Decision;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.List;

public class ProduitDelegue
  extends fr.unedic.cali.asu.cge01.p03.ProduitDelegue
{
  public Object creerObjectifExamen(int p_sousType, List<ContexteDemandeSpec> p_contexteDemande)
  {
    return FabriqueObjectifExamen.creerObjectif(p_sousType, p_contexteDemande);
  }
  
  public ValidationProduitSpec obtenirValidationProduit(ActiviteSalarie p_activiteSalarie, IndividuSpec p_individu, DemandeSpec p_demande, boolean p_avecPeriodeNonAttestee)
    throws ApplicativeException
  {
    return RechercheValiditeProduit.getInstance().validerProduit(p_activiteSalarie, (DemandeAssuranceSpec)p_demande, p_avecPeriodeNonAttestee, FabriqueParametres.getParametres(p_demande, ProduitAsuCsa06P02.getInstance()));
  }
  
  public Periode determinerPraLaPlusLongue(DemandeSpec p_demandeCourante, ActiviteSalarie p_periodeFctCourante)
    throws CoucheLogiqueException
  {
    return ConstructionPra.getPra(p_periodeFctCourante, (Demande)p_demandeCourante, FabriqueParametres.getParametres(p_demandeCourante, ProduitAsuCsa06P02.getInstance()));
  }
  
  public Resultat verifierConditionChomageTotal(Contexte p_contexte)
    throws CoucheLogiqueException
  {
    return new Resultat(0);
  }
  
  public void alimenterBaseEchangesProduit(DossierExamenSpec p_dossierExamen, Decision p_demandeEchange)
    throws ApplicativeException
  {
    AlimenterBaseEchanges.alimenterDonneesProduit(p_dossierExamen, p_demandeEchange);
  }
  
  public void determinerOrdreObjectifs(Contexte p_contexte)
    throws ApplicativeException
  {
    ParcoursDeterminationOrdreObjectifs parcours = new ParcoursDeterminationOrdreObjectifs();
    parcours.effectuerParcours(p_contexte);
  }
  
  public boolean verifierCapasPreliminaires(Contexte p_contexte)
    throws ApplicativeException
  {
    return true;
  }
  
  public FormuleMontantSpec getFormuleMontant(String p_code)
  {
    return RecuperationFormuleMontant.getInstanceFormuleMontant(p_code);
  }
  
  public Resultat constituerProduitResultant(Contexte p_contexte)
    throws ApplicativeException
  {
    return new Resultat(0);
  }
  
  public BigDecimal determinerDureeMaximumPourProduit()
  {
    return new BigDecimal(122);
  }
  
  public StrategieSpec retournerStrategieAvantDeterminationChomageInvolontaire()
  {
    return new StrategieConditionChomageInvolontaireAre14Avant();
  }
}

/* Location:
 * Qualified Name:     ProduitDelegue
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */