package fr.unedic.cali.asu.cva10.calcul.pbjc;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.calcul.pbjc.FacadePBJCLigneSansTrancheImpl;
import fr.unedic.cali.asu.cva10.calcul.dom.FormuleMontantRegimeGeneralASPDC;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.MontantAsuSpec;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.mnt.dom.Accord;
import fr.unedic.cali.asu.mnt.dom.DemandeMaintien;
import fr.unedic.cali.asu.mnt.dom.DossierExamen;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsTrancheCalcul;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.Reprise;
import fr.unedic.cali.asu.produits.liquidation.dom.TrancheExecutable;
import fr.unedic.cali.autresdoms.cohab.dom.spec.PeriodeSousPensionInvaliditeChaineeSpec;
import fr.unedic.cali.autresdoms.ga.dom.PeriodeActiviteSalarie;
import fr.unedic.cali.calcul.OutillagePeriodes;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculSpec;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.calcul.dom.EtatAuDji;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.Somme;
import fr.unedic.cali.calcul.dom.UniteTraitement;
import fr.unedic.cali.calcul.dom.periode.ActionFormation;
import fr.unedic.cali.calcul.dom.periode.DsmTravail;
import fr.unedic.cali.calcul.dom.periode.PeriodeClca;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodeInterStageFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodePrime;
import fr.unedic.cali.calcul.dom.periode.PeriodeTravailJustifiee;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeLimiteIndemnisationASP;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeRadiation;
import fr.unedic.cali.calcul.pbjc.FacadePBJCProduitSpec;
import fr.unedic.cali.calcul.pbjc.dom.PbjcNcp;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.ElementBaseIndemnisationSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.cali.dom.Prescription;
import fr.unedic.cali.dom.RepriseSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuCva10P02;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.outilsfonctionnels.OutilDemande;
import fr.unedic.util.Mathematiques;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.Collection;
import java.util.Iterator;

public class FacadePBJCLigneCVA10Impl
  extends FacadePBJCLigneSansTrancheImpl
  implements FacadePBJCProduitSpec
{
  protected void ajouterGroupeMontantAREF(PbjcNcp pbjcNcp, String nomProduit, Somme somme, UniteTraitement ut)
  {
    ChronologiePeriodes periodes = null;
    ObjetChronoPeriode objetChronoPeriode = null;
    PeriodeFormation periodeFormationCalcul = null;
    
    pbjcNcp.ajouterGroupeMontants(nomProduit, 1, new BigDecimal("0"), somme.getMontant().getMontantBrut().getValeur(), new BigDecimal("1"), somme.getMontant().getMontantBrut().getValeur(), "");
    
    periodes = ut.getQualificationPeriodes().getPeriodesSegmentantes();
    periodes.iterer();
    while (periodes.encoreSuivant())
    {
      objetChronoPeriode = (ObjetChronoPeriode)periodes.elementSuivant();
      if ((objetChronoPeriode instanceof PeriodeFormation))
      {
        if (objetChronoPeriode.getDateDebut().equals(pbjcNcp.getDateDebut())) {
          if (((PeriodeFormation)objetChronoPeriode).getIdentifiantPeriodeFormation() == 1) {
            pbjcNcp.ajouterComplementDeJustification("BF");
          } else {
            pbjcNcp.ajouterComplementDeJustification("BA");
          }
        }
        if (objetChronoPeriode.getDateFin().equals(pbjcNcp.getDateFin()))
        {
          pbjcNcp.ajouterComplementDeJustification("TH");
          pbjcNcp.ajouterComplementDeJustification("TD");
          
          pbjcNcp.setCodeRadiationLendemainPeriode("41");
        }
        if (pbjcNcp.chevauche(new Periode(objetChronoPeriode.getDateDebut(), objetChronoPeriode.getDateFin())))
        {
          periodeFormationCalcul = (PeriodeFormation)objetChronoPeriode;
          pbjcNcp.setIdStageFormation(periodeFormationCalcul.getIdentifiantPeriodeFormation());
          pbjcNcp.setTypeMesurePourLEmploi(periodeFormationCalcul.getTypeMesureEmploi());
        }
      }
      else if (((objetChronoPeriode instanceof PeriodeInterStageFormation)) && 
        (objetChronoPeriode.getDateDebut().veille().equals(pbjcNcp.getDateFin())))
      {
        pbjcNcp.ajouterComplementDeJustification("TH");
        pbjcNcp.ajouterComplementDeJustification("TD");
      }
    }
    periodes = ut.getQualificationPeriodes().getPeriodesNonQualifiees();
    periodes.iterer();
    while (periodes.encoreSuivant())
    {
      objetChronoPeriode = (ObjetChronoPeriode)periodes.elementSuivant();
      if (((objetChronoPeriode instanceof ActionFormation)) && 
        (pbjcNcp.chevauche(new Periode(objetChronoPeriode.getDateDebut(), objetChronoPeriode.getDateFin()))))
      {
        pbjcNcp.setIdPlanFormation(((ActionFormation)objetChronoPeriode).getIdentifiantActionFormation());
        
        pbjcNcp.setTypeDePlan(((ActionFormation)objetChronoPeriode).getTypePlan());
      }
    }
  }
  
  protected void ajouterGroupeMontantPCRC(PbjcNcp pbjcNcp, MontantBaseSpec montantBaseSpec)
  {
    MontantAsuSpec montant = (MontantAsuSpec)montantBaseSpec;
    
    pbjcNcp.ajouterGroupeMontants("PCRC", 0, montant.getSjrNonReduit(), montant.getBaseCalculCrc().setScale(2, 3), Mathematiques.arrondiASup(montant.getTauxCrc().multiply(new BigDecimal("100")), 2), Mathematiques.arrondiASup(montant.getCrc().getValeur(), 2), montant.getPositionExonerationCrc());
    if (montant.getPensionInvaliditeADeduirePriseEnCompte() != null) {
      pbjcNcp.setMontantPensionInvalidite(montant.getPensionInvaliditeADeduirePriseEnCompte().getValeur());
    }
  }
  
  public void ajouterGroupeMontantProduit(PbjcNcp pbjcNcp, AttributionSpec attribution, Somme somme, UniteTraitement ut)
  {
    if ((somme.getMontant().getType().equals("FORMATION EFFECTIVE")) || (somme.getMontant().getType().equals("FORMATION PREVISIONNELLE"))) {
      ajouterGroupeMontantAREF(pbjcNcp, attribution.getProduit().getNom(), somme, ut);
    } else {
      pbjcNcp.ajouterGroupeMontants(attribution.getProduit().getNom(), 0, new BigDecimal("0"), somme.getMontant().getMontantBrut().getValeur(), new BigDecimal("1"), somme.getMontant().getMontantBrut().getValeur(), "");
    }
    if (pbjcNcp.isTopApplicationCRC()) {
      ajouterGroupeMontantPCRC(pbjcNcp, somme.getMontant());
    }
    if (somme.getMontant().getMontantFinancement() != null) {
      ajouterGroupeMontantFinancement(pbjcNcp, attribution, somme);
    }
  }
  
  public ChronologiePeriodes creerChronologiePBJCsAvant(AttributionSpec attribution, Damj dateGeneration, Damj dateBlocageActualisation, String libelleBlocageActualisation)
    throws ApplicativeException
  {
    if (estContextePap(attribution)) {
      return super.creerChronologiePBJCsAvant(attribution, dateGeneration, dateBlocageActualisation, libelleBlocageActualisation);
    }
    return new ChronologiePeriodes();
  }
  
  public void positionnerJustificationFermetureDJI(PbjcNcp pbjcNcp, AttributionSpec attribution, UniteTraitement ut)
  {
    if (ut.getArretProduitAvecRaison().isRaisonsContientRaison(1))
    {
      pbjcNcp.ajouterComplementDeJustification("NF");
    }
    else
    {
      Iterator itID = ut.getArretProduitAvecRaison().getPeriodesInterruptivesDefinitives().iterator();
      while (itID.hasNext())
      {
        ObjetChronoPeriode periode = (ObjetChronoPeriode)itID.next();
        if ((periode instanceof ObjetChronoPeriodeLimiteIndemnisationASP)) {
          pbjcNcp.ajouterComplementDeJustification("NF");
        }
      }
    }
    super.positionnerJustificationFermetureDJI(pbjcNcp, attribution, ut);
  }
  
  public void traiterBlocageActuPourLAvant(PbjcNcp pbjcNcpAvant, Damj dateBlocageActualisation, String libelleBlocageActualisation) {}
  
  public Quantite retournerQuantiteIndemnisationInitialeDroit(AttributionSpec attribution, UniteTraitement ut)
  {
    Periode periodeIndemnisation = null;
    try
    {
      periodeIndemnisation = new Periode(attribution.getDateAttribution(), ((AttributionAssuranceSpec)attribution).getDateLimiteIndemnisation());
    }
    catch (CoucheLogiqueException ex) {}
    int cumulJourImputeAttributionCourante = periodeIndemnisation.getDuree();
    int cumulJourImputeAttributionPrecedente = 0;
    if (((attribution instanceof RepriseSpec)) && 
      (((Reprise)attribution).getAttributionPrecedente().getCalendrierExecutionCalcul() != null) && (((Reprise)attribution).getAttributionPrecedente().getCalendrierExecutionCalcul().getEtatAuDJI() != null)) {
      cumulJourImputeAttributionPrecedente = ((Reprise)attribution).getAttributionPrecedente().getCalendrierExecutionCalcul().getEtatAuDJI().getCumulJoursIndemnise();
    }
    return new QuantiteJour(new BigDecimal(cumulJourImputeAttributionCourante + cumulJourImputeAttributionPrecedente));
  }
  
  public void traiterPBJCsAPosteriori(ChronologiePeriodes chronoPBJCs, AttributionSpec attribution, Chronologie chronoUT)
    throws CoucheLogiqueException
  {
    PbjcNcp pbjcNcp = null;
    PbjcNcp pbjcNcpAvant = null;
    DossierExamen dossierExamen = null;
    Damj dateMaintien = null;
    boolean pbjcTrouvee = false;
    
    ChronologiePeriodes chronologiePeriodesRadiationPEC = OutillagePeriodes.recupererPecsRadiationSuiteEntreeFormation(attribution.getDemandeur());
    
    Chronologie demandes = attribution.getDemandeur().getChronoDemandeMaintien();
    demandes.iterer();
    while (demandes.encoreSuivant())
    {
      DemandeSpec demandeMaintien = (DemandeSpec)demandes.elementSuivant();
      if (((demandeMaintien instanceof DemandeMaintien)) && (!demandeMaintien.estEnReExamen()) && ((demandeMaintien.getClassementAdministratif() == null) || (((demandeMaintien.getClassementAdministratif() instanceof Prescription)) && (!((Prescription)demandeMaintien.getClassementAdministratif()).isValidite()))))
      {
        dossierExamen = ((DemandeMaintien)demandeMaintien).getDossierExamen();
        if ((dossierExamen != null) && ((dossierExamen instanceof Accord))) {
          dateMaintien = demandeMaintien.getDateEffet();
        }
      }
    }
    chronoPBJCs.iterer();
    while (chronoPBJCs.encoreSuivant())
    {
      pbjcNcp = (PbjcNcp)chronoPBJCs.elementSuivant();
      if ((estContextePap(attribution)) && ((pbjcNcp.getEtatReglementaireOd().compareTo("3") == 0) || (pbjcNcp.getEtatReglementaireOd().compareTo("9") == 0))) {
        positionnerCategorieAttribution(pbjcNcp, attribution, null);
      }
      if ((dateMaintien != null) && (((AttributionAssuranceSpec)attribution).estMaintenue()))
      {
        if (pbjcNcp.getDateDebut().estApresOuCoincideAvec(dateMaintien))
        {
          if (pbjcNcp.getDateDebut().coincideAvec(dateMaintien)) {
            pbjcNcp.ajouterComplementDeJustification("B1");
          }
          pbjcTrouvee = true;
        }
        if (pbjcTrouvee) {
          pbjcNcp.setEtatReglementaireOd("5");
        }
      }
      chronologiePeriodesRadiationPEC.iterer();
      while (chronologiePeriodesRadiationPEC.encoreSuivant())
      {
        ObjetChronoPeriodeRadiation periodeRadiation = (ObjetChronoPeriodeRadiation)chronologiePeriodesRadiationPEC.elementSuivant();
        if (periodeRadiation.getDateDebut().veille().coincideAvec(pbjcNcp.getDateFin()))
        {
          pbjcNcp.ajouterComplementDeJustification("TD");
          
          pbjcNcp.setCodeRadiationLendemainPeriode("31");
        }
      }
      if (pbjcNcpAvant != null)
      {
        if (pbjcNcpAvant.getDateFin().coincideAvec(pbjcNcp.getDateDebut().veille()))
        {
          if (pbjcNcp.contientComplementDeJustification("FR")) {
            pbjcNcpAvant.ajouterComplementDeJustification("QF");
          }
          if ((pbjcNcp.getInterrupIndemParPensionInvalidite() != null) && (pbjcNcpAvant.getInterrupIndemParPensionInvalidite() != null))
          {
            if ((pbjcNcp.getInterrupIndemParPensionInvalidite().equals("O")) && 
              (pbjcNcpAvant.getInterrupIndemParPensionInvalidite().equals("N"))) {
              pbjcNcp.ajouterComplementDeJustification("FN");
            }
            if ((pbjcNcp.getInterrupIndemParPensionInvalidite().equals("N")) && 
              (pbjcNcpAvant.getInterrupIndemParPensionInvalidite().equals("O"))) {
              pbjcNcp.ajouterComplementDeJustification("FO");
            }
          }
        }
        if ((pbjcNcpAvant.getMontantCumuleRevaloriseAV() != null) && (pbjcNcpAvant.getMontantCumuleRevaloriseAV().compareTo(new BigDecimal("0")) > 0) && 
          (pbjcNcp.getMontantCumuleRevaloriseAV() != null) && (pbjcNcp.getMontantCumuleRevaloriseAV().compareTo(new BigDecimal("0")) > 0) && 
          (pbjcNcp.getMontantCumuleRevaloriseAV().compareTo(pbjcNcpAvant.getMontantCumuleRevaloriseAV()) != 0) && (!pbjcNcp.contientComplementDeJustification("DG"))) {
          pbjcNcp.ajouterComplementDeJustification("DH");
        }
      }
      if ((pbjcNcp.contientComplementDeJustification("FR")) && (pbjcNcp.getInterrupIndemParPensionInvalidite() != null) && (pbjcNcp.getInterrupIndemParPensionInvalidite().equals("O"))) {
        pbjcNcp.ajouterComplementDeJustification("FN");
      }
      if (((retournerQuantiteIndemnisationInitialeDroit(attribution, null).getValeurEntiere() == pbjcNcp.getReliquatDureeMax()) || (new Periode(attribution.getDateAttribution(), ((AttributionAssuranceSpec)attribution).getDateLimiteIndemnisation()).getDuree() == pbjcNcp.getReliquatDureeMax())) && (pbjcNcp.getNbJoursImputes() != 0)) {
        positionnerJustificationOuverturePJI(pbjcNcp, attribution);
      }
      if (pbjcNcpAvant != null)
      {
        if ((!pbjcNcpAvant.getNaturePBJC().equals("TO")) && (pbjcNcp.getNaturePBJC().equals("TO"))) {
          pbjcNcp.ajouterComplementDeJustification("HB");
        }
      }
      else if (pbjcNcp.getNaturePBJC().equals("TO")) {
        pbjcNcp.ajouterComplementDeJustification("HB");
      }
      if (pbjcNcpAvant != null) {
        pbjcNcp.setNbJoursAREF(pbjcNcpAvant.getNbJoursAREF());
      }
      if ((pbjcNcp.estEnAref()) && (pbjcNcp.getEtatIndemnisation().compareTo("AVANT") != 0)) {
        pbjcNcp.setNbJoursAREF(pbjcNcp.getNbJoursAREF() + pbjcNcp.getNbJoursImputes());
      }
      pbjcNcpAvant = pbjcNcp;
    }
  }
  
  public ChronologiePeriodes traitementPeriodesSuspensives(ChronologiePeriodes periodesSuspensives, UniteTraitement ut)
  {
    return periodesSuspensives;
  }
  
  public void positionnerJustificationOuverturePJI(PbjcNcp pbjcNcp, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    pbjcNcp.ajouterComplementDeJustification("BB");
    
    AttributionAssuranceSpec assurancePrecedente = ((AttributionAssuranceSpec)attribution).getAttributionPrecedente();
    if ((assurancePrecedente != null) && (OutilDemande.estUneDemandeFinDroit(assurancePrecedente.getDemande()))) {
      pbjcNcp.ajouterComplementDeJustification("BV");
    }
    if (OutilsTrancheCalcul.estTrancheActive(attribution)) {
      super.positionnerJustificationOuverturePJITrancheExecutable(pbjcNcp, attribution);
    } else {
      super.positionnerJustificationOuverturePJI(pbjcNcp, attribution);
    }
  }
  
  private void ajouterGroupeMontantFinancement(PbjcNcp pbjcNcp, AttributionSpec attribution, Somme somme)
  {
    pbjcNcp.ajouterGroupeMontants(ProduitAsuCva10P02.getInstance().recupererProduitAreActif(attribution).getNom(), 0, new BigDecimal("0"), somme.getMontant().getMontantFinancement(), new BigDecimal("1"), somme.getMontant().getMontantFinancement(), "");
  }
  
  public void positionnerComplementJustification(PbjcNcp pbjcNcp, UniteTraitement ut, AttributionSpec attribution)
  {
    ChronologiePeriodes periodes = null;
    ObjetChronoPeriode objetChronoPeriode = null;
    
    periodes = ut.getQualificationPeriodes().getPeriodesSegmentantes();
    periodes.iterer();
    while (periodes.encoreSuivant())
    {
      objetChronoPeriode = (ObjetChronoPeriode)periodes.elementSuivant();
      if ((objetChronoPeriode.getDateDebut().coincideAvec(pbjcNcp.getDateDebut())) && 
        ((objetChronoPeriode instanceof PeriodeSousPensionInvaliditeChaineeSpec))) {
        pbjcNcp.ajouterComplementDeJustification("FR");
      }
    }
    super.positionnerComplementJustification(pbjcNcp, ut, attribution);
  }
  
  public void qualifierPbjcSuspensive(PbjcNcp pbjcNcp, ObjetChronoPeriode periode)
  {
    if (((periode instanceof PeriodeTravailJustifiee)) || ((periode instanceof PeriodeActiviteSalarie)) || ((periode instanceof PeriodeClca)) || ((periode instanceof DsmTravail)) || ((periode instanceof PeriodePrime))) {
      if (periode.getDateDebut().coincideAvec(pbjcNcp.getDateDebut()))
      {
        pbjcNcp.setNaturePBJC("TO");
        pbjcNcp.setQualificationPeriode(1);
      }
    }
    super.qualifierPbjcSuspensive(pbjcNcp, periode);
  }
  
  public void positionnerCategorieAttribution(PbjcNcp pbjcNcp, AttributionSpec pattribution, UniteTraitement ut)
  {
    AttributionAssuranceSpec attribution = (AttributionAssuranceSpec)pattribution;
    pbjcNcp.setCategorie(attribution.determinerCodeSousProduitPourSigma());
  }
  
  public void positionnerInfoConventionGestion(PbjcNcp pbjcNcp, AttributionSpec attribution)
  {
    super.positionnerInfoConventionGestion(pbjcNcp, attribution);
    if (estContextePapParlementaire(attribution)) {
      pbjcNcp.ajouterTypeSousTypePopulation("PP", "");
    } else if (!estContextePap(attribution)) {
      pbjcNcp.ajouterTypeSousTypePopulation("CS", "");
    }
  }
  
  public String retournerReglementApplicable(AttributionSpec attribution)
  {
    FormuleMontantRegimeGeneralASPDC formuleMontantAsp = (FormuleMontantRegimeGeneralASPDC)attribution.getFormuleMontant("1");
    int formuleMontantApplicable = formuleMontantAsp.getFormuleMontantApplicable();
    AttributionAssuranceSpec attributionAssociee = ((Attribution)attribution).getAttributionAssociee();
    if ((attributionAssociee != null) && (formuleMontantApplicable == 2) && 
      ((attributionAssociee instanceof Attribution))) {
      return ((Attribution)attributionAssociee).getNomReglementApplicable();
    }
    return ((Attribution)attribution).getNomReglementApplicable();
  }
  
  public void positionnerMontantSalaireRevalorisePlafonne(PbjcNcp pbjcNcp, AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, MontantBaseSpec montant)
    throws CoucheLogiqueException
  {
    FormuleMontantRegimeGeneralASPDC formuleMontantAsp = (FormuleMontantRegimeGeneralASPDC)attribution.getFormuleMontant("1");
    if (formuleMontantAsp.getFormuleMontantApplicable() == 2)
    {
      ElementBaseIndemnisationSpec ebiAssocie = ((ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant()).getElementBaseIndemnisationDroitAssocie();
      
      BigDecimal sjr = ((ElementBaseIndemnisation)ebiAssocie).getSjr().getSalaire();
      if (((ElementBaseIndemnisation)ebiAssocie).getCoefficientSaisonnier() != null) {
        sjr = sjr.multiply(((ElementBaseIndemnisation)ebiAssocie).getCoefficientSaisonnier());
      }
      pbjcNcp.setMontantSalaireRevalorisePlafonne(sjr.setScale(2, 3));
    }
    else
    {
      super.positionnerMontantSalaireRevalorisePlafonne(pbjcNcp, attribution, constituantsIndemnisation, montant);
    }
  }
  
  private boolean estContextePap(AttributionSpec attribution)
  {
    boolean contextePap = false;
    if (OutilsTrancheCalcul.estTrancheActive(attribution))
    {
      TrancheExecutable tranche = OutilsTrancheCalcul.recupererTrancheInitiale(attribution);
      contextePap = tranche.isContextePAPPresent();
    }
    else
    {
      ElementBaseIndemnisation ebi = ((AttributionAssuranceSpec)attribution).getElementBaseIndemnisation();
      contextePap = ebi.isContextePAPPresent();
    }
    return contextePap;
  }
  
  private boolean estContextePapParlementaire(AttributionSpec attribution)
  {
    boolean contextePapParlementaire = false;
    if (OutilsTrancheCalcul.estTrancheActive(attribution))
    {
      TrancheExecutable tranche = OutilsTrancheCalcul.recupererTrancheInitiale(attribution);
      contextePapParlementaire = tranche.estContextePapParlementaire();
    }
    else
    {
      ElementBaseIndemnisation ebi = ((AttributionAssuranceSpec)attribution).getElementBaseIndemnisation();
      contextePapParlementaire = ebi.isContextePapParlementaire();
    }
    return contextePapParlementaire;
  }
}

/* Location:
 * Qualified Name:     FacadePBJCLigneCVA10Impl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */