package fr.unedic.cali.asu.cva10.p01.calcul;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.calcul.FacadeCalculGammeImpl;
import fr.unedic.cali.asu.calcul.dom.ConstituantsCalculActiviteReduiteAsu;
import fr.unedic.cali.asu.calcul.dom.ConstituantsCalculActiviteReduiteGamme;
import fr.unedic.cali.asu.calcul.dom.EtatAuDjiGamme;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeAssDemandeExpresse;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.DefinitionStatutUtTraitementActiviteReduite;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.RecuperationPensionInvaliditeAvantDate;
import fr.unedic.cali.asu.cge01.outilsfonctionnels.RevalorisationSalaire;
import fr.unedic.cali.asu.cva10.p01.calcul.dom.DureeIndemnisation;
import fr.unedic.cali.asu.cva10.p01.calcul.dom.FormuleMontantASRDCF;
import fr.unedic.cali.asu.cva10.p01.calcul.dom.FormuleMontantRegimeGeneralASRDC;
import fr.unedic.cali.asu.cva10.p01.calcul.outilsfonctionnels.MajCi;
import fr.unedic.cali.asu.cva10.p01.calcul.outilsfonctionnels.PostTraitements;
import fr.unedic.cali.asu.cva10.p01.calcul.outilsfonctionnels.Qualification;
import fr.unedic.cali.asu.cva10.p01.calcul.outilsfonctionnels.TraitementActiviteReduite;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisationAREF;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.dom.SalaireReference;
import fr.unedic.cali.asu.dom.Sjc;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.outilsfonctionnels.RechercheDecisionsInterruptives;
import fr.unedic.cali.asu.parametres.EvenementParametre;
import fr.unedic.cali.asu.parametres.ParametresIndemnisation;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.autresdoms.cohab.dom.ObjetChronoPeriodePriseEnCharge;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.calcul.OutillageCalculADate;
import fr.unedic.cali.calcul.OutillagePeriodes;
import fr.unedic.cali.calcul.OutillageQuantites;
import fr.unedic.cali.calcul.RecuperationDonneesSecteurPublic;
import fr.unedic.cali.calcul.TraitementPeriodes;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculPeriodique;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculSpec;
import fr.unedic.cali.calcul.dom.ConstituantsCalculActiviteReduiteSpec;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.calcul.dom.EtatAuDji;
import fr.unedic.cali.calcul.dom.EvenementChangementParametre;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.periode.ActionFormation;
import fr.unedic.cali.calcul.dom.periode.FinActionFormation;
import fr.unedic.cali.calcul.dom.periode.FinPeriodePensionInvalidite;
import fr.unedic.cali.calcul.dom.periode.PeriodeAbsenceAuPointage;
import fr.unedic.cali.calcul.dom.periode.PeriodeActiviteEmploiCalcul;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormationNonIndemniseeAbsenceHeure;
import fr.unedic.cali.calcul.dom.periode.PeriodeInterStageFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodePensionInvalidite;
import fr.unedic.cali.calcul.dom.periode.PeriodeSuspensionDDTEAvecImputation;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeInterProduits;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeLimiteIndemnisationASR;
import fr.unedic.cali.calcul.outilsfonctionnels.DecoupageProratisation;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionForcage;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionSuivi;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ContexteUT;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ContexteUT.ElementContexteUT;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ElementBaseIndemnisationFacade;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodeAnalyseSpec;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodesPriseEnCompte;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.ElementBaseIndemnisationSpec;
import fr.unedic.cali.dom.FormuleMontantAREFSpec;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.cali.dom.OdSpec;
import fr.unedic.cali.dom.QuantiteDroit;
import fr.unedic.cali.dom.QuantiteDroitSpec;
import fr.unedic.cali.dom.QuantiteIndemnisationSpec;
import fr.unedic.cali.dom.RepriseSpec;
import fr.unedic.cali.dom.affectation.GammeSpec;
import fr.unedic.cali.dom.affectation.ProduitSolSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.outilsfonctionnels.Anomalie;
import fr.unedic.cali.outilsfonctionnels.GestionAnomalies;
import fr.unedic.cali.parcours.ResultatCalcul;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.Unite;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

public class FacadeCalculProduitImpl
  extends FacadeCalculGammeImpl
{
  private static final DureeCalendaire DUREE_6_MOIS = new DureeCalendaire(0, 6, 1);
  private static final int AGE_50_ANS = 50;
  
  public void controlerAttribution(AttributionSpec p_attribution)
    throws ContexteException
  {}
  
  public ConstituantsCalculActiviteReduiteSpec creationConstituantsCalculActiviteReduite(AttributionSpec p_attribution, ContexteUT p_contexteUT, ConstituantsIndemnisation p_constituantsIndemnisation)
    throws CoucheLogiqueException
  {
    return new ConstituantsCalculActiviteReduiteAsu(0, ((Attribution)p_attribution).getElementBaseIndemnisation().getSjr(), ((Attribution)p_attribution).getSJC());
  }
  
  public fr.unedic.cali.calcul.dom.UniteTraitement creerUT(Periode p_periodeUT, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return new fr.unedic.cali.asu.calcul.dom.UniteTraitement(Unite.get("jour"), p_periodeUT);
  }
  
  public ChronologiePeriodes decoupageEtProratisationPeriodesActivites(PeriodesPriseEnCompte p_periodesPriseEnCompte, int p_typePeriodeDeReference, ChronologiePeriodes p_chronologieDePeriodesAProratiser, Periode p_periodeUT)
    throws CoucheLogiqueException
  {
    Periode periodeDeReference = null;
    Iterator iterator = null;
    ChronologiePeriodes chronologie = null;
    ObjetChronoPeriode objetChronoPeriode = null;
    iterator = p_periodesPriseEnCompte.getPeriodesParTypologie(p_typePeriodeDeReference).iterer();
    chronologie = new ChronologiePeriodes();
    while (iterator.hasNext())
    {
      objetChronoPeriode = (ObjetChronoPeriode)iterator.next();
      periodeDeReference = new Periode(objetChronoPeriode.getDateDebut(), objetChronoPeriode.getDateFin());
      chronologie.ajouter(DecoupageProratisation.decoupageEtProratisationPeriodesActivites(periodeDeReference, p_chronologieDePeriodesAProratiser));
    }
    return chronologie;
  }
  
  public void determinerStatutUT(AttributionSpec p_attribution, ChronologiePeriodes p_periodesDecalantes, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ArretProduitAvecRaison p_arretProduitAvecRaison, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    boolean absenceAuPointage = false;
    if (p_ut.getQualificationPeriodes().getPeriodesGelantes() != null)
    {
      ChronologiePeriodes periodesGelantes = p_ut.getQualificationPeriodes().getPeriodesGelantes();
      periodesGelantes.iterer();
      while (periodesGelantes.encoreSuivant()) {
        if ((periodesGelantes.elementSuivant() instanceof PeriodeAbsenceAuPointage))
        {
          p_ut.setStatut(6);
          absenceAuPointage = true;
        }
      }
    }
    if (!absenceAuPointage) {
      if (!GestionForcage.appliquerForcageStatut(p_attribution.getDemande(), p_ut)) {
        p_ut.setStatut(DefinitionStatutUtTraitementActiviteReduite.definirStatutUt(p_attribution, p_periodesDecalantes, ((ConstituantsCalculActiviteReduiteGamme)p_constituantsCalculActiviteReduite).getNbMoisEnPPA(), estEnFormation(p_ut), p_ut, p_arretProduitAvecRaison, this));
      }
    }
  }
  
  public boolean epuisementQuantiteDroit(Damj p_dateEpuisementQuantite, AttributionSpec p_attribution, QuantiteDroitSpec p_quantiteDroitEpuisee, ConstituantsIndemnisation p_constituantsIndemnisation, fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
    throws ApplicativeException
  {
    return true;
  }
  
  public Damj getDateFinQuantiteDroit(Periode p_periode, AttributionSpec p_attribution, QuantiteDroitSpec p_quantiteDroit, ChronologiePeriodes p_chronologieRemplissage, Quantite p_quantiteAImputer, Damj p_dateDebutQuantiteDroit)
  {
    return OutillageCalculADate.remplirTrousChronologieParIndemnisation(p_chronologieRemplissage, p_quantiteAImputer, p_periode);
  }
  
  public Collection getEvtsChangementParametre(ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_date)
  {
    List evtsRetour = new ArrayList();
    EvenementParametre evtParam = ParametresIndemnisation.getParametresIndemnisation().getElementActif(p_date);
    Sjr sjr = ((ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant()).getSjr();
    if ((evtParam.isNouveauRevalorisationSjr()) && 
      (!sjr.getDateDepart().deplacerVersAvant(DUREE_6_MOIS).estApres(p_date)))
    {
      EvenementChangementParametre evt = new EvenementChangementParametre("REVALORISATION", evtParam.getDateEvenement());
      
      evtsRetour.add(evt);
    }
    return evtsRetour;
  }
  
  public Quantite getQuantiteIndemnisableTheorique(Periode p_periode, AttributionSpec p_attribution, ConstituantsIndemnisation p_constituantsIndemnisation, ContexteUT p_contexteUt)
  {
    return new QuantiteJour(new BigDecimal(p_periode.getDuree()));
  }
  
  public void imputerAvant(ObjetChronoPeriode p_periode, ConstituantsIndemnisation p_constituantsIndemnisation, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {}
  
  public void imputerQuantiteIndemnisationDuAuxSanctions(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, PeriodeSuspensionDDTEAvecImputation p_periodeSuspensionDDTEAvecImputation, ConstituantsIndemnisation p_constituantsIndemnisation, ArretProduitAvecRaison p_arretProduitAvecRaison)
    throws CoucheLogiqueException
  {}
  
  public void initialisationQuantitesIndemnisation(ConstituantsIndemnisation p_constituantsIndemnisation, AttributionSpec p_attribution, Periode p_periodeUT)
    throws ApplicativeException
  {
    Collection collectionDurees = p_constituantsIndemnisation.getCollectionQuantiteDroit();
    if (collectionDurees != null)
    {
      Iterator iterator = collectionDurees.iterator();
      while (iterator.hasNext())
      {
        QuantiteDroitSpec duree = (QuantiteDroitSpec)iterator.next();
        if ((duree instanceof DureeIndemnisation))
        {
          duree.activer();
          initialiseElementBaseIndemnisationCourante(p_constituantsIndemnisation, p_attribution, p_periodeUT);
        }
      }
    }
  }
  
  public void initialiseElementBaseIndemnisationCourante(ConstituantsIndemnisation p_constituantsIndemnisation, AttributionSpec p_attribution, Periode p_periodeUT)
    throws CoucheLogiqueException
  {
    if (p_constituantsIndemnisation.getElementBaseIndemnisationCourant() == null)
    {
      Attribution attribution = (Attribution)p_attribution;
      ElementBaseIndemnisation elementBaseIndemnisationCourant = new ElementBaseIndemnisation();
      ElementBaseIndemnisation ebiAttrib = attribution.getElementBaseIndemnisation();
      
      Reglement reglementApplicable = ebiAttrib.getReglementApplicable();
      if (reglementApplicable != null) {
        elementBaseIndemnisationCourant.setReglementApplicable(reglementApplicable);
      }
      Quantite affiliationRequisePourPRA = ebiAttrib.getAffiliationRequisePourPRA();
      if (affiliationRequisePourPRA != null) {
        elementBaseIndemnisationCourant.setAffiliationRequisePourPRA(affiliationRequisePourPRA);
      }
      SalaireReference salaireReference = ebiAttrib.getSalaireReference();
      if (salaireReference != null) {
        elementBaseIndemnisationCourant.setSalaireReference(salaireReference);
      }
      BigDecimal nombreHeureTravaillesEtendu = ebiAttrib.getNombreHeureTravaillesEtendu();
      if (nombreHeureTravaillesEtendu != null) {
        elementBaseIndemnisationCourant.setNombreHeureTravaillesEtendu(nombreHeureTravaillesEtendu);
      }
      BigDecimal nombreHeuresTravailleesPlafonnees = ebiAttrib.getNombreHeuresTravailleesPlafonnees();
      if (nombreHeuresTravailleesPlafonnees != null) {
        elementBaseIndemnisationCourant.setNombreHeuresTravailleesPlafonnees(nombreHeuresTravailleesPlafonnees);
      }
      Periode prc = ebiAttrib.getPrc();
      if (prc != null) {
        elementBaseIndemnisationCourant.setPrc(prc);
      }
      elementBaseIndemnisationCourant.setNbJoursEmploiSurPrc(ebiAttrib.getNbJoursEmploiSurPrc());
      elementBaseIndemnisationCourant.setCoefficientHoraireJour(ebiAttrib.getCoefficientHoraireJour());
      if (ebiAttrib.getCoefficientSaisonnier() != null) {
        elementBaseIndemnisationCourant.setCoefficientSaisonnier(ebiAttrib.getCoefficientSaisonnier());
      }
      if (ebiAttrib.getCoefficientTempsPartiel() != null) {
        elementBaseIndemnisationCourant.setCoefficientTempsPartiel(ebiAttrib.getCoefficientTempsPartiel());
      }
      elementBaseIndemnisationCourant.setSjr(ebiAttrib.getSjr());
      elementBaseIndemnisationCourant.setMontantPensionInvaliditeADeduire(RecuperationPensionInvaliditeAvantDate.recuperationMontantPI(attribution.getDemandeur(), attribution.getPji().veille()));
      
      elementBaseIndemnisationCourant.setTypeCaractereSaisonnierRetenu(ebiAttrib.getTypeCaractereSaisonnierRetenu());
      
      elementBaseIndemnisationCourant.setIsConditionCaractereSaisonnierParRythme(ebiAttrib.isConditionCaractereSaisonnierParRythme());
      
      elementBaseIndemnisationCourant.setSjc(attribution.getSJC());
      
      elementBaseIndemnisationCourant.setMontantPreavis(ebiAttrib.getMontantPreavis());
      
      FormuleMontantSpec formuleMontant = null;
      ElementBaseIndemnisationAREF elementBaseIndemnisationAREF = null;
      
      QuantiteIndemnisationSpec duree = OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(p_constituantsIndemnisation.getCollectionQuantiteDroit());
      if (duree != null) {
        formuleMontant = p_attribution.getFormuleMontant(duree.getCodeFormuleMontant());
      } else {
        formuleMontant = p_attribution.getFormuleMontant(p_constituantsIndemnisation.getCodeFormuleMontant());
      }
      p_constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationCourant);
      if ((formuleMontant instanceof FormuleMontantAREFSpec))
      {
        elementBaseIndemnisationAREF = new ElementBaseIndemnisationAREF(elementBaseIndemnisationCourant);
        p_constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationAREF);
      }
    }
  }
  
  public int initialiserCompteurFormation(AttributionSpec p_attribution)
  {
    return 0;
  }
  
  public ElementBaseIndemnisationFacade mapperUTVersElementBaseIndemnisation(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, AttributionSpec p_attribution)
  {
    ElementBaseIndemnisationFacade elt = new ElementBaseIndemnisationFacade();
    ElementBaseIndemnisation eltBase = null;
    eltBase = (ElementBaseIndemnisation)p_ut.getConstituantsIndemnisationEnFinUT().getElementBaseIndemnisationCourant();
    if (eltBase.getCoefficientSaisonnier() != null) {
      elt.setCoefficientSaisonnier(eltBase.getCoefficientSaisonnier().toString());
    }
    if (eltBase.getCoefficientTempsPartiel() != null) {
      elt.setCoefficientTempsPartiel(eltBase.getCoefficientTempsPartiel().toString());
    }
    if (eltBase.getMontantPensionInvaliditeADeduire() != null) {
      elt.setMontantPensionInvaliditeADeduire(eltBase.getMontantPensionInvaliditeADeduire().toString());
    }
    if ((eltBase.getSjc() != null) && (eltBase.getSjc().getSalaire() != null)) {
      elt.setSjc(eltBase.getSjc().getSalaire().toString());
    }
    if ((eltBase.getSjr() != null) && (eltBase.getSjr().getSalaire() != null)) {
      elt.setSjr(eltBase.getSjr().getSalaire().toString());
    }
    return elt;
  }
  
  public ConstituantsIndemnisation miseAJourConstituantsIndemnisation(fr.unedic.cali.calcul.dom.UniteTraitement ut, AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, Damj dateDeMiseAjour, Periode periode)
    throws CoucheLogiqueException
  {
    return MajCi.miseAJourConstituantsIndemnisation(attribution, constituantsIndemnisation, dateDeMiseAjour);
  }
  
  public void miseAJourConstituantsIndemnisationADate(AttributionSpec p_attribution, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_date, ChronologiePeriodes p_chronologiePeriodesSanctions)
    throws CoucheLogiqueException
  {
    ElementBaseIndemnisation elementBaseIndemnisationCourant = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
    
    elementBaseIndemnisationCourant.setMontantPensionInvaliditeADeduire(RecuperationPensionInvaliditeAvantDate.recuperationMontantPI(p_attribution.getDemandeur(), p_date.veille()));
  }
  
  public ConstituantsCalculActiviteReduiteSpec miseAJourCumulAR(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, AttributionSpec p_attribution, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, ContexteUT p_contexteUT, ArretProduitAvecRaison p_arretProduitAvecRaison)
    throws CoucheLogiqueException
  {
    ConstituantsCalculActiviteReduiteAsu constituantsCalculActiviteReduite = (ConstituantsCalculActiviteReduiteAsu)p_constituantsCalculActiviteReduite;
    
    int cumulActiviteReduite = constituantsCalculActiviteReduite.getCumul();
    boolean individuPossedeCesSurUt = false;
    boolean individuPossedeCaeSurUt = false;
    boolean individuPossedeCaeCuiSurUt = false;
    
    Reglement reglementOdCourante = ((Attribution)p_attribution).getReglementApplicable().getReglement();
    if (!reglementOdCourante.equals(p_attribution.getProduit().getReglement("A4")))
    {
      Iterator iterateurPeriode = p_ut.getQualificationPeriodes().getPeriodesDecalantes().iterer();
      while (iterateurPeriode.hasNext())
      {
        ObjetChronoPeriode periodeActivite = (ObjetChronoPeriode)iterateurPeriode.next();
        if ((periodeActivite instanceof PeriodeActiviteEmploiCalcul)) {
          if (1 != ((PeriodeActiviteEmploiCalcul)periodeActivite).getTypeActivite())
          {
            if (7 == ((PeriodeActiviteEmploiCalcul)periodeActivite).getTypeContratParticulier()) {
              individuPossedeCesSurUt = true;
            }
            if (14 == ((PeriodeActiviteEmploiCalcul)periodeActivite).getTypeContratParticulier()) {
              individuPossedeCaeSurUt = true;
            }
            if (23 == ((PeriodeActiviteEmploiCalcul)periodeActivite).getTypeContratParticulier()) {
              individuPossedeCaeCuiSurUt = true;
            }
          }
        }
      }
      if ((!individuPossedeCesSurUt) && (!individuPossedeCaeSurUt) && (!individuPossedeCaeCuiSurUt) && (!p_ut.isNeutralisee()) && (p_ut.getCreditDecalage() != null) && (p_ut.getCreditDecalage().getValeur() != null) && (p_ut.getCreditDecalage().getValeur().intValue() >= 0) && (p_ut.getQuantiteIndemnisee() != null) && (p_ut.getQuantiteIndemnisee().getValeur() != null) && (p_ut.getQuantiteIndemnisee().getValeur().intValue() >= 1))
      {
        cumulActiviteReduite++;
        constituantsCalculActiviteReduite.setCumul(cumulActiviteReduite);
        if ((cumulActiviteReduite == 13) && (p_attribution.getDemandeur().getAgeALaDate(p_ut.getDateDebut()).getAnnees() < 50)) {
          GestionSuivi.enregistrerEnquetePbjcNcp(p_attribution, p_ut.getDateFin(), 11, 0, true, null, this, p_ut.getConstituantsIndemnisationEnFinUT());
        }
      }
    }
    return constituantsCalculActiviteReduite;
  }
  
  public ConstituantsCalculActiviteReduiteSpec miseAjourConstituantsCalculActiviteReduite(AttributionSpec p_attribution, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, Damj p_dateDeMiseAjour, ConstituantsIndemnisation p_constituantIndemnisation)
    throws CoucheLogiqueException
  {
    Attribution attribution = (Attribution)p_attribution;
    ConstituantsCalculActiviteReduiteAsu constituantsCalculActiviteReduiteProduit = (ConstituantsCalculActiviteReduiteAsu)p_constituantsCalculActiviteReduite;
    
    constituantsCalculActiviteReduiteProduit.setSjr(RevalorisationSalaire.revaloriserSjr(attribution, p_dateDeMiseAjour));
    
    constituantsCalculActiviteReduiteProduit.setSjc(RevalorisationSalaire.revaloriserSjc(attribution.getSJC(), p_dateDeMiseAjour));
    return p_constituantsCalculActiviteReduite;
  }
  
  public QualificationPeriodes qualificationPeriodes(ChronologiePeriodes p_chronologiePeriodes, AttributionSpec p_attribution, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    return new Qualification().qualificationPeriodes(p_chronologiePeriodes, p_attribution);
  }
  
  public void realiserDetectionFinDeProduitPourSuivi(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    ArretProduitAvecRaison arretProduitAvecRaison = null;
    boolean estFinASR = false;
    arretProduitAvecRaison = p_ut.getArretProduitAvecRaison();
    if ((arretProduitAvecRaison.isRaisonsContientRaison(1)) || (arretProduitAvecRaison.isRaisonsContientRaison(4))) {
      GestionSuivi.enregistrerEnquetePbjcNcp(p_attribution, arretProduitAvecRaison.recupereLendemainDateArret().veille(), 29, 0, true, null, this, p_ut.getConstituantsIndemnisationEnFinUT());
    }
    Iterator itID = arretProduitAvecRaison.getPeriodesInterruptivesDefinitives().iterator();
    while (itID.hasNext())
    {
      ObjetChronoPeriode periode = (ObjetChronoPeriode)itID.next();
      if ((periode instanceof ObjetChronoPeriodeLimiteIndemnisationASR)) {
        estFinASR = true;
      }
    }
    Iterator ite = ((Attribution)p_attribution).getListeDurees().iterator();
    QuantiteDroit dureeTh = null;
    boolean existeDuTh = false;
    while ((ite.hasNext()) && (!existeDuTh))
    {
      dureeTh = (QuantiteDroit)ite.next();
      if ((dureeTh instanceof DureeIndemnisation)) {
        existeDuTh = true;
      }
    }
    if ((arretProduitAvecRaison.isRaisonsContientRaison(1)) || (estFinASR))
    {
      Iterator it = p_ut.getConstituantsIndemnisationEnFinUT().getCollectionQuantiteDroit().iterator();
      while (it.hasNext())
      {
        QuantiteDroit duree = (QuantiteDroit)it.next();
        if ((duree instanceof DureeIndemnisation))
        {
          if (!existeDuTh) {
            dureeTh = duree;
          }
          if ((duree.getQuantiteCourante() == null) || (dureeTh.getQuantiteInitial().getValeurEntiere() <= duree.getQuantiteInitial().getValeurEntiere())) {
            GestionSuivi.enregistrerEnquetePbjcNcp(p_attribution, arretProduitAvecRaison.recupereLendemainDateArret().veille(), 28, 0, true, null, this, p_ut.getConstituantsIndemnisationEnFinUT());
          } else if (duree.getQuantiteCourante() != null) {
            GestionSuivi.enregistrerEnquetePbjcNcp(p_attribution, arretProduitAvecRaison.recupereLendemainDateArret().veille(), 27, 0, true, null, this, p_ut.getConstituantsIndemnisationEnFinUT());
          }
        }
      }
    }
  }
  
  public AttributionSpec rechercherAttributionPrecedenteSurLUT(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return ((AttributionAssuranceSpec)p_attribution).getAttributionPrecedente();
  }
  
  public ChronologiePeriodes recupererPeriodesLieesAuContexte(ContexteUT p_contexteUT, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes chronologiePeriodes = new ChronologiePeriodes();
    
    Collection collectionPeriode = p_contexteUT.getPeriodesInterProduitsSurUTDateDepartAttributionPourGamme(p_attribution, "ASU");
    List liste = p_contexteUT.getListeAttributions();
    if (liste != null)
    {
      Iterator iterator = liste.iterator();
      while (iterator.hasNext())
      {
        AttributionSpec attribution = (AttributionSpec)iterator.next();
        if (attribution.getGamme().getNomUnique().equals("SOL")) {
          if (((attribution.getProduit().getNomUnique().equals("SOL_AER05_01")) || (attribution.getProduit().getNomUnique().equals("SOL_AER05_02")) || (attribution.getProduit().getNomUnique().equals("SOL_AER05_03"))) && (attribution.getCalendrierExecutionCalcul() != null) && ((attribution.getCalendrierExecutionCalcul().getEtatAttribution() == 1) || (attribution.getCalendrierExecutionCalcul().getEtatAttribution() == 2)))
          {
            Damj djiTheoriqueAER = ((ProduitSolSpec)attribution.getProduit()).getDjiTheoriqueAER(attribution);
            chronologiePeriodes.ajouter(new ObjetChronoPeriodeInterProduits(djiTheoriqueAER.lendemain(), djiTheoriqueAER.lendemain(), 5, attribution));
          }
        }
      }
    }
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "SOL_AER05_01"));
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "SOL_AER05_02"));
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "SOL_AER05_03"));
    
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartAttributionPourProduit(p_attribution, "INR_RCE04_01"));
    
    chronologiePeriodes.ajouter(collectionPeriode);
    
    chronologiePeriodes.ajouter(RechercheDecisionsInterruptives.rechercher(p_attribution.getDemandeur(), p_attribution.getPji(), p_attribution));
    
    RecuperationDonneesSecteurPublic.recupererDemandeClassementSP(chronologiePeriodes, p_attribution);
    
    RecuperationDonneesSecteurPublic.rechercherAdmissionSecteurPublic(chronologiePeriodes, p_attribution);
    
    chronologiePeriodes.ajouter(p_contexteUT.getPeriodesInterProduitsPeriodesLieuSurUTPourGammeRBF(p_attribution));
    
    chronologiePeriodes.ajouter(p_contexteUT.getPeriodesInterProduitsSurUTIndemnisationRfpe(p_attribution));
    
    chronologiePeriodes.ajouter(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "RET_ACO01_01"));
    
    return chronologiePeriodes;
  }
  
  public EtatAuDji renseignerEtatAuDji(fr.unedic.cali.calcul.dom.UniteTraitement p_derniereUT, CalendrierExecutionCalculPeriodique p_calendrier, AttributionSpec p_attribution, EtatAuDji p_etatAuDji)
    throws CoucheLogiqueException
  {
    int reliquatCumulAR = 0;
    EtatAuDjiGamme etatAuDji = new EtatAuDjiGamme();
    Quantite reliquatDureeIndemnisation = null;
    etatAuDji.setMontant(p_etatAuDji.getMontant());
    reliquatCumulAR = ((ConstituantsCalculActiviteReduiteGamme)p_derniereUT.getConstituantsCalculActiviteReduiteEnFinUT()).getCumul();
    etatAuDji.setCumulMoisActiviteReduite(reliquatCumulAR);
    reliquatDureeIndemnisation = recupererReliquatDureeIndemnisation(p_derniereUT);
    if (reliquatDureeIndemnisation != null)
    {
      etatAuDji.setReliquatDureeIndemnisation(new Quantite(reliquatDureeIndemnisation.getValeur().setScale(0), reliquatDureeIndemnisation.getUnite()));
      
      etatAuDji.setReliquatDureeIndemnisationAvecMaintien(etatAuDji.getReliquatDureeIndemnisation());
    }
    if (p_attribution.getDemandeur().getDernierJourAtteste() != null) {
      if (p_calendrier.getDernierJourIndemnisable().estAvant(p_attribution.getDemandeur().getDernierJourAtteste()))
      {
        ObjetChronoPeriodePriseEnCharge pec = OutillagePeriodes.recupererPeriodePECContenant(p_attribution.getDemandeur(), p_attribution.getDateAttribution());
        if (pec != null) {
          if (!pec.getDateFin().coincideAvec(p_calendrier.getDernierJourIndemnisable()))
          {
            Damj dateM07 = Damj.max(p_attribution.getDateAttribution(), p_calendrier.getDernierJourIndemnisable());
            
            GestionAnomalies.ajouteAnomalie(new Anomalie("M07", dateM07, ""), p_attribution.getDemandeur());
          }
        }
      }
    }
    etatAuDji.setCumulJoursIndemnise(p_derniereUT.getCumulJoursIndemnise());
    etatAuDji.setNbJourAREF(p_derniereUT.getNbJoursFormationEnFinDUT());
    etatAuDji.setNbMoisIndemniseAsu(p_derniereUT.getNbMoisIndemniseAsu());
    etatAuDji.setEstNbMoisIndemniseAsu(p_derniereUT.isEstNbMoisIndemniseAsu());
    
    return etatAuDji;
  }
  
  private Quantite recupererReliquatDureeIndemnisation(fr.unedic.cali.calcul.dom.UniteTraitement p_derniereUT)
  {
    Quantite reliquatDureeIndemnisation = null;
    Collection collectionQuantiteDroit = p_derniereUT.getConstituantsIndemnisationEnFinUT().getCollectionQuantiteDroit();
    DureeIndemnisation quantiteIndemnisation = null;
    DureeIndemnisation quantiteIndemnisationEpuise = null;
    if (collectionQuantiteDroit != null)
    {
      Iterator iterator = collectionQuantiteDroit.iterator();
      while (iterator.hasNext())
      {
        QuantiteDroit quantiteDroit = (QuantiteDroit)iterator.next();
        if ((quantiteDroit instanceof DureeIndemnisation))
        {
          quantiteIndemnisation = (DureeIndemnisation)quantiteDroit;
          if (quantiteDroit.getEtat() == 1) {
            break;
          }
          if (quantiteDroit.getEtat() == 2) {
            quantiteIndemnisationEpuise = quantiteIndemnisation;
          }
        }
      }
    }
    if (quantiteIndemnisation != null)
    {
      if (quantiteIndemnisation.getEtat() == 1) {
        reliquatDureeIndemnisation = quantiteIndemnisation.getQuantiteCourante();
      } else if ((quantiteIndemnisation.getEtat() == 2) || (quantiteIndemnisationEpuise != null)) {
        reliquatDureeIndemnisation = new QuantiteJour(BigDecimal.ZERO);
      }
    }
    else {
      reliquatDureeIndemnisation = new QuantiteJour(BigDecimal.ZERO);
    }
    return reliquatDureeIndemnisation;
  }
  
  public void traitementPeriodeSegmentante(AttributionSpec p_attribution, ObjetChronoPeriode p_periode, ConstituantsIndemnisation p_constituantsIndemnisation, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, PeriodeAnalyseSpec p_pa, ArretProduitAvecRaison p_arretProduitAvecRaison, ChronologiePeriodes p_periodesAnalyses)
    throws ApplicativeException
  {
    if ((p_periode instanceof PeriodeFormation))
    {
      if (((PeriodeFormation)p_periode).getActionFormation().estBasculeAutoriserEnContexteFormation()) {
        if (((PeriodeFormation)p_periode).estEffective()) {
          passerEnIndemnisationAvecFormation(p_periode, p_constituantsIndemnisation);
        } else {
          passerEnIndemnisationSansFormation(p_constituantsIndemnisation);
        }
      }
    }
    else if (((p_periode instanceof PeriodeInterStageFormation)) || ((p_periode instanceof FinActionFormation)))
    {
      passerEnIndemnisationSansFormation(p_constituantsIndemnisation);
    }
    else if (((p_periode instanceof PeriodePensionInvalidite)) && (p_periode.getDateDebut().estApresOuCoincideAvec(p_attribution.getPji())))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
      
      elementBaseIndemnisation.setMontantPensionInvaliditeADeduire(elementBaseIndemnisation.getMontantPensionInvaliditeADeduire().add(((PeriodePensionInvalidite)p_periode).getQuantiteEuro().getValeur()));
    }
    else if (((p_periode instanceof FinPeriodePensionInvalidite)) && (((p_pa != null) && (p_pa.getDateDebut().equals(p_periode.getDateDebut()))) || ((p_pa == null) && (p_periode.getDateDebut().estContenueDans(p_ut.getPeriode())))))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
      elementBaseIndemnisation.setMontantPensionInvaliditeADeduire(elementBaseIndemnisation.getMontantPensionInvaliditeADeduire().subtract(((FinPeriodePensionInvalidite)p_periode).getQuantiteEuro().getValeur()));
    }
  }
  
  public void traitementPeriodesAlertantes(AttributionSpec p_attribution, ObjetChronoPeriode p_periode, ConstituantsIndemnisation p_constituantsIndemnisation, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, PeriodeAnalyseSpec p_pa, ArretProduitAvecRaison p_arretProduitAvecRaison)
    throws ApplicativeException
  {}
  
  public void traitementPeriodesDecalantes(AttributionSpec p_attribution, ChronologiePeriodes p_periodes, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduiteSpec, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ConstituantsIndemnisation p_constituantsIndemnisation, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    TraitementActiviteReduite.traitementPeriodesDecalantes(p_attribution, p_periodes, p_constituantsCalculActiviteReduiteSpec, p_ut);
  }
  
  public void traitementPeriodesGelantes(AttributionSpec p_attribution, ChronologiePeriodes p_periodes, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduiteSpec, fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
    throws CoucheLogiqueException
  {
    TraitementActiviteReduite.traitementPeriodesGelantes(p_attribution, p_periodes, p_constituantsCalculActiviteReduiteSpec, p_ut);
  }
  
  public void traitementPeriodesSuspensives(AttributionSpec p_attribution, ChronologiePeriodes p_periodes, PeriodeAnalyseSpec p_pa)
    throws CoucheLogiqueException
  {
    Quantite quantiteSuspensive = TraitementPeriodes.getQuantiteSuspensive(p_pa.getPeriode(), p_pa.getQuantiteIndemnisable(), p_periodes);
    
    p_pa.setQuantiteNonIndemnisee(p_pa.getQuantiteNonIndemnisee().ajouter(quantiteSuspensive));
  }
  
  public void traiterPeriodeInterruptiveDefinitive(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ObjetChronoPeriode p_objetChronoPeriode, ArretProduitAvecRaison p_arretProduitAvecRaison, CalendrierExecutionCalculPeriodique calendrier)
    throws CoucheLogiqueException
  {
    if ((p_objetChronoPeriode instanceof ObjetChronoPeriodeAssDemandeExpresse)) {
      p_arretProduitAvecRaison.setProduitAEteindre(true);
    } else if ((p_objetChronoPeriode instanceof PeriodeFormationNonIndemniseeAbsenceHeure)) {
      GestionAnomalies.ajouteAnomalie(new Anomalie("M06", p_objetChronoPeriode.getDateDebut(), ""), p_attribution.getDemandeur());
    }
  }
  
  public boolean verifierConditionExecutionEtEventuelAbandon(AttributionSpec p_attribution, ContexteUT p_contexteUT, Periode p_periodeUT, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul)
    throws CoucheLogiqueException
  {
    return true;
  }
  
  public boolean verifierImputationDuree(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ConstituantsIndemnisation p_constituantsIndemnisation)
    throws CoucheLogiqueException
  {
    return true;
  }
  
  public MontantBaseSpec calculMontant(FormuleMontantSpec p_formuleMontant, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_dateCalcul)
    throws CoucheLogiqueException
  {
    return p_formuleMontant.calculer(p_constituantsIndemnisation, p_dateCalcul);
  }
  
  public ConstituantsIndemnisation creationConstituantsIndemnisation(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    ConstituantsIndemnisation constituantsIndemnisation = new ConstituantsIndemnisation();
    Collection collectionDureesCalcul = new ArrayList();
    Periode periodeIndemnisation = new Periode(p_attribution.getDateAttribution(), ((Attribution)p_attribution).getDateLimiteIndemnisation());
    DureeIndemnisation dureeIndemnisation = new DureeIndemnisation(periodeIndemnisation.getDuree());
    dureeIndemnisation.setCodeFormuleMontant(FormuleMontantRegimeGeneralASRDC.getCode());
    collectionDureesCalcul.add(dureeIndemnisation);
    constituantsIndemnisation.setCollectionQuantiteDroit(collectionDureesCalcul);
    return constituantsIndemnisation;
  }
  
  public CalendrierExecutionCalculSpec creerCalendrierExecutionCalcul(AttributionSpec p_attribution)
  {
    return new fr.unedic.cali.asu.calcul.dom.CalendrierExecutionCalcul();
  }
  
  public boolean estEnActiviteConservee(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
    throws CoucheLogiqueException
  {
    if (((Attribution)p_attribution).getListeActiviteConservee() != null)
    {
      Iterator ite = ((Attribution)p_attribution).getListeActiviteConservee().iterer();
      boolean aUneActiviteEncoreConserve = false;
      while (ite.hasNext())
      {
        TravailSpec activite = (TravailSpec)ite.next();
        if (activite.getDateFin().estApresOuCoincideAvec(p_ut.getDateDebut())) {
          aUneActiviteEncoreConserve = true;
        }
      }
      return (!((Attribution)p_attribution).getListeActiviteConservee().estVide()) && (aUneActiviteEncoreConserve);
    }
    return false;
  }
  
  public FormuleMontantSpec getFormuleMontant(String p_code)
  {
    return new FormuleMontantRegimeGeneralASRDC();
  }
  
  public ResultatCalcul postTraitementResultatDetaille(AttributionSpec p_attribution, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul)
    throws CoucheLogiqueException
  {
    return PostTraitements.postTraitementResultatDetaille(p_attribution, (fr.unedic.cali.calcul.dom.CalendrierExecutionCalcul)p_calendrierExecutionCalcul);
  }
  
  public ResultatCalcul postTraitementResultatDetailleNotification(AttributionSpec p_attribution, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul)
    throws CoucheLogiqueException
  {
    return PostTraitements.postTraitementResultatDetailleNotification(p_attribution, (fr.unedic.cali.calcul.dom.CalendrierExecutionCalcul)p_calendrierExecutionCalcul);
  }
  
  public ResultatCalcul postTraitementResultatDeterminationEtatDroit(AttributionSpec p_attribution, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul, Damj p_dateEtatDroit)
    throws CoucheLogiqueException
  {
    return PostTraitements.postTraitementResultatDeterminationEtatDroit(p_attribution, (fr.unedic.cali.calcul.dom.CalendrierExecutionCalcul)p_calendrierExecutionCalcul, p_dateEtatDroit);
  }
  
  public ResultatCalcul postTraitementResultatMigrationCalcul(AttributionSpec p_attribution, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul)
    throws CoucheLogiqueException
  {
    return null;
  }
  
  public Damj recupererDateFinDroitTheorique(CalendrierExecutionCalculSpec p_calendrierExecutionCalcul, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    Damj dateFinDroitTheorique = null;
    EtatAuDjiGamme etatAuDji = (EtatAuDjiGamme)p_calendrierExecutionCalcul.getEtatAuDJI();
    BigDecimal reliquatDureeIndemnisation = null;
    if (etatAuDji != null)
    {
      if ((etatAuDji.getReliquatDureeIndemnisation() != null) && (etatAuDji.getReliquatDureeIndemnisation().getValeur() != null))
      {
        reliquatDureeIndemnisation = etatAuDji.getReliquatDureeIndemnisation().getValeur();
        dateFinDroitTheorique = p_calendrierExecutionCalcul.getDernierJourIndemnisable().deplacerVersAvant(new DureeCalendaire(0, 0, reliquatDureeIndemnisation.intValue()));
      }
      else
      {
        dateFinDroitTheorique = p_calendrierExecutionCalcul.getDernierJourIndemnisable();
      }
    }
    else
    {
      Attribution attribution = (Attribution)p_attribution;
      dateFinDroitTheorique = p_attribution.getPji().deplacerVersAvant(new DureeCalendaire(0, 0, attribution.getDureeIndemnisationTheorique().getValeurEntiere() - 1));
    }
    return dateFinDroitTheorique;
  }
  
  public ChronologiePeriodes recupererPeriodesProduit(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesIndividuelles = null;
    IndividuSpec individu = null;
    
    periodesIndividuelles = new ChronologiePeriodes();
    individu = p_attribution.getDemandeur();
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire50Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire55Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire60Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererPeriodeRetraite(individu));
    
    periodesIndividuelles.ajouter(new ObjetChronoPeriodeLimiteIndemnisationASR(((Attribution)p_attribution).getDateLimiteIndemnisation().lendemain(), p_attribution.getRsod()));
    if (individu.getDernierJourAtteste() != null) {
      periodesIndividuelles.ajouter(OutillagePeriodes.genererLendemainDja(individu));
    }
    return periodesIndividuelles;
  }
  
  private void passerEnIndemnisationSansFormation(ConstituantsIndemnisation p_constituantsIndemnisation)
  {
    DureeIndemnisation duree = (DureeIndemnisation)OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(p_constituantsIndemnisation.getCollectionQuantiteDroit());
    if (duree != null) {
      duree.setCodeFormuleMontant(FormuleMontantRegimeGeneralASRDC.getCode());
    } else {
      p_constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantRegimeGeneralASRDC.getCode());
    }
    ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant().copie();
    p_constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisation);
  }
  
  private void passerEnIndemnisationAvecFormation(ObjetChronoPeriode p_periode, ConstituantsIndemnisation p_constituantsIndemnisation)
  {
    DureeIndemnisation duree = (DureeIndemnisation)OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(p_constituantsIndemnisation.getCollectionQuantiteDroit());
    if (duree != null) {
      duree.setCodeFormuleMontant(FormuleMontantASRDCF.getCode());
    } else {
      p_constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantASRDCF.getCode());
    }
    ElementBaseIndemnisationAREF elementBaseIndemnisationAREF = new ElementBaseIndemnisationAREF((ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant());
    if ((p_periode instanceof PeriodeFormation)) {
      elementBaseIndemnisationAREF.setEffectif(((PeriodeFormation)p_periode).estEffective());
    }
    p_constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationAREF);
  }
  
  public int calculerCompteurNombreJoursIndemnisesSurUT(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, int p_cumulNombreJoursServi)
  {
    int nombreJourServiEnDebutUT = 0;
    nombreJourServiEnDebutUT = p_cumulNombreJoursServi + p_ut.getQuantiteIndemnisee().getValeur().intValue();
    p_ut.setEstCumulJoursIndemnise(true);
    return nombreJourServiEnDebutUT;
  }
  
  private boolean estEnFormation(fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
  {
    ChronologiePeriodes periodesSegmentantes = p_ut.getQualificationPeriodes().getPeriodesSegmentantes();
    periodesSegmentantes.iterer();
    while (periodesSegmentantes.encoreSuivant()) {
      if ((periodesSegmentantes.elementSuivant() instanceof PeriodeFormation)) {
        return true;
      }
    }
    return false;
  }
  
  public boolean neutralisationApplicableRetourUL961()
  {
    return false;
  }
  
  public int calculerCompteurNombreMoisIndemnisesSurUT(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, int p_nbMoisIndemniseEnDebutDUT)
  {
    int nbMoisIndemniseAsu = p_ut.getNbMoisIndemniseEnDebutDUT();
    
    Quantite quantiteIndemnise = p_ut.getQuantiteIndemnisee();
    if (quantiteIndemnise.getValeur().intValue() >= 1) {
      nbMoisIndemniseAsu += 1;
    }
    return nbMoisIndemniseAsu;
  }
  
  public int initialiserNombreMoisIndemnise(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    int nbMoisIndemniseAsu = 0;
    Attribution attribution = (Attribution)p_attribution;
    if (((attribution instanceof RepriseSpec)) && 
      (attribution.getAttributionPrecedente() != null) && (attribution.getAttributionPrecedente().getCalendrierExecutionCalcul() != null) && (attribution.getAttributionPrecedente().getCalendrierExecutionCalcul().getEtatAuDJI() != null))
    {
      EtatAuDjiGamme etatAuDji = (EtatAuDjiGamme)attribution.getAttributionPrecedente().getCalendrierExecutionCalcul().getEtatAuDJI();
      if (etatAuDji.isEstNbMoisIndemniseAsu()) {
        nbMoisIndemniseAsu = etatAuDji.getNbMoisIndemniseAsu();
      }
      if ((attribution.getAttributionPrecedente().getCalendrierExecutionCalcul().getDernierJourIndemnisable() != null) && (p_ut.getPeriode().contient(attribution.getAttributionPrecedente().getCalendrierExecutionCalcul().getDernierJourIndemnisable()))) {
        if (attribution.getAttributionPrecedente().estNeutralise())
        {
          nbMoisIndemniseAsu--;
        }
        else
        {
          ContexteUT.ElementContexteUT elementContexteUT = p_contexteUT.getElementContexteUT(attribution.getAttributionPrecedente());
          if ((elementContexteUT.getQuantiteIndemnisee() != null) && (elementContexteUT.getQuantiteIndemnisee().getValeur() != null) && (elementContexteUT.getQuantiteIndemnisee().getValeur().intValue() > 0) && (p_ut.getQuantiteIndemnisee() != null) && (p_ut.getQuantiteIndemnisee().getValeur() != null) && (p_ut.getQuantiteIndemnisee().getValeur().intValue() > 0)) {
            nbMoisIndemniseAsu--;
          }
        }
      }
    }
    return nbMoisIndemniseAsu;
  }
  
  public boolean recuperationAlimentationNombreMoisIndemnise(AttributionSpec p_attribution)
  {
    boolean estAlimenteNbMoisIndemniseAsu = false;
    Attribution attribution = (Attribution)p_attribution;
    if ((attribution instanceof RepriseSpec))
    {
      AttributionSpec attributionPrecedente = attribution.getAttributionPrecedente();
      if ((attributionPrecedente != null) && (attributionPrecedente.getCalendrierExecutionCalcul() != null) && (attributionPrecedente.getCalendrierExecutionCalcul().getEtatAuDJI() != null))
      {
        EtatAuDjiGamme etatAuDji = (EtatAuDjiGamme)attribution.getAttributionPrecedente().getCalendrierExecutionCalcul().getEtatAuDJI();
        
        estAlimenteNbMoisIndemniseAsu = etatAuDji.isEstNbMoisIndemniseAsu();
      }
    }
    else if ((attribution instanceof OdSpec))
    {
      estAlimenteNbMoisIndemniseAsu = true;
    }
    else
    {
      estAlimenteNbMoisIndemniseAsu = false;
    }
    return estAlimenteNbMoisIndemniseAsu;
  }
  
  public void controleActiviteReduiteMaintienEuropeen(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ArretProduitAvecRaison p_arretProduitAvecRaison, ConstituantsIndemnisation p_constituantsIndemnisation)
    throws CoucheLogiqueException
  {}
  
  public Damj getIdeMaintienEuropeenDuDroit(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return null;
  }
  
  public Damj getPjiMaintienEuropeenDuDroit(AttributionSpec p_attribution)
  {
    return null;
  }
  
  public Damj getDjiMaintienEuropeenDuDroit(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return null;
  }
  
  public boolean enregistrerDroitPBJCNCP(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return true;
  }
  
  public boolean enregistrerEnquetePBJCNCP()
  {
    return true;
  }
  
  public fr.unedic.cali.calcul.dom.EvenementFinQuantiteDroit creerEvenementFinQuantiteDroit(Damj p_dateEffet, QuantiteDroitSpec p_quantiteDroit)
  {
    return new fr.unedic.cali.asu.calcul.dom.EvenementFinQuantiteDroit(p_dateEffet, p_quantiteDroit);
  }
  
  public fr.unedic.cali.calcul.dom.periode.DsmTravail convertirDsmTravailVersDsmTravailProduit(fr.unedic.cali.calcul.dom.periode.DsmTravail p_dsmTravail)
  {
    return new fr.unedic.cali.asu.calcul.dom.periode.DsmTravail(p_dsmTravail);
  }
  
  public void postTraitementQualification(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, QualificationPeriodes p_qualificationPeriodes)
    throws CoucheLogiqueException
  {}
  
  public boolean verifierEligibilitePaiementParAvance(fr.unedic.cali.calcul.dom.UniteTraitement ut)
  {
    ut.setRaisonStatut(1);
    return false;
  }
}

/* Location:
 * Qualified Name:     FacadeCalculProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */