package fr.unedic.cali.asu.cva10.p02.calcul;

import fr.unedic.cali.asu.cva10.calcul.FacadeCalculLigneCVA10Impl;
import fr.unedic.cali.asu.cva10.calcul.dom.DureeIndemnisation;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.calcul.dom.UniteTraitement;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeLimiteIndemnisationASP;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionSuivi;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.QuantiteDroit;
import fr.unedic.cali.dom.affectation.ProduitAsuCva10P02;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

public class FacadeCalculProduitImpl
  extends FacadeCalculLigneCVA10Impl
{
  public void initialiseElementBaseIndemnisation(ConstituantsIndemnisation constituantsIndemnisation, ElementBaseIndemnisation elementBaseIndemnisationCourant, ElementBaseIndemnisation ebiAttrib, AttributionAssuranceSpec attribution, Periode periodeUT)
    throws CoucheLogiqueException
  {
    super.initialiseElementBaseIndemnisation(constituantsIndemnisation, elementBaseIndemnisationCourant, ebiAttrib, attribution, periodeUT);
    elementBaseIndemnisationCourant.setProduitMontantRetenu((ProduitAsuSpec)ebiAttrib.getProduitAreActif());
  }
  
  protected void genererEnquetesCourrierFinDeDroitAsp(AttributionSpec attribution, UniteTraitement uniteTraitement)
  {
    ArretProduitAvecRaison arretProduitAvecRaison = uniteTraitement.getArretProduitAvecRaison();
    boolean estFinASP = false;
    
    Iterator itID = arretProduitAvecRaison.getPeriodesInterruptivesDefinitives().iterator();
    while (itID.hasNext())
    {
      ObjetChronoPeriode periode = (ObjetChronoPeriode)itID.next();
      if ((periode instanceof ObjetChronoPeriodeLimiteIndemnisationASP)) {
        estFinASP = true;
      }
    }
    Iterator ite = ((AttributionAssuranceSpec)attribution).getListeDurees().iterator();
    QuantiteDroit dureeTh = null;
    boolean existeDuTh = false;
    while ((ite.hasNext()) && (!existeDuTh))
    {
      dureeTh = (QuantiteDroit)ite.next();
      if ((dureeTh instanceof DureeIndemnisation)) {
        existeDuTh = true;
      }
    }
    if ((arretProduitAvecRaison.isRaisonsContientRaison(1)) || (estFinASP)) {
      genererEnquetesFinASP(attribution, uniteTraitement, arretProduitAvecRaison, dureeTh, existeDuTh);
    }
  }
  
  private void genererEnquetesFinASP(AttributionSpec attribution, UniteTraitement uniteTraitement, ArretProduitAvecRaison arretProduitAvecRaison, QuantiteDroit dureeTh, boolean existeDuTh)
  {
    Iterator it = uniteTraitement.getConstituantsIndemnisationEnFinUT().getCollectionQuantiteDroit().iterator();
    while (it.hasNext())
    {
      QuantiteDroit duree = (QuantiteDroit)it.next();
      if ((duree instanceof DureeIndemnisation))
      {
        if (!existeDuTh) {
          dureeTh = duree;
        }
        if ((duree.getQuantiteCourante() == null) || (dureeTh.getQuantiteInitial().getValeurEntiere() <= duree.getQuantiteInitial().getValeurEntiere())) {
          GestionSuivi.enregistrerEnquetePbjcNcp(attribution, arretProduitAvecRaison.recupereLendemainDateArret().veille(), 35, 0, true, ((AttributionAssuranceSpec)attribution).determinerCodeSousProduitPourSigma(), this, uniteTraitement.getConstituantsIndemnisationEnFinUT());
        } else if (duree.getQuantiteCourante() != null) {
          GestionSuivi.enregistrerEnquetePbjcNcp(attribution, arretProduitAvecRaison.recupereLendemainDateArret().veille(), 34, 0, true, ((AttributionAssuranceSpec)attribution).determinerCodeSousProduitPourSigma(), this, uniteTraitement.getConstituantsIndemnisationEnFinUT());
        }
      }
    }
  }
  
  public boolean estAspDcSuperieurUnAn(AttributionSpec attribution)
  {
    String codeSousProduit = ProduitAsuCva10P02.getInstance().determinerCodeSousProduitPourSigma(attribution);
    return (codeSousProduit.equals("02")) || (codeSousProduit.equals("M2"));
  }
}

/* Location:
 * Qualified Name:     FacadeCalculProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */