package fr.unedic.cali.asu.cva10.p02.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.produits.liquidation.dom.Decision;
import fr.unedic.cali.dom.DecisionSpec;
import java.util.ArrayList;

public class ComparateurDecision
  extends fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.ComparateurDecision
{
  public static boolean estEgal(DecisionSpec p_decision1, DecisionSpec p_decision2)
  {
    boolean estEgal = false;
    if ((p_decision1 != null) && (p_decision2 != null)) {
      estEgal = (produitEgal(p_decision1, p_decision2)) && (decisionEgal((Decision)p_decision1, (Decision)p_decision2)) && (revisionsPossedeAttributionPrecedente((Decision)p_decision1, (Decision)p_decision2)) && (reprise1PossedeAttributionPrecedente((Decision)p_decision1, (Decision)p_decision2)) && (dureeEffectiveEgale((Decision)p_decision1, (Decision)p_decision2)) && (pjiEgal((Decision)p_decision1, (Decision)p_decision2)) && (reglementEgal((Decision)p_decision1, (Decision)p_decision2)) && (motifRejetEgal((Decision)p_decision1, (Decision)p_decision2)) && (montantBrutEgal((Decision)p_decision1, (Decision)p_decision2)) && (sjrEgal((Decision)p_decision1, (Decision)p_decision2)) && (coefSaisonnierEgal((Decision)p_decision1, (Decision)p_decision2)) && (coefTempsPartielEgal((Decision)p_decision1, (Decision)p_decision2)) && (dateAttributionEgal((Decision)p_decision1, (Decision)p_decision2)) && (topAlsaceMoselleEgal((Decision)p_decision1, (Decision)p_decision2)) && (regimeSecuEgal((Decision)p_decision1, (Decision)p_decision2)) && (competenceAdministrativeEgale((Decision)p_decision1, (Decision)p_decision2));
    }
    if (ignorerChangementAre2009Expatries(p_decision1, p_decision2)) {
      estEgal = decisionEgal(p_decision1, p_decision2);
    }
    return estEgal;
  }
  
  public static ArrayList rechercheDifferencesComparaisonDecision(DecisionSpec p_decision1, DecisionSpec p_decision2)
  {
    ArrayList listeDifferences = new ArrayList();
    if (!estEgal(p_decision1, p_decision2)) {
      if (produitEgal(p_decision1, p_decision2))
      {
        boolean revisionsPossedeAttributionPrecedente = revisionsPossedeAttributionPrecedente(p_decision1, p_decision2);
        boolean reprise1PossedeAttributionPrecedente = reprise1PossedeAttributionPrecedente(p_decision1, p_decision2);
        if (decisionEgal(p_decision1, p_decision2))
        {
          if ((reprise1PossedeAttributionPrecedente) && (revisionsPossedeAttributionPrecedente))
          {
            Decision decisionAvant = (Decision)p_decision1;
            Decision decisionApres = (Decision)p_decision2;
            if (!dureeEffectiveEgale(decisionAvant, decisionApres)) {
              alimenterDureeComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!pjiEgal(decisionAvant, decisionApres)) {
              alimenterPjiComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!reglementEgal(decisionAvant, decisionApres)) {
              alimenterReglementComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!motifRejetEgal(decisionAvant, decisionApres)) {
              alimenterMotifsRejetComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!montantBrutEgal(decisionAvant, decisionApres)) {
              alimenterMontantComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!sjrEgal(decisionAvant, decisionApres)) {
              alimenterSjrComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!coefSaisonnierEgal(decisionAvant, decisionApres)) {
              alimenterCoefSaisonnierComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!coefTempsPartielEgal(decisionAvant, decisionApres)) {
              alimenterCoefTempsPartielComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!dateAttributionEgal(decisionAvant, decisionApres)) {
              alimenterDateAttributionComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!topAlsaceMoselleEgal(decisionAvant, decisionApres)) {
              alimenterAlsaceLorraineComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!regimeSecuEgal(decisionAvant, decisionApres)) {
              alimenterRegimeSecuComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
            if (!competenceAdministrativeEgale(decisionAvant, decisionApres)) {
              alimenterCompetenceAdministrativeComparaisonDecision(decisionAvant, decisionApres, listeDifferences);
            }
          }
          else if (!reprise1PossedeAttributionPrecedente)
          {
            alimenterAttribPrecRepriseComparaisonDecision(p_decision2, listeDifferences);
          }
          else if (!revisionsPossedeAttributionPrecedente)
          {
            alimenterAttribPrecRevisionComparaisonDecision(p_decision1, p_decision2, listeDifferences);
          }
        }
        else {
          alimenterDecisionComparaisonDecision(p_decision1, p_decision2, listeDifferences);
        }
      }
      else if ((p_decision1 != null) && (p_decision2 != null))
      {
        alimenterProduitComparaisonDecision(p_decision1, p_decision2, listeDifferences);
        if (!decisionEgal(p_decision1, p_decision2)) {
          alimenterDecisionComparaisonDecision(p_decision1, p_decision2, listeDifferences);
        }
      }
    }
    return listeDifferences;
  }
}

/* Location:
 * Qualified Name:     ComparateurDecision
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */