package fr.unedic.cali.asu.cva10.p03.calcul;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.calcul.dom.ConstituantsCalculActiviteReduiteAsu;
import fr.unedic.cali.asu.calcul.dom.DureeProlongation;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.OutilsMaintienEuropeenEessiASU;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.RecuperationPensionInvaliditeAvantDate;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.fabriques.FabriqueStrategieConvention2014;
import fr.unedic.cali.asu.cge01.outilsfonctionnels.RevalorisationSalaire;
import fr.unedic.cali.asu.cva10.calcul.FacadeCalculLigneCVA10Impl;
import fr.unedic.cali.asu.cva10.calcul.dom.DureeIndemnisation;
import fr.unedic.cali.asu.cva10.calcul.dom.FormuleMontantASPDCF;
import fr.unedic.cali.asu.cva10.calcul.dom.FormuleMontantRegimeGeneralASPDC;
import fr.unedic.cali.asu.cva10.calcul.outilsfonctionnels.MajCiTranche;
import fr.unedic.cali.asu.cva10.p03.calcul.dom.FormuleMontantASPDCFAvecFinancement;
import fr.unedic.cali.asu.cva10.p03.calcul.dom.FormuleMontantASPDCPostPrime;
import fr.unedic.cali.asu.cva10.p03.calcul.dom.FormuleMontantASPDCPostPrimeFormation;
import fr.unedic.cali.asu.cva10.p03.calcul.dom.FormuleMontantRegimeGeneralASPDCAvecFinancement;
import fr.unedic.cali.asu.cva10.p03.calcul.dom.FormuleMontantRegimeGeneralASPDCP03;
import fr.unedic.cali.asu.cva10.p03.calcul.outilsfonctionnels.MajCi;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisationAREF;
import fr.unedic.cali.asu.dom.SalaireReference;
import fr.unedic.cali.asu.dom.Sjc;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.dom.cge01.AttributionAssuranceCgeSpec;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsRevisions;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsTrancheCalcul;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.TrancheExecutable;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.calcul.OutillagePeriodes;
import fr.unedic.cali.calcul.OutillageQuantites;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculPeriodique;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculSpec;
import fr.unedic.cali.calcul.dom.ConstituantsCalculActiviteReduiteSpec;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.calcul.dom.EtatAuDji;
import fr.unedic.cali.calcul.dom.EvenementBaisseIndemnisationCSP;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.Somme;
import fr.unedic.cali.calcul.dom.UniteTraitement;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormation;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnomalieI04;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeLimiteIndemnisationPMVS;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionSuivi;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ContexteUT;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ElementBaseIndemnisationFacade;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DureeIndemnisationAbstraite;
import fr.unedic.cali.dom.DureeProlongationAbstraite;
import fr.unedic.cali.dom.ElementBaseIndemnisationSpec;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.cali.dom.QuantiteDroit;
import fr.unedic.cali.dom.QuantiteDroitSpec;
import fr.unedic.cali.dom.affectation.Parametres;
import fr.unedic.cali.dom.affectation.ProduitAsuCva10P03;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.parametres.GestionnaireDateApplication;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreDemandePourERE;
import fr.unedic.cali.utilitaire.outils.OutilRecherche;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class FacadeCalculProduitImpl
  extends FacadeCalculLigneCVA10Impl
{
  public ChronologiePeriodes recupererPeriodesLieesAuContexte(ContexteUT contexteUT, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes chronologiePeriodes = super.recupererPeriodesLieesAuContexte(contexteUT, attribution);
    if (contexteUT.getPeriodeUT().getDebut().estApresOuCoincideAvec(FabriqueStrategieConvention2014.DATE_APPLICATION))
    {
      Iterator ite = ((AttributionAssuranceSpec)attribution).getListeActiviteConservee().iterer();
      while (ite.hasNext())
      {
        TravailSpec activite = (TravailSpec)ite.next();
        if ((activite.getDateFin().estContenueDans(contexteUT.getPeriodeUT())) && (!estDecisionneeSuiteActiviteConserveePerdue(activite, attribution)) && (!estDemandeApresActiviteConserveePerdue(activite.getDateFin(), attribution))) {
          chronologiePeriodes.ajouter(new ObjetChronoAnomalieI04(activite.getDateFin(), attribution.getRsod()));
        }
      }
    }
    return chronologiePeriodes;
  }
  
  private boolean estDecisionneeSuiteActiviteConserveePerdue(TravailSpec activite, AttributionSpec attribution)
  {
    Map<TravailSpec, DemandeSpec> maps = OutilsRevisions.getMapFctsAssociees(attribution.getDemandeur());
    DemandeSpec demande = (DemandeSpec)maps.get(activite);
    return (demande != null) && (demande.estDecisionnee());
  }
  
  private boolean estDemandeApresActiviteConserveePerdue(Damj dateFct, AttributionSpec attribution)
  {
    return OutilRecherche.rechercherDemandeSuivante(attribution.getDemande().getChronologieDemandesAssuranceSansCourante(), dateFct.veille(), new FiltreDemandePourERE("ASU_28")) != null;
  }
  
  public ConstituantsIndemnisation creationConstituantsIndemnisation(AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    ConstituantsIndemnisation constituantsIndemnisation = new ConstituantsIndemnisation();
    Collection collectionDureesCalcul = new ArrayList();
    DureeIndemnisation dureeIndemnisation = new DureeIndemnisation();
    if (estAspDcSuperieurUnAn(attribution)) {
      dureeIndemnisation.setCodeFormuleMontant(FormuleMontantRegimeGeneralASPDCAvecFinancement.getCode());
    } else {
      dureeIndemnisation.setCodeFormuleMontant(FormuleMontantRegimeGeneralASPDCP03.getCode());
    }
    if (OutilsTrancheCalcul.estTrancheActive(attribution))
    {
      collectionDureesCalcul = OutilsTrancheCalcul.getListeDurees((Attribution)attribution);
      convertirDureeIndemnisationEnAsp(collectionDureesCalcul, attribution);
      constituantsIndemnisation.setCollectionQuantiteDroit(collectionDureesCalcul);
    }
    else
    {
      dureeIndemnisation.setQuantiteInitial(((AttributionAssuranceSpec)attribution).getDureeIndemnisationInitiale());
      collectionDureesCalcul.add(dureeIndemnisation);
    }
    DureeProlongation dureePostPrime = recupererDureePostPrime(attribution);
    if (dureePostPrime != null)
    {
      if (dureePostPrime.getQuantiteInitial().getValeur().compareTo(BigDecimal.ZERO) == 0)
      {
        Iterator ite = collectionDureesCalcul.iterator();
        while (ite.hasNext())
        {
          Object duree = ite.next();
          if ((duree instanceof DureeIndemnisation)) {
            ((DureeIndemnisation)duree).setCodeFormuleMontant(FormuleMontantASPDCPostPrime.getCode());
          }
        }
      }
      collectionDureesCalcul.add(dureePostPrime);
    }
    constituantsIndemnisation.setDateFinDispositifCSP(((AttributionAssuranceSpec)attribution).getDateLimiteIndemnisation());
    constituantsIndemnisation.setCollectionQuantiteDroit(collectionDureesCalcul);
    return constituantsIndemnisation;
  }
  
  private DureeProlongation recupererDureePostPrime(AttributionSpec attribution)
  {
    DureeProlongation dureePostPrime = null;
    if (OutilsTrancheCalcul.estTrancheActive(attribution))
    {
      Quantite quantitePostPrime = ((TrancheExecutable)((Attribution)attribution).getListTranchesExecutables().get(0)).getDuree(5);
      if (quantitePostPrime != null) {
        dureePostPrime = new DureeProlongation(quantitePostPrime.getValeurEntiere());
      }
    }
    else if (((AttributionAssuranceCgeSpec)attribution).getDureePostPrime() != null)
    {
      dureePostPrime = new DureeProlongation(((AttributionAssuranceCgeSpec)attribution).getDureePostPrime().getValeurEntiere());
    }
    return dureePostPrime;
  }
  
  private void convertirDureeIndemnisationEnAsp(Collection<DureeIndemnisationAbstraite> collection, AttributionSpec attribution)
  {
    Iterator<DureeIndemnisationAbstraite> ite = collection.iterator();
    Collection<DureeIndemnisationAbstraite> collectionDureeAsp = new ArrayList();
    while (ite.hasNext())
    {
      QuantiteDroitSpec duree = (QuantiteDroitSpec)ite.next();
      if ((duree instanceof DureeIndemnisationAbstraite))
      {
        DureeIndemnisation dureeAsp = new DureeIndemnisation(duree.getQuantiteInitial().getValeurEntiere());
        dureeAsp.setCodeFormuleMontant(FormuleMontantRegimeGeneralASPDCP03.getCode());
        if (estAspDcSuperieurUnAn(attribution)) {
          dureeAsp.setCodeFormuleMontant(FormuleMontantRegimeGeneralASPDCAvecFinancement.getCode());
        } else {
          dureeAsp.setCodeFormuleMontant(FormuleMontantRegimeGeneralASPDCP03.getCode());
        }
        collectionDureeAsp.add(dureeAsp);
        ite.remove();
      }
      else if ((duree instanceof DureeProlongationAbstraite))
      {
        ite.remove();
      }
    }
    collection.addAll(collectionDureeAsp);
  }
  
  private ElementBaseIndemnisation creerElementBaseIndemnisation(TrancheExecutable tranche, ConstituantsIndemnisation constituantsIndemnisation, AttributionAssuranceSpec attribution, Periode periodeUT)
    throws CoucheLogiqueException
  {
    ElementBaseIndemnisation elementBaseIndemnisationCourant = new ElementBaseIndemnisationAREF();
    
    Reglement reglementApplicable = tranche.getReglement();
    if (reglementApplicable != null) {
      elementBaseIndemnisationCourant.setReglementApplicable(reglementApplicable);
    }
    Quantite affiliationRequisePourPRA = tranche.getAffiliationRequisePourPRA();
    if (affiliationRequisePourPRA != null) {
      elementBaseIndemnisationCourant.setAffiliationRequisePourPRA(affiliationRequisePourPRA);
    }
    SalaireReference salaireReference = tranche.getSalaireReferenceInitialSpectacle();
    if (salaireReference != null) {
      elementBaseIndemnisationCourant.setSalaireReference(salaireReference);
    }
    BigDecimal nombreHeureTravaillesEtendu = tranche.getNombreHeuresTravailleesEtendu();
    if (nombreHeureTravaillesEtendu != null) {
      elementBaseIndemnisationCourant.setNombreHeureTravaillesEtendu(nombreHeureTravaillesEtendu);
    }
    BigDecimal nombreHeuresTravailleesPlafonnees = tranche.getNombreHeuresTravailleesPlafonne();
    if (nombreHeuresTravailleesPlafonnees != null) {
      elementBaseIndemnisationCourant.setNombreHeuresTravailleesPlafonnees(nombreHeuresTravailleesPlafonnees);
    }
    Periode prc = tranche.getPrc();
    if (prc != null) {
      elementBaseIndemnisationCourant.setPrc(prc);
    }
    elementBaseIndemnisationCourant.setNbJoursEmploiSurPrc(tranche.getNombreJoursEmploiDansPRC());
    elementBaseIndemnisationCourant.setCoefficientHoraireJour(tranche.getCoefficientHoraireJour());
    if (tranche.getCoefficientSaisonnier() != null) {
      elementBaseIndemnisationCourant.setCoefficientSaisonnier(tranche.getCoefficientSaisonnier());
    } else {
      elementBaseIndemnisationCourant.setCoefficientSaisonnier(BigDecimal.ONE);
    }
    if (tranche.getCoefficientTempsPartiel() != null) {
      elementBaseIndemnisationCourant.setCoefficientTempsPartiel(tranche.getCoefficientTempsPartiel());
    } else {
      elementBaseIndemnisationCourant.setCoefficientTempsPartiel(BigDecimal.ONE);
    }
    elementBaseIndemnisationCourant.setTypeCaractereSaisonnierRetenu(tranche.getNatureCoefficientSaisonnier());
    elementBaseIndemnisationCourant.setIsConditionCaractereSaisonnierParRythme(tranche.isA3ansActiviteEn5ans());
    
    Damj dateReval = Damj.max(periodeUT.getDebut(), attribution.getDateAttribution());
    elementBaseIndemnisationCourant.setSjr(RevalorisationSalaire.revaloriserSjrTranche(tranche, dateReval));
    
    elementBaseIndemnisationCourant.setListePensionInvalidite(tranche.getListePensionsInvalidites());
    elementBaseIndemnisationCourant.setMontantPensionInvaliditeADeduire(RecuperationPensionInvaliditeAvantDate.recuperationMontantPIChainees(elementBaseIndemnisationCourant, attribution.getDemandeur(), attribution.getPji().veille(), attribution.getDateAttribution()));
    
    elementBaseIndemnisationCourant.setCoefficientAvantageVieillesse(BigDecimal.ONE);
    
    elementBaseIndemnisationCourant.setSjc(new Sjc(BigDecimal.ZERO));
    
    elementBaseIndemnisationCourant.setProduitMontantRetenu((ProduitAsuSpec)Parametres.getProduit(tranche.getProduitMontantRetenu()));
    elementBaseIndemnisationCourant.setProduitAreActif(tranche.getProduitAreActif());
    
    elementBaseIndemnisationCourant.setDateMaintienEuropeen(OutilsMaintienEuropeenEessiASU.rechercherDateMaintienEuropeen(attribution, periodeUT, constituantsIndemnisation));
    
    elementBaseIndemnisationCourant.setContextePAPPresent(tranche.isContextePAPPresent());
    elementBaseIndemnisationCourant.setContextePapParlementaire(tranche.estContextePapParlementaire());
    
    return elementBaseIndemnisationCourant;
  }
  
  private Collection<ElementBaseIndemnisation> creerListeEBIaPartirTrancheExecutable(TrancheExecutable tranche, AttributionAssuranceSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, Periode periodeUT)
    throws CoucheLogiqueException
  {
    Collection<ElementBaseIndemnisation> listeEBI = new ArrayList();
    
    List<TrancheExecutable> listeTranche = tranche.getListListeSousTrancheExecutable();
    
    Iterator<TrancheExecutable> iteTranche = listeTranche.iterator();
    while (iteTranche.hasNext())
    {
      TrancheExecutable trancheCourante = (TrancheExecutable)iteTranche.next();
      
      ElementBaseIndemnisation ebi = creerElementBaseIndemnisation(trancheCourante, constituantsIndemnisation, attribution, periodeUT);
      listeEBI.add(ebi);
    }
    return listeEBI;
  }
  
  public boolean epuisementQuantiteDroit(Damj dateEpuisementQuantite, AttributionSpec attribution, QuantiteDroitSpec quantiteDroitEpuisee, ConstituantsIndemnisation constituantsIndemnisation, UniteTraitement uniteTraitement)
    throws ApplicativeException
  {
    if ((quantiteDroitEpuisee instanceof DureeIndemnisation))
    {
      DureeIndemnisation dureeFinancement = (DureeIndemnisation)constituantsIndemnisation.getDureeIndemnisation();
      if ((dureeFinancement != null) && (constituantsIndemnisation.getCodeFormuleMontant() != FormuleMontantASPDCPostPrime.getCode())) {
        if (FormuleMontantRegimeGeneralASPDCAvecFinancement.getCode().equals(dureeFinancement.getCodeFormuleMontant())) {
          constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantRegimeGeneralASPDCAvecFinancement.getCode());
        } else if (FormuleMontantRegimeGeneralASPDCP03.getCode().equals(dureeFinancement.getCodeFormuleMontant())) {
          constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantRegimeGeneralASPDCP03.getCode());
        } else if (FormuleMontantASPDCF.getCode().equals(dureeFinancement.getCodeFormuleMontant())) {
          constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantASPDCF.getCode());
        } else if (FormuleMontantASPDCFAvecFinancement.getCode().equals(dureeFinancement.getCodeFormuleMontant())) {
          constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantASPDCFAvecFinancement.getCode());
        }
      }
      GestionSuivi.enregistrerEnquetePbjcNcp(attribution, dateEpuisementQuantite.lendemain(), 38, 0, true, attribution.determinerCodeSousProduitPourSigma(), this, uniteTraitement.getConstituantsIndemnisationEnFinUT());
      
      uniteTraitement.setDateEpuisementDuree(dateEpuisementQuantite);
    }
    else if ((quantiteDroitEpuisee instanceof DureeProlongation))
    {
      Collection collectionQuantiteDroit = constituantsIndemnisation.getCollectionQuantiteDroit();
      Iterator ite = collectionQuantiteDroit.iterator();
      while (ite.hasNext())
      {
        QuantiteDroit quantiteDroit = (QuantiteDroit)ite.next();
        if (((quantiteDroit instanceof DureeIndemnisation)) && (quantiteDroit.getQuantiteInitial().getValeurEntiere() > 0)) {
          ((DureeIndemnisation)quantiteDroit).setCodeFormuleMontant(FormuleMontantASPDCPostPrime.getCode());
        }
      }
      constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantASPDCPostPrime.getCode());
      if (dateEpuisementQuantite != null)
      {
        if (dateEpuisementQuantite.estApresOuCoincideAvec(GestionnaireDateApplication.getInstance().recupererDateApplication("Application de la notification lors de la baisse du montant ASP"))) {
          GestionSuivi.enregistrerEnquetePbjcNcp(attribution, dateEpuisementQuantite.lendemain(), 40, 0, true, attribution.determinerCodeSousProduitPourSigma(), this, uniteTraitement.getConstituantsIndemnisationEnFinUT());
        }
        uniteTraitement.ajouterEvenement(new EvenementBaisseIndemnisationCSP(dateEpuisementQuantite));
      }
    }
    return false;
  }
  
  public void initialiseElementBaseIndemnisation(ConstituantsIndemnisation constituantsIndemnisation, ElementBaseIndemnisation elementBaseIndemnisationCourant, ElementBaseIndemnisation ebiAttrib, AttributionAssuranceSpec attribution, Periode periodeUT)
    throws CoucheLogiqueException
  {
    if (OutilsTrancheCalcul.estTrancheActive(attribution))
    {
      initialiseElementBaseIndemnisationCouranteTranche(constituantsIndemnisation, attribution, periodeUT);
      
      ((ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant()).setListeSousEBI(creerListeEBIaPartirTrancheExecutable(OutilsTrancheCalcul.recupererTrancheInitiale(attribution), attribution, constituantsIndemnisation, periodeUT));
    }
    else if (constituantsIndemnisation.getElementBaseIndemnisationCourant() == null)
    {
      super.initialiseElementBaseIndemnisation(constituantsIndemnisation, elementBaseIndemnisationCourant, ebiAttrib, attribution, periodeUT);
      elementBaseIndemnisationCourant.setProduitMontantRetenu((ProduitAsuSpec)ebiAttrib.getProduitAreActif());
      
      elementBaseIndemnisationCourant.setContextePAPPresent(ebiAttrib.isContextePAPPresent());
      
      elementBaseIndemnisationCourant.setContextePapParlementaire(ebiAttrib.isContextePapParlementaire());
    }
  }
  
  public void initialiseElementBaseIndemnisationCourante(ConstituantsIndemnisation constituantsIndemnisation, AttributionSpec attribution, Periode periodeUT)
    throws CoucheLogiqueException
  {
    if (OutilsTrancheCalcul.estTrancheActive(attribution))
    {
      initialiseElementBaseIndemnisationCouranteTranche(constituantsIndemnisation, (AttributionAssuranceSpec)attribution, periodeUT);
      
      ((ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant()).setListeSousEBI(creerListeEBIaPartirTrancheExecutable(OutilsTrancheCalcul.recupererTrancheInitiale(attribution), (Attribution)attribution, constituantsIndemnisation, periodeUT));
    }
    else
    {
      super.initialiseElementBaseIndemnisationCourante(constituantsIndemnisation, attribution, periodeUT);
    }
  }
  
  private void initialiseElementBaseIndemnisationCouranteTranche(ConstituantsIndemnisation constituantsIndemnisation, AttributionAssuranceSpec attribution, Periode periodeUT)
    throws CoucheLogiqueException
  {
    if (constituantsIndemnisation.getElementBaseIndemnisationCourant() == null)
    {
      ElementBaseIndemnisation elementBaseIndemnisationCourant = creerElementBaseIndemnisation(OutilsTrancheCalcul.recupererTrancheInitiale(attribution), constituantsIndemnisation, attribution, periodeUT);
      
      elementBaseIndemnisationCourant.setListeSousEBI(creerListeEBIaPartirTrancheExecutable(OutilsTrancheCalcul.recupererTrancheInitiale(attribution), attribution, constituantsIndemnisation, periodeUT));
      
      constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationCourant);
    }
  }
  
  public void initialisationQuantitesIndemnisation(ConstituantsIndemnisation constituantsIndemnisation, AttributionSpec attribution, Periode periodeUT)
    throws ApplicativeException
  {
    Collection<DureeIndemnisationAbstraite> collectionDurees = constituantsIndemnisation.getCollectionQuantiteDroit();
    if (collectionDurees != null)
    {
      Iterator<DureeIndemnisationAbstraite> iterator = collectionDurees.iterator();
      while (iterator.hasNext())
      {
        QuantiteDroitSpec duree = (QuantiteDroitSpec)iterator.next();
        if ((duree instanceof DureeIndemnisation))
        {
          duree.activer();
          if (OutilsTrancheCalcul.estTrancheActive(attribution)) {
            initialiseElementBaseIndemnisationCouranteTranche(constituantsIndemnisation, (Attribution)attribution, periodeUT);
          } else {
            initialiseElementBaseIndemnisationCourante(constituantsIndemnisation, attribution, periodeUT);
          }
        }
        else if ((duree instanceof DureeProlongation))
        {
          duree.activer();
        }
      }
    }
  }
  
  public ConstituantsIndemnisation miseAJourConstituantsIndemnisation(UniteTraitement uniteTraitement, AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, Damj dateDeMiseAjour, Periode periode)
    throws CoucheLogiqueException
  {
    ConstituantsIndemnisation ci;
    ConstituantsIndemnisation ci;
    if (OutilsTrancheCalcul.estTrancheActive(attribution))
    {
      ci = MajCiTranche.miseAJourConstituantsIndemnisation(attribution, constituantsIndemnisation, dateDeMiseAjour);
    }
    else
    {
      ((ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant()).setProduitAreActif(ProduitAsuCva10P03.getInstance().recupererProduitAreActif(attribution));
      
      ci = MajCi.miseAJourConstituantsIndemnisation(attribution, constituantsIndemnisation, dateDeMiseAjour);
    }
    if ((uniteTraitement != null) && (uniteTraitement.getConstituantsIndemnisationEnDebutUT() != null)) {
      ci.setDateFinDispositifCSP(uniteTraitement.getConstituantsIndemnisationEnDebutUT().getDateFinDispositifCSP());
    }
    return constituantsIndemnisation;
  }
  
  public ConstituantsCalculActiviteReduiteSpec miseAjourConstituantsCalculActiviteReduite(AttributionSpec attribution, ConstituantsCalculActiviteReduiteSpec constituantsCalculActiviteReduite, Damj dateDeMiseAjour, ConstituantsIndemnisation constituantIndemnisation)
    throws CoucheLogiqueException
  {
    if (OutilsTrancheCalcul.estTrancheActive(attribution))
    {
      ConstituantsCalculActiviteReduiteAsu constituantsCalculActiviteReduiteProduit = (ConstituantsCalculActiviteReduiteAsu)constituantsCalculActiviteReduite;
      
      constituantsCalculActiviteReduiteProduit.setSjr(RevalorisationSalaire.revaloriserSjrTranche(attribution, dateDeMiseAjour));
      return constituantsCalculActiviteReduiteProduit;
    }
    return super.miseAjourConstituantsCalculActiviteReduite(attribution, constituantsCalculActiviteReduite, dateDeMiseAjour, constituantIndemnisation);
  }
  
  public ChronologiePeriodes recupererPeriodesProduit(AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesIndividuelles = null;
    IndividuSpec individu = null;
    periodesIndividuelles = new ChronologiePeriodes();
    individu = attribution.getDemandeur();
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire50Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire55Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire60Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererPeriodeRetraite(individu));
    if ((((AttributionAssuranceSpec)attribution).getContexteDateLimiteIndemnisation() != null) && (((AttributionAssuranceSpec)attribution).getContexteDateLimiteIndemnisation().equals("CRSPMVS")) && (OutilGestionContexteDemande.estContexteDemandeAssurancePresent((Demande)attribution.getDemande(), 2))) {
      periodesIndividuelles.ajouter(new ObjetChronoPeriodeLimiteIndemnisationPMVS(((AttributionAssuranceSpec)attribution).getDateLimiteIndemnisation().lendemain(), attribution.getRsod()));
    }
    if (individu.getDernierJourAtteste() != null) {
      periodesIndividuelles.ajouter(OutillagePeriodes.genererLendemainDja(individu));
    }
    enrichirPeriodeDisponibilite(attribution, individu);
    
    return periodesIndividuelles;
  }
  
  public void realiserDetectionFinDeProduitPourSuivi(AttributionSpec attribution, UniteTraitement uniteTraitement, ContexteUT contexteUT)
    throws CoucheLogiqueException
  {
    genererEnquetesCourrierFinDeDroitAsp(attribution, uniteTraitement);
  }
  
  public void miseAJourConstituantsIndemnisationADate(AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, Damj date, ChronologiePeriodes chronologiePeriodesSanctions)
    throws CoucheLogiqueException
  {
    ElementBaseIndemnisation elementBaseIndemnisationCourant = (ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant();
    elementBaseIndemnisationCourant.setMontantPensionInvaliditeADeduire(RecuperationPensionInvaliditeAvantDate.recuperationMontantPIChainees(elementBaseIndemnisationCourant, attribution.getDemandeur(), date.veille(), attribution.getDateAttribution()));
    
    Iterator<ElementBaseIndemnisation> iterator = elementBaseIndemnisationCourant.getListeSousEBI().iterator();
    while (iterator.hasNext())
    {
      ElementBaseIndemnisation sousEBI = (ElementBaseIndemnisation)iterator.next();
      sousEBI.setMontantPensionInvaliditeADeduire(RecuperationPensionInvaliditeAvantDate.recuperationMontantPIChainees(sousEBI, attribution.getDemandeur(), date.veille(), attribution.getDateAttribution()));
    }
  }
  
  public EtatAuDji renseignerEtatAuDji(UniteTraitement derniereUT, CalendrierExecutionCalculPeriodique calendrier, AttributionSpec attribution, EtatAuDji etatAuDji)
    throws CoucheLogiqueException
  {
    return super.renseignerEtatAuDji(derniereUT, calendrier, attribution, etatAuDji);
  }
  
  public void mettreAjourDateFinDispositif(AttributionSpec attribution, UniteTraitement ut, CalendrierExecutionCalculPeriodique calendrier, QualificationPeriodes qualificationPeriodes)
    throws CoucheLogiqueException
  {
    miseAJourDateFinCSP(attribution, ut, calendrier, qualificationPeriodes);
  }
  
  public boolean enregistrerDispositifPBJCNCP(AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    boolean enregistrerDispositif = true;
    if (OutilsTrancheCalcul.estTrancheActive(attribution))
    {
      TrancheExecutable tranche = OutilsTrancheCalcul.recupererTrancheInitiale(attribution);
      enregistrerDispositif = !tranche.isContextePAPPresent();
    }
    else
    {
      ElementBaseIndemnisation ebi = ((AttributionAssuranceSpec)attribution).getElementBaseIndemnisation();
      enregistrerDispositif = !ebi.isContextePAPPresent();
    }
    return enregistrerDispositif;
  }
  
  public ElementBaseIndemnisationFacade mapperUTVersElementBaseIndemnisation(UniteTraitement uniteTraitement, AttributionSpec attribution)
  {
    ElementBaseIndemnisationFacade elt = super.mapperUTVersElementBaseIndemnisation(uniteTraitement, attribution);
    ElementBaseIndemnisation eltBase = (ElementBaseIndemnisation)uniteTraitement.getConstituantsIndemnisationEnFinUT().getElementBaseIndemnisationCourant();
    FormuleMontantSpec formuleMontantAsp = attribution.getFormuleMontant("1");
    if ((eltBase.getSjr() != null) && (eltBase.getSjr().getSalaire() != null) && ((!(formuleMontantAsp instanceof FormuleMontantRegimeGeneralASPDC)) || (((FormuleMontantRegimeGeneralASPDC)formuleMontantAsp).getFormuleMontantApplicable() != 2)))
    {
      Somme somme = null;
      Iterator<?> i = uniteTraitement.getCollectionSommes().iterator();
      while ((i.hasNext()) && (somme == null)) {
        somme = (Somme)i.next();
      }
      if ((somme != null) && (somme.getMontant() != null) && (somme.getMontant().getSjrNonReduit() != null)) {
        elt.setSjr(somme.getMontant().getSjrNonReduit().toString());
      }
    }
    return elt;
  }
  
  protected void passerEnIndemnisationSansFormation(ConstituantsIndemnisation constituantsIndemnisation, boolean estAvecFinancementEtat)
  {
    DureeIndemnisation duree = (DureeIndemnisation)OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(constituantsIndemnisation.getCollectionQuantiteDroit());
    if (duree != null)
    {
      if (estFormuleMontantPostPrime(constituantsIndemnisation)) {
        duree.setCodeFormuleMontant(FormuleMontantASPDCPostPrime.getCode());
      } else if (estAvecFinancementEtat) {
        duree.setCodeFormuleMontant(FormuleMontantRegimeGeneralASPDCAvecFinancement.getCode());
      } else {
        duree.setCodeFormuleMontant(FormuleMontantRegimeGeneralASPDC.getCode());
      }
    }
    else if (estFormuleMontantPostPrime(constituantsIndemnisation)) {
      constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantASPDCPostPrime.getCode());
    } else if (estAvecFinancementEtat) {
      constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantRegimeGeneralASPDCAvecFinancement.getCode());
    } else {
      constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantRegimeGeneralASPDC.getCode());
    }
    ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant().copie();
    constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisation);
  }
  
  protected void passerEnIndemnisationAvecFormation(ObjetChronoPeriode periode, ConstituantsIndemnisation constituantsIndemnisation, boolean estAvecFinancementEtat)
  {
    DureeIndemnisation duree = (DureeIndemnisation)OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(constituantsIndemnisation.getCollectionQuantiteDroit());
    if (duree != null)
    {
      if (estFormuleMontantPostPrime(constituantsIndemnisation)) {
        duree.setCodeFormuleMontant(FormuleMontantASPDCPostPrimeFormation.getCode());
      } else if (estAvecFinancementEtat) {
        duree.setCodeFormuleMontant(FormuleMontantASPDCFAvecFinancement.getCode());
      } else {
        duree.setCodeFormuleMontant(FormuleMontantASPDCF.getCode());
      }
    }
    else if (estFormuleMontantPostPrime(constituantsIndemnisation)) {
      constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantASPDCPostPrimeFormation.getCode());
    } else if (estAvecFinancementEtat) {
      constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantASPDCFAvecFinancement.getCode());
    } else {
      constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantASPDCF.getCode());
    }
    ElementBaseIndemnisationAREF elementBaseIndemnisationAREF = new ElementBaseIndemnisationAREF((ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant());
    if ((periode instanceof PeriodeFormation)) {
      elementBaseIndemnisationAREF.setEffectif(((PeriodeFormation)periode).estEffective());
    }
    constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationAREF);
  }
  
  private boolean estFormuleMontantPostPrime(ConstituantsIndemnisation constituantIndemnisation)
  {
    boolean estFormuleMontantPostPrime = false;
    if ((constituantIndemnisation != null) && (constituantIndemnisation.getCodeFormuleMontant() != null) && ((constituantIndemnisation.getCodeFormuleMontant().equals("5")) || (constituantIndemnisation.getCodeFormuleMontant().equals("6")))) {
      estFormuleMontantPostPrime = true;
    }
    return estFormuleMontantPostPrime;
  }
  
  public boolean estAspDcSuperieurUnAn(AttributionSpec attribution)
  {
    String codeSousProduit = ProduitAsuCva10P03.getInstance().determinerCodeSousProduitPourSigma(attribution);
    return (codeSousProduit.equals("02")) || (codeSousProduit.equals("M2")) || (codeSousProduit.equals("06")) || (codeSousProduit.equals("08"));
  }
  
  public Damj recupererDateFinDroitTheorique(CalendrierExecutionCalculSpec calendrierExecutionCalcul, AttributionSpec attributionParam)
    throws CoucheLogiqueException
  {
    return calendrierExecutionCalcul.getDateFinDispositifCSP();
  }
}

/* Location:
 * Qualified Name:     FacadeCalculProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */