package fr.unedic.cali.asu.cva10.p03.calcul.pbjc;

import fr.unedic.cali.asu.cva10.calcul.pbjc.FacadePBJCLigneCVA10Impl;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.calcul.dom.EvenementBaisseIndemnisationCSP;
import fr.unedic.cali.calcul.dom.Somme;
import fr.unedic.cali.calcul.dom.UniteTraitement;
import fr.unedic.cali.calcul.pbjc.FacadePBJCProduitSpec;
import fr.unedic.cali.calcul.pbjc.dom.PbjcNcp;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuCva10P03;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoEvenement;
import java.math.BigDecimal;
import java.util.Collection;
import java.util.Iterator;

public class FacadePBJCProduitImpl
  extends FacadePBJCLigneCVA10Impl
  implements FacadePBJCProduitSpec
{
  public String retournerReglementApplicable(AttributionSpec attribution)
  {
    return ((AttributionAssuranceSpec)attribution).getReglementApplicable().getReglement().getNomReglement();
  }
  
  public void positionnerMontantSalaireRevalorisePlafonne(PbjcNcp pbjcNcp, AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, MontantBaseSpec montant)
    throws CoucheLogiqueException
  {
    if (montant.getSjrNonReduit() != null)
    {
      pbjcNcp.setMontantSalaireRevalorisePlafonne(montant.getSjrNonReduit().setScale(2, 3));
    }
    else
    {
      BigDecimal sjr = ((ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant()).getSjr().getSalaire();
      if (((ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant()).getCoefficientSaisonnier() != null) {
        sjr = sjr.multiply(((ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant()).getCoefficientSaisonnier());
      }
      pbjcNcp.setMontantSalaireRevalorisePlafonne(sjr.setScale(2, 3));
    }
  }
  
  public void positionnerComplementJustification(PbjcNcp pbjcNcp, UniteTraitement ut, AttributionSpec attribution)
  {
    ObjetChronoEvenement objetChronoEvenement = null;
    Collection evenements = ut.getCollectionEvenements();
    Iterator itEvenements = evenements.iterator();
    while (itEvenements.hasNext())
    {
      objetChronoEvenement = (ObjetChronoEvenement)itEvenements.next();
      if (((objetChronoEvenement instanceof EvenementBaisseIndemnisationCSP)) && (objetChronoEvenement.getDateEvenement().coincideAvec(pbjcNcp.getDateFin()))) {
        pbjcNcp.ajouterComplementDeJustification("Q5");
      }
    }
    super.positionnerComplementJustification(pbjcNcp, ut, attribution);
  }
  
  public Quantite retournerQuantiteIndemnisationInitialeDroit(AttributionSpec attribution, UniteTraitement ut)
  {
    return ((AttributionAssuranceSpec)attribution).getDureeIndemnisationInitiale();
  }
  
  public void ajouterGroupeMontantProduit(PbjcNcp pbjcNcp, AttributionSpec attribution, Somme somme, UniteTraitement ut)
  {
    if ((somme.getMontant().getType().equals("FORMATION EFFECTIVE")) || (somme.getMontant().getType().equals("FORMATION PREVISIONNELLE"))) {
      ajouterGroupeMontantAREF(pbjcNcp, attribution.getProduitExecution().getNom(), somme, ut);
    } else {
      pbjcNcp.ajouterGroupeMontants(attribution.getProduitExecution().getNom(), 0, BigDecimal.ZERO, somme.getMontant().getMontantBrut().getValeur(), BigDecimal.ONE, somme.getMontant().getMontantBrut().getValeur(), "");
    }
    if (pbjcNcp.isTopApplicationCRC()) {
      ajouterGroupeMontantPCRC(pbjcNcp, somme.getMontant());
    }
    if (somme.getMontant().getMontantFinancement() != null) {
      ajouterGroupeMontantFinancement(pbjcNcp, attribution, somme);
    }
  }
  
  private void ajouterGroupeMontantFinancement(PbjcNcp pbjcNcp, AttributionSpec attribution, Somme somme)
  {
    pbjcNcp.ajouterGroupeMontants(ProduitAsuCva10P03.getInstance().recupererProduitAreActif(attribution).getNom(), 0, BigDecimal.ZERO, somme.getMontant().getMontantFinancement(), BigDecimal.ONE, somme.getMontant().getMontantFinancement(), "");
  }
}

/* Location:
 * Qualified Name:     FacadePBJCProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */