package fr.unedic.cali.asu.cve13.p01.calcul.outilsfonctionnels;

import fr.unedic.cali.asu.cge01.outilsfonctionnels.RevalorisationSalaire;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Sjc;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.parametres.ParametresIndemnisation;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.QuantiteDroitSpec;
import fr.unedic.cali.dom.QuantiteIndemnisationSpec;
import fr.unedic.cali.dom.RepriseSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;
import java.util.Collection;
import java.util.Iterator;

public class MajCi
{
  public static ConstituantsIndemnisation miseAJourConstituantsIndemnisation(AttributionSpec p_attribution, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_dateDeMiseAjour)
    throws CoucheLogiqueException
  {
    QuantiteDroitSpec dureeDroit = null;
    Collection collectionDurees = null;
    Iterator iterator = null;
    String codeFormuleMontant = null;
    
    codeFormuleMontant = p_constituantsIndemnisation.getCodeFormuleMontant();
    if (codeFormuleMontant != null) {
      miseAJourParametres(p_attribution, p_constituantsIndemnisation, p_dateDeMiseAjour);
    }
    collectionDurees = p_constituantsIndemnisation.getCollectionQuantiteDroit();
    if (collectionDurees != null)
    {
      iterator = collectionDurees.iterator();
      while (iterator.hasNext())
      {
        dureeDroit = (QuantiteDroitSpec)iterator.next();
        if ((dureeDroit instanceof QuantiteIndemnisationSpec)) {
          miseAJourParametres(p_attribution, p_constituantsIndemnisation, p_dateDeMiseAjour);
        }
      }
    }
    return p_constituantsIndemnisation;
  }
  
  private static void miseAJourParametres(AttributionSpec p_attribution, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_dateDeMiseAjour)
    throws CoucheLogiqueException
  {
    ParametresIndemnisation parametresIndemnisation = null;
    fr.unedic.cali.asu.cve13.p01.calcul.dom.ElementBaseIndemnisation elementBaseIndemnisation = null;
    Sjr nouveauSjr = null;
    Sjc nouveauSjc = null;
    Attribution attribution = (Attribution)p_attribution;
    BigDecimal tauxAvantageViellesse = null;
    
    parametresIndemnisation = ParametresIndemnisation.getParametresIndemnisation();
    
    elementBaseIndemnisation = (fr.unedic.cali.asu.cve13.p01.calcul.dom.ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
    
    tauxAvantageViellesse = parametresIndemnisation.getTauxAvantageViellesse(p_attribution.getDemandeur().getAgeALaDate(p_dateDeMiseAjour));
    if (tauxAvantageViellesse != null) {
      elementBaseIndemnisation.setTauxAvantageVieillesse(tauxAvantageViellesse);
    }
    boolean isPlafonne = false;
    if ((attribution instanceof RepriseSpec))
    {
      AttributionSpec attributionMaitre = attribution.getAttributionMaitre();
      if ((attributionMaitre != null) && (attributionMaitre.getDateAttribution() != null)) {
        nouveauSjr = RevalorisationSalaire.revaloriserSjr(attribution.getElementBaseIndemnisation().getSjr(), attributionMaitre.getDateAttribution(), isPlafonne);
      }
    }
    else
    {
      nouveauSjr = RevalorisationSalaire.revaloriserSjr(attribution.getElementBaseIndemnisation().getSjr(), attribution.getDateAttribution(), isPlafonne);
    }
    elementBaseIndemnisation.getSjrATP().setSalaire(nouveauSjr.getSalaire());
    if (attribution.getAttributionFinancement() != null)
    {
      Sjr sjrRevalorisePlafonne = RevalorisationSalaire.revaloriserSjr(attribution.getAttributionFinancement().getElementBaseIndemnisation().getSjr(), p_dateDeMiseAjour);
      elementBaseIndemnisation.getSjr().setSalaire(sjrRevalorisePlafonne.getSalaire());
    }
    nouveauSjc = RevalorisationSalaire.revaloriserSjc(attribution.getSJC(), p_dateDeMiseAjour);
    
    elementBaseIndemnisation.getSjc().setSalaire(nouveauSjc.getSalaire());
  }
}

/* Location:
 * Qualified Name:     MajCi
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */