package fr.unedic.cali.asu.ddm16.p01.calcul;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.calcul.FacadeCalculGammeImpl;
import fr.unedic.cali.asu.calcul.dom.ConstituantsCalculActiviteReduiteAsu;
import fr.unedic.cali.asu.calcul.dom.EtatAuDjiGamme;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeAssDemandeExpresse;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.RecuperationPensionInvaliditeAvantDate;
import fr.unedic.cali.asu.ddm16.p01.calcul.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.ddm16.p01.calcul.dom.FormuleMontantRegimeGeneral;
import fr.unedic.cali.asu.ddm16.p01.calcul.outilsfonctionnels.DefinitionStatutUtTraitementActiviteReduite;
import fr.unedic.cali.asu.ddm16.p01.calcul.outilsfonctionnels.MajCi;
import fr.unedic.cali.asu.ddm16.p01.calcul.outilsfonctionnels.PostTraitements;
import fr.unedic.cali.asu.ddm16.p01.calcul.outilsfonctionnels.Qualification;
import fr.unedic.cali.asu.ddm16.p01.calcul.outilsfonctionnels.TraitementActiviteReduite;
import fr.unedic.cali.asu.ddm16.p01.liquidation.dom.Admission;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.outilsfonctionnels.RechercheDecisionsInterruptives;
import fr.unedic.cali.asu.parametres.EvenementParametre;
import fr.unedic.cali.asu.parametres.ParametresIndemnisation;
import fr.unedic.cali.calcul.OutillageCalculADate;
import fr.unedic.cali.calcul.OutillagePeriodes;
import fr.unedic.cali.calcul.TraitementPeriodes;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculPeriodique;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculSpec;
import fr.unedic.cali.calcul.dom.ConstituantsCalculActiviteReduiteSpec;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.calcul.dom.EtatAuDji;
import fr.unedic.cali.calcul.dom.EvenementChangementParametre;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.periode.FinPeriodePensionInvalidite;
import fr.unedic.cali.calcul.dom.periode.PeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.periode.PeriodeExclusionDefinitiveDDTE;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormationNonIndemniseeAbsenceHeure;
import fr.unedic.cali.calcul.dom.periode.PeriodePensionInvalidite;
import fr.unedic.cali.calcul.dom.periode.PeriodeSuspensionDDTEAvecImputation;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeInterProduits;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionForcage;
import fr.unedic.cali.calcul.outilsfonctionnels.RecuperationAvantageVieillesseAvantPJI;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ContexteUT;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ElementBaseIndemnisationFacade;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodeAnalyseSpec;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodesPriseEnCompte;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.cali.dom.QuantiteDroitSpec;
import fr.unedic.cali.dom.SalaireJournalierSpec;
import fr.unedic.cali.dom.affectation.GammeSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P04;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.ProduitSolSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.outilsfonctionnels.Anomalie;
import fr.unedic.cali.outilsfonctionnels.GestionAnomalies;
import fr.unedic.cali.parcours.ResultatCalcul;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.Unite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

public class FacadeCalculProduitImpl
  extends FacadeCalculGammeImpl
{
  private static final int DIX = 10;
  private static final DureeCalendaire DUREE_6_MOIS = new DureeCalendaire(0, 6, 1);
  
  public int calculerCompteurFormationSurUT(fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
    throws CoucheLogiqueException
  {
    return 0;
  }
  
  public int calculerCompteurNombreJoursIndemnisesSurUT(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, int p_cumulNombreJoursServi)
  {
    return 0;
  }
  
  public int calculerCompteurNombreMoisIndemnisesSurUT(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, int p_nbMoisIndemniseEnDebutDUT)
  {
    int nbMoisIndemniseAsu = p_ut.getNbMoisIndemniseEnDebutDUT();
    
    Quantite quantiteIndemnise = p_ut.getQuantiteIndemnisee();
    if (quantiteIndemnise.getValeur().intValue() >= 1) {
      nbMoisIndemniseAsu += 1;
    }
    return nbMoisIndemniseAsu;
  }
  
  public void controleActiviteReduiteMaintienEuropeen(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ArretProduitAvecRaison p_arretProduitAvecRaison, ConstituantsIndemnisation p_constituantsIndemnisation)
    throws CoucheLogiqueException
  {}
  
  public Quantite convertir(Quantite p_quantite, Unite p_unite, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_dateDebutPa)
    throws CoucheLogiqueException
  {
    return p_quantite;
  }
  
  public ConstituantsCalculActiviteReduiteSpec creationConstituantsCalculActiviteReduite(AttributionSpec p_attribution, ContexteUT p_contexteUT, ConstituantsIndemnisation p_constituantsIndemnisation)
    throws CoucheLogiqueException
  {
    return new ConstituantsCalculActiviteReduiteAsu(0, ((Admission)p_attribution).getElementBaseIndemnisation().getSjr(), null);
  }
  
  public fr.unedic.cali.calcul.dom.UniteTraitement creerUT(Periode p_periodeUT, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return new fr.unedic.cali.asu.ddm16.p01.calcul.dom.UniteTraitement(Unite.get("jour"), p_periodeUT);
  }
  
  public ChronologiePeriodes decoupageEtProratisationPeriodesActivites(PeriodesPriseEnCompte p_periodesPriseEnCompte, int p_typePeriodeDeRefence, ChronologiePeriodes p_chronologieDePeriodesAProratiser, Periode p_periodeUT)
    throws CoucheLogiqueException
  {
    return p_chronologieDePeriodesAProratiser;
  }
  
  public void determinerStatutUT(AttributionSpec p_attribution, ChronologiePeriodes p_periodesDecalantes, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ArretProduitAvecRaison p_arretProduitAvecRaison, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    p_ut.setStatut(DefinitionStatutUtTraitementActiviteReduite.definirStatutUt(p_attribution, p_periodesDecalantes, false, p_ut, p_arretProduitAvecRaison, this));
    if (GestionForcage.appliquerForcageStatutEtCreditDecalage(p_attribution.getDemande(), p_ut)) {
      p_ut.setStatut(3);
    }
  }
  
  public boolean epuisementQuantiteDroit(Damj p_dateEpuisementQuantite, AttributionSpec p_attribution, QuantiteDroitSpec p_quantiteDroitEpuisee, ConstituantsIndemnisation p_constituantsIndemnisation, fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
    throws ApplicativeException
  {
    return false;
  }
  
  public void filtrePriseEnComptePeriodesActiviteSurUT(PeriodesPriseEnCompte p_periodesPriseEnCompte, Periode p_periodeUT, ContexteUT p_contexteUT, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {}
  
  public Damj getDateFinQuantiteDroit(Periode p_periode, AttributionSpec p_attribution, QuantiteDroitSpec p_quantiteDroit, ChronologiePeriodes p_chronologieRemplissage, Quantite p_quantiteAImputer, Damj p_dateDebutQuantiteDroit)
  {
    return OutillageCalculADate.remplirTrousChronologieParIndemnisation(p_chronologieRemplissage, p_quantiteAImputer, p_periode);
  }
  
  public Collection getEvtsChangementParametre(ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_date)
  {
    List evtsRetour = new ArrayList();
    EvenementParametre evtParam = ParametresIndemnisation.getParametresIndemnisation().getElementActif(p_date);
    Sjr sjr = ((ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant()).getSjr();
    if ((evtParam.isNouveauRevalorisationSjr()) && 
      (!sjr.getDateDepart().deplacerVersAvant(DUREE_6_MOIS).estApres(p_date)))
    {
      EvenementChangementParametre evt = new EvenementChangementParametre("REVALORISATION", evtParam.getDateEvenement());
      
      evtsRetour.add(evt);
    }
    return evtsRetour;
  }
  
  public Quantite getQuantiteIndemnisableTheorique(Periode p_periode, AttributionSpec p_attribution, ConstituantsIndemnisation p_constituantsIndemnisation, ContexteUT p_contexteUt)
  {
    return new QuantiteJour(new BigDecimal(p_periode.getDuree()));
  }
  
  public void imputerAvant(ObjetChronoPeriode p_periode, ConstituantsIndemnisation p_constituantsIndemnisation, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {}
  
  public void imputerQuantiteIndemnisationDuAuxSanctions(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, PeriodeSuspensionDDTEAvecImputation p_periodeSuspensionDDTEAvecImputation, ConstituantsIndemnisation p_constituantsIndemnisation, ArretProduitAvecRaison p_arretProduitAvecRaison)
    throws ApplicativeException
  {}
  
  public void initialisationQuantitesIndemnisation(ConstituantsIndemnisation p_constituantsIndemnisation, AttributionSpec p_attribution, Periode p_periodeUT)
    throws ApplicativeException
  {
    initialiseElementBaseIndemnisationCourante(p_constituantsIndemnisation, p_attribution, p_periodeUT);
  }
  
  public void initialiseElementBaseIndemnisationCourante(ConstituantsIndemnisation p_constituantsIndemnisation, AttributionSpec p_attribution, Periode p_periodeUT)
    throws CoucheLogiqueException
  {
    if (p_constituantsIndemnisation.getElementBaseIndemnisationCourant() == null)
    {
      Admission attribution = (Admission)p_attribution;
      ElementBaseIndemnisation elementBaseIndemnisationCourant = new ElementBaseIndemnisation();
      ElementBaseIndemnisation ebiAttrib = attribution.getElementBaseIndemnisation();
      
      p_constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationCourant);
      if (ebiAttrib.getCoefficientSaisonnier() != null) {
        elementBaseIndemnisationCourant.setCoefficientSaisonnier(ebiAttrib.getCoefficientSaisonnier());
      } else {
        elementBaseIndemnisationCourant.setCoefficientSaisonnier(new BigDecimal("1"));
      }
      if (ebiAttrib.getCoefficientTempsPartiel() != null) {
        elementBaseIndemnisationCourant.setCoefficientTempsPartiel(ebiAttrib.getCoefficientTempsPartiel());
      } else {
        elementBaseIndemnisationCourant.setCoefficientTempsPartiel(new BigDecimal("1"));
      }
      SalaireJournalierSpec salaireJournalier = ebiAttrib.getSjr();
      elementBaseIndemnisationCourant.setSjr((Sjr)salaireJournalier);
      
      elementBaseIndemnisationCourant.setCoefficientSanctionReduction(new BigDecimal("1.00"));
      
      BigDecimal montantPI = RecuperationPensionInvaliditeAvantDate.recuperationMontantPI(attribution.getDemandeur(), attribution.getPji().veille());
      if (montantPI != null) {
        elementBaseIndemnisationCourant.setMontantPensionInvaliditeADeduire(montantPI);
      }
      PeriodeAvantageVieillesse periodeAvCourante = RecuperationAvantageVieillesseAvantPJI.recupererPeriodeAvADate(attribution.getDemandeur(), attribution.getPji().veille());
      
      BigDecimal montantAV = new BigDecimal(0);
      if (periodeAvCourante != null)
      {
        montantAV = periodeAvCourante.getQuantiteEuro().getValeur();
        
        elementBaseIndemnisationCourant.setDateEffetAV(attribution.getPji().veille());
      }
      ProduitAsuSpec produitARE = ProduitAsuCge01P04.getInstance();
      
      Sjr sjrrp = (Sjr)produitARE.revaloriserSalaireJournalierReference(ebiAttrib.getSjr().getSalaire(), ebiAttrib.getSjr().getDateDepart(), attribution.getDateAttribution(), ebiAttrib.getSjr().getContexteParticulier());
      
      BigDecimal coeffAV = montantAV.divide(sjrrp.getSalaire(), 10, 4);
      elementBaseIndemnisationCourant.setCoefficientAvantageVieillesse(coeffAV);
      elementBaseIndemnisationCourant.setMontantAvantageVieillesse(coeffAV.multiply(sjrrp.getSalaire()));
      
      elementBaseIndemnisationCourant.setSjrRP(sjrrp);
      
      elementBaseIndemnisationCourant.setAgeALaDateCalcul(p_attribution.getDemandeur().getAgeALaDate(p_periodeUT.getDebut()));
    }
  }
  
  public int initialiserCompteurFormation(AttributionSpec p_attribution)
  {
    return 0;
  }
  
  public int initialiserNombreMoisIndemnise(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    return 0;
  }
  
  public ElementBaseIndemnisationFacade mapperUTVersElementBaseIndemnisation(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, AttributionSpec p_attribution)
  {
    ElementBaseIndemnisationFacade elt = new ElementBaseIndemnisationFacade();
    ElementBaseIndemnisation eltBase = null;
    eltBase = (ElementBaseIndemnisation)p_ut.getConstituantsIndemnisationEnFinUT().getElementBaseIndemnisationCourant();
    
    elt.setCoefficientAvantageVieillesse(eltBase.getCoefficientAvantageVieillesse().toString());
    if (eltBase.getCoefficientSaisonnier() != null) {
      elt.setCoefficientSaisonnier(eltBase.getCoefficientSaisonnier().toString());
    }
    if (eltBase.getCoefficientTempsPartiel() != null) {
      elt.setCoefficientTempsPartiel(eltBase.getCoefficientTempsPartiel().toString());
    }
    if (eltBase.getMontantPensionInvaliditeADeduire() != null) {
      elt.setMontantPensionInvaliditeADeduire(eltBase.getMontantPensionInvaliditeADeduire().toString());
    }
    if (eltBase.getMontantAvantageVieillesse() != null) {
      elt.setMontantAvantageVieillesse(eltBase.getMontantAvantageVieillesse().toString());
    }
    if (eltBase.getSjrRP().getSalaire() != null) {
      elt.setSjr(eltBase.getSjrRP().getSalaire().setScale(2, 6).toString());
    }
    if (eltBase.getTauxAvantageVieillesse() != null) {
      elt.setTauxAvantageVieillesse(elt.getTauxAvantageVieillesse());
    }
    return elt;
  }
  
  public ConstituantsIndemnisation miseAJourConstituantsIndemnisation(fr.unedic.cali.calcul.dom.UniteTraitement ut, AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, Damj dateDeMiseAjour, Periode periode)
    throws CoucheLogiqueException
  {
    return MajCi.miseAJourConstituantsIndemnisation(attribution, constituantsIndemnisation, dateDeMiseAjour);
  }
  
  public void miseAJourConstituantsIndemnisationADate(AttributionSpec p_attribution, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_date, ChronologiePeriodes p_chronologiePeriodesSanctions)
    throws CoucheLogiqueException
  {
    ElementBaseIndemnisation elementBaseIndemnisationCourant = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
    
    elementBaseIndemnisationCourant.setMontantPensionInvaliditeADeduire(RecuperationPensionInvaliditeAvantDate.recuperationMontantPI(p_attribution.getDemandeur(), p_date.veille()));
    
    elementBaseIndemnisationCourant.setCoefficientAvantageVieillesse(new BigDecimal(0));
    elementBaseIndemnisationCourant.setMontantAvantageVieillesse(new BigDecimal(0));
    
    PeriodeAvantageVieillesse periodeAvCourante = RecuperationAvantageVieillesseAvantPJI.recupererPeriodeAvADate(((Admission)p_attribution).getDemandeur(), p_date.veille());
    if (periodeAvCourante != null)
    {
      Damj dateDepart = Damj.max(p_attribution.getDateAttribution(), periodeAvCourante.getDateDebut());
      
      ProduitAsuSpec produitARE = ProduitAsuCge01P04.getInstance();
      Sjr sjrDepart = (Sjr)produitARE.revaloriserSalaireJournalierReference(elementBaseIndemnisationCourant.getSjr().getSalaire(), elementBaseIndemnisationCourant.getSjr().getDateDepart(), dateDepart, elementBaseIndemnisationCourant.getSjr().getContexteParticulier());
      
      BigDecimal coeffAV = periodeAvCourante.getQuantiteEuro().getValeur().divide(sjrDepart.getSalaire(), 10, 4);
      elementBaseIndemnisationCourant.setCoefficientAvantageVieillesse(coeffAV);
      
      Sjr sjrCourant = (Sjr)produitARE.revaloriserSalaireJournalierReference(elementBaseIndemnisationCourant.getSjr().getSalaire(), elementBaseIndemnisationCourant.getSjr().getDateDepart(), p_date.veille(), elementBaseIndemnisationCourant.getSjr().getContexteParticulier());
      
      elementBaseIndemnisationCourant.setCoefficientAvantageVieillesse(coeffAV);
      elementBaseIndemnisationCourant.setMontantAvantageVieillesse(coeffAV.multiply(sjrCourant.getSalaire()));
      
      elementBaseIndemnisationCourant.setDateEffetAV(p_date.veille());
    }
    elementBaseIndemnisationCourant.setCoefficientSanctionReduction(new BigDecimal("1"));
    
    elementBaseIndemnisationCourant.setAgeALaDateCalcul(p_attribution.getDemandeur().getAgeALaDate(p_date));
  }
  
  public ConstituantsCalculActiviteReduiteSpec miseAJourCumulAR(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, AttributionSpec p_attribution, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, ContexteUT p_contexteUT, ArretProduitAvecRaison p_arretProduitAvecRaison)
    throws CoucheLogiqueException
  {
    return p_constituantsCalculActiviteReduite;
  }
  
  public ConstituantsCalculActiviteReduiteSpec miseAjourConstituantsCalculActiviteReduite(AttributionSpec p_attribution, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite, Damj p_dateDeMiseAjour, ConstituantsIndemnisation p_constituantsIndemnisation)
    throws CoucheLogiqueException
  {
    Admission attribution = (Admission)p_attribution;
    ConstituantsCalculActiviteReduiteAsu constituantsCalculActiviteReduiteProduit = (ConstituantsCalculActiviteReduiteAsu)p_constituantsCalculActiviteReduite;
    
    ElementBaseIndemnisation elementBaseIndemnisationCourant = attribution.getElementBaseIndemnisation();
    
    ProduitAsuSpec produitARE = ProduitAsuCge01P04.getInstance();
    Sjr sjrDepart = (Sjr)produitARE.revaloriserSalaireJournalierReference(elementBaseIndemnisationCourant.getSjr().getSalaire(), elementBaseIndemnisationCourant.getSjr().getDateDepart(), p_dateDeMiseAjour, elementBaseIndemnisationCourant.getSjr().getContexteParticulier());
    
    constituantsCalculActiviteReduiteProduit.setSjr(sjrDepart);
    
    return constituantsCalculActiviteReduiteProduit;
  }
  
  public QualificationPeriodes qualificationPeriodes(ChronologiePeriodes p_chronologiePeriodes, AttributionSpec p_attribution, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    return new Qualification().qualificationPeriodes(p_chronologiePeriodes, p_attribution);
  }
  
  public void realiserDetectionFinDeProduitPourSuivi(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {}
  
  public AttributionSpec rechercherAttributionPrecedenteSurLUT(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return ((AttributionAssuranceSpec)p_attribution).getAttributionPrecedente();
  }
  
  public boolean recuperationAlimentationNombreMoisIndemnise(AttributionSpec p_attribution)
  {
    return true;
  }
  
  public String recupererCategorieAttribution(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
    throws CoucheLogiqueException
  {
    return null;
  }
  
  public ChronologiePeriodes recupererPeriodesLieesAuContexte(ContexteUT p_contexteUT, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes chronologiePeriodes = new ChronologiePeriodes();
    
    Collection collectionPeriode = p_contexteUT.getPeriodesInterProduitsSurUTDateDepartAttributionPourGamme(p_attribution, "ASU");
    
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "SOL_AER05_01"));
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "SOL_AER05_02"));
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "SOL_AER05_03"));
    
    List liste = p_contexteUT.getListeAttributions();
    if (liste != null)
    {
      Iterator iterator = liste.iterator();
      while (iterator.hasNext())
      {
        AttributionSpec attribution = (AttributionSpec)iterator.next();
        if (attribution.getGamme().getNomUnique().equals("SOL")) {
          if ((attribution.getProduit().getNomUnique().equals("SOL_AER05_01")) || (attribution.getProduit().getNomUnique().equals("SOL_AER05_02")) || (attribution.getProduit().getNomUnique().equals("SOL_AER05_03")))
          {
            Damj djiTheoriqueAER = ((ProduitSolSpec)attribution.getProduit()).getDjiTheoriqueAER(attribution);
            chronologiePeriodes.ajouter(new ObjetChronoPeriodeInterProduits(djiTheoriqueAER.lendemain(), djiTheoriqueAER.lendemain(), 5, attribution));
          }
        }
      }
    }
    collectionPeriode.addAll(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartAttributionPourProduit(p_attribution, "INR_RCE04_01"));
    
    chronologiePeriodes.ajouter(collectionPeriode);
    
    chronologiePeriodes.ajouter(RechercheDecisionsInterruptives.rechercher(p_attribution.getDemandeur(), p_attribution.getPji(), p_attribution));
    
    chronologiePeriodes.ajouter(p_contexteUT.getPeriodesInterProduitsPeriodesLieuSurUTPourGammeRBF(p_attribution));
    
    chronologiePeriodes.ajouter(p_contexteUT.getPeriodesInterProduitsSurUTIndemnisationRfpe(p_attribution));
    
    chronologiePeriodes.ajouter(p_contexteUT.getPeriodesInterProduitsSurUTDateDepartPjiPourProduit(p_attribution, "RET_ACO01_01"));
    
    return chronologiePeriodes;
  }
  
  public EtatAuDji renseignerEtatAuDji(fr.unedic.cali.calcul.dom.UniteTraitement p_derniereUT, CalendrierExecutionCalculPeriodique p_calendrier, AttributionSpec p_attribution, EtatAuDji p_etatAuDji)
    throws CoucheLogiqueException
  {
    EtatAuDjiGamme etatAuDji = new EtatAuDjiGamme();
    
    etatAuDji.setMontant(p_etatAuDji.getMontant());
    
    etatAuDji.setNbMoisIndemniseAsu(p_derniereUT.getNbMoisIndemniseAsu());
    
    etatAuDji.setEstNbMoisIndemniseAsu(p_derniereUT.isEstNbMoisIndemniseAsu());
    
    return etatAuDji;
  }
  
  public void traitementPeriodeSegmentante(AttributionSpec p_attribution, ObjetChronoPeriode p_periode, ConstituantsIndemnisation p_constituantsIndemnisation, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, PeriodeAnalyseSpec p_pa, ArretProduitAvecRaison p_arretProduitAvecRaison, ChronologiePeriodes p_periodesAnalyses)
    throws ApplicativeException
  {
    if (((p_periode instanceof PeriodePensionInvalidite)) && (p_periode.getDateDebut().estApresOuCoincideAvec(p_attribution.getPji())))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
      elementBaseIndemnisation.setMontantPensionInvaliditeADeduire(elementBaseIndemnisation.getMontantPensionInvaliditeADeduire().add(((PeriodePensionInvalidite)p_periode).getQuantiteEuro().getValeur()));
    }
    else if (((p_periode instanceof PeriodeAvantageVieillesse)) && (p_periode.getDateDebut().estApresOuCoincideAvec(p_attribution.getPji())))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
      
      BigDecimal montantAv = null;
      if ((elementBaseIndemnisation.getDateEffetAV() == null) || (elementBaseIndemnisation.getDateEffetAV().estAvant(p_periode.getDateDebut())))
      {
        montantAv = ((PeriodeAvantageVieillesse)p_periode).getQuantiteEuro().getValeur();
        elementBaseIndemnisation.setDateEffetAV(p_periode.getDateDebut());
      }
      else if (elementBaseIndemnisation.getDateEffetAV().coincideAvec(p_periode.getDateDebut()))
      {
        montantAv = elementBaseIndemnisation.getMontantAvantageVieillesse().add(((PeriodeAvantageVieillesse)p_periode).getQuantiteEuro().getValeur());
      }
      if (montantAv != null)
      {
        elementBaseIndemnisation.setMontantAvantageVieillesse(montantAv);
        
        elementBaseIndemnisation.setDateEffetAV(p_periode.getDateDebut());
        Damj dateDepart = Damj.max(p_periode.getDateDebut(), p_attribution.getDateAttribution());
        
        ProduitAsuSpec produitARE = ProduitAsuCge01P04.getInstance();
        Sjr sjrrp = (Sjr)produitARE.revaloriserSalaireJournalierReference(elementBaseIndemnisation.getSjr().getSalaire(), elementBaseIndemnisation.getSjr().getDateDepart(), dateDepart, elementBaseIndemnisation.getSjr().getContexteParticulier());
        if ((sjrrp != null) && (sjrrp.getSalaire() != null) && (!sjrrp.getSalaire().equals(new BigDecimal("0.00"))))
        {
          BigDecimal coeffAV = montantAv.divide(sjrrp.getSalaire(), 10, 4);
          elementBaseIndemnisation.setCoefficientAvantageVieillesse(coeffAV);
        }
      }
    }
    else if (((p_periode instanceof FinPeriodeAvantageVieillesse)) && (((p_pa != null) && (p_pa.getDateDebut().equals(p_periode.getDateDebut()))) || ((p_pa == null) && (p_periode.getDateDebut().estContenueDans(p_ut.getPeriode())))))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
      
      elementBaseIndemnisation.setCoefficientAvantageVieillesse(new BigDecimal("0"));
      elementBaseIndemnisation.setMontantAvantageVieillesse(new BigDecimal("0"));
    }
    else if (((p_periode instanceof FinPeriodePensionInvalidite)) && (((p_pa != null) && (p_pa.getDateDebut().equals(p_periode.getDateDebut()))) || ((p_pa == null) && (p_periode.getDateDebut().estContenueDans(p_ut.getPeriode())))))
    {
      ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
      elementBaseIndemnisation.setMontantPensionInvaliditeADeduire(elementBaseIndemnisation.getMontantPensionInvaliditeADeduire().subtract(((FinPeriodePensionInvalidite)p_periode).getQuantiteEuro().getValeur()));
    }
  }
  
  public void traitementPeriodesAlertantes(AttributionSpec p_attribution, ObjetChronoPeriode p_periode, ConstituantsIndemnisation p_constituantsIndemnisation, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, PeriodeAnalyseSpec p_pa, ArretProduitAvecRaison p_arretProduitAvecRaison)
    throws ApplicativeException
  {}
  
  public void traitementPeriodesDecalantes(AttributionSpec p_attribution, ChronologiePeriodes p_periodes, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduiteSpec, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ConstituantsIndemnisation p_constituantsIndemnisation, ContexteUT p_contexteUT)
    throws CoucheLogiqueException
  {
    TraitementActiviteReduite.traitementPeriodesDecalantes(p_attribution, p_periodes, p_constituantsCalculActiviteReduiteSpec, p_ut);
  }
  
  public void traitementPeriodesGelantes(AttributionSpec p_attribution, ChronologiePeriodes p_periodes, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduiteSpec, fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
    throws CoucheLogiqueException
  {
    TraitementActiviteReduite.traitementPeriodesGelantes(p_ut);
  }
  
  public void traitementPeriodesSuspensives(AttributionSpec p_attribution, ChronologiePeriodes p_periodes, PeriodeAnalyseSpec p_pa)
    throws CoucheLogiqueException
  {
    Quantite quantiteSuspensive = TraitementPeriodes.getQuantiteSuspensive(p_pa.getPeriode(), p_pa.getQuantiteIndemnisable(), p_periodes);
    p_pa.setQuantiteNonIndemnisee(p_pa.getQuantiteNonIndemnisee().ajouter(quantiteSuspensive));
  }
  
  public void traiterPeriodeInterruptiveDefinitive(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ObjetChronoPeriode p_objetChronoPeriode, ArretProduitAvecRaison p_arretProduitAvecRaison, CalendrierExecutionCalculPeriodique calendrier)
    throws CoucheLogiqueException
  {
    if ((p_objetChronoPeriode instanceof ObjetChronoPeriodeAssDemandeExpresse)) {
      p_arretProduitAvecRaison.setProduitAEteindre(true);
    } else if ((p_objetChronoPeriode instanceof PeriodeExclusionDefinitiveDDTE)) {
      p_arretProduitAvecRaison.setProduitAEteindre(true);
    } else if ((p_objetChronoPeriode instanceof PeriodeFormationNonIndemniseeAbsenceHeure)) {
      GestionAnomalies.ajouteAnomalie(new Anomalie("M06", p_objetChronoPeriode.getDateDebut(), ""), p_attribution.getDemandeur());
    }
  }
  
  public boolean verifierConditionExecutionEtEventuelAbandon(AttributionSpec p_attribution, ContexteUT p_contexteUT, Periode p_periodeUT, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul)
    throws CoucheLogiqueException
  {
    return true;
  }
  
  public boolean verifierImputationDuree(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, ConstituantsIndemnisation p_constituantsIndemnisation)
    throws CoucheLogiqueException
  {
    return true;
  }
  
  public MontantBaseSpec calculMontant(FormuleMontantSpec p_formuleMontant, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_dateCalcul)
    throws CoucheLogiqueException
  {
    return p_formuleMontant.calculer(p_constituantsIndemnisation, p_dateCalcul);
  }
  
  public ConstituantsIndemnisation creationConstituantsIndemnisation(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    ConstituantsIndemnisation constituantsIndemnisation = new ConstituantsIndemnisation();
    constituantsIndemnisation.setCodeFormuleMontant("1");
    return constituantsIndemnisation;
  }
  
  public CalendrierExecutionCalculSpec creerCalendrierExecutionCalcul(AttributionSpec p_attribution)
  {
    return new fr.unedic.cali.asu.ddm16.p01.calcul.dom.CalendrierExecutionCalcul();
  }
  
  public boolean enregistrerDroitPBJCNCP(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return true;
  }
  
  public boolean enregistrerEnquetePBJCNCP()
  {
    return true;
  }
  
  public boolean estEnActiviteConservee(AttributionSpec p_attribution, fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
    throws CoucheLogiqueException
  {
    return false;
  }
  
  public Damj getDjiMaintienEuropeenDuDroit(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return null;
  }
  
  public FormuleMontantSpec getFormuleMontant(String p_code)
  {
    FormuleMontantSpec fm = null;
    if (FormuleMontantRegimeGeneral.getCode().equals(p_code)) {
      fm = new FormuleMontantRegimeGeneral();
    }
    return fm;
  }
  
  public Damj getIdeMaintienEuropeenDuDroit(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return null;
  }
  
  public Damj getPjiMaintienEuropeenDuDroit(AttributionSpec p_attribution)
  {
    return null;
  }
  
  public boolean neutralisationApplicableRetourUL961()
  {
    return false;
  }
  
  public ResultatCalcul postTraitementResultatDetaille(AttributionSpec p_attribution, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul)
    throws CoucheLogiqueException
  {
    return PostTraitements.postTraitementResultatDetaille(p_attribution, (fr.unedic.cali.calcul.dom.CalendrierExecutionCalcul)p_calendrierExecutionCalcul);
  }
  
  public ResultatCalcul postTraitementResultatDetailleNotification(AttributionSpec p_attribution, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul)
    throws CoucheLogiqueException
  {
    return PostTraitements.postTraitementResultatDetailleNotification(p_attribution, (fr.unedic.cali.calcul.dom.CalendrierExecutionCalcul)p_calendrierExecutionCalcul);
  }
  
  public ResultatCalcul postTraitementResultatDeterminationEtatDroit(AttributionSpec p_attribution, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul, Damj p_dateEtatDroit)
    throws CoucheLogiqueException
  {
    return PostTraitements.postTraitementResultatDeterminationEtatDroit(p_attribution, (fr.unedic.cali.calcul.dom.CalendrierExecutionCalcul)p_calendrierExecutionCalcul, p_dateEtatDroit);
  }
  
  public ResultatCalcul postTraitementResultatMigrationCalcul(AttributionSpec p_attribution, CalendrierExecutionCalculSpec p_calendrierExecutionCalcul)
    throws CoucheLogiqueException
  {
    return null;
  }
  
  public Damj recupererDateFinDroitTheorique(CalendrierExecutionCalculSpec p_calendrierExecutionCalcul, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    return p_calendrierExecutionCalcul.getDernierJourIndemnisable();
  }
  
  public ChronologiePeriodes recupererPeriodesProduit(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesIndividuelles = null;
    IndividuSpec individu = null;
    
    periodesIndividuelles = new ChronologiePeriodes();
    individu = p_attribution.getDemandeur();
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire50Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire55Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire60Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererPeriodeRetraite(individu));
    if (individu.getDernierJourAtteste() != null) {
      periodesIndividuelles.ajouter(OutillagePeriodes.genererLendemainDja(individu));
    }
    return periodesIndividuelles;
  }
  
  public boolean verifierEligibilitePaiementParAvance(fr.unedic.cali.calcul.dom.UniteTraitement p_ut)
  {
    p_ut.setRaisonStatut(1);
    return false;
  }
  
  public fr.unedic.cali.calcul.dom.EvenementFinQuantiteDroit creerEvenementFinQuantiteDroit(Damj p_dateEffet, QuantiteDroitSpec p_quantiteDroit)
  {
    return new fr.unedic.cali.asu.ddm16.p01.calcul.dom.EvenementFinQuantiteDroit(p_dateEffet, p_quantiteDroit);
  }
  
  public fr.unedic.cali.calcul.dom.periode.DsmTravail convertirDsmTravailVersDsmTravailProduit(fr.unedic.cali.calcul.dom.periode.DsmTravail p_dsmTravail)
  {
    return new fr.unedic.cali.asu.ddm16.p01.calcul.dom.periode.DsmTravail(p_dsmTravail);
  }
  
  public void postTraitementQualification(fr.unedic.cali.calcul.dom.UniteTraitement p_ut, QualificationPeriodes p_qualificationPeriodes)
    throws CoucheLogiqueException
  {}
  
  public fr.unedic.cali.calcul.dom.UniteTraitementForcee creerUniteTraitementForcee(Damj p_dateDebut, Damj p_dateFin)
  {
    return new fr.unedic.cali.ari.calcul.dom.UniteTraitementForcee(p_dateDebut, p_dateFin);
  }
}

/* Location:
 * Qualified Name:     FacadeCalculProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */