package fr.unedic.cali.asu.dom;

import fr.unedic.cali.asu.dom.gen.PeriodeElementaireGen;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.PeriodeIntensite;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import fr.unedic.util.temps.Periode;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

public class PeriodeElementaire
  extends PeriodeElementaireGen
  implements PeriodeAffiliationSpec, ObjetPersistantSpec
{
  private static final long serialVersionUID = 7840480160143538581L;
  public static final int TAUX_PLEIN = 1;
  private transient Map mQuantitesAffiliationInitiales;
  private transient PeriodeIntensite mPeriodeIntensite;
  private transient ActiviteSalarie mActiviteSalarie;
  private transient boolean mPresenceHeureComplementaire;
  
  public PeriodeElementaire()
  {
    mQuantitesAffiliationInitiales = new HashMap();
  }
  
  public PeriodeElementaire(DomPCSpec pc)
  {
    super(pc);
    mQuantitesAffiliationInitiales = new HashMap();
  }
  
  public Periode getPeriode()
  {
    return getPeriodePE();
  }
  
  public String getLibelle()
  {
    return getRaisonSociale() + " " + getReglement();
  }
  
  public ObjetMetierSpec copie()
  {
    PeriodeElementaire copie = new PeriodeElementaire();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec pCopie)
  {
    PeriodeElementaire copie = (PeriodeElementaire)pCopie;
    copie.setEstSanctionnee(isEstSanctionnee());
    copie.setIdPeriodeActivite(getIdPeriodeActivite());
    copie.setIntensite(getIntensite());
    copie.setNature(getNature());
    copie.setPeriodeActiviteSalariee(getPeriodeActiviteSalariee());
    copie.setPeriodePE(getPeriodePE());
    copie.setQuantiteInitialeHeure(getQuantiteInitialeHeure());
    copie.setQuantitePlafonnee(getQuantitePlafonnee());
    copie.setQuantiteRetenue(getQuantiteRetenue());
    copie.setRaisonSociale(getRaisonSociale());
    copie.setReglement(getReglement());
    copie.setPeriodeIntensite(getPeriodeIntensite());
    copie.setActiviteSalarie(getActiviteSalarie());
    copie.setPresenceHeureComplementaire(isPresenceHeureComplementaire());
    
    Iterator it = getListQuantiteAffiliationInitiales().iterator();
    while (it.hasNext())
    {
      Quantite quantite = (Quantite)it.next();
      copie.ajouterQuantiteAffiliationInitiale(quantite);
    }
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public void marquerGraphePersistant() {}
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public Collection getListQuantiteAffiliationInitiales()
  {
    return mQuantitesAffiliationInitiales.values();
  }
  
  public void ajouterQuantiteAffiliationInitiale(Quantite quantite)
  {
    if (quantite != null) {
      mQuantitesAffiliationInitiales.put(quantite.getUnite(), quantite);
    }
  }
  
  public Quantite getQuantiteAffiliationInitiale(Unite unite)
  {
    return (Quantite)mQuantitesAffiliationInitiales.get(unite);
  }
  
  public PeriodeIntensite getPeriodeIntensite()
  {
    return mPeriodeIntensite;
  }
  
  public void setPeriodeIntensite(PeriodeIntensite periodeIntensite)
  {
    mPeriodeIntensite = periodeIntensite;
  }
  
  public ActiviteSalarie getActiviteSalarie()
  {
    return mActiviteSalarie;
  }
  
  public void setActiviteSalarie(ActiviteSalarie activiteSalarie)
  {
    mActiviteSalarie = activiteSalarie;
  }
  
  public boolean isPresenceHeureComplementaire()
  {
    return mPresenceHeureComplementaire;
  }
  
  public void setPresenceHeureComplementaire(boolean presenceHeureComplementaire)
  {
    mPresenceHeureComplementaire = presenceHeureComplementaire;
  }
}

/* Location:
 * Qualified Name:     PeriodeElementaire
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */