package fr.unedic.cali.asu.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.dom.pc.DemandePC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public abstract class DonneesSortieNPDEGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_demandePC;
  private String m_modeTraitementDemande;
  private String m_motifEchecTraitempent;
  private Damj m_dateTraitementDemande;
  
  public DonneesSortieNPDEGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public DomPCSpec getPC()
  {
    return m_demandePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_demandePC)
  {
    m_demandePC = p_demandePC;
  }
  
  protected String rawGetModeTraitementDemande()
  {
    return ((DemandePC)getPC()).getModeTraitementDemande();
  }
  
  public String getModeTraitementDemande()
  {
    return ((DemandePC)getPC()).getModeTraitementDemande();
  }
  
  public void setModeTraitementDemande(String p_modeTraitementDemande)
  {
    if ((m_modeTraitementDemande == null) || (p_modeTraitementDemande == null))
    {
      m_modeTraitementDemande = p_modeTraitementDemande;
      ((DemandePC)getPC()).setModeTraitementDemande(p_modeTraitementDemande);
    }
    else if ((m_modeTraitementDemande != null) && (p_modeTraitementDemande != null) && (!p_modeTraitementDemande.equals(m_modeTraitementDemande)))
    {
      m_modeTraitementDemande = p_modeTraitementDemande;
      ((DemandePC)getPC()).setModeTraitementDemande(p_modeTraitementDemande);
    }
  }
  
  protected String rawGetMotifEchecTraitempent()
  {
    return ((DemandePC)getPC()).getMotifEchecTraitement();
  }
  
  public String getMotifEchecTraitempent()
  {
    return ((DemandePC)getPC()).getMotifEchecTraitement();
  }
  
  public void setMotifEchecTraitempent(String p_motifEchecTraitempent)
  {
    if ((m_motifEchecTraitempent == null) || (p_motifEchecTraitempent == null))
    {
      m_motifEchecTraitempent = p_motifEchecTraitempent;
      ((DemandePC)getPC()).setMotifEchecTraitement(p_motifEchecTraitempent);
    }
    else if ((m_motifEchecTraitempent != null) && (p_motifEchecTraitempent != null) && (!p_motifEchecTraitempent.equals(m_motifEchecTraitempent)))
    {
      m_motifEchecTraitempent = p_motifEchecTraitempent;
      ((DemandePC)getPC()).setMotifEchecTraitement(p_motifEchecTraitempent);
    }
  }
  
  protected Damj rawGetDateTraitementDemande()
  {
    return ((DemandePC)getPC()).getDateTraitementDemande();
  }
  
  public Damj getDateTraitementDemande()
  {
    return ((DemandePC)getPC()).getDateTraitementDemande();
  }
  
  public void setDateTraitementDemande(Damj p_dateTraitementDemande)
  {
    if ((m_dateTraitementDemande == null) || (p_dateTraitementDemande == null))
    {
      m_dateTraitementDemande = p_dateTraitementDemande;
      ((DemandePC)getPC()).setDateTraitementDemande(p_dateTraitementDemande);
    }
    else if ((m_dateTraitementDemande != null) && (p_dateTraitementDemande != null) && (!p_dateTraitementDemande.equals(m_dateTraitementDemande)))
    {
      m_dateTraitementDemande = p_dateTraitementDemande;
      ((DemandePC)getPC()).setDateTraitementDemande(p_dateTraitementDemande);
    }
  }
  
  protected boolean rawIsAttenteIncohrenceSalaireLevee()
  {
    return ((DemandePC)getPC()).isAttenteIncoherenceSalaireLevee();
  }
  
  public boolean isAttenteIncohrenceSalaireLevee()
  {
    return ((DemandePC)getPC()).isAttenteIncoherenceSalaireLevee();
  }
  
  public void setAttenteIncohrenceSalaireLevee(boolean p_attenteIncohrenceSalaireLevee)
  {
    ((DemandePC)getPC()).setAttenteIncoherenceSalaireLevee(p_attenteIncohrenceSalaireLevee);
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    setModeTraitementDemande(null);
    setMotifEchecTraitempent(null);
    setDateTraitementDemande(null);
    setAttenteIncohrenceSalaireLevee(false);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     DonneesSortieNPDEGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */