package fr.unedic.cali.asu.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.dom.AffiliationAssimilee;
import fr.unedic.cali.asu.dom.AffiliationSupplementaire;
import fr.unedic.cali.asu.dom.PeriodeElementaire;
import fr.unedic.cali.asu.dom.pc.ElementZoneMemeExercicePC;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;

public abstract class ElementZoneMemeExerciceGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_elementZoneMemeExercicePC;
  private Quantite m_quantiteAffiliation;
  public PeriodeElementaire m_periodeElementaire;
  public AffiliationSupplementaire m_affiliationSupplementaire;
  public AffiliationAssimilee m_affiliationAssimilee;
  
  public ElementZoneMemeExerciceGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ElementZoneMemeExerciceGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ElementZoneMemeExercicePC();
  }
  
  public DomPCSpec getPC()
  {
    return m_elementZoneMemeExercicePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_elementZoneMemeExercicePC)
  {
    m_elementZoneMemeExercicePC = p_elementZoneMemeExercicePC;
  }
  
  protected Quantite rawGetQuantiteAffiliation()
  {
    return ((ElementZoneMemeExercicePC)getPC()).getQuantiteAffiliation();
  }
  
  public Quantite getQuantiteAffiliation()
  {
    return ((ElementZoneMemeExercicePC)getPC()).getQuantiteAffiliation();
  }
  
  public void setQuantiteAffiliation(Quantite p_quantiteAffiliation)
  {
    if ((m_quantiteAffiliation == null) || (p_quantiteAffiliation == null))
    {
      m_quantiteAffiliation = p_quantiteAffiliation;
      ((ElementZoneMemeExercicePC)getPC()).setQuantiteAffiliation(p_quantiteAffiliation);
    }
    else if ((m_quantiteAffiliation != null) && (p_quantiteAffiliation != null) && (!p_quantiteAffiliation.equals(m_quantiteAffiliation)))
    {
      m_quantiteAffiliation = p_quantiteAffiliation;
      ((ElementZoneMemeExercicePC)getPC()).setQuantiteAffiliation(p_quantiteAffiliation);
    }
  }
  
  public PeriodeElementaire getPeriodeElementaire()
  {
    if (m_periodeElementaire == null)
    {
      DomPCSpec periodeElementairePC = ((ElementZoneMemeExercicePC)getPC()).getPeriodeElementaire();
      if (periodeElementairePC != null) {
        m_periodeElementaire = ((PeriodeElementaire)periodeElementairePC.createOM());
      }
    }
    return m_periodeElementaire;
  }
  
  public void setPeriodeElementaire(PeriodeElementaire p_periodeElementaire)
  {
    if (p_periodeElementaire == null)
    {
      ((ElementZoneMemeExercicePC)getPC()).setPeriodeElementaire(null);
      m_periodeElementaire = p_periodeElementaire;
    }
    else if (!p_periodeElementaire.equals(m_periodeElementaire))
    {
      ((ElementZoneMemeExercicePC)getPC()).setPeriodeElementaire(p_periodeElementaire.getPC());
      m_periodeElementaire = p_periodeElementaire;
    }
  }
  
  public AffiliationSupplementaire getAffiliationSupplementaire()
  {
    if (m_affiliationSupplementaire == null)
    {
      DomPCSpec affiliationSupplementairePC = ((ElementZoneMemeExercicePC)getPC()).getAffiliationSupplementaire();
      if (affiliationSupplementairePC != null) {
        m_affiliationSupplementaire = ((AffiliationSupplementaire)affiliationSupplementairePC.createOM());
      }
    }
    return m_affiliationSupplementaire;
  }
  
  public void setAffiliationSupplementaire(AffiliationSupplementaire p_affiliationSupplementaire)
  {
    if (p_affiliationSupplementaire == null)
    {
      ((ElementZoneMemeExercicePC)getPC()).setAffiliationSupplementaire(null);
      m_affiliationSupplementaire = p_affiliationSupplementaire;
    }
    else if (!p_affiliationSupplementaire.equals(m_affiliationSupplementaire))
    {
      ((ElementZoneMemeExercicePC)getPC()).setAffiliationSupplementaire(p_affiliationSupplementaire.getPC());
      m_affiliationSupplementaire = p_affiliationSupplementaire;
    }
  }
  
  public AffiliationAssimilee getAffiliationAssimilee()
  {
    if (m_affiliationAssimilee == null)
    {
      DomPCSpec affiliationAssimileePC = ((ElementZoneMemeExercicePC)getPC()).getAffiliationAssimilee();
      if (affiliationAssimileePC != null) {
        m_affiliationAssimilee = ((AffiliationAssimilee)affiliationAssimileePC.createOM());
      }
    }
    return m_affiliationAssimilee;
  }
  
  public void setAffiliationAssimilee(AffiliationAssimilee p_affiliationAssimilee)
  {
    if (p_affiliationAssimilee == null)
    {
      ((ElementZoneMemeExercicePC)getPC()).setAffiliationAssimilee(null);
      m_affiliationAssimilee = p_affiliationAssimilee;
    }
    else if (!p_affiliationAssimilee.equals(m_affiliationAssimilee))
    {
      ((ElementZoneMemeExercicePC)getPC()).setAffiliationAssimilee(p_affiliationAssimilee.getPC());
      m_affiliationAssimilee = p_affiliationAssimilee;
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    Object periodeElementaire = getPeriodeElementaire();
    if ((periodeElementaire != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(periodeElementaire))) {
      DomManager.supprimer(getPeriodeElementaire(), p_contexteSuppression);
    }
    Object affiliationSupplementaire = getAffiliationSupplementaire();
    if ((affiliationSupplementaire != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(affiliationSupplementaire))) {
      DomManager.supprimer(getAffiliationSupplementaire(), p_contexteSuppression);
    }
    Object affiliationAssimilee = getAffiliationAssimilee();
    if ((affiliationAssimilee != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(affiliationAssimilee))) {
      DomManager.supprimer(getAffiliationAssimilee(), p_contexteSuppression);
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ElementZoneMemeExerciceGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */