package fr.unedic.cali.asu.dom.pc;

import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;
import java.io.IOException;
import java.io.ObjectOutputStream;
import javax.jdo.JDOFatalInternalException;
import javax.jdo.JDOUnsupportedOptionException;
import javax.jdo.JDOUserException;
import javax.jdo.PersistenceManager;
import javax.jdo.spi.JDOImplHelper;
import javax.jdo.spi.JDOPermission;
import javax.jdo.spi.PersistenceCapable;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldConsumer;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldSupplier;
import javax.jdo.spi.StateManager;
import xcalia.lido.internal.sm.CommonStateManager;

public class ValidationProduitPC
  implements DomPCSpec, PersistenceCapable
{
  private transient ValidationProduit m_validationProduitOM;
  protected String m_identifiantPeriodeValidationProduit;
  protected Quantite m_qteAcquise;
  protected String m_nomReglementApplicable;
  protected Damj m_dateFinPeriode;
  protected String m_motifFinPeriode;
  protected Damj m_djtpPeriode;
  protected int m_codeProduitValide;
  protected Periode m_periodePra;
  protected int m_catEmploiPart;
  protected int m_popOccHorsFrance;
  public JustificationAffiliationPC m_justificationCalculAffiliation;
  public JustificationAffiliationJoursTravaillesPC m_justificationAffiliationJoursTravailles;
  protected transient byte jdoFlags;
  protected transient StateManager jdoStateManager;
  private static int jdoInheritedFieldCount = 0;
  private static String[] jdoFieldNames = { "m_identifiantPeriodeValidationProduit", "m_qteAcquise", "m_nomReglementApplicable", "m_dateFinPeriode", "m_motifFinPeriode", "m_djtpPeriode", "m_codeProduitValide", "m_periodePra", "m_catEmploiPart", "m_popOccHorsFrance", "m_justificationCalculAffiliation", "m_justificationAffiliationJoursTravailles" };
  private static Class[] jdoFieldTypes = { String.class, Quantite.class, String.class, Damj.class, String.class, Damj.class, Integer.TYPE, Periode.class, Integer.TYPE, Integer.TYPE, JustificationAffiliationPC.class, JustificationAffiliationJoursTravaillesPC.class };
  private static byte[] jdoFieldFlags = { (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE) };
  private static Class jdoPersistenceCapableSuperclass = null;
  
  public Object createOM()
  {
    if (m_validationProduitOM == null) {
      m_validationProduitOM = new ValidationProduit(this);
    }
    return m_validationProduitOM;
  }
  
  public String getIdentifiantPeriodeValidationProduit()
  {
    return jdoGetm_identifiantPeriodeValidationProduit(this);
  }
  
  public final void setIdentifiantPeriodeValidationProduit(String p_identifiantPeriodeValidationProduit)
  {
    jdoSetm_identifiantPeriodeValidationProduit(this, p_identifiantPeriodeValidationProduit);
  }
  
  public Quantite getQteAcquise()
  {
    return jdoGetm_qteAcquise(this);
  }
  
  public final void setQteAcquise(Quantite p_qteAcquise)
  {
    jdoSetm_qteAcquise(this, p_qteAcquise);
  }
  
  public String getNomReglementApplicable()
  {
    return jdoGetm_nomReglementApplicable(this);
  }
  
  public final void setNomReglementApplicable(String p_nomReglementApplicable)
  {
    jdoSetm_nomReglementApplicable(this, p_nomReglementApplicable);
  }
  
  public Damj getDateFinPeriode()
  {
    return jdoGetm_dateFinPeriode(this);
  }
  
  public final void setDateFinPeriode(Damj p_dateFinPeriode)
  {
    jdoSetm_dateFinPeriode(this, p_dateFinPeriode);
  }
  
  public String getMotifFinPeriode()
  {
    return jdoGetm_motifFinPeriode(this);
  }
  
  public final void setMotifFinPeriode(String p_motifFinPeriode)
  {
    jdoSetm_motifFinPeriode(this, p_motifFinPeriode);
  }
  
  public Damj getDjtpPeriode()
  {
    return jdoGetm_djtpPeriode(this);
  }
  
  public final void setDjtpPeriode(Damj p_djtpPeriode)
  {
    jdoSetm_djtpPeriode(this, p_djtpPeriode);
  }
  
  public int getCodeProduitValide()
  {
    return jdoGetm_codeProduitValide(this);
  }
  
  public final void setCodeProduitValide(int p_codeProduitValide)
  {
    jdoSetm_codeProduitValide(this, p_codeProduitValide);
  }
  
  public Periode getPeriodePra()
  {
    return jdoGetm_periodePra(this);
  }
  
  public final void setPeriodePra(Periode p_periodePra)
  {
    jdoSetm_periodePra(this, p_periodePra);
  }
  
  public int getCatEmploiPart()
  {
    return jdoGetm_catEmploiPart(this);
  }
  
  public final void setCatEmploiPart(int p_catEmploiPart)
  {
    jdoSetm_catEmploiPart(this, p_catEmploiPart);
  }
  
  public int getPopOccHorsFrance()
  {
    return jdoGetm_popOccHorsFrance(this);
  }
  
  public final void setPopOccHorsFrance(int p_popOccHorsFrance)
  {
    jdoSetm_popOccHorsFrance(this, p_popOccHorsFrance);
  }
  
  public DomPCSpec getJustificationCalculAffiliation()
  {
    return jdoGetm_justificationCalculAffiliation(this);
  }
  
  public final void setJustificationCalculAffiliation(DomPCSpec p_justificationCalculAffiliation)
  {
    jdoSetm_justificationCalculAffiliation(this, (JustificationAffiliationPC)p_justificationCalculAffiliation);
  }
  
  public DomPCSpec getJustificationAffiliationJoursTravailles()
  {
    return jdoGetm_justificationAffiliationJoursTravailles(this);
  }
  
  public final void setJustificationAffiliationJoursTravailles(DomPCSpec p_justificationAffiliationJoursTravailles)
  {
    jdoSetm_justificationAffiliationJoursTravailles(this, (JustificationAffiliationJoursTravaillesPC)p_justificationAffiliationJoursTravailles);
  }
  
  static
  {
    JDOImplHelper.registerClass(ValidationProduitPC.class, jdoFieldNames, jdoFieldTypes, jdoFieldFlags, jdoPersistenceCapableSuperclass, new ValidationProduitPC());
  }
  
  protected static final String jdoGetm_identifiantPeriodeValidationProduit(ValidationProduitPC pc)
  {
    if (jdoFlags <= 0) {
      return m_identifiantPeriodeValidationProduit;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 0)) {
        return m_identifiantPeriodeValidationProduit;
      }
      return (String)sm.getStringField(pc, jdoInheritedFieldCount + 0, m_identifiantPeriodeValidationProduit);
    }
    return m_identifiantPeriodeValidationProduit;
  }
  
  protected static final Quantite jdoGetm_qteAcquise(ValidationProduitPC pc)
  {
    if (jdoFlags <= 0) {
      return m_qteAcquise;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 1)) {
        return m_qteAcquise;
      }
      return (Quantite)sm.getObjectField(pc, jdoInheritedFieldCount + 1, m_qteAcquise);
    }
    return m_qteAcquise;
  }
  
  protected static final String jdoGetm_nomReglementApplicable(ValidationProduitPC pc)
  {
    if (jdoFlags <= 0) {
      return m_nomReglementApplicable;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 2)) {
        return m_nomReglementApplicable;
      }
      return (String)sm.getStringField(pc, jdoInheritedFieldCount + 2, m_nomReglementApplicable);
    }
    return m_nomReglementApplicable;
  }
  
  protected static final Damj jdoGetm_dateFinPeriode(ValidationProduitPC pc)
  {
    if (jdoFlags <= 0) {
      return m_dateFinPeriode;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 3)) {
        return m_dateFinPeriode;
      }
      return (Damj)sm.getObjectField(pc, jdoInheritedFieldCount + 3, m_dateFinPeriode);
    }
    return m_dateFinPeriode;
  }
  
  protected static final String jdoGetm_motifFinPeriode(ValidationProduitPC pc)
  {
    if (jdoFlags <= 0) {
      return m_motifFinPeriode;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 4)) {
        return m_motifFinPeriode;
      }
      return (String)sm.getStringField(pc, jdoInheritedFieldCount + 4, m_motifFinPeriode);
    }
    return m_motifFinPeriode;
  }
  
  protected static final Damj jdoGetm_djtpPeriode(ValidationProduitPC pc)
  {
    if (jdoFlags <= 0) {
      return m_djtpPeriode;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 5)) {
        return m_djtpPeriode;
      }
      return (Damj)sm.getObjectField(pc, jdoInheritedFieldCount + 5, m_djtpPeriode);
    }
    return m_djtpPeriode;
  }
  
  protected static final int jdoGetm_codeProduitValide(ValidationProduitPC pc)
  {
    if (jdoFlags <= 0) {
      return m_codeProduitValide;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 6)) {
        return m_codeProduitValide;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 6, m_codeProduitValide);
    }
    return m_codeProduitValide;
  }
  
  protected static final Periode jdoGetm_periodePra(ValidationProduitPC pc)
  {
    if (jdoFlags <= 0) {
      return m_periodePra;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 7)) {
        return m_periodePra;
      }
      return (Periode)sm.getObjectField(pc, jdoInheritedFieldCount + 7, m_periodePra);
    }
    return m_periodePra;
  }
  
  protected static final int jdoGetm_catEmploiPart(ValidationProduitPC pc)
  {
    if (jdoFlags <= 0) {
      return m_catEmploiPart;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 8)) {
        return m_catEmploiPart;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 8, m_catEmploiPart);
    }
    return m_catEmploiPart;
  }
  
  protected static final int jdoGetm_popOccHorsFrance(ValidationProduitPC pc)
  {
    if (jdoFlags <= 0) {
      return m_popOccHorsFrance;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 9)) {
        return m_popOccHorsFrance;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 9, m_popOccHorsFrance);
    }
    return m_popOccHorsFrance;
  }
  
  public static final JustificationAffiliationPC jdoGetm_justificationCalculAffiliation(ValidationProduitPC pc)
  {
    if (jdoFlags <= 0) {
      return m_justificationCalculAffiliation;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 10)) {
        return m_justificationCalculAffiliation;
      }
      return (JustificationAffiliationPC)sm.getObjectField(pc, jdoInheritedFieldCount + 10, m_justificationCalculAffiliation);
    }
    return m_justificationCalculAffiliation;
  }
  
  public static final JustificationAffiliationJoursTravaillesPC jdoGetm_justificationAffiliationJoursTravailles(ValidationProduitPC pc)
  {
    if (jdoFlags <= 0) {
      return m_justificationAffiliationJoursTravailles;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 11)) {
        return m_justificationAffiliationJoursTravailles;
      }
      return (JustificationAffiliationJoursTravaillesPC)sm.getObjectField(pc, jdoInheritedFieldCount + 11, m_justificationAffiliationJoursTravailles);
    }
    return m_justificationAffiliationJoursTravailles;
  }
  
  protected static final void jdoSetm_identifiantPeriodeValidationProduit(ValidationProduitPC pc, String newValue)
  {
    if (jdoFlags == 0)
    {
      m_identifiantPeriodeValidationProduit = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setStringField(pc, jdoInheritedFieldCount + 0, m_identifiantPeriodeValidationProduit, newValue);
    } else {
      m_identifiantPeriodeValidationProduit = newValue;
    }
  }
  
  protected static final void jdoSetm_qteAcquise(ValidationProduitPC pc, Quantite newValue)
  {
    if (jdoFlags == 0)
    {
      m_qteAcquise = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 1, m_qteAcquise, newValue);
    } else {
      m_qteAcquise = newValue;
    }
  }
  
  protected static final void jdoSetm_nomReglementApplicable(ValidationProduitPC pc, String newValue)
  {
    if (jdoFlags == 0)
    {
      m_nomReglementApplicable = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setStringField(pc, jdoInheritedFieldCount + 2, m_nomReglementApplicable, newValue);
    } else {
      m_nomReglementApplicable = newValue;
    }
  }
  
  protected static final void jdoSetm_dateFinPeriode(ValidationProduitPC pc, Damj newValue)
  {
    if (jdoFlags == 0)
    {
      m_dateFinPeriode = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 3, m_dateFinPeriode, newValue);
    } else {
      m_dateFinPeriode = newValue;
    }
  }
  
  protected static final void jdoSetm_motifFinPeriode(ValidationProduitPC pc, String newValue)
  {
    if (jdoFlags == 0)
    {
      m_motifFinPeriode = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setStringField(pc, jdoInheritedFieldCount + 4, m_motifFinPeriode, newValue);
    } else {
      m_motifFinPeriode = newValue;
    }
  }
  
  protected static final void jdoSetm_djtpPeriode(ValidationProduitPC pc, Damj newValue)
  {
    if (jdoFlags == 0)
    {
      m_djtpPeriode = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 5, m_djtpPeriode, newValue);
    } else {
      m_djtpPeriode = newValue;
    }
  }
  
  protected static final void jdoSetm_codeProduitValide(ValidationProduitPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_codeProduitValide = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 6, m_codeProduitValide, newValue);
    } else {
      m_codeProduitValide = newValue;
    }
  }
  
  protected static final void jdoSetm_periodePra(ValidationProduitPC pc, Periode newValue)
  {
    if (jdoFlags == 0)
    {
      m_periodePra = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 7, m_periodePra, newValue);
    } else {
      m_periodePra = newValue;
    }
  }
  
  protected static final void jdoSetm_catEmploiPart(ValidationProduitPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_catEmploiPart = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 8, m_catEmploiPart, newValue);
    } else {
      m_catEmploiPart = newValue;
    }
  }
  
  protected static final void jdoSetm_popOccHorsFrance(ValidationProduitPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_popOccHorsFrance = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 9, m_popOccHorsFrance, newValue);
    } else {
      m_popOccHorsFrance = newValue;
    }
  }
  
  public static final void jdoSetm_justificationCalculAffiliation(ValidationProduitPC pc, JustificationAffiliationPC newValue)
  {
    if (jdoFlags == 0)
    {
      m_justificationCalculAffiliation = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 10, m_justificationCalculAffiliation, newValue);
    } else {
      m_justificationCalculAffiliation = newValue;
    }
  }
  
  public static final void jdoSetm_justificationAffiliationJoursTravailles(ValidationProduitPC pc, JustificationAffiliationJoursTravaillesPC newValue)
  {
    if (jdoFlags == 0)
    {
      m_justificationAffiliationJoursTravailles = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 11, m_justificationAffiliationJoursTravailles, newValue);
    } else {
      m_justificationAffiliationJoursTravailles = newValue;
    }
  }
  
  public void jdoProvideField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      jdoStateManager.providedStringField(this, fieldNumber, m_identifiantPeriodeValidationProduit);
      break;
    case 1: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_qteAcquise);
      break;
    case 2: 
      jdoStateManager.providedStringField(this, fieldNumber, m_nomReglementApplicable);
      break;
    case 3: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_dateFinPeriode);
      break;
    case 4: 
      jdoStateManager.providedStringField(this, fieldNumber, m_motifFinPeriode);
      break;
    case 5: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_djtpPeriode);
      break;
    case 6: 
      jdoStateManager.providedIntField(this, fieldNumber, m_codeProduitValide);
      break;
    case 7: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_periodePra);
      break;
    case 8: 
      jdoStateManager.providedIntField(this, fieldNumber, m_catEmploiPart);
      break;
    case 9: 
      jdoStateManager.providedIntField(this, fieldNumber, m_popOccHorsFrance);
      break;
    case 10: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_justificationCalculAffiliation);
      break;
    case 11: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_justificationAffiliationJoursTravailles);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoReplaceField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      m_identifiantPeriodeValidationProduit = ((String)jdoStateManager.replacingStringField(this, fieldNumber));
      break;
    case 1: 
      m_qteAcquise = ((Quantite)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 2: 
      m_nomReglementApplicable = ((String)jdoStateManager.replacingStringField(this, fieldNumber));
      break;
    case 3: 
      m_dateFinPeriode = ((Damj)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 4: 
      m_motifFinPeriode = ((String)jdoStateManager.replacingStringField(this, fieldNumber));
      break;
    case 5: 
      m_djtpPeriode = ((Damj)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 6: 
      m_codeProduitValide = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 7: 
      m_periodePra = ((Periode)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 8: 
      m_catEmploiPart = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 9: 
      m_popOccHorsFrance = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 10: 
      m_justificationCalculAffiliation = ((JustificationAffiliationPC)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 11: 
      m_justificationAffiliationJoursTravailles = ((JustificationAffiliationJoursTravaillesPC)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoProvideFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoProvideField(fieldNumber);
    }
  }
  
  public void jdoReplaceFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoReplaceField(fieldNumber);
    }
  }
  
  public synchronized void jdoReplaceStateManager(StateManager sm)
  {
    if (jdoStateManager != null)
    {
      jdoStateManager = jdoStateManager.replacingStateManager(this, sm);
    }
    else
    {
      SecurityManager securityManager = System.getSecurityManager();
      if (securityManager != null) {
        securityManager.checkPermission(JDOPermission.SET_STATE_MANAGER);
      }
      jdoStateManager = sm;
    }
  }
  
  public boolean jdoIsPersistent()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isPersistent(this);
    }
    return false;
  }
  
  public boolean jdoIsTransactional()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isTransactional(this);
    }
    return false;
  }
  
  public boolean jdoIsNew()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isNew(this);
    }
    return false;
  }
  
  public boolean jdoIsDirty()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDirty(this);
    }
    return false;
  }
  
  public boolean jdoIsDeleted()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDeleted(this);
    }
    return false;
  }
  
  public void jdoMakeDirty(String fieldName)
  {
    if (jdoStateManager != null) {
      jdoStateManager.makeDirty(this, fieldName);
    }
  }
  
  public void jdoReplaceFlags()
  {
    if (jdoStateManager != null)
    {
      jdoFlags = jdoStateManager.replacingFlags(this);
      return;
      jdoFlags = 0;
    }
  }
  
  public boolean jdoIsDetached()
  {
    if (jdoStateManager != null) {
      return ((CommonStateManager)jdoStateManager).isDetached();
    }
    return false;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm)
  {
    ValidationProduitPC pc = new ValidationProduitPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    return pc;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm, Object oid)
  {
    ValidationProduitPC pc = new ValidationProduitPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    pc.jdoCopyKeyFieldsFromObjectId(oid);
    return pc;
  }
  
  public static int jdoGetManagedFieldCount()
  {
    return jdoInheritedFieldCount + 12;
  }
  
  public void jdoCopyFields(Object pc, int[] fieldNumbers)
  {
    if (!(pc instanceof ValidationProduitPC)) {
      throw new JDOFatalInternalException("Can't copy fields from a different class");
    }
    ValidationProduitPC other = (ValidationProduitPC)pc;
    if (jdoStateManager != jdoStateManager) {
      throw new JDOUserException("Source object should have the same StateManager");
    }
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int relativeField = fieldNumbers[i] - jdoInheritedFieldCount;
      switch (relativeField)
      {
      case 0: 
        m_identifiantPeriodeValidationProduit = m_identifiantPeriodeValidationProduit;
        break;
      case 1: 
        m_qteAcquise = m_qteAcquise;
        break;
      case 2: 
        m_nomReglementApplicable = m_nomReglementApplicable;
        break;
      case 3: 
        m_dateFinPeriode = m_dateFinPeriode;
        break;
      case 4: 
        m_motifFinPeriode = m_motifFinPeriode;
        break;
      case 5: 
        m_djtpPeriode = m_djtpPeriode;
        break;
      case 6: 
        m_codeProduitValide = m_codeProduitValide;
        break;
      case 7: 
        m_periodePra = m_periodePra;
        break;
      case 8: 
        m_catEmploiPart = m_catEmploiPart;
        break;
      case 9: 
        m_popOccHorsFrance = m_popOccHorsFrance;
        break;
      case 10: 
        m_justificationCalculAffiliation = m_justificationCalculAffiliation;
        break;
      case 11: 
        m_justificationAffiliationJoursTravailles = m_justificationAffiliationJoursTravailles;
      }
    }
  }
  
  public void jdoCopyKeyFieldsToObjectId(Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public void jdoCopyKeyFieldsToObjectId(PersistenceCapable.ObjectIdFieldSupplier supplier, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  protected void jdoCopyKeyFieldsFromObjectId(Object object) {}
  
  public void jdoCopyKeyFieldsFromObjectId(PersistenceCapable.ObjectIdFieldConsumer consumer, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public Object jdoNewObjectIdInstance()
  {
    return null;
  }
  
  public Object jdoNewObjectIdInstance(Object str)
  {
    return null;
  }
  
  public Object jdoGetObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getObjectId(this);
    }
    return null;
  }
  
  public PersistenceManager jdoGetPersistenceManager()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getPersistenceManager(this);
    }
    return null;
  }
  
  private void jdoPreSerialize()
  {
    if (jdoStateManager != null) {
      jdoStateManager.preSerialize(this);
    }
  }
  
  private void writeObject(ObjectOutputStream out)
    throws IOException
  {
    jdoPreSerialize();
    out.defaultWriteObject();
  }
  
  public Object jdoGetTransactionalObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getTransactionalObjectId(this);
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     ValidationProduitPC
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */