package fr.unedic.cali.asu.eur05.p01.calcul.pbjc;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.autresdoms.cohab.dom.ObjetChronoPeriodePriseEnCharge;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculSpec;
import fr.unedic.cali.calcul.dom.ConstituantsCalculActiviteReduiteSpec;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.calcul.dom.Somme;
import fr.unedic.cali.calcul.dom.UniteTraitement;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeInterProduits;
import fr.unedic.cali.calcul.pbjc.FacadePBJCProduitSpec;
import fr.unedic.cali.calcul.pbjc.dom.PbjcNcp;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoPeriode;
import java.math.BigDecimal;
import java.util.Collection;

public class FacadePBJCProduitImpl
  implements FacadePBJCProduitSpec
{
  public static final int REF_BASE_CALCUL_OUVERTURE_DROIT = 1;
  
  public void ajouterGroupeMontantProduit(PbjcNcp p_pbjcNcp, AttributionSpec p_attribution, Somme p_somme, UniteTraitement p_ut)
  {
    p_pbjcNcp.ajouterGroupeMontants(p_attribution.getProduit().getNom(), 0, new BigDecimal("0"), p_somme.getMontant().getMontantBrut().getValeur(), new BigDecimal("1"), p_somme.getMontant().getMontantBrut().getValeur(), "");
  }
  
  public boolean controlerExecutionPBJCs(AttributionSpec p_attribution)
  {
    return true;
  }
  
  public ChronologiePeriodes creerChronologiePBJCsAvant(AttributionSpec p_attribution, Damj p_dateGeneration, Damj p_dateBlocageActualisation, String p_libelleBlocageActualisation)
    throws ApplicativeException
  {
    return new ChronologiePeriodes();
  }
  
  public boolean creerPBJCsurUT(AttributionSpec p_attribution, UniteTraitement p_ut)
  {
    return true;
  }
  
  public Collection getEvtsChangementParametre(Damj p_dateDebut, Damj p_dateFin, AttributionSpec p_attribution)
  {
    return null;
  }
  
  public void mapperPecSurPbjc(PbjcNcp p_pbjc, ObjetChronoPeriodePriseEnCharge p_pec) {}
  
  public void miseAJourNombreJoursImputes(UniteTraitement p_ut, PbjcNcp p_pbjcNcp) {}
  
  public void positionnerActiviteReduite(PbjcNcp p_pbjcNcp, ConstituantsCalculActiviteReduiteSpec p_constituantsCalculActiviteReduite) {}
  
  public void positionnerCategorieAttribution(PbjcNcp p_pbjcNcp, AttributionSpec p_attribution, UniteTraitement p_ut) {}
  
  public void positionnerCoefficientTempsPartiel(PbjcNcp p_pbjcNcp, UniteTraitement p_ut, AttributionSpec p_attribution) {}
  
  public void positionnerComplementJustification(PbjcNcp p_pbjcNcp, UniteTraitement p_ut, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {}
  
  public void positionnerDonneesAvantageVieillesse(PbjcNcp p_pbjcNcp, UniteTraitement p_ut, AttributionSpec p_attribution) {}
  
  public void positionnerEtatsReglementaireEtAdministratif(PbjcNcp p_pbjcNcp)
  {
    p_pbjcNcp.setEtatReglementaireOd("1");
    
    p_pbjcNcp.setEtatAdministratifOd("1");
  }
  
  public void positionnerIndicateurInterruptionIndemnisationParPensionInvalidite(PbjcNcp p_pbjcNcp) {}
  
  public void positionnerInfoConventionGestion(PbjcNcp p_pbjcNcp, AttributionSpec p_attribution) {}
  
  public void positionnerInformationDecisionSanction(PbjcNcp p_pbjcNcp, UniteTraitement p_ut) {}
  
  public void positionnerInformationDecisionSanction(PbjcNcp p_pbjcNcp, ObjetChronoPeriode p_periode) {}
  
  public void positionnerInformationSuspension(PbjcNcp p_pbjcNcp, UniteTraitement p_ut) {}
  
  public void positionnerJustificationFermetureDJI(PbjcNcp p_pbjcNcp, AttributionSpec p_attribution, UniteTraitement p_ut)
  {
    p_pbjcNcp.ajouterComplementDeJustification("NF");
  }
  
  public void positionnerJustificationOuverturePJI(PbjcNcp p_pbjcNcp, AttributionSpec p_attribution)
  {
    p_pbjcNcp.ajouterComplementDeJustification("BB");
    p_pbjcNcp.ajouterComplementDeJustification("BD");
  }
  
  public void positionnerMontantSalaireRevalorisePlafonne(PbjcNcp pbjcNcp, AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, MontantBaseSpec montant)
    throws CoucheLogiqueException
  {}
  
  public void positionnerMontantSjc(PbjcNcp p_pbjcNcp, AttributionSpec p_attribution, ConstituantsIndemnisation p_constituantsIndemnisation)
    throws CoucheLogiqueException
  {}
  
  public void positionnerNombreMoisEnPaiementProvisoire(PbjcNcp p_pbjcNcp, UniteTraitement p_ut) {}
  
  public void positionnerPBJCASupprimer(PbjcNcp p_pbjcNcp, ObjetChronoPeriode p_periode)
  {
    if (((p_periode instanceof ObjetChronoPeriodeInterProduits)) && ("FOR_RFP04_01".equals(((ObjetChronoPeriodeInterProduits)p_periode).getNomProduit()))) {
      p_pbjcNcp.setQualificationPeriode(3);
    }
  }
  
  public void positionnerPriseEnChargeAER(PbjcNcp p_pbjcNcp, Collection p_periodesAER) {}
  
  public void positionnerPriseEnChargeAER(PbjcNcp p_pbjcNcp, UniteTraitement p_ut) {}
  
  public void positionnerRangProlongation(PbjcNcp p_pbjcNcp, UniteTraitement p_ut, AttributionSpec p_attribution) {}
  
  public void positionnerReferencesOuvertureDroit(PbjcNcp p_pbjcNcp, AttributionSpec p_attribution)
  {
    p_pbjcNcp.setIdentifiantReprise(new Integer(p_attribution.getRsrp()).intValue());
    
    p_pbjcNcp.setRefOdPjcFaitGenerateurOrigine(new Integer(p_attribution.getRsod()).intValue());
    
    p_pbjcNcp.setRefOdPjcPremierFaitGenerateur(p_pbjcNcp.getRefOdPjcFaitGenerateurOrigine());
  }
  
  public void positionnerRessources(PbjcNcp p_pbjcNcp, AttributionSpec p_attribution) {}
  
  public void positionnerSituationParticuliere(PbjcNcp p_pbjcNcp, AttributionSpec p_attribution, UniteTraitement p_ut)
  {
    p_pbjcNcp.setSituationParticuliere(p_attribution.getSituationParticuliere());
  }
  
  public void qualifierPbjcSuspensive(PbjcNcp p_pbjcNcp, ObjetChronoPeriode p_periode) {}
  
  public int retournerMaxDureeReglementaireCourante(AttributionSpec p_attribution)
  {
    return 0;
  }
  
  public Quantite retournerQuantiteIndemnisationInitialeDroit(AttributionSpec p_attribution, UniteTraitement ut)
  {
    return new QuantiteJour(new BigDecimal("0"));
  }
  
  public int retournerReferenceBaseCalcul(AttributionSpec p_attribution)
  {
    return 1;
  }
  
  public String retournerReglementApplicable(AttributionSpec p_attribution)
  {
    return null;
  }
  
  public int retournerReliquatDureeMax(UniteTraitement p_ut, ChronologiePeriodes p_chronoPBJCs, AttributionSpec p_attributionSpec)
  {
    return 0;
  }
  
  public int retournerReliquatDureeReglementaireCourante(UniteTraitement p_ut)
  {
    return 0;
  }
  
  public boolean retournerTopPeriodeRessourcesSuperieuresPlafond(Somme p_somme)
  {
    return false;
  }
  
  public boolean retournerTopPlafonnementDureeDroitParDate()
  {
    return false;
  }
  
  public ChronologiePeriodes supprimerPBJCsANePasPrendreEnCompte(ChronologiePeriodes p_chronoPBJCs)
  {
    ChronologiePeriodes chronoTemp = null;
    PbjcNcp pbjcNcp = null;
    
    chronoTemp = new ChronologiePeriodes();
    p_chronoPBJCs.iterer();
    while (p_chronoPBJCs.encoreSuivant())
    {
      pbjcNcp = (PbjcNcp)p_chronoPBJCs.elementSuivant();
      if (pbjcNcp.getQualificationPeriode() != 3) {
        chronoTemp.ajouter(pbjcNcp);
      }
    }
    return chronoTemp;
  }
  
  public ChronologiePeriodes traitementPeriodesSuspensives(ChronologiePeriodes p_periodesSuspensives, UniteTraitement p_ut)
  {
    return p_periodesSuspensives;
  }
  
  public void traiterBlocageActuPourLAvant(PbjcNcp p_pbjcNcpAvant, Damj p_dateBlocageActualisation, String p_libelleBlocageActualisation) {}
  
  public void traiterPBJCsAPosteriori(ChronologiePeriodes p_chronoPBJCs, AttributionSpec p_attribution, Chronologie chronoUT)
    throws CoucheLogiqueException
  {
    PbjcNcp pbjcNcp = null;
    p_chronoPBJCs.iterer();
    boolean traitementTermine = false;
    while ((p_chronoPBJCs.encoreSuivant()) && (!traitementTermine))
    {
      pbjcNcp = (PbjcNcp)p_chronoPBJCs.elementSuivant();
      if ((p_attribution.getCalendrierExecutionCalcul() != null) && (p_attribution.getCalendrierExecutionCalcul().getPremierJourIndemnisable().coincideAvec(pbjcNcp.getDateDebut())))
      {
        positionnerJustificationOuverturePJI(pbjcNcp, p_attribution);
        traitementTermine = true;
      }
    }
  }
  
  public boolean creerPBJCsurSomme(AttributionSpec p_attribution, Somme p_somme)
  {
    return true;
  }
}

/* Location:
 * Qualified Name:     FacadePBJCProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */