package fr.unedic.cali.asu.eur05.p01.liquidation.dom;

import fr.unedic.cali.ari.dom.Demande;
import fr.unedic.cali.asu.eur05.p01.calcul.dom.DureeIndemnisation;
import fr.unedic.cali.asu.eur05.p01.calcul.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.eur05.p01.liquidation.dom.gen.AdmissionGen;
import fr.unedic.cali.asu.eur05.p01.liquidation.outilsfonctionnels.OutilCalculDonneesNonPersistantes;
import fr.unedic.cali.asu.eur05.p01.liquidation.outilsfonctionnels.RecuperationElementIndemnisation;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculSpec;
import fr.unedic.cali.dom.OdSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class Admission
  extends AdmissionGen
  implements AttributionEurAueSpec, OdSpec
{
  private static final long serialVersionUID = -2960328815801330001L;
  protected transient ElementBaseIndemnisation m_ebiAdmission = null;
  
  public Admission(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public Admission() {}
  
  public ObjetMetierSpec copie()
  {
    Admission copie = new Admission();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    Admission copie = (Admission)p_copie;
    super.copieElements(copie);
  }
  
  public void setCalendrierExecutionCalcul(CalendrierExecutionCalculSpec p_calendrier)
  {
    DomManager.supprimer(super.getCalendrierExecutionCalcul(), p_calendrier);
    super.setCalendrierExecutionCalcul(p_calendrier);
  }
  
  public Damj getPji()
  {
    Damj pji = null;
    try
    {
      pji = OutilCalculDonneesNonPersistantes.trouverPji((Demande)getDemande());
    }
    catch (CoucheLogiqueException ex)
    {
      throw new RuntimeException(ex.getMessage());
    }
    return pji;
  }
  
  public String getPaysOrigine()
    throws CoucheLogiqueException
  {
    return OutilCalculDonneesNonPersistantes.trouverPaysOrigine((Demande)getDemande());
  }
  
  public int getNatureDecision()
  {
    return 10;
  }
  
  public Damj getDateDebutPrestationPossible()
    throws CoucheLogiqueException
  {
    return OutilCalculDonneesNonPersistantes.trouverDateDebutPrestationPossible((Demande)getDemande());
  }
  
  public int getNbJoursSemaine()
    throws CoucheLogiqueException
  {
    return OutilCalculDonneesNonPersistantes.trouverNbJoursSemaine((Demande)getDemande());
  }
  
  public BigDecimal getMontantJournalierCalcule()
    throws CoucheLogiqueException
  {
    return OutilCalculDonneesNonPersistantes.trouverMontantJournalierCalcule((Demande)getDemande());
  }
  
  public int getNbJoursReliquat()
    throws CoucheLogiqueException
  {
    return OutilCalculDonneesNonPersistantes.trouverNbJoursReliquat((Demande)getDemande());
  }
  
  public Damj getDateLimiteIndemnisation()
    throws CoucheLogiqueException
  {
    return OutilCalculDonneesNonPersistantes.calculerDateLimiteIndemnisation((Demande)getDemande());
  }
  
  public int getNbJoursMois()
    throws CoucheLogiqueException
  {
    return OutilCalculDonneesNonPersistantes.trouverNbJoursMois((Demande)getDemande());
  }
  
  public ElementBaseIndemnisation getElementBaseIndemnisation()
    throws CoucheLogiqueException
  {
    if (m_ebiAdmission == null) {
      m_ebiAdmission = RecuperationElementIndemnisation.recupererElementBaseIndemnisation(this);
    }
    return m_ebiAdmission;
  }
  
  public void setElementBaseIndemnisation(ElementBaseIndemnisation p_elementBaseIndemnisation)
  {
    m_ebiAdmission = p_elementBaseIndemnisation;
  }
  
  public List getListeDurees()
    throws CoucheLogiqueException
  {
    ArrayList listeDurees = new ArrayList();
    
    listeDurees.add(new DureeIndemnisation(OutilCalculDonneesNonPersistantes.calculerDureeIndemnisation((Demande)getDemande())));
    return listeDurees;
  }
  
  public ProduitSpec getProduitExecution()
  {
    return getProduit();
  }
  
  public void marquerGraphePersistant()
  {
    super.marquerGraphePersistant();
    DomManager.persisterEnProfondeur(super.getCalendrierExecutionCalcul());
  }
}

/* Location:
 * Qualified Name:     Admission
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */