package fr.unedic.cali.asu.exp03.p01.calcul;

import fr.unedic.cali.asu.calcul.outilsfonctionnels.RecuperationPensionInvaliditeAvantDate;
import fr.unedic.cali.asu.cge01.calcul.FacadeCalculLignePourLiquidationImpl;
import fr.unedic.cali.asu.cge01.outilsfonctionnels.RevalorisationSalaire;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisationAREF;
import fr.unedic.cali.asu.dom.SalaireReference;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.outilsfonctionnels.OutilMappingSjmSjr;
import fr.unedic.cali.asu.parametres.ParametresIndemnisation;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.calcul.dom.periode.PeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.outilsfonctionnels.RecuperationAvantageVieillesseAvantPJI;
import fr.unedic.cali.dom.Competences;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P04;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.dom.conteneurs.DonneesCalculMontant;
import fr.unedic.cali.dom.conteneurs.DonneesCalculMontantSpectacle;
import fr.unedic.cali.dom.conteneurs.DonneesEntreesRecuperationMontant;
import fr.unedic.cali.dom.spec.ConventionGestionSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;

public class FacadeCalculProduitPourLiquidationImpl
  extends FacadeCalculLignePourLiquidationImpl
{
  private static final int CINQUANTE_ANS = 50;
  private static final int DIX = 10;
  
  protected ConstituantsIndemnisation initialiserConstituantsIndemnisation(DonneesEntreesRecuperationMontant p_donneesEntreesRecuperationMontant, Competences p_competences)
    throws CoucheLogiqueException
  {
    Damj dateCalcul = p_donneesEntreesRecuperationMontant.getDateCalculMontant();
    Damj dateAttribution = null;
    IndividuSpec individu = p_donneesEntreesRecuperationMontant.getIndividu();
    DonneesCalculMontant donneesCalculMontant = p_donneesEntreesRecuperationMontant.getDonneesCalculMontant();
    DonneesCalculMontant donneesCalculMontantDroitAssocie = p_donneesEntreesRecuperationMontant.getDonneesEntreesRecuperationMontantDroitAssocie().getDonneesCalculMontant();
    
    DonneesCalculMontantSpectacle donneesCalculMontantSpectacle = p_donneesEntreesRecuperationMontant.getDonneesCalculMontantSpectacle();
    DonneesCalculMontantSpectacle donneesCalculMontantSpectacleDroitAssociee = p_donneesEntreesRecuperationMontant.getDonneesEntreesRecuperationMontantDroitAssocie().getDonneesCalculMontantSpectacle();
    
    boolean droitAssocieExiste = p_donneesEntreesRecuperationMontant.getDonneesEntreesRecuperationMontantDroitAssocie() != null;
    
    ConstituantsIndemnisation constituantsIndemnisation = new ConstituantsIndemnisation();
    ElementBaseIndemnisation elementBaseIndemnisationCourant = new ElementBaseIndemnisation();
    
    ElementBaseIndemnisation elementBaseIndemnisationCourantDroitAssocie = null;
    if (droitAssocieExiste)
    {
      elementBaseIndemnisationCourantDroitAssocie = new ElementBaseIndemnisation();
      elementBaseIndemnisationCourant.setElementBaseIndemnisationDroitAssocie(elementBaseIndemnisationCourantDroitAssocie);
    }
    elementBaseIndemnisationCourant.setProduitMontantRetenu((ProduitAsuSpec)donneesCalculMontant.getProduit());
    constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationCourant);
    ParametresIndemnisation parametresIndemnisation = ParametresIndemnisation.getParametresIndemnisation();
    if (donneesCalculMontant.getSalaireJournalier() != null) {
      elementBaseIndemnisationCourant.setSalaireJournalier(donneesCalculMontant.getSalaireJournalier());
    }
    if ((droitAssocieExiste) && 
      (donneesCalculMontantDroitAssocie.getSalaireJournalier() != null)) {
      elementBaseIndemnisationCourantDroitAssocie.setSalaireJournalier(donneesCalculMontantDroitAssocie.getSalaireJournalier());
    }
    Sjr sjr = OutilMappingSjmSjr.convertirSjr(elementBaseIndemnisationCourant.getSalaireJournalier());
    elementBaseIndemnisationCourant.setSjr(sjr);
    if (droitAssocieExiste)
    {
      Sjr sjrDroitAssocie = OutilMappingSjmSjr.convertirSjr(elementBaseIndemnisationCourantDroitAssocie.getSalaireJournalier());
      elementBaseIndemnisationCourantDroitAssocie.setSjr(sjrDroitAssocie);
    }
    Sjr sjrRevalorise = RevalorisationSalaire.revaloriserSjr(elementBaseIndemnisationCourant, ProduitAsuCge01P04.getInstance(), dateCalcul);
    elementBaseIndemnisationCourant.setSjr(sjrRevalorise);
    if (droitAssocieExiste)
    {
      Sjr sjrRevaloriseDroitAssocie = RevalorisationSalaire.revaloriserSjr(elementBaseIndemnisationCourantDroitAssocie, ProduitAsuCge01P04.getInstance(), dateCalcul);
      elementBaseIndemnisationCourantDroitAssocie.setSjr(sjrRevaloriseDroitAssocie);
    }
    if (donneesCalculMontant.getCoefficientSaisonnier() != null) {
      elementBaseIndemnisationCourant.setCoefficientSaisonnier(donneesCalculMontant.getCoefficientSaisonnier());
    }
    if ((elementBaseIndemnisationCourant.getCoefficientSaisonnier().intValue() != 1) && (individu.getAgeALaDate(dateCalcul).getAnnees() >= 50)) {
      if ((donneesCalculMontant.getTypeCaractereSaisonnierRetenu() == 1) && (donneesCalculMontant.isConditionCaractereSaisonnierParRythme())) {
        elementBaseIndemnisationCourant.setCoefficientSaisonnier(new BigDecimal("1.00"));
      }
    }
    if (droitAssocieExiste)
    {
      if (donneesCalculMontantDroitAssocie.getCoefficientSaisonnier() != null) {
        elementBaseIndemnisationCourantDroitAssocie.setCoefficientSaisonnier(donneesCalculMontantDroitAssocie.getCoefficientSaisonnier());
      }
      if ((elementBaseIndemnisationCourantDroitAssocie.getCoefficientSaisonnier() != null) && (elementBaseIndemnisationCourantDroitAssocie.getCoefficientSaisonnier().intValue() != 1) && (individu.getAgeALaDate(dateCalcul).getAnnees() >= 50)) {
        if ((donneesCalculMontantDroitAssocie.getTypeCaractereSaisonnierRetenu() == 1) && (donneesCalculMontantDroitAssocie.isConditionCaractereSaisonnierParRythme())) {
          elementBaseIndemnisationCourantDroitAssocie.setCoefficientSaisonnier(new BigDecimal("1.00"));
        }
      }
    }
    if (donneesCalculMontant.getCoefficientTempsPartiel() != null) {
      elementBaseIndemnisationCourant.setCoefficientTempsPartiel(donneesCalculMontant.getCoefficientTempsPartiel());
    }
    if ((droitAssocieExiste) && 
      (donneesCalculMontantDroitAssocie.getCoefficientTempsPartiel() != null)) {
      elementBaseIndemnisationCourantDroitAssocie.setCoefficientTempsPartiel(donneesCalculMontantDroitAssocie.getCoefficientTempsPartiel());
    }
    if (donneesCalculMontantDroitAssocie.isPriseEnComptePensionInvalidite())
    {
      Boolean gerePensionInvalidite = donneesCalculMontant.getEstProduitGerantPensionInvalidite();
      if ((gerePensionInvalidite != null) && (gerePensionInvalidite.booleanValue()))
      {
        elementBaseIndemnisationCourant.setListePensionInvalidite(donneesCalculMontantDroitAssocie.getListePensionInvalidite());
        
        elementBaseIndemnisationCourant.setMontantPensionInvaliditeADeduire(RecuperationPensionInvaliditeAvantDate.recuperationMontantPIChainees(elementBaseIndemnisationCourant, individu, dateCalcul, dateAttribution));
      }
      else
      {
        elementBaseIndemnisationCourant.setMontantPensionInvaliditeADeduire(RecuperationPensionInvaliditeAvantDate.recuperationMontantPI(individu, dateCalcul));
      }
      if (droitAssocieExiste) {
        if (individu != null)
        {
          elementBaseIndemnisationCourantDroitAssocie.setListePensionInvalidite(donneesCalculMontantDroitAssocie.getListePensionInvalidite());
          
          determinerMontantPensionInvaliditeADeduire(elementBaseIndemnisationCourantDroitAssocie, individu, dateCalcul);
        }
        else
        {
          elementBaseIndemnisationCourantDroitAssocie.setMontantPensionInvaliditeADeduire(donneesCalculMontantDroitAssocie.getMontantPensionInvaliditeADeduire());
        }
      }
    }
    else
    {
      elementBaseIndemnisationCourant.setMontantPensionInvaliditeADeduire(new BigDecimal("0.00"));
      if (droitAssocieExiste) {
        elementBaseIndemnisationCourantDroitAssocie.setMontantPensionInvaliditeADeduire(new BigDecimal("0.00"));
      }
    }
    if (donneesCalculMontant.isPriseEnCompteAvantageVieillesse())
    {
      PeriodeAvantageVieillesse periodeAvCourante = null;
      DureeCalendaire ageALaDate = null;
      PeriodeAvantageVieillesse periodeAvCouranteDroitAssocie = null;
      DureeCalendaire ageALaDateDroitAssocie = null;
      if (individu != null)
      {
        periodeAvCourante = RecuperationAvantageVieillesseAvantPJI.recupererPeriodeAvADate(individu, dateCalcul);
        ageALaDate = individu.getAgeALaDate(dateCalcul);
        if (droitAssocieExiste)
        {
          periodeAvCouranteDroitAssocie = RecuperationAvantageVieillesseAvantPJI.recupererPeriodeAvADate(individu, dateCalcul);
          ageALaDateDroitAssocie = individu.getAgeALaDate(dateCalcul);
        }
      }
      if (periodeAvCourante != null)
      {
        BigDecimal montantAV = periodeAvCourante.getQuantiteEuro().getValeur();
        
        elementBaseIndemnisationCourant.setDateEffetAV(dateCalcul);
        BigDecimal coeffAV = new BigDecimal("0.00");
        if ((sjrRevalorise != null) && (sjrRevalorise.getSalaire() != null) && (!sjrRevalorise.getSalaire().equals(new BigDecimal("0.00")))) {
          coeffAV = montantAV.divide(sjrRevalorise.getSalaire(), 10, 4);
        }
        elementBaseIndemnisationCourant.setCoefficientAvantageVieillesse(coeffAV);
        elementBaseIndemnisationCourant.setMontantAvantageVieillesse(montantAV);
      }
      else
      {
        elementBaseIndemnisationCourant.setDateEffetAV(donneesCalculMontant.getDateEffetAV());
        elementBaseIndemnisationCourant.setCoefficientAvantageVieillesse(donneesCalculMontant.getCoefficientAvantageVieillesse());
        elementBaseIndemnisationCourant.setMontantAvantageVieillesse(donneesCalculMontant.getMontantAvantageVieillesse());
      }
      if (droitAssocieExiste) {
        if (periodeAvCouranteDroitAssocie != null)
        {
          BigDecimal montantAV = periodeAvCouranteDroitAssocie.getQuantiteEuro().getValeur();
          
          elementBaseIndemnisationCourantDroitAssocie.setDateEffetAV(dateCalcul);
          BigDecimal coeffAV = new BigDecimal("0.00");
          if ((sjrRevalorise != null) && (sjrRevalorise.getSalaire() != null) && (!sjrRevalorise.getSalaire().equals(new BigDecimal("0.00")))) {
            coeffAV = montantAV.divide(sjrRevalorise.getSalaire(), 10, 4);
          }
          elementBaseIndemnisationCourantDroitAssocie.setCoefficientAvantageVieillesse(coeffAV);
          elementBaseIndemnisationCourantDroitAssocie.setMontantAvantageVieillesse(montantAV);
        }
        else
        {
          elementBaseIndemnisationCourantDroitAssocie.setDateEffetAV(donneesCalculMontantDroitAssocie.getDateEffetAV());
          elementBaseIndemnisationCourantDroitAssocie.setCoefficientAvantageVieillesse(donneesCalculMontantDroitAssocie.getCoefficientAvantageVieillesse());
          elementBaseIndemnisationCourantDroitAssocie.setMontantAvantageVieillesse(donneesCalculMontantDroitAssocie.getMontantAvantageVieillesse());
        }
      }
      BigDecimal tauxavantageVieillesse = parametresIndemnisation.getTauxAvantageViellesse(ageALaDate);
      if (tauxavantageVieillesse != null) {
        elementBaseIndemnisationCourant.setTauxAvantageVieillesse(tauxavantageVieillesse);
      }
      if (droitAssocieExiste)
      {
        BigDecimal tauxavantageVieillesseDroitAssocie = parametresIndemnisation.getTauxAvantageViellesse(ageALaDateDroitAssocie);
        if (tauxavantageVieillesseDroitAssocie != null) {
          elementBaseIndemnisationCourantDroitAssocie.setTauxAvantageVieillesse(tauxavantageVieillesseDroitAssocie);
        }
      }
    }
    else
    {
      elementBaseIndemnisationCourant.setCoefficientAvantageVieillesse(new BigDecimal("0.00"));
      elementBaseIndemnisationCourant.setTauxAvantageVieillesse(new BigDecimal("0.00"));
      elementBaseIndemnisationCourant.setMontantAvantageVieillesse(new BigDecimal("0.00"));
      if (droitAssocieExiste)
      {
        elementBaseIndemnisationCourantDroitAssocie.setCoefficientAvantageVieillesse(new BigDecimal("0.00"));
        elementBaseIndemnisationCourantDroitAssocie.setTauxAvantageVieillesse(new BigDecimal("0.00"));
        elementBaseIndemnisationCourantDroitAssocie.setMontantAvantageVieillesse(new BigDecimal("0.00"));
      }
    }
    elementBaseIndemnisationCourant.setCoefficientSanctionReduction(new BigDecimal("1.00"));
    if (droitAssocieExiste) {
      elementBaseIndemnisationCourantDroitAssocie.setCoefficientSanctionReduction(new BigDecimal("1.00"));
    }
    if (donneesCalculMontant.getAvecPrecompteCRC() != null) {
      elementBaseIndemnisationCourant.setAvecPrecompteCRC(donneesCalculMontant.getAvecPrecompteCRC());
    } else if (p_competences == null) {
      elementBaseIndemnisationCourant.setAvecPrecompteCRC(new Boolean(true));
    } else if ((p_competences.getCompetenceFinanciere() == 2) && ((p_competences.getCompetenceAdministrative() != 1) || ((p_competences.getConventionGestion() != null) && (!p_competences.getConventionGestion().estPrecompteCRC())))) {
      elementBaseIndemnisationCourant.setAvecPrecompteCRC(new Boolean(false));
    }
    if (droitAssocieExiste) {
      if (donneesCalculMontant.getAvecPrecompteCRC() != null) {
        elementBaseIndemnisationCourantDroitAssocie.setAvecPrecompteCRC(donneesCalculMontant.getAvecPrecompteCRC());
      } else if (p_competences == null) {
        elementBaseIndemnisationCourantDroitAssocie.setAvecPrecompteCRC(new Boolean(true));
      } else if ((p_competences.getCompetenceFinanciere() == 2) && ((p_competences.getCompetenceAdministrative() != 1) || ((p_competences.getConventionGestion() != null) && (!p_competences.getConventionGestion().estPrecompteCRC())))) {
        elementBaseIndemnisationCourantDroitAssocie.setAvecPrecompteCRC(new Boolean(false));
      }
    }
    elementBaseIndemnisationCourant.setExpatrieApresConvention17(donneesCalculMontant.isExpatrieApresConvention17());
    if (donneesCalculMontant.isContexteFormation())
    {
      ElementBaseIndemnisationAREF ebiAREF = new ElementBaseIndemnisationAREF(elementBaseIndemnisationCourant);
      constituantsIndemnisation.setElementBaseIndemnisationCourant(ebiAREF);
      if (droitAssocieExiste)
      {
        ElementBaseIndemnisationAREF ebiAREFDroitAssocie = new ElementBaseIndemnisationAREF(elementBaseIndemnisationCourantDroitAssocie);
        ebiAREF.setElementBaseIndemnisationDroitAssocie(ebiAREFDroitAssocie);
      }
    }
    if (donneesCalculMontantSpectacle != null)
    {
      Reglement reglementApplicable = donneesCalculMontantSpectacle.getReglementApplicable();
      if (reglementApplicable != null) {
        elementBaseIndemnisationCourant.setReglementApplicable(reglementApplicable);
      }
      Quantite affiliationRequisePourPRA = donneesCalculMontantSpectacle.getAffiliationRequisePourPRA();
      if (affiliationRequisePourPRA != null) {
        elementBaseIndemnisationCourant.setAffiliationRequisePourPRA(affiliationRequisePourPRA);
      }
      SalaireReference salaireReference = (SalaireReference)donneesCalculMontantSpectacle.getSalaireReference();
      if (salaireReference != null) {
        elementBaseIndemnisationCourant.setSalaireReference(salaireReference);
      }
      BigDecimal nombreHeureTravaillesEtendu = donneesCalculMontantSpectacle.getNombreHeureTravaillesEtendu();
      if (nombreHeureTravaillesEtendu != null) {
        elementBaseIndemnisationCourant.setNombreHeureTravaillesEtendu(nombreHeureTravaillesEtendu);
      }
      BigDecimal nombreHeuresTravailleesPlafonnees = donneesCalculMontantSpectacle.getNombreHeuresTravailleesPlafonnees();
      if (nombreHeuresTravailleesPlafonnees != null) {
        elementBaseIndemnisationCourant.setNombreHeuresTravailleesPlafonnees(nombreHeuresTravailleesPlafonnees);
      }
      Periode prc = donneesCalculMontantSpectacle.getPrc();
      if (prc != null) {
        elementBaseIndemnisationCourant.setPrc(prc);
      }
      elementBaseIndemnisationCourant.setNbJoursEmploiSurPrc(donneesCalculMontantSpectacle.getNbJoursEmploiSurPrc());
      elementBaseIndemnisationCourant.setCoefficientHoraireJour(donneesCalculMontantSpectacle.getCoefficientHoraireJour());
    }
    if ((droitAssocieExiste) && 
      (donneesCalculMontantSpectacleDroitAssociee != null))
    {
      Reglement reglementApplicable = donneesCalculMontantSpectacleDroitAssociee.getReglementApplicable();
      if (reglementApplicable != null) {
        elementBaseIndemnisationCourantDroitAssocie.setReglementApplicable(reglementApplicable);
      }
      Quantite affiliationRequisePourPRA = donneesCalculMontantSpectacleDroitAssociee.getAffiliationRequisePourPRA();
      if (affiliationRequisePourPRA != null) {
        elementBaseIndemnisationCourantDroitAssocie.setAffiliationRequisePourPRA(affiliationRequisePourPRA);
      }
      SalaireReference salaireReference = (SalaireReference)donneesCalculMontantSpectacleDroitAssociee.getSalaireReference();
      if (salaireReference != null) {
        elementBaseIndemnisationCourantDroitAssocie.setSalaireReference(salaireReference);
      }
      BigDecimal nombreHeureTravaillesEtendu = donneesCalculMontantSpectacleDroitAssociee.getNombreHeureTravaillesEtendu();
      if (nombreHeureTravaillesEtendu != null) {
        elementBaseIndemnisationCourantDroitAssocie.setNombreHeureTravaillesEtendu(nombreHeureTravaillesEtendu);
      }
      BigDecimal nombreHeuresTravailleesPlafonnees = donneesCalculMontantSpectacleDroitAssociee.getNombreHeuresTravailleesPlafonnees();
      if (nombreHeuresTravailleesPlafonnees != null) {
        elementBaseIndemnisationCourantDroitAssocie.setNombreHeuresTravailleesPlafonnees(nombreHeuresTravailleesPlafonnees);
      }
      Periode prc = donneesCalculMontantSpectacleDroitAssociee.getPrc();
      if (prc != null) {
        elementBaseIndemnisationCourantDroitAssocie.setPrc(prc);
      }
      elementBaseIndemnisationCourantDroitAssocie.setNbJoursEmploiSurPrc(donneesCalculMontantSpectacleDroitAssociee.getNbJoursEmploiSurPrc());
      elementBaseIndemnisationCourantDroitAssocie.setCoefficientHoraireJour(donneesCalculMontantSpectacleDroitAssociee.getCoefficientHoraireJour());
    }
    return constituantsIndemnisation;
  }
}

/* Location:
 * Qualified Name:     FacadeCalculProduitPourLiquidationImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */