package fr.unedic.cali.asu.exp03.p01.calcul.outilsfonctionnels;

import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeDebutPec;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.OutilPensionInvalidite;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeDetection100TMaintien;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeDetectionAgeMaintien;
import fr.unedic.cali.asu.mnt.dom.temps.ObjetChronoPeriodeMaintien;
import fr.unedic.cali.autresdoms.cohab.dom.PeriodeSousPensionInvaliditeChainee;
import fr.unedic.cali.autresdoms.cohab.dom.spec.PeriodeSousPensionInvaliditeChaineeSpec;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.periode.DebutActionFormation;
import fr.unedic.cali.calcul.dom.periode.DsmTravail;
import fr.unedic.cali.calcul.dom.periode.FinActionFormation;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeFormationNonIndemnisee;
import fr.unedic.cali.calcul.dom.periode.FinPeriodePensionInvaliditeChainee;
import fr.unedic.cali.calcul.dom.periode.FinPeriodeSanctionReductionMontant;
import fr.unedic.cali.calcul.dom.periode.PeriodeAbsenceAuPointage;
import fr.unedic.cali.calcul.dom.periode.PeriodeAvantageVieillesse;
import fr.unedic.cali.calcul.dom.periode.PeriodeEvenementBloquant;
import fr.unedic.cali.calcul.dom.periode.PeriodeInterStageFormation;
import fr.unedic.cali.calcul.dom.periode.PeriodePrime;
import fr.unedic.cali.calcul.dom.periode.PeriodeSanctionReductionMontant;
import fr.unedic.cali.calcul.dom.periode.PeriodeSuspensionDDTEAvecImputation;
import fr.unedic.cali.calcul.dom.periode.PeriodeTravailJustifiee;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnniversaire50Ans;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnniversaire55Ans;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoAnniversaire60Ans;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoNonPeriodeHomogene;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeCalcul;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeHomogene;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeInterProduits;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeLendemainDja;
import fr.unedic.cali.calcul.outilsfonctionnels.OutilGestionPoursuite;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public class Qualification
  extends fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.Qualification
{
  protected boolean qualifierUnePeriodeSegmentante(ObjetChronoPeriodeCalcul p_periode, QualificationPeriodes p_qualificationPeriodes, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    Damj pjeNcp = OutilGestionPoursuite.getInstance().recupererPremierJourExecutableNcp(p_attribution);
    if ((p_periode instanceof PeriodeSousPensionInvaliditeChaineeSpec))
    {
      PeriodeSousPensionInvaliditeChainee sousPiChainee = (PeriodeSousPensionInvaliditeChainee)p_periode;
      if (OutilPensionInvalidite.estUneSousPensionDeductible((AttributionAssuranceSpec)p_attribution, sousPiChainee)) {
        p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
      }
    }
    else if ((p_periode instanceof FinPeriodePensionInvaliditeChainee))
    {
      FinPeriodePensionInvaliditeChainee finPiChainee = (FinPeriodePensionInvaliditeChainee)p_periode;
      PeriodeSousPensionInvaliditeChainee piChainee = (PeriodeSousPensionInvaliditeChainee)finPiChainee.getPeriodePensionGeneratrice();
      if (OutilPensionInvalidite.estUneSousPensionDeductible((AttributionAssuranceSpec)p_attribution, piChainee)) {
        p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
      }
    }
    else
    {
      if ((p_periode instanceof fr.unedic.cali.calcul.dom.periode.PeriodeFormation))
      {
        if (((fr.unedic.cali.calcul.dom.periode.PeriodeFormation)p_periode).getActionFormation().estBasculeAutoriserEnContexteFormation())
        {
          ObjetChronoPeriodeCalcul periodeFormation = (ObjetChronoPeriodeCalcul)p_periode.copie();
          if ((p_periode.getDateDebut().estAvant(pjeNcp)) && (p_periode.getDateFin().estApres(pjeNcp))) {
            periodeFormation.setDateDebut(pjeNcp);
          }
          p_qualificationPeriodes.ajouterPeriodesSegmentantes(periodeFormation);
        }
      }
      else if ((p_periode instanceof ObjetChronoPeriodeLendemainDja))
      {
        p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
      }
      else if ((p_periode instanceof FinActionFormation))
      {
        IndividuSpec individu = p_attribution.getDemandeur();
        ObjetChronoPeriode periodeActivite = null;
        ChronologiePeriodes chronologiePeriodes = individu.getChronoPeriodePasseProfessionnelSansFiltrageDNJ();
        chronologiePeriodes.iterer();
        boolean estEncoreEnFormation = false;
        while ((chronologiePeriodes.encoreSuivant()) && (!estEncoreEnFormation))
        {
          periodeActivite = (ObjetChronoPeriode)chronologiePeriodes.elementSuivant();
          if (((periodeActivite instanceof fr.unedic.cali.autresdoms.ga.dom.ActionFormation)) && (!((fr.unedic.cali.autresdoms.ga.dom.ActionFormation)periodeActivite).estAnnulee()) && (((FinActionFormation)p_periode).getActionFormation().getIdentifiantActionFormation() != Integer.parseInt(((fr.unedic.cali.autresdoms.ga.dom.ActionFormation)periodeActivite).getIdentifiant())) && (p_periode.getDateFin().estContenueDans(new Periode(periodeActivite.getDateDebut(), periodeActivite.getDateFin()))) && (p_periode.getDateFin().lendemain().estContenueDans(new Periode(periodeActivite.getDateDebut(), periodeActivite.getDateFin())))) {
            estEncoreEnFormation = true;
          }
        }
        if (!estEncoreEnFormation) {
          p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
        }
      }
      else if ((p_periode instanceof DebutActionFormation))
      {
        p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
      }
      else if (((p_periode instanceof ObjetChronoAnniversaire50Ans)) || ((p_periode instanceof ObjetChronoAnniversaire55Ans)) || ((p_periode instanceof ObjetChronoAnniversaire60Ans)))
      {
        p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
      }
      else if ((p_periode instanceof PeriodeInterStageFormation))
      {
        IndividuSpec individu = p_attribution.getDemandeur();
        Collection listePeriodeAQualifier = new ArrayList();
        ObjetChronoPeriode periodeActivite = null;
        Periode periodeFormation = null;
        ChronologiePeriodes listePeriodesFormations = null;
        
        listePeriodeAQualifier.add(p_periode);
        
        ChronologiePeriodes chronologiePeriodes = individu.getChronoPeriodePasseProfessionnelSansFiltrageDNJ();
        chronologiePeriodes.iterer();
        while (chronologiePeriodes.encoreSuivant())
        {
          periodeActivite = (ObjetChronoPeriode)chronologiePeriodes.elementSuivant();
          if ((periodeActivite instanceof fr.unedic.cali.autresdoms.ga.dom.ActionFormation))
          {
            listePeriodesFormations = ((fr.unedic.cali.autresdoms.ga.dom.ActionFormation)periodeActivite).getListePeriodeFormation();
            listePeriodesFormations.iterer();
            while (listePeriodesFormations.encoreSuivant())
            {
              periodeFormation = ((fr.unedic.cali.autresdoms.ga.dom.PeriodeFormation)listePeriodesFormations.elementSuivant()).getPeriodeEffective();
              if (periodeFormation != null) {
                if (new Periode(periodeFormation.getDebut(), periodeFormation.getFin()).contient(p_periode.getPeriode()))
                {
                  listePeriodeAQualifier.remove(p_periode);
                }
                else if (p_periode.getPeriode().contient(new Periode(periodeFormation.getDebut(), periodeFormation.getFin())))
                {
                  listePeriodeAQualifier.remove(p_periode);
                  PeriodeInterStageFormation periodePremierDecoupage = new PeriodeInterStageFormation();
                  if (p_periode.getDateDebut().estAvant(periodeFormation.getDebut().veille()))
                  {
                    periodePremierDecoupage.setDateDebut(p_periode.getDateDebut());
                    periodePremierDecoupage.setDateFin(periodeFormation.getDebut().veille());
                    listePeriodeAQualifier.add(periodePremierDecoupage);
                  }
                  PeriodeInterStageFormation periodeDeuxiemeDecoupage = new PeriodeInterStageFormation();
                  if (p_periode.getDateFin().estApres(periodeFormation.getFin().lendemain()))
                  {
                    periodeDeuxiemeDecoupage.setDateDebut(periodeFormation.getFin().lendemain());
                    periodeDeuxiemeDecoupage.setDateFin(p_periode.getDateFin());
                    listePeriodeAQualifier.add(periodeDeuxiemeDecoupage);
                  }
                }
                else if (p_periode.getPeriode().contient(periodeFormation.getDebut()))
                {
                  p_periode.setDateFin(periodeFormation.getDebut().veille());
                }
                else if (p_periode.getPeriode().contient(periodeFormation.getFin()))
                {
                  p_periode.setDateDebut(periodeFormation.getFin().lendemain());
                }
              }
            }
          }
        }
        Iterator iterateur = listePeriodeAQualifier.iterator();
        while (iterateur.hasNext())
        {
          ObjetChronoPeriodeCalcul periodeAAjouter = (ObjetChronoPeriodeCalcul)iterateur.next();
          if (periodeAAjouter.getDuree() > 15) {
            p_qualificationPeriodes.ajouterPeriodesSegmentantes(periodeAAjouter);
          }
        }
      }
      else if ((p_periode instanceof ObjetChronoPeriodeDetectionAgeMaintien))
      {
        p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
      }
      else if ((p_periode instanceof ObjetChronoPeriodeDetection100TMaintien))
      {
        p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
      }
      else if ((p_periode instanceof ObjetChronoPeriodeMaintien))
      {
        p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
      }
      else if (((p_periode instanceof ObjetChronoPeriodeInterProduits)) && (!p_attribution.equals(((ObjetChronoPeriodeInterProduits)p_periode).getAttribution())))
      {
        if ((((ObjetChronoPeriodeInterProduits)p_periode).getTypePeriode() == 2) && ((((ObjetChronoPeriodeInterProduits)p_periode).getNomProduit().equals("SOL_AER05_01")) || (((ObjetChronoPeriodeInterProduits)p_periode).getNomProduit().equals("SOL_AER05_02")) || (((ObjetChronoPeriodeInterProduits)p_periode).getNomProduit().equals("SOL_AER05_03")))) {
          p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
        } else if ((((ObjetChronoPeriodeInterProduits)p_periode).getTypePeriode() == 5) && ((((ObjetChronoPeriodeInterProduits)p_periode).getNomProduit().equals("SOL_AER05_01")) || (((ObjetChronoPeriodeInterProduits)p_periode).getNomProduit().equals("SOL_AER05_02")) || (((ObjetChronoPeriodeInterProduits)p_periode).getNomProduit().equals("SOL_AER05_03")))) {
          p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
        }
      }
      else if (((p_periode instanceof PeriodeSanctionReductionMontant)) || ((p_periode instanceof FinPeriodeSanctionReductionMontant)))
      {
        if (((p_periode instanceof PeriodeSanctionReductionMontant)) && (p_periode.getDateDebut().estAvant(pjeNcp)) && (p_periode.getDateFin().estApresOuCoincideAvec(pjeNcp))) {
          p_periode.setDateDebut(pjeNcp);
        }
        p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
      }
      else if ((p_periode instanceof PeriodeAvantageVieillesse))
      {
        p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
      }
      else if ((p_periode instanceof FinPeriodeAvantageVieillesse))
      {
        p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
      }
      else if ((p_periode instanceof PeriodeEvenementBloquant))
      {
        p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
      }
      else if (((p_periode instanceof ObjetChronoPeriodeHomogene)) || ((p_periode instanceof ObjetChronoNonPeriodeHomogene)))
      {
        p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
      }
      else if ((p_periode instanceof FinPeriodeFormationNonIndemnisee))
      {
        p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
      }
      else if ((p_periode instanceof PeriodeSuspensionDDTEAvecImputation))
      {
        if (((((PeriodeSuspensionDDTEAvecImputation)p_periode).getCodeSanction().equals("SD")) || (((PeriodeSuspensionDDTEAvecImputation)p_periode).getCodeSanction().equals("SE"))) && (p_attribution.getRsod() != null) && (p_attribution.getRsod().equals(((PeriodeSuspensionDDTEAvecImputation)p_periode).getRSOD()))) {
          p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
        }
      }
      else if ((p_periode instanceof ObjetChronoPeriodeDebutPec))
      {
        p_qualificationPeriodes.ajouterPeriodesSegmentantes(p_periode);
      }
      else
      {
        return false;
      }
      return true;
    }
    return true;
  }
  
  protected boolean qualifierUnePeriodeGelante(ObjetChronoPeriodeCalcul p_periode, QualificationPeriodes p_qualificationPeriodes, AttributionSpec p_attribution)
  {
    if (((p_periode instanceof PeriodeTravailJustifiee)) || ((p_periode instanceof DsmTravail)) || ((p_periode instanceof PeriodePrime))) {
      p_qualificationPeriodes.ajouterPeriodesGelantes(p_periode);
    } else if ((p_periode instanceof PeriodeAbsenceAuPointage)) {
      p_qualificationPeriodes.ajouterPeriodesGelantes(p_periode);
    } else {
      return false;
    }
    return true;
  }
}

/* Location:
 * Qualified Name:     Qualification
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */