package fr.unedic.cali.asu.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.may17.p02.liquidation.dom.Admission;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.Competence;
import fr.unedic.cali.asu.produits.liquidation.dom.SousTrancheExecutable;
import fr.unedic.cali.asu.produits.liquidation.dom.TrancheExecutable;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.Competences;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.affectation.Parametres;
import fr.unedic.cali.dom.affectation.ProduitAsuMay17P03;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.dom.affectation.ProduitSecurisationProfessionnelleSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.dom.conteneurs.DonneesCalculMontant;
import fr.unedic.cali.dom.conteneurs.DonneesCalculMontantAsp;
import fr.unedic.cali.dom.conteneurs.DonneesCalculMontantSpectacle;
import fr.unedic.cali.dom.conteneurs.DonneesEntreesRecuperationMontant;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.OutilFonctionnel;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

public class OutilConstructionDonneesEntreesRecuperationMontant
  implements OutilFonctionnel
{
  public DonneesEntreesRecuperationMontant creerDonneesEntreesRecuperationMontant(AttributionSpec attribution)
  {
    DonneesEntreesRecuperationMontant donneesEntrees;
    DonneesEntreesRecuperationMontant donneesEntrees;
    if ((!estUneAttributionMayotteAREM(attribution)) && (((ProduitAsuSpec)attribution.getProduit()).estTrancheActivee(attribution.getDemande())))
    {
      TrancheExecutable trancheExecutable = (TrancheExecutable)((Attribution)attribution).getListTranchesExecutables().get(0);
      donneesEntrees = creerDonneesEntreesRecuperationMontant(trancheExecutable);
    }
    else
    {
      ProduitSpec produit;
      AttributionAssuranceSpec attributionAssurance;
      ProduitSpec produit;
      if ((estUneAttributionMayotteAREM(attribution)) && ((attribution instanceof Admission)))
      {
        AttributionAssuranceSpec attributionAssurance = ((Admission)attribution).getAttributionAssurance();
        produit = ProduitAsuMay17P03.getInstance();
      }
      else
      {
        attributionAssurance = (AttributionAssuranceSpec)attribution;
        produit = attributionAssurance.getProduitMontantRetenu();
      }
      ElementBaseIndemnisation ebi = (ElementBaseIndemnisation)attributionAssurance.getElementBaseIndemnisation().copie();
      donneesEntrees = creerDonneesEntreesRecuperationMontant(ebi);
      Competences conteneurCompetences = creerConteneurCompetence(attributionAssurance);
      donneesEntrees.getDonneesCalculMontant().setProduit(produit);
      donneesEntrees.setCompetences(conteneurCompetences);
    }
    IndividuSpec demandeur = attribution.getDemande().getDemandeur();
    donneesEntrees.setIndividu(demandeur);
    donneesEntrees.setDateAttribution(attribution.getDateAttribution());
    if ((attribution.getProduit() instanceof ProduitSecurisationProfessionnelleSpec)) {
      donneesEntrees.getDonneesCalculMontantAsp().setProduitAreSousJacent(((ProduitSecurisationProfessionnelleSpec)attribution.getProduit()).recupererProduitAreActif(attribution));
    }
    return donneesEntrees;
  }
  
  public DonneesEntreesRecuperationMontant creerDonneesEntreesRecuperationMontant(ElementBaseIndemnisation ebi)
  {
    DonneesEntreesRecuperationMontant donneesEntrees = new DonneesEntreesRecuperationMontant();
    
    DonneesCalculMontant donneesCalculMontant = donneesEntrees.getDonneesCalculMontant();
    donneesCalculMontant.setSalaireJournalier(ebi.getSjr());
    donneesCalculMontant.setCoefficientSaisonnier(ebi.getCoefficientSaisonnier());
    donneesCalculMontant.setConditionCaractereSaisonnierParRythme(ebi.isConditionCaractereSaisonnierParRythme());
    donneesCalculMontant.setTypeCaractereSaisonnierRetenu(ebi.getTypeCaractereSaisonnierRetenu());
    donneesCalculMontant.setCoefficientTempsPartiel(ebi.getCoefficientTempsPartiel());
    donneesCalculMontant.setListePensionInvalidite(ebi.getListePensionInvalidite());
    donneesCalculMontant.setEstProduitGerantPensionInvalidite(ebi.getEstProduitGerantPensionInvalidite());
    donneesCalculMontant.setAvecPrecompteCRC(ebi.getAvecPrecompteCRC());
    donneesCalculMontant.setExpatrieApresConvention17(ebi.isExpatrieApresConvention17());
    if (ebi.getReglementApplicableMontantRetenu() != null) {
      donneesCalculMontant.setReglementMontantRetenu(ebi.getReglementApplicableMontantRetenu().getReglement());
    }
    DonneesCalculMontantSpectacle donneesSpectacle = donneesEntrees.getDonneesCalculMontantSpectacle();
    donneesSpectacle.setReglementApplicable(ebi.getReglementApplicable());
    donneesSpectacle.setCoefficientHoraireJour(ebi.getCoefficientHoraireJour());
    donneesSpectacle.setAffiliationRequisePourPRA(ebi.getAffiliationRequisePourPRA());
    donneesSpectacle.setPrc(ebi.getPrc());
    donneesSpectacle.setSalaireReference(ebi.getSalaireReference());
    donneesSpectacle.setNbJoursEmploiSurPrc(ebi.getNbJoursEmploiSurPrc());
    donneesSpectacle.setNombreHeuresTravailleesPlafonnees(ebi.getNombreHeuresTravailleesPlafonnees());
    donneesSpectacle.setNombreHeuresTravailleesMajorees(ebi.getNombreHeuresTravailleesMajoree());
    donneesSpectacle.setNombreHeureTravaillesEtendu(ebi.getNombreHeureTravaillesEtendu());
    donneesSpectacle.setRangAllongementPRA(ebi.getRangAllongementPRA());
    donneesSpectacle.setMontantCRA(ebi.getMontantCRA());
    donneesSpectacle.setClauseRattrapage(ebi.isClauseRattrapage());
    donneesSpectacle.setNombreJoursInactivite(ebi.getNombreJoursInactivite());
    
    DonneesCalculMontantAsp donneesCalculMontantAsp = donneesEntrees.getDonneesCalculMontantAsp();
    donneesCalculMontantAsp.setMontantPreavis(ebi.getMontantPreavis());
    donneesCalculMontantAsp.setEstDureePostPrimeEpuisee(ebi.isEstDureePostPrimeEpuisee());
    donneesCalculMontantAsp.setContextePAPPresent(ebi.isContextePAPPresent());
    donneesCalculMontantAsp.setContextePapParlementaire(ebi.isContextePapParlementaire());
    if (ebi.getListeSousEBI() != null)
    {
      donneesCalculMontantAsp.setListeDonneesEntreesRecuperationMontant(new ArrayList());
      Iterator<ElementBaseIndemnisation> iterEBI = ebi.getListeSousEBI().iterator();
      while (iterEBI.hasNext())
      {
        ElementBaseIndemnisation sousEBI = (ElementBaseIndemnisation)iterEBI.next();
        DonneesEntreesRecuperationMontant donneesSousEBI = creerDonneesEntreesRecuperationMontant(sousEBI);
        
        donneesSousEBI.getDonneesCalculMontant().setProduit(sousEBI.getProduitMontantRetenu());
        donneesSousEBI.setCompetences(creerConteneurCompetence(sousEBI));
        donneesCalculMontantAsp.getListeDonneesEntreesRecuperationMontant().add(donneesSousEBI);
      }
    }
    if (ebi.getElementBaseIndemnisationDroitAssocie() != null) {
      donneesEntrees.setDonneesEntreesRecuperationMontantDroitAssocie(creerDonneesEntreesRecuperationMontant((ElementBaseIndemnisation)ebi.getElementBaseIndemnisationDroitAssocie().copie()));
    }
    return donneesEntrees;
  }
  
  protected DonneesEntreesRecuperationMontant creerDonneesEntreesRecuperationMontant(TrancheExecutable trancheExecutable)
  {
    DonneesEntreesRecuperationMontant donneesEntrees = new DonneesEntreesRecuperationMontant();
    
    DonneesCalculMontant donneesCalculMontant = donneesEntrees.getDonneesCalculMontant();
    donneesCalculMontant.setProduit(Parametres.getProduit(trancheExecutable.getProduitMontantRetenu()));
    donneesCalculMontant.setSalaireJournalier(trancheExecutable.getSjr());
    donneesCalculMontant.setCoefficientSaisonnier(trancheExecutable.getCoefficientSaisonnier());
    donneesCalculMontant.setConditionCaractereSaisonnierParRythme(trancheExecutable.isA3ansActiviteEn5ans());
    donneesCalculMontant.setTypeCaractereSaisonnierRetenu(trancheExecutable.getNatureCoefficientSaisonnier());
    donneesCalculMontant.setCoefficientTempsPartiel(trancheExecutable.getCoefficientTempsPartiel());
    donneesCalculMontant.setListePensionInvalidite(trancheExecutable.getListePensionsInvalidites());
    donneesCalculMontant.setEstProduitGerantPensionInvalidite(Boolean.valueOf(((ProduitAsuSpec)trancheExecutable.getAttribution().getProduit()).estProduitGerantPensionInvalidite(trancheExecutable.getAttribution().getDemande())));
    
    donneesCalculMontant.setAvecPrecompteCRC(trancheExecutable.getPrecompteCRC());
    donneesCalculMontant.setReglementMontantRetenu(trancheExecutable.getReglementMontantRetenu());
    
    DonneesCalculMontantSpectacle donneesSpectacle = donneesEntrees.getDonneesCalculMontantSpectacle();
    donneesSpectacle.setReglementApplicable(trancheExecutable.getReglementMontantRetenu());
    donneesSpectacle.setCoefficientHoraireJour(trancheExecutable.getCoefficientHoraireJour());
    donneesSpectacle.setAffiliationRequisePourPRA(trancheExecutable.getAffiliationRequisePourPRA());
    donneesSpectacle.setPrc(trancheExecutable.getPrc());
    donneesSpectacle.setSalaireReference(trancheExecutable.getSalaireReferenceInitialSpectacle());
    donneesSpectacle.setNbJoursEmploiSurPrc(trancheExecutable.getNombreJoursEmploiDansPRC());
    donneesSpectacle.setNombreHeuresTravailleesPlafonnees(trancheExecutable.getNombreHeuresTravailleesPlafonne());
    donneesSpectacle.setNombreHeureTravaillesEtendu(trancheExecutable.getNombreHeuresTravailleesEtendu());
    
    DonneesCalculMontantAsp donneesCalculMontantAsp = donneesEntrees.getDonneesCalculMontantAsp();
    Quantite dureePostPrime = trancheExecutable.getDuree(5);
    if ((dureePostPrime != null) && (dureePostPrime.getValeurEntiere() == 0)) {
      donneesCalculMontantAsp.setEstDureePostPrimeEpuisee(true);
    }
    if (trancheExecutable.getMontantPreavis() != null) {
      donneesCalculMontantAsp.setMontantPreavis(trancheExecutable.getMontantPreavis().getValeur());
    }
    donneesCalculMontantAsp.setContextePAPPresent(trancheExecutable.isContextePAPPresent());
    donneesCalculMontantAsp.setContextePapParlementaire(trancheExecutable.estContextePapParlementaire());
    if (trancheExecutable.getListeSousTranchesExecutable() != null)
    {
      donneesCalculMontantAsp.setListeDonneesEntreesRecuperationMontant(new ArrayList());
      Iterator<SousTrancheExecutable> iterTranche = trancheExecutable.getListeSousTranchesExecutable().iterator();
      while (iterTranche.hasNext())
      {
        SousTrancheExecutable sousTranche = (SousTrancheExecutable)iterTranche.next();
        DonneesEntreesRecuperationMontant donneesSousTranches = creerDonneesEntreesRecuperationMontant(sousTranche);
        donneesCalculMontantAsp.getListeDonneesEntreesRecuperationMontant().add(donneesSousTranches);
      }
    }
    donneesEntrees.setCompetences(creerConteneurCompetence(trancheExecutable));
    if ((trancheExecutable.getAttribution().getAttributionAssociee() != null) && (!OutilGestionContexteDemande.estContexteDemandeAssurancePresent((Demande)trancheExecutable.getAttribution().getDemande(), 9))) {
      donneesEntrees.setDonneesEntreesRecuperationMontantDroitAssocie(creerDonneesEntreesRecuperationMontant(trancheExecutable.getAttribution().getAttributionAssociee()));
    }
    return donneesEntrees;
  }
  
  public Competences creerConteneurCompetence(AttributionAssuranceSpec attribution)
  {
    Competences conteneurCompetences = new Competences();
    conteneurCompetences.setCompetenceAdministrative(attribution.getCompetenceAdministrative());
    conteneurCompetences.setCompetenceFinanciere(attribution.getCompetenceFinanciere());
    conteneurCompetences.setConventionGestion(attribution.getConventionGestion());
    if ((attribution.getCompetence() instanceof Competence)) {
      conteneurCompetences.setEstPCRCForce(((Competence)attribution.getCompetence()).isEstPCRCForce());
    }
    return conteneurCompetences;
  }
  
  protected Competences creerConteneurCompetence(TrancheExecutable trancheExecutable)
  {
    Competences conteneurCompetences = new Competences();
    conteneurCompetences.setCompetenceAdministrative(trancheExecutable.getCompetenceAdministrative());
    conteneurCompetences.setCompetenceFinanciere(trancheExecutable.getCompetenceFinanciere());
    conteneurCompetences.setConventionGestion(trancheExecutable.getConventionGestion());
    if (trancheExecutable.getPrecompteCRC() != null) {
      conteneurCompetences.setEstPCRCForce(trancheExecutable.getPrecompteCRC().booleanValue());
    }
    return conteneurCompetences;
  }
  
  protected Competences creerConteneurCompetence(ElementBaseIndemnisation ebi)
  {
    Competences conteneurCompetences = new Competences();
    conteneurCompetences.setCompetenceAdministrative(ebi.getCompetence().getCompetenceAdministrative());
    conteneurCompetences.setCompetenceFinanciere(ebi.getCompetence().getCompetenceFinanciere());
    conteneurCompetences.setConventionGestion(ebi.getCompetence().getConventionGestion());
    if (ebi.getAvecPrecompteCRC() != null) {
      conteneurCompetences.setEstPCRCForce(ebi.getAvecPrecompteCRC().booleanValue());
    }
    return conteneurCompetences;
  }
  
  private boolean estUneAttributionMayotteAREM(AttributionSpec attribution)
  {
    return (attribution.getProduitExecution().getNom().equals("ASU_MAY17_03")) || (attribution.getProduitExecution().getNom().equals("ASU_MAY17_02"));
  }
}

/* Location:
 * Qualified Name:     OutilConstructionDonneesEntreesRecuperationMontant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */