package fr.unedic.cali.asu.may17.p02.calcul.outilsfonctionnels;

import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.fabriques.FabriqueStrategieActiviteReduitePansConservee;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.fabriques.FabriqueStrategieConvention2014;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.strategies.StrategieActiviteReduitePansConserveeSpec;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.strategies.StrategieConventionARE14Spec;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.Sjc;
import fr.unedic.cali.asu.may17.p02.liquidation.dom.Admission;
import fr.unedic.cali.asu.may17.p02.liquidation.dom.AttributionAssuranceMayotte;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.calcul.dom.ConstituantsCalculActiviteReduiteSpec;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.calcul.dom.SyntheseARsurUT;
import fr.unedic.cali.calcul.dom.UniteTraitement;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeCalcul;
import fr.unedic.cali.calcul.outilsfonctionnels.DeterminationActiviteConserveeReprise;
import fr.unedic.cali.calcul.outilsfonctionnels.DeterminerJustificatifsRevenusAR;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionForcage;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ResultatActiviteReduite;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.SalaireJournalierSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import java.math.BigDecimal;

public class TraitementActiviteReduite
  extends fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.TraitementActiviteReduite
{
  public static void traitementPeriodesGelantes(AttributionSpec attribution, ChronologiePeriodes periodesGelantes, ConstituantsCalculActiviteReduiteSpec constituantsCalculActiviteReduite, UniteTraitement ut)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesGelantesDeclareees = new ChronologiePeriodes();
    ChronologiePeriodes periodesGelantesJustifiees = new ChronologiePeriodes();
    
    boolean traitementActiviteReduite = preTraitementPeriodesGelantes(((Admission)attribution).getAttributionAssurance(), ut, periodesGelantes, periodesGelantesDeclareees, periodesGelantesJustifiees);
    if ((traitementActiviteReduite) && ((estAvantConventionARE14(ut.getDateDebut())) || (ActiviteReduite.estEntreReBranchementAremEtConventionAREM2016(ut.getDateDebut()))))
    {
      if (periodesGelantesJustifiees.getTaille() != 0)
      {
        ResultatActiviteReduite resultatActiviteReduite = appelleActiviteReduite(((Admission)attribution).getAttributionAssurance(), periodesGelantesJustifiees, constituantsCalculActiviteReduite, ut, false);
        
        postTraitementPeriodesGelantes(ut, resultatActiviteReduite);
      }
      if (periodesGelantesDeclareees.getTaille() != 0)
      {
        ResultatActiviteReduite resultatActiviteReduite = appelleActiviteReduite(((Admission)attribution).getAttributionAssurance(), periodesGelantesDeclareees, constituantsCalculActiviteReduite, ut, false);
        
        postTraitementPeriodesGelantes(ut, resultatActiviteReduite);
      }
    }
  }
  
  public static void traitementPeriodesDecalantes(AttributionSpec attribution, ChronologiePeriodes periodesDecalantes, ConstituantsCalculActiviteReduiteSpec constituantsCalculActiviteReduite, UniteTraitement ut)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesDecalantesDeclarees = new ChronologiePeriodes();
    ChronologiePeriodes periodesDecalantesJustifiees = new ChronologiePeriodes();
    ChronologiePeriodes periodeNonDeclareeSanction = null;
    ObjetChronoPeriodeCalcul periodeTravailCalcul = null;
    
    boolean traitementActiviteReduite = preTraitementPeriodesDecalantes(((Admission)attribution).getAttributionAssurance(), periodesDecalantes, constituantsCalculActiviteReduite, ut, periodesDecalantesDeclarees, periodesDecalantesJustifiees, periodeNonDeclareeSanction, periodeTravailCalcul);
    
    BigDecimal sjr = constituantsCalculActiviteReduite.getSjrProduit().getSalaire();
    BigDecimal sjc = constituantsCalculActiviteReduite.getSjcProduit().getSalaire();
    boolean apprenti = ((Admission)attribution).isTopContratsRemuneresBaseSmic();
    
    BigDecimal cumulGainPansConservee = new BigDecimal("0");
    
    CritereStrategie critere = new CritereStrategie();
    critere.setDatePivot(ut.getDateDebut());
    FabriqueStrategieActiviteReduitePansConservee fabrique = new FabriqueStrategieActiviteReduitePansConservee();
    StrategieActiviteReduitePansConserveeSpec strategie = (StrategieActiviteReduitePansConserveeSpec)fabrique.getStrategie(critere);
    
    BigDecimal gainPansConserveeALaLiquidation = strategie.getGainPansConserveeALaLiquidation(((Admission)attribution).getAttributionAssurance(), cumulGainPansConservee);
    
    ut.getSyntheseARsurUT().setSeuilRemunerationAR(new Quantite(ActiviteReduite.calculerSeuilMensuel(ut.getDateDebut(), sjr, sjc, apprenti, gainPansConserveeALaLiquidation), ut.getUniteParDefautQuantites()));
    if (traitementActiviteReduite)
    {
      if (periodesDecalantesJustifiees.getTaille() != 0)
      {
        ut.setChronoPeriodeDecalante(periodesDecalantesJustifiees);
        ResultatActiviteReduite resultatActiviteReduite = appelleActiviteReduite(((Admission)attribution).getAttributionAssurance(), periodesDecalantesJustifiees, constituantsCalculActiviteReduite, ut, false);
        
        postTraitementPeriodesDecalantes(ut, resultatActiviteReduite, ((Admission)attribution).getAttributionAssurance());
      }
      if (periodesDecalantesDeclarees.getTaille() != 0)
      {
        ResultatActiviteReduite resultatActiviteReduite = appelleActiviteReduite(((Admission)attribution).getAttributionAssurance(), periodesDecalantesDeclarees, constituantsCalculActiviteReduite, ut, false);
        
        postTraitementPeriodesDecalantes(ut, resultatActiviteReduite, ((Admission)attribution).getAttributionAssurance());
        
        appliquerRegleSurUTPP(ut);
      }
    }
  }
  
  protected static ResultatActiviteReduite appelleActiviteReduite(AttributionSpec pattribution, ChronologiePeriodes periodesEmploi, ConstituantsCalculActiviteReduiteSpec constituantsCalculActiviteReduite, UniteTraitement ut, boolean estPNDS)
    throws CoucheLogiqueException
  {
    BigDecimal salaireSjc = null;
    Attribution attribution = (Attribution)pattribution;
    
    DureeCalendaire age = pattribution.getDemandeur().getAgeALaDate(ut.getDateFin());
    if (constituantsCalculActiviteReduite.getSjcProduit() != null) {
      salaireSjc = constituantsCalculActiviteReduite.getSjcProduit().getSalaire();
    }
    verificationActiviteConserve(pattribution, ut);
    
    DeterminerJustificatifsRevenusAR.traitementRevenusBS(periodesEmploi, ut.getDateDebut(), pattribution);
    
    return ActiviteReduite.genererEvenementActiviteReduite(ut.getDateDebut(), periodesEmploi, age, ((Attribution)pattribution).isTopContratsRemuneresBaseSmic(), constituantsCalculActiviteReduite.getCumul(), attribution.getNomReglementApplicable(), constituantsCalculActiviteReduite.getSjrProduit().getSalaire(), salaireSjc, estPNDS, attribution);
  }
  
  private static void verificationActiviteConserve(AttributionSpec attribution, UniteTraitement ut)
    throws CoucheLogiqueException
  {
    if (((verifierPresenceSJC(attribution, ut)) || (((AttributionAssuranceMayotte)attribution).getRevenuMensuelANSConservee().compareTo(new BigDecimal(0)) > 0)) && (verifierPresenceForcageSurUT(attribution, ut))) {
      DeterminationActiviteConserveeReprise.genereEvenementBlocageActiviteConservee(ut, attribution.getDemandeur());
    }
  }
  
  private static boolean verifierPresenceForcageSurUT(AttributionSpec attribution, UniteTraitement ut)
    throws CoucheLogiqueException
  {
    return (!GestionForcage.appliquerForcageCreditDecalage(attribution.getDemande(), ut)) && (attribution.getDemandeur().getDernierJourAtteste() != null) && (ut.getDateDebut().estAvantOuCoincideAvec(attribution.getDemandeur().getDernierJourAtteste()));
  }
  
  protected static boolean estAvantConventionARE14(Damj date)
    throws CoucheLogiqueException
  {
    FabriqueStrategieConvention2014 fab = new FabriqueStrategieConvention2014();
    CritereStrategie cs = new CritereStrategie();
    cs.setDatePivot(date);
    StrategieConventionARE14Spec strat = (StrategieConventionARE14Spec)fab.getStrategie(cs);
    return strat.estAvantConventionARE14();
  }
  
  private static boolean verifierPresenceSJC(AttributionSpec attribution, UniteTraitement ut)
  {
    boolean presenceAC = false;
    BigDecimal sjcInitialAttribution = ((AttributionAssuranceMayotte)attribution).getSJCInitial();
    BigDecimal sjcEbi = BigDecimal.ZERO;
    if ((ut.getConstituantsIndemnisationEnDebutUT() != null) && (ut.getConstituantsIndemnisationEnDebutUT().getElementBaseIndemnisationCourant() != null) && (((ElementBaseIndemnisation)ut.getConstituantsIndemnisationEnDebutUT().getElementBaseIndemnisationCourant()).getSjc() != null)) {
      sjcEbi = ((ElementBaseIndemnisation)ut.getConstituantsIndemnisationEnDebutUT().getElementBaseIndemnisationCourant()).getSjc().getSalaire();
    }
    if ((sjcEbi.compareTo(BigDecimal.ZERO) > 0) || (sjcInitialAttribution.compareTo(BigDecimal.ZERO) > 0)) {
      presenceAC = true;
    }
    return presenceAC;
  }
}

/* Location:
 * Qualified Name:     TraitementActiviteReduite
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */