package fr.unedic.cali.asu.mnt.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.mnt.dom.pc.ConditionAgeMaintienPC;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;

public abstract class ConditionAgeMaintienGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_conditionAgeMaintienPC;
  private DureeCalendaire m_ageMinimum = null;
  private Damj m_dateObtentionAgeMinimum = null;
  private ResultatElementDroit m_resultatElementDroit;
  
  public ConditionAgeMaintienGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConditionAgeMaintienGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ConditionAgeMaintienPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_conditionAgeMaintienPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_conditionAgeMaintienPC)
  {
    m_conditionAgeMaintienPC = p_conditionAgeMaintienPC;
  }
  
  protected DureeCalendaire rawGetAgeMinimum()
  {
    return ((ConditionAgeMaintienPC)getPC()).getAgeMinimum();
  }
  
  public DureeCalendaire getAgeMinimum()
  {
    return ((ConditionAgeMaintienPC)getPC()).getAgeMinimum();
  }
  
  public void setAgeMinimum(DureeCalendaire p_ageMinimum)
  {
    if ((m_ageMinimum == null) || (p_ageMinimum == null))
    {
      m_ageMinimum = p_ageMinimum;
      ((ConditionAgeMaintienPC)getPC()).setAgeMinimum(p_ageMinimum);
    }
    else if ((m_ageMinimum != null) && (p_ageMinimum != null) && (!p_ageMinimum.equals(m_ageMinimum)))
    {
      m_ageMinimum = p_ageMinimum;
      ((ConditionAgeMaintienPC)getPC()).setAgeMinimum(p_ageMinimum);
    }
  }
  
  protected Damj rawGetDateObtentionAgeMinimum()
  {
    return ((ConditionAgeMaintienPC)getPC()).getDateObtentionAgeMinimum();
  }
  
  public Damj getDateObtentionAgeMinimum()
  {
    return ((ConditionAgeMaintienPC)getPC()).getDateObtentionAgeMinimum();
  }
  
  public void setDateObtentionAgeMinimum(Damj p_dateObtentionAgeMinimum)
  {
    if ((m_dateObtentionAgeMinimum == null) || (p_dateObtentionAgeMinimum == null))
    {
      m_dateObtentionAgeMinimum = p_dateObtentionAgeMinimum;
      ((ConditionAgeMaintienPC)getPC()).setDateObtentionAgeMinimum(p_dateObtentionAgeMinimum);
    }
    else if ((m_dateObtentionAgeMinimum != null) && (p_dateObtentionAgeMinimum != null) && (!p_dateObtentionAgeMinimum.equals(m_dateObtentionAgeMinimum)))
    {
      m_dateObtentionAgeMinimum = p_dateObtentionAgeMinimum;
      ((ConditionAgeMaintienPC)getPC()).setDateObtentionAgeMinimum(p_dateObtentionAgeMinimum);
    }
  }
  
  public ResultatElementDroit getResultatElementDroit()
  {
    if (m_resultatElementDroit == null)
    {
      DomPCSpec resultatElementDroitPC = ((ConditionAgeMaintienPC)getPC()).getResultatElementDroit();
      if (resultatElementDroitPC != null) {
        m_resultatElementDroit = ((ResultatElementDroit)resultatElementDroitPC.createOM());
      }
    }
    return m_resultatElementDroit;
  }
  
  public void setResultatElementDroit(ResultatElementDroit p_resultatElementDroit)
  {
    if (p_resultatElementDroit == null)
    {
      ((ConditionAgeMaintienPC)getPC()).setResultatElementDroit(null);
      m_resultatElementDroit = p_resultatElementDroit;
    }
    else if (!p_resultatElementDroit.equals(m_resultatElementDroit))
    {
      ((ConditionAgeMaintienPC)getPC()).setResultatElementDroit(p_resultatElementDroit.getPC());
      m_resultatElementDroit = p_resultatElementDroit;
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    Object resultatElementDroit = getResultatElementDroit();
    if ((resultatElementDroit != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(resultatElementDroit))) {
      DomManager.supprimer(getResultatElementDroit(), p_contexteSuppression);
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConditionAgeMaintienGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */