package fr.unedic.cali.asu.mnt.dom.pc;

import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoEvenementDebutPC;
import java.io.IOException;
import java.io.ObjectOutputStream;
import javax.jdo.JDOFatalInternalException;
import javax.jdo.JDOUnsupportedOptionException;
import javax.jdo.JDOUserException;
import javax.jdo.PersistenceManager;
import javax.jdo.spi.JDOImplHelper;
import javax.jdo.spi.JDOPermission;
import javax.jdo.spi.PersistenceCapable;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldConsumer;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldSupplier;
import javax.jdo.spi.StateManager;
import xcalia.lido.internal.sm.CommonStateManager;

public abstract class DossierExamenPC
  extends ObjetChronoEvenementDebutPC
  implements DomPCSpec, PersistenceCapable
{
  protected DomPCSpec m_demande;
  protected ConditionsAttributionAdmissionPC m_conditionsAttributionAdmission;
  protected transient byte jdoFlags;
  protected transient StateManager jdoStateManager;
  private static int jdoInheritedFieldCount = 0;
  private static String[] jdoFieldNames = { "m_dateEvenement", "m_demande", "m_conditionsAttributionAdmission" };
  private static Class[] jdoFieldTypes = { Damj.class, DomPCSpec.class, ConditionsAttributionAdmissionPC.class };
  private static byte[] jdoFieldFlags = { (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE) };
  private static Class jdoPersistenceCapableSuperclass = null;
  static final long serialVersionUID = 5919383061840559788L;
  
  public abstract Object createOM();
  
  public DomPCSpec getDemande()
  {
    return jdoGetm_demande(this);
  }
  
  public final void setDemande(DomPCSpec p_demande)
  {
    jdoSetm_demande(this, p_demande);
  }
  
  public DomPCSpec getConditionsAttributionAdmission()
  {
    return jdoGetm_conditionsAttributionAdmission(this);
  }
  
  public final void setConditionsAttributionAdmission(DomPCSpec p_conditionsAttributionAdmission)
  {
    jdoSetm_conditionsAttributionAdmission(this, (ConditionsAttributionAdmissionPC)p_conditionsAttributionAdmission);
  }
  
  static
  {
    JDOImplHelper.registerClass(DossierExamenPC.class, jdoFieldNames, jdoFieldTypes, jdoFieldFlags, jdoPersistenceCapableSuperclass, null);
  }
  
  protected static final Damj jdoGetm_dateEvenement(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_dateEvenement;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 0)) {
        return m_dateEvenement;
      }
      return (Damj)sm.getObjectField(pc, jdoInheritedFieldCount + 0, m_dateEvenement);
    }
    return m_dateEvenement;
  }
  
  protected static final DomPCSpec jdoGetm_demande(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_demande;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 1)) {
        return m_demande;
      }
      return (DomPCSpec)sm.getObjectField(pc, jdoInheritedFieldCount + 1, m_demande);
    }
    return m_demande;
  }
  
  protected static final ConditionsAttributionAdmissionPC jdoGetm_conditionsAttributionAdmission(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_conditionsAttributionAdmission;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 2)) {
        return m_conditionsAttributionAdmission;
      }
      return (ConditionsAttributionAdmissionPC)sm.getObjectField(pc, jdoInheritedFieldCount + 2, m_conditionsAttributionAdmission);
    }
    return m_conditionsAttributionAdmission;
  }
  
  protected static final void jdoSetm_dateEvenement(DossierExamenPC pc, Damj newValue)
  {
    if (jdoFlags == 0)
    {
      m_dateEvenement = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 0, m_dateEvenement, newValue);
    } else {
      m_dateEvenement = newValue;
    }
  }
  
  protected static final void jdoSetm_demande(DossierExamenPC pc, DomPCSpec newValue)
  {
    if (jdoFlags == 0)
    {
      m_demande = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 1, m_demande, newValue);
    } else {
      m_demande = newValue;
    }
  }
  
  protected static final void jdoSetm_conditionsAttributionAdmission(DossierExamenPC pc, ConditionsAttributionAdmissionPC newValue)
  {
    if (jdoFlags == 0)
    {
      m_conditionsAttributionAdmission = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 2, m_conditionsAttributionAdmission, newValue);
    } else {
      m_conditionsAttributionAdmission = newValue;
    }
  }
  
  public void jdoProvideField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_dateEvenement);
      break;
    case 1: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_demande);
      break;
    case 2: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_conditionsAttributionAdmission);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoReplaceField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      m_dateEvenement = ((Damj)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 1: 
      m_demande = ((DomPCSpec)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 2: 
      m_conditionsAttributionAdmission = ((ConditionsAttributionAdmissionPC)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoProvideFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoProvideField(fieldNumber);
    }
  }
  
  public void jdoReplaceFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoReplaceField(fieldNumber);
    }
  }
  
  public synchronized void jdoReplaceStateManager(StateManager sm)
  {
    if (jdoStateManager != null)
    {
      jdoStateManager = jdoStateManager.replacingStateManager(this, sm);
    }
    else
    {
      SecurityManager securityManager = System.getSecurityManager();
      if (securityManager != null) {
        securityManager.checkPermission(JDOPermission.SET_STATE_MANAGER);
      }
      jdoStateManager = sm;
    }
  }
  
  public boolean jdoIsPersistent()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isPersistent(this);
    }
    return false;
  }
  
  public boolean jdoIsTransactional()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isTransactional(this);
    }
    return false;
  }
  
  public boolean jdoIsNew()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isNew(this);
    }
    return false;
  }
  
  public boolean jdoIsDirty()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDirty(this);
    }
    return false;
  }
  
  public boolean jdoIsDeleted()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDeleted(this);
    }
    return false;
  }
  
  public void jdoMakeDirty(String fieldName)
  {
    if (jdoStateManager != null) {
      jdoStateManager.makeDirty(this, fieldName);
    }
  }
  
  public void jdoReplaceFlags()
  {
    if (jdoStateManager != null)
    {
      jdoFlags = jdoStateManager.replacingFlags(this);
      return;
      jdoFlags = 0;
    }
  }
  
  public boolean jdoIsDetached()
  {
    if (jdoStateManager != null) {
      return ((CommonStateManager)jdoStateManager).isDetached();
    }
    return false;
  }
  
  /* Error */
  public PersistenceCapable jdoNewInstance(StateManager sm)
  {
    // Byte code:
    //   0: new 41	javax/jdo/JDOFatalInternalException
    //   3: dup
    //   4: ldc_w 276
    //   7: invokespecial 190	javax/jdo/JDOFatalInternalException:<init>	(Ljava/lang/String;)V
    //   10: athrow
    //   11: areturn
    // Local variable table:
    //   start	length	slot	name	signature
    //   0	12	0	this	DossierExamenPC
    //   0	12	1	sm	StateManager
  }
  
  /* Error */
  public PersistenceCapable jdoNewInstance(StateManager sm, Object oid)
  {
    // Byte code:
    //   0: new 41	javax/jdo/JDOFatalInternalException
    //   3: dup
    //   4: ldc_w 276
    //   7: invokespecial 190	javax/jdo/JDOFatalInternalException:<init>	(Ljava/lang/String;)V
    //   10: athrow
    //   11: areturn
    // Local variable table:
    //   start	length	slot	name	signature
    //   0	12	0	this	DossierExamenPC
    //   0	12	1	sm	StateManager
    //   0	12	2	oid	Object
  }
  
  public static int jdoGetManagedFieldCount()
  {
    return jdoInheritedFieldCount + 3;
  }
  
  public void jdoCopyFields(Object pc, int[] fieldNumbers)
  {
    if (!(pc instanceof DossierExamenPC)) {
      throw new JDOFatalInternalException("Can't copy fields from a different class");
    }
    DossierExamenPC other = (DossierExamenPC)pc;
    if (jdoStateManager != jdoStateManager) {
      throw new JDOUserException("Source object should have the same StateManager");
    }
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int relativeField = fieldNumbers[i] - jdoInheritedFieldCount;
      switch (relativeField)
      {
      case 0: 
        m_dateEvenement = m_dateEvenement;
        break;
      case 1: 
        m_demande = m_demande;
        break;
      case 2: 
        m_conditionsAttributionAdmission = m_conditionsAttributionAdmission;
      }
    }
  }
  
  public void jdoCopyKeyFieldsToObjectId(Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public void jdoCopyKeyFieldsToObjectId(PersistenceCapable.ObjectIdFieldSupplier supplier, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  protected void jdoCopyKeyFieldsFromObjectId(Object object) {}
  
  public void jdoCopyKeyFieldsFromObjectId(PersistenceCapable.ObjectIdFieldConsumer consumer, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public Object jdoNewObjectIdInstance()
  {
    return null;
  }
  
  public Object jdoNewObjectIdInstance(Object str)
  {
    return null;
  }
  
  public Object jdoGetObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getObjectId(this);
    }
    return null;
  }
  
  public PersistenceManager jdoGetPersistenceManager()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getPersistenceManager(this);
    }
    return null;
  }
  
  private void jdoPreSerialize()
  {
    if (jdoStateManager != null) {
      jdoStateManager.preSerialize(this);
    }
  }
  
  private void writeObject(ObjectOutputStream out)
    throws IOException
  {
    jdoPreSerialize();
    out.defaultWriteObject();
  }
  
  public Object jdoGetTransactionalObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getTransactionalObjectId(this);
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     DossierExamenPC
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */