package fr.unedic.cali.asu.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.calcul.FacadeCalculProduitPourLiquidationAsuSpec;
import fr.unedic.cali.asu.dom.MontantAsuSpec;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.dom.conteneurs.DonneesCalculMontant;
import fr.unedic.cali.dom.conteneurs.DonneesEntreesRecuperationMontant;
import fr.unedic.cali.outilsfonctionnels.AppelCalculParLiquidation;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;

public class AppelCalculParLiquidationAsu
  extends AppelCalculParLiquidation
{
  public static MontantBaseSpec determinerMontant(DonneesEntreesRecuperationMontant p_donneesEntreesRecuperationMontant)
    throws CoucheLogiqueException
  {
    FacadeCalculProduitPourLiquidationAsuSpec facade = (FacadeCalculProduitPourLiquidationAsuSpec)recuperationFacadesCalculPourLiquidation(p_donneesEntreesRecuperationMontant.getDonneesCalculMontant().getProduit());
    
    return facade.determinerMontant(p_donneesEntreesRecuperationMontant);
  }
  
  public static boolean determinerPrecompteCRC(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    FacadeCalculProduitPourLiquidationAsuSpec facade = (FacadeCalculProduitPourLiquidationAsuSpec)recuperationFacadesCalculPourLiquidation(p_attribution.getProduitExecution());
    
    return facade.determinerPrecompteCRC(p_attribution);
  }
  
  public static Quantite determinerDureeEffectiveReliquat(ProduitSpec p_produit, Quantite p_quantiteInitiale, Quantite p_nbHeuresFormation)
    throws IllegalArgumentException
  {
    FacadeCalculProduitPourLiquidationAsuSpec facade = (FacadeCalculProduitPourLiquidationAsuSpec)recuperationFacadesCalculPourLiquidation(p_produit);
    
    return facade.determinerDureeEffectiveReliquat(p_quantiteInitiale, p_nbHeuresFormation);
  }
  
  public static Damj determinerDateConditionNombreJoursIndemnisesNecessaireMaintien(AttributionSpec p_attribution)
    throws ApplicativeException
  {
    FacadeCalculProduitPourLiquidationAsuSpec facade = (FacadeCalculProduitPourLiquidationAsuSpec)recuperationFacadesCalculPourLiquidation(p_attribution.getProduitExecution());
    
    return facade.determinerDateConditionNombreJoursIndemnisesNecessaireMaintien(p_attribution);
  }
  
  public static FormuleMontantSpec getFormuleMontant(ProduitSpec p_produit)
  {
    FacadeCalculProduitPourLiquidationAsuSpec facade = (FacadeCalculProduitPourLiquidationAsuSpec)recuperationFacadesCalculPourLiquidation(p_produit);
    
    return facade.getFormuleMontant();
  }
  
  public static Boolean determinerReliquatValide(AttributionSpec attribution, Damj dateRecherche)
    throws CoucheLogiqueException
  {
    FacadeCalculProduitPourLiquidationAsuSpec facade = (FacadeCalculProduitPourLiquidationAsuSpec)recuperationFacadesCalculPourLiquidation(attribution.getProduitExecution());
    
    return facade.determinerReliquatValide(attribution, dateRecherche);
  }
  
  public static Quantite calculerCapital(AttributionSpec p_attribution, MontantAsuSpec p_montant, Damj p_pointDeDepart, Quantite p_nbJoursIndemnisables)
    throws CoucheLogiqueException
  {
    FacadeCalculProduitPourLiquidationAsuSpec facade = (FacadeCalculProduitPourLiquidationAsuSpec)recuperationFacadesCalculPourLiquidation(p_attribution.getProduitExecution());
    
    return facade.calculerCapital(p_attribution, p_montant, p_pointDeDepart, p_nbJoursIndemnisables);
  }
  
  public static Quantite calculerCapital(AttributionSpec p_attribution, Damj p_dateAttribution, Damj p_pointDeDepart, Quantite p_nbJoursIndemnisables)
    throws CoucheLogiqueException
  {
    FacadeCalculProduitPourLiquidationAsuSpec facade = (FacadeCalculProduitPourLiquidationAsuSpec)recuperationFacadesCalculPourLiquidation(p_attribution.getProduitExecution());
    
    return facade.calculerCapital(p_attribution, p_dateAttribution, p_pointDeDepart, p_nbJoursIndemnisables);
  }
  
  public static int determinerNombreMoisIndemnise(AttributionSpec p_attribution, Damj p_dateEtude)
    throws ApplicativeException
  {
    FacadeCalculProduitPourLiquidationAsuSpec facade = (FacadeCalculProduitPourLiquidationAsuSpec)recuperationFacadesCalculPourLiquidation(p_attribution.getProduitExecution());
    
    return facade.determinerNombreMoisIndemnise(p_attribution, p_dateEtude);
  }
  
  public static BigDecimal getSeuilRenumeration(AttributionSpec p_attribution, Damj p_dateCalcul)
    throws CoucheLogiqueException
  {
    FacadeCalculProduitPourLiquidationAsuSpec facade = (FacadeCalculProduitPourLiquidationAsuSpec)recuperationFacadesCalculPourLiquidation(p_attribution.getProduitExecution());
    
    return facade.getSeuilRenumeration(p_attribution, p_dateCalcul);
  }
  
  public static int determinerNbJoursImputesContextePmvs(AttributionSpec p_attribution, Periode p_periode)
    throws ApplicativeException
  {
    FacadeCalculProduitPourLiquidationAsuSpec facade = (FacadeCalculProduitPourLiquidationAsuSpec)recuperationFacadesCalculPourLiquidation(p_attribution.getProduitExecution());
    
    return facade.determinerNbJoursImputesContextePmvs(p_attribution, p_periode);
  }
}

/* Location:
 * Qualified Name:     AppelCalculParLiquidationAsu
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */