package fr.unedic.cali.asu.outilsfonctionnels.liquidationsimplifiee;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.EntretienLiquidationSimplifiee;
import fr.unedic.cali.asu.dom.SituationDemandeur;
import fr.unedic.cali.asu.parcours.DomLiquidationSimplifiee;
import fr.unedic.cali.autresdoms.cohab.dom.PreInscriptionAude;
import fr.unedic.cali.dom.Entretien;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.PreInscription;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import java.util.Iterator;
import java.util.List;

public class OutilEntretien
{
  public static void supprimerPreInscriptions(DomLiquidationSimplifiee p_dom)
  {
    List listePins = p_dom.getIndividu().getListPreInscription();
    if ((listePins != null) && (!listePins.isEmpty())) {
      while (!listePins.isEmpty())
      {
        Iterator it = listePins.iterator();
        PreInscription pinsCourante = (PreInscription)it.next();
        p_dom.getIndividu().supprimerPreInscription(pinsCourante);
      }
    }
  }
  
  public static Entretien mettreAJourEntretien(Contexte p_contexte, Damj p_datePreinscription)
    throws CoucheLogiqueException
  {
    DomLiquidationSimplifiee dom = (DomLiquidationSimplifiee)p_contexte.getDonnees();
    Demande demande = (Demande)dom.getDemande();
    EntretienLiquidationSimplifiee domEntretien = dom.getEntretien();
    
    List listePreinscription = dom.getIndividu().getListPreInscription();
    
    Damj datePreinscription = null;
    if (p_datePreinscription == null) {
      datePreinscription = dom.getSituationDemandeur().getDateInscription();
    } else {
      datePreinscription = p_datePreinscription;
    }
    PreInscription preinscription = getPreInscription(listePreinscription, datePreinscription);
    Entretien entretienPreinscription = null;
    if (preinscription != null) {
      entretienPreinscription = preinscription.getEntretien();
    }
    Entretien entretien = null;
    if ((demande != null) && (demande.getEntretien() != null)) {
      entretien = demande.getEntretien();
    } else if ((preinscription != null) && (preinscription.getEntretien() != null)) {
      entretien = (Entretien)entretienPreinscription.copie();
    }
    if (entretien == null) {
      entretien = new Entretien();
    }
    entretien.setDateCessationInscription(domEntretien.getDateCessationInscription());
    entretien.setDateFinContrat(domEntretien.getDateFinContrat());
    entretien.setDateDebutPra(domEntretien.getDateDebutPra());
    entretien.setDateFinPra(domEntretien.getDateFinPra());
    entretien.setAExerceActiviteSalarie(domEntretien.getAExerceActiviteSalarie());
    entretien.setASuiviFormation(domEntretien.isASuiviFormation());
    entretien.setQuantiteAffiliation(domEntretien.getQuantiteAffiliation());
    if (demande != null)
    {
      demande.setEntretien(entretien);
    }
    else if ((preinscription != null) && (entretienPreinscription != null))
    {
      entretienPreinscription.setDateCessationInscription(domEntretien.getDateCessationInscription());
      entretienPreinscription.setDateFinContrat(domEntretien.getDateFinContrat());
      entretienPreinscription.setDateDebutPra(domEntretien.getDateDebutPra());
      entretienPreinscription.setDateFinPra(domEntretien.getDateFinPra());
      entretienPreinscription.setAExerceActiviteSalarie(domEntretien.getAExerceActiviteSalarie());
      entretienPreinscription.setASuiviFormation(domEntretien.isASuiviFormation());
      entretienPreinscription.setQuantiteAffiliation(domEntretien.getQuantiteAffiliation());
      preinscription.setEntretien(entretienPreinscription);
    }
    return entretien;
  }
  
  public static void mettreAJourEntretienPreInscription(Contexte p_contexte)
    throws CoucheLogiqueException
  {
    DomLiquidationSimplifiee dom = (DomLiquidationSimplifiee)p_contexte.getDonnees();
    if (!"ENR".equalsIgnoreCase(dom.getContexteAppel()))
    {
      EntretienLiquidationSimplifiee domEntretien = dom.getEntretien();
      SituationDemandeur situationDemandeur = dom.getSituationDemandeur();
      controlerDonneesSaisiesEntretien(domEntretien, situationDemandeur, dom.isEstPrimoDemandeur());
    }
    Damj datePreinscription = dom.getPreInscriptionAude().getDatePreInscription();
    
    Entretien entretien = mettreAJourEntretien(p_contexte, datePreinscription);
    
    List listePreinscription = dom.getIndividu().getListPreInscription();
    PreInscription preinscription = getPreInscription(listePreinscription, datePreinscription);
    PreInscription pins;
    PreInscription pins;
    if (preinscription != null)
    {
      pins = (PreInscription)preinscription.copie();
    }
    else
    {
      pins = new PreInscription();
      
      dom.getIndividu().ajouterPreInscription(pins);
      
      PreInscriptionAude preInscriptionAude = dom.getPreInscriptionAude();
      pins.setDatePreInscription(preInscriptionAude.getDatePreInscription());
    }
    pins.setEntretien(entretien);
  }
  
  private static void controlerDonneesSaisiesEntretien(EntretienLiquidationSimplifiee p_domEntretien, SituationDemandeur p_situationDemandeur, boolean p_estPrimoDemandeur)
    throws CoucheLogiqueException
  {
    if (p_domEntretien.getAExerceActiviteSalarie())
    {
      if (p_domEntretien.getDateFinContrat() == null) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_LS_FCT_OBLIGATOIRE");
      }
      if ((!p_estPrimoDemandeur) && (p_domEntretien.getDateFinContrat().estAvant(p_situationDemandeur.getDateDerniereCessation()))) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_LS_FCT_INFERIEURE_CI");
      }
      if (p_domEntretien.getQuantiteAffiliation() == null) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_LS_QUANTITE_TRAVAIL_OBLIGATOIRE");
      }
    }
    else
    {
      if (p_domEntretien.getDateFinContrat() != null) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_LS_FCT_SAISI");
      }
      if (p_domEntretien.getQuantiteAffiliation() != null) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_LS_QUANTITE_TRAVAIL_SAISI");
      }
    }
  }
  
  public static Entretien mapperEnEntretien(EntretienLiquidationSimplifiee p_entretien)
  {
    Entretien entretien = new Entretien();
    
    entretien.setAExerceActiviteSalarie(p_entretien.getAExerceActiviteSalarie());
    entretien.setASuiviFormation(p_entretien.isASuiviFormation());
    entretien.setDateCessationInscription(p_entretien.getDateCessationInscription());
    entretien.setDateDebutPra(p_entretien.getDateDebutPra());
    entretien.setDateFinPra(p_entretien.getDateFinPra());
    entretien.setDateFinContrat(p_entretien.getDateFinContrat());
    if (p_entretien.getQuantiteAffiliation() != null) {
      entretien.setQuantiteAffiliation(p_entretien.getQuantiteAffiliation());
    }
    return entretien;
  }
  
  public static PreInscription getPreInscription(List p_list, Damj p_date)
    throws CoucheLogiqueException
  {
    if ((p_list != null) && (!p_list.isEmpty())) {
      if (p_date != null) {
        for (int i = 0; i < p_list.size(); i++) {
          if (p_date.coincideAvec(((PreInscription)p_list.get(i)).getDatePreInscription())) {
            return (PreInscription)p_list.get(i);
          }
        }
      } else {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_LS_DATE_NON_RENSEIGNEE");
      }
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     OutilEntretien
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */