package fr.unedic.cali.asu.parcours;

import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.parcours.DomCali;
import fr.unedic.cali.parcours.DomCaliOptimise;
import fr.unedic.util.services.ContexteService;
import fr.unedic.util.temps.ChronologieDebuts;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;

public class DomExamenAuFilEau
  extends DomCaliOptimise
  implements DomCali
{
  public static final int EXAMEN_AUTOMATIQUE = 0;
  public static final int EXAMEN_MANUEL = 1;
  private ContexteService m_contexteService;
  private IndividuSpec m_individu;
  private ChronologiePeriodes m_chronoPefe = null;
  private ChronologieDebuts m_chronoDemandes = null;
  private boolean m_modeSimulationActif;
  private boolean m_calculAffiliationSimplifieeActif;
  private int m_nombreMaximumFctATraiter;
  private Damj m_dateEvenement;
  private int m_typeDeclenchementExamen;
  private Damj m_dateEvenementDeclencheur;
  private int m_natureEvenementDeclencheur;
  private boolean m_ecrireStat = false;
  
  public DomExamenAuFilEau()
  {
    m_chronoPefe = new ChronologiePeriodes();
    m_chronoDemandes = new ChronologieDebuts();
  }
  
  public DomExamenAuFilEau(IndividuSpec p_individu, ContexteService p_contexteService)
  {
    m_chronoPefe = new ChronologiePeriodes();
    m_chronoDemandes = new ChronologieDebuts();
    setIndividu(p_individu);
    setContexteService(p_contexteService);
  }
  
  public ContexteService getContexteService()
  {
    return m_contexteService;
  }
  
  public IndividuSpec getIndividu()
  {
    return m_individu;
  }
  
  public void setContexteService(ContexteService p_contexteService)
  {
    m_contexteService = p_contexteService;
  }
  
  public void setIndividu(IndividuSpec p_individu)
  {
    m_individu = p_individu;
  }
  
  public ChronologiePeriodes getChronoPefe()
  {
    return m_chronoPefe;
  }
  
  public void setChronoPefe(ChronologiePeriodes p_chronoPefe)
  {
    m_chronoPefe = p_chronoPefe;
  }
  
  public ChronologieDebuts getChronoDemandes()
  {
    return m_chronoDemandes;
  }
  
  public void setChronoDemandes(ChronologieDebuts p_chronoDemandes)
  {
    m_chronoDemandes = p_chronoDemandes;
  }
  
  public boolean isCalculAffiliationSimplifieeActif()
  {
    return m_calculAffiliationSimplifieeActif;
  }
  
  public void setCalculAffiliationSimplifieeActif(boolean p_calculAffiliationSimplifieeActif)
  {
    m_calculAffiliationSimplifieeActif = p_calculAffiliationSimplifieeActif;
  }
  
  public Damj getDateEvenement()
  {
    return m_dateEvenement;
  }
  
  public void setDateEvenement(Damj p_dateEvenement)
  {
    m_dateEvenement = p_dateEvenement;
  }
  
  public boolean isModeSimulationActif()
  {
    return m_modeSimulationActif;
  }
  
  public void setModeSimulationActif(boolean p_modeSimulationActif)
  {
    m_modeSimulationActif = p_modeSimulationActif;
  }
  
  public int getNombreMaximumFctATraiter()
  {
    return m_nombreMaximumFctATraiter;
  }
  
  public void setNombreMaximumFctATraiter(int p_nombreMaximumFctATraiter)
  {
    m_nombreMaximumFctATraiter = p_nombreMaximumFctATraiter;
  }
  
  public void setTypeDeclenchementExamen(int p_typeDeclenchementExamen)
  {
    m_typeDeclenchementExamen = p_typeDeclenchementExamen;
  }
  
  public boolean isExamenAutomatique()
  {
    if (m_typeDeclenchementExamen == 0) {
      return true;
    }
    return false;
  }
  
  public boolean isExamenManuel()
  {
    if (m_typeDeclenchementExamen == 1) {
      return true;
    }
    return false;
  }
  
  public Damj getDateEvenementDeclencheur()
  {
    return m_dateEvenementDeclencheur;
  }
  
  public void setDateEvenementDeclencheur(Damj p_dateEvenementDeclencheur)
  {
    m_dateEvenementDeclencheur = p_dateEvenementDeclencheur;
  }
  
  public int getNatureEvenementDeclencheur()
  {
    return m_natureEvenementDeclencheur;
  }
  
  public void setNatureEvenementDeclencheur(int p_natureEvenementDeclencheur)
  {
    m_natureEvenementDeclencheur = p_natureEvenementDeclencheur;
  }
  
  public boolean isEcrireStat()
  {
    return m_ecrireStat;
  }
  
  public void setEcrireStat(boolean p_ecrireStat)
  {
    m_ecrireStat = p_ecrireStat;
  }
}

/* Location:
 * Qualified Name:     DomExamenAuFilEau
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */