package fr.unedic.cali.asu.parcours;

import fr.unedic.cali.asu.dom.EntretienLiquidationSimplifiee;
import fr.unedic.cali.asu.dom.SituationDemandeur;
import fr.unedic.cali.asu.produits.liquidation.dom.ParametreLiquidationSimplifiee;
import fr.unedic.cali.autresdoms.cohab.dom.PreInscriptionAude;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.parcours.DomCali;
import fr.unedic.cali.parcours.DomCaliOptimise;
import fr.unedic.util.services.ContexteService;
import java.util.ArrayList;
import java.util.List;

public class DomLiquidationSimplifiee
  extends DomCaliOptimise
  implements DomCali
{
  private String contexteAppel = null;
  private IndividuSpec individu = null;
  private DemandeSpec demande = null;
  private String idDemande = null;
  private boolean estPrimoDemandeur;
  private ContexteService contexteService;
  private boolean notifierCourrier = false;
  private String referenceExterne = null;
  private List<ParametreLiquidationSimplifiee> listeParametreLiquidationSimplifiee = new ArrayList();
  private SituationDemandeur situationDemandeur;
  private EntretienLiquidationSimplifiee entretien;
  private DemandeSpec demandeStandard;
  private PreInscriptionAude preInscriptionAude;
  private int natureDecisionAttendue;
  private String codeMotifEchecANotifier;
  private boolean envoieSigma = true;
  private boolean appelGestionnaireReexecution = true;
  public static final String CONTEXTE_APPEL_CREER_DEMANDE = "C";
  public static final String CONTEXTE_APPEL_LIQUIDER_DEMANDE = "L";
  public static final String CONTEXTE_APPEL_VALIDER_DEMANDE = "V";
  public static final String CONTEXTE_APPEL_VALIDER_ENVOIE_DAL = "E";
  public static final String CONTEXTE_APPEL_LECTURE_DEMANDE = "D";
  public static final String CONTEXTE_APPEL_REFUSER_DECISION = "R";
  public static final String CONTEXTE_APPEL_SIMULER_LIQUIDATION = "SIMU";
  public static final String CONTEXTE_APPEL_LIQUIDATION_SIMULEE = "LSSI";
  public static final String CONTEXTE_APPEL_ENREGISTRER_ENTRETIEN = "ENR";
  
  public IndividuSpec getIndividu()
  {
    return individu;
  }
  
  public void setIndividu(IndividuSpec pIndividu)
  {
    individu = pIndividu;
  }
  
  public ContexteService getContexteService()
  {
    return contexteService;
  }
  
  public void setContexteService(ContexteService pContexteService)
  {
    contexteService = pContexteService;
  }
  
  public boolean isEstPrimoDemandeur()
  {
    return estPrimoDemandeur;
  }
  
  public void setEstPrimoDemandeur(boolean primoDemandeur)
  {
    estPrimoDemandeur = primoDemandeur;
  }
  
  public DemandeSpec getDemande()
  {
    return demande;
  }
  
  public void setDemande(DemandeSpec pDemande)
  {
    demande = pDemande;
  }
  
  public String getIdDemande()
  {
    return idDemande;
  }
  
  public void setIdDemande(String pIdDemande)
  {
    idDemande = pIdDemande;
  }
  
  public String getContexteAppel()
  {
    return contexteAppel;
  }
  
  public void setContexteAppel(String pContexteAppel)
  {
    contexteAppel = pContexteAppel;
  }
  
  public String getReferenceExterne()
  {
    return referenceExterne;
  }
  
  public void setReferenceExterne(String refExt)
  {
    referenceExterne = refExt;
  }
  
  public boolean isNotifierCourrier()
  {
    return notifierCourrier;
  }
  
  public void setNotifierCourrier(boolean pNotifierCourrier)
  {
    notifierCourrier = pNotifierCourrier;
  }
  
  public List<ParametreLiquidationSimplifiee> getListeParametreLiquidationSimplifiee()
  {
    return listeParametreLiquidationSimplifiee;
  }
  
  public void setListeParametreLiquidationSimplifiee(List<ParametreLiquidationSimplifiee> listeParametres)
  {
    listeParametreLiquidationSimplifiee = listeParametres;
  }
  
  public SituationDemandeur getSituationDemandeur()
  {
    return situationDemandeur;
  }
  
  public void setSituationDemandeur(SituationDemandeur situation)
  {
    situationDemandeur = situation;
  }
  
  public EntretienLiquidationSimplifiee getEntretien()
  {
    return entretien;
  }
  
  public void setEntretien(EntretienLiquidationSimplifiee pEntretien)
  {
    entretien = pEntretien;
  }
  
  public DemandeSpec getDemandeStandard()
  {
    return demandeStandard;
  }
  
  public void setDemandeStandard(DemandeSpec demande)
  {
    demandeStandard = demande;
  }
  
  public PreInscriptionAude getPreInscriptionAude()
  {
    return preInscriptionAude;
  }
  
  public void setPreInscriptionAude(PreInscriptionAude preInscription)
  {
    preInscriptionAude = preInscription;
  }
  
  public String getCodeMotifEchecANotifier()
  {
    return codeMotifEchecANotifier;
  }
  
  public void setCodeMotifEchecANotifier(String codeMotifEchec)
  {
    codeMotifEchecANotifier = codeMotifEchec;
  }
  
  public int getNatureDecisionAttendue()
  {
    return natureDecisionAttendue;
  }
  
  public void setNatureDecisionAttendue(int natureDecision)
  {
    natureDecisionAttendue = natureDecision;
  }
  
  public void setEnvoieSigma(boolean envoieSigma)
  {
    this.envoieSigma = envoieSigma;
  }
  
  public boolean isEnvoieSigma()
  {
    return envoieSigma;
  }
  
  public void setAppelGestionnaireReexecution(boolean appelGestionnaireReexecution)
  {
    this.appelGestionnaireReexecution = appelGestionnaireReexecution;
  }
  
  public boolean isAppelGestionnaireReexecution()
  {
    return appelGestionnaireReexecution;
  }
}

/* Location:
 * Qualified Name:     DomLiquidationSimplifiee
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */