package fr.unedic.cali.asu.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.ConditionQuantiteAffiliationSpec;
import fr.unedic.cali.asu.dom.DecisionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.DonneesSortieNPDE;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.DossierAffecte;
import fr.unedic.cali.asu.dom.DossierExamenAssuranceSpec;
import fr.unedic.cali.asu.dom.EreDemandeExpresse;
import fr.unedic.cali.asu.dom.ErePassageCPSuiteRejetDV;
import fr.unedic.cali.asu.dom.FaitGenerateurSpec;
import fr.unedic.cali.asu.dom.FormulaireAsu;
import fr.unedic.cali.asu.dom.ObjectifExamen;
import fr.unedic.cali.asu.dom.Reliquat;
import fr.unedic.cali.asu.dom.SaisieAntecedent;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.asu.fabriques.FabriqueConstitutionListeEre;
import fr.unedic.cali.asu.fabriques.FabriqueStrategieDroitOption;
import fr.unedic.cali.asu.outilsfonctionnels.ConstitutionListeEre;
import fr.unedic.cali.asu.outilsfonctionnels.ConstitutionListeEreDdeExprForcageMotifExamen;
import fr.unedic.cali.asu.outilsfonctionnels.ControlePrescription;
import fr.unedic.cali.asu.outilsfonctionnels.DetectionContexteParticulierLiquidation;
import fr.unedic.cali.asu.outilsfonctionnels.GestionDemandeDv122eJour;
import fr.unedic.cali.asu.outilsfonctionnels.OutilCopieDonneesForcees;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.outilsfonctionnels.VerificationDonneesForcees;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieDroitOptionSpec;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieRepriseSystematiqueApresAre14;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieRepriseSystematiqueAvantAre14;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieRepriseSystematiqueSpec;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.asp.impl.StrategieBlocageDonneesSecteurPublicApres2016;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.asp.impl.StrategieBlocageDonneesSecteurPublicApresConvention2015;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.asp.impl.StrategieBlocageDonneesSecteurPublicAvantConvention2015;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.asp.spec.StrategieBlocageDonneesSecteurPublicSpec;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.strategies.StrategieDroitOptionElargiApres;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.strategies.StrategieDroitOptionElargiAvant;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.strategies.spec.StrategieDroitOptionElargiSpec;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.dom.AgregatGaec;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.ContexteDemande;
import fr.unedic.cali.dom.DecisionSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DonneesChargementGaec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.dom.EvenementReferenceExamenSpec;
import fr.unedic.cali.dom.Individu;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.NaturesDecisions;
import fr.unedic.cali.dom.NovationSpec;
import fr.unedic.cali.dom.OdSpec;
import fr.unedic.cali.dom.RejetSpec;
import fr.unedic.cali.dom.RepriseSpec;
import fr.unedic.cali.dom.affectation.ProduitAbstrait;
import fr.unedic.cali.dom.affectation.ProduitAsuAbstrait;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.fabriques.FabriqueStrategieRevision;
import fr.unedic.cali.fabriques.outilsfonctionnels.FabriqueStrategieGenerique;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.outilsfonctionnels.RechercherReliquat;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreInvestigationFrauduleuse;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.spec.StrategieRevisionARE14Spec;
import fr.unedic.cali.parcours.AccesDonneesGaecException;
import fr.unedic.cali.parcours.DomLiquidationDemande;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreAttributionSurDecisions;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreDecisionPourProduit;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreDecisionneeSurDemande;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreDemandePourERE;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreReexamenSurDemande;
import fr.unedic.cali.utilitaire.filtres.logiques.FiltreET;
import fr.unedic.cali.utilitaire.filtres.logiques.FiltreNegation;
import fr.unedic.cali.utilitaire.filtres.logiques.FiltreOU;
import fr.unedic.cali.utilitaire.outils.OutilRecherche;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Parcours;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Temporel;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;

public class ParcoursLiquidationAssuranceClassique
  extends ParcoursLiquidationAssurance
{
  private static final int NOMBRE_FCT_A_ETUDIER = 100;
  
  protected void controlerDonneesSecteurPublic(IndividuSpec individu, DemandeAssuranceSpec demande)
    throws ContexteException
  {
    try
    {
      VerificationDonneesForcees.getInstance().controlerDonneesSecteurPublic(individu, demande);
    }
    catch (CoucheLogiqueException ex)
    {
      throw new ContexteException(ex.getCode(), ex.getLibelle(), ex);
    }
  }
  
  public Resultat demarrerTraitement(Contexte contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    Damj datePremiereFCTEtudiee = null;
    Demande demandeCourante = getDemandeAsu(contexte);
    initialisationPasseProfessionnelLiquidation(contexte);
    
    verifierRecevabiliteDAL(demandeCourante);
    verifierContexte(demandeCourante);
    ResultatLiquidationAssurance mResultatLiquidation = new ResultatLiquidationAssurance(2);
    
    sauvegarderDonneesAvantReexamenSiDecisionnee(demandeCourante, contexte);
    
    determinerDateExamen(contexte);
    
    reporterDroitOptionForce(demandeCourante);
    
    verifierContexteExamen(demandeCourante);
    
    demandeCourante.getDemandeur().nettoyerPNDSSurActiviteSalariePourSpectacle();
    
    verifierPreconditions(contexte);
    
    verifierPrescription(demandeCourante);
    
    List<EvenementReferenceExamenSpec> listeEre = determinerListeEre(demandeCourante, contexte);
    
    determinationContexteParticulier(contexte);
    
    miseAJourDemandeAssurance(contexte);
    
    constaterContexteInitial(contexte);
    
    Iterator<EvenementReferenceExamenSpec> iter = listeEre.iterator();
    int nbEre = listeEre.size();
    int indiceEreEtudie = 0;
    while ((iter.hasNext()) && (getDom(contexte).continuerEtudeFctEre()))
    {
      indiceEreEtudie++;
      
      demandeCourante.setEvenementReferenceExamen((EvenementReferenceExamenSpec)iter.next());
      
      detecterContexteSortieClauseRattrapage(demandeCourante);
      
      getDom(contexte).setEtudeDerniereFct(indiceEreEtudie == nbEre);
      if ((indiceEreEtudie == 1) && ((demandeCourante.getEvenementReferenceExamen() instanceof EreDemandeExpresse)))
      {
        if (((EreDemandeExpresse)demandeCourante.getEvenementReferenceExamen()).getPeriodeExamen() != null) {
          datePremiereFCTEtudiee = ((EreDemandeExpresse)demandeCourante.getEvenementReferenceExamen()).getPeriodeExamen().getDateFin();
        }
        detectionPresenceAntecedentPendantFCT(demandeCourante);
      }
      chargermentListePNDSIndividu(demandeCourante, demandeCourante.getEvenementReferenceExamen().getDateExamen(demandeCourante));
      
      boolean passerIterationSuivanteSuiteAffectation = lancerAffectationProduit(contexte);
      if (!passerIterationSuivanteSuiteAffectation)
      {
        determinerContextes(contexte);
        
        boolean passerIterationSuivanteSuiteLiquidation = lancerLiquidationDemande(contexte, iter, demandeCourante);
        if (!passerIterationSuivanteSuiteLiquidation)
        {
          detecterErreurFctConcommitantes(demandeCourante);
          
          detecterNombreMaxFctAEtudierAtteint(contexte, demandeCourante, indiceEreEtudie, datePremiereFCTEtudiee);
          
          controlerDonneesForceesPostLiquidation(contexte, demandeCourante);
          
          detecterDroitOption(contexte, mResultatLiquidation);
          
          stockageContexteDemandeExpresse(contexte);
          
          declencherAlertesNonBloquantes(contexte);
          
          controlerPresenceRevisionPostLiquidation(contexte);
          
          alimenterDecisionsReexamen(contexte, mResultatLiquidation);
        }
      }
    }
    verifierPostContexte(demandeCourante);
    
    verifierValiditeContexteDemande(contexte);
    
    determinerQuantiteTravailCourrierASS(demandeCourante);
    
    mResultatLiquidation.setDemande(demandeCourante);
    
    determinerCREMModificationLiquidation(contexte, mResultatLiquidation);
    
    effectuerControlesEligibiliteSurDecisionAuto(contexte, demandeCourante);
    alimenterDonneesCreationAttenteIncoherenceSalaireNPDE(demandeCourante);
    
    OutilTrace.tracerFinParcours();
    return mResultatLiquidation;
  }
  
  protected void verifierValiditeContexteDemande(Contexte contexte)
  {
    Demande demandeAsu = getDemandeAsu(contexte);
    if (ProduitAbstrait.estDuType(6, demandeAsu.getDossierAffectation().getProduit()))
    {
      ContexteDemande contexteDemandeEnCoursDispo = (ContexteDemande)OutilGestionContexteDemande.trouverContexteDemandeAssurance(demandeAsu, "COURSDISPO");
      if (contexteDemandeEnCoursDispo != null) {
        demandeAsu.supprimerContexteDemande(contexteDemandeEnCoursDispo);
      }
      ContexteDemande contexteDemandeSortieDispo = (ContexteDemande)OutilGestionContexteDemande.trouverContexteDemandeAssurance(demandeAsu, "POSTDISPO");
      if (contexteDemandeSortieDispo != null) {
        demandeAsu.supprimerContexteDemande(contexteDemandeSortieDispo);
      }
    }
  }
  
  private void alimenterDonneesCreationAttenteIncoherenceSalaireNPDE(Demande demande)
  {
    if (demande.getAlertesNonBloquantes() != null)
    {
      boolean presenceAlerteA11MN5 = demande.getAlertesNonBloquantes().get("A11MNB5") != null;
      if (leverAttenteIncoherente(presenceAlerteA11MN5, demande.isDecisionAuto(), demande.getDonneesSortieNPDE().isAttenteIncohrenceSalaireLevee()))
      {
        demande.getDonneesSortieNPDE().setAttenteIncohrenceSalaireLevee(true);
        if (demande.isDecisionAuto()) {
          demande.setLiquideeEnEtat(true);
        }
      }
      else
      {
        demande.getDonneesSortieNPDE().setAttenteIncohrenceSalaireLevee(false);
      }
    }
  }
  
  private boolean leverAttenteIncoherente(boolean alertePresente, boolean isDecisionAuto, boolean isAttenteDejaLevee)
  {
    return (alertePresente) && ((isDecisionAuto) || (isAttenteDejaLevee));
  }
  
  private void detecterContexteSortieClauseRattrapage(Demande demandeCourante)
    throws CoucheLogiqueException
  {
    if ((demandeCourante.getEvenementReferenceExamen() instanceof EreDemandeExpresse))
    {
      OutilGestionContexteDemande.supprimerContexteDemande(demandeCourante, "SORTIECRA");
      DetectionContexteParticulierLiquidation.getInstance().detectionContexteSortieClauseRattrapageSpectacle(demandeCourante);
      if (demandeCourante.estEnContexteDemande("SORTIECRA")) {
        ((EreDemandeExpresse)demandeCourante.getEvenementReferenceExamen()).recalerDateExamenEnContexteSortieCRA();
      }
    }
  }
  
  private boolean lancerLiquidationDemande(Contexte contexte, Iterator<EvenementReferenceExamenSpec> iter, Demande demandeCourante)
    throws ApplicativeException
  {
    boolean passerIterationSuivante = false;
    try
    {
      liquiderDemande(contexte);
    }
    catch (CoucheLogiqueException e)
    {
      ArrayList<String> codesA15MB1 = new ArrayList();
      codesA15MB1.add("ASU_PR_CALI_L_ALERTE_A15MB1_FGD_KO");
      codesA15MB1.add("ASU_PR_CALI_L_ALERTE_A15MB1_AFFI_KO");
      codesA15MB1.add("ASU_PR_CALI_L_ALERTE_A15MB1");
      
      boolean estErreurA15MB1 = (e.getCode() != null) && (codesA15MB1.contains(e.getCode()));
      if ((estErreurA15MB1) && (getDom(contexte).continuerEtudeFctEre()) && (iter.hasNext()) && ((demandeCourante.getEvenementReferenceExamen() instanceof EreDemandeExpresse))) {
        passerIterationSuivante = true;
      } else {
        throw e;
      }
    }
    return passerIterationSuivante;
  }
  
  private boolean lancerAffectationProduit(Contexte contexte)
    throws ApplicativeException
  {
    boolean passerIterationSuivante = false;
    try
    {
      affecterProduit(contexte);
    }
    catch (CoucheLogiqueException e)
    {
      if (e.getCode().equals("ASU_PR_CALI_L_INTERR_FONCT_PARCOURS_AFFECT_ASU")) {
        passerIterationSuivante = true;
      } else {
        throw e;
      }
    }
    return passerIterationSuivante;
  }
  
  private void determinerQuantiteTravailCourrierASS(Demande demandeCourante)
    throws ApplicativeException
  {
    if ((!OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(demandeCourante.getListContexteDemande(), "ARESJASPDC")) && (!OutilGestionContexteDemande.estUnContexteDemandeAssurancePresent(demandeCourante.getListContexteDemande(), "ASPSJACENT"))) {
      deternminerQuantiteTravailPourCourrierASS(demandeCourante);
    }
  }
  
  protected Damj determinerDateExamen(Contexte contexte)
    throws ApplicativeException
  {
    Damj dateExamen = super.determinerDateExamen(contexte);
    if (dateExamen == null) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("HG_PR_CALI_L_ERR_DATE_EXAMEN_NON_DETERMINEE");
    }
    return dateExamen;
  }
  
  private void sauvegarderDonneesAvantReexamenSiDecisionnee(Demande demandeCourante, Contexte contexte)
    throws CoucheLogiqueException
  {
    if (demandeCourante.estDecisionnee()) {
      sauvegarderDonneesAvantReexamen(contexte);
    }
  }
  
  protected void controlerDonneesForceesPostLiquidation(Contexte contexte, Demande demandeCourante)
    throws ApplicativeException
  {
    try
    {
      super.controlerDonneesForceesPostLiquidation(contexte);
    }
    catch (ContexteException e)
    {
      if (e.getCode().equals("ASU_PR_N_DONNEES_FORCEES_INCOHERENCE_PRODUIT_AFF"))
      {
        if ((!getDom(contexte).continuerEtudeFctEre()) && ((demandeCourante.getEvenementReferenceExamen() instanceof EreDemandeExpresse))) {
          throw e;
        }
      }
      else {
        throw e;
      }
    }
  }
  
  private void detecterNombreMaxFctAEtudierAtteint(Contexte contexte, Demande demandeCourante, int indiceEreEtudie, Damj datePremiereFCTEtudiee)
    throws CoucheLogiqueException
  {
    if ((getDom(contexte).continuerEtudeFctEre()) && (indiceEreEtudie >= 100) && ((demandeCourante.getEvenementReferenceExamen() instanceof EreDemandeExpresse)) && (((EreDemandeExpresse)demandeCourante.getEvenementReferenceExamen()).getPeriodeExamen() != null))
    {
      Damj dateDerniereFCTEtudiee = ((EreDemandeExpresse)demandeCourante.getEvenementReferenceExamen()).getPeriodeExamen().getDateFin();
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_DEM_EXP_ETUDE_NBRE_ERE_ATTEINT", new Object[] { String.valueOf(100), datePremiereFCTEtudiee, dateDerniereFCTEtudiee });
    }
  }
  
  private void determinerContextes(Contexte contexte)
    throws ApplicativeException
  {
    determinerContexteExamen(contexte);
    
    determinerContextesLiquidation(contexte);
    
    controlerPostDeterminationContexte(contexte);
    
    controlerDonneesForcees(contexte);
  }
  
  private void detecterErreurFctConcommitantes(Demande demandeCourante)
    throws CoucheLogiqueException
  {
    if (((demandeCourante.getEvenementReferenceExamen() instanceof EreDemandeExpresse)) && ((demandeCourante.getAttribution() instanceof OdSpec)))
    {
      ActiviteSalarie fctRetenue = ((DossierAffecte)demandeCourante.getDossierAffectation()).getValidationProduit().getPeriodeValidationProduit();
      if ((fctRetenue.estUneFctConcomittante()) && (!fctRetenue.estFctPrincipale())) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_FCT_CONCOMITTANTE_NON_PRINCIPALE", new Object[] { fctRetenue.getDateFin() });
      }
      ActiviteSalarie fgd = demandeCourante.getAttribution().getFaitGenerateur().getPeriodeFaitGenerateur();
      if ((fgd.estUneFctConcomittante()) && (!fgd.estFctPrincipale())) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_FGD_FCT_CONCOMITTANTE_NON_PRINCIPALE", new Object[] { fgd.getDateFin() });
      }
    }
  }
  
  private List<EvenementReferenceExamenSpec> determinerListeEre(Demande demandeCourante, Contexte contexte)
    throws ApplicativeException
  {
    List<EvenementReferenceExamenSpec> listeEre = new ArrayList();
    if ((demandeCourante.getEvenementReferenceExamen() instanceof EreDemandeExpresse))
    {
      EreDemandeExpresse ereDemandeExpresse = (EreDemandeExpresse)demandeCourante.getEvenementReferenceExamen();
      if (ereDemandeExpresse.isForcageMotifExamen(demandeCourante))
      {
        listeEre = ConstitutionListeEreDdeExprForcageMotifExamen.getInstance().determinerPourDemandeExpresse(contexte);
      }
      else
      {
        initialiserDateDepotOrigine((FormulaireAsu)demandeCourante.getFormulaire());
        ConstitutionListeEre outil = getOutilConstitutionListeEre(((FormulaireAsu)demandeCourante.getFormulaire()).getDateDepotOrigine(), demandeCourante);
        listeEre = outil.determinerPourDemandeExpresse(contexte);
      }
    }
    else
    {
      listeEre.add(demandeCourante.getEvenementReferenceExamen());
    }
    return listeEre;
  }
  
  protected ConstitutionListeEre getOutilConstitutionListeEre(Damj datePivot, Demande demande)
    throws CoucheLogiqueException
  {
    return FabriqueConstitutionListeEre.getOutilConstitutionListeEre(datePivot, demande);
  }
  
  protected void initialiserDateDepotOrigine(FormulaireAsu formulaire)
  {
    if (formulaire.getDateDepotOrigine() == null) {
      formulaire.setDateDepotOrigine(formulaire.getDateDepot());
    }
  }
  
  private void verifierDonneesForceesDroitOption(Demande demande)
    throws CoucheLogiqueException
  {
    if ((demande.getEvenementReferenceExamen() instanceof ErePassageCPSuiteRejetDV))
    {
      DemandeAssuranceSpec derniereDemandeAsu = GestionDemandeDv122eJour.retrouverDemandePortantDv(demande);
      if (verifierAbsenceDroitOptionSurRejetDV(demande, derniereDemandeAsu)) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_DEMANDE_DV_DROIT_OPTION", new Object[] { derniereDemandeAsu.getDateExamen() });
      }
    }
  }
  
  private boolean verifierAbsenceDroitOptionSurRejetDV(Demande demande, DemandeAssuranceSpec derniereDemandeAsu)
  {
    return (demande.estDroitOptionReadmission()) && (!derniereDemandeAsu.estDroitOptionReadmission());
  }
  
  private void reporterDroitOptionForce(DemandeSpec demande)
    throws CoucheLogiqueException
  {
    Demande demandeCourante = (Demande)demande;
    if (demandeCourante.getDonneesTemporaires() != null)
    {
      StrategieDroitOptionElargiSpec strategie = (StrategieDroitOptionElargiSpec)FabriqueStrategieGenerique.choisirStrategie(demande.getDateExamen(), "Application du droit d'option élargi.", new StrategieDroitOptionElargiAvant(), new StrategieDroitOptionElargiApres());
      
      boolean droitOptionReadmissionForce = strategie.estDroitOptionForce(demandeCourante);
      if (!strategie.estDroitOptionApprenti(demandeCourante)) {
        demandeCourante.setDroitOptionReadmission(droitOptionReadmissionForce);
      }
    }
  }
  
  public void controlerPostDeterminationContexte(Contexte contexte)
    throws CoucheLogiqueException
  {
    DomLiquidationAssurance dom = (DomLiquidationAssurance)contexte.getDonnees();
    Demande demande = dom.getDemande();
    controlerDonneesSecteurPublic(demande);
    verifierDonneesForceesDroitOption(demande);
  }
  
  private void controlerDonneesSecteurPublic(Demande demande)
    throws CoucheLogiqueException
  {
    FabriqueStrategieGenerique fabrique = FabriqueStrategieGenerique.getInstance();
    fabrique.inscrireStrategiePeriode("Date de la nuit des temps", "Date d'application de la Veille nouvelle convention CSP 2015", new StrategieBlocageDonneesSecteurPublicAvantConvention2015());
    
    fabrique.inscrireStrategiePeriode("Date d'application de la nouvelle convention CSP 2015", "Veille Reprise SP", new StrategieBlocageDonneesSecteurPublicApresConvention2015());
    
    fabrique.inscrireStrategiePeriode("Reprise SP", "Date de la fin des temps", new StrategieBlocageDonneesSecteurPublicApres2016());
    
    StrategieBlocageDonneesSecteurPublicSpec strategie = (StrategieBlocageDonneesSecteurPublicSpec)fabrique.getStrategie(demande.getDateExamen());
    strategie.leverBlocage(demande);
  }
  
  protected void verifierPrescription(DemandeSpec demande)
    throws CoucheLogiqueException
  {
    boolean prescritpionOk = ControlePrescription.controlerPrescription(demande.getFormulaire());
    if (!prescritpionOk) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("HG_PR_CALI_L_ERR_DAL_PRESCRITE");
    }
  }
  
  private void stockageContexteDemandeExpresse(Contexte contexte)
  {
    Demande demandeCourante = getDemandeAsu(contexte);
    DossierExamenSpec dossierExamen = demandeCourante.getDossierExamen();
    if (dossierExamen != null) {
      ((DossierExamenAssuranceSpec)dossierExamen).setContexteDdeExpresse(getDom(contexte).getContexteExamenDdeExpresse());
    }
  }
  
  protected void postTraiterJustificationAffiliation(Demande demande)
  {
    if (demande.getDossierAffectationAdmission().getProduit() != null) {
      ((ProduitAsuAbstrait)demande.getDossierAffectationAdmission().getProduit()).postTraiterPourJustificationAffiliation(demande);
    }
  }
  
  private void controlerPresenceRevisionPostLiquidation(Contexte contexte)
    throws ApplicativeException
  {
    Demande demande = (Demande)getDemande(contexte);
    if (!"ASU_21".equals(demande.getEvenementReferenceExamen().getTypeExamen()))
    {
      CritereStrategie critere = new CritereStrategie();
      critere.setDatePivot(demande.getDateExamen());
      StrategieRevisionARE14Spec strategie = (StrategieRevisionARE14Spec)FabriqueStrategieRevision.getInstance().getStrategie(critere);
      strategie.controlePresenceDemandeRevisionPostLiquidation(demande);
    }
  }
  
  private void detecterDroitOption(Contexte contexte, ResultatLiquidationAssurance resultat)
    throws ApplicativeException
  {
    DemandeAssuranceSpec demande = getDemandeAsu(contexte);
    if ((demande.getEvenementReferenceExamen().getTypeExamen().equalsIgnoreCase("ASU_01")) || (demande.getEvenementReferenceExamen().getTypeExamen().equalsIgnoreCase("ASU_27")))
    {
      DossierExamenSpec dossierExamen = demande.getDossierExamen();
      if (!(dossierExamen instanceof RejetSpec))
      {
        FiltreOU filtreAss = new FiltreOU();
        filtreAss.ajouterFiltre(new FiltreDecisionPourProduit(9));
        filtreAss.ajouterFiltre(new FiltreDecisionPourProduit(10));
        FiltreET filtre = new FiltreET();
        filtre.ajouterFiltre(new FiltreAttributionSurDecisions());
        filtre.ajouterFiltre(filtreAss);
        filtre.ajouterFiltre(new FiltreNegation(new FiltreReexamenSurDemande()));
        
        AttributionSpec attributionPrecedente = (AttributionSpec)OutilRecherche.rechercherDecisionPrecedente(demande.getDemandeur().getChronoDemandesNonTriees(), demande.getDateExamen(), filtre);
        
        DemandeSpec demandeSuivante = null;
        if (attributionPrecedente != null)
        {
          demandeSuivante = attributionPrecedente.getDemandeSuivantePourTraitementReliquat();
          
          attributionPrecedente.setDemandeSuivantePourTraitementReliquat(demande);
        }
        if (RechercherReliquat.rechercherValiditeReliquatPourAss(attributionPrecedente, demande.getDateExamen())) {
          resultat.setAfficherDroitOptionAss(true);
        }
        if (attributionPrecedente != null) {
          attributionPrecedente.setDemandeSuivantePourTraitementReliquat(demandeSuivante);
        }
      }
      if ((dossierExamen instanceof OdSpec))
      {
        int typeParticulierContratFg = demande.getFaitGenerateur().getPeriodeFaitGenerateur().getContratTypeParticulier();
        switch (typeParticulierContratFg)
        {
        case 7: 
        case 14: 
        case 15: 
        case 16: 
        case 17: 
        case 20: 
        case 21: 
        case 22: 
        case 23: 
        case 24: 
        case 211: 
        case 221: 
          if ((((Demande)demande).getReliquat() != null) && (((Demande)demande).getReliquat().estReliquatValide())) {
            resultat.setAfficherDroitOptionReprise(true);
          }
          break;
        }
      }
    }
    if (((demande.getDossierExamen() instanceof RepriseSpec)) || ((demande.getDossierExamen() instanceof NovationSpec))) {
      proposerDroitOptionReadmission(resultat, demande);
    }
    if (((DossierExamenAssuranceSpec)demande.getDossierExamen()).estRejetDV())
    {
      int sousType = demande.getObjectifDecisionne().getSousType();
      if (NaturesDecisions.estdeTypeReprise(sousType)) {
        proposerDroitOptionReadmission(resultat, demande);
      }
    }
  }
  
  private void proposerDroitOptionReadmission(ResultatLiquidationAssurance resultat, DemandeAssuranceSpec demande)
    throws CoucheLogiqueException
  {
    CritereStrategie critere = new CritereStrategie();
    critere.setDatePivot(demande.getDateExamen());
    
    StrategieDroitOptionSpec strategie = (StrategieDroitOptionSpec)FabriqueStrategieDroitOption.getInstance().getStrategie(critere);
    
    resultat.setAfficherDroitOptionReadmission(strategie.estDroitOptionReadmissionPossible((Demande)demande));
  }
  
  private void declencherAlertesNonBloquantes(Contexte contexte)
    throws ApplicativeException
  {
    Parcours parcours = new ParcoursRechercheAlertesNonBloquantes();
    parcours.effectuerParcours(contexte);
  }
  
  protected void liquiderDemande(Contexte contexte)
    throws ApplicativeException
  {
    determinerOrdreObjectifs(contexte);
    
    traiterObjectifs(contexte);
  }
  
  protected void determinerOrdreObjectifs(Contexte contexte)
    throws ApplicativeException
  {
    ProduitAsuSpec produit = (ProduitAsuSpec)getDemandeAsu(contexte).getDossierAffectation().getProduit();
    produit.determinerOrdreObjectifs(contexte);
  }
  
  private void traiterObjectifs(Contexte contexte)
    throws ApplicativeException
  {
    Demande demandeCourante = getDemandeAsu(contexte);
    
    ObjectifExamen objectifCourant = demandeCourante.getObjectifParNumeroOrdre(1);
    try
    {
      boolean traitementFini = false;
      while (!traitementFini)
      {
        lancerParcoursObjectif(contexte, objectifCourant);
        if (objectifCourant.getEtat() == 21)
        {
          boolean objectifValide = verifierValiditeObjectif(contexte);
          if (objectifValide)
          {
            proposerAttribution(contexte);
            objectifCourant.setEtat(23);
            traitementFini = true;
          }
          else
          {
            sauvegardeElementsJustificatifs(contexte);
            determinerOrdreObjectifs(contexte);
            objectifCourant = demandeCourante.getObjectifParNumeroOrdre(1);
          }
        }
        else
        {
          StrategieRepriseSystematiqueSpec strategie = (StrategieRepriseSystematiqueSpec)FabriqueStrategieGenerique.choisirStrategie(demandeCourante.getDateExamen(), "Date d'application de la nouvelle convention ARE 2014", new StrategieRepriseSystematiqueAvantAre14(), new StrategieRepriseSystematiqueApresAre14());
          
          strategie.gererRepriseInvalide(objectifCourant, demandeCourante);
          
          ObjectifExamen objectifNonTraite = verifierExistenceObjectifNonTraite(contexte);
          if (objectifNonTraite == null)
          {
            proposerRejet(contexte);
            traitementFini = true;
          }
          else
          {
            objectifCourant = objectifNonTraite;
          }
        }
      }
      alimenterTopInvestigationFrauduleuse(getDemandeAsu(contexte));
    }
    finally
    {
      getDemandeAsu(contexte).setObjectifCourant(null);
    }
  }
  
  private void sauvegardeElementsJustificatifs(Contexte contexte)
    throws CoucheLogiqueException
  {
    DossierExamenAssuranceSpec dossierExamen = (DossierExamenAssuranceSpec)getDemandeAsu(contexte).getDossierExamen();
    
    ProduitAsuSpec produit = (ProduitAsuSpec)getDemandeAsu(contexte).getDossierAffectation().getProduit();
    produit.sauvegardeElementsJustificatifs(dossierExamen);
  }
  
  private boolean verifierValiditeObjectif(Contexte contexte)
    throws ApplicativeException
  {
    Collection<?> listeObjectifs = getDemandeAsu(contexte).getListeObjectifsExamen();
    for (Iterator<?> iter = listeObjectifs.iterator(); iter.hasNext();)
    {
      ObjectifExamen objectif = (ObjectifExamen)iter.next();
      if ((objectif.getType() == 2) && (objectif.getEtat() != 20)) {
        return true;
      }
    }
    if (getDom(contexte).getContexteExamen() != 3) {
      return true;
    }
    ((ProduitAsuSpec)getDemandeAsu(contexte).getDossierAffectation().getProduit()).verifierValiditeObjectif(contexte);
    
    EvenementReferenceExamenSpec ere = getDemandeAsu(contexte).getEvenementReferenceExamen();
    if ((ere instanceof EreDemandeExpresse)) {
      return true;
    }
    if ((ere instanceof ErePassageCPSuiteRejetDV)) {
      return true;
    }
    if (getDom(contexte).estEnRepriseContextuelle()) {
      return false;
    }
    return true;
  }
  
  protected void proposerRejet(Contexte contexte)
    throws CoucheLogiqueException
  {
    Demande demande = getDemandeAsu(contexte);
    
    demande.setListeMotifsReexamen(null);
    
    DossierExamenSpec dossierExamen = demande.getDossierAffectation().getDossierExamen();
    ((DossierExamenAssuranceSpec)dossierExamen).setContributionParticuliere(null);
    
    demande.setDemandeOrigine(null);
    
    Collection<?> listeObjectifs = demande.getListeObjectifsExamen();
    for (Iterator<?> iter = listeObjectifs.iterator(); iter.hasNext();)
    {
      ObjectifExamen objectif = (ObjectifExamen)iter.next();
      if (objectif.getType() == 1) {
        if (demande.getDecisionAutomatique() == 1)
        {
          demande.getDossierAffectationAdmission().getDossierExamen().changerEtat(28);
          ((DecisionSpec)demande.getDossierAffectationAdmission().getDossierExamen()).setNatureDecision(28);
        }
        else
        {
          verifierAlerteA15MB1(demande, contexte);
          if ("S".equalsIgnoreCase(demande.getModeLiquidation()))
          {
            demande.getDossierAffectationAdmission().getDossierExamen().changerEtat(33);
            ((DecisionSpec)demande.getDossierAffectationAdmission().getDossierExamen()).setNatureDecision(33);
          }
          else
          {
            demande.getDossierAffectationAdmission().getDossierExamen().changerEtat(16);
            ((DecisionSpec)demande.getDossierAffectationAdmission().getDossierExamen()).setNatureDecision(16);
          }
        }
      }
      if ((objectif.getType() == 2) || (objectif.getType() == 5) || (objectif.getType() == 6))
      {
        verifierAlerteA15MB1(demande, contexte);
        if ("S".equalsIgnoreCase(demande.getModeLiquidation()))
        {
          demande.getDossierAffectationReprise().getDossierExamen().changerEtat(33);
          ((DecisionSpec)demande.getDossierAffectationReprise().getDossierExamen()).setNatureDecision(33);
        }
        else
        {
          demande.getDossierAffectationReprise().getDossierExamen().changerEtat(16);
          ((DecisionSpec)demande.getDossierAffectationReprise().getDossierExamen()).setNatureDecision(16);
        }
      }
    }
    demande.setObjectifCourant(null);
    postTraiterJustificationAffiliation(getDemandeAsu(contexte));
    
    ((ProduitAsuSpec)dossierExamen.getDossierAffecte().getProduit()).verifierPropositionRejet(demande);
  }
  
  protected void proposerAttribution(Contexte contexte)
    throws ApplicativeException
  {
    Demande demande = getDemandeAsu(contexte);
    
    DossierExamenSpec dossierExamen = demande.getDossierAffectation().getDossierExamen();
    
    ((DecisionSpec)demande.getDossierExamen()).setNatureDecision(getDemandeAsu(contexte).getObjectifCourant().getSousType());
    
    ((ProduitAsuSpec)dossierExamen.getDossierAffecte().getProduit()).verifierPropositionAttribution(demande);
    if ((dossierExamen instanceof OdSpec)) {
      ((ProduitAsuSpec)dossierExamen.getDossierAffecte().getProduit()).detecterContributionParticuliere(contexte);
    } else if (((dossierExamen instanceof RepriseSpec)) || ((dossierExamen instanceof NovationSpec))) {
      if (OutilGestionContexteDemande.estContexteDemandeAssurancePresent(demande, "AREENTRCSP")) {
        ((ProduitAsuSpec)dossierExamen.getDossierAffecte().getProduit()).detecterContributionParticuliere(contexte);
      } else {
        ((DossierExamenAssuranceSpec)dossierExamen).setContributionParticuliere(null);
      }
    }
    if ((dossierExamen instanceof AttributionSpec))
    {
      alimenterTranchesExecutables(contexte);
      ((AttributionAssuranceSpec)dossierExamen).supprimerCacheElementBaseIndemnisation();
    }
    if (demande.getDossierAffectationReprise() != null)
    {
      demande.getDossierAffectationReprise().setTypeRepriseContextuellePourSuivi(getDom(contexte).getTypeRepriseContextuelle());
      if (!demande.estEnContexteDroitAnterieurSecteurPublicValide())
      {
        DomLiquidationAssurance dom = (DomLiquidationAssurance)contexte.getDonnees();
        getDemandeAsu(contexte).setDemandeOrigine((DemandeAssuranceSpec)dom.getAttributionPrecedente().getDemande());
      }
    }
    demande.setListeMotifsReexamen(null);
    
    getDom(contexte).setContinuerEtudeFctEre(false);
    
    demande.setObjectifCourant(null);
    postTraiterJustificationAffiliation(getDemandeAsu(contexte));
    
    controlerDemandeOrigine(demande);
  }
  
  protected void controlerDemandeOrigine(Demande demande)
    throws CoucheLogiqueException
  {
    boolean estDemandeExpress = "ASU_02".equals(demande.getEvenementReferenceExamen().getTypeExamen());
    boolean sontAttributionsPresentes = (demande.getDemandeOrigine() != null) && (demande.getAttribution() != null) && (demande.getDemandeOrigine().getAttribution() != null);
    if ((estDemandeExpress) && (sontAttributionsPresentes) && (demande.getAttribution().getDateAttribution().compareTo(demande.getDemandeOrigine().getAttribution().getDateAttribution()) < 0)) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_L_CALI_ASU_DEMANDE_ORIGINE", new String[] { demande.getDemandeOrigine().getAttribution().getDateAttribution().toString() });
    }
  }
  
  private void verifierAlerteA15MB1(DemandeSpec demande, Contexte contexte)
    throws CoucheLogiqueException
  {
    DossierExamenAssuranceSpec dossierExamenAsu = (DossierExamenAssuranceSpec)((Demande)demande).getDossierExamen();
    
    boolean estConditionFaitGenerateurNonSatisfaite = (dossierExamenAsu.getFaitGenerateur() != null) && (!dossierExamenAsu.getFaitGenerateur().estSatisfait());
    boolean estConditionQuantiteAffiliationNonSatisfaite = (dossierExamenAsu.getConditionQuantiteAffiliation() != null) && (!dossierExamenAsu.getConditionQuantiteAffiliation().estSatisfait());
    if (((estConditionFaitGenerateurNonSatisfaite) || (estConditionQuantiteAffiliationNonSatisfaite)) && (((Demande)demande).estEnContexteDroitAnterieurSecteurPublicValide()) && (4 == getDom(contexte).getContexteExamen())) {
      leverAlerteA15MB1(dossierExamenAsu);
    }
  }
  
  private void leverAlerteA15MB1(DossierExamenAssuranceSpec dossierExamenAsu)
    throws CoucheLogiqueException
  {
    boolean capaAffiliationSatisfaite = true;
    if ((dossierExamenAsu.getConditionQuantiteAffiliation() == null) || (!dossierExamenAsu.getConditionQuantiteAffiliation().estSatisfait())) {
      capaAffiliationSatisfaite = false;
    }
    boolean capaFaitGenerateurSatisfaite = true;
    if ((dossierExamenAsu.getFaitGenerateur() == null) || (!dossierExamenAsu.getFaitGenerateur().estSatisfait())) {
      capaFaitGenerateurSatisfaite = false;
    }
    if (!capaFaitGenerateurSatisfaite) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ALERTE_A15MB1_FGD_KO");
    } else if (!capaAffiliationSatisfaite) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ALERTE_A15MB1_AFFI_KO");
    } else {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ALERTE_A15MB1");
    }
  }
  
  private void alimenterTopInvestigationFrauduleuse(Demande demande)
    throws CoucheLogiqueException
  {
    boolean alimenterTopInvestigationFraude = true;
    if (demande.estExamenSuiteRejetDV())
    {
      DemandeSpec demandeDV = GestionDemandeDv122eJour.retrouverDemandePortantDv(demande);
      if ((demandeDV != null) && (demandeDV.estMigree())) {
        alimenterTopInvestigationFraude = false;
      }
    }
    if (alimenterTopInvestigationFraude)
    {
      FiltreInvestigationFrauduleuse filtrePF = new FiltreInvestigationFrauduleuse();
      filtrePF.ajouterStatusInvestigationFrauduleuse(4);
      
      Chronologie chronoPeriodesPF = demande.getDemandeur().getChronoPeriodePasseProfessionnelEcartees().copier(filtrePF);
      
      boolean presencePeriodeFrauduleuses = !chronoPeriodesPF.estVide();
      if (presencePeriodeFrauduleuses)
      {
        boolean deTopeFraudeAvantDateExamen = chronoPeriodesPF.premierElement().getDateDebut().estAvantOuCoincideAvec(demande.getDateExamen());
        
        ((DecisionAssuranceSpec)demande.getDossierExamen()).setInvestigationFraude(deTopeFraudeAvantDateExamen);
      }
      demande.getDemandeur().setInvestigationFraude(presencePeriodeFrauduleuses);
    }
  }
  
  protected int getModeChargementDebrayageDossiersLourds(Individu individu)
  {
    return 0;
  }
  
  protected void alimenterAgregatGaec(Individu individu, String idDemande)
  {
    individu.getDonneesChargementGaec().getAgregatGaec().setModeAppel(0);
  }
  
  protected void controlerPostTraitement(Individu individu)
    throws AccesDonneesGaecException
  {
    controlerModeAppel(individu.getDonneesChargementGaec().getAppelGaecReduit(), 0);
  }
  
  protected void traitementPostLiquidation(Contexte contexte)
    throws CoucheLogiqueException
  {
    super.traitementPostLiquidation(contexte);
    DomLiquidationDemande domCourant = (DomLiquidationDemande)contexte.getDonnees();
    DemandeAssuranceSpec demande = (DemandeAssuranceSpec)domCourant.getDemandeSpec();
    OutilCopieDonneesForcees.nettoyerDonneesForcees(demande);
    
    demande.getDateExamen();
  }
  
  private void detectionPresenceAntecedentPendantFCT(DemandeSpec demandeCourante)
    throws ApplicativeException
  {
    FiltreET filtreAntecedentAsu = new FiltreET();
    filtreAntecedentAsu.ajouterFiltre(new FiltreDemandePourERE("ASU_22"));
    filtreAntecedentAsu.ajouterFiltre(new FiltreDecisionneeSurDemande());
    filtreAntecedentAsu.ajouterFiltre(new FiltreNegation(new FiltreReexamenSurDemande()));
    
    DecisionSpec antecedent = OutilRecherche.rechercherDecisionPrecedente(demandeCourante.getChronologieDemandesAssuranceSansCourante(), demandeCourante.getDateExamen(), filtreAntecedentAsu);
    if (antecedent != null)
    {
      Damj djc = ((Demande)antecedent.getDemande()).getSaisieAntecedent().getDateDernierJourCalcule();
      if (djc.estApresOuCoincideAvec(demandeCourante.getDateExamen()))
      {
        Object[] params = { djc };
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_CALI_L_ETUDE_FCT_DURANT_ANTECEDENT", params);
      }
    }
  }
}

/* Location:
 * Qualified Name:     ParcoursLiquidationAssuranceClassique
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */