package fr.unedic.cali.asu.produits.liquidation.dom;

import fr.unedic.cali.asu.produits.liquidation.dom.gen.ConstitutionElementsRevisionGen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public class ConstitutionElementsRevision
  extends ConstitutionElementsRevisionGen
  implements ConstitutionElementsSpec
{
  private static final long serialVersionUID = -111984143464462503L;
  
  public ConstitutionElementsRevision(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public ConstitutionElementsRevision() {}
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(super.getConstitutionSjr());
    DomManager.persisterEnProfondeur(super.getConstitutionDelais());
    DomManager.persisterEnProfondeur(super.getConstitutionSjc());
    DomManager.persisterEnProfondeur(super.getConstitutionDurees());
    DomManager.persisterEnProfondeur(super.getConstitutionMontantsBruts());
    DomManager.persisterEnProfondeur(super.getConstitutionPointDepartIndemnisation());
    DomManager.persisterEnProfondeur(super.getConstitutionCoefficientTempsPartiel());
    DomManager.persisterEnProfondeur(super.getConstitutionDateAttribution());
    DomManager.persisterEnProfondeur(super.getConstitutionDateLimiteIndemnisation());
  }
  
  public ObjetMetierSpec copie()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller le méthode copieElements(ObjetMetierSpec).");
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ConstitutionElementsRevision copie = (ConstitutionElementsRevision)p_copie;
    if (getConstitutionDateAttribution() != null)
    {
      ConstitutionDateAttribution copieCepa = copie.createConstitutionDateAttribution();
      getConstitutionDateAttribution().copieElements(copieCepa);
    }
    if (getConstitutionDelais() != null)
    {
      ConstitutionDelais copieCepa = copie.createConstitutionDelais();
      getConstitutionDelais().copieElements(copieCepa);
    }
    if (getConstitutionMontantsBruts() != null)
    {
      ConstitutionMontantsBruts copieCepa = copie.createConstitutionMontantsBruts();
      getConstitutionMontantsBruts().copieElements(copieCepa);
    }
    if (getConstitutionSjc() != null)
    {
      ConstitutionSjc copieCepa = copie.createConstitutionSjc();
      getConstitutionSjc().copieElements(copieCepa);
    }
    if (getConstitutionSjr() != null)
    {
      ConstitutionSjr copieCepa = copie.createConstitutionSjr();
      getConstitutionSjr().copieElements(copieCepa);
    }
    if (getConstitutionPointDepartIndemnisation() != null)
    {
      ConstitutionPointDepartIndemnisation copieCepa = copie.createConstitutionPointDepartIndemnisation();
      getConstitutionPointDepartIndemnisation().copieElements(copieCepa);
    }
    if (getConstitutionCoefficientTempsPartiel() != null)
    {
      ConstitutionCoefficientTempsPartiel copieCepa = copie.createConstitutionCoefficientTempsPartiel();
      getConstitutionCoefficientTempsPartiel().copieElements(copieCepa);
    }
    if (getConstitutionDurees() != null)
    {
      ConstitutionDurees copieCepa = copie.createConstitutionDurees();
      getConstitutionDurees().copieElements(copieCepa);
    }
    if (getConstitutionDateLimiteIndemnisation() != null)
    {
      ConstitutionDateLimiteIndemnisation copieCepa = copie.createConstitutionDateLimiteIndemnisation();
      getConstitutionDateLimiteIndemnisation().copieElements(copieCepa);
    }
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public ConstitutionCaractereSaisonnier createConstitutionCaractereSaisonnier()
  {
    return null;
  }
  
  public ConstitutionCoefficientSaisonnier createConstitutionCoefficientSaisonnier()
  {
    return null;
  }
  
  public ConstitutionReglementApplicable createConstitutionReglementApplicable()
  {
    return null;
  }
  
  public ConstitutionCaractereSaisonnier getConstitutionCaractereSaisonnier()
  {
    return null;
  }
  
  public ConstitutionCoefficientSaisonnier getConstitutionCoefficientSaisonnier()
  {
    return null;
  }
  
  public ConstitutionReglementApplicable getConstitutionReglementApplicable()
  {
    return null;
  }
  
  public ConstitutionDateLimiteIndemnisation createConstitutionDateLimiteIndemnisation()
  {
    return null;
  }
  
  public ConstitutionDateLimiteIndemnisation getConstitutionDateLimiteIndemnisation()
  {
    return null;
  }
  
  public ConstitutionSjr createConstitutionSjr()
  {
    ConstitutionSjr constitutionSjr = super.createConstitutionSjr();
    constitutionSjr.setSjrRevise(null);
    return constitutionSjr;
  }
}

/* Location:
 * Qualified Name:     ConstitutionElementsRevision
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */