package fr.unedic.cali.asu.produits.liquidation.dom;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffecte;
import fr.unedic.cali.asu.dom.JustificationAffiliationSpec;
import fr.unedic.cali.asu.dom.ObjectifExamen;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.asu.produits.liquidation.dom.gen.ExamenGen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConditionsAttributionSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsSpec;
import fr.unedic.cali.dom.ExamenSpec;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;
import java.util.Collection;

public class Examen
  extends ExamenGen
  implements ExamenSpec
{
  private static final long serialVersionUID = 1896030672504007635L;
  
  public Examen(DomPCSpec pc)
  {
    super(pc);
  }
  
  public Examen() {}
  
  public Examen(Damj dateEvenement)
  {
    super(dateEvenement);
  }
  
  public ObjetMetierSpec copie()
  {
    Examen copie = new Examen();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
    
    Examen copie = (Examen)p_copie;
    if (getConditionsAttributionAdmission() != null) {
      copie.setConditionsAttributionAdmission(new ConditionsAttributionAdmission());
    }
    if (getConstitutionElementsAdmission() != null) {
      copie.setConstitutionElementsAdmission(new ConstitutionElementsAdmission());
    }
    if (getConditionsAttributionReprise() != null) {
      copie.setConditionsAttributionReprise(new ConditionsAttributionReprise());
    }
    if (getConstitutionElementsReprise() != null) {
      copie.setConstitutionElementsReprise(new ConstitutionElementsReprise());
    }
    if (getConditionsAttributionRevision() != null) {
      copie.setConditionsAttributionRevision(new ConditionsAttributionRevision());
    }
    if (getConstitutionElementsRevision() != null) {
      copie.setConstitutionElementsRevision(new ConstitutionElementsRevision());
    }
  }
  
  /**
   * @deprecated
   */
  public void marquerGraphePersistant()
  {
    super.marquerGraphePersistant();
  }
  
  public ConditionsAttributionSpec getConditionsAttributionActives()
  {
    ObjectifExamen objectifCourant = ((Demande)getDemande()).getObjectifCourant();
    int natureObjectif = ((DossierAffecte)getDossierAffecte()).getTypeDossier();
    if (objectifCourant != null) {
      natureObjectif = objectifCourant.getType();
    }
    switch (natureObjectif)
    {
    case 2: 
    case 5: 
    case 6: 
      return getConditionsAttributionReprise();
    }
    return getConditionsAttributionAdmission();
  }
  
  public ConstitutionElementsSpec getConstitutionElementsActifs()
  {
    ObjectifExamen objectifCourant = ((Demande)getDemande()).getObjectifCourant();
    int natureObjectif = ((DossierAffecte)getDossierAffecte()).getTypeDossier();
    if (objectifCourant != null) {
      natureObjectif = objectifCourant.getType();
    }
    switch (natureObjectif)
    {
    case 2: 
    case 5: 
    case 6: 
      return getConstitutionElementsReprise();
    }
    return getConstitutionElementsAdmission();
  }
  
  public JustificationAffiliationSpec getJustificationAffiliation()
  {
    if ((getDossierAffecte() != null) && (((DossierAffecte)getDossierAffecte()).getValidationProduit() != null) && (((DossierAffecte)getDossierAffecte()).getValidationProduit().getJustificationCalculAffiliation() != null)) {
      return ((DossierAffecte)getDossierAffecte()).getValidationProduit().getJustificationCalculAffiliation();
    }
    return getConditionsAttributionAdmission().getConditionQuantiteAffiliation() != null ? getConditionsAttributionAdmission().getConditionQuantiteAffiliation().getJustificationAffiliation() : null;
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public Collection getListePlafonnementAffiliation()
  {
    return getJustificationAffiliation() != null ? ((JustificationAffiliation)getJustificationAffiliation()).getListePlafonnementAffiliation() : null;
  }
}

/* Location:
 * Qualified Name:     Examen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */