package fr.unedic.cali.asu.produits.liquidation.dom;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.DossierAffecte;
import fr.unedic.cali.asu.dom.FaitGenerateurSpec;
import fr.unedic.cali.asu.dom.JustificationAffiliationSpec;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.asu.produits.liquidation.dom.gen.OdGen;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.DeterminationSituationParticuliere;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.parcours.ResultatAvant;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import java.util.Collection;

public class Od
  extends OdGen
  implements fr.unedic.cali.asu.dom.OdAssuranceSpec
{
  private static final long serialVersionUID = -3093196909253706931L;
  
  public Od(DomPCSpec pc)
  {
    super(pc);
  }
  
  public Od() {}
  
  public Od(Damj dateEvenement)
  {
    super(dateEvenement);
  }
  
  public Od(Damj dateEvenement, DossierExamen dossierExamen)
  {
    super(dateEvenement);
    copie(dossierExamen);
  }
  
  public String getRsod()
  {
    return getReferenceExterne();
  }
  
  public String getRsrp()
  {
    return "0";
  }
  
  protected void copie(Attribution source)
  {
    if (source == null) {
      return;
    }
    super.copie(source);
  }
  
  public void copieElements(ObjetMetierSpec copie)
  {
    Od copieLocal = (Od)copie;
    super.copieElements(copieLocal);
  }
  
  public ObjetMetierSpec copie()
  {
    Od copie = new Od();
    copieElements(copie);
    return copie;
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public JustificationAffiliationSpec getJustificationAffiliation()
  {
    if (((DossierAffecte)getDossierAffecte()).getValidationProduit().getJustificationCalculAffiliation() != null) {
      return ((DossierAffecte)getDossierAffecte()).getValidationProduit().getJustificationCalculAffiliation();
    }
    if (((DossierAffecte)getDossierAffecte()).getValidationProduit().getJustificationAffiliationJoursTravailles() != null) {
      return ((DossierAffecte)getDossierAffecte()).getValidationProduit().getJustificationAffiliationJoursTravailles();
    }
    if (getConstitutionQuantiteAffiliation() == null) {
      return null;
    }
    Unite uniteJustification = getConstitutionQuantiteAffiliation().getQuantiteAcquise().getUnite();
    return getConstitutionQuantiteAffiliation().getJustificationAffiliation(uniteJustification);
  }
  
  public AttributionAssuranceSpec getAttributionOrigine()
  {
    return this;
  }
  
  public AttributionAssuranceSpec getAttributionMaitrePourRevision()
  {
    return this;
  }
  
  public Damj getDateFaitGenerateurDroit()
  {
    return getConditionFaitGenerateur().getDateFaitGenerateur();
  }
  
  public String getSituationParticuliere()
  {
    String situation = super.getSituationParticuliere();
    if (situation == null) {
      situation = DeterminationSituationParticuliere.getSituationParticuliere(this);
    }
    return situation;
  }
  
  public Collection<?> getListePlafonnementAffiliation()
  {
    Collection<?> listePlafonnementAffiliation = null;
    try
    {
      listePlafonnementAffiliation = ((ProduitAsuSpec)getProduit()).determinerListePlafonnementAffiliation(this);
    }
    catch (ApplicativeException ex)
    {
      listePlafonnementAffiliation = null;
    }
    return listePlafonnementAffiliation;
  }
  
  public fr.unedic.cali.dom.OdAssuranceSpec getOuvertureDroit()
  {
    return this;
  }
  
  public fr.unedic.cali.asu.dom.OdAssuranceSpec getOuvertureDroitCapitalRetenu()
  {
    return this;
  }
  
  public ResultatAvant determinationEtatACT()
    throws CoucheLogiqueException
  {
    return null;
  }
  
  protected ConstitutionDateLimiteIndemnisation getConstitutionDateLimiteIndemnisationAttributionOrigine()
  {
    return getConstitutionDateLimiteIndemnisation();
  }
}

/* Location:
 * Qualified Name:     Od
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */