package fr.unedic.cali.asu.produits.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.dom.PeriodeChomageSaisonnier;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsAbstraitPC;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Periode;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public abstract class ConstitutionCaractereSaisonnierGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionElementsAbstraitPC;
  private Periode m_periodeReferenceSaisonnier = null;
  private Periode m_periodeRechercheActiviteSaisonniere = null;
  private Collection m_listePeriodesChomageSaisonnierPrive = null;
  
  public ConstitutionCaractereSaisonnierGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConstitutionCaractereSaisonnierGen() {}
  
  public DomPCSpec getPC()
  {
    return m_constitutionElementsAbstraitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionElementsAbstraitPC)
  {
    m_constitutionElementsAbstraitPC = p_constitutionElementsAbstraitPC;
  }
  
  protected boolean rawIsCaractereSaisonnierRetenu()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).isCaractereSaisonnierRetenuConstitutionCaractereSaisonnier();
  }
  
  public boolean isCaractereSaisonnierRetenu()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).isCaractereSaisonnierRetenuConstitutionCaractereSaisonnier();
  }
  
  public void setCaractereSaisonnierRetenu(boolean p_caractereSaisonnierRetenu)
  {
    ((ConstitutionElementsAbstraitPC)getPC()).setCaractereSaisonnierRetenuConstitutionCaractereSaisonnier(p_caractereSaisonnierRetenu);
  }
  
  protected int rawGetTypeCaractereSaisonnierRetenu()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTypeCaractereSaisonnierRetenuConstitutionCaractereSaisonnier();
  }
  
  public int getTypeCaractereSaisonnierRetenu()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTypeCaractereSaisonnierRetenuConstitutionCaractereSaisonnier();
  }
  
  public void setTypeCaractereSaisonnierRetenu(int p_typeCaractereSaisonnierRetenu)
  {
    ((ConstitutionElementsAbstraitPC)getPC()).setTypeCaractereSaisonnierRetenuConstitutionCaractereSaisonnier(p_typeCaractereSaisonnierRetenu);
  }
  
  protected Periode rawGetPeriodeReferenceSaisonnier()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getPeriodeReferenceSaisonnierConstitutionCaractereSaisonnier();
  }
  
  public Periode getPeriodeReferenceSaisonnier()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getPeriodeReferenceSaisonnierConstitutionCaractereSaisonnier();
  }
  
  public void setPeriodeReferenceSaisonnier(Periode p_periodeReferenceSaisonnier)
  {
    if ((m_periodeReferenceSaisonnier == null) || (p_periodeReferenceSaisonnier == null))
    {
      m_periodeReferenceSaisonnier = p_periodeReferenceSaisonnier;
      ((ConstitutionElementsAbstraitPC)getPC()).setPeriodeReferenceSaisonnierConstitutionCaractereSaisonnier(p_periodeReferenceSaisonnier);
    }
    else if ((m_periodeReferenceSaisonnier != null) && (p_periodeReferenceSaisonnier != null) && (!p_periodeReferenceSaisonnier.equals(m_periodeReferenceSaisonnier)))
    {
      m_periodeReferenceSaisonnier = p_periodeReferenceSaisonnier;
      ((ConstitutionElementsAbstraitPC)getPC()).setPeriodeReferenceSaisonnierConstitutionCaractereSaisonnier(p_periodeReferenceSaisonnier);
    }
  }
  
  protected Periode rawGetPeriodeRechercheActiviteSaisonniere()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getPeriodeRechercheActiviteSaisonniereConstitutionCaractereSaisonnier();
  }
  
  public Periode getPeriodeRechercheActiviteSaisonniere()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getPeriodeRechercheActiviteSaisonniereConstitutionCaractereSaisonnier();
  }
  
  public void setPeriodeRechercheActiviteSaisonniere(Periode p_periodeRechercheActiviteSaisonniere)
  {
    if ((m_periodeRechercheActiviteSaisonniere == null) || (p_periodeRechercheActiviteSaisonniere == null))
    {
      m_periodeRechercheActiviteSaisonniere = p_periodeRechercheActiviteSaisonniere;
      ((ConstitutionElementsAbstraitPC)getPC()).setPeriodeRechercheActiviteSaisonniereConstitutionCaractereSaisonnier(p_periodeRechercheActiviteSaisonniere);
    }
    else if ((m_periodeRechercheActiviteSaisonniere != null) && (p_periodeRechercheActiviteSaisonniere != null) && (!p_periodeRechercheActiviteSaisonniere.equals(m_periodeRechercheActiviteSaisonniere)))
    {
      m_periodeRechercheActiviteSaisonniere = p_periodeRechercheActiviteSaisonniere;
      ((ConstitutionElementsAbstraitPC)getPC()).setPeriodeRechercheActiviteSaisonniereConstitutionCaractereSaisonnier(p_periodeRechercheActiviteSaisonniere);
    }
  }
  
  protected boolean rawIsActivite3Sur5()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).isActivite3Sur5ConstitutionCaractereSaisonnier();
  }
  
  public boolean isActivite3Sur5()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).isActivite3Sur5ConstitutionCaractereSaisonnier();
  }
  
  public void setActivite3Sur5(boolean p_activite3Sur5)
  {
    ((ConstitutionElementsAbstraitPC)getPC()).setActivite3Sur5ConstitutionCaractereSaisonnier(p_activite3Sur5);
  }
  
  private final Collection getCollectionModifiablePeriodeChomageSaisonnier()
  {
    Iterator itCollectionPC;
    if (m_listePeriodesChomageSaisonnierPrive == null)
    {
      m_listePeriodesChomageSaisonnierPrive = new ArrayList();
      for (itCollectionPC = ((ConstitutionElementsAbstraitPC)getPC()).getCollectionPeriodeChomageSaisonnier().iterator(); itCollectionPC.hasNext();)
      {
        DomPCSpec currentPC = (DomPCSpec)itCollectionPC.next();
        Object currentOM = currentPC.createOM();
        m_listePeriodesChomageSaisonnierPrive.add(currentOM);
      }
    }
    return m_listePeriodesChomageSaisonnierPrive;
  }
  
  public Collection getCollectionPeriodeChomageSaisonnier()
  {
    return Collections.unmodifiableCollection(getCollectionModifiablePeriodeChomageSaisonnier());
  }
  
  public List getListPeriodeChomageSaisonnier()
  {
    return Collections.unmodifiableList((List)getCollectionModifiablePeriodeChomageSaisonnier());
  }
  
  public void remplacerCollectionPeriodeChomageSaisonnier(Collection p_collectionACopier)
  {
    clearCollectionPeriodeChomageSaisonnier();
    for (Iterator i = p_collectionACopier.iterator(); i.hasNext();)
    {
      PeriodeChomageSaisonnier objet = (PeriodeChomageSaisonnier)i.next();
      ajouterPeriodeChomageSaisonnier(objet);
    }
  }
  
  public void supprimerSousCollectionPeriodeChomageSaisonnier(Collection p_collectionASupprimer)
  {
    for (Iterator i = p_collectionASupprimer.iterator(); i.hasNext();)
    {
      PeriodeChomageSaisonnier objet = (PeriodeChomageSaisonnier)i.next();
      supprimerPeriodeChomageSaisonnier(objet);
    }
  }
  
  public void ajouterPeriodeChomageSaisonnier(PeriodeChomageSaisonnier p_periodesChomageSaisonnierConstitutionCaractereSaisonnier)
    throws NullPointerException
  {
    if (p_periodesChomageSaisonnierConstitutionCaractereSaisonnier == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodesChomageSaisonnierConstitutionCaractereSaisonnier ne devrait pas être nul.", p_periodesChomageSaisonnierConstitutionCaractereSaisonnier);
    }
    getCollectionModifiablePeriodeChomageSaisonnier().add(p_periodesChomageSaisonnierConstitutionCaractereSaisonnier);
    ((ConstitutionElementsAbstraitPC)getPC()).ajouterPeriodeChomageSaisonnier(p_periodesChomageSaisonnierConstitutionCaractereSaisonnier.getPC());
  }
  
  public void supprimerPeriodeChomageSaisonnier(PeriodeChomageSaisonnier p_periodesChomageSaisonnierConstitutionCaractereSaisonnier)
    throws NullPointerException
  {
    if (p_periodesChomageSaisonnierConstitutionCaractereSaisonnier == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodesChomageSaisonnierConstitutionCaractereSaisonnier ne devrait pas être nul.", p_periodesChomageSaisonnierConstitutionCaractereSaisonnier);
    }
    getCollectionModifiablePeriodeChomageSaisonnier().remove(p_periodesChomageSaisonnierConstitutionCaractereSaisonnier);
    ((ConstitutionElementsAbstraitPC)getPC()).supprimerPeriodeChomageSaisonnier(p_periodesChomageSaisonnierConstitutionCaractereSaisonnier.getPC());
  }
  
  public void recopierCollectionPeriodeChomageSaisonnierVers(ObjetMetierSpec p_copie)
  {
    ConstitutionCaractereSaisonnierGen copie = (ConstitutionCaractereSaisonnierGen)p_copie;
    Collection listeACopier = getCollectionPeriodeChomageSaisonnier();
    for (Iterator i = listeACopier.iterator(); i.hasNext();)
    {
      ObjetMetierSpec objet = ((ObjetMetierSpec)i.next()).copie();
      copie.ajouterPeriodeChomageSaisonnier((PeriodeChomageSaisonnier)objet);
    }
  }
  
  public void clearCollectionPeriodeChomageSaisonnier()
  {
    getCollectionModifiablePeriodeChomageSaisonnier().clear();
    ((ConstitutionElementsAbstraitPC)getPC()).getCollectionPeriodeChomageSaisonnier().clear();
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    for (Iterator iter = getCollectionPeriodeChomageSaisonnier().iterator(); iter.hasNext();)
    {
      DomGenSpec item = (DomGenSpec)iter.next();
      if ((item != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(item))) {
        DomManager.supprimer(item, p_contexteSuppression);
      }
    }
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    setCaractereSaisonnierRetenu(false);
    setTypeCaractereSaisonnierRetenu(0);
    setPeriodeReferenceSaisonnier(null);
    setPeriodeRechercheActiviteSaisonniere(null);
    setActivite3Sur5(false);
    for (Iterator iter = getCollectionPeriodeChomageSaisonnier().iterator(); iter.hasNext();)
    {
      DomGenSpec item = (DomGenSpec)iter.next();
      if (item != null) {
        DomManager.supprimer(item);
      }
    }
    clearCollectionPeriodeChomageSaisonnier();
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConstitutionCaractereSaisonnierGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */