package fr.unedic.cali.asu.produits.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsAbstraitPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public abstract class ConstitutionDateLimiteIndemnisationGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionElementsAbstraitPC;
  private Damj m_dateLimiteIndem;
  private Damj m_dateDebutIndem;
  private String m_contexteDateLimiteIndemnisation;
  
  public ConstitutionDateLimiteIndemnisationGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConstitutionDateLimiteIndemnisationGen() {}
  
  public DomPCSpec getPC()
  {
    return m_constitutionElementsAbstraitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionElementsAbstraitPC)
  {
    m_constitutionElementsAbstraitPC = p_constitutionElementsAbstraitPC;
  }
  
  protected Damj rawGetDateLimiteIndem()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDateLimiteIndem();
  }
  
  public Damj getDateLimiteIndem()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDateLimiteIndem();
  }
  
  public void setDateLimiteIndem(Damj p_dateLimiteIndem)
  {
    if ((m_dateLimiteIndem == null) || (p_dateLimiteIndem == null))
    {
      m_dateLimiteIndem = p_dateLimiteIndem;
      ((ConstitutionElementsAbstraitPC)getPC()).setDateLimiteIndem(p_dateLimiteIndem);
    }
    else if ((m_dateLimiteIndem != null) && (p_dateLimiteIndem != null) && (!p_dateLimiteIndem.equals(m_dateLimiteIndem)))
    {
      m_dateLimiteIndem = p_dateLimiteIndem;
      ((ConstitutionElementsAbstraitPC)getPC()).setDateLimiteIndem(p_dateLimiteIndem);
    }
  }
  
  protected Damj rawGetDateDebutIndem()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDateDebutIndem();
  }
  
  public Damj getDateDebutIndem()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDateDebutIndem();
  }
  
  public void setDateDebutIndem(Damj p_dateDebutIndem)
  {
    if ((m_dateDebutIndem == null) || (p_dateDebutIndem == null))
    {
      m_dateDebutIndem = p_dateDebutIndem;
      ((ConstitutionElementsAbstraitPC)getPC()).setDateDebutIndem(p_dateDebutIndem);
    }
    else if ((m_dateDebutIndem != null) && (p_dateDebutIndem != null) && (!p_dateDebutIndem.equals(m_dateDebutIndem)))
    {
      m_dateDebutIndem = p_dateDebutIndem;
      ((ConstitutionElementsAbstraitPC)getPC()).setDateDebutIndem(p_dateDebutIndem);
    }
  }
  
  protected String rawGetContexteDateLimiteIndemnisation()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getContexteDateLimiteIndemnisation();
  }
  
  public String getContexteDateLimiteIndemnisation()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getContexteDateLimiteIndemnisation();
  }
  
  public void setContexteDateLimiteIndemnisation(String p_contexteDateLimiteIndemnisation)
  {
    if ((m_contexteDateLimiteIndemnisation == null) || (p_contexteDateLimiteIndemnisation == null))
    {
      m_contexteDateLimiteIndemnisation = p_contexteDateLimiteIndemnisation;
      ((ConstitutionElementsAbstraitPC)getPC()).setContexteDateLimiteIndemnisation(p_contexteDateLimiteIndemnisation);
    }
    else if ((m_contexteDateLimiteIndemnisation != null) && (p_contexteDateLimiteIndemnisation != null) && (!p_contexteDateLimiteIndemnisation.equals(m_contexteDateLimiteIndemnisation)))
    {
      m_contexteDateLimiteIndemnisation = p_contexteDateLimiteIndemnisation;
      ((ConstitutionElementsAbstraitPC)getPC()).setContexteDateLimiteIndemnisation(p_contexteDateLimiteIndemnisation);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    setDateLimiteIndem(null);
    setDateDebutIndem(null);
    setContexteDateLimiteIndemnisation(null);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConstitutionDateLimiteIndemnisationGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */