package fr.unedic.cali.asu.produits.liquidation.dom.pc;

import fr.unedic.cali.asu.produits.liquidation.dom.JustificationDroitResultant;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.QuantiteJour;
import java.io.IOException;
import java.io.ObjectOutputStream;
import javax.jdo.JDOFatalInternalException;
import javax.jdo.JDOUnsupportedOptionException;
import javax.jdo.JDOUserException;
import javax.jdo.PersistenceManager;
import javax.jdo.spi.JDOImplHelper;
import javax.jdo.spi.JDOPermission;
import javax.jdo.spi.PersistenceCapable;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldConsumer;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldSupplier;
import javax.jdo.spi.StateManager;
import xcalia.lido.internal.sm.CommonStateManager;

public class JustificationDroitResultantPC
  implements DomPCSpec, PersistenceCapable
{
  private transient JustificationDroitResultant m_justificationDroitResultantOM;
  protected int m_competenceFinanciereDroitCourant;
  protected QuantiteEuro m_montantInitialDroitCourant;
  protected QuantiteEuro m_capitalDroitCourant;
  protected QuantiteJour m_imputationDroitCourant;
  protected QuantiteJour m_dureeDroitCourant;
  protected QuantiteEuro m_avantageVieillesseDroitCourant;
  protected QuantiteEuro m_pensionInvaliditeDroitCourant;
  protected QuantiteEuro m_crcDroitCourantCompCapitaux;
  protected QuantiteEuro m_montantBrutDroitCourantCompCapitaux;
  protected QuantiteEuro m_montantBrutDroitCourantCompMontants;
  protected int m_competenceFinanciereDroitPrecedent;
  protected QuantiteEuro m_montantInitialDroitPrecedent;
  protected QuantiteEuro m_capitalDroitPrecedent;
  protected QuantiteJour m_imputationDroitPrecedent;
  protected QuantiteJour m_dureeDroitPrecedent;
  protected QuantiteEuro m_avantageVieillesseDroitPrecedent;
  protected QuantiteEuro m_pensionInvaliditeDroitPrecedent;
  protected QuantiteEuro m_crcDroitPrecedentCompCapitaux;
  protected QuantiteEuro m_montantBrutDroitPrecedentCompCapitaux;
  protected QuantiteEuro m_montantBrutDroitPrecedentCompMontants;
  protected int m_competenceFinanciereDroitRetenu;
  protected QuantiteEuro m_montantDroitRetenu;
  protected QuantiteEuro m_capitalDroitRetenu;
  protected QuantiteJour m_imputationDroitRetenu;
  protected boolean m_estCasParticulierPensionInvalidite;
  protected QuantiteJour m_dureeDroitRetenu;
  protected int m_statutPensionInvaliditeDroitCourant;
  private QuantiteEuro m_crcDroitCourantCompMontants;
  private QuantiteEuro m_crcDroitPrecedentCompMontants;
  protected transient byte jdoFlags;
  protected transient StateManager jdoStateManager;
  private static int jdoInheritedFieldCount = 0;
  private static String[] jdoFieldNames = { "m_competenceFinanciereDroitCourant", "m_montantInitialDroitCourant", "m_capitalDroitCourant", "m_imputationDroitCourant", "m_dureeDroitCourant", "m_avantageVieillesseDroitCourant", "m_pensionInvaliditeDroitCourant", "m_crcDroitCourantCompCapitaux", "m_montantBrutDroitCourantCompCapitaux", "m_montantBrutDroitCourantCompMontants", "m_competenceFinanciereDroitPrecedent", "m_montantInitialDroitPrecedent", "m_capitalDroitPrecedent", "m_imputationDroitPrecedent", "m_dureeDroitPrecedent", "m_avantageVieillesseDroitPrecedent", "m_pensionInvaliditeDroitPrecedent", "m_crcDroitPrecedentCompCapitaux", "m_montantBrutDroitPrecedentCompCapitaux", "m_montantBrutDroitPrecedentCompMontants", "m_competenceFinanciereDroitRetenu", "m_montantDroitRetenu", "m_capitalDroitRetenu", "m_imputationDroitRetenu", "m_estCasParticulierPensionInvalidite", "m_dureeDroitRetenu", "m_statutPensionInvaliditeDroitCourant", "m_crcDroitCourantCompMontants", "m_crcDroitPrecedentCompMontants" };
  private static Class[] jdoFieldTypes = { Integer.TYPE, QuantiteEuro.class, QuantiteEuro.class, QuantiteJour.class, QuantiteJour.class, QuantiteEuro.class, QuantiteEuro.class, QuantiteEuro.class, QuantiteEuro.class, QuantiteEuro.class, Integer.TYPE, QuantiteEuro.class, QuantiteEuro.class, QuantiteJour.class, QuantiteJour.class, QuantiteEuro.class, QuantiteEuro.class, QuantiteEuro.class, QuantiteEuro.class, QuantiteEuro.class, Integer.TYPE, QuantiteEuro.class, QuantiteEuro.class, QuantiteJour.class, Boolean.TYPE, QuantiteJour.class, Integer.TYPE, QuantiteEuro.class, QuantiteEuro.class };
  private static byte[] jdoFieldFlags = { (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE) };
  private static Class jdoPersistenceCapableSuperclass = null;
  
  public Object createOM()
  {
    if (m_justificationDroitResultantOM == null) {
      m_justificationDroitResultantOM = new JustificationDroitResultant(this);
    }
    return m_justificationDroitResultantOM;
  }
  
  public int getCompetenceFinanciereDroitCourant()
  {
    return jdoGetm_competenceFinanciereDroitCourant(this);
  }
  
  public final void setCompetenceFinanciereDroitCourant(int p_competenceFinanciereDroitCourant)
  {
    jdoSetm_competenceFinanciereDroitCourant(this, p_competenceFinanciereDroitCourant);
  }
  
  public QuantiteEuro getMontantInitialDroitCourant()
  {
    return jdoGetm_montantInitialDroitCourant(this);
  }
  
  public final void setMontantInitialDroitCourant(QuantiteEuro p_montantInitialDroitCourant)
  {
    jdoSetm_montantInitialDroitCourant(this, p_montantInitialDroitCourant);
  }
  
  public QuantiteEuro getCapitalDroitCourant()
  {
    return jdoGetm_capitalDroitCourant(this);
  }
  
  public final void setCapitalDroitCourant(QuantiteEuro p_capitalDroitCourant)
  {
    jdoSetm_capitalDroitCourant(this, p_capitalDroitCourant);
  }
  
  public QuantiteJour getImputationDroitCourant()
  {
    return jdoGetm_imputationDroitCourant(this);
  }
  
  public final void setImputationDroitCourant(QuantiteJour p_imputationDroitCourant)
  {
    jdoSetm_imputationDroitCourant(this, p_imputationDroitCourant);
  }
  
  public QuantiteJour getDureeDroitCourant()
  {
    return jdoGetm_dureeDroitCourant(this);
  }
  
  public final void setDureeDroitCourant(QuantiteJour p_dureeDroitCourant)
  {
    jdoSetm_dureeDroitCourant(this, p_dureeDroitCourant);
  }
  
  public QuantiteEuro getAvantageVieillesseDroitCourant()
  {
    return jdoGetm_avantageVieillesseDroitCourant(this);
  }
  
  public final void setAvantageVieillesseDroitCourant(QuantiteEuro p_avantageVieillesseDroitCourant)
  {
    jdoSetm_avantageVieillesseDroitCourant(this, p_avantageVieillesseDroitCourant);
  }
  
  public QuantiteEuro getPensionInvaliditeDroitCourant()
  {
    return jdoGetm_pensionInvaliditeDroitCourant(this);
  }
  
  public final void setPensionInvaliditeDroitCourant(QuantiteEuro p_pensionInvaliditeDroitCourant)
  {
    jdoSetm_pensionInvaliditeDroitCourant(this, p_pensionInvaliditeDroitCourant);
  }
  
  public QuantiteEuro getCrcDroitCourantCompCapitaux()
  {
    return jdoGetm_crcDroitCourantCompCapitaux(this);
  }
  
  public final void setCrcDroitCourantCompCapitaux(QuantiteEuro p_crcDroitCourantCompCapitaux)
  {
    jdoSetm_crcDroitCourantCompCapitaux(this, p_crcDroitCourantCompCapitaux);
  }
  
  public QuantiteEuro getMontantBrutDroitCourantCompCapitaux()
  {
    return jdoGetm_montantBrutDroitCourantCompCapitaux(this);
  }
  
  public final void setMontantBrutDroitCourantCompCapitaux(QuantiteEuro p_montantBrutDroitCourantCompCapitaux)
  {
    jdoSetm_montantBrutDroitCourantCompCapitaux(this, p_montantBrutDroitCourantCompCapitaux);
  }
  
  public QuantiteEuro getMontantBrutDroitCourantCompMontants()
  {
    return jdoGetm_montantBrutDroitCourantCompMontants(this);
  }
  
  public final void setMontantBrutDroitCourantCompMontants(QuantiteEuro p_montantBrutDroitCourantCompMontants)
  {
    jdoSetm_montantBrutDroitCourantCompMontants(this, p_montantBrutDroitCourantCompMontants);
  }
  
  public int getCompetenceFinanciereDroitPrecedent()
  {
    return jdoGetm_competenceFinanciereDroitPrecedent(this);
  }
  
  public final void setCompetenceFinanciereDroitPrecedent(int p_competenceFinanciereDroitPrecedent)
  {
    jdoSetm_competenceFinanciereDroitPrecedent(this, p_competenceFinanciereDroitPrecedent);
  }
  
  public QuantiteEuro getMontantInitialDroitPrecedent()
  {
    return jdoGetm_montantInitialDroitPrecedent(this);
  }
  
  public final void setMontantInitialDroitPrecedent(QuantiteEuro p_montantInitialDroitPrecedent)
  {
    jdoSetm_montantInitialDroitPrecedent(this, p_montantInitialDroitPrecedent);
  }
  
  public QuantiteEuro getCapitalDroitPrecedent()
  {
    return jdoGetm_capitalDroitPrecedent(this);
  }
  
  public final void setCapitalDroitPrecedent(QuantiteEuro p_capitalDroitPrecedent)
  {
    jdoSetm_capitalDroitPrecedent(this, p_capitalDroitPrecedent);
  }
  
  public QuantiteJour getImputationDroitPrecedent()
  {
    return jdoGetm_imputationDroitPrecedent(this);
  }
  
  public final void setImputationDroitPrecedent(QuantiteJour p_imputationDroitPrecedent)
  {
    jdoSetm_imputationDroitPrecedent(this, p_imputationDroitPrecedent);
  }
  
  public QuantiteJour getDureeDroitPrecedent()
  {
    return jdoGetm_dureeDroitPrecedent(this);
  }
  
  public final void setDureeDroitPrecedent(QuantiteJour p_dureeDroitPrecedent)
  {
    jdoSetm_dureeDroitPrecedent(this, p_dureeDroitPrecedent);
  }
  
  public QuantiteEuro getAvantageVieillesseDroitPrecedent()
  {
    return jdoGetm_avantageVieillesseDroitPrecedent(this);
  }
  
  public final void setAvantageVieillesseDroitPrecedent(QuantiteEuro p_avantageVieillesseDroitPrecedent)
  {
    jdoSetm_avantageVieillesseDroitPrecedent(this, p_avantageVieillesseDroitPrecedent);
  }
  
  public QuantiteEuro getPensionInvaliditeDroitPrecedent()
  {
    return jdoGetm_pensionInvaliditeDroitPrecedent(this);
  }
  
  public final void setPensionInvaliditeDroitPrecedent(QuantiteEuro p_pensionInvaliditeDroitPrecedent)
  {
    jdoSetm_pensionInvaliditeDroitPrecedent(this, p_pensionInvaliditeDroitPrecedent);
  }
  
  public QuantiteEuro getCrcDroitPrecedentCompCapitaux()
  {
    return jdoGetm_crcDroitPrecedentCompCapitaux(this);
  }
  
  public final void setCrcDroitPrecedentCompCapitaux(QuantiteEuro p_crcDroitPrecedentCompCapitaux)
  {
    jdoSetm_crcDroitPrecedentCompCapitaux(this, p_crcDroitPrecedentCompCapitaux);
  }
  
  public QuantiteEuro getMontantBrutDroitPrecedentCompCapitaux()
  {
    return jdoGetm_montantBrutDroitPrecedentCompCapitaux(this);
  }
  
  public final void setMontantBrutDroitPrecedentCompCapitaux(QuantiteEuro p_montantBrutDroitPrecedentCompCapitaux)
  {
    jdoSetm_montantBrutDroitPrecedentCompCapitaux(this, p_montantBrutDroitPrecedentCompCapitaux);
  }
  
  public QuantiteEuro getMontantBrutDroitPrecedentCompMontants()
  {
    return jdoGetm_montantBrutDroitPrecedentCompMontants(this);
  }
  
  public final void setMontantBrutDroitPrecedentCompMontants(QuantiteEuro p_montantBrutDroitPrecedentCompMontants)
  {
    jdoSetm_montantBrutDroitPrecedentCompMontants(this, p_montantBrutDroitPrecedentCompMontants);
  }
  
  public int getCompetenceFinanciereDroitRetenu()
  {
    return jdoGetm_competenceFinanciereDroitRetenu(this);
  }
  
  public final void setCompetenceFinanciereDroitRetenu(int p_competenceFinanciereDroitRetenu)
  {
    jdoSetm_competenceFinanciereDroitRetenu(this, p_competenceFinanciereDroitRetenu);
  }
  
  public QuantiteEuro getMontantDroitRetenu()
  {
    return jdoGetm_montantDroitRetenu(this);
  }
  
  public final void setMontantDroitRetenu(QuantiteEuro p_montantDroitRetenu)
  {
    jdoSetm_montantDroitRetenu(this, p_montantDroitRetenu);
  }
  
  public QuantiteEuro getCapitalDroitRetenu()
  {
    return jdoGetm_capitalDroitRetenu(this);
  }
  
  public final void setCapitalDroitRetenu(QuantiteEuro p_capitalDroitRetenu)
  {
    jdoSetm_capitalDroitRetenu(this, p_capitalDroitRetenu);
  }
  
  public QuantiteJour getImputationDroitRetenu()
  {
    return jdoGetm_imputationDroitRetenu(this);
  }
  
  public final void setImputationDroitRetenu(QuantiteJour p_imputationDroitRetenu)
  {
    jdoSetm_imputationDroitRetenu(this, p_imputationDroitRetenu);
  }
  
  public boolean isEstCasParticulierPensionInvalidite()
  {
    return jdoGetm_estCasParticulierPensionInvalidite(this);
  }
  
  public final void setEstCasParticulierPensionInvalidite(boolean p_estCasParticulierPensionInvalidite)
  {
    jdoSetm_estCasParticulierPensionInvalidite(this, p_estCasParticulierPensionInvalidite);
  }
  
  public QuantiteJour getDureeDroitRetenu()
  {
    return jdoGetm_dureeDroitRetenu(this);
  }
  
  public final void setDureeDroitRetenu(QuantiteJour p_dureeDroitRetenu)
  {
    jdoSetm_dureeDroitRetenu(this, p_dureeDroitRetenu);
  }
  
  public int getStatutPensionInvaliditeDroitCourant()
  {
    return jdoGetm_statutPensionInvaliditeDroitCourant(this);
  }
  
  public final void setStatutPensionInvaliditeDroitCourant(int p_statutPensionInvaliditeDroitCourant)
  {
    jdoSetm_statutPensionInvaliditeDroitCourant(this, p_statutPensionInvaliditeDroitCourant);
  }
  
  public QuantiteEuro getCrcDroitCourantCompMontants()
  {
    return jdoGetm_crcDroitCourantCompMontants(this);
  }
  
  public final void setCrcDroitCourantCompMontants(QuantiteEuro p_crcDroitCourantCompMontants)
  {
    jdoSetm_crcDroitCourantCompMontants(this, p_crcDroitCourantCompMontants);
  }
  
  public QuantiteEuro getCrcDroitPrecedentCompMontants()
  {
    return jdoGetm_crcDroitPrecedentCompMontants(this);
  }
  
  public final void setCrcDroitPrecedentCompMontants(QuantiteEuro p_crcDroitPrecedentCompMontants)
  {
    jdoSetm_crcDroitPrecedentCompMontants(this, p_crcDroitPrecedentCompMontants);
  }
  
  static
  {
    JDOImplHelper.registerClass(JustificationDroitResultantPC.class, jdoFieldNames, jdoFieldTypes, jdoFieldFlags, jdoPersistenceCapableSuperclass, new JustificationDroitResultantPC());
  }
  
  protected static final int jdoGetm_competenceFinanciereDroitCourant(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_competenceFinanciereDroitCourant;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 0)) {
        return m_competenceFinanciereDroitCourant;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 0, m_competenceFinanciereDroitCourant);
    }
    return m_competenceFinanciereDroitCourant;
  }
  
  protected static final QuantiteEuro jdoGetm_montantInitialDroitCourant(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_montantInitialDroitCourant;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 1)) {
        return m_montantInitialDroitCourant;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 1, m_montantInitialDroitCourant);
    }
    return m_montantInitialDroitCourant;
  }
  
  protected static final QuantiteEuro jdoGetm_capitalDroitCourant(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_capitalDroitCourant;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 2)) {
        return m_capitalDroitCourant;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 2, m_capitalDroitCourant);
    }
    return m_capitalDroitCourant;
  }
  
  protected static final QuantiteJour jdoGetm_imputationDroitCourant(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_imputationDroitCourant;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 3)) {
        return m_imputationDroitCourant;
      }
      return (QuantiteJour)sm.getObjectField(pc, jdoInheritedFieldCount + 3, m_imputationDroitCourant);
    }
    return m_imputationDroitCourant;
  }
  
  protected static final QuantiteJour jdoGetm_dureeDroitCourant(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_dureeDroitCourant;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 4)) {
        return m_dureeDroitCourant;
      }
      return (QuantiteJour)sm.getObjectField(pc, jdoInheritedFieldCount + 4, m_dureeDroitCourant);
    }
    return m_dureeDroitCourant;
  }
  
  protected static final QuantiteEuro jdoGetm_avantageVieillesseDroitCourant(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_avantageVieillesseDroitCourant;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 5)) {
        return m_avantageVieillesseDroitCourant;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 5, m_avantageVieillesseDroitCourant);
    }
    return m_avantageVieillesseDroitCourant;
  }
  
  protected static final QuantiteEuro jdoGetm_pensionInvaliditeDroitCourant(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_pensionInvaliditeDroitCourant;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 6)) {
        return m_pensionInvaliditeDroitCourant;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 6, m_pensionInvaliditeDroitCourant);
    }
    return m_pensionInvaliditeDroitCourant;
  }
  
  protected static final QuantiteEuro jdoGetm_crcDroitCourantCompCapitaux(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_crcDroitCourantCompCapitaux;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 7)) {
        return m_crcDroitCourantCompCapitaux;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 7, m_crcDroitCourantCompCapitaux);
    }
    return m_crcDroitCourantCompCapitaux;
  }
  
  protected static final QuantiteEuro jdoGetm_montantBrutDroitCourantCompCapitaux(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_montantBrutDroitCourantCompCapitaux;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 8)) {
        return m_montantBrutDroitCourantCompCapitaux;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 8, m_montantBrutDroitCourantCompCapitaux);
    }
    return m_montantBrutDroitCourantCompCapitaux;
  }
  
  protected static final QuantiteEuro jdoGetm_montantBrutDroitCourantCompMontants(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_montantBrutDroitCourantCompMontants;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 9)) {
        return m_montantBrutDroitCourantCompMontants;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 9, m_montantBrutDroitCourantCompMontants);
    }
    return m_montantBrutDroitCourantCompMontants;
  }
  
  protected static final int jdoGetm_competenceFinanciereDroitPrecedent(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_competenceFinanciereDroitPrecedent;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 10)) {
        return m_competenceFinanciereDroitPrecedent;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 10, m_competenceFinanciereDroitPrecedent);
    }
    return m_competenceFinanciereDroitPrecedent;
  }
  
  protected static final QuantiteEuro jdoGetm_montantInitialDroitPrecedent(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_montantInitialDroitPrecedent;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 11)) {
        return m_montantInitialDroitPrecedent;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 11, m_montantInitialDroitPrecedent);
    }
    return m_montantInitialDroitPrecedent;
  }
  
  protected static final QuantiteEuro jdoGetm_capitalDroitPrecedent(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_capitalDroitPrecedent;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 12)) {
        return m_capitalDroitPrecedent;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 12, m_capitalDroitPrecedent);
    }
    return m_capitalDroitPrecedent;
  }
  
  protected static final QuantiteJour jdoGetm_imputationDroitPrecedent(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_imputationDroitPrecedent;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 13)) {
        return m_imputationDroitPrecedent;
      }
      return (QuantiteJour)sm.getObjectField(pc, jdoInheritedFieldCount + 13, m_imputationDroitPrecedent);
    }
    return m_imputationDroitPrecedent;
  }
  
  protected static final QuantiteJour jdoGetm_dureeDroitPrecedent(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_dureeDroitPrecedent;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 14)) {
        return m_dureeDroitPrecedent;
      }
      return (QuantiteJour)sm.getObjectField(pc, jdoInheritedFieldCount + 14, m_dureeDroitPrecedent);
    }
    return m_dureeDroitPrecedent;
  }
  
  protected static final QuantiteEuro jdoGetm_avantageVieillesseDroitPrecedent(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_avantageVieillesseDroitPrecedent;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 15)) {
        return m_avantageVieillesseDroitPrecedent;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 15, m_avantageVieillesseDroitPrecedent);
    }
    return m_avantageVieillesseDroitPrecedent;
  }
  
  protected static final QuantiteEuro jdoGetm_pensionInvaliditeDroitPrecedent(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_pensionInvaliditeDroitPrecedent;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 16)) {
        return m_pensionInvaliditeDroitPrecedent;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 16, m_pensionInvaliditeDroitPrecedent);
    }
    return m_pensionInvaliditeDroitPrecedent;
  }
  
  protected static final QuantiteEuro jdoGetm_crcDroitPrecedentCompCapitaux(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_crcDroitPrecedentCompCapitaux;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 17)) {
        return m_crcDroitPrecedentCompCapitaux;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 17, m_crcDroitPrecedentCompCapitaux);
    }
    return m_crcDroitPrecedentCompCapitaux;
  }
  
  protected static final QuantiteEuro jdoGetm_montantBrutDroitPrecedentCompCapitaux(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_montantBrutDroitPrecedentCompCapitaux;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 18)) {
        return m_montantBrutDroitPrecedentCompCapitaux;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 18, m_montantBrutDroitPrecedentCompCapitaux);
    }
    return m_montantBrutDroitPrecedentCompCapitaux;
  }
  
  protected static final QuantiteEuro jdoGetm_montantBrutDroitPrecedentCompMontants(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_montantBrutDroitPrecedentCompMontants;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 19)) {
        return m_montantBrutDroitPrecedentCompMontants;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 19, m_montantBrutDroitPrecedentCompMontants);
    }
    return m_montantBrutDroitPrecedentCompMontants;
  }
  
  protected static final int jdoGetm_competenceFinanciereDroitRetenu(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_competenceFinanciereDroitRetenu;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 20)) {
        return m_competenceFinanciereDroitRetenu;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 20, m_competenceFinanciereDroitRetenu);
    }
    return m_competenceFinanciereDroitRetenu;
  }
  
  protected static final QuantiteEuro jdoGetm_montantDroitRetenu(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_montantDroitRetenu;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 21)) {
        return m_montantDroitRetenu;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 21, m_montantDroitRetenu);
    }
    return m_montantDroitRetenu;
  }
  
  protected static final QuantiteEuro jdoGetm_capitalDroitRetenu(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_capitalDroitRetenu;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 22)) {
        return m_capitalDroitRetenu;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 22, m_capitalDroitRetenu);
    }
    return m_capitalDroitRetenu;
  }
  
  protected static final QuantiteJour jdoGetm_imputationDroitRetenu(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_imputationDroitRetenu;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 23)) {
        return m_imputationDroitRetenu;
      }
      return (QuantiteJour)sm.getObjectField(pc, jdoInheritedFieldCount + 23, m_imputationDroitRetenu);
    }
    return m_imputationDroitRetenu;
  }
  
  protected static final boolean jdoGetm_estCasParticulierPensionInvalidite(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_estCasParticulierPensionInvalidite;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 24)) {
        return m_estCasParticulierPensionInvalidite;
      }
      return sm.getBooleanField(pc, jdoInheritedFieldCount + 24, m_estCasParticulierPensionInvalidite);
    }
    return m_estCasParticulierPensionInvalidite;
  }
  
  protected static final QuantiteJour jdoGetm_dureeDroitRetenu(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_dureeDroitRetenu;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 25)) {
        return m_dureeDroitRetenu;
      }
      return (QuantiteJour)sm.getObjectField(pc, jdoInheritedFieldCount + 25, m_dureeDroitRetenu);
    }
    return m_dureeDroitRetenu;
  }
  
  protected static final int jdoGetm_statutPensionInvaliditeDroitCourant(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_statutPensionInvaliditeDroitCourant;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 26)) {
        return m_statutPensionInvaliditeDroitCourant;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 26, m_statutPensionInvaliditeDroitCourant);
    }
    return m_statutPensionInvaliditeDroitCourant;
  }
  
  private static final QuantiteEuro jdoGetm_crcDroitCourantCompMontants(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_crcDroitCourantCompMontants;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 27)) {
        return m_crcDroitCourantCompMontants;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 27, m_crcDroitCourantCompMontants);
    }
    return m_crcDroitCourantCompMontants;
  }
  
  private static final QuantiteEuro jdoGetm_crcDroitPrecedentCompMontants(JustificationDroitResultantPC pc)
  {
    if (jdoFlags <= 0) {
      return m_crcDroitPrecedentCompMontants;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 28)) {
        return m_crcDroitPrecedentCompMontants;
      }
      return (QuantiteEuro)sm.getObjectField(pc, jdoInheritedFieldCount + 28, m_crcDroitPrecedentCompMontants);
    }
    return m_crcDroitPrecedentCompMontants;
  }
  
  protected static final void jdoSetm_competenceFinanciereDroitCourant(JustificationDroitResultantPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_competenceFinanciereDroitCourant = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 0, m_competenceFinanciereDroitCourant, newValue);
    } else {
      m_competenceFinanciereDroitCourant = newValue;
    }
  }
  
  protected static final void jdoSetm_montantInitialDroitCourant(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_montantInitialDroitCourant = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 1, m_montantInitialDroitCourant, newValue);
    } else {
      m_montantInitialDroitCourant = newValue;
    }
  }
  
  protected static final void jdoSetm_capitalDroitCourant(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_capitalDroitCourant = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 2, m_capitalDroitCourant, newValue);
    } else {
      m_capitalDroitCourant = newValue;
    }
  }
  
  protected static final void jdoSetm_imputationDroitCourant(JustificationDroitResultantPC pc, QuantiteJour newValue)
  {
    if (jdoFlags == 0)
    {
      m_imputationDroitCourant = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 3, m_imputationDroitCourant, newValue);
    } else {
      m_imputationDroitCourant = newValue;
    }
  }
  
  protected static final void jdoSetm_dureeDroitCourant(JustificationDroitResultantPC pc, QuantiteJour newValue)
  {
    if (jdoFlags == 0)
    {
      m_dureeDroitCourant = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 4, m_dureeDroitCourant, newValue);
    } else {
      m_dureeDroitCourant = newValue;
    }
  }
  
  protected static final void jdoSetm_avantageVieillesseDroitCourant(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_avantageVieillesseDroitCourant = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 5, m_avantageVieillesseDroitCourant, newValue);
    } else {
      m_avantageVieillesseDroitCourant = newValue;
    }
  }
  
  protected static final void jdoSetm_pensionInvaliditeDroitCourant(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_pensionInvaliditeDroitCourant = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 6, m_pensionInvaliditeDroitCourant, newValue);
    } else {
      m_pensionInvaliditeDroitCourant = newValue;
    }
  }
  
  protected static final void jdoSetm_crcDroitCourantCompCapitaux(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_crcDroitCourantCompCapitaux = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 7, m_crcDroitCourantCompCapitaux, newValue);
    } else {
      m_crcDroitCourantCompCapitaux = newValue;
    }
  }
  
  protected static final void jdoSetm_montantBrutDroitCourantCompCapitaux(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_montantBrutDroitCourantCompCapitaux = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 8, m_montantBrutDroitCourantCompCapitaux, newValue);
    } else {
      m_montantBrutDroitCourantCompCapitaux = newValue;
    }
  }
  
  protected static final void jdoSetm_montantBrutDroitCourantCompMontants(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_montantBrutDroitCourantCompMontants = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 9, m_montantBrutDroitCourantCompMontants, newValue);
    } else {
      m_montantBrutDroitCourantCompMontants = newValue;
    }
  }
  
  protected static final void jdoSetm_competenceFinanciereDroitPrecedent(JustificationDroitResultantPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_competenceFinanciereDroitPrecedent = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 10, m_competenceFinanciereDroitPrecedent, newValue);
    } else {
      m_competenceFinanciereDroitPrecedent = newValue;
    }
  }
  
  protected static final void jdoSetm_montantInitialDroitPrecedent(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_montantInitialDroitPrecedent = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 11, m_montantInitialDroitPrecedent, newValue);
    } else {
      m_montantInitialDroitPrecedent = newValue;
    }
  }
  
  protected static final void jdoSetm_capitalDroitPrecedent(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_capitalDroitPrecedent = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 12, m_capitalDroitPrecedent, newValue);
    } else {
      m_capitalDroitPrecedent = newValue;
    }
  }
  
  protected static final void jdoSetm_imputationDroitPrecedent(JustificationDroitResultantPC pc, QuantiteJour newValue)
  {
    if (jdoFlags == 0)
    {
      m_imputationDroitPrecedent = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 13, m_imputationDroitPrecedent, newValue);
    } else {
      m_imputationDroitPrecedent = newValue;
    }
  }
  
  protected static final void jdoSetm_dureeDroitPrecedent(JustificationDroitResultantPC pc, QuantiteJour newValue)
  {
    if (jdoFlags == 0)
    {
      m_dureeDroitPrecedent = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 14, m_dureeDroitPrecedent, newValue);
    } else {
      m_dureeDroitPrecedent = newValue;
    }
  }
  
  protected static final void jdoSetm_avantageVieillesseDroitPrecedent(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_avantageVieillesseDroitPrecedent = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 15, m_avantageVieillesseDroitPrecedent, newValue);
    } else {
      m_avantageVieillesseDroitPrecedent = newValue;
    }
  }
  
  protected static final void jdoSetm_pensionInvaliditeDroitPrecedent(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_pensionInvaliditeDroitPrecedent = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 16, m_pensionInvaliditeDroitPrecedent, newValue);
    } else {
      m_pensionInvaliditeDroitPrecedent = newValue;
    }
  }
  
  protected static final void jdoSetm_crcDroitPrecedentCompCapitaux(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_crcDroitPrecedentCompCapitaux = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 17, m_crcDroitPrecedentCompCapitaux, newValue);
    } else {
      m_crcDroitPrecedentCompCapitaux = newValue;
    }
  }
  
  protected static final void jdoSetm_montantBrutDroitPrecedentCompCapitaux(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_montantBrutDroitPrecedentCompCapitaux = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 18, m_montantBrutDroitPrecedentCompCapitaux, newValue);
    } else {
      m_montantBrutDroitPrecedentCompCapitaux = newValue;
    }
  }
  
  protected static final void jdoSetm_montantBrutDroitPrecedentCompMontants(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_montantBrutDroitPrecedentCompMontants = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 19, m_montantBrutDroitPrecedentCompMontants, newValue);
    } else {
      m_montantBrutDroitPrecedentCompMontants = newValue;
    }
  }
  
  protected static final void jdoSetm_competenceFinanciereDroitRetenu(JustificationDroitResultantPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_competenceFinanciereDroitRetenu = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 20, m_competenceFinanciereDroitRetenu, newValue);
    } else {
      m_competenceFinanciereDroitRetenu = newValue;
    }
  }
  
  protected static final void jdoSetm_montantDroitRetenu(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_montantDroitRetenu = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 21, m_montantDroitRetenu, newValue);
    } else {
      m_montantDroitRetenu = newValue;
    }
  }
  
  protected static final void jdoSetm_capitalDroitRetenu(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_capitalDroitRetenu = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 22, m_capitalDroitRetenu, newValue);
    } else {
      m_capitalDroitRetenu = newValue;
    }
  }
  
  protected static final void jdoSetm_imputationDroitRetenu(JustificationDroitResultantPC pc, QuantiteJour newValue)
  {
    if (jdoFlags == 0)
    {
      m_imputationDroitRetenu = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 23, m_imputationDroitRetenu, newValue);
    } else {
      m_imputationDroitRetenu = newValue;
    }
  }
  
  protected static final void jdoSetm_estCasParticulierPensionInvalidite(JustificationDroitResultantPC pc, boolean newValue)
  {
    if (jdoFlags == 0)
    {
      m_estCasParticulierPensionInvalidite = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setBooleanField(pc, jdoInheritedFieldCount + 24, m_estCasParticulierPensionInvalidite, newValue);
    } else {
      m_estCasParticulierPensionInvalidite = newValue;
    }
  }
  
  protected static final void jdoSetm_dureeDroitRetenu(JustificationDroitResultantPC pc, QuantiteJour newValue)
  {
    if (jdoFlags == 0)
    {
      m_dureeDroitRetenu = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 25, m_dureeDroitRetenu, newValue);
    } else {
      m_dureeDroitRetenu = newValue;
    }
  }
  
  protected static final void jdoSetm_statutPensionInvaliditeDroitCourant(JustificationDroitResultantPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_statutPensionInvaliditeDroitCourant = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 26, m_statutPensionInvaliditeDroitCourant, newValue);
    } else {
      m_statutPensionInvaliditeDroitCourant = newValue;
    }
  }
  
  private static final void jdoSetm_crcDroitCourantCompMontants(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_crcDroitCourantCompMontants = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 27, m_crcDroitCourantCompMontants, newValue);
    } else {
      m_crcDroitCourantCompMontants = newValue;
    }
  }
  
  private static final void jdoSetm_crcDroitPrecedentCompMontants(JustificationDroitResultantPC pc, QuantiteEuro newValue)
  {
    if (jdoFlags == 0)
    {
      m_crcDroitPrecedentCompMontants = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 28, m_crcDroitPrecedentCompMontants, newValue);
    } else {
      m_crcDroitPrecedentCompMontants = newValue;
    }
  }
  
  public void jdoProvideField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      jdoStateManager.providedIntField(this, fieldNumber, m_competenceFinanciereDroitCourant);
      break;
    case 1: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_montantInitialDroitCourant);
      break;
    case 2: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_capitalDroitCourant);
      break;
    case 3: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_imputationDroitCourant);
      break;
    case 4: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_dureeDroitCourant);
      break;
    case 5: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_avantageVieillesseDroitCourant);
      break;
    case 6: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_pensionInvaliditeDroitCourant);
      break;
    case 7: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_crcDroitCourantCompCapitaux);
      break;
    case 8: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_montantBrutDroitCourantCompCapitaux);
      break;
    case 9: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_montantBrutDroitCourantCompMontants);
      break;
    case 10: 
      jdoStateManager.providedIntField(this, fieldNumber, m_competenceFinanciereDroitPrecedent);
      break;
    case 11: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_montantInitialDroitPrecedent);
      break;
    case 12: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_capitalDroitPrecedent);
      break;
    case 13: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_imputationDroitPrecedent);
      break;
    case 14: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_dureeDroitPrecedent);
      break;
    case 15: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_avantageVieillesseDroitPrecedent);
      break;
    case 16: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_pensionInvaliditeDroitPrecedent);
      break;
    case 17: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_crcDroitPrecedentCompCapitaux);
      break;
    case 18: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_montantBrutDroitPrecedentCompCapitaux);
      break;
    case 19: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_montantBrutDroitPrecedentCompMontants);
      break;
    case 20: 
      jdoStateManager.providedIntField(this, fieldNumber, m_competenceFinanciereDroitRetenu);
      break;
    case 21: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_montantDroitRetenu);
      break;
    case 22: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_capitalDroitRetenu);
      break;
    case 23: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_imputationDroitRetenu);
      break;
    case 24: 
      jdoStateManager.providedBooleanField(this, fieldNumber, m_estCasParticulierPensionInvalidite);
      break;
    case 25: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_dureeDroitRetenu);
      break;
    case 26: 
      jdoStateManager.providedIntField(this, fieldNumber, m_statutPensionInvaliditeDroitCourant);
      break;
    case 27: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_crcDroitCourantCompMontants);
      break;
    case 28: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_crcDroitPrecedentCompMontants);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoReplaceField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      m_competenceFinanciereDroitCourant = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 1: 
      m_montantInitialDroitCourant = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 2: 
      m_capitalDroitCourant = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 3: 
      m_imputationDroitCourant = ((QuantiteJour)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 4: 
      m_dureeDroitCourant = ((QuantiteJour)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 5: 
      m_avantageVieillesseDroitCourant = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 6: 
      m_pensionInvaliditeDroitCourant = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 7: 
      m_crcDroitCourantCompCapitaux = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 8: 
      m_montantBrutDroitCourantCompCapitaux = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 9: 
      m_montantBrutDroitCourantCompMontants = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 10: 
      m_competenceFinanciereDroitPrecedent = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 11: 
      m_montantInitialDroitPrecedent = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 12: 
      m_capitalDroitPrecedent = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 13: 
      m_imputationDroitPrecedent = ((QuantiteJour)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 14: 
      m_dureeDroitPrecedent = ((QuantiteJour)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 15: 
      m_avantageVieillesseDroitPrecedent = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 16: 
      m_pensionInvaliditeDroitPrecedent = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 17: 
      m_crcDroitPrecedentCompCapitaux = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 18: 
      m_montantBrutDroitPrecedentCompCapitaux = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 19: 
      m_montantBrutDroitPrecedentCompMontants = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 20: 
      m_competenceFinanciereDroitRetenu = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 21: 
      m_montantDroitRetenu = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 22: 
      m_capitalDroitRetenu = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 23: 
      m_imputationDroitRetenu = ((QuantiteJour)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 24: 
      m_estCasParticulierPensionInvalidite = jdoStateManager.replacingBooleanField(this, fieldNumber);
      break;
    case 25: 
      m_dureeDroitRetenu = ((QuantiteJour)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 26: 
      m_statutPensionInvaliditeDroitCourant = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 27: 
      m_crcDroitCourantCompMontants = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 28: 
      m_crcDroitPrecedentCompMontants = ((QuantiteEuro)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoProvideFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoProvideField(fieldNumber);
    }
  }
  
  public void jdoReplaceFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoReplaceField(fieldNumber);
    }
  }
  
  public synchronized void jdoReplaceStateManager(StateManager sm)
  {
    if (jdoStateManager != null)
    {
      jdoStateManager = jdoStateManager.replacingStateManager(this, sm);
    }
    else
    {
      SecurityManager securityManager = System.getSecurityManager();
      if (securityManager != null) {
        securityManager.checkPermission(JDOPermission.SET_STATE_MANAGER);
      }
      jdoStateManager = sm;
    }
  }
  
  public boolean jdoIsPersistent()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isPersistent(this);
    }
    return false;
  }
  
  public boolean jdoIsTransactional()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isTransactional(this);
    }
    return false;
  }
  
  public boolean jdoIsNew()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isNew(this);
    }
    return false;
  }
  
  public boolean jdoIsDirty()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDirty(this);
    }
    return false;
  }
  
  public boolean jdoIsDeleted()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDeleted(this);
    }
    return false;
  }
  
  public void jdoMakeDirty(String fieldName)
  {
    if (jdoStateManager != null) {
      jdoStateManager.makeDirty(this, fieldName);
    }
  }
  
  public void jdoReplaceFlags()
  {
    if (jdoStateManager != null)
    {
      jdoFlags = jdoStateManager.replacingFlags(this);
      return;
      jdoFlags = 0;
    }
  }
  
  public boolean jdoIsDetached()
  {
    if (jdoStateManager != null) {
      return ((CommonStateManager)jdoStateManager).isDetached();
    }
    return false;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm)
  {
    JustificationDroitResultantPC pc = new JustificationDroitResultantPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    return pc;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm, Object oid)
  {
    JustificationDroitResultantPC pc = new JustificationDroitResultantPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    pc.jdoCopyKeyFieldsFromObjectId(oid);
    return pc;
  }
  
  public static int jdoGetManagedFieldCount()
  {
    return jdoInheritedFieldCount + 29;
  }
  
  public void jdoCopyFields(Object pc, int[] fieldNumbers)
  {
    if (!(pc instanceof JustificationDroitResultantPC)) {
      throw new JDOFatalInternalException("Can't copy fields from a different class");
    }
    JustificationDroitResultantPC other = (JustificationDroitResultantPC)pc;
    if (jdoStateManager != jdoStateManager) {
      throw new JDOUserException("Source object should have the same StateManager");
    }
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int relativeField = fieldNumbers[i] - jdoInheritedFieldCount;
      switch (relativeField)
      {
      case 0: 
        m_competenceFinanciereDroitCourant = m_competenceFinanciereDroitCourant;
        break;
      case 1: 
        m_montantInitialDroitCourant = m_montantInitialDroitCourant;
        break;
      case 2: 
        m_capitalDroitCourant = m_capitalDroitCourant;
        break;
      case 3: 
        m_imputationDroitCourant = m_imputationDroitCourant;
        break;
      case 4: 
        m_dureeDroitCourant = m_dureeDroitCourant;
        break;
      case 5: 
        m_avantageVieillesseDroitCourant = m_avantageVieillesseDroitCourant;
        break;
      case 6: 
        m_pensionInvaliditeDroitCourant = m_pensionInvaliditeDroitCourant;
        break;
      case 7: 
        m_crcDroitCourantCompCapitaux = m_crcDroitCourantCompCapitaux;
        break;
      case 8: 
        m_montantBrutDroitCourantCompCapitaux = m_montantBrutDroitCourantCompCapitaux;
        break;
      case 9: 
        m_montantBrutDroitCourantCompMontants = m_montantBrutDroitCourantCompMontants;
        break;
      case 10: 
        m_competenceFinanciereDroitPrecedent = m_competenceFinanciereDroitPrecedent;
        break;
      case 11: 
        m_montantInitialDroitPrecedent = m_montantInitialDroitPrecedent;
        break;
      case 12: 
        m_capitalDroitPrecedent = m_capitalDroitPrecedent;
        break;
      case 13: 
        m_imputationDroitPrecedent = m_imputationDroitPrecedent;
        break;
      case 14: 
        m_dureeDroitPrecedent = m_dureeDroitPrecedent;
        break;
      case 15: 
        m_avantageVieillesseDroitPrecedent = m_avantageVieillesseDroitPrecedent;
        break;
      case 16: 
        m_pensionInvaliditeDroitPrecedent = m_pensionInvaliditeDroitPrecedent;
        break;
      case 17: 
        m_crcDroitPrecedentCompCapitaux = m_crcDroitPrecedentCompCapitaux;
        break;
      case 18: 
        m_montantBrutDroitPrecedentCompCapitaux = m_montantBrutDroitPrecedentCompCapitaux;
        break;
      case 19: 
        m_montantBrutDroitPrecedentCompMontants = m_montantBrutDroitPrecedentCompMontants;
        break;
      case 20: 
        m_competenceFinanciereDroitRetenu = m_competenceFinanciereDroitRetenu;
        break;
      case 21: 
        m_montantDroitRetenu = m_montantDroitRetenu;
        break;
      case 22: 
        m_capitalDroitRetenu = m_capitalDroitRetenu;
        break;
      case 23: 
        m_imputationDroitRetenu = m_imputationDroitRetenu;
        break;
      case 24: 
        m_estCasParticulierPensionInvalidite = m_estCasParticulierPensionInvalidite;
        break;
      case 25: 
        m_dureeDroitRetenu = m_dureeDroitRetenu;
        break;
      case 26: 
        m_statutPensionInvaliditeDroitCourant = m_statutPensionInvaliditeDroitCourant;
        break;
      case 27: 
        m_crcDroitCourantCompMontants = m_crcDroitCourantCompMontants;
        break;
      case 28: 
        m_crcDroitPrecedentCompMontants = m_crcDroitPrecedentCompMontants;
      }
    }
  }
  
  public void jdoCopyKeyFieldsToObjectId(Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public void jdoCopyKeyFieldsToObjectId(PersistenceCapable.ObjectIdFieldSupplier supplier, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  protected void jdoCopyKeyFieldsFromObjectId(Object object) {}
  
  public void jdoCopyKeyFieldsFromObjectId(PersistenceCapable.ObjectIdFieldConsumer consumer, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public Object jdoNewObjectIdInstance()
  {
    return null;
  }
  
  public Object jdoNewObjectIdInstance(Object str)
  {
    return null;
  }
  
  public Object jdoGetObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getObjectId(this);
    }
    return null;
  }
  
  public PersistenceManager jdoGetPersistenceManager()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getPersistenceManager(this);
    }
    return null;
  }
  
  private void jdoPreSerialize()
  {
    if (jdoStateManager != null) {
      jdoStateManager.preSerialize(this);
    }
  }
  
  private void writeObject(ObjectOutputStream out)
    throws IOException
  {
    jdoPreSerialize();
    out.defaultWriteObject();
  }
  
  public Object jdoGetTransactionalObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getTransactionalObjectId(this);
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     JustificationDroitResultantPC
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */