package fr.unedic.cali.asu.spe02.p03.avant;

import fr.unedic.archi.util.trace.Log;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeSuspensionIndemnisation;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.OutilsMaintienEuropeenEessiASU;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.outilsfonctionnels.OutilCarence;
import fr.unedic.cali.asu.outilsfonctionnels.RechercheDecisionsInterruptives;
import fr.unedic.cali.asu.spe02.p03.avant.outilsfonctionnels.TraitementDureeConsommableAvant;
import fr.unedic.cali.asu.spe02.p03.avant.outilsfonctionnels.TraitementPeriodesAvant;
import fr.unedic.cali.asu.spe02.p03.avant.outilsfonctionnels.TraitementUtAvant;
import fr.unedic.cali.asu.spe02.p03.calcul.outilsfonctionnels.Qualification;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.Attribution;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.CarenceIslr;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.CarencePrefixeAFixer;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.CarenceStandard;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.Differe;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.PreavisMesureConservatoireNonIndemnisable;
import fr.unedic.cali.autresdoms.cohab.dom.ObjetChronoPeriodePriseEnCharge;
import fr.unedic.cali.avant.FacadeAvantProduitAbstraite;
import fr.unedic.cali.calcul.FacadeCalculProduitFactory;
import fr.unedic.cali.calcul.FacadeCalculProduitSpec;
import fr.unedic.cali.calcul.OutillagePeriodes;
import fr.unedic.cali.calcul.RecuperationDonneesSecteurPublic;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.CalendrierExecutionAvant;
import fr.unedic.cali.calcul.dom.CalendrierExecutionAvantSpec;
import fr.unedic.cali.calcul.dom.ConsommationPeriodes;
import fr.unedic.cali.calcul.dom.DureeConsommableAvant;
import fr.unedic.cali.calcul.dom.EtatAuDernierJourAvant;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.UniteTraitementAvant;
import fr.unedic.cali.calcul.dom.periode.DsmMaladie;
import fr.unedic.cali.calcul.dom.periode.PeriodeAbsenceAuPointage;
import fr.unedic.cali.calcul.dom.periode.PeriodeActiviteEmploiCalcul;
import fr.unedic.cali.calcul.dom.periode.PeriodeBlocageIndemnisation;
import fr.unedic.cali.calcul.dom.periode.PeriodeEvenementPersonnel;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeInterProduits;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeRetraite;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionSanctions;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionSuivi;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodeAnalyseSpec;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodesPriseEnCompte;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodeTravailCalculPAEC;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.QuantiteDroitSpec;
import fr.unedic.cali.dom.affectation.GammeSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.fabriques.FabriqueStrategieQuantiteAffiliationHeureAvecCachet;
import fr.unedic.cali.outilsfonctionnels.OutillagePEC;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreConflitGaec;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreNegation;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieQuantiteAffiliationHeureAvecCachetSpec;
import fr.unedic.cali.parcours.ResultatAvant;
import fr.unedic.cali.util.ObjetChronoPeriodeConcreteCarence;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.FiltreChevauchePeriode;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.ObjetChronoPeriodeConcrete;
import fr.unedic.util.temps.Periode;
import fr.unedic.util.temps.Temporel;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;

public class FacadeAvantProduitImpl
  extends FacadeAvantProduitAbstraite
{
  private static final int CENT = 100;
  
  public ResultatAvant executerAvant(AttributionSpec p_attribution, boolean p_estAvecPriseEnCompteEvenement, Damj p_dateEtude, boolean p_executionPersistante)
    throws CoucheLogiqueException
  {
    ResultatAvant resultatAvant = null;
    Damj pji = null;
    Collection carencesEffectives = new ArrayList();
    ObjetChronoPeriodePriseEnCharge periodePEC = null;
    ChronologiePeriodes chronologiePeriodes = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodesSansConflitGAEC = new ChronologiePeriodes();
    int etat = 0;
    Periode periodeUtAvant = null;
    Damj dateDebutUtAvant = null;
    Damj dateFinUtAvant = null;
    Damj finPEC = null;
    
    CalendrierExecutionAvant calendrierAvant = new CalendrierExecutionAvant();
    calendrierAvant.setPremierJourAvant(rechercherDateDebutAvant((Attribution)p_attribution));
    calendrierAvant.setEtatExecutionAvant(1);
    dateDebutUtAvant = calendrierAvant.getPremierJourAvant().getDebutMois();
    dateFinUtAvant = dateDebutUtAvant.getFinMois();
    if (p_estAvecPriseEnCompteEvenement)
    {
      chronologiePeriodes = recuperationDeToutesLesDesPeriodes(p_attribution.getDemandeur(), p_attribution, p_attribution.getDateAttribution(), null);
      
      periodePEC = OutillagePeriodes.recupererPeriodePECContenant(p_attribution.getDemandeur(), p_attribution.getDateAttribution());
      if (periodePEC == null)
      {
        if ((!"ASU_22".equals(p_attribution.getTypeExamen())) && (!"ASU_23".equals(p_attribution.getTypeExamen()))) {
          throw new CoucheLogiqueException("HG_PR_CALI_L_PAS_DE_PEC_POUR_EXECUTION_AVANT", "Attention lors de l'execution de l'avant, impossible de retrouver une periode de prise en charge.", null);
        }
        resultatAvant = new ResultatAvant(pji, new ArrayList(carencesEffectives), true);
        resultatAvant.setEtat(1);
        return resultatAvant;
      }
      finPEC = periodePEC.getDateFin();
    }
    else
    {
      chronologiePeriodes = (ChronologiePeriodes)recuperationDeToutesLesDesPeriodes(p_attribution.getDemandeur(), p_attribution, p_attribution.getDateAttribution(), p_attribution.getDateAttribution()).copier(new FiltreChevauchePeriode(new Periode(p_attribution.getDateAttribution(), p_attribution.getDateAttribution())));
      
      chronologiePeriodesSansConflitGAEC = (ChronologiePeriodes)chronologiePeriodes.copier(new FiltreNegation(new FiltreConflitGaec()));
      
      chronologiePeriodes = chronologiePeriodesSansConflitGAEC;
      
      Qualification qualification = new Qualification();
      QualificationPeriodes periodesQualifie = new QualificationPeriodes();
      periodesQualifie = qualification.qualificationPeriodesPourAvant(chronologiePeriodes, p_attribution);
      chronologiePeriodes = periodesQualifie.getPeriodesSuspensives();
      chronologiePeriodes.ajouter(periodesQualifie.getPeriodesInterruptives());
    }
    IndividuSpec individu = p_attribution.getDemandeur();
    while ((calendrierAvant.getEtatExecutionAvant() != 3) && (!((AttributionAssuranceSpec)p_attribution).getListeCarences().isEmpty()))
    {
      periodeUtAvant = new Periode(dateDebutUtAvant, dateFinUtAvant);
      if ((individu != null) && (individu.getDateNaissance() != null) && (periodeUtAvant.getDebut().estApres(individu.getDateNaissance().deplacerVersAvant(new DureeCalendaire(100))))) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("HG_PR_CALI_L_EXECUTION_ATTRIBUTION_DEMARRE_JAMAIS", new Object[] { p_attribution.getDateAttribution() });
      } else if (periodeUtAvant.getDebut().estApres(new Damj("2200, 01, 01"))) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("HG_PR_CALI_L_EXECUTION_ATTRIBUTION_DEMARRE_JAMAIS", new Object[] { p_attribution.getDateAttribution() });
      } else if (periodeUtAvant.getDebut().estApres(Damj.FIN_DES_TEMPS)) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("HG_PR_CALI_L_EXECUTION_ATTRIBUTION_DEMARRE_JAMAIS", new Object[] { p_attribution.getDateAttribution() });
      }
      dateDebutUtAvant = dateFinUtAvant.getDebutMoisSuivant();
      dateFinUtAvant = dateDebutUtAvant.getFinMois();
      if (Log.isTraceActive(FacadeAvantProduitImpl.class, Niveau.DEBUG)) {
        Log.ecritTrace(Niveau.DEBUG, FacadeAvantProduitImpl.class, "executerAvant", "Calcul: UT Avant [" + periodeUtAvant.getDebut() + " - " + periodeUtAvant.getFin() + "]");
      }
      etat = TraitementUtAvant.executerUtAvant(p_attribution, calendrierAvant, periodeUtAvant, chronologiePeriodes);
    }
    if (etat == 0) {
      pji = calendrierAvant.getDernierJourAvant().lendemain();
    }
    if (p_estAvecPriseEnCompteEvenement) {
      if ((finPEC != null) && (pji != null) && (finPEC.estAvantOuCoincideAvec(calendrierAvant.getDernierJourAvant()))) {
        if (OutillagePEC.estPecSuivanteAutreEtatMembreCoordination(p_attribution.getDemandeur(), finPEC))
        {
          Chronologie chronologiePecEuropeenne = OutillagePEC.getPeriodesPecAutreEtatMembreCoordinationDebutApresDate(p_attribution.getDemandeur(), finPEC);
          ObjetChronoPeriodePriseEnCharge pec = (ObjetChronoPeriodePriseEnCharge)chronologiePecEuropeenne.premierElement();
          if (pec.getDateDebut().estApres(pji))
          {
            pji = Damj.max(pec.getDateDebut(), finPEC);
            
            FacadeCalculProduitSpec facadeCalculProduit = FacadeCalculProduitFactory.getInstance().getInstanceGestionnaireCalculProduit(p_attribution.getProduitExecution());
            
            GestionSuivi.enregistrerEnquetePbjcNcp(p_attribution, pji, 31, 0, true, null, facadeCalculProduit, null);
          }
        }
      }
    }
    if (!((AttributionAssuranceSpec)p_attribution).getListeCarences().isEmpty())
    {
      if (p_executionPersistante) {
        p_attribution.setCalendrierExecutionAvant(calendrierAvant);
      }
      mettreAJour(calendrierAvant, (Attribution)p_attribution, carencesEffectives);
      
      resultatAvant = new ResultatAvant(pji, new ArrayList(carencesEffectives), calendrierAvant.getEtatAuDernierJourAvant().isDelaiAttenteEntame());
      resultatAvant.setEtat(etat);
      resultatAvant.setPremierJourAvant(calendrierAvant.getDateDebut());
      resultatAvant.setDernierJourAvant(calendrierAvant.getDateFin());
      resultatAvant.setCalendrierExecutionAvantCalcul(calendrierAvant);
    }
    else
    {
      p_attribution.setCalendrierExecutionAvant(null);
      
      resultatAvant = new ResultatAvant(p_attribution.getDateAttribution(), new ArrayList(carencesEffectives), false);
      resultatAvant.setEtat(etat);
      resultatAvant.setPremierJourAvant(p_attribution.getDateAttribution());
      resultatAvant.setDernierJourAvant(p_attribution.getDateAttribution());
    }
    if (etat == 1) {
      resultatAvant.setMessageErreur("Impossible de determiner le PJI : Un événement interruptif est survenu avant la fin du différé.");
    }
    return resultatAvant;
  }
  
  public ResultatAvant executerAvant(IndividuSpec p_individu, Damj p_dateAttribution, ProduitSpec p_produit, Collection p_delaisReport, Collection p_carences)
    throws CoucheLogiqueException
  {
    return null;
  }
  
  protected ChronologiePeriodes recuperationDeToutesLesDesPeriodes(IndividuSpec p_individu, AttributionSpec p_attribution, Damj dateDebut, Damj dateFin)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes chronologiePeriodesGAEC = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodesPEC = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodesSanctions = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodesPourAttribution = new ChronologiePeriodes();
    ChronologiePeriodes chronologieRetraite = new ChronologiePeriodes();
    ChronologiePeriodes chronologieDemandeExpresse = new ChronologiePeriodes();
    ChronologiePeriodes chronologiePeriodeInterProduit = new ChronologiePeriodes();
    Collection collectionPeriodesPourAttribution = new LinkedList();
    ChronologiePeriodes chronologiePeriodeSP = new ChronologiePeriodes();
    
    ChronologiePeriodes chronologiePeriodeEvtActualisation = new ChronologiePeriodes();
    Collection decisionsSuivi = null;
    
    chronologiePeriodesGAEC = OutillagePeriodes.recupererPeriodesGAEC(p_individu, dateDebut, dateFin);
    decisionsSuivi = OutillagePeriodes.recupererDecisionsSuivi(p_individu);
    chronologiePeriodesSanctions = GestionSanctions.recupererSanctions(decisionsSuivi);
    chronologiePeriodesPEC = OutillagePeriodes.recupererRadiations(p_individu);
    ObjetChronoPeriodeRetraite chronoRetraite = OutillagePeriodes.genererPeriodeRetraite(p_individu);
    chronologieRetraite.ajouter(chronoRetraite);
    chronologieDemandeExpresse = (ChronologiePeriodes)RechercheDecisionsInterruptives.rechercher(p_individu, dateDebut, p_attribution);
    
    chronologiePeriodeEvtActualisation = OutillagePeriodes.recupererPeriodesEvtActualisation(p_individu);
    
    RecuperationDonneesSecteurPublic.recupererDemandeClassementSP(chronologiePeriodeSP, p_attribution);
    
    RecuperationDonneesSecteurPublic.rechercherAdmissionSecteurPublic(chronologiePeriodeSP, p_attribution);
    chronologiePeriodeInterProduit = recuperationObjetPeriodeInterProduit(p_individu, "ASU", p_attribution, 1);
    
    collectionPeriodesPourAttribution.addAll(chronologiePeriodesGAEC.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologiePeriodesPEC.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologiePeriodesSanctions.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologieRetraite.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologieDemandeExpresse.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologiePeriodeInterProduit.mapperVersCollection());
    collectionPeriodesPourAttribution.addAll(chronologiePeriodeSP.mapperVersCollection());
    
    collectionPeriodesPourAttribution.addAll(chronologiePeriodeEvtActualisation.mapperVersCollection());
    
    collectionPeriodesPourAttribution.addAll(getPeriodesInterProduitsSurAvantPourArce(p_individu, p_attribution));
    if (p_individu.getDateBlocageIndemnisation() != null)
    {
      PeriodeBlocageIndemnisation periodeBlocageIndemnisation = new PeriodeBlocageIndemnisation(p_individu.getDateBlocageIndemnisation().lendemain());
      
      collectionPeriodesPourAttribution.add(periodeBlocageIndemnisation);
    }
    collectionPeriodesPourAttribution.addAll(OutilsMaintienEuropeenEessiASU.getListesPeriodesMaintienEuropeen(p_attribution).mapperVersCollection());
    
    chronologiePeriodesPourAttribution.ajouter(collectionPeriodesPourAttribution);
    
    return chronologiePeriodesPourAttribution;
  }
  
  private ChronologiePeriodes recuperationObjetPeriodeInterProduit(IndividuSpec p_individu, String p_gamme, AttributionSpec p_attribution, int p_typeDateDebutPeriodeInterProduits)
    throws CoucheLogiqueException
  {
    Iterator iterateur = null;
    AttributionSpec attribution = null;
    ObjetChronoPeriodeInterProduits objetChronoPeriodeInterProduits = null;
    ChronologiePeriodes listePeriodesInterProduit = new ChronologiePeriodes();
    
    iterateur = p_individu.getListeAttributionsExecutables().iterator();
    while (iterateur.hasNext())
    {
      attribution = (AttributionSpec)iterateur.next();
      if ((attribution.getDemande() != null) && 
        (attribution.getGamme().getNomUnique().equals(p_gamme)) && (attribution != p_attribution))
      {
        objetChronoPeriodeInterProduits = getPeriodeInterProduit(p_typeDateDebutPeriodeInterProduits, attribution);
        if (objetChronoPeriodeInterProduits != null) {
          listePeriodesInterProduit.ajouter(objetChronoPeriodeInterProduits);
        }
      }
    }
    return listePeriodesInterProduit;
  }
  
  private Collection getPeriodesInterProduitsSurAvantPourArce(IndividuSpec p_individu, AttributionSpec p_attribution)
  {
    Iterator iterateur = null;
    AttributionSpec attribution = null;
    ObjetChronoPeriodeInterProduits objetChronoPeriodeInterProduits = null;
    List listePeriodesInterProduit = new ArrayList();
    Damj dateDepart = null;
    
    iterateur = p_individu.getListeAttributionsExecutables().iterator();
    while (iterateur.hasNext())
    {
      attribution = (AttributionSpec)iterateur.next();
      if ((attribution.estValidee()) && (!attribution.estEnReexamen()) && (attribution.getProduitExecution().getNomUnique().equals("INR_RCE04_01")) && (attribution != p_attribution) && (attribution.getDateEffet() != null))
      {
        dateDepart = attribution.getDateEffet();
        objetChronoPeriodeInterProduits = new ObjetChronoPeriodeInterProduits(dateDepart, dateDepart, 1, attribution);
        if (objetChronoPeriodeInterProduits != null) {
          listePeriodesInterProduit.add(objetChronoPeriodeInterProduits);
        }
      }
    }
    return listePeriodesInterProduit;
  }
  
  private ObjetChronoPeriodeInterProduits getPeriodeInterProduit(int p_typeDateDebutPeriodeInterProduits, AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    ObjetChronoPeriodeInterProduits objetChronoPeriodeInterProduits = null;
    Damj dateDepart = null;
    Damj dateFin = Damj.FIN_DES_TEMPS;
    switch (p_typeDateDebutPeriodeInterProduits)
    {
    case 1: 
      dateDepart = p_attribution.getDateAttribution();
      dateFin = p_attribution.getDateAttribution();
      break;
    case 2: 
      dateDepart = p_attribution.getPji();
      break;
    default: 
      throw new CoucheLogiqueException("HG_PR_CALI_L_UT_TYPE_PER_INTER_PROD_INCONNU", "Type de période inter-produit inconnu", null);
    }
    objetChronoPeriodeInterProduits = new ObjetChronoPeriodeInterProduits(dateDepart, dateFin, p_typeDateDebutPeriodeInterProduits, p_attribution);
    
    return objetChronoPeriodeInterProduits;
  }
  
  protected Damj rechercherDateDebutAvant(Attribution p_attribution)
  {
    PreavisMesureConservatoireNonIndemnisable pmc = getPmcAConsommer(p_attribution);
    CarenceStandard differeStandard = getDiffereStandardAConsommer(p_attribution);
    CarenceIslr differeSpecifique = getDiffereSpecifiqueAConsommer(p_attribution);
    if (pmc != null) {
      return pmc.getDateFinPeriodeOrigine().lendemain();
    }
    if (differeStandard != null) {
      return p_attribution.getDateAttribution();
    }
    if (differeSpecifique != null) {
      return differeSpecifique.getDateFinPeriodeOrigine().lendemain();
    }
    return p_attribution.getDateAttribution();
  }
  
  public static PreavisMesureConservatoireNonIndemnisable getPmcAConsommer(AttributionSpec p_attribution)
  {
    Collection carences = ((Attribution)p_attribution).getListeCarences();
    Iterator iterator = carences.iterator();
    Damj dateFinPmcMax = null;
    Damj dateFinPmc = null;
    Damj dateFinPeriodeOrigine = null;
    PreavisMesureConservatoireNonIndemnisable pmc = null;
    PreavisMesureConservatoireNonIndemnisable pmcMax = null;
    while (iterator.hasNext())
    {
      CarencePrefixeAFixer carence = (CarencePrefixeAFixer)iterator.next();
      if ((carence instanceof PreavisMesureConservatoireNonIndemnisable))
      {
        pmc = (PreavisMesureConservatoireNonIndemnisable)carence;
        dateFinPeriodeOrigine = pmc.getDateFinPeriodeOrigine();
        if (dateFinPeriodeOrigine != null)
        {
          dateFinPmc = dateFinPeriodeOrigine.deplacerVersAvant(new DureeCalendaire(0, 0, pmc.getQuantiteInitiale().getValeurEntiere()));
          if ((dateFinPmcMax == null) || (dateFinPmc.estApres(dateFinPmcMax)))
          {
            dateFinPmcMax = dateFinPmc;
            pmcMax = (PreavisMesureConservatoireNonIndemnisable)carence;
          }
        }
      }
    }
    return pmcMax;
  }
  
  public static CarenceStandard getDiffereStandardAConsommer(AttributionSpec p_attribution)
  {
    Collection carences = ((Attribution)p_attribution).getListeCarences();
    Iterator iterator = carences.iterator();
    CarenceStandard differeStandard = null;
    while (iterator.hasNext())
    {
      CarencePrefixeAFixer carence = (CarencePrefixeAFixer)iterator.next();
      if ((carence instanceof CarenceStandard)) {
        differeStandard = (CarenceStandard)carence;
      }
    }
    return differeStandard;
  }
  
  public static CarenceIslr getDiffereSpecifiqueAConsommer(AttributionSpec p_attribution)
  {
    Collection carences = ((Attribution)p_attribution).getListeCarences();
    Iterator iterator = carences.iterator();
    CarenceIslr differeSpecifique = null;
    while (iterator.hasNext())
    {
      CarencePrefixeAFixer carence = (CarencePrefixeAFixer)iterator.next();
      if ((carence instanceof CarenceIslr)) {
        differeSpecifique = (CarenceIslr)carence;
      }
    }
    return differeSpecifique;
  }
  
  public static Differe getDelaiAttenteAConsommer(AttributionSpec p_attribution)
  {
    return (Differe)OutilCarence.trouverCarence(((Attribution)p_attribution).getListeCarences(), "5");
  }
  
  protected static void mettreAJour(CalendrierExecutionAvant p_calendrierExecutionAvant, Attribution p_attribution, Collection p_carences)
  {
    Chronologie uts = p_calendrierExecutionAvant.getChronologieUnitesTraitements();
    UniteTraitementAvant derniereUtAvant = (UniteTraitementAvant)uts.dernierElement();
    DureeConsommableAvant duree = null;
    ObjetChronoPeriode periodeOrigineReliquat = null;
    
    PreavisMesureConservatoireNonIndemnisable pmc = getPmcAConsommer(p_attribution);
    CarenceStandard differeStandard = getDiffereStandardAConsommer(p_attribution);
    CarenceIslr differeSpecifique = getDiffereSpecifiqueAConsommer(p_attribution);
    Differe delaiAttente = getDelaiAttenteAConsommer(p_attribution);
    if (pmc != null)
    {
      if (derniereUtAvant != null)
      {
        duree = derniereUtAvant.getDureePmcEnFinUT();
        pmc.setPeriodeApplicationCarence(duree.getPeriodeApplicationCarence());
        pmc.setReliquat(duree.getQuantiteCourante());
        if (duree.getEtat() == 0) {
          pmc.setReliquat(duree.getQuantiteInitial());
        }
        if (duree.getEtat() != 2)
        {
          periodeOrigineReliquat = new ObjetChronoPeriodeConcreteCarence(p_calendrierExecutionAvant.getDernierJourAvant(), p_calendrierExecutionAvant.getDernierJourAvant());
          pmc.setOrigineReliquat(periodeOrigineReliquat);
        }
      }
      p_carences.add(pmc);
    }
    if (differeStandard != null)
    {
      if (derniereUtAvant != null)
      {
        duree = derniereUtAvant.getDureeDiffereStandardEnFinUT();
        differeStandard.setPeriodeApplicationCarence(duree.getPeriodeApplicationCarence());
        differeStandard.setReliquat(duree.getQuantiteCourante());
        if (duree.getEtat() == 0) {
          differeStandard.setReliquat(duree.getQuantiteInitial());
        }
        if (duree.getEtat() != 2)
        {
          periodeOrigineReliquat = new ObjetChronoPeriodeConcreteCarence(p_calendrierExecutionAvant.getDernierJourAvant(), p_calendrierExecutionAvant.getDernierJourAvant());
          differeStandard.setOrigineReliquat(periodeOrigineReliquat);
        }
      }
      p_carences.add(differeStandard);
    }
    if (differeSpecifique != null)
    {
      if (derniereUtAvant != null)
      {
        duree = derniereUtAvant.getDureeDiffereSpecifiqueEnFinUT();
        differeSpecifique.setPeriodeApplicationCarence(duree.getPeriodeApplicationCarence());
        differeSpecifique.setReliquat(duree.getQuantiteCourante());
        if (duree.getEtat() == 0) {
          differeSpecifique.setReliquat(duree.getQuantiteInitial());
        }
        if (duree.getEtat() != 2)
        {
          periodeOrigineReliquat = new ObjetChronoPeriodeConcreteCarence(p_calendrierExecutionAvant.getDernierJourAvant(), p_calendrierExecutionAvant.getDernierJourAvant());
          differeSpecifique.setOrigineReliquat(periodeOrigineReliquat);
        }
      }
      p_carences.add(differeSpecifique);
    }
    if (delaiAttente != null)
    {
      if (derniereUtAvant != null)
      {
        duree = derniereUtAvant.getDureeDelaiAttenteEnFinUT();
        delaiAttente.setPeriodeApplicationCarence(duree.getPeriodeApplicationCarence());
        delaiAttente.setReliquat(duree.getQuantiteCourante());
        if (duree.getEtat() == 0) {
          delaiAttente.setReliquat(duree.getQuantiteInitial());
        }
      }
      p_carences.add(delaiAttente);
    }
  }
  
  public ResultatAvant postTraitementResultatDeterminationEtatAvant(AttributionSpec p_attribution)
  {
    CalendrierExecutionAvantSpec calendrierAvant = p_attribution.getCalendrierExecutionAvant();
    Damj dernierJourAvant = calendrierAvant.getDernierJourAvant();
    Collection carencesEffectives = new ArrayList();
    ObjetChronoPeriode periodeOrigineReliquat = new ObjetChronoPeriodeConcrete(dernierJourAvant, dernierJourAvant);
    EtatAuDernierJourAvant etatAuDernierJourAvant = calendrierAvant.getEtatAuDernierJourAvant();
    if (etatAuDernierJourAvant.getReliquatPMC() != null)
    {
      PreavisMesureConservatoireNonIndemnisable pmc = new PreavisMesureConservatoireNonIndemnisable();
      pmc.setReliquat(new QuantiteJour(etatAuDernierJourAvant.getReliquatPMC().toString()));
      pmc.setOrigineReliquat(periodeOrigineReliquat);
      pmc.setPeriodeApplicationCarence(etatAuDernierJourAvant.getPeriodeApplicationPMC());
      pmc.setQuantiteInitiale(new QuantiteJour(etatAuDernierJourAvant.getDureeInitialePMC().toString()));
      carencesEffectives.add(pmc);
    }
    if (etatAuDernierJourAvant.getReliquatICCP() != null)
    {
      CarenceStandard carenceStandard = new CarenceStandard();
      carenceStandard.setReliquat(new QuantiteJour(etatAuDernierJourAvant.getReliquatICCP().toString()));
      carenceStandard.setOrigineReliquat(periodeOrigineReliquat);
      carenceStandard.setPeriodeApplicationCarence(etatAuDernierJourAvant.getPeriodeApplicationICCP());
      carenceStandard.setQuantiteInitiale(new QuantiteJour(etatAuDernierJourAvant.getDureeInitialeICCP().toString()));
      carencesEffectives.add(carenceStandard);
    }
    if (etatAuDernierJourAvant.getReliquatISLR() != null)
    {
      CarenceIslr carenceISLR = new CarenceIslr();
      carenceISLR.setReliquat(new QuantiteJour(etatAuDernierJourAvant.getReliquatISLR().toString()));
      carenceISLR.setOrigineReliquat(periodeOrigineReliquat);
      carenceISLR.setPeriodeApplicationCarence(etatAuDernierJourAvant.getPeriodeApplicationISLR());
      carenceISLR.setQuantiteInitiale(new QuantiteJour(etatAuDernierJourAvant.getDureeInitialeISLR().toString()));
      carencesEffectives.add(carenceISLR);
    }
    if (etatAuDernierJourAvant.getReliquatDelaiAttente() != null)
    {
      Differe delaiAttente = new Differe();
      delaiAttente.setReliquat(new QuantiteJour(etatAuDernierJourAvant.getReliquatDelaiAttente().toString()));
      delaiAttente.setOrigineReliquat(periodeOrigineReliquat);
      delaiAttente.setPeriodeApplicationCarence(etatAuDernierJourAvant.getPeriodeApplicationDelaiAttente());
      delaiAttente.setQuantiteInitiale(new QuantiteJour(etatAuDernierJourAvant.getDureeInitialeDelaiAttente().toString()));
      carencesEffectives.add(delaiAttente);
    }
    ResultatAvant resultat = new ResultatAvant(dernierJourAvant.lendemain(), (List)carencesEffectives, etatAuDernierJourAvant.isDelaiAttenteEntame());
    resultat.setEtat(etatAuDernierJourAvant.getEtat());
    
    resultat.setPremierJourAvant(calendrierAvant.getPremierJourAvant());
    resultat.setDernierJourAvant(calendrierAvant.getDernierJourAvant());
    return resultat;
  }
  
  public boolean estUnProduitGerantLaRefonte()
  {
    return true;
  }
  
  public void traitementPeriodesAlertantes(AttributionSpec attribution, ObjetChronoPeriode periode, PeriodeAnalyseSpec pa, ArretProduitAvecRaison arretProduitAvecRaison)
    throws CoucheLogiqueException
  {}
  
  public Collection<?> recupererCarrence(AttributionSpec attribution)
  {
    return ((AttributionAssuranceSpec)attribution).getListeCarences();
  }
  
  public Damj rechercherPremierJourAvant(AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    return rechercherDateDebutAvant((Attribution)attribution);
  }
  
  public ChronologiePeriodes recupererPeriodeGAEC(IndividuSpec individu, AttributionSpec attribution, Damj dateDebut, Damj dateFin)
    throws CoucheLogiqueException
  {
    return recuperationDeToutesLesDesPeriodes(attribution.getDemandeur(), attribution, dateDebut, dateFin);
  }
  
  public QualificationPeriodes qualificationPeriodesPourAvant(ChronologiePeriodes chronologiePeriodes, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    Qualification qualification = new Qualification();
    return qualification.qualificationPeriodesPourAvant(chronologiePeriodes, attribution);
  }
  
  public void mettreAJourCarencesSurResultatAvant(CalendrierExecutionAvant calendrierExecutionAvant, AttributionSpec attribution, Collection listeCarences)
  {
    mettreAJour(calendrierExecutionAvant, (Attribution)attribution, listeCarences);
  }
  
  public Damj mettreAjourPjiSurPecESSI(AttributionSpec attribution, Damj finPec, Damj premierJourIndemnisable)
  {
    Damj pji = premierJourIndemnisable;
    if (OutillagePEC.estPecSuivanteAutreEtatMembreCoordination(attribution.getDemandeur(), finPec))
    {
      Chronologie chronologiePecEuropeenne = OutillagePEC.getPeriodesPecAutreEtatMembreCoordinationDebutApresDate(attribution.getDemandeur(), finPec);
      ObjetChronoPeriodePriseEnCharge pec = (ObjetChronoPeriodePriseEnCharge)chronologiePecEuropeenne.premierElement();
      if (pec.getDateDebut().estApres(pji)) {
        pji = Damj.max(pec.getDateDebut(), finPec);
      }
    }
    return pji;
  }
  
  public void convertionCachets(ChronologiePeriodes chronologiePeriodes)
  {
    if ((chronologiePeriodes != null) && (!chronologiePeriodes.estVide()))
    {
      PeriodeActiviteEmploiCalcul periodeActivite = null;
      Chronologie chronoPeriodesPAEC = chronologiePeriodes.copier(new FiltrePeriodeTravailCalculPAEC());
      if ((chronoPeriodesPAEC != null) && (!chronoPeriodesPAEC.estVide()))
      {
        chronoPeriodesPAEC.iterer();
        while (chronoPeriodesPAEC.encoreSuivant())
        {
          periodeActivite = (PeriodeActiviteEmploiCalcul)chronoPeriodesPAEC.elementSuivant();
          if ((periodeActivite.getQuantiteAffiliationCachets() != null) && (periodeActivite.getCachets() != null))
          {
            periodeActivite.setNombreHeures(periodeActivite.getNombreHeuresDeCompletude());
            CritereStrategie strategieHeureCachets = new CritereStrategie();
            strategieHeureCachets.setDatePivot(periodeActivite.getDateDebut());
            StrategieQuantiteAffiliationHeureAvecCachetSpec strategieHeureAvecCachet = (StrategieQuantiteAffiliationHeureAvecCachetSpec)FabriqueStrategieQuantiteAffiliationHeureAvecCachet.getInstance().getStrategie(strategieHeureCachets);
            
            strategieHeureAvecCachet.determinerQuantiteAffiliationHeureAvecCachet(periodeActivite, periodeActivite.getQuantiteAffiliationCachets());
          }
        }
      }
    }
  }
  
  public Damj determinerDateDepartAttribution(AttributionSpec attribution)
  {
    return attribution.getDateAttribution();
  }
  
  public ChronologiePeriodes traitementPeriodesSegmentantes(Periode periode, UniteTraitementAvant utAvant, ChronologiePeriodes periodesSegmentantes)
    throws CoucheLogiqueException
  {
    return TraitementPeriodesAvant.traitementPeriodesSegmentantes(periode, utAvant, periodesSegmentantes);
  }
  
  public void creerDureeIndemnisation(AttributionSpec attribution, CalendrierExecutionAvant calendrierAvant, UniteTraitementAvant utAvant)
  {
    DureeConsommableAvant dureePmc = new DureeConsommableAvant(0, new QuantiteJour("0"));
    DureeConsommableAvant dureeDiffereStandard = new DureeConsommableAvant(1, new QuantiteJour("0"));
    DureeConsommableAvant dureeDiffereSpecifique = new DureeConsommableAvant(2, new QuantiteJour("0"));
    DureeConsommableAvant dureeDelaiAttente = new DureeConsommableAvant(3, new QuantiteJour("0"));
    
    PreavisMesureConservatoireNonIndemnisable pmc = getPmcAConsommer((Attribution)attribution);
    if (pmc != null) {
      dureePmc.setQuantiteInitial(pmc.getQuantiteInitiale());
    }
    CarenceStandard differeStandard = getDiffereStandardAConsommer((Attribution)attribution);
    if (differeStandard != null) {
      dureeDiffereStandard.setQuantiteInitial(differeStandard.getQuantiteInitiale());
    }
    CarenceIslr differeSpecifique = getDiffereSpecifiqueAConsommer((Attribution)attribution);
    if (differeSpecifique != null) {
      dureeDiffereSpecifique.setQuantiteInitial(differeSpecifique.getQuantiteInitiale());
    }
    Differe delaiAttente = getDelaiAttenteAConsommer((Attribution)attribution);
    if (delaiAttente != null) {
      dureeDelaiAttente.setQuantiteInitial(delaiAttente.getQuantiteInitiale());
    }
    dureePmc.activer();
    if (dureePmc.getQuantiteInitial().getValeurEntiere() > 0)
    {
      Periode p = new Periode(calendrierAvant.getPremierJourAvant());
      utAvant.getConsommationPeriodes().setPeriodePmc(p);
    }
    utAvant.setDureePmcEnDebutUT(dureePmc);
    utAvant.setDureeDiffereStandardEnDebutUT(dureeDiffereStandard);
    utAvant.setDureeDiffereSpecifiqueEnDebutUT(dureeDiffereSpecifique);
    utAvant.setDureeDelaiAttenteEnDebutUT(dureeDelaiAttente);
  }
  
  public ArretProduitAvecRaison traitementPeriodesInterruptivesDefinitives(PeriodesPriseEnCompte periodesPriseEnCompte, UniteTraitementAvant utAvant, AttributionSpec attribution, CalendrierExecutionAvant calendrierAvant)
    throws CoucheLogiqueException
  {
    ObjetChronoPeriode objetChronoPeriode = null;
    ListIterator iterator = null;
    ArretProduitAvecRaison retour = new ArretProduitAvecRaison();
    Damj dateDebutPremierePeriodeTraitee = null;
    ChronologiePeriodes periodesInterruptivesDefinitives = utAvant.getQualificationPeriodes().getPeriodesInterruptivesDefinitives();
    
    iterator = periodesInterruptivesDefinitives.iterer();
    while (iterator.hasNext())
    {
      objetChronoPeriode = (ObjetChronoPeriode)iterator.next();
      if ((dateDebutPremierePeriodeTraitee == null) || (objetChronoPeriode.getDateDebut().equals(dateDebutPremierePeriodeTraitee)))
      {
        dateDebutPremierePeriodeTraitee = objetChronoPeriode.getDateDebut();
        
        retour.ajoutePeriodeInterruptiveDefinitive(objetChronoPeriode);
        
        periodesPriseEnCompte.tronquePeriodesPriseEnCompteEnFin(objetChronoPeriode.getDateDebut().veille());
      }
    }
    return retour;
  }
  
  public boolean traitementPeriodesSuspensivesPourDebutConsommationDelaiAttente(PeriodeAnalyseSpec pa, QualificationPeriodes qualificationPeriodes, Damj dateDebutConsommationDelaiAttente)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesSuspensivesSurPa = (ChronologiePeriodes)qualificationPeriodes.getPeriodesSuspensives().copier(new FiltreChevauchePeriode(pa.getPeriode()));
    
    periodesSuspensivesSurPa.ajouter((ChronologiePeriodes)qualificationPeriodes.getPeriodesInterruptives().copier(new FiltreChevauchePeriode(pa.getPeriode())));
    
    ChronologiePeriodes chronologiePeriodesSuspensivesSurPeriode = new ChronologiePeriodes();
    
    periodesSuspensivesSurPa.iterer();
    while (periodesSuspensivesSurPa.encoreSuivant())
    {
      Temporel periode = periodesSuspensivesSurPa.elementSuivant();
      if (periode.getDateDebut().estAvantOuCoincideAvec(dateDebutConsommationDelaiAttente)) {
        if ((periode instanceof DsmMaladie)) {
          chronologiePeriodesSuspensivesSurPeriode.ajouter(periode);
        } else if ((periode instanceof PeriodeEvenementPersonnel)) {
          chronologiePeriodesSuspensivesSurPeriode.ajouter(periode);
        } else if ((periode instanceof PeriodeAbsenceAuPointage)) {
          chronologiePeriodesSuspensivesSurPeriode.ajouter(periode);
        }
      }
      if ((periode instanceof ObjetChronoPeriodeSuspensionIndemnisation)) {
        chronologiePeriodesSuspensivesSurPeriode.ajouter(periode);
      }
    }
    if (!chronologiePeriodesSuspensivesSurPeriode.estVide()) {
      return true;
    }
    return false;
  }
  
  public Quantite simulerImputationEtImputerLaQuantite(Quantite quantiteAImputer, DureeConsommableAvant dureeConcommableAvant, UniteTraitementAvant utAvant, Damj dateDebutConsommation)
    throws CoucheLogiqueException
  {
    return TraitementDureeConsommableAvant.simulerImputationEtImputerLaQuantite(quantiteAImputer, dureeConcommableAvant, utAvant, dateDebutConsommation);
  }
  
  public void simulerImputationEtImputerLaQuantiteEtTerminerProduit(Quantite quantiteAImputer, PeriodeAnalyseSpec pa, DureeConsommableAvant dureeConcommableAvant, UniteTraitementAvant utAvant, Damj dateDebutConsommation, ArretProduitAvecRaison arretProduitAvecRaison, Damj dateAttribution)
    throws CoucheLogiqueException
  {
    TraitementDureeConsommableAvant.simulerImputationEtImputerLaQuantiteEtTerminerProduit(quantiteAImputer, pa, dureeConcommableAvant, utAvant, dateDebutConsommation, arretProduitAvecRaison);
  }
  
  public boolean estUnCarenceGereeParLeProduit(DureeConsommableAvant dureeAvant)
  {
    return (dureeAvant.getTypeDureeConsommable() == 0) || (dureeAvant.getTypeDureeConsommable() == 1) || (dureeAvant.getTypeDureeConsommable() == 2) || (dureeAvant.getTypeDureeConsommable() == 3);
  }
  
  public boolean estCarenceTerminantProduit(DureeConsommableAvant dureeAvant)
  {
    return dureeAvant.getTypeDureeConsommable() == 3;
  }
  
  public boolean estUneCarenceSeConsommantApresDateAttribution(DureeConsommableAvant dureeAvant)
  {
    return dureeAvant.getTypeDureeConsommable() == 1;
  }
  
  public boolean estUneCarenceSuspendueParSuspensif(DureeConsommableAvant dureeAvant)
  {
    return dureeAvant.getTypeDureeConsommable() == 1;
  }
  
  public fr.unedic.cali.calcul.dom.EvenementFinQuantiteDroit creerEvtFinQteDroit(Damj dateFinQuantiteDroit, QuantiteDroitSpec quantiteDroitAImputer)
  {
    return new fr.unedic.cali.asu.calcul.dom.EvenementFinQuantiteDroit(dateFinQuantiteDroit, quantiteDroitAImputer);
  }
}

/* Location:
 * Qualified Name:     FacadeAvantProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */