package fr.unedic.cali.asu.spe02.p03.liquidation.dom;

import fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen.ConstitutionElementsAdmissionGen;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public class ConstitutionElementsAdmission
  extends ConstitutionElementsAdmissionGen
  implements ConstitutionElementsSpec
{
  private static final long serialVersionUID = 1L;
  
  public ConstitutionElementsAdmission() {}
  
  public ConstitutionElementsAdmission(DomPCSpec pc)
  {
    super(pc);
  }
  
  public ObjetMetierSpec copie()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller le méthode copieElements(ObjetMetierSpec).");
  }
  
  public void copieElements(ObjetMetierSpec pCopie)
  {
    ConstitutionElementsAdmission copie = (ConstitutionElementsAdmission)pCopie;
    super.copieElements(copie);
    if (getConstitutionNbHeuresTravaillees() != null)
    {
      ConstitutionNbHeuresTravaillees copieCepa = copie.createConstitutionNbHeuresTravaillees();
      getConstitutionNbHeuresTravaillees().copieElements(copieCepa);
    }
    if (getConstitutionPointDepartIndemnisation() != null)
    {
      ConstitutionPointDepartIndemnisation copieCepa = copie.createConstitutionPointDepartIndemnisation();
      getConstitutionPointDepartIndemnisation().copieElements(copieCepa);
    }
    if (getConstitutionDateAttribution() != null)
    {
      ConstitutionDateAttribution copieCepa = copie.createConstitutionDateAttribution();
      getConstitutionDateAttribution().copieElements(copieCepa);
    }
    if (getConstitutionReglementApplicable() != null)
    {
      ConstitutionReglementApplicable copieCepa = copie.createConstitutionReglementApplicable();
      getConstitutionReglementApplicable().copieElements(copieCepa);
    }
    if (getConstitutionDelaisReport() != null)
    {
      ConstitutionDelaisReport copieCepa = copie.createConstitutionDelaisReport();
      getConstitutionDelaisReport().copieElements(copieCepa);
    }
    if (getConstitutionSalaireJournalierMoyen() != null)
    {
      ConstitutionSalaireJournalierMoyen copieCepa = copie.createConstitutionSalaireJournalierMoyen();
      getConstitutionSalaireJournalierMoyen().copieElements(copieCepa);
    }
    if (getConstitutionSalaireReference() != null)
    {
      ConstitutionSalaireReference copieCepa = copie.createConstitutionSalaireReference();
      getConstitutionSalaireReference().copieElements(copieCepa);
    }
    if (getConstitutionDurees() != null)
    {
      ConstitutionDurees copieCepa = copie.createConstitutionDurees();
      getConstitutionDurees().copieElements(copieCepa);
    }
    if (getConstitutionMontantsBruts() != null)
    {
      ConstitutionMontantsBruts copieCepa = copie.createConstitutionMontantsBruts();
      getConstitutionMontantsBruts().copieElements(copieCepa);
    }
    if (getConstitutionDateLimiteIndemnisation() != null)
    {
      ConstitutionDateLimiteIndemnisation copieCepa = copie.createConstitutionDateLimiteIndemnisation();
      getConstitutionDateLimiteIndemnisation().copieElements(copieCepa);
    }
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(super.getConstitutionDurees());
    DomManager.persisterEnProfondeur(super.getConstitutionMontantsBruts());
    DomManager.persisterEnProfondeur(super.getConstitutionSalaireReference());
    DomManager.persisterEnProfondeur(super.getConstitutionSalaireJournalierMoyen());
    DomManager.persisterEnProfondeur(super.getConstitutionDelaisReport());
    DomManager.persisterEnProfondeur(super.getConstitutionReglementApplicable());
    DomManager.persisterEnProfondeur(super.getConstitutionDateAttribution());
    DomManager.persisterEnProfondeur(super.getConstitutionPointDepartIndemnisation());
    DomManager.persisterEnProfondeur(super.getConstitutionNbHeuresTravaillees());
    DomManager.persisterEnProfondeur(super.getConstitutionDateLimiteIndemnisation());
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
}

/* Location:
 * Qualified Name:     ConstitutionElementsAdmission
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */