package fr.unedic.cali.asu.spe02.p03.liquidation.dom;

import fr.unedic.cali.asu.dom.JustificationAffiliationSpec;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen.JustificationAffiliationGen;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Unite;
import fr.unedic.util.UniteAffiliation;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.Periode;
import java.util.Collection;
import java.util.Iterator;

public class JustificationAffiliation
  extends JustificationAffiliationGen
  implements ObjetPersistantSpec, JustificationAffiliationSpec
{
  private static final long serialVersionUID = 3828799293939876507L;
  private transient int nombreJourAssimilationSalaire = 0;
  
  public JustificationAffiliation(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public JustificationAffiliation() {}
  
  public ObjetMetierSpec copie()
  {
    JustificationAffiliation copie = new JustificationAffiliation();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    JustificationAffiliation copie = (JustificationAffiliation)p_copie;
    super.copieElements(copie);
    Iterator iter1 = getCollectionActiviteParticipante().iterator();
    while (iter1.hasNext())
    {
      ActiviteParticipante activiteParticipanteACloner = (ActiviteParticipante)iter1.next();
      if (activiteParticipanteACloner != null)
      {
        ActiviteParticipante activiteParticipanteClone = (ActiviteParticipante)activiteParticipanteACloner.copie();
        copie.ajouterActiviteParticipante(activiteParticipanteClone);
      }
    }
    Iterator iter2 = getCollectionAssimilation().iterator();
    while (iter2.hasNext())
    {
      AffiliationAssimilee affiliationAssimileeACloner = (AffiliationAssimilee)iter2.next();
      if (affiliationAssimileeACloner != null)
      {
        AffiliationAssimilee affiliationAssimileeClone = (AffiliationAssimilee)affiliationAssimileeACloner.copie();
        copie.ajouterAssimilation(affiliationAssimileeClone);
      }
    }
    Iterator iter3 = getCollectionAffiliationSupplementaire().iterator();
    while (iter3.hasNext())
    {
      AffiliationSupplementaire affiliationSupplementaireACloner = (AffiliationSupplementaire)iter3.next();
      if (affiliationSupplementaireACloner != null)
      {
        AffiliationSupplementaire affiliationSupplementaireClone = (AffiliationSupplementaire)affiliationSupplementaireACloner.copie();
        copie.ajouterAffiliationSupplementaire(affiliationSupplementaireClone);
      }
    }
    Iterator iter4 = getCollectionAllongementPra().iterator();
    while (iter4.hasNext())
    {
      AllongementPra allongementPraACloner = (AllongementPra)iter4.next();
      if (allongementPraACloner != null)
      {
        AllongementPra allongementPraClone = (AllongementPra)allongementPraACloner.copie();
        copie.ajouterAllongementPra(allongementPraClone);
      }
    }
    Iterator iter5 = getCollectionPeriodeElementaireAffiliation().iterator();
    while (iter5.hasNext())
    {
      PeriodeElementaireAffiliation periodeElementaireAffiliationACloner = (PeriodeElementaireAffiliation)iter5.next();
      if (periodeElementaireAffiliationACloner != null)
      {
        PeriodeElementaireAffiliation periodeElementaireAffiliationClone = (PeriodeElementaireAffiliation)periodeElementaireAffiliationACloner.copie();
        
        copie.ajouterPeriodeElementaireAffiliation(periodeElementaireAffiliationClone);
      }
    }
    copie.setNombreJourAssimilationSalaire(getNombreJourAssimilationSalaire());
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(getCollectionAllongementPra());
    DomManager.persisterEnProfondeur(getCollectionActiviteParticipante());
    DomManager.persisterEnProfondeur(getCollectionAssimilation());
    DomManager.persisterEnProfondeur(getCollectionAffiliationSupplementaire());
    DomManager.persisterEnProfondeur(getCollectionPeriodeElementaireAffiliation());
  }
  
  public Chronologie getChronoZmes()
  {
    throw new UnsupportedOperationException("Cette méthode ne devrait pas être appelée dans ce contexte");
  }
  
  public UniteAffiliation getUniteJustification()
  {
    return (UniteAffiliation)Unite.getParCode("18");
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public String getTypeJustificationAffiliation()
  {
    return "justifSPE";
  }
  
  public Periode getPeriodeRechercheAffiliation()
  {
    return null;
  }
  
  public void remplacerCollectionAllongementPra(Collection collectionACopier)
  {
    for (Iterator iter = super.getCollectionAllongementPra().iterator(); iter.hasNext();)
    {
      AllongementPra element = (AllongementPra)iter.next();
      DomManager.supprimer(element);
    }
    super.remplacerCollectionAllongementPra(collectionACopier);
  }
  
  public void remplacerCollectionActiviteParticipante(Collection collectionACopier)
  {
    for (Iterator iter = super.getCollectionActiviteParticipante().iterator(); iter.hasNext();)
    {
      ActiviteParticipante element = (ActiviteParticipante)iter.next();
      DomManager.supprimer(element);
    }
    super.remplacerCollectionActiviteParticipante(collectionACopier);
  }
  
  public void remplacerCollectionAssimilation(Collection collectionACopier)
  {
    for (Iterator iter = super.getCollectionAssimilation().iterator(); iter.hasNext();)
    {
      AffiliationAssimilee element = (AffiliationAssimilee)iter.next();
      DomManager.supprimer(element);
    }
    super.remplacerCollectionAssimilation(collectionACopier);
  }
  
  public void remplacerCollectionAffiliationSupplementaire(Collection collectionACopier)
  {
    for (Iterator iter = super.getCollectionAffiliationSupplementaire().iterator(); iter.hasNext();)
    {
      AffiliationSupplementaire element = (AffiliationSupplementaire)iter.next();
      DomManager.supprimer(element);
    }
    super.remplacerCollectionAffiliationSupplementaire(collectionACopier);
  }
  
  public void remplacerCollectionPeriodeElementaireAffiliation(Collection collectionACopier)
  {
    for (Iterator iter = super.getCollectionPeriodeElementaireAffiliation().iterator(); iter.hasNext();)
    {
      PeriodeElementaireAffiliation element = (PeriodeElementaireAffiliation)iter.next();
      DomManager.supprimer(element);
    }
    super.remplacerCollectionPeriodeElementaireAffiliation(collectionACopier);
  }
  
  public int getNombreJourAssimilationSalaire()
  {
    return nombreJourAssimilationSalaire;
  }
  
  public void setNombreJourAssimilationSalaire(int nombreJourAssimilationSalaire)
  {
    this.nombreJourAssimilationSalaire = nombreJourAssimilationSalaire;
  }
}

/* Location:
 * Qualified Name:     JustificationAffiliation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */