package fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.spec.ConditionsAttributionAbstraitPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.ObjetChronoEvenementDebutCREM;

public abstract class ConditionFaitGenerateurGen
  extends ObjetChronoEvenementDebutCREM
  implements DomGenSpec
{
  private String m_identifiantPeriodeFG;
  private Damj m_dateEvenement;
  private String m_motifFinPeriodeFG;
  private Damj m_dateFinPeriodeFG;
  private DureeCalendaire m_ageIndividuDateFG;
  private String m_refusAdhesionFne;
  
  public ConditionFaitGenerateurGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public ConditionFaitGenerateurGen() {}
  
  protected int rawGetEtat()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getEtatConditionFaitGenerateur();
  }
  
  public int getEtat()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getEtatConditionFaitGenerateur();
  }
  
  public void setEtat(int p_etat)
  {
    ((ConditionsAttributionAbstraitPC)getPC()).setEtatConditionFaitGenerateur(p_etat);
  }
  
  protected int rawGetCodeMotifEchec()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getCodeMotifEchecConditionFaitGenerateur();
  }
  
  public int getCodeMotifEchec()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getCodeMotifEchecConditionFaitGenerateur();
  }
  
  public void setCodeMotifEchec(int p_codeMotifEchec)
  {
    ((ConditionsAttributionAbstraitPC)getPC()).setCodeMotifEchecConditionFaitGenerateur(p_codeMotifEchec);
  }
  
  protected String rawGetIdentifiantPeriodeFG()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getIdentifiantPeriodeFGConditionFaitGenerateur();
  }
  
  public String getIdentifiantPeriodeFG()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getIdentifiantPeriodeFGConditionFaitGenerateur();
  }
  
  public void setIdentifiantPeriodeFG(String p_identifiantPeriodeFG)
  {
    if ((m_identifiantPeriodeFG == null) || (p_identifiantPeriodeFG == null))
    {
      m_identifiantPeriodeFG = p_identifiantPeriodeFG;
      ((ConditionsAttributionAbstraitPC)getPC()).setIdentifiantPeriodeFGConditionFaitGenerateur(p_identifiantPeriodeFG);
    }
    else if ((m_identifiantPeriodeFG != null) && (p_identifiantPeriodeFG != null) && (!p_identifiantPeriodeFG.equals(m_identifiantPeriodeFG)))
    {
      m_identifiantPeriodeFG = p_identifiantPeriodeFG;
      ((ConditionsAttributionAbstraitPC)getPC()).setIdentifiantPeriodeFGConditionFaitGenerateur(p_identifiantPeriodeFG);
    }
  }
  
  protected Damj rawGetDateEvenement()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getDateEvenementConditionFaitGenerateur();
  }
  
  public Damj getDateEvenement()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getDateEvenementConditionFaitGenerateur();
  }
  
  public void setDateEvenement(Damj p_dateEvenement)
  {
    if ((m_dateEvenement == null) || (p_dateEvenement == null))
    {
      m_dateEvenement = p_dateEvenement;
      ((ConditionsAttributionAbstraitPC)getPC()).setDateEvenementConditionFaitGenerateur(p_dateEvenement);
    }
    else if ((m_dateEvenement != null) && (p_dateEvenement != null) && (!p_dateEvenement.equals(m_dateEvenement)))
    {
      m_dateEvenement = p_dateEvenement;
      ((ConditionsAttributionAbstraitPC)getPC()).setDateEvenementConditionFaitGenerateur(p_dateEvenement);
    }
  }
  
  protected String rawGetMotifFinPeriodeFG()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getMotifFinPeriodeFGConditionFaitGenerateur();
  }
  
  public String getMotifFinPeriodeFG()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getMotifFinPeriodeFGConditionFaitGenerateur();
  }
  
  public void setMotifFinPeriodeFG(String p_motifFinPeriodeFG)
  {
    if ((m_motifFinPeriodeFG == null) || (p_motifFinPeriodeFG == null))
    {
      m_motifFinPeriodeFG = p_motifFinPeriodeFG;
      ((ConditionsAttributionAbstraitPC)getPC()).setMotifFinPeriodeFGConditionFaitGenerateur(p_motifFinPeriodeFG);
    }
    else if ((m_motifFinPeriodeFG != null) && (p_motifFinPeriodeFG != null) && (!p_motifFinPeriodeFG.equals(m_motifFinPeriodeFG)))
    {
      m_motifFinPeriodeFG = p_motifFinPeriodeFG;
      ((ConditionsAttributionAbstraitPC)getPC()).setMotifFinPeriodeFGConditionFaitGenerateur(p_motifFinPeriodeFG);
    }
  }
  
  protected Damj rawGetDateFinPeriodeFG()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getDateFinPeriodeFGConditionFaitGenerateur();
  }
  
  public Damj getDateFinPeriodeFG()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getDateFinPeriodeFGConditionFaitGenerateur();
  }
  
  public void setDateFinPeriodeFG(Damj p_dateFinPeriodeFG)
  {
    if ((m_dateFinPeriodeFG == null) || (p_dateFinPeriodeFG == null))
    {
      m_dateFinPeriodeFG = p_dateFinPeriodeFG;
      ((ConditionsAttributionAbstraitPC)getPC()).setDateFinPeriodeFGConditionFaitGenerateur(p_dateFinPeriodeFG);
    }
    else if ((m_dateFinPeriodeFG != null) && (p_dateFinPeriodeFG != null) && (!p_dateFinPeriodeFG.equals(m_dateFinPeriodeFG)))
    {
      m_dateFinPeriodeFG = p_dateFinPeriodeFG;
      ((ConditionsAttributionAbstraitPC)getPC()).setDateFinPeriodeFGConditionFaitGenerateur(p_dateFinPeriodeFG);
    }
  }
  
  protected DureeCalendaire rawGetAgeIndividuDateFG()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getAgeIndividuDateFGConditionFaitGenerateur();
  }
  
  public DureeCalendaire getAgeIndividuDateFG()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getAgeIndividuDateFGConditionFaitGenerateur();
  }
  
  public void setAgeIndividuDateFG(DureeCalendaire p_ageIndividuDateFG)
  {
    if ((m_ageIndividuDateFG == null) || (p_ageIndividuDateFG == null))
    {
      m_ageIndividuDateFG = p_ageIndividuDateFG;
      ((ConditionsAttributionAbstraitPC)getPC()).setAgeIndividuDateFGConditionFaitGenerateur(p_ageIndividuDateFG);
    }
    else if ((m_ageIndividuDateFG != null) && (p_ageIndividuDateFG != null) && (!p_ageIndividuDateFG.equals(m_ageIndividuDateFG)))
    {
      m_ageIndividuDateFG = p_ageIndividuDateFG;
      ((ConditionsAttributionAbstraitPC)getPC()).setAgeIndividuDateFGConditionFaitGenerateur(p_ageIndividuDateFG);
    }
  }
  
  protected String rawGetRefusAdhesionFne()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getRefusFneConditionFaitGenerateur();
  }
  
  public String getRefusAdhesionFne()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getRefusFneConditionFaitGenerateur();
  }
  
  public void setRefusAdhesionFne(String p_refusAdhesionFne)
  {
    if ((m_refusAdhesionFne == null) || (p_refusAdhesionFne == null))
    {
      m_refusAdhesionFne = p_refusAdhesionFne;
      ((ConditionsAttributionAbstraitPC)getPC()).setRefusFneConditionFaitGenerateur(p_refusAdhesionFne);
    }
    else if ((m_refusAdhesionFne != null) && (p_refusAdhesionFne != null) && (!p_refusAdhesionFne.equals(m_refusAdhesionFne)))
    {
      m_refusAdhesionFne = p_refusAdhesionFne;
      ((ConditionsAttributionAbstraitPC)getPC()).setRefusFneConditionFaitGenerateur(p_refusAdhesionFne);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    super.initEnProfondeur();
    
    setEtat(0);
    setCodeMotifEchec(0);
    setIdentifiantPeriodeFG(null);
    setDateEvenement(null);
    setMotifFinPeriodeFG(null);
    setDateFinPeriodeFG(null);
    setAgeIndividuDateFG(null);
    setRefusAdhesionFne(null);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     ConditionFaitGenerateurGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */