package fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.CarencePrefixeAFixer;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.JustificationDiffere;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.JustificationFranchiseCongesPayes;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.spec.ConstitutionElementsAbstraitPC;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.ApplicativeRuntimeException;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public abstract class ConstitutionDelaisReportGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionElementsAbstraitPC;
  private Damj m_debutPMCNonIndemn;
  private Damj m_termePMCNonIndemn;
  private Damj m_debutPMCIndemn;
  private Damj m_termePMCIndemn;
  private Damj m_debutCarenceStandard;
  private Damj m_termeCarenceStandard;
  private Damj m_debutCarenceISLR;
  private Damj m_termeCarenceISLR;
  private Damj m_debutDelaiReport;
  private Damj m_termeDelaiReport;
  private Quantite m_quantiteFranchiseCPMensuelle;
  private Quantite m_quantiteFranchiseSalaireMensuelle;
  public JustificationFranchiseCongesPayes m_justificationFranchiseCongesPayes;
  private Periode m_periodeApplicationDifferePrecedent;
  private Collection m_listeCarences;
  private transient JustificationDiffere m_justificationDiffere;
  
  public ConstitutionDelaisReportGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConstitutionDelaisReportGen() {}
  
  public DomPCSpec getPC()
  {
    return m_constitutionElementsAbstraitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionElementsAbstraitPC)
  {
    m_constitutionElementsAbstraitPC = p_constitutionElementsAbstraitPC;
  }
  
  protected int rawGetNbJoursPMCNonIndemn()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getNbJoursPMCNonIndemnConstitutionDelaisReport();
  }
  
  public int getNbJoursPMCNonIndemn()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getNbJoursPMCNonIndemnConstitutionDelaisReport();
  }
  
  public void setNbJoursPMCNonIndemn(int p_nbJoursPMCNonIndemn)
  {
    ((ConstitutionElementsAbstraitPC)getPC()).setNbJoursPMCNonIndemnConstitutionDelaisReport(p_nbJoursPMCNonIndemn);
  }
  
  protected Damj rawGetDebutPMCNonIndemn()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDebutPMCNonIndemnConstitutionDelaisReport();
  }
  
  public Damj getDebutPMCNonIndemn()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDebutPMCNonIndemnConstitutionDelaisReport();
  }
  
  public void setDebutPMCNonIndemn(Damj p_debutPMCNonIndemn)
  {
    if ((m_debutPMCNonIndemn == null) || (p_debutPMCNonIndemn == null))
    {
      m_debutPMCNonIndemn = p_debutPMCNonIndemn;
      ((ConstitutionElementsAbstraitPC)getPC()).setDebutPMCNonIndemnConstitutionDelaisReport(p_debutPMCNonIndemn);
    }
    else if ((m_debutPMCNonIndemn != null) && (p_debutPMCNonIndemn != null) && (!p_debutPMCNonIndemn.equals(m_debutPMCNonIndemn)))
    {
      m_debutPMCNonIndemn = p_debutPMCNonIndemn;
      ((ConstitutionElementsAbstraitPC)getPC()).setDebutPMCNonIndemnConstitutionDelaisReport(p_debutPMCNonIndemn);
    }
  }
  
  protected Damj rawGetTermePMCNonIndemn()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTermePMCNonIndemnConstitutionDelaisReport();
  }
  
  public Damj getTermePMCNonIndemn()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTermePMCNonIndemnConstitutionDelaisReport();
  }
  
  public void setTermePMCNonIndemn(Damj p_termePMCNonIndemn)
  {
    if ((m_termePMCNonIndemn == null) || (p_termePMCNonIndemn == null))
    {
      m_termePMCNonIndemn = p_termePMCNonIndemn;
      ((ConstitutionElementsAbstraitPC)getPC()).setTermePMCNonIndemnConstitutionDelaisReport(p_termePMCNonIndemn);
    }
    else if ((m_termePMCNonIndemn != null) && (p_termePMCNonIndemn != null) && (!p_termePMCNonIndemn.equals(m_termePMCNonIndemn)))
    {
      m_termePMCNonIndemn = p_termePMCNonIndemn;
      ((ConstitutionElementsAbstraitPC)getPC()).setTermePMCNonIndemnConstitutionDelaisReport(p_termePMCNonIndemn);
    }
  }
  
  protected int rawGetNbJoursPMCIndemn()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getNbJoursPMCIndemnConstitutionDelaisReport();
  }
  
  public int getNbJoursPMCIndemn()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getNbJoursPMCIndemnConstitutionDelaisReport();
  }
  
  public void setNbJoursPMCIndemn(int p_nbJoursPMCIndemn)
  {
    ((ConstitutionElementsAbstraitPC)getPC()).setNbJoursPMCIndemnConstitutionDelaisReport(p_nbJoursPMCIndemn);
  }
  
  protected Damj rawGetDebutPMCIndemn()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDebutPMCIndemnConstitutionDelaisReport();
  }
  
  public Damj getDebutPMCIndemn()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDebutPMCIndemnConstitutionDelaisReport();
  }
  
  public void setDebutPMCIndemn(Damj p_debutPMCIndemn)
  {
    if ((m_debutPMCIndemn == null) || (p_debutPMCIndemn == null))
    {
      m_debutPMCIndemn = p_debutPMCIndemn;
      ((ConstitutionElementsAbstraitPC)getPC()).setDebutPMCIndemnConstitutionDelaisReport(p_debutPMCIndemn);
    }
    else if ((m_debutPMCIndemn != null) && (p_debutPMCIndemn != null) && (!p_debutPMCIndemn.equals(m_debutPMCIndemn)))
    {
      m_debutPMCIndemn = p_debutPMCIndemn;
      ((ConstitutionElementsAbstraitPC)getPC()).setDebutPMCIndemnConstitutionDelaisReport(p_debutPMCIndemn);
    }
  }
  
  protected Damj rawGetTermePMCIndemn()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTermePMCIndemnConstitutionDelaisReport();
  }
  
  public Damj getTermePMCIndemn()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTermePMCIndemnConstitutionDelaisReport();
  }
  
  public void setTermePMCIndemn(Damj p_termePMCIndemn)
  {
    if ((m_termePMCIndemn == null) || (p_termePMCIndemn == null))
    {
      m_termePMCIndemn = p_termePMCIndemn;
      ((ConstitutionElementsAbstraitPC)getPC()).setTermePMCIndemnConstitutionDelaisReport(p_termePMCIndemn);
    }
    else if ((m_termePMCIndemn != null) && (p_termePMCIndemn != null) && (!p_termePMCIndemn.equals(m_termePMCIndemn)))
    {
      m_termePMCIndemn = p_termePMCIndemn;
      ((ConstitutionElementsAbstraitPC)getPC()).setTermePMCIndemnConstitutionDelaisReport(p_termePMCIndemn);
    }
  }
  
  protected int rawGetNbJoursCarenceStandard()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getNbJoursCarenceStandardConstitutionDelaisReport();
  }
  
  public int getNbJoursCarenceStandard()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getNbJoursCarenceStandardConstitutionDelaisReport();
  }
  
  public void setNbJoursCarenceStandard(int p_nbJoursCarenceStandard)
  {
    ((ConstitutionElementsAbstraitPC)getPC()).setNbJoursCarenceStandardConstitutionDelaisReport(p_nbJoursCarenceStandard);
  }
  
  protected Damj rawGetDebutCarenceStandard()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDebutCarenceStandardConstitutionDelaisReport();
  }
  
  public Damj getDebutCarenceStandard()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDebutCarenceStandardConstitutionDelaisReport();
  }
  
  public void setDebutCarenceStandard(Damj p_debutCarenceStandard)
  {
    if ((m_debutCarenceStandard == null) || (p_debutCarenceStandard == null))
    {
      m_debutCarenceStandard = p_debutCarenceStandard;
      ((ConstitutionElementsAbstraitPC)getPC()).setDebutCarenceStandardConstitutionDelaisReport(p_debutCarenceStandard);
    }
    else if ((m_debutCarenceStandard != null) && (p_debutCarenceStandard != null) && (!p_debutCarenceStandard.equals(m_debutCarenceStandard)))
    {
      m_debutCarenceStandard = p_debutCarenceStandard;
      ((ConstitutionElementsAbstraitPC)getPC()).setDebutCarenceStandardConstitutionDelaisReport(p_debutCarenceStandard);
    }
  }
  
  protected Damj rawGetTermeCarenceStandard()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTermeCarenceStandardConstitutionDelaisReport();
  }
  
  public Damj getTermeCarenceStandard()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTermeCarenceStandardConstitutionDelaisReport();
  }
  
  public void setTermeCarenceStandard(Damj p_termeCarenceStandard)
  {
    if ((m_termeCarenceStandard == null) || (p_termeCarenceStandard == null))
    {
      m_termeCarenceStandard = p_termeCarenceStandard;
      ((ConstitutionElementsAbstraitPC)getPC()).setTermeCarenceStandardConstitutionDelaisReport(p_termeCarenceStandard);
    }
    else if ((m_termeCarenceStandard != null) && (p_termeCarenceStandard != null) && (!p_termeCarenceStandard.equals(m_termeCarenceStandard)))
    {
      m_termeCarenceStandard = p_termeCarenceStandard;
      ((ConstitutionElementsAbstraitPC)getPC()).setTermeCarenceStandardConstitutionDelaisReport(p_termeCarenceStandard);
    }
  }
  
  protected int rawGetNbJoursCarenceISLR()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getNbJoursCarenceISLRConstitutionDelaisReport();
  }
  
  public int getNbJoursCarenceISLR()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getNbJoursCarenceISLRConstitutionDelaisReport();
  }
  
  public void setNbJoursCarenceISLR(int p_nbJoursCarenceISLR)
  {
    ((ConstitutionElementsAbstraitPC)getPC()).setNbJoursCarenceISLRConstitutionDelaisReport(p_nbJoursCarenceISLR);
  }
  
  protected Damj rawGetDebutCarenceISLR()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDebutCarenceISLRConstitutionDelaisReport();
  }
  
  public Damj getDebutCarenceISLR()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDebutCarenceISLRConstitutionDelaisReport();
  }
  
  public void setDebutCarenceISLR(Damj p_debutCarenceISLR)
  {
    if ((m_debutCarenceISLR == null) || (p_debutCarenceISLR == null))
    {
      m_debutCarenceISLR = p_debutCarenceISLR;
      ((ConstitutionElementsAbstraitPC)getPC()).setDebutCarenceISLRConstitutionDelaisReport(p_debutCarenceISLR);
    }
    else if ((m_debutCarenceISLR != null) && (p_debutCarenceISLR != null) && (!p_debutCarenceISLR.equals(m_debutCarenceISLR)))
    {
      m_debutCarenceISLR = p_debutCarenceISLR;
      ((ConstitutionElementsAbstraitPC)getPC()).setDebutCarenceISLRConstitutionDelaisReport(p_debutCarenceISLR);
    }
  }
  
  protected Damj rawGetTermeCarenceISLR()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTermeCarenceISLRConstitutionDelaisReport();
  }
  
  public Damj getTermeCarenceISLR()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTermeCarenceISLRConstitutionDelaisReport();
  }
  
  public void setTermeCarenceISLR(Damj p_termeCarenceISLR)
  {
    if ((m_termeCarenceISLR == null) || (p_termeCarenceISLR == null))
    {
      m_termeCarenceISLR = p_termeCarenceISLR;
      ((ConstitutionElementsAbstraitPC)getPC()).setTermeCarenceISLRConstitutionDelaisReport(p_termeCarenceISLR);
    }
    else if ((m_termeCarenceISLR != null) && (p_termeCarenceISLR != null) && (!p_termeCarenceISLR.equals(m_termeCarenceISLR)))
    {
      m_termeCarenceISLR = p_termeCarenceISLR;
      ((ConstitutionElementsAbstraitPC)getPC()).setTermeCarenceISLRConstitutionDelaisReport(p_termeCarenceISLR);
    }
  }
  
  protected int rawGetNbJoursDelaiReport()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getNbJoursDelaiReportConstitutionDelaisReport();
  }
  
  public int getNbJoursDelaiReport()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getNbJoursDelaiReportConstitutionDelaisReport();
  }
  
  public void setNbJoursDelaiReport(int p_nbJoursDelaiReport)
  {
    ((ConstitutionElementsAbstraitPC)getPC()).setNbJoursDelaiReportConstitutionDelaisReport(p_nbJoursDelaiReport);
  }
  
  protected Damj rawGetDebutDelaiReport()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDebutDelaiReportConstitutionDelaisReport();
  }
  
  public Damj getDebutDelaiReport()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDebutDelaiReportConstitutionDelaisReport();
  }
  
  public void setDebutDelaiReport(Damj p_debutDelaiReport)
  {
    if ((m_debutDelaiReport == null) || (p_debutDelaiReport == null))
    {
      m_debutDelaiReport = p_debutDelaiReport;
      ((ConstitutionElementsAbstraitPC)getPC()).setDebutDelaiReportConstitutionDelaisReport(p_debutDelaiReport);
    }
    else if ((m_debutDelaiReport != null) && (p_debutDelaiReport != null) && (!p_debutDelaiReport.equals(m_debutDelaiReport)))
    {
      m_debutDelaiReport = p_debutDelaiReport;
      ((ConstitutionElementsAbstraitPC)getPC()).setDebutDelaiReportConstitutionDelaisReport(p_debutDelaiReport);
    }
  }
  
  protected Damj rawGetTermeDelaiReport()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTermeDelaiReportConstitutionDelaisReport();
  }
  
  public Damj getTermeDelaiReport()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getTermeDelaiReportConstitutionDelaisReport();
  }
  
  public void setTermeDelaiReport(Damj p_termeDelaiReport)
  {
    if ((m_termeDelaiReport == null) || (p_termeDelaiReport == null))
    {
      m_termeDelaiReport = p_termeDelaiReport;
      ((ConstitutionElementsAbstraitPC)getPC()).setTermeDelaiReportConstitutionDelaisReport(p_termeDelaiReport);
    }
    else if ((m_termeDelaiReport != null) && (p_termeDelaiReport != null) && (!p_termeDelaiReport.equals(m_termeDelaiReport)))
    {
      m_termeDelaiReport = p_termeDelaiReport;
      ((ConstitutionElementsAbstraitPC)getPC()).setTermeDelaiReportConstitutionDelaisReport(p_termeDelaiReport);
    }
  }
  
  protected int rawGetFranchiseCongesPayes()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getFranchiseCongesPayesConstitutionDelaisReport();
  }
  
  public int getFranchiseCongesPayes()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getFranchiseCongesPayesConstitutionDelaisReport();
  }
  
  public void setFranchiseCongesPayes(int p_franchiseCongesPayes)
  {
    ((ConstitutionElementsAbstraitPC)getPC()).setFranchiseCongesPayesConstitutionDelaisReport(p_franchiseCongesPayes);
  }
  
  protected Quantite rawGetQuantiteFranchiseCPMensuelle()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getQuantiteFranchiseCPMensuelle();
  }
  
  public Quantite getQuantiteFranchiseCPMensuelle()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getQuantiteFranchiseCPMensuelle();
  }
  
  public void setQuantiteFranchiseCPMensuelle(Quantite p_quantiteFranchiseCPMensuelle)
  {
    if ((m_quantiteFranchiseCPMensuelle == null) || (p_quantiteFranchiseCPMensuelle == null))
    {
      m_quantiteFranchiseCPMensuelle = p_quantiteFranchiseCPMensuelle;
      ((ConstitutionElementsAbstraitPC)getPC()).setQuantiteFranchiseCPMensuelle(p_quantiteFranchiseCPMensuelle);
    }
    else if ((m_quantiteFranchiseCPMensuelle != null) && (p_quantiteFranchiseCPMensuelle != null) && (!p_quantiteFranchiseCPMensuelle.equals(m_quantiteFranchiseCPMensuelle)))
    {
      m_quantiteFranchiseCPMensuelle = p_quantiteFranchiseCPMensuelle;
      ((ConstitutionElementsAbstraitPC)getPC()).setQuantiteFranchiseCPMensuelle(p_quantiteFranchiseCPMensuelle);
    }
  }
  
  protected Quantite rawGetQuantiteFranchiseSalaireMensuelle()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getQuantiteFranchiseSalaireMensuelle();
  }
  
  public Quantite getQuantiteFranchiseSalaireMensuelle()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getQuantiteFranchiseSalaireMensuelle();
  }
  
  public void setQuantiteFranchiseSalaireMensuelle(Quantite p_quantiteFranchiseSalaireMensuelle)
  {
    if ((m_quantiteFranchiseSalaireMensuelle == null) || (p_quantiteFranchiseSalaireMensuelle == null))
    {
      m_quantiteFranchiseSalaireMensuelle = p_quantiteFranchiseSalaireMensuelle;
      ((ConstitutionElementsAbstraitPC)getPC()).setQuantiteFranchiseSalaireMensuelle(p_quantiteFranchiseSalaireMensuelle);
    }
    else if ((m_quantiteFranchiseSalaireMensuelle != null) && (p_quantiteFranchiseSalaireMensuelle != null) && (!p_quantiteFranchiseSalaireMensuelle.equals(m_quantiteFranchiseSalaireMensuelle)))
    {
      m_quantiteFranchiseSalaireMensuelle = p_quantiteFranchiseSalaireMensuelle;
      ((ConstitutionElementsAbstraitPC)getPC()).setQuantiteFranchiseSalaireMensuelle(p_quantiteFranchiseSalaireMensuelle);
    }
  }
  
  public JustificationFranchiseCongesPayes getJustificationFranchiseCongesPayes()
  {
    if (m_justificationFranchiseCongesPayes == null)
    {
      DomPCSpec justificationFranchiseCongesPayesPC = ((ConstitutionElementsAbstraitPC)getPC()).getJustificationFranchiseCongesPayes();
      if (justificationFranchiseCongesPayesPC != null) {
        m_justificationFranchiseCongesPayes = ((JustificationFranchiseCongesPayes)justificationFranchiseCongesPayesPC.createOM());
      }
    }
    return m_justificationFranchiseCongesPayes;
  }
  
  public void setJustificationFranchiseCongesPayes(JustificationFranchiseCongesPayes p_justificationFranchiseCongesPayes)
  {
    if (p_justificationFranchiseCongesPayes == null)
    {
      ((ConstitutionElementsAbstraitPC)getPC()).setJustificationFranchiseCongesPayes(null);
      m_justificationFranchiseCongesPayes = p_justificationFranchiseCongesPayes;
    }
    else if (!p_justificationFranchiseCongesPayes.equals(m_justificationFranchiseCongesPayes))
    {
      ((ConstitutionElementsAbstraitPC)getPC()).setJustificationFranchiseCongesPayes(p_justificationFranchiseCongesPayes.getPC());
      m_justificationFranchiseCongesPayes = p_justificationFranchiseCongesPayes;
    }
  }
  
  protected Periode rawGetPeriodeApplicationDifferePrecedent()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getPeriodeApplicationDifferePrecedentConstitutionDelaisReport();
  }
  
  public Periode getPeriodeApplicationDifferePrecedent()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getPeriodeApplicationDifferePrecedentConstitutionDelaisReport();
  }
  
  public void setPeriodeApplicationDifferePrecedent(Periode p_periodeApplicationDifferePrecedent)
  {
    if ((m_periodeApplicationDifferePrecedent == null) || (p_periodeApplicationDifferePrecedent == null))
    {
      m_periodeApplicationDifferePrecedent = p_periodeApplicationDifferePrecedent;
      ((ConstitutionElementsAbstraitPC)getPC()).setPeriodeApplicationDifferePrecedentConstitutionDelaisReport(p_periodeApplicationDifferePrecedent);
    }
    else if ((m_periodeApplicationDifferePrecedent != null) && (p_periodeApplicationDifferePrecedent != null) && (!p_periodeApplicationDifferePrecedent.equals(m_periodeApplicationDifferePrecedent)))
    {
      m_periodeApplicationDifferePrecedent = p_periodeApplicationDifferePrecedent;
      ((ConstitutionElementsAbstraitPC)getPC()).setPeriodeApplicationDifferePrecedentConstitutionDelaisReport(p_periodeApplicationDifferePrecedent);
    }
  }
  
  private final Collection getCollectionModifiableCarence()
  {
    Iterator itCollectionPC;
    if (m_listeCarences == null)
    {
      m_listeCarences = new ArrayList();
      for (itCollectionPC = ((ConstitutionElementsAbstraitPC)getPC()).getCollectionCarence().iterator(); itCollectionPC.hasNext();)
      {
        DomPCSpec currentPC = (DomPCSpec)itCollectionPC.next();
        Object currentOM = currentPC.createOM();
        m_listeCarences.add(currentOM);
      }
    }
    return m_listeCarences;
  }
  
  public Collection getCollectionCarence()
  {
    return Collections.unmodifiableCollection(getCollectionModifiableCarence());
  }
  
  public List getListCarence()
  {
    return Collections.unmodifiableList((List)getCollectionModifiableCarence());
  }
  
  public void remplacerCollectionCarence(Collection p_collectionACopier)
  {
    clearCollectionCarence();
    for (Iterator i = p_collectionACopier.iterator(); i.hasNext();)
    {
      CarencePrefixeAFixer objet = (CarencePrefixeAFixer)i.next();
      ajouterCarence(objet);
    }
  }
  
  public void supprimerSousCollectionCarence(Collection p_collectionASupprimer)
  {
    for (Iterator i = p_collectionASupprimer.iterator(); i.hasNext();)
    {
      CarencePrefixeAFixer objet = (CarencePrefixeAFixer)i.next();
      supprimerCarence(objet);
    }
  }
  
  public void ajouterCarence(CarencePrefixeAFixer p_carencesConstitutionDelaisReport)
    throws NullPointerException
  {
    if (p_carencesConstitutionDelaisReport == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_carencesConstitutionDelaisReport ne devrait pas être nul.", p_carencesConstitutionDelaisReport);
    }
    getCollectionModifiableCarence().add(p_carencesConstitutionDelaisReport);
    ((ConstitutionElementsAbstraitPC)getPC()).ajouterCarence(p_carencesConstitutionDelaisReport.getPC());
  }
  
  public void supprimerCarence(CarencePrefixeAFixer p_carencesConstitutionDelaisReport)
    throws NullPointerException
  {
    if (p_carencesConstitutionDelaisReport == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_carencesConstitutionDelaisReport ne devrait pas être nul.", p_carencesConstitutionDelaisReport);
    }
    getCollectionModifiableCarence().remove(p_carencesConstitutionDelaisReport);
    ((ConstitutionElementsAbstraitPC)getPC()).supprimerCarence(p_carencesConstitutionDelaisReport.getPC());
  }
  
  public void recopierCollectionCarenceVers(ObjetMetierSpec p_copie)
  {
    ConstitutionDelaisReportGen copie = (ConstitutionDelaisReportGen)p_copie;
    Collection listeACopier = getCollectionCarence();
    for (Iterator i = listeACopier.iterator(); i.hasNext();)
    {
      ObjetMetierSpec objet = ((ObjetMetierSpec)i.next()).copie();
      copie.ajouterCarence((CarencePrefixeAFixer)objet);
    }
  }
  
  public void clearCollectionCarence()
  {
    getCollectionModifiableCarence().clear();
    ((ConstitutionElementsAbstraitPC)getPC()).getCollectionCarence().clear();
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    if (getJustificationDiffere() != null)
    {
      getJustificationDiffere().supprimerEnProfondeur(p_contexteSuppression);
      m_justificationDiffere = null;
    }
    Object justificationFranchiseCongesPayes = getJustificationFranchiseCongesPayes();
    if ((justificationFranchiseCongesPayes != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(justificationFranchiseCongesPayes))) {
      DomManager.supprimer(getJustificationFranchiseCongesPayes(), p_contexteSuppression);
    }
    for (Iterator iter = getCollectionCarence().iterator(); iter.hasNext();)
    {
      DomGenSpec item = (DomGenSpec)iter.next();
      if ((item != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(item))) {
        DomManager.supprimer(item, p_contexteSuppression);
      }
    }
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    if (getJustificationDiffere() != null)
    {
      getJustificationDiffere().initEnProfondeur();
      m_justificationDiffere = null;
    }
    if (getJustificationFranchiseCongesPayes() != null)
    {
      DomManager.supprimer(getJustificationFranchiseCongesPayes());
      setJustificationFranchiseCongesPayes(null);
    }
    setNbJoursPMCNonIndemn(0);
    setDebutPMCNonIndemn(null);
    setTermePMCNonIndemn(null);
    setNbJoursPMCIndemn(0);
    setDebutPMCIndemn(null);
    setTermePMCIndemn(null);
    setNbJoursCarenceStandard(0);
    setDebutCarenceStandard(null);
    setTermeCarenceStandard(null);
    setNbJoursCarenceISLR(0);
    setDebutCarenceISLR(null);
    setTermeCarenceISLR(null);
    setNbJoursDelaiReport(0);
    setDebutDelaiReport(null);
    setTermeDelaiReport(null);
    setFranchiseCongesPayes(0);
    setQuantiteFranchiseCPMensuelle(null);
    setQuantiteFranchiseSalaireMensuelle(null);
    setPeriodeApplicationDifferePrecedent(null);
    for (Iterator iter = getCollectionCarence().iterator(); iter.hasNext();)
    {
      DomGenSpec item = (DomGenSpec)iter.next();
      if (item != null) {
        DomManager.supprimer(item);
      }
    }
    clearCollectionCarence();
  }
  
  public JustificationDiffere getJustificationDiffere()
  {
    if (m_justificationDiffere == null) {
      m_justificationDiffere = new JustificationDiffere(getPC());
    }
    return m_justificationDiffere;
  }
  
  public JustificationDiffere createJustificationDiffere()
  {
    if (m_justificationDiffere == null) {
      m_justificationDiffere = new JustificationDiffere(getPC());
    }
    try
    {
      m_justificationDiffere.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
    return m_justificationDiffere;
  }
  
  public void removeJustificationDiffere()
  {
    try
    {
      m_justificationDiffere.initEnProfondeur();
    }
    catch (TechniqueException e)
    {
      throw new ApplicativeRuntimeException("HG_PR_CALI_L_ERR_GENERIQUE", "Erreur inconnue dans l'exécution de l'application", e);
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConstitutionDelaisReportGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */