package fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConditionsAttributionAdmission;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConditionsAttributionReprise;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConstitutionElementsAdmission;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConstitutionElementsReprise;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.pc.DossierExamenPC;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoEvenementDebutCREM;

public abstract class DossierExamenGen
  extends ObjetChronoEvenementDebutCREM
  implements DomGenSpec
{
  private DossierAffectationSpec m_dossierAffecte;
  private ConstitutionElementsAdmission m_constitutionElementsAdmission;
  private ConstitutionElementsReprise m_constitutionElementsReprise;
  private ConditionsAttributionReprise m_conditionAttributionReprise;
  private ConditionsAttributionAdmission m_conditionAttributionAdmission;
  
  public DossierExamenGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public DossierExamenGen() {}
  
  public DossierExamenGen(Damj p_dateEvenement)
  {
    super(p_dateEvenement);
  }
  
  protected abstract DomPCSpec createPC();
  
  protected int rawGetMotifRejetNotifie()
  {
    return ((DossierExamenPC)getPC()).getMotifRejetNotifie();
  }
  
  public int getMotifRejetNotifie()
  {
    return ((DossierExamenPC)getPC()).getMotifRejetNotifie();
  }
  
  public void setMotifRejetNotifie(int p_motifRejetNotifie)
  {
    ((DossierExamenPC)getPC()).setMotifRejetNotifie(p_motifRejetNotifie);
  }
  
  public DossierAffectationSpec getDossierAffecte()
  {
    if (m_dossierAffecte == null)
    {
      DomPCSpec dossierAffectePC = ((DossierExamenPC)getPC()).getDossierAffecte();
      if (dossierAffectePC != null) {
        m_dossierAffecte = ((DossierAffectationSpec)dossierAffectePC.createOM());
      }
    }
    return m_dossierAffecte;
  }
  
  public void setDossierAffecte(DossierAffectationSpec p_dossierAffecte)
  {
    if (p_dossierAffecte == null)
    {
      ((DossierExamenPC)getPC()).setDossierAffecte(null);
      m_dossierAffecte = p_dossierAffecte;
    }
    else if (!p_dossierAffecte.equals(m_dossierAffecte))
    {
      ((DossierExamenPC)getPC()).setDossierAffecte(((DomGenSpec)p_dossierAffecte).getPC());
      m_dossierAffecte = p_dossierAffecte;
    }
  }
  
  public ConstitutionElementsAdmission getConstitutionElementsAdmission()
  {
    if (m_constitutionElementsAdmission == null)
    {
      DomPCSpec constitutionElementsAdmissionPC = ((DossierExamenPC)getPC()).getConstitutionElementsAdmission();
      if (constitutionElementsAdmissionPC != null) {
        m_constitutionElementsAdmission = ((ConstitutionElementsAdmission)constitutionElementsAdmissionPC.createOM());
      }
    }
    return m_constitutionElementsAdmission;
  }
  
  public void setConstitutionElementsAdmission(ConstitutionElementsAdmission p_constitutionElementsAdmission)
  {
    if (p_constitutionElementsAdmission == null)
    {
      ((DossierExamenPC)getPC()).setConstitutionElementsAdmission(null);
      m_constitutionElementsAdmission = p_constitutionElementsAdmission;
    }
    else if (!p_constitutionElementsAdmission.equals(m_constitutionElementsAdmission))
    {
      ((DossierExamenPC)getPC()).setConstitutionElementsAdmission(p_constitutionElementsAdmission.getPC());
      m_constitutionElementsAdmission = p_constitutionElementsAdmission;
    }
  }
  
  public ConstitutionElementsReprise getConstitutionElementsReprise()
  {
    if (m_constitutionElementsReprise == null)
    {
      DomPCSpec constitutionElementsReprisePC = ((DossierExamenPC)getPC()).getConstitutionElementsReprise();
      if (constitutionElementsReprisePC != null) {
        m_constitutionElementsReprise = ((ConstitutionElementsReprise)constitutionElementsReprisePC.createOM());
      }
    }
    return m_constitutionElementsReprise;
  }
  
  public void setConstitutionElementsReprise(ConstitutionElementsReprise p_constitutionElementsReprise)
  {
    if (p_constitutionElementsReprise == null)
    {
      ((DossierExamenPC)getPC()).setConstitutionElementsReprise(null);
      m_constitutionElementsReprise = p_constitutionElementsReprise;
    }
    else if (!p_constitutionElementsReprise.equals(m_constitutionElementsReprise))
    {
      ((DossierExamenPC)getPC()).setConstitutionElementsReprise(p_constitutionElementsReprise.getPC());
      m_constitutionElementsReprise = p_constitutionElementsReprise;
    }
  }
  
  public ConditionsAttributionReprise getConditionAttributionReprise()
  {
    if (m_conditionAttributionReprise == null)
    {
      DomPCSpec conditionAttributionReprisePC = ((DossierExamenPC)getPC()).getConditionAttributionReprise();
      if (conditionAttributionReprisePC != null) {
        m_conditionAttributionReprise = ((ConditionsAttributionReprise)conditionAttributionReprisePC.createOM());
      }
    }
    return m_conditionAttributionReprise;
  }
  
  public void setConditionAttributionReprise(ConditionsAttributionReprise p_conditionAttributionReprise)
  {
    if (p_conditionAttributionReprise == null)
    {
      ((DossierExamenPC)getPC()).setConditionAttributionReprise(null);
      m_conditionAttributionReprise = p_conditionAttributionReprise;
    }
    else if (!p_conditionAttributionReprise.equals(m_conditionAttributionReprise))
    {
      ((DossierExamenPC)getPC()).setConditionAttributionReprise(p_conditionAttributionReprise.getPC());
      m_conditionAttributionReprise = p_conditionAttributionReprise;
    }
  }
  
  public ConditionsAttributionAdmission getConditionAttributionAdmission()
  {
    if (m_conditionAttributionAdmission == null)
    {
      DomPCSpec conditionAttributionAdmissionPC = ((DossierExamenPC)getPC()).getConditionAttributionAdmission();
      if (conditionAttributionAdmissionPC != null) {
        m_conditionAttributionAdmission = ((ConditionsAttributionAdmission)conditionAttributionAdmissionPC.createOM());
      }
    }
    return m_conditionAttributionAdmission;
  }
  
  public void setConditionAttributionAdmission(ConditionsAttributionAdmission p_conditionAttributionAdmission)
  {
    if (p_conditionAttributionAdmission == null)
    {
      ((DossierExamenPC)getPC()).setConditionAttributionAdmission(null);
      m_conditionAttributionAdmission = p_conditionAttributionAdmission;
    }
    else if (!p_conditionAttributionAdmission.equals(m_conditionAttributionAdmission))
    {
      ((DossierExamenPC)getPC()).setConditionAttributionAdmission(p_conditionAttributionAdmission.getPC());
      m_conditionAttributionAdmission = p_conditionAttributionAdmission;
    }
  }
  
  protected int rawGetContexteDdeExpresse()
  {
    return ((DossierExamenPC)getPC()).getContexteDdeExpresse();
  }
  
  public int getContexteDdeExpresse()
  {
    return ((DossierExamenPC)getPC()).getContexteDdeExpresse();
  }
  
  public void setContexteDdeExpresse(int p_contexteDdeExpresse)
  {
    ((DossierExamenPC)getPC()).setContexteDdeExpresse(p_contexteDdeExpresse);
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
    
    Object constitutionElementsAdmission = getConstitutionElementsAdmission();
    if ((constitutionElementsAdmission != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(constitutionElementsAdmission))) {
      DomManager.supprimer(getConstitutionElementsAdmission(), p_contexteSuppression);
    }
    Object constitutionElementsReprise = getConstitutionElementsReprise();
    if ((constitutionElementsReprise != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(constitutionElementsReprise))) {
      DomManager.supprimer(getConstitutionElementsReprise(), p_contexteSuppression);
    }
    Object conditionAttributionReprise = getConditionAttributionReprise();
    if ((conditionAttributionReprise != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(conditionAttributionReprise))) {
      DomManager.supprimer(getConditionAttributionReprise(), p_contexteSuppression);
    }
    Object conditionAttributionAdmission = getConditionAttributionAdmission();
    if ((conditionAttributionAdmission != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(conditionAttributionAdmission))) {
      DomManager.supprimer(getConditionAttributionAdmission(), p_contexteSuppression);
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     DossierExamenGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */