package fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.MoisCivil;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.pc.JustificationFranchiseCongesPayesPC;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Periode;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public abstract class JustificationFranchiseCongesPayesGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_justificationFranchiseCongesPayesPC;
  private Periode m_periodeCalculFranchiseCp;
  private String m_formule;
  public Collection m_moisCivil;
  
  public JustificationFranchiseCongesPayesGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public JustificationFranchiseCongesPayesGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new JustificationFranchiseCongesPayesPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_justificationFranchiseCongesPayesPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_justificationFranchiseCongesPayesPC)
  {
    m_justificationFranchiseCongesPayesPC = p_justificationFranchiseCongesPayesPC;
  }
  
  protected Periode rawGetPeriodeCalculFranchiseCp()
  {
    return ((JustificationFranchiseCongesPayesPC)getPC()).getPeriodeCalculFranchiseCp();
  }
  
  public Periode getPeriodeCalculFranchiseCp()
  {
    return ((JustificationFranchiseCongesPayesPC)getPC()).getPeriodeCalculFranchiseCp();
  }
  
  public void setPeriodeCalculFranchiseCp(Periode p_periodeCalculFranchiseCp)
  {
    if ((m_periodeCalculFranchiseCp == null) || (p_periodeCalculFranchiseCp == null))
    {
      m_periodeCalculFranchiseCp = p_periodeCalculFranchiseCp;
      ((JustificationFranchiseCongesPayesPC)getPC()).setPeriodeCalculFranchiseCp(p_periodeCalculFranchiseCp);
    }
    else if ((m_periodeCalculFranchiseCp != null) && (p_periodeCalculFranchiseCp != null) && (!p_periodeCalculFranchiseCp.equals(m_periodeCalculFranchiseCp)))
    {
      m_periodeCalculFranchiseCp = p_periodeCalculFranchiseCp;
      ((JustificationFranchiseCongesPayesPC)getPC()).setPeriodeCalculFranchiseCp(p_periodeCalculFranchiseCp);
    }
  }
  
  protected int rawGetNbJoursTravaillesRetenus()
  {
    return ((JustificationFranchiseCongesPayesPC)getPC()).getNbJoursTravaillesRetenus();
  }
  
  public int getNbJoursTravaillesRetenus()
  {
    return ((JustificationFranchiseCongesPayesPC)getPC()).getNbJoursTravaillesRetenus();
  }
  
  public void setNbJoursTravaillesRetenus(int p_nbJoursTravaillesRetenus)
  {
    ((JustificationFranchiseCongesPayesPC)getPC()).setNbJoursTravaillesRetenus(p_nbJoursTravaillesRetenus);
  }
  
  protected String rawGetFormule()
  {
    return ((JustificationFranchiseCongesPayesPC)getPC()).getFormule();
  }
  
  public String getFormule()
  {
    return ((JustificationFranchiseCongesPayesPC)getPC()).getFormule();
  }
  
  public void setFormule(String p_formule)
  {
    if ((m_formule == null) || (p_formule == null))
    {
      m_formule = p_formule;
      ((JustificationFranchiseCongesPayesPC)getPC()).setFormule(p_formule);
    }
    else if ((m_formule != null) && (p_formule != null) && (!p_formule.equals(m_formule)))
    {
      m_formule = p_formule;
      ((JustificationFranchiseCongesPayesPC)getPC()).setFormule(p_formule);
    }
  }
  
  private final Collection getCollectionModifiableMoisCivil()
  {
    Iterator itCollectionPC;
    if (m_moisCivil == null)
    {
      m_moisCivil = new ArrayList();
      for (itCollectionPC = ((JustificationFranchiseCongesPayesPC)getPC()).getCollectionMoisCivil().iterator(); itCollectionPC.hasNext();)
      {
        DomPCSpec currentPC = (DomPCSpec)itCollectionPC.next();
        Object currentOM = currentPC.createOM();
        m_moisCivil.add(currentOM);
      }
    }
    return m_moisCivil;
  }
  
  public Collection getCollectionMoisCivil()
  {
    return Collections.unmodifiableCollection(getCollectionModifiableMoisCivil());
  }
  
  public List getListMoisCivil()
  {
    return Collections.unmodifiableList((List)getCollectionModifiableMoisCivil());
  }
  
  public void remplacerCollectionMoisCivil(Collection p_collectionACopier)
  {
    clearCollectionMoisCivil();
    for (Iterator i = p_collectionACopier.iterator(); i.hasNext();)
    {
      MoisCivil objet = (MoisCivil)i.next();
      ajouterMoisCivil(objet);
    }
  }
  
  public void supprimerSousCollectionMoisCivil(Collection p_collectionASupprimer)
  {
    for (Iterator i = p_collectionASupprimer.iterator(); i.hasNext();)
    {
      MoisCivil objet = (MoisCivil)i.next();
      supprimerMoisCivil(objet);
    }
  }
  
  public void ajouterMoisCivil(MoisCivil p_moisCivil)
    throws NullPointerException
  {
    if (p_moisCivil == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_moisCivil ne devrait pas être nul.", p_moisCivil);
    }
    getCollectionModifiableMoisCivil().add(p_moisCivil);
    ((JustificationFranchiseCongesPayesPC)getPC()).ajouterMoisCivil(p_moisCivil.getPC());
  }
  
  public void supprimerMoisCivil(MoisCivil p_moisCivil)
    throws NullPointerException
  {
    if (p_moisCivil == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_moisCivil ne devrait pas être nul.", p_moisCivil);
    }
    getCollectionModifiableMoisCivil().remove(p_moisCivil);
    ((JustificationFranchiseCongesPayesPC)getPC()).supprimerMoisCivil(p_moisCivil.getPC());
  }
  
  public void recopierCollectionMoisCivilVers(ObjetMetierSpec p_copie)
  {
    JustificationFranchiseCongesPayesGen copie = (JustificationFranchiseCongesPayesGen)p_copie;
    Collection listeACopier = getCollectionMoisCivil();
    for (Iterator i = listeACopier.iterator(); i.hasNext();)
    {
      ObjetMetierSpec objet = ((ObjetMetierSpec)i.next()).copie();
      copie.ajouterMoisCivil((MoisCivil)objet);
    }
  }
  
  public void clearCollectionMoisCivil()
  {
    getCollectionModifiableMoisCivil().clear();
    ((JustificationFranchiseCongesPayesPC)getPC()).getCollectionMoisCivil().clear();
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    for (Iterator iter = getCollectionMoisCivil().iterator(); iter.hasNext();)
    {
      DomGenSpec item = (DomGenSpec)iter.next();
      if ((item != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(item))) {
        DomManager.supprimer(item, p_contexteSuppression);
      }
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     JustificationFranchiseCongesPayesGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */