package fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.pc.JustificationReductionSalairePeriodeActiviteSurMoisPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.ObjetChronoPeriodeCREM;
import java.math.BigDecimal;

public abstract class JustificationReductionSalairePeriodeActiviteSurMoisGen
  extends ObjetChronoPeriodeCREM
  implements DomGenSpec
{
  private String m_raisonSociale;
  private BigDecimal m_nombreHeures = new BigDecimal("0");
  private BigDecimal m_nombreCachetsGroupes = new BigDecimal("0");
  private BigDecimal m_nombreCachetsIsoles = new BigDecimal("0");
  private String m_siren;
  private BigDecimal m_heuresMono = new BigDecimal("0");
  private BigDecimal m_plafondMono;
  private BigDecimal m_coefEcretementHeures;
  private String m_contexteEcretement;
  
  public JustificationReductionSalairePeriodeActiviteSurMoisGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public JustificationReductionSalairePeriodeActiviteSurMoisGen() {}
  
  protected DomPCSpec createPC()
  {
    return new JustificationReductionSalairePeriodeActiviteSurMoisPC();
  }
  
  protected String rawGetRaisonSociale()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getRaisonSociale();
  }
  
  public String getRaisonSociale()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getRaisonSociale();
  }
  
  public void setRaisonSociale(String p_raisonSociale)
  {
    if ((m_raisonSociale == null) || (p_raisonSociale == null))
    {
      m_raisonSociale = p_raisonSociale;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setRaisonSociale(p_raisonSociale);
    }
    else if ((m_raisonSociale != null) && (p_raisonSociale != null) && (!p_raisonSociale.equals(m_raisonSociale)))
    {
      m_raisonSociale = p_raisonSociale;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setRaisonSociale(p_raisonSociale);
    }
  }
  
  protected BigDecimal rawGetNombreHeures()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getNombreHeures();
  }
  
  public BigDecimal getNombreHeures()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getNombreHeures();
  }
  
  public void setNombreHeures(BigDecimal p_nombreHeures)
  {
    if ((m_nombreHeures == null) || (p_nombreHeures == null))
    {
      m_nombreHeures = p_nombreHeures;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setNombreHeures(p_nombreHeures);
    }
    else if ((m_nombreHeures != null) && (p_nombreHeures != null) && (!p_nombreHeures.equals(m_nombreHeures)))
    {
      m_nombreHeures = p_nombreHeures;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setNombreHeures(p_nombreHeures);
    }
  }
  
  protected BigDecimal rawGetNombreCachetsGroupes()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getNombreCachetsGroupes();
  }
  
  public BigDecimal getNombreCachetsGroupes()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getNombreCachetsGroupes();
  }
  
  public void setNombreCachetsGroupes(BigDecimal p_nombreCachetsGroupes)
  {
    if ((m_nombreCachetsGroupes == null) || (p_nombreCachetsGroupes == null))
    {
      m_nombreCachetsGroupes = p_nombreCachetsGroupes;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setNombreCachetsGroupes(p_nombreCachetsGroupes);
    }
    else if ((m_nombreCachetsGroupes != null) && (p_nombreCachetsGroupes != null) && (!p_nombreCachetsGroupes.equals(m_nombreCachetsGroupes)))
    {
      m_nombreCachetsGroupes = p_nombreCachetsGroupes;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setNombreCachetsGroupes(p_nombreCachetsGroupes);
    }
  }
  
  protected BigDecimal rawGetNombreCachetsIsoles()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getNombreCachetsIsoles();
  }
  
  public BigDecimal getNombreCachetsIsoles()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getNombreCachetsIsoles();
  }
  
  public void setNombreCachetsIsoles(BigDecimal p_nombreCachetsIsoles)
  {
    if ((m_nombreCachetsIsoles == null) || (p_nombreCachetsIsoles == null))
    {
      m_nombreCachetsIsoles = p_nombreCachetsIsoles;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setNombreCachetsIsoles(p_nombreCachetsIsoles);
    }
    else if ((m_nombreCachetsIsoles != null) && (p_nombreCachetsIsoles != null) && (!p_nombreCachetsIsoles.equals(m_nombreCachetsIsoles)))
    {
      m_nombreCachetsIsoles = p_nombreCachetsIsoles;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setNombreCachetsIsoles(p_nombreCachetsIsoles);
    }
  }
  
  protected String rawGetSiren()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getSiren();
  }
  
  public String getSiren()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getSiren();
  }
  
  public void setSiren(String p_siren)
  {
    if ((m_siren == null) || (p_siren == null))
    {
      m_siren = p_siren;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setSiren(p_siren);
    }
    else if ((m_siren != null) && (p_siren != null) && (!p_siren.equals(m_siren)))
    {
      m_siren = p_siren;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setSiren(p_siren);
    }
  }
  
  protected BigDecimal rawGetHeuresMono()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getHeuresMono();
  }
  
  public BigDecimal getHeuresMono()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getHeuresMono();
  }
  
  public void setHeuresMono(BigDecimal p_heuresMono)
  {
    if ((m_heuresMono == null) || (p_heuresMono == null))
    {
      m_heuresMono = p_heuresMono;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setHeuresMono(p_heuresMono);
    }
    else if ((m_heuresMono != null) && (p_heuresMono != null) && (!p_heuresMono.equals(m_heuresMono)))
    {
      m_heuresMono = p_heuresMono;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setHeuresMono(p_heuresMono);
    }
  }
  
  protected BigDecimal rawGetPlafondMono()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getPlafondMono();
  }
  
  public BigDecimal getPlafondMono()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getPlafondMono();
  }
  
  public void setPlafondMono(BigDecimal p_plafondMono)
  {
    if ((m_plafondMono == null) || (p_plafondMono == null))
    {
      m_plafondMono = p_plafondMono;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setPlafondMono(p_plafondMono);
    }
    else if ((m_plafondMono != null) && (p_plafondMono != null) && (!p_plafondMono.equals(m_plafondMono)))
    {
      m_plafondMono = p_plafondMono;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setPlafondMono(p_plafondMono);
    }
  }
  
  protected BigDecimal rawGetCoefEcretementHeures()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getCoefEcretementHeures();
  }
  
  public BigDecimal getCoefEcretementHeures()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getCoefEcretementHeures();
  }
  
  public void setCoefEcretementHeures(BigDecimal p_coefEcretementHeures)
  {
    if ((m_coefEcretementHeures == null) || (p_coefEcretementHeures == null))
    {
      m_coefEcretementHeures = p_coefEcretementHeures;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setCoefEcretementHeures(p_coefEcretementHeures);
    }
    else if ((m_coefEcretementHeures != null) && (p_coefEcretementHeures != null) && (!p_coefEcretementHeures.equals(m_coefEcretementHeures)))
    {
      m_coefEcretementHeures = p_coefEcretementHeures;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setCoefEcretementHeures(p_coefEcretementHeures);
    }
  }
  
  protected String rawGetContexteEcretement()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getContexteEcretement();
  }
  
  public String getContexteEcretement()
  {
    return ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).getContexteEcretement();
  }
  
  public void setContexteEcretement(String p_contexteEcretement)
  {
    if ((m_contexteEcretement == null) || (p_contexteEcretement == null))
    {
      m_contexteEcretement = p_contexteEcretement;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setContexteEcretement(p_contexteEcretement);
    }
    else if ((m_contexteEcretement != null) && (p_contexteEcretement != null) && (!p_contexteEcretement.equals(m_contexteEcretement)))
    {
      m_contexteEcretement = p_contexteEcretement;
      ((JustificationReductionSalairePeriodeActiviteSurMoisPC)getPC()).setContexteEcretement(p_contexteEcretement);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     JustificationReductionSalairePeriodeActiviteSurMoisGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */