package fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.JustificationSRPeriodeRemuneration;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.pc.JustificationSRPeriodeActivitePC;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.temps.ObjetChronoPeriodeCREM;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public abstract class JustificationSRPeriodeActiviteGen
  extends ObjetChronoPeriodeCREM
  implements DomGenSpec
{
  private String m_raisonSociale;
  private String m_reglement;
  private QuantiteEuro m_montantPlafond;
  private QuantiteEuro m_montantSalairePlafonne;
  private QuantiteEuro m_montantSalaireNonPlafonne;
  private Collection m_listePeriodeRemuneration;
  
  public JustificationSRPeriodeActiviteGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public JustificationSRPeriodeActiviteGen() {}
  
  protected DomPCSpec createPC()
  {
    return new JustificationSRPeriodeActivitePC();
  }
  
  protected String rawGetRaisonSociale()
  {
    return ((JustificationSRPeriodeActivitePC)getPC()).getRaisonSociale();
  }
  
  public String getRaisonSociale()
  {
    return ((JustificationSRPeriodeActivitePC)getPC()).getRaisonSociale();
  }
  
  public void setRaisonSociale(String p_raisonSociale)
  {
    if ((m_raisonSociale == null) || (p_raisonSociale == null))
    {
      m_raisonSociale = p_raisonSociale;
      ((JustificationSRPeriodeActivitePC)getPC()).setRaisonSociale(p_raisonSociale);
    }
    else if ((m_raisonSociale != null) && (p_raisonSociale != null) && (!p_raisonSociale.equals(m_raisonSociale)))
    {
      m_raisonSociale = p_raisonSociale;
      ((JustificationSRPeriodeActivitePC)getPC()).setRaisonSociale(p_raisonSociale);
    }
  }
  
  protected String rawGetReglement()
  {
    return ((JustificationSRPeriodeActivitePC)getPC()).getReglement();
  }
  
  public String getReglement()
  {
    return ((JustificationSRPeriodeActivitePC)getPC()).getReglement();
  }
  
  public void setReglement(String p_reglement)
  {
    if ((m_reglement == null) || (p_reglement == null))
    {
      m_reglement = p_reglement;
      ((JustificationSRPeriodeActivitePC)getPC()).setReglement(p_reglement);
    }
    else if ((m_reglement != null) && (p_reglement != null) && (!p_reglement.equals(m_reglement)))
    {
      m_reglement = p_reglement;
      ((JustificationSRPeriodeActivitePC)getPC()).setReglement(p_reglement);
    }
  }
  
  protected QuantiteEuro rawGetMontantPlafond()
  {
    return ((JustificationSRPeriodeActivitePC)getPC()).getMontantPlafond();
  }
  
  public QuantiteEuro getMontantPlafond()
  {
    return ((JustificationSRPeriodeActivitePC)getPC()).getMontantPlafond();
  }
  
  public void setMontantPlafond(QuantiteEuro p_montantPlafond)
  {
    if ((m_montantPlafond == null) || (p_montantPlafond == null))
    {
      m_montantPlafond = p_montantPlafond;
      ((JustificationSRPeriodeActivitePC)getPC()).setMontantPlafond(p_montantPlafond);
    }
    else if ((m_montantPlafond != null) && (p_montantPlafond != null) && (!p_montantPlafond.equals(m_montantPlafond)))
    {
      m_montantPlafond = p_montantPlafond;
      ((JustificationSRPeriodeActivitePC)getPC()).setMontantPlafond(p_montantPlafond);
    }
  }
  
  protected QuantiteEuro rawGetMontantSalairePlafonne()
  {
    return ((JustificationSRPeriodeActivitePC)getPC()).getMontantSalairePlafonne();
  }
  
  public QuantiteEuro getMontantSalairePlafonne()
  {
    return ((JustificationSRPeriodeActivitePC)getPC()).getMontantSalairePlafonne();
  }
  
  public void setMontantSalairePlafonne(QuantiteEuro p_montantSalairePlafonne)
  {
    if ((m_montantSalairePlafonne == null) || (p_montantSalairePlafonne == null))
    {
      m_montantSalairePlafonne = p_montantSalairePlafonne;
      ((JustificationSRPeriodeActivitePC)getPC()).setMontantSalairePlafonne(p_montantSalairePlafonne);
    }
    else if ((m_montantSalairePlafonne != null) && (p_montantSalairePlafonne != null) && (!p_montantSalairePlafonne.equals(m_montantSalairePlafonne)))
    {
      m_montantSalairePlafonne = p_montantSalairePlafonne;
      ((JustificationSRPeriodeActivitePC)getPC()).setMontantSalairePlafonne(p_montantSalairePlafonne);
    }
  }
  
  protected QuantiteEuro rawGetMontantSalaireNonPlafonne()
  {
    return ((JustificationSRPeriodeActivitePC)getPC()).getMontantSalaireNonPlafonne();
  }
  
  public QuantiteEuro getMontantSalaireNonPlafonne()
  {
    return ((JustificationSRPeriodeActivitePC)getPC()).getMontantSalaireNonPlafonne();
  }
  
  public void setMontantSalaireNonPlafonne(QuantiteEuro p_montantSalaireNonPlafonne)
  {
    if ((m_montantSalaireNonPlafonne == null) || (p_montantSalaireNonPlafonne == null))
    {
      m_montantSalaireNonPlafonne = p_montantSalaireNonPlafonne;
      ((JustificationSRPeriodeActivitePC)getPC()).setMontantSalaireNonPlafonne(p_montantSalaireNonPlafonne);
    }
    else if ((m_montantSalaireNonPlafonne != null) && (p_montantSalaireNonPlafonne != null) && (!p_montantSalaireNonPlafonne.equals(m_montantSalaireNonPlafonne)))
    {
      m_montantSalaireNonPlafonne = p_montantSalaireNonPlafonne;
      ((JustificationSRPeriodeActivitePC)getPC()).setMontantSalaireNonPlafonne(p_montantSalaireNonPlafonne);
    }
  }
  
  private final Collection getCollectionModifiablePeriodeRemuneration()
  {
    Iterator itCollectionPC;
    if (m_listePeriodeRemuneration == null)
    {
      m_listePeriodeRemuneration = new ArrayList();
      for (itCollectionPC = ((JustificationSRPeriodeActivitePC)getPC()).getCollectionPeriodeRemuneration().iterator(); itCollectionPC.hasNext();)
      {
        DomPCSpec currentPC = (DomPCSpec)itCollectionPC.next();
        Object currentOM = currentPC.createOM();
        m_listePeriodeRemuneration.add(currentOM);
      }
    }
    return m_listePeriodeRemuneration;
  }
  
  public Collection getCollectionPeriodeRemuneration()
  {
    return Collections.unmodifiableCollection(getCollectionModifiablePeriodeRemuneration());
  }
  
  public List getListPeriodeRemuneration()
  {
    return Collections.unmodifiableList((List)getCollectionModifiablePeriodeRemuneration());
  }
  
  public void remplacerCollectionPeriodeRemuneration(Collection p_collectionACopier)
  {
    clearCollectionPeriodeRemuneration();
    for (Iterator i = p_collectionACopier.iterator(); i.hasNext();)
    {
      JustificationSRPeriodeRemuneration objet = (JustificationSRPeriodeRemuneration)i.next();
      ajouterPeriodeRemuneration(objet);
    }
  }
  
  public void supprimerSousCollectionPeriodeRemuneration(Collection p_collectionASupprimer)
  {
    for (Iterator i = p_collectionASupprimer.iterator(); i.hasNext();)
    {
      JustificationSRPeriodeRemuneration objet = (JustificationSRPeriodeRemuneration)i.next();
      supprimerPeriodeRemuneration(objet);
    }
  }
  
  public void ajouterPeriodeRemuneration(JustificationSRPeriodeRemuneration p_periodeRemuneration)
    throws NullPointerException
  {
    if (p_periodeRemuneration == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodeRemuneration ne devrait pas être nul.", p_periodeRemuneration);
    }
    getCollectionModifiablePeriodeRemuneration().add(p_periodeRemuneration);
    ((JustificationSRPeriodeActivitePC)getPC()).ajouterPeriodeRemuneration(p_periodeRemuneration.getPC());
  }
  
  public void supprimerPeriodeRemuneration(JustificationSRPeriodeRemuneration p_periodeRemuneration)
    throws NullPointerException
  {
    if (p_periodeRemuneration == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodeRemuneration ne devrait pas être nul.", p_periodeRemuneration);
    }
    getCollectionModifiablePeriodeRemuneration().remove(p_periodeRemuneration);
    ((JustificationSRPeriodeActivitePC)getPC()).supprimerPeriodeRemuneration(p_periodeRemuneration.getPC());
  }
  
  public void recopierCollectionPeriodeRemunerationVers(ObjetMetierSpec p_copie)
  {
    JustificationSRPeriodeActiviteGen copie = (JustificationSRPeriodeActiviteGen)p_copie;
    Collection listeACopier = getCollectionPeriodeRemuneration();
    for (Iterator i = listeACopier.iterator(); i.hasNext();)
    {
      ObjetMetierSpec objet = ((ObjetMetierSpec)i.next()).copie();
      copie.ajouterPeriodeRemuneration((JustificationSRPeriodeRemuneration)objet);
    }
  }
  
  public void clearCollectionPeriodeRemuneration()
  {
    getCollectionModifiablePeriodeRemuneration().clear();
    ((JustificationSRPeriodeActivitePC)getPC()).getCollectionPeriodeRemuneration().clear();
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
    for (Iterator iter = getCollectionPeriodeRemuneration().iterator(); iter.hasNext();)
    {
      DomGenSpec item = (DomGenSpec)iter.next();
      if ((item != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(item))) {
        DomManager.supprimer(item, p_contexteSuppression);
      }
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     JustificationSRPeriodeActiviteGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */