package fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.PeriodeElementaireEmployeur;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.pc.PeriodeElementaireAffiliationPC;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public abstract class PeriodeElementaireAffiliationGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_periodeElementaireAffiliationPC;
  private Periode m_mois;
  private Quantite m_affiliationRetenue;
  private BigDecimal m_heuresA8;
  private BigDecimal m_heuresA10;
  private BigDecimal m_cachetIsoleA8;
  private BigDecimal m_cachetGroupeA8;
  private BigDecimal m_cachetIsoleA10;
  private BigDecimal m_cachetGroupeA10;
  private BigDecimal m_heuresComplementairesA10;
  private BigDecimal m_montantPlafondCachets;
  private BigDecimal m_montantPlafondHeures;
  private BigDecimal m_quantiteHeureExercee;
  private BigDecimal m_quantiteCachetGroupeIsoleHeureExercee;
  private BigDecimal m_heuresApresPlafonnementMonoEmployeur;
  private BigDecimal m_heuresApresPlafonnementMultiEmployeur;
  public Collection m_listePeriodesElementairesEmployeur;
  
  public PeriodeElementaireAffiliationGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public PeriodeElementaireAffiliationGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new PeriodeElementaireAffiliationPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_periodeElementaireAffiliationPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_periodeElementaireAffiliationPC)
  {
    m_periodeElementaireAffiliationPC = p_periodeElementaireAffiliationPC;
  }
  
  protected Periode rawGetMois()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getMois();
  }
  
  public Periode getMois()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getMois();
  }
  
  public void setMois(Periode p_mois)
  {
    if ((m_mois == null) || (p_mois == null))
    {
      m_mois = p_mois;
      ((PeriodeElementaireAffiliationPC)getPC()).setMois(p_mois);
    }
    else if ((m_mois != null) && (p_mois != null) && (!p_mois.equals(m_mois)))
    {
      m_mois = p_mois;
      ((PeriodeElementaireAffiliationPC)getPC()).setMois(p_mois);
    }
  }
  
  protected Quantite rawGetAffiliationRetenue()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getAffiliationRetenue();
  }
  
  public Quantite getAffiliationRetenue()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getAffiliationRetenue();
  }
  
  public void setAffiliationRetenue(Quantite p_affiliationRetenue)
  {
    if ((m_affiliationRetenue == null) || (p_affiliationRetenue == null))
    {
      m_affiliationRetenue = p_affiliationRetenue;
      ((PeriodeElementaireAffiliationPC)getPC()).setAffiliationRetenue(p_affiliationRetenue);
    }
    else if ((m_affiliationRetenue != null) && (p_affiliationRetenue != null) && (!p_affiliationRetenue.equals(m_affiliationRetenue)))
    {
      m_affiliationRetenue = p_affiliationRetenue;
      ((PeriodeElementaireAffiliationPC)getPC()).setAffiliationRetenue(p_affiliationRetenue);
    }
  }
  
  protected BigDecimal rawGetHeuresA8()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getHeuresA8();
  }
  
  public BigDecimal getHeuresA8()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getHeuresA8();
  }
  
  public void setHeuresA8(BigDecimal p_heuresA8)
  {
    if ((m_heuresA8 == null) || (p_heuresA8 == null))
    {
      m_heuresA8 = p_heuresA8;
      ((PeriodeElementaireAffiliationPC)getPC()).setHeuresA8(p_heuresA8);
    }
    else if ((m_heuresA8 != null) && (p_heuresA8 != null) && (!p_heuresA8.equals(m_heuresA8)))
    {
      m_heuresA8 = p_heuresA8;
      ((PeriodeElementaireAffiliationPC)getPC()).setHeuresA8(p_heuresA8);
    }
  }
  
  protected BigDecimal rawGetHeuresA10()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getHeuresA10();
  }
  
  public BigDecimal getHeuresA10()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getHeuresA10();
  }
  
  public void setHeuresA10(BigDecimal p_heuresA10)
  {
    if ((m_heuresA10 == null) || (p_heuresA10 == null))
    {
      m_heuresA10 = p_heuresA10;
      ((PeriodeElementaireAffiliationPC)getPC()).setHeuresA10(p_heuresA10);
    }
    else if ((m_heuresA10 != null) && (p_heuresA10 != null) && (!p_heuresA10.equals(m_heuresA10)))
    {
      m_heuresA10 = p_heuresA10;
      ((PeriodeElementaireAffiliationPC)getPC()).setHeuresA10(p_heuresA10);
    }
  }
  
  protected BigDecimal rawGetCachetIsoleA8()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getCachetIsoleA8();
  }
  
  public BigDecimal getCachetIsoleA8()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getCachetIsoleA8();
  }
  
  public void setCachetIsoleA8(BigDecimal p_cachetIsoleA8)
  {
    if ((m_cachetIsoleA8 == null) || (p_cachetIsoleA8 == null))
    {
      m_cachetIsoleA8 = p_cachetIsoleA8;
      ((PeriodeElementaireAffiliationPC)getPC()).setCachetIsoleA8(p_cachetIsoleA8);
    }
    else if ((m_cachetIsoleA8 != null) && (p_cachetIsoleA8 != null) && (!p_cachetIsoleA8.equals(m_cachetIsoleA8)))
    {
      m_cachetIsoleA8 = p_cachetIsoleA8;
      ((PeriodeElementaireAffiliationPC)getPC()).setCachetIsoleA8(p_cachetIsoleA8);
    }
  }
  
  protected BigDecimal rawGetCachetGroupeA8()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getCachetGroupeA8();
  }
  
  public BigDecimal getCachetGroupeA8()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getCachetGroupeA8();
  }
  
  public void setCachetGroupeA8(BigDecimal p_cachetGroupeA8)
  {
    if ((m_cachetGroupeA8 == null) || (p_cachetGroupeA8 == null))
    {
      m_cachetGroupeA8 = p_cachetGroupeA8;
      ((PeriodeElementaireAffiliationPC)getPC()).setCachetGroupeA8(p_cachetGroupeA8);
    }
    else if ((m_cachetGroupeA8 != null) && (p_cachetGroupeA8 != null) && (!p_cachetGroupeA8.equals(m_cachetGroupeA8)))
    {
      m_cachetGroupeA8 = p_cachetGroupeA8;
      ((PeriodeElementaireAffiliationPC)getPC()).setCachetGroupeA8(p_cachetGroupeA8);
    }
  }
  
  protected BigDecimal rawGetCachetIsoleA10()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getCachetIsoleA10();
  }
  
  public BigDecimal getCachetIsoleA10()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getCachetIsoleA10();
  }
  
  public void setCachetIsoleA10(BigDecimal p_cachetIsoleA10)
  {
    if ((m_cachetIsoleA10 == null) || (p_cachetIsoleA10 == null))
    {
      m_cachetIsoleA10 = p_cachetIsoleA10;
      ((PeriodeElementaireAffiliationPC)getPC()).setCachetIsoleA10(p_cachetIsoleA10);
    }
    else if ((m_cachetIsoleA10 != null) && (p_cachetIsoleA10 != null) && (!p_cachetIsoleA10.equals(m_cachetIsoleA10)))
    {
      m_cachetIsoleA10 = p_cachetIsoleA10;
      ((PeriodeElementaireAffiliationPC)getPC()).setCachetIsoleA10(p_cachetIsoleA10);
    }
  }
  
  protected BigDecimal rawGetCachetGroupeA10()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getCachetGroupeA10();
  }
  
  public BigDecimal getCachetGroupeA10()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getCachetGroupeA10();
  }
  
  public void setCachetGroupeA10(BigDecimal p_cachetGroupeA10)
  {
    if ((m_cachetGroupeA10 == null) || (p_cachetGroupeA10 == null))
    {
      m_cachetGroupeA10 = p_cachetGroupeA10;
      ((PeriodeElementaireAffiliationPC)getPC()).setCachetGroupeA10(p_cachetGroupeA10);
    }
    else if ((m_cachetGroupeA10 != null) && (p_cachetGroupeA10 != null) && (!p_cachetGroupeA10.equals(m_cachetGroupeA10)))
    {
      m_cachetGroupeA10 = p_cachetGroupeA10;
      ((PeriodeElementaireAffiliationPC)getPC()).setCachetGroupeA10(p_cachetGroupeA10);
    }
  }
  
  protected BigDecimal rawGetHeuresComplementairesA10()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getHeuresComplementairesA10();
  }
  
  public BigDecimal getHeuresComplementairesA10()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getHeuresComplementairesA10();
  }
  
  public void setHeuresComplementairesA10(BigDecimal p_heuresComplementairesA10)
  {
    if ((m_heuresComplementairesA10 == null) || (p_heuresComplementairesA10 == null))
    {
      m_heuresComplementairesA10 = p_heuresComplementairesA10;
      ((PeriodeElementaireAffiliationPC)getPC()).setHeuresComplementairesA10(p_heuresComplementairesA10);
    }
    else if ((m_heuresComplementairesA10 != null) && (p_heuresComplementairesA10 != null) && (!p_heuresComplementairesA10.equals(m_heuresComplementairesA10)))
    {
      m_heuresComplementairesA10 = p_heuresComplementairesA10;
      ((PeriodeElementaireAffiliationPC)getPC()).setHeuresComplementairesA10(p_heuresComplementairesA10);
    }
  }
  
  protected BigDecimal rawGetMontantPlafondCachets()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getMontantPlafondCachets();
  }
  
  public BigDecimal getMontantPlafondCachets()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getMontantPlafondCachets();
  }
  
  public void setMontantPlafondCachets(BigDecimal p_montantPlafondCachets)
  {
    if ((m_montantPlafondCachets == null) || (p_montantPlafondCachets == null))
    {
      m_montantPlafondCachets = p_montantPlafondCachets;
      ((PeriodeElementaireAffiliationPC)getPC()).setMontantPlafondCachets(p_montantPlafondCachets);
    }
    else if ((m_montantPlafondCachets != null) && (p_montantPlafondCachets != null) && (!p_montantPlafondCachets.equals(m_montantPlafondCachets)))
    {
      m_montantPlafondCachets = p_montantPlafondCachets;
      ((PeriodeElementaireAffiliationPC)getPC()).setMontantPlafondCachets(p_montantPlafondCachets);
    }
  }
  
  protected BigDecimal rawGetMontantPlafondHeures()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getMontantPlafondHeures();
  }
  
  public BigDecimal getMontantPlafondHeures()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getMontantPlafondHeures();
  }
  
  public void setMontantPlafondHeures(BigDecimal p_montantPlafondHeures)
  {
    if ((m_montantPlafondHeures == null) || (p_montantPlafondHeures == null))
    {
      m_montantPlafondHeures = p_montantPlafondHeures;
      ((PeriodeElementaireAffiliationPC)getPC()).setMontantPlafondHeures(p_montantPlafondHeures);
    }
    else if ((m_montantPlafondHeures != null) && (p_montantPlafondHeures != null) && (!p_montantPlafondHeures.equals(m_montantPlafondHeures)))
    {
      m_montantPlafondHeures = p_montantPlafondHeures;
      ((PeriodeElementaireAffiliationPC)getPC()).setMontantPlafondHeures(p_montantPlafondHeures);
    }
  }
  
  protected BigDecimal rawGetQuantiteHeureExercee()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getQuantiteHeureExercee();
  }
  
  public BigDecimal getQuantiteHeureExercee()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getQuantiteHeureExercee();
  }
  
  public void setQuantiteHeureExercee(BigDecimal p_quantiteHeureExercee)
  {
    if ((m_quantiteHeureExercee == null) || (p_quantiteHeureExercee == null))
    {
      m_quantiteHeureExercee = p_quantiteHeureExercee;
      ((PeriodeElementaireAffiliationPC)getPC()).setQuantiteHeureExercee(p_quantiteHeureExercee);
    }
    else if ((m_quantiteHeureExercee != null) && (p_quantiteHeureExercee != null) && (!p_quantiteHeureExercee.equals(m_quantiteHeureExercee)))
    {
      m_quantiteHeureExercee = p_quantiteHeureExercee;
      ((PeriodeElementaireAffiliationPC)getPC()).setQuantiteHeureExercee(p_quantiteHeureExercee);
    }
  }
  
  protected BigDecimal rawGetQuantiteCachetGroupeIsoleHeureExercee()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getQuantiteCachetGroupeIsoleHeureExercee();
  }
  
  public BigDecimal getQuantiteCachetGroupeIsoleHeureExercee()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getQuantiteCachetGroupeIsoleHeureExercee();
  }
  
  public void setQuantiteCachetGroupeIsoleHeureExercee(BigDecimal p_quantiteCachetGroupeIsoleHeureExercee)
  {
    if ((m_quantiteCachetGroupeIsoleHeureExercee == null) || (p_quantiteCachetGroupeIsoleHeureExercee == null))
    {
      m_quantiteCachetGroupeIsoleHeureExercee = p_quantiteCachetGroupeIsoleHeureExercee;
      ((PeriodeElementaireAffiliationPC)getPC()).setQuantiteCachetGroupeIsoleHeureExercee(p_quantiteCachetGroupeIsoleHeureExercee);
    }
    else if ((m_quantiteCachetGroupeIsoleHeureExercee != null) && (p_quantiteCachetGroupeIsoleHeureExercee != null) && (!p_quantiteCachetGroupeIsoleHeureExercee.equals(m_quantiteCachetGroupeIsoleHeureExercee)))
    {
      m_quantiteCachetGroupeIsoleHeureExercee = p_quantiteCachetGroupeIsoleHeureExercee;
      ((PeriodeElementaireAffiliationPC)getPC()).setQuantiteCachetGroupeIsoleHeureExercee(p_quantiteCachetGroupeIsoleHeureExercee);
    }
  }
  
  protected BigDecimal rawGetHeuresApresPlafonnementMonoEmployeur()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getHeuresApresPlafonnementMonoEmployeur();
  }
  
  public BigDecimal getHeuresApresPlafonnementMonoEmployeur()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getHeuresApresPlafonnementMonoEmployeur();
  }
  
  public void setHeuresApresPlafonnementMonoEmployeur(BigDecimal p_heuresApresPlafonnementMonoEmployeur)
  {
    if ((m_heuresApresPlafonnementMonoEmployeur == null) || (p_heuresApresPlafonnementMonoEmployeur == null))
    {
      m_heuresApresPlafonnementMonoEmployeur = p_heuresApresPlafonnementMonoEmployeur;
      ((PeriodeElementaireAffiliationPC)getPC()).setHeuresApresPlafonnementMonoEmployeur(p_heuresApresPlafonnementMonoEmployeur);
    }
    else if ((m_heuresApresPlafonnementMonoEmployeur != null) && (p_heuresApresPlafonnementMonoEmployeur != null) && (!p_heuresApresPlafonnementMonoEmployeur.equals(m_heuresApresPlafonnementMonoEmployeur)))
    {
      m_heuresApresPlafonnementMonoEmployeur = p_heuresApresPlafonnementMonoEmployeur;
      ((PeriodeElementaireAffiliationPC)getPC()).setHeuresApresPlafonnementMonoEmployeur(p_heuresApresPlafonnementMonoEmployeur);
    }
  }
  
  protected BigDecimal rawGetHeuresApresPlafonnementMultiEmployeur()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getHeuresApresPlafonnementMultiEmployeur();
  }
  
  public BigDecimal getHeuresApresPlafonnementMultiEmployeur()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).getHeuresApresPlafonnementMultiEmployeur();
  }
  
  public void setHeuresApresPlafonnementMultiEmployeur(BigDecimal p_heuresApresPlafonnementMultiEmployeur)
  {
    if ((m_heuresApresPlafonnementMultiEmployeur == null) || (p_heuresApresPlafonnementMultiEmployeur == null))
    {
      m_heuresApresPlafonnementMultiEmployeur = p_heuresApresPlafonnementMultiEmployeur;
      ((PeriodeElementaireAffiliationPC)getPC()).setHeuresApresPlafonnementMultiEmployeur(p_heuresApresPlafonnementMultiEmployeur);
    }
    else if ((m_heuresApresPlafonnementMultiEmployeur != null) && (p_heuresApresPlafonnementMultiEmployeur != null) && (!p_heuresApresPlafonnementMultiEmployeur.equals(m_heuresApresPlafonnementMultiEmployeur)))
    {
      m_heuresApresPlafonnementMultiEmployeur = p_heuresApresPlafonnementMultiEmployeur;
      ((PeriodeElementaireAffiliationPC)getPC()).setHeuresApresPlafonnementMultiEmployeur(p_heuresApresPlafonnementMultiEmployeur);
    }
  }
  
  protected boolean rawIsEstPlafonneMultiEmployeur()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).isEstPlafonneMultiEmployeur();
  }
  
  public boolean isEstPlafonneMultiEmployeur()
  {
    return ((PeriodeElementaireAffiliationPC)getPC()).isEstPlafonneMultiEmployeur();
  }
  
  public void setEstPlafonneMultiEmployeur(boolean p_estPlafonneMultiEmployeur)
  {
    ((PeriodeElementaireAffiliationPC)getPC()).setEstPlafonneMultiEmployeur(p_estPlafonneMultiEmployeur);
  }
  
  private final Collection getCollectionModifiablePeriodeElementaireEmployeur()
  {
    Iterator itCollectionPC;
    if (m_listePeriodesElementairesEmployeur == null)
    {
      m_listePeriodesElementairesEmployeur = new ArrayList();
      for (itCollectionPC = ((PeriodeElementaireAffiliationPC)getPC()).getCollectionPeriodeElementaireEmployeur().iterator(); itCollectionPC.hasNext();)
      {
        DomPCSpec currentPC = (DomPCSpec)itCollectionPC.next();
        Object currentOM = currentPC.createOM();
        m_listePeriodesElementairesEmployeur.add(currentOM);
      }
    }
    return m_listePeriodesElementairesEmployeur;
  }
  
  public Collection getCollectionPeriodeElementaireEmployeur()
  {
    return Collections.unmodifiableCollection(getCollectionModifiablePeriodeElementaireEmployeur());
  }
  
  public List getListPeriodeElementaireEmployeur()
  {
    return Collections.unmodifiableList((List)getCollectionModifiablePeriodeElementaireEmployeur());
  }
  
  public void remplacerCollectionPeriodeElementaireEmployeur(Collection p_collectionACopier)
  {
    clearCollectionPeriodeElementaireEmployeur();
    for (Iterator i = p_collectionACopier.iterator(); i.hasNext();)
    {
      PeriodeElementaireEmployeur objet = (PeriodeElementaireEmployeur)i.next();
      ajouterPeriodeElementaireEmployeur(objet);
    }
  }
  
  public void supprimerSousCollectionPeriodeElementaireEmployeur(Collection p_collectionASupprimer)
  {
    for (Iterator i = p_collectionASupprimer.iterator(); i.hasNext();)
    {
      PeriodeElementaireEmployeur objet = (PeriodeElementaireEmployeur)i.next();
      supprimerPeriodeElementaireEmployeur(objet);
    }
  }
  
  public void ajouterPeriodeElementaireEmployeur(PeriodeElementaireEmployeur p_periodesElementairesEmployeur)
    throws NullPointerException
  {
    if (p_periodesElementairesEmployeur == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodesElementairesEmployeur ne devrait pas être nul.", p_periodesElementairesEmployeur);
    }
    getCollectionModifiablePeriodeElementaireEmployeur().add(p_periodesElementairesEmployeur);
    ((PeriodeElementaireAffiliationPC)getPC()).ajouterPeriodeElementaireEmployeur(p_periodesElementairesEmployeur.getPC());
  }
  
  public void supprimerPeriodeElementaireEmployeur(PeriodeElementaireEmployeur p_periodesElementairesEmployeur)
    throws NullPointerException
  {
    if (p_periodesElementairesEmployeur == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodesElementairesEmployeur ne devrait pas être nul.", p_periodesElementairesEmployeur);
    }
    getCollectionModifiablePeriodeElementaireEmployeur().remove(p_periodesElementairesEmployeur);
    ((PeriodeElementaireAffiliationPC)getPC()).supprimerPeriodeElementaireEmployeur(p_periodesElementairesEmployeur.getPC());
  }
  
  public void recopierCollectionPeriodeElementaireEmployeurVers(ObjetMetierSpec p_copie)
  {
    PeriodeElementaireAffiliationGen copie = (PeriodeElementaireAffiliationGen)p_copie;
    Collection listeACopier = getCollectionPeriodeElementaireEmployeur();
    for (Iterator i = listeACopier.iterator(); i.hasNext();)
    {
      ObjetMetierSpec objet = ((ObjetMetierSpec)i.next()).copie();
      copie.ajouterPeriodeElementaireEmployeur((PeriodeElementaireEmployeur)objet);
    }
  }
  
  public void clearCollectionPeriodeElementaireEmployeur()
  {
    getCollectionModifiablePeriodeElementaireEmployeur().clear();
    ((PeriodeElementaireAffiliationPC)getPC()).getCollectionPeriodeElementaireEmployeur().clear();
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    for (Iterator iter = getCollectionPeriodeElementaireEmployeur().iterator(); iter.hasNext();)
    {
      DomGenSpec item = (DomGenSpec)iter.next();
      if ((item != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(item))) {
        DomManager.supprimer(item, p_contexteSuppression);
      }
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     PeriodeElementaireAffiliationGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */