package fr.unedic.cali.asu.spe02.p03.liquidation.dom.pc;

import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConditionsAttributionReprise;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.spec.ConditionsAttributionAbstraitPC;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import java.io.IOException;
import java.io.ObjectOutputStream;
import javax.jdo.JDOFatalInternalException;
import javax.jdo.JDOUnsupportedOptionException;
import javax.jdo.JDOUserException;
import javax.jdo.PersistenceManager;
import javax.jdo.spi.JDOImplHelper;
import javax.jdo.spi.JDOPermission;
import javax.jdo.spi.PersistenceCapable;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldConsumer;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldSupplier;
import javax.jdo.spi.StateManager;
import xcalia.lido.internal.sm.CommonStateManager;

public class ConditionsAttributionReprisePC
  extends ConditionsAttributionAbstraitPC
  implements DomPCSpec, PersistenceCapable
{
  protected boolean m_presenceDonneesConditionRechercheEmploi;
  protected boolean m_presenceDonneesConditionAdhesionDispositif;
  protected boolean m_presenceDonneesConditionAge;
  protected boolean m_presenceDonneesConditionChomageInvolontaire;
  protected boolean m_presenceDonneesConditionCumulPrestationFamiliale;
  protected boolean m_presenceDonneesConditionMontantNonNul;
  private boolean m_presenceDonneesConditionValiditeReliquat;
  private transient ConditionsAttributionReprise m_conditionsAttributionRepriseOM;
  protected int m_etatConditionRechercheEmploi;
  protected int m_codeMotifEchecConditionRechercheEmploi;
  protected int m_etatConditionAdhesionDispositif;
  protected int m_codeMotifEchecConditionAdhesionDispositif;
  protected int m_etatConditionAge;
  protected int m_codeMotifEchecConditionAge;
  protected Damj m_datePensionRetraiteConditionAge;
  protected DureeCalendaire m_ageDateAttributionConditionAge;
  protected int m_etatConditionChomageInvolontaire;
  protected int m_codeMotifEchecConditionChomageInvolontaire;
  protected Quantite m_quantiteAffiliationChomageInvolontaire;
  protected int m_etatConditionCumulPrestationFamiliale;
  protected int m_codeMotifEchecConditionCumulPrestationFamiliale;
  protected int m_etatConditionMontantNonNul;
  protected int m_codeMotifEchecConditionMontantNonNul;
  private int m_etatConditionValiditeReliquat;
  private int m_codeMotifEchecConditionValiditeReliquat;
  private Damj m_dateDecheanceConditionValiditeReliquat;
  private int m_motifNonValiditeConditionValiditeReliquat;
  private int m_causeExtinctionConditionValiditeReliquat;
  protected transient byte jdoFlags;
  protected transient StateManager jdoStateManager;
  private static int jdoInheritedFieldCount = 0;
  private static String[] jdoFieldNames = { "m_presenceDonneesConditionRechercheEmploi", "m_presenceDonneesConditionAdhesionDispositif", "m_presenceDonneesConditionAge", "m_presenceDonneesConditionChomageInvolontaire", "m_presenceDonneesConditionCumulPrestationFamiliale", "m_presenceDonneesConditionMontantNonNul", "m_presenceDonneesConditionValiditeReliquat", "m_etatConditionRechercheEmploi", "m_codeMotifEchecConditionRechercheEmploi", "m_etatConditionAdhesionDispositif", "m_codeMotifEchecConditionAdhesionDispositif", "m_etatConditionAge", "m_codeMotifEchecConditionAge", "m_datePensionRetraiteConditionAge", "m_ageDateAttributionConditionAge", "m_etatConditionChomageInvolontaire", "m_codeMotifEchecConditionChomageInvolontaire", "m_quantiteAffiliationChomageInvolontaire", "m_etatConditionCumulPrestationFamiliale", "m_codeMotifEchecConditionCumulPrestationFamiliale", "m_etatConditionMontantNonNul", "m_codeMotifEchecConditionMontantNonNul", "m_etatConditionValiditeReliquat", "m_codeMotifEchecConditionValiditeReliquat", "m_dateDecheanceConditionValiditeReliquat", "m_motifNonValiditeConditionValiditeReliquat", "m_causeExtinctionConditionValiditeReliquat" };
  private static Class[] jdoFieldTypes = { Boolean.TYPE, Boolean.TYPE, Boolean.TYPE, Boolean.TYPE, Boolean.TYPE, Boolean.TYPE, Boolean.TYPE, Integer.TYPE, Integer.TYPE, Integer.TYPE, Integer.TYPE, Integer.TYPE, Integer.TYPE, Damj.class, DureeCalendaire.class, Integer.TYPE, Integer.TYPE, Quantite.class, Integer.TYPE, Integer.TYPE, Integer.TYPE, Integer.TYPE, Integer.TYPE, Integer.TYPE, Damj.class, Integer.TYPE, Integer.TYPE };
  private static byte[] jdoFieldFlags = { (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE) };
  private static Class jdoPersistenceCapableSuperclass = null;
  
  public ConditionsAttributionReprisePC()
  {
    jdoSetm_presenceDonneesConditionRechercheEmploi(this, false);
    jdoSetm_presenceDonneesConditionAdhesionDispositif(this, false);
    jdoSetm_presenceDonneesConditionAge(this, false);
    jdoSetm_presenceDonneesConditionChomageInvolontaire(this, false);
    jdoSetm_presenceDonneesConditionCumulPrestationFamiliale(this, false);
    jdoSetm_presenceDonneesConditionMontantNonNul(this, false);
    jdoSetm_presenceDonneesConditionValiditeReliquat(this, false);
    
    jdoSetm_quantiteAffiliationChomageInvolontaire(this, null);
  }
  
  public Object createOM()
  {
    if (m_conditionsAttributionRepriseOM == null) {
      m_conditionsAttributionRepriseOM = new ConditionsAttributionReprise(this);
    }
    return m_conditionsAttributionRepriseOM;
  }
  
  public boolean isPresenceDonneesConditionRechercheEmploi()
  {
    return jdoGetm_presenceDonneesConditionRechercheEmploi(this);
  }
  
  public final void setPresenceDonneesConditionRechercheEmploi(boolean p_presenceDonneesConditionRechercheEmploi)
  {
    jdoSetm_presenceDonneesConditionRechercheEmploi(this, p_presenceDonneesConditionRechercheEmploi);
  }
  
  public boolean isPresenceDonneesConditionAdhesionDispositif()
  {
    return jdoGetm_presenceDonneesConditionAdhesionDispositif(this);
  }
  
  public final void setPresenceDonneesConditionAdhesionDispositif(boolean p_presenceDonneesConditionAdhesionDispositif)
  {
    jdoSetm_presenceDonneesConditionAdhesionDispositif(this, p_presenceDonneesConditionAdhesionDispositif);
  }
  
  public boolean isPresenceDonneesConditionAge()
  {
    return jdoGetm_presenceDonneesConditionAge(this);
  }
  
  public final void setPresenceDonneesConditionAge(boolean p_presenceDonneesConditionAge)
  {
    jdoSetm_presenceDonneesConditionAge(this, p_presenceDonneesConditionAge);
  }
  
  public boolean isPresenceDonneesConditionChomageInvolontaire()
  {
    return jdoGetm_presenceDonneesConditionChomageInvolontaire(this);
  }
  
  public final void setPresenceDonneesConditionChomageInvolontaire(boolean p_presenceDonneesConditionChomageInvolontaire)
  {
    jdoSetm_presenceDonneesConditionChomageInvolontaire(this, p_presenceDonneesConditionChomageInvolontaire);
  }
  
  public boolean isPresenceDonneesConditionCumulPrestationFamiliale()
  {
    return jdoGetm_presenceDonneesConditionCumulPrestationFamiliale(this);
  }
  
  public final void setPresenceDonneesConditionCumulPrestationFamiliale(boolean p_presenceDonneesConditionCumulPrestationFamiliale)
  {
    jdoSetm_presenceDonneesConditionCumulPrestationFamiliale(this, p_presenceDonneesConditionCumulPrestationFamiliale);
  }
  
  public boolean isPresenceDonneesConditionMontantNonNul()
  {
    return jdoGetm_presenceDonneesConditionMontantNonNul(this);
  }
  
  public final void setPresenceDonneesConditionMontantNonNul(boolean p_presenceDonneesConditionMontantNonNul)
  {
    jdoSetm_presenceDonneesConditionMontantNonNul(this, p_presenceDonneesConditionMontantNonNul);
  }
  
  public boolean isPresenceDonneesConditionValiditeReliquat()
  {
    return jdoGetm_presenceDonneesConditionValiditeReliquat(this);
  }
  
  public final void setPresenceDonneesConditionValiditeReliquat(boolean p_presenceDonneesConditionValiditeReliquat)
  {
    jdoSetm_presenceDonneesConditionValiditeReliquat(this, p_presenceDonneesConditionValiditeReliquat);
  }
  
  public int getEtatConditionRechercheEmploi()
  {
    return jdoGetm_etatConditionRechercheEmploi(this);
  }
  
  public final void setEtatConditionRechercheEmploi(int p_etatConditionRechercheEmploi)
  {
    jdoSetm_etatConditionRechercheEmploi(this, p_etatConditionRechercheEmploi);
  }
  
  public int getCodeMotifEchecConditionRechercheEmploi()
  {
    return jdoGetm_codeMotifEchecConditionRechercheEmploi(this);
  }
  
  public final void setCodeMotifEchecConditionRechercheEmploi(int p_codeMotifEchecConditionRechercheEmploi)
  {
    jdoSetm_codeMotifEchecConditionRechercheEmploi(this, p_codeMotifEchecConditionRechercheEmploi);
  }
  
  public int getEtatConditionAdhesionDispositif()
  {
    return jdoGetm_etatConditionAdhesionDispositif(this);
  }
  
  public final void setEtatConditionAdhesionDispositif(int p_etatConditionAdhesionDispositif)
  {
    jdoSetm_etatConditionAdhesionDispositif(this, p_etatConditionAdhesionDispositif);
  }
  
  public int getCodeMotifEchecConditionAdhesionDispositif()
  {
    return jdoGetm_codeMotifEchecConditionAdhesionDispositif(this);
  }
  
  public final void setCodeMotifEchecConditionAdhesionDispositif(int p_codeMotifEchecConditionAdhesionDispositif)
  {
    jdoSetm_codeMotifEchecConditionAdhesionDispositif(this, p_codeMotifEchecConditionAdhesionDispositif);
  }
  
  public int getEtatConditionAge()
  {
    return jdoGetm_etatConditionAge(this);
  }
  
  public final void setEtatConditionAge(int p_etatConditionAge)
  {
    jdoSetm_etatConditionAge(this, p_etatConditionAge);
  }
  
  public int getCodeMotifEchecConditionAge()
  {
    return jdoGetm_codeMotifEchecConditionAge(this);
  }
  
  public final void setCodeMotifEchecConditionAge(int p_codeMotifEchecConditionAge)
  {
    jdoSetm_codeMotifEchecConditionAge(this, p_codeMotifEchecConditionAge);
  }
  
  public Damj getDatePensionRetraiteConditionAge()
  {
    return jdoGetm_datePensionRetraiteConditionAge(this);
  }
  
  public final void setDatePensionRetraiteConditionAge(Damj p_datePensionRetraiteConditionAge)
  {
    jdoSetm_datePensionRetraiteConditionAge(this, p_datePensionRetraiteConditionAge);
  }
  
  public DureeCalendaire getAgeDateAttributionConditionAge()
  {
    return jdoGetm_ageDateAttributionConditionAge(this);
  }
  
  public final void setAgeDateAttributionConditionAge(DureeCalendaire p_ageDateAttributionConditionAge)
  {
    jdoSetm_ageDateAttributionConditionAge(this, p_ageDateAttributionConditionAge);
  }
  
  public int getEtatConditionChomageInvolontaire()
  {
    return jdoGetm_etatConditionChomageInvolontaire(this);
  }
  
  public final void setEtatConditionChomageInvolontaire(int p_etatConditionChomageInvolontaire)
  {
    jdoSetm_etatConditionChomageInvolontaire(this, p_etatConditionChomageInvolontaire);
  }
  
  public int getCodeMotifEchecConditionChomageInvolontaire()
  {
    return jdoGetm_codeMotifEchecConditionChomageInvolontaire(this);
  }
  
  public final void setCodeMotifEchecConditionChomageInvolontaire(int p_codeMotifEchecConditionChomageInvolontaire)
  {
    jdoSetm_codeMotifEchecConditionChomageInvolontaire(this, p_codeMotifEchecConditionChomageInvolontaire);
  }
  
  public Quantite getQuantiteAffiliationChomageInvolontaire()
  {
    return jdoGetm_quantiteAffiliationChomageInvolontaire(this);
  }
  
  public final void setQuantiteAffiliationChomageInvolontaire(Quantite p_quantiteAffiliationChomageInvolontaire)
  {
    jdoSetm_quantiteAffiliationChomageInvolontaire(this, p_quantiteAffiliationChomageInvolontaire);
  }
  
  public int getEtatConditionCumulPrestationFamiliale()
  {
    return jdoGetm_etatConditionCumulPrestationFamiliale(this);
  }
  
  public final void setEtatConditionCumulPrestationFamiliale(int p_etatConditionCumulPrestationFamiliale)
  {
    jdoSetm_etatConditionCumulPrestationFamiliale(this, p_etatConditionCumulPrestationFamiliale);
  }
  
  public int getCodeMotifEchecConditionCumulPrestationFamiliale()
  {
    return jdoGetm_codeMotifEchecConditionCumulPrestationFamiliale(this);
  }
  
  public final void setCodeMotifEchecConditionCumulPrestationFamiliale(int p_codeMotifEchecConditionCumulPrestationFamiliale)
  {
    jdoSetm_codeMotifEchecConditionCumulPrestationFamiliale(this, p_codeMotifEchecConditionCumulPrestationFamiliale);
  }
  
  public int getEtatConditionMontantNonNul()
  {
    return jdoGetm_etatConditionMontantNonNul(this);
  }
  
  public final void setEtatConditionMontantNonNul(int p_etatConditionMontantNonNul)
  {
    jdoSetm_etatConditionMontantNonNul(this, p_etatConditionMontantNonNul);
  }
  
  public int getCodeMotifEchecConditionMontantNonNul()
  {
    return jdoGetm_codeMotifEchecConditionMontantNonNul(this);
  }
  
  public final void setCodeMotifEchecConditionMontantNonNul(int p_codeMotifEchecConditionMontantNonNul)
  {
    jdoSetm_codeMotifEchecConditionMontantNonNul(this, p_codeMotifEchecConditionMontantNonNul);
  }
  
  public int getEtatConditionValiditeReliquat()
  {
    return jdoGetm_etatConditionValiditeReliquat(this);
  }
  
  public final void setEtatConditionValiditeReliquat(int p_etatConditionValiditeReliquat)
  {
    jdoSetm_etatConditionValiditeReliquat(this, p_etatConditionValiditeReliquat);
  }
  
  public int getCodeMotifEchecConditionValiditeReliquat()
  {
    return jdoGetm_codeMotifEchecConditionValiditeReliquat(this);
  }
  
  public final void setCodeMotifEchecConditionValiditeReliquat(int p_codeMotifEchecConditionValiditeReliquat)
  {
    jdoSetm_codeMotifEchecConditionValiditeReliquat(this, p_codeMotifEchecConditionValiditeReliquat);
  }
  
  public Damj getDateDecheanceConditionValiditeReliquat()
  {
    return jdoGetm_dateDecheanceConditionValiditeReliquat(this);
  }
  
  public final void setDateDecheanceConditionValiditeReliquat(Damj p_dateDecheanceConditionValiditeReliquat)
  {
    jdoSetm_dateDecheanceConditionValiditeReliquat(this, p_dateDecheanceConditionValiditeReliquat);
  }
  
  public int getMotifNonValiditeConditionValiditeReliquat()
  {
    return jdoGetm_motifNonValiditeConditionValiditeReliquat(this);
  }
  
  public final void setMotifNonValiditeConditionValiditeReliquat(int p_motifNonValiditeConditionValiditeReliquat)
  {
    jdoSetm_motifNonValiditeConditionValiditeReliquat(this, p_motifNonValiditeConditionValiditeReliquat);
  }
  
  public int getCauseExtinctionConditionValiditeReliquat()
  {
    return jdoGetm_causeExtinctionConditionValiditeReliquat(this);
  }
  
  public final void setCauseExtinctionConditionValiditeReliquat(int p_causeExtinctionConditionValiditeReliquat)
  {
    jdoSetm_causeExtinctionConditionValiditeReliquat(this, p_causeExtinctionConditionValiditeReliquat);
  }
  
  static
  {
    JDOImplHelper.registerClass(ConditionsAttributionReprisePC.class, jdoFieldNames, jdoFieldTypes, jdoFieldFlags, jdoPersistenceCapableSuperclass, new ConditionsAttributionReprisePC());
  }
  
  protected static final boolean jdoGetm_presenceDonneesConditionRechercheEmploi(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_presenceDonneesConditionRechercheEmploi;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 0)) {
        return m_presenceDonneesConditionRechercheEmploi;
      }
      return sm.getBooleanField(pc, jdoInheritedFieldCount + 0, m_presenceDonneesConditionRechercheEmploi);
    }
    return m_presenceDonneesConditionRechercheEmploi;
  }
  
  protected static final boolean jdoGetm_presenceDonneesConditionAdhesionDispositif(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_presenceDonneesConditionAdhesionDispositif;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 1)) {
        return m_presenceDonneesConditionAdhesionDispositif;
      }
      return sm.getBooleanField(pc, jdoInheritedFieldCount + 1, m_presenceDonneesConditionAdhesionDispositif);
    }
    return m_presenceDonneesConditionAdhesionDispositif;
  }
  
  protected static final boolean jdoGetm_presenceDonneesConditionAge(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_presenceDonneesConditionAge;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 2)) {
        return m_presenceDonneesConditionAge;
      }
      return sm.getBooleanField(pc, jdoInheritedFieldCount + 2, m_presenceDonneesConditionAge);
    }
    return m_presenceDonneesConditionAge;
  }
  
  protected static final boolean jdoGetm_presenceDonneesConditionChomageInvolontaire(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_presenceDonneesConditionChomageInvolontaire;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 3)) {
        return m_presenceDonneesConditionChomageInvolontaire;
      }
      return sm.getBooleanField(pc, jdoInheritedFieldCount + 3, m_presenceDonneesConditionChomageInvolontaire);
    }
    return m_presenceDonneesConditionChomageInvolontaire;
  }
  
  protected static final boolean jdoGetm_presenceDonneesConditionCumulPrestationFamiliale(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_presenceDonneesConditionCumulPrestationFamiliale;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 4)) {
        return m_presenceDonneesConditionCumulPrestationFamiliale;
      }
      return sm.getBooleanField(pc, jdoInheritedFieldCount + 4, m_presenceDonneesConditionCumulPrestationFamiliale);
    }
    return m_presenceDonneesConditionCumulPrestationFamiliale;
  }
  
  protected static final boolean jdoGetm_presenceDonneesConditionMontantNonNul(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_presenceDonneesConditionMontantNonNul;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 5)) {
        return m_presenceDonneesConditionMontantNonNul;
      }
      return sm.getBooleanField(pc, jdoInheritedFieldCount + 5, m_presenceDonneesConditionMontantNonNul);
    }
    return m_presenceDonneesConditionMontantNonNul;
  }
  
  private static final boolean jdoGetm_presenceDonneesConditionValiditeReliquat(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_presenceDonneesConditionValiditeReliquat;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 6)) {
        return m_presenceDonneesConditionValiditeReliquat;
      }
      return sm.getBooleanField(pc, jdoInheritedFieldCount + 6, m_presenceDonneesConditionValiditeReliquat);
    }
    return m_presenceDonneesConditionValiditeReliquat;
  }
  
  protected static final int jdoGetm_etatConditionRechercheEmploi(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_etatConditionRechercheEmploi;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 7)) {
        return m_etatConditionRechercheEmploi;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 7, m_etatConditionRechercheEmploi);
    }
    return m_etatConditionRechercheEmploi;
  }
  
  protected static final int jdoGetm_codeMotifEchecConditionRechercheEmploi(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_codeMotifEchecConditionRechercheEmploi;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 8)) {
        return m_codeMotifEchecConditionRechercheEmploi;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 8, m_codeMotifEchecConditionRechercheEmploi);
    }
    return m_codeMotifEchecConditionRechercheEmploi;
  }
  
  protected static final int jdoGetm_etatConditionAdhesionDispositif(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_etatConditionAdhesionDispositif;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 9)) {
        return m_etatConditionAdhesionDispositif;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 9, m_etatConditionAdhesionDispositif);
    }
    return m_etatConditionAdhesionDispositif;
  }
  
  protected static final int jdoGetm_codeMotifEchecConditionAdhesionDispositif(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_codeMotifEchecConditionAdhesionDispositif;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 10)) {
        return m_codeMotifEchecConditionAdhesionDispositif;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 10, m_codeMotifEchecConditionAdhesionDispositif);
    }
    return m_codeMotifEchecConditionAdhesionDispositif;
  }
  
  protected static final int jdoGetm_etatConditionAge(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_etatConditionAge;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 11)) {
        return m_etatConditionAge;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 11, m_etatConditionAge);
    }
    return m_etatConditionAge;
  }
  
  protected static final int jdoGetm_codeMotifEchecConditionAge(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_codeMotifEchecConditionAge;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 12)) {
        return m_codeMotifEchecConditionAge;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 12, m_codeMotifEchecConditionAge);
    }
    return m_codeMotifEchecConditionAge;
  }
  
  protected static final Damj jdoGetm_datePensionRetraiteConditionAge(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_datePensionRetraiteConditionAge;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 13)) {
        return m_datePensionRetraiteConditionAge;
      }
      return (Damj)sm.getObjectField(pc, jdoInheritedFieldCount + 13, m_datePensionRetraiteConditionAge);
    }
    return m_datePensionRetraiteConditionAge;
  }
  
  protected static final DureeCalendaire jdoGetm_ageDateAttributionConditionAge(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_ageDateAttributionConditionAge;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 14)) {
        return m_ageDateAttributionConditionAge;
      }
      return (DureeCalendaire)sm.getObjectField(pc, jdoInheritedFieldCount + 14, m_ageDateAttributionConditionAge);
    }
    return m_ageDateAttributionConditionAge;
  }
  
  protected static final int jdoGetm_etatConditionChomageInvolontaire(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_etatConditionChomageInvolontaire;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 15)) {
        return m_etatConditionChomageInvolontaire;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 15, m_etatConditionChomageInvolontaire);
    }
    return m_etatConditionChomageInvolontaire;
  }
  
  protected static final int jdoGetm_codeMotifEchecConditionChomageInvolontaire(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_codeMotifEchecConditionChomageInvolontaire;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 16)) {
        return m_codeMotifEchecConditionChomageInvolontaire;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 16, m_codeMotifEchecConditionChomageInvolontaire);
    }
    return m_codeMotifEchecConditionChomageInvolontaire;
  }
  
  protected static final Quantite jdoGetm_quantiteAffiliationChomageInvolontaire(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_quantiteAffiliationChomageInvolontaire;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 17)) {
        return m_quantiteAffiliationChomageInvolontaire;
      }
      return (Quantite)sm.getObjectField(pc, jdoInheritedFieldCount + 17, m_quantiteAffiliationChomageInvolontaire);
    }
    return m_quantiteAffiliationChomageInvolontaire;
  }
  
  protected static final int jdoGetm_etatConditionCumulPrestationFamiliale(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_etatConditionCumulPrestationFamiliale;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 18)) {
        return m_etatConditionCumulPrestationFamiliale;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 18, m_etatConditionCumulPrestationFamiliale);
    }
    return m_etatConditionCumulPrestationFamiliale;
  }
  
  protected static final int jdoGetm_codeMotifEchecConditionCumulPrestationFamiliale(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_codeMotifEchecConditionCumulPrestationFamiliale;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 19)) {
        return m_codeMotifEchecConditionCumulPrestationFamiliale;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 19, m_codeMotifEchecConditionCumulPrestationFamiliale);
    }
    return m_codeMotifEchecConditionCumulPrestationFamiliale;
  }
  
  protected static final int jdoGetm_etatConditionMontantNonNul(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_etatConditionMontantNonNul;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 20)) {
        return m_etatConditionMontantNonNul;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 20, m_etatConditionMontantNonNul);
    }
    return m_etatConditionMontantNonNul;
  }
  
  protected static final int jdoGetm_codeMotifEchecConditionMontantNonNul(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_codeMotifEchecConditionMontantNonNul;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 21)) {
        return m_codeMotifEchecConditionMontantNonNul;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 21, m_codeMotifEchecConditionMontantNonNul);
    }
    return m_codeMotifEchecConditionMontantNonNul;
  }
  
  private static final int jdoGetm_etatConditionValiditeReliquat(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_etatConditionValiditeReliquat;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 22)) {
        return m_etatConditionValiditeReliquat;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 22, m_etatConditionValiditeReliquat);
    }
    return m_etatConditionValiditeReliquat;
  }
  
  private static final int jdoGetm_codeMotifEchecConditionValiditeReliquat(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_codeMotifEchecConditionValiditeReliquat;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 23)) {
        return m_codeMotifEchecConditionValiditeReliquat;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 23, m_codeMotifEchecConditionValiditeReliquat);
    }
    return m_codeMotifEchecConditionValiditeReliquat;
  }
  
  private static final Damj jdoGetm_dateDecheanceConditionValiditeReliquat(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_dateDecheanceConditionValiditeReliquat;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 24)) {
        return m_dateDecheanceConditionValiditeReliquat;
      }
      return (Damj)sm.getObjectField(pc, jdoInheritedFieldCount + 24, m_dateDecheanceConditionValiditeReliquat);
    }
    return m_dateDecheanceConditionValiditeReliquat;
  }
  
  private static final int jdoGetm_motifNonValiditeConditionValiditeReliquat(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_motifNonValiditeConditionValiditeReliquat;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 25)) {
        return m_motifNonValiditeConditionValiditeReliquat;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 25, m_motifNonValiditeConditionValiditeReliquat);
    }
    return m_motifNonValiditeConditionValiditeReliquat;
  }
  
  private static final int jdoGetm_causeExtinctionConditionValiditeReliquat(ConditionsAttributionReprisePC pc)
  {
    if (jdoFlags <= 0) {
      return m_causeExtinctionConditionValiditeReliquat;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 26)) {
        return m_causeExtinctionConditionValiditeReliquat;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 26, m_causeExtinctionConditionValiditeReliquat);
    }
    return m_causeExtinctionConditionValiditeReliquat;
  }
  
  protected static final void jdoSetm_presenceDonneesConditionRechercheEmploi(ConditionsAttributionReprisePC pc, boolean newValue)
  {
    if (jdoFlags == 0)
    {
      m_presenceDonneesConditionRechercheEmploi = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setBooleanField(pc, jdoInheritedFieldCount + 0, m_presenceDonneesConditionRechercheEmploi, newValue);
    } else {
      m_presenceDonneesConditionRechercheEmploi = newValue;
    }
  }
  
  protected static final void jdoSetm_presenceDonneesConditionAdhesionDispositif(ConditionsAttributionReprisePC pc, boolean newValue)
  {
    if (jdoFlags == 0)
    {
      m_presenceDonneesConditionAdhesionDispositif = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setBooleanField(pc, jdoInheritedFieldCount + 1, m_presenceDonneesConditionAdhesionDispositif, newValue);
    } else {
      m_presenceDonneesConditionAdhesionDispositif = newValue;
    }
  }
  
  protected static final void jdoSetm_presenceDonneesConditionAge(ConditionsAttributionReprisePC pc, boolean newValue)
  {
    if (jdoFlags == 0)
    {
      m_presenceDonneesConditionAge = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setBooleanField(pc, jdoInheritedFieldCount + 2, m_presenceDonneesConditionAge, newValue);
    } else {
      m_presenceDonneesConditionAge = newValue;
    }
  }
  
  protected static final void jdoSetm_presenceDonneesConditionChomageInvolontaire(ConditionsAttributionReprisePC pc, boolean newValue)
  {
    if (jdoFlags == 0)
    {
      m_presenceDonneesConditionChomageInvolontaire = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setBooleanField(pc, jdoInheritedFieldCount + 3, m_presenceDonneesConditionChomageInvolontaire, newValue);
    } else {
      m_presenceDonneesConditionChomageInvolontaire = newValue;
    }
  }
  
  protected static final void jdoSetm_presenceDonneesConditionCumulPrestationFamiliale(ConditionsAttributionReprisePC pc, boolean newValue)
  {
    if (jdoFlags == 0)
    {
      m_presenceDonneesConditionCumulPrestationFamiliale = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setBooleanField(pc, jdoInheritedFieldCount + 4, m_presenceDonneesConditionCumulPrestationFamiliale, newValue);
    } else {
      m_presenceDonneesConditionCumulPrestationFamiliale = newValue;
    }
  }
  
  protected static final void jdoSetm_presenceDonneesConditionMontantNonNul(ConditionsAttributionReprisePC pc, boolean newValue)
  {
    if (jdoFlags == 0)
    {
      m_presenceDonneesConditionMontantNonNul = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setBooleanField(pc, jdoInheritedFieldCount + 5, m_presenceDonneesConditionMontantNonNul, newValue);
    } else {
      m_presenceDonneesConditionMontantNonNul = newValue;
    }
  }
  
  private static final void jdoSetm_presenceDonneesConditionValiditeReliquat(ConditionsAttributionReprisePC pc, boolean newValue)
  {
    if (jdoFlags == 0)
    {
      m_presenceDonneesConditionValiditeReliquat = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setBooleanField(pc, jdoInheritedFieldCount + 6, m_presenceDonneesConditionValiditeReliquat, newValue);
    } else {
      m_presenceDonneesConditionValiditeReliquat = newValue;
    }
  }
  
  protected static final void jdoSetm_etatConditionRechercheEmploi(ConditionsAttributionReprisePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_etatConditionRechercheEmploi = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 7, m_etatConditionRechercheEmploi, newValue);
    } else {
      m_etatConditionRechercheEmploi = newValue;
    }
  }
  
  protected static final void jdoSetm_codeMotifEchecConditionRechercheEmploi(ConditionsAttributionReprisePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_codeMotifEchecConditionRechercheEmploi = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 8, m_codeMotifEchecConditionRechercheEmploi, newValue);
    } else {
      m_codeMotifEchecConditionRechercheEmploi = newValue;
    }
  }
  
  protected static final void jdoSetm_etatConditionAdhesionDispositif(ConditionsAttributionReprisePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_etatConditionAdhesionDispositif = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 9, m_etatConditionAdhesionDispositif, newValue);
    } else {
      m_etatConditionAdhesionDispositif = newValue;
    }
  }
  
  protected static final void jdoSetm_codeMotifEchecConditionAdhesionDispositif(ConditionsAttributionReprisePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_codeMotifEchecConditionAdhesionDispositif = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 10, m_codeMotifEchecConditionAdhesionDispositif, newValue);
    } else {
      m_codeMotifEchecConditionAdhesionDispositif = newValue;
    }
  }
  
  protected static final void jdoSetm_etatConditionAge(ConditionsAttributionReprisePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_etatConditionAge = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 11, m_etatConditionAge, newValue);
    } else {
      m_etatConditionAge = newValue;
    }
  }
  
  protected static final void jdoSetm_codeMotifEchecConditionAge(ConditionsAttributionReprisePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_codeMotifEchecConditionAge = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 12, m_codeMotifEchecConditionAge, newValue);
    } else {
      m_codeMotifEchecConditionAge = newValue;
    }
  }
  
  protected static final void jdoSetm_datePensionRetraiteConditionAge(ConditionsAttributionReprisePC pc, Damj newValue)
  {
    if (jdoFlags == 0)
    {
      m_datePensionRetraiteConditionAge = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 13, m_datePensionRetraiteConditionAge, newValue);
    } else {
      m_datePensionRetraiteConditionAge = newValue;
    }
  }
  
  protected static final void jdoSetm_ageDateAttributionConditionAge(ConditionsAttributionReprisePC pc, DureeCalendaire newValue)
  {
    if (jdoFlags == 0)
    {
      m_ageDateAttributionConditionAge = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 14, m_ageDateAttributionConditionAge, newValue);
    } else {
      m_ageDateAttributionConditionAge = newValue;
    }
  }
  
  protected static final void jdoSetm_etatConditionChomageInvolontaire(ConditionsAttributionReprisePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_etatConditionChomageInvolontaire = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 15, m_etatConditionChomageInvolontaire, newValue);
    } else {
      m_etatConditionChomageInvolontaire = newValue;
    }
  }
  
  protected static final void jdoSetm_codeMotifEchecConditionChomageInvolontaire(ConditionsAttributionReprisePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_codeMotifEchecConditionChomageInvolontaire = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 16, m_codeMotifEchecConditionChomageInvolontaire, newValue);
    } else {
      m_codeMotifEchecConditionChomageInvolontaire = newValue;
    }
  }
  
  protected static final void jdoSetm_quantiteAffiliationChomageInvolontaire(ConditionsAttributionReprisePC pc, Quantite newValue)
  {
    if (jdoFlags == 0)
    {
      m_quantiteAffiliationChomageInvolontaire = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 17, m_quantiteAffiliationChomageInvolontaire, newValue);
    } else {
      m_quantiteAffiliationChomageInvolontaire = newValue;
    }
  }
  
  protected static final void jdoSetm_etatConditionCumulPrestationFamiliale(ConditionsAttributionReprisePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_etatConditionCumulPrestationFamiliale = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 18, m_etatConditionCumulPrestationFamiliale, newValue);
    } else {
      m_etatConditionCumulPrestationFamiliale = newValue;
    }
  }
  
  protected static final void jdoSetm_codeMotifEchecConditionCumulPrestationFamiliale(ConditionsAttributionReprisePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_codeMotifEchecConditionCumulPrestationFamiliale = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 19, m_codeMotifEchecConditionCumulPrestationFamiliale, newValue);
    } else {
      m_codeMotifEchecConditionCumulPrestationFamiliale = newValue;
    }
  }
  
  protected static final void jdoSetm_etatConditionMontantNonNul(ConditionsAttributionReprisePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_etatConditionMontantNonNul = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 20, m_etatConditionMontantNonNul, newValue);
    } else {
      m_etatConditionMontantNonNul = newValue;
    }
  }
  
  protected static final void jdoSetm_codeMotifEchecConditionMontantNonNul(ConditionsAttributionReprisePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_codeMotifEchecConditionMontantNonNul = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 21, m_codeMotifEchecConditionMontantNonNul, newValue);
    } else {
      m_codeMotifEchecConditionMontantNonNul = newValue;
    }
  }
  
  private static final void jdoSetm_etatConditionValiditeReliquat(ConditionsAttributionReprisePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_etatConditionValiditeReliquat = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 22, m_etatConditionValiditeReliquat, newValue);
    } else {
      m_etatConditionValiditeReliquat = newValue;
    }
  }
  
  private static final void jdoSetm_codeMotifEchecConditionValiditeReliquat(ConditionsAttributionReprisePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_codeMotifEchecConditionValiditeReliquat = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 23, m_codeMotifEchecConditionValiditeReliquat, newValue);
    } else {
      m_codeMotifEchecConditionValiditeReliquat = newValue;
    }
  }
  
  private static final void jdoSetm_dateDecheanceConditionValiditeReliquat(ConditionsAttributionReprisePC pc, Damj newValue)
  {
    if (jdoFlags == 0)
    {
      m_dateDecheanceConditionValiditeReliquat = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 24, m_dateDecheanceConditionValiditeReliquat, newValue);
    } else {
      m_dateDecheanceConditionValiditeReliquat = newValue;
    }
  }
  
  private static final void jdoSetm_motifNonValiditeConditionValiditeReliquat(ConditionsAttributionReprisePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_motifNonValiditeConditionValiditeReliquat = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 25, m_motifNonValiditeConditionValiditeReliquat, newValue);
    } else {
      m_motifNonValiditeConditionValiditeReliquat = newValue;
    }
  }
  
  private static final void jdoSetm_causeExtinctionConditionValiditeReliquat(ConditionsAttributionReprisePC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_causeExtinctionConditionValiditeReliquat = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 26, m_causeExtinctionConditionValiditeReliquat, newValue);
    } else {
      m_causeExtinctionConditionValiditeReliquat = newValue;
    }
  }
  
  public void jdoProvideField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      jdoStateManager.providedBooleanField(this, fieldNumber, m_presenceDonneesConditionRechercheEmploi);
      break;
    case 1: 
      jdoStateManager.providedBooleanField(this, fieldNumber, m_presenceDonneesConditionAdhesionDispositif);
      break;
    case 2: 
      jdoStateManager.providedBooleanField(this, fieldNumber, m_presenceDonneesConditionAge);
      break;
    case 3: 
      jdoStateManager.providedBooleanField(this, fieldNumber, m_presenceDonneesConditionChomageInvolontaire);
      break;
    case 4: 
      jdoStateManager.providedBooleanField(this, fieldNumber, m_presenceDonneesConditionCumulPrestationFamiliale);
      break;
    case 5: 
      jdoStateManager.providedBooleanField(this, fieldNumber, m_presenceDonneesConditionMontantNonNul);
      break;
    case 6: 
      jdoStateManager.providedBooleanField(this, fieldNumber, m_presenceDonneesConditionValiditeReliquat);
      break;
    case 7: 
      jdoStateManager.providedIntField(this, fieldNumber, m_etatConditionRechercheEmploi);
      break;
    case 8: 
      jdoStateManager.providedIntField(this, fieldNumber, m_codeMotifEchecConditionRechercheEmploi);
      break;
    case 9: 
      jdoStateManager.providedIntField(this, fieldNumber, m_etatConditionAdhesionDispositif);
      break;
    case 10: 
      jdoStateManager.providedIntField(this, fieldNumber, m_codeMotifEchecConditionAdhesionDispositif);
      break;
    case 11: 
      jdoStateManager.providedIntField(this, fieldNumber, m_etatConditionAge);
      break;
    case 12: 
      jdoStateManager.providedIntField(this, fieldNumber, m_codeMotifEchecConditionAge);
      break;
    case 13: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_datePensionRetraiteConditionAge);
      break;
    case 14: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_ageDateAttributionConditionAge);
      break;
    case 15: 
      jdoStateManager.providedIntField(this, fieldNumber, m_etatConditionChomageInvolontaire);
      break;
    case 16: 
      jdoStateManager.providedIntField(this, fieldNumber, m_codeMotifEchecConditionChomageInvolontaire);
      break;
    case 17: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_quantiteAffiliationChomageInvolontaire);
      break;
    case 18: 
      jdoStateManager.providedIntField(this, fieldNumber, m_etatConditionCumulPrestationFamiliale);
      break;
    case 19: 
      jdoStateManager.providedIntField(this, fieldNumber, m_codeMotifEchecConditionCumulPrestationFamiliale);
      break;
    case 20: 
      jdoStateManager.providedIntField(this, fieldNumber, m_etatConditionMontantNonNul);
      break;
    case 21: 
      jdoStateManager.providedIntField(this, fieldNumber, m_codeMotifEchecConditionMontantNonNul);
      break;
    case 22: 
      jdoStateManager.providedIntField(this, fieldNumber, m_etatConditionValiditeReliquat);
      break;
    case 23: 
      jdoStateManager.providedIntField(this, fieldNumber, m_codeMotifEchecConditionValiditeReliquat);
      break;
    case 24: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_dateDecheanceConditionValiditeReliquat);
      break;
    case 25: 
      jdoStateManager.providedIntField(this, fieldNumber, m_motifNonValiditeConditionValiditeReliquat);
      break;
    case 26: 
      jdoStateManager.providedIntField(this, fieldNumber, m_causeExtinctionConditionValiditeReliquat);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoReplaceField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      m_presenceDonneesConditionRechercheEmploi = jdoStateManager.replacingBooleanField(this, fieldNumber);
      break;
    case 1: 
      m_presenceDonneesConditionAdhesionDispositif = jdoStateManager.replacingBooleanField(this, fieldNumber);
      break;
    case 2: 
      m_presenceDonneesConditionAge = jdoStateManager.replacingBooleanField(this, fieldNumber);
      break;
    case 3: 
      m_presenceDonneesConditionChomageInvolontaire = jdoStateManager.replacingBooleanField(this, fieldNumber);
      break;
    case 4: 
      m_presenceDonneesConditionCumulPrestationFamiliale = jdoStateManager.replacingBooleanField(this, fieldNumber);
      break;
    case 5: 
      m_presenceDonneesConditionMontantNonNul = jdoStateManager.replacingBooleanField(this, fieldNumber);
      break;
    case 6: 
      m_presenceDonneesConditionValiditeReliquat = jdoStateManager.replacingBooleanField(this, fieldNumber);
      break;
    case 7: 
      m_etatConditionRechercheEmploi = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 8: 
      m_codeMotifEchecConditionRechercheEmploi = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 9: 
      m_etatConditionAdhesionDispositif = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 10: 
      m_codeMotifEchecConditionAdhesionDispositif = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 11: 
      m_etatConditionAge = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 12: 
      m_codeMotifEchecConditionAge = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 13: 
      m_datePensionRetraiteConditionAge = ((Damj)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 14: 
      m_ageDateAttributionConditionAge = ((DureeCalendaire)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 15: 
      m_etatConditionChomageInvolontaire = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 16: 
      m_codeMotifEchecConditionChomageInvolontaire = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 17: 
      m_quantiteAffiliationChomageInvolontaire = ((Quantite)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 18: 
      m_etatConditionCumulPrestationFamiliale = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 19: 
      m_codeMotifEchecConditionCumulPrestationFamiliale = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 20: 
      m_etatConditionMontantNonNul = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 21: 
      m_codeMotifEchecConditionMontantNonNul = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 22: 
      m_etatConditionValiditeReliquat = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 23: 
      m_codeMotifEchecConditionValiditeReliquat = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 24: 
      m_dateDecheanceConditionValiditeReliquat = ((Damj)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 25: 
      m_motifNonValiditeConditionValiditeReliquat = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 26: 
      m_causeExtinctionConditionValiditeReliquat = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoProvideFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoProvideField(fieldNumber);
    }
  }
  
  public void jdoReplaceFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoReplaceField(fieldNumber);
    }
  }
  
  public synchronized void jdoReplaceStateManager(StateManager sm)
  {
    if (jdoStateManager != null)
    {
      jdoStateManager = jdoStateManager.replacingStateManager(this, sm);
    }
    else
    {
      SecurityManager securityManager = System.getSecurityManager();
      if (securityManager != null) {
        securityManager.checkPermission(JDOPermission.SET_STATE_MANAGER);
      }
      jdoStateManager = sm;
    }
  }
  
  public boolean jdoIsPersistent()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isPersistent(this);
    }
    return false;
  }
  
  public boolean jdoIsTransactional()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isTransactional(this);
    }
    return false;
  }
  
  public boolean jdoIsNew()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isNew(this);
    }
    return false;
  }
  
  public boolean jdoIsDirty()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDirty(this);
    }
    return false;
  }
  
  public boolean jdoIsDeleted()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDeleted(this);
    }
    return false;
  }
  
  public void jdoMakeDirty(String fieldName)
  {
    if (jdoStateManager != null) {
      jdoStateManager.makeDirty(this, fieldName);
    }
  }
  
  public void jdoReplaceFlags()
  {
    if (jdoStateManager != null)
    {
      jdoFlags = jdoStateManager.replacingFlags(this);
      return;
      jdoFlags = 0;
    }
  }
  
  public boolean jdoIsDetached()
  {
    if (jdoStateManager != null) {
      return ((CommonStateManager)jdoStateManager).isDetached();
    }
    return false;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm)
  {
    ConditionsAttributionReprisePC pc = new ConditionsAttributionReprisePC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    return pc;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm, Object oid)
  {
    ConditionsAttributionReprisePC pc = new ConditionsAttributionReprisePC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    pc.jdoCopyKeyFieldsFromObjectId(oid);
    return pc;
  }
  
  public static int jdoGetManagedFieldCount()
  {
    return jdoInheritedFieldCount + 27;
  }
  
  public void jdoCopyFields(Object pc, int[] fieldNumbers)
  {
    if (!(pc instanceof ConditionsAttributionReprisePC)) {
      throw new JDOFatalInternalException("Can't copy fields from a different class");
    }
    ConditionsAttributionReprisePC other = (ConditionsAttributionReprisePC)pc;
    if (jdoStateManager != jdoStateManager) {
      throw new JDOUserException("Source object should have the same StateManager");
    }
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int relativeField = fieldNumbers[i] - jdoInheritedFieldCount;
      switch (relativeField)
      {
      case 0: 
        m_presenceDonneesConditionRechercheEmploi = m_presenceDonneesConditionRechercheEmploi;
        break;
      case 1: 
        m_presenceDonneesConditionAdhesionDispositif = m_presenceDonneesConditionAdhesionDispositif;
        break;
      case 2: 
        m_presenceDonneesConditionAge = m_presenceDonneesConditionAge;
        break;
      case 3: 
        m_presenceDonneesConditionChomageInvolontaire = m_presenceDonneesConditionChomageInvolontaire;
        break;
      case 4: 
        m_presenceDonneesConditionCumulPrestationFamiliale = m_presenceDonneesConditionCumulPrestationFamiliale;
        break;
      case 5: 
        m_presenceDonneesConditionMontantNonNul = m_presenceDonneesConditionMontantNonNul;
        break;
      case 6: 
        m_presenceDonneesConditionValiditeReliquat = m_presenceDonneesConditionValiditeReliquat;
        break;
      case 7: 
        m_etatConditionRechercheEmploi = m_etatConditionRechercheEmploi;
        break;
      case 8: 
        m_codeMotifEchecConditionRechercheEmploi = m_codeMotifEchecConditionRechercheEmploi;
        break;
      case 9: 
        m_etatConditionAdhesionDispositif = m_etatConditionAdhesionDispositif;
        break;
      case 10: 
        m_codeMotifEchecConditionAdhesionDispositif = m_codeMotifEchecConditionAdhesionDispositif;
        break;
      case 11: 
        m_etatConditionAge = m_etatConditionAge;
        break;
      case 12: 
        m_codeMotifEchecConditionAge = m_codeMotifEchecConditionAge;
        break;
      case 13: 
        m_datePensionRetraiteConditionAge = m_datePensionRetraiteConditionAge;
        break;
      case 14: 
        m_ageDateAttributionConditionAge = m_ageDateAttributionConditionAge;
        break;
      case 15: 
        m_etatConditionChomageInvolontaire = m_etatConditionChomageInvolontaire;
        break;
      case 16: 
        m_codeMotifEchecConditionChomageInvolontaire = m_codeMotifEchecConditionChomageInvolontaire;
        break;
      case 17: 
        m_quantiteAffiliationChomageInvolontaire = m_quantiteAffiliationChomageInvolontaire;
        break;
      case 18: 
        m_etatConditionCumulPrestationFamiliale = m_etatConditionCumulPrestationFamiliale;
        break;
      case 19: 
        m_codeMotifEchecConditionCumulPrestationFamiliale = m_codeMotifEchecConditionCumulPrestationFamiliale;
        break;
      case 20: 
        m_etatConditionMontantNonNul = m_etatConditionMontantNonNul;
        break;
      case 21: 
        m_codeMotifEchecConditionMontantNonNul = m_codeMotifEchecConditionMontantNonNul;
        break;
      case 22: 
        m_etatConditionValiditeReliquat = m_etatConditionValiditeReliquat;
        break;
      case 23: 
        m_codeMotifEchecConditionValiditeReliquat = m_codeMotifEchecConditionValiditeReliquat;
        break;
      case 24: 
        m_dateDecheanceConditionValiditeReliquat = m_dateDecheanceConditionValiditeReliquat;
        break;
      case 25: 
        m_motifNonValiditeConditionValiditeReliquat = m_motifNonValiditeConditionValiditeReliquat;
        break;
      case 26: 
        m_causeExtinctionConditionValiditeReliquat = m_causeExtinctionConditionValiditeReliquat;
      }
    }
  }
  
  public void jdoCopyKeyFieldsToObjectId(Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public void jdoCopyKeyFieldsToObjectId(PersistenceCapable.ObjectIdFieldSupplier supplier, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  protected void jdoCopyKeyFieldsFromObjectId(Object object) {}
  
  public void jdoCopyKeyFieldsFromObjectId(PersistenceCapable.ObjectIdFieldConsumer consumer, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public Object jdoNewObjectIdInstance()
  {
    return null;
  }
  
  public Object jdoNewObjectIdInstance(Object str)
  {
    return null;
  }
  
  public Object jdoGetObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getObjectId(this);
    }
    return null;
  }
  
  public PersistenceManager jdoGetPersistenceManager()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getPersistenceManager(this);
    }
    return null;
  }
  
  private void jdoPreSerialize()
  {
    if (jdoStateManager != null) {
      jdoStateManager.preSerialize(this);
    }
  }
  
  private void writeObject(ObjectOutputStream out)
    throws IOException
  {
    jdoPreSerialize();
    out.defaultWriteObject();
  }
  
  public Object jdoGetTransactionalObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getTransactionalObjectId(this);
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     ConditionsAttributionReprisePC
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */