package fr.unedic.cali.asu.spe02.p03.liquidation.dom.pc;

import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.ObjetChronoEvenementPC;
import java.io.IOException;
import java.io.ObjectOutputStream;
import javax.jdo.JDOFatalInternalException;
import javax.jdo.JDOUnsupportedOptionException;
import javax.jdo.JDOUserException;
import javax.jdo.PersistenceManager;
import javax.jdo.spi.JDOImplHelper;
import javax.jdo.spi.JDOPermission;
import javax.jdo.spi.PersistenceCapable;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldConsumer;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldSupplier;
import javax.jdo.spi.StateManager;
import xcalia.lido.internal.sm.CommonStateManager;

public abstract class DossierExamenPC
  extends ObjetChronoEvenementPC
  implements DomPCSpec, PersistenceCapable
{
  protected int m_motifRejetNotifie;
  protected DomPCSpec m_dossierAffecte;
  protected ConstitutionElementsAdmissionPC m_constitutionElementsAdmission;
  protected ConstitutionElementsReprisePC m_constitutionElementsReprise;
  protected ConditionsAttributionReprisePC m_conditionAttributionReprise;
  protected ConditionsAttributionAdmissionPC m_conditionAttributionAdmission;
  private int m_contexteDdeExpresse;
  protected transient byte jdoFlags;
  protected transient StateManager jdoStateManager;
  private static int jdoInheritedFieldCount = 0;
  private static String[] jdoFieldNames = { "m_dateEvenement", "m_motifRejetNotifie", "m_dossierAffecte", "m_constitutionElementsAdmission", "m_constitutionElementsReprise", "m_conditionAttributionReprise", "m_conditionAttributionAdmission", "m_contexteDdeExpresse" };
  private static Class[] jdoFieldTypes = { Damj.class, Integer.TYPE, DomPCSpec.class, ConstitutionElementsAdmissionPC.class, ConstitutionElementsReprisePC.class, ConditionsAttributionReprisePC.class, ConditionsAttributionAdmissionPC.class, Integer.TYPE };
  private static byte[] jdoFieldFlags = { (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE) };
  private static Class jdoPersistenceCapableSuperclass = null;
  static final long serialVersionUID = 2214230204808865025L;
  
  public abstract Object createOM();
  
  public int getMotifRejetNotifie()
  {
    return jdoGetm_motifRejetNotifie(this);
  }
  
  public final void setMotifRejetNotifie(int p_motifRejetNotifie)
  {
    jdoSetm_motifRejetNotifie(this, p_motifRejetNotifie);
  }
  
  public DomPCSpec getDossierAffecte()
  {
    return jdoGetm_dossierAffecte(this);
  }
  
  public final void setDossierAffecte(DomPCSpec p_dossierAffecte)
  {
    jdoSetm_dossierAffecte(this, p_dossierAffecte);
  }
  
  public DomPCSpec getConstitutionElementsAdmission()
  {
    return jdoGetm_constitutionElementsAdmission(this);
  }
  
  public final void setConstitutionElementsAdmission(DomPCSpec p_constitutionElementsAdmission)
  {
    jdoSetm_constitutionElementsAdmission(this, (ConstitutionElementsAdmissionPC)p_constitutionElementsAdmission);
  }
  
  public DomPCSpec getConstitutionElementsReprise()
  {
    return jdoGetm_constitutionElementsReprise(this);
  }
  
  public final void setConstitutionElementsReprise(DomPCSpec p_constitutionElementsReprise)
  {
    jdoSetm_constitutionElementsReprise(this, (ConstitutionElementsReprisePC)p_constitutionElementsReprise);
  }
  
  public DomPCSpec getConditionAttributionReprise()
  {
    return jdoGetm_conditionAttributionReprise(this);
  }
  
  public final void setConditionAttributionReprise(DomPCSpec p_conditionAttributionReprise)
  {
    jdoSetm_conditionAttributionReprise(this, (ConditionsAttributionReprisePC)p_conditionAttributionReprise);
  }
  
  public DomPCSpec getConditionAttributionAdmission()
  {
    return jdoGetm_conditionAttributionAdmission(this);
  }
  
  public final void setConditionAttributionAdmission(DomPCSpec p_conditionAttributionAdmission)
  {
    jdoSetm_conditionAttributionAdmission(this, (ConditionsAttributionAdmissionPC)p_conditionAttributionAdmission);
  }
  
  public int getContexteDdeExpresse()
  {
    return jdoGetm_contexteDdeExpresse(this);
  }
  
  public final void setContexteDdeExpresse(int p_contexteDdeExpresse)
  {
    jdoSetm_contexteDdeExpresse(this, p_contexteDdeExpresse);
  }
  
  static
  {
    JDOImplHelper.registerClass(DossierExamenPC.class, jdoFieldNames, jdoFieldTypes, jdoFieldFlags, jdoPersistenceCapableSuperclass, null);
  }
  
  protected static final Damj jdoGetm_dateEvenement(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_dateEvenement;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 0)) {
        return m_dateEvenement;
      }
      return (Damj)sm.getObjectField(pc, jdoInheritedFieldCount + 0, m_dateEvenement);
    }
    return m_dateEvenement;
  }
  
  protected static final int jdoGetm_motifRejetNotifie(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_motifRejetNotifie;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 1)) {
        return m_motifRejetNotifie;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 1, m_motifRejetNotifie);
    }
    return m_motifRejetNotifie;
  }
  
  protected static final DomPCSpec jdoGetm_dossierAffecte(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_dossierAffecte;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 2)) {
        return m_dossierAffecte;
      }
      return (DomPCSpec)sm.getObjectField(pc, jdoInheritedFieldCount + 2, m_dossierAffecte);
    }
    return m_dossierAffecte;
  }
  
  protected static final ConstitutionElementsAdmissionPC jdoGetm_constitutionElementsAdmission(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_constitutionElementsAdmission;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 3)) {
        return m_constitutionElementsAdmission;
      }
      return (ConstitutionElementsAdmissionPC)sm.getObjectField(pc, jdoInheritedFieldCount + 3, m_constitutionElementsAdmission);
    }
    return m_constitutionElementsAdmission;
  }
  
  protected static final ConstitutionElementsReprisePC jdoGetm_constitutionElementsReprise(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_constitutionElementsReprise;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 4)) {
        return m_constitutionElementsReprise;
      }
      return (ConstitutionElementsReprisePC)sm.getObjectField(pc, jdoInheritedFieldCount + 4, m_constitutionElementsReprise);
    }
    return m_constitutionElementsReprise;
  }
  
  protected static final ConditionsAttributionReprisePC jdoGetm_conditionAttributionReprise(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_conditionAttributionReprise;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 5)) {
        return m_conditionAttributionReprise;
      }
      return (ConditionsAttributionReprisePC)sm.getObjectField(pc, jdoInheritedFieldCount + 5, m_conditionAttributionReprise);
    }
    return m_conditionAttributionReprise;
  }
  
  protected static final ConditionsAttributionAdmissionPC jdoGetm_conditionAttributionAdmission(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_conditionAttributionAdmission;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 6)) {
        return m_conditionAttributionAdmission;
      }
      return (ConditionsAttributionAdmissionPC)sm.getObjectField(pc, jdoInheritedFieldCount + 6, m_conditionAttributionAdmission);
    }
    return m_conditionAttributionAdmission;
  }
  
  private static final int jdoGetm_contexteDdeExpresse(DossierExamenPC pc)
  {
    if (jdoFlags <= 0) {
      return m_contexteDdeExpresse;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 7)) {
        return m_contexteDdeExpresse;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 7, m_contexteDdeExpresse);
    }
    return m_contexteDdeExpresse;
  }
  
  protected static final void jdoSetm_dateEvenement(DossierExamenPC pc, Damj newValue)
  {
    if (jdoFlags == 0)
    {
      m_dateEvenement = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 0, m_dateEvenement, newValue);
    } else {
      m_dateEvenement = newValue;
    }
  }
  
  protected static final void jdoSetm_motifRejetNotifie(DossierExamenPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_motifRejetNotifie = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 1, m_motifRejetNotifie, newValue);
    } else {
      m_motifRejetNotifie = newValue;
    }
  }
  
  protected static final void jdoSetm_dossierAffecte(DossierExamenPC pc, DomPCSpec newValue)
  {
    if (jdoFlags == 0)
    {
      m_dossierAffecte = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 2, m_dossierAffecte, newValue);
    } else {
      m_dossierAffecte = newValue;
    }
  }
  
  protected static final void jdoSetm_constitutionElementsAdmission(DossierExamenPC pc, ConstitutionElementsAdmissionPC newValue)
  {
    if (jdoFlags == 0)
    {
      m_constitutionElementsAdmission = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 3, m_constitutionElementsAdmission, newValue);
    } else {
      m_constitutionElementsAdmission = newValue;
    }
  }
  
  protected static final void jdoSetm_constitutionElementsReprise(DossierExamenPC pc, ConstitutionElementsReprisePC newValue)
  {
    if (jdoFlags == 0)
    {
      m_constitutionElementsReprise = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 4, m_constitutionElementsReprise, newValue);
    } else {
      m_constitutionElementsReprise = newValue;
    }
  }
  
  protected static final void jdoSetm_conditionAttributionReprise(DossierExamenPC pc, ConditionsAttributionReprisePC newValue)
  {
    if (jdoFlags == 0)
    {
      m_conditionAttributionReprise = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 5, m_conditionAttributionReprise, newValue);
    } else {
      m_conditionAttributionReprise = newValue;
    }
  }
  
  protected static final void jdoSetm_conditionAttributionAdmission(DossierExamenPC pc, ConditionsAttributionAdmissionPC newValue)
  {
    if (jdoFlags == 0)
    {
      m_conditionAttributionAdmission = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 6, m_conditionAttributionAdmission, newValue);
    } else {
      m_conditionAttributionAdmission = newValue;
    }
  }
  
  private static final void jdoSetm_contexteDdeExpresse(DossierExamenPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_contexteDdeExpresse = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 7, m_contexteDdeExpresse, newValue);
    } else {
      m_contexteDdeExpresse = newValue;
    }
  }
  
  public void jdoProvideField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_dateEvenement);
      break;
    case 1: 
      jdoStateManager.providedIntField(this, fieldNumber, m_motifRejetNotifie);
      break;
    case 2: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_dossierAffecte);
      break;
    case 3: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_constitutionElementsAdmission);
      break;
    case 4: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_constitutionElementsReprise);
      break;
    case 5: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_conditionAttributionReprise);
      break;
    case 6: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_conditionAttributionAdmission);
      break;
    case 7: 
      jdoStateManager.providedIntField(this, fieldNumber, m_contexteDdeExpresse);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoReplaceField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      m_dateEvenement = ((Damj)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 1: 
      m_motifRejetNotifie = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 2: 
      m_dossierAffecte = ((DomPCSpec)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 3: 
      m_constitutionElementsAdmission = ((ConstitutionElementsAdmissionPC)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 4: 
      m_constitutionElementsReprise = ((ConstitutionElementsReprisePC)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 5: 
      m_conditionAttributionReprise = ((ConditionsAttributionReprisePC)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 6: 
      m_conditionAttributionAdmission = ((ConditionsAttributionAdmissionPC)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 7: 
      m_contexteDdeExpresse = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoProvideFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoProvideField(fieldNumber);
    }
  }
  
  public void jdoReplaceFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoReplaceField(fieldNumber);
    }
  }
  
  public synchronized void jdoReplaceStateManager(StateManager sm)
  {
    if (jdoStateManager != null)
    {
      jdoStateManager = jdoStateManager.replacingStateManager(this, sm);
    }
    else
    {
      SecurityManager securityManager = System.getSecurityManager();
      if (securityManager != null) {
        securityManager.checkPermission(JDOPermission.SET_STATE_MANAGER);
      }
      jdoStateManager = sm;
    }
  }
  
  public boolean jdoIsPersistent()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isPersistent(this);
    }
    return false;
  }
  
  public boolean jdoIsTransactional()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isTransactional(this);
    }
    return false;
  }
  
  public boolean jdoIsNew()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isNew(this);
    }
    return false;
  }
  
  public boolean jdoIsDirty()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDirty(this);
    }
    return false;
  }
  
  public boolean jdoIsDeleted()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDeleted(this);
    }
    return false;
  }
  
  public void jdoMakeDirty(String fieldName)
  {
    if (jdoStateManager != null) {
      jdoStateManager.makeDirty(this, fieldName);
    }
  }
  
  public void jdoReplaceFlags()
  {
    if (jdoStateManager != null)
    {
      jdoFlags = jdoStateManager.replacingFlags(this);
      return;
      jdoFlags = 0;
    }
  }
  
  public boolean jdoIsDetached()
  {
    if (jdoStateManager != null) {
      return ((CommonStateManager)jdoStateManager).isDetached();
    }
    return false;
  }
  
  /* Error */
  public PersistenceCapable jdoNewInstance(StateManager sm)
  {
    // Byte code:
    //   0: new 83	javax/jdo/JDOFatalInternalException
    //   3: dup
    //   4: ldc_w 397
    //   7: invokespecial 308	javax/jdo/JDOFatalInternalException:<init>	(Ljava/lang/String;)V
    //   10: athrow
    //   11: areturn
    // Local variable table:
    //   start	length	slot	name	signature
    //   0	12	0	this	DossierExamenPC
    //   0	12	1	sm	StateManager
  }
  
  /* Error */
  public PersistenceCapable jdoNewInstance(StateManager sm, Object oid)
  {
    // Byte code:
    //   0: new 83	javax/jdo/JDOFatalInternalException
    //   3: dup
    //   4: ldc_w 397
    //   7: invokespecial 308	javax/jdo/JDOFatalInternalException:<init>	(Ljava/lang/String;)V
    //   10: athrow
    //   11: areturn
    // Local variable table:
    //   start	length	slot	name	signature
    //   0	12	0	this	DossierExamenPC
    //   0	12	1	sm	StateManager
    //   0	12	2	oid	Object
  }
  
  public static int jdoGetManagedFieldCount()
  {
    return jdoInheritedFieldCount + 8;
  }
  
  public void jdoCopyFields(Object pc, int[] fieldNumbers)
  {
    if (!(pc instanceof DossierExamenPC)) {
      throw new JDOFatalInternalException("Can't copy fields from a different class");
    }
    DossierExamenPC other = (DossierExamenPC)pc;
    if (jdoStateManager != jdoStateManager) {
      throw new JDOUserException("Source object should have the same StateManager");
    }
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int relativeField = fieldNumbers[i] - jdoInheritedFieldCount;
      switch (relativeField)
      {
      case 0: 
        m_dateEvenement = m_dateEvenement;
        break;
      case 1: 
        m_motifRejetNotifie = m_motifRejetNotifie;
        break;
      case 2: 
        m_dossierAffecte = m_dossierAffecte;
        break;
      case 3: 
        m_constitutionElementsAdmission = m_constitutionElementsAdmission;
        break;
      case 4: 
        m_constitutionElementsReprise = m_constitutionElementsReprise;
        break;
      case 5: 
        m_conditionAttributionReprise = m_conditionAttributionReprise;
        break;
      case 6: 
        m_conditionAttributionAdmission = m_conditionAttributionAdmission;
        break;
      case 7: 
        m_contexteDdeExpresse = m_contexteDdeExpresse;
      }
    }
  }
  
  public void jdoCopyKeyFieldsToObjectId(Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public void jdoCopyKeyFieldsToObjectId(PersistenceCapable.ObjectIdFieldSupplier supplier, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  protected void jdoCopyKeyFieldsFromObjectId(Object object) {}
  
  public void jdoCopyKeyFieldsFromObjectId(PersistenceCapable.ObjectIdFieldConsumer consumer, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public Object jdoNewObjectIdInstance()
  {
    return null;
  }
  
  public Object jdoNewObjectIdInstance(Object str)
  {
    return null;
  }
  
  public Object jdoGetObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getObjectId(this);
    }
    return null;
  }
  
  public PersistenceManager jdoGetPersistenceManager()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getPersistenceManager(this);
    }
    return null;
  }
  
  private void jdoPreSerialize()
  {
    if (jdoStateManager != null) {
      jdoStateManager.preSerialize(this);
    }
  }
  
  private void writeObject(ObjectOutputStream out)
    throws IOException
  {
    jdoPreSerialize();
    out.defaultWriteObject();
  }
  
  public Object jdoGetTransactionalObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getTransactionalObjectId(this);
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     DossierExamenPC
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */