package fr.unedic.cali.asu.spe02.p03.liquidation.dom.pc;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.JustificationFranchiseCongesPayes;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.temps.Periode;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Collection;
import javax.jdo.JDOFatalInternalException;
import javax.jdo.JDOUnsupportedOptionException;
import javax.jdo.JDOUserException;
import javax.jdo.PersistenceManager;
import javax.jdo.spi.JDOImplHelper;
import javax.jdo.spi.JDOPermission;
import javax.jdo.spi.PersistenceCapable;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldConsumer;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldSupplier;
import javax.jdo.spi.StateManager;
import xcalia.lido.internal.sm.CommonStateManager;

public class JustificationFranchiseCongesPayesPC
  implements DomPCSpec, PersistenceCapable
{
  private transient JustificationFranchiseCongesPayes m_justificationFranchiseCongesPayesOM;
  private Periode m_periodeCalculFranchiseCp;
  private int m_nbJoursTravaillesRetenus;
  private String m_formule;
  public Collection m_moisCivil;
  protected transient byte jdoFlags;
  protected transient StateManager jdoStateManager;
  private static int jdoInheritedFieldCount = 0;
  private static String[] jdoFieldNames = { "m_periodeCalculFranchiseCp", "m_nbJoursTravaillesRetenus", "m_formule", "m_moisCivil" };
  private static Class[] jdoFieldTypes = { Periode.class, Integer.TYPE, String.class, Collection.class };
  private static byte[] jdoFieldFlags = { (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE) };
  private static Class jdoPersistenceCapableSuperclass = null;
  
  public Object createOM()
  {
    if (m_justificationFranchiseCongesPayesOM == null) {
      m_justificationFranchiseCongesPayesOM = new JustificationFranchiseCongesPayes(this);
    }
    return m_justificationFranchiseCongesPayesOM;
  }
  
  public Periode getPeriodeCalculFranchiseCp()
  {
    return jdoGetm_periodeCalculFranchiseCp(this);
  }
  
  public final void setPeriodeCalculFranchiseCp(Periode p_periodeCalculFranchiseCp)
  {
    jdoSetm_periodeCalculFranchiseCp(this, p_periodeCalculFranchiseCp);
  }
  
  public int getNbJoursTravaillesRetenus()
  {
    return jdoGetm_nbJoursTravaillesRetenus(this);
  }
  
  public final void setNbJoursTravaillesRetenus(int p_nbJoursTravaillesRetenus)
  {
    jdoSetm_nbJoursTravaillesRetenus(this, p_nbJoursTravaillesRetenus);
  }
  
  public String getFormule()
  {
    return jdoGetm_formule(this);
  }
  
  public final void setFormule(String p_formule)
  {
    jdoSetm_formule(this, p_formule);
  }
  
  public final Collection getCollectionMoisCivil()
  {
    if (jdoGetm_moisCivil(this) == null) {
      jdoSetm_moisCivil(this, new ArrayList());
    }
    return jdoGetm_moisCivil(this);
  }
  
  public final void ajouterMoisCivil(DomPCSpec p_moisCivil)
    throws NullPointerException
  {
    if (p_moisCivil == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_moisCivil ne devrait pas être nul.", p_moisCivil);
    }
    getCollectionMoisCivil().add(p_moisCivil);
  }
  
  public final void supprimerMoisCivil(DomPCSpec p_moisCivil)
    throws NullPointerException
  {
    if (p_moisCivil == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_moisCivil ne devrait pas être nul.", p_moisCivil);
    }
    getCollectionMoisCivil().remove(p_moisCivil);
  }
  
  static
  {
    JDOImplHelper.registerClass(JustificationFranchiseCongesPayesPC.class, jdoFieldNames, jdoFieldTypes, jdoFieldFlags, jdoPersistenceCapableSuperclass, new JustificationFranchiseCongesPayesPC());
  }
  
  private static final Periode jdoGetm_periodeCalculFranchiseCp(JustificationFranchiseCongesPayesPC pc)
  {
    if (jdoFlags <= 0) {
      return m_periodeCalculFranchiseCp;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 0)) {
        return m_periodeCalculFranchiseCp;
      }
      return (Periode)sm.getObjectField(pc, jdoInheritedFieldCount + 0, m_periodeCalculFranchiseCp);
    }
    return m_periodeCalculFranchiseCp;
  }
  
  private static final int jdoGetm_nbJoursTravaillesRetenus(JustificationFranchiseCongesPayesPC pc)
  {
    if (jdoFlags <= 0) {
      return m_nbJoursTravaillesRetenus;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 1)) {
        return m_nbJoursTravaillesRetenus;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 1, m_nbJoursTravaillesRetenus);
    }
    return m_nbJoursTravaillesRetenus;
  }
  
  private static final String jdoGetm_formule(JustificationFranchiseCongesPayesPC pc)
  {
    if (jdoFlags <= 0) {
      return m_formule;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 2)) {
        return m_formule;
      }
      return (String)sm.getStringField(pc, jdoInheritedFieldCount + 2, m_formule);
    }
    return m_formule;
  }
  
  public static final Collection jdoGetm_moisCivil(JustificationFranchiseCongesPayesPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 3)) {
        return m_moisCivil;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 3, m_moisCivil);
    }
    return m_moisCivil;
  }
  
  private static final void jdoSetm_periodeCalculFranchiseCp(JustificationFranchiseCongesPayesPC pc, Periode newValue)
  {
    if (jdoFlags == 0)
    {
      m_periodeCalculFranchiseCp = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 0, m_periodeCalculFranchiseCp, newValue);
    } else {
      m_periodeCalculFranchiseCp = newValue;
    }
  }
  
  private static final void jdoSetm_nbJoursTravaillesRetenus(JustificationFranchiseCongesPayesPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_nbJoursTravaillesRetenus = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 1, m_nbJoursTravaillesRetenus, newValue);
    } else {
      m_nbJoursTravaillesRetenus = newValue;
    }
  }
  
  private static final void jdoSetm_formule(JustificationFranchiseCongesPayesPC pc, String newValue)
  {
    if (jdoFlags == 0)
    {
      m_formule = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setStringField(pc, jdoInheritedFieldCount + 2, m_formule, newValue);
    } else {
      m_formule = newValue;
    }
  }
  
  public static final void jdoSetm_moisCivil(JustificationFranchiseCongesPayesPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 3, m_moisCivil, newValue);
    } else {
      m_moisCivil = newValue;
    }
  }
  
  public void jdoProvideField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_periodeCalculFranchiseCp);
      break;
    case 1: 
      jdoStateManager.providedIntField(this, fieldNumber, m_nbJoursTravaillesRetenus);
      break;
    case 2: 
      jdoStateManager.providedStringField(this, fieldNumber, m_formule);
      break;
    case 3: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_moisCivil);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoReplaceField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      m_periodeCalculFranchiseCp = ((Periode)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 1: 
      m_nbJoursTravaillesRetenus = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 2: 
      m_formule = ((String)jdoStateManager.replacingStringField(this, fieldNumber));
      break;
    case 3: 
      m_moisCivil = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoProvideFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoProvideField(fieldNumber);
    }
  }
  
  public void jdoReplaceFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoReplaceField(fieldNumber);
    }
  }
  
  public synchronized void jdoReplaceStateManager(StateManager sm)
  {
    if (jdoStateManager != null)
    {
      jdoStateManager = jdoStateManager.replacingStateManager(this, sm);
    }
    else
    {
      SecurityManager securityManager = System.getSecurityManager();
      if (securityManager != null) {
        securityManager.checkPermission(JDOPermission.SET_STATE_MANAGER);
      }
      jdoStateManager = sm;
    }
  }
  
  public boolean jdoIsPersistent()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isPersistent(this);
    }
    return false;
  }
  
  public boolean jdoIsTransactional()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isTransactional(this);
    }
    return false;
  }
  
  public boolean jdoIsNew()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isNew(this);
    }
    return false;
  }
  
  public boolean jdoIsDirty()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDirty(this);
    }
    return false;
  }
  
  public boolean jdoIsDeleted()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDeleted(this);
    }
    return false;
  }
  
  public void jdoMakeDirty(String fieldName)
  {
    if (jdoStateManager != null) {
      jdoStateManager.makeDirty(this, fieldName);
    }
  }
  
  public void jdoReplaceFlags()
  {
    if (jdoStateManager != null)
    {
      jdoFlags = jdoStateManager.replacingFlags(this);
      return;
      jdoFlags = 0;
    }
  }
  
  public boolean jdoIsDetached()
  {
    if (jdoStateManager != null) {
      return ((CommonStateManager)jdoStateManager).isDetached();
    }
    return false;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm)
  {
    JustificationFranchiseCongesPayesPC pc = new JustificationFranchiseCongesPayesPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    return pc;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm, Object oid)
  {
    JustificationFranchiseCongesPayesPC pc = new JustificationFranchiseCongesPayesPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    pc.jdoCopyKeyFieldsFromObjectId(oid);
    return pc;
  }
  
  public static int jdoGetManagedFieldCount()
  {
    return jdoInheritedFieldCount + 4;
  }
  
  public void jdoCopyFields(Object pc, int[] fieldNumbers)
  {
    if (!(pc instanceof JustificationFranchiseCongesPayesPC)) {
      throw new JDOFatalInternalException("Can't copy fields from a different class");
    }
    JustificationFranchiseCongesPayesPC other = (JustificationFranchiseCongesPayesPC)pc;
    if (jdoStateManager != jdoStateManager) {
      throw new JDOUserException("Source object should have the same StateManager");
    }
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int relativeField = fieldNumbers[i] - jdoInheritedFieldCount;
      switch (relativeField)
      {
      case 0: 
        m_periodeCalculFranchiseCp = m_periodeCalculFranchiseCp;
        break;
      case 1: 
        m_nbJoursTravaillesRetenus = m_nbJoursTravaillesRetenus;
        break;
      case 2: 
        m_formule = m_formule;
        break;
      case 3: 
        m_moisCivil = m_moisCivil;
      }
    }
  }
  
  public void jdoCopyKeyFieldsToObjectId(Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public void jdoCopyKeyFieldsToObjectId(PersistenceCapable.ObjectIdFieldSupplier supplier, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  protected void jdoCopyKeyFieldsFromObjectId(Object object) {}
  
  public void jdoCopyKeyFieldsFromObjectId(PersistenceCapable.ObjectIdFieldConsumer consumer, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public Object jdoNewObjectIdInstance()
  {
    return null;
  }
  
  public Object jdoNewObjectIdInstance(Object str)
  {
    return null;
  }
  
  public Object jdoGetObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getObjectId(this);
    }
    return null;
  }
  
  public PersistenceManager jdoGetPersistenceManager()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getPersistenceManager(this);
    }
    return null;
  }
  
  private void jdoPreSerialize()
  {
    if (jdoStateManager != null) {
      jdoStateManager.preSerialize(this);
    }
  }
  
  private void writeObject(ObjectOutputStream out)
    throws IOException
  {
    jdoPreSerialize();
    out.defaultWriteObject();
  }
  
  public Object jdoGetTransactionalObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getTransactionalObjectId(this);
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     JustificationFranchiseCongesPayesPC
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */