package fr.unedic.cali.asu.spe02.p03.liquidation.dom.pc;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.MoisCivil;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.temps.Periode;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Collection;
import javax.jdo.JDOFatalInternalException;
import javax.jdo.JDOUnsupportedOptionException;
import javax.jdo.JDOUserException;
import javax.jdo.PersistenceManager;
import javax.jdo.spi.JDOImplHelper;
import javax.jdo.spi.JDOPermission;
import javax.jdo.spi.PersistenceCapable;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldConsumer;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldSupplier;
import javax.jdo.spi.StateManager;
import xcalia.lido.internal.sm.CommonStateManager;

public class MoisCivilPC
  implements DomPCSpec, PersistenceCapable
{
  private transient MoisCivil m_moisCivilOM;
  private int m_nbJoursTravailles;
  private int m_nbJoursRetenus;
  private Periode m_periode;
  public Collection m_periodeSurMoisCivil;
  protected transient byte jdoFlags;
  protected transient StateManager jdoStateManager;
  private static int jdoInheritedFieldCount = 0;
  private static String[] jdoFieldNames = { "m_nbJoursTravailles", "m_nbJoursRetenus", "m_periode", "m_periodeSurMoisCivil" };
  private static Class[] jdoFieldTypes = { Integer.TYPE, Integer.TYPE, Periode.class, Collection.class };
  private static byte[] jdoFieldFlags = { (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE) };
  private static Class jdoPersistenceCapableSuperclass = null;
  
  public Object createOM()
  {
    if (m_moisCivilOM == null) {
      m_moisCivilOM = new MoisCivil(this);
    }
    return m_moisCivilOM;
  }
  
  public int getNbJoursTravailles()
  {
    return jdoGetm_nbJoursTravailles(this);
  }
  
  public final void setNbJoursTravailles(int p_nbJoursTravailles)
  {
    jdoSetm_nbJoursTravailles(this, p_nbJoursTravailles);
  }
  
  public int getNbJoursRetenus()
  {
    return jdoGetm_nbJoursRetenus(this);
  }
  
  public final void setNbJoursRetenus(int p_nbJoursRetenus)
  {
    jdoSetm_nbJoursRetenus(this, p_nbJoursRetenus);
  }
  
  public Periode getPeriode()
  {
    return jdoGetm_periode(this);
  }
  
  public final void setPeriode(Periode p_periode)
  {
    jdoSetm_periode(this, p_periode);
  }
  
  public final Collection getCollectionPeriodeSurMoisCivil()
  {
    if (jdoGetm_periodeSurMoisCivil(this) == null) {
      jdoSetm_periodeSurMoisCivil(this, new ArrayList());
    }
    return jdoGetm_periodeSurMoisCivil(this);
  }
  
  public final void ajouterPeriodeSurMoisCivil(DomPCSpec p_periodeSurMoisCivil)
    throws NullPointerException
  {
    if (p_periodeSurMoisCivil == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodeSurMoisCivil ne devrait pas être nul.", p_periodeSurMoisCivil);
    }
    getCollectionPeriodeSurMoisCivil().add(p_periodeSurMoisCivil);
  }
  
  public final void supprimerPeriodeSurMoisCivil(DomPCSpec p_periodeSurMoisCivil)
    throws NullPointerException
  {
    if (p_periodeSurMoisCivil == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodeSurMoisCivil ne devrait pas être nul.", p_periodeSurMoisCivil);
    }
    getCollectionPeriodeSurMoisCivil().remove(p_periodeSurMoisCivil);
  }
  
  static
  {
    JDOImplHelper.registerClass(MoisCivilPC.class, jdoFieldNames, jdoFieldTypes, jdoFieldFlags, jdoPersistenceCapableSuperclass, new MoisCivilPC());
  }
  
  private static final int jdoGetm_nbJoursTravailles(MoisCivilPC pc)
  {
    if (jdoFlags <= 0) {
      return m_nbJoursTravailles;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 0)) {
        return m_nbJoursTravailles;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 0, m_nbJoursTravailles);
    }
    return m_nbJoursTravailles;
  }
  
  private static final int jdoGetm_nbJoursRetenus(MoisCivilPC pc)
  {
    if (jdoFlags <= 0) {
      return m_nbJoursRetenus;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 1)) {
        return m_nbJoursRetenus;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 1, m_nbJoursRetenus);
    }
    return m_nbJoursRetenus;
  }
  
  private static final Periode jdoGetm_periode(MoisCivilPC pc)
  {
    if (jdoFlags <= 0) {
      return m_periode;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 2)) {
        return m_periode;
      }
      return (Periode)sm.getObjectField(pc, jdoInheritedFieldCount + 2, m_periode);
    }
    return m_periode;
  }
  
  public static final Collection jdoGetm_periodeSurMoisCivil(MoisCivilPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 3)) {
        return m_periodeSurMoisCivil;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 3, m_periodeSurMoisCivil);
    }
    return m_periodeSurMoisCivil;
  }
  
  private static final void jdoSetm_nbJoursTravailles(MoisCivilPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_nbJoursTravailles = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 0, m_nbJoursTravailles, newValue);
    } else {
      m_nbJoursTravailles = newValue;
    }
  }
  
  private static final void jdoSetm_nbJoursRetenus(MoisCivilPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_nbJoursRetenus = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 1, m_nbJoursRetenus, newValue);
    } else {
      m_nbJoursRetenus = newValue;
    }
  }
  
  private static final void jdoSetm_periode(MoisCivilPC pc, Periode newValue)
  {
    if (jdoFlags == 0)
    {
      m_periode = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 2, m_periode, newValue);
    } else {
      m_periode = newValue;
    }
  }
  
  public static final void jdoSetm_periodeSurMoisCivil(MoisCivilPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 3, m_periodeSurMoisCivil, newValue);
    } else {
      m_periodeSurMoisCivil = newValue;
    }
  }
  
  public void jdoProvideField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      jdoStateManager.providedIntField(this, fieldNumber, m_nbJoursTravailles);
      break;
    case 1: 
      jdoStateManager.providedIntField(this, fieldNumber, m_nbJoursRetenus);
      break;
    case 2: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_periode);
      break;
    case 3: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_periodeSurMoisCivil);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoReplaceField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      m_nbJoursTravailles = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 1: 
      m_nbJoursRetenus = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 2: 
      m_periode = ((Periode)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 3: 
      m_periodeSurMoisCivil = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoProvideFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoProvideField(fieldNumber);
    }
  }
  
  public void jdoReplaceFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoReplaceField(fieldNumber);
    }
  }
  
  public synchronized void jdoReplaceStateManager(StateManager sm)
  {
    if (jdoStateManager != null)
    {
      jdoStateManager = jdoStateManager.replacingStateManager(this, sm);
    }
    else
    {
      SecurityManager securityManager = System.getSecurityManager();
      if (securityManager != null) {
        securityManager.checkPermission(JDOPermission.SET_STATE_MANAGER);
      }
      jdoStateManager = sm;
    }
  }
  
  public boolean jdoIsPersistent()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isPersistent(this);
    }
    return false;
  }
  
  public boolean jdoIsTransactional()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isTransactional(this);
    }
    return false;
  }
  
  public boolean jdoIsNew()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isNew(this);
    }
    return false;
  }
  
  public boolean jdoIsDirty()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDirty(this);
    }
    return false;
  }
  
  public boolean jdoIsDeleted()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDeleted(this);
    }
    return false;
  }
  
  public void jdoMakeDirty(String fieldName)
  {
    if (jdoStateManager != null) {
      jdoStateManager.makeDirty(this, fieldName);
    }
  }
  
  public void jdoReplaceFlags()
  {
    if (jdoStateManager != null)
    {
      jdoFlags = jdoStateManager.replacingFlags(this);
      return;
      jdoFlags = 0;
    }
  }
  
  public boolean jdoIsDetached()
  {
    if (jdoStateManager != null) {
      return ((CommonStateManager)jdoStateManager).isDetached();
    }
    return false;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm)
  {
    MoisCivilPC pc = new MoisCivilPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    return pc;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm, Object oid)
  {
    MoisCivilPC pc = new MoisCivilPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    pc.jdoCopyKeyFieldsFromObjectId(oid);
    return pc;
  }
  
  public static int jdoGetManagedFieldCount()
  {
    return jdoInheritedFieldCount + 4;
  }
  
  public void jdoCopyFields(Object pc, int[] fieldNumbers)
  {
    if (!(pc instanceof MoisCivilPC)) {
      throw new JDOFatalInternalException("Can't copy fields from a different class");
    }
    MoisCivilPC other = (MoisCivilPC)pc;
    if (jdoStateManager != jdoStateManager) {
      throw new JDOUserException("Source object should have the same StateManager");
    }
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int relativeField = fieldNumbers[i] - jdoInheritedFieldCount;
      switch (relativeField)
      {
      case 0: 
        m_nbJoursTravailles = m_nbJoursTravailles;
        break;
      case 1: 
        m_nbJoursRetenus = m_nbJoursRetenus;
        break;
      case 2: 
        m_periode = m_periode;
        break;
      case 3: 
        m_periodeSurMoisCivil = m_periodeSurMoisCivil;
      }
    }
  }
  
  public void jdoCopyKeyFieldsToObjectId(Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public void jdoCopyKeyFieldsToObjectId(PersistenceCapable.ObjectIdFieldSupplier supplier, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  protected void jdoCopyKeyFieldsFromObjectId(Object object) {}
  
  public void jdoCopyKeyFieldsFromObjectId(PersistenceCapable.ObjectIdFieldConsumer consumer, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public Object jdoNewObjectIdInstance()
  {
    return null;
  }
  
  public Object jdoNewObjectIdInstance(Object str)
  {
    return null;
  }
  
  public Object jdoGetObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getObjectId(this);
    }
    return null;
  }
  
  public PersistenceManager jdoGetPersistenceManager()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getPersistenceManager(this);
    }
    return null;
  }
  
  private void jdoPreSerialize()
  {
    if (jdoStateManager != null) {
      jdoStateManager.preSerialize(this);
    }
  }
  
  private void writeObject(ObjectOutputStream out)
    throws IOException
  {
    jdoPreSerialize();
    out.defaultWriteObject();
  }
  
  public Object jdoGetTransactionalObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getTransactionalObjectId(this);
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     MoisCivilPC
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */