package fr.unedic.cali.asu.spe02.p03.liquidation.dom.pc;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.PeriodeElementaireAffiliation;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.Periode;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import javax.jdo.JDOFatalInternalException;
import javax.jdo.JDOUnsupportedOptionException;
import javax.jdo.JDOUserException;
import javax.jdo.PersistenceManager;
import javax.jdo.spi.JDOImplHelper;
import javax.jdo.spi.JDOPermission;
import javax.jdo.spi.PersistenceCapable;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldConsumer;
import javax.jdo.spi.PersistenceCapable.ObjectIdFieldSupplier;
import javax.jdo.spi.StateManager;
import xcalia.lido.internal.sm.CommonStateManager;

public class PeriodeElementaireAffiliationPC
  implements DomPCSpec, PersistenceCapable
{
  private transient PeriodeElementaireAffiliation m_periodeElementaireAffiliationOM;
  protected Periode m_mois;
  protected Quantite m_affiliationRetenue;
  protected BigDecimal m_heuresA8;
  protected BigDecimal m_heuresA10;
  protected BigDecimal m_cachetIsoleA8;
  protected BigDecimal m_cachetGroupeA8;
  protected BigDecimal m_cachetIsoleA10;
  protected BigDecimal m_cachetGroupeA10;
  protected BigDecimal m_heuresComplementairesA10;
  protected BigDecimal m_montantPlafondCachets;
  protected BigDecimal m_montantPlafondHeures;
  protected BigDecimal m_quantiteHeureExercee;
  protected BigDecimal m_quantiteCachetGroupeIsoleHeureExercee;
  private BigDecimal m_heuresApresPlafonnementMonoEmployeur;
  private BigDecimal m_heuresApresPlafonnementMultiEmployeur;
  private boolean m_estPlafonneMultiEmployeur;
  public Collection m_listePeriodesElementairesEmployeur;
  protected transient byte jdoFlags;
  protected transient StateManager jdoStateManager;
  private static int jdoInheritedFieldCount = 0;
  private static String[] jdoFieldNames = { "m_mois", "m_affiliationRetenue", "m_heuresA8", "m_heuresA10", "m_cachetIsoleA8", "m_cachetGroupeA8", "m_cachetIsoleA10", "m_cachetGroupeA10", "m_heuresComplementairesA10", "m_montantPlafondCachets", "m_montantPlafondHeures", "m_quantiteHeureExercee", "m_quantiteCachetGroupeIsoleHeureExercee", "m_heuresApresPlafonnementMonoEmployeur", "m_heuresApresPlafonnementMultiEmployeur", "m_estPlafonneMultiEmployeur", "m_listePeriodesElementairesEmployeur" };
  private static Class[] jdoFieldTypes = { Periode.class, Quantite.class, BigDecimal.class, BigDecimal.class, BigDecimal.class, BigDecimal.class, BigDecimal.class, BigDecimal.class, BigDecimal.class, BigDecimal.class, BigDecimal.class, BigDecimal.class, BigDecimal.class, BigDecimal.class, BigDecimal.class, Boolean.TYPE, Collection.class };
  private static byte[] jdoFieldFlags = { (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE) };
  private static Class jdoPersistenceCapableSuperclass = null;
  
  public Object createOM()
  {
    if (m_periodeElementaireAffiliationOM == null) {
      m_periodeElementaireAffiliationOM = new PeriodeElementaireAffiliation(this);
    }
    return m_periodeElementaireAffiliationOM;
  }
  
  public Periode getMois()
  {
    return jdoGetm_mois(this);
  }
  
  public final void setMois(Periode p_mois)
  {
    jdoSetm_mois(this, p_mois);
  }
  
  public Quantite getAffiliationRetenue()
  {
    return jdoGetm_affiliationRetenue(this);
  }
  
  public final void setAffiliationRetenue(Quantite p_affiliationRetenue)
  {
    jdoSetm_affiliationRetenue(this, p_affiliationRetenue);
  }
  
  public BigDecimal getHeuresA8()
  {
    return jdoGetm_heuresA8(this);
  }
  
  public final void setHeuresA8(BigDecimal p_heuresA8)
  {
    jdoSetm_heuresA8(this, p_heuresA8);
  }
  
  public BigDecimal getHeuresA10()
  {
    return jdoGetm_heuresA10(this);
  }
  
  public final void setHeuresA10(BigDecimal p_heuresA10)
  {
    jdoSetm_heuresA10(this, p_heuresA10);
  }
  
  public BigDecimal getCachetIsoleA8()
  {
    return jdoGetm_cachetIsoleA8(this);
  }
  
  public final void setCachetIsoleA8(BigDecimal p_cachetIsoleA8)
  {
    jdoSetm_cachetIsoleA8(this, p_cachetIsoleA8);
  }
  
  public BigDecimal getCachetGroupeA8()
  {
    return jdoGetm_cachetGroupeA8(this);
  }
  
  public final void setCachetGroupeA8(BigDecimal p_cachetGroupeA8)
  {
    jdoSetm_cachetGroupeA8(this, p_cachetGroupeA8);
  }
  
  public BigDecimal getCachetIsoleA10()
  {
    return jdoGetm_cachetIsoleA10(this);
  }
  
  public final void setCachetIsoleA10(BigDecimal p_cachetIsoleA10)
  {
    jdoSetm_cachetIsoleA10(this, p_cachetIsoleA10);
  }
  
  public BigDecimal getCachetGroupeA10()
  {
    return jdoGetm_cachetGroupeA10(this);
  }
  
  public final void setCachetGroupeA10(BigDecimal p_cachetGroupeA10)
  {
    jdoSetm_cachetGroupeA10(this, p_cachetGroupeA10);
  }
  
  public BigDecimal getHeuresComplementairesA10()
  {
    return jdoGetm_heuresComplementairesA10(this);
  }
  
  public final void setHeuresComplementairesA10(BigDecimal p_heuresComplementairesA10)
  {
    jdoSetm_heuresComplementairesA10(this, p_heuresComplementairesA10);
  }
  
  public BigDecimal getMontantPlafondCachets()
  {
    return jdoGetm_montantPlafondCachets(this);
  }
  
  public final void setMontantPlafondCachets(BigDecimal p_montantPlafondCachets)
  {
    jdoSetm_montantPlafondCachets(this, p_montantPlafondCachets);
  }
  
  public BigDecimal getMontantPlafondHeures()
  {
    return jdoGetm_montantPlafondHeures(this);
  }
  
  public final void setMontantPlafondHeures(BigDecimal p_montantPlafondHeures)
  {
    jdoSetm_montantPlafondHeures(this, p_montantPlafondHeures);
  }
  
  public BigDecimal getQuantiteHeureExercee()
  {
    return jdoGetm_quantiteHeureExercee(this);
  }
  
  public final void setQuantiteHeureExercee(BigDecimal p_quantiteHeureExercee)
  {
    jdoSetm_quantiteHeureExercee(this, p_quantiteHeureExercee);
  }
  
  public BigDecimal getQuantiteCachetGroupeIsoleHeureExercee()
  {
    return jdoGetm_quantiteCachetGroupeIsoleHeureExercee(this);
  }
  
  public final void setQuantiteCachetGroupeIsoleHeureExercee(BigDecimal p_quantiteCachetGroupeIsoleHeureExercee)
  {
    jdoSetm_quantiteCachetGroupeIsoleHeureExercee(this, p_quantiteCachetGroupeIsoleHeureExercee);
  }
  
  public BigDecimal getHeuresApresPlafonnementMonoEmployeur()
  {
    return jdoGetm_heuresApresPlafonnementMonoEmployeur(this);
  }
  
  public final void setHeuresApresPlafonnementMonoEmployeur(BigDecimal p_heuresApresPlafonnementMonoEmployeur)
  {
    jdoSetm_heuresApresPlafonnementMonoEmployeur(this, p_heuresApresPlafonnementMonoEmployeur);
  }
  
  public BigDecimal getHeuresApresPlafonnementMultiEmployeur()
  {
    return jdoGetm_heuresApresPlafonnementMultiEmployeur(this);
  }
  
  public final void setHeuresApresPlafonnementMultiEmployeur(BigDecimal p_heuresApresPlafonnementMultiEmployeur)
  {
    jdoSetm_heuresApresPlafonnementMultiEmployeur(this, p_heuresApresPlafonnementMultiEmployeur);
  }
  
  public boolean isEstPlafonneMultiEmployeur()
  {
    return jdoGetm_estPlafonneMultiEmployeur(this);
  }
  
  public final void setEstPlafonneMultiEmployeur(boolean p_estPlafonneMultiEmployeur)
  {
    jdoSetm_estPlafonneMultiEmployeur(this, p_estPlafonneMultiEmployeur);
  }
  
  public final Collection getCollectionPeriodeElementaireEmployeur()
  {
    if (jdoGetm_listePeriodesElementairesEmployeur(this) == null) {
      jdoSetm_listePeriodesElementairesEmployeur(this, new ArrayList());
    }
    return jdoGetm_listePeriodesElementairesEmployeur(this);
  }
  
  public final void ajouterPeriodeElementaireEmployeur(DomPCSpec p_periodesElementairesEmployeur)
    throws NullPointerException
  {
    if (p_periodesElementairesEmployeur == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodesElementairesEmployeur ne devrait pas être nul.", p_periodesElementairesEmployeur);
    }
    getCollectionPeriodeElementaireEmployeur().add(p_periodesElementairesEmployeur);
  }
  
  public final void supprimerPeriodeElementaireEmployeur(DomPCSpec p_periodesElementairesEmployeur)
    throws NullPointerException
  {
    if (p_periodesElementairesEmployeur == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodesElementairesEmployeur ne devrait pas être nul.", p_periodesElementairesEmployeur);
    }
    getCollectionPeriodeElementaireEmployeur().remove(p_periodesElementairesEmployeur);
  }
  
  static
  {
    JDOImplHelper.registerClass(PeriodeElementaireAffiliationPC.class, jdoFieldNames, jdoFieldTypes, jdoFieldFlags, jdoPersistenceCapableSuperclass, new PeriodeElementaireAffiliationPC());
  }
  
  protected static final Periode jdoGetm_mois(PeriodeElementaireAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_mois;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 0)) {
        return m_mois;
      }
      return (Periode)sm.getObjectField(pc, jdoInheritedFieldCount + 0, m_mois);
    }
    return m_mois;
  }
  
  protected static final Quantite jdoGetm_affiliationRetenue(PeriodeElementaireAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_affiliationRetenue;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 1)) {
        return m_affiliationRetenue;
      }
      return (Quantite)sm.getObjectField(pc, jdoInheritedFieldCount + 1, m_affiliationRetenue);
    }
    return m_affiliationRetenue;
  }
  
  protected static final BigDecimal jdoGetm_heuresA8(PeriodeElementaireAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_heuresA8;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 2)) {
        return m_heuresA8;
      }
      return (BigDecimal)sm.getObjectField(pc, jdoInheritedFieldCount + 2, m_heuresA8);
    }
    return m_heuresA8;
  }
  
  protected static final BigDecimal jdoGetm_heuresA10(PeriodeElementaireAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_heuresA10;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 3)) {
        return m_heuresA10;
      }
      return (BigDecimal)sm.getObjectField(pc, jdoInheritedFieldCount + 3, m_heuresA10);
    }
    return m_heuresA10;
  }
  
  protected static final BigDecimal jdoGetm_cachetIsoleA8(PeriodeElementaireAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_cachetIsoleA8;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 4)) {
        return m_cachetIsoleA8;
      }
      return (BigDecimal)sm.getObjectField(pc, jdoInheritedFieldCount + 4, m_cachetIsoleA8);
    }
    return m_cachetIsoleA8;
  }
  
  protected static final BigDecimal jdoGetm_cachetGroupeA8(PeriodeElementaireAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_cachetGroupeA8;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 5)) {
        return m_cachetGroupeA8;
      }
      return (BigDecimal)sm.getObjectField(pc, jdoInheritedFieldCount + 5, m_cachetGroupeA8);
    }
    return m_cachetGroupeA8;
  }
  
  protected static final BigDecimal jdoGetm_cachetIsoleA10(PeriodeElementaireAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_cachetIsoleA10;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 6)) {
        return m_cachetIsoleA10;
      }
      return (BigDecimal)sm.getObjectField(pc, jdoInheritedFieldCount + 6, m_cachetIsoleA10);
    }
    return m_cachetIsoleA10;
  }
  
  protected static final BigDecimal jdoGetm_cachetGroupeA10(PeriodeElementaireAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_cachetGroupeA10;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 7)) {
        return m_cachetGroupeA10;
      }
      return (BigDecimal)sm.getObjectField(pc, jdoInheritedFieldCount + 7, m_cachetGroupeA10);
    }
    return m_cachetGroupeA10;
  }
  
  protected static final BigDecimal jdoGetm_heuresComplementairesA10(PeriodeElementaireAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_heuresComplementairesA10;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 8)) {
        return m_heuresComplementairesA10;
      }
      return (BigDecimal)sm.getObjectField(pc, jdoInheritedFieldCount + 8, m_heuresComplementairesA10);
    }
    return m_heuresComplementairesA10;
  }
  
  protected static final BigDecimal jdoGetm_montantPlafondCachets(PeriodeElementaireAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_montantPlafondCachets;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 9)) {
        return m_montantPlafondCachets;
      }
      return (BigDecimal)sm.getObjectField(pc, jdoInheritedFieldCount + 9, m_montantPlafondCachets);
    }
    return m_montantPlafondCachets;
  }
  
  protected static final BigDecimal jdoGetm_montantPlafondHeures(PeriodeElementaireAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_montantPlafondHeures;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 10)) {
        return m_montantPlafondHeures;
      }
      return (BigDecimal)sm.getObjectField(pc, jdoInheritedFieldCount + 10, m_montantPlafondHeures);
    }
    return m_montantPlafondHeures;
  }
  
  protected static final BigDecimal jdoGetm_quantiteHeureExercee(PeriodeElementaireAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_quantiteHeureExercee;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 11)) {
        return m_quantiteHeureExercee;
      }
      return (BigDecimal)sm.getObjectField(pc, jdoInheritedFieldCount + 11, m_quantiteHeureExercee);
    }
    return m_quantiteHeureExercee;
  }
  
  protected static final BigDecimal jdoGetm_quantiteCachetGroupeIsoleHeureExercee(PeriodeElementaireAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_quantiteCachetGroupeIsoleHeureExercee;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 12)) {
        return m_quantiteCachetGroupeIsoleHeureExercee;
      }
      return (BigDecimal)sm.getObjectField(pc, jdoInheritedFieldCount + 12, m_quantiteCachetGroupeIsoleHeureExercee);
    }
    return m_quantiteCachetGroupeIsoleHeureExercee;
  }
  
  private static final BigDecimal jdoGetm_heuresApresPlafonnementMonoEmployeur(PeriodeElementaireAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_heuresApresPlafonnementMonoEmployeur;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 13)) {
        return m_heuresApresPlafonnementMonoEmployeur;
      }
      return (BigDecimal)sm.getObjectField(pc, jdoInheritedFieldCount + 13, m_heuresApresPlafonnementMonoEmployeur);
    }
    return m_heuresApresPlafonnementMonoEmployeur;
  }
  
  private static final BigDecimal jdoGetm_heuresApresPlafonnementMultiEmployeur(PeriodeElementaireAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_heuresApresPlafonnementMultiEmployeur;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 14)) {
        return m_heuresApresPlafonnementMultiEmployeur;
      }
      return (BigDecimal)sm.getObjectField(pc, jdoInheritedFieldCount + 14, m_heuresApresPlafonnementMultiEmployeur);
    }
    return m_heuresApresPlafonnementMultiEmployeur;
  }
  
  private static final boolean jdoGetm_estPlafonneMultiEmployeur(PeriodeElementaireAffiliationPC pc)
  {
    if (jdoFlags <= 0) {
      return m_estPlafonneMultiEmployeur;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 15)) {
        return m_estPlafonneMultiEmployeur;
      }
      return sm.getBooleanField(pc, jdoInheritedFieldCount + 15, m_estPlafonneMultiEmployeur);
    }
    return m_estPlafonneMultiEmployeur;
  }
  
  public static final Collection jdoGetm_listePeriodesElementairesEmployeur(PeriodeElementaireAffiliationPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 16)) {
        return m_listePeriodesElementairesEmployeur;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 16, m_listePeriodesElementairesEmployeur);
    }
    return m_listePeriodesElementairesEmployeur;
  }
  
  protected static final void jdoSetm_mois(PeriodeElementaireAffiliationPC pc, Periode newValue)
  {
    if (jdoFlags == 0)
    {
      m_mois = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 0, m_mois, newValue);
    } else {
      m_mois = newValue;
    }
  }
  
  protected static final void jdoSetm_affiliationRetenue(PeriodeElementaireAffiliationPC pc, Quantite newValue)
  {
    if (jdoFlags == 0)
    {
      m_affiliationRetenue = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 1, m_affiliationRetenue, newValue);
    } else {
      m_affiliationRetenue = newValue;
    }
  }
  
  protected static final void jdoSetm_heuresA8(PeriodeElementaireAffiliationPC pc, BigDecimal newValue)
  {
    if (jdoFlags == 0)
    {
      m_heuresA8 = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 2, m_heuresA8, newValue);
    } else {
      m_heuresA8 = newValue;
    }
  }
  
  protected static final void jdoSetm_heuresA10(PeriodeElementaireAffiliationPC pc, BigDecimal newValue)
  {
    if (jdoFlags == 0)
    {
      m_heuresA10 = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 3, m_heuresA10, newValue);
    } else {
      m_heuresA10 = newValue;
    }
  }
  
  protected static final void jdoSetm_cachetIsoleA8(PeriodeElementaireAffiliationPC pc, BigDecimal newValue)
  {
    if (jdoFlags == 0)
    {
      m_cachetIsoleA8 = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 4, m_cachetIsoleA8, newValue);
    } else {
      m_cachetIsoleA8 = newValue;
    }
  }
  
  protected static final void jdoSetm_cachetGroupeA8(PeriodeElementaireAffiliationPC pc, BigDecimal newValue)
  {
    if (jdoFlags == 0)
    {
      m_cachetGroupeA8 = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 5, m_cachetGroupeA8, newValue);
    } else {
      m_cachetGroupeA8 = newValue;
    }
  }
  
  protected static final void jdoSetm_cachetIsoleA10(PeriodeElementaireAffiliationPC pc, BigDecimal newValue)
  {
    if (jdoFlags == 0)
    {
      m_cachetIsoleA10 = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 6, m_cachetIsoleA10, newValue);
    } else {
      m_cachetIsoleA10 = newValue;
    }
  }
  
  protected static final void jdoSetm_cachetGroupeA10(PeriodeElementaireAffiliationPC pc, BigDecimal newValue)
  {
    if (jdoFlags == 0)
    {
      m_cachetGroupeA10 = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 7, m_cachetGroupeA10, newValue);
    } else {
      m_cachetGroupeA10 = newValue;
    }
  }
  
  protected static final void jdoSetm_heuresComplementairesA10(PeriodeElementaireAffiliationPC pc, BigDecimal newValue)
  {
    if (jdoFlags == 0)
    {
      m_heuresComplementairesA10 = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 8, m_heuresComplementairesA10, newValue);
    } else {
      m_heuresComplementairesA10 = newValue;
    }
  }
  
  protected static final void jdoSetm_montantPlafondCachets(PeriodeElementaireAffiliationPC pc, BigDecimal newValue)
  {
    if (jdoFlags == 0)
    {
      m_montantPlafondCachets = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 9, m_montantPlafondCachets, newValue);
    } else {
      m_montantPlafondCachets = newValue;
    }
  }
  
  protected static final void jdoSetm_montantPlafondHeures(PeriodeElementaireAffiliationPC pc, BigDecimal newValue)
  {
    if (jdoFlags == 0)
    {
      m_montantPlafondHeures = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 10, m_montantPlafondHeures, newValue);
    } else {
      m_montantPlafondHeures = newValue;
    }
  }
  
  protected static final void jdoSetm_quantiteHeureExercee(PeriodeElementaireAffiliationPC pc, BigDecimal newValue)
  {
    if (jdoFlags == 0)
    {
      m_quantiteHeureExercee = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 11, m_quantiteHeureExercee, newValue);
    } else {
      m_quantiteHeureExercee = newValue;
    }
  }
  
  protected static final void jdoSetm_quantiteCachetGroupeIsoleHeureExercee(PeriodeElementaireAffiliationPC pc, BigDecimal newValue)
  {
    if (jdoFlags == 0)
    {
      m_quantiteCachetGroupeIsoleHeureExercee = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 12, m_quantiteCachetGroupeIsoleHeureExercee, newValue);
    } else {
      m_quantiteCachetGroupeIsoleHeureExercee = newValue;
    }
  }
  
  private static final void jdoSetm_heuresApresPlafonnementMonoEmployeur(PeriodeElementaireAffiliationPC pc, BigDecimal newValue)
  {
    if (jdoFlags == 0)
    {
      m_heuresApresPlafonnementMonoEmployeur = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 13, m_heuresApresPlafonnementMonoEmployeur, newValue);
    } else {
      m_heuresApresPlafonnementMonoEmployeur = newValue;
    }
  }
  
  private static final void jdoSetm_heuresApresPlafonnementMultiEmployeur(PeriodeElementaireAffiliationPC pc, BigDecimal newValue)
  {
    if (jdoFlags == 0)
    {
      m_heuresApresPlafonnementMultiEmployeur = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 14, m_heuresApresPlafonnementMultiEmployeur, newValue);
    } else {
      m_heuresApresPlafonnementMultiEmployeur = newValue;
    }
  }
  
  private static final void jdoSetm_estPlafonneMultiEmployeur(PeriodeElementaireAffiliationPC pc, boolean newValue)
  {
    if (jdoFlags == 0)
    {
      m_estPlafonneMultiEmployeur = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setBooleanField(pc, jdoInheritedFieldCount + 15, m_estPlafonneMultiEmployeur, newValue);
    } else {
      m_estPlafonneMultiEmployeur = newValue;
    }
  }
  
  public static final void jdoSetm_listePeriodesElementairesEmployeur(PeriodeElementaireAffiliationPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 16, m_listePeriodesElementairesEmployeur, newValue);
    } else {
      m_listePeriodesElementairesEmployeur = newValue;
    }
  }
  
  public void jdoProvideField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_mois);
      break;
    case 1: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_affiliationRetenue);
      break;
    case 2: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_heuresA8);
      break;
    case 3: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_heuresA10);
      break;
    case 4: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_cachetIsoleA8);
      break;
    case 5: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_cachetGroupeA8);
      break;
    case 6: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_cachetIsoleA10);
      break;
    case 7: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_cachetGroupeA10);
      break;
    case 8: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_heuresComplementairesA10);
      break;
    case 9: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_montantPlafondCachets);
      break;
    case 10: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_montantPlafondHeures);
      break;
    case 11: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_quantiteHeureExercee);
      break;
    case 12: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_quantiteCachetGroupeIsoleHeureExercee);
      break;
    case 13: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_heuresApresPlafonnementMonoEmployeur);
      break;
    case 14: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_heuresApresPlafonnementMultiEmployeur);
      break;
    case 15: 
      jdoStateManager.providedBooleanField(this, fieldNumber, m_estPlafonneMultiEmployeur);
      break;
    case 16: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_listePeriodesElementairesEmployeur);
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoReplaceField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      m_mois = ((Periode)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 1: 
      m_affiliationRetenue = ((Quantite)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 2: 
      m_heuresA8 = ((BigDecimal)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 3: 
      m_heuresA10 = ((BigDecimal)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 4: 
      m_cachetIsoleA8 = ((BigDecimal)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 5: 
      m_cachetGroupeA8 = ((BigDecimal)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 6: 
      m_cachetIsoleA10 = ((BigDecimal)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 7: 
      m_cachetGroupeA10 = ((BigDecimal)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 8: 
      m_heuresComplementairesA10 = ((BigDecimal)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 9: 
      m_montantPlafondCachets = ((BigDecimal)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 10: 
      m_montantPlafondHeures = ((BigDecimal)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 11: 
      m_quantiteHeureExercee = ((BigDecimal)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 12: 
      m_quantiteCachetGroupeIsoleHeureExercee = ((BigDecimal)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 13: 
      m_heuresApresPlafonnementMonoEmployeur = ((BigDecimal)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 14: 
      m_heuresApresPlafonnementMultiEmployeur = ((BigDecimal)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 15: 
      m_estPlafonneMultiEmployeur = jdoStateManager.replacingBooleanField(this, fieldNumber);
      break;
    case 16: 
      m_listePeriodesElementairesEmployeur = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    default: 
      throw new JDOFatalInternalException("index of field is out of bound");
    }
  }
  
  public void jdoProvideFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoProvideField(fieldNumber);
    }
  }
  
  public void jdoReplaceFields(int[] fieldNumbers)
  {
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int fieldNumber = fieldNumbers[i];
      jdoReplaceField(fieldNumber);
    }
  }
  
  public synchronized void jdoReplaceStateManager(StateManager sm)
  {
    if (jdoStateManager != null)
    {
      jdoStateManager = jdoStateManager.replacingStateManager(this, sm);
    }
    else
    {
      SecurityManager securityManager = System.getSecurityManager();
      if (securityManager != null) {
        securityManager.checkPermission(JDOPermission.SET_STATE_MANAGER);
      }
      jdoStateManager = sm;
    }
  }
  
  public boolean jdoIsPersistent()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isPersistent(this);
    }
    return false;
  }
  
  public boolean jdoIsTransactional()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isTransactional(this);
    }
    return false;
  }
  
  public boolean jdoIsNew()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isNew(this);
    }
    return false;
  }
  
  public boolean jdoIsDirty()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDirty(this);
    }
    return false;
  }
  
  public boolean jdoIsDeleted()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.isDeleted(this);
    }
    return false;
  }
  
  public void jdoMakeDirty(String fieldName)
  {
    if (jdoStateManager != null) {
      jdoStateManager.makeDirty(this, fieldName);
    }
  }
  
  public void jdoReplaceFlags()
  {
    if (jdoStateManager != null)
    {
      jdoFlags = jdoStateManager.replacingFlags(this);
      return;
      jdoFlags = 0;
    }
  }
  
  public boolean jdoIsDetached()
  {
    if (jdoStateManager != null) {
      return ((CommonStateManager)jdoStateManager).isDetached();
    }
    return false;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm)
  {
    PeriodeElementaireAffiliationPC pc = new PeriodeElementaireAffiliationPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    return pc;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm, Object oid)
  {
    PeriodeElementaireAffiliationPC pc = new PeriodeElementaireAffiliationPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    pc.jdoCopyKeyFieldsFromObjectId(oid);
    return pc;
  }
  
  public static int jdoGetManagedFieldCount()
  {
    return jdoInheritedFieldCount + 17;
  }
  
  public void jdoCopyFields(Object pc, int[] fieldNumbers)
  {
    if (!(pc instanceof PeriodeElementaireAffiliationPC)) {
      throw new JDOFatalInternalException("Can't copy fields from a different class");
    }
    PeriodeElementaireAffiliationPC other = (PeriodeElementaireAffiliationPC)pc;
    if (jdoStateManager != jdoStateManager) {
      throw new JDOUserException("Source object should have the same StateManager");
    }
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int relativeField = fieldNumbers[i] - jdoInheritedFieldCount;
      switch (relativeField)
      {
      case 0: 
        m_mois = m_mois;
        break;
      case 1: 
        m_affiliationRetenue = m_affiliationRetenue;
        break;
      case 2: 
        m_heuresA8 = m_heuresA8;
        break;
      case 3: 
        m_heuresA10 = m_heuresA10;
        break;
      case 4: 
        m_cachetIsoleA8 = m_cachetIsoleA8;
        break;
      case 5: 
        m_cachetGroupeA8 = m_cachetGroupeA8;
        break;
      case 6: 
        m_cachetIsoleA10 = m_cachetIsoleA10;
        break;
      case 7: 
        m_cachetGroupeA10 = m_cachetGroupeA10;
        break;
      case 8: 
        m_heuresComplementairesA10 = m_heuresComplementairesA10;
        break;
      case 9: 
        m_montantPlafondCachets = m_montantPlafondCachets;
        break;
      case 10: 
        m_montantPlafondHeures = m_montantPlafondHeures;
        break;
      case 11: 
        m_quantiteHeureExercee = m_quantiteHeureExercee;
        break;
      case 12: 
        m_quantiteCachetGroupeIsoleHeureExercee = m_quantiteCachetGroupeIsoleHeureExercee;
        break;
      case 13: 
        m_heuresApresPlafonnementMonoEmployeur = m_heuresApresPlafonnementMonoEmployeur;
        break;
      case 14: 
        m_heuresApresPlafonnementMultiEmployeur = m_heuresApresPlafonnementMultiEmployeur;
        break;
      case 15: 
        m_estPlafonneMultiEmployeur = m_estPlafonneMultiEmployeur;
        break;
      case 16: 
        m_listePeriodesElementairesEmployeur = m_listePeriodesElementairesEmployeur;
      }
    }
  }
  
  public void jdoCopyKeyFieldsToObjectId(Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public void jdoCopyKeyFieldsToObjectId(PersistenceCapable.ObjectIdFieldSupplier supplier, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  protected void jdoCopyKeyFieldsFromObjectId(Object object) {}
  
  public void jdoCopyKeyFieldsFromObjectId(PersistenceCapable.ObjectIdFieldConsumer consumer, Object object)
  {
    throw new JDOUnsupportedOptionException("Can't be used without Application Identity");
  }
  
  public Object jdoNewObjectIdInstance()
  {
    return null;
  }
  
  public Object jdoNewObjectIdInstance(Object str)
  {
    return null;
  }
  
  public Object jdoGetObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getObjectId(this);
    }
    return null;
  }
  
  public PersistenceManager jdoGetPersistenceManager()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getPersistenceManager(this);
    }
    return null;
  }
  
  private void jdoPreSerialize()
  {
    if (jdoStateManager != null) {
      jdoStateManager.preSerialize(this);
    }
  }
  
  private void writeObject(ObjectOutputStream out)
    throws IOException
  {
    jdoPreSerialize();
    out.defaultWriteObject();
  }
  
  public Object jdoGetTransactionalObjectId()
  {
    if (jdoStateManager != null) {
      return jdoStateManager.getTransactionalObjectId(this);
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     PeriodeElementaireAffiliationPC
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */