package fr.unedic.cali.asu.spe02.p03.liquidation.dom.pc;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ValidationProduit;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.Quantite;
import java.util.ArrayList;
import java.util.Collection;
import javax.jdo.JDOFatalInternalException;
import javax.jdo.JDOUserException;
import javax.jdo.spi.JDOImplHelper;
import javax.jdo.spi.PersistenceCapable;
import javax.jdo.spi.StateManager;

public class ValidationProduitPC
  extends fr.unedic.cali.asu.dom.pc.ValidationProduitPC
  implements DomPCSpec, PersistenceCapable
{
  protected boolean m_presenceDonneesJustificationAffiliation;
  private transient ValidationProduit m_validationProduitOM;
  protected int m_rangAllongement;
  protected Quantite m_heuresRequises;
  protected boolean m_estProduitValide;
  protected Collection m_listeAllongementsPra;
  protected Collection m_listeActivitesParticipantes;
  protected Collection m_listeAffiliationsAssimilees;
  protected Collection m_listeAffiliationsSupplementaires;
  protected Collection m_listePeriodesElementairesAffiliation;
  private static int jdoInheritedFieldCount = ;
  private static String[] jdoFieldNames = { "m_presenceDonneesJustificationAffiliation", "m_rangAllongement", "m_heuresRequises", "m_estProduitValide", "m_listeAllongementsPra", "m_listeActivitesParticipantes", "m_listeAffiliationsAssimilees", "m_listeAffiliationsSupplementaires", "m_listePeriodesElementairesAffiliation" };
  private static Class[] jdoFieldTypes = { Boolean.TYPE, Integer.TYPE, Quantite.class, Boolean.TYPE, Collection.class, Collection.class, Collection.class, Collection.class, Collection.class };
  private static byte[] jdoFieldFlags = { (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.CHECK_READ + PersistenceCapable.CHECK_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE), (byte)(PersistenceCapable.MEDIATE_READ + PersistenceCapable.MEDIATE_WRITE) };
  private static Class jdoPersistenceCapableSuperclass = class$("fr.unedic.cali.asu.dom.pc.ValidationProduitPC");
  
  public ValidationProduitPC()
  {
    jdoSetm_presenceDonneesJustificationAffiliation(this, false);
  }
  
  public Object createOM()
  {
    if (m_validationProduitOM == null) {
      m_validationProduitOM = new ValidationProduit(this);
    }
    return m_validationProduitOM;
  }
  
  public boolean isPresenceDonneesJustificationAffiliation()
  {
    return jdoGetm_presenceDonneesJustificationAffiliation(this);
  }
  
  public final void setPresenceDonneesJustificationAffiliation(boolean p_presenceDonneesJustificationAffiliation)
  {
    jdoSetm_presenceDonneesJustificationAffiliation(this, p_presenceDonneesJustificationAffiliation);
  }
  
  public int getRangAllongement()
  {
    return jdoGetm_rangAllongement(this);
  }
  
  public final void setRangAllongement(int p_rangAllongement)
  {
    jdoSetm_rangAllongement(this, p_rangAllongement);
  }
  
  public Quantite getHeuresRequises()
  {
    return jdoGetm_heuresRequises(this);
  }
  
  public final void setHeuresRequises(Quantite p_heuresRequises)
  {
    jdoSetm_heuresRequises(this, p_heuresRequises);
  }
  
  public boolean isEstProduitValide()
  {
    return jdoGetm_estProduitValide(this);
  }
  
  public final void setEstProduitValide(boolean p_estProduitValide)
  {
    jdoSetm_estProduitValide(this, p_estProduitValide);
  }
  
  public final Collection getCollectionAllongementPra()
  {
    if (jdoGetm_listeAllongementsPra(this) == null) {
      jdoSetm_listeAllongementsPra(this, new ArrayList());
    }
    return jdoGetm_listeAllongementsPra(this);
  }
  
  public final void ajouterAllongementPra(DomPCSpec p_allongementsPra)
    throws NullPointerException
  {
    if (p_allongementsPra == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_allongementsPra ne devrait pas être nul.", p_allongementsPra);
    }
    getCollectionAllongementPra().add(p_allongementsPra);
  }
  
  public final void supprimerAllongementPra(DomPCSpec p_allongementsPra)
    throws NullPointerException
  {
    if (p_allongementsPra == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_allongementsPra ne devrait pas être nul.", p_allongementsPra);
    }
    getCollectionAllongementPra().remove(p_allongementsPra);
  }
  
  public final Collection getCollectionActiviteParticipante()
  {
    if (jdoGetm_listeActivitesParticipantes(this) == null) {
      jdoSetm_listeActivitesParticipantes(this, new ArrayList());
    }
    return jdoGetm_listeActivitesParticipantes(this);
  }
  
  public final void ajouterActiviteParticipante(DomPCSpec p_activitesParticipantes)
    throws NullPointerException
  {
    if (p_activitesParticipantes == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_activitesParticipantes ne devrait pas être nul.", p_activitesParticipantes);
    }
    getCollectionActiviteParticipante().add(p_activitesParticipantes);
  }
  
  public final void supprimerActiviteParticipante(DomPCSpec p_activitesParticipantes)
    throws NullPointerException
  {
    if (p_activitesParticipantes == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_activitesParticipantes ne devrait pas être nul.", p_activitesParticipantes);
    }
    getCollectionActiviteParticipante().remove(p_activitesParticipantes);
  }
  
  public final Collection getCollectionAssimilation()
  {
    if (jdoGetm_listeAffiliationsAssimilees(this) == null) {
      jdoSetm_listeAffiliationsAssimilees(this, new ArrayList());
    }
    return jdoGetm_listeAffiliationsAssimilees(this);
  }
  
  public final void ajouterAssimilation(DomPCSpec p_affiliationsAssimilees)
    throws NullPointerException
  {
    if (p_affiliationsAssimilees == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_affiliationsAssimilees ne devrait pas être nul.", p_affiliationsAssimilees);
    }
    getCollectionAssimilation().add(p_affiliationsAssimilees);
  }
  
  public final void supprimerAssimilation(DomPCSpec p_affiliationsAssimilees)
    throws NullPointerException
  {
    if (p_affiliationsAssimilees == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_affiliationsAssimilees ne devrait pas être nul.", p_affiliationsAssimilees);
    }
    getCollectionAssimilation().remove(p_affiliationsAssimilees);
  }
  
  public final Collection getCollectionAffiliationSupplementaire()
  {
    if (jdoGetm_listeAffiliationsSupplementaires(this) == null) {
      jdoSetm_listeAffiliationsSupplementaires(this, new ArrayList());
    }
    return jdoGetm_listeAffiliationsSupplementaires(this);
  }
  
  public final void ajouterAffiliationSupplementaire(DomPCSpec p_affiliationsSupplementaires)
    throws NullPointerException
  {
    if (p_affiliationsSupplementaires == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_affiliationsSupplementaires ne devrait pas être nul.", p_affiliationsSupplementaires);
    }
    getCollectionAffiliationSupplementaire().add(p_affiliationsSupplementaires);
  }
  
  public final void supprimerAffiliationSupplementaire(DomPCSpec p_affiliationsSupplementaires)
    throws NullPointerException
  {
    if (p_affiliationsSupplementaires == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_affiliationsSupplementaires ne devrait pas être nul.", p_affiliationsSupplementaires);
    }
    getCollectionAffiliationSupplementaire().remove(p_affiliationsSupplementaires);
  }
  
  public final Collection getCollectionPeriodeElementaireAffiliation()
  {
    if (jdoGetm_listePeriodesElementairesAffiliation(this) == null) {
      jdoSetm_listePeriodesElementairesAffiliation(this, new ArrayList());
    }
    return jdoGetm_listePeriodesElementairesAffiliation(this);
  }
  
  public final void ajouterPeriodeElementaireAffiliation(DomPCSpec p_periodesElementairesAffiliation)
    throws NullPointerException
  {
    if (p_periodesElementairesAffiliation == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodesElementairesAffiliation ne devrait pas être nul.", p_periodesElementairesAffiliation);
    }
    getCollectionPeriodeElementaireAffiliation().add(p_periodesElementairesAffiliation);
  }
  
  public final void supprimerPeriodeElementaireAffiliation(DomPCSpec p_periodesElementairesAffiliation)
    throws NullPointerException
  {
    if (p_periodesElementairesAffiliation == null) {
      ExceptionUtil.assertInternalNotNull("Le paramètre p_periodesElementairesAffiliation ne devrait pas être nul.", p_periodesElementairesAffiliation);
    }
    getCollectionPeriodeElementaireAffiliation().remove(p_periodesElementairesAffiliation);
  }
  
  static
  {
    JDOImplHelper.registerClass(ValidationProduitPC.class, jdoFieldNames, jdoFieldTypes, jdoFieldFlags, jdoPersistenceCapableSuperclass, new ValidationProduitPC());
  }
  
  protected static final boolean jdoGetm_presenceDonneesJustificationAffiliation(ValidationProduitPC pc)
  {
    if (jdoFlags <= 0) {
      return m_presenceDonneesJustificationAffiliation;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 0)) {
        return m_presenceDonneesJustificationAffiliation;
      }
      return sm.getBooleanField(pc, jdoInheritedFieldCount + 0, m_presenceDonneesJustificationAffiliation);
    }
    return m_presenceDonneesJustificationAffiliation;
  }
  
  protected static final int jdoGetm_rangAllongement(ValidationProduitPC pc)
  {
    if (jdoFlags <= 0) {
      return m_rangAllongement;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 1)) {
        return m_rangAllongement;
      }
      return sm.getIntField(pc, jdoInheritedFieldCount + 1, m_rangAllongement);
    }
    return m_rangAllongement;
  }
  
  protected static final Quantite jdoGetm_heuresRequises(ValidationProduitPC pc)
  {
    if (jdoFlags <= 0) {
      return m_heuresRequises;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 2)) {
        return m_heuresRequises;
      }
      return (Quantite)sm.getObjectField(pc, jdoInheritedFieldCount + 2, m_heuresRequises);
    }
    return m_heuresRequises;
  }
  
  protected static final boolean jdoGetm_estProduitValide(ValidationProduitPC pc)
  {
    if (jdoFlags <= 0) {
      return m_estProduitValide;
    }
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 3)) {
        return m_estProduitValide;
      }
      return sm.getBooleanField(pc, jdoInheritedFieldCount + 3, m_estProduitValide);
    }
    return m_estProduitValide;
  }
  
  protected static final Collection jdoGetm_listeAllongementsPra(ValidationProduitPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 4)) {
        return m_listeAllongementsPra;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 4, m_listeAllongementsPra);
    }
    return m_listeAllongementsPra;
  }
  
  protected static final Collection jdoGetm_listeActivitesParticipantes(ValidationProduitPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 5)) {
        return m_listeActivitesParticipantes;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 5, m_listeActivitesParticipantes);
    }
    return m_listeActivitesParticipantes;
  }
  
  protected static final Collection jdoGetm_listeAffiliationsAssimilees(ValidationProduitPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 6)) {
        return m_listeAffiliationsAssimilees;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 6, m_listeAffiliationsAssimilees);
    }
    return m_listeAffiliationsAssimilees;
  }
  
  protected static final Collection jdoGetm_listeAffiliationsSupplementaires(ValidationProduitPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 7)) {
        return m_listeAffiliationsSupplementaires;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 7, m_listeAffiliationsSupplementaires);
    }
    return m_listeAffiliationsSupplementaires;
  }
  
  protected static final Collection jdoGetm_listePeriodesElementairesAffiliation(ValidationProduitPC pc)
  {
    StateManager sm = jdoStateManager;
    if (sm != null)
    {
      if (sm.isLoaded(pc, jdoInheritedFieldCount + 8)) {
        return m_listePeriodesElementairesAffiliation;
      }
      return (Collection)sm.getObjectField(pc, jdoInheritedFieldCount + 8, m_listePeriodesElementairesAffiliation);
    }
    return m_listePeriodesElementairesAffiliation;
  }
  
  protected static final void jdoSetm_presenceDonneesJustificationAffiliation(ValidationProduitPC pc, boolean newValue)
  {
    if (jdoFlags == 0)
    {
      m_presenceDonneesJustificationAffiliation = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setBooleanField(pc, jdoInheritedFieldCount + 0, m_presenceDonneesJustificationAffiliation, newValue);
    } else {
      m_presenceDonneesJustificationAffiliation = newValue;
    }
  }
  
  protected static final void jdoSetm_rangAllongement(ValidationProduitPC pc, int newValue)
  {
    if (jdoFlags == 0)
    {
      m_rangAllongement = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setIntField(pc, jdoInheritedFieldCount + 1, m_rangAllongement, newValue);
    } else {
      m_rangAllongement = newValue;
    }
  }
  
  protected static final void jdoSetm_heuresRequises(ValidationProduitPC pc, Quantite newValue)
  {
    if (jdoFlags == 0)
    {
      m_heuresRequises = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 2, m_heuresRequises, newValue);
    } else {
      m_heuresRequises = newValue;
    }
  }
  
  protected static final void jdoSetm_estProduitValide(ValidationProduitPC pc, boolean newValue)
  {
    if (jdoFlags == 0)
    {
      m_estProduitValide = newValue;
      return;
    }
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setBooleanField(pc, jdoInheritedFieldCount + 3, m_estProduitValide, newValue);
    } else {
      m_estProduitValide = newValue;
    }
  }
  
  protected static final void jdoSetm_listeAllongementsPra(ValidationProduitPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 4, m_listeAllongementsPra, newValue);
    } else {
      m_listeAllongementsPra = newValue;
    }
  }
  
  protected static final void jdoSetm_listeActivitesParticipantes(ValidationProduitPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 5, m_listeActivitesParticipantes, newValue);
    } else {
      m_listeActivitesParticipantes = newValue;
    }
  }
  
  protected static final void jdoSetm_listeAffiliationsAssimilees(ValidationProduitPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 6, m_listeAffiliationsAssimilees, newValue);
    } else {
      m_listeAffiliationsAssimilees = newValue;
    }
  }
  
  protected static final void jdoSetm_listeAffiliationsSupplementaires(ValidationProduitPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 7, m_listeAffiliationsSupplementaires, newValue);
    } else {
      m_listeAffiliationsSupplementaires = newValue;
    }
  }
  
  protected static final void jdoSetm_listePeriodesElementairesAffiliation(ValidationProduitPC pc, Collection newValue)
  {
    StateManager sm = jdoStateManager;
    if (sm != null) {
      sm.setObjectField(pc, jdoInheritedFieldCount + 8, m_listePeriodesElementairesAffiliation, newValue);
    } else {
      m_listePeriodesElementairesAffiliation = newValue;
    }
  }
  
  public void jdoProvideField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      jdoStateManager.providedBooleanField(this, fieldNumber, m_presenceDonneesJustificationAffiliation);
      break;
    case 1: 
      jdoStateManager.providedIntField(this, fieldNumber, m_rangAllongement);
      break;
    case 2: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_heuresRequises);
      break;
    case 3: 
      jdoStateManager.providedBooleanField(this, fieldNumber, m_estProduitValide);
      break;
    case 4: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_listeAllongementsPra);
      break;
    case 5: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_listeActivitesParticipantes);
      break;
    case 6: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_listeAffiliationsAssimilees);
      break;
    case 7: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_listeAffiliationsSupplementaires);
      break;
    case 8: 
      jdoStateManager.providedObjectField(this, fieldNumber, m_listePeriodesElementairesAffiliation);
      break;
    default: 
      if (relativeField < 0) {
        super.jdoProvideField(fieldNumber);
      } else {
        throw new JDOFatalInternalException("index of field is out of bound");
      }
      break;
    }
  }
  
  public void jdoReplaceField(int fieldNumber)
  {
    int relativeField = fieldNumber - jdoInheritedFieldCount;
    switch (relativeField)
    {
    case 0: 
      m_presenceDonneesJustificationAffiliation = jdoStateManager.replacingBooleanField(this, fieldNumber);
      break;
    case 1: 
      m_rangAllongement = jdoStateManager.replacingIntField(this, fieldNumber);
      break;
    case 2: 
      m_heuresRequises = ((Quantite)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 3: 
      m_estProduitValide = jdoStateManager.replacingBooleanField(this, fieldNumber);
      break;
    case 4: 
      m_listeAllongementsPra = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 5: 
      m_listeActivitesParticipantes = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 6: 
      m_listeAffiliationsAssimilees = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 7: 
      m_listeAffiliationsSupplementaires = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    case 8: 
      m_listePeriodesElementairesAffiliation = ((Collection)jdoStateManager.replacingObjectField(this, fieldNumber));
      break;
    default: 
      if (relativeField < 0) {
        super.jdoReplaceField(fieldNumber);
      } else {
        throw new JDOFatalInternalException("index of field is out of bound");
      }
      break;
    }
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm)
  {
    ValidationProduitPC pc = new ValidationProduitPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    return pc;
  }
  
  public PersistenceCapable jdoNewInstance(StateManager sm, Object oid)
  {
    ValidationProduitPC pc = new ValidationProduitPC();
    jdoStateManager = sm;
    jdoFlags = PersistenceCapable.LOAD_REQUIRED;
    pc.jdoCopyKeyFieldsFromObjectId(oid);
    return pc;
  }
  
  public static int jdoGetManagedFieldCount()
  {
    return jdoInheritedFieldCount + 9;
  }
  
  public void jdoCopyFields(Object pc, int[] fieldNumbers)
  {
    if (!(pc instanceof ValidationProduitPC)) {
      throw new JDOFatalInternalException("Can't copy fields from a different class");
    }
    ValidationProduitPC other = (ValidationProduitPC)pc;
    if (jdoStateManager != jdoStateManager) {
      throw new JDOUserException("Source object should have the same StateManager");
    }
    for (int i = 0; i < fieldNumbers.length; i++)
    {
      int relativeField = fieldNumbers[i] - jdoInheritedFieldCount;
      switch (relativeField)
      {
      case 0: 
        m_presenceDonneesJustificationAffiliation = m_presenceDonneesJustificationAffiliation;
        break;
      case 1: 
        m_rangAllongement = m_rangAllongement;
        break;
      case 2: 
        m_heuresRequises = m_heuresRequises;
        break;
      case 3: 
        m_estProduitValide = m_estProduitValide;
        break;
      case 4: 
        m_listeAllongementsPra = m_listeAllongementsPra;
        break;
      case 5: 
        m_listeActivitesParticipantes = m_listeActivitesParticipantes;
        break;
      case 6: 
        m_listeAffiliationsAssimilees = m_listeAffiliationsAssimilees;
        break;
      case 7: 
        m_listeAffiliationsSupplementaires = m_listeAffiliationsSupplementaires;
        break;
      case 8: 
        m_listePeriodesElementairesAffiliation = m_listePeriodesElementairesAffiliation;
      }
    }
    super.jdoCopyFields(pc, fieldNumbers);
  }
}

/* Location:
 * Qualified Name:     ValidationProduitPC
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */