package fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.spe02.p03.liquidation.outilsaffiliation.dom.ComportementCalculAffiliation;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.filtres.FiltreActiviteSalarieCinemaSpectacle;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.outilsfonctionnels.OutilChronologie;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreActiviteSalarie;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreActiviteSalarieeMotifDvNonLegitime;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreCategorieEmploiParticulier;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeActiviteNonSalariee;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeActiviteSalarieeHorsChamp;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeDsmTravail;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesAttestees;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesAvecConflit;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesCertifiees;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesJustifiees;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesLiquidables;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesSansConflit;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesSurFiltresExclusifs;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreTravailSalarie;
import fr.unedic.cali.utilitaire.filtres.objetChronoPeriode.FiltreObjetChronoPeriodeChevauchePeriode;
import fr.unedic.cali.utilitaire.filtres.objetChronoPeriode.FiltreObjetChronoPeriodeFinAvantDate;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.FiltreFinDansBornes;
import fr.unedic.util.temps.FiltresTemporel;
import fr.unedic.util.temps.Periode;

public class ConstructionChronologie
{
  public static Chronologie determinerChronoPeriodesTravailDelaiRechercheDv(Periode p_periodeDelai, ActiviteSalarie p_periodeFgd, Chronologie p_chronoPeriodes)
  {
    Chronologie chronoPeriodesTravailDelaiRechercheDv = null;
    if ((p_periodeDelai != null) && (p_chronoPeriodes != null) && (!p_chronoPeriodes.estVide()))
    {
      FiltrePeriodesSurFiltresExclusifs filtreExclusifPeriodesTravail = new FiltrePeriodesSurFiltresExclusifs();
      
      FiltresTemporel filtresPeriodesTravailSalarieNonAtteste = new FiltresTemporel();
      filtresPeriodesTravailSalarieNonAtteste.ajouterFiltre(new FiltreTravailSalarie());
      filtresPeriodesTravailSalarieNonAtteste.ajouterFiltre(new FiltrePeriodesAttestees(false));
      
      filtreExclusifPeriodesTravail.ajouterFiltre(filtresPeriodesTravailSalarieNonAtteste);
      
      filtreExclusifPeriodesTravail.ajouterFiltre(new FiltrePeriodesJustifiees(false));
      
      filtreExclusifPeriodesTravail.ajouterFiltre(new FiltrePeriodesAvecConflit());
      
      filtreExclusifPeriodesTravail.ajouterFiltre(new FiltreActiviteSalarieeMotifDvNonLegitime());
      
      FiltresTemporel filtresPeriodesTravailDelaiRechercheDv = new FiltresTemporel();
      
      filtresPeriodesTravailDelaiRechercheDv.ajouterFiltre(filtreExclusifPeriodesTravail);
      
      filtresPeriodesTravailDelaiRechercheDv.ajouterFiltre(new FiltreFinDansBornes(p_periodeDelai));
      
      filtresPeriodesTravailDelaiRechercheDv.ajouterFiltre(new FiltrePeriodesLiquidables());
      
      chronoPeriodesTravailDelaiRechercheDv = p_chronoPeriodes.copier(filtresPeriodesTravailDelaiRechercheDv);
      
      OutilChronologie.supprimerPeriodeParIdentifiant(chronoPeriodesTravailDelaiRechercheDv, p_periodeFgd);
    }
    return chronoPeriodesTravailDelaiRechercheDv;
  }
  
  public static Chronologie determinerChronoPeriodesTravailFiniesDansDelai(Periode p_periodeDelai, Chronologie p_chronoPeriodesTravail)
  {
    Chronologie chronoPeriodesTravailFiniesDansDelai = null;
    if ((p_periodeDelai != null) && (p_chronoPeriodesTravail != null) && (!p_chronoPeriodesTravail.estVide()))
    {
      FiltrePeriodesSurFiltresExclusifs filtrePeriodesTravail = new FiltrePeriodesSurFiltresExclusifs();
      
      filtrePeriodesTravail.ajouterFiltre(new FiltrePeriodesCertifiees());
      
      filtrePeriodesTravail.ajouterFiltre(new FiltrePeriodeDsmTravail());
      
      FiltresTemporel listefiltres = new FiltresTemporel();
      listefiltres.ajouterFiltre(filtrePeriodesTravail);
      
      listefiltres.ajouterFiltre(new FiltreFinDansBornes(p_periodeDelai));
      
      listefiltres.ajouterFiltre(new FiltrePeriodesLiquidables());
      
      chronoPeriodesTravailFiniesDansDelai = p_chronoPeriodesTravail.copier(listefiltres);
    }
    return chronoPeriodesTravailFiniesDansDelai;
  }
  
  public static Chronologie determinerChronoPeriodesTravailHorsChamp(Chronologie p_chronoPeriodesTravail)
  {
    Chronologie chronoPeriodesTravailHorsChamp = null;
    if ((p_chronoPeriodesTravail != null) && (!p_chronoPeriodesTravail.estVide()))
    {
      FiltrePeriodesSurFiltresExclusifs filtrePeriodesTravailHorsChamp = new FiltrePeriodesSurFiltresExclusifs();
      
      filtrePeriodesTravailHorsChamp.ajouterFiltre(new FiltrePeriodeActiviteSalarieeHorsChamp());
      
      filtrePeriodesTravailHorsChamp.ajouterFiltre(new FiltrePeriodeActiviteNonSalariee());
      
      FiltresTemporel listefiltres = new FiltresTemporel();
      listefiltres.ajouterFiltre(filtrePeriodesTravailHorsChamp);
      
      listefiltres.ajouterFiltre(new FiltrePeriodesLiquidables());
      
      chronoPeriodesTravailHorsChamp = p_chronoPeriodesTravail.copier(listefiltres);
    }
    return chronoPeriodesTravailHorsChamp;
  }
  
  public static Chronologie determinerChronoActivitesSalarieesNonSpectacle(Chronologie p_chronoPeriodesTravail)
  {
    Chronologie chronoActivitesSalarieesNonSpectacle = null;
    Chronologie chronoActivitesEnseignementSalarie = null;
    ActiviteSalarie activiteEnseignementSalarieCourante = null;
    if ((p_chronoPeriodesTravail != null) && (!p_chronoPeriodesTravail.estVide()))
    {
      chronoActivitesSalarieesNonSpectacle = p_chronoPeriodesTravail.copier(new FiltreActiviteSalarieCinemaSpectacle(false));
      if ((chronoActivitesSalarieesNonSpectacle != null) && (!chronoActivitesSalarieesNonSpectacle.estVide()))
      {
        FiltreCategorieEmploiParticulier filtreEmploiParticulier = new FiltreCategorieEmploiParticulier();
        filtreEmploiParticulier.ajouterCategorieEmploi(31);
        chronoActivitesEnseignementSalarie = chronoActivitesSalarieesNonSpectacle.copier(filtreEmploiParticulier);
        chronoActivitesEnseignementSalarie.iterer();
        while (chronoActivitesEnseignementSalarie.encoreSuivant())
        {
          activiteEnseignementSalarieCourante = (ActiviteSalarie)chronoActivitesEnseignementSalarie.elementSuivant();
          chronoActivitesSalarieesNonSpectacle.supprimer(activiteEnseignementSalarieCourante);
        }
      }
    }
    return chronoActivitesSalarieesNonSpectacle;
  }
  
  public static Chronologie determinerChronoActivitesSalarieesFiniesDansDelai(Periode p_periodeDelai, Chronologie p_chronoPeriodesTravail)
  {
    Chronologie chronoActivitesSalarieesFiniesDansDelai = null;
    if ((p_periodeDelai != null) && (p_chronoPeriodesTravail != null) && (!p_chronoPeriodesTravail.estVide()))
    {
      FiltresTemporel filtreActivitesSalarieesFiniesDansDelai = new FiltresTemporel();
      
      filtreActivitesSalarieesFiniesDansDelai.ajouterFiltre(new FiltreActiviteSalarie());
      
      filtreActivitesSalarieesFiniesDansDelai.ajouterFiltre(new FiltreFinDansBornes(p_periodeDelai));
      
      filtreActivitesSalarieesFiniesDansDelai.ajouterFiltre(new FiltrePeriodesLiquidables());
      
      chronoActivitesSalarieesFiniesDansDelai = p_chronoPeriodesTravail.copier(filtreActivitesSalarieesFiniesDansDelai);
    }
    return chronoActivitesSalarieesFiniesDansDelai;
  }
  
  public static Chronologie determinerChronoActivitesAssimilables(Periode p_periodeDelai, Chronologie p_chronoPeriodes)
  {
    Chronologie chronoActivitesAssimilables = null;
    if ((p_periodeDelai != null) && (p_chronoPeriodes != null) && (!p_chronoPeriodes.estVide()))
    {
      fr.unedic.cali.asu.spe02.p03.liquidation.outilsaffiliation.ConstructionChronologie constructionChronologie = new fr.unedic.cali.asu.spe02.p03.liquidation.outilsaffiliation.ConstructionChronologie();
      
      chronoActivitesAssimilables = new ChronologiePeriodes();
      
      ComportementCalculAffiliation comportementCalculAffiliation = ComportementCalculAffiliation.creerInstance();
      comportementCalculAffiliation.setChronologieActivitesParticipantes(p_chronoPeriodes);
      comportementCalculAffiliation.setPeriodeRecherche(p_periodeDelai);
      
      chronoActivitesAssimilables.ajouter(constructionChronologie.determinerChronologiePourAssimilationFormation(comportementCalculAffiliation));
      
      chronoActivitesAssimilables.ajouter(constructionChronologie.determinerChronologiePourAssimilationMaterniteAdoptionAccidentTravail(comportementCalculAffiliation));
      
      chronoActivitesAssimilables.ajouter(constructionChronologie.determinerChronologiePourAssimilationEnseignants(comportementCalculAffiliation));
    }
    return chronoActivitesAssimilables;
  }
  
  public static Chronologie determinerChronoActivitesSalarieesSr(Periode p_periodePrc, Damj p_dateFgd, Chronologie p_chronoPasseProfessionnel)
  {
    Chronologie chronoActivitesSalarieesSr = null;
    if ((p_periodePrc != null) && (p_dateFgd != null) && (p_chronoPasseProfessionnel != null) && (!p_chronoPasseProfessionnel.estVide()))
    {
      FiltresTemporel filtreActivitesSalarieesSr = new FiltresTemporel();
      
      filtreActivitesSalarieesSr.ajouterFiltre(new FiltreActiviteSalarieCinemaSpectacle());
      
      filtreActivitesSalarieesSr.ajouterFiltre(new FiltrePeriodesAttestees());
      filtreActivitesSalarieesSr.ajouterFiltre(new FiltrePeriodesLiquidables());
      filtreActivitesSalarieesSr.ajouterFiltre(new FiltrePeriodesSansConflit());
      
      filtreActivitesSalarieesSr.ajouterFiltre(new FiltreObjetChronoPeriodeChevauchePeriode(p_periodePrc, "MVS"));
      
      filtreActivitesSalarieesSr.ajouterFiltre(new FiltreObjetChronoPeriodeFinAvantDate(p_dateFgd.lendemain(), "MVS"));
      
      chronoActivitesSalarieesSr = p_chronoPasseProfessionnel.copier(filtreActivitesSalarieesSr);
    }
    return chronoActivitesSalarieesSr;
  }
}

/* Location:
 * Qualified Name:     ConstructionChronologie
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */