package fr.unedic.cali.asu.spe02.p04.liquidation.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConstitutionDelaisReport;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConstitutionElementsSpec;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConstitutionMontantsBruts;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConstitutionSalaireReference;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.DeterminationMontantTotalSalaires;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.dom.OdSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuSpe02P04;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;

public class AlimentationBasePivot
  extends fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.AlimentationBasePivot
{
  public static AlimentationBasePivot getInstance()
  {
    return new AlimentationBasePivot();
  }
  
  protected void renseignerDroitCourant(fr.unedic.cali.dom.pivot.Attribution attributionPivot, Demande demande)
    throws ApplicativeException, CoucheLogiqueException
  {
    super.renseignerDroitCourant(attributionPivot, demande);
    if ((demande.getAttribution() != null) && (demande.getAttribution().getProduit().getCode() == ProduitAsuSpe02P04.getInstance().getCode()))
    {
      fr.unedic.cali.asu.spe02.p03.liquidation.dom.Attribution attributionDom = (fr.unedic.cali.asu.spe02.p03.liquidation.dom.Attribution)demande.getDossierExamen();
      if (((attributionDom instanceof OdSpec)) && (attributionDom.getConstitutionDelaisReport() != null))
      {
        int differeAvant = attributionDom.getConstitutionDelaisReport().getNbJoursCarenceStandard();
        
        OutilCalculDiffereStandard outilCalculDiffereStandard = new OutilCalculDiffereStandard();
        
        DossierExamen dossierExamen = (DossierExamen)demande.getDossierExamen();
        Periode periodeRechercheCalcul = dossierExamen.getConstitutionSalaireReference().getPrc();
        BigDecimal montantTotalRemunerationsPrc = DeterminationMontantTotalSalaires.determinerMontantTotalSalaires(dossierExamen.getConstitutionDelaisReport().getJustificationDiffere(), demande, periodeRechercheCalcul);
        
        int differeApres = outilCalculDiffereStandard.calculerDiffereStandard(demande, null, montantTotalRemunerationsPrc).getValeurEntiere();
        
        attributionPivot.setDeltaDiffereSpectacle(determinerDeltaDiffere(differeAvant, differeApres));
      }
    }
  }
  
  private int determinerDeltaDiffere(int differeAvant, int differeApres)
  {
    int deltaDiffere = differeApres - differeAvant;
    if (deltaDiffere <= 0) {
      deltaDiffere = 0;
    }
    return deltaDiffere;
  }
  
  protected void alimenterMontantJournalierBrut(DossierExamenSpec dossierExamen, fr.unedic.cali.dom.pivot.Attribution attributionPivot)
    throws ApplicativeException
  {
    boolean estClauseRattrapage = estContexteClauseRattrapage((Demande)dossierExamen.getDemande());
    if (estClauseRattrapage)
    {
      fr.unedic.cali.asu.spe02.p03.liquidation.dom.Attribution attribution = (fr.unedic.cali.asu.spe02.p03.liquidation.dom.Attribution)dossierExamen;
      
      BigDecimal montantBrut = attribution.getConstitutionElementsActifs().getConstitutionMontantsBruts().getMontantJournalierBrutNonPrecompte().getValeur();
      
      attributionPivot.setMontantAllocationJournaliereBrut(montantBrut);
    }
    else
    {
      super.alimenterMontantJournalierBrut(dossierExamen, attributionPivot);
    }
  }
}

/* Location:
 * Qualified Name:     AlimentationBasePivot
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */