package fr.unedic.cali.asu.spe02.p05.calcul;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.antecedent.GestionAntecedentCalculAsuSpec;
import fr.unedic.cali.asu.calcul.outilsfonctionnels.OutilsMaintienEuropeenEessiASU;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisationAREF;
import fr.unedic.cali.asu.dom.SalaireReference;
import fr.unedic.cali.asu.dom.Sjm;
import fr.unedic.cali.asu.outilsfonctionnels.OutilDemande;
import fr.unedic.cali.asu.spe02.p03.calcul.dom.CalendrierExecutionCalcul;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.Attribution;
import fr.unedic.cali.asu.spe02.p05.antecedent.GestionAntecedentCalcul;
import fr.unedic.cali.asu.spe02.p05.calcul.dom.FormuleMontantAREF;
import fr.unedic.cali.asu.spe02.p05.calcul.dom.FormuleMontantRegimeGeneral;
import fr.unedic.cali.asu.spe02.p05.calcul.dom.ObjetChronoDateLimiteIndemnisation;
import fr.unedic.cali.asu.spe02.p05.calcul.outilsfonctionnels.Maintien;
import fr.unedic.cali.asu.spe02.p05.calcul.outilsfonctionnels.MajCi;
import fr.unedic.cali.asu.spe02.p05.calcul.outilsfonctionnels.PostTraitements;
import fr.unedic.cali.asu.spe02.p05.calcul.outilsfonctionnels.Qualification;
import fr.unedic.cali.asu.spe02.p05.calcul.outilsfonctionnels.TraitementActiviteReduite;
import fr.unedic.cali.asu.spe02.p05.liquidation.outilsaffiliation.ConvertisseurUniteAffiliation;
import fr.unedic.cali.calcul.OutillageCalculADate;
import fr.unedic.cali.calcul.OutillagePeriodes;
import fr.unedic.cali.calcul.RecuperationDonneesSecteurPublic;
import fr.unedic.cali.calcul.TraitementDureeNonIndemnisable;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculPeriodique;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculSpec;
import fr.unedic.cali.calcul.dom.ConstituantsCalculActiviteReduiteSpec;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.calcul.dom.EtatAuDji;
import fr.unedic.cali.calcul.dom.EtatAuDjiSpec;
import fr.unedic.cali.calcul.dom.EvenementDateLimiteIndemnisation;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.QuantiteNonIndemnises;
import fr.unedic.cali.calcul.dom.UniteTraitement;
import fr.unedic.cali.calcul.dom.periode.PeriodeActiviteEmploiCalcul;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoNonIndemnise;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeInterProduits;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoRemplissage;
import fr.unedic.cali.calcul.outilsfonctionnels.GestionSuivi;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ContexteUT;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.ContexteUT.ElementContexteUT;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodesPriseEnCompte;
import fr.unedic.cali.calcul.outilsfonctionnels.filtres.FiltrePeriodeTravailCalculPAEC;
import fr.unedic.cali.calcul.outilsfonctionnels.proratisation.PeriodeProratisationFactory;
import fr.unedic.cali.calcul.pbjc.dom.DroitPbjcNcp;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DureeNonIndemnisable;
import fr.unedic.cali.dom.ElementBaseIndemnisationSpec;
import fr.unedic.cali.dom.FormuleMontantAREFSpec;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.OdAssuranceSpec;
import fr.unedic.cali.dom.QuantiteDroitSpec;
import fr.unedic.cali.dom.RepriseSpec;
import fr.unedic.cali.dom.Retraite;
import fr.unedic.cali.outilsfonctionnels.OutilRetraite;
import fr.unedic.cali.parametres.EvenementParametre;
import fr.unedic.cali.parametres.GestionnaireDateApplication;
import fr.unedic.cali.parametres.ParametresIndemnisation;
import fr.unedic.cali.parcours.ResultatCalcul;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.UniteAffiliation;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.NonConformiteException;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import fr.unedic.util.temps.Temporel;
import java.math.BigDecimal;
import java.util.Iterator;
import java.util.List;

public class FacadeCalculProduitImpl
  extends fr.unedic.cali.asu.spe02.p04.calcul.FacadeCalculProduitImpl
{
  private static final int ZERO = 0;
  
  public BigDecimal recupererPlafondGlobal(AttributionSpec attribution, Damj dateDebut)
  {
    ParametresIndemnisation paramHG = ParametresIndemnisation.getParametresIndemnisation();
    EvenementParametre evtParamHG = paramHG.getElementActif(dateDebut);
    
    return evtParamHG.getPlafondMensuelSecuriteSociale().multiply(new BigDecimal("1.18"));
  }
  
  public void traitementPeriodesDecalantes(AttributionSpec attribution, ChronologiePeriodes periodes, ConstituantsCalculActiviteReduiteSpec constituantsCalculActiviteReduiteSpec, UniteTraitement ut, ConstituantsIndemnisation constituantsIndemnisation, ContexteUT contexteUT)
    throws CoucheLogiqueException
  {
    traitementPeriodesDecalantes(attribution, periodes, ut, new TraitementActiviteReduite());
  }
  
  public void traitementPeriodesGelantes(AttributionSpec attribution, ChronologiePeriodes periodes, ConstituantsCalculActiviteReduiteSpec constituantsCalculActiviteReduiteSpec, UniteTraitement ut)
    throws CoucheLogiqueException
  {
    TraitementActiviteReduite traitementAR = new TraitementActiviteReduite();
    traitementAR.traitementPeriodesGelantes(attribution, periodes, ut);
  }
  
  public void convertionCachets(ChronologiePeriodes periodes)
  {
    if ((periodes != null) && (!periodes.estVide()))
    {
      Chronologie chronoPeriodesPAEC = periodes.copier(new FiltrePeriodeTravailCalculPAEC());
      if ((chronoPeriodesPAEC != null) && (!chronoPeriodesPAEC.estVide()))
      {
        chronoPeriodesPAEC.iterer();
        while (chronoPeriodesPAEC.encoreSuivant())
        {
          PeriodeActiviteEmploiCalcul periodeActivite = (PeriodeActiviteEmploiCalcul)chronoPeriodesPAEC.elementSuivant();
          if ((periodeActivite.getCachets() != null) && (periodeActivite.getCachets().intValue() > 0)) {
            periodeActivite.setNombreHeures(periodeActivite.getNombreHeuresDeCompletude().add(new Quantite(periodeActivite.getCachets(), UniteAffiliation.CACHET_GROUPE).convertir(UniteAffiliation.HEURE_TRAVAIL, ConvertisseurUniteAffiliation.getInstance()).getValeur()));
          }
        }
      }
    }
  }
  
  protected void passerEnIndemnisationSansFormation(ConstituantsIndemnisation constituantsIndemnisation)
  {
    constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantRegimeGeneral.getCode());
    
    ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant().copie();
    constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisation);
  }
  
  public FormuleMontantSpec getFormuleMontant(String code)
  {
    FormuleMontantSpec fm = null;
    if (FormuleMontantAREF.getCode().equals(code)) {
      fm = new FormuleMontantAREF();
    } else if (FormuleMontantRegimeGeneral.getCode().equals(code)) {
      fm = new FormuleMontantRegimeGeneral();
    }
    return fm;
  }
  
  public ConstituantsIndemnisation creationConstituantsIndemnisation(AttributionSpec attributionSpec)
    throws CoucheLogiqueException
  {
    ConstituantsIndemnisation constituantsIndemnisation = new ConstituantsIndemnisation();
    Attribution attribution = (Attribution)attributionSpec;
    constituantsIndemnisation.setCodeFormuleMontant(FormuleMontantRegimeGeneral.getCode());
    boolean majReliquatFranchise = false;
    EtatAuDjiSpec etatAuDJI = null;
    if (((attribution instanceof RepriseSpec)) && (attribution.getAttributionPrecedente() != null) && (attribution.getAttributionPrecedente().getCalendrierExecutionCalcul() != null) && (attribution.getAttributionPrecedente().getCalendrierExecutionCalcul().getEtatAuDJI() != null))
    {
      etatAuDJI = attribution.getAttributionPrecedente().getCalendrierExecutionCalcul().getEtatAuDJI();
      Damj dji = attribution.getAttributionPrecedente().getCalendrierExecutionCalcul().getDernierJourIndemnisable();
      if ((attribution.getPji().getMois() == dji.getMois()) && (attribution.getPji().getAnnee() == dji.getAnnee())) {
        majReliquatFranchise = true;
      }
    }
    ElementBaseIndemnisation ebiAttributionSpectacle = attribution.getElementBaseIndemnisation();
    if (ebiAttributionSpectacle.getDureeFranchiseCp() > 0)
    {
      DureeNonIndemnisable dureeFCP = new DureeNonIndemnisable(ebiAttributionSpectacle.getDureeFranchiseCp());
      dureeFCP.setRythmeConsomation(new QuantiteJour(Integer.toString(ebiAttributionSpectacle.getQuantiteMensConsomFranchiseCp())));
      dureeFCP.setType("FCP");
      if ((majReliquatFranchise) && (((EtatAuDji)etatAuDJI).getReliquatMaxFCP() != null)) {
        dureeFCP.setReliquatMaxMois(new QuantiteJour(((EtatAuDji)etatAuDJI).getReliquatMaxFCP().toString()));
      }
      dureeFCP.activer();
      constituantsIndemnisation.ajouterListeDureeNonIndemnisables(dureeFCP);
    }
    if (ebiAttributionSpectacle.getDureeFranchiseSalaire() > 0)
    {
      DureeNonIndemnisable dureeSalaire = new DureeNonIndemnisable(ebiAttributionSpectacle.getDureeFranchiseSalaire());
      dureeSalaire.setRythmeConsomation(new QuantiteJour(Integer.toString(ebiAttributionSpectacle.getQuantiteMensConsomFranchiseSalaire())));
      dureeSalaire.setType("FS");
      if ((majReliquatFranchise) && (((EtatAuDji)etatAuDJI).getReliquatMaxFS() != null)) {
        dureeSalaire.setReliquatMaxMois(new QuantiteJour(((EtatAuDji)etatAuDJI).getReliquatMaxFS().toString()));
      }
      dureeSalaire.activer();
      constituantsIndemnisation.ajouterListeDureeNonIndemnisables(dureeSalaire);
    }
    if (ebiAttributionSpectacle.getNombreJoursDelaiAttente() > 0)
    {
      DureeNonIndemnisable dureeDA = new DureeNonIndemnisable(ebiAttributionSpectacle.getNombreJoursDelaiAttente());
      dureeDA.setEtat(1);
      dureeDA.setType("DA");
      dureeDA.activer();
      constituantsIndemnisation.ajouterListeDureeNonIndemnisables(dureeDA);
    }
    return constituantsIndemnisation;
  }
  
  public EtatAuDji renseignerEtatAuDji(UniteTraitement derniereUT, CalendrierExecutionCalculPeriodique calendrier, AttributionSpec attribution, EtatAuDji etatAuDji)
    throws CoucheLogiqueException
  {
    EtatAuDji etatAuDjiReturn = super.renseignerEtatAuDji(derniereUT, calendrier, attribution, etatAuDji);
    
    List<DureeNonIndemnisable> listeDureeNiEnFinUT = derniereUT.getConstituantsIndemnisationEnFinUT().getListListeDureeNonIndemnisables();
    DureeNonIndemnisable delaiAttente = TraitementDureeNonIndemnisable.recupererDureeNonIndemnisable(listeDureeNiEnFinUT, "DA");
    
    DureeNonIndemnisable franchiseCP = TraitementDureeNonIndemnisable.recupererDureeNonIndemnisable(listeDureeNiEnFinUT, "FCP");
    
    DureeNonIndemnisable franchiseS = TraitementDureeNonIndemnisable.recupererDureeNonIndemnisable(listeDureeNiEnFinUT, "FS");
    if ((((Attribution)attribution).getElementBaseIndemnisation() != null) && (((Attribution)attribution).getElementBaseIndemnisation().isClauseRattrapage()))
    {
      ArretProduitAvecRaison arret = derniereUT.getArretProduitAvecRaison();
      for (Object o : arret.getPeriodesInterruptivesDefinitives()) {
        if ((((o instanceof ObjetChronoDateLimiteIndemnisation)) && (((Attribution)attribution).getDateLimiteIndemnisation() != null) && (calendrier.getDernierJourIndemnisable().coincideAvec(((Attribution)attribution).getDateLimiteIndemnisation()))) || (((o instanceof ObjetChronoPeriodeInterProduits)) && (((ObjetChronoPeriodeInterProduits)o).getGamme().equals("ASU")) && (calendrier.getDernierJourIndemnisable().lendemain().coincideAvec(((ObjetChronoPeriodeInterProduits)o).getAttribution().getDateAttribution()))))
        {
          if (franchiseCP != null) {
            franchiseCP.setQuantiteCourante(new QuantiteJour(BigDecimal.ZERO));
          }
          if (franchiseS != null) {
            franchiseS.setQuantiteCourante(new QuantiteJour(BigDecimal.ZERO));
          }
        }
      }
    }
    if (franchiseCP != null)
    {
      etatAuDjiReturn.setReliquatFCP(franchiseCP.getQuantiteCourante() != null ? Integer.valueOf(franchiseCP.getQuantiteCourante().getValeurEntiere()) : null);
      etatAuDjiReturn.setReliquatMaxFCP(franchiseCP.getQuantiteRestanteAConsommeSurMois() != null ? Integer.valueOf(franchiseCP.getQuantiteRestanteAConsommeSurMois().getValeurEntiere()) : null);
    }
    if (franchiseS != null)
    {
      etatAuDjiReturn.setReliquatFS(franchiseS.getQuantiteCourante() != null ? Integer.valueOf(franchiseS.getQuantiteCourante().getValeurEntiere()) : null);
      etatAuDjiReturn.setReliquatMaxFS(franchiseS.getQuantiteRestanteAConsommeSurMois() != null ? Integer.valueOf(franchiseS.getQuantiteRestanteAConsommeSurMois().getValeurEntiere()) : null);
    }
    if (delaiAttente != null)
    {
      etatAuDjiReturn.setPeriodeDA(delaiAttente.getPeriodeDA());
      etatAuDjiReturn.setReliquatDA(Integer.valueOf(delaiAttente.getQuantiteCourante() != null ? delaiAttente.getQuantiteCourante().getValeurEntiere() : 0));
    }
    etatAuDjiReturn.setCumulJoursIndemnise(derniereUT.getCumulJoursIndemnise());
    
    return etatAuDjiReturn;
  }
  
  public void traitementPeriodesNonIndemnises(UniteTraitement ut, QualificationPeriodes qualificationPeriodes, QuantiteNonIndemnises quantiteNonIndemnises, ConstituantsIndemnisation constituantsIndemnisation)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes chronoPeriodesNI = PeriodeProratisationFactory.decoupeEtProratiseParDefaut(qualificationPeriodes.getPeriodesSuspensives(), ut.getPeriode());
    
    int plafond = ut.getQuantitePlafonnee().getValeurEntiere();
    int decalage = ut.getCreditDecalage() != null ? ut.getCreditDecalage().getValeurEntiere() - (ut.getCreditDecalageDureeEnFinUT() != null ? ut.getCreditDecalageDureeEnFinUT().getValeurEntiere() : 0) : 0;
    
    ajouterPeriodeNI(ut, quantiteNonIndemnises.getQuantiteDelaiAttente(), chronoPeriodesNI, quantiteNonIndemnises, "DA", true);
    
    ajouterPeriodeNI(ut, decalage, chronoPeriodesNI, quantiteNonIndemnises, "DECALAGE", false);
    ajouterPeriodeNI(ut, plafond, chronoPeriodesNI, quantiteNonIndemnises, "PLAFOND", false);
    ajouterPeriodeNI(ut, quantiteNonIndemnises.getQuantiteDelaiAttente(), chronoPeriodesNI, quantiteNonIndemnises, "DA", false);
    
    ajouterPeriodeNI(ut, quantiteNonIndemnises.getQuantiteFranchiseCP(), chronoPeriodesNI, quantiteNonIndemnises, "FCP", false);
    
    ajouterPeriodeNI(ut, quantiteNonIndemnises.getQuantiteFranchiseSalaire(), chronoPeriodesNI, quantiteNonIndemnises, "FS", false);
    
    ajouterPeriodeNI(ut, quantiteNonIndemnises.getQuantiteReportCP(), chronoPeriodesNI, quantiteNonIndemnises, "FCPR", false);
    
    ajouterPeriodeNI(ut, quantiteNonIndemnises.getQuantiteReportSalaire(), chronoPeriodesNI, quantiteNonIndemnises, "FSR", false);
    
    alimenterPeriodeDApplicationDelaiAttenteSurCI(constituantsIndemnisation, chronoPeriodesNI);
  }
  
  private void alimenterPeriodeDApplicationDelaiAttenteSurCI(ConstituantsIndemnisation constituantsIndemnisation, ChronologiePeriodes chronoPeriodesNI)
  {
    List<DureeNonIndemnisable> listeDureeNiEnFinUT = constituantsIndemnisation.getListListeDureeNonIndemnisables();
    DureeNonIndemnisable delaiAttente = TraitementDureeNonIndemnisable.recupererDureeNonIndemnisable(listeDureeNiEnFinUT, "DA");
    if (delaiAttente != null)
    {
      chronoPeriodesNI.iterer();
      Damj debut = delaiAttente.getPeriodeDA() != null ? delaiAttente.getPeriodeDA().getDebut() : null;
      Damj fin = delaiAttente.getPeriodeDA() != null ? delaiAttente.getPeriodeDA().getFin() : null;
      while (chronoPeriodesNI.encoreSuivant())
      {
        Temporel temporel = chronoPeriodesNI.elementSuivant();
        if (((temporel instanceof ObjetChronoNonIndemnise)) && (((ObjetChronoNonIndemnise)temporel).getType().equals("DA")))
        {
          ObjetChronoNonIndemnise objetChronoNonIndemnise = (ObjetChronoNonIndemnise)temporel;
          if (verificationDateDebutDA(debut, objetChronoNonIndemnise)) {
            debut = objetChronoNonIndemnise.getDateDebut();
          }
          if (verificationDateFinDA(fin, objetChronoNonIndemnise)) {
            fin = objetChronoNonIndemnise.getDateFin();
          }
          delaiAttente.setPeriodeDA(new Periode(debut, fin));
        }
      }
    }
  }
  
  private boolean verificationDateFinDA(Damj fin, ObjetChronoNonIndemnise objetChronoNonIndemnise)
  {
    return (fin == null) || (objetChronoNonIndemnise.getDateFin().estApres(fin));
  }
  
  private boolean verificationDateDebutDA(Damj debut, ObjetChronoNonIndemnise objetChronoNonIndemnise)
  {
    return (debut == null) || (objetChronoNonIndemnise.getDateDebut().estAvant(debut));
  }
  
  public static void ajouterPeriodeNI(UniteTraitement ut, int quantite, ChronologiePeriodes chronoPeriodesNonIndemniseEtSuspensive, QuantiteNonIndemnises qni, String type, boolean estReliquatDA)
    throws CoucheLogiqueException
  {
    if ((quantite == 0) || ((type.equals("DA")) && (estReliquatDA != qni.isDaTraiteEnDebutUT()))) {
      return;
    }
    int quantiteARemplir = quantite;
    
    ChronologiePeriodes chronologiePeriodesRemplie = OutillageCalculADate.boucheLesTrous(estReliquatDA ? new ChronologiePeriodes() : chronoPeriodesNonIndemniseEtSuspensive, ObjetChronoRemplissage.class, qni.getDateDebut(), ut.getDateFin());
    
    chronologiePeriodesRemplie.iterer();
    while ((chronologiePeriodesRemplie.encoreSuivant()) && (quantiteARemplir > 0))
    {
      ObjetChronoPeriode objetChronoPeriode = (ObjetChronoPeriode)chronologiePeriodesRemplie.elementSuivant();
      if ((objetChronoPeriode instanceof ObjetChronoRemplissage))
      {
        int quantiteTmp = type.equals("DA") ? quantiteARemplir : Math.min(objetChronoPeriode.getDuree(), quantiteARemplir);
        
        ObjetChronoNonIndemnise o = new ObjetChronoNonIndemnise(objetChronoPeriode.getDateDebut(), objetChronoPeriode.getDateDebut().deplacerVersAvant(new DureeCalendaire(0, 0, quantiteTmp - 1)), type);
        
        ut.ajouterChronoNonIndemnisee(o);
        chronoPeriodesNonIndemniseEtSuspensive.ajouter(o);
        quantiteARemplir -= quantiteTmp;
      }
    }
  }
  
  public QualificationPeriodes qualificationPeriodes(ChronologiePeriodes chronologiePeriodes, AttributionSpec attribution, ContexteUT contexteUT)
    throws CoucheLogiqueException
  {
    return new Qualification().qualificationPeriodes(chronologiePeriodes, attribution);
  }
  
  public ChronologiePeriodes recupererPeriodesProduit(AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes periodesIndividuelles = new ChronologiePeriodes();
    IndividuSpec individu = attribution.getDemandeur();
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire50Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire55Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererAnniversaire60Ans(individu));
    periodesIndividuelles.ajouter(OutillagePeriodes.genererPeriodeRetraite(individu));
    if (individu.getDernierJourAtteste() != null) {
      periodesIndividuelles.ajouter(OutillagePeriodes.genererLendemainDja(individu));
    }
    RecuperationDonneesSecteurPublic.recupererDemandeClassementSP(periodesIndividuelles, attribution);
    
    RecuperationDonneesSecteurPublic.rechercherAdmissionSecteurPublic(periodesIndividuelles, attribution);
    
    ElementBaseIndemnisation ebiSpectacle = ((Attribution)attribution).getElementBaseIndemnisation();
    if (ebiSpectacle.getDateLimiteIndemnisation() != null) {
      periodesIndividuelles.ajouter(new ObjetChronoDateLimiteIndemnisation(ebiSpectacle.getDateLimiteIndemnisation().lendemain(), ebiSpectacle.getDateLimiteIndemnisation().lendemain(), attribution.getRsod()));
    }
    return periodesIndividuelles;
  }
  
  public ResultatCalcul postTraitementResultatDeterminationEtatDroit(AttributionSpec attribution, CalendrierExecutionCalculSpec calendrierExecutionCalcul, Damj dateEtatDroit)
    throws CoucheLogiqueException
  {
    return PostTraitements.postTraitementResultatDeterminationEtatDroit(attribution, (CalendrierExecutionCalcul)calendrierExecutionCalcul, dateEtatDroit);
  }
  
  public Damj getDateFinQuantiteDroit(Periode periode, AttributionSpec attribution, QuantiteDroitSpec quantiteDroit, ChronologiePeriodes chronologieRemplissage, Quantite quantiteAImputer, Damj dateDebutQuantiteDroit)
  {
    return ((AttributionAssuranceSpec)attribution).getElementBaseIndemnisation().getDateLimiteIndemnisation().lendemain();
  }
  
  public void initialisationQuantitesIndemnisation(ConstituantsIndemnisation constituantsIndemnisation, AttributionSpec attribution, Periode periodeUT)
    throws ApplicativeException
  {
    initialiseElementBaseIndemnisationCourante(constituantsIndemnisation, attribution, periodeUT);
  }
  
  public Damj recupererDateFinDroitTheorique(CalendrierExecutionCalculSpec calendrierExecutionCalcul, AttributionSpec attributionParam)
    throws CoucheLogiqueException
  {
    Attribution attribution = (Attribution)attributionParam;
    Damj dateFinDeDroit = null;
    if (calendrierExecutionCalcul != null)
    {
      Chronologie chronoUT = ((CalendrierExecutionCalculPeriodique)calendrierExecutionCalcul).getChronologieUnitesTraitements();
      if ((chronoUT != null) && (!chronoUT.estVide()) && (chronoUT.dernierElement() != null))
      {
        UniteTraitement derniereUT = (UniteTraitement)chronoUT.dernierElement();
        ArretProduitAvecRaison arretProduit = derniereUT.getArretProduitAvecRaison();
        if ((arretProduit != null) && (estinterruptionAutreDroit(arretProduit))) {
          dateFinDeDroit = arretProduit.recupereLendemainDateArret().veille();
        }
      }
    }
    if (dateFinDeDroit != null) {
      return Damj.min(attribution.getElementBaseIndemnisation().getDateLimiteIndemnisation(), dateFinDeDroit);
    }
    if (attribution.estMaintenue()) {
      return OutilRetraite.getInstance().determinerRetraite(attribution.getDemandeur()).getDate().veille();
    }
    return attribution.getElementBaseIndemnisation().getDateLimiteIndemnisation();
  }
  
  private static boolean estinterruptionAutreDroit(ArretProduitAvecRaison arretProduitAvecRaison)
  {
    for (Object o : arretProduitAvecRaison.getPeriodesInterruptivesDefinitives()) {
      if (((o instanceof ObjetChronoPeriodeInterProduits)) && (((ObjetChronoPeriodeInterProduits)o).getTypePeriode() == 1)) {
        return true;
      }
    }
    return false;
  }
  
  public void miseAJourConstituantsIndemnisationADate(AttributionSpec attributionSpec, ConstituantsIndemnisation constituantsIndemnisation, Damj date, ChronologiePeriodes chronologiePeriodesSanctions)
    throws CoucheLogiqueException
  {
    Attribution attribution = (Attribution)attributionSpec;
    if (!attribution.getElementBaseIndemnisation().isClauseRattrapage()) {
      super.miseAJourConstituantsIndemnisationADate(attributionSpec, constituantsIndemnisation, date, chronologiePeriodesSanctions);
    }
  }
  
  public void initialiseElementBaseIndemnisationCourante(ConstituantsIndemnisation constituantsIndemnisation, AttributionSpec attributionSpec, Periode periodeUT)
    throws CoucheLogiqueException
  {
    Attribution attribution = (Attribution)attributionSpec;
    if (!attribution.getElementBaseIndemnisation().isClauseRattrapage())
    {
      super.initialiseElementBaseIndemnisationCourante(constituantsIndemnisation, attributionSpec, periodeUT);
      valorisationRythmeConsommation(constituantsIndemnisation, attribution);
    }
    else if (constituantsIndemnisation.getElementBaseIndemnisationCourant() == null)
    {
      ElementBaseIndemnisation elementBaseIndemnisationCourant = new ElementBaseIndemnisation();
      ElementBaseIndemnisation elementBaseIndemnisationCourantDroitAssocie = new ElementBaseIndemnisation();
      attribution.getElementBaseIndemnisation().copieElements(elementBaseIndemnisationCourant);
      constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationCourant);
      ElementBaseIndemnisation ebiAttributionDroitAssocie = attribution.getElementBaseIndemnisation().getElementBaseIndemnisationDroitAssocie();
      if (ebiAttributionDroitAssocie != null)
      {
        ebiAttributionDroitAssocie.copieElements(elementBaseIndemnisationCourantDroitAssocie);
        elementBaseIndemnisationCourant.setElementBaseIndemnisationDroitAssocie(elementBaseIndemnisationCourantDroitAssocie);
      }
      valorisationCoeffSaisonnier(attribution, elementBaseIndemnisationCourant, elementBaseIndemnisationCourantDroitAssocie, ebiAttributionDroitAssocie);
      
      valorisationTempsPartiel(attribution, elementBaseIndemnisationCourant, elementBaseIndemnisationCourantDroitAssocie, ebiAttributionDroitAssocie);
      
      valorisationPrc(attribution, elementBaseIndemnisationCourant, elementBaseIndemnisationCourantDroitAssocie, ebiAttributionDroitAssocie);
      if (((ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant()).getSjm().getSalaire().compareTo(BigDecimal.ZERO) == 0) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_SALAIRE_PLAFONNE_A_ZERO");
      }
      elementBaseIndemnisationCourant.setDateMaintienEuropeen(OutilsMaintienEuropeenEessiASU.rechercherDateMaintienEuropeen(attributionSpec, periodeUT, constituantsIndemnisation));
      if (ebiAttributionDroitAssocie != null) {
        elementBaseIndemnisationCourantDroitAssocie.setDateMaintienEuropeen(OutilsMaintienEuropeenEessiASU.rechercherDateMaintienEuropeen(attributionSpec, periodeUT, constituantsIndemnisation));
      }
      FormuleMontantSpec formuleMontant = attribution.getFormuleMontant(constituantsIndemnisation.getCodeFormuleMontant());
      if ((formuleMontant instanceof FormuleMontantAREFSpec))
      {
        ElementBaseIndemnisationAREF elementBaseIndemnisationAREF = new ElementBaseIndemnisationAREF(elementBaseIndemnisationCourant);
        constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationAREF);
      }
      valorisationRythmeConsommation(constituantsIndemnisation, attribution);
      elementBaseIndemnisationCourant.setElementBaseIndemnisationDroitAssocie(elementBaseIndemnisationCourantDroitAssocie);
    }
  }
  
  protected SalaireReference recupereSJR(ElementBaseIndemnisation elementBaseIndemnisationCourant, Damj date)
  {
    return fr.unedic.cali.asu.spe02.p05.calcul.outilsfonctionnels.RevalorisationSalaire.determinerSrrp(elementBaseIndemnisationCourant.getSalaireReference(), elementBaseIndemnisationCourant.getNombreJoursInactivite(), elementBaseIndemnisationCourant.getNbJoursEmploiSurPrc(), date);
  }
  
  protected Sjm recupereSJM(ElementBaseIndemnisation elementBaseIndemnisationCourant, SalaireReference srrp, Damj date)
  {
    return fr.unedic.cali.asu.spe02.p03.calcul.outilsfonctionnels.RevalorisationSalaire.determinerSjmrp(srrp, elementBaseIndemnisationCourant.getCoefficientHoraireJour(), elementBaseIndemnisationCourant.getNombreHeuresTravailleesMajoree(), date);
  }
  
  private void valorisationPrc(Attribution attribution, ElementBaseIndemnisation elementBaseIndemnisationCourant, ElementBaseIndemnisation elementBaseIndemnisationCourantDroitAssocie, ElementBaseIndemnisation ebiAttributionDroitAssocie)
  {
    if (attribution.getElementBaseIndemnisation().getPrc() != null) {
      elementBaseIndemnisationCourant.setPrc(attribution.getElementBaseIndemnisation().getPrc());
    }
    elementBaseIndemnisationCourant.setNbJoursEmploiSurPrc(attribution.getElementBaseIndemnisation().getNbJoursEmploiSurPrc());
    if (ebiAttributionDroitAssocie != null)
    {
      if (ebiAttributionDroitAssocie.getPrc() != null) {
        elementBaseIndemnisationCourantDroitAssocie.setPrc(ebiAttributionDroitAssocie.getPrc());
      }
      elementBaseIndemnisationCourantDroitAssocie.setNbJoursEmploiSurPrc(ebiAttributionDroitAssocie.getNbJoursEmploiSurPrc());
    }
  }
  
  private void valorisationTempsPartiel(Attribution attribution, ElementBaseIndemnisation elementBaseIndemnisationCourant, ElementBaseIndemnisation elementBaseIndemnisationCourantDroitAssocie, ElementBaseIndemnisation ebiAttributionDroitAssocie)
  {
    if (attribution.getElementBaseIndemnisation().getCoefficientTempsPartiel() == null) {
      elementBaseIndemnisationCourant.setCoefficientTempsPartiel(BigDecimal.ONE);
    }
    if ((ebiAttributionDroitAssocie != null) && (ebiAttributionDroitAssocie.getCoefficientTempsPartiel() == null)) {
      elementBaseIndemnisationCourantDroitAssocie.setCoefficientTempsPartiel(BigDecimal.ONE);
    }
  }
  
  private void valorisationCoeffSaisonnier(Attribution attribution, ElementBaseIndemnisation elementBaseIndemnisationCourant, ElementBaseIndemnisation elementBaseIndemnisationCourantDroitAssocie, ElementBaseIndemnisation ebiAttributionDroitAssocie)
  {
    if (attribution.getElementBaseIndemnisation().getCoefficientSaisonnier() == null) {
      elementBaseIndemnisationCourant.setCoefficientSaisonnier(BigDecimal.ONE);
    }
    if ((ebiAttributionDroitAssocie != null) && (ebiAttributionDroitAssocie.getCoefficientSaisonnier() == null)) {
      elementBaseIndemnisationCourantDroitAssocie.setCoefficientSaisonnier(BigDecimal.ONE);
    }
  }
  
  private void valorisationRythmeConsommation(ConstituantsIndemnisation constituantsIndemnisation, Attribution attribution)
  {
    if ((constituantsIndemnisation.getElementBaseIndemnisationCourant() != null) && (constituantsIndemnisation.getListListeDureeNonIndemnisables() != null) && (!constituantsIndemnisation.getListListeDureeNonIndemnisables().isEmpty()))
    {
      List<DureeNonIndemnisable> listeDureeNiEnFinUT = constituantsIndemnisation.getListListeDureeNonIndemnisables();
      DureeNonIndemnisable franchiseCP = TraitementDureeNonIndemnisable.recupererDureeNonIndemnisable(listeDureeNiEnFinUT, "FCP");
      if (franchiseCP != null) {
        franchiseCP.setRythmeConsomation(new QuantiteJour(Integer.toString(attribution.getElementBaseIndemnisation().getQuantiteMensConsomFranchiseCp())));
      }
      DureeNonIndemnisable franchiseSalaire = TraitementDureeNonIndemnisable.recupererDureeNonIndemnisable(listeDureeNiEnFinUT, "FS");
      if (franchiseSalaire != null) {
        franchiseSalaire.setRythmeConsomation(new QuantiteJour(Integer.toString(attribution.getElementBaseIndemnisation().getQuantiteMensConsomFranchiseSalaire())));
      }
    }
  }
  
  public ConstituantsIndemnisation miseAJourConstituantsIndemnisation(UniteTraitement ut, AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, Damj dateDeMiseAjour, Periode periode)
    throws CoucheLogiqueException
  {
    if (constituantsIndemnisation.getElementBaseIndemnisationCourant().isClauseRattrapage()) {
      return constituantsIndemnisation;
    }
    return MajCi.miseAJourConstituantsIndemnisation(attribution, constituantsIndemnisation, dateDeMiseAjour);
  }
  
  public void traiterPeriodeInterruptiveDefinitive(AttributionSpec attribution, UniteTraitement ut, ObjetChronoPeriode objetChronoPeriode, ArretProduitAvecRaison arretProduitAvecRaison, CalendrierExecutionCalculPeriodique calendrier)
    throws CoucheLogiqueException
  {
    if ((objetChronoPeriode instanceof ObjetChronoDateLimiteIndemnisation)) {
      ut.ajouterEvenement(new EvenementDateLimiteIndemnisation(objetChronoPeriode.getDateDebut().veille()));
    } else {
      super.traiterPeriodeInterruptiveDefinitive(attribution, ut, objetChronoPeriode, arretProduitAvecRaison, calendrier);
    }
  }
  
  public int calculerCompteurNombreJoursIndemnisesSurUT(UniteTraitement ut, int cumulNombreJoursServi)
  {
    return cumulNombreJoursServi + ut.getQuantiteIndemnisee().getValeur().intValue();
  }
  
  public void realiserDetectionFinDeProduitPourSuivi(AttributionSpec attribution, UniteTraitement ut, ContexteUT contexteUT)
    throws CoucheLogiqueException
  {
    if ((estArretProduitParDateAnniversaire(attribution, ut)) && (!((AttributionAssuranceSpec)attribution).estMaintenue())) {
      if (((Attribution)attribution).getElementBaseIndemnisation().isClauseRattrapage())
      {
        GestionSuivi.enregistrerEnquetePbjcNcp(attribution, ut.getArretProduitAvecRaison().recupereLendemainDateArret().veille(), 41, 0, true, null, this, ut.getConstituantsIndemnisationEnFinUT());
      }
      else
      {
        GestionSuivi.enregistrerEnquetePbjcNcp(attribution, ut.getArretProduitAvecRaison().recupereLendemainDateArret().veille(), 6, 0, true, null, this, ut.getConstituantsIndemnisationEnFinUT());
        if (ut.getArretProduitAvecRaison().recupereLendemainDateArret().veille().estApresOuCoincideAvec(GestionnaireDateApplication.getInstance().recupererDateApplication("Date d'application pour le courrier KC2N"))) {
          GestionSuivi.enregistrerEnquetePbjcNcp(attribution, ut.getArretProduitAvecRaison().recupereLendemainDateArret().veille(), 42, 0, true, null, this, ut.getConstituantsIndemnisationEnFinUT());
        }
      }
    }
  }
  
  private boolean estArretProduitParDateAnniversaire(AttributionSpec attribution, UniteTraitement ut)
  {
    boolean estArretProduit = false;
    ArretProduitAvecRaison arretProduit = ut.getArretProduitAvecRaison();
    if ((arretProduit != null) && (((Attribution)attribution).getElementBaseIndemnisation() != null))
    {
      Damj dateFinDeDroit = arretProduit.recupereLendemainDateArret().veille();
      if (dateFinDeDroit.coincideAvec(((Attribution)attribution).getElementBaseIndemnisation().getDateLimiteIndemnisation())) {
        estArretProduit = true;
      }
    }
    return estArretProduit;
  }
  
  public void alimenterDonneesSpectacle(AttributionSpec attribution, CalendrierExecutionCalculSpec calendrierExecutionCalcul, DroitPbjcNcp droitPbjcNcp)
  {
    Attribution attrib = (Attribution)attribution;
    
    EtatAuDji etatAuDji = calendrierExecutionCalcul.getEtatAuDJI();
    ElementBaseIndemnisation ebiAttributionSpectacle = attrib.getElementBaseIndemnisation();
    Damj dateAttribution;
    Damj dateAttribution;
    if ((attribution instanceof RepriseSpec)) {
      dateAttribution = attrib.getOuvertureDroit().getDateAttribution();
    } else {
      dateAttribution = attrib.getDateAttribution();
    }
    droitPbjcNcp.setDateDebutDroit(dateAttribution);
    if (ebiAttributionSpectacle != null)
    {
      droitPbjcNcp.setMontantBrutOd(ebiAttributionSpectacle.getMontantBrut());
      if ((ebiAttributionSpectacle.getMontantBrut() != null) && (ebiAttributionSpectacle.getMontantBrutPrecompte() != null)) {
        droitPbjcNcp.setMontantPrecompteOd(ebiAttributionSpectacle.getMontantBrut().subtract(ebiAttributionSpectacle.getMontantBrutPrecompte()));
      }
      droitPbjcNcp.setFranchiseSalaireInit(Integer.valueOf(ebiAttributionSpectacle.getDureeFranchiseSalaire()));
      droitPbjcNcp.setFranchiseCPinit(Integer.valueOf(ebiAttributionSpectacle.getDureeFranchiseCp()));
    }
    if (etatAuDji != null)
    {
      droitPbjcNcp.setReliquatFranchiseCP(etatAuDji.getReliquatFCP());
      droitPbjcNcp.setReliquatFranchiseSalaire(etatAuDji.getReliquatFS());
      int sommeReliquat = 0;
      sommeReliquat += (etatAuDji.getReliquatFCP() != null ? etatAuDji.getReliquatFCP().intValue() : 0);
      sommeReliquat += (etatAuDji.getReliquatFS() != null ? etatAuDji.getReliquatFS().intValue() : 0);
      int nbjourIndemnise = etatAuDji.getCumulJoursIndemnise();
      droitPbjcNcp.setSommeReliquatPlafonee(Integer.valueOf(Math.min(sommeReliquat, nbjourIndemnise)));
    }
  }
  
  protected boolean controlerConditionsDetectionHorsAge(AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, Damj dateDebut)
  {
    return Maintien.getInstance().controlerConditionsDetectionHorsAge((AttributionAssuranceSpec)attribution, constituantsIndemnisation, dateDebut);
  }
  
  protected boolean controlerConditionsDetectionHors100T(AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, Damj dateDebut)
  {
    return Maintien.getInstance().controlerConditionsDetectionHors100T((AttributionAssuranceSpec)attribution, constituantsIndemnisation, dateDebut);
  }
  
  protected void ajoutObjectDetectionMaintien(ChronologiePeriodes chronologiePeriodes, AttributionSpec attribution)
    throws CoucheLogiqueException, NonConformiteException
  {
    if (!((Attribution)attribution).getElementBaseIndemnisation().isClauseRattrapage()) {
      super.ajoutObjectDetectionMaintien(chronologiePeriodes, attribution);
    }
  }
  
  public void alimenterGrapheAntecedentCalcul(AttributionSpec p_attribution)
    throws CoucheLogiqueException
  {
    GestionAntecedentCalcul.getInstance().alimenterGrapheCalcul(p_attribution);
  }
  
  public void appliquerFiltreSurFDDSuiteEpuismentOuDateAnniverssaire(PeriodesPriseEnCompte periodesPriseEnCompte, Periode periodeUT, ContexteUT contexteUT, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    if ((OutilDemande.estUneDemandeFinDeDroitSurEpuissement((AttributionAssuranceSpec)attribution, periodeUT)) && (!((AttributionAssuranceSpec)attribution).getOuvertureDroit().getDateAttribution().coincideAvec(periodeUT.getDebut())))
    {
      Damj dateFinTraitementARattributionPrecedente = null;
      
      List<?> listeAttributions = contexteUT.getListeOrdonneeCandidats();
      Iterator<?> it = listeAttributions.iterator();
      while (it.hasNext())
      {
        AttributionSpec attributionCandidate = (AttributionSpec)it.next();
        if (attributionCandidate != attribution)
        {
          ContexteUT.ElementContexteUT elementContexteUT = contexteUT.getElementContexteUT(attributionCandidate);
          dateFinTraitementARattributionPrecedente = (dateFinTraitementARattributionPrecedente == null) || ((elementContexteUT.recupererDateTraitementARSurMoisDJI() != null) && (dateFinTraitementARattributionPrecedente.estAvant(elementContexteUT.recupererDateTraitementARSurMoisDJI()))) ? elementContexteUT.recupererDateTraitementARSurMoisDJI() : dateFinTraitementARattributionPrecedente;
        }
      }
      if (dateFinTraitementARattributionPrecedente != null)
      {
        periodesPriseEnCompte.tronquePeriodeParTypologieEnDebut(dateFinTraitementARattributionPrecedente.lendemain(), 5);
        periodesPriseEnCompte.tronquePeriodeParTypologieEnDebut(dateFinTraitementARattributionPrecedente.lendemain(), 4);
      }
    }
  }
}

/* Location:
 * Qualified Name:     FacadeCalculProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */