package fr.unedic.cali.asu.ssp07.p03.calcul.outilsfonctionnels;

import fr.unedic.cali.asu.calcul.dom.temps.ObjetChronoPeriodeFinDureeMaintienDroit;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.periode.PeriodeBlocageIndemnisation;
import fr.unedic.cali.calcul.dom.periode.PeriodeChevauchementSanction;
import fr.unedic.cali.calcul.dom.periode.PeriodeConflitGAEC;
import fr.unedic.cali.calcul.dom.periode.PeriodeExclusionDefinitiveDDTE;
import fr.unedic.cali.calcul.dom.periode.PeriodeSuspensionDDTEAvecImputation;
import fr.unedic.cali.calcul.dom.periode.PeriodeSuspensionDDTESansImputation;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeAttributionSecteurPublic;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeCalcul;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeDemandeClassementSP;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeFinPec;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeInterProduits;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeRetraite;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreAttributionSurDecisions;
import fr.unedic.cali.utilitaire.outils.OutilRecherche;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;

public class Qualification
  extends fr.unedic.cali.asu.spe02.p03.calcul.outilsfonctionnels.Qualification
{
  protected boolean qualifierUnePeriodeInterruptivesDefinitives(ObjetChronoPeriodeCalcul periode, QualificationPeriodes qualificationPeriodes, AttributionSpec attribution)
  {
    ObjetChronoPeriodeInterProduits objetChronoPeriodeInterProduits = null;
    if (((periode instanceof ObjetChronoPeriodeAttributionSecteurPublic)) && (!attribution.equals(((ObjetChronoPeriodeAttributionSecteurPublic)periode).getAttribution())))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if (((periode instanceof ObjetChronoPeriodeInterProduits)) && (!attribution.equals(((ObjetChronoPeriodeInterProduits)periode).getAttribution())))
    {
      if ((((ObjetChronoPeriodeInterProduits)periode).getTypePeriode() == 2) && (((ObjetChronoPeriodeInterProduits)periode).getGamme().equals("ASU")))
      {
        objetChronoPeriodeInterProduits = (ObjetChronoPeriodeInterProduits)periode;
        AttributionAssuranceSpec attributionAsu = (AttributionAssuranceSpec)objetChronoPeriodeInterProduits.getAttribution();
        if (!attributionAsu.estDemandeSuiteFinDeDroit()) {
          qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
        }
      }
      else if (((ObjetChronoPeriodeInterProduits)periode).getNomProduit().equals("INR_RCE04_01"))
      {
        qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
      }
      else
      {
        return false;
      }
    }
    else if ((periode instanceof ObjetChronoPeriodeRetraite))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if (((periode instanceof PeriodeExclusionDefinitiveDDTE)) && (((PeriodeExclusionDefinitiveDDTE)periode).getRSOD().equals(attribution.getRsod())))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if ((periode instanceof PeriodeConflitGAEC))
    {
      if ((attribution.getDateAttribution() != null) && (attribution.getDateAttribution().estApres(periode.getDateDebut()))) {
        periode.setDateDebut(attribution.getDateAttribution());
      }
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if ((periode instanceof PeriodeChevauchementSanction))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if ((periode instanceof PeriodeBlocageIndemnisation))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if ((periode instanceof ObjetChronoPeriodeDemandeClassementSP))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if ((periode instanceof ObjetChronoPeriodeFinDureeMaintienDroit))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else if ((periode instanceof ObjetChronoPeriodeFinPec))
    {
      qualificationPeriodes.ajouterPeriodesInterruptivesDefinitives(periode);
    }
    else
    {
      return false;
    }
    return true;
  }
  
  public boolean qualifierUnePeriodeSuspensives(ObjetChronoPeriodeCalcul periode, QualificationPeriodes qualificationPeriodes, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    if ((periode instanceof PeriodeSuspensionDDTEAvecImputation))
    {
      if (attribution.getRsod() != null) {
        if (attribution.getRsod().equals(((PeriodeSuspensionDDTEAvecImputation)periode).getRSOD()))
        {
          qualificationPeriodes.ajouterPeriodesSuspensives(periode);
        }
        else
        {
          FiltreAttributionSurDecisions filtreCali = new FiltreAttributionSurDecisions(true);
          AttributionSpec odAsu = (AttributionSpec)OutilRecherche.rechercherDecisionPrecedente(attribution.getDemandeur().getChronoDemandesNonTriees(), attribution, filtreCali);
          if ((odAsu != null) && (odAsu.getRsod().equals(((PeriodeSuspensionDDTEAvecImputation)periode).getRSOD())) && (estUnProduitSpectacle(odAsu))) {
            qualificationPeriodes.ajouterPeriodesSuspensives(periode);
          }
        }
      }
    }
    else if ((periode instanceof PeriodeSuspensionDDTESansImputation))
    {
      if (attribution.getRsod() != null) {
        if (attribution.getRsod().equals(((PeriodeSuspensionDDTESansImputation)periode).getRSOD()))
        {
          qualificationPeriodes.ajouterPeriodesSuspensives(periode);
        }
        else
        {
          FiltreAttributionSurDecisions filtreCali = new FiltreAttributionSurDecisions(true);
          AttributionSpec odAsu = (AttributionSpec)OutilRecherche.rechercherDecisionPrecedente(attribution.getDemandeur().getChronoDemandesNonTriees(), attribution, filtreCali);
          if ((odAsu != null) && (odAsu.getRsod().equals(((PeriodeSuspensionDDTESansImputation)periode).getRSOD())) && (estUnProduitSpectacle(odAsu))) {
            qualificationPeriodes.ajouterPeriodesSuspensives(periode);
          }
        }
      }
    }
    else {
      return super.qualifierUnePeriodeSuspensives(periode, qualificationPeriodes, attribution);
    }
    return true;
  }
  
  private boolean estUnProduitSpectacle(AttributionSpec odAsu)
  {
    return ("ASU_SPE02_03".equals(odAsu.getProduit().getNomUnique())) || ("ASU_SPE02_04".equals(odAsu.getProduit().getNomUnique())) || ("ASU_SPE02_05".equals(odAsu.getProduit().getNomUnique())) || ("ASU_SPE02_06".equals(odAsu.getProduit().getNomUnique()));
  }
}

/* Location:
 * Qualified Name:     Qualification
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */