package fr.unedic.cali.asu.ssp07.p05.avant.outilsfonctionnels;

import fr.unedic.cali.asu.spe02.p03.calcul.outilsfonctionnels.Qualification;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.Attribution;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.PreavisMesureConservatoireNonIndemnisable;
import fr.unedic.cali.asu.ssp07.p05.avant.FacadeAvantProduitImpl;
import fr.unedic.cali.calcul.dom.ArretProduitAvecRaison;
import fr.unedic.cali.calcul.dom.CalendrierExecutionAvant;
import fr.unedic.cali.calcul.dom.ConsommationPeriodes;
import fr.unedic.cali.calcul.dom.DureeConsommableAvant;
import fr.unedic.cali.calcul.dom.EtatAuDernierJourAvant;
import fr.unedic.cali.calcul.dom.QualificationPeriodes;
import fr.unedic.cali.calcul.dom.UniteTraitementAvant;
import fr.unedic.cali.calcul.dom.periode.PeriodeConflitGAEC;
import fr.unedic.cali.calcul.dom.periode.PeriodeExclusionDefinitiveDDTE;
import fr.unedic.cali.calcul.dom.periode.PeriodeFormationNonIndemniseeAbsenceHeure;
import fr.unedic.cali.calcul.dom.temps.ObjetChronoPeriodeCalcul;
import fr.unedic.cali.calcul.outilsfonctionnels.dom.PeriodesPriseEnCompte;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.outilsfonctionnels.Anomalie;
import fr.unedic.cali.outilsfonctionnels.GestionAnomalies;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteJour;
import fr.unedic.util.Unite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.FiltreChevauchePeriode;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import java.util.Iterator;

public class TraitementUtAvant
  extends fr.unedic.cali.asu.spe02.p05.avant.outilsfonctionnels.TraitementUtAvant
{
  public static int executerUtAvant(AttributionSpec attribution, CalendrierExecutionAvant calendrierAvant, Periode periodeUtAvant, ChronologiePeriodes chronologiePeriodes)
    throws CoucheLogiqueException
  {
    UniteTraitementAvant utAvant = executerAttributionAvant(attribution, calendrierAvant, periodeUtAvant, chronologiePeriodes);
    return executerUtAvant(calendrierAvant, utAvant, attribution);
  }
  
  public static UniteTraitementAvant executerAttributionAvant(AttributionSpec attribution, CalendrierExecutionAvant calendrierAvant, Periode periodeUtAvant, ChronologiePeriodes chronologiePeriodes)
    throws CoucheLogiqueException
  {
    ChronologiePeriodes chronoPeriodesSurUt = new ChronologiePeriodes(new FiltreChevauchePeriode(new Periode(periodeUtAvant.getDebut(), periodeUtAvant.getFin().lendemain())));
    
    chronoPeriodesSurUt.ajouter(chronologiePeriodes);
    
    Qualification qualification = new Qualification();
    QualificationPeriodes periodesQualifie = qualification.qualificationPeriodesPourAvant(chronoPeriodesSurUt, attribution);
    
    ChronologiePeriodes periodesInterruptives = periodesQualifie.getPeriodesInterruptivesDefinitives();
    ChronologiePeriodes periodesNouvellesInterruptives = new ChronologiePeriodes();
    periodesInterruptives.iterer();
    while (periodesInterruptives.encoreSuivant())
    {
      ObjetChronoPeriodeCalcul periode = (ObjetChronoPeriodeCalcul)periodesInterruptives.elementSuivant();
      if (periode.getDateDebut().estApresOuCoincideAvec(attribution.getDateAttribution())) {
        periodesNouvellesInterruptives.ajouter(periode);
      }
    }
    periodesQualifie.setPeriodesInterruptivesDefinitives(periodesNouvellesInterruptives);
    return executerAttributionAvant(attribution, calendrierAvant, periodeUtAvant, periodesQualifie);
  }
  
  public static int executerUtAvant(CalendrierExecutionAvant calendrierAvant, UniteTraitementAvant utAvant, AttributionSpec attribution)
    throws CoucheLogiqueException
  {
    int etat = 0;
    
    mettreAJourDateFinConsommation(utAvant);
    
    calendrierAvant.ajouterUniteTraitementAvant(utAvant);
    if (utAvant.isProduitATerminerApresUT())
    {
      Damj dateDJA = Damj.max(utAvant.getArretProduitAvecRaison().recupereLendemainDateArret().veille(), attribution.getDateAttribution().veille());
      calendrierAvant.setDernierJourAvant(dateDJA);
      if ((etat == 0) && (utAvant.getArretProduitAvecRaison().isRaisonsContientRaison(4))) {
        etat = 1;
      }
      ChronologiePeriodes periodesInterruptivesDefinitives = new ChronologiePeriodes();
      periodesInterruptivesDefinitives.ajouter(utAvant.getArretProduitAvecRaison().getPeriodesInterruptivesDefinitives());
      if (!periodesInterruptivesDefinitives.estVide())
      {
        Damj datePeriodeInterruptives = null;
        
        ObjetChronoPeriode premiereChronoPeriode = null;
        
        periodesInterruptivesDefinitives.iterer();
        while (periodesInterruptivesDefinitives.encoreSuivant())
        {
          ObjetChronoPeriode objetChronoPeriode = (ObjetChronoPeriode)periodesInterruptivesDefinitives.elementSuivant();
          datePeriodeInterruptives = objetChronoPeriode.getDateDebut();
          if ((datePeriodeInterruptives.estContenueDans(new Periode(calendrierAvant.getDateDebut(), calendrierAvant.getDateFin().lendemain()))) && ((premiereChronoPeriode == null) || (objetChronoPeriode.getDateDebut().estAvant(premiereChronoPeriode.getDateDebut())))) {
            premiereChronoPeriode = objetChronoPeriode;
          }
        }
        etat = gestionAnomalie(calendrierAvant, attribution.getDemandeur(), etat, premiereChronoPeriode);
      }
      mettreAJourPeriodeApplicationDureeConsommableAvant(calendrierAvant);
      calendrierAvant.setEtatAuDernierJourAvant(new EtatAuDernierJourAvant(utAvant, etat, null));
    }
    return etat;
  }
  
  private static int gestionAnomalie(CalendrierExecutionAvant calendrierAvant, IndividuSpec individu, int etat, ObjetChronoPeriode premiereChronoPeriode)
    throws CoucheLogiqueException
  {
    int etatTmp = etat;
    if ((premiereChronoPeriode instanceof PeriodeExclusionDefinitiveDDTE)) {
      etatTmp = 9;
    } else if ((premiereChronoPeriode instanceof PeriodeConflitGAEC)) {
      GestionAnomalies.ajouteAnomalie(new Anomalie("M02", calendrierAvant.getDateFin().lendemain(), ""), individu);
    } else if ((premiereChronoPeriode instanceof PeriodeFormationNonIndemniseeAbsenceHeure)) {
      GestionAnomalies.ajouteAnomalie(new Anomalie("M06", calendrierAvant.getDateFin().lendemain(), ""), individu);
    }
    return etatTmp;
  }
  
  private static void mettreAJourDateFinConsommation(UniteTraitementAvant utAvant)
  {
    DureeConsommableAvant dureeActive = utAvant.getDureeConsommableAvantActiveEnFinUt();
    if (dureeActive != null)
    {
      Periode p = utAvant.getConsommationPeriodes().getPeriodesParTypologie(dureeActive.getTypeDureeConsommable());
      if (p != null) {
        if (utAvant.isProduitATerminerApresUT()) {
          p.setFin(utAvant.getArretProduitAvecRaison().recupereLendemainDateArret().veille());
        } else {
          p.setFin(utAvant.getDateFin());
        }
      }
    }
  }
  
  protected static void mettreAJourPeriodeApplicationDureeConsommableAvant(CalendrierExecutionAvant calendrierExecutionAvant)
  {
    Chronologie uts = calendrierExecutionAvant.getChronologieUnitesTraitements();
    UniteTraitementAvant derniereUtAvant = (UniteTraitementAvant)uts.dernierElement();
    DureeConsommableAvant duree = null;
    Periode periodeConsoPmc = getPeriode(calendrierExecutionAvant, 0);
    
    duree = derniereUtAvant.getDureePmcEnFinUT();
    if (duree != null) {
      duree.setPeriodeApplicationCarence(periodeConsoPmc);
    }
  }
  
  public static UniteTraitementAvant executerAttributionAvant(AttributionSpec attribution, CalendrierExecutionAvant calendrierAvant, Periode periodeUtAvant, QualificationPeriodes periodesQualifie)
    throws CoucheLogiqueException
  {
    UniteTraitementAvant utAvant = null;
    ChronologiePeriodes periodesAnalyses = null;
    PeriodesPriseEnCompte periodesPriseEnCompte = null;
    
    Periode pUtAvant = (Periode)periodeUtAvant.copie();
    
    utAvant = new UniteTraitementAvant(Unite.get("jour"), pUtAvant);
    
    utAvant.setQualificationPeriodes(periodesQualifie);
    
    utAvant.setConsommationPeriodes(new ConsommationPeriodes());
    
    periodesPriseEnCompte = new PeriodesPriseEnCompte(periodeUtAvant);
    if (calendrierAvant.getEtatExecutionAvant() == 1)
    {
      periodesPriseEnCompte.tronquePeriodesPriseEnCompteEnDebut(calendrierAvant.getPremierJourAvant());
      
      calendrierAvant.setEtatExecutionAvant(2);
    }
    initialiserDureesConsommablesAvant(calendrierAvant, utAvant, attribution);
    
    ArretProduitAvecRaison arretProduitAvecRaison = effectuerTraitementPeriodes(utAvant, periodesPriseEnCompte);
    
    DureeConsommableAvant dureeActive = utAvant.getDureeConsommableAvantActiveEnDebutUt();
    if ((dureeActive != null) && (dureeActive.getQuantiteInitial().getValeurEntiere() > 0))
    {
      Periode p = utAvant.getConsommationPeriodes().getPeriodesParTypologie(dureeActive.getTypeDureeConsommable());
      if (p == null)
      {
        p = new Periode(utAvant.getDateDebut());
        utAvant.getConsommationPeriodes().setPeriodesParTypologie(dureeActive.getTypeDureeConsommable(), p);
      }
    }
    periodesAnalyses = creerLesPeriodesAnalyses(utAvant, utAvant.getQualificationPeriodes(), periodesPriseEnCompte);
    
    TraitementPeriodesAnalyseAvant.traitementDesPeriodesAnalyses(utAvant, periodesAnalyses);
    if (arretProduitAvecRaison.isProduitAArreter())
    {
      utAvant.setProduitATerminerApresUT(true);
      utAvant.setArretProduitAvecRaison(arretProduitAvecRaison);
      calendrierAvant.setEtatExecutionAvant(3);
    }
    return utAvant;
  }
  
  public static void initialiserDureesConsommablesAvant(CalendrierExecutionAvant calendrierAvant, UniteTraitementAvant putAvant, AttributionSpec attribution)
  {
    if (calendrierAvant.getChronologieUnitesTraitements() != null)
    {
      UniteTraitementAvant utAvant = null;
      Iterator<?> listeUt = calendrierAvant.getChronologieUnitesTraitements().iterer();
      while (listeUt.hasNext()) {
        utAvant = (UniteTraitementAvant)listeUt.next();
      }
      if (utAvant != null)
      {
        if (utAvant.getDureePmcEnFinUT() != null)
        {
          DureeConsommableAvant dureePmc = (DureeConsommableAvant)utAvant.getDureePmcEnFinUT().copie();
          putAvant.setDureePmcEnDebutUT(dureePmc);
        }
        if (utAvant.getDureeDiffereSpecifiqueEnFinUT() != null)
        {
          DureeConsommableAvant dureeDiffereSpecifique = (DureeConsommableAvant)utAvant.getDureeDiffereSpecifiqueEnFinUT().copie();
          putAvant.setDureeDiffereSpecifiqueEnDebutUT(dureeDiffereSpecifique);
        }
        if (utAvant.getDureeDiffereStandardEnFinUT() != null)
        {
          DureeConsommableAvant dureeDiffereStandard = (DureeConsommableAvant)utAvant.getDureeDiffereStandardEnFinUT().copie();
          putAvant.setDureeDiffereStandardEnDebutUT(dureeDiffereStandard);
        }
        if (utAvant.getDureeDelaiAttenteEnFinUT() != null)
        {
          DureeConsommableAvant dureeDelaiAttente = (DureeConsommableAvant)utAvant.getDureeDelaiAttenteEnFinUT().copie();
          putAvant.setDureeDelaiAttenteEnDebutUT(dureeDelaiAttente);
        }
        return;
      }
    }
    creerDureeIndemnisation(attribution, calendrierAvant, putAvant);
  }
  
  private static void creerDureeIndemnisation(AttributionSpec attribution, CalendrierExecutionAvant calendrierAvant, UniteTraitementAvant utAvant)
  {
    DureeConsommableAvant dureePmc = new DureeConsommableAvant(0, new QuantiteJour("0"));
    DureeConsommableAvant dureeDiffereStandard = new DureeConsommableAvant(1, new QuantiteJour("0"));
    DureeConsommableAvant dureeDiffereSpecifique = new DureeConsommableAvant(2, new QuantiteJour("0"));
    DureeConsommableAvant dureeDelaiAttente = new DureeConsommableAvant(3, new QuantiteJour("0"));
    
    PreavisMesureConservatoireNonIndemnisable pmc = FacadeAvantProduitImpl.getPmcAConsommer((Attribution)attribution);
    if (pmc != null) {
      dureePmc.setQuantiteInitial(pmc.getQuantiteInitiale());
    }
    dureePmc.activer();
    if (dureePmc.getQuantiteInitial().getValeurEntiere() > 0)
    {
      Periode p = new Periode(calendrierAvant.getPremierJourAvant());
      utAvant.getConsommationPeriodes().setPeriodePmc(p);
    }
    utAvant.setDureePmcEnDebutUT(dureePmc);
    utAvant.setDureeDiffereStandardEnDebutUT(dureeDiffereStandard);
    utAvant.setDureeDiffereSpecifiqueEnDebutUT(dureeDiffereSpecifique);
    utAvant.setDureeDelaiAttenteEnDebutUT(dureeDelaiAttente);
  }
}

/* Location:
 * Qualified Name:     TraitementUtAvant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */