package fr.unedic.logique.donnees.dr1.service.vls;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.archi.logique.adaptateur.ObjetSerialisableFournisseur;
import java.io.Serializable;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class _YI24Impl
  extends YI24
  implements ObjetSerialisableFournisseur, Serializable
{
  private static final long serialVersionUID = 1L;
  private final _YI24 m_YI24Infra;
  
  public _YI24Impl()
  {
    m_YI24Infra = new _YI24();
  }
  
  public _YI24Impl(_YI24 pValeur)
  {
    ExceptionUtil.assertMethodParamNotNull("YI24Infra", pValeur);
    
    m_YI24Infra = pValeur;
  }
  
  public Object getObjet()
  {
    return m_YI24Infra;
  }
  
  public String getIdentifiant()
  {
    return m_YI24Infra.get_IDENT();
  }
  
  public void setIdentifiant(String pIdentifiant)
  {
    m_YI24Infra.set_IDENT(pIdentifiant);
  }
  
  public String getCodeEtat()
  {
    return m_YI24Infra.get_C_ETAT();
  }
  
  public void setCodeEtat(String pCode)
  {
    m_YI24Infra.set_C_ETAT(pCode);
  }
  
  public String getCSNEN()
  {
    return m_YI24Infra.getCSNEN_Nature_d_environnement();
  }
  
  public String getCodeErreurCSNEN()
  {
    return m_YI24Infra.getCSNEN_Nature_d_environnement_C_ERR();
  }
  
  public void setCSNEN(String pValeur)
  {
    m_YI24Infra.setCSNEN_Nature_d_environnement(pValeur);
  }
  
  public void setCodeErreurCSNEN(String pCodeErreur)
  {
    m_YI24Infra.setCSNEN_Nature_d_environnement_C_ERR(pCodeErreur);
  }
  
  public String getCSNEN_Nature_d_environnement()
  {
    return m_YI24Infra.getCSNEN_Nature_d_environnement();
  }
  
  public String getCodeErreurCSNEN_Nature_d_environnement()
  {
    return m_YI24Infra.getCSNEN_Nature_d_environnement_C_ERR();
  }
  
  public void setCSNEN_Nature_d_environnement(String pValeur)
  {
    m_YI24Infra.setCSNEN_Nature_d_environnement(pValeur);
  }
  
  public void setCodeErreurCSNEN_Nature_d_environnement(String pCodeErreur)
  {
    m_YI24Infra.setCSNEN_Nature_d_environnement_C_ERR(pCodeErreur);
  }
  
  public String getCDJBA()
  {
    return m_YI24Infra.getCDJBA_Jeu_de_Base();
  }
  
  public String getCodeErreurCDJBA()
  {
    return m_YI24Infra.getCDJBA_Jeu_de_Base_C_ERR();
  }
  
  public void setCDJBA(String pValeur)
  {
    m_YI24Infra.setCDJBA_Jeu_de_Base(pValeur);
  }
  
  public void setCodeErreurCDJBA(String pCodeErreur)
  {
    m_YI24Infra.setCDJBA_Jeu_de_Base_C_ERR(pCodeErreur);
  }
  
  public String getCDJBA_Jeu_de_Base()
  {
    return m_YI24Infra.getCDJBA_Jeu_de_Base();
  }
  
  public String getCodeErreurCDJBA_Jeu_de_Base()
  {
    return m_YI24Infra.getCDJBA_Jeu_de_Base_C_ERR();
  }
  
  public void setCDJBA_Jeu_de_Base(String pValeur)
  {
    m_YI24Infra.setCDJBA_Jeu_de_Base(pValeur);
  }
  
  public void setCodeErreurCDJBA_Jeu_de_Base(String pCodeErreur)
  {
    m_YI24Infra.setCDJBA_Jeu_de_Base_C_ERR(pCodeErreur);
  }
  
  public String getCNSRP()
  {
    return m_YI24Infra.getCNSRP_Serveur_Physique();
  }
  
  public String getCodeErreurCNSRP()
  {
    return m_YI24Infra.getCNSRP_Serveur_Physique_C_ERR();
  }
  
  public void setCNSRP(String pValeur)
  {
    m_YI24Infra.setCNSRP_Serveur_Physique(pValeur);
  }
  
  public void setCodeErreurCNSRP(String pCodeErreur)
  {
    m_YI24Infra.setCNSRP_Serveur_Physique_C_ERR(pCodeErreur);
  }
  
  public String getCNSRP_Serveur_Physique()
  {
    return m_YI24Infra.getCNSRP_Serveur_Physique();
  }
  
  public String getCodeErreurCNSRP_Serveur_Physique()
  {
    return m_YI24Infra.getCNSRP_Serveur_Physique_C_ERR();
  }
  
  public void setCNSRP_Serveur_Physique(String pValeur)
  {
    m_YI24Infra.setCNSRP_Serveur_Physique(pValeur);
  }
  
  public void setCodeErreurCNSRP_Serveur_Physique(String pCodeErreur)
  {
    m_YI24Infra.setCNSRP_Serveur_Physique_C_ERR(pCodeErreur);
  }
  
  public _YI24 getYI24Infra()
  {
    return m_YI24Infra;
  }
  
  public String toString()
  {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
  }
  
  public boolean isEnErreur()
  {
    if ((getCodeErreurCSNEN() != null) && 
      ("".equals(getCodeErreurCSNEN()))) {
      return true;
    }
    if ((getCodeErreurCDJBA() != null) && 
      ("".equals(getCodeErreurCDJBA()))) {
      return true;
    }
    if ((getCodeErreurCNSRP() != null) && 
      ("".equals(getCodeErreurCNSRP()))) {
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     _YI24Impl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */