package fr.unedic.logique.donnees.dr1.service.vls;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.archi.logique.adaptateur.ObjetSerialisableFournisseur;
import fr.unedic.util.temps.Damj;
import java.io.Serializable;
import java.math.BigDecimal;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class _YI5LImpl
  extends YI5L
  implements ObjetSerialisableFournisseur, Serializable
{
  private static final long serialVersionUID = 1L;
  private final _YI5L m_YI5LInfra;
  
  public _YI5LImpl()
  {
    m_YI5LInfra = new _YI5L();
  }
  
  public _YI5LImpl(_YI5L pValeur)
  {
    ExceptionUtil.assertMethodParamNotNull("YI5LInfra", pValeur);
    
    m_YI5LInfra = pValeur;
  }
  
  public Object getObjet()
  {
    return m_YI5LInfra;
  }
  
  public String getIdentifiant()
  {
    return m_YI5LInfra.get_IDENT();
  }
  
  public void setIdentifiant(String pIdentifiant)
  {
    m_YI5LInfra.set_IDENT(pIdentifiant);
  }
  
  public String getCodeEtat()
  {
    return m_YI5LInfra.get_C_ETAT();
  }
  
  public void setCodeEtat(String pCode)
  {
    m_YI5LInfra.set_C_ETAT(pCode);
  }
  
  public BigDecimal getRSRS2()
  {
    return m_YI5LInfra.getRSRS2_IDENT_RESSOURCES();
  }
  
  public String getCodeErreurRSRS2()
  {
    return m_YI5LInfra.getRSRS2_IDENT_RESSOURCES_C_ERR();
  }
  
  public void setRSRS2(BigDecimal pValeur)
  {
    m_YI5LInfra.setRSRS2_IDENT_RESSOURCES(pValeur);
  }
  
  public void setCodeErreurRSRS2(String pCodeErreur)
  {
    m_YI5LInfra.setRSRS2_IDENT_RESSOURCES_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getRSRS2_IDENT_RESSOURCES()
  {
    return m_YI5LInfra.getRSRS2_IDENT_RESSOURCES();
  }
  
  public String getCodeErreurRSRS2_IDENT_RESSOURCES()
  {
    return m_YI5LInfra.getRSRS2_IDENT_RESSOURCES_C_ERR();
  }
  
  public void setRSRS2_IDENT_RESSOURCES(BigDecimal pValeur)
  {
    m_YI5LInfra.setRSRS2_IDENT_RESSOURCES(pValeur);
  }
  
  public void setCodeErreurRSRS2_IDENT_RESSOURCES(String pCodeErreur)
  {
    m_YI5LInfra.setRSRS2_IDENT_RESSOURCES_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getNSARSA()
  {
    return m_YI5LInfra.getNSARSA_ANNEE_DE_PERCEPTION_DES_RESSOURCES();
  }
  
  public String getCodeErreurNSARSA()
  {
    return m_YI5LInfra.getNSARSA_ANNEE_DE_PERCEPTION_DES_RESSOURCES_C_ERR();
  }
  
  public void setNSARSA(BigDecimal pValeur)
  {
    m_YI5LInfra.setNSARSA_ANNEE_DE_PERCEPTION_DES_RESSOURCES(pValeur);
  }
  
  public void setCodeErreurNSARSA(String pCodeErreur)
  {
    m_YI5LInfra.setNSARSA_ANNEE_DE_PERCEPTION_DES_RESSOURCES_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getNSARSA_ANNEE_DE_PERCEPTION_DES_RESSOURCES()
  {
    return m_YI5LInfra.getNSARSA_ANNEE_DE_PERCEPTION_DES_RESSOURCES();
  }
  
  public String getCodeErreurNSARSA_ANNEE_DE_PERCEPTION_DES_RESSOURCES()
  {
    return m_YI5LInfra.getNSARSA_ANNEE_DE_PERCEPTION_DES_RESSOURCES_C_ERR();
  }
  
  public void setNSARSA_ANNEE_DE_PERCEPTION_DES_RESSOURCES(BigDecimal pValeur)
  {
    m_YI5LInfra.setNSARSA_ANNEE_DE_PERCEPTION_DES_RESSOURCES(pValeur);
  }
  
  public void setCodeErreurNSARSA_ANNEE_DE_PERCEPTION_DES_RESSOURCES(String pCodeErreur)
  {
    m_YI5LInfra.setNSARSA_ANNEE_DE_PERCEPTION_DES_RESSOURCES_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getNSRRSA()
  {
    return m_YI5LInfra.getNSRRSA_MOIS_DE_PERCEPTION_DES_RESSOURCES();
  }
  
  public String getCodeErreurNSRRSA()
  {
    return m_YI5LInfra.getNSRRSA_MOIS_DE_PERCEPTION_DES_RESSOURCES_C_ERR();
  }
  
  public void setNSRRSA(BigDecimal pValeur)
  {
    m_YI5LInfra.setNSRRSA_MOIS_DE_PERCEPTION_DES_RESSOURCES(pValeur);
  }
  
  public void setCodeErreurNSRRSA(String pCodeErreur)
  {
    m_YI5LInfra.setNSRRSA_MOIS_DE_PERCEPTION_DES_RESSOURCES_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getNSRRSA_MOIS_DE_PERCEPTION_DES_RESSOURCES()
  {
    return m_YI5LInfra.getNSRRSA_MOIS_DE_PERCEPTION_DES_RESSOURCES();
  }
  
  public String getCodeErreurNSRRSA_MOIS_DE_PERCEPTION_DES_RESSOURCES()
  {
    return m_YI5LInfra.getNSRRSA_MOIS_DE_PERCEPTION_DES_RESSOURCES_C_ERR();
  }
  
  public void setNSRRSA_MOIS_DE_PERCEPTION_DES_RESSOURCES(BigDecimal pValeur)
  {
    m_YI5LInfra.setNSRRSA_MOIS_DE_PERCEPTION_DES_RESSOURCES(pValeur);
  }
  
  public void setCodeErreurNSRRSA_MOIS_DE_PERCEPTION_DES_RESSOURCES(String pCodeErreur)
  {
    m_YI5LInfra.setNSRRSA_MOIS_DE_PERCEPTION_DES_RESSOURCES_C_ERR(pCodeErreur);
  }
  
  public String getCSMSF4()
  {
    return m_YI5LInfra.getCSMSF4_SITUATION_FAMILIALE();
  }
  
  public String getCodeErreurCSMSF4()
  {
    return m_YI5LInfra.getCSMSF4_SITUATION_FAMILIALE_C_ERR();
  }
  
  public void setCSMSF4(String pValeur)
  {
    m_YI5LInfra.setCSMSF4_SITUATION_FAMILIALE(pValeur);
  }
  
  public void setCodeErreurCSMSF4(String pCodeErreur)
  {
    m_YI5LInfra.setCSMSF4_SITUATION_FAMILIALE_C_ERR(pCodeErreur);
  }
  
  public String getCSMSF4_SITUATION_FAMILIALE()
  {
    return m_YI5LInfra.getCSMSF4_SITUATION_FAMILIALE();
  }
  
  public String getCodeErreurCSMSF4_SITUATION_FAMILIALE()
  {
    return m_YI5LInfra.getCSMSF4_SITUATION_FAMILIALE_C_ERR();
  }
  
  public void setCSMSF4_SITUATION_FAMILIALE(String pValeur)
  {
    m_YI5LInfra.setCSMSF4_SITUATION_FAMILIALE(pValeur);
  }
  
  public void setCodeErreurCSMSF4_SITUATION_FAMILIALE(String pCodeErreur)
  {
    m_YI5LInfra.setCSMSF4_SITUATION_FAMILIALE_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getQMRS4()
  {
    return m_YI5LInfra.getQMRS4_MONTANT_RESSOURCE_MENSUEL();
  }
  
  public String getCodeErreurQMRS4()
  {
    return m_YI5LInfra.getQMRS4_MONTANT_RESSOURCE_MENSUEL_C_ERR();
  }
  
  public void setQMRS4(BigDecimal pValeur)
  {
    m_YI5LInfra.setQMRS4_MONTANT_RESSOURCE_MENSUEL(pValeur);
  }
  
  public void setCodeErreurQMRS4(String pCodeErreur)
  {
    m_YI5LInfra.setQMRS4_MONTANT_RESSOURCE_MENSUEL_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getQMRS4_MONTANT_RESSOURCE_MENSUEL()
  {
    return m_YI5LInfra.getQMRS4_MONTANT_RESSOURCE_MENSUEL();
  }
  
  public String getCodeErreurQMRS4_MONTANT_RESSOURCE_MENSUEL()
  {
    return m_YI5LInfra.getQMRS4_MONTANT_RESSOURCE_MENSUEL_C_ERR();
  }
  
  public void setQMRS4_MONTANT_RESSOURCE_MENSUEL(BigDecimal pValeur)
  {
    m_YI5LInfra.setQMRS4_MONTANT_RESSOURCE_MENSUEL(pValeur);
  }
  
  public void setCodeErreurQMRS4_MONTANT_RESSOURCE_MENSUEL(String pCodeErreur)
  {
    m_YI5LInfra.setQMRS4_MONTANT_RESSOURCE_MENSUEL_C_ERR(pCodeErreur);
  }
  
  public String getCSCTF()
  {
    return m_YI5LInfra.getCSCTF_CODE_DE_CERTIFICATION_PERIODE();
  }
  
  public String getCodeErreurCSCTF()
  {
    return m_YI5LInfra.getCSCTF_CODE_DE_CERTIFICATION_PERIODE_C_ERR();
  }
  
  public void setCSCTF(String pValeur)
  {
    m_YI5LInfra.setCSCTF_CODE_DE_CERTIFICATION_PERIODE(pValeur);
  }
  
  public void setCodeErreurCSCTF(String pCodeErreur)
  {
    m_YI5LInfra.setCSCTF_CODE_DE_CERTIFICATION_PERIODE_C_ERR(pCodeErreur);
  }
  
  public String getCSCTF_CODE_DE_CERTIFICATION_PERIODE()
  {
    return m_YI5LInfra.getCSCTF_CODE_DE_CERTIFICATION_PERIODE();
  }
  
  public String getCodeErreurCSCTF_CODE_DE_CERTIFICATION_PERIODE()
  {
    return m_YI5LInfra.getCSCTF_CODE_DE_CERTIFICATION_PERIODE_C_ERR();
  }
  
  public void setCSCTF_CODE_DE_CERTIFICATION_PERIODE(String pValeur)
  {
    m_YI5LInfra.setCSCTF_CODE_DE_CERTIFICATION_PERIODE(pValeur);
  }
  
  public void setCodeErreurCSCTF_CODE_DE_CERTIFICATION_PERIODE(String pCodeErreur)
  {
    m_YI5LInfra.setCSCTF_CODE_DE_CERTIFICATION_PERIODE_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getNSOPRL()
  {
    return m_YI5LInfra.getNSOPRL_SAUVEGARDE_RANG_DUREES_ARI_DJC_();
  }
  
  public String getCodeErreurNSOPRL()
  {
    return m_YI5LInfra.getNSOPRL_SAUVEGARDE_RANG_DUREES_ARI_DJC__C_ERR();
  }
  
  public void setNSOPRL(BigDecimal pValeur)
  {
    m_YI5LInfra.setNSOPRL_SAUVEGARDE_RANG_DUREES_ARI_DJC_(pValeur);
  }
  
  public void setCodeErreurNSOPRL(String pCodeErreur)
  {
    m_YI5LInfra.setNSOPRL_SAUVEGARDE_RANG_DUREES_ARI_DJC__C_ERR(pCodeErreur);
  }
  
  public BigDecimal getNSOPRL_SAUVEGARDE_RANG_DUREES_ARI_DJC_()
  {
    return m_YI5LInfra.getNSOPRL_SAUVEGARDE_RANG_DUREES_ARI_DJC_();
  }
  
  public String getCodeErreurNSOPRL_SAUVEGARDE_RANG_DUREES_ARI_DJC_()
  {
    return m_YI5LInfra.getNSOPRL_SAUVEGARDE_RANG_DUREES_ARI_DJC__C_ERR();
  }
  
  public void setNSOPRL_SAUVEGARDE_RANG_DUREES_ARI_DJC_(BigDecimal pValeur)
  {
    m_YI5LInfra.setNSOPRL_SAUVEGARDE_RANG_DUREES_ARI_DJC_(pValeur);
  }
  
  public void setCodeErreurNSOPRL_SAUVEGARDE_RANG_DUREES_ARI_DJC_(String pCodeErreur)
  {
    m_YI5LInfra.setNSOPRL_SAUVEGARDE_RANG_DUREES_ARI_DJC__C_ERR(pCodeErreur);
  }
  
  public String getCSOREC()
  {
    return m_YI5LInfra.getCSOREC_ORIGINE_DES_RESSOURCES();
  }
  
  public String getCodeErreurCSOREC()
  {
    return m_YI5LInfra.getCSOREC_ORIGINE_DES_RESSOURCES_C_ERR();
  }
  
  public void setCSOREC(String pValeur)
  {
    m_YI5LInfra.setCSOREC_ORIGINE_DES_RESSOURCES(pValeur);
  }
  
  public void setCodeErreurCSOREC(String pCodeErreur)
  {
    m_YI5LInfra.setCSOREC_ORIGINE_DES_RESSOURCES_C_ERR(pCodeErreur);
  }
  
  public String getCSOREC_ORIGINE_DES_RESSOURCES()
  {
    return m_YI5LInfra.getCSOREC_ORIGINE_DES_RESSOURCES();
  }
  
  public String getCodeErreurCSOREC_ORIGINE_DES_RESSOURCES()
  {
    return m_YI5LInfra.getCSOREC_ORIGINE_DES_RESSOURCES_C_ERR();
  }
  
  public void setCSOREC_ORIGINE_DES_RESSOURCES(String pValeur)
  {
    m_YI5LInfra.setCSOREC_ORIGINE_DES_RESSOURCES(pValeur);
  }
  
  public void setCodeErreurCSOREC_ORIGINE_DES_RESSOURCES(String pCodeErreur)
  {
    m_YI5LInfra.setCSOREC_ORIGINE_DES_RESSOURCES_C_ERR(pCodeErreur);
  }
  
  public Damj getDERES1()
  {
    return m_YI5LInfra.getDERES1_DATE_D_EFFET_DE_LA_RESSOURCE_DB2();
  }
  
  public String getCodeErreurDERES1()
  {
    return m_YI5LInfra.getDERES1_DATE_D_EFFET_DE_LA_RESSOURCE_DB2_C_ERR();
  }
  
  public void setDERES1(Damj pValeur)
  {
    m_YI5LInfra.setDERES1_DATE_D_EFFET_DE_LA_RESSOURCE_DB2(pValeur);
  }
  
  public void setCodeErreurDERES1(String pCodeErreur)
  {
    m_YI5LInfra.setDERES1_DATE_D_EFFET_DE_LA_RESSOURCE_DB2_C_ERR(pCodeErreur);
  }
  
  public Damj getDERES1_DATE_D_EFFET_DE_LA_RESSOURCE_DB2()
  {
    return m_YI5LInfra.getDERES1_DATE_D_EFFET_DE_LA_RESSOURCE_DB2();
  }
  
  public String getCodeErreurDERES1_DATE_D_EFFET_DE_LA_RESSOURCE_DB2()
  {
    return m_YI5LInfra.getDERES1_DATE_D_EFFET_DE_LA_RESSOURCE_DB2_C_ERR();
  }
  
  public void setDERES1_DATE_D_EFFET_DE_LA_RESSOURCE_DB2(Damj pValeur)
  {
    m_YI5LInfra.setDERES1_DATE_D_EFFET_DE_LA_RESSOURCE_DB2(pValeur);
  }
  
  public void setCodeErreurDERES1_DATE_D_EFFET_DE_LA_RESSOURCE_DB2(String pCodeErreur)
  {
    m_YI5LInfra.setDERES1_DATE_D_EFFET_DE_LA_RESSOURCE_DB2_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getQMRSF()
  {
    return m_YI5LInfra.getQMRSF_RESSOURCES_ALLOCATAIRE_AER_ANNUELLES();
  }
  
  public String getCodeErreurQMRSF()
  {
    return m_YI5LInfra.getQMRSF_RESSOURCES_ALLOCATAIRE_AER_ANNUELLES_C_ERR();
  }
  
  public void setQMRSF(BigDecimal pValeur)
  {
    m_YI5LInfra.setQMRSF_RESSOURCES_ALLOCATAIRE_AER_ANNUELLES(pValeur);
  }
  
  public void setCodeErreurQMRSF(String pCodeErreur)
  {
    m_YI5LInfra.setQMRSF_RESSOURCES_ALLOCATAIRE_AER_ANNUELLES_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getQMRSF_RESSOURCES_ALLOCATAIRE_AER_ANNUELLES()
  {
    return m_YI5LInfra.getQMRSF_RESSOURCES_ALLOCATAIRE_AER_ANNUELLES();
  }
  
  public String getCodeErreurQMRSF_RESSOURCES_ALLOCATAIRE_AER_ANNUELLES()
  {
    return m_YI5LInfra.getQMRSF_RESSOURCES_ALLOCATAIRE_AER_ANNUELLES_C_ERR();
  }
  
  public void setQMRSF_RESSOURCES_ALLOCATAIRE_AER_ANNUELLES(BigDecimal pValeur)
  {
    m_YI5LInfra.setQMRSF_RESSOURCES_ALLOCATAIRE_AER_ANNUELLES(pValeur);
  }
  
  public void setCodeErreurQMRSF_RESSOURCES_ALLOCATAIRE_AER_ANNUELLES(String pCodeErreur)
  {
    m_YI5LInfra.setQMRSF_RESSOURCES_ALLOCATAIRE_AER_ANNUELLES_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getQMRSG()
  {
    return m_YI5LInfra.getQMRSG_RESSOURCES_CONJOINT_AER_ANNUELLES();
  }
  
  public String getCodeErreurQMRSG()
  {
    return m_YI5LInfra.getQMRSG_RESSOURCES_CONJOINT_AER_ANNUELLES_C_ERR();
  }
  
  public void setQMRSG(BigDecimal pValeur)
  {
    m_YI5LInfra.setQMRSG_RESSOURCES_CONJOINT_AER_ANNUELLES(pValeur);
  }
  
  public void setCodeErreurQMRSG(String pCodeErreur)
  {
    m_YI5LInfra.setQMRSG_RESSOURCES_CONJOINT_AER_ANNUELLES_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getQMRSG_RESSOURCES_CONJOINT_AER_ANNUELLES()
  {
    return m_YI5LInfra.getQMRSG_RESSOURCES_CONJOINT_AER_ANNUELLES();
  }
  
  public String getCodeErreurQMRSG_RESSOURCES_CONJOINT_AER_ANNUELLES()
  {
    return m_YI5LInfra.getQMRSG_RESSOURCES_CONJOINT_AER_ANNUELLES_C_ERR();
  }
  
  public void setQMRSG_RESSOURCES_CONJOINT_AER_ANNUELLES(BigDecimal pValeur)
  {
    m_YI5LInfra.setQMRSG_RESSOURCES_CONJOINT_AER_ANNUELLES(pValeur);
  }
  
  public void setCodeErreurQMRSG_RESSOURCES_CONJOINT_AER_ANNUELLES(String pCodeErreur)
  {
    m_YI5LInfra.setQMRSG_RESSOURCES_CONJOINT_AER_ANNUELLES_C_ERR(pCodeErreur);
  }
  
  public String getREFEX1()
  {
    return m_YI5LInfra.getREFEX1_REFERENCE_EXTERNE_DE_LA_DEMANDE();
  }
  
  public String getCodeErreurREFEX1()
  {
    return m_YI5LInfra.getREFEX1_REFERENCE_EXTERNE_DE_LA_DEMANDE_C_ERR();
  }
  
  public void setREFEX1(String pValeur)
  {
    m_YI5LInfra.setREFEX1_REFERENCE_EXTERNE_DE_LA_DEMANDE(pValeur);
  }
  
  public void setCodeErreurREFEX1(String pCodeErreur)
  {
    m_YI5LInfra.setREFEX1_REFERENCE_EXTERNE_DE_LA_DEMANDE_C_ERR(pCodeErreur);
  }
  
  public String getREFEX1_REFERENCE_EXTERNE_DE_LA_DEMANDE()
  {
    return m_YI5LInfra.getREFEX1_REFERENCE_EXTERNE_DE_LA_DEMANDE();
  }
  
  public String getCodeErreurREFEX1_REFERENCE_EXTERNE_DE_LA_DEMANDE()
  {
    return m_YI5LInfra.getREFEX1_REFERENCE_EXTERNE_DE_LA_DEMANDE_C_ERR();
  }
  
  public void setREFEX1_REFERENCE_EXTERNE_DE_LA_DEMANDE(String pValeur)
  {
    m_YI5LInfra.setREFEX1_REFERENCE_EXTERNE_DE_LA_DEMANDE(pValeur);
  }
  
  public void setCodeErreurREFEX1_REFERENCE_EXTERNE_DE_LA_DEMANDE(String pCodeErreur)
  {
    m_YI5LInfra.setREFEX1_REFERENCE_EXTERNE_DE_LA_DEMANDE_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getQSDSF2()
  {
    return m_YI5LInfra.getQSDSF2_NB_D_ENFANTS_A_L_EXAMEN_RESSOURCES();
  }
  
  public String getCodeErreurQSDSF2()
  {
    return m_YI5LInfra.getQSDSF2_NB_D_ENFANTS_A_L_EXAMEN_RESSOURCES_C_ERR();
  }
  
  public void setQSDSF2(BigDecimal pValeur)
  {
    m_YI5LInfra.setQSDSF2_NB_D_ENFANTS_A_L_EXAMEN_RESSOURCES(pValeur);
  }
  
  public void setCodeErreurQSDSF2(String pCodeErreur)
  {
    m_YI5LInfra.setQSDSF2_NB_D_ENFANTS_A_L_EXAMEN_RESSOURCES_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getQSDSF2_NB_D_ENFANTS_A_L_EXAMEN_RESSOURCES()
  {
    return m_YI5LInfra.getQSDSF2_NB_D_ENFANTS_A_L_EXAMEN_RESSOURCES();
  }
  
  public String getCodeErreurQSDSF2_NB_D_ENFANTS_A_L_EXAMEN_RESSOURCES()
  {
    return m_YI5LInfra.getQSDSF2_NB_D_ENFANTS_A_L_EXAMEN_RESSOURCES_C_ERR();
  }
  
  public void setQSDSF2_NB_D_ENFANTS_A_L_EXAMEN_RESSOURCES(BigDecimal pValeur)
  {
    m_YI5LInfra.setQSDSF2_NB_D_ENFANTS_A_L_EXAMEN_RESSOURCES(pValeur);
  }
  
  public void setCodeErreurQSDSF2_NB_D_ENFANTS_A_L_EXAMEN_RESSOURCES(String pCodeErreur)
  {
    m_YI5LInfra.setQSDSF2_NB_D_ENFANTS_A_L_EXAMEN_RESSOURCES_C_ERR(pCodeErreur);
  }
  
  public _YI5L getYI5LInfra()
  {
    return m_YI5LInfra;
  }
  
  public String toString()
  {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
  }
  
  public boolean isEnErreur()
  {
    if ((getCodeErreurRSRS2() != null) && 
      ("".equals(getCodeErreurRSRS2()))) {
      return true;
    }
    if ((getCodeErreurNSARSA() != null) && 
      ("".equals(getCodeErreurNSARSA()))) {
      return true;
    }
    if ((getCodeErreurNSRRSA() != null) && 
      ("".equals(getCodeErreurNSRRSA()))) {
      return true;
    }
    if ((getCodeErreurCSMSF4() != null) && 
      ("".equals(getCodeErreurCSMSF4()))) {
      return true;
    }
    if ((getCodeErreurQMRS4() != null) && 
      ("".equals(getCodeErreurQMRS4()))) {
      return true;
    }
    if ((getCodeErreurCSCTF() != null) && 
      ("".equals(getCodeErreurCSCTF()))) {
      return true;
    }
    if ((getCodeErreurNSOPRL() != null) && 
      ("".equals(getCodeErreurNSOPRL()))) {
      return true;
    }
    if ((getCodeErreurCSOREC() != null) && 
      ("".equals(getCodeErreurCSOREC()))) {
      return true;
    }
    if ((getCodeErreurDERES1() != null) && 
      ("".equals(getCodeErreurDERES1()))) {
      return true;
    }
    if ((getCodeErreurQMRSF() != null) && 
      ("".equals(getCodeErreurQMRSF()))) {
      return true;
    }
    if ((getCodeErreurQMRSG() != null) && 
      ("".equals(getCodeErreurQMRSG()))) {
      return true;
    }
    if ((getCodeErreurREFEX1() != null) && 
      ("".equals(getCodeErreurREFEX1()))) {
      return true;
    }
    if ((getCodeErreurQSDSF2() != null) && 
      ("".equals(getCodeErreurQSDSF2()))) {
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     _YI5LImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */