package fr.unedic.logique.donnees.dr1.service.vls;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.archi.logique.adaptateur.ObjetSerialisableFournisseur;
import java.io.Serializable;
import java.math.BigDecimal;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class _YI5XImpl
  extends YI5X
  implements ObjetSerialisableFournisseur, Serializable
{
  private static final long serialVersionUID = 1L;
  private final _YI5X m_YI5XInfra;
  
  public _YI5XImpl()
  {
    m_YI5XInfra = new _YI5X();
  }
  
  public _YI5XImpl(_YI5X pValeur)
  {
    ExceptionUtil.assertMethodParamNotNull("YI5XInfra", pValeur);
    
    m_YI5XInfra = pValeur;
  }
  
  public Object getObjet()
  {
    return m_YI5XInfra;
  }
  
  public String getIdentifiant()
  {
    return m_YI5XInfra.get_IDENT();
  }
  
  public void setIdentifiant(String pIdentifiant)
  {
    m_YI5XInfra.set_IDENT(pIdentifiant);
  }
  
  public String getCodeEtat()
  {
    return m_YI5XInfra.get_C_ETAT();
  }
  
  public void setCodeEtat(String pCode)
  {
    m_YI5XInfra.set_C_ETAT(pCode);
  }
  
  public BigDecimal getDSAAS4()
  {
    return m_YI5XInfra.getDSAAS4_SIECLE_ANNEE_D_IMPUTATION_MANDATEMEN();
  }
  
  public String getCodeErreurDSAAS4()
  {
    return m_YI5XInfra.getDSAAS4_SIECLE_ANNEE_D_IMPUTATION_MANDATEMEN_C_ERR();
  }
  
  public void setDSAAS4(BigDecimal pValeur)
  {
    m_YI5XInfra.setDSAAS4_SIECLE_ANNEE_D_IMPUTATION_MANDATEMEN(pValeur);
  }
  
  public void setCodeErreurDSAAS4(String pCodeErreur)
  {
    m_YI5XInfra.setDSAAS4_SIECLE_ANNEE_D_IMPUTATION_MANDATEMEN_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getDSAAS4_SIECLE_ANNEE_D_IMPUTATION_MANDATEMEN()
  {
    return m_YI5XInfra.getDSAAS4_SIECLE_ANNEE_D_IMPUTATION_MANDATEMEN();
  }
  
  public String getCodeErreurDSAAS4_SIECLE_ANNEE_D_IMPUTATION_MANDATEMEN()
  {
    return m_YI5XInfra.getDSAAS4_SIECLE_ANNEE_D_IMPUTATION_MANDATEMEN_C_ERR();
  }
  
  public void setDSAAS4_SIECLE_ANNEE_D_IMPUTATION_MANDATEMEN(BigDecimal pValeur)
  {
    m_YI5XInfra.setDSAAS4_SIECLE_ANNEE_D_IMPUTATION_MANDATEMEN(pValeur);
  }
  
  public void setCodeErreurDSAAS4_SIECLE_ANNEE_D_IMPUTATION_MANDATEMEN(String pCodeErreur)
  {
    m_YI5XInfra.setDSAAS4_SIECLE_ANNEE_D_IMPUTATION_MANDATEMEN_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getDSMA4()
  {
    return m_YI5XInfra.getDSMA4_MOIS_D_IMPUTATION_MANDATEMENT();
  }
  
  public String getCodeErreurDSMA4()
  {
    return m_YI5XInfra.getDSMA4_MOIS_D_IMPUTATION_MANDATEMENT_C_ERR();
  }
  
  public void setDSMA4(BigDecimal pValeur)
  {
    m_YI5XInfra.setDSMA4_MOIS_D_IMPUTATION_MANDATEMENT(pValeur);
  }
  
  public void setCodeErreurDSMA4(String pCodeErreur)
  {
    m_YI5XInfra.setDSMA4_MOIS_D_IMPUTATION_MANDATEMENT_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getDSMA4_MOIS_D_IMPUTATION_MANDATEMENT()
  {
    return m_YI5XInfra.getDSMA4_MOIS_D_IMPUTATION_MANDATEMENT();
  }
  
  public String getCodeErreurDSMA4_MOIS_D_IMPUTATION_MANDATEMENT()
  {
    return m_YI5XInfra.getDSMA4_MOIS_D_IMPUTATION_MANDATEMENT_C_ERR();
  }
  
  public void setDSMA4_MOIS_D_IMPUTATION_MANDATEMENT(BigDecimal pValeur)
  {
    m_YI5XInfra.setDSMA4_MOIS_D_IMPUTATION_MANDATEMENT(pValeur);
  }
  
  public void setCodeErreurDSMA4_MOIS_D_IMPUTATION_MANDATEMENT(String pCodeErreur)
  {
    m_YI5XInfra.setDSMA4_MOIS_D_IMPUTATION_MANDATEMENT_C_ERR(pCodeErreur);
  }
  
  public String getFSMPP()
  {
    return m_YI5XInfra.getFSMPP_IND__PAIEMENT_PROVISOIRE_SUR_LE_MOIS();
  }
  
  public String getCodeErreurFSMPP()
  {
    return m_YI5XInfra.getFSMPP_IND__PAIEMENT_PROVISOIRE_SUR_LE_MOIS_C_ERR();
  }
  
  public void setFSMPP(String pValeur)
  {
    m_YI5XInfra.setFSMPP_IND__PAIEMENT_PROVISOIRE_SUR_LE_MOIS(pValeur);
  }
  
  public void setCodeErreurFSMPP(String pCodeErreur)
  {
    m_YI5XInfra.setFSMPP_IND__PAIEMENT_PROVISOIRE_SUR_LE_MOIS_C_ERR(pCodeErreur);
  }
  
  public String getFSMPP_IND__PAIEMENT_PROVISOIRE_SUR_LE_MOIS()
  {
    return m_YI5XInfra.getFSMPP_IND__PAIEMENT_PROVISOIRE_SUR_LE_MOIS();
  }
  
  public String getCodeErreurFSMPP_IND__PAIEMENT_PROVISOIRE_SUR_LE_MOIS()
  {
    return m_YI5XInfra.getFSMPP_IND__PAIEMENT_PROVISOIRE_SUR_LE_MOIS_C_ERR();
  }
  
  public void setFSMPP_IND__PAIEMENT_PROVISOIRE_SUR_LE_MOIS(String pValeur)
  {
    m_YI5XInfra.setFSMPP_IND__PAIEMENT_PROVISOIRE_SUR_LE_MOIS(pValeur);
  }
  
  public void setCodeErreurFSMPP_IND__PAIEMENT_PROVISOIRE_SUR_LE_MOIS(String pCodeErreur)
  {
    m_YI5XInfra.setFSMPP_IND__PAIEMENT_PROVISOIRE_SUR_LE_MOIS_C_ERR(pCodeErreur);
  }
  
  public String getFFCOH()
  {
    return m_YI5XInfra.getFFCOH_TOP_COHERENCE_TRAVAIL_A8_A10();
  }
  
  public String getCodeErreurFFCOH()
  {
    return m_YI5XInfra.getFFCOH_TOP_COHERENCE_TRAVAIL_A8_A10_C_ERR();
  }
  
  public void setFFCOH(String pValeur)
  {
    m_YI5XInfra.setFFCOH_TOP_COHERENCE_TRAVAIL_A8_A10(pValeur);
  }
  
  public void setCodeErreurFFCOH(String pCodeErreur)
  {
    m_YI5XInfra.setFFCOH_TOP_COHERENCE_TRAVAIL_A8_A10_C_ERR(pCodeErreur);
  }
  
  public String getFFCOH_TOP_COHERENCE_TRAVAIL_A8_A10()
  {
    return m_YI5XInfra.getFFCOH_TOP_COHERENCE_TRAVAIL_A8_A10();
  }
  
  public String getCodeErreurFFCOH_TOP_COHERENCE_TRAVAIL_A8_A10()
  {
    return m_YI5XInfra.getFFCOH_TOP_COHERENCE_TRAVAIL_A8_A10_C_ERR();
  }
  
  public void setFFCOH_TOP_COHERENCE_TRAVAIL_A8_A10(String pValeur)
  {
    m_YI5XInfra.setFFCOH_TOP_COHERENCE_TRAVAIL_A8_A10(pValeur);
  }
  
  public void setCodeErreurFFCOH_TOP_COHERENCE_TRAVAIL_A8_A10(String pCodeErreur)
  {
    m_YI5XInfra.setFFCOH_TOP_COHERENCE_TRAVAIL_A8_A10_C_ERR(pCodeErreur);
  }
  
  public _YI5X getYI5XInfra()
  {
    return m_YI5XInfra;
  }
  
  public String toString()
  {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
  }
  
  public boolean isEnErreur()
  {
    if ((getCodeErreurDSAAS4() != null) && 
      ("".equals(getCodeErreurDSAAS4()))) {
      return true;
    }
    if ((getCodeErreurDSMA4() != null) && 
      ("".equals(getCodeErreurDSMA4()))) {
      return true;
    }
    if ((getCodeErreurFSMPP() != null) && 
      ("".equals(getCodeErreurFSMPP()))) {
      return true;
    }
    if ((getCodeErreurFFCOH() != null) && 
      ("".equals(getCodeErreurFFCOH()))) {
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     _YI5XImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */