package fr.unedic.logique.donnees.rac.commun.dra.zu;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.archi.logique.adaptateur.ObjetSerialisableFournisseur;
import java.io.Serializable;
import java.math.BigDecimal;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class _MI2JImpl
  extends MI2J
  implements ObjetSerialisableFournisseur, Serializable
{
  private static final long serialVersionUID = 1L;
  private final _MI2J m_MI2JInfra;
  
  public _MI2JImpl()
  {
    m_MI2JInfra = new _MI2J();
  }
  
  public _MI2JImpl(_MI2J pValeur)
  {
    ExceptionUtil.assertMethodParamNotNull("MI2JInfra", pValeur);
    
    m_MI2JInfra = pValeur;
  }
  
  public Object getObjet()
  {
    return m_MI2JInfra;
  }
  
  public String getIdentifiant()
  {
    return m_MI2JInfra.get_IDENT();
  }
  
  public void setIdentifiant(String pIdentifiant)
  {
    m_MI2JInfra.set_IDENT(pIdentifiant);
  }
  
  public String getCodeEtat()
  {
    return m_MI2JInfra.get_C_ETAT();
  }
  
  public void setCodeEtat(String pCode)
  {
    m_MI2JInfra.set_C_ETAT(pCode);
  }
  
  public BigDecimal getCXALA_IDENTIFIANT_NATIONAL_ALADIN()
  {
    return m_MI2JInfra.getCXALA_IDENTIFIANT_NATIONAL_ALADIN();
  }
  
  public String getCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN()
  {
    return m_MI2JInfra.getCXALA_IDENTIFIANT_NATIONAL_ALADIN_C_ERR();
  }
  
  public void setCXALA_IDENTIFIANT_NATIONAL_ALADIN(BigDecimal pValeur)
  {
    m_MI2JInfra.setCXALA_IDENTIFIANT_NATIONAL_ALADIN(pValeur);
  }
  
  public void setCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN(String pCodeErreur)
  {
    m_MI2JInfra.setCXALA_IDENTIFIANT_NATIONAL_ALADIN_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public BigDecimal getCXALA()
  {
    return getCXALA_IDENTIFIANT_NATIONAL_ALADIN();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCXALA()
  {
    return getCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN();
  }
  
  /**
   * @deprecated
   */
  public void setCXALA(BigDecimal pValeur)
  {
    setCXALA_IDENTIFIANT_NATIONAL_ALADIN(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCXALA(String pCodeErreur)
  {
    setCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN(pCodeErreur);
  }
  
  public String getCXIN_IDENTIFIANT_DE_L_INDIVIDU()
  {
    return m_MI2JInfra.getCXIN_IDENTIFIANT_DE_L_INDIVIDU();
  }
  
  public String getCodeErreurCXIN_IDENTIFIANT_DE_L_INDIVIDU()
  {
    return m_MI2JInfra.getCXIN_IDENTIFIANT_DE_L_INDIVIDU_C_ERR();
  }
  
  public void setCXIN_IDENTIFIANT_DE_L_INDIVIDU(String pValeur)
  {
    m_MI2JInfra.setCXIN_IDENTIFIANT_DE_L_INDIVIDU(pValeur);
  }
  
  public void setCodeErreurCXIN_IDENTIFIANT_DE_L_INDIVIDU(String pCodeErreur)
  {
    m_MI2JInfra.setCXIN_IDENTIFIANT_DE_L_INDIVIDU_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getCXIN()
  {
    return getCXIN_IDENTIFIANT_DE_L_INDIVIDU();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCXIN()
  {
    return getCodeErreurCXIN_IDENTIFIANT_DE_L_INDIVIDU();
  }
  
  /**
   * @deprecated
   */
  public void setCXIN(String pValeur)
  {
    setCXIN_IDENTIFIANT_DE_L_INDIVIDU(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCXIN(String pCodeErreur)
  {
    setCodeErreurCXIN_IDENTIFIANT_DE_L_INDIVIDU(pCodeErreur);
  }
  
  public String getFIHST_INDICATEUR_PRESENCE_HISTORIQUE()
  {
    return m_MI2JInfra.getFIHST_INDICATEUR_PRESENCE_HISTORIQUE();
  }
  
  public String getCodeErreurFIHST_INDICATEUR_PRESENCE_HISTORIQUE()
  {
    return m_MI2JInfra.getFIHST_INDICATEUR_PRESENCE_HISTORIQUE_C_ERR();
  }
  
  public void setFIHST_INDICATEUR_PRESENCE_HISTORIQUE(String pValeur)
  {
    m_MI2JInfra.setFIHST_INDICATEUR_PRESENCE_HISTORIQUE(pValeur);
  }
  
  public void setCodeErreurFIHST_INDICATEUR_PRESENCE_HISTORIQUE(String pCodeErreur)
  {
    m_MI2JInfra.setFIHST_INDICATEUR_PRESENCE_HISTORIQUE_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getFIHST()
  {
    return getFIHST_INDICATEUR_PRESENCE_HISTORIQUE();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurFIHST()
  {
    return getCodeErreurFIHST_INDICATEUR_PRESENCE_HISTORIQUE();
  }
  
  /**
   * @deprecated
   */
  public void setFIHST(String pValeur)
  {
    setFIHST_INDICATEUR_PRESENCE_HISTORIQUE(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurFIHST(String pCodeErreur)
  {
    setCodeErreurFIHST_INDICATEUR_PRESENCE_HISTORIQUE(pCodeErreur);
  }
  
  public String getLNIND1_NOM_PATRONYMIQUE()
  {
    return m_MI2JInfra.getLNIND1_NOM_PATRONYMIQUE();
  }
  
  public String getCodeErreurLNIND1_NOM_PATRONYMIQUE()
  {
    return m_MI2JInfra.getLNIND1_NOM_PATRONYMIQUE_C_ERR();
  }
  
  public void setLNIND1_NOM_PATRONYMIQUE(String pValeur)
  {
    m_MI2JInfra.setLNIND1_NOM_PATRONYMIQUE(pValeur);
  }
  
  public void setCodeErreurLNIND1_NOM_PATRONYMIQUE(String pCodeErreur)
  {
    m_MI2JInfra.setLNIND1_NOM_PATRONYMIQUE_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getLNIND1()
  {
    return getLNIND1_NOM_PATRONYMIQUE();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurLNIND1()
  {
    return getCodeErreurLNIND1_NOM_PATRONYMIQUE();
  }
  
  /**
   * @deprecated
   */
  public void setLNIND1(String pValeur)
  {
    setLNIND1_NOM_PATRONYMIQUE(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurLNIND1(String pCodeErreur)
  {
    setCodeErreurLNIND1_NOM_PATRONYMIQUE(pCodeErreur);
  }
  
  public String getLNIND2_NOM_MARITAL()
  {
    return m_MI2JInfra.getLNIND2_NOM_MARITAL();
  }
  
  public String getCodeErreurLNIND2_NOM_MARITAL()
  {
    return m_MI2JInfra.getLNIND2_NOM_MARITAL_C_ERR();
  }
  
  public void setLNIND2_NOM_MARITAL(String pValeur)
  {
    m_MI2JInfra.setLNIND2_NOM_MARITAL(pValeur);
  }
  
  public void setCodeErreurLNIND2_NOM_MARITAL(String pCodeErreur)
  {
    m_MI2JInfra.setLNIND2_NOM_MARITAL_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getLNIND2()
  {
    return getLNIND2_NOM_MARITAL();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurLNIND2()
  {
    return getCodeErreurLNIND2_NOM_MARITAL();
  }
  
  /**
   * @deprecated
   */
  public void setLNIND2(String pValeur)
  {
    setLNIND2_NOM_MARITAL(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurLNIND2(String pCodeErreur)
  {
    setCodeErreurLNIND2_NOM_MARITAL(pCodeErreur);
  }
  
  public String getLNIND3_NOM_PSEUDONYMIQUE()
  {
    return m_MI2JInfra.getLNIND3_NOM_PSEUDONYMIQUE();
  }
  
  public String getCodeErreurLNIND3_NOM_PSEUDONYMIQUE()
  {
    return m_MI2JInfra.getLNIND3_NOM_PSEUDONYMIQUE_C_ERR();
  }
  
  public void setLNIND3_NOM_PSEUDONYMIQUE(String pValeur)
  {
    m_MI2JInfra.setLNIND3_NOM_PSEUDONYMIQUE(pValeur);
  }
  
  public void setCodeErreurLNIND3_NOM_PSEUDONYMIQUE(String pCodeErreur)
  {
    m_MI2JInfra.setLNIND3_NOM_PSEUDONYMIQUE_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getLNIND3()
  {
    return getLNIND3_NOM_PSEUDONYMIQUE();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurLNIND3()
  {
    return getCodeErreurLNIND3_NOM_PSEUDONYMIQUE();
  }
  
  /**
   * @deprecated
   */
  public void setLNIND3(String pValeur)
  {
    setLNIND3_NOM_PSEUDONYMIQUE(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurLNIND3(String pCodeErreur)
  {
    setCodeErreurLNIND3_NOM_PSEUDONYMIQUE(pCodeErreur);
  }
  
  public String getLNPIN_PRENOM()
  {
    return m_MI2JInfra.getLNPIN_PRENOM();
  }
  
  public String getCodeErreurLNPIN_PRENOM()
  {
    return m_MI2JInfra.getLNPIN_PRENOM_C_ERR();
  }
  
  public void setLNPIN_PRENOM(String pValeur)
  {
    m_MI2JInfra.setLNPIN_PRENOM(pValeur);
  }
  
  public void setCodeErreurLNPIN_PRENOM(String pCodeErreur)
  {
    m_MI2JInfra.setLNPIN_PRENOM_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getLNPIN()
  {
    return getLNPIN_PRENOM();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurLNPIN()
  {
    return getCodeErreurLNPIN_PRENOM();
  }
  
  /**
   * @deprecated
   */
  public void setLNPIN(String pValeur)
  {
    setLNPIN_PRENOM(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurLNPIN(String pCodeErreur)
  {
    setCodeErreurLNPIN_PRENOM(pCodeErreur);
  }
  
  public String getISNIR_NUMERO_IDENTIFICATION_REPERTOIRE_NIR()
  {
    return m_MI2JInfra.getISNIR_NUMERO_IDENTIFICATION_REPERTOIRE_NIR();
  }
  
  public String getCodeErreurISNIR_NUMERO_IDENTIFICATION_REPERTOIRE_NIR()
  {
    return m_MI2JInfra.getISNIR_NUMERO_IDENTIFICATION_REPERTOIRE_NIR_C_ERR();
  }
  
  public void setISNIR_NUMERO_IDENTIFICATION_REPERTOIRE_NIR(String pValeur)
  {
    m_MI2JInfra.setISNIR_NUMERO_IDENTIFICATION_REPERTOIRE_NIR(pValeur);
  }
  
  public void setCodeErreurISNIR_NUMERO_IDENTIFICATION_REPERTOIRE_NIR(String pCodeErreur)
  {
    m_MI2JInfra.setISNIR_NUMERO_IDENTIFICATION_REPERTOIRE_NIR_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getISNIR()
  {
    return getISNIR_NUMERO_IDENTIFICATION_REPERTOIRE_NIR();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurISNIR()
  {
    return getCodeErreurISNIR_NUMERO_IDENTIFICATION_REPERTOIRE_NIR();
  }
  
  /**
   * @deprecated
   */
  public void setISNIR(String pValeur)
  {
    setISNIR_NUMERO_IDENTIFICATION_REPERTOIRE_NIR(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurISNIR(String pCodeErreur)
  {
    setCodeErreurISNIR_NUMERO_IDENTIFICATION_REPERTOIRE_NIR(pCodeErreur);
  }
  
  public String getCXASS_CODE_ASSEDIC()
  {
    return m_MI2JInfra.getCXASS_CODE_ASSEDIC();
  }
  
  public String getCodeErreurCXASS_CODE_ASSEDIC()
  {
    return m_MI2JInfra.getCXASS_CODE_ASSEDIC_C_ERR();
  }
  
  public void setCXASS_CODE_ASSEDIC(String pValeur)
  {
    m_MI2JInfra.setCXASS_CODE_ASSEDIC(pValeur);
  }
  
  public void setCodeErreurCXASS_CODE_ASSEDIC(String pCodeErreur)
  {
    m_MI2JInfra.setCXASS_CODE_ASSEDIC_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getCXASS()
  {
    return getCXASS_CODE_ASSEDIC();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCXASS()
  {
    return getCodeErreurCXASS_CODE_ASSEDIC();
  }
  
  /**
   * @deprecated
   */
  public void setCXASS(String pValeur)
  {
    setCXASS_CODE_ASSEDIC(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCXASS(String pCodeErreur)
  {
    setCodeErreurCXASS_CODE_ASSEDIC(pCodeErreur);
  }
  
  public String getCKENC_MOTIF_DE_PRESENCE_DANS_LE_SI()
  {
    return m_MI2JInfra.getCKENC_MOTIF_DE_PRESENCE_DANS_LE_SI();
  }
  
  public String getCodeErreurCKENC_MOTIF_DE_PRESENCE_DANS_LE_SI()
  {
    return m_MI2JInfra.getCKENC_MOTIF_DE_PRESENCE_DANS_LE_SI_C_ERR();
  }
  
  public void setCKENC_MOTIF_DE_PRESENCE_DANS_LE_SI(String pValeur)
  {
    m_MI2JInfra.setCKENC_MOTIF_DE_PRESENCE_DANS_LE_SI(pValeur);
  }
  
  public void setCodeErreurCKENC_MOTIF_DE_PRESENCE_DANS_LE_SI(String pCodeErreur)
  {
    m_MI2JInfra.setCKENC_MOTIF_DE_PRESENCE_DANS_LE_SI_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getCKENC()
  {
    return getCKENC_MOTIF_DE_PRESENCE_DANS_LE_SI();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCKENC()
  {
    return getCodeErreurCKENC_MOTIF_DE_PRESENCE_DANS_LE_SI();
  }
  
  /**
   * @deprecated
   */
  public void setCKENC(String pValeur)
  {
    setCKENC_MOTIF_DE_PRESENCE_DANS_LE_SI(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCKENC(String pCodeErreur)
  {
    setCodeErreurCKENC_MOTIF_DE_PRESENCE_DANS_LE_SI(pCodeErreur);
  }
  
  public String getCDSEX_CODE_SEXE_INDIVIDU()
  {
    return m_MI2JInfra.getCDSEX_CODE_SEXE_INDIVIDU();
  }
  
  public String getCodeErreurCDSEX_CODE_SEXE_INDIVIDU()
  {
    return m_MI2JInfra.getCDSEX_CODE_SEXE_INDIVIDU_C_ERR();
  }
  
  public void setCDSEX_CODE_SEXE_INDIVIDU(String pValeur)
  {
    m_MI2JInfra.setCDSEX_CODE_SEXE_INDIVIDU(pValeur);
  }
  
  public void setCodeErreurCDSEX_CODE_SEXE_INDIVIDU(String pCodeErreur)
  {
    m_MI2JInfra.setCDSEX_CODE_SEXE_INDIVIDU_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getCDSEX()
  {
    return getCDSEX_CODE_SEXE_INDIVIDU();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCDSEX()
  {
    return getCodeErreurCDSEX_CODE_SEXE_INDIVIDU();
  }
  
  /**
   * @deprecated
   */
  public void setCDSEX(String pValeur)
  {
    setCDSEX_CODE_SEXE_INDIVIDU(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCDSEX(String pCodeErreur)
  {
    setCodeErreurCDSEX_CODE_SEXE_INDIVIDU(pCodeErreur);
  }
  
  public String getDDNAIB_DATE_DE_NAISSANCE()
  {
    return m_MI2JInfra.getDDNAIB_DATE_DE_NAISSANCE();
  }
  
  public String getCodeErreurDDNAIB_DATE_DE_NAISSANCE()
  {
    return m_MI2JInfra.getDDNAIB_DATE_DE_NAISSANCE_C_ERR();
  }
  
  public void setDDNAIB_DATE_DE_NAISSANCE(String pValeur)
  {
    m_MI2JInfra.setDDNAIB_DATE_DE_NAISSANCE(pValeur);
  }
  
  public void setCodeErreurDDNAIB_DATE_DE_NAISSANCE(String pCodeErreur)
  {
    m_MI2JInfra.setDDNAIB_DATE_DE_NAISSANCE_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getDDNAIB()
  {
    return getDDNAIB_DATE_DE_NAISSANCE();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurDDNAIB()
  {
    return getCodeErreurDDNAIB_DATE_DE_NAISSANCE();
  }
  
  /**
   * @deprecated
   */
  public void setDDNAIB(String pValeur)
  {
    setDDNAIB_DATE_DE_NAISSANCE(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurDDNAIB(String pCodeErreur)
  {
    setCodeErreurDDNAIB_DATE_DE_NAISSANCE(pCodeErreur);
  }
  
  public String getAOPOS_CODE_POSTAL()
  {
    return m_MI2JInfra.getAOPOS_CODE_POSTAL();
  }
  
  public String getCodeErreurAOPOS_CODE_POSTAL()
  {
    return m_MI2JInfra.getAOPOS_CODE_POSTAL_C_ERR();
  }
  
  public void setAOPOS_CODE_POSTAL(String pValeur)
  {
    m_MI2JInfra.setAOPOS_CODE_POSTAL(pValeur);
  }
  
  public void setCodeErreurAOPOS_CODE_POSTAL(String pCodeErreur)
  {
    m_MI2JInfra.setAOPOS_CODE_POSTAL_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getAOPOS()
  {
    return getAOPOS_CODE_POSTAL();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurAOPOS()
  {
    return getCodeErreurAOPOS_CODE_POSTAL();
  }
  
  /**
   * @deprecated
   */
  public void setAOPOS(String pValeur)
  {
    setAOPOS_CODE_POSTAL(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurAOPOS(String pCodeErreur)
  {
    setCodeErreurAOPOS_CODE_POSTAL(pCodeErreur);
  }
  
  public String getADLCOC_LIBELLE_COMMUNE_FORMAT_CONTRIBULL()
  {
    return m_MI2JInfra.getADLCOC_LIBELLE_COMMUNE_FORMAT_CONTRIBULL();
  }
  
  public String getCodeErreurADLCOC_LIBELLE_COMMUNE_FORMAT_CONTRIBULL()
  {
    return m_MI2JInfra.getADLCOC_LIBELLE_COMMUNE_FORMAT_CONTRIBULL_C_ERR();
  }
  
  public void setADLCOC_LIBELLE_COMMUNE_FORMAT_CONTRIBULL(String pValeur)
  {
    m_MI2JInfra.setADLCOC_LIBELLE_COMMUNE_FORMAT_CONTRIBULL(pValeur);
  }
  
  public void setCodeErreurADLCOC_LIBELLE_COMMUNE_FORMAT_CONTRIBULL(String pCodeErreur)
  {
    m_MI2JInfra.setADLCOC_LIBELLE_COMMUNE_FORMAT_CONTRIBULL_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getADLCOC()
  {
    return getADLCOC_LIBELLE_COMMUNE_FORMAT_CONTRIBULL();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurADLCOC()
  {
    return getCodeErreurADLCOC_LIBELLE_COMMUNE_FORMAT_CONTRIBULL();
  }
  
  /**
   * @deprecated
   */
  public void setADLCOC(String pValeur)
  {
    setADLCOC_LIBELLE_COMMUNE_FORMAT_CONTRIBULL(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurADLCOC(String pCodeErreur)
  {
    setCodeErreurADLCOC_LIBELLE_COMMUNE_FORMAT_CONTRIBULL(pCodeErreur);
  }
  
  public String getCDETA1_TYPE_DE_POPULATION()
  {
    return m_MI2JInfra.getCDETA1_TYPE_DE_POPULATION();
  }
  
  public String getCodeErreurCDETA1_TYPE_DE_POPULATION()
  {
    return m_MI2JInfra.getCDETA1_TYPE_DE_POPULATION_C_ERR();
  }
  
  public void setCDETA1_TYPE_DE_POPULATION(String pValeur)
  {
    m_MI2JInfra.setCDETA1_TYPE_DE_POPULATION(pValeur);
  }
  
  public void setCodeErreurCDETA1_TYPE_DE_POPULATION(String pCodeErreur)
  {
    m_MI2JInfra.setCDETA1_TYPE_DE_POPULATION_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getCDETA1()
  {
    return getCDETA1_TYPE_DE_POPULATION();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCDETA1()
  {
    return getCodeErreurCDETA1_TYPE_DE_POPULATION();
  }
  
  /**
   * @deprecated
   */
  public void setCDETA1(String pValeur)
  {
    setCDETA1_TYPE_DE_POPULATION(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCDETA1(String pCodeErreur)
  {
    setCodeErreurCDETA1_TYPE_DE_POPULATION(pCodeErreur);
  }
  
  public String getCXALE_ALE_DE_L_INDIVIDU()
  {
    return m_MI2JInfra.getCXALE_ALE_DE_L_INDIVIDU();
  }
  
  public String getCodeErreurCXALE_ALE_DE_L_INDIVIDU()
  {
    return m_MI2JInfra.getCXALE_ALE_DE_L_INDIVIDU_C_ERR();
  }
  
  public void setCXALE_ALE_DE_L_INDIVIDU(String pValeur)
  {
    m_MI2JInfra.setCXALE_ALE_DE_L_INDIVIDU(pValeur);
  }
  
  public void setCodeErreurCXALE_ALE_DE_L_INDIVIDU(String pCodeErreur)
  {
    m_MI2JInfra.setCXALE_ALE_DE_L_INDIVIDU_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getCXALE()
  {
    return getCXALE_ALE_DE_L_INDIVIDU();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCXALE()
  {
    return getCodeErreurCXALE_ALE_DE_L_INDIVIDU();
  }
  
  /**
   * @deprecated
   */
  public void setCXALE(String pValeur)
  {
    setCXALE_ALE_DE_L_INDIVIDU(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCXALE(String pCodeErreur)
  {
    setCodeErreurCXALE_ALE_DE_L_INDIVIDU(pCodeErreur);
  }
  
  public String getCDANT_ANTENNE_DE_L_INDIVIDU()
  {
    return m_MI2JInfra.getCDANT_ANTENNE_DE_L_INDIVIDU();
  }
  
  public String getCodeErreurCDANT_ANTENNE_DE_L_INDIVIDU()
  {
    return m_MI2JInfra.getCDANT_ANTENNE_DE_L_INDIVIDU_C_ERR();
  }
  
  public void setCDANT_ANTENNE_DE_L_INDIVIDU(String pValeur)
  {
    m_MI2JInfra.setCDANT_ANTENNE_DE_L_INDIVIDU(pValeur);
  }
  
  public void setCodeErreurCDANT_ANTENNE_DE_L_INDIVIDU(String pCodeErreur)
  {
    m_MI2JInfra.setCDANT_ANTENNE_DE_L_INDIVIDU_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getCDANT()
  {
    return getCDANT_ANTENNE_DE_L_INDIVIDU();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCDANT()
  {
    return getCodeErreurCDANT_ANTENNE_DE_L_INDIVIDU();
  }
  
  /**
   * @deprecated
   */
  public void setCDANT(String pValeur)
  {
    setCDANT_ANTENNE_DE_L_INDIVIDU(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCDANT(String pCodeErreur)
  {
    setCodeErreurCDANT_ANTENNE_DE_L_INDIVIDU(pCodeErreur);
  }
  
  public BigDecimal getCDSTN_CODE_STATUT_NIR__ANCIENNE_CODIF_()
  {
    return m_MI2JInfra.getCDSTN_CODE_STATUT_NIR__ANCIENNE_CODIF_();
  }
  
  public String getCodeErreurCDSTN_CODE_STATUT_NIR__ANCIENNE_CODIF_()
  {
    return m_MI2JInfra.getCDSTN_CODE_STATUT_NIR__ANCIENNE_CODIF__C_ERR();
  }
  
  public void setCDSTN_CODE_STATUT_NIR__ANCIENNE_CODIF_(BigDecimal pValeur)
  {
    m_MI2JInfra.setCDSTN_CODE_STATUT_NIR__ANCIENNE_CODIF_(pValeur);
  }
  
  public void setCodeErreurCDSTN_CODE_STATUT_NIR__ANCIENNE_CODIF_(String pCodeErreur)
  {
    m_MI2JInfra.setCDSTN_CODE_STATUT_NIR__ANCIENNE_CODIF__C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public BigDecimal getCDSTN()
  {
    return getCDSTN_CODE_STATUT_NIR__ANCIENNE_CODIF_();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCDSTN()
  {
    return getCodeErreurCDSTN_CODE_STATUT_NIR__ANCIENNE_CODIF_();
  }
  
  /**
   * @deprecated
   */
  public void setCDSTN(BigDecimal pValeur)
  {
    setCDSTN_CODE_STATUT_NIR__ANCIENNE_CODIF_(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCDSTN(String pCodeErreur)
  {
    setCodeErreurCDSTN_CODE_STATUT_NIR__ANCIENNE_CODIF_(pCodeErreur);
  }
  
  public String getCDETT_TOP_RECHERCHE_SALARIE_E_T_T_()
  {
    return m_MI2JInfra.getCDETT_TOP_RECHERCHE_SALARIE_E_T_T_();
  }
  
  public String getCodeErreurCDETT_TOP_RECHERCHE_SALARIE_E_T_T_()
  {
    return m_MI2JInfra.getCDETT_TOP_RECHERCHE_SALARIE_E_T_T__C_ERR();
  }
  
  public void setCDETT_TOP_RECHERCHE_SALARIE_E_T_T_(String pValeur)
  {
    m_MI2JInfra.setCDETT_TOP_RECHERCHE_SALARIE_E_T_T_(pValeur);
  }
  
  public void setCodeErreurCDETT_TOP_RECHERCHE_SALARIE_E_T_T_(String pCodeErreur)
  {
    m_MI2JInfra.setCDETT_TOP_RECHERCHE_SALARIE_E_T_T__C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getCDETT()
  {
    return getCDETT_TOP_RECHERCHE_SALARIE_E_T_T_();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCDETT()
  {
    return getCodeErreurCDETT_TOP_RECHERCHE_SALARIE_E_T_T_();
  }
  
  /**
   * @deprecated
   */
  public void setCDETT(String pValeur)
  {
    setCDETT_TOP_RECHERCHE_SALARIE_E_T_T_(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCDETT(String pCodeErreur)
  {
    setCodeErreurCDETT_TOP_RECHERCHE_SALARIE_E_T_T_(pCodeErreur);
  }
  
  public String getCKCNI_CODE_QUALITE_CERTIFICATION_NIR_DNA()
  {
    return m_MI2JInfra.getCKCNI_CODE_QUALITE_CERTIFICATION_NIR_DNA();
  }
  
  public String getCodeErreurCKCNI_CODE_QUALITE_CERTIFICATION_NIR_DNA()
  {
    return m_MI2JInfra.getCKCNI_CODE_QUALITE_CERTIFICATION_NIR_DNA_C_ERR();
  }
  
  public void setCKCNI_CODE_QUALITE_CERTIFICATION_NIR_DNA(String pValeur)
  {
    m_MI2JInfra.setCKCNI_CODE_QUALITE_CERTIFICATION_NIR_DNA(pValeur);
  }
  
  public void setCodeErreurCKCNI_CODE_QUALITE_CERTIFICATION_NIR_DNA(String pCodeErreur)
  {
    m_MI2JInfra.setCKCNI_CODE_QUALITE_CERTIFICATION_NIR_DNA_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getCKCNI()
  {
    return getCKCNI_CODE_QUALITE_CERTIFICATION_NIR_DNA();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCKCNI()
  {
    return getCodeErreurCKCNI_CODE_QUALITE_CERTIFICATION_NIR_DNA();
  }
  
  /**
   * @deprecated
   */
  public void setCKCNI(String pValeur)
  {
    setCKCNI_CODE_QUALITE_CERTIFICATION_NIR_DNA(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCKCNI(String pCodeErreur)
  {
    setCodeErreurCKCNI_CODE_QUALITE_CERTIFICATION_NIR_DNA(pCodeErreur);
  }
  
  public String getCINCP_CODE_ETAT_MIGRATION_NCP()
  {
    return m_MI2JInfra.getCINCP_CODE_ETAT_MIGRATION_NCP();
  }
  
  public String getCodeErreurCINCP_CODE_ETAT_MIGRATION_NCP()
  {
    return m_MI2JInfra.getCINCP_CODE_ETAT_MIGRATION_NCP_C_ERR();
  }
  
  public void setCINCP_CODE_ETAT_MIGRATION_NCP(String pValeur)
  {
    m_MI2JInfra.setCINCP_CODE_ETAT_MIGRATION_NCP(pValeur);
  }
  
  public void setCodeErreurCINCP_CODE_ETAT_MIGRATION_NCP(String pCodeErreur)
  {
    m_MI2JInfra.setCINCP_CODE_ETAT_MIGRATION_NCP_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getCINCP()
  {
    return getCINCP_CODE_ETAT_MIGRATION_NCP();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCINCP()
  {
    return getCodeErreurCINCP_CODE_ETAT_MIGRATION_NCP();
  }
  
  /**
   * @deprecated
   */
  public void setCINCP(String pValeur)
  {
    setCINCP_CODE_ETAT_MIGRATION_NCP(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCINCP(String pCodeErreur)
  {
    setCodeErreurCINCP_CODE_ETAT_MIGRATION_NCP(pCodeErreur);
  }
  
  public String getLZOCN_ORIGINE_CERTIFICATION_IDENTITE()
  {
    return m_MI2JInfra.getLZOCN_ORIGINE_CERTIFICATION_IDENTITE();
  }
  
  public String getCodeErreurLZOCN_ORIGINE_CERTIFICATION_IDENTITE()
  {
    return m_MI2JInfra.getLZOCN_ORIGINE_CERTIFICATION_IDENTITE_C_ERR();
  }
  
  public void setLZOCN_ORIGINE_CERTIFICATION_IDENTITE(String pValeur)
  {
    m_MI2JInfra.setLZOCN_ORIGINE_CERTIFICATION_IDENTITE(pValeur);
  }
  
  public void setCodeErreurLZOCN_ORIGINE_CERTIFICATION_IDENTITE(String pCodeErreur)
  {
    m_MI2JInfra.setLZOCN_ORIGINE_CERTIFICATION_IDENTITE_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getLZOCN()
  {
    return getLZOCN_ORIGINE_CERTIFICATION_IDENTITE();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurLZOCN()
  {
    return getCodeErreurLZOCN_ORIGINE_CERTIFICATION_IDENTITE();
  }
  
  /**
   * @deprecated
   */
  public void setLZOCN(String pValeur)
  {
    setLZOCN_ORIGINE_CERTIFICATION_IDENTITE(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurLZOCN(String pCodeErreur)
  {
    setCodeErreurLZOCN_ORIGINE_CERTIFICATION_IDENTITE(pCodeErreur);
  }
  
  public String getISDNA_Valeur_Identifiant_DNA()
  {
    return m_MI2JInfra.getISDNA_Valeur_Identifiant_DNA();
  }
  
  public String getCodeErreurISDNA_Valeur_Identifiant_DNA()
  {
    return m_MI2JInfra.getISDNA_Valeur_Identifiant_DNA_C_ERR();
  }
  
  public void setISDNA_Valeur_Identifiant_DNA(String pValeur)
  {
    m_MI2JInfra.setISDNA_Valeur_Identifiant_DNA(pValeur);
  }
  
  public void setCodeErreurISDNA_Valeur_Identifiant_DNA(String pCodeErreur)
  {
    m_MI2JInfra.setISDNA_Valeur_Identifiant_DNA_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getISDNA()
  {
    return getISDNA_Valeur_Identifiant_DNA();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurISDNA()
  {
    return getCodeErreurISDNA_Valeur_Identifiant_DNA();
  }
  
  /**
   * @deprecated
   */
  public void setISDNA(String pValeur)
  {
    setISDNA_Valeur_Identifiant_DNA(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurISDNA(String pCodeErreur)
  {
    setCodeErreurISDNA_Valeur_Identifiant_DNA(pCodeErreur);
  }
  
  public String getCKABO_CODE_STATUT_ABONNEMENT()
  {
    return m_MI2JInfra.getCKABO_CODE_STATUT_ABONNEMENT();
  }
  
  public String getCodeErreurCKABO_CODE_STATUT_ABONNEMENT()
  {
    return m_MI2JInfra.getCKABO_CODE_STATUT_ABONNEMENT_C_ERR();
  }
  
  public void setCKABO_CODE_STATUT_ABONNEMENT(String pValeur)
  {
    m_MI2JInfra.setCKABO_CODE_STATUT_ABONNEMENT(pValeur);
  }
  
  public void setCodeErreurCKABO_CODE_STATUT_ABONNEMENT(String pCodeErreur)
  {
    m_MI2JInfra.setCKABO_CODE_STATUT_ABONNEMENT_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getCKABO()
  {
    return getCKABO_CODE_STATUT_ABONNEMENT();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCKABO()
  {
    return getCodeErreurCKABO_CODE_STATUT_ABONNEMENT();
  }
  
  /**
   * @deprecated
   */
  public void setCKABO(String pValeur)
  {
    setCKABO_CODE_STATUT_ABONNEMENT(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCKABO(String pCodeErreur)
  {
    setCodeErreurCKABO_CODE_STATUT_ABONNEMENT(pCodeErreur);
  }
  
  public _MI2J getMI2JInfra()
  {
    return m_MI2JInfra;
  }
  
  public String toString()
  {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
  }
  
  public boolean isEnErreur()
  {
    if ((getCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN() != null) && 
      ("".equals(getCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN()))) {
      return true;
    }
    if ((getCodeErreurCXIN_IDENTIFIANT_DE_L_INDIVIDU() != null) && 
      ("".equals(getCodeErreurCXIN_IDENTIFIANT_DE_L_INDIVIDU()))) {
      return true;
    }
    if ((getCodeErreurFIHST_INDICATEUR_PRESENCE_HISTORIQUE() != null) && 
      ("".equals(getCodeErreurFIHST_INDICATEUR_PRESENCE_HISTORIQUE()))) {
      return true;
    }
    if ((getCodeErreurLNIND1_NOM_PATRONYMIQUE() != null) && 
      ("".equals(getCodeErreurLNIND1_NOM_PATRONYMIQUE()))) {
      return true;
    }
    if ((getCodeErreurLNIND2_NOM_MARITAL() != null) && 
      ("".equals(getCodeErreurLNIND2_NOM_MARITAL()))) {
      return true;
    }
    if ((getCodeErreurLNIND3_NOM_PSEUDONYMIQUE() != null) && 
      ("".equals(getCodeErreurLNIND3_NOM_PSEUDONYMIQUE()))) {
      return true;
    }
    if ((getCodeErreurLNPIN_PRENOM() != null) && 
      ("".equals(getCodeErreurLNPIN_PRENOM()))) {
      return true;
    }
    if ((getCodeErreurISNIR_NUMERO_IDENTIFICATION_REPERTOIRE_NIR() != null) && 
      ("".equals(getCodeErreurISNIR_NUMERO_IDENTIFICATION_REPERTOIRE_NIR()))) {
      return true;
    }
    if ((getCodeErreurCXASS_CODE_ASSEDIC() != null) && 
      ("".equals(getCodeErreurCXASS_CODE_ASSEDIC()))) {
      return true;
    }
    if ((getCodeErreurCKENC_MOTIF_DE_PRESENCE_DANS_LE_SI() != null) && 
      ("".equals(getCodeErreurCKENC_MOTIF_DE_PRESENCE_DANS_LE_SI()))) {
      return true;
    }
    if ((getCodeErreurCDSEX_CODE_SEXE_INDIVIDU() != null) && 
      ("".equals(getCodeErreurCDSEX_CODE_SEXE_INDIVIDU()))) {
      return true;
    }
    if ((getCodeErreurDDNAIB_DATE_DE_NAISSANCE() != null) && 
      ("".equals(getCodeErreurDDNAIB_DATE_DE_NAISSANCE()))) {
      return true;
    }
    if ((getCodeErreurAOPOS_CODE_POSTAL() != null) && 
      ("".equals(getCodeErreurAOPOS_CODE_POSTAL()))) {
      return true;
    }
    if ((getCodeErreurADLCOC_LIBELLE_COMMUNE_FORMAT_CONTRIBULL() != null) && 
      ("".equals(getCodeErreurADLCOC_LIBELLE_COMMUNE_FORMAT_CONTRIBULL()))) {
      return true;
    }
    if ((getCodeErreurCDETA1_TYPE_DE_POPULATION() != null) && 
      ("".equals(getCodeErreurCDETA1_TYPE_DE_POPULATION()))) {
      return true;
    }
    if ((getCodeErreurCXALE_ALE_DE_L_INDIVIDU() != null) && 
      ("".equals(getCodeErreurCXALE_ALE_DE_L_INDIVIDU()))) {
      return true;
    }
    if ((getCodeErreurCDANT_ANTENNE_DE_L_INDIVIDU() != null) && 
      ("".equals(getCodeErreurCDANT_ANTENNE_DE_L_INDIVIDU()))) {
      return true;
    }
    if ((getCodeErreurCDSTN_CODE_STATUT_NIR__ANCIENNE_CODIF_() != null) && 
      ("".equals(getCodeErreurCDSTN_CODE_STATUT_NIR__ANCIENNE_CODIF_()))) {
      return true;
    }
    if ((getCodeErreurCDETT_TOP_RECHERCHE_SALARIE_E_T_T_() != null) && 
      ("".equals(getCodeErreurCDETT_TOP_RECHERCHE_SALARIE_E_T_T_()))) {
      return true;
    }
    if ((getCodeErreurCKCNI_CODE_QUALITE_CERTIFICATION_NIR_DNA() != null) && 
      ("".equals(getCodeErreurCKCNI_CODE_QUALITE_CERTIFICATION_NIR_DNA()))) {
      return true;
    }
    if ((getCodeErreurCINCP_CODE_ETAT_MIGRATION_NCP() != null) && 
      ("".equals(getCodeErreurCINCP_CODE_ETAT_MIGRATION_NCP()))) {
      return true;
    }
    if ((getCodeErreurLZOCN_ORIGINE_CERTIFICATION_IDENTITE() != null) && 
      ("".equals(getCodeErreurLZOCN_ORIGINE_CERTIFICATION_IDENTITE()))) {
      return true;
    }
    if ((getCodeErreurISDNA_Valeur_Identifiant_DNA() != null) && 
      ("".equals(getCodeErreurISDNA_Valeur_Identifiant_DNA()))) {
      return true;
    }
    if ((getCodeErreurCKABO_CODE_STATUT_ABONNEMENT() != null) && 
      ("".equals(getCodeErreurCKABO_CODE_STATUT_ABONNEMENT()))) {
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     _MI2JImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */