package fr.unedic.logique.donnees.rac.commun.dra.zu;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.archi.logique.adaptateur.ObjetSerialisableFournisseur;
import java.io.Serializable;
import java.math.BigDecimal;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class _MI89Impl
  extends MI89
  implements ObjetSerialisableFournisseur, Serializable
{
  private static final long serialVersionUID = 1L;
  private final _MI89 m_MI89Infra;
  
  public _MI89Impl()
  {
    m_MI89Infra = new _MI89();
  }
  
  public _MI89Impl(_MI89 pValeur)
  {
    ExceptionUtil.assertMethodParamNotNull("MI89Infra", pValeur);
    
    m_MI89Infra = pValeur;
  }
  
  public Object getObjet()
  {
    return m_MI89Infra;
  }
  
  public String getIdentifiant()
  {
    return m_MI89Infra.get_IDENT();
  }
  
  public void setIdentifiant(String pIdentifiant)
  {
    m_MI89Infra.set_IDENT(pIdentifiant);
  }
  
  public String getCodeEtat()
  {
    return m_MI89Infra.get_C_ETAT();
  }
  
  public void setCodeEtat(String pCode)
  {
    m_MI89Infra.set_C_ETAT(pCode);
  }
  
  public BigDecimal getCXALA_IDENTIFIANT_NATIONAL_ALADIN()
  {
    return m_MI89Infra.getCXALA_IDENTIFIANT_NATIONAL_ALADIN();
  }
  
  public String getCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN()
  {
    return m_MI89Infra.getCXALA_IDENTIFIANT_NATIONAL_ALADIN_C_ERR();
  }
  
  public void setCXALA_IDENTIFIANT_NATIONAL_ALADIN(BigDecimal pValeur)
  {
    m_MI89Infra.setCXALA_IDENTIFIANT_NATIONAL_ALADIN(pValeur);
  }
  
  public void setCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN(String pCodeErreur)
  {
    m_MI89Infra.setCXALA_IDENTIFIANT_NATIONAL_ALADIN_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public BigDecimal getCXALA()
  {
    return getCXALA_IDENTIFIANT_NATIONAL_ALADIN();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCXALA()
  {
    return getCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN();
  }
  
  /**
   * @deprecated
   */
  public void setCXALA(BigDecimal pValeur)
  {
    setCXALA_IDENTIFIANT_NATIONAL_ALADIN(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCXALA(String pCodeErreur)
  {
    setCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN(pCodeErreur);
  }
  
  public String getCXASS_CODE_ASSEDIC()
  {
    return m_MI89Infra.getCXASS_CODE_ASSEDIC();
  }
  
  public String getCodeErreurCXASS_CODE_ASSEDIC()
  {
    return m_MI89Infra.getCXASS_CODE_ASSEDIC_C_ERR();
  }
  
  public void setCXASS_CODE_ASSEDIC(String pValeur)
  {
    m_MI89Infra.setCXASS_CODE_ASSEDIC(pValeur);
  }
  
  public void setCodeErreurCXASS_CODE_ASSEDIC(String pCodeErreur)
  {
    m_MI89Infra.setCXASS_CODE_ASSEDIC_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getCXASS()
  {
    return getCXASS_CODE_ASSEDIC();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCXASS()
  {
    return getCodeErreurCXASS_CODE_ASSEDIC();
  }
  
  /**
   * @deprecated
   */
  public void setCXASS(String pValeur)
  {
    setCXASS_CODE_ASSEDIC(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCXASS(String pCodeErreur)
  {
    setCodeErreurCXASS_CODE_ASSEDIC(pCodeErreur);
  }
  
  public String getCXIN_IDENTIFIANT_DE_L_INDIVIDU()
  {
    return m_MI89Infra.getCXIN_IDENTIFIANT_DE_L_INDIVIDU();
  }
  
  public String getCodeErreurCXIN_IDENTIFIANT_DE_L_INDIVIDU()
  {
    return m_MI89Infra.getCXIN_IDENTIFIANT_DE_L_INDIVIDU_C_ERR();
  }
  
  public void setCXIN_IDENTIFIANT_DE_L_INDIVIDU(String pValeur)
  {
    m_MI89Infra.setCXIN_IDENTIFIANT_DE_L_INDIVIDU(pValeur);
  }
  
  public void setCodeErreurCXIN_IDENTIFIANT_DE_L_INDIVIDU(String pCodeErreur)
  {
    m_MI89Infra.setCXIN_IDENTIFIANT_DE_L_INDIVIDU_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getCXIN()
  {
    return getCXIN_IDENTIFIANT_DE_L_INDIVIDU();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCXIN()
  {
    return getCodeErreurCXIN_IDENTIFIANT_DE_L_INDIVIDU();
  }
  
  /**
   * @deprecated
   */
  public void setCXIN(String pValeur)
  {
    setCXIN_IDENTIFIANT_DE_L_INDIVIDU(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCXIN(String pCodeErreur)
  {
    setCodeErreurCXIN_IDENTIFIANT_DE_L_INDIVIDU(pCodeErreur);
  }
  
  public String getCXALAK_IDENTIFIANT_ALIAS_NCP()
  {
    return m_MI89Infra.getCXALAK_IDENTIFIANT_ALIAS_NCP();
  }
  
  public String getCodeErreurCXALAK_IDENTIFIANT_ALIAS_NCP()
  {
    return m_MI89Infra.getCXALAK_IDENTIFIANT_ALIAS_NCP_C_ERR();
  }
  
  public void setCXALAK_IDENTIFIANT_ALIAS_NCP(String pValeur)
  {
    m_MI89Infra.setCXALAK_IDENTIFIANT_ALIAS_NCP(pValeur);
  }
  
  public void setCodeErreurCXALAK_IDENTIFIANT_ALIAS_NCP(String pCodeErreur)
  {
    m_MI89Infra.setCXALAK_IDENTIFIANT_ALIAS_NCP_C_ERR(pCodeErreur);
  }
  
  /**
   * @deprecated
   */
  public String getCXALAK()
  {
    return getCXALAK_IDENTIFIANT_ALIAS_NCP();
  }
  
  /**
   * @deprecated
   */
  public String getCodeErreurCXALAK()
  {
    return getCodeErreurCXALAK_IDENTIFIANT_ALIAS_NCP();
  }
  
  /**
   * @deprecated
   */
  public void setCXALAK(String pValeur)
  {
    setCXALAK_IDENTIFIANT_ALIAS_NCP(pValeur);
  }
  
  /**
   * @deprecated
   */
  public void setCodeErreurCXALAK(String pCodeErreur)
  {
    setCodeErreurCXALAK_IDENTIFIANT_ALIAS_NCP(pCodeErreur);
  }
  
  public _MI89 getMI89Infra()
  {
    return m_MI89Infra;
  }
  
  public String toString()
  {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
  }
  
  public boolean isEnErreur()
  {
    if ((getCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN() != null) && 
      ("".equals(getCodeErreurCXALA_IDENTIFIANT_NATIONAL_ALADIN()))) {
      return true;
    }
    if ((getCodeErreurCXASS_CODE_ASSEDIC() != null) && 
      ("".equals(getCodeErreurCXASS_CODE_ASSEDIC()))) {
      return true;
    }
    if ((getCodeErreurCXIN_IDENTIFIANT_DE_L_INDIVIDU() != null) && 
      ("".equals(getCodeErreurCXIN_IDENTIFIANT_DE_L_INDIVIDU()))) {
      return true;
    }
    if ((getCodeErreurCXALAK_IDENTIFIANT_ALIAS_NCP() != null) && 
      ("".equals(getCodeErreurCXALAK_IDENTIFIANT_ALIAS_NCP()))) {
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     _MI89Impl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */