package fr.unedic.logique.service.rac.commun.dr1;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.archi.logique.contexte.Utilisateur;
import fr.unedic.archi.logique.deploiement.DomaineFabrique;

public abstract class DomaineDR1Fabrique
  extends DomaineFabrique
{
  public static DomaineDR1ServiceSync getDomaineDR1ServiceSync()
    throws TechniqueException
  {
    DomaineDR1ServiceSync domaineInstance = (DomaineDR1ServiceSync)getCachedDomaineInstance(DomaineDR1ServiceSync.class);
    DomaineDR1ServiceSync retour;
    DomaineDR1ServiceSync retour;
    if (domaineInstance == null) {
      retour = loadDomaineInstanceSync();
    } else {
      retour = domaineInstance;
    }
    return retour;
  }
  
  public static DomaineDR1ServiceAsync getDomaineDR1ServiceAsync()
    throws TechniqueException
  {
    DomaineDR1ServiceAsync domaineInstance = (DomaineDR1ServiceAsync)getCachedDomaineInstance(DomaineDR1ServiceAsync.class);
    DomaineDR1ServiceAsync retour;
    DomaineDR1ServiceAsync retour;
    if (domaineInstance == null) {
      retour = loadDomaineInstanceAsync();
    } else {
      retour = domaineInstance;
    }
    return retour;
  }
  
  public static DomaineDR1Flux getDomaineDR1Flux(Utilisateur pUtilisateur, String pAssedic)
    throws TechniqueException
  {
    DomaineDR1Flux domaineInstance = (DomaineDR1Flux)getCachedDomaineInstance(DomaineDR1Flux.class);
    _DomaineDR1FluxImpl impl;
    _DomaineDR1FluxImpl impl;
    if (domaineInstance == null)
    {
      DomaineDR1Flux newDomaine = loadDomaineInstanceFlux(pUtilisateur, pAssedic);
      
      ExceptionUtil.assertInstanceOf("newDomaine", newDomaine, _DomaineDR1FluxImpl.class);
      
      impl = (_DomaineDR1FluxImpl)newDomaine;
    }
    else
    {
      ExceptionUtil.assertInstanceOf("domaineInstance", domaineInstance, _DomaineDR1FluxImpl.class);
      impl = (_DomaineDR1FluxImpl)domaineInstance;
    }
    impl.setCodeAssedic(pAssedic);
    impl.setUtilisateur(pUtilisateur);
    
    return impl;
  }
  
  public static DomaineDR1Flux getDomaineDR1Flux()
    throws TechniqueException
  {
    return getDomaineDR1Flux(getCurrentUser(), getCurrentAssedic());
  }
  
  public static DomaineDR1Flux getDomaineDR1Flux(Utilisateur pUtilisateur)
    throws TechniqueException
  {
    return getDomaineDR1Flux(pUtilisateur, getCurrentAssedic());
  }
  
  public static DomaineDR1Flux getDomaineDR1Flux(String pAssedic)
    throws TechniqueException
  {
    return getDomaineDR1Flux(getCurrentUser(), pAssedic);
  }
  
  private static synchronized DomaineDR1ServiceSync loadDomaineInstanceSync()
    throws TechniqueException
  {
    DomaineDR1ServiceSync domaineInstance = (DomaineDR1ServiceSync)getCachedDomaineInstance(DomaineDR1ServiceSync.class);
    DomaineDR1ServiceSync retour;
    DomaineDR1ServiceSync retour;
    if (domaineInstance == null)
    {
      DomaineDR1ServiceSyncImpl domaineImpl = new DomaineDR1ServiceSyncImpl();
      retour = (DomaineDR1ServiceSync)configureDomaineSyncImpl(DomaineDR1ServiceSync.class, domaineImpl);
    }
    else
    {
      retour = domaineInstance;
    }
    return retour;
  }
  
  private static synchronized DomaineDR1ServiceAsync loadDomaineInstanceAsync()
    throws TechniqueException
  {
    DomaineDR1ServiceAsync domaineInstance = (DomaineDR1ServiceAsync)getCachedDomaineInstance(DomaineDR1ServiceAsync.class);
    DomaineDR1ServiceAsync retour;
    DomaineDR1ServiceAsync retour;
    if (domaineInstance == null)
    {
      DomaineDR1ServiceAsyncImpl domaineImpl = new DomaineDR1ServiceAsyncImpl();
      retour = (DomaineDR1ServiceAsync)configureDomaineAsyncImpl(DomaineDR1ServiceAsync.class, domaineImpl);
    }
    else
    {
      retour = domaineInstance;
    }
    return retour;
  }
  
  private static synchronized DomaineDR1Flux loadDomaineInstanceFlux(Utilisateur pUser, String pAssedic)
    throws TechniqueException
  {
    DomaineDR1Flux domaineInstance = (DomaineDR1Flux)getCachedDomaineInstance(DomaineDR1Flux.class, pUser, pAssedic);
    DomaineDR1Flux retour;
    DomaineDR1Flux retour;
    if (domaineInstance == null)
    {
      _DomaineDR1FluxImpl domaineImpl = new _DomaineDR1FluxImpl();
      retour = (DomaineDR1Flux)configureDomaineFluxImpl(DomaineDR1Flux.class, domaineImpl, pUser, pAssedic);
    }
    else
    {
      retour = domaineInstance;
    }
    return retour;
  }
}

/* Location:
 * Qualified Name:     DomaineDR1Fabrique
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */