package fr.unedic.cali.asu.asr.liquidation.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionDateAttribution;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionPointDepartIndemnisation;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsSpec;
import fr.unedic.util.services.OutilFonctionnel;

public class DeterminationPointDeDepart
  implements OutilFonctionnel
{
  public static DeterminationPointDeDepart getInstance()
  {
    return new DeterminationPointDeDepart();
  }
  
  public ConstitutionPointDepartIndemnisation determinerPointDeDepartIndemnisation(Demande p_demande)
    throws ApplicativeException
  {
    DossierExamen dossierExamenCourant = (DossierExamen)p_demande.getDossierExamen();
    
    ConstitutionPointDepartIndemnisation cep = dossierExamenCourant.getConstitutionElementsActifs().createConstitutionPointDepartIndemnisation();
    
    cep.setPji(dossierExamenCourant.getConstitutionElementsActifs().getConstitutionDateAttribution().getDateAttribution());
    
    return cep;
  }
}

/* Location:
 * Qualified Name:     DeterminationPointDeDepart
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */