package fr.unedic.cali.asu.caa14.p02.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.caa14.p02.liquidation.dom.ObjectifExamenAdmission;
import fr.unedic.cali.asu.caa14.p02.liquidation.dom.ObjectifExamenReprise;
import fr.unedic.cali.asu.caa14.p02.liquidation.dom.ObjectifExamenRevision;
import fr.unedic.cali.asu.caa14.p02.liquidation.dom.ObjectifExamenRevisionAdmission;
import fr.unedic.cali.asu.dom.ObjectifExamen;
import fr.unedic.cali.dom.affectation.ContexteDemandeSpec;
import fr.unedic.util.services.OutilFonctionnel;
import java.util.List;

public final class FabriqueObjectifExamen
  implements OutilFonctionnel
{
  public static ObjectifExamen creerObjectif(int sousType, List<ContexteDemandeSpec> contexteDemande)
  {
    ObjectifExamen objectif = null;
    switch (sousType)
    {
    case 10: 
    case 12: 
    case 44: 
      objectif = new ObjectifExamenAdmission(contexteDemande);
      break;
    case 3: 
    case 13: 
    case 15: 
    case 47: 
    case 48: 
      objectif = new ObjectifExamenReprise(contexteDemande);
      break;
    case 30: 
      objectif = new ObjectifExamenRevision(contexteDemande);
      break;
    case 45: 
      objectif = new ObjectifExamenRevisionAdmission();
      break;
    default: 
      throw new UnsupportedOperationException("FabriqueObjectifExamen : le sous-type " + sousType + " est inconnu.");
    }
    objectif.setSousType(sousType);
    return objectif;
  }
}

/* Location:
 * Qualified Name:     FabriqueObjectifExamen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */