package fr.unedic.cali.asu.calcul;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.MontantAsuSpec;
import fr.unedic.cali.calcul.FacadeCalculProduitPourLiquidationSpec;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.cali.dom.conteneurs.DonneesEntreesRecuperationMontant;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;

public abstract interface FacadeCalculProduitPourLiquidationAsuSpec
  extends FacadeCalculProduitPourLiquidationSpec
{
  public abstract MontantBaseSpec determinerMontant(DonneesEntreesRecuperationMontant paramDonneesEntreesRecuperationMontant)
    throws CoucheLogiqueException;
  
  public abstract boolean determinerPrecompteCRC(AttributionSpec paramAttributionSpec)
    throws CoucheLogiqueException;
  
  public abstract Quantite determinerDureeEffectiveReliquat(Quantite paramQuantite1, Quantite paramQuantite2)
    throws IllegalArgumentException;
  
  public abstract Damj determinerDateConditionNombreJoursIndemnisesNecessaireMaintien(AttributionSpec paramAttributionSpec)
    throws ApplicativeException;
  
  public abstract FormuleMontantSpec getFormuleMontant();
  
  public abstract FormuleMontantSpec getFormuleMontantEnFormation();
  
  public abstract Boolean determinerReliquatValide(AttributionSpec paramAttributionSpec, Damj paramDamj)
    throws CoucheLogiqueException;
  
  public abstract Quantite calculerCapital(AttributionSpec paramAttributionSpec, MontantAsuSpec paramMontantAsuSpec, Damj paramDamj, Quantite paramQuantite)
    throws CoucheLogiqueException;
  
  public abstract Quantite calculerCapital(AttributionSpec paramAttributionSpec, Damj paramDamj1, Damj paramDamj2, Quantite paramQuantite)
    throws CoucheLogiqueException;
  
  public abstract int determinerNombreMoisIndemnise(AttributionSpec paramAttributionSpec, Damj paramDamj)
    throws ApplicativeException;
  
  public abstract BigDecimal getSeuilRenumeration(AttributionSpec paramAttributionSpec, Damj paramDamj)
    throws CoucheLogiqueException;
  
  public abstract int determinerNbJoursImputesContextePmvs(AttributionSpec paramAttributionSpec, Periode paramPeriode)
    throws ApplicativeException;
}

/* Location:
 * Qualified Name:     FacadeCalculProduitPourLiquidationAsuSpec
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */