package fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels;

import fr.unedic.util.Mathematiques;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import java.math.BigDecimal;

public class DeterminationReliquat
{
  static final String DIVISEUR_NB_HEURES_FORMATION = "10";
  static final String NB_JOUR_MINIMUM_RELIQUAT = "30";
  
  private static Quantite determinerDureeTheoriqueImputationSurReliquat(Quantite nbHeuresFormation)
    throws IllegalArgumentException
  {
    if (!nbHeuresFormation.getUnite().equals(Unite.get("heure de travail"))) {
      throw new IllegalArgumentException("La quantite de formation doit être exprimée en heures");
    }
    BigDecimal result = Mathematiques.diviseEntier(nbHeuresFormation.getValeur(), new BigDecimal("10"));
    return new Quantite(result, Unite.get("jour"));
  }
  
  private static Quantite determinerDureeEffectiveImputation(Quantite quantiteInitiale, Quantite nbHeuresFormation)
    throws IllegalArgumentException
  {
    Quantite dureeTheoriqueImputation = determinerDureeTheoriqueImputationSurReliquat(nbHeuresFormation);
    int result = Math.min(quantiteInitiale.getValeurEntiere() - 30, dureeTheoriqueImputation.getValeurEntiere());
    return new Quantite(new BigDecimal(result), Unite.get("jour"));
  }
  
  public static Quantite determinerDureeEffectiveReliquat(Quantite quantiteInitiale, Quantite nbHeuresFormation)
    throws IllegalArgumentException
  {
    Quantite dureeEffectiveImputation = determinerDureeEffectiveImputation(quantiteInitiale, nbHeuresFormation);
    return new Quantite(quantiteInitiale.getValeur().subtract(dureeEffectiveImputation.getValeur()), Unite.get("jour"));
  }
}

/* Location:
 * Qualified Name:     DeterminationReliquat
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */