package fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels;

import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.OdAssuranceSpec;
import fr.unedic.cali.asu.mnt.outilsfonctionnels.DetectionMaintien;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;

public final class Maintien
  extends DetectionMaintien
{
  private static Maintien s_instance = new Maintien();
  
  public static Maintien getInstance()
  {
    return s_instance;
  }
  
  public boolean evaluerConditionAge(AttributionSpec attribution, Damj date)
  {
    boolean condition = false;
    
    DureeCalendaire ageIndividuAuPji = attribution.getDemandeur().getAgeALaDate(attribution.getPji());
    
    ProduitAsuSpec produitAMaintenir = (ProduitAsuSpec)((AttributionAssuranceSpec)attribution).getOuvertureDroitCapitalRetenu().getProduit();
    Damj dateDetectionAgeMaintien = attribution.getPji().deplacerVersArriere(ageIndividuAuPji).deplacerVersAvant(produitAMaintenir.getAgeMinimumObtentionMaintien(attribution.getDemande()));
    if (dateDetectionAgeMaintien.estAvantOuCoincideAvec(date)) {
      condition = true;
    }
    return condition;
  }
}

/* Location:
 * Qualified Name:     Maintien
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */