package fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels;

import fr.unedic.cali.dom.EtatQuantiteDroitActive;
import fr.unedic.cali.dom.EtatQuantiteDroitEpuisee;
import fr.unedic.cali.dom.EtatQuantiteDroitInactive;
import fr.unedic.cali.dom.ImputationJour;
import fr.unedic.cali.dom.QuantiteDroit;
import fr.unedic.cali.dom.VisiteurQuantiteDroit;
import fr.unedic.util.Quantite;

public class SimulateurImputeurDureeIndemnisation
  implements VisiteurQuantiteDroit
{
  private QuantiteDroit duree = null;
  private Quantite quantiteAImputer = null;
  
  public Object visiter(EtatQuantiteDroitActive dureeActive)
  {
    ImputationJour monImputation = new ImputationJour();
    monImputation.setQuantiteDroit(duree);
    
    monImputation.setImpute(true);
    monImputation.setResteAImputer(duree.getQuantiteCourante().getValeurEntiere() - quantiteAImputer.getValeurEntiere());
    return monImputation;
  }
  
  public Object visiter(EtatQuantiteDroitEpuisee paramDuree)
  {
    ImputationJour monImputation = new ImputationJour();
    monImputation.setQuantiteDroit(duree);
    monImputation.setImpute(false);
    return monImputation;
  }
  
  public Object visiter(EtatQuantiteDroitInactive etat)
  {
    ImputationJour monImputation = new ImputationJour();
    monImputation.setQuantiteDroit(duree);
    monImputation.setImpute(false);
    return monImputation;
  }
  
  public SimulateurImputeurDureeIndemnisation(QuantiteDroit paramDuree, Quantite quantite)
  {
    duree = paramDuree;
    quantiteAImputer = quantite;
  }
}

/* Location:
 * Qualified Name:     SimulateurImputeurDureeIndemnisation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */