package fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.fabriques;

import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.strategies.StrategieConventionARE14Apres;
import fr.unedic.cali.asu.cge01.calcul.outilsfonctionnels.strategies.StrategieConventionARE14Avant;
import fr.unedic.cali.fabriques.FabriqueConvention2014;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;

public class FabriqueStrategieConvention2014
  extends FabriqueConvention2014
{
  private static FabriqueStrategieConvention2014 instance = new FabriqueStrategieConvention2014();
  
  public static FabriqueStrategieConvention2014 getInstance()
  {
    return instance;
  }
  
  public StrategieSpec getStrategie(CritereStrategie critereStrategie)
    throws CoucheLogiqueException
  {
    StrategieSpec retour = null;
    
    Damj datePivot = critereStrategie.getDatePivot();
    if (datePivot == null) {
      throw new UnsupportedOperationException("FabriqueStrategieConvention2014 : la date pivot est null.");
    }
    if (datePivot.estApresOuCoincideAvec(DATE_APPLICATION)) {
      retour = new StrategieConventionARE14Apres();
    } else {
      retour = new StrategieConventionARE14Avant();
    }
    return retour;
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieConvention2014
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */