package fr.unedic.cali.asu.cge01.liquidation.outilsaffiliation.strategies;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.liquidation.dom.ResultatRechercheConditionChomageInvolontaire;
import fr.unedic.cali.asu.cge01.liquidation.outilsaffiliation.strategies.spec.StrategieConditionChomageInvolontaireAre14Spec;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.RechercheConditionChomageInvolontaire;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.dom.FormulaireSpec;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.dom.affectation.Reglement;

public class StrategieConditionChomageInvolontaireAre14Avant
  implements StrategieConditionChomageInvolontaireAre14Spec
{
  public ResultatRechercheConditionChomageInvolontaire rechercheConditionChomageInvolontairePourOd(Demande demande)
    throws ApplicativeException
  {
    ResultatRechercheConditionChomageInvolontaire resultat = initialiserResultat();
    
    boolean conditionForcee = false;
    if (demande.getDonneesTemporaires() != null) {
      conditionForcee = demande.getDonneesTemporaires().isConditionChomageInvolontaireSatistaite();
    }
    if (conditionForcee) {
      resultat.getResultatElementDroit().setEtatSatisfait(true);
    } else {
      resultat = RechercheConditionChomageInvolontaire.verifierChomageInvolontaireDemandeAssurance(demande, demande.getFaitGenerateur());
    }
    return resultat;
  }
  
  public ResultatRechercheConditionChomageInvolontaire rechercheConditionChomageInvolontairePourReprise(Demande demande)
    throws ApplicativeException
  {
    ResultatRechercheConditionChomageInvolontaire resultat = initialiserResultat();
    if (demande.getFormulaire().getPresenceAe().equalsIgnoreCase("I"))
    {
      resultat.getResultatElementDroit().setEtatSatisfait(true);
      resultat.setSituationConditionChomageInvolontaire(2);
    }
    else
    {
      Reglement reglementApplicableCourant = RechercheConditionChomageInvolontaire.recupererReglement(demande);
      
      RechercheConditionChomageInvolontaire.traiterSituation1(demande, reglementApplicableCourant, resultat);
      if (!resultat.getResultatElementDroit().estSatisfait()) {
        RechercheConditionChomageInvolontaire.traiterSituation2(demande, reglementApplicableCourant, resultat);
      }
    }
    return resultat;
  }
  
  private ResultatRechercheConditionChomageInvolontaire initialiserResultat()
  {
    ResultatRechercheConditionChomageInvolontaire resultatRechercheConditionChomageInvolontaire = new ResultatRechercheConditionChomageInvolontaire();
    ResultatElementDroit resultatElementDroit = new ResultatElementDroit();
    resultatRechercheConditionChomageInvolontaire.setResultatElementDroit(resultatElementDroit);
    return resultatRechercheConditionChomageInvolontaire;
  }
}

/* Location:
 * Qualified Name:     StrategieConditionChomageInvolontaireAre14Avant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */