package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.liquidation.dom.ResultatDeterminationDuree;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.liquidation.outilsfonctionnels.OutilAdhesionVolontaire;
import fr.unedic.cali.asu.outilsfonctionnels.OutilFinDroit;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.dom.spec.EvenementReferenceExamenFinDroitSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.UniteDuree;

public class DeterminationDureeReglementaireAdhesionVolontaire
  extends DeterminationDureeReglementaire
{
  public static DeterminationDureeReglementaire getInstanceAdhesionVolontaire()
  {
    return new DeterminationDureeReglementaireAdhesionVolontaire();
  }
  
  public ResultatDeterminationDuree determinerDureeReglementairePourRepriseRevision(Demande p_demande)
    throws ApplicativeException
  {
    ResultatDeterminationDuree dureeIndemnisation = super.determinerDureeReglementairePourRepriseRevision(p_demande);
    EvenementReferenceExamenFinDroitSpec ere = (EvenementReferenceExamenFinDroitSpec)p_demande.getEvenementReferenceExamen();
    AttributionAssuranceSpec attributionAssurance = (AttributionAssuranceSpec)ere.rechercherAttributionPrecedente(p_demande);
    Quantite quantiteAImputer = OutilFinDroit.trouverQuantiteAImputer(p_demande, attributionAssurance);
    Quantite dureeTheorique = dureeIndemnisation.getDureeTheorique();
    
    dureeIndemnisation.setDureeRestantAImputer(new Quantite(0, UniteDuree.JOUR));
    if ((OutilGestionContexteDemande.estContexteDemandeAssurancePresent(p_demande, "ACTIMPREL")) && 
      (dureeTheorique.compareTo(quantiteAImputer) < 0))
    {
      Quantite quantiteRestantAImputer = quantiteAImputer.soustraire(dureeTheorique);
      dureeIndemnisation.setDureeRestantAImputer(quantiteRestantAImputer);
    }
    Quantite nouvelleDureeTheorique = OutilAdhesionVolontaire.imputerQuantite(dureeTheorique, quantiteAImputer);
    Quantite nouvelleDureeEffective = OutilAdhesionVolontaire.imputerQuantite(dureeIndemnisation.getDureeEffective(), quantiteAImputer);
    dureeIndemnisation.setDureeTheorique(nouvelleDureeTheorique);
    dureeIndemnisation.setDureeEffective(nouvelleDureeEffective);
    return dureeIndemnisation;
  }
}

/* Location:
 * Qualified Name:     DeterminationDureeReglementaireAdhesionVolontaire
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */