package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.produits.liquidation.dom.Pra;
import fr.unedic.cali.util.TableQuantites;
import fr.unedic.util.Mathematiques;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.Enumeration;
import java.util.Hashtable;

public class OutilPlafonnementAssimilation
{
  private static final OutilPlafonnementAssimilation INSTANCE_OUTIL_ASSIMILATION = new OutilPlafonnementAssimilation();
  private static final double MULTIPLICATEUR_CALCUL_ASSIMILATION_MAX = 2.0D;
  private static final double DIVISEUR_CALCUL_ASSIMILATION_MAX = 3.0D;
  private static final int VALEUR_ARRONDI = 0;
  
  public static OutilPlafonnementAssimilation getInstance()
  {
    return INSTANCE_OUTIL_ASSIMILATION;
  }
  
  public void positionnerQuantiteAssimilationMaximum(Periode p_periode, TableQuantites p_tableQuantitesAffiliationAcquises)
  {
    Pra pra = (Pra)p_periode;
    Hashtable quantiteAssimilationMax = new Hashtable();
    
    Enumeration enumQuantite = p_tableQuantitesAffiliationAcquises.keys();
    while (enumQuantite.hasMoreElements())
    {
      Unite unite = (Unite)enumQuantite.nextElement();
      Quantite quantitePourUnite = p_tableQuantitesAffiliationAcquises.get(unite);
      quantiteAssimilationMax.put(unite, determinerQuantiteMaxAssimilationSelonQuantiteAffiliation(quantitePourUnite));
    }
    pra.setListeQuantitesAssimilationMaximales(quantiteAssimilationMax);
  }
  
  private static Quantite determinerQuantiteMaxAssimilationSelonQuantiteAffiliation(Quantite p_quantiteAffiliation)
  {
    BigDecimal assimilationMax = Mathematiques.arrondiASup(p_quantiteAffiliation.getValeur().multiply(new BigDecimal(2.0D)).divide(new BigDecimal(3.0D), 0), 0);
    
    return new Quantite(assimilationMax, p_quantiteAffiliation.getUnite());
  }
}

/* Location:
 * Qualified Name:     OutilPlafonnementAssimilation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */