package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.mnt.dom.ConditionDureeIndemnisationMaintien;
import fr.unedic.cali.asu.mnt.dom.DemandeMaintien;
import fr.unedic.cali.asu.outilsfonctionnels.AppelCalculParLiquidationAsu;
import fr.unedic.cali.asu.outilsfonctionnels.RechercherDemandeMaintien;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.util.services.OutilFonctionnel;
import fr.unedic.util.temps.Damj;

public class RechercheConditionDureeIndemnisationMaintien
  implements OutilFonctionnel
{
  public static ConditionDureeIndemnisationMaintien rechercherConditionDureeIndemnisation(DemandeMaintien p_demande)
    throws ApplicativeException
  {
    ConditionDureeIndemnisationMaintien conditionDureeIndemnisation = new ConditionDureeIndemnisationMaintien();
    
    int nombreJoursIndemnisationRequis = 365;
    conditionDureeIndemnisation.setNombreJoursDureeIndemnisationRequise(nombreJoursIndemnisationRequis);
    
    Damj dateObtentionDureeIndemnisation = getDateObtentionIndemnisation(p_demande);
    conditionDureeIndemnisation.setDateObtentionDureeIndemnisation(dateObtentionDureeIndemnisation);
    if ((dateObtentionDureeIndemnisation != null) && (dateObtentionDureeIndemnisation.estAvantOuCoincideAvec(p_demande.getDateExamen())))
    {
      conditionDureeIndemnisation.setEtatSatisfait(true);
    }
    else
    {
      conditionDureeIndemnisation.setEtatSatisfait(false);
      conditionDureeIndemnisation.setCodeMotifEchec(985);
    }
    return conditionDureeIndemnisation;
  }
  
  public static Damj getDateObtentionIndemnisation(DemandeMaintien p_demande)
    throws ApplicativeException
  {
    AttributionSpec attributionARE = RechercherDemandeMaintien.rechercherAttributionAssurancePrecedentePourMaintien(p_demande);
    Damj dateObtentionNombreJoursIndemnisesNecessaireMaintien = AppelCalculParLiquidationAsu.determinerDateConditionNombreJoursIndemnisesNecessaireMaintien(attributionARE);
    if (dateObtentionNombreJoursIndemnisesNecessaireMaintien == null) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_MNT_OBTENTION_NB_JOURS_INDEMN", new Object[] { attributionARE.getDateAttribution() });
    }
    return dateObtentionNombreJoursIndemnisesNecessaireMaintien;
  }
}

/* Location:
 * Qualified Name:     RechercheConditionDureeIndemnisationMaintien
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */