package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.affiliation;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.affiliation.dom.AlerteAffiliation;
import fr.unedic.cali.asu.dom.PeriodeElementaire;
import java.util.HashMap;

public class OutilAlerteAffiliation
{
  private static OutilAlerteAffiliation s_singleton = new OutilAlerteAffiliation();
  public static HashMap s_libelleAlertesAffiliation = new HashMap();
  public static final String CODE_ALERTE_ABSENCE_AFFILIATION = "1";
  public static final String LIBELLE_ALERTE_ABSENCE_AFFILIATION = "Pas d'affiliation en %ARG%";
  
  static
  {
    s_libelleAlertesAffiliation.put("1", "Pas d'affiliation en %ARG%");
  }
  
  public static OutilAlerteAffiliation getInstance()
  {
    return s_singleton;
  }
  
  public AlerteAffiliation genererAlerteAffiliation(PeriodeElementaire p_periodeElementaire, String p_codeAlerte, String[] p_arguments)
  {
    AlerteAffiliation alerteAffiliation = creerAlerteAffiliation();
    
    alerteAffiliation.setPeriodeActivite(p_periodeElementaire.getPeriodeActiviteSalariee());
    alerteAffiliation.setPeriodeAlerte(p_periodeElementaire.getPeriodePE());
    alerteAffiliation.setCodeAlerte(p_codeAlerte);
    alerteAffiliation.setLibelleAlerte(creerMessageParametres(p_codeAlerte, p_arguments));
    alerteAffiliation.setRaisonSociale(p_periodeElementaire.getRaisonSociale());
    
    return alerteAffiliation;
  }
  
  private String creerMessageParametres(String p_codeAlerte, String[] p_args)
  {
    String message = null;
    message = (String)s_libelleAlertesAffiliation.get(p_codeAlerte);
    if (p_args != null) {
      for (int i = 0; i < p_args.length; i++) {
        message = message.replaceFirst("%ARG%", p_args[i].toString());
      }
    }
    return message;
  }
  
  private AlerteAffiliation creerAlerteAffiliation()
  {
    return new AlerteAffiliation();
  }
}

/* Location:
 * Qualified Name:     OutilAlerteAffiliation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */