package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.fabriques;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StategieDateDebutMaxActiviteConserveeApres;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StategieDateDebutMaxActiviteConserveeAvant;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StategieDateDebutMaxActiviteConserveeSpec;
import fr.unedic.cali.fabriques.FabriqueStrategieSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.temps.Damj;

public class FabriqueStategieDateDebutMaxActiviteConservee
  implements FabriqueStrategieSpec
{
  public static final Damj DATE_APPLICATION = new Damj(2010, 1, 8);
  private static FabriqueStategieDateDebutMaxActiviteConservee s_instance = new FabriqueStategieDateDebutMaxActiviteConservee();
  
  public static FabriqueStategieDateDebutMaxActiviteConservee getInstance()
  {
    return s_instance;
  }
  
  public StrategieSpec getStrategie(CritereStrategie p_critereStrategie)
  {
    StategieDateDebutMaxActiviteConserveeSpec strategie = null;
    
    Damj datePivotDateDebutMaxActiviteConservee = p_critereStrategie.getDatePivot();
    if (datePivotDateDebutMaxActiviteConservee == null) {
      throw new UnsupportedOperationException("FabriqueStrategieDateDebutMaxActiviteConservee : la date pivot est null.");
    }
    if (datePivotDateDebutMaxActiviteConservee.estApresOuCoincideAvec(DATE_APPLICATION)) {
      strategie = new StategieDateDebutMaxActiviteConserveeApres();
    } else {
      strategie = new StategieDateDebutMaxActiviteConserveeAvant();
    }
    return strategie;
  }
}

/* Location:
 * Qualified Name:     FabriqueStategieDateDebutMaxActiviteConservee
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */