package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.fabriques;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StrategieAppliquerISLRApresMep15SI1;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StrategieAppliquerISLRAvantMep15SI1;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieAppliquerISLRSpec;
import fr.unedic.cali.fabriques.FabriqueStrategieSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;

public class FabriqueStrategieAppliquerISLR
  implements FabriqueStrategieSpec
{
  private static final Damj DATE_MEP_15SI1 = new Damj(2015, 4, 1);
  private static FabriqueStrategieAppliquerISLR instance = new FabriqueStrategieAppliquerISLR();
  
  public static FabriqueStrategieAppliquerISLR getInstance()
  {
    return instance;
  }
  
  public StrategieSpec getStrategie(CritereStrategie critereStrategie)
    throws CoucheLogiqueException
  {
    StrategieAppliquerISLRSpec strategie = null;
    Damj dateFct = critereStrategie.getDatePivot();
    if (dateFct == null) {
      throw new UnsupportedOperationException("FabriqueStrategieAppliquerISLR : date pivot nulle.");
    }
    if (recupererDateApplication().estApres(dateFct)) {
      strategie = new StrategieAppliquerISLRAvantMep15SI1();
    } else {
      strategie = new StrategieAppliquerISLRApresMep15SI1();
    }
    return strategie;
  }
  
  public Damj recupererDateApplication()
  {
    return DATE_MEP_15SI1;
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieAppliquerISLR
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */