package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.fabriques;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.spec.FabriqueStrategieDeterminationDiviseurSjrSpec;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.CriteresStrategieDeterminationDiviseurSjr;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StrategieDeterminationDiviseurSjrA3;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StrategieDeterminationDiviseurSjrA4;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StrategieDeterminationDiviseurSjrA5;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.StrategieDeterminationDiviseurSjrCasGeneral;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieDeterminationDiviseurSjrCasGeneralSpec;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieDeterminationDiviseurSjrSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.dom.conteneurs.spec.DonneesEntreeDemandeDeterminationSjrSpec;
import fr.unedic.cali.dom.conteneurs.spec.DonneesEntreeDeterminationSjrSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import java.util.ArrayList;
import java.util.Collection;

public class FabriqueStrategieDeterminationDiviseurSjr
  implements FabriqueStrategieDeterminationDiviseurSjrSpec
{
  private static FabriqueStrategieDeterminationDiviseurSjr instance = new FabriqueStrategieDeterminationDiviseurSjr();
  
  public static FabriqueStrategieDeterminationDiviseurSjr getInstance()
  {
    return instance;
  }
  
  public StrategieDeterminationDiviseurSjrCasGeneralSpec getStrategieCasGeneral()
    throws CoucheLogiqueException
  {
    return new StrategieDeterminationDiviseurSjrCasGeneral();
  }
  
  public StrategieSpec getStrategie(CritereStrategie critereStrategie)
    throws CoucheLogiqueException
  {
    StrategieDeterminationDiviseurSjrSpec strategie = null;
    
    DonneesEntreeDeterminationSjrSpec donneesEntree = ((CriteresStrategieDeterminationDiviseurSjr)critereStrategie).getDonneesEntreeDeterminationSjr();
    
    Reglement reglementApplicable = donneesEntree.getDonneesEntreeDemande().getReglementApplicable();
    if (reglementApplicable == null) {
      throw new UnsupportedOperationException("FabriqueStrategieDeterminationDiviseurSjr : pas de règlement applicable.");
    }
    boolean estPrimoDemandeurA3A4A5 = donneesEntree.getDonneesEntreeDemande().isPrimoDemandeurA3A4A5();
    if ((estReglementPourCasGeneral(reglementApplicable.getNomReglement())) || (estPrimoDemandeurA3A4A5)) {
      strategie = getStrategieCasGeneral();
    } else if (reglementApplicable.estNomReglementIdentique("A3")) {
      strategie = new StrategieDeterminationDiviseurSjrA3();
    } else if (reglementApplicable.estNomReglementIdentique("A4")) {
      strategie = new StrategieDeterminationDiviseurSjrA4();
    } else if (reglementApplicable.estNomReglementIdentique("A5")) {
      strategie = new StrategieDeterminationDiviseurSjrA5();
    }
    return strategie;
  }
  
  private boolean estReglementPourCasGeneral(String reglement)
  {
    Collection<String> listeReglements = new ArrayList();
    
    listeReglements.add("A8");
    listeReglements.add("A10");
    listeReglements.add("RG");
    listeReglements.add("OP");
    listeReglements.add("A1");
    listeReglements.add("A2a");
    listeReglements.add("A6");
    listeReglements.add("A9A");
    listeReglements.add("A9B");
    
    return listeReglements.contains(reglement);
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieDeterminationDiviseurSjr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */