package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieAppliquerISLRSpec;
import fr.unedic.cali.dom.ObjetChronoPeriodeIndemnisationConcret;
import fr.unedic.cali.dom.affectation.LigneAsuCge01;
import fr.unedic.cali.dom.affectation.LigneAsuCsa06;
import fr.unedic.cali.dom.affectation.LigneAsuExp03;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P02;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P03;
import fr.unedic.cali.dom.affectation.ProduitAsuCsa06P01;
import fr.unedic.cali.dom.affectation.ProduitAsuCsa06P02;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;

public class StrategieAppliquerISLRApresMep15SI1
  implements StrategieAppliquerISLRSpec
{
  public boolean doitAppliquerISLR(ChronologiePeriodes chronologie, Damj dateFct)
  {
    boolean applicationISLR = true;
    chronologie.iterer();
    while (chronologie.encoreSuivant())
    {
      ObjetChronoPeriodeIndemnisationConcret periode = (ObjetChronoPeriodeIndemnisationConcret)chronologie.elementSuivant();
      if ((dateFct.estApresOuCoincideAvec(periode.getDateDebut())) && (dateFct.estAvantOuCoincideAvec(periode.getDateFin()))) {
        if (produitPrisEnCompteParCalcul(periode.getProduitAssociePeriode())) {
          applicationISLR = false;
        }
      }
    }
    return applicationISLR;
  }
  
  private boolean produitPrisEnCompteParCalcul(ProduitSpec produit)
  {
    boolean produitPrisEnCompteParCalcul = false;
    if ((produit.getLigne().equals(LigneAsuCge01.getInstance())) || (produit.getLigne().equals(LigneAsuCsa06.getInstance())) || (produit.getLigne().equals(LigneAsuExp03.getInstance())))
    {
      produitPrisEnCompteParCalcul = true;
      if ((produit.equals(ProduitAsuCge01P02.getInstance())) || (produit.equals(ProduitAsuCge01P03.getInstance())) || (produit.equals(ProduitAsuCsa06P01.getInstance())) || (produit.equals(ProduitAsuCsa06P02.getInstance()))) {
        produitPrisEnCompteParCalcul = false;
      }
    }
    return produitPrisEnCompteParCalcul;
  }
}

/* Location:
 * Qualified Name:     StrategieAppliquerISLRApresMep15SI1
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */