package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.competence.DeterminationCompetenceCge;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.competence.OutilDeterminationCompetence;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieConventionGestionPESpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.dom.ResultatDeterminationCompetence;
import fr.unedic.cali.dom.ConventionGestion;
import fr.unedic.util.services.CoucheLogiqueException;

public class StrategieConventionGestionPEApres
  implements StrategieConventionGestionPESpec
{
  public void verifierConventionGestionPoleEmploiForcee(ResultatDeterminationCompetence resultatDeterminationCompetence, Demande demande)
    throws CoucheLogiqueException
  {
    if ("556".equals(resultatDeterminationCompetence.getNumeroConventionGestion()))
    {
      String numeroConventionPEForce = demande.getDonneesTemporaires().getNumeroConventionPE();
      if (numeroConventionPEForce == null)
      {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ERR_CONVENTION_GESTION_PE_A_FORCER");
      }
      else
      {
        ConventionGestion conventionGestionEnrichie = DeterminationCompetenceCge.getInstance().determinerConventionGestionEnrichie(demande, null);
        
        OutilDeterminationCompetence.alimenterConventionGestion(resultatDeterminationCompetence, conventionGestionEnrichie);
      }
    }
  }
}

/* Location:
 * Qualified Name:     StrategieConventionGestionPEApres
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */