package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.FormuleDiffereICCPConservatoireBatiment;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.FormuleDiffereICCPMontantApresARE14;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.FormuleDiffereICCPTemps;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.spec.FormuleDelaiReportSpec;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieFormuleICCPSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.BaseDelaiReport;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.QuantiteJourTravailDansSemaineSpec;
import java.math.BigDecimal;

public class StrategieIccpApresMajPriorisation
  implements StrategieFormuleICCPSpec
{
  public FormuleDelaiReportSpec getFormuleICCP(BaseDelaiReport baseDelaiReport)
  {
    FormuleDelaiReportSpec formuleDelaiReportRetour = null;
    QuantiteJourTravailDansSemaineSpec jours = baseDelaiReport.getQuantiteJourIccp();
    QuantiteEuro montant = baseDelaiReport.getQuantiteEuroIccp();
    
    boolean presenceJours = (jours != null) && (jours.getNombreJours() > 0);
    boolean presenceMontant = (montant != null) && (montant.getValeurMontant().compareTo(BigDecimal.ZERO) > 0);
    if ((!baseDelaiReport.estMontantIccpProratise()) && (presenceJours)) {
      formuleDelaiReportRetour = new FormuleDiffereICCPTemps();
    } else if (((!baseDelaiReport.estMontantIccpProratise()) || (!presenceJours)) && (presenceMontant)) {
      formuleDelaiReportRetour = new FormuleDiffereICCPMontantApresARE14();
    } else if ((!presenceJours) && (baseDelaiReport.isIccpConservatoireAutoriseBatiment()) && (!estUneRepriseSimplifiee(baseDelaiReport))) {
      formuleDelaiReportRetour = new FormuleDiffereICCPConservatoireBatiment();
    }
    return formuleDelaiReportRetour;
  }
  
  protected boolean estUneRepriseSimplifiee(BaseDelaiReport baseDelaiReport)
  {
    return 34 == baseDelaiReport.getSousTypeObjectif();
  }
}

/* Location:
 * Qualified Name:     StrategieIccpApresMajPriorisation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */