package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies;

import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;

public class StrategieMontantICCP2009D007DReglementApplicableA4Apres09SI2
  extends StrategieMontantICCP
{
  public QuantiteEuro determinerMontantICCPRuptureA4(ActiviteSalarie activiteSalarie, ChronologiePeriodes chronoPeriodesIndemnisation)
  {
    QuantiteEuro quantiteEuroICCPRetournee = null;
    
    Periode periodeFct = new Periode(activiteSalarie.getDateFin(), activiteSalarie.getDateFin());
    if (periodeFct.inter(chronoPeriodesIndemnisation) == 0)
    {
      QuantiteEuro quantiteEuroICCPRupture = recupererQuantiteEuroICCPSurFCT(activiteSalarie);
      if ((quantiteEuroICCPRupture != null) && (quantiteEuroICCPRupture.getValeurMontant().compareTo(BigDecimal.ZERO) > 0))
      {
        BigDecimal montantICCPRuptureProratise = determinerMontantRuptureICCPProratiseHorsPeriodesIndemnisation(quantiteEuroICCPRupture.getValeurMontant(), activiteSalarie, chronoPeriodesIndemnisation);
        if (montantICCPRuptureProratise != null) {
          quantiteEuroICCPRetournee = new QuantiteEuro(montantICCPRuptureProratise);
        }
      }
    }
    return quantiteEuroICCPRetournee;
  }
}

/* Location:
 * Qualified Name:     StrategieMontantICCP2009D007DReglementApplicableA4Apres09SI2
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */