package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.temps.ChronologiePeriodes;
import java.math.BigDecimal;

public class StrategieMontantICCPA5Avant09SI2
  extends StrategieMontantICCP
{
  public QuantiteEuro determinerMontantICCP(DemandeAssuranceSpec demande, ActiviteSalarie activiteSalarie, ChronologiePeriodes chronoPeriodesIndemnisation)
    throws ApplicativeException
  {
    QuantiteEuro quantiteEuroICCPRetour = null;
    BigDecimal montantICCPRetour = null;
    
    QuantiteEuro quantiteEuroICCPRupture = recupererQuantiteEuroICCPSurFCT(activiteSalarie);
    if ((quantiteEuroICCPRupture != null) && (quantiteEuroICCPRupture.getValeurMontant().compareTo(BigDecimal.ZERO) > 0)) {
      montantICCPRetour = determinerMontantRuptureICCPProratiseHorsPeriodesIndemnisation(quantiteEuroICCPRupture.getValeurMontant(), activiteSalarie, chronoPeriodesIndemnisation);
    } else {
      montantICCPRetour = determinerMontantICCPMajorationRemuneration(activiteSalarie, ((Demande)demande).getDateFaitGenerateurOuDernierSinistrePourCarences(), chronoPeriodesIndemnisation);
    }
    if (montantICCPRetour != null) {
      quantiteEuroICCPRetour = new QuantiteEuro(montantICCPRetour);
    }
    return quantiteEuroICCPRetour;
  }
}

/* Location:
 * Qualified Name:     StrategieMontantICCPA5Avant09SI2
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */