package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.Salaire;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.temps.ChronologiePeriodes;
import java.math.BigDecimal;

public class StrategieMontantICCPCasGeneralApres09SI2SansMajorationRemuneration
  extends StrategieMontantICCP
{
  public QuantiteEuro determinerMontantICCP(DemandeAssuranceSpec demande, ActiviteSalarie activiteSalarie, ChronologiePeriodes chronoPeriodesIndemnisation)
    throws ApplicativeException
  {
    QuantiteEuro quantiteEuroIccpRetournee = null;
    
    quantiteEuroIccpRetournee = recupererQuantiteEuroICCPSurFCT(activiteSalarie);
    if (quantiteEuroIccpRetournee == null)
    {
      Salaire salaireChevauchantFCT = recupererSalaireChevauchantFCT(activiteSalarie);
      if (salaireChevauchantFCT != null)
      {
        BigDecimal montantICCPSalaireChevauchantFCT = salaireChevauchantFCT.determinerMontantIccp();
        if (montantICCPSalaireChevauchantFCT != null) {
          quantiteEuroIccpRetournee = new QuantiteEuro(montantICCPSalaireChevauchantFCT);
        }
      }
    }
    if ((quantiteEuroIccpRetournee != null) && (quantiteEuroIccpRetournee.getValeur().compareTo(BigDecimal.ZERO) > 0)) {
      activiteSalarie.setPresenceMontantICCPAvantProratisation(true);
    }
    return quantiteEuroIccpRetournee;
  }
}

/* Location:
 * Qualified Name:     StrategieMontantICCPCasGeneralApres09SI2SansMajorationRemuneration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */