package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategiePriseEnCompteMontantCarencesSurActiviteConserveeSpec;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.utilitaire.filtres.composites.FiltreAttributionStandardAssurance;
import fr.unedic.cali.utilitaire.filtres.logiques.FiltreET;
import fr.unedic.cali.utilitaire.filtres.metiers.FiltreAttributionEnCoursIndemnisationPourDate;
import fr.unedic.cali.utilitaire.outils.OutilRecherche;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;

public class StrategiePriseEnCompteMontantCarencesSurActiviteConserveeApres
  implements StrategiePriseEnCompteMontantCarencesSurActiviteConserveeSpec
{
  public boolean estUneActiviteConservee(ActiviteSalarie activiteSalariee, IndividuSpec individu)
  {
    boolean estUneActiviteConservee = false;
    
    FiltreET filtreAttributionAssurancesEnCours = new FiltreET();
    filtreAttributionAssurancesEnCours.ajouterFiltre(new FiltreAttributionStandardAssurance(true, true, false, false, null));
    filtreAttributionAssurancesEnCours.ajouterFiltre(new FiltreAttributionEnCoursIndemnisationPourDate(activiteSalariee.getDateFin()));
    
    AttributionAssuranceSpec attributionAssuranceEnCours = (AttributionAssuranceSpec)OutilRecherche.rechercherDecisionPrecedente(individu.getChronoDemandeAssurance(), activiteSalariee.getDateFin(), filtreAttributionAssurancesEnCours);
    if ((attributionAssuranceEnCours != null) && (attributionAssuranceEnCours.getListeActiviteConservee() != null)) {
      estUneActiviteConservee = attributionAssuranceEnCours.getListeActiviteConservee().contientElement(activiteSalariee);
    }
    return estUneActiviteConservee;
  }
  
  public ChronologiePeriodes formaterPeriodesIndemnisation(ChronologiePeriodes periodesIndemnisation, boolean formater)
  {
    ChronologiePeriodes retour;
    ChronologiePeriodes retour;
    if (formater) {
      retour = new ChronologiePeriodes();
    } else {
      retour = periodesIndemnisation;
    }
    return retour;
  }
}

/* Location:
 * Qualified Name:     StrategiePriseEnCompteMontantCarencesSurActiviteConserveeApres
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */