package fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.RechercheQuantiteAppartenance;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieQuantiteAffiliationSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.outilsfonctionnels.GestionDemandeDv122eJour;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionQuantiteAffiliation;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.affectation.Reglement;

public class StrategieQuantiteAffiliationDemandeASUPassageCPSuiteRejetDV
  implements StrategieQuantiteAffiliationSpec
{
  public ConstitutionQuantiteAffiliation determinerQuantiteAffiliation(Demande p_demande)
    throws ApplicativeException
  {
    Demande demandeRejetDv = GestionDemandeDv122eJour.retrouverDemandePortantDv(p_demande);
    DossierExamen dossierExamenCourant = (DossierExamen)p_demande.getDossierAffectation().getDossierExamen();
    if (demandeRejetDv != null)
    {
      ConstitutionQuantiteAffiliation cepQuantiteAffiliation = dossierExamenCourant.createConstitutionQuantiteAffiliation();
      
      ReglementApplicableSpec reglement = dossierExamenCourant.getReglementApplicable();
      if (demandeRejetDv.getDonneesTemporaires() != null)
      {
        if (demandeRejetDv.getDonneesTemporaires().getQuantiteAffiliation() != null) {
          p_demande.getDonneesTemporaires().setQuantiteAffiliation(demandeRejetDv.getDonneesTemporaires().getQuantiteAffiliation());
        }
        if (demandeRejetDv.getDonneesTemporaires().getIdentifiantPeriodeFctARetenir() != null) {
          p_demande.getDonneesTemporaires().setIdentifiantPeriodeFctARetenir(demandeRejetDv.getDonneesTemporaires().getIdentifiantPeriodeFctARetenir());
        }
      }
      cepQuantiteAffiliation = RechercheQuantiteAppartenance.getInstance().rechercher(p_demande, false);
      if (demandeRejetDv.getDonneesTemporaires() != null)
      {
        p_demande.getDonneesTemporaires().setQuantiteAffiliation(null);
        p_demande.getDonneesTemporaires().setIdentifiantPeriodeFctARetenir(null);
      }
      if ((reglement.getReglement().getLibelleCourt().equals("A9A")) || (reglement.getReglement().getLibelleCourt().equals("A9B"))) {
        if (cepQuantiteAffiliation == null) {
          fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_DEMANDE_DV_MIGREE_AFFI_NULLE");
        }
      }
      if ((demandeRejetDv.estMigree()) && (cepQuantiteAffiliation == null)) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_DEMANDE_DV_MIGREE_AFFI_NULLE", new Object[] { demandeRejetDv.getDateExamen() });
      }
      if (cepQuantiteAffiliation == null) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_DEMANDE_DV_MIGREE_AFFI_NULLE", new Object[] { demandeRejetDv.getDateExamen() });
      }
      return cepQuantiteAffiliation;
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     StrategieQuantiteAffiliationDemandeASUPassageCPSuiteRejetDV
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */