package fr.unedic.cali.asu.cge01.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.DeterminationDateAttributionCsr;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsSpec;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Damj;

public class ConstitutionDateAttributionCsr
  extends fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionDateAttribution
{
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCEPA14 = new Resultat();
    
    Demande demande = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demande.getDossierExamen();
    fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionDateAttribution constitutionDate = dossierExamenCourant.getConstitutionElementsActifs().createConstitutionDateAttribution();
    if (verifierPreconditions(p_contexte))
    {
      Damj dateAttribution = DeterminationDateAttributionCsr.getInstance().determinerDateAttributionTheoriquePourAdmissionCsr(demande);
      
      constitutionDate.setDateAttribution(dateAttribution);
    }
    OutilTrace.tracerFinParcours();
    
    return resultatCEPA14;
  }
}

/* Location:
 * Qualified Name:     ConstitutionDateAttributionCsr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */