package fr.unedic.cali.asu.cge01.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.OutilDelaiReport;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.OutilDeterminationDelaisReports;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.CarencePrefixeAFixer;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionDelais;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.util.services.Contexte;
import java.util.Collection;
import java.util.Iterator;

public class ConstitutionDelaisReportsRepriseCsr
  extends ConstitutionDelaisReportsReprise
{
  protected Collection determinerCollectionReliquatDelaisReport(Contexte contexte, Collection collectionDelaisReportsRetour)
    throws ApplicativeException
  {
    Collection collectionDelaisReportsEffectifsDroitPrecedent = trouverCollectionDelaisReportsEffectifsDroitPrecedent(contexte);
    Demande demande = DomLiquidationAssurance.getDemande(contexte);
    
    Collection delaisReportReliquat = OutilDeterminationDelaisReports.determinerCollectionDelaisReportsReliquats(demande, collectionDelaisReportsEffectifsDroitPrecedent);
    Iterator i;
    if (delaisReportReliquat != null) {
      for (i = delaisReportReliquat.iterator(); i.hasNext();)
      {
        CarencePrefixeAFixer delaiReportCourant = (CarencePrefixeAFixer)i.next();
        OutilDelaiReport.ajouterDelaiReportDansCollection(collectionDelaisReportsRetour, (CarencePrefixeAFixer)delaiReportCourant.copie());
      }
    }
    return collectionDelaisReportsRetour;
  }
  
  protected Collection determinerCollectionDelaisReportCourant(Contexte contexte, Collection collectionDelaisReportsRetour)
    throws ApplicativeException
  {
    ParcoursDeterminationDelaisReportsCsr parcoursDeterminationDelaisReports = new ParcoursDeterminationDelaisReportsCsr();
    ResultatDeterminationDelaisReports resultatDeterminationDelaisReports = (ResultatDeterminationDelaisReports)parcoursDeterminationDelaisReports.effectuerParcours(contexte);
    
    Collection collectionDelaisReports = resultatDeterminationDelaisReports.getListeDelaisReports();
    Iterator i;
    if (collectionDelaisReports != null) {
      for (i = collectionDelaisReports.iterator(); i.hasNext();)
      {
        CarencePrefixeAFixer delaiReportCourant = (CarencePrefixeAFixer)i.next();
        OutilDelaiReport.ajouterDelaiReportDansCollection(collectionDelaisReportsRetour, delaiReportCourant);
      }
    }
    return collectionDelaisReportsRetour;
  }
  
  protected void appelCalcul(Demande demande, DossierExamen dossierExamenCourant, ConstitutionDelais constitutionDelais)
    throws ApplicativeException
  {}
}

/* Location:
 * Qualified Name:     ConstitutionDelaisReportsRepriseCsr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */