package fr.unedic.cali.asu.cge01.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.OutilDelaiReport;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.OutilDeterminationDelaisReports;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.CarencePrefixeAFixer;
import fr.unedic.cali.parcours.ResultatExecutionCalculSpec;
import fr.unedic.util.services.Contexte;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public class ConstitutionDelaisReportsRevision
  extends ConstitutionDelaisReportsAbstrait
{
  protected ResultatDeterminationDelaisReports determinerCollectionDelaisReports(Contexte contexte)
    throws ApplicativeException
  {
    Collection collectionDelaisReportsRetour = new ArrayList();
    
    Demande demande = DomLiquidationAssurance.getDemande(contexte);
    
    Collection collectionDelaisReportsEffectifsDroitPrecedent = ((DomLiquidationAssurance)contexte.getDonnees()).getResultatExecutionCalculDroitPrecedent().getListeCarencesEffectives();
    
    Collection collectionDelaisReportsReliquats = OutilDeterminationDelaisReports.determinerCollectionDelaisReportsReliquats(demande, collectionDelaisReportsEffectifsDroitPrecedent);
    Iterator i;
    if (collectionDelaisReportsReliquats != null) {
      for (i = collectionDelaisReportsReliquats.iterator(); i.hasNext();)
      {
        CarencePrefixeAFixer delaiReportCourant = (CarencePrefixeAFixer)i.next();
        OutilDelaiReport.ajouterDelaiReportDansCollection(collectionDelaisReportsRetour, delaiReportCourant);
      }
    }
    ResultatDeterminationDelaisReports resultat = new ResultatDeterminationDelaisReports();
    resultat.getListeDelaisReports().addAll(collectionDelaisReportsRetour);
    return resultat;
  }
}

/* Location:
 * Qualified Name:     ConstitutionDelaisReportsRevision
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */