package fr.unedic.cali.asu.cge01.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.liquidation.parcours.fabrique.FabriqueParcoursConstitutionProduitResultantFinDroit;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.JustificationDroitResultant;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Parcours;
import fr.unedic.util.services.Resultat;

public class ConstitutionProduitResultantFinDroit
  extends ConstitutionProduitResultant
{
  public Resultat demarrer(Contexte p_contexte)
    throws CoucheLogiqueException, ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCEPA15 = new Resultat(0);
    
    Demande demandeCourante = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demandeCourante.getDossierExamen();
    
    dossierExamenCourant.createConstitutionProduitResultant();
    if (verifierPreconditions(p_contexte))
    {
      alimentationCapitalDroitCourant(demandeCourante);
      
      Parcours parcours = getParcours(getContexteExamen(p_contexte), demandeCourante);
      if (parcours != null)
      {
        JustificationDroitResultant justif = new JustificationDroitResultant();
        dossierExamenCourant.getConstitutionProduitResultant().setJustificationDroitResultant(justif);
        
        parcours.effectuerParcours(p_contexte);
      }
    }
    OutilTrace.tracerFinParcours();
    
    return resultatCEPA15;
  }
  
  protected Parcours getParcours(int p_contexteExamen, Demande p_demandeCourante)
    throws ApplicativeException
  {
    return FabriqueParcoursConstitutionProduitResultantFinDroit.getParcoursProduitResultant(p_contexteExamen, p_demandeCourante);
  }
}

/* Location:
 * Qualified Name:     ConstitutionProduitResultantFinDroit
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */