package fr.unedic.cali.asu.cge01.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.liquidation.parcours.conteneurs.ConteneurParcoursRevisionAutomatique;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.outilsfonctionnels.OutilAsr;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsActiviteConserve;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.FiltreFinAvantOuCoincideAvecDate;

public class ConstitutionRevisionAutomatiqueFinAsr
  extends ConstitutionRevisionAutomatiqueFinDroit
{
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    Demande demandeCourante = DomLiquidationAssurance.getDemande(p_contexte);
    Attribution attributionFinAsr = (Attribution)demandeCourante.getDossierExamen();
    Demande demandeAsr = OutilAsr.getDemandeAsrPrecedente(demandeCourante, demandeCourante.getDateRecherche());
    ConteneurParcoursRevisionAutomatique conteneur = new ConteneurParcoursRevisionAutomatique();
    conteneur.setDemandeCourante(demandeCourante);
    conteneur.setAttributionAReviser(attributionFinAsr);
    conteneur.setDemandeOrigine(demandeAsr);
    return demarrerParcours(conteneur);
  }
  
  protected Chronologie trouverChronoActiviteAReviser(Demande p_demandeCourante)
    throws ApplicativeException
  {
    Chronologie resultat = OutilsActiviteConserve.getListeActiviteConserveesPerduesHorsDv(p_demandeCourante);
    return resultat.copier(new FiltreFinAvantOuCoincideAvecDate(p_demandeCourante.getDossierExamen().getDateAttribution().veille()));
  }
}

/* Location:
 * Qualified Name:     ConstitutionRevisionAutomatiqueFinAsr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */