package fr.unedic.cali.asu.cge01.liquidation.parcours;

import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.competence.DeterminationCompetenceCge;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.competence.DeterminationCompetenceProduitResultant;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.competence.OutilDeterminationCompetence;
import fr.unedic.cali.asu.dom.CompetenceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierExamenAssuranceSpec;
import fr.unedic.cali.asu.dom.ResultatDeterminationCompetence;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;

public class DeterminationCompetencesProduitResultant
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte contexte)
    throws CoucheLogiqueException
  {
    OutilTrace.tracerDebutParcours();
    
    Demande demandeCourante = DomLiquidationAssurance.getDemande(contexte);
    DossierExamenAssuranceSpec dossierExamen = (DossierExamenAssuranceSpec)demandeCourante.getDossierExamen();
    CompetenceSpec competence = dossierExamen.getCompetence();
    ResultatDeterminationCompetence resultatDeterminationCompetence = new ResultatDeterminationCompetence();
    
    OutilDeterminationCompetence.mapperCompetenceSurResultat(competence, resultatDeterminationCompetence);
    DeterminationCompetenceCge.getInstance().determinerCompetenceFinanciere(demandeCourante, resultatDeterminationCompetence);
    
    DeterminationCompetenceProduitResultant.getInstance().determinerCompetenceAdministrativeProduitResultant(demandeCourante, resultatDeterminationCompetence);
    
    OutilDeterminationCompetence.mapperResultatSurCompetence(resultatDeterminationCompetence, competence);
    
    OutilTrace.tracerFinParcours();
    
    return new Resultat();
  }
  
  public void controlerContexte(Contexte contexte)
    throws ContexteException
  {
    if (DomLiquidationAssurance.getDemande(contexte) == null) {
      throw new ContexteException("HG_PR_CALI_L_CONTEXTE_ABSENCE_DEMANDE_ASSURANCE", "Une demande est obligatoire pour ce produit. : DeterminationCompetenceAdministrative impossible");
    }
    if (DomLiquidationAssurance.getDemande(contexte).getDemandeur() == null) {
      throw new ContexteException("HG_PR_CALI_L_ERR_CTX_ABS_DEMANDEUR", "Absence individu demandeur sur la demande : DeterminationCompetenceAdministrative impossible");
    }
    if (DomLiquidationAssurance.getDemande(contexte).getDossierExamen() == null) {
      throw new ContexteException("ASU_PR_CALI_L_CONTEXTE_ABSENCE_DOSSIER_EXAMEN", "Le dossier examen est null: DeterminationCompetenceAdministrative impossible");
    }
  }
}

/* Location:
 * Qualified Name:     DeterminationCompetencesProduitResultant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */