package fr.unedic.cali.asu.cge01.liquidation.parcours;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.RechercheConditionFaitGenerateur;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.ConditionFaitGenerateur;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;

public class DeterminationConditionFaitGenerateurCsr
  extends DeterminationConditionFaitGenerateur
{
  public Resultat demarrer(Contexte p_contexte)
    throws CoucheLogiqueException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCAPA04 = super.demarrer(p_contexte);
    Demande demande = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demande.getDossierExamen();
    ConditionFaitGenerateur faitGenerateur = (ConditionFaitGenerateur)dossierExamenCourant.getConditionFaitGenerateur();
    if (faitGenerateur.estSatisfait())
    {
      ResultatElementDroit resultatElementDroit = RechercheConditionFaitGenerateur.getInstance().rechercheConditionFaitGenerateurCsr(demande);
      faitGenerateur.setEtatSatisfait(resultatElementDroit.estSatisfait());
      faitGenerateur.setCodeMotifEchec(resultatElementDroit.getCodeMotifEchec());
    }
    OutilTrace.tracerFinParcours();
    
    return resultatCAPA04;
  }
}

/* Location:
 * Qualified Name:     DeterminationConditionFaitGenerateurCsr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */