package fr.unedic.cali.asu.cge01.liquidation.parcours.novation;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionSjc;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.SjcipSpec;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.novation.OutilConstitutionSjc;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;

public class ParcoursConstitutionSjc
  extends ParcoursCali
{
  public Resultat demarrer(Contexte contexte)
    throws ApplicativeException
  {
    Demande demande = DomLiquidationAssurance.getDemande(contexte);
    Attribution attributionAssurance = (Attribution)demande.getAttribution();
    
    ConstitutionSjc constitutionSjc = attributionAssurance.getConstitutionElementsActifs().getConstitutionSjc();
    if (constitutionSjc == null) {
      constitutionSjc = attributionAssurance.getConstitutionElementsActifs().createConstitutionSjc();
    }
    SjcipSpec sjcip = constitutionSjc.getSjcip();
    if (sjcip == null) {
      sjcip = constitutionSjc.createSjcip();
    }
    OutilConstitutionSjc.alimenterSjcPourReprise(attributionAssurance, constitutionSjc, sjcip, (ProduitAsuSpec)attributionAssurance.getProduit());
    
    return new Resultat();
  }
}

/* Location:
 * Qualified Name:     ParcoursConstitutionSjc
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */