package fr.unedic.cali.asu.cge01.liquidation.parcours.novation;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionSjr;
import fr.unedic.cali.asu.produits.liquidation.dom.Sjrip;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsSpec;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.novation.OutilConstitutionSjr;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;

public class ParcoursConstitutionSjr
  extends ParcoursCali
{
  public Resultat demarrer(Contexte contexte)
    throws ApplicativeException
  {
    Demande demande = DomLiquidationAssurance.getDemande(contexte);
    Attribution attributionAssurance = (Attribution)demande.getAttribution();
    
    ConstitutionSjr constitutionSjr = attributionAssurance.getConstitutionElementsActifs().getConstitutionSjr();
    if (constitutionSjr == null) {
      constitutionSjr = attributionAssurance.getConstitutionElementsActifs().createConstitutionSjr();
    }
    Sjrip sjrip = constitutionSjr.getSjrip();
    if (sjrip == null) {
      sjrip = constitutionSjr.createSjrip();
    }
    OutilConstitutionSjr.alimenterSjr(constitutionSjr, (ProduitAsuSpec)attributionAssurance.getProduit(), attributionAssurance);
    
    return new Resultat();
  }
}

/* Location:
 * Qualified Name:     ParcoursConstitutionSjr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */