package fr.unedic.cali.asu.cge01.p02.liquidation.dom;

import fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen.ConditionQuantiteAffiliationGen;
import fr.unedic.cali.asu.dom.ConditionQuantiteAffiliationSpec;
import fr.unedic.cali.asu.dom.JustificationAffiliationSpec;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.UniteAffiliation;

public class ConditionQuantiteAffiliation
  extends ConditionQuantiteAffiliationGen
  implements ConditionQuantiteAffiliationSpec
{
  private static final long serialVersionUID = 8988860070592094684L;
  private transient JustificationAffiliationSpec m_justificationAffiliation;
  
  public ConditionQuantiteAffiliation() {}
  
  public ConditionQuantiteAffiliation(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public ResultatElementDroit getResultatElementDroit()
  {
    if (super.getResultatElementDroit() == null) {
      super.setResultatElementDroit(new ResultatElementDroit());
    }
    return super.getResultatElementDroit();
  }
  
  public void jdoPreDelete() {}
  
  public void marquerGraphePersistant() {}
  
  public boolean estSatisfait()
  {
    return getResultatElementDroit().estSatisfait();
  }
  
  public int getCodeMotifEchec()
  {
    return getResultatElementDroit().getCodeMotifEchec();
  }
  
  public void setCodeMotifEchec(int p_codeMotifEchec)
  {
    getResultatElementDroit().setCodeMotifEchec(p_codeMotifEchec);
  }
  
  public void setEtatSatisfait(boolean p_etatSatisfait)
  {
    getResultatElementDroit().setEtatSatisfait(p_etatSatisfait);
  }
  
  public Quantite getQuantiteAppartenance()
  {
    if (super.getQuantiteAppartenance() == null) {
      super.setQuantiteAppartenance(new Quantite("0", UniteAffiliation.JOUR));
    }
    return super.getQuantiteAppartenance();
  }
  
  public ObjetMetierSpec copie()
  {
    ConditionQuantiteAffiliation copie = new ConditionQuantiteAffiliation();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ConditionQuantiteAffiliation copie = (ConditionQuantiteAffiliation)p_copie;
    copie.setCodeMotifEchec(getCodeMotifEchec());
    copie.setQuantiteAppartenance(getQuantiteAppartenance());
    copie.setEtat(getEtat());
    
    copie.setJustificationAffiliation(getJustificationAffiliation());
    copie.setQuantiteAppartenanceSecondaire(getQuantiteAppartenanceSecondaire());
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public void jdoPostLoad() {}
  
  public void jdoPreClear() {}
  
  public void jdoPreStore() {}
  
  public void setEtat(int p_etat)
  {
    getResultatElementDroit().setEtat(p_etat);
  }
  
  public int getEtat()
  {
    return getResultatElementDroit().getEtat();
  }
  
  public JustificationAffiliationSpec getJustificationAffiliation()
  {
    return m_justificationAffiliation;
  }
  
  public void setJustificationAffiliation(JustificationAffiliationSpec p_justificationAffiliation)
  {
    m_justificationAffiliation = p_justificationAffiliation;
  }
  
  public String getEtatPndsPourCalculAffi()
  {
    return null;
  }
}

/* Location:
 * Qualified Name:     ConditionQuantiteAffiliation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */