package fr.unedic.cali.asu.cge01.p02.liquidation.dom;

import fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen.ConstitutionReglementApplicableGen;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.dom.affectation.Parametres;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public class ConstitutionReglementApplicable
  extends ConstitutionReglementApplicableGen
  implements ReglementApplicableSpec
{
  private static final long serialVersionUID = -8444972091499238808L;
  private transient Reglement m_reglement;
  
  public ConstitutionReglementApplicable() {}
  
  public ConstitutionReglementApplicable(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public Reglement getReglement()
  {
    if (m_reglement == null) {
      m_reglement = Parametres.getReglement(super.getNomReglement(), Parametres.getProduit(super.getCodeProduit()));
    }
    return m_reglement;
  }
  
  public void setReglement(Reglement p_reglement)
  {
    m_reglement = p_reglement;
    super.setNomReglement(p_reglement.getNomReglement());
    super.setCodeProduit(p_reglement.getProduit().getCode());
  }
  
  public String toString()
  {
    StringBuffer sb = new StringBuffer();
    sb.append(getReglement());
    return sb.toString();
  }
  
  public void jdoPostLoad() {}
  
  public void jdoPreClear() {}
  
  public void jdoPreDelete() {}
  
  public void marquerGraphePersistant() {}
  
  public void jdoPreStore() {}
  
  public ObjetMetierSpec copie()
  {
    ConstitutionReglementApplicable copie = new ConstitutionReglementApplicable();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ConstitutionReglementApplicable copie = (ConstitutionReglementApplicable)p_copie;
    
    copie.setReglement(getReglement());
  }
}

/* Location:
 * Qualified Name:     ConstitutionReglementApplicable
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */