package fr.unedic.cali.asu.cge01.p02.liquidation.dom;

import fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen.DiffereGen;
import fr.unedic.cali.asu.dom.DiffereSpec;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import org.apache.commons.lang.builder.EqualsBuilder;

public class Differe
  extends DiffereGen
  implements ObjetPersistantSpec, DiffereSpec
{
  private static final long serialVersionUID = -8835990069037774017L;
  public static final int DIFFERE_7_JOURS = 7;
  public static final Unite UNITE_DEFAUT = Unite.get("jour");
  
  public Differe() {}
  
  public Differe(DomPCSpec pc)
  {
    super(pc);
  }
  
  public Differe(int jours)
  {
    setQuantiteInitial(new Quantite(new BigDecimal(Integer.toString(jours)), UNITE_DEFAUT));
  }
  
  public DureeCalendaire getDureeCalendaireReport()
  {
    return new DureeCalendaire(0, 0, getQuantiteInitialJour());
  }
  
  public int getQuantiteInitialJour()
  {
    return getQuantiteInitial().getValeurEntiere();
  }
  
  public void setQuantiteInitialJour(int jours)
  {
    setQuantiteInitial(new Quantite(new BigDecimal(Integer.toString(jours)), UNITE_DEFAUT));
  }
  
  public void jdoPreDelete() {}
  
  public void marquerGraphePersistant() {}
  
  public void jdoPostLoad() {}
  
  public void jdoPreClear() {}
  
  public void jdoPreStore() {}
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public ObjetMetierSpec copie()
  {
    Differe copie = new Differe();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec pCopie)
  {
    Differe copie = (Differe)pCopie;
    
    copie.setPeriodeEffet(new Periode(getPeriodeEffet().getDebut(), getPeriodeEffet().getFin()));
    copie.setQuantiteInitial(getQuantiteInitial());
  }
  
  public boolean estIdentiqueA(Differe delaiReport)
  {
    Differe aComparer = delaiReport;
    
    EqualsBuilder eqb = new EqualsBuilder();
    return eqb.append(getPeriodeEffet().getDebut(), aComparer.getPeriodeEffet().getDebut()).append(getPeriodeEffet().getFin(), aComparer.getPeriodeEffet().getFin()).append(getQuantiteInitial(), aComparer.getQuantiteInitial()).isEquals();
  }
  
  public String getTypeCarence()
  {
    return "Différé";
  }
  
  public Periode getPeriodeApplicationCarence()
  {
    return getPeriodeEffet();
  }
}

/* Location:
 * Qualified Name:     Differe
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */