package fr.unedic.cali.asu.cge01.p02.liquidation.dom;

import fr.unedic.cali.asu.cge01.p02.calcul.dom.FormuleMontantRegimeGeneral;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen.DureeIndemnisationGen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.DureeReglementaireSpec;
import fr.unedic.cali.dom.QuantiteDroit;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;

public class DureeIndemnisation
  extends DureeIndemnisationGen
  implements DureeReglementaireSpec
{
  private static final long serialVersionUID = -6822356149313272899L;
  private transient Quantite dureeRestantAImputer = null;
  
  public DureeIndemnisation() {}
  
  public DureeIndemnisation(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public DureeIndemnisation(int p_dureeTheorique, int p_dureeImputation)
  {
    setDureeTheorique(new Quantite(p_dureeTheorique, UNITE_DEFAUT));
    setDureeImputation(new Quantite(p_dureeImputation, UNITE_DEFAUT));
  }
  
  public String toString()
  {
    StringBuffer chaine = new StringBuffer();
    
    chaine.append("--- Duree Indemnisation ---");
    chaine.append("\n- duree theorique : " + getDureeTheorique());
    chaine.append("\n- duree imputation : " + getDureeImputation());
    chaine.append("\n- duree effective : " + getDureeEffective());
    return chaine.toString();
  }
  
  public ObjetMetierSpec copie()
  {
    DureeIndemnisation copie = new DureeIndemnisation();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    DureeIndemnisation copie = (DureeIndemnisation)p_copie;
    
    super.copieElements(copie);
    copie.setDureeImputation(getDureeImputation());
    copie.setDureeTheorique(getDureeTheorique());
    copie.setDureePostPrimeCspConstitutionDurees(getDureePostPrimeCspConstitutionDurees());
    copie.setDureeImputationPostPrime(getDureeImputationPostPrime());
  }
  
  public Quantite getDureePostPrimeCspConstitutionDurees()
  {
    return super.getDureePostPrimeCspConstitutionDurees();
  }
  
  public void jdoPreDelete()
  {
    super.jdoPreDelete();
  }
  
  public void marquerGraphePersistant() {}
  
  public QuantiteDroit creerDureeCalcul()
  {
    fr.unedic.cali.asu.cge01.p02.calcul.dom.DureeIndemnisation dureeCalcul = null;
    
    dureeCalcul = new fr.unedic.cali.asu.cge01.p02.calcul.dom.DureeIndemnisation(getDureeEffective().getValeurEntiere());
    dureeCalcul.setCodeFormuleMontant(FormuleMontantRegimeGeneral.getCode());
    
    return dureeCalcul;
  }
  
  public Quantite getDureeRestantAImputer()
  {
    return dureeRestantAImputer;
  }
  
  public void setDureeRestantAImputer(Quantite dureeRestantAImputer)
  {
    this.dureeRestantAImputer = dureeRestantAImputer;
  }
}

/* Location:
 * Qualified Name:     DureeIndemnisation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */