package fr.unedic.cali.asu.cge01.p02.liquidation.dom;

import fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen.ExamenGen;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffecte;
import fr.unedic.cali.asu.dom.JustificationAffiliationSpec;
import fr.unedic.cali.asu.dom.ObjectifExamen;
import fr.unedic.cali.dom.ExamenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public class Examen
  extends ExamenGen
  implements ExamenSpec
{
  private static final long serialVersionUID = 1164500901052619513L;
  
  public Examen() {}
  
  public Examen(DomPCSpec pc)
  {
    super(pc);
  }
  
  public Examen(Damj dateEvenement)
  {
    super(dateEvenement);
  }
  
  public ConditionsAttributionSpec getConditionsAttributionActives()
  {
    ObjectifExamen objectifCourant = ((Demande)getDemande()).getObjectifCourant();
    int natureObjectif = ((DossierAffecte)getDossierAffecte()).getTypeDossier();
    if (objectifCourant != null) {
      natureObjectif = objectifCourant.getType();
    }
    switch (natureObjectif)
    {
    case 2: 
    case 5: 
    case 6: 
      return getConditionsAttributionReprise();
    }
    return getConditionsAttributionAdmission();
  }
  
  public ConstitutionElementsSpec getConstitutionElementsActifs()
  {
    ObjectifExamen objectifCourant = ((Demande)getDemande()).getObjectifCourant();
    int natureObjectif = ((DossierAffecte)getDossierAffecte()).getTypeDossier();
    if (objectifCourant != null) {
      natureObjectif = objectifCourant.getType();
    }
    switch (natureObjectif)
    {
    case 2: 
    case 5: 
    case 6: 
      return getConstitutionElementsReprise();
    }
    return getConstitutionElementsAdmission();
  }
  
  public ObjetMetierSpec copie()
  {
    Examen copie = new Examen();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec pCopie)
  {
    super.copieElements(pCopie);
    
    Examen copie = (Examen)pCopie;
    if (getConditionsAttributionAdmission() != null) {
      copie.setConditionsAttributionAdmission(new ConditionsAttributionAdmission());
    }
    if (getConstitutionElementsAdmission() != null) {
      copie.setConstitutionElementsAdmission(new ConstitutionElementsAdmission());
    }
    if (getConditionsAttributionReprise() != null) {
      copie.setConditionsAttributionReprise(new ConditionsAttributionReprise());
    }
    if (getConstitutionElementsReprise() != null) {
      copie.setConstitutionElementsReprise(new ConstitutionElementsReprise());
    }
  }
  
  public JustificationAffiliationSpec getJustificationAffiliation()
  {
    return getConditionsAttributionAdmission().getConditionQuantiteAffiliation() != null ? getConditionsAttributionAdmission().getConditionQuantiteAffiliation().getJustificationAffiliation() : null;
  }
}

/* Location:
 * Qualified Name:     Examen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */