package fr.unedic.cali.asu.cge01.p02.liquidation.dom;

import fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen.JustificationSjrGen;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public class JustificationSjr
  extends JustificationSjrGen
  implements ObjetPersistantSpec
{
  private static final long serialVersionUID = -2416318073865294564L;
  private transient JustificationDiviseur m_justificationDiviseur;
  private transient JustificationPlafonds m_justificationPlafonds;
  
  public JustificationSjr()
  {
    m_justificationDiviseur = new JustificationDiviseur();
    m_justificationPlafonds = new JustificationPlafonds();
    super.setJustificationSr(new JustificationSr());
  }
  
  public JustificationSjr(DomPCSpec p_pc)
  {
    super(p_pc);
    m_justificationDiviseur = new JustificationDiviseur();
    m_justificationPlafonds = new JustificationPlafonds();
    
    setJustificationSr(new JustificationSr());
  }
  
  public JustificationDiviseur getJustificationDiviseur()
  {
    return m_justificationDiviseur;
  }
  
  public void setJustificationDiviseur(JustificationDiviseur p_justificationDiviseur)
  {
    m_justificationDiviseur = p_justificationDiviseur;
  }
  
  public JustificationPlafonds getJustificationPlafonds()
  {
    return m_justificationPlafonds;
  }
  
  public void setJustificationPlafonds(JustificationPlafonds p_justificationPlafonds)
  {
    m_justificationPlafonds = p_justificationPlafonds;
  }
  
  public void setJustificationSr(JustificationSr p_justificationSr)
  {
    DomManager.supprimer(super.getJustificationSr(), p_justificationSr);
    super.setJustificationSr(p_justificationSr);
  }
  
  public ObjetMetierSpec copie()
  {
    JustificationSjr copie = new JustificationSjr();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    JustificationSjr copie = (JustificationSjr)p_copie;
    copie.setJustificationDiviseur((JustificationDiviseur)getJustificationDiviseur().copie());
    copie.setJustificationPlafonds((JustificationPlafonds)getJustificationPlafonds().copie());
    copie.setJustificationSr((JustificationSr)getJustificationSr().copie());
  }
  
  public void jdoPostLoad() {}
  
  public void jdoPreClear() {}
  
  public void jdoPreDelete()
  {
    DomManager.supprimer(super.getJustificationSr());
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(super.getJustificationSr());
  }
  
  public void jdoPreStore() {}
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
}

/* Location:
 * Qualified Name:     JustificationSjr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */