package fr.unedic.cali.asu.cge01.p02.liquidation.dom;

import fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen.PreavisMesureConservatoireIndemnisableGen;
import fr.unedic.cali.asu.dom.PreavisMesureConservatoireIndemnisableSpec;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.Individu;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.parcours.ContexteParcoursCali;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import fr.unedic.util.temps.UniteDuree;
import org.apache.commons.lang.builder.EqualsBuilder;

public class PreavisMesureConservatoireIndemnisable
  extends PreavisMesureConservatoireIndemnisableGen
  implements ObjetPersistantSpec, PreavisMesureConservatoireIndemnisableSpec
{
  private static final long serialVersionUID = 5378601805542527543L;
  private transient ObjetChronoPeriode m_periodeOrigine;
  
  public PreavisMesureConservatoireIndemnisable() {}
  
  public PreavisMesureConservatoireIndemnisable(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public PreavisMesureConservatoireIndemnisable(ObjetChronoPeriode p_periodeOrigine, Periode p_periodeApplication)
  {
    setQuantiteInitial(new Quantite(String.valueOf(p_periodeApplication.getDuree()), UniteDuree.JOUR));
    setPeriodeApplicationPMC(p_periodeApplication);
    setOrigine(p_periodeOrigine);
  }
  
  public ObjetChronoPeriode getOrigine()
  {
    if (m_periodeOrigine == null)
    {
      Individu individuCourant = ContexteParcoursCali.getIndividuCourant();
      
      m_periodeOrigine = ((ObjetChronoPeriode)individuCourant.rechercherPeriodePasseProfessionnel(getIdentifiantPeriodeOrigine()));
    }
    return m_periodeOrigine;
  }
  
  public void setOrigine(ObjetChronoPeriode p_periodeOrigine)
  {
    m_periodeOrigine = p_periodeOrigine;
    if (p_periodeOrigine != null)
    {
      setIdentifiantPeriodeOrigine(((ActiviteSalarie)p_periodeOrigine).getIdentifiant());
      setDateFinPeriodeOrigine(p_periodeOrigine.getDateFin());
    }
  }
  
  public void jdoPreDelete() {}
  
  public void marquerGraphePersistant() {}
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public void jdoPostLoad() {}
  
  public void jdoPreClear() {}
  
  public void jdoPreStore() {}
  
  public ObjetMetierSpec copie()
  {
    PreavisMesureConservatoireIndemnisable copie = new PreavisMesureConservatoireIndemnisable();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    PreavisMesureConservatoireIndemnisable copie = (PreavisMesureConservatoireIndemnisable)p_copie;
    
    copie.setPeriodeApplicationPMC(new Periode(getPeriodeApplicationPMC().getDebut(), getPeriodeApplicationPMC().getFin()));
    copie.setDateFinPeriodeOrigine(getDateFinPeriodeOrigine());
    copie.setIdentifiantPeriodeOrigine(getIdentifiantPeriodeOrigine());
    copie.setQuantiteInitial(getQuantiteInitial());
  }
  
  public boolean estIdentiqueA(PreavisMesureConservatoireIndemnisable p_pmc)
  {
    if (p_pmc == null) {
      return false;
    }
    PreavisMesureConservatoireIndemnisable aComparer = p_pmc;
    
    EqualsBuilder eqb = new EqualsBuilder();
    return eqb.append(getPeriodeApplicationPMC().getDebut(), aComparer.getPeriodeApplicationPMC().getDebut()).append(getPeriodeApplicationPMC().getFin(), aComparer.getPeriodeApplicationPMC().getFin()).append(getQuantiteInitial(), aComparer.getQuantiteInitial()).append(getIdentifiantPeriodeOrigine(), aComparer.getIdentifiantPeriodeOrigine()).isEquals();
  }
}

/* Location:
 * Qualified Name:     PreavisMesureConservatoireIndemnisable
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */