package fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc.ConditionAgePC;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public abstract class ConditionAgeGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_conditionAgePC;
  private Damj m_dateEffetPension;
  private ResultatElementDroit m_resultatElementDroit;
  
  public ConditionAgeGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConditionAgeGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ConditionAgePC();
  }
  
  public DomPCSpec getPC()
  {
    return m_conditionAgePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_conditionAgePC)
  {
    m_conditionAgePC = p_conditionAgePC;
  }
  
  protected int rawGetSituationConditionAge()
  {
    return ((ConditionAgePC)getPC()).getSituationConditionAge();
  }
  
  public int getSituationConditionAge()
  {
    return ((ConditionAgePC)getPC()).getSituationConditionAge();
  }
  
  public void setSituationConditionAge(int p_situationConditionAge)
  {
    ((ConditionAgePC)getPC()).setSituationConditionAge(p_situationConditionAge);
  }
  
  protected Damj rawGetDateEffetPension()
  {
    return ((ConditionAgePC)getPC()).getDateEffetPension();
  }
  
  public Damj getDateEffetPension()
  {
    return ((ConditionAgePC)getPC()).getDateEffetPension();
  }
  
  public void setDateEffetPension(Damj p_dateEffetPension)
  {
    if ((m_dateEffetPension == null) || (p_dateEffetPension == null))
    {
      m_dateEffetPension = p_dateEffetPension;
      ((ConditionAgePC)getPC()).setDateEffetPension(p_dateEffetPension);
    }
    else if ((m_dateEffetPension != null) && (p_dateEffetPension != null) && (!p_dateEffetPension.equals(m_dateEffetPension)))
    {
      m_dateEffetPension = p_dateEffetPension;
      ((ConditionAgePC)getPC()).setDateEffetPension(p_dateEffetPension);
    }
  }
  
  public ResultatElementDroit getResultatElementDroit()
  {
    if (m_resultatElementDroit == null)
    {
      DomPCSpec resultatElementDroitPC = ((ConditionAgePC)getPC()).getResultatElementDroit();
      if (resultatElementDroitPC != null) {
        m_resultatElementDroit = ((ResultatElementDroit)resultatElementDroitPC.createOM());
      }
    }
    return m_resultatElementDroit;
  }
  
  public void setResultatElementDroit(ResultatElementDroit p_resultatElementDroit)
  {
    if (p_resultatElementDroit == null)
    {
      ((ConditionAgePC)getPC()).setResultatElementDroit(null);
      m_resultatElementDroit = p_resultatElementDroit;
    }
    else if (!p_resultatElementDroit.equals(m_resultatElementDroit))
    {
      ((ConditionAgePC)getPC()).setResultatElementDroit(p_resultatElementDroit.getPC());
      m_resultatElementDroit = p_resultatElementDroit;
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    Object resultatElementDroit = getResultatElementDroit();
    if ((resultatElementDroit != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(resultatElementDroit))) {
      DomManager.supprimer(getResultatElementDroit(), p_contexteSuppression);
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConditionAgeGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */