package fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Sjcip;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc.ConstitutionSjcPC;
import fr.unedic.cali.asu.dom.Sjc;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public abstract class ConstitutionSjcGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionSjcPC;
  private Sjcip m_sjcip;
  private Sjc m_sjcrp;
  
  public ConstitutionSjcGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConstitutionSjcGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ConstitutionSjcPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_constitutionSjcPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionSjcPC)
  {
    m_constitutionSjcPC = p_constitutionSjcPC;
  }
  
  public Sjcip getSjcip()
  {
    if (m_sjcip == null)
    {
      DomPCSpec sjcipPC = ((ConstitutionSjcPC)getPC()).getSjcip();
      if (sjcipPC != null) {
        m_sjcip = ((Sjcip)sjcipPC.createOM());
      }
    }
    return m_sjcip;
  }
  
  public void setSjcip(Sjcip p_sjcip)
  {
    if (p_sjcip == null)
    {
      ((ConstitutionSjcPC)getPC()).setSjcip(null);
      m_sjcip = p_sjcip;
    }
    else if (!p_sjcip.equals(m_sjcip))
    {
      ((ConstitutionSjcPC)getPC()).setSjcip(p_sjcip.getPC());
      m_sjcip = p_sjcip;
    }
  }
  
  protected Sjc rawGetSjcrp()
  {
    return ((ConstitutionSjcPC)getPC()).getSjcrp();
  }
  
  public Sjc getSjcrp()
  {
    return ((ConstitutionSjcPC)getPC()).getSjcrp();
  }
  
  public void setSjcrp(Sjc p_sjcrp)
  {
    if ((m_sjcrp == null) || (p_sjcrp == null))
    {
      m_sjcrp = p_sjcrp;
      ((ConstitutionSjcPC)getPC()).setSjcrp(p_sjcrp);
    }
    else if ((m_sjcrp != null) && (p_sjcrp != null) && (!p_sjcrp.equals(m_sjcrp)))
    {
      m_sjcrp = p_sjcrp;
      ((ConstitutionSjcPC)getPC()).setSjcrp(p_sjcrp);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    Object sjcip = getSjcip();
    if ((sjcip != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(sjcip))) {
      DomManager.supprimer(getSjcip(), p_contexteSuppression);
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConstitutionSjcGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */