package fr.unedic.cali.asu.cge01.p02.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Attribution;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.pc.NovationPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public abstract class NovationGen
  extends Attribution
  implements DomGenSpec
{
  private String m_situationParticuliere;
  
  public NovationGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public NovationGen() {}
  
  public NovationGen(Damj p_dateEvenement)
  {
    super(p_dateEvenement);
  }
  
  protected DomPCSpec createPC()
  {
    return new NovationPC();
  }
  
  protected String rawGetSituationParticuliere()
  {
    return ((NovationPC)getPC()).getSituationParticuliere();
  }
  
  public String getSituationParticuliere()
  {
    return ((NovationPC)getPC()).getSituationParticuliere();
  }
  
  public void setSituationParticuliere(String p_situationParticuliere)
  {
    if ((m_situationParticuliere == null) || (p_situationParticuliere == null))
    {
      m_situationParticuliere = p_situationParticuliere;
      ((NovationPC)getPC()).setSituationParticuliere(p_situationParticuliere);
    }
    else if ((m_situationParticuliere != null) && (p_situationParticuliere != null) && (!p_situationParticuliere.equals(m_situationParticuliere)))
    {
      m_situationParticuliere = p_situationParticuliere;
      ((NovationPC)getPC()).setSituationParticuliere(p_situationParticuliere);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     NovationGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */