package fr.unedic.cali.asu.cge01.p02.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.Attribution;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.DeterminationDateLimiteIndemnisation;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Damj;

public class ConstitutionDateLimiteIndemnisation
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCEPA = new Resultat();
    
    Demande demande = DomLiquidationAssurance.getDemande(contexte);
    Attribution attribution = (Attribution)demande.getAttribution();
    
    boolean estDateLimiteForcee = demande.getDonneesTemporaires().getDateLimiteIndemnisationDonneeForcee() != null;
    boolean enCoursOuEntreeCSP = OutilGestionContexteDemande.estContexteDemandeAssurancePresent(demande, 6);
    if ((enCoursOuEntreeCSP) && (!estDateLimiteForcee)) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_DATE_LIMITE_ARE03_ARE06");
    }
    Damj dateLimiteIndemnisation = attribution.getDateLimiteIndemnisation();
    
    DeterminationDateLimiteIndemnisation.controleValiditeDateLimiteIndemnisation(demande, dateLimiteIndemnisation);
    if (estDateLimiteForcee) {
      DeterminationDateLimiteIndemnisation.controleValiditeDateLimiteIndemnisationForcee(demande, dateLimiteIndemnisation);
    }
    OutilTrace.tracerFinParcours();
    
    return resultatCEPA;
  }
}

/* Location:
 * Qualified Name:     ConstitutionDateLimiteIndemnisation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */