package fr.unedic.cali.asu.cge01.p02.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionQuantiteAffiliation;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.cge01.p02.liquidation.outilsfonctionnels.RechercheQuantiteAppartenance;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.parcours.ParcoursConstitutionQuantiteAffiliationDemandeASU;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;

public class ConstitutionQuantiteAffiliationDemandeASUClassique
  extends ParcoursConstitutionQuantiteAffiliationDemandeASU
{
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours(Niveau.DEBUG);
    
    Demande demande = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demande.getDossierExamen();
    
    ConstitutionQuantiteAffiliation quantiteAppartenance = RechercheQuantiteAppartenance.rechercher(demande, false);
    
    dossierExamenCourant.setConstitutionQuantiteAffiliation(quantiteAppartenance);
    
    OutilTrace.tracerFinParcours(Niveau.DEBUG);
    
    return new Resultat(0);
  }
}

/* Location:
 * Qualified Name:     ConstitutionQuantiteAffiliationDemandeASUClassique
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */