package fr.unedic.cali.asu.cge01.p02.liquidation.parcours;

import fr.unedic.archi.util.trace.Log;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionMontantNonNul;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.cge01.p02.liquidation.outilsfonctionnels.RechercheConditionMontantNonNul;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;

public class DeterminationConditionMontantNonNulPourReprise
  extends ParcoursCali
  implements ParcoursAssurance
{
  public void controlerContexte(Contexte p_contexte)
    throws ContexteException
  {
    if (DomLiquidationAssurance.getDemande(p_contexte) == null) {
      throw new ContexteException("HG_PR_CALI_L_CONTEXTE_ABSENCE_DEMANDE_ASSURANCE", "La demande d'assurance est null pour une détermination condition montant non nul.");
    }
  }
  
  public Resultat demarrer(Contexte p_contexte)
    throws CoucheLogiqueException
  {
    if (Log.isTraceActive(DeterminationConditionMontantNonNulPourReprise.class, Niveau.DEBUG))
    {
      Log.ecritTrace(Niveau.DEBUG, DeterminationConditionMontantNonNulPourReprise.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, DeterminationConditionMontantNonNulPourReprise.class, "demarrer", "\t\t******** Début Parcours DeterminationConditionMontantNonNul ********\n");
    }
    Resultat resultatCapr18 = new Resultat(1);
    
    Demande demandeCourante = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demandeCourante.getDossierExamen();
    
    ConditionMontantNonNul condition = RechercheConditionMontantNonNul.rechercherConditionMontantNonNul(demandeCourante);
    
    dossierExamenCourant.setConditionMontantNonNul(condition);
    if (condition.estSatisfait())
    {
      resultatCapr18.setEtat(0);
    }
    else
    {
      resultatCapr18.setEtat(1);
      resultatCapr18.setMessageErreur(Integer.toString(condition.getCodeMotifEchec()));
    }
    if (Log.isTraceActive(DeterminationConditionMontantNonNulPourReprise.class, Niveau.DEBUG))
    {
      Log.ecritTrace(Niveau.DEBUG, DeterminationConditionMontantNonNulPourReprise.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, DeterminationConditionMontantNonNulPourReprise.class, "demarrer", "\t\t******** Résultat Parcours DeterminationConditionMontantNonNul pour Reprise ********\n" + resultatCapr18);
      
      Log.ecritTrace(Niveau.DEBUG, DeterminationConditionMontantNonNulPourReprise.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, DeterminationConditionMontantNonNulPourReprise.class, "demarrer", "\t\t******** Fin Parcours DeterminationConditionMontantNonNul pour Reprise ********\n");
    }
    return resultatCapr18;
  }
}

/* Location:
 * Qualified Name:     DeterminationConditionMontantNonNulPourReprise
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */