package fr.unedic.cali.asu.cge01.p02.liquidation.parcours;

import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConditionRechercheEmploi;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.ResultatConditionRechercheEmploi;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.asr.RechercheConditionRechercheEmploiAsp;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.asr.RechercheConditionRechercheEmploiPap;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;

public class DeterminationConditionRechercheEmploi
  extends ParcoursCali
  implements ParcoursAssurance
{
  public void controlerContexte(Contexte contexte)
    throws ContexteException
  {
    if (DomLiquidationAssurance.getDemande(contexte) == null) {
      throw new ContexteException("HG_PR_CALI_L_CONTEXTE_ABSENCE_DEMANDE_ASSURANCE", "Une demande est obligatoire pour ce produit. : DeterminationConditionRechercheEmploi impossible");
    }
    if (DomLiquidationAssurance.getDemande(contexte).getDemandeur() == null) {
      throw new ContexteException("HG_PR_CALI_L_ERR_CTX_ABS_DEMANDEUR", "Absence individu demandeur sur la demande : DeterminationConditionRechercheEmploi impossible");
    }
  }
  
  public Resultat demarrer(Contexte contexte)
    throws CoucheLogiqueException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCapa01 = new Resultat(1);
    
    Demande demandeCourante = DomLiquidationAssurance.getDemande(contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demandeCourante.getDossierExamen();
    
    ResultatConditionRechercheEmploi resultatConditionRechercheEmploi = getOutilFonctionnel(demandeCourante).rechercherConditionRechercheEmploi(demandeCourante);
    
    ResultatElementDroit resultatElementDroit = resultatConditionRechercheEmploi.getResultatElementDroit();
    ConditionRechercheEmploi conditionRechercheEmploi = new ConditionRechercheEmploi();
    conditionRechercheEmploi.setEtat(0);
    if (!resultatElementDroit.estSatisfait())
    {
      conditionRechercheEmploi.setEtat(resultatElementDroit.getEtat());
      conditionRechercheEmploi.setCodeMotifEchec(resultatElementDroit.getCodeMotifEchec());
    }
    if ((resultatElementDroit.estSatisfait()) && (!fr.unedic.cali.asu.cge01.p02.liquidation.outilsfonctionnels.RechercheConditionRechercheEmploi.rechercherConditionRechercheEmploi(demandeCourante)))
    {
      conditionRechercheEmploi.setEtat(1);
      conditionRechercheEmploi.setCodeMotifEchec(11);
    }
    dossierExamenCourant.setConditionRechercheEmploi(conditionRechercheEmploi);
    resultatCapa01.setEtat(conditionRechercheEmploi.getEtat());
    
    OutilTrace.tracerFinParcours();
    
    return resultatCapa01;
  }
  
  private fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.RechercheConditionRechercheEmploi getOutilFonctionnel(Demande demande)
  {
    if (demande.estEnContexteDemande(6))
    {
      if (demande.estEnContexteDemande(10)) {
        return RechercheConditionRechercheEmploiPap.getInstance();
      }
      return RechercheConditionRechercheEmploiAsp.getInstance();
    }
    return fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.RechercheConditionRechercheEmploi.getInstance();
  }
}

/* Location:
 * Qualified Name:     DeterminationConditionRechercheEmploi
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */