package fr.unedic.cali.asu.cge01.p03.calcul.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p03.calcul.dom.pc.CalendrierExecutionCalculPC;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculPeriodique;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public abstract class CalendrierExecutionCalculGen
  extends CalendrierExecutionCalculPeriodique
  implements DomGenSpec
{
  private Damj m_dateDrv;
  
  public CalendrierExecutionCalculGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public CalendrierExecutionCalculGen() {}
  
  protected DomPCSpec createPC()
  {
    return new CalendrierExecutionCalculPC();
  }
  
  protected Damj rawGetDateDrv()
  {
    return ((CalendrierExecutionCalculPC)getPC()).getDateDrv();
  }
  
  public Damj getDateDrv()
  {
    return ((CalendrierExecutionCalculPC)getPC()).getDateDrv();
  }
  
  public void setDateDrv(Damj p_dateDrv)
  {
    if ((m_dateDrv == null) || (p_dateDrv == null))
    {
      m_dateDrv = p_dateDrv;
      ((CalendrierExecutionCalculPC)getPC()).setDateDrv(p_dateDrv);
    }
    else if ((m_dateDrv != null) && (p_dateDrv != null) && (!p_dateDrv.equals(m_dateDrv)))
    {
      m_dateDrv = p_dateDrv;
      ((CalendrierExecutionCalculPC)getPC()).setDateDrv(p_dateDrv);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     CalendrierExecutionCalculGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */