package fr.unedic.cali.asu.cge01.p03.liquidation.dom;

import fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen.CarencePrefixeAFixerGen;
import fr.unedic.cali.asu.dom.CarenceSpec;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.dom.Individu;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.parcours.ContexteParcoursCali;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;

public abstract class CarencePrefixeAFixer
  extends CarencePrefixeAFixerGen
  implements ObjetPersistantSpec, CarenceSpec
{
  private transient ObjetChronoPeriode m_periodeOrigine;
  
  public CarencePrefixeAFixer() {}
  
  public CarencePrefixeAFixer(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public ObjetChronoPeriode getOrigine()
  {
    if (m_periodeOrigine == null)
    {
      Individu individuCourant = ContexteParcoursCali.getIndividuCourant();
      
      m_periodeOrigine = ((ObjetChronoPeriode)individuCourant.rechercherPeriodePasseProfessionnel(getIdentifiantPeriodeOrigine()));
    }
    return m_periodeOrigine;
  }
  
  public abstract String getTypeCarence();
  
  public boolean peutEtreFixee()
  {
    return false;
  }
  
  public void setOrigine(ObjetChronoPeriode p_periodeOrigine)
  {
    m_periodeOrigine = p_periodeOrigine;
    if (p_periodeOrigine != null)
    {
      if ((p_periodeOrigine instanceof TravailSpec)) {
        setIdentifiantPeriodeOrigine(((TravailSpec)p_periodeOrigine).getIdentifiant());
      }
      setDateFinPeriodeOrigine(p_periodeOrigine.getDateFin());
    }
  }
  
  public void jdoPreDelete() {}
  
  public void marquerGraphePersistant() {}
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public void jdoPostLoad() {}
  
  public void jdoPreClear() {}
  
  public void jdoPreStore() {}
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    CarencePrefixeAFixer copie = (CarencePrefixeAFixer)p_copie;
    
    copie.setPeriodeApplicationCarence(new Periode(getPeriodeApplicationCarence().getDebut(), getPeriodeApplicationCarence().getFin()));
    copie.setDateFinPeriodeOrigine(getDateFinPeriodeOrigine());
    copie.setIdentifiantPeriodeOrigine(getIdentifiantPeriodeOrigine());
    copie.setQuantiteInitial(getQuantiteInitial());
  }
  
  public abstract CarencePrefixeAFixer getCarencePrecedente();
  
  public abstract CarencePrefixeAFixer getCarenceSuivante();
  
  public abstract boolean estIdentiqueA(CarencePrefixeAFixer paramCarencePrefixeAFixer);
}

/* Location:
 * Qualified Name:     CarencePrefixeAFixer
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */