package fr.unedic.cali.asu.cge01.p03.liquidation.dom;

import fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen.ConditionQuantiteAffiliationGen;
import fr.unedic.cali.asu.dom.ConditionQuantiteAffiliationSpec;
import fr.unedic.cali.asu.dom.JustificationAffiliationSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.UniteAffiliation;

public class ConditionQuantiteAffiliation
  extends ConditionQuantiteAffiliationGen
  implements ConditionQuantiteAffiliationSpec
{
  private transient JustificationAffiliationSpec m_justificationAffiliation;
  
  private ConditionQuantiteAffiliation() {}
  
  public ConditionQuantiteAffiliation(DomPCSpec p_conditionsAttributionPC)
  {
    super(p_conditionsAttributionPC);
  }
  
  public void marquerGraphePersistant() {}
  
  public boolean estSatisfait()
  {
    return getEtat() == 0;
  }
  
  public void setEtatSatisfait(boolean p_etatSatisfait)
  {
    if (p_etatSatisfait) {
      setEtat(0);
    } else {
      setEtat(1);
    }
  }
  
  public ObjetMetierSpec copie()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller le méthode copieElements(ObjetMetierSpec).");
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ConditionQuantiteAffiliation copie = (ConditionQuantiteAffiliation)p_copie;
    copie.setCodeMotifEchec(getCodeMotifEchec());
    copie.setQuantiteAppartenance(getQuantiteAppartenance());
    copie.setEtat(getEtat());
    
    copie.setJustificationAffiliation(getJustificationAffiliation());
    copie.setQuantiteAppartenanceSecondaire(getQuantiteAppartenanceSecondaire());
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public JustificationAffiliationSpec getJustificationAffiliation()
  {
    return m_justificationAffiliation;
  }
  
  public void setJustificationAffiliation(JustificationAffiliationSpec p_justificationAffiliation)
  {
    m_justificationAffiliation = p_justificationAffiliation;
  }
  
  public Quantite getQuantiteAppartenance()
  {
    if (super.getQuantiteAppartenance() == null) {
      setQuantiteAppartenance(new Quantite("0", UniteAffiliation.JOUR));
    }
    return super.getQuantiteAppartenance();
  }
  
  public String getEtatPndsPourCalculAffi()
  {
    return null;
  }
}

/* Location:
 * Qualified Name:     ConditionQuantiteAffiliation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */