package fr.unedic.cali.asu.cge01.p03.liquidation.dom;

import fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen.ConstitutionProduitResultantGen;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.spec.ConstitutionElementsAbstraitPC;
import fr.unedic.cali.asu.dom.ConstitutionProduitResultantSpec;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public class ConstitutionProduitResultant
  extends ConstitutionProduitResultantGen
  implements ConstitutionProduitResultantSpec
{
  private static final long serialVersionUID = 1L;
  
  protected ConstitutionProduitResultant() {}
  
  public ConstitutionProduitResultant(DomPCSpec p_cepAbstraitPC)
  {
    super(p_cepAbstraitPC);
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public ObjetMetierSpec copie()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller le méthode copieElements(ObjetMetierSpec).");
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ConstitutionProduitResultant copie = (ConstitutionProduitResultant)p_copie;
    
    copie.setCapitalDroitPrecedent(getCapitalDroitPrecedent());
    copie.setDureeDroitPrecedent(getDureeDroitPrecedent());
    copie.setMontantDroitPrecedent(getMontantDroitPrecedent());
    copie.setCapitalMax(getCapitalMax());
    copie.setCapitalRetenu(getCapitalRetenu());
    copie.setMontantRetenu(getMontantRetenu());
    if (getSjrrpProduitPrecedent() != null) {
      copie.setSjrrpProduitPrecedent((Sjr)getSjrrpProduitPrecedent().copie());
    }
    if (((ConstitutionElementsAbstraitPC)getPC()).isPresenceDonneesConstitutionDureesConstitutionProduitResultant())
    {
      ConstitutionDurees copieDurees = copie.createConstitutionDurees();
      getConstitutionDurees().copieElements(copieDurees);
    }
    if (((ConstitutionElementsAbstraitPC)getPC()).isPresenceDonneesConstitutionMontantsBrutsConstitutionProduitResultant())
    {
      ConstitutionMontantsBruts copieMtBrut = copie.createConstitutionMontantsBruts();
      getConstitutionMontantsBruts().copieElements(copieMtBrut);
    }
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(super.getConstitutionDurees());
    DomManager.persisterEnProfondeur(super.getConstitutionMontantsBruts());
  }
  
  public int getTypeMontantRetenu()
  {
    return getMontantRetenu();
  }
}

/* Location:
 * Qualified Name:     ConstitutionProduitResultant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */