package fr.unedic.cali.asu.cge01.p03.liquidation.dom;

import fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen.ConstitutionReglementApplicableGen;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.dom.affectation.Parametres;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public class ConstitutionReglementApplicable
  extends ConstitutionReglementApplicableGen
  implements ReglementApplicableSpec
{
  private transient Reglement m_reglement;
  
  private ConstitutionReglementApplicable() {}
  
  public ConstitutionReglementApplicable(DomPCSpec p_cepAbstraitPC)
  {
    super(p_cepAbstraitPC);
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public Reglement getReglement()
  {
    if (m_reglement == null) {
      m_reglement = Parametres.getReglement(getNomReglement(), Parametres.getProduit(getCodeProduit()));
    }
    return m_reglement;
  }
  
  public void setReglement(Reglement p_reglement)
  {
    m_reglement = p_reglement;
    setNomReglement(p_reglement.getNomReglement());
    setCodeProduit(p_reglement.getProduit().getCode());
  }
  
  public String toString()
  {
    StringBuffer sb = new StringBuffer();
    sb.append(getReglement());
    return sb.toString();
  }
  
  public void marquerGraphePersistant() {}
  
  public ObjetMetierSpec copie()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller le méthode copieElements(ObjetMetierSpec).");
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ConstitutionReglementApplicable copie = (ConstitutionReglementApplicable)p_copie;
    copie.setReglement(getReglement());
  }
  
  public void jdoPreClear() {}
  
  public void jdoPreDelete() {}
  
  public void jdoPostLoad() {}
  
  public void jdoPreStore() {}
}

/* Location:
 * Qualified Name:     ConstitutionReglementApplicable
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */