package fr.unedic.cali.asu.cge01.p03.liquidation.dom;

import fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen.ConstitutionSjcGen;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.spec.ConstitutionElementsAbstraitPC;
import fr.unedic.cali.asu.dom.ConstitutionSjcSpec;
import fr.unedic.cali.asu.dom.Sjc;
import fr.unedic.cali.dom.ConstitutionDroitSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.temps.Damj;
import java.util.Collection;

public class ConstitutionSjc
  extends ConstitutionSjcGen
  implements ConstitutionDroitSpec, ConstitutionSjcSpec
{
  private static final long serialVersionUID = 1L;
  private transient JustificationSjc m_justificationSjc;
  
  private ConstitutionSjc() {}
  
  public ConstitutionSjc(DomPCSpec p_constitutionElementsAdmissionPC)
  {
    super(p_constitutionElementsAdmissionPC);
  }
  
  public Sjcip createSjcip(Damj p_dateEffet, QuantiteEuro p_plafond, QuantiteEuro p_sjcInitial)
  {
    Sjcip om = super.createSjcip();
    
    om.setPlafond(p_plafond);
    om.setSjcInitial(p_sjcInitial);
    om.setDateEvenement(p_dateEffet);
    
    return om;
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public Sjcip getSjcip()
  {
    if ((sjcipEstPresent()) && (super.getSjcip() == null)) {
      createSjcip();
    }
    return super.getSjcip();
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(super.getSjcip());
  }
  
  public ObjetMetierSpec copie()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller le méthode copieElements(ObjetMetierSpec).");
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ConstitutionSjc copie = (ConstitutionSjc)p_copie;
    if (getSjcip() != null)
    {
      Sjcip copieSjcip = copie.createSjcip();
      getSjcip().copieElements(copieSjcip);
    }
    copie.setSjcrp(getSjcrp() != null ? (Sjc)getSjcrp().copie() : null);
  }
  
  public JustificationSjc getJustificationSjc()
  {
    return m_justificationSjc;
  }
  
  public void setJustificationSjc(JustificationSjc p_justificationSjc)
  {
    m_justificationSjc = p_justificationSjc;
  }
  
  private boolean sjcipEstPresent()
  {
    return (((ConstitutionElementsAbstraitPC)getPC()).getPlafondConstitutionSjc() != null) || (((ConstitutionElementsAbstraitPC)getPC()).getSjcInitialConstitutionSjc() != null) || (((ConstitutionElementsAbstraitPC)getPC()).getDateEvenementConstitutionSjc() != null) || (((ConstitutionElementsAbstraitPC)getPC()).getCollectionSjrActiviteConservee().isEmpty());
  }
  
  public void jdoPreClear() {}
  
  public void jdoPreDelete() {}
  
  public void jdoPostLoad() {}
  
  public void jdoPreStore() {}
}

/* Location:
 * Qualified Name:     ConstitutionSjc
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */