package fr.unedic.cali.asu.cge01.p03.liquidation.dom;

import fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen.ContributionParticuliereGen;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import java.util.ArrayList;
import java.util.List;

public class ContributionParticuliere
  extends ContributionParticuliereGen
{
  private static final long serialVersionUID = 7390690520892696291L;
  private static transient List<Integer> motifAppelContribSpecif = new ArrayList();
  private static transient List<Integer> motifAppelContribSuppl;
  
  static
  {
    motifAppelContribSpecif.add(Integer.valueOf(1));
    motifAppelContribSpecif.add(Integer.valueOf(3));
    
    motifAppelContribSpecif.add(Integer.valueOf(2));
    motifAppelContribSpecif.add(Integer.valueOf(33));
    motifAppelContribSpecif.add(Integer.valueOf(6));
    
    motifAppelContribSuppl = new ArrayList();
    
    motifAppelContribSuppl.add(Integer.valueOf(1));
    motifAppelContribSuppl.add(Integer.valueOf(3));
    motifAppelContribSuppl.add(Integer.valueOf(5));
    
    motifAppelContribSuppl.add(Integer.valueOf(2));
    motifAppelContribSuppl.add(Integer.valueOf(33));
    motifAppelContribSuppl.add(Integer.valueOf(17));
    motifAppelContribSuppl.add(Integer.valueOf(30));
    motifAppelContribSuppl.add(Integer.valueOf(31));
    motifAppelContribSuppl.add(Integer.valueOf(6));
    motifAppelContribSuppl.add(Integer.valueOf(10));
  }
  
  public ContributionParticuliere()
  {
    setContributionParticuliere(0);
  }
  
  public ContributionParticuliere(DomPCSpec particulierePC)
  {
    super(particulierePC);
  }
  
  public static boolean estMotifAppelContribSpecifique(int motif)
  {
    return motifAppelContribSpecif.contains(Integer.valueOf(motif));
  }
  
  public static boolean estMotifAppelContribSuppl(int motif)
  {
    return motifAppelContribSuppl.contains(Integer.valueOf(motif));
  }
  
  public int getTypeContributionParticuliere()
  {
    return getContributionParticuliere();
  }
  
  public void setTypeContributionParticuliere(int contributionParticuliere)
  {
    setContributionParticuliere(contributionParticuliere);
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public ObjetMetierSpec copie()
  {
    ContributionParticuliere copie = new ContributionParticuliere();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec pcopie)
  {
    ContributionParticuliere copie = (ContributionParticuliere)pcopie;
    
    copie.setTypeContributionParticuliere(getTypeContributionParticuliere());
  }
  
  public String toString()
  {
    return donnerLibelleContributionParticuliere(getTypeContributionParticuliere());
  }
  
  public String donnerLibelleContributionParticuliere(int contributionParticuliere)
  {
    String libelleContributionParticuliereRetour = null;
    switch (contributionParticuliere)
    {
    case 0: 
      libelleContributionParticuliereRetour = "Aucune contribution";
      break;
    case 2: 
      libelleContributionParticuliereRetour = "Contribution spécifique";
      break;
    case 1: 
      libelleContributionParticuliereRetour = "Contribution supplémentaire";
      break;
    case 3: 
      libelleContributionParticuliereRetour = "Contributions supplémentaire et spécifique";
      break;
    }
    return libelleContributionParticuliereRetour;
  }
  
  public void jdoPreClear() {}
  
  public void jdoPreDelete() {}
  
  public void marquerGraphePersistant() {}
  
  public void jdoPostLoad() {}
  
  public void jdoPreStore() {}
}

/* Location:
 * Qualified Name:     ContributionParticuliere
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */