package fr.unedic.cali.asu.cge01.p03.liquidation.dom;

import fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen.PreavisMesureConservatoireNonIndemnisableGen;
import fr.unedic.cali.asu.dom.PreavisMesureConservatoireNonIndemnisableSpec;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.Periode;
import org.apache.commons.lang.builder.EqualsBuilder;

public class PreavisMesureConservatoireNonIndemnisable
  extends PreavisMesureConservatoireNonIndemnisableGen
  implements ObjetPersistantSpec, PreavisMesureConservatoireNonIndemnisableSpec
{
  private static final long serialVersionUID = -454366678604405021L;
  
  public String getTypeCarence()
  {
    return "PMC_NI";
  }
  
  public boolean peutEtreFixee()
  {
    return true;
  }
  
  public PreavisMesureConservatoireNonIndemnisable() {}
  
  public PreavisMesureConservatoireNonIndemnisable(ObjetChronoPeriode periodeOrigine, Periode periodeApplication)
  {
    super(periodeApplication.getDuree());
    setPeriodeApplicationCarence(periodeApplication);
    setOrigine(periodeOrigine);
  }
  
  public PreavisMesureConservatoireNonIndemnisable(DomPCSpec indemnisablePC)
  {
    super(indemnisablePC);
  }
  
  public String toString()
  {
    StringBuffer chaineRetour = new StringBuffer();
    
    chaineRetour.append("Carence PMC:");
    chaineRetour.append("\n\t Période d'origine: ");
    chaineRetour.append(getOrigine());
    chaineRetour.append("\n\t Nombre initial de jours: ");
    chaineRetour.append(getQuantiteInitialJour());
    chaineRetour.append("\n\t Carence suivante: ");
    chaineRetour.append(getCarenceSuivante());
    
    return chaineRetour.toString();
  }
  
  public ObjetMetierSpec copie()
  {
    PreavisMesureConservatoireNonIndemnisable copie = new PreavisMesureConservatoireNonIndemnisable();
    copieElements(copie);
    return copie;
  }
  
  public CarencePrefixeAFixer getCarencePrecedente()
  {
    return null;
  }
  
  public CarencePrefixeAFixer getCarenceSuivante()
  {
    CarencePrefixeAFixer suivante = null;
    if (getEnsembleCarences().getCarenceIccp() != null) {
      suivante = getEnsembleCarences().getCarenceIccp();
    } else if (getEnsembleCarences().getCarenceIslr() != null) {
      suivante = getEnsembleCarences().getCarenceIslr();
    }
    return suivante;
  }
  
  public boolean estIdentiqueA(CarencePrefixeAFixer carence)
  {
    if (!(carence instanceof PreavisMesureConservatoireNonIndemnisable)) {
      return false;
    }
    PreavisMesureConservatoireNonIndemnisable aComparer = (PreavisMesureConservatoireNonIndemnisable)carence;
    
    EqualsBuilder eqb = new EqualsBuilder();
    return eqb.append(getPeriodeApplicationCarence().getDebut(), aComparer.getPeriodeApplicationCarence().getDebut()).append(getPeriodeApplicationCarence().getFin(), aComparer.getPeriodeApplicationCarence().getFin()).append(getQuantiteInitial(), aComparer.getQuantiteInitial()).append(getIdentifiantPeriodeOrigine(), aComparer.getIdentifiantPeriodeOrigine()).isEquals();
  }
}

/* Location:
 * Qualified Name:     PreavisMesureConservatoireNonIndemnisable
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */