package fr.unedic.cali.asu.cge01.p03.liquidation.dom;

import fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen.RejetGen;
import fr.unedic.cali.asu.dom.JustificationAffiliationSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.RejetSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public class Rejet
  extends RejetGen
  implements RejetSpec
{
  private static final long serialVersionUID = 1L;
  
  public Rejet() {}
  
  public Rejet(Damj dateEvenement)
  {
    super(dateEvenement);
  }
  
  public Rejet(Damj dateEvenement, DossierExamen dossierExamen)
  {
    super(dateEvenement);
    copie(dossierExamen);
  }
  
  public Rejet(DomPCSpec rejetPC)
  {
    super(rejetPC);
  }
  
  public Damj getDateEvenement()
  {
    return getDemande().getDateExamen();
  }
  
  public ObjetMetierSpec copie()
  {
    Rejet copie = new Rejet();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec copie)
  {
    super.copieElements(copie);
  }
  
  public JustificationAffiliationSpec getJustificationAffiliation()
  {
    JustificationAffiliationSpec justif = null;
    if (getConstitutionQuantiteAffiliation() != null) {
      justif = getConstitutionQuantiteAffiliation().getJustificationAffiliation();
    } else if (getConditionsAttributionAdmission().getConditionQuantiteAffiliation() != null) {
      justif = getConditionsAttributionAdmission().getConditionQuantiteAffiliation().getJustificationAffiliation();
    }
    return justif;
  }
  
  public Damj getDateEffetDecision()
  {
    return getDemande().getDateRecherche();
  }
  
  public void jdoPostLoad() {}
  
  public void jdoPreStore() {}
  
  public void jdoPreClear() {}
  
  public void jdoPreDelete() {}
}

/* Location:
 * Qualified Name:     Rejet
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */