package fr.unedic.cali.asu.cge01.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.spec.ConstitutionElementsAbstraitPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;

public abstract class DureeReglementaireGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_constitutionElementsAbstraitPC;
  private Quantite m_dureeEffective;
  
  public DureeReglementaireGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public DureeReglementaireGen() {}
  
  public DomPCSpec getPC()
  {
    return m_constitutionElementsAbstraitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_constitutionElementsAbstraitPC)
  {
    m_constitutionElementsAbstraitPC = p_constitutionElementsAbstraitPC;
  }
  
  protected Quantite rawGetDureeEffective()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureeEffectiveConstitutionDurees();
  }
  
  public Quantite getDureeEffective()
  {
    return ((ConstitutionElementsAbstraitPC)getPC()).getDureeEffectiveConstitutionDurees();
  }
  
  public void setDureeEffective(Quantite p_dureeEffective)
  {
    if ((m_dureeEffective == null) || (p_dureeEffective == null))
    {
      m_dureeEffective = p_dureeEffective;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureeEffectiveConstitutionDurees(p_dureeEffective);
    }
    else if ((m_dureeEffective != null) && (p_dureeEffective != null) && (!p_dureeEffective.equals(m_dureeEffective)))
    {
      m_dureeEffective = p_dureeEffective;
      ((ConstitutionElementsAbstraitPC)getPC()).setDureeEffectiveConstitutionDurees(p_dureeEffective);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    setDureeEffective(null);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     DureeReglementaireGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */