package fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConditionMontantNonNul;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConditionsAttributionSpec;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.util.Mathematiques;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.OutilFonctionnel;
import java.math.BigDecimal;

public class RechercheConditionMontantNonNul
  implements OutilFonctionnel
{
  public static ConditionMontantNonNul rechercherConditionMontantNonNul(Demande p_demande)
    throws CoucheLogiqueException
  {
    ConditionMontantNonNul conditionMontantNonNul = ((DossierExamen)p_demande.getDossierExamen()).getConditionsAttributionActives().createConditionMontantNonNul();
    
    conditionMontantNonNul.setEtatSatisfait(false);
    
    AttributionAssuranceSpec attributionAssurance = p_demande.getAttribution();
    Quantite montantJournalier = attributionAssurance.getMontantJournalierBrut();
    BigDecimal valeurMontantJournalier = null;
    if (montantJournalier != null)
    {
      valeurMontantJournalier = montantJournalier.getValeur();
      valeurMontantJournalier = Mathematiques.arrondiASup(valeurMontantJournalier, 2);
    }
    if ((valeurMontantJournalier != null) && (!valeurMontantJournalier.equals(new BigDecimal("0.00"))))
    {
      conditionMontantNonNul.setEtatSatisfait(true);
    }
    else
    {
      conditionMontantNonNul.setEtatSatisfait(false);
      conditionMontantNonNul.setCodeMotifEchec(181);
    }
    return conditionMontantNonNul;
  }
}

/* Location:
 * Qualified Name:     RechercheConditionMontantNonNul
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */