package fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.fabriques.FabriqueStrategieContexteRepriseSystematique;
import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.strategies.spec.StrategieContexteRepriseSystematiqueSpec;
import fr.unedic.cali.asu.dom.DelaiRechercheProduit;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.autresdoms.cohab.dom.ObjetChronoPeriodePriseEnCharge;
import fr.unedic.cali.outilsfonctionnels.OutillagePEC;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.Damj;
import java.util.ArrayList;

public class StrategieFaitGenerateurDelaiValiditeApresMEP08SI1
  implements StrategieFaitGenerateurDelaiValiditeSpec
{
  public DelaiRechercheProduit determinerDelaiValiditeFaitGenerateur(Demande p_demande)
  {
    DelaiRechercheProduit delaiValiditeFgd = (DelaiRechercheProduit)((DossierAffectation)p_demande.getDossierAffectation()).getDelaiRecherche().copie();
    if (delaiValiditeFgd != null)
    {
      Chronologie chronoPeriodesPecIndemnisablesPrecedentes = OutillagePEC.getPeriodesPecFinAvantOuCoincideAvecDate(p_demande.getDemandeur(), p_demande.getDateExamen());
      if ((chronoPeriodesPecIndemnisablesPrecedentes != null) && (!chronoPeriodesPecIndemnisablesPrecedentes.estVide()))
      {
        ObjetChronoPeriodePriseEnCharge objetChronoPecPrecedente = (ObjetChronoPeriodePriseEnCharge)chronoPeriodesPecIndemnisablesPrecedentes.dernierElement();
        if (delaiValiditeFgd.getDebut().estAvant(objetChronoPecPrecedente.getDateFin()))
        {
          delaiValiditeFgd.setDebut(objetChronoPecPrecedente.getDateFin());
          if (delaiValiditeFgd.getDebut().estApres(delaiValiditeFgd.getFin())) {
            delaiValiditeFgd = null;
          }
        }
      }
    }
    return delaiValiditeFgd;
  }
  
  public ArrayList determinerOrdreObjectif(Demande p_demande)
    throws CoucheLogiqueException
  {
    CritereStrategie critere = new CritereStrategie();
    critere.setDatePivot(p_demande.getDateExamen());
    
    StrategieContexteRepriseSystematiqueSpec strategie = (StrategieContexteRepriseSystematiqueSpec)FabriqueStrategieContexteRepriseSystematique.getInstance().getStrategie(critere);
    
    ArrayList listeObjectifs = new ArrayList();
    
    listeObjectifs.addAll(strategie.determinerObjectifsExamenPourRepriseSystematique(p_demande));
    return listeObjectifs;
  }
}

/* Location:
 * Qualified Name:     StrategieFaitGenerateurDelaiValiditeApresMEP08SI1
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */