package fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.DeterminationCarenceIccpA4;
import fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.ConstructionBaseCarence;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.Salaire;
import fr.unedic.cali.outilsfonctionnels.ComparateurTemporelSurDateFinDecroissante;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;

public class StrategiePriseEnCompteIccpApres
  extends ConstructionBaseCarence
  implements StrategiePriseEnCompteIccpSpec
{
  public QuantiteEuro determinerMontantIccpALaFctOdRg(ActiviteSalarie p_periodeActiviteSalarie)
  {
    QuantiteEuro quantiteEuroIccpRetournee = null;
    
    quantiteEuroIccpRetournee = p_periodeActiviteSalarie.getQuantiteEuroIccp();
    if (quantiteEuroIccpRetournee == null)
    {
      Chronologie chronoPeriodesSalaireCourante = p_periodeActiviteSalarie.getListeSalaires();
      if ((chronoPeriodesSalaireCourante != null) && (!chronoPeriodesSalaireCourante.estVide()))
      {
        chronoPeriodesSalaireCourante.setComparateur(new ComparateurTemporelSurDateFinDecroissante());
        
        Salaire periodeSalaireFct = (Salaire)chronoPeriodesSalaireCourante.premierElement();
        
        BigDecimal montantIccpSalaireFct = null;
        if (p_periodeActiviteSalarie.getDateFin().estContenueDans(new Periode(periodeSalaireFct.getDateDebut(), periodeSalaireFct.getDateFin()))) {
          montantIccpSalaireFct = periodeSalaireFct.determinerMontantIccp();
        }
        if (montantIccpSalaireFct != null) {
          quantiteEuroIccpRetournee = new QuantiteEuro(montantIccpSalaireFct);
        }
      }
    }
    return quantiteEuroIccpRetournee;
  }
  
  public QuantiteEuro determinerMontantIccpA5(ActiviteSalarie p_periodeActiviteSalarie, Damj p_dateFg)
  {
    QuantiteEuro quantiteEuroIccpRetournee = null;
    BigDecimal cumulMontantsIccpA5 = null;
    
    QuantiteEuro quantiteEuroIccpCourante = p_periodeActiviteSalarie.getQuantiteEuroIccp();
    if (quantiteEuroIccpCourante != null) {
      cumulMontantsIccpA5 = quantiteEuroIccpCourante.getValeurMontant();
    }
    quantiteEuroIccpCourante = determinerMontantIccpA5Salaires(p_periodeActiviteSalarie, p_dateFg);
    if (quantiteEuroIccpCourante != null) {
      if (cumulMontantsIccpA5 == null) {
        cumulMontantsIccpA5 = quantiteEuroIccpCourante.getValeurMontant();
      } else {
        cumulMontantsIccpA5 = cumulMontantsIccpA5.add(quantiteEuroIccpCourante.getValeurMontant());
      }
    }
    if (cumulMontantsIccpA5 != null) {
      quantiteEuroIccpRetournee = new QuantiteEuro(cumulMontantsIccpA5);
    }
    return quantiteEuroIccpRetournee;
  }
  
  public BigDecimal determinerMontantIccpOdA4(ActiviteSalarie p_periodeActiviteSalarie, Damj p_finPeriodeAttributionAsuPrecedente, Damj p_finPeriodeAttributionAssPrecedente, boolean p_estUneChronoPendantAttribution)
  {
    return DeterminationCarenceIccpA4.getInstance().determinerMontantIccpOdA4Apres(p_periodeActiviteSalarie, p_finPeriodeAttributionAsuPrecedente, p_finPeriodeAttributionAssPrecedente, p_estUneChronoPendantAttribution);
  }
}

/* Location:
 * Qualified Name:     StrategiePriseEnCompteIccpApres
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */