package fr.unedic.cali.asu.cge01.p03.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDateAttribution;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionElementsSpec;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.DeterminationDateAttribution;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Damj;

public class ConstitutionDateAttributionFinDroit
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCEPA14 = new Resultat();
    
    Demande demande = DomLiquidationAssurance.getDemande(contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demande.getDossierExamen();
    ConstitutionDateAttribution constitutionDate = dossierExamenCourant.getConstitutionElementsActifs().createConstitutionDateAttribution();
    
    Damj dateAttribution = DeterminationDateAttribution.getInstance().determinerDateAttributionTheoriquePourFinDroit(demande);
    
    constitutionDate.setDateAttribution(dateAttribution);
    
    OutilTrace.tracerFinParcours();
    
    return resultatCEPA14;
  }
}

/* Location:
 * Qualified Name:     ConstitutionDateAttributionFinDroit
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */