package fr.unedic.cali.asu.cge01.p03.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.archi.util.trace.Log;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDateAttribution;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionElementsSpec;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.DeterminationDateAttribution;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Damj;

public class ConstitutionDateAttributionPourRevision
  extends ParcoursCali
  implements ParcoursAssurance
{
  public void controlerContexte(Contexte p_contexte)
    throws ContexteException
  {
    if (DomLiquidationAssurance.getDemande(p_contexte) == null) {
      throw new ContexteException("HG_PR_CALI_L_CONTEXTE_ABSENCE_DEMANDE_ASSURANCE", "Une demande est obligatoire pour ce produit. : ConstitutionDateAttributionPourRevision impossible");
    }
  }
  
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    if (Log.isTraceActive(ConstitutionDateAttributionPourRevision.class, Niveau.DEBUG))
    {
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDateAttributionPourRevision.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDateAttributionPourRevision.class, "demarrer", "\t\t******** Début Parcours ConstitutionCoefficientTempsPartielPourRevision ********");
    }
    Resultat resultat = new Resultat(0);
    
    Demande demande = DomLiquidationAssurance.getDemande(p_contexte);
    
    DossierExamen dossierExamenCourant = (DossierExamen)demande.getDossierExamen();
    
    ConstitutionDateAttribution constitutionDate = dossierExamenCourant.getConstitutionElementsActifs().createConstitutionDateAttribution();
    
    controlerContexte(p_contexte);
    
    Damj dateAttribution = DeterminationDateAttribution.getInstance().determinerDateAttributionTheoriquePourRevision(demande);
    
    constitutionDate.setDateAttribution(dateAttribution);
    if (Log.isTraceActive(ConstitutionCoefficientTempsPartielPourRevision.class, Niveau.DEBUG))
    {
      Log.ecritTrace(Niveau.DEBUG, ConstitutionCoefficientTempsPartielPourRevision.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDateAttributionPourRevision.class, "demarrer", "\t\t******** Résultat Parcours ConstitutionDateAttributionPourRevision ********\n" + resultat);
      
      Log.ecritTrace(Niveau.DEBUG, ConstitutionCoefficientTempsPartielPourRevision.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDateAttributionPourRevision.class, "demarrer", "\t\t******** Fin Parcours ConstitutionDateAttributionPourRevision ********\n");
    }
    return resultat;
  }
}

/* Location:
 * Qualified Name:     ConstitutionDateAttributionPourRevision
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */