package fr.unedic.cali.asu.cge01.p03.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.liquidation.dom.ResultatDeterminationDuree;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDurees;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionElementsSpec;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DureeIndemnisation;
import fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.DeterminationDureeReglementaire;
import fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.DeterminationDureeReglementaireAdhesionVolontaire;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;

public class ConstitutionDureeReglementaireRepriseAdhesionVolontaire
  extends ConstitutionDureePourReprise
{
  public Resultat demarrer(Contexte contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    Demande demande = DomLiquidationAssurance.getDemande(contexte);
    DossierExamen dossierExamen = (DossierExamen)demande.getDossierExamen();
    
    dossierExamen.getConstitutionElementsActifs().createConstitutionDurees();
    ConstitutionDurees constitutionDurees = dossierExamen.getConstitutionDurees();
    DureeIndemnisation dureeIndemnisation = constitutionDurees.createDureeIndemnisation();
    
    ResultatDeterminationDuree resultat = DeterminationDureeReglementaireAdhesionVolontaire.getInstanceAdhesionVolontaire().determinerDureeReglementairePourRepriseRevision(demande);
    
    DeterminationDureeReglementaireAdhesionVolontaire.getInstanceAdhesionVolontaire().mapperResultatSurDom(resultat, dureeIndemnisation);
    
    OutilTrace.tracerFinParcours();
    
    return new Resultat();
  }
}

/* Location:
 * Qualified Name:     ConstitutionDureeReglementaireRepriseAdhesionVolontaire
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */