package fr.unedic.cali.asu.cge01.p03.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionQuantiteAffiliation;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.RechercheQuantiteAppartenance;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.outilsfonctionnels.GestionDemandeDv122eJour;
import fr.unedic.cali.asu.parcours.ParcoursConstitutionQuantiteAffiliationDemandeASU;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;

public class ConstitutionQuantiteAffiliationDemandeASUPassageCPSuiteRejetDV
  extends ParcoursConstitutionQuantiteAffiliationDemandeASU
{
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    Demande demande = getDemande(p_contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demande.getDossierAffectation().getDossierExamen();
    
    Demande demandeRejetDv = GestionDemandeDv122eJour.retrouverDemandePortantDv(demande);
    if (demandeRejetDv != null)
    {
      ConstitutionQuantiteAffiliation qa = dossierExamenCourant.createConstitutionQuantiteAffiliation();
      
      ReglementApplicableSpec reglement = dossierExamenCourant.getReglementApplicable();
      if ((!reglement.getReglement().getLibelleCourt().equals("A9A")) && (!reglement.getReglement().getLibelleCourt().equals("A9B"))) {
        if (demandeRejetDv.getDonneesTemporaires() != null)
        {
          if (demandeRejetDv.getDonneesTemporaires().getQuantiteAffiliation() != null) {
            demande.getDonneesTemporaires().setQuantiteAffiliation(demandeRejetDv.getDonneesTemporaires().getQuantiteAffiliation());
          }
          if (demandeRejetDv.getDonneesTemporaires().getIdentifiantPeriodeFctARetenir() != null) {
            demande.getDonneesTemporaires().setIdentifiantPeriodeFctARetenir(demandeRejetDv.getDonneesTemporaires().getIdentifiantPeriodeFctARetenir());
          }
        }
      }
      qa = RechercheQuantiteAppartenance.rechercher(demande, false);
      if ((!reglement.getReglement().getLibelleCourt().equals("A9A")) && (!reglement.getReglement().getLibelleCourt().equals("A9B"))) {
        if (demandeRejetDv.getDonneesTemporaires() != null)
        {
          demande.getDonneesTemporaires().setQuantiteAffiliation(null);
          demande.getDonneesTemporaires().setIdentifiantPeriodeFctARetenir(null);
        }
      }
      if ((reglement.getReglement().getLibelleCourt().equals("A9A")) || (reglement.getReglement().getLibelleCourt().equals("A9B"))) {
        if (qa == null) {
          fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererException("ASU_PR_CALI_L_EXPATRIE_DF_AFFILIATION_EXAMEN_DV", 1);
        }
      }
      if (qa == null) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_DEMANDE_DV_MIGREE_AFFI_NULLE", new Object[] { demandeRejetDv.getDateExamen() });
      }
    }
    OutilTrace.tracerFinParcours();
    
    return new Resultat(0);
  }
}

/* Location:
 * Qualified Name:     ConstitutionQuantiteAffiliationDemandeASUPassageCPSuiteRejetDV
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */