package fr.unedic.cali.asu.cge01.p03.liquidation.parcours;

import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConditionMontantNonNul;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConditionsAttributionSpec;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.RechercheConditionMontantNonNul;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.ChronologiePeriodes;

public class DeterminationConditionMontantNonNul
  extends ParcoursCali
  implements ParcoursAssurance
{
  public void controlerContexte(Contexte p_contexte)
    throws ContexteException
  {
    if (DomLiquidationAssurance.getDemande(p_contexte) == null) {
      throw new ContexteException("HG_PR_CALI_L_CONTEXTE_ABSENCE_DEMANDE_ASSURANCE", "La demande d'assurance est null pour une détermination condition montant non nul.");
    }
  }
  
  public Resultat demarrer(Contexte p_contexte)
    throws CoucheLogiqueException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCapa18 = new Resultat(1);
    
    Demande demandeCourante = DomLiquidationAssurance.getDemande(p_contexte);
    
    ResultatElementDroit resultatElementDroit = RechercheConditionMontantNonNul.getInstance().rechercherConditionMontantNonNul(demandeCourante);
    
    ConditionMontantNonNul conditionMontantNonNul = ((DossierExamen)demandeCourante.getDossierExamen()).getConditionsAttributionActives().createConditionMontantNonNul();
    
    conditionMontantNonNul.setEtat(resultatElementDroit.getEtat());
    conditionMontantNonNul.setCodeMotifEchec(resultatElementDroit.getCodeMotifEchec());
    if (conditionMontantNonNul.estSatisfait())
    {
      resultatCapa18.setEtat(0);
    }
    else
    {
      if ((demandeCourante.getDemandeur().getChronoPensionsInvaliditeEtAvantagesVieillesse() == null) || (demandeCourante.getDemandeur().getChronoPensionsInvaliditeEtAvantagesVieillesse().estVide())) {
        fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_CAPA_MONTANT_NON_NUL_CAUSE_PI");
      }
      resultatCapa18.setEtat(1);
      resultatCapa18.setMessageErreur(Integer.toString(conditionMontantNonNul.getCodeMotifEchec()));
    }
    OutilTrace.tracerFinParcours();
    
    return resultatCapa18;
  }
}

/* Location:
 * Qualified Name:     DeterminationConditionMontantNonNul
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */