package fr.unedic.cali.asu.cge01.p04.liquidation.dom;

import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionCoefficientTempsPartielRevision;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDelaisReportsRevision;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDelaisReportsRevisionCsr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeEffective;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeEffectiveRevisionCsr;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ConstitutionDureeReglementaireRepriseRevision;
import fr.unedic.cali.asu.cge01.liquidation.parcours.DeterminationCompetencesProduitResultant;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ParcoursConstitutionSjcRevision;
import fr.unedic.cali.asu.cge01.liquidation.parcours.ParcoursConstitutionSjrRevision;
import fr.unedic.cali.asu.cge01.p04.liquidation.dom.gen.ObjectifExamenRevisionGen;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsChomageSansRCT;
import fr.unedic.cali.asu.produits.liquidation.parcours.ConstitutionMontantsBrutsRevision;
import fr.unedic.cali.dom.affectation.ContexteDemandeSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.services.Parcours;
import java.util.List;

public class ObjectifExamenRevision
  extends ObjectifExamenRevisionGen
{
  private static List<ContexteDemandeSpec> s_contexteDemande = null;
  private static final long serialVersionUID = -6574141057884168780L;
  
  public ObjectifExamenRevision(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public ObjectifExamenRevision() {}
  
  public ObjectifExamenRevision(List<ContexteDemandeSpec> p_contexteDemande)
  {
    s_contexteDemande = p_contexteDemande;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
  
  public ObjetMetierSpec copie()
  {
    ObjectifExamenRevision copie = new ObjectifExamenRevision();
    copieElements(copie);
    return copie;
  }
  
  public Parcours creerParcoursCoefficientTempsPartiel()
  {
    return new ConstitutionCoefficientTempsPartielRevision();
  }
  
  public Parcours creerParcoursDureeEffective()
  {
    if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(s_contexteDemande)) {
      return new ConstitutionDureeEffectiveRevisionCsr();
    }
    return new ConstitutionDureeEffective();
  }
  
  public Parcours creerParcoursSalaireJournalierConserve()
  {
    return new ParcoursConstitutionSjcRevision();
  }
  
  public Parcours creerParcoursSalaireJournalierDeReference()
  {
    return new ParcoursConstitutionSjrRevision();
  }
  
  public Parcours creerParcoursDeterminationCompetencesFinanceAdmDroitCourant()
  {
    return new DeterminationCompetencesProduitResultant();
  }
  
  public Parcours creerParcoursDureesReglementaires()
  {
    return new ConstitutionDureeReglementaireRepriseRevision();
  }
  
  public Parcours creerParcoursProduitResultant()
  {
    return null;
  }
  
  public Parcours creerParcoursDelaisReports()
  {
    if (OutilsChomageSansRCT.estUnContexteDeChomageEnCoursDeSuspension(s_contexteDemande)) {
      return new ConstitutionDelaisReportsRevisionCsr();
    }
    return new ConstitutionDelaisReportsRevision();
  }
  
  public Parcours creerParcoursMontantsBruts()
  {
    return new ConstitutionMontantsBrutsRevision();
  }
}

/* Location:
 * Qualified Name:     ObjectifExamenRevision
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */