package fr.unedic.cali.asu.cge01.p07.antecedent;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierExamenAssuranceSpec;
import fr.unedic.cali.asu.dom.SaisieAntecedent;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionDateLimiteIndemnisation;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionDurees;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.DureeIndemnisation;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsSpec;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.DeterminationDateLimiteIndemnisation;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.DeterminationMontantsBruts;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.ResultatDeterminationDateLimiteIndemnisation;
import fr.unedic.cali.dom.ContexteDemande;
import fr.unedic.util.services.CoucheLogiqueException;

public class GrapheAntecedent
  extends fr.unedic.cali.asu.cge01.antecedent.GrapheAntecedent
{
  public static GrapheAntecedent getInstance()
  {
    return new GrapheAntecedent();
  }
  
  protected void alimenterConstitutionMontantBrut(DossierExamenAssuranceSpec dossierExamen, SaisieAntecedent saisieAntecedent)
    throws CoucheLogiqueException
  {
    DeterminationMontantsBruts.getInstance().determinerMontantsBruts((Demande)dossierExamen.getDemande());
    DeterminationMontantsBruts.getInstance().alimentationCapitalDroitCourant((Demande)dossierExamen.getDemande());
  }
  
  protected void alimenterDateLimiteIndemnisation(Demande demande, DossierExamen dossierExamen, SaisieAntecedent saisieAntecedent)
    throws CoucheLogiqueException
  {
    ConstitutionDateLimiteIndemnisation dateLimiteIndemnisation = dossierExamen.getConstitutionElementsActifs().createConstitutionDateLimiteIndemnisation();
    
    ContexteDemande contexteDemande = (ContexteDemande)OutilGestionContexteDemande.trouverUnContexteDemandeAssurancePresent(demande, 2);
    if (contexteDemande != null) {
      dateLimiteIndemnisation.setDateLimiteIndem(contexteDemande.getDateFinJustifContexte());
    }
    if ((OutilGestionContexteDemande.estContexteDemandeAssurancePresent(demande, "ASPARE")) || (OutilGestionContexteDemande.estContexteDemandeAssurancePresent(demande, "ASPDC")))
    {
      ResultatDeterminationDateLimiteIndemnisation resultat = DeterminationDateLimiteIndemnisation.determinerDateLimiteIndemnisation(demande);
      dateLimiteIndemnisation.setDateLimiteIndem(resultat.getDateLimiteIndemnisation());
    }
  }
  
  protected void alimenterConstitutionDurees(DossierExamen dossierExamen, SaisieAntecedent saisieAntecedent)
    throws CoucheLogiqueException
  {
    super.alimenterConstitutionDurees(dossierExamen, saisieAntecedent);
    
    ConstitutionDurees constitutionDurees = dossierExamen.getConstitutionElementsActifs().getConstitutionDurees();
    DureeIndemnisation dureeIndemnisation = constitutionDurees.createDureeIndemnisation();
    dureeIndemnisation.setDureeAllongementAREF(saisieAntecedent.getDureeAllongementAREF());
    dureeIndemnisation.setEligibleAllongementAREF(saisieAntecedent.getDureeAllongementAREF() > 0);
  }
}

/* Location:
 * Qualified Name:     GrapheAntecedent
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */