package fr.unedic.cali.asu.cge01.parametres;

import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

public class ParametrageISLR
{
  private static ParametrageISLR instance;
  private static Map<Periode, BigDecimal> parametresISLR = new HashMap();
  private static final Damj DATE_DIVISEUR_ISLR_2014 = new Damj(2014, 7, 1);
  private static final Damj DATE_DIVISEUR_ISLR_2017 = new Damj(2017, 1, 1);
  private static final Damj DATE_DIVISEUR_ISLR_2018 = new Damj(2018, 1, 1);
  private static final BigDecimal QUATRE_VINGT_DIX = new BigDecimal("90");
  private static final BigDecimal QUATRE_VINGT_ONZE_VIRGULE_QUATRE = new BigDecimal("91.40");
  private static final BigDecimal QUATRE_VINGT_DOUZE_VIRGULE_SIX = new BigDecimal("92.60");
  
  static
  {
    parametresISLR.put(new Periode(DATE_DIVISEUR_ISLR_2018, Damj.FIN_DES_TEMPS), QUATRE_VINGT_DOUZE_VIRGULE_SIX);
    
    parametresISLR.put(new Periode(DATE_DIVISEUR_ISLR_2017, DATE_DIVISEUR_ISLR_2018.veille()), QUATRE_VINGT_ONZE_VIRGULE_QUATRE);
    
    parametresISLR.put(new Periode(DATE_DIVISEUR_ISLR_2014, DATE_DIVISEUR_ISLR_2017.veille()), QUATRE_VINGT_DIX);
  }
  
  public static synchronized ParametrageISLR getInstance()
  {
    if (instance == null) {
      instance = new ParametrageISLR();
    }
    return instance;
  }
  
  public BigDecimal recuperDiviseur(Damj dateApplication)
    throws CoucheLogiqueException
  {
    BigDecimal retour = null;
    Iterator<Periode> mesCles = parametresISLR.keySet().iterator();
    while (mesCles.hasNext())
    {
      Periode cleTemp = (Periode)mesCles.next();
      if (cleTemp.contient(dateApplication)) {
        return (BigDecimal)parametresISLR.get(cleTemp);
      }
    }
    return retour;
  }
}

/* Location:
 * Qualified Name:     ParametrageISLR
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */