package fr.unedic.cali.asu.cge01.parametres;

import fr.unedic.cali.asu.produits.liquidation.dom.Pra;
import fr.unedic.cali.asu.produits.liquidation.parametres.CleAccesPRA;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;
import java.util.Iterator;

public class ParametragePRAM
{
  public static final int PRA_3_MOIS = 3;
  private Collection m_listePRA;
  private static ParametragePRAM s_instance;
  private static final int UN = 1;
  
  public static ParametragePRAM getInstance()
  {
    if (s_instance == null) {
      s_instance = new ParametragePRAM();
    }
    return s_instance;
  }
  
  public ParametragePRAM()
  {
    initInstance();
  }
  
  private void initInstance()
  {
    m_listePRA = new ArrayList();
    
    Pra pra = new Pra("RG", 3, 1, 1);
    positionnerQuantiteAffiliationRequise(pra, 30, "jour d'affiliation");
    positionnerQuantiteAffiliationRequise(pra, 151, "heure de travail");
    ajouterPRASurCollection(pra);
    
    pra = new Pra("RGP", 3, 1, 1);
    positionnerQuantiteAffiliationRequise(pra, 30, "jour d'affiliation");
    positionnerQuantiteAffiliationRequise(pra, 151, "heure de travail");
    ajouterPRASurCollection(pra);
    
    pra = new Pra("OP", 3, 1, 1);
    positionnerQuantiteAffiliationRequise(pra, 30, "jour d'affiliation");
    positionnerQuantiteAffiliationRequise(pra, 139, "heure de travail");
    ajouterPRASurCollection(pra);
    
    pra = new Pra("A1", 3, 1, 1);
    positionnerQuantiteAffiliationRequise(pra, 30, "jour d'affiliation");
    ajouterPRASurCollection(pra);
    
    pra = new Pra("A2a", 3, 1, 1);
    positionnerQuantiteAffiliationRequise(pra, 30, "embarquement administratif");
    positionnerQuantiteAffiliationRequise(pra, 210, "heure de travail");
    ajouterPRASurCollection(pra);
    
    pra = new Pra("A2b", 3, 1, 1);
    positionnerQuantiteAffiliationRequise(pra, 30, "embarquement administratif");
    ajouterPRASurCollection(pra);
    
    pra = new Pra("A3", 3, 1, 1);
    positionnerQuantiteAffiliationRequise(pra, 45, "vacation");
    ajouterPRASurCollection(pra);
    
    pra = new Pra("A4", 3, 1, 1);
    positionnerQuantiteAffiliationRequise(pra, 151, "heure de travail");
    ajouterPRASurCollection(pra);
    
    pra = new Pra("A5", 3, 1, 1);
    positionnerQuantiteAffiliationRequise(pra, 151, "heure de travail");
    ajouterPRASurCollection(pra);
    
    pra = new Pra("A9A", 3, 1, 1);
    positionnerQuantiteAffiliationRequise(pra, 30, "jour d'affiliation");
    positionnerQuantiteAffiliationRequise(pra, 151, "heure de travail");
    ajouterPRASurCollection(pra);
    
    pra = new Pra("A9B", 3, 1, 1);
    positionnerQuantiteAffiliationRequise(pra, 30, "jour d'affiliation");
    ajouterPRASurCollection(pra);
  }
  
  public Pra getPram(CleAccesPRA p_cle)
  {
    Iterator it = m_listePRA.iterator();
    while (it.hasNext())
    {
      Pra pra = (Pra)it.next();
      if (pra.estApplicable(p_cle)) {
        return (Pra)pra.copie();
      }
    }
    return null;
  }
  
  private void ajouterPRASurCollection(Pra p_pra)
  {
    m_listePRA.add(p_pra);
  }
  
  private void positionnerQuantiteAffiliationRequise(Pra p_pra, int p_quantite, String p_uniteAffiliation)
  {
    Unite unite = Unite.get(p_uniteAffiliation);
    Quantite quantite = new Quantite(p_quantite, unite);
    p_pra.getListeQuantitesAffiliationRequises().put(unite, quantite);
  }
}

/* Location:
 * Qualified Name:     ParametragePRAM
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */