package fr.unedic.cali.asu.csa06.liquidation.outilsfonctionnels.fabriques;

import fr.unedic.cali.asu.csa06.liquidation.outilsfonctionnels.strategies.StrategieContexteRepriseSystematiqueApresARE14;
import fr.unedic.cali.asu.csa06.liquidation.outilsfonctionnels.strategies.StrategieContexteRepriseSystematiqueAvantARE14;
import fr.unedic.cali.fabriques.FabriqueConvention2014;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;

public class FabriqueStrategieContexteRepriseSystematique
  extends FabriqueConvention2014
{
  private static FabriqueStrategieContexteRepriseSystematique instance = new FabriqueStrategieContexteRepriseSystematique();
  
  public static FabriqueStrategieContexteRepriseSystematique getInstance()
  {
    return instance;
  }
  
  public StrategieSpec getStrategie(CritereStrategie critereStrategie)
    throws CoucheLogiqueException
  {
    StrategieSpec retour = null;
    
    Damj datePivot = critereStrategie.getDatePivot();
    if (datePivot == null) {
      throw new UnsupportedOperationException("FabriqueStrategieContexteRepriseSystematique : la date pivot est null.");
    }
    if (datePivot.estApresOuCoincideAvec(DATE_APPLICATION)) {
      retour = getStrategieApres();
    } else {
      retour = getStrategieAvant();
    }
    return retour;
  }
  
  protected StrategieSpec getStrategieAvant()
  {
    return new StrategieContexteRepriseSystematiqueAvantARE14();
  }
  
  protected StrategieSpec getStrategieApres()
  {
    return new StrategieContexteRepriseSystematiqueApresARE14();
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieContexteRepriseSystematique
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */