package fr.unedic.cali.asu.csa06.p01.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.csa06.p01.liquidation.dom.DureeIndemnisation;
import fr.unedic.cali.asu.csa06.p01.parametres.AccesDureeDroit;
import fr.unedic.cali.asu.csa06.p01.parametres.CleAccesDureeDroit;
import fr.unedic.cali.asu.csa06.p01.parametres.ValeurDureeDroit;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.OutilFonctionnel;

public class DeterminationDureeReglementaire
  implements OutilFonctionnel
{
  public static DureeIndemnisation determinerDureeReglementaire()
  {
    DureeIndemnisation dureeReglementaire = null;
    
    int dureeTheoriqueDroitCourant = determinerDureeTheoriqueDroitCourant();
    Quantite qteDureeTheorique = new Quantite(dureeTheoriqueDroitCourant, DureeIndemnisation.UNITE_DEFAUT);
    
    int dureeImputationDroitCourant = 0;
    Quantite qteDureeImputation = new Quantite(dureeImputationDroitCourant, DureeIndemnisation.UNITE_DEFAUT);
    
    dureeReglementaire = new DureeIndemnisation(dureeTheoriqueDroitCourant, dureeImputationDroitCourant);
    
    dureeReglementaire.setDureeEffective(qteDureeTheorique.moins(qteDureeImputation));
    
    return dureeReglementaire;
  }
  
  private static int determinerDureeTheoriqueDroitCourant()
  {
    int dureeTheorique = 0;
    
    CleAccesDureeDroit cleAccesDureeDroit = new CleAccesDureeDroit();
    AccesDureeDroit accesDureeDroit = new AccesDureeDroit();
    ValeurDureeDroit valeurDureeDroit = (ValeurDureeDroit)accesDureeDroit.getValeurs(cleAccesDureeDroit);
    if (valeurDureeDroit != null) {
      dureeTheorique = valeurDureeDroit.getDureeTheorique();
    }
    return dureeTheorique;
  }
}

/* Location:
 * Qualified Name:     DeterminationDureeReglementaire
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */