package fr.unedic.cali.asu.csa06.p01.liquidation.parcours;

import fr.unedic.archi.util.trace.Log;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.ConstitutionDurees;
import fr.unedic.cali.asu.cge01.p02.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.csa06.p01.liquidation.dom.DureeIndemnisation;
import fr.unedic.cali.asu.csa06.p01.liquidation.outilsfonctionnels.DeterminationDureeReglementaire;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;

public class ConstitutionDureeReglementaire
  extends ParcoursCali
  implements ParcoursAssurance
{
  public void controlerContexte(Contexte p_contexte)
    throws ContexteException
  {}
  
  public Resultat demarrer(Contexte p_contexte)
    throws CoucheLogiqueException
  {
    if (Log.isTraceActive(ConstitutionDureeReglementaire.class, Niveau.DEBUG)) {
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDureeReglementaire.class, "demarrer", "\t\t******** Début Parcours ConstitutionDureeReglementaire ********\n");
    }
    Resultat resultatCEPA02 = new Resultat(0);
    
    Demande demande = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demande.getDossierExamen();
    
    ConstitutionDurees constitutionDurees = new ConstitutionDurees();
    
    DureeIndemnisation dureeIndemnisation = null;
    
    dureeIndemnisation = DeterminationDureeReglementaire.determinerDureeReglementaire();
    
    constitutionDurees.ajouterDuree(dureeIndemnisation);
    
    dossierExamenCourant.setConstitutionDurees(constitutionDurees);
    if (Log.isTraceActive(ConstitutionDureeReglementaire.class, Niveau.DEBUG)) {
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDureeReglementaire.class, "demarrer", "\t\t******** Fin Parcours ConstitutionDureeReglementaire ********\n");
    }
    return resultatCEPA02;
  }
}

/* Location:
 * Qualified Name:     ConstitutionDureeReglementaire
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */