package fr.unedic.cali.asu.csa06.p02.parametres;

import fr.unedic.cali.asu.csa06.p02.parametres.spec.ParametresSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import fr.unedic.util.UniteAffiliation;
import java.util.Hashtable;

public class Parametres
  implements ParametresSpec
{
  private static final int DUREE_PRA_MOIS = 22;
  private static final int QUANTITE_APPARTENANCE_REQUISE_HEURES = 910;
  private static final int QUANTITE_APPARTENANCE_REQUISE_JOURS = 182;
  private static final int QUANTITE_APPARTENANCE_REQUISE_SUITE_DV_HEURES = 455;
  private static final int QUANTITE_APPARTENANCE_REQUISE_SUITE_DV_JOURS = 91;
  public static final int QUANTITE_MAXI_DUREE_INITALE_ANTECEDENT_CSA = 122;
  
  public Quantite getQuantiteAffiliationRequise(Unite p_unite)
  {
    Quantite quantiteRequise;
    Quantite quantiteRequise;
    if (UniteAffiliation.JOUR.equals(p_unite)) {
      quantiteRequise = new Quantite(182, p_unite);
    } else {
      quantiteRequise = new Quantite(910, p_unite);
    }
    return quantiteRequise;
  }
  
  public Quantite getQuantiteAffiliationRequiseSuiteDV(Unite p_unite)
  {
    Quantite quantiteRequise;
    Quantite quantiteRequise;
    if (UniteAffiliation.JOUR.equals(p_unite)) {
      quantiteRequise = new Quantite(91, p_unite);
    } else {
      quantiteRequise = new Quantite(455, p_unite);
    }
    return quantiteRequise;
  }
  
  public Quantite getDureePraEnMois()
  {
    return new Quantite(22, Unite.get("mois"));
  }
  
  public Hashtable getListeQuantiteAssimilationMax()
  {
    return new Hashtable();
  }
}

/* Location:
 * Qualified Name:     Parametres
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */