package fr.unedic.cali.asu.csa06.p5b.calcul;

import fr.unedic.cali.asu.csa06.p5b.calcul.dom.FormuleMontantAREF;
import fr.unedic.cali.asu.csa06.p5b.calcul.dom.FormuleMontantRegimeGeneral;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisationAREF;
import fr.unedic.cali.calcul.OutillageQuantites;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.FormuleMontantAREFSpec;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.QuantiteIndemnisationSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Periode;

public class FacadeCalculProduitImpl
  extends fr.unedic.cali.asu.cge01.p6b.calcul.FacadeCalculProduitImpl
{
  private static final String ANCIEN_CODE_FORMULE_MONTANT_CSA = "3";
  private static final String ANCIEN_CODE_FORMULE_MONTANT_CSA_AREF = "4";
  
  public FormuleMontantSpec getFormuleMontant(String p_code)
  {
    FormuleMontantSpec fm = null;
    if ((FormuleMontantAREF.getCode().equals(p_code)) || ("4".equals(p_code))) {
      fm = new FormuleMontantAREF();
    } else if ((FormuleMontantRegimeGeneral.getCode().equals(p_code)) || ("3".equals(p_code))) {
      fm = new FormuleMontantRegimeGeneral();
    }
    return fm;
  }
  
  public void initialiseElementBaseIndemnisationCourante(ConstituantsIndemnisation p_constituantsIndemnisation, AttributionSpec p_attribution, Periode p_periodeUT)
    throws CoucheLogiqueException
  {
    super.initialiseElementBaseIndemnisationCourante(p_constituantsIndemnisation, p_attribution, p_periodeUT);
    FormuleMontantSpec formuleMontant = null;
    ElementBaseIndemnisationAREF elementBaseIndemnisationAREF = null;
    
    QuantiteIndemnisationSpec duree = OutillageQuantites.recupererPremiereQuantiteIndemnisationActive(p_constituantsIndemnisation.getCollectionQuantiteDroit());
    if (duree != null) {
      formuleMontant = p_attribution.getFormuleMontant(duree.getCodeFormuleMontant());
    } else {
      formuleMontant = p_attribution.getFormuleMontant(p_constituantsIndemnisation.getCodeFormuleMontant());
    }
    if ((formuleMontant instanceof FormuleMontantAREFSpec))
    {
      elementBaseIndemnisationAREF = new ElementBaseIndemnisationAREF((ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant());
      p_constituantsIndemnisation.setElementBaseIndemnisationCourant(elementBaseIndemnisationAREF);
    }
  }
}

/* Location:
 * Qualified Name:     FacadeCalculProduitImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */