package fr.unedic.cali.asu.csa06.parametres;

import fr.unedic.cali.asu.csa06.parametres.spec.ParametresSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import fr.unedic.util.UniteAffiliation;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import java.util.Hashtable;

public class Parametres
  implements ParametresSpec
{
  private static final int DUREE_PRA_MOIS_DE_MOINS_50_ANS = 28;
  private static final int DUREE_PRA_MOIS_DE_50_ANS_ET_PLUS = 36;
  private static final int AGE_PIVOT_PRA = 50;
  protected static final int QUANTITE_APPARTENANCE_REQUISE_HEURES = 610;
  private static final int QUANTITE_APPARTENANCE_REQUISE_JOURS = 122;
  protected static final int QUANTITE_APPARTENANCE_REQUISE_SUITE_DV_HEURES = 455;
  private static final int QUANTITE_APPARTENANCE_REQUISE_SUITE_DV_JOURS = 91;
  public static final int QUANTITE_MAXI_DUREE_INITALE_ANTECEDENT_CSA = 122;
  private Demande demande;
  private int ageDE;
  
  public Parametres(DemandeSpec demande)
  {
    this.demande = ((Demande)demande);
    Damj dateRechercheAgeDE = ((DossierAffectation)this.demande.getDossierAffectation()).getSinistre().getDateFin();
    ageDE = this.demande.getDemandeur().getAgeALaDate(dateRechercheAgeDE).getAnnees();
  }
  
  public Quantite getQuantiteAffiliationRequise(Unite unite)
  {
    Quantite quantiteRequise;
    Quantite quantiteRequise;
    if (UniteAffiliation.JOUR.equals(unite)) {
      quantiteRequise = new Quantite(122, unite);
    } else {
      quantiteRequise = new Quantite(610, unite);
    }
    return quantiteRequise;
  }
  
  public Quantite getQuantiteAffiliationRequiseSuiteDV(Unite unite)
  {
    Quantite quantiteRequise;
    Quantite quantiteRequise;
    if (UniteAffiliation.JOUR.equals(unite)) {
      quantiteRequise = new Quantite(91, unite);
    } else {
      quantiteRequise = new Quantite(455, unite);
    }
    return quantiteRequise;
  }
  
  public Hashtable getListeQuantiteAssimilationMax()
  {
    Hashtable hashquantiteAssimilationMax = new Hashtable();
    return hashquantiteAssimilationMax;
  }
  
  public Quantite getDureePraEnMois()
  {
    if (ageDE < 50) {
      return new Quantite(28, Unite.get("mois"));
    }
    return new Quantite(36, Unite.get("mois"));
  }
}

/* Location:
 * Qualified Name:     Parametres
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */