package fr.unedic.cali.asu.csr04.p01.liquidation.parcours;

import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.DeterminationDateOdTheorique;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.outilsfonctionnels.OutillagePEC;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Damj;

public class ConstitutionDateAttribution
  extends fr.unedic.cali.asu.cge01.p03.liquidation.parcours.ConstitutionDateAttribution
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte p_contexte)
    throws CoucheLogiqueException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCEPA14 = new Resultat(0);
    
    Demande demande = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demande.getDossierExamen();
    
    fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDateAttribution constitutionDate = dossierExamenCourant.createConstitutionDateAttribution();
    if (verifierPreconditions(p_contexte))
    {
      Damj dateAttribution = null;
      if (demande.getDonneesTemporaires().getNouvelleDateAttributionChomageTotalSansRupture() != null)
      {
        verifierDateAttributionForcee(demande, demande.getDonneesTemporaires().getNouvelleDateAttributionChomageTotalSansRupture());
        dateAttribution = demande.getDonneesTemporaires().getNouvelleDateAttributionChomageTotalSansRupture();
      }
      else
      {
        Damj dateOdTheorique = DeterminationDateOdTheorique.determinerDateAttributionTheoriquePourAdmission(demande);
        
        Damj dateAttributionCP = demande.getDonneesTemporaires().getDateAttributionCPChomageTotalSansRupture();
        if (dateAttributionCP != null) {
          verifierDateAttributionForcee(demande, dateAttributionCP);
        }
        dateAttribution = Damj.max(dateAttributionCP, dateOdTheorique);
      }
      constitutionDate.setDateAttribution(dateAttribution);
    }
    OutilTrace.ecrireTrace(Niveau.DEBUG, new Object[] { "\t\t******** Résultat Parcours ConstitutionDateAttribution ********\n", resultatCEPA14 });
    OutilTrace.tracerFinParcours();
    return resultatCEPA14;
  }
  
  private void verifierDateAttributionForcee(Demande p_demande, Damj p_dateAttributionForcee)
    throws CoucheLogiqueException
  {
    if (!OutillagePEC.estContenueDansUnePecIndemnisable(p_demande.getDemandeur(), p_dateAttributionForcee)) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ALERTE_A11MB22");
    }
  }
}

/* Location:
 * Qualified Name:     ConstitutionDateAttribution
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */