package fr.unedic.cali.asu.csr04.p01.liquidation.parcours;

import fr.unedic.archi.util.trace.Log;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.cge01.p03.liquidation.outilsfonctionnels.DeterminationDateOdTheorique;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Damj;

public class ConstitutionDateAttributionPourReprise
  extends fr.unedic.cali.asu.cge01.p03.liquidation.parcours.ConstitutionDateAttributionPourReprise
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte p_contexte)
    throws CoucheLogiqueException
  {
    if (Log.isTraceActive(ConstitutionDateAttribution.class, Niveau.DEBUG))
    {
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDateAttribution.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDateAttribution.class, "demarrer", "\t\t******** Début Parcours ConstitutionDateAttribution ********");
    }
    Resultat resultatCEPA14 = new Resultat(0);
    
    Demande demande = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demande.getDossierExamen();
    
    fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDateAttribution constitutionDate = dossierExamenCourant.createConstitutionDateAttribution();
    if (verifierPreconditions(p_contexte))
    {
      Damj dateAttribution = null;
      if (demande.getDonneesTemporaires().getNouvelleDateAttributionChomageTotalSansRupture() != null)
      {
        dateAttribution = demande.getDonneesTemporaires().getNouvelleDateAttributionChomageTotalSansRupture();
      }
      else
      {
        Damj dateReprise = DeterminationDateOdTheorique.determinerDateAttributionTheoriquePourReprise(demande);
        
        Damj dateAttributionCP = demande.getDonneesTemporaires().getDateAttributionCPChomageTotalSansRupture();
        
        dateAttribution = Damj.max(dateAttributionCP, dateReprise);
      }
      constitutionDate.setDateAttribution(dateAttribution);
    }
    if (Log.isTraceActive(ConstitutionDateAttribution.class, Niveau.DEBUG))
    {
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDateAttribution.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDateAttribution.class, "demarrer", "\t\t******** Résultat Parcours ConstitutionDateAttribution ********\n" + resultatCEPA14);
      
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDateAttribution.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, ConstitutionDateAttribution.class, "demarrer", "\t\t******** Fin Parcours ConstitutionDateAttribution ********\n");
    }
    return resultatCEPA14;
  }
}

/* Location:
 * Qualified Name:     ConstitutionDateAttributionPourReprise
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */