package fr.unedic.cali.asu.csr04.p01.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.ConstitutionDurees;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.cge01.p03.liquidation.dom.DureeIndemnisation;
import fr.unedic.cali.asu.csr04.liquidation.outilsfonctionnels.DeterminationDureeEffective;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;
import java.math.BigDecimal;

public class ConstitutionDureeEffective
  extends fr.unedic.cali.asu.cge01.p03.liquidation.parcours.ConstitutionDureeEffective
{
  public Resultat demarrer(Contexte p_contexte)
    throws CoucheLogiqueException, ApplicativeException
  {
    Resultat resultat = super.demarrer(p_contexte);
    Demande demande = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamen = (DossierExamen)demande.getDossierExamen();
    DureeIndemnisation dureeIndemnisation = dossierExamen.getConstitutionDurees().getDureeIndemnisation();
    Quantite dureeEffective = dureeIndemnisation.getDureeEffective();
    DeterminationDureeEffective determinationDureeEffective = DeterminationDureeEffective.getInstance();
    
    BigDecimal dureeEffectiveBornee = determinationDureeEffective.bornerDureeEffective(demande, dureeEffective.getValeur(), true, null);
    determinationDureeEffective.controleDuree(dureeEffectiveBornee, demande);
    return resultat;
  }
}

/* Location:
 * Qualified Name:     ConstitutionDureeEffective
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */