package fr.unedic.cali.asu.cva10.antecedent;

import fr.unedic.cali.asu.antecedent.GestionAntecedentCalculAsu;
import fr.unedic.cali.asu.antecedent.GestionAntecedentCalculAsuSpec;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.SaisieAntecedent;
import fr.unedic.cali.asu.produits.liquidation.dom.Antecedent;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalculSpec;
import fr.unedic.cali.calcul.dom.EtatAuDji;
import fr.unedic.cali.dom.AttributionSpec;

public class GestionAntecedentCalcul
  extends GestionAntecedentCalculAsu
{
  public static GestionAntecedentCalculAsuSpec getInstance()
  {
    return new GestionAntecedentCalcul();
  }
  
  public void alimenterGrapheCalcul(AttributionSpec p_attribution)
  {
    AttributionAssuranceSpec antecedent = (AttributionAssuranceSpec)p_attribution;
    SaisieAntecedent saisieAntecedent = ((Antecedent)antecedent).getSaisieAntecedent();
    alimenterCalendrierExecutionCalculPendant(antecedent, saisieAntecedent);
  }
  
  protected void alimenterEtatAuDJI(AttributionAssuranceSpec p_antecedent, SaisieAntecedent p_saisieAntecedent)
  {
    super.alimenterEtatAuDJI(p_antecedent, p_saisieAntecedent);
    if (p_saisieAntecedent.getCumulMoisActiviteReduite() != null) {
      p_antecedent.getCalendrierExecutionCalcul().getEtatAuDJI().setCumulJoursAR(p_saisieAntecedent.getCumulMoisActiviteReduite().intValue());
    }
  }
}

/* Location:
 * Qualified Name:     GestionAntecedentCalcul
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */