package fr.unedic.cali.asu.cva10.p01.calcul.dom;

import fr.unedic.cali.asu.cva10.p01.calcul.dom.gen.MontantASRDCFGen;
import fr.unedic.cali.asu.cva10.p01.calcul.dom.pc.MontantASRDCFPC;
import fr.unedic.cali.dom.MontantAREFSpec;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.util.ObjetMetierSpec;

public class MontantASRDCF
  extends MontantASRDCFGen
  implements DomGenSpec, MontantAREFSpec
{
  private static final long serialVersionUID = 1L;
  
  private MontantASRDCF() {}
  
  public MontantASRDCF(Montant p_montant)
  {
    setMontantBrut(p_montant.getMontantBrut());
    setCrc(p_montant.getCrc());
    setBase(p_montant.getBase());
    setBaseCalculCrc(p_montant.getBaseCalculCrc());
    setCrds(p_montant.getCrds());
    setCsg(p_montant.getCsg());
    setJustificationCalculMontant(p_montant.getJustificationCalculMontant());
    setMini(p_montant.getMini());
    setMontantBrutSansPensionInvaliditeADeduire(p_montant.getMontantBrutSansPensionInvaliditeADeduire());
    setPensionInvaliditeADeduirePriseEnCompte(p_montant.getPensionInvaliditeADeduirePriseEnCompte());
    setPlafond(p_montant.getPlafond());
    setPlancher(p_montant.getPlancher());
    setPositionExonerationCrc(p_montant.getPositionExonerationCrc());
    setTauxCrc(p_montant.getTauxCrc());
    setTotalCotisationContribution(p_montant.getTotalCotisationContribution());
    setType("FORMATION PREVISIONNELLE");
    setSjrNonReduit(getSjrNonReduit());
    setMontant80PcentPreavis(getMontant80PcentPreavis());
  }
  
  public MontantASRDCF(MontantASRDCFPC p_montant)
  {
    super(p_montant);
  }
  
  public ObjetMetierSpec copie()
  {
    MontantASRDCF copie = new MontantASRDCF();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    MontantASRDCF copie = (MontantASRDCF)p_copie;
    super.copieElements(copie);
  }
}

/* Location:
 * Qualified Name:     MontantASRDCF
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */