package fr.unedic.cali.asu.cva10.p01.liquidation.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.outilsfonctionnels.OutilAsr;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.DureeIndemnisation;
import fr.unedic.util.Quantite;
import fr.unedic.util.UniteAffiliation;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.PasAssezInformationException;

public class DeterminationDureeEffective
  extends fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.DeterminationDureeEffective
{
  public static fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.DeterminationDureeEffective getInstance()
  {
    return new DeterminationDureeEffective();
  }
  
  public DureeIndemnisation determinerDureeEffective(Demande p_demande)
    throws PasAssezInformationException, CoucheLogiqueException, ApplicativeException
  {
    DossierExamen dossierExamen = (DossierExamen)p_demande.getDossierExamen();
    DureeIndemnisation dureeIndemnisation = super.determinerDureeEffective(p_demande);
    
    int dureeEffectiveDc = OutilAsr.trouverDureeADateLimiteIndemnisation(dossierExamen);
    dureeIndemnisation.setDureeEffective(new Quantite(dureeEffectiveDc, UniteAffiliation.JOUR));
    return dureeIndemnisation;
  }
}

/* Location:
 * Qualified Name:     DeterminationDureeEffective
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */