package fr.unedic.cali.asu.cva10.p01.liquidation.parcours;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.OdAssuranceSpec;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.asu.outilsfonctionnels.ContributionsParticulieres;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.ContributionParticuliere;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.Indemnite;
import fr.unedic.cali.outilsfonctionnels.OutilDemande;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;
import java.util.Collection;
import java.util.Iterator;

public class ParcoursDetecterContributionParticuliere
  extends ParcoursCali
{
  public Resultat demarrer(Contexte p_contexte)
  {
    OutilTrace.tracerDebutParcours();
    
    Demande demandeCourante = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demandeCourante.getDossierExamen();
    ContributionParticuliere contributionParticuliere = new ContributionParticuliere();
    if (ContributionsParticulieres.estDecisionPourAppelDetecContribPart((OdAssuranceSpec)dossierExamenCourant))
    {
      boolean topDetectionContributionPreavis = false;
      boolean topDetectionContributionDif = false;
      
      Demande demande = (Demande)dossierExamenCourant.getDemande();
      ValidationProduit validationProduit = ((DossierAffectation)demande.getDossierAffectation()).getValidationProduit();
      if ((validationProduit != null) && (validationProduit.isEstProduitValide()) && (validationProduit.getPeriodeValidationProduit() != null))
      {
        Collection listeIndemnites = validationProduit.getPeriodeValidationProduit().getListeIndemnites();
        if (listeIndemnites != null)
        {
          Iterator it = listeIndemnites.iterator();
          while (it.hasNext())
          {
            Indemnite indemnitePeriode = (Indemnite)it.next();
            int typeIndemnite = indemnitePeriode.getTypeIndemnite();
            switch (typeIndemnite)
            {
            case 124: 
              if (indemnitePeriode.getMontant() != null) {
                topDetectionContributionPreavis = true;
              }
              break;
            case 126: 
              if (indemnitePeriode.getMontant() != null) {
                topDetectionContributionDif = true;
              }
              break;
            }
          }
        }
      }
      if (OutilDemande.estUneDemandeAsr(dossierExamenCourant.getDemande()))
      {
        if ((topDetectionContributionPreavis) && (topDetectionContributionDif)) {
          contributionParticuliere.setTypeContributionParticuliere(6);
        } else if ((topDetectionContributionPreavis) && (!topDetectionContributionDif)) {
          contributionParticuliere.setTypeContributionParticuliere(5);
        } else if ((topDetectionContributionDif) && (!topDetectionContributionPreavis)) {
          contributionParticuliere.setTypeContributionParticuliere(7);
        } else {
          contributionParticuliere.setTypeContributionParticuliere(0);
        }
        dossierExamenCourant.setContributionParticuliere(contributionParticuliere);
      }
    }
    OutilTrace.tracerFinParcours();
    return new Resultat();
  }
}

/* Location:
 * Qualified Name:     ParcoursDetecterContributionParticuliere
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */