package fr.unedic.cali.asu.cva10.p03.calcul;

import fr.unedic.cali.asu.cva10.calcul.FacadeCalculLignePourLiquidationCVA10Impl;
import fr.unedic.cali.asu.cva10.p03.calcul.dom.FormuleMontantASPDCPostPrime;
import fr.unedic.cali.asu.cva10.p03.calcul.dom.FormuleMontantRegimeGeneralASPDCP03;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.cali.dom.conteneurs.DonneesCalculMontant;
import fr.unedic.cali.dom.conteneurs.DonneesCalculMontantAsp;
import fr.unedic.cali.dom.conteneurs.DonneesEntreesRecuperationMontant;
import fr.unedic.util.services.CoucheLogiqueException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

public class FacadeCalculProduitPourLiquidationImpl
  extends FacadeCalculLignePourLiquidationCVA10Impl
{
  public MontantBaseSpec determinerMontant(DonneesEntreesRecuperationMontant donneesEntreesRecuperationMontant)
    throws CoucheLogiqueException
  {
    FormuleMontantSpec fm = null;
    
    Iterator<DonneesEntreesRecuperationMontant> iteDERM = donneesEntreesRecuperationMontant.getDonneesCalculMontantAsp().getListeDonneesEntreesRecuperationMontant().iterator();
    
    List<ElementBaseIndemnisation> listeSousEbi = new ArrayList();
    while (iteDERM.hasNext())
    {
      DonneesEntreesRecuperationMontant sousDERM = (DonneesEntreesRecuperationMontant)iteDERM.next();
      sousDERM.setDateCalculMontant(donneesEntreesRecuperationMontant.getDateCalculMontant());
      sousDERM.setIndividu(donneesEntreesRecuperationMontant.getIndividu());
      listeSousEbi.add((ElementBaseIndemnisation)super.initialiserConstituantsIndemnisation(sousDERM).getElementBaseIndemnisationCourant());
    }
    ConstituantsIndemnisation constituantsIndemnisation = super.initialiserConstituantsIndemnisation(donneesEntreesRecuperationMontant);
    ((ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant()).setListeSousEBI(listeSousEbi);
    
    DonneesCalculMontant donneesCalculMontant = donneesEntreesRecuperationMontant.getDonneesCalculMontant();
    if (donneesEntreesRecuperationMontant.getDonneesCalculMontantAsp().isEstDureePostPrimeEpuisee()) {
      fm = getFormuleMontantDureePostPrime();
    } else if (donneesCalculMontant.getFormuleMontant() != null) {
      fm = donneesCalculMontant.getFormuleMontant();
    } else if (donneesCalculMontant.isContexteFormation()) {
      fm = getFormuleMontantEnFormation();
    } else {
      fm = getFormuleMontant();
    }
    return fm.calculer(constituantsIndemnisation, donneesEntreesRecuperationMontant.getDateCalculMontant());
  }
  
  public FormuleMontantSpec getFormuleMontant()
  {
    return new FormuleMontantRegimeGeneralASPDCP03();
  }
  
  public FormuleMontantSpec getFormuleMontantDureePostPrime()
  {
    return new FormuleMontantASPDCPostPrime();
  }
}

/* Location:
 * Qualified Name:     FacadeCalculProduitPourLiquidationImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */