package fr.unedic.cali.asu.cva10.p03.calcul.dom;

import fr.unedic.cali.asu.cva10.calcul.dom.MontantASPDCF;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisationAREF;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.dom.FormuleMontantAREFSpec;
import fr.unedic.cali.dom.FormuleMontantSpec;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;

public class FormuleMontantASPDCFAvecFinancement
  extends FormuleMontantRegimeGeneralASPDCAvecFinancement
  implements FormuleMontantAREFSpec
{
  private FormuleMontantSpec formuleMontantDroitAssocie;
  private int formuleMontantApplicable = 1;
  
  public static String getCode()
  {
    return "4";
  }
  
  public MontantBaseSpec calculer(ConstituantsIndemnisation constituantsIndemnisation, Damj dateCalcul)
    throws CoucheLogiqueException
  {
    Montant montant = (Montant)super.calculer(constituantsIndemnisation, dateCalcul);
    MontantASPDCF montantAPSDCF = new MontantASPDCF(montant);
    
    ElementBaseIndemnisationAREF ebiASPF = (ElementBaseIndemnisationAREF)constituantsIndemnisation.getElementBaseIndemnisationCourant();
    if ((ebiASPF != null) && (ebiASPF.estEffectif())) {
      montantAPSDCF.setType("FORMATION EFFECTIVE");
    }
    return montantAPSDCF;
  }
  
  public FormuleMontantSpec getFormuleMontantDroitAssocie()
  {
    return formuleMontantDroitAssocie;
  }
  
  public int getFormuleMontantApplicable()
  {
    return formuleMontantApplicable;
  }
  
  public void setFormuleMontantDroitAssocie(FormuleMontantSpec fMDroitAssocie)
  {
    formuleMontantDroitAssocie = fMDroitAssocie;
  }
  
  public void setFormuleMontantApplicable(int fMApplicable)
  {
    formuleMontantApplicable = fMApplicable;
  }
}

/* Location:
 * Qualified Name:     FormuleMontantASPDCFAvecFinancement
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */