package fr.unedic.cali.asu.cva10.p03.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DecisionSpec;

public class OutilDeterminationCodeSousProduit
{
  public static OutilDeterminationCodeSousProduit getInstance()
  {
    return new OutilDeterminationCodeSousProduit();
  }
  
  public String determinerCodeSousProduitPourSigmaPourAttribution(DecisionSpec decision)
  {
    String codeSousProduitRetourne = "";
    AttributionSpec attribution = (AttributionSpec)decision;
    ActiviteSalarie aeCSPPourEntreeDispositif = recupererAeCspPourEntreeEnDispositifCSP(attribution);
    if (aeCSPPourEntreeDispositif != null)
    {
      boolean estPmvs = ((Demande)decision.getDemande()).estEnContexteDemande(2);
      boolean estAncienneteSuperieure2Ans = estAncienneteSuperieure2Ans(attribution, aeCSPPourEntreeDispositif);
      Demande demande = (Demande)decision.getDemande();
      if (demande.estEnContexteDemande(10))
      {
        boolean estContextePapParlementaire = demande.estEnContexteDemande("PAPPARLEM");
        codeSousProduitRetourne = calculerCodeSousProduitPap(estAncienneteSuperieure2Ans, estContextePapParlementaire);
      }
      else
      {
        codeSousProduitRetourne = calculerCodeSousProduitAsp(estPmvs, estAncienneteSuperieure2Ans);
      }
    }
    return codeSousProduitRetourne;
  }
  
  protected ActiviteSalarie recupererAeCspPourEntreeEnDispositifCSP(AttributionSpec attribution)
  {
    return fr.unedic.cali.asu.outilsfonctionnels.OutilAsp.getInstance().recupererAeCspPourEntreeEnDispositifCSP(attribution.getDemandeur(), (AttributionAssuranceSpec)attribution);
  }
  
  protected boolean estAncienneteSuperieure2Ans(AttributionSpec attribution, ActiviteSalarie aeCSPPourEntreeDispositif)
  {
    return fr.unedic.cali.outilsfonctionnels.OutilAsp.aAncienneteSuperieur2Ans(attribution.getDemande(), aeCSPPourEntreeDispositif);
  }
  
  protected String calculerCodeSousProduitPap(boolean estAncienneteSuperieure2Ans, boolean estContextePapParlementaire)
  {
    String codeSousProduitRetourne;
    String codeSousProduitRetourne;
    if (estAncienneteSuperieure2Ans)
    {
      String codeSousProduitRetourne;
      if (estContextePapParlementaire) {
        codeSousProduitRetourne = "08";
      } else {
        codeSousProduitRetourne = "06";
      }
    }
    else
    {
      String codeSousProduitRetourne;
      if (estContextePapParlementaire) {
        codeSousProduitRetourne = "08";
      } else {
        codeSousProduitRetourne = "06";
      }
    }
    return codeSousProduitRetourne;
  }
  
  private String calculerCodeSousProduitAsp(boolean estPmvs, boolean estAncienneteSuperieure2Ans)
  {
    String codeSousProduitRetourne;
    String codeSousProduitRetourne;
    if (estAncienneteSuperieure2Ans)
    {
      String codeSousProduitRetourne;
      if (estPmvs) {
        codeSousProduitRetourne = "M1";
      } else {
        codeSousProduitRetourne = "01";
      }
    }
    else
    {
      String codeSousProduitRetourne;
      if (estPmvs) {
        codeSousProduitRetourne = "M2";
      } else {
        codeSousProduitRetourne = "02";
      }
    }
    return codeSousProduitRetourne;
  }
  
  public String determinerCodeSousProduitRejet(DecisionSpec decision)
  {
    String resultat = null;
    Demande demande = (Demande)decision.getDemande();
    if (demande.estEnContexteDemande("PAPDC")) {
      if (demande.estEnContexteDemande("PAPPARLEM")) {
        resultat = "08";
      } else {
        resultat = "06";
      }
    }
    return resultat;
  }
}

/* Location:
 * Qualified Name:     OutilDeterminationCodeSousProduit
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */