package fr.unedic.cali.asu.cve13.p01.liquidation.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesDemandeAssociee;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.FinancementSpec;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.dom.pivot.Decision;
import fr.unedic.cali.dom.pivot.DemandePivot;
import fr.unedic.util.services.CoucheLogiqueException;

public final class AlimentationBasePivot
{
  private static final String FINANCEMENT_ETAT_POUR_PIVOT = "E";
  private static final String FINANCEMENT_PARTAGE_POUR_PIVOT = "D";
  private static final String CODE_BASSIN_CTP06 = "22";
  private static final String CODE_BASSIN_CTP09 = "23";
  
  public static void alimenterDonneesProduit(DossierExamenSpec dossierExamen, DemandePivot demandePivot)
    throws ApplicativeException, CoucheLogiqueException
  {
    fr.unedic.cali.asu.cge01.liquidation.outilsfonctionnels.AlimentationBasePivot.getInstance().alimenterDonneesProduit(dossierExamen, demandePivot);
    
    Demande demandeATP = (Demande)dossierExamen.getDemande();
    Demande demandeFinancement = demandeATP.getDonneesDemandeAssociee().getDemandeAssociee();
    if (demandeFinancement != null)
    {
      FinancementSpec decisionFinancement = null;
      if ((demandeFinancement.getDossierExamen() instanceof FinancementSpec)) {
        decisionFinancement = (FinancementSpec)demandeFinancement.getDossierExamen();
      }
      if (decisionFinancement != null) {
        if ("E".equals(decisionFinancement.getNatureFinancement())) {
          demandePivot.getAttribution().setTypeFinancement("E");
        } else {
          demandePivot.getAttribution().setTypeFinancement("D");
        }
      }
    }
    fr.unedic.cali.asu.produits.liquidation.dom.Attribution attribution = (fr.unedic.cali.asu.produits.liquidation.dom.Attribution)dossierExamen;
    
    int codeBassinEmploi = attribution.getBassinEmploi();
    if (3 == codeBassinEmploi) {
      demandePivot.getAttribution().setCodeSousProduitCourant("23");
    } else if (1 == codeBassinEmploi) {
      demandePivot.getAttribution().setCodeSousProduitCourant("22");
    } else if (2 == codeBassinEmploi) {
      demandePivot.getAttribution().setCodeSousProduitCourant("23");
    }
    if (demandeATP.estUneDemandeFinDroitAtp()) {
      demandePivot.getAttribution().setSituationParticuliereDroitCourant("4");
    }
    renseignerDecision(demandePivot.getDecision(), (DossierExamen)dossierExamen);
    
    renseignerAttribution(demandePivot.getAttribution(), (DossierExamen)dossierExamen);
  }
  
  private static void renseignerDecision(Decision decision, DossierExamen dossierExamen)
    throws CoucheLogiqueException
  {
    fr.unedic.cali.asu.produits.liquidation.dom.Attribution attribution = (fr.unedic.cali.asu.produits.liquidation.dom.Attribution)dossierExamen;
    
    int codeBassinEmploi = attribution.getBassinEmploi();
    if (3 == codeBassinEmploi) {
      decision.setCodeSousProduit("23");
    } else if (1 == codeBassinEmploi) {
      decision.setCodeSousProduit("22");
    } else if (2 == codeBassinEmploi) {
      decision.setCodeSousProduit("23");
    }
  }
  
  private static void renseignerAttribution(fr.unedic.cali.dom.pivot.Attribution attributionPivot, DossierExamen dossierExamen)
    throws CoucheLogiqueException
  {
    fr.unedic.cali.asu.produits.liquidation.dom.Attribution attribution = (fr.unedic.cali.asu.produits.liquidation.dom.Attribution)dossierExamen;
    
    attributionPivot.setDateFinDelaiDecheance(attribution.getDateLimiteIndemnisation());
  }
}

/* Location:
 * Qualified Name:     AlimentationBasePivot
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */