package fr.unedic.cali.asu.cve13.p01.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.outilsfonctionnels.OutilAsr;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionSjr;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.JustificationSjr;
import fr.unedic.cali.asu.produits.liquidation.dom.JustificationSr;
import fr.unedic.cali.asu.produits.liquidation.dom.Prc;
import fr.unedic.cali.asu.produits.liquidation.dom.Sjrip;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.util.Mathematiques;
import fr.unedic.util.Quantite;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.OutilFonctionnel;
import java.math.BigDecimal;

public class DeterminationSjr
  implements OutilFonctionnel
{
  public static DeterminationSjr getInstance()
  {
    return new DeterminationSjr();
  }
  
  public ConstitutionSjr determinerConstitutionSjrBasculeCrpCtp(DemandeSpec p_demande)
    throws CoucheLogiqueException
  {
    DossierExamen dossierExamenCourant = (DossierExamen)p_demande.getDossierAffectation().getDossierExamen();
    ConstitutionSjr constitutionSjr = dossierExamenCourant.createConstitutionSjr();
    
    AttributionSpec attributionCRP = OutilAsr.rechercherAttributionAsrPrecedent(p_demande, p_demande.getDateDepot());
    if (attributionCRP == null) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_ATP_ATP_BASCULE_SANS_CRP");
    }
    ConstitutionSjr constitutionSjrCrp = ((Attribution)attributionCRP).getConstitutionSjr();
    
    constitutionSjrCrp.copieElements(constitutionSjr);
    
    Quantite sjrSaisi = ((DemandeAssuranceSpec)p_demande).getDonneesTemporaires().getSjr();
    if (sjrSaisi == null)
    {
      BigDecimal salaireReferenceNonPlafonne = constitutionSjr.getJustificationSjr().getJustificationSr().getSalaireReferenceNonPlafonne();
      BigDecimal diviseur = constitutionSjr.getSjrip().getPrc().getDiviseur();
      BigDecimal sjnpr = Mathematiques.diviseParDefaut(salaireReferenceNonPlafonne, diviseur);
      constitutionSjr.getSjrip().setSjrInitial(new QuantiteEuro(Mathematiques.arrondiASup(sjnpr, 2)));
    }
    return constitutionSjr;
  }
}

/* Location:
 * Qualified Name:     DeterminationSjr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */