package fr.unedic.cali.asu.cve13.p01.liquidation.parcours;

import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.Competence;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;

public class DeterminationCompetencesProduitCourant
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte p_contexte)
    throws CoucheLogiqueException
  {
    OutilTrace.tracerDebutParcours();
    
    Demande demandeCourante = DomLiquidationAssurance.getDemande(p_contexte);
    DossierExamen dossierExamenCourant = (DossierExamen)demandeCourante.getDossierExamen();
    
    Competence competenceDroitCourant = new Competence();
    competenceDroitCourant.setCompetenceAdministrative(1);
    competenceDroitCourant.setCompetenceAdministrativeDroitCourant(1);
    competenceDroitCourant.setCompetenceFinanciere(1);
    competenceDroitCourant.setCompetenceFinanciereDroitCourant(1);
    
    dossierExamenCourant.setCompetence(competenceDroitCourant);
    
    OutilTrace.tracerFinParcours();
    
    Resultat resultat = new Resultat();
    resultat.setEtat(0);
    return resultat;
  }
  
  public void controlerContexte(Contexte p_contexte)
    throws ContexteException
  {
    if (DomLiquidationAssurance.getDemande(p_contexte) == null) {
      throw new ContexteException("HG_PR_CALI_L_CONTEXTE_ABSENCE_DEMANDE_ASSURANCE", "Une demande est obligatoire pour ce produit. : DeterminationCompetencesProduitCourant impossible");
    }
    if (DomLiquidationAssurance.getDemande(p_contexte).getDemandeur() == null) {
      throw new ContexteException("HG_PR_CALI_L_ERR_CTX_ABS_DEMANDEUR", "Absence individu demandeur sur la demande : DeterminationCompetencesProduitCourant impossible");
    }
    if (DomLiquidationAssurance.getDemande(p_contexte).getDossierExamen() == null) {
      throw new ContexteException("ASU_PR_CALI_L_CONTEXTE_ABSENCE_DOSSIER_EXAMEN", "Le dossier examen est null: DeterminationCompetencesProduitCourant impossible");
    }
  }
}

/* Location:
 * Qualified Name:     DeterminationCompetencesProduitCourant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */