package fr.unedic.cali.asu.ddm16.p01.calcul.outilsfonctionnels;

import fr.unedic.cali.asu.ddm16.p01.calcul.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.parametres.ParametresIndemnisation;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.affectation.ProduitAsuCge01P04;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;

public class MajCi
{
  public static ConstituantsIndemnisation miseAJourConstituantsIndemnisation(AttributionSpec p_attribution, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_dateDeMiseAjour)
    throws CoucheLogiqueException
  {
    String codeFormuleMontant = null;
    
    codeFormuleMontant = p_constituantsIndemnisation.getCodeFormuleMontant();
    if (codeFormuleMontant != null) {
      miseAJourParametres(p_attribution, p_constituantsIndemnisation, p_dateDeMiseAjour);
    }
    return p_constituantsIndemnisation;
  }
  
  private static void miseAJourParametres(AttributionSpec p_attribution, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_dateDeMiseAjour)
    throws CoucheLogiqueException
  {
    ParametresIndemnisation parametresIndemnisation = null;
    BigDecimal tauxAvantageViellesse = null;
    ElementBaseIndemnisation elementBaseIndemnisation = null;
    Sjr nouveauSjr = null;
    
    parametresIndemnisation = ParametresIndemnisation.getParametresIndemnisation();
    
    elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
    
    tauxAvantageViellesse = parametresIndemnisation.getTauxAvantageViellesse(p_attribution.getDemandeur().getAgeALaDate(p_dateDeMiseAjour));
    if (tauxAvantageViellesse != null) {
      ((ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant()).setTauxAvantageVieillesse(tauxAvantageViellesse);
    }
    ProduitAsuSpec produitARE = ProduitAsuCge01P04.getInstance();
    nouveauSjr = (Sjr)produitARE.revaloriserSalaireJournalierReference(elementBaseIndemnisation.getSjr().getSalaire(), elementBaseIndemnisation.getSjr().getDateDepart(), p_dateDeMiseAjour, elementBaseIndemnisation.getSjr().getContexteParticulier());
    if (nouveauSjr.getSalaire().doubleValue() != elementBaseIndemnisation.getSjr().getSalaire().doubleValue()) {
      elementBaseIndemnisation.setMontantAvantageVieillesse(elementBaseIndemnisation.getCoefficientAvantageVieillesse().multiply(nouveauSjr.getSalaire()));
    }
    elementBaseIndemnisation.setSjrRP(nouveauSjr);
    
    elementBaseIndemnisation.setAgeALaDateCalcul(p_attribution.getDemandeur().getAgeALaDate(p_dateDeMiseAjour));
    if (elementBaseIndemnisation.getAvecPrecompteCRC() == null) {
      elementBaseIndemnisation.setAvecPrecompteCRC(new Boolean(true));
    }
  }
}

/* Location:
 * Qualified Name:     MajCi
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */