package fr.unedic.cali.asu.dom;

import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;

public abstract interface ContributionParticuliereSpec
  extends ObjetPersistantSpec
{
  public static final int AUCUNE_CONTRIBUTION_PARTICULIERE = 0;
  public static final int CONTRIBUTION_SUPPLEMENTAIRE = 1;
  public static final int CONTRIBUTION_SPECIFIQUE = 2;
  public static final int CONTRIBUTION_SUPPLEMENTAIRE_SPECIFIQUE = 3;
  public static final int CONTRIBUTION_PAS_APPLICABLE = 4;
  public static final int CONTRIBUTION_FINANCEMENT_FIN_ASR = 5;
  public static final int CONTRIBUTION_FINANCEMENT_FIN_ASR_ET_CONTRIBUTION_FINANCEMENT_PRESTA_ACCOMP = 6;
  public static final int CONTRIBUTION_FINANCEMENT_PRESTA_ACCOMP = 7;
  public static final int CONTRIBUTION_FINANCEMENT_CTP = 8;
  public static final int CONTRIBUTION_FINANCEMENT_CTP_ET_CONTRIBUTION_FINANCEMENT_DIF = 9;
  public static final int CONTRIBUTION_FINANCEMENT_DIF = 10;
  public static final int CONTRIBUTION_FINANCEMENT_CSP_DIFF_ET_PREAVIS = 11;
  public static final int CONTRIBUTION_FINANCEMENT_CSP_PREAVIS = 12;
  public static final int CONTRIBUTION_FINANCEMENT_CSP_VOLONTAIRE = 13;
  public static final int CONTRIBUTION_FINANCEMENT_PAP_PREAVIS = 14;
  public static final int CONTRIBUTION_FINANCEMENT_PAP_VOLONTAIRE = 15;
  public static final String LIB_AUCUNE_CONTRIBUTION_PARTICULIERE = "Aucune contribution";
  public static final String LIB_CONTRIBUTION_SUPPLEMENTAIRE = "Contribution supplémentaire";
  public static final String LIB_CONTRIBUTION_SPECIFIQUE = "Contribution spécifique";
  public static final String LIB_CONTRIBUTION_SPECIAL = "Contribution spécial";
  public static final String LIB_CONTRIBUTION_SUPPLEMENTAIRE_SPECIFIQUE = "Contributions supplémentaire et spécifique";
  public static final String LIB_CONTRIBUTION_SUPPLEMENTAIRE_SPECIALE = "Contributions supplémentaire et spéciale";
  public static final String LIB_CONTRIBUTION_FINANCEMENT_ASR = "Détection de la contribution  au financement de l'ASR - Participation au financement des prestations d'accompagnement";
  public static final String LIB_CONTRIBUTION_FINANCEMENT_PRESTA_ACCOMP = "Participation au financement des prestations d'accompagnement";
  public static final int AGE_ADMIS_CONTRI_SUPPL = 50;
  public static final int AGE_SALARIE_EXCLU_EMPL = 45;
  public static final Damj DATE_CRTL_EXCLU_EMPL_PAS = new Damj(2003, 5, 27);
  public static final Damj DATE_CTRL_FCT_CONT_SPE = new Damj(2002, 4, 13);
  public static final Damj DATE_CTRL_FAIT_GENERATEUR_CONT_SUPPL = new Damj(2008, 1, 1);
  public static final String CODE_POSTAL_MONEGASQUES = "98000";
  
  public abstract int getTypeContributionParticuliere();
  
  public abstract void setTypeContributionParticuliere(int paramInt);
  
  public abstract BigDecimal getMontantFormationDifCtp();
  
  public abstract void setMontantFormationDifCtp(BigDecimal paramBigDecimal);
  
  public abstract BigDecimal getMontantPreavisCtp();
  
  public abstract void setMontantPreavisCtp(BigDecimal paramBigDecimal);
  
  public abstract boolean isTopDetectionContributionPreavis();
  
  public abstract void setTopDetectionContributionPreavis(boolean paramBoolean);
  
  public abstract boolean isTopDetectionContributionDif();
  
  public abstract void setTopDetectionContributionDif(boolean paramBoolean);
}

/* Location:
 * Qualified Name:     ContributionParticuliereSpec
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */