package fr.unedic.cali.asu.dom;

import fr.unedic.cali.asu.dom.gen.DonneesDALGen;
import fr.unedic.cali.autresdoms.d12i.spec.DonneesDALSpec;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public class DonneesDAL
  extends DonneesDALGen
  implements ObjetPersistantSpec, DonneesDALSpec
{
  private static final long serialVersionUID = -6608735557205116753L;
  
  public DonneesDAL(DomPCSpec pc)
  {
    super(pc);
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public void marquerGraphePersistant() {}
  
  public ObjetMetierSpec copie()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller la méthode copieElements(ObjetMetierSpec).");
  }
  
  public void copieElements(ObjetMetierSpec pCopie)
  {
    DonneesDAL copie = (DonneesDAL)pCopie;
    
    copie.setCategorieParticuliere(getCategorieParticuliere());
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public boolean estTopFinDeDroit()
  {
    return 9 == getCategorieParticuliere();
  }
  
  public String getRefusPropositionFNE()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller la méthode sur la Demande.");
  }
  
  public String getTopPropositionCSP()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller la méthode getTopContribution() sur la Demande.");
  }
  
  public Boolean estTopPropositionPAP()
  {
    return null;
  }
  
  public Damj getDernierJourAtteste()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller la méthode getDernierJourAtteste()");
  }
}

/* Location:
 * Qualified Name:     DonneesDAL
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */