package fr.unedic.cali.asu.dom;

import fr.unedic.cali.asu.dom.gen.ElementJustificationGen;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Periode;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;

public class ElementJustification
  extends ElementJustificationGen
  implements ObjetPersistantSpec
{
  private static final long serialVersionUID = -2763789808486456709L;
  
  public ElementJustification(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public ObjetMetierSpec copie()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller le méthode copieElements(ObjetMetierSpec).");
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ElementJustification copie = (ElementJustification)p_copie;
    
    copie.setPrsRepriseContextuelle(getPrsRepriseContextuelle() != null ? new Periode(getPrsRepriseContextuelle().getDebut(), getPrsRepriseContextuelle().getFin()) : null);
    
    Iterator iter = getListePeriodesChomageSaisonnierRepContextuelle().iterator();
    while (iter.hasNext())
    {
      PeriodeChomageSaisonnier element = (PeriodeChomageSaisonnier)iter.next();
      copie.ajouterPeriodeChomageSaisonnierRepContextuelle((PeriodeChomageSaisonnier)element.copie());
    }
  }
  
  public void jdoPostLoad() {}
  
  public void jdoPreStore() {}
  
  public void jdoPreClear() {}
  
  public void jdoPreDelete() {}
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(super.getCollectionPeriodeChomageSaisonnierRepContextuelle());
  }
  
  public Collection getListePeriodesChomageSaisonnierRepContextuelle()
  {
    return Collections.unmodifiableCollection(getListePeriodesChomageSaisonnierRepContextuellePrive());
  }
  
  private Collection getListePeriodesChomageSaisonnierRepContextuellePrive()
  {
    return super.getCollectionPeriodeChomageSaisonnierRepContextuelle();
  }
  
  public void ajouterPeriodeChomageSaisonnierRepContextuelle(PeriodeChomageSaisonnier p_periodeChomageSaisonnier)
  {
    if (p_periodeChomageSaisonnier != null) {
      super.ajouterPeriodeChomageSaisonnierRepContextuelle(p_periodeChomageSaisonnier);
    }
  }
  
  public void supprimerPeriodesChomageSaisonnierRepContextuelle()
  {
    Iterator it = getListePeriodesChomageSaisonnierRepContextuelle().iterator();
    while (it.hasNext())
    {
      PeriodeChomageSaisonnier periode = (PeriodeChomageSaisonnier)it.next();
      DomManager.supprimer(periode);
    }
    setListePeriodesChomageSaisonnierRepContextuelle(new ArrayList());
  }
  
  public void setListePeriodesChomageSaisonnierRepContextuelle(Collection p_listePeriodesChomageSaisonnierRepContextuelle)
  {
    super.remplacerCollectionPeriodeChomageSaisonnierRepContextuelle(p_listePeriodesChomageSaisonnierRepContextuelle);
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public void remplacerCollectionPeriodeChomageSaisonnierRepContextuelle(Collection collectionACopier)
  {
    for (Iterator iter = super.getCollectionPeriodeChomageSaisonnierRepContextuelle().iterator(); iter.hasNext();)
    {
      PeriodeChomageSaisonnier element = (PeriodeChomageSaisonnier)iter.next();
      DomManager.supprimer(element);
    }
    super.remplacerCollectionPeriodeChomageSaisonnierRepContextuelle(collectionACopier);
  }
}

/* Location:
 * Qualified Name:     ElementJustification
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */