package fr.unedic.cali.asu.dom;

import fr.unedic.cali.asu.dom.gen.PeriodeRepriseActiviteMemeEmployeurPossibleGen;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public class PeriodeRepriseActiviteMemeEmployeurPossible
  extends PeriodeRepriseActiviteMemeEmployeurPossibleGen
  implements ObjetPersistantSpec
{
  private static final long serialVersionUID = -3101346751635137005L;
  public static final int AVIS_NON_RENSEIGNE = 0;
  public static final int AVIS_FAVORABLE = 1;
  public static final int AVIS_DEFAVORABLE = 2;
  public static final int INDEX_PERIODE1 = 0;
  public static final int INDEX_PERIODE2 = 1;
  
  public PeriodeRepriseActiviteMemeEmployeurPossible() {}
  
  public PeriodeRepriseActiviteMemeEmployeurPossible(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public boolean isAvisFavorable()
  {
    return super.getAvis() == 1;
  }
  
  public void setAvisFavorable(boolean p_avisFavorable)
  {
    if (p_avisFavorable) {
      super.setAvis(1);
    } else {
      super.setAvis(2);
    }
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public void jdoPostLoad() {}
  
  public void jdoPreClear() {}
  
  public void jdoPreDelete() {}
  
  public void marquerGraphePersistant() {}
  
  public void jdoPreStore() {}
  
  public ObjetMetierSpec copie()
  {
    PeriodeRepriseActiviteMemeEmployeurPossible copie = new PeriodeRepriseActiviteMemeEmployeurPossible();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    PeriodeRepriseActiviteMemeEmployeurPossible copie = (PeriodeRepriseActiviteMemeEmployeurPossible)p_copie;
    
    copie.setDebut(getDebut());
    copie.setFin(getFin());
    copie.setAvis(getAvis());
    copie.setIndex(getIndex());
  }
  
  public String toString()
  {
    StringBuffer sb = new StringBuffer();
    sb.append("Periode ").append(getIndex());
    sb.append("[ Avis: ");
    if (getAvis() == 1) {
      sb.append(" favorable");
    } else if (getAvis() == 2) {
      sb.append(" défavorable");
    } else {
      sb.append(" non renseigné");
    }
    sb.append(" - du: ").append(getDebut());
    sb.append(" au: ").append(getFin());
    
    sb.append(" ] ");
    
    return sb.toString();
  }
}

/* Location:
 * Qualified Name:     PeriodeRepriseActiviteMemeEmployeurPossible
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */