package fr.unedic.cali.asu.dom;

import fr.unedic.cali.dom.SalaireJournalierSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.Unite;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;

public abstract class SalaireJournalierAbstrait
  implements SalaireJournalierSpec, ObjetMetierSpec
{
  private Quantite m_montant;
  private static final Unite UNITE_SJ = Unite.get("Euros");
  private Damj m_dateDepart = null;
  private boolean m_estRevalorise = false;
  private String m_contexteParticulier;
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    SalaireJournalierAbstrait copie = (SalaireJournalierAbstrait)p_copie;
    copie.setDateDepart(getDateDepart());
    copie.setMontant(getMontant());
    copie.setRevalorise(estRevalorise());
    copie.setContexteParticulier(getContexteParticulier());
  }
  
  protected Quantite getMontant()
  {
    return m_montant;
  }
  
  protected void setMontant(Quantite p_montant)
  {
    m_montant = p_montant;
  }
  
  public Damj getDateDepart()
  {
    return m_dateDepart;
  }
  
  public BigDecimal getSalaire()
  {
    return getMontant().getValeur();
  }
  
  public void setDateDepart(Damj p_dateDepart)
  {
    m_dateDepart = p_dateDepart;
  }
  
  public void setSalaire(BigDecimal p_salaire)
  {
    setMontant(new Quantite(p_salaire, UNITE_SJ));
  }
  
  public boolean estRevalorise()
  {
    return m_estRevalorise;
  }
  
  public void setRevalorise(boolean p_estRevalorise)
  {
    m_estRevalorise = p_estRevalorise;
  }
  
  public String toString()
  {
    StringBuffer chaineRetour = new StringBuffer();
    chaineRetour.append("Salaire journalier: " + getMontant() + "\n");
    chaineRetour.append("Date départ: " + m_dateDepart + "\n");
    chaineRetour.append("Revalorisé: " + m_estRevalorise + "\n");
    return chaineRetour.toString();
  }
  
  public String getContexteParticulier()
  {
    return m_contexteParticulier;
  }
  
  public void setContexteParticulier(String p_contexteParticulier)
  {
    m_contexteParticulier = p_contexteParticulier;
  }
}

/* Location:
 * Qualified Name:     SalaireJournalierAbstrait
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */