package fr.unedic.cali.asu.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.dom.pc.SousPensionInvaliditeChaineePC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.temps.ObjetChronoPeriodeCREM;

public abstract class SousPensionInvaliditeChaineeGen
  extends ObjetChronoPeriodeCREM
  implements DomGenSpec
{
  private String m_codeNature;
  private String m_etat;
  private QuantiteEuro m_montant;
  
  public SousPensionInvaliditeChaineeGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public SousPensionInvaliditeChaineeGen() {}
  
  protected DomPCSpec createPC()
  {
    return new SousPensionInvaliditeChaineePC();
  }
  
  protected String rawGetCodeNature()
  {
    return ((SousPensionInvaliditeChaineePC)getPC()).getCodeNature();
  }
  
  public String getCodeNature()
  {
    return ((SousPensionInvaliditeChaineePC)getPC()).getCodeNature();
  }
  
  public void setCodeNature(String p_codeNature)
  {
    if ((m_codeNature == null) || (p_codeNature == null))
    {
      m_codeNature = p_codeNature;
      ((SousPensionInvaliditeChaineePC)getPC()).setCodeNature(p_codeNature);
    }
    else if ((m_codeNature != null) && (p_codeNature != null) && (!p_codeNature.equals(m_codeNature)))
    {
      m_codeNature = p_codeNature;
      ((SousPensionInvaliditeChaineePC)getPC()).setCodeNature(p_codeNature);
    }
  }
  
  protected String rawGetEtat()
  {
    return ((SousPensionInvaliditeChaineePC)getPC()).getEtat();
  }
  
  public String getEtat()
  {
    return ((SousPensionInvaliditeChaineePC)getPC()).getEtat();
  }
  
  public void setEtat(String p_etat)
  {
    if ((m_etat == null) || (p_etat == null))
    {
      m_etat = p_etat;
      ((SousPensionInvaliditeChaineePC)getPC()).setEtat(p_etat);
    }
    else if ((m_etat != null) && (p_etat != null) && (!p_etat.equals(m_etat)))
    {
      m_etat = p_etat;
      ((SousPensionInvaliditeChaineePC)getPC()).setEtat(p_etat);
    }
  }
  
  protected QuantiteEuro rawGetMontant()
  {
    return ((SousPensionInvaliditeChaineePC)getPC()).getMontant();
  }
  
  public QuantiteEuro getMontant()
  {
    return ((SousPensionInvaliditeChaineePC)getPC()).getMontant();
  }
  
  public void setMontant(QuantiteEuro p_montant)
  {
    if ((m_montant == null) || (p_montant == null))
    {
      m_montant = p_montant;
      ((SousPensionInvaliditeChaineePC)getPC()).setMontant(p_montant);
    }
    else if ((m_montant != null) && (p_montant != null) && (!p_montant.equals(m_montant)))
    {
      m_montant = p_montant;
      ((SousPensionInvaliditeChaineePC)getPC()).setMontant(p_montant);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     SousPensionInvaliditeChaineeGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */