package fr.unedic.cali.asu.eur05.p01.calcul.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.eur05.p01.calcul.dom.pc.UniteTraitementPC;
import fr.unedic.cali.calcul.dom.UniteTraitement;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Periode;

public abstract class UniteTraitementGen
  extends UniteTraitement
  implements DomGenSpec
{
  public UniteTraitementGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public UniteTraitementGen() {}
  
  public UniteTraitementGen(Periode p_periode)
  {
    super(p_periode);
  }
  
  protected DomPCSpec createPC()
  {
    return new UniteTraitementPC();
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     UniteTraitementGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */