package fr.unedic.cali.asu.eur05.p01.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.eur05.p01.calcul.dom.DureeIndemnisation;
import fr.unedic.cali.asu.eur05.p01.liquidation.dom.Admission;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.dom.echange.Decision;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.CoucheLogiqueException;
import java.util.List;

public class AlimenterBaseEchanges
{
  public static void alimenterDonneesProduit(DossierExamenSpec p_dossierExamen, Decision p_demandeEchange)
    throws CoucheLogiqueException
  {
    if (p_demandeEchange == null) {
      p_demandeEchange = new Decision();
    }
    p_demandeEchange.setLigne("ASU_EUR05");
    if ((p_dossierExamen.getDemande().estNotifieeCourrier()) && ((p_dossierExamen instanceof Admission))) {
      alimenterDonneesCourrierEC8A(p_dossierExamen, p_demandeEchange);
    }
  }
  
  private static void alimenterDonneesCourrierEC8A(DossierExamenSpec p_dossierExamen, Decision p_demandeEchange)
    throws CoucheLogiqueException
  {
    Admission admissionAue = (Admission)p_dossierExamen;
    
    p_demandeEchange.setMontantAllocationJournalierBrutCourrier(admissionAue.getMontantJournalierCalcule());
    
    int joursIndemnisation = 0;
    if ((admissionAue.getListeDurees() != null) && (!admissionAue.getListeDurees().isEmpty()))
    {
      DureeIndemnisation dureeIndemnisation = (DureeIndemnisation)admissionAue.getListeDurees().get(0);
      if (dureeIndemnisation != null) {
        joursIndemnisation = dureeIndemnisation.getQuantiteInitial().getValeurEntiere();
      }
    }
    p_demandeEchange.setDureeTheoriqueDroitServiCourrier(joursIndemnisation);
    
    p_demandeEchange.setDateBanalisee(admissionAue.getDateLimiteIndemnisation());
  }
}

/* Location:
 * Qualified Name:     AlimenterBaseEchanges
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */