package fr.unedic.cali.asu.fabriques;

import fr.unedic.cali.asu.outilsfonctionnels.strategies.SrategieMajCompteurFormationAvant;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieMajCompteurFormationApres;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieMajCompteurFormationSpec;
import fr.unedic.cali.fabriques.FabriqueStrategieSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;

public class FabriqueMajCompteurFormation
  implements FabriqueStrategieSpec
{
  public static final Damj DATE_APPLICATION = new Damj(2014, 6, 1);
  private static FabriqueMajCompteurFormation s_instance = new FabriqueMajCompteurFormation();
  
  public static FabriqueMajCompteurFormation getInstance()
  {
    return s_instance;
  }
  
  public StrategieSpec getStrategie(CritereStrategie p_critereStrategie)
    throws CoucheLogiqueException
  {
    StrategieMajCompteurFormationSpec strategie = null;
    
    Damj datePivotRegleAC = p_critereStrategie.getDatePivot();
    if (datePivotRegleAC.estApresOuCoincideAvec(DATE_APPLICATION)) {
      strategie = new StrategieMajCompteurFormationApres();
    } else {
      strategie = new SrategieMajCompteurFormationAvant();
    }
    return strategie;
  }
}

/* Location:
 * Qualified Name:     FabriqueMajCompteurFormation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */