package fr.unedic.cali.asu.fabriques;

import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieBaseCalculSMICJournalierApresMEP09SI3;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieBaseCalculSMICJournalierAvantMEP09SI3;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieBaseCalculSMICJournalierSpec;
import fr.unedic.cali.fabriques.FabriqueStrategieSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;

public class FabriqueStrategieBaseCalculSMICJournalier
  implements FabriqueStrategieSpec
{
  private static final Damj DATE_APPLICATION = new Damj(2009, 12, 1);
  private static FabriqueStrategieBaseCalculSMICJournalier s_instance = new FabriqueStrategieBaseCalculSMICJournalier();
  
  public static FabriqueStrategieBaseCalculSMICJournalier getInstance()
  {
    return s_instance;
  }
  
  public StrategieSpec getStrategie(CritereStrategie p_critereStrategie)
    throws CoucheLogiqueException
  {
    StrategieBaseCalculSMICJournalierSpec strategie = null;
    
    Damj datePivot = p_critereStrategie.getDatePivot();
    if (datePivot == null) {
      throw new UnsupportedOperationException("FabriqueBaseCalculSMICJournalier : la date pivot est nulle.");
    }
    if (datePivot.estApresOuCoincideAvec(DATE_APPLICATION)) {
      strategie = new StrategieBaseCalculSMICJournalierApresMEP09SI3();
    } else {
      strategie = new StrategieBaseCalculSMICJournalierAvantMEP09SI3();
    }
    return strategie;
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieBaseCalculSMICJournalier
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */