package fr.unedic.cali.asu.fabriques;

import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieControleDonneesSecteurPublicApres;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieControleDonneesSecteurPublicAvant;
import fr.unedic.cali.fabriques.FabriqueConvention2014;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;

public class FabriqueStrategieControleDonneesSecteurPublic
  extends FabriqueConvention2014
{
  public StrategieSpec getStrategie(CritereStrategie p_critereStrategie)
    throws CoucheLogiqueException
  {
    StrategieSpec strategie = null;
    
    Damj datePivot = p_critereStrategie.getDatePivot();
    if (datePivot == null) {
      throw new UnsupportedOperationException("FabriqueStrategieControleDonneesSecteurPublic : la date pivot est null.");
    }
    if (datePivot.estApresOuCoincideAvec(DATE_APPLICATION)) {
      strategie = new StrategieControleDonneesSecteurPublicApres();
    } else {
      strategie = new StrategieControleDonneesSecteurPublicAvant();
    }
    return strategie;
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieControleDonneesSecteurPublic
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */