package fr.unedic.cali.asu.fabriques;

import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieGestionReliquatImputationFinDroitApres;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieGestionReliquatImputationFinDroitAvant;
import fr.unedic.cali.asu.outilsfonctionnels.strategies.StrategieGestionReliquatImputationFinDroitSpec;
import fr.unedic.cali.fabriques.FabriqueConvention2014;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.util.temps.Damj;

public class FabriqueStrategieGestionReliquatImputationFinDroit
  extends FabriqueConvention2014
{
  private static FabriqueStrategieGestionReliquatImputationFinDroit s_instance = new FabriqueStrategieGestionReliquatImputationFinDroit();
  
  public static FabriqueStrategieGestionReliquatImputationFinDroit getInstance()
  {
    return s_instance;
  }
  
  public StrategieGestionReliquatImputationFinDroitSpec getStrategie(CritereStrategie p_critereStrategie)
  {
    StrategieGestionReliquatImputationFinDroitSpec retour = null;
    
    Damj datePivot = p_critereStrategie.getDatePivot();
    if (datePivot == null) {
      throw new UnsupportedOperationException("FabriqueStrategieGestionReliquatImputationFinDroit : la date pivot est null.");
    }
    if (datePivot.estApresOuCoincideAvec(DATE_APPLICATION)) {
      retour = new StrategieGestionReliquatImputationFinDroitApres();
    } else {
      retour = new StrategieGestionReliquatImputationFinDroitAvant();
    }
    return retour;
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieGestionReliquatImputationFinDroit
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */