package fr.unedic.cali.asu.fds12.p02.liquidation.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConditionBeneficeAutreProduit;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.dom.OdSpec;
import fr.unedic.util.services.CoucheLogiqueException;

public class AlimentationBasePivot
  extends fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.AlimentationBasePivot
{
  private static final String REFERENCE_REGLEMENTAIRE_AFFILIATION_FILIERE_COURTE = "B";
  private static final String REFERENCE_REGLEMENTAIRE_AFFILIATION_FILIERE_INTERMEDIAIRE = "C";
  private static final String REFERENCE_REGLEMENTAIRE_AFFILIATION_FILIERE_LONGUE = "D";
  
  public static fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.AlimentationBasePivot getInstance()
  {
    return new AlimentationBasePivot();
  }
  
  protected void renseignerDroitCourant(fr.unedic.cali.dom.pivot.Attribution p_attributionPivot, Demande p_demande)
    throws ApplicativeException, CoucheLogiqueException
  {
    super.renseignerDroitCourant(p_attributionPivot, p_demande);
    if ((p_demande.getDossierExamen() instanceof OdSpec))
    {
      p_attributionPivot.setReferenceReglementaireAffiliationDroitCourant(determinerReferenceReglementaireAffiliation(p_demande));
      p_attributionPivot.setRangAttributionAFDFiliereFNA(determinerRangAttributionAFD(p_demande));
    }
  }
  
  protected void renseignerDroitRetenu(fr.unedic.cali.dom.pivot.Attribution p_attributionPivot, Demande p_demande)
    throws CoucheLogiqueException
  {
    super.renseignerDroitRetenu(p_attributionPivot, p_demande);
  }
  
  private String determinerReferenceReglementaireAffiliation(Demande p_demande)
    throws CoucheLogiqueException
  {
    DossierExamen dossierExamen = (DossierExamen)p_demande.getDossierExamen();
    if (dossierExamen.getDureeAnciennete() != null)
    {
      int filiere = OutilDeterminationFiliere.determinerFiliere(dossierExamen.getDureeAnciennete());
      switch (filiere)
      {
      case 0: 
        return "B";
      case 1: 
        return "C";
      case 2: 
        return "D";
      }
    }
    return null;
  }
  
  private int determinerRangAttributionAFD(Demande p_demande)
  {
    fr.unedic.cali.asu.spe02.p03.liquidation.dom.Attribution attribution = (fr.unedic.cali.asu.spe02.p03.liquidation.dom.Attribution)p_demande.getAttribution();
    return attribution.getConditionBeneficeAutreProduit().getRangAttributionAFDFiliere();
  }
}

/* Location:
 * Qualified Name:     AlimentationBasePivot
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */