package fr.unedic.cali.asu.fds12.p02.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.FaitGenerateurSpec;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.asu.fds12.p02.liquidation.outilsAffiliation.ParametresAffiliation;
import fr.unedic.cali.asu.fps.liquidation.outilsfonctionnels.OutilConditionAffiliationAbstraite;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsaffiliation.dom.ParametresCalculAffiliation;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.affectation.ProduitAsuFds12P02;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.utilitaire.filtres.generiques.FiltreOuvertureDroitSurDecision;
import fr.unedic.cali.utilitaire.filtres.logiques.FiltreNegation;
import fr.unedic.cali.utilitaire.filtres.logiques.FiltreOU;
import fr.unedic.cali.utilitaire.filtres.metiers.FiltreDecisionARESurDecision;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;

public class OutilConditionAffiliation
  extends OutilConditionAffiliationAbstraite
{
  protected Quantite determinerAffiliationRequise(ParametresCalculAffiliation parametres)
  {
    return ParametresAffiliation.QUANTITE_AFFILIATION_REQUISE;
  }
  
  protected Damj determinerBornePRA(DemandeAssuranceSpec demande)
    throws CoucheLogiqueException
  {
    FiltreOU filtreElementsAPrendreEnCompte = new FiltreOU();
    filtreElementsAPrendreEnCompte.ajouterFiltre(new FiltreDecisionARESurDecision());
    filtreElementsAPrendreEnCompte.ajouterFiltre(new FiltreNegation(new FiltreOuvertureDroitSurDecision()));
    
    return trouverLendemainFgPourBornePra(demande, filtreElementsAPrendreEnCompte);
  }
  
  protected DureeCalendaire determinerDureePRA(ParametresCalculAffiliation parametres)
  {
    return ParametresAffiliation.DUREE_PRA;
  }
  
  protected ProduitSpec getProduit()
  {
    return ProduitAsuFds12P02.getInstance();
  }
  
  protected Damj getTermePeriodeRecherche(DemandeAssuranceSpec demande)
  {
    if (((DossierAffectation)demande.getDossierAffectation()).getValidationProduit() != null)
    {
      Damj fctRetenue = ((DossierAffectation)demande.getDossierAffectation()).getValidationProduit().getDateFinPeriode();
      if (fctRetenue != null) {
        return fctRetenue;
      }
    }
    return demande.getFaitGenerateur().getPeriodeFaitGenerateur().getDateFin();
  }
  
  protected Damj determinerTermePRA(Damj dateFct, Damj dateExamen, boolean estContexteDroitSuiteCRA)
  {
    return dateFct;
  }
}

/* Location:
 * Qualified Name:     OutilConditionAffiliation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */