package fr.unedic.cali.asu.fps.liquidation.outilsaffiliation.convention2017;

import fr.unedic.cali.asu.fps.liquidation.outilsaffiliation.ConstructionChronologieFPS;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsaffiliation.spec.ComportementAffiliationSpec;
import fr.unedic.cali.asu.spe02.p05.liquidation.outilsaffiliation.ConstructionChronologie;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreMaladieLongueDuree;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreNegation;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.FiltresTemporel;
import java.util.Map;

public class ConstructionChonologieConvention2017
  extends ConstructionChronologie
{
  public static final String CHRONO_AFFILIATION_MALADIES_LONGUE_DUREE = "chronoAffiMaladiesLongueDuree";
  
  public Map<String, Chronologie> determinerChronologies(IndividuSpec individu, ComportementAffiliationSpec pcomportement)
  {
    Map<String, Chronologie> resultat = super.determinerChronologies(individu, pcomportement);
    
    ComportementAffiliationConvention2017 comportement = (ComportementAffiliationConvention2017)pcomportement;
    if (comportement.isCalculAffiliationAssimilableMaladieLongueDuree())
    {
      Chronologie chronoCourante = recupererAncienOutil().determinerChronologiePourAssimilationMaladiesLongueDuree(pcomportement);
      
      resultat.put("chronoAffiMaladiesLongueDuree", chronoCourante);
    }
    return resultat;
  }
  
  public Chronologie determinerActivitesAllongementPeriodeReference(IndividuSpec individu, ComportementAffiliationSpec comportement)
  {
    Chronologie chronoActiviteAllongementPRAClassique = super.determinerActivitesAllongementPeriodeReference(individu, comportement);
    
    FiltresTemporel filtreElementsAExclure = new FiltresTemporel();
    filtreElementsAExclure.ajouterFiltre(new FiltreNegation(new FiltreMaladieLongueDuree()));
    
    return chronoActiviteAllongementPRAClassique.copier(filtreElementsAExclure);
  }
  
  private ConstructionChronologieFPS recupererAncienOutil()
  {
    return new ConstructionChronologieFPS();
  }
}

/* Location:
 * Qualified Name:     ConstructionChonologieConvention2017
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */