package fr.unedic.cali.asu.liquidation.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.outilsfonctionnels.DetectionContexteParticulierLiquidation;
import fr.unedic.cali.asu.outilsfonctionnels.OutilFinDroit;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.dom.ContexteDemande;
import fr.unedic.util.Quantite;
import fr.unedic.util.temps.UniteDuree;
import java.math.BigDecimal;

public class OutilAdhesionVolontaire
{
  public static Quantite imputerQuantite(Demande demandeFinDroit, AttributionAssuranceSpec attributionAImputer, Quantite quantite)
    throws ApplicativeException
  {
    Quantite quantiteAImputer = OutilFinDroit.trouverQuantiteAImputer(demandeFinDroit, attributionAImputer);
    return imputerQuantite(quantite, quantiteAImputer);
  }
  
  public static Quantite imputerQuantite(Quantite quantite, Quantite quantiteAImputer)
    throws ApplicativeException
  {
    Quantite retour = quantite.soustraire(quantiteAImputer);
    if (retour.getValeur().intValue() < 0) {
      retour = new Quantite(0, UniteDuree.JOUR);
    }
    return retour;
  }
  
  public static AttributionAssuranceSpec trouverOdAreAdhesionVolontaire(Demande demande)
  {
    AttributionAssuranceSpec attributionAssurance = null;
    ContexteDemande contexte = (ContexteDemande)OutilGestionContexteDemande.trouverContexteDemandeAssurance(demande, new String[] { "FINASPVOL", "FINASPVOLC", "ADHVOLARE" });
    if (contexte.getAttributionAreAdhesionVolontaire() == null)
    {
      attributionAssurance = DetectionContexteParticulierLiquidation.getInstance().trouverOdArePrecedente(demande);
      contexte.setAttributionAreAdhesionVolontaire(attributionAssurance);
    }
    return attributionAssurance;
  }
}

/* Location:
 * Qualified Name:     OutilAdhesionVolontaire
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */