package fr.unedic.cali.asu.may17.p02.calcul.outilsfonctionnels;

import fr.unedic.cali.asu.calcul.outilsfonctionnels.PostTraitementsAsu;
import fr.unedic.cali.asu.calcul.parcours.ResultatDeterminationEtatDroit;
import fr.unedic.cali.asu.may17.p02.calcul.dom.FormuleMontantPremiereTranche;
import fr.unedic.cali.asu.may17.p02.calcul.dom.FormuleMontantSecondeTranche;
import fr.unedic.cali.asu.may17.p02.calcul.dom.FormuleMontantTroisiemeTranche;
import fr.unedic.cali.asu.may17.p02.liquidation.dom.Admission;
import fr.unedic.cali.asu.may17.p03.calcul.dom.FormuleMontantAREM2016PremiereTranche;
import fr.unedic.cali.asu.may17.p03.calcul.dom.FormuleMontantAREM2016SecondeTranche;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.calcul.dom.CalendrierExecutionCalcul;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.parcours.ResultatDeterminationEtatDroitProduit;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;

public class PostTraitement
  extends PostTraitementsAsu
{
  public static ResultatDeterminationEtatDroitProduit postTraitementResultatDeterminationEtatDroit(AttributionSpec attribution, CalendrierExecutionCalcul calendrierExecutionCalcul, Damj dateEtatDroit)
    throws CoucheLogiqueException
  {
    ResultatDeterminationEtatDroit resultat = new ResultatDeterminationEtatDroit();
    
    remplirResultatPostTraitement(attribution, calendrierExecutionCalcul, dateEtatDroit, resultat);
    
    alimenterFormuleMontantArem(attribution, resultat);
    
    Quantite dureeInitiale = null;
    dureeInitiale = ((Admission)attribution).getAttributionAssurance().getDureeInitiale();
    Quantite reliquatARE = resultat.getReliquatAREAvecMaintien();
    if ((dureeInitiale != null) && (reliquatARE != null))
    {
      int cumulJourIndemnises = dureeInitiale.getValeurEntiere() - reliquatARE.getValeurEntiere();
      resultat.setCumulJourIndemnise(cumulJourIndemnises);
    }
    return resultat;
  }
  
  private static void alimenterFormuleMontantArem(AttributionSpec attribution, ResultatDeterminationEtatDroit resultat)
    throws CoucheLogiqueException
  {
    if (attribution.getProduitExecution().getNom().equals("ASU_MAY17_02"))
    {
      if ((((Admission)attribution).getDureeTranche3() != null) && (((Admission)attribution).getDureeTranche3().compareTo(BigDecimal.ZERO) > 0)) {
        resultat.setFormuleMontant(new FormuleMontantTroisiemeTranche());
      } else if ((((Admission)attribution).getDureeTranche2() != null) && (((Admission)attribution).getDureeTranche2().compareTo(BigDecimal.ZERO) > 0)) {
        resultat.setFormuleMontant(new FormuleMontantSecondeTranche());
      } else {
        resultat.setFormuleMontant(new FormuleMontantPremiereTranche());
      }
    }
    else if ((((Admission)attribution).getDureeTranche2() != null) && (((Admission)attribution).getDureeTranche2().compareTo(BigDecimal.ZERO) > 0)) {
      resultat.setFormuleMontant(new FormuleMontantAREM2016SecondeTranche());
    } else {
      resultat.setFormuleMontant(new FormuleMontantAREM2016PremiereTranche());
    }
  }
}

/* Location:
 * Qualified Name:     PostTraitement
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */