package fr.unedic.cali.asu.may17.p02.liquidation.outilsfonctionnels;

import fr.unedic.cali.ari.dom.Demande;
import fr.unedic.cali.asu.may17.p02.liquidation.dom.Admission;
import fr.unedic.cali.dom.DossierExamenSpec;
import fr.unedic.cali.dom.pivot.Attribution;
import fr.unedic.cali.dom.pivot.Decision;
import fr.unedic.cali.dom.pivot.DemandePivot;
import fr.unedic.cali.dom.spec.ConventionGestionSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.OutilFonctionnel;

public class AlimentationBasePivot
  implements OutilFonctionnel
{
  public static void alimenterDonneesProduit(DossierExamenSpec p_dossierExamen, DemandePivot p_demandePivot)
    throws CoucheLogiqueException
  {
    Demande demandeAri = (Demande)p_dossierExamen.getDemande();
    if (demandeAri.getDossierExamen() != null) {
      if (p_demandePivot.getAttribution() == null) {
        p_demandePivot.setAttribution(new Attribution());
      } else {
        p_demandePivot.getAttribution().initInstance();
      }
    }
    renseignerDecision(p_demandePivot.getDecision(), demandeAri);
    
    renseignerAttribution(p_demandePivot.getAttribution(), demandeAri);
  }
  
  private static void renseignerAttribution(Attribution p_attribution, Demande p_demande)
    throws CoucheLogiqueException
  {
    if ((p_demande.getDossierExamen() != null) && ((p_demande.getDossierExamen() instanceof Admission)))
    {
      Admission admissionMay = (Admission)p_demande.getDossierExamen();
      if ((admissionMay.getConventionGestion() != null) && ("2".equals(admissionMay.getConventionGestion().getSignataire())))
      {
        p_attribution.setCodeAffectationConvention(admissionMay.getConventionGestion().getCodeAffectation());
        p_attribution.setNumeroConvention(admissionMay.getConventionGestion().getNumeroConventionGestion());
      }
      p_attribution.setRegimeSs(0);
      
      p_attribution.setMontantSjc(admissionMay.getSJCInitial());
      
      p_attribution.setMontantSjrCourantPlafonne(admissionMay.getSJRRP());
      
      p_attribution.setFctRetenueOD(admissionMay.getPointDepartDelaisReport());
      
      p_attribution.setNbJoursIccp(admissionMay.getNbJoursICCP());
      p_attribution.setUniteDureeIccp("C");
      
      p_attribution.setNbJoursIslr(admissionMay.getNbJoursISLR());
      p_attribution.setUniteDureeIslr("C");
      
      p_attribution.setNbJoursDiffere(admissionMay.getNbJoursDelaiAttente());
      p_attribution.setUniteDureeDiffere("C");
    }
  }
  
  private static void renseignerDecision(Decision p_decision, Demande p_demande)
    throws CoucheLogiqueException
  {
    if ((p_demande.getDossierExamen() != null) && ((p_demande.getDossierExamen() instanceof Admission)))
    {
      Admission admissionMay = (Admission)p_demande.getDossierExamen();
      if ((admissionMay.getConventionGestion() != null) && ("2".equals(admissionMay.getConventionGestion().getSignataire()))) {
        p_decision.setEtablissementFinanceur(admissionMay.getConventionGestion().getNumeroConventionGestion());
      }
      p_decision.setDateFinPmc(admissionMay.getDateFinPMC());
    }
  }
}

/* Location:
 * Qualified Name:     AlimentationBasePivot
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */