package fr.unedic.cali.asu.may17.p02.liquidation.outilsfonctionnels;

import fr.unedic.cali.ari.dom.AttributionARISpec;
import fr.unedic.cali.ari.dom.Demande;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.Sjc;
import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.cali.asu.may17.p02.liquidation.dom.Admission;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.OutilFonctionnel;
import java.math.BigDecimal;

public final class RecuperationElementIndemnisation
  implements OutilFonctionnel
{
  public static ElementBaseIndemnisation recupererElementBaseIndemnisation(AttributionARISpec attribution)
    throws CoucheLogiqueException
  {
    Admission admission = (Admission)attribution;
    ElementBaseIndemnisation ebi = new ElementBaseIndemnisation();
    Demande demande = (Demande)admission.getDemande();
    
    ebi.setCoefficientTempsPartiel(admission.getCoefficientTP());
    ebi.setSjr(new Sjr(admission.getSJRInitial(), admission.getTermePRC(), "AREMAYOTTE"));
    
    BigDecimal valeurSJCInitial = admission.getSJCInitial();
    if (demande.getDossierAffectation().getProduit().getNom().equals("ASU_MAY17_03")) {
      if (OutilCalculDonneesNonPersistantes.trouverPresenceActiviteConservee(demande)) {
        valeurSJCInitial = BigDecimal.ONE;
      } else {
        valeurSJCInitial = BigDecimal.ZERO;
      }
    }
    ebi.setSjc(new Sjc(valeurSJCInitial, admission.getTermePRC(), "AREMAYOTTE"));
    
    ebi.setReglementApplicableMontantRetenu(((Admission)attribution).getAttributionAssurance().getReglementApplicable());
    
    ebi.setListePensionInvalidite(((Admission)attribution).getListePensionsInvalidite());
    return ebi;
  }
}

/* Location:
 * Qualified Name:     RecuperationElementIndemnisation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */