package fr.unedic.cali.asu.may17.p03.calcul.dom;

import fr.unedic.cali.asu.dom.ElementBaseIndemnisationAREF;
import fr.unedic.cali.asu.may17.p02.calcul.dom.FormuleMontantAREMFSpec;
import fr.unedic.cali.asu.may17.p02.calcul.dom.Montant;
import fr.unedic.cali.asu.may17.p02.calcul.dom.MontantMAYF;
import fr.unedic.cali.asu.parametres.EvenementParametre;
import fr.unedic.cali.asu.parametres.ParametresIndemnisation;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.UniteMonaitaire;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;

public class FormuleMontantAREM2016PremiereTrancheF
  extends FormuleMontantAREM2016PremiereTranche
  implements FormuleMontantAREMFSpec
{
  public static String getCode()
  {
    return "2";
  }
  
  public MontantBaseSpec calculer(ConstituantsIndemnisation constituantsIndemnisation, Damj dateCalcul)
    throws CoucheLogiqueException
  {
    Montant montant = null;
    MontantMAYF montantAREMF = null;
    EvenementParametre evenementParametre = null;
    
    montant = (Montant)super.calculer(constituantsIndemnisation, dateCalcul);
    
    evenementParametre = ParametresIndemnisation.getParametresIndemnisation().getElementActif(dateCalcul);
    
    montantAREMF = new MontantMAYF(montant);
    
    montantAREMF.setMini(new Quantite(evenementParametre.getSeuilMinimalAREMF(), UniteMonaitaire.EUROS));
    montantAREMF.setMontantBrut(new Quantite(montant.getMontantBrut().getValeur().max(montantAREMF.getMini().getValeur()), UniteMonaitaire.EUROS));
    if (montantAREMF.getMontantBrut().equals(montantAREMF.getMini())) {
      montantAREMF.setJustificationCalculMontant("04");
    }
    if (((constituantsIndemnisation.getElementBaseIndemnisationCourant() instanceof ElementBaseIndemnisationAREF)) && (((ElementBaseIndemnisationAREF)constituantsIndemnisation.getElementBaseIndemnisationCourant()).estEffectif())) {
      montantAREMF.setType("FORMATION EFFECTIVE");
    }
    return montantAREMF;
  }
}

/* Location:
 * Qualified Name:     FormuleMontantAREM2016PremiereTrancheF
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */