package fr.unedic.cali.asu.mnt.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.mnt.dom.pc.ConditionDecisionCPMaintienPC;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public abstract class ConditionDecisionCPMaintienGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_conditionDecisionCPMaintienPC;
  private ResultatElementDroit m_resultatElementDroit;
  
  public ConditionDecisionCPMaintienGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConditionDecisionCPMaintienGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new ConditionDecisionCPMaintienPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_conditionDecisionCPMaintienPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_conditionDecisionCPMaintienPC)
  {
    m_conditionDecisionCPMaintienPC = p_conditionDecisionCPMaintienPC;
  }
  
  protected boolean rawIsRefusFNE()
  {
    return ((ConditionDecisionCPMaintienPC)getPC()).isRefusFNE();
  }
  
  public boolean isRefusFNE()
  {
    return ((ConditionDecisionCPMaintienPC)getPC()).isRefusFNE();
  }
  
  public void setRefusFNE(boolean p_refusFNE)
  {
    ((ConditionDecisionCPMaintienPC)getPC()).setRefusFNE(p_refusFNE);
  }
  
  protected boolean rawIsDepartVolontaire()
  {
    return ((ConditionDecisionCPMaintienPC)getPC()).isDepartVolontaire();
  }
  
  public boolean isDepartVolontaire()
  {
    return ((ConditionDecisionCPMaintienPC)getPC()).isDepartVolontaire();
  }
  
  public void setDepartVolontaire(boolean p_departVolontaire)
  {
    ((ConditionDecisionCPMaintienPC)getPC()).setDepartVolontaire(p_departVolontaire);
  }
  
  protected boolean rawIsDecisionCPFavorable()
  {
    return ((ConditionDecisionCPMaintienPC)getPC()).isDecisionCPFavorable();
  }
  
  public boolean isDecisionCPFavorable()
  {
    return ((ConditionDecisionCPMaintienPC)getPC()).isDecisionCPFavorable();
  }
  
  public void setDecisionCPFavorable(boolean p_decisionCPFavorable)
  {
    ((ConditionDecisionCPMaintienPC)getPC()).setDecisionCPFavorable(p_decisionCPFavorable);
  }
  
  public ResultatElementDroit getResultatElementDroit()
  {
    if (m_resultatElementDroit == null)
    {
      DomPCSpec resultatElementDroitPC = ((ConditionDecisionCPMaintienPC)getPC()).getResultatElementDroit();
      if (resultatElementDroitPC != null) {
        m_resultatElementDroit = ((ResultatElementDroit)resultatElementDroitPC.createOM());
      }
    }
    return m_resultatElementDroit;
  }
  
  public void setResultatElementDroit(ResultatElementDroit p_resultatElementDroit)
  {
    if (p_resultatElementDroit == null)
    {
      ((ConditionDecisionCPMaintienPC)getPC()).setResultatElementDroit(null);
      m_resultatElementDroit = p_resultatElementDroit;
    }
    else if (!p_resultatElementDroit.equals(m_resultatElementDroit))
    {
      ((ConditionDecisionCPMaintienPC)getPC()).setResultatElementDroit(p_resultatElementDroit.getPC());
      m_resultatElementDroit = p_resultatElementDroit;
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    Object resultatElementDroit = getResultatElementDroit();
    if ((resultatElementDroit != null) && (!p_contexteSuppression.isAlreadyEnlistedForDeletion(resultatElementDroit))) {
      DomManager.supprimer(getResultatElementDroit(), p_contexteSuppression);
    }
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConditionDecisionCPMaintienGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */