package fr.unedic.cali.asu.mnt.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.mnt.dom.pc.FormulaireMaintienPC;
import fr.unedic.cali.dom.FormulaireAbstrait;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public abstract class FormulaireMaintienGen
  extends FormulaireAbstrait
  implements DomGenSpec
{
  private String m_referenceExterne;
  
  public FormulaireMaintienGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public FormulaireMaintienGen() {}
  
  protected DomPCSpec createPC()
  {
    return new FormulaireMaintienPC();
  }
  
  protected String rawGetReferenceExterne()
  {
    return ((FormulaireMaintienPC)getPC()).getReferenceExterne();
  }
  
  public String getReferenceExterne()
  {
    return ((FormulaireMaintienPC)getPC()).getReferenceExterne();
  }
  
  public void setReferenceExterne(String p_referenceExterne)
  {
    if ((m_referenceExterne == null) || (p_referenceExterne == null))
    {
      m_referenceExterne = p_referenceExterne;
      ((FormulaireMaintienPC)getPC()).setReferenceExterne(p_referenceExterne);
    }
    else if ((m_referenceExterne != null) && (p_referenceExterne != null) && (!p_referenceExterne.equals(m_referenceExterne)))
    {
      m_referenceExterne = p_referenceExterne;
      ((FormulaireMaintienPC)getPC()).setReferenceExterne(p_referenceExterne);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     FormulaireMaintienGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */