package fr.unedic.cali.asu.mnt.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.parcours.ParcoursLiquidationAssurance;
import fr.unedic.cali.dom.AgregatGaec;
import fr.unedic.cali.dom.DonneesChargementGaec;
import fr.unedic.cali.dom.Individu;
import fr.unedic.cali.dom.affectation.GammeSpec;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreDemandeASSOdAquise;
import fr.unedic.cali.parcours.AccesDonneesGaecException;
import fr.unedic.cali.parcours.DomCali;
import fr.unedic.cali.parcours.ParcoursLiquidation;
import fr.unedic.cali.parcours.ResultatRattrapageCourrierDalAss;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;

public class ParcoursRattraperCourrierDalAss
  extends ParcoursLiquidation
{
  public Resultat demarrerParcours(Contexte p_contexte)
    throws ApplicativeException
  {
    DomCali domCali = (DomCali)p_contexte.getDonnees();
    Individu individu = (Individu)domCali.getIndividu();
    
    ChronologiePeriodes chronoDemande = new ChronologiePeriodes();
    chronoDemande.ajouter(individu.getDemandes());
    
    Chronologie chronoDemandeResultante = chronoDemande.copier(new FiltreDemandeASSOdAquise());
    
    DemandeAssuranceSpec demande = (DemandeAssuranceSpec)chronoDemandeResultante.premierElement();
    
    ParcoursLiquidationAssurance parcoursLiquidation = (ParcoursLiquidationAssurance)demande.getGamme().getParcoursLiquidation(demande);
    parcoursLiquidation.deternminerQuantiteTravailPourCourrierASS(demande);
    
    ResultatRattrapageCourrierDalAss resultat = new ResultatRattrapageCourrierDalAss();
    resultat.estSatisfait();
    
    return resultat;
  }
  
  protected int getModeChargementDebrayageDossiersLourds(Individu p_individu)
  {
    return 2;
  }
  
  protected void alimenterAgregatGaec(Individu p_individu, String p_idDemande)
  {
    if (p_individu != null) {
      p_individu.getDonneesChargementGaec().getAgregatGaec().setModeAppel(2);
    }
  }
  
  protected void controlerPostTraitement(Individu p_individu)
    throws AccesDonneesGaecException
  {
    controlerModeAppel(p_individu.getDonneesChargementGaec().getAppelGaecReduit(), 2);
  }
}

/* Location:
 * Qualified Name:     ParcoursRattraperCourrierDalAss
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */