package fr.unedic.cali.asu.occasionnel.outilsfonctionnels;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.occasionnel.outilsfonctionnels.CriteresTraitementPopulation;
import fr.unedic.cali.occasionnel.outilsfonctionnels.ResultatTraitementPopulation;
import fr.unedic.cali.occasionnel.outilsfonctionnels.TraitementPopulationSpec;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.Damj;

public class TraitementContribOuvertureDroitCSP
  implements TraitementPopulationSpec
{
  private static final Damj DATE_REGRESSION = new Damj(2016, 12, 12);
  private static final Damj DATE_CORRECTIF = new Damj(2016, 12, 16);
  
  public ResultatTraitementPopulation effectuerTraitement(CriteresTraitementPopulation criteres)
    throws ApplicativeException
  {
    IndividuSpec individu = criteres.getIndividu();
    Chronologie demandesAssurances = individu.getChronoDemandeAssurance();
    demandesAssurances.iterer();
    while (demandesAssurances.encoreSuivant())
    {
      Demande demandeCourante = (Demande)demandesAssurances.elementSuivant();
      Damj datePremiereValidation = demandeCourante.getDatePremiereValidation();
      boolean estDemandeEnEntreeCSP = OutilGestionContexteDemande.estContexteDemandeAssurancePresent(demandeCourante, "AREENTRCSP");
      if ((estDemandeEnEntreeCSP) && (estDemandeElligible(datePremiereValidation))) {
        demandeCourante.setTopAppelContribution(true);
      }
    }
    return new ResultatTraitementPopulation();
  }
  
  private boolean estDemandeElligible(Damj datePremiereValidation)
  {
    return (DATE_REGRESSION.estAvantOuCoincideAvec(datePremiereValidation)) && (DATE_CORRECTIF.estApresOuCoincideAvec(datePremiereValidation));
  }
}

/* Location:
 * Qualified Name:     TraitementContribOuvertureDroitCSP
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */