package fr.unedic.cali.asu.outilsaffiliation;

import fr.unedic.util.services.OutilFonctionnel;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.ObjetChronoPeriode;
import fr.unedic.util.temps.OutilOptimisationChronologie;
import fr.unedic.util.temps.Periode;
import java.util.Iterator;

public class OutilPeriodeAffiliation
  implements OutilFonctionnel
{
  public static int determinerNombreJoursChronoApresFusionPeriode(Chronologie p_chrono, Periode p_periode)
  {
    ChronologiePeriodes chronoPeriode = construireChronologiePeriode(p_chrono);
    int total = 0;
    if ((chronoPeriode != null) && (!chronoPeriode.estVide()))
    {
      ChronologiePeriodes chronoPeriodeFusion = chronoPeriode.fusionnerChevauchementPeriodes();
      Iterator it = chronoPeriodeFusion.iterer();
      while (it.hasNext())
      {
        ObjetChronoPeriode objetPeriode = (ObjetChronoPeriode)it.next();
        Periode periodeCourante = new Periode(objetPeriode.getDateDebut(), objetPeriode.getDateFin());
        total += p_periode.inter(periodeCourante);
      }
    }
    return total;
  }
  
  public static ChronologiePeriodes construireChronologiePeriode(Chronologie chronoActivite)
  {
    if ((chronoActivite instanceof ChronologiePeriodes)) {
      return (ChronologiePeriodes)chronoActivite;
    }
    ChronologiePeriodes resultat = new ChronologiePeriodes();
    
    OutilOptimisationChronologie outilOptimisationChronologie = new OutilOptimisationChronologie(resultat);
    if (chronoActivite != null)
    {
      Iterator it = chronoActivite.iterer();
      while (it.hasNext())
      {
        ObjetChronoPeriode periode = (ObjetChronoPeriode)it.next();
        
        outilOptimisationChronologie.ajouter(periode);
      }
    }
    return (ChronologiePeriodes)outilOptimisationChronologie.getChronologieTriee();
  }
}

/* Location:
 * Qualified Name:     OutilPeriodeAffiliation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */