package fr.unedic.cali.asu.outilsfonctionnels;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreActiviteSalarie;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreFinActivite;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesLiquidables;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesSansConflit;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.FiltreChevauchePeriode;
import fr.unedic.util.temps.FiltreFinDansBornes;
import fr.unedic.util.temps.FiltresTemporel;
import fr.unedic.util.temps.Periode;

public class ConstructionChronologieCarences
{
  public static Chronologie determinerChronoActivitesParticipantCarences(Periode p_periodeReference, Demande p_demande)
  {
    Chronologie chronoActivitesRetenuesCarences = null;
    
    FiltresTemporel filtres = new FiltresTemporel();
    filtres.ajouterFiltre(new FiltreActiviteSalarie());
    filtres.ajouterFiltre(new FiltreFinDansBornes(p_periodeReference));
    
    filtres.ajouterFiltre(new FiltrePeriodesLiquidables());
    filtres.ajouterFiltre(new FiltrePeriodesSansConflit());
    filtres.ajouterFiltre(new FiltreFinActivite());
    
    chronoActivitesRetenuesCarences = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(filtres);
    
    return chronoActivitesRetenuesCarences;
  }
  
  public static Chronologie determinerChronoActiviteToutReglementPourSalaireDiffereStandard(Periode p_periodeRecherche, DemandeAssuranceSpec p_demande)
  {
    Chronologie chronoActivitesRetenuesCarences = null;
    
    FiltresTemporel filtres = new FiltresTemporel();
    filtres.ajouterFiltre(new FiltreActiviteSalarie());
    filtres.ajouterFiltre(new FiltreChevauchePeriode(p_periodeRecherche));
    
    chronoActivitesRetenuesCarences = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(filtres);
    
    return chronoActivitesRetenuesCarences;
  }
}

/* Location:
 * Qualified Name:     ConstructionChronologieCarences
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */