package fr.unedic.cali.asu.outilsfonctionnels;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.dom.EreDemandeApsEfe;
import fr.unedic.cali.asu.dom.EreDemandeAreEfe;
import fr.unedic.cali.asu.dom.EreDemandeAtAfdEfe;
import fr.unedic.cali.dom.EvenementReferenceExamenSpec;
import fr.unedic.cali.dom.FormulaireSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreNegation;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeActiviteSalarieeE301;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeActiviteSalarieeE301NonFrontalier;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.FiltreChevauchePeriode;
import fr.unedic.util.temps.FiltresTemporel;
import fr.unedic.util.temps.Periode;

public class OutilGestionCoordinationEuropeenne
{
  private static OutilGestionCoordinationEuropeenne s_instance = new OutilGestionCoordinationEuropeenne();
  
  public static OutilGestionCoordinationEuropeenne getInstance()
  {
    return s_instance;
  }
  
  public void controlerCoordinationEuropeenneATord(Demande p_demande, Periode p_periodePra)
    throws CoucheLogiqueException
  {
    if ((p_periodePra != null) && (p_demande.getDonneesTemporaires().isEstCoordCee()))
    {
      FiltresTemporel listeFiltresE301DansPra = new FiltresTemporel();
      listeFiltresE301DansPra.ajouterFiltre(new FiltrePeriodeActiviteSalarieeE301());
      listeFiltresE301DansPra.ajouterFiltre(new FiltreChevauchePeriode(p_periodePra));
      Chronologie chronoE301DansPra = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(listeFiltresE301DansPra);
      
      Periode periodeRecherche = new Periode(p_periodePra.getFin(), getDateBornageRechercheE301NonFrontalier(p_demande));
      FiltresTemporel listeFiltresE301EntrePraDateExamen = new FiltresTemporel();
      listeFiltresE301EntrePraDateExamen.ajouterFiltre(new FiltrePeriodeActiviteSalarieeE301());
      listeFiltresE301EntrePraDateExamen.ajouterFiltre(new FiltreNegation(new FiltrePeriodeActiviteSalarieeE301NonFrontalier()));
      listeFiltresE301EntrePraDateExamen.ajouterFiltre(new FiltreChevauchePeriode(periodeRecherche));
      Chronologie chronoE301DansEntrePraDateExamen = p_demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation().copier(listeFiltresE301EntrePraDateExamen);
      if ((estLeverAlerte(chronoE301DansPra)) && (estLeverAlerte(chronoE301DansEntrePraDateExamen))) {
        GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ALERTE_A16MB5");
      }
    }
  }
  
  private boolean estLeverAlerte(Chronologie p_chronologie)
  {
    return (p_chronologie == null) || (p_chronologie.estVide());
  }
  
  private Damj getDateBornageRechercheE301NonFrontalier(Demande p_demande)
  {
    Damj dateBornageRecherche = p_demande.getDateExamen();
    
    EvenementReferenceExamenSpec ere = p_demande.getEvenementReferenceExamen();
    if (((ere instanceof EreDemandeApsEfe)) || ((ere instanceof EreDemandeAreEfe)) || ((ere instanceof EreDemandeAtAfdEfe))) {
      dateBornageRecherche = p_demande.getFormulaire().getDateDepot();
    }
    return dateBornageRecherche;
  }
}

/* Location:
 * Qualified Name:     OutilGestionCoordinationEuropeenne
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */