package fr.unedic.cali.asu.outilsfonctionnels;

import fr.unedic.util.services.CoucheLogiqueException;

public class VerificationDonneesInfoComplementaires
{
  private static VerificationDonneesInfoComplementaires instance;
  protected String competenceAssedic = String.valueOf(1);
  protected String competenceSp = String.valueOf(2);
  
  public static VerificationDonneesInfoComplementaires getInstance()
  {
    if (instance == null) {
      instance = new VerificationDonneesInfoComplementaires();
    }
    return instance;
  }
  
  public void detecterBlocageSurCompetenceFinanciereSaisie(String competenceFinanciere, String etablissementFinanceur, String codeAffectation, String employeurSPCompetent)
    throws CoucheLogiqueException
  {
    if ((competenceFinanciere != null) && (competenceFinanciere.equals(competenceSp)))
    {
      boolean estEmployeurEtConventionGestionNonSaisie = (etablissementFinanceur == null) && (codeAffectation == null) && (employeurSPCompetent == null);
      if (estEmployeurEtConventionGestionNonSaisie) {
        GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_CSP_PAP_COMP_FIN_SANS_EMP_ET_CG");
      }
    }
  }
  
  public void detecterBlocageSurConventionGestionSaisie(String etablissementFinanceur, String codeAffectation, String competenceFinanciere, String employeurSPCompetent)
    throws CoucheLogiqueException
  {
    boolean estEtablissementFinanceurSaisi = etablissementFinanceur != null;
    boolean estCodeAffectationSaisi = codeAffectation != null;
    boolean estConventionGestionComplete = (estEtablissementFinanceurSaisi) && (estCodeAffectationSaisi);
    if ((estEtablissementFinanceurSaisi) && (!estCodeAffectationSaisi))
    {
      GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_CSP_PAP_CG_CD_AFFECT_MANQUANT");
    }
    else if ((estCodeAffectationSaisi) && (!estEtablissementFinanceurSaisi))
    {
      GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_CSP_PAP_CG_ETAB_FIN_MANQUANT");
    }
    else if (estConventionGestionComplete)
    {
      if ((competenceFinanciere != null) && (!competenceFinanciere.equals(competenceSp))) {
        GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_CSP_PAP_CG_AVEC_COMP_FIN_NON_SP");
      }
      if (employeurSPCompetent != null) {
        GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_CSP_PAP_CG_ET_EMP_SP_SAISI");
      }
    }
  }
  
  public void detecterBlocageSurEmployeurSPCompetentSaisie(String employeurSPCompetent, String competenceFinanciere)
    throws CoucheLogiqueException
  {
    if ((employeurSPCompetent != null) && (competenceFinanciere != null) && (!competenceSp.equals(competenceFinanciere))) {
      GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_CSP_PAP_EMPL_SP_COMP_FIN");
    }
  }
}

/* Location:
 * Qualified Name:     VerificationDonneesInfoComplementaires
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */