package fr.unedic.cali.asu.outilsfonctionnels.liquidationsimplifiee.strategie;

import fr.unedic.cali.asu.dom.SituationDemandeur;
import fr.unedic.cali.asu.outilsfonctionnels.liquidationsimplifiee.Parametres;
import fr.unedic.cali.asu.produits.liquidation.dom.ParametreLiquidationSimplifiee;
import fr.unedic.cali.asu.produits.liquidation.parametres.CleAccesPRA;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import java.util.Iterator;
import java.util.List;

public class StrategieAffiliationLiquidationSimplifieeApres
  implements StrategieAffiliationLiquidationSimplifieeSpec
{
  public ParametreLiquidationSimplifiee determinerPra(SituationDemandeur situation, Damj dateFCT, IndividuSpec individu)
  {
    ParametreLiquidationSimplifiee param = null;
    
    DureeCalendaire ageFG = individu.getAgeALaDate(dateFCT);
    
    CleAccesPRA cle = Parametres.construireCleAccesPRA(ageFG, dateFCT);
    
    boolean reliquatValide = situation.getEtatReliquat() == 3;
    
    List<ParametreLiquidationSimplifiee> listeParametre = Parametres.chargerParametres();
    
    Iterator<ParametreLiquidationSimplifiee> it = listeParametre.iterator();
    while (it.hasNext())
    {
      param = (ParametreLiquidationSimplifiee)it.next();
      if ((param.estApplicable(cle)) && (reliquatValide == param.isReliquatValide())) {
        break;
      }
    }
    alimenteDateDebutPra(situation, param);
    return param;
  }
  
  public void alimenteDateDebutPra(SituationDemandeur situation, ParametreLiquidationSimplifiee param)
  {
    boolean reliquatValide = situation.getEtatReliquat() == 3;
    if (reliquatValide)
    {
      Damj debut = situation.getDateFgdAsuPrecedent();
      if (situation.getDateDVprecedantRepriseIPR() != null) {
        debut = Damj.max(debut, situation.getDateDVprecedantRepriseIPR());
      }
      param.setDateDebutPra(debut);
    }
  }
}

/* Location:
 * Qualified Name:     StrategieAffiliationLiquidationSimplifieeApres
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */