package fr.unedic.cali.asu.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.EreDemandeExpresse;
import fr.unedic.cali.asu.outilsfonctionnels.OutilsChomageSansRCT;
import fr.unedic.cali.asu.outilsfonctionnels.RechercherDernierSinistreAsu;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Chronologie;

public class StrategieFCTRetenueDemandeExpresseAvant
  implements StrategieFCTRetenueDemandeExpresseSpec
{
  public boolean rechercherDernierSinistre(DemandeAssuranceSpec p_demandeAssurance, Chronologie p_chronoPeriodesParticipantes)
    throws CoucheLogiqueException
  {
    TravailSpec dernierSinistre = null;
    if (OutilsChomageSansRCT.estDemandeEnContexteDeChomageEnCoursDeSuspension(p_demandeAssurance))
    {
      dernierSinistre = RechercherDernierSinistreAsu.determinerDernierSinitrePourChomageSansRCT(p_demandeAssurance, p_chronoPeriodesParticipantes, p_chronoPeriodesParticipantes);
    }
    else
    {
      EreDemandeExpresse ereDemande = (EreDemandeExpresse)p_demandeAssurance.getEvenementReferenceExamen();
      dernierSinistre = ereDemande.getPeriodeExamen();
    }
    ((DossierAffectation)p_demandeAssurance.getDossierAffectation()).setSinistre(dernierSinistre);
    if (dernierSinistre == null) {
      return false;
    }
    return true;
  }
}

/* Location:
 * Qualified Name:     StrategieFCTRetenueDemandeExpresseAvant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */