package fr.unedic.cali.asu.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.DossierExamenAssuranceSpec;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.RejetSpec;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreDateDeclenchementExamenApresOuCoincideDate;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreDateDeclenchementExamenAvantOuCoincideDate;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologieDebuts;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.FiltresTemporel;

public class StrategieRejetDvAssAvant13SI1
  implements StrategieRejetDvAssSpec
{
  public boolean verifierCreationDalASS(AttributionSpec p_attributionAss, DemandeSpec p_demande)
  {
    boolean presenceRejetDV = false;
    
    FiltresTemporel filtreDemandesAre = new FiltresTemporel();
    filtreDemandesAre.ajouterFiltre(new FiltreDateDeclenchementExamenAvantOuCoincideDate(p_demande.getDateRecherche()));
    
    filtreDemandesAre.ajouterFiltre(new FiltreDateDeclenchementExamenApresOuCoincideDate(p_attributionAss.getDateAttribution().lendemain()));
    
    Chronologie demandesAssurances = p_demande.getDemandeur().getChronoDemandeAssurance().copier(filtreDemandesAre);
    demandesAssurances.iterer();
    while ((demandesAssurances.encoreSuivant()) && (!presenceRejetDV))
    {
      DemandeAssuranceSpec demandeCourante = (DemandeAssuranceSpec)demandesAssurances.elementSuivant();
      if ((demandeCourante.getDossierExamen() != null) && ((demandeCourante.getDossierExamen() instanceof RejetSpec)) && (((DossierExamenAssuranceSpec)demandeCourante.getDossierExamen()).estRejetDV())) {
        presenceRejetDV = true;
      }
    }
    return !presenceRejetDV;
  }
}

/* Location:
 * Qualified Name:     StrategieRejetDvAssAvant13SI1
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */