package fr.unedic.cali.asu.parametres;

import java.math.BigDecimal;
import java.util.HashMap;

public class AccesSeuilMinimalAREF
  extends AccesParametreIdemnisation
{
  public AccesSeuilMinimalAREF()
  {
    initialiser();
  }
  
  protected void initialiser()
  {
    m_table.put(new DateAcces(JUILLET_2017), new ValeurParametreCalcul(new BigDecimal("20.67")));
    m_table.put(new DateAcces(JUILLET_2015), new ValeurParametreCalcul(new BigDecimal("20.54")));
    m_table.put(new DateAcces(JUILLET_2014), new ValeurParametreCalcul(new BigDecimal("20.48")));
    m_table.put(new DateAcces(JUILLET_2013), new ValeurParametreCalcul(new BigDecimal("20.34")));
    m_table.put(new DateAcces(JUILLET_2012), new ValeurParametreCalcul(new BigDecimal("20.22")));
    m_table.put(new DateAcces(JUILLET_2011), new ValeurParametreCalcul(new BigDecimal("19.82")));
    m_table.put(new DateAcces(JUILLET_2010), new ValeurParametreCalcul(new BigDecimal("19.53")));
    m_table.put(new DateAcces(JUILLET_2009), new ValeurParametreCalcul(new BigDecimal("19.30")));
    m_table.put(new DateAcces(JUILLET_2008), new ValeurParametreCalcul(new BigDecimal("19.11")));
    m_table.put(new DateAcces(JUILLET_2007), new ValeurParametreCalcul(new BigDecimal("18.64")));
    m_table.put(new DateAcces(JUILLET_2006), new ValeurParametreCalcul(new BigDecimal("18.28")));
    m_table.put(new DateAcces(JUILLET_2004), new ValeurParametreCalcul(new BigDecimal("17.92")));
    m_table.put(new DateAcces(JUILLET_2003), new ValeurParametreCalcul(new BigDecimal("17.74")));
    m_table.put(new DateAcces(JUILLET_2002), new ValeurParametreCalcul(new BigDecimal("17.37")));
    
    m_table.put(new DateAcces(JUILLET_2001), new ValeurParametreCalcul(new BigDecimal("17.11")));
    m_table.put(new DateAcces(JUILLET_2000), new ValeurParametreCalcul(new BigDecimal("16.71")));
    m_table.put(new DateAcces(JUILLET_1999), new ValeurParametreCalcul(new BigDecimal("16.38")));
    m_table.put(new DateAcces(JUILLET_1998), new ValeurParametreCalcul(new BigDecimal("16.18")));
    m_table.put(new DateAcces(JUILLET_1997), new ValeurParametreCalcul(new BigDecimal("15.88")));
  }
  
  public void remplir(EvenementParametre evenement, DateAcces dateAcces)
  {
    evenement.setSeuilMinimalAREF(((ValeurParametreCalcul)m_table.get(dateAcces)).getValeur());
  }
}

/* Location:
 * Qualified Name:     AccesSeuilMinimalAREF
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */