package fr.unedic.cali.asu.parametres;

import fr.pe.cali.reglementaire.dom.impl.CriteresFabriqueReglementaire;
import fr.pe.cali.reglementaire.regles.assurance.affiliation.parametres.unites.dom.DonneesEntreeListeUniteParReglement;
import fr.pe.cali.reglementaire.regles.assurance.affiliation.parametres.unites.dom.ResultatListeUniteParReglement;
import fr.pe.cali.reglementaire.regles.assurance.affiliation.parametres.unites.fabrique.FabriqueAccesListeUniteParReglement;
import fr.pe.cali.reglementaire.regles.assurance.affiliation.parametres.unites.outils.spec.IOutilAccesListeUniteParReglement;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.util.Unite;
import fr.unedic.util.temps.Periode;
import java.util.ArrayList;
import java.util.List;

public class OutilAccesListeUnitesReglement
{
  private static OutilAccesListeUnitesReglement instance = new OutilAccesListeUnitesReglement();
  
  public static final OutilAccesListeUnitesReglement getInstance()
  {
    return instance;
  }
  
  public List<Unite> recupererListeUniteRechercheReglementApplicable(String nomReglement, boolean estConditionMinimalRechargement, ProduitSpec produit)
  {
    return recupererListeUnite(nomReglement, estConditionMinimalRechargement, "rechercheReglementApplicable", produit);
  }
  
  public List<Unite> recupererListeUniteConstitutionQuantiteAffiliation(String nomReglement, ProduitSpec produit)
  {
    return recupererListeUnite(nomReglement, false, "cepAffi", produit);
  }
  
  public List<Unite> recupererListeUniteCouvetureChomageInvolontaire(String nomReglement, ProduitSpec produit)
  {
    return recupererListeUnite(nomReglement, false, "couvertureChomageInvolontaire", produit);
  }
  
  public List<Unite> recupererListeUniteInpposabiliteChomageInvolontaire(String nomReglement, ProduitSpec produit)
  {
    return recupererListeUnite(nomReglement, false, "inopposabiliteChomageInvolontaire", produit);
  }
  
  public List<Unite> recupererListeUnite(String nomReglement, boolean estConditionMinimalRechargement, String contexteAppel, ProduitSpec produit)
  {
    FabriqueAccesListeUniteParReglement fabrique = FabriqueAccesListeUniteParReglement.getInstance();
    CriteresFabriqueReglementaire criteres = new CriteresFabriqueReglementaire();
    criteres.setCodeProduit(produit.getNomUnique());
    
    criteres.setDate(produit.getPeriodeValidite().getDebut());
    List<String> fonctionnelles = new ArrayList();
    fonctionnelles.add(contexteAppel);
    List<String> reglementaires = new ArrayList();
    if (estConditionMinimalRechargement) {
      reglementaires.add("conditionMinimalRechargement");
    }
    criteres.setListeContextesFonctionnels(fonctionnelles);
    criteres.setListeContextesReglementaires(reglementaires);
    IOutilAccesListeUniteParReglement outil = fabrique.recupererOutilCorpsRegle(criteres);
    DonneesEntreeListeUniteParReglement donnees = new DonneesEntreeListeUniteParReglement();
    donnees.setReglement(nomReglement);
    return outil.determinerListeUnite(donnees).getListeUnites();
  }
}

/* Location:
 * Qualified Name:     OutilAccesListeUnitesReglement
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */