package fr.unedic.cali.asu.parcours;

import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.outilsfonctionnels.OutilAsr;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.autresdoms.ga.dom.spec.CertifieSpec;
import fr.unedic.cali.autresdoms.ga.dom.spec.DeclareSpec;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.dom.affectation.GammeAsu;
import fr.unedic.cali.dom.affectation.ProduitAsuCaa14P01;
import fr.unedic.cali.dom.affectation.ProduitAsuCva10P01;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import java.util.List;

public class AffectationDemandeAsr
  extends AffectationDemandeCvaCaa
{
  protected ProduitAsuSpec recupererProduitActif()
  {
    return ProduitAsuCaa14P01.getInstance();
  }
  
  protected ProduitAsuSpec affecterProduitCaa(Damj p_dateRechercheDecor)
    throws CoucheLogiqueException
  {
    ProduitAsuSpec produit = ProduitAsuCaa14P01.getInstance();
    if (!GammeAsu.getInstance().getProduitsActifs(p_dateRechercheDecor).contains(produit)) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("HG_PR_CALI_L_PRODUIT_NON_ACTIF_DATE_EXAMEN", new Object[] { produit.getLibelleCourt(), p_dateRechercheDecor.toString() });
    }
    return produit;
  }
  
  protected ProduitAsuSpec affecterProduitCva(Damj p_dateRechercheDecor)
    throws CoucheLogiqueException
  {
    ProduitAsuSpec produit = ProduitAsuCva10P01.getInstance();
    if (!GammeAsu.getInstance().getProduitsActifs(p_dateRechercheDecor).contains(produit)) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("HG_PR_CALI_L_PRODUIT_NON_ACTIF_DATE_EXAMEN", new Object[] { produit.getLibelleCourt(), p_dateRechercheDecor.toString() });
    }
    return produit;
  }
  
  protected void verifierDernierAuAtteste(TravailSpec p_dernierSinistre)
    throws CoucheLogiqueException
  {
    if ((((p_dernierSinistre instanceof ActiviteSalarie)) && (!((ActiviteSalarie)p_dernierSinistre).estAtteste())) || (((p_dernierSinistre instanceof CertifieSpec)) && (!((CertifieSpec)p_dernierSinistre).estAtteste())) || (((p_dernierSinistre instanceof DeclareSpec)) && (!((DeclareSpec)p_dernierSinistre).estJustifie()))) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_ALERTE_A8MB9");
    }
  }
  
  protected boolean verifierAncienneteSuffisante(DemandeAssuranceSpec p_demande, TravailSpec sinistre, Damj dateExecutionProcedure)
    throws CoucheLogiqueException
  {
    return OutilAsr.estDeuxAnsAnciennetee(p_demande, sinistre);
  }
}

/* Location:
 * Qualified Name:     AffectationDemandeAsr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */