package fr.unedic.cali.asu.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.ValidationProduit;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.util.temps.Chronologie;

public class AffectationDemandeAsuFinAsr
  extends AffectationDemandeASUClassique
{
  protected void validerProduit(DemandeAssuranceSpec p_demandeAsuCourante, Chronologie p_chronoPeriodesParticipantes, ProduitAsuSpec p_produitDernierSinistre)
    throws ApplicativeException
  {
    super.validerProduit(p_demandeAsuCourante, p_chronoPeriodesParticipantes, p_produitDernierSinistre);
    DossierAffectation dossierAffectationCourant = (DossierAffectation)p_demandeAsuCourante.getDossierAffectation();
    ValidationProduit validationProduit = dossierAffectationCourant.getValidationProduit();
    if (((validationProduit == null) || (!validationProduit.isEstProduitValide())) && ((dossierAffectationCourant.getSinistre() instanceof ActiviteSalarie)) && (((Demande)p_demandeAsuCourante).estContexteAsrPrecSuiteCsr()))
    {
      validationProduit = new ValidationProduit();
      validationProduit.setPeriodeValidationProduit((ActiviteSalarie)dossierAffectationCourant.getSinistre());
      
      validationProduit.setProduitValide(p_produitDernierSinistre);
      dossierAffectationCourant.setValidationProduit(validationProduit);
    }
  }
}

/* Location:
 * Qualified Name:     AffectationDemandeAsuFinAsr
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */