package fr.unedic.cali.asu.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.dom.AgregatGaec;
import fr.unedic.cali.dom.ComportementExamenFilEauSpec;
import fr.unedic.cali.dom.DonneesChargementGaec;
import fr.unedic.cali.dom.Individu;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.outilsfonctionnels.ExamenAuFilEauManager;
import fr.unedic.cali.outilsfonctionnels.OutilComportementExamenFilEau;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.AccesDonneesGaecException;
import fr.unedic.cali.parcours.ParcoursServiceAbstrait;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Damj;

public class ParcoursServiceExamenAuFilEau
  extends ParcoursServiceAbstrait
{
  public Resultat demarrerParcours(Contexte p_contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    IndividuSpec individu = getIndividu(p_contexte);
    Damj dateFct = ((DomExamenAuFilEau)p_contexte.getDonnees()).getDateEvenement();
    boolean modeSimulation = ((DomExamenAuFilEau)p_contexte.getDonnees()).isModeSimulationActif();
    
    ComportementExamenFilEauSpec comportement = OutilComportementExamenFilEau.getComportementManuel();
    
    comportement.setModeSimulationActif(modeSimulation);
    
    comportement.setDateEvenementDeclencheur(dateFct);
    
    Resultat resultatExamenAuFilEau = ExamenAuFilEauManager.executerExamenFilEau(individu, comportement);
    
    OutilTrace.tracerFinParcours();
    
    return resultatExamenAuFilEau;
  }
  
  protected int getModeChargementDebrayageDossiersLourds(Individu p_individu)
  {
    return 2;
  }
  
  protected void alimenterAgregatGaec(Individu p_individu, String p_idDemande)
  {
    if (p_individu != null) {
      p_individu.getDonneesChargementGaec().getAgregatGaec().setModeAppel(2);
    }
  }
  
  protected void controlerPostTraitement(Individu p_individu)
    throws AccesDonneesGaecException
  {
    controlerModeAppel(p_individu.getDonneesChargementGaec().getAppelGaecReduit(), 2);
  }
}

/* Location:
 * Qualified Name:     ParcoursServiceExamenAuFilEau
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */