package fr.unedic.cali.asu.produits.liquidation.dom;

import fr.unedic.cali.asu.dom.Sjr;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.temps.Damj;

public class BaseCarenceMontant
  extends BaseCarence
{
  private static final long serialVersionUID = -1858367230039483548L;
  private Sjr m_sjrrp = null;
  private Damj m_dateFg = null;
  private boolean m_estTopContratsRemuneresBaseSmic;
  
  private BaseCarenceMontant() {}
  
  public BaseCarenceMontant(Sjr p_sjrrp)
  {
    setSjrrp(p_sjrrp);
  }
  
  public BaseCarenceMontant(Sjr p_sjrrp, QuantiteEuro p_montantIccp, QuantiteEuro p_montantIslr, Damj p_dateFg)
  {
    super(null, p_montantIccp, p_montantIslr);
    setSjrrp(p_sjrrp);
    setDateFg(p_dateFg);
  }
  
  public BaseCarenceMontant(Sjr p_sjrrp, QuantiteEuro p_montantIccp, QuantiteEuro p_montantIslr, Damj p_dateFg, boolean p_estTopContratsRemuneresBaseSmic)
  {
    super(null, p_montantIccp, p_montantIslr);
    setSjrrp(p_sjrrp);
    setDateFg(p_dateFg);
    setEstTopContratsRemuneresBaseSmic(p_estTopContratsRemuneresBaseSmic);
  }
  
  public Damj getDateFg()
  {
    return m_dateFg;
  }
  
  public Sjr getSjrrp()
  {
    return m_sjrrp;
  }
  
  public void setDateFg(Damj p_dateFg)
  {
    m_dateFg = p_dateFg;
  }
  
  public void setSjrrp(Sjr p_sjrrp)
  {
    m_sjrrp = p_sjrrp;
  }
  
  public boolean estTopContratsRemuneresBaseSmic()
  {
    return m_estTopContratsRemuneresBaseSmic;
  }
  
  public void setEstTopContratsRemuneresBaseSmic(boolean p_estTopContratsRemuneresBaseSmic)
  {
    m_estTopContratsRemuneresBaseSmic = p_estTopContratsRemuneresBaseSmic;
  }
  
  public String toString()
  {
    StringBuffer chaineRetour = new StringBuffer();
    
    chaineRetour.append(super.toString());
    chaineRetour.append("\n\t SJRRP : " + getSjrrp() + "\n");
    chaineRetour.append("\n\t DATE FG : " + getDateFg() + "\n");
    chaineRetour.append("\n\t TOP CONTRATS REMUNERES BASE SMIC : " + estTopContratsRemuneresBaseSmic() + "\n");
    
    return chaineRetour.toString();
  }
  
  public ObjetMetierSpec copie()
  {
    BaseCarenceMontant copie = new BaseCarenceMontant();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    BaseCarenceMontant copie = (BaseCarenceMontant)p_copie;
    
    super.copieElements(copie);
    if (getSjrrp() != null) {
      copie.setSjrrp((Sjr)getSjrrp().copie());
    }
    copie.setDateFg(getDateFg());
    copie.setEstTopContratsRemuneresBaseSmic(estTopContratsRemuneresBaseSmic());
  }
}

/* Location:
 * Qualified Name:     BaseCarenceMontant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */