package fr.unedic.cali.asu.produits.liquidation.dom;

import fr.unedic.cali.asu.dom.ObjetChronoPeriodeConcreteCarenceForcee;
import fr.unedic.cali.asu.produits.liquidation.dom.gen.CarenceIccpGen;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.ObjetChronoPeriode;

public class CarenceIccp
  extends CarenceIccpGen
{
  private static final long serialVersionUID = -6269650313624267611L;
  
  public CarenceIccp(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public CarenceIccp() {}
  
  public CarenceIccp(int p_jours)
  {
    super(p_jours);
  }
  
  public CarenceIccp(ObjetChronoPeriode p_periodeOrigine, int p_nombreJours)
  {
    super(p_nombreJours);
    if (p_periodeOrigine != null) {
      setDateFinPeriodeOrigine(p_periodeOrigine.getDateFin());
    }
    setOrigine(p_periodeOrigine);
    if ((p_periodeOrigine instanceof TravailSpec)) {
      setIdentifiantPeriodeOrigine(((TravailSpec)p_periodeOrigine).getIdentifiant());
    } else if ((p_periodeOrigine instanceof ObjetChronoPeriodeConcreteCarenceForcee)) {
      setIdentifiantPeriodeOrigine("CarenceForcee");
    }
  }
  
  public String getTypeCarence()
  {
    return "ICCP";
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    CarenceIccp copie = (CarenceIccp)p_copie;
    super.copieElements(copie);
  }
  
  public ObjetMetierSpec copie()
  {
    CarenceIccp copie = new CarenceIccp();
    copieElements(copie);
    return copie;
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
}

/* Location:
 * Qualified Name:     CarenceIccp
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */