package fr.unedic.cali.asu.produits.liquidation.dom;

import fr.unedic.cali.asu.dom.PeriodeChomageSaisonnier;
import fr.unedic.cali.asu.dom.spec.ConstitutionCaractereSaisonnierSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.gen.ConstitutionCaractereSaisonnierGen;
import fr.unedic.cali.dom.ConstitutionDroitSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Periode;
import java.util.Collection;
import java.util.Iterator;

public class ConstitutionCaractereSaisonnier
  extends ConstitutionCaractereSaisonnierGen
  implements ConstitutionDroitSpec, ConstitutionCaractereSaisonnierSpec
{
  private static final long serialVersionUID = -8638878078326154688L;
  public static final int CARACTERE_SAISONNIER_NATURE = 2;
  public static final int CARACTERE_SAISONNIER_RYTHME = 1;
  public static final int CARACTERE_SAISONNIER_NON_DETERMINE = -1;
  
  public ConstitutionCaractereSaisonnier(DomPCSpec pc)
  {
    super(pc);
  }
  
  public ConstitutionCaractereSaisonnier() {}
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(super.getCollectionPeriodeChomageSaisonnier());
  }
  
  public ObjetMetierSpec copie()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller le méthode copieElements(ObjetMetierSpec).");
  }
  
  public void copieElements(ObjetMetierSpec copie)
  {
    ConstitutionCaractereSaisonnier copieCaractere = (ConstitutionCaractereSaisonnier)copie;
    if (getPeriodeRechercheActiviteSaisonniere() != null) {
      copieCaractere.setPeriodeRechercheActiviteSaisonniere(new Periode(getPeriodeRechercheActiviteSaisonniere().getDebut(), getPeriodeRechercheActiviteSaisonniere().getFin()));
    }
    if (getPeriodeReferenceSaisonnier() != null) {
      copieCaractere.setPeriodeReferenceSaisonnier(new Periode(getPeriodeReferenceSaisonnier().getDebut(), getPeriodeReferenceSaisonnier().getFin()));
    }
    copieCaractere.setActivite3Sur5(isActivite3Sur5());
    copieCaractere.setCaractereSaisonnierRetenu(isCaractereSaisonnierRetenu());
    copieCaractere.setTypeCaractereSaisonnierRetenu(getTypeCaractereSaisonnierRetenu());
    
    Iterator iter = getCollectionPeriodeChomageSaisonnier().iterator();
    while (iter.hasNext())
    {
      PeriodeChomageSaisonnier element = (PeriodeChomageSaisonnier)iter.next();
      copieCaractere.ajouterPeriodeChomageSaisonnier((PeriodeChomageSaisonnier)element.copie());
    }
  }
  
  public Collection getListePeriodesChomageSaisonnier()
  {
    return getCollectionPeriodeChomageSaisonnier();
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public void remplacerCollectionPeriodeChomageSaisonnier(Collection collectionACopier)
  {
    for (Iterator iter = super.getCollectionPeriodeChomageSaisonnier().iterator(); iter.hasNext();)
    {
      PeriodeChomageSaisonnier element = (PeriodeChomageSaisonnier)iter.next();
      DomManager.supprimer(element);
    }
    super.remplacerCollectionPeriodeChomageSaisonnier(collectionACopier);
  }
}

/* Location:
 * Qualified Name:     ConstitutionCaractereSaisonnier
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */