package fr.unedic.cali.asu.produits.liquidation.dom;

import fr.unedic.cali.asu.produits.liquidation.dom.gen.ConstitutionDureesGen;
import fr.unedic.cali.dom.ConstitutionDroitSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public class ConstitutionDurees
  extends ConstitutionDureesGen
  implements ConstitutionDroitSpec
{
  private static final long serialVersionUID = -1171588208684191189L;
  private transient int m_joursEcretementSurPlafonnementDuree = 0;
  private DureeIndemnisation m_dureeIndemnisation;
  
  private ConstitutionDurees() {}
  
  public ConstitutionDurees(DomPCSpec p_constitutionElementsAdmissionPC)
  {
    super(p_constitutionElementsAdmissionPC);
  }
  
  public DureeIndemnisation createDureeIndemnisation()
  {
    m_dureeIndemnisation = new DureeIndemnisation(getPC());
    return m_dureeIndemnisation;
  }
  
  public DureeIndemnisation getDureeIndemnisation()
  {
    if (m_dureeIndemnisation == null) {
      m_dureeIndemnisation = createDureeIndemnisation();
    }
    return m_dureeIndemnisation;
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  /**
   * @deprecated
   */
  public void marquerGraphePersistant() {}
  
  public ObjetMetierSpec copie()
  {
    throw new UnsupportedOperationException("Cette méthode ne doit pas être appelée! Appeller le méthode copieElements(ObjetMetierSpec).");
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    ConstitutionDurees copie = (ConstitutionDurees)p_copie;
    if (getDureeIndemnisation() != null)
    {
      DureeIndemnisation copieDuree = copie.createDureeIndemnisation();
      getDureeIndemnisation().copieElements(copieDuree);
    }
    copie.setJoursEcretementSurPlafonnementDuree(getJoursEcretementSurPlafonnementDuree());
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
  
  public DureeIndemnisation setDureeIndemnisationCSA06P03(DureeIndemnisation p_dureeIndemnisation)
  {
    m_dureeIndemnisation = p_dureeIndemnisation;
    return m_dureeIndemnisation;
  }
  
  public void setJoursEcretementSurPlafonnementDuree(int joursEcretementSurPlafonnementDuree)
  {
    m_joursEcretementSurPlafonnementDuree = joursEcretementSurPlafonnementDuree;
  }
  
  public int getJoursEcretementSurPlafonnementDuree()
  {
    return m_joursEcretementSurPlafonnementDuree;
  }
}

/* Location:
 * Qualified Name:     ConstitutionDurees
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */