package fr.unedic.cali.asu.produits.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.produits.liquidation.dom.Od;
import fr.unedic.cali.asu.produits.liquidation.dom.pc.AntecedentPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public abstract class AntecedentGen
  extends Od
  implements DomGenSpec
{
  public AntecedentGen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public AntecedentGen() {}
  
  public AntecedentGen(Damj p_dateEvenement)
  {
    super(p_dateEvenement);
  }
  
  protected DomPCSpec createPC()
  {
    return new AntecedentPC();
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
    
    super.supprimerEnProfondeur(p_contexteSuppression);
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    super.copieElements(p_copie);
  }
}

/* Location:
 * Qualified Name:     AntecedentGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */