package fr.unedic.cali.asu.produits.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConditionsAttributionAbstraitPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public abstract class ConditionAgeGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_conditionsAttributionAbstraitPC;
  private Damj m_dateEffetPension;
  
  public ConditionAgeGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public ConditionAgeGen() {}
  
  public DomPCSpec getPC()
  {
    return m_conditionsAttributionAbstraitPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_conditionsAttributionAbstraitPC)
  {
    m_conditionsAttributionAbstraitPC = p_conditionsAttributionAbstraitPC;
  }
  
  protected Damj rawGetDateEffetPension()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getDateEffetPensionConditionAge();
  }
  
  public Damj getDateEffetPension()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getDateEffetPensionConditionAge();
  }
  
  public void setDateEffetPension(Damj p_dateEffetPension)
  {
    if ((m_dateEffetPension == null) || (p_dateEffetPension == null))
    {
      m_dateEffetPension = p_dateEffetPension;
      ((ConditionsAttributionAbstraitPC)getPC()).setDateEffetPensionConditionAge(p_dateEffetPension);
    }
    else if ((m_dateEffetPension != null) && (p_dateEffetPension != null) && (!p_dateEffetPension.equals(m_dateEffetPension)))
    {
      m_dateEffetPension = p_dateEffetPension;
      ((ConditionsAttributionAbstraitPC)getPC()).setDateEffetPensionConditionAge(p_dateEffetPension);
    }
  }
  
  protected int rawGetSituationConditionAge()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getSituationConditionAge();
  }
  
  public int getSituationConditionAge()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getSituationConditionAge();
  }
  
  public void setSituationConditionAge(int p_situationConditionAge)
  {
    ((ConditionsAttributionAbstraitPC)getPC()).setSituationConditionAge(p_situationConditionAge);
  }
  
  protected int rawGetEtat()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getEtatConditionAge();
  }
  
  public int getEtat()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getEtatConditionAge();
  }
  
  public void setEtat(int p_etat)
  {
    ((ConditionsAttributionAbstraitPC)getPC()).setEtatConditionAge(p_etat);
  }
  
  protected int rawGetCodeMotifEchec()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getCodeMotifEchecConditionAge();
  }
  
  public int getCodeMotifEchec()
  {
    return ((ConditionsAttributionAbstraitPC)getPC()).getCodeMotifEchecConditionAge();
  }
  
  public void setCodeMotifEchec(int p_codeMotifEchec)
  {
    ((ConditionsAttributionAbstraitPC)getPC()).setCodeMotifEchecConditionAge(p_codeMotifEchec);
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void initEnProfondeur()
    throws TechniqueException
  {
    setDateEffetPension(null);
    setSituationConditionAge(0);
    setEtat(0);
    setCodeMotifEchec(0);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     ConditionAgeGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */