package fr.unedic.cali.asu.produits.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.produits.liquidation.dom.pc.DureePC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public abstract class DureeGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_dureePC;
  private Integer m_nombreJour;
  
  public DureeGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public DureeGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new DureePC();
  }
  
  public DomPCSpec getPC()
  {
    return m_dureePC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_dureePC)
  {
    m_dureePC = p_dureePC;
  }
  
  protected Integer rawGetNombreJour()
  {
    return ((DureePC)getPC()).getNombreJour();
  }
  
  public Integer getNombreJour()
  {
    return ((DureePC)getPC()).getNombreJour();
  }
  
  public void setNombreJour(Integer p_nombreJour)
  {
    if ((m_nombreJour == null) || (p_nombreJour == null))
    {
      m_nombreJour = p_nombreJour;
      ((DureePC)getPC()).setNombreJour(p_nombreJour);
    }
    else if ((m_nombreJour != null) && (p_nombreJour != null) && (!p_nombreJour.equals(m_nombreJour)))
    {
      m_nombreJour = p_nombreJour;
      ((DureePC)getPC()).setNombreJour(p_nombreJour);
    }
  }
  
  protected int rawGetTypeDuree()
  {
    return ((DureePC)getPC()).getTypeDuree();
  }
  
  public int getTypeDuree()
  {
    return ((DureePC)getPC()).getTypeDuree();
  }
  
  public void setTypeDuree(int p_typeDuree)
  {
    ((DureePC)getPC()).setTypeDuree(p_typeDuree);
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     DureeGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */