package fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels;

import fr.unedic.cali.dom.Individu;
import fr.unedic.cali.dom.conteneurs.DonneesEntreeConstructionChronologie;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreActiviteSalarie;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreBulletinSalaire;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeDsmTravail;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesLiquidables;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesSurFiltresExclusifs;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.FiltreChevauchePeriode;
import fr.unedic.util.temps.FiltreFinAvantOuCoincideAvecDate;
import fr.unedic.util.temps.FiltreFinDansBornes;
import fr.unedic.util.temps.FiltreTemporel;
import fr.unedic.util.temps.FiltresTemporel;

public class OutilSjrJoursDeductibles
{
  public static ChronologiePeriodes determinerChronoActivitesPourChomageAtteste(DonneesEntreeConstructionChronologie p_donneesEntree)
  {
    FiltresTemporel filtres = new FiltresTemporel();
    
    FiltrePeriodesSurFiltresExclusifs filtresExclusifsActivites = new FiltrePeriodesSurFiltresExclusifs();
    
    filtresExclusifsActivites.ajouterFiltre(new FiltreActiviteSalarie());
    
    filtresExclusifsActivites.ajouterFiltre(new FiltreBulletinSalaire());
    
    filtresExclusifsActivites.ajouterFiltre(new FiltrePeriodeDsmTravail());
    filtres.ajouterFiltre(filtresExclusifsActivites);
    
    filtres.ajouterFiltre(new FiltrePeriodesLiquidables());
    filtres.ajouterFiltre(new FiltreChevauchePeriode(p_donneesEntree.getPeriodePrc()));
    
    FiltreTemporel filtreExclusionAc = trouverFiltrePourExclureAC(p_donneesEntree);
    filtres.ajouterFiltre(filtreExclusionAc);
    
    ChronologiePeriodes chronoPeriodesTravailRetenues = (ChronologiePeriodes)p_donneesEntree.getIndividu().getChronoPeriodePasseProfessionnelLiquidation().copier(filtres);
    
    return chronoPeriodesTravailRetenues;
  }
  
  public static FiltreTemporel trouverFiltrePourExclureAC(DonneesEntreeConstructionChronologie p_donneesEntree)
  {
    Damj dateFgOdCourante = null;
    Damj dateFgOdPrecedente = p_donneesEntree.getDateFgdOdPrecedente();
    FiltreTemporel filtreRetour = null;
    if (p_donneesEntree.isEstUneDemandeRevision()) {
      dateFgOdCourante = p_donneesEntree.getDateDeclenchementExamen();
    } else {
      dateFgOdCourante = p_donneesEntree.getDateFgd();
    }
    if (dateFgOdPrecedente != null) {
      filtreRetour = new FiltreFinDansBornes(dateFgOdPrecedente.lendemain(), dateFgOdCourante);
    } else {
      filtreRetour = new FiltreFinAvantOuCoincideAvecDate(dateFgOdCourante);
    }
    return filtreRetour;
  }
}

/* Location:
 * Qualified Name:     OutilSjrJoursDeductibles
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */