package fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.affiliation;

import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.Pra;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltreActiviteSalarie;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesLiquidables;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodesQualifiables;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.FiltreChevauchePeriode;
import fr.unedic.util.temps.FiltreTemporel;
import java.util.Iterator;

public class OutilVerificationReglementsMultiples
{
  private static OutilVerificationReglementsMultiples outilVerificationMultiplesReglements = null;
  
  public static OutilVerificationReglementsMultiples getInstance()
  {
    if (outilVerificationMultiplesReglements == null) {
      outilVerificationMultiplesReglements = new OutilVerificationReglementsMultiples();
    }
    return outilVerificationMultiplesReglements;
  }
  
  public boolean verifierReglementAppartenanceDifferent(DemandeAssuranceSpec demande, Pra pra)
  {
    Chronologie passeProfessionnel = demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation();
    
    FiltreTemporel filtre = new FiltreChevauchePeriode(pra);
    passeProfessionnel = passeProfessionnel.copier(filtre);
    
    filtre = new FiltreActiviteSalarie();
    Chronologie listeActivitesSalariees = passeProfessionnel.copier(filtre);
    
    listeActivitesSalariees = listeActivitesSalariees.copier(new FiltrePeriodesQualifiables());
    listeActivitesSalariees = listeActivitesSalariees.copier(new FiltrePeriodesLiquidables());
    
    ActiviteSalarie periodeActiviteSalariePrec = null;
    for (Iterator<?> iter = listeActivitesSalariees.iterer(); iter.hasNext();)
    {
      ActiviteSalarie periodeActiviteSalarie = (ActiviteSalarie)iter.next();
      if (periodeActiviteSalariePrec != null)
      {
        boolean deuxPeriodesA8A10 = ((periodeActiviteSalarie.getReglement().getNomReglement().equals("A8")) || (periodeActiviteSalarie.getReglement().getNomReglement().equals("A10"))) && ((periodeActiviteSalariePrec.getReglement().getNomReglement().equals("A8")) || (periodeActiviteSalariePrec.getReglement().getNomReglement().equals("A10")));
        if ((!deuxPeriodesA8A10) && (!periodeActiviteSalarie.getReglement().equals(periodeActiviteSalariePrec.getReglement()))) {
          return true;
        }
      }
      periodeActiviteSalariePrec = periodeActiviteSalarie;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     OutilVerificationReglementsMultiples
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */