package fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.datelimite.asp;

import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.Periode;

public final class OutilDecalageDateLimiteIndemnisation
{
  private static final int DOUZE = 12;
  private static final DureeCalendaire DELAI_FIN_ALLONGEMENT_INITIAL = new DureeCalendaire(0, 12);
  
  public static Damj decalerDateLimite(Damj entreeDispositif, Damj dateLimiteCourante, int nombreJoursAllongement)
  {
    Damj allongementMax = OutilAllongementDateLimiteIndemnisation.recupererDateFinAllongementMax(entreeDispositif);
    int joursAllongementMax = determinerAllongementMaximal(dateLimiteCourante, allongementMax);
    
    int allongementRetenu = Math.min(joursAllongementMax, nombreJoursAllongement);
    
    return dateLimiteCourante.deplacerVersAvant(new DureeCalendaire(0, 0, allongementRetenu));
  }
  
  private static int determinerAllongementMaximal(Damj finCSP, Damj allongementMax)
  {
    return new Periode(finCSP, allongementMax).inter(new Periode(Damj.NUIT_DES_TEMPS, Damj.FIN_DES_TEMPS)) - 1;
  }
  
  public static void controlerDateLimiteForcee(Damj entreeCsp, Damj dateLimiteForcee)
    throws CoucheLogiqueException
  {
    Damj finCspInitiale = OutilAllongementDateLimiteIndemnisation.decalerDate(entreeCsp, DELAI_FIN_ALLONGEMENT_INITIAL);
    Damj allongementMax = OutilAllongementDateLimiteIndemnisation.recupererDateFinAllongementMax(entreeCsp);
    if ((dateLimiteForcee.estAvant(finCspInitiale)) || (dateLimiteForcee.estApres(allongementMax))) {
      fr.unedic.cali.asu.outilsfonctionnels.GestionnaireErreur.getInstance().genererCoucheLogiqueException("ASU_PR_CALI_L_DATE_LIMITE_HORS_CADRE");
    }
  }
}

/* Location:
 * Qualified Name:     OutilDecalageDateLimiteIndemnisation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */