package fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.fabriques;

import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.strategies.StrategieDelaiRechercheSpec;
import fr.unedic.cali.fabriques.FabriqueStrategieSpec;
import fr.unedic.cali.outilsfonctionnels.strategies.CritereStrategie;
import fr.unedic.cali.outilsfonctionnels.strategies.CriteresStrategieDelaiRecherche;
import fr.unedic.cali.outilsfonctionnels.strategies.StrategieSpec;
import fr.unedic.util.temps.Damj;

public class FabriqueStrategieDelaiRecherche
  implements FabriqueStrategieSpec
{
  public static final Damj DATE_PIVOT = new Damj(2010, 4, 30);
  private static FabriqueStrategieDelaiRecherche s_instance = new FabriqueStrategieDelaiRecherche();
  
  public static FabriqueStrategieDelaiRecherche getInstance()
  {
    return s_instance;
  }
  
  public StrategieSpec getStrategie(CritereStrategie p_critereStrategie)
  {
    StrategieDelaiRechercheSpec strategie = null;
    
    Damj datePivotRechercheDelai = p_critereStrategie.getDatePivot();
    
    int typeCoordinationEuropeenne = ((CriteresStrategieDelaiRecherche)p_critereStrategie).getTypeCoordinationEuropeenne();
    if (datePivotRechercheDelai == null) {
      throw new UnsupportedOperationException("FabriqueStrategieDelaiRecherche : la date pivot est null.");
    }
    if ((datePivotRechercheDelai.estApres(DATE_PIVOT)) && ((typeCoordinationEuropeenne == 1) || (typeCoordinationEuropeenne == 2))) {
      strategie = new StrategieDelaiRechercheCoordinationEuropenne();
    } else {
      strategie = new StrategieDelaiRechercheClassique();
    }
    return strategie;
  }
}

/* Location:
 * Qualified Name:     FabriqueStrategieDelaiRecherche
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */