package fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.novation;

import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.spec.ConstitutionCoefficientSaisonnierSpec;
import fr.unedic.cali.asu.produits.liquidation.dom.Attribution;
import fr.unedic.cali.asu.produits.liquidation.dom.TrancheExecutable;
import fr.unedic.cali.dom.affectation.ProduitAsuSpec;
import fr.unedic.util.services.OutilFonctionnel;
import java.math.BigDecimal;
import java.util.List;

public final class OutilConstitutionCoefficientSaisonnier
  implements OutilFonctionnel
{
  public static OutilConstitutionCoefficientSaisonnier getInstance()
  {
    return new OutilConstitutionCoefficientSaisonnier();
  }
  
  public void alimenterConstitutionCoefficientSaisonnier(ConstitutionCoefficientSaisonnierSpec constitutionCoefficientSaisonnier, AttributionAssuranceSpec attributionAssurance)
  {
    BigDecimal coefficient = BigDecimal.ONE;
    
    AttributionAssuranceSpec attributionPrecedente = attributionAssurance.getAttributionPrecedente();
    if (attributionPrecedente != null)
    {
      if (((ProduitAsuSpec)attributionPrecedente.getProduit()).estTrancheActivee(attributionPrecedente.getDemande()))
      {
        TrancheExecutable trancheExecutable = (TrancheExecutable)((Attribution)attributionPrecedente).getListTranchesExecutables().get(0);
        coefficient = trancheExecutable.getCoefficientSaisonnier();
      }
      else
      {
        coefficient = attributionPrecedente.getElementBaseIndemnisation().getCoefficientSaisonnier();
      }
      if (coefficient != null) {
        constitutionCoefficientSaisonnier.setCoefficientSaisonnierRetenu(coefficient);
      }
    }
  }
}

/* Location:
 * Qualified Name:     OutilConstitutionCoefficientSaisonnier
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */