package fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.strategies.spec.StrategieCoordinationEuropeennePointDepartPrcSpec;
import fr.unedic.cali.autresdoms.ga.dom.spec.TravailSpec;
import fr.unedic.cali.dom.Individu;
import fr.unedic.cali.dom.conteneurs.DonneesEntreePRC;
import fr.unedic.cali.outilsfonctionnels.filtres.FiltrePeriodeActiviteSalarieeE301NonFrontalier;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.ChronologiePeriodes;
import fr.unedic.util.temps.ComparateurTemporelsSurDateFin;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.FiltreFinAvantOuCoincideAvecDate;
import fr.unedic.util.temps.FiltresTemporel;

public class StrategieCoordinationEuropeennePointDepartPrcAvant
  implements StrategieCoordinationEuropeennePointDepartPrcSpec
{
  public Damj determinerBornePointDepartPrc(DonneesEntreePRC p_donneesEntreePRC, Damj p_termePrc)
  {
    Damj bornePointDepartPrc = null;
    
    TravailSpec derniereActiviteE301NonFrontaliere = recupererDerniereActiviteE301NonFrontaliereAvantDate(p_donneesEntreePRC, p_termePrc);
    if (derniereActiviteE301NonFrontaliere != null) {
      bornePointDepartPrc = derniereActiviteE301NonFrontaliere.getDateFin();
    }
    return bornePointDepartPrc;
  }
  
  private static TravailSpec recupererDerniereActiviteE301NonFrontaliereAvantDate(DonneesEntreePRC p_donneesEntreePRC, Damj p_dateBorneFin)
  {
    TravailSpec derniereActiviteE301NonFrontaliere = null;
    
    FiltresTemporel listeFiltres = new FiltresTemporel();
    listeFiltres.ajouterFiltre(new FiltrePeriodeActiviteSalarieeE301NonFrontalier());
    listeFiltres.ajouterFiltre(new FiltreFinAvantOuCoincideAvecDate(p_dateBorneFin));
    Chronologie chronoActiviteE301NonFrontaliere = p_donneesEntreePRC.getIndividu().getChronoPeriodePasseProfessionnelLiquidation().copier(listeFiltres);
    if ((chronoActiviteE301NonFrontaliere != null) && (!chronoActiviteE301NonFrontaliere.estVide()))
    {
      chronoActiviteE301NonFrontaliere.setComparateur(new ComparateurTemporelsSurDateFin());
      derniereActiviteE301NonFrontaliere = (TravailSpec)chronoActiviteE301NonFrontaliere.premierElement();
    }
    return derniereActiviteE301NonFrontaliere;
  }
}

/* Location:
 * Qualified Name:     StrategieCoordinationEuropeennePointDepartPrcAvant
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */