package fr.unedic.cali.asu.produits.liquidation.parcours;

import fr.pe.cali.reglementaire.dom.impl.CriteresFabriqueReglementaire;
import fr.pe.cali.reglementaire.regles.assurance.cep.reglementapplicable.dom.DonneesEntreesRegleReglementApplicable;
import fr.pe.cali.reglementaire.regles.assurance.cep.reglementapplicable.dom.ResultatRegleReglementApplicable;
import fr.pe.cali.reglementaire.regles.assurance.cep.reglementapplicable.fabrique.FabriqueCorpsRegleReglementApplicable;
import fr.pe.cali.reglementaire.regles.assurance.cep.reglementapplicable.outils.spec.IOutilCorpsRegleReglementApplicable;
import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.cge01.p07.liquidation.outilsfonctionnels.reglementapplicable.OutilFonctionnelReglementApplicable;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConstitutionElementsSpec;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.DossierAffectationSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;
import java.util.ArrayList;
import java.util.List;

public class ConstitutionReglementApplicable
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte contexte)
    throws ApplicativeException
  {
    Resultat resultatCEPA13 = new Resultat();
    
    Demande demande = DomLiquidationAssurance.getDemande(contexte);
    
    CriteresFabriqueReglementaire criteres = new CriteresFabriqueReglementaire();
    criteres.setCodeProduit(demande.getDossierAffectation().getProduit().getNomUnique());
    criteres.setDate(demande.getDateExamen());
    if (demande.estEnContexteDemande("ASPSJACENT"))
    {
      List<String> contextesReglementaires = new ArrayList();
      contextesReglementaires.add("ReglementApplicableContexteAspSousJacent");
      criteres.setListeContextesReglementaires(contextesReglementaires);
    }
    IOutilCorpsRegleReglementApplicable outil = FabriqueCorpsRegleReglementApplicable.getInstance().recupererOutilCorpsRegle(criteres);
    
    DonneesEntreesRegleReglementApplicable donneesEntrees = new DonneesEntreesRegleReglementApplicable();
    donneesEntrees.setReglementDernierSinistre(((ActiviteSalarie)demande.getDossierAffectationAdmission().getSinistre()).getReglement());
    donneesEntrees.setReglementValidationProduit(demande.getDossierAffectationAdmission().getReglementPeriodeValidationProduit());
    donneesEntrees.setPasseProfessionnel(demande.getDemandeur().getChronoPeriodePasseProfessionnelLiquidation());
    donneesEntrees.setOutilFonctionnel(new OutilFonctionnelReglementApplicable(demande));
    donneesEntrees.setAffiliationForcee(demande.getDonneesTemporaires().getQuantiteAffiliation() != null);
    donneesEntrees.setDroitInterimaireForcee(demande.getDonneesTemporaires().isDroitInterimaireForce());
    
    ResultatRegleReglementApplicable resultat = outil.determinerReglementApplicable(donneesEntrees);
    
    fr.unedic.cali.asu.produits.liquidation.dom.ConstitutionReglementApplicable reglementApplicable = ((DossierExamen)demande.getDossierExamen()).getConstitutionElementsActifs().createConstitutionReglementApplicable();
    
    reglementApplicable.setReglement(resultat.getReglementApplicable());
    reglementApplicable.setDroitInterimaire(resultat.isDroitInterimaire());
    
    return resultatCEPA13;
  }
}

/* Location:
 * Qualified Name:     ConstitutionReglementApplicable
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */