package fr.unedic.cali.asu.produits.liquidation.parcours;

import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.ConditionMontantRevise;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.RechercheConditionMontantRevise;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;

public class DeterminationConditionMontantReviseRevision
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte p_contexte)
    throws CoucheLogiqueException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCaprevSup = new Resultat(1);
    
    Demande demandeCourante = DomLiquidationAssurance.getDemande(p_contexte);
    
    ConditionMontantRevise condition = RechercheConditionMontantRevise.getInstance().rechercherConditionMontantRevise(demandeCourante);
    if (condition.estSatisfait())
    {
      resultatCaprevSup.setEtat(0);
    }
    else
    {
      resultatCaprevSup.setEtat(1);
      resultatCaprevSup.setMessageErreur(Integer.toString(condition.getCodeMotifEchec()));
    }
    OutilTrace.ecrireTrace(Niveau.DEBUG, new Object[] { "Resultat : ", resultatCaprevSup });
    
    OutilTrace.tracerFinParcours();
    
    return resultatCaprevSup;
  }
}

/* Location:
 * Qualified Name:     DeterminationConditionMontantReviseRevision
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */