package fr.unedic.cali.asu.produits.liquidation.parcours;

import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.produits.liquidation.dom.ConditionRechercheEmploi;
import fr.unedic.cali.asu.produits.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.produits.liquidation.dom.ResultatConditionRechercheEmploi;
import fr.unedic.cali.asu.produits.liquidation.dom.spec.ConditionsAttributionSpec;
import fr.unedic.cali.asu.produits.liquidation.outilsfonctionnels.RechercheConditionRechercheEmploi;
import fr.unedic.cali.dom.ResultatElementDroit;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;

public class DeterminationConditionRechercheEmploiReprise
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte p_contexte)
    throws CoucheLogiqueException
  {
    OutilTrace.tracerDebutParcours();
    
    Demande demandeCourante = DomLiquidationAssurance.getDemande(p_contexte);
    
    Resultat resultatCapa01 = new Resultat(1);
    
    ConditionRechercheEmploi conditionRechercheEmploi = ((DossierExamen)demandeCourante.getDossierExamen()).getConditionsAttributionActives().createConditionRechercheEmploi();
    
    conditionRechercheEmploi.setEtatSatisfait(false);
    
    ResultatConditionRechercheEmploi resultatConditionRechercheEmploi = RechercheConditionRechercheEmploi.getInstance().rechercherConditionRechercheEmploi(demandeCourante);
    
    ResultatElementDroit resultatElementDroit = resultatConditionRechercheEmploi.getResultatElementDroit();
    conditionRechercheEmploi.setEtatSatisfait(resultatElementDroit.estSatisfait());
    conditionRechercheEmploi.setCodeMotifEchec(resultatElementDroit.getCodeMotifEchec());
    
    resultatCapa01.setEtat(resultatConditionRechercheEmploi.getResultatElementDroit().getEtat());
    
    OutilTrace.ecrireTrace(Niveau.DEBUG, new Object[] { "Résultat : ", resultatCapa01 });
    
    OutilTrace.tracerFinParcours();
    
    return resultatCapa01;
  }
}

/* Location:
 * Qualified Name:     DeterminationConditionRechercheEmploiReprise
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */