package fr.unedic.cali.asu.spe02.p03.calcul.outilsfonctionnels;

import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.SalaireReference;
import fr.unedic.cali.asu.dom.Sjm;
import fr.unedic.cali.asu.spe02.p03.parametres.ParametresIndemnisation;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.QuantiteDroitSpec;
import fr.unedic.cali.dom.QuantiteIndemnisationSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;
import java.util.Collection;
import java.util.Iterator;

public class MajCi
{
  public static ConstituantsIndemnisation miseAJourConstituantsIndemnisation(AttributionSpec p_attribution, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_dateDeMiseAjour)
    throws CoucheLogiqueException
  {
    QuantiteDroitSpec dureeDroit = null;
    Collection collectionDurees = null;
    Iterator iterator = null;
    String codeFormuleMontant = null;
    
    codeFormuleMontant = p_constituantsIndemnisation.getCodeFormuleMontant();
    if (codeFormuleMontant != null) {
      miseAJourParametres(p_attribution, p_constituantsIndemnisation, p_dateDeMiseAjour);
    }
    collectionDurees = p_constituantsIndemnisation.getCollectionQuantiteDroit();
    if (collectionDurees != null)
    {
      iterator = collectionDurees.iterator();
      while (iterator.hasNext())
      {
        dureeDroit = (QuantiteDroitSpec)iterator.next();
        if ((dureeDroit instanceof QuantiteIndemnisationSpec)) {
          miseAJourParametres(p_attribution, p_constituantsIndemnisation, p_dateDeMiseAjour);
        }
      }
    }
    return p_constituantsIndemnisation;
  }
  
  private static void miseAJourParametres(AttributionSpec p_attribution, ConstituantsIndemnisation p_constituantsIndemnisation, Damj p_dateDeMiseAjour)
    throws CoucheLogiqueException
  {
    ParametresIndemnisation parametresIndemnisation = null;
    BigDecimal tauxAvantageViellesse = null;
    ElementBaseIndemnisation elementBaseIndemnisation = null;
    SalaireReference srrp = null;
    Sjm sjmrp = null;
    
    parametresIndemnisation = ParametresIndemnisation.getParametresIndemnisation();
    
    elementBaseIndemnisation = (ElementBaseIndemnisation)p_constituantsIndemnisation.getElementBaseIndemnisationCourant();
    
    tauxAvantageViellesse = parametresIndemnisation.getTauxAvantageViellesse(p_attribution.getDemandeur().getAgeALaDate(p_dateDeMiseAjour));
    if (tauxAvantageViellesse != null) {
      elementBaseIndemnisation.setTauxAvantageVieillesse(tauxAvantageViellesse);
    }
    srrp = RevalorisationSalaire.determinerSrrp(elementBaseIndemnisation.getSalaireReference(), elementBaseIndemnisation.getNbJoursEmploiSurPrc(), p_dateDeMiseAjour);
    
    sjmrp = RevalorisationSalaire.determinerSjmrp(srrp, elementBaseIndemnisation.getCoefficientHoraireJour(), elementBaseIndemnisation.getNombreHeuresTravailleesPlafonnees(), p_dateDeMiseAjour);
    if (sjmrp.getSalaire().doubleValue() != elementBaseIndemnisation.getSalaireReference().getSalaire().doubleValue()) {
      elementBaseIndemnisation.setMontantAvantageVieillesse(elementBaseIndemnisation.getCoefficientAvantageVieillesse().multiply(sjmrp.getSalaire()));
    }
  }
}

/* Location:
 * Qualified Name:     MajCi
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */