package fr.unedic.cali.asu.spe02.p03.liquidation.dom;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffecte;
import fr.unedic.cali.asu.dom.JustificationAffiliationSpec;
import fr.unedic.cali.asu.dom.ObjectifExamen;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen.ExamenGen;
import fr.unedic.cali.dom.ExamenSpec;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Damj;

public class Examen
  extends ExamenGen
  implements ExamenSpec
{
  private static final long serialVersionUID = 1L;
  
  public Examen(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public Examen() {}
  
  public Examen(Damj p_dateEvenement)
  {
    super(p_dateEvenement);
  }
  
  public ObjetMetierSpec copie()
  {
    Examen copie = new Examen();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    Examen copie = (Examen)p_copie;
    super.copieElements(copie);
  }
  
  public void marquerGraphePersistant()
  {
    super.marquerGraphePersistant();
  }
  
  public ConditionsAttributionSpec getConditionsAttributionActives()
  {
    ConditionsAttributionSpec conditionsAttributionActivesRetourne = null;
    
    ObjectifExamen objectifCourant = ((Demande)getDemande()).getObjectifCourant();
    if (objectifCourant != null)
    {
      if (objectifCourant.getType() == 2) {
        conditionsAttributionActivesRetourne = getConditionAttributionReprise();
      } else {
        conditionsAttributionActivesRetourne = getConditionAttributionAdmission();
      }
    }
    else {
      switch (((DossierAffecte)getDossierAffecte()).getTypeDossier())
      {
      case 1: 
        conditionsAttributionActivesRetourne = getConditionAttributionAdmission();
      case 2: 
        conditionsAttributionActivesRetourne = getConditionAttributionReprise();
      }
    }
    return conditionsAttributionActivesRetourne;
  }
  
  public ConstitutionElementsSpec getConstitutionElementsActifs()
  {
    ConstitutionElementsSpec constitutionElementsActifsRetourne = null;
    
    ObjectifExamen objectifCourant = ((Demande)getDemande()).getObjectifCourant();
    if (objectifCourant != null)
    {
      if (objectifCourant.getType() == 2) {
        constitutionElementsActifsRetourne = getConstitutionElementsReprise();
      } else {
        constitutionElementsActifsRetourne = getConstitutionElementsAdmission();
      }
    }
    else {
      switch (((DossierAffecte)getDossierAffecte()).getTypeDossier())
      {
      case 1: 
        constitutionElementsActifsRetourne = getConstitutionElementsAdmission();
      case 2: 
        constitutionElementsActifsRetourne = getConstitutionElementsReprise();
      }
    }
    return constitutionElementsActifsRetourne;
  }
  
  public JustificationAffiliationSpec getJustificationAffiliation()
  {
    if ((ValidationProduit)((DossierAffecte)getDossierAffecte()).getValidationProduit() != null) {
      return ((ValidationProduit)((DossierAffecte)getDossierAffecte()).getValidationProduit()).getJustificationAffiliation();
    }
    return null;
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
}

/* Location:
 * Qualified Name:     Examen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */