package fr.unedic.cali.asu.spe02.p03.liquidation.dom;

import fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen.JustificationFranchiseCongesPayesGen;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Periode;
import java.util.Collection;
import java.util.Iterator;

public class JustificationFranchiseCongesPayes
  extends JustificationFranchiseCongesPayesGen
  implements ObjetPersistantSpec
{
  private static final long serialVersionUID = -5777292479957454371L;
  
  public JustificationFranchiseCongesPayes() {}
  
  public JustificationFranchiseCongesPayes(DomPCSpec pc)
  {
    super(pc);
  }
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public void marquerGraphePersistant()
  {
    DomManager.persisterEnProfondeur(super.getCollectionMoisCivil());
  }
  
  public ObjetMetierSpec copie()
  {
    JustificationFranchiseCongesPayes copie = new JustificationFranchiseCongesPayes();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec pCopie)
  {
    JustificationFranchiseCongesPayes copie = (JustificationFranchiseCongesPayes)pCopie;
    if (super.getPeriodeCalculFranchiseCp() != null) {
      copie.setPeriodeCalculFranchiseCp((Periode)super.getPeriodeCalculFranchiseCp().copie());
    }
    copie.setNbJoursTravaillesRetenus(super.getNbJoursTravaillesRetenus());
    if (super.getCollectionMoisCivil() != null)
    {
      Iterator<?> it = super.getCollectionMoisCivil().iterator();
      while (it.hasNext())
      {
        MoisCivil mois = (MoisCivil)it.next();
        if (mois != null) {
          copie.ajouterMoisCivil((MoisCivil)mois.copie());
        }
      }
    }
  }
  
  public void remplacerCollectionMoisCivil(Collection collectionACopier)
  {
    for (Iterator<?> iter = super.getCollectionMoisCivil().iterator(); iter.hasNext();)
    {
      MoisCivil element = (MoisCivil)iter.next();
      DomManager.supprimer(element);
    }
    super.remplacerCollectionMoisCivil(collectionACopier);
  }
}

/* Location:
 * Qualified Name:     JustificationFranchiseCongesPayes
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */