package fr.unedic.cali.asu.spe02.p03.liquidation.dom;

import fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen.PeriodeElementaireEmployeurGen;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;

public class PeriodeElementaireEmployeur
  extends PeriodeElementaireEmployeurGen
  implements ObjetPersistantSpec
{
  private static final long serialVersionUID = -1678912300208770856L;
  private transient boolean derogation;
  
  public PeriodeElementaireEmployeur(DomPCSpec pc)
  {
    super(pc);
  }
  
  public PeriodeElementaireEmployeur() {}
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public void marquerGraphePersistant() {}
  
  public ObjetMetierSpec copie()
  {
    PeriodeElementaireEmployeur copie = new PeriodeElementaireEmployeur();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec pCopie)
  {
    PeriodeElementaireEmployeur copie = (PeriodeElementaireEmployeur)pCopie;
    
    copie.setHeuresA8Totales(getHeuresA8Totales());
    copie.setHeuresA10Totales(getHeuresA10Totales());
    copie.setHeuresPlafonnees(getHeuresPlafonnees());
    copie.setNumeroAffiliation(getNumeroAffiliation());
    copie.setNumeroSiret(getNumeroSiret());
    copie.setRaisonSociale(getRaisonSociale());
    copie.setPlafond(getPlafond());
    copie.setDerogation(isDerogation());
    copie.setEstPlafonneMonoEmployeur(isEstPlafonneMonoEmployeur());
  }
  
  public void setDerogation(boolean derogation)
  {
    this.derogation = derogation;
  }
  
  public boolean isDerogation()
  {
    return derogation;
  }
}

/* Location:
 * Qualified Name:     PeriodeElementaireEmployeur
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */