package fr.unedic.cali.asu.spe02.p03.liquidation.dom;

import fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen.PeriodeRetenueGen;
import fr.unedic.cali.dom.ObjetPersistantSpec;
import fr.unedic.cali.dom.affectation.Parametres;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.cali.dom.persistance.util.DomManager;
import fr.unedic.cali.util.OutilDomToString;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.Periode;

public class PeriodeRetenue
  extends PeriodeRetenueGen
  implements ObjetPersistantSpec
{
  private transient Reglement m_reglement;
  
  public PeriodeRetenue() {}
  
  public PeriodeRetenue(DomPCSpec p_pc)
  {
    super(p_pc);
  }
  
  public ObjetMetierSpec copie()
  {
    PeriodeRetenue copie = new PeriodeRetenue();
    copieElements(copie);
    return copie;
  }
  
  public void copieElements(ObjetMetierSpec p_copie)
  {
    PeriodeRetenue copie = (PeriodeRetenue)p_copie;
    super.copieElements(copie);
    copie.setPeriode(getPeriode() != null ? new Periode(getPeriode().getDebut(), getPeriode().getFin()) : null);
    
    copie.setReglement(getReglement());
    copie.setRaisonSociale(getRaisonSociale());
    copie.setMontantRetenu(getMontantRetenu());
    copie.setNature(getNature());
    copie.setCodeProduitReglement(getCodeProduitReglement());
    copie.setNomReglement(getNomReglement());
  }
  
  public void marquerGraphePersistant() {}
  
  public String getIdentifiant()
  {
    return DomManager.getIdentifiant(this);
  }
  
  public Reglement getReglement()
  {
    if (m_reglement == null) {
      m_reglement = Parametres.getReglement(getNomReglement(), Parametres.getProduit(getCodeProduitReglement()));
    }
    return m_reglement;
  }
  
  public void setReglement(Reglement p_reglement)
  {
    m_reglement = p_reglement;
    setNomReglement(p_reglement.getNomReglement());
    setCodeProduitReglement(p_reglement.getProduit().getCode());
  }
  
  public String toString()
  {
    return OutilDomToString.toString(this);
  }
}

/* Location:
 * Qualified Name:     PeriodeRetenue
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */