package fr.unedic.cali.asu.spe02.p03.liquidation.dom.gen;

import fr.unedic.archi.commun.exception.TechniqueException;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.pc.AllongementPraPC;
import fr.unedic.transverse.dom.ContexteSuppressionEnProfondeur;
import fr.unedic.transverse.dom.spec.DomGenSpec;
import fr.unedic.transverse.dom.spec.DomPCSpec;
import fr.unedic.util.ObjetMetierSpec;
import fr.unedic.util.temps.DureeCalendaire;
import fr.unedic.util.temps.Periode;

public abstract class AllongementPraGen
  implements DomGenSpec
{
  protected transient DomPCSpec m_allongementPraPC;
  private Periode m_periodeActivite;
  private DureeCalendaire m_duree;
  
  public AllongementPraGen(DomPCSpec p_pc)
  {
    setPC(p_pc);
  }
  
  public AllongementPraGen()
  {
    setPC(createPC());
  }
  
  protected DomPCSpec createPC()
  {
    return new AllongementPraPC();
  }
  
  public DomPCSpec getPC()
  {
    return m_allongementPraPC;
  }
  
  public Object getGenericPC()
  {
    return getPC();
  }
  
  public void setPC(DomPCSpec p_allongementPraPC)
  {
    m_allongementPraPC = p_allongementPraPC;
  }
  
  protected int rawGetNature()
  {
    return ((AllongementPraPC)getPC()).getNature();
  }
  
  public int getNature()
  {
    return ((AllongementPraPC)getPC()).getNature();
  }
  
  public void setNature(int p_nature)
  {
    ((AllongementPraPC)getPC()).setNature(p_nature);
  }
  
  protected Periode rawGetPeriodeActivite()
  {
    return ((AllongementPraPC)getPC()).getPeriodeActivite();
  }
  
  public Periode getPeriodeActivite()
  {
    return ((AllongementPraPC)getPC()).getPeriodeActivite();
  }
  
  public void setPeriodeActivite(Periode p_periodeActivite)
  {
    if ((m_periodeActivite == null) || (p_periodeActivite == null))
    {
      m_periodeActivite = p_periodeActivite;
      ((AllongementPraPC)getPC()).setPeriodeActivite(p_periodeActivite);
    }
    else if ((m_periodeActivite != null) && (p_periodeActivite != null) && (!p_periodeActivite.equals(m_periodeActivite)))
    {
      m_periodeActivite = p_periodeActivite;
      ((AllongementPraPC)getPC()).setPeriodeActivite(p_periodeActivite);
    }
  }
  
  protected DureeCalendaire rawGetDuree()
  {
    return ((AllongementPraPC)getPC()).getDuree();
  }
  
  public DureeCalendaire getDuree()
  {
    return ((AllongementPraPC)getPC()).getDuree();
  }
  
  public void setDuree(DureeCalendaire p_duree)
  {
    if ((m_duree == null) || (p_duree == null))
    {
      m_duree = p_duree;
      ((AllongementPraPC)getPC()).setDuree(p_duree);
    }
    else if ((m_duree != null) && (p_duree != null) && (!p_duree.equals(m_duree)))
    {
      m_duree = p_duree;
      ((AllongementPraPC)getPC()).setDuree(p_duree);
    }
  }
  
  public void supprimerEnProfondeur(ContexteSuppressionEnProfondeur p_contexteSuppression)
    throws TechniqueException
  {
    p_contexteSuppression.addElementEnCoursDeSuppression(this);
  }
  
  public void copieElements(ObjetMetierSpec p_copie) {}
}

/* Location:
 * Qualified Name:     AllongementPraGen
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */