package fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.dom.DemandeAssuranceSpec;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.outilsfonctionnels.ConstructionChronologieCarences;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.JustificationDiffere;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.ResultatRemunerationsParNature;
import fr.unedic.cali.outilsfonctionnels.DeterminationRemuneration;
import fr.unedic.util.QuantiteEuro;
import fr.unedic.util.services.OutilFonctionnel;
import fr.unedic.util.temps.Chronologie;
import fr.unedic.util.temps.Periode;
import java.math.BigDecimal;
import java.util.Iterator;

public class DeterminationMontantTotalSalaires
  implements OutilFonctionnel
{
  public static BigDecimal determinerMontantTotalSalaires(JustificationDiffere p_justification, DemandeAssuranceSpec demande, Periode periodeRecherche)
  {
    BigDecimal total = new BigDecimal(0);
    QuantiteEuro sripNonPlafonne = demande.getDonneesTemporaires().getTotalRemunerationDansPRC();
    if (sripNonPlafonne != null)
    {
      total = sripNonPlafonne.getValeur();
    }
    else
    {
      Chronologie chronoActivites = ConstructionChronologieCarences.determinerChronoActiviteToutReglementPourSalaireDiffereStandard(periodeRecherche, demande);
      
      Iterator<ActiviteSalarie> itChrono = chronoActivites.iterer();
      while (itChrono.hasNext())
      {
        ActiviteSalarie activite = (ActiviteSalarie)itChrono.next();
        
        ResultatRemunerationsParNature resultatRemuneration = new ResultatRemunerationsParNature();
        BigDecimal remunerationPourActivite = DeterminationRemuneration.determinerRemunerationActiviteSalarie(activite, periodeRecherche, resultatRemuneration);
        
        total = total.add(remunerationPourActivite);
      }
    }
    return total;
  }
}

/* Location:
 * Qualified Name:     DeterminationMontantTotalSalaires
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */