package fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DossierAffectation;
import fr.unedic.cali.asu.dom.ReglementApplicableSpec;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConstitutionElementsSpec;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConstitutionReglementApplicable;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.OutilFonctionnel;
import fr.unedic.util.services.PasAssezInformationException;

public class DeterminationReglementApplicable
  implements OutilFonctionnel
{
  public static ConstitutionReglementApplicable determinerReglementApplicable(Demande p_demande)
    throws PasAssezInformationException, CoucheLogiqueException
  {
    ConstitutionReglementApplicable reglementApplicable = ((DossierExamen)p_demande.getDossierExamen()).getConstitutionElementsActifs().createConstitutionReglementApplicable();
    
    Reglement reglement = ((DossierAffectation)p_demande.getDossierAffectation()).getReglementPeriodeValidationProduit();
    
    reglementApplicable.setReglement(reglement);
    
    return reglementApplicable;
  }
  
  public static ConstitutionReglementApplicable determinerReglementApplicablePourReprise(Demande p_demande)
    throws PasAssezInformationException, CoucheLogiqueException
  {
    ConstitutionReglementApplicable reglementApplicable = ((DossierExamen)p_demande.getDossierExamen()).getConstitutionElementsActifs().createConstitutionReglementApplicable();
    
    ReglementApplicableSpec reglementApplicableAttributionPrecedente = ((DossierExamen)p_demande.getDossierExamen()).getAttributionPrecedente().getReglementApplicable();
    if (reglementApplicableAttributionPrecedente != null) {
      reglementApplicableAttributionPrecedente.copieElements(reglementApplicable);
    }
    return reglementApplicable;
  }
}

/* Location:
 * Qualified Name:     DeterminationReglementApplicable
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */