package fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels;

import fr.unedic.cali.asu.dom.AttributionAssuranceSpec;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.EreDemandeExpresse;
import fr.unedic.cali.asu.dom.EreInscriptionDemandeurEmploi;
import fr.unedic.cali.asu.dom.ErePassageCPSuiteRejetDV;
import fr.unedic.cali.asu.dom.Reliquat;
import fr.unedic.cali.asu.fabriques.FabriqueConventionTransitoire2014;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.EvenementReferenceExamenSpec;
import fr.unedic.cali.dom.affectation.LigneAsuCge01;
import fr.unedic.cali.dom.affectation.LigneAsuCsa06;
import fr.unedic.cali.dom.affectation.LigneAsuExp03;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.util.temps.Damj;

public class FabriqueRechercheConditionFaitGenerateur
{
  public static RechercheConditionFaitGenerateurSpec getOutilFonctionnelRechercheConditionFaitGenerateur(DemandeSpec demande, AttributionAssuranceSpec attributionPrecedente, int etatReliquat)
  {
    EvenementReferenceExamenSpec ere = demande.getEvenementReferenceExamen();
    if (((ere instanceof EreInscriptionDemandeurEmploi)) && (!estAntecedentCasGeneralApresAre14(demande, attributionPrecedente, etatReliquat))) {
      return new RechercheConditionFaitGenerateurDemandeIDE();
    }
    if ((ere instanceof ErePassageCPSuiteRejetDV)) {
      return new RechercheConditionFaitGenerateurDemandeExamenCpSuiteDv();
    }
    if ((ere instanceof EreDemandeExpresse)) {
      return new RechercheConditionFaitGenerateurDemandeExpresse();
    }
    return new RechercheConditionFaitGenerateurDemandeClassique();
  }
  
  private static boolean estAntecedentCasGeneralApresAre14(DemandeSpec demande, AttributionAssuranceSpec attributionPrecedente, int etatReliquat)
  {
    Reliquat reliquat = ((Demande)demande).getReliquat();
    
    boolean apresAre14 = demande.getDateExamen().estApresOuCoincideAvec(FabriqueConventionTransitoire2014.DATE_APPLICATION);
    boolean reliquatEteint = etatReliquat == 1;
    boolean aOpte = ((Demande)demande).estDroitOptionReadmission();
    
    boolean reliquatValide = (reliquat != null) && (reliquat.isReliquatValide());
    
    boolean antecedentCG = (attributionPrecedente != null) && ((attributionPrecedente.getProduit().getLigne().equals(LigneAsuCge01.getInstance())) || (attributionPrecedente.getProduit().getLigne().equals(LigneAsuExp03.getInstance())) || (attributionPrecedente.getProduit().getLigne().equals(LigneAsuCsa06.getInstance())));
    
    boolean reliquatAPrendeEnCompte = (reliquatValide) || ((aOpte) && (reliquatEteint));
    
    return (apresAre14) && (antecedentCG) && (reliquatAPrendeEnCompte);
  }
}

/* Location:
 * Qualified Name:     FabriqueRechercheConditionFaitGenerateur
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */