package fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.strategies;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.outilsfonctionnels.GestionDemandeDv122eJour;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConstitutionNbHeuresTravaillees;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.DeterminationNombreHeuresTravaillees;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.PasAssezInformationException;

public class StrategieNombreHeuresTravailleesExamenCpSuiteRejetDV
  implements StrategieNombreHeuresTravailleesSpec
{
  public ConstitutionNbHeuresTravaillees determinerNombreHeuresTravaillees(Demande p_demande)
    throws PasAssezInformationException, CoucheLogiqueException
  {
    ConstitutionNbHeuresTravaillees cepa = null;
    
    Demande demandeRejetDv = GestionDemandeDv122eJour.retrouverDemandePortantDv(p_demande);
    if (demandeRejetDv != null)
    {
      if (demandeRejetDv.getDonneesTemporaires() != null)
      {
        if (demandeRejetDv.getDonneesTemporaires().getNbHeuresTravailPlafonneSpectacle() != null) {
          p_demande.getDonneesTemporaires().setNbHeuresTravailPlafonneSpectacle(demandeRejetDv.getDonneesTemporaires().getNbHeuresTravailPlafonneSpectacle());
        }
        if (demandeRejetDv.getDonneesTemporaires().getNbHeuresTravailEtenduSpectacle() != null) {
          p_demande.getDonneesTemporaires().setNbHeuresTravailEtenduSpectacle(demandeRejetDv.getDonneesTemporaires().getNbHeuresTravailEtenduSpectacle());
        }
        if (demandeRejetDv.getDonneesTemporaires().getIdentifiantPeriodeFctARetenir() != null) {
          p_demande.getDonneesTemporaires().setIdentifiantPeriodeFctARetenir(demandeRejetDv.getDonneesTemporaires().getIdentifiantPeriodeFctARetenir());
        }
      }
      cepa = DeterminationNombreHeuresTravaillees.determinerNombreHeuresTravaillees(p_demande);
      if (demandeRejetDv.getDonneesTemporaires() != null)
      {
        p_demande.getDonneesTemporaires().setNbHeuresTravailPlafonneSpectacle(null);
        p_demande.getDonneesTemporaires().setNbHeuresTravailEtenduSpectacle(null);
        p_demande.getDonneesTemporaires().setIdentifiantPeriodeFctARetenir(null);
      }
    }
    return cepa;
  }
}

/* Location:
 * Qualified Name:     StrategieNombreHeuresTravailleesExamenCpSuiteRejetDV
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */