package fr.unedic.cali.asu.spe02.p03.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConditionsAttributionAdmission;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConstitutionElementsSpec;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.DossierExamen;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.DeterminationDateOdTheorique;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;
import fr.unedic.util.temps.Damj;

public class ConstitutionDateAttribution
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    ecrireTrace(Niveau.DEBUG, "demarrer", "\t\t******** Début Parcours ConstitutionDateAttribution ********");
    
    Resultat resultatCEPA14 = new Resultat();
    
    Demande demande = DomLiquidationAssurance.getDemande(p_contexte);
    if (verifierPreconditions(p_contexte))
    {
      Damj dateOdTheorique = DeterminationDateOdTheorique.determinerDateAttributionTheoriquePourAdmission(demande);
      DossierExamen dossierExamenCourant = (DossierExamen)demande.getDossierExamen();
      fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConstitutionDateAttribution cepa = dossierExamenCourant.getConstitutionElementsActifs().createConstitutionDateAttribution();
      
      cepa.setDateAttribution(dateOdTheorique);
      
      resultatCEPA14 = new Resultat(0);
    }
    else
    {
      resultatCEPA14 = new Resultat(1);
    }
    ecrireTrace(Niveau.DEBUG, "demarrer", "\t\t******** Résultat Parcours ConstitutionDateAttribution ********\n" + resultatCEPA14);
    
    ecrireTrace(Niveau.DEBUG, "demarrer", "\t\t******** Fin Parcours ConstitutionDateAttribution ********\n");
    
    return resultatCEPA14;
  }
  
  protected boolean verifierPreconditions(Contexte p_contexte)
  {
    boolean preconditionsValides = true;
    
    Demande demandeCourante = DomLiquidationAssurance.getDemande(p_contexte);
    
    DossierExamen dossierExamenCourant = (DossierExamen)demandeCourante.getDossierExamen();
    if ((dossierExamenCourant.getConditionAttributionAdmission() != null) && (dossierExamenCourant.getConditionAttributionAdmission().estSatisfait())) {
      preconditionsValides = true;
    } else {
      preconditionsValides = false;
    }
    return preconditionsValides;
  }
}

/* Location:
 * Qualified Name:     ConstitutionDateAttribution
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */