package fr.unedic.cali.asu.spe02.p03.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.archi.util.trace.Log;
import fr.unedic.archi.util.trace.Niveau;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.DeterminationSalaireJournalierMoyen;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.ContexteException;
import fr.unedic.util.services.Resultat;

public class ConstitutionSjmPourReprise
  extends ParcoursCali
  implements ParcoursAssurance
{
  public void controlerContexte(Contexte contexte)
    throws ContexteException
  {}
  
  public Resultat demarrer(Contexte contexte)
    throws ApplicativeException
  {
    if (Log.isTraceActive(ConstitutionSjmPourReprise.class, Niveau.DEBUG))
    {
      Log.ecritTrace(Niveau.DEBUG, ConstitutionSjmPourReprise.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, ConstitutionSjmPourReprise.class, "demarrer", "\t\t******** Début Parcours ConstitutionSjmPourReprise ********");
    }
    Resultat resultatCEPA07 = new Resultat();
    resultatCEPA07.setEtat(0);
    
    Demande demande = DomLiquidationAssurance.getDemande(contexte);
    
    DeterminationSalaireJournalierMoyen.getInstance().determinerSalaireJournalierMoyenPourReprise(demande);
    if (Log.isTraceActive(ConstitutionSjmPourReprise.class, Niveau.DEBUG))
    {
      Log.ecritTrace(Niveau.DEBUG, ConstitutionSjmPourReprise.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, ConstitutionSjmPourReprise.class, "demarrer", "\t\t******** Résultat Parcours ConstitutionSjmPourReprise ********\n" + resultatCEPA07);
      
      Log.ecritTrace(Niveau.DEBUG, ConstitutionSjmPourReprise.class, "demarrer", "");
      Log.ecritTrace(Niveau.DEBUG, ConstitutionSjmPourReprise.class, "demarrer", "\t\t******** Fin Parcours ConstitutionSjmPourReprise ********\n");
    }
    return resultatCEPA07;
  }
}

/* Location:
 * Qualified Name:     ConstitutionSjmPourReprise
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */