package fr.unedic.cali.asu.spe02.p05.calcul.outilsfonctionnels;

import fr.unedic.cali.asu.dom.ElementBaseIndemnisation;
import fr.unedic.cali.asu.dom.SalaireReference;
import fr.unedic.cali.asu.dom.Sjm;
import fr.unedic.cali.asu.spe02.p03.parametres.ParametresIndemnisation;
import fr.unedic.cali.calcul.dom.ConstituantsIndemnisation;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.IndividuSpec;
import fr.unedic.cali.dom.QuantiteDroitSpec;
import fr.unedic.cali.dom.QuantiteIndemnisationSpec;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;
import java.math.BigDecimal;
import java.util.Collection;
import java.util.Iterator;

public class MajCi
{
  public static ConstituantsIndemnisation miseAJourConstituantsIndemnisation(AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, Damj dateDeMiseAjour)
    throws CoucheLogiqueException
  {
    String codeFormuleMontant = constituantsIndemnisation.getCodeFormuleMontant();
    if (codeFormuleMontant != null) {
      miseAJourParametres(attribution, constituantsIndemnisation, dateDeMiseAjour);
    }
    Collection<?> collectionDurees = constituantsIndemnisation.getCollectionQuantiteDroit();
    if (collectionDurees != null)
    {
      Iterator<?> iterator = collectionDurees.iterator();
      while (iterator.hasNext())
      {
        QuantiteDroitSpec dureeDroit = (QuantiteDroitSpec)iterator.next();
        if ((dureeDroit instanceof QuantiteIndemnisationSpec)) {
          miseAJourParametres(attribution, constituantsIndemnisation, dateDeMiseAjour);
        }
      }
    }
    return constituantsIndemnisation;
  }
  
  private static void miseAJourParametres(AttributionSpec attribution, ConstituantsIndemnisation constituantsIndemnisation, Damj dateDeMiseAjour)
    throws CoucheLogiqueException
  {
    ParametresIndemnisation parametresIndemnisation = ParametresIndemnisation.getParametresIndemnisation();
    ElementBaseIndemnisation elementBaseIndemnisation = (ElementBaseIndemnisation)constituantsIndemnisation.getElementBaseIndemnisationCourant();
    
    BigDecimal tauxAvantageViellesse = parametresIndemnisation.getTauxAvantageViellesse(attribution.getDemandeur().getAgeALaDate(dateDeMiseAjour));
    if (tauxAvantageViellesse != null) {
      elementBaseIndemnisation.setTauxAvantageVieillesse(tauxAvantageViellesse);
    }
    SalaireReference srrp = RevalorisationSalaire.determinerSrrp(elementBaseIndemnisation.getSalaireReference(), elementBaseIndemnisation.getNombreJoursInactivite(), elementBaseIndemnisation.getNbJoursEmploiSurPrc(), dateDeMiseAjour);
    
    Sjm sjmrp = fr.unedic.cali.asu.spe02.p03.calcul.outilsfonctionnels.RevalorisationSalaire.determinerSjmrp(srrp, elementBaseIndemnisation.getCoefficientHoraireJour(), elementBaseIndemnisation.getNombreHeuresTravailleesPlafonnees(), dateDeMiseAjour);
    if (sjmrp.getSalaire().doubleValue() != elementBaseIndemnisation.getSalaireReference().getSalaire().doubleValue()) {
      elementBaseIndemnisation.setMontantAvantageVieillesse(elementBaseIndemnisation.getCoefficientAvantageVieillesse().multiply(sjmrp.getSalaire()));
    }
  }
}

/* Location:
 * Qualified Name:     MajCi
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */