package fr.unedic.cali.asu.spe02.p05.liquidation.outilsaffiliation.dom;

import fr.unedic.cali.asu.spe02.p03.liquidation.outilsaffiliation.CalculAffiliationSupplementaire;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsaffiliation.JustifierAffiliation;
import fr.unedic.cali.asu.spe02.p05.liquidation.outilsaffiliation.CalculAffiliationBase;
import fr.unedic.cali.asu.spe02.p05.liquidation.outilsaffiliation.CalculAssimilation;
import fr.unedic.cali.asu.spe02.p05.liquidation.outilsaffiliation.ConstructionChronologie;
import fr.unedic.cali.asu.spe02.p05.liquidation.outilsaffiliation.ParametresAffiliation;
import fr.unedic.cali.autresdoms.ga.dom.ActiviteSalarie;
import fr.unedic.cali.dom.affectation.Reglement;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;

public class ComportementCalculAffiliation
  extends fr.unedic.cali.asu.spe02.p03.liquidation.outilsaffiliation.dom.ComportementCalculAffiliation
{
  public static ComportementCalculAffiliation creerInstance()
  {
    return new ComportementCalculAffiliation();
  }
  
  public ComportementCalculAffiliation()
  {
    setOutilCalculAffiliationBase(new CalculAffiliationBase());
    setOutilCalculAffiliationSupplementaire(new CalculAffiliationSupplementaire());
    setOutilCalculAssimilation(new CalculAssimilation());
    setOutilConstructionChronologie(new ConstructionChronologie());
    setOutilJustifierAffiliation(new JustifierAffiliation());
    setOutilParametreAffiliation(new ParametresAffiliation());
  }
  
  public boolean estEnseignementApplicablePourReglement(Reglement reglement)
  {
    return (reglement != null) && ((reglement.getLibelleCourt().equals("A10")) || (reglement.getLibelleCourt().equals("A8")));
  }
  
  public boolean estActiviteAPrendreEnComptePourEnseignement(ActiviteSalarie activite)
  {
    boolean retour = true;
    Reglement reglement = getReglementCandidat();
    if ((reglement != null) && (reglement.getLibelleCourt().equals("A8")) && (activite.getDateFin().estApres(getPeriodeRecherche().getFin()))) {
      retour = false;
    }
    return retour;
  }
}

/* Location:
 * Qualified Name:     ComportementCalculAffiliation
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */