package fr.unedic.cali.asu.spe02.p05.liquidation.outilsfonctionnels;

import fr.pe.cali.reglementaire.dom.impl.CriteresFabriqueReglementaire;
import fr.pe.cali.reglementaire.regles.assurance.cep.delaisreports.fabrique.FabriqueCorpsRegleConstitutionDelaisReports;
import fr.pe.cali.reglementaire.regles.assurance.cep.delaisreports.outils.spec.IOutilConstitutionDelaisReportsSpectacle;
import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.dom.AttributionSpec;
import fr.unedic.cali.dom.affectation.ProduitSpec;
import fr.unedic.cali.outilsfonctionnels.AppelCalculParLiquidation;
import fr.unedic.cali.parcours.ResultatExecutionCalculSpec;
import fr.unedic.util.Quantite;
import fr.unedic.util.services.OutilFonctionnel;
import fr.unedic.util.temps.Damj;
import fr.unedic.util.temps.Periode;

public class OutilGestionArce
  implements OutilFonctionnel
{
  public static OutilGestionArce getInstance()
  {
    return new OutilGestionArce();
  }
  
  protected ResultatExecutionCalculSpec executerAttribution(AttributionSpec attribution, Damj dateCalcul)
    throws ApplicativeException
  {
    return AppelCalculParLiquidation.executerCalculDeterminationEtatDroit(attribution, dateCalcul, true, true);
  }
  
  protected int determinerReliquatDelaiAttente(ResultatExecutionCalculSpec resultatCalcul, Damj dateCalcul)
  {
    IOutilConstitutionDelaisReportsSpectacle outil = getOutilReglementaire(resultatCalcul.getAttributionEtudiee().getProduit(), dateCalcul.lendemain());
    int reliquatDiffere = 0;
    Quantite reliquat = resultatCalcul.getReliquatDelaiAttente();
    Periode periodeApplication = resultatCalcul.getPeriodeApplicationDelaiAttente();
    if (reliquat != null) {
      reliquatDiffere = reliquat.getValeurEntiere();
    }
    return outil.calculerReliquatCarenceDiffere7Jours(reliquatDiffere, periodeApplication, dateCalcul.lendemain());
  }
  
  protected IOutilConstitutionDelaisReportsSpectacle getOutilReglementaire(ProduitSpec produit, Damj dateCalcul)
  {
    CriteresFabriqueReglementaire criteres = new CriteresFabriqueReglementaire();
    criteres.setCodeProduit(produit.getNomUnique());
    criteres.setDate(dateCalcul);
    return (IOutilConstitutionDelaisReportsSpectacle)FabriqueCorpsRegleConstitutionDelaisReports.getInstance().recupererOutilCorpsRegle(criteres);
  }
  
  protected int determinerReliquatFranchiseCP(ResultatExecutionCalculSpec resultatCalcul)
  {
    int reliquatFranchiseCP = 0;
    if (resultatCalcul.getReliquatFranchiseCP() != null) {
      reliquatFranchiseCP = resultatCalcul.getReliquatFranchiseCP().getValeurEntiere();
    }
    return reliquatFranchiseCP;
  }
  
  protected int determinerReliquatFranchiseSalaire(ResultatExecutionCalculSpec resultatCalcul)
  {
    int reliquatFranchiseSalaire = 0;
    if (resultatCalcul.getReliquatFranchiseSalaire() != null) {
      reliquatFranchiseSalaire = resultatCalcul.getReliquatFranchiseSalaire().getValeurEntiere();
    }
    return reliquatFranchiseSalaire;
  }
}

/* Location:
 * Qualified Name:     OutilGestionArce
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */