package fr.unedic.cali.asu.spe02.p05.liquidation.outilsfonctionnels.cep.nht;

import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.dom.DonneesTemporaires;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.DeterminationNombreHeuresTravaillees;
import fr.unedic.util.Quantite;
import java.math.BigDecimal;

public final class OutilDeterminationNombreHeuresTravaillees
  extends DeterminationNombreHeuresTravaillees
{
  public static BigDecimal calculerNHTP(Demande demande)
  {
    BigDecimal nhtp = BigDecimal.ZERO;
    Quantite nbHeuresTravailPlafonneForcees = demande.getDonneesTemporaires().getNbHeuresTravailPlafonneSpectacle();
    if (nbHeuresTravailPlafonneForcees != null) {
      nhtp = nbHeuresTravailPlafonneForcees.getValeur();
    } else {
      nhtp = compterAffiliationBaseRetenue(demande);
    }
    return nhtp;
  }
  
  public static BigDecimal calculerNHTM(BigDecimal nhtp, Demande demande)
  {
    BigDecimal nhtm = nhtp;
    
    Quantite nbHeuresTravailMajoreForce = demande.getDonneesTemporaires().getNbHeuresTravailPlafonneSpectacle();
    if (nbHeuresTravailMajoreForce != null)
    {
      nhtm = nbHeuresTravailMajoreForce.getValeur();
    }
    else
    {
      int[] listeNatures = { 3, 12 };
      
      nhtm = nhtm.add(compterAffiliationAssimileeRetenue(demande, listeNatures));
    }
    return nhtm;
  }
  
  public static BigDecimal calculerNHTE(BigDecimal nhtm, Demande demande)
  {
    BigDecimal nhte = nhtm;
    Quantite nbHeuresTravailEtenduForcees = demande.getDonneesTemporaires().getNbHeuresTravailEtenduSpectacle();
    if (nbHeuresTravailEtenduForcees != null)
    {
      nhte = nbHeuresTravailEtenduForcees.getValeur();
    }
    else
    {
      nhte = nhte.add(compterAffiliationSupplementaireRetenue(demande, null));
      int[] listeNatures = { 4, 5 };
      
      nhte = nhte.add(compterAffiliationAssimileeRetenue(demande, listeNatures));
    }
    return nhte;
  }
}

/* Location:
 * Qualified Name:     OutilDeterminationNombreHeuresTravaillees
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */