package fr.unedic.cali.asu.spe02.p05.liquidation.parcours.cep.montant;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.outilsfonctionnels.OutilGestionContexteDemande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.spe02.p03.calcul.dom.Montant;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.Attribution;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConstitutionElementsAdmission;
import fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.DeterminationMontantsBruts;
import fr.unedic.cali.asu.spe02.p03.liquidation.parcours.ConstitutionMontantsBruts;
import fr.unedic.cali.dom.MontantBaseSpec;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.cali.parcours.ResultatExecutionCalculSpec;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.services.Resultat;

public class ParcoursConstitutionMontantBrut
  extends ParcoursCali
{
  public Resultat demarrer(Contexte contexte)
    throws ApplicativeException
  {
    Demande demande = recupererDemande(contexte);
    Resultat resultat = null;
    if (estEnContexteEntreeClauseRattrapage(demande)) {
      resultat = effectuerTraitementEntreeClauseRattrapage(contexte);
    } else {
      resultat = effectuerTraitementClassique(contexte);
    }
    return resultat;
  }
  
  protected Resultat effectuerTraitementClassique(Contexte contexte)
    throws ApplicativeException
  {
    ParcoursCali parcours = new ConstitutionMontantsBruts();
    return parcours.demarrer(contexte);
  }
  
  protected Resultat effectuerTraitementEntreeClauseRattrapage(Contexte contexte)
    throws CoucheLogiqueException
  {
    Resultat resultat = new Resultat(0);
    Demande demande = recupererDemande(contexte);
    Attribution attribution = recupererAttribution(demande);
    attribution.getConstitutionElementsAdmission().createConstitutionMontantsBruts();
    
    ResultatExecutionCalculSpec executionAttributionPrecedente = recupererExecutionCalculAttributionPrecedente(contexte);
    MontantBaseSpec montantPrecedent = executionAttributionPrecedente.getMontant();
    DeterminationMontantsBruts.getInstance().alimenterResultatCepa((Montant)montantPrecedent, attribution);
    return resultat;
  }
  
  protected boolean estEnContexteEntreeClauseRattrapage(Demande demande)
  {
    return OutilGestionContexteDemande.estContexteDemandeAssurancePresent(demande, "ENTREECRA");
  }
  
  protected Demande recupererDemande(Contexte contexte)
  {
    return DomLiquidationAssurance.getDemande(contexte);
  }
  
  protected Attribution recupererAttribution(Demande demande)
  {
    return (Attribution)demande.getDossierExamen();
  }
  
  protected ResultatExecutionCalculSpec recupererExecutionCalculAttributionPrecedente(Contexte contexte)
  {
    return ((DomLiquidationAssurance)contexte.getDonnees()).getResultatExecutionCalculDroitPrecedent();
  }
}

/* Location:
 * Qualified Name:     ParcoursConstitutionMontantBrut
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */