package fr.unedic.cali.asu.ssp07.p03.liquidation.outilsfonctionnels;

import fr.unedic.cali.dom.DecisionSpec;
import fr.unedic.cali.dom.DemandeSpec;
import fr.unedic.cali.dom.OdSpec;
import fr.unedic.cali.outilsfonctionnels.OutilDemande;
import fr.unedic.cali.parcours.ResultatExecutionCalculSpec;
import fr.unedic.cali.utilitaire.filtres.composites.FiltreOuvertureDroitStandardAssurance;
import fr.unedic.cali.utilitaire.outils.OutilRecherche;
import fr.unedic.util.services.CoucheLogiqueException;
import fr.unedic.util.temps.Damj;

public class OutilTraitementReliquat
  extends fr.unedic.cali.asu.fps.liquidation.outilsfonctionnels.OutilTraitementReliquat
{
  private static OutilTraitementReliquat s_instance = null;
  
  public static fr.unedic.cali.asu.spe02.p03.liquidation.outilsfonctionnels.OutilTraitementReliquat getInstance()
  {
    if (s_instance == null) {
      s_instance = new OutilTraitementReliquat();
    }
    return s_instance;
  }
  
  protected Damj getDateExtinction(DemandeSpec p_demande, DecisionSpec p_decisionPrecedente, ResultatExecutionCalculSpec p_resultatExecutionCalcul, Damj p_dateEtude)
    throws CoucheLogiqueException
  {
    Damj dateExtinction = super.getDateExtinction(p_demande, p_decisionPrecedente, p_resultatExecutionCalcul, p_dateEtude);
    if (dateExtinction == null)
    {
      OdSpec odPrecedente = (OdSpec)OutilRecherche.rechercherDecisionPrecedente(p_demande.getChronologieDemandesAssuranceSansCourante(), p_demande, new FiltreOuvertureDroitStandardAssurance(true, true, false, false, null));
      if ((odPrecedente != null) && (odPrecedente.getDateAttribution().estApres(p_decisionPrecedente.getDateAttribution())) && (OutilDemande.estUneDemandeAre(odPrecedente.getDemande()))) {
        dateExtinction = odPrecedente.getDateAttribution();
      }
    }
    return dateExtinction;
  }
}

/* Location:
 * Qualified Name:     OutilTraitementReliquat
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */