package fr.unedic.cali.asu.ssp07.p03.liquidation.parcours;

import fr.unedic.archi.logique.exception.ApplicativeException;
import fr.unedic.cali.asu.ParcoursAssurance;
import fr.unedic.cali.asu.dom.Demande;
import fr.unedic.cali.asu.parcours.DomLiquidationAssurance;
import fr.unedic.cali.asu.spe02.p03.liquidation.dom.ConditionBeneficeAutreProduit;
import fr.unedic.cali.asu.ssp07.p03.liquidation.outilsfonctionnels.OutilConditionBeneficeAutreProduit;
import fr.unedic.cali.outilsfonctionnels.OutilTrace;
import fr.unedic.cali.parcours.ParcoursCali;
import fr.unedic.util.services.Contexte;
import fr.unedic.util.services.Resultat;

public class DeterminationConditionBeneficeAutreProduit
  extends ParcoursCali
  implements ParcoursAssurance
{
  public Resultat demarrer(Contexte p_contexte)
    throws ApplicativeException
  {
    OutilTrace.tracerDebutParcours();
    
    Resultat resultatCapa14 = new Resultat(1);
    Demande demandeCourante = DomLiquidationAssurance.getDemande(p_contexte);
    
    ConditionBeneficeAutreProduit conditionBeneficeAutreProduit = OutilConditionBeneficeAutreProduit.verifierConditionBeneficeAutreProduit(demandeCourante);
    if (conditionBeneficeAutreProduit.estSatisfait())
    {
      resultatCapa14.setEtat(0);
    }
    else
    {
      resultatCapa14.setEtat(1);
      resultatCapa14.setMessageErreur(Integer.toString(conditionBeneficeAutreProduit.getCodeMotifEchec()));
    }
    OutilTrace.tracerFinParcours();
    return resultatCapa14;
  }
}

/* Location:
 * Qualified Name:     DeterminationConditionBeneficeAutreProduit
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */