package fr.unedic.logique.donnees.dr1.service.vls;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.archi.logique.adaptateur.ObjetSerialisableFournisseur;
import java.io.Serializable;
import java.math.BigDecimal;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class _YI19Impl
  extends YI19
  implements ObjetSerialisableFournisseur, Serializable
{
  private static final long serialVersionUID = 1L;
  private final _YI19 m_YI19Infra;
  
  public _YI19Impl()
  {
    m_YI19Infra = new _YI19();
  }
  
  public _YI19Impl(_YI19 pValeur)
  {
    ExceptionUtil.assertMethodParamNotNull("YI19Infra", pValeur);
    
    m_YI19Infra = pValeur;
  }
  
  public Object getObjet()
  {
    return m_YI19Infra;
  }
  
  public String getIdentifiant()
  {
    return m_YI19Infra.get_IDENT();
  }
  
  public void setIdentifiant(String pIdentifiant)
  {
    m_YI19Infra.set_IDENT(pIdentifiant);
  }
  
  public String getCodeEtat()
  {
    return m_YI19Infra.get_C_ETAT();
  }
  
  public void setCodeEtat(String pCode)
  {
    m_YI19Infra.set_C_ETAT(pCode);
  }
  
  public BigDecimal getNBRUS()
  {
    return m_YI19Infra.getNBRUS_NOMBRE_DE_RUBRIQUE_ENTETE_APLICATIVE();
  }
  
  public String getCodeErreurNBRUS()
  {
    return m_YI19Infra.getNBRUS_NOMBRE_DE_RUBRIQUE_ENTETE_APLICATIVE_C_ERR();
  }
  
  public void setNBRUS(BigDecimal pValeur)
  {
    m_YI19Infra.setNBRUS_NOMBRE_DE_RUBRIQUE_ENTETE_APLICATIVE(pValeur);
  }
  
  public void setCodeErreurNBRUS(String pCodeErreur)
  {
    m_YI19Infra.setNBRUS_NOMBRE_DE_RUBRIQUE_ENTETE_APLICATIVE_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getNBRUS_NOMBRE_DE_RUBRIQUE_ENTETE_APLICATIVE()
  {
    return m_YI19Infra.getNBRUS_NOMBRE_DE_RUBRIQUE_ENTETE_APLICATIVE();
  }
  
  public String getCodeErreurNBRUS_NOMBRE_DE_RUBRIQUE_ENTETE_APLICATIVE()
  {
    return m_YI19Infra.getNBRUS_NOMBRE_DE_RUBRIQUE_ENTETE_APLICATIVE_C_ERR();
  }
  
  public void setNBRUS_NOMBRE_DE_RUBRIQUE_ENTETE_APLICATIVE(BigDecimal pValeur)
  {
    m_YI19Infra.setNBRUS_NOMBRE_DE_RUBRIQUE_ENTETE_APLICATIVE(pValeur);
  }
  
  public void setCodeErreurNBRUS_NOMBRE_DE_RUBRIQUE_ENTETE_APLICATIVE(String pCodeErreur)
  {
    m_YI19Infra.setNBRUS_NOMBRE_DE_RUBRIQUE_ENTETE_APLICATIVE_C_ERR(pCodeErreur);
  }
  
  public _YI19 getYI19Infra()
  {
    return m_YI19Infra;
  }
  
  public String toString()
  {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
  }
  
  public boolean isEnErreur()
  {
    if ((getCodeErreurNBRUS() != null) && 
      ("".equals(getCodeErreurNBRUS()))) {
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     _YI19Impl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */