package fr.unedic.logique.donnees.dr1.service.vls;

import fr.unedic.archi.commun.lang.ExceptionUtil;
import fr.unedic.archi.logique.adaptateur.ObjetSerialisableFournisseur;
import java.io.Serializable;
import java.math.BigDecimal;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class _YI5ZImpl
  extends YI5Z
  implements ObjetSerialisableFournisseur, Serializable
{
  private static final long serialVersionUID = 1L;
  private final _YI5Z m_YI5ZInfra;
  
  public _YI5ZImpl()
  {
    m_YI5ZInfra = new _YI5Z();
  }
  
  public _YI5ZImpl(_YI5Z pValeur)
  {
    ExceptionUtil.assertMethodParamNotNull("YI5ZInfra", pValeur);
    
    m_YI5ZInfra = pValeur;
  }
  
  public Object getObjet()
  {
    return m_YI5ZInfra;
  }
  
  public String getIdentifiant()
  {
    return m_YI5ZInfra.get_IDENT();
  }
  
  public void setIdentifiant(String pIdentifiant)
  {
    m_YI5ZInfra.set_IDENT(pIdentifiant);
  }
  
  public String getCodeEtat()
  {
    return m_YI5ZInfra.get_C_ETAT();
  }
  
  public void setCodeEtat(String pCode)
  {
    m_YI5ZInfra.set_C_ETAT(pCode);
  }
  
  public BigDecimal getDSAAS6()
  {
    return m_YI5ZInfra.getDSAAS6_ANNEE_ABSENCE_MAINTIEN();
  }
  
  public String getCodeErreurDSAAS6()
  {
    return m_YI5ZInfra.getDSAAS6_ANNEE_ABSENCE_MAINTIEN_C_ERR();
  }
  
  public void setDSAAS6(BigDecimal pValeur)
  {
    m_YI5ZInfra.setDSAAS6_ANNEE_ABSENCE_MAINTIEN(pValeur);
  }
  
  public void setCodeErreurDSAAS6(String pCodeErreur)
  {
    m_YI5ZInfra.setDSAAS6_ANNEE_ABSENCE_MAINTIEN_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getDSAAS6_ANNEE_ABSENCE_MAINTIEN()
  {
    return m_YI5ZInfra.getDSAAS6_ANNEE_ABSENCE_MAINTIEN();
  }
  
  public String getCodeErreurDSAAS6_ANNEE_ABSENCE_MAINTIEN()
  {
    return m_YI5ZInfra.getDSAAS6_ANNEE_ABSENCE_MAINTIEN_C_ERR();
  }
  
  public void setDSAAS6_ANNEE_ABSENCE_MAINTIEN(BigDecimal pValeur)
  {
    m_YI5ZInfra.setDSAAS6_ANNEE_ABSENCE_MAINTIEN(pValeur);
  }
  
  public void setCodeErreurDSAAS6_ANNEE_ABSENCE_MAINTIEN(String pCodeErreur)
  {
    m_YI5ZInfra.setDSAAS6_ANNEE_ABSENCE_MAINTIEN_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getDSMA6()
  {
    return m_YI5ZInfra.getDSMA6_MOIS_ABSENCE_MAINTIEN();
  }
  
  public String getCodeErreurDSMA6()
  {
    return m_YI5ZInfra.getDSMA6_MOIS_ABSENCE_MAINTIEN_C_ERR();
  }
  
  public void setDSMA6(BigDecimal pValeur)
  {
    m_YI5ZInfra.setDSMA6_MOIS_ABSENCE_MAINTIEN(pValeur);
  }
  
  public void setCodeErreurDSMA6(String pCodeErreur)
  {
    m_YI5ZInfra.setDSMA6_MOIS_ABSENCE_MAINTIEN_C_ERR(pCodeErreur);
  }
  
  public BigDecimal getDSMA6_MOIS_ABSENCE_MAINTIEN()
  {
    return m_YI5ZInfra.getDSMA6_MOIS_ABSENCE_MAINTIEN();
  }
  
  public String getCodeErreurDSMA6_MOIS_ABSENCE_MAINTIEN()
  {
    return m_YI5ZInfra.getDSMA6_MOIS_ABSENCE_MAINTIEN_C_ERR();
  }
  
  public void setDSMA6_MOIS_ABSENCE_MAINTIEN(BigDecimal pValeur)
  {
    m_YI5ZInfra.setDSMA6_MOIS_ABSENCE_MAINTIEN(pValeur);
  }
  
  public void setCodeErreurDSMA6_MOIS_ABSENCE_MAINTIEN(String pCodeErreur)
  {
    m_YI5ZInfra.setDSMA6_MOIS_ABSENCE_MAINTIEN_C_ERR(pCodeErreur);
  }
  
  public _YI5Z getYI5ZInfra()
  {
    return m_YI5ZInfra;
  }
  
  public String toString()
  {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
  }
  
  public boolean isEnErreur()
  {
    if ((getCodeErreurDSAAS6() != null) && 
      ("".equals(getCodeErreurDSAAS6()))) {
      return true;
    }
    if ((getCodeErreurDSMA6() != null) && 
      ("".equals(getCodeErreurDSMA6()))) {
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     _YI5ZImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */