package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCDAGNEnumeration
{
  public static final SRCDAGNEnumeration E_DSI = new SRCDAGNEnumeration("Profil DSI", "DSI");
  public static final SRCDAGNEnumeration E_ELD = new SRCDAGNEnumeration("ELD", "ELD");
  public static final SRCDAGNEnumeration E_PTE = new SRCDAGNEnumeration("Plateforme IDE externe - National", "PTE");
  public static final SRCDAGNEnumeration E_PTI = new SRCDAGNEnumeration("Plateforme interne - RÃ©gional", "PTI");
  public static final SRCDAGNEnumeration E_VIS = new SRCDAGNEnumeration("Profil VISU", "VIS");
  public static final SRCDAGNEnumeration E_SOC = new SRCDAGNEnumeration("Profil socle (conseiller PE, en agence)", "SOC");
  static final SRCDAGNEnumeration[] LISTE_ENUM = { E_DSI, E_ELD, E_PTE, E_PTI, E_VIS, E_SOC };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCDAGNEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCDAGNEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCDAGNEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCDAGNEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDAGNEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCDAGNEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDAGNEnumeration getPourValeur(String pValeur)
  {
    SRCDAGNEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDAGNEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCDAGNEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */