package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCDCECEnumeration
{
  public static final SRCDCECEnumeration E_IDENT = new SRCDCECEnumeration("Demande Identification", "IDENT");
  public static final SRCDCECEnumeration E_ABONN = new SRCDCECEnumeration("Demande Abonnement", "ABONN");
  public static final SRCDCECEnumeration E_NOTIF = new SRCDCECEnumeration("Notification", "NOTIF");
  static final SRCDCECEnumeration[] LISTE_ENUM = { E_IDENT, E_ABONN, E_NOTIF };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCDCECEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCDCECEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCDCECEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCDCECEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDCECEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCDCECEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDCECEnumeration getPourValeur(String pValeur)
  {
    SRCDCECEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDCECEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCDCECEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */