package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCDFEMEnumeration
{
  public static final SRCDFEMEnumeration E_PMA = new SRCDFEMEnumeration("Maj", "PMA");
  public static final SRCDFEMEnumeration E_PMC = new SRCDFEMEnumeration("Creation", "PMC");
  public static final SRCDFEMEnumeration E_PIA = new SRCDFEMEnumeration("Calage SE INSEE", "PIA");
  public static final SRCDFEMEnumeration E_PIJ = new SRCDFEMEnumeration("SE INSEE Journalier", "PIJ");
  public static final SRCDFEMEnumeration E_PIV = new SRCDFEMEnumeration("Invalidation suite crÃ©ation par SE GUSO", "PIV");
  public static final SRCDFEMEnumeration E_PMS = new SRCDFEMEnumeration("SE CMSA", "PMS");
  public static final SRCDFEMEnumeration E_PGU = new SRCDFEMEnumeration("SE GUSO", "PGU");
  public static final SRCDFEMEnumeration E_PUR = new SRCDFEMEnumeration("SE URSSAF", "PUR");
  static final SRCDFEMEnumeration[] LISTE_ENUM = { E_PMA, E_PMC, E_PIA, E_PIJ, E_PIV, E_PMS, E_PGU, E_PUR };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCDFEMEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCDFEMEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCDFEMEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCDFEMEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDFEMEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCDFEMEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDFEMEnumeration getPourValeur(String pValeur)
  {
    SRCDFEMEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDFEMEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCDFEMEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */