package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCDROCAEnumeration
{
  public static final SRCDROCAEnumeration E_RN = new SRCDROCAEnumeration("Accord diffusion nominative", "RN");
  public static final SRCDROCAEnumeration E_RA = new SRCDROCAEnumeration("Accord diffusion anonyme", "RA");
  public static final SRCDROCAEnumeration E_RO = new SRCDROCAEnumeration("???", "RO");
  public static final SRCDROCAEnumeration E_RR = new SRCDROCAEnumeration("Refus ROC", "RR");
  static final SRCDROCAEnumeration[] LISTE_ENUM = { E_RN, E_RA, E_RO, E_RR };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCDROCAEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCDROCAEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCDROCAEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCDROCAEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDROCAEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCDROCAEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDROCAEnumeration getPourValeur(String pValeur)
  {
    SRCDROCAEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCDROCAEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCDROCAEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */