package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCICSSEnumeration
{
  public static final SRCICSSEnumeration E_O = new SRCICSSEnumeration("OUI", "O");
  public static final SRCICSSEnumeration E_N = new SRCICSSEnumeration("NON", "N");
  static final SRCICSSEnumeration[] LISTE_ENUM = { E_O, E_N };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCICSSEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCICSSEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCICSSEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCICSSEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCICSSEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCICSSEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCICSSEnumeration getPourValeur(String pValeur)
  {
    SRCICSSEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCICSSEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCICSSEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */