package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCIDPREnumeration
{
  public static final SRCIDPREnumeration E_E = new SRCIDPREnumeration("demandeur de prestation EPURES", "E");
  public static final SRCIDPREnumeration E_I = new SRCIDPREnumeration("demandeur de prestation INACTIF", "I");
  public static final SRCIDPREnumeration E_A = new SRCIDPREnumeration("demandeur de prestation ACTIF", "A");
  static final SRCIDPREnumeration[] LISTE_ENUM = { E_E, E_I, E_A };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCIDPREnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCIDPREnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCIDPREnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCIDPREnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCIDPREnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCIDPREnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCIDPREnumeration getPourValeur(String pValeur)
  {
    SRCIDPREnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCIDPREnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCIDPREnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */