package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCISMSEnumeration
{
  public static final SRCISMSEnumeration E_O = new SRCISMSEnumeration("Acceptation des SMS", "O");
  public static final SRCISMSEnumeration E_N = new SRCISMSEnumeration("Refus des SMS", "N");
  static final SRCISMSEnumeration[] LISTE_ENUM = { E_O, E_N };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCISMSEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCISMSEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCISMSEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCISMSEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCISMSEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCISMSEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCISMSEnumeration getPourValeur(String pValeur)
  {
    SRCISMSEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCISMSEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCISMSEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */