package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRCSSAMEnumeration
{
  public static final SRCSSAMEnumeration E_H = new SRCSSAMEnumeration("Euros bruts horaires", "H");
  public static final SRCSSAMEnumeration E_M = new SRCSSAMEnumeration("Euros bruts mensuels", "M");
  public static final SRCSSAMEnumeration E_A = new SRCSSAMEnumeration("Euros bruts annuels", "A");
  static final SRCSSAMEnumeration[] LISTE_ENUM = { E_H, E_M, E_A };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRCSSAMEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRCSSAMEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRCSSAMEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRCSSAMEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCSSAMEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRCSSAMEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCSSAMEnumeration getPourValeur(String pValeur)
  {
    SRCSSAMEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRCSSAMEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRCSSAMEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */