package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRFSEDUEnumeration
{
  public static final SRFSEDUEnumeration E_N = new SRFSEDUEnumeration("Edition du DU en UPS", "N");
  public static final SRFSEDUEnumeration E_O = new SRFSEDUEnumeration("Edition en local AC60", "O");
  static final SRFSEDUEnumeration[] LISTE_ENUM = { E_N, E_O };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRFSEDUEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRFSEDUEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRFSEDUEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRFSEDUEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRFSEDUEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRFSEDUEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRFSEDUEnumeration getPourValeur(String pValeur)
  {
    SRFSEDUEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRFSEDUEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRFSEDUEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */