package fr.unedic.logique.service.rac.commun.dra.d01.dictionnaire;

public final class SRLZOCNEnumeration
{
  public static final SRLZOCNEnumeration E_CNAV = new SRLZOCNEnumeration("CERTIFICATION CNAV", "CNAV");
  public static final SRLZOCNEnumeration E_DNA = new SRLZOCNEnumeration("CERTIFICATION DNA", "DNA");
  public static final SRLZOCNEnumeration E_DADSU = new SRLZOCNEnumeration("CERTIFICATION DADSU", "DADSU");
  static final SRLZOCNEnumeration[] LISTE_ENUM = { E_CNAV, E_DNA, E_DADSU };
  final String m_libelleCourt;
  final String m_libelleLong;
  final String m_valeur;
  
  private SRLZOCNEnumeration(String pLibelleCourt, String pLibelleLong, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = pLibelleLong;
    m_valeur = pValeur;
  }
  
  private SRLZOCNEnumeration(String pLibelleCourt, String pValeur)
  {
    m_libelleCourt = pLibelleCourt;
    m_libelleLong = null;
    m_valeur = pValeur;
  }
  
  public String getLibelleCourt()
  {
    return m_libelleCourt;
  }
  
  public String getLibelleLong()
  {
    return m_libelleLong;
  }
  
  public String getValeur()
  {
    return m_valeur;
  }
  
  public static SRLZOCNEnumeration getPourLibelleCourt(String pLibelleCourt)
  {
    SRLZOCNEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleCourt().equals(pLibelleCourt)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRLZOCNEnumeration getPourLibelleLong(String pLibelleLong)
  {
    SRLZOCNEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getLibelleLong().equals(pLibelleLong)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRLZOCNEnumeration getPourValeur(String pValeur)
  {
    SRLZOCNEnumeration retour = null;
    for (int i = 0; (retour == null) && (i < LISTE_ENUM.length); i++) {
      if (LISTE_ENUM[i].getValeur().equals(pValeur)) {
        retour = LISTE_ENUM[i];
      }
    }
    return retour;
  }
  
  public static SRLZOCNEnumeration[] getAll()
  {
    return LISTE_ENUM;
  }
}

/* Location:
 * Qualified Name:     SRLZOCNEnumeration
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */